/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/ease/drive_dp.c,v $
 $Date: 2003/11/09 14:17:35 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: drive_dp.c,v $
 Revision 1.1  2003/11/09 14:17:35  jwd
 Initial version from SPARC--incomplete for arm

 Revision 1.2  1998/04/07 20:04:47  jwd
 First ANSI C version.


*************************************************************************/

#include <stdio.h>

#define DRIVE_D 1
#define DRIVE_P 1
#include "ease.h"
#include "drive_dp.h"

/*
 * This file contains the functions needed to start and finish a program
 * instrumented to perform data cache simulations and precision timing.
 */

static char my_name[100];
static int my_pid;

/*
 * ease_start_dp - start measurements, data cache and precision timing
 */
void __ease_start_dp(int argc, char **argv, char **envp)
{
/*ARGSUSED*/

   int getpid(void);
   void __ease_start_prec(), __ease_init_cacher();

   __ease_start_prec();

   if (*argv)
      basename(*argv, my_name);
   else
      error("cannot locate program name");

   __ease_init_cacher(envp);

   my_pid = getpid();
}

/*
 * ease_end_dp - finish measurements, data cache and precision timing
 */
void __ease_end_dp(void)
{

   int getpid(void);
   void __ease_end_cacher(), __ease_stop_prec();

   if (my_pid != getpid())
      return;

   __ease_end_cacher(my_name, "dtr");
   __ease_stop_prec();
}

/*
 * The following functions support the main tasks
 */

/*
 * basename - return the file name from a path
 */
static void basename(char *path, char *file)
{

   char *a, *b, *d;

   /*
      Scan through the pathname.  When we are finished, we will have "b"
      pointing to the last file name in the path and "d" pointing to the last
      '.' within the last file name.
   */
   d = (char *) NULL;
   for (a = b = path; *a; a++) {
      if (*a == '.')
	 d = a;
      if (*a == '/') {
	 b = a + 1;
	 d = (char *) NULL;
      }
   }

   /*
      Extract the file name from the path and move it to the "file" argument
   */
   if (!d)
      d = a;
   for (a = file; b != d; *a++ = *b++);
   *a++ = '\0';
}

/*
 * error - print error message and exit
 */
static void error(char *s)
{

   int fflush(FILE *);
   void exit(int);

   (void) fprintf(stderr, "ease: %s\n", s);
   (void) fflush(stderr);
   exit(1);
}
