/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/ease/ease.h,v $
 $Date: 2003/11/09 14:19:51 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: ease.h,v $
 Revision 1.1  2003/11/09 14:19:51  jwd
 Initial version from SPARC--incomplete for arm

 Revision 1.3  2002/08/07 02:09:52  clc5q
 Update EASE code per changes from David Whalley to make the SPARC EASE
 target build and execute properly.

 Revision 1.2  1998/04/07 20:06:06  jwd
 First ANSI C version.


*************************************************************************/

/*
 * This file contains most of the machine-dependent aspects of the EASE
 * library functions
 */

/*
 * Define the number of clock ticks per second
 */
#define TIME_HZ 60.0

/*
 * Declares a global area that is needed to save and restore the target
 * machine's scratch registers when a call has to be made to the cache
 * simulation routines.
 */
#if DRIVE_D || DRIVE_I
extern double __scratch_dump[128];
#endif

/*
 * Declare the default cache simulation configuration file
 */
#define TRACE_IN  "trace.config"

/*
 * Declare the number of items in a single instruction information line.  This
 * is the number of items that the stinstinfo() function in linstinfo.c emits
 * per instruction.
 */
#define INSTINFONUM (4 + MAXFIELDS * 2)

/*
 * Declare the argument list that will allow the __ease_start functions to
 * reference the argumments passed to main().
 */
#define MAIN_ARGS argc, argv, envp
#define MAIN_DECL int argc; \
                  char **argv; \
                  char **envp

/*
 * If all of the instructions on the target machine are of the same size, then
 * the variable SAMESIZE should be defined here and its value should be the
 * size of each instruction.
 */
#define SAMESIZE 4
