/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/ease/ease_p.c,v $
 $Date: 2003/11/09 14:19:52 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: ease_p.c,v $
 Revision 1.1  2003/11/09 14:19:52  jwd
 Initial version from SPARC--incomplete for arm

 Revision 1.2  1998/04/07 20:08:02  jwd
 First ANSI C version.


*************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>
#include "ease.h"
#include "ease_p.h"

/*
 * This file contains functions to support the precision timing options
 */

static long start;
static char *time_out;

/*
 * ease_start_prec - obtain the starting time
 */
void __ease_start_prec(void) {

   struct tms buffer;
   char *getenv(const char *);

   time_out = getenv("PREC_TIME");
   (void) times(&buffer);
   start = buffer.tms_utime + buffer.tms_cutime;
}

/*
 * ease_stop_time - calculate the time elapsed and display it
 */
void __ease_stop_prec(void) {

   struct tms buffer;
   FILE *tfile;
   double total;
   long stop;
   FILE *fopen(const char *, const char *);

   (void) times(&buffer);
   stop = buffer.tms_utime + buffer.tms_cutime;
   total = (stop - start) / TIME_HZ;
   if (!time_out || !(tfile = fopen(time_out, "a")))
      (void) fprintf(stderr, "Total time is %3.3f seconds\n", total);
   else {
      (void) fprintf(tfile, "Total time is %3.3f seconds\n", total);
      fclose(tfile);
   }
}
