
/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/inst.h,v $
 $Date: 2002/07/19 19:10:37 $
 $Revision: 1.10 $
 $Name:  $

 Log of changes:

 $Log: inst.h,v $
 Revision 1.10  2002/07/19 19:10:37  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.9  2002/07/16 19:42:50  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.8  2001/09/05 18:44:16  jdh8d
 *** empty log message ***

 Revision 1.7  2001/06/06 14:27:25  jdh8d


 Added scaled address modes:

 	r[3]=R[r[1]+(r[2]{2)];r[1]=r[1]+(r[2]{2); for an example

 fixed form_expr bug with large constants

 Revision 1.6  2001/03/30 02:10:35  jdh8d
 *** empty log message ***

 Revision 1.5  2001/03/09 04:42:25  jdh8d
 *** empty log message ***

 Revision 1.4  2001/02/27 22:35:09  jdh8d
 *** empty log message ***

 Revision 1.3  2001/02/05 20:46:55  jdh8d
 added fixz.  most float/int instructions should work, branches, etc are OK
 too

 Revision 1.2  2001/02/04 23:36:48  jdh8d
 Most of the integer instructions now work, including cmp, and the branches.
 Non parameter variables are all working as far as I know, and the floating
 point instructions work.


 works:	ldr, str, add, sub, mul, adr, mov, shift left (mov r0, r1 asl r2),
 shift right (mov r0, r1 rsl r2), mufs, adfs, sufs, difs, mufd, adfd, sufd,
 difd, difd, stfs, stfd, ldfs, ldfd.

 Turned off optimization for debugging purposes.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.1  2000/09/15 23:06:19  jwd
 Initial revision

*************************************************************************/

#ifndef INST_H
#define INST_H

#include "addrdef.h"
#include "recdef.h"

extern int minlocrefs;
extern int minargrefs;
extern int dassem;
extern int str_ptr;
extern int i_ptr;
extern char *labprt;
extern char *acomment;

extern int condret;             /* indicates if RETURN can be the target
                                 * of a conditional jump, i.e., conditional
                                 * returns are supported by the machine
                                 */

extern char *r_regs[];
extern char *f_regs[];

struct addr_entry *addr(int, int, struct addr_entry *, struct addr_entry *, struct addr_entry *);
struct addr_entry *sr_addr(int, int, struct addr_entry *, struct addr_entry *, struct addr_entry *);
int icompare(struct addr_entry *, struct addr_entry *);
void dump_addr(struct addr_entry *);
int isreloc(struct addr_entry *);
struct addr_entry *initexpr(struct addr_entry *, int, struct addr_entry *);
struct addr_entry *addexpr(struct addr_entry *, int, struct addr_entry *);
struct addr_entry *displacement(struct addr_entry *, int, int);
struct addr_entry *memref(int, struct addr_entry *, int max_disp);
void branch(struct sem_rec *);
void fbranch(struct sem_rec *);
void fcmp(struct sem_rec *);
void call(struct sem_rec *);
void jmp(struct sem_rec *);
void l(struct sem_rec *);
void adr(struct sem_rec *);
void mov(struct sem_rec *);
void nop(void);
void retrn(void);
void neg(struct sem_rec *,struct sem_rec*);
void mvn(struct sem_rec *,struct sem_rec*);
void not(struct sem_rec *);
void s(struct sem_rec *);
void samemem(struct sem_rec *);
void cvt(struct sem_rec *);

/* valid integer checking */
extern int valid_integer;
extern int valid_negated;
extern int valid_flipped;
extern int valid_load;
int is_valid_int(unsigned int b);
int valid_int_help(unsigned int a);

unsigned int ConstantValue(struct addr_entry *t);
void checklabel(struct addr_entry* t);


#endif
