
/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/isem.h,v $
 $Date: 2002/07/19 19:10:37 $
 $Revision: 1.9 $
 $Name:  $

 Log of changes:

 $Log: isem.h,v $
 Revision 1.9  2002/07/19 19:10:37  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.8  2002/07/16 19:42:50  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.7  2001/09/05 18:44:16  jdh8d
 *** empty log message ***

 Revision 1.6  2001/08/21 00:11:03  jdh8d
 *** empty log message ***

 Revision 1.5  2001/05/16 18:53:32  jdh8d
 Changes to support "soft floating point"

 Revision 1.4  2001/04/19 15:11:00  jdh8d
 Initial implentation of "if conversion" for basic predicated
 execution.

 Revision 1.3  2001/04/04 19:40:17  jdh8d

 changes to support pre/post modification of an address register.

 in simp.c we added support to change:

 	r[X]=R[..];r[Y]=r[Y]; to simply remove the 2nd effect.

 This came from

 	r[X]=R[..];r[Y]=r[Y]+r[Z]; to simply remove the 2nd effect.

 but r[Z] was later recognized to be zero.  It works if the useless
 effect comes first as well.

 Revision 1.2  2001/02/03 13:02:58  jdh8d
 Lastest version of the back end.  I added the "cmp" and branch instructions.
 At this point, i compiled a small for loop with a print statement inside.
 Moving addresses to regsiters is tricky though.  I'm not sure how we'll
 be able to help.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.1  2000/09/15 23:05:47  jwd
 Initial revision

*************************************************************************/

#ifndef ISEM_H
#define ISEM_H

#include "addrdef.h"
#include "recdef.h"

extern int sem_ptr;

struct sem_rec *record(struct addr_entry *, struct addr_entry *, struct addr_entry *);

struct sem_rec *pre_record(struct addr_entry *d1, struct addr_entry *d2,
 struct addr_entry *d3, struct sem_rec *rec);
struct sem_rec *cmp_record(struct addr_entry *, struct addr_entry *, struct addr_entry *, char );

struct sem_rec *brecord(int, struct addr_entry *, struct addr_entry *);
struct sem_rec *rrecord(char *, struct addr_entry *, struct addr_entry *,
 struct addr_entry *);
struct sem_rec *binary_op(struct addr_entry *, struct sem_rec *);
struct addr_entry *same(struct addr_entry *, struct addr_entry *);
struct sem_rec* add_predicate(struct sem_rec* sem, char* predicate, struct addr_entry* second_src);

struct sem_rec *fcmp_record(struct addr_entry *d1, struct addr_entry *d2,
        struct addr_entry *d3, char* d4);


struct sem_rec *mla_record( struct sem_rec *s, struct addr_entry* inc);

#endif


