/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/rtl.c,v $
 $Date: 2004/01/21 18:39:47 $
 $Revision: 1.98 $
 $Name:  $

 Log of changes:

 $Log: rtl.c,v $
 Revision 1.98  2004/01/21 18:39:47  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.96  2003/11/17 22:08:50  clc5q
 Add GlobalIsFunction(), which determines whether a struct globalsym is
    a function based on the contents of its SectionBuffer.

 $Log: rtl.c,v $
 Revision 1.98  2004/01/21 18:39:47  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.95  2003/11/02 19:48:42  clc5q
 Add stubbed out function NotProcessingGlobal() for data placement use.

 Revision 1.94  2003/10/08 15:17:07  jdh8d
 fixed begin/end_trans mismatch

 Revision 1.93  2003/08/01 01:06:54  jg9h
 Support interface changes made due to addition of loop count down and repeat block support

 Revision 1.92  2003/05/04 01:36:26  clc5q
 Delete obsolete, unused function maybe_same_new().

 Revision 1.91  2003/05/01 00:56:55  jg9h
 Added a parameter to comparison()/md_replace_induction_var()/md_can_replace_induction_var()

 Revision 1.90  2003/04/29 20:09:37  jg9h
 Added md_can_replace_induction_var() and md_replace_induction_var()

 Revision 1.89  2003/01/24 20:20:48  clc5q
 Move maybe_same() from each target's rtl.c module up into combine.c.
    Make calls into rtl.c for machine-dependent information or processing.

 Revision 1.88  2002/10/11 17:45:17  clc5q
 Stub out divconst(); currently implemented only in SPARC.

 Revision 1.87  2002/07/31 18:01:15  jdh8d
 bug fix for predicated rtls in comp()

 Revision 1.86  2002/07/16 21:48:10  clc5q
 Export find_unification_point().

 Revision 1.85  2002/07/16 19:44:03  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.84  2002/06/24 13:20:40  jdh8d
 *** empty log message ***

 Revision 1.83  2002/06/21 23:23:45  jdh8d
 *** empty log message ***

 Revision 1.82  2002/06/20 14:06:22  jdh8d
  applied bug fix from sparc to the rest of the machines

 Revision 1.81  2002/04/22 16:11:20  jwd
 Added a return NULL at the end of find_unification_point.  It should return
 NULL if we fall out of the loop.

 Revision 1.80  2002/03/29 20:02:45  rv3s
 Changed all remv_rtl() to nullify_rtl() that nulls out rtl->val and deadlist. This is to confirm to the convention that machine dependent optimizations (except fixentry) should not remove rtls

 Revision 1.79  2002/03/18 17:13:12  jdh8d
 *** empty log message ***

 Revision 1.78  2002/02/22 20:56:07  rv3s
 New routine possibly_same_mem_location() called from maybe_same to check if two memory references can potentially refer to overlapping locations

 Revision 1.77  2002/01/03 16:46:32  jdh8d
 *** empty log message ***

 Revision 1.76  2001/12/30 23:47:11  jdh8d
 *** empty log message ***

 Revision 1.75  2001/12/29 13:52:14  jdh8d
 *** empty log message ***

 Revision 1.74  2001/12/29 13:40:01  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.73  2001/12/11 14:48:07  jdh8d
 *** empty log message ***

 Revision 1.72  2001/12/07 16:14:59  jdh8d
 *** empty log message ***

 Revision 1.71  2001/12/06 14:40:41  rv3s
 new routine maybe_same_new() added to handle mem expressions better

 Revision 1.70  2001/12/05 19:11:52  rv3s
 remv_useless_cond_branches now calls try_compare_with_const_opt to see if the CC=reg?const optimization can be done

 Revision 1.69  2001/12/03 19:52:57  jdh8d
 *** empty log message ***

 Revision 1.68  2001/11/28 18:33:03  jdh8d
 *** empty log message ***

 Revision 1.67  2001/11/28 15:11:50  jdh8d
 *** empty log message ***

 Revision 1.66  2001/11/27 21:02:59  jdh8d
 *** empty log message ***

 Revision 1.65  2001/11/22 02:19:22  jdh8d
 *** empty log message ***

 Revision 1.64  2001/11/21 18:08:58  jdh8d
 *** empty log message ***

 Revision 1.63  2001/11/21 18:00:28  jdh8d
 *** empty log message ***

 Revision 1.62  2001/11/19 16:21:21  jdh8d
 bug fix to remove_useless_cond_branchs

 Revision 1.61  2001/11/16 17:23:11  jdh8d
 *** empty log message ***

 Revision 1.60  2001/11/15 00:59:28  rv3s
 move_and_predicate cannot move a block with function calls. Side effect check added before moving rtls

 Revision 1.59  2001/11/14 19:44:32  jdh8d
 *** empty log message ***

 Revision 1.58  2001/11/13 17:04:49  jdh8d
  fixed memory leaks

 Revision 1.57  2001/11/12 16:34:05  rv3s
 rtl links fix in move_and_predicate

 Revision 1.56  2001/11/08 21:09:36  jdh8d
 *** empty log message ***

 Revision 1.55  2001/11/07 01:48:02  jdh8d
 *** empty log message ***

 Revision 1.54  2001/11/06 19:16:35  rv3s
 Following new features added
 1. comp() now reverses condition code sets like CC = const?reg into CC = reg?const (accompanied by reversing the branch condition), as the former is not valid and latter is
 2. Branch target instrns are predicated if it is profitable and the branch target has no other predecessors

 Revision 1.53  2001/11/06 19:09:36  rv3s
 locget modified to follow mips version and fix bugs with pseudo register numbers greater than 40

 Revision 1.52  2001/10/30 14:53:16  jdh8d
 *** empty log message ***

 Revision 1.51  2001/10/29 19:23:18  jdh8d
 *** empty log message ***

 Revision 1.50  2001/10/29 18:37:23  jdh8d
 *** empty log message ***

 Revision 1.49  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.48  2001/10/22 20:42:53  jdh8d
 *** empty log message ***

 Revision 1.47  2001/10/22 18:48:29  jdh8d
 *** empty log message ***

 Revision 1.46  2001/10/11 14:41:34  jdh8d
 *** empty log message ***

 Revision 1.45  2001/10/10 19:51:06  jdh8d
 *** empty log message ***

 Revision 1.44  2001/10/10 18:29:03  rv3s
 While changing an unconditional branch to conditional branch, follow the links.

 Revision 1.43  2001/10/10 15:58:09  jdh8d
 *** empty log message ***

 Revision 1.42  2001/10/08 15:13:50  jdh8d
 *** empty log message ***

 Revision 1.41  2001/10/04 18:31:29  jdh8d
 *** empty log message ***

 Revision 1.40  2001/09/25 21:32:58  jdh8d
 *** empty log message ***

 Revision 1.39  2001/09/25 15:50:28  jdh8d
 *** empty log message ***

 Revision 1.38  2001/09/24 20:35:35  jdh8d
 *** empty log message ***

 Revision 1.37  2001/09/24 19:47:14  rv3s
 Needless link from an auto-incr multi-rtl to the increment rtl removed

 Revision 1.36  2001/09/05 18:44:16  jdh8d
 *** empty log message ***

 Revision 1.35  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.34  2001/08/28 21:04:59  jdh8d
 *** empty log message ***

 Revision 1.33  2001/08/21 00:11:03  jdh8d
 *** empty log message ***

 Revision 1.32  2001/07/23 16:10:46  jdh8d
 *** empty log message ***

 Revision 1.31  2001/07/20 15:48:49  jdh8d
 *** empty log message ***

 Revision 1.30  2001/07/17 21:55:28  jdh8d
 *** empty log message ***

 Revision 1.29  2001/07/17 16:56:10  jdh8d
 *** empty log message ***

 Revision 1.28  2001/06/08 15:05:38  jdh8d
 *** empty log message ***

 Revision 1.27  2001/06/06 14:27:25  jdh8d


 Added scaled address modes:

 	r[3]=R[r[1]+(r[2]{2)];r[1]=r[1]+(r[2]{2); for an example

 fixed form_expr bug with large constants

 Revision 1.26  2001/06/05 18:55:35  jdh8d
 *** empty log message ***

 Revision 1.25  2001/06/04 11:06:02  jdh8d
 *** empty log message ***

 Revision 1.24  2001/05/17 23:07:21  jdh8d
 *** empty log message ***

 Revision 1.23  2001/05/07 20:21:17  jdh8d
 *** empty log message ***

 Revision 1.22  2001/04/26 19:00:16  jdh8d

 initial version of machine dependend scheduling for arm.

 Revision 1.21  2001/04/26 01:34:53  jdh8d
 *** empty log message ***

 Revision 1.20  2001/04/26 00:00:39  jdh8d
 *** empty log message ***

 Revision 1.19  2001/04/25 19:39:53  jdh8d

 added check for a conditional branch that has both the left and right
 going to the fallthrough block.

 Revision 1.18  2001/04/25 16:05:09  jdh8d

 Added remove_useless_cond_branches.  This may go to mach. independent
 sometime soon.  It's pretty useful.

 Revision 1.17  2001/04/25 12:38:32  jdh8d
 changes to form_expr to support large constants in an
 expression w/o generating bad code.

 Revision 1.16  2001/04/25 02:50:19  rv3s
 exit_cond and comparison now check the condition codes correctly

 Revision 1.15  2001/04/25 02:47:36  jdh8d


 fixed a bug in strength reduction, it was looking for c*i+d
 and it found (r[8]+((r[12]+1-r[6])*2).  When it recursed
 it found dee=1-r[6].  When unwinding, it tried to multiply c and
 d by 2.. unfortunately is_const(dee) passed, and it "lost" the -r[6]
 part.  I added a check is_const(dee) && *is_const(dee)==0 (eg, the
 constant is the only thing in the string)

 Revision 1.14  2001/04/24 14:32:40  jdh8d


 changed pred_div to , from :

 Revision 1.13  2001/04/11 21:12:41  jdh8d
 strength reduction fixes, accepted multiply by constant
 if the constant is a power of 2..

 Revision 1.12  2001/04/09 20:48:30  jdh8d
 *** empty log message ***

 Revision 1.11  2001/04/04 19:40:18  jdh8d

 changes to support pre/post modification of an address register.

 in simp.c we added support to change:

 	r[X]=R[..];r[Y]=r[Y]; to simply remove the 2nd effect.

 This came from

 	r[X]=R[..];r[Y]=r[Y]+r[Z]; to simply remove the 2nd effect.

 but r[Z] was later recognized to be zero.  It works if the useless
 effect comes first as well.

 Revision 1.10  2001/03/23 21:58:55  jdh8d

 Register assignment bug, recorded signed/unsigned-ness of
 byte and halfword variables.

 Revision 1.9  2001/03/14 21:09:22  jdh8d


 inst.c:  added support for  r[x]=r[x]*r[y] by printing it out as
 if it were r[x]=r[y]*r[x] which is a valid instruction.

 regs.c:  changed the multiply "fix" to only work if all 3 regs
 are the same.

 rtl.c: made mask an int so 0xffff would get printd right.

 Revision 1.8  2001/03/14 20:39:05  rv3s
 'D' already used for doubles. 'E' used for unsigned bytes

 Revision 1.7  2001/03/14 19:05:19  rv3s
 Added new memchar types 'X' and 'Y' for handling half-word spills and restores
 (of locals).  'X' refers to unsigned half-word and 'Y' refers to signed. The
 load() routine performs masking or shifting (depending on the sign)
 Types 'C' and 'D' similarly added for byte spills and restores

 Revision 1.6  2001/03/12 20:02:31  jdh8d
 *** empty log message ***

 Revision 1.5  2001/02/27 22:35:10  jdh8d
 *** empty log message ***

 Revision 1.4  2001/02/20 14:30:17  jdh8d

 Added lots of support:  r-reg=label (adr instr) halfword loads/stores.
 Many fixentry bugs taken care of.

 Revision 1.3  2001/02/12 21:54:22  jdh8d
 fixes for call, changed ST=GLO[1],0,0 to just ST=GLO[1]

 still need to add ST=rreg

 Revision 1.2  2001/02/04 23:36:48  jdh8d
 Most of the integer instructions now work, including cmp, and the branches.
 Non parameter variables are all working as far as I know, and the floating
 point instructions work.


 works:	ldr, str, add, sub, mul, adr, mov, shift left (mov r0, r1 asl r2),
 shift right (mov r0, r1 rsl r2), mufs, adfs, sufs, difs, mufd, adfd, sufd,
 difd, difd, stfs, stfd, ldfs, ldfd.

 Turned off optimization for debugging purposes.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.3  2000/06/10 18:48:35  jwd
 Converted to ANSI C.


*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "../lib/vpo.h"
#include "../lib/assign.h"
#include "../lib/cdmotion.h"
#include "../lib/combine.h"
#include "../lib/database.h"
#include "../lib/links.h"
#include "../lib/locals.h"
#include "../lib/misc.h"
#include "../lib/vectors.h"
#include "../lib/view.h"

#include "inst.h"
#include "predicates.h"
#include "regs.h"
#include "regs2.h"
#include "rtl.h"

/*
 * This file contains RTL format definitions for the target machine
 */

char *ret = "RT";                         /* Label for subroutine return  */
char *pc_equ = "PC=";                     /* Set program counter          */
char *lab_mask = "L00%d";                 /* Mask to make working labels  */
char *opstr = "+-{}\\&|^\"*/~%#:!><'`slhg,?"; /* Set of operators           */
int index_reduce = TRUE;                 /* No index reduction           */

static struct list *
add_offset_to_item(struct bblock* cblk, struct list* ptr, char* item, int offset);
int 
is_register_shift(struct list* rtlptr, char** new_current, int *the_const,
                  int *is_left, int *is_signed);
int 
needs_extension(struct locuse* ptr,struct list* rtl,struct bblock* cblk,
                char* initial_reg, char* current_reg, int size, int signed);
void 
process_work_list();

struct reg_assignment_work_list_item *
is_in_work_list(struct list* rtl);

#define COMPARISON_NOT_TRUE 0
#define COMPARISON_TRUE 1
#define COMPARISON_MAYBE_TRUE 2

int 
get_test_outcome(char* left, char* right, char cond);

int 
ind_if_sizes_dont_match(char* code,char memChar);

void add_to_reg_assignment_work_list(
        struct locuse* ptr,             /* the local var */
        struct list* rtl,               /* the rtl with the reference */
        char* reg,                      /* the register it was replaced with */
        int the_size,                   /* the size of the var, 8 or 16 */
        int is_signed                   /* whether the var was signed or not */
     ) ;

struct reg_assignment_work_list_item
{
	struct locuse* ptr;		/* the local var */
	struct list* rtl;		/* the rtl with the reference */
	char reg[REGSTRING];		/* the register it was replaced with */
	int the_size;			/* the size of the var, 8 or 16 */
	int is_signed;			/* whether the var was signed or not */


	/* the next item on the list */
	struct reg_assignment_work_list_item *next; 

};
static struct reg_assignment_work_list_item *reg_assignment_work_list=NULL;

/*
 * NotProcessingGlobal - used in callgraph/data placement optimization.
 */
int NotProcessingGlobal(char *line) {
   return TRUE;
}

/*
 * GlobalIsFunction - returns TRUE if the global symbol table entry is
 * a function, as indicated by the contents of its sectionBuffer; returns
 * FALSE otherwise.
 */
int GlobalIsFunction(struct globalsym *global) {
   return (NULL != strstr(global->sectionBuffer, ".text"));
}


/*
 * mdEmitPadBytes - Emit the proper assembler directive to allocate space
 * for the padding bytes at the end of a global.
 * NOTE: Cloned from SPARC, need to confirm actual assembler directive
 * for this target !!!!!!
 */
void mdEmitPadBytes(struct globalsym *global) {
   assert(NULL != global);
   assert(0 < global->PadBytes);

   (void) printf(".space %d\n", global->PadBytes);
   return;
} /* end of mdEmitPadBytes() */

/*
 * mdEmitCommonGlobal - Emit the proper assembler directives to allocate space
 * for a global in the common-block (uninitialized data) section.
 */
void mdEmitCommonGlobal(struct globalsym *global) {
   assert(NULL != global);
   assert(0 <= global->PadBytes);

   (void) printf("%s:\n", globalname(global->code));
   (void) printf(".space %d\n", global->size);  /* !!! Port to ARM !!! */

   return;
} /* end of mdEmitCommonGlobal() */

/* GlobalIsCommonData - returns TRUE if the global symbol table entry is
 * an uninitialized common-block data item, as indicated by the contents
 * of its sectionBuffer; returns FALSE otherwise. WARNING: SPARC code.
 */
int GlobalIsCommonData(struct globalsym *global) {
   return ((NULL != strstr(global->sectionBuffer, "bss"))
           || (NULL != strstr(global->FirstLine->line, "common")));
}

/*
 * GetGlobalPlacementSection - analyze the sectionBuffer for a global
 * symbol table entry and return the initial partition number for global
 * data placement.
 * WARNING!!!!!!  This is just a copy of the SPARC function.  To port
 * global data placement to the ARM, you must research the use of
 * section directives on the ARM and modify the code below.
 */
int GetGlobalPlacementSection(struct globalsym *global) {
   char *a, *b;

   if (NULL != strstr(global->sectionBuffer, ".text"))
      return (-1);
   else if (NULL != strstr(global->sectionBuffer, ".rodata"))
      return 0;
   else if (NULL != (a = strstr(global->sectionBuffer, ".rodata1"))) {
      /* We will merge rodata and rodata1 sections. */
      while (*a != '1')
         ++a;
      b = a + 1; /* Skip over the '1' in ".rodata1". */
      while (*b)
         *a++ = *b++;
      *a = '\0';
      return 0;
   }
   else if (NULL != strstr(global->sectionBuffer, ".bss"))
      return 1;
   else if (NULL != strstr(global->sectionBuffer, ".data"))
      return 2;
   else if (NULL != (a = strstr(global->sectionBuffer, ".data1"))) {
      /* We will merge data and data1 sections. */
      while (*a != '1')
         ++a;
      b = a + 1; /* Skip over the '1' in ".rodata1". */
      while (*b)
         *a++ = *b++;
      *a = '\0';
      return 2;
   }
   else {
      (void) fprintf(stderr, "WARNING: Unknown section type for global: %s\n",
                     (globals + global->gallocIndex));
      (void) fprintf(stderr, " Section Buffer: %s\n", global->sectionBuffer);
      return 3; /* Group unknowns together until they get fixed. */
   }
} /* end of GetGlobalPlacementSection() */


/*
 * mdlinks - set up machine dependent combiner links
 */
void mdlinks(struct list *ptr) 
{

  int ismemop=0;
  struct list *p=NULL, *p2=NULL;
  char destreg[MAXSTRING]={0,},mem_str[MAXSTRING]={0,};
  char *a=NULL,*e=NULL;
  int i=0;

    if ((set_cc(ptr->val) || is_rjmp(ptr->val)) && cnts(ptr->prev))
      (void) add_link(ptr, ptr->prev);

  ismemop =  gtmem(ptr->val)!=0;

  if (is_pc(ptr->val) || is_call(ptr->val))
    return;


  /* in a pre/post incr rtl try to link the register on the register that is used */
  if(ismemop && fmatch(ptr->val,";") && fmatch((a=epos),";"))
  {
	/* get the incrimented reg */
	gtstr(a,a+2,destreg);
  	for (p = ptr->next;p;p = p->next) 
	{
		if(p->val && (p->type&RTLINE==RTLINE) && gtmem(p->val))
			goto mem_links;
		if(fmatch(p->val, a) && *epos!='=')
		{
			add_link(p,ptr);
			goto mem_links;
		}
		else
			goto mem_links;
	}
  }

mem_links:


/*
	watch for:

	r[12]=r[5]
	r[5]=r[12]+1
	R[r[12]]

*/
  if(!ismemop)
	goto incr;

  gtmem(ptr->val);
  gtstr(bpos,epos,mem_str);

  /* hunt through the previous rtls */
  for (p = ptr->prev;p;p = p->prev) 
  {
  	if(!p->val || (p->type&RTLINE!=RTLINE))
  		continue;
  	a=mem_str;
  	/* for each register used in the memory operation */
  	while(a=gtrgstr(a,destreg))
  	{
  		/* if we're defining a reg used in the mem op*/
  		if(fmatch(p->val,destreg) && *epos=='=')
  		{

			/* search through the links that define this reg */
                      	for (i = 0; i < MAXLINKS && (p2=p->blnks[i]); i++) 
  			{
  				char* b;
  				char b2[REGSTRING];
  				if(!p2->val || (p2->type&RTLINE!=RTLINE))
  					continue;
  				if(gtmem(p2->val))
  					continue;
  				gtrgstr(p2->val,b2);
  
  				/* this is linked to the define of a reg used in memory
  				and it looks like it might benefit from
  				a pre/post modification */
				if(fmatch(gtrg(p2->val), b2) && 
					/* this should be a pre/post incr as well */
					(fmatch(p2->val, "+")||fmatch(p2->val, "-")))
				{
					if(p2->rnum>ptr->rnum)
						add_link(p2,ptr);
					else
						add_link(ptr,p2);
					goto incr;
				}
			}
			goto incr;
			
		}
		else if(fmatch(p->val,destreg))
			goto incr;
	}
  }

incr:

/*
	watch for a memory op followed by an increment of one of the
	registers, we might be able to combine here 
*/

  if(ismemop)
	goto next;

    /* Check if the dest reg is same as one of the sources */
  a = ptr->val;
  gtrgstr(a,destreg);
  if(!fmatch(ptr->val+3,destreg))
	return;

  for (p = ptr->prev;p;p = p->prev) 
  {
    char *c;

    if (!p->val || ((p->type&RTLINE)!=RTLINE))
      continue;

    /* don't try it across calls */
    if(strncmp(p->val,"ST=",3)==0)
        goto next;


    ismemop = gtmem(p->val)!=0;

    /* Check to see if this rtl uses or defines the register */
    if (!ismemop && fmatch(p->val, destreg))
	  /* if so, return, we can't link */
          goto next;

    /* otherwise, if we haven't found memory, try the next rtl */
    else if(!ismemop)
	continue;

    /* Memory op. Check to see if the memop uses the register as a base register */

    e = gtmem(p->val);
    gtstr(bpos,e, mem_str);

    /* if we match in the rtl, look closer */
    if(fmatch(p->val,destreg)) 
    {
      /* if there is  match in memory, add the link */
      if(fmatch(mem_str,destreg))
        add_link(ptr,p);

      /* one way or another we've found the reg, return now */
      goto next;
    }
    /* even though it was a memory, we didn't find our reg, continue */
  }

next:
  if(ismemop)
        goto next2;

  a = ptr->val;
  gtrgstr(a,destreg);

  for (p = ptr->prev;p;p = p->prev) 
  {
    char *c;

    if (!p->val || ((p->type&RTLINE)!=RTLINE))
      continue;

    ismemop = gtmem(p->val)!=0;


    /* are we copying the suspect register? */
    if (!ismemop && fmatch(p->val, destreg) && strlen(p->val)==6 &&
	(fmatch(p->val, "+") || fmatch(p->val, "-")))
	break;
    /* Check to see if this rtl uses or defines the register */
    if (fmatch(p->val, destreg)) 

	/* if so, we skip out */
	goto next2;
  }
  if(!p)
	goto next2;

  strncpy(destreg, p->val,2);
  destreg[2]=0;
  for (p2 = ptr->next;p2;p2 = p2->next) 
  {
    char *c;

    if (!p2->val || ((p2->type&RTLINE)!=RTLINE))
      continue;

    ismemop = gtmem(p2->val)!=0;

    /* Check to see if this rtl uses or defines the register */
    if (ismemop && fmatch(p->val, destreg))
    {
        add_link(p2,ptr);
	goto next2;
    }
  }

next2:
/* watch for incriments immediately after a copy of a reg.  we add a link
because we might be able to do some combining */


	/* first, is this an inc/dec? */
	/* reg=reg+<reg|expr>; */
	if(strlen(ptr->val)>=7 && fmatch(ptr->val, "+") && !gtmem(ptr->val) &&
		ptr->val[0]==ptr->val[3] && ptr->val[1]==ptr->val[4])
	{
		/* it is an inc/dec */
		destreg[0]=ptr->val[0];	
		destreg[1]=ptr->val[1];	
		destreg[2]=0;
  		for (p = ptr->prev;p;p = p->prev) 
  		{
    			if (!p->val || ((p->type&RTLINE)!=RTLINE))
      				continue;
			/* is this reg found? */
			if(!fmatch(p->val, destreg))
				continue;
			if(*epos=='=')
			{
				/* we're defining it, n/m */
				goto next3;
			}

			/* hey!, we're using it */
			/* is this a reg-reg copy? */
			/* reg=reg; */
			if(strlen(p->val)==6 && p->val[2]=='=' && p->val[5]==';')
			{
				/* looks like it, we add a link */
				add_link(ptr,p);
				goto next3;
			}
		}

	}


next3:
	return;
}

/*
 * rtlprt - called by dmplist() after it prints out each RTL
 */
void rtlprt(struct list *ptr, int *rnum) {

}

/*
 * findlabel - searches an RTL for a label and returns it
 */
char *findlabel(char *line, int *direct) {
    register char c, *s, *l;
    register int len;
    char label[MAXSTRING];

    *direct = TRUE;
    s = line;
    while ((c = *s++) != 'L') {
      if (!c)
        return((fmatch(line, ret)) ? strcpy(CALLOC(3), ret) : (char *) NULL);
      }
    if (s != (line + 1))
      *direct = FALSE;
    l = label;
    *l++ = c;
    for (len = 2; (c = *s++) != ';' && c != '-' && c; len++)
      *l++ = c;
    *l = '\0';
    return(strcpy(CALLOC(len), label));
}

/*
 * reverse - negate the branch condition and change target label of RTL
 */
void reverse(struct list *rtl, char *label) 
{
   char new[MAXSTRING];
   char* a=new,*b;
   
   strcpy(new,rtl->val);

   assert(*a=='P'); a++;
   assert(*a=='C'); a++;
   assert(*a=='='); a++;
   assert(isreg(a) && regtype(a)==CTREG && regnum(a)==0);
   a=skiploc(a);

   switch (*a) 
   {

      case ':':
         *a = '!';
         break;

      case '!':
         *a = ':';
         break;

      case '>':
         *a = '\'';
         break;

      case '<':
         *a = '`';
         break;

      case '`':
         *a = '<';
         break;

      case '\'':
         *a = '>';
         break;

      case 'h':
         *a = 's';
         break;

      case 'l':
         *a = 'g';
         break;

      case 'g':
         *a = 'l';
         break;

      case 's':
         *a = 'h';
         break;

      default:
         (void) fprintf(stderr, "vpo (reverse): bad conditional, '%s'\n",
                        rtl->val);
         exit(1);
   }
   while ((*a++) != ',');

    /*
     * Place the new label in the RTL
     */
    b = label;
    while (*a++ = *b++);
    *(a - 1) = ';';
    *a = '\0';
    FREE(rtl->val);
    rtl->val = strcpy(CALLOC(strlen(new) + 1), new);
}


/* invertBranch - we are changing the relative order of the two operands.
  *                This will also require changing the branch direction. Note
  *                that this change is different than reversing the branch.
  *                eg. '>' branch will be changed to '<' and not '<=', which
  *                would be the case when reversing branch in the traditional
  *                sense in some function like reverse branches.
  */
char invertBranch(struct list *rtl, char *label)
{
    register char *a, *b, *c;
    char  new[MAXSTRING], *relop, pattern[REGSTRING];

    a = rtl->val;
    b = new;


    if (*a++ != 'P' || *a++ != 'C' || *a++ != '=')
    {
       fprintf(stderr, "Invalid Branch rtl\n");
       show(rtl->val);
       exit(1);
    }
    if(!isreg(a) || regtype(a) != CTREG || regnum(a) != 0)
    {
       fprintf(stderr, "Invalid Branch rtl\n");
       show(rtl->val);
       exit(1);
    }
    a = skiploc(a);

    /*c = rtl->val;
    while (!is_rel(*c))
    *b++ = *c++;*/
    
    makereg(pattern,CTREG,0);
    sprintf(new, "PC=%s", pattern);
    for(b=new ; b && *b ; b++);
    

    relop = b;
    switch (*a++) {

     case ':':
        *b = '!';
        break;

     case '!':
        *b = ':';
        break;

     case '>':
        *b = '<';
        break;

     case '<':
        *b = '>';
        break;

     case '`':
        *b = '\'';
        break;

     case '\'':
        *b = '`';
        break;

     case 'h':
        *b = 'l';
        break;

     case 'l':
        *b = 'h';
        break;

     case 'g':
        *b = 's';
        break;

     case 's':
        *b = 'g';
        break;

     default:
        (void) fprintf(stderr, "vpo (reverse): bad conditional, '%s'\n",
                       rtl->val);
        exit(EXIT_FAILURE);
    }
    b++;
    while ((*b++ = *a++) != ',') ;
    a = label;
    while (*b++ = *a++) ;
    *(b - 1) = ';';
    *b = '\0';
    FREE(rtl->val);
    rtl->val = strcpy(CALLOC(strlen(new) + 1), new);
#ifdef INTERACT
    mod_rtl(rtl, NULL, rtl->val);
#endif

    return(*relop);
}


/*
 * is_call - see if string is a procedure call
 */
int is_call(char *s) {

    return(*s++ == 'S' && *s == 'T');
}

/*
 * is_pc - see if the string begins with the program counter
 */
char *is_pc(char *s) {

    if (*s++ == 'P' && *s++ == 'C')
      return(s);
    else
      return((char *) NULL);
}

/*
 * dont_bother_with - return TRUE if expression should not be tracked by CSE
 */
int dont_bother_with(char *s) {

    return((*s == 'P' && *(s + 1) == 'C') ||
           (*s == 'S' && *(s + 1) == 'T'));
}

/*
 * is_rjmp - is RTL a relational jump
 */
int is_rjmp(char *s) 
{
	if(*s++!='P') return FALSE;
	if(*s++!='C') return FALSE;
	if(*s++!='=') return FALSE;
	if(cmploc(cc_reg,s)!=0) return FALSE;
        return TRUE;

}

/*
 * is_return - see if string is a procedure return
 */
int
is_return(register char *s)
{
   return ((s = is_pc(s)) && *++s == 'R' && *++s == 'T');
}

/*
 * locget - return a reference to a local variable if found
 */
int locget(char **val, char *code, int *type, int *ind, int *set, struct list *rtl) 
{
	char *v;
	char frame_pointer[REGSTRING];
	
	if(*val==0)
		return FALSE;
	
	makereg(frame_pointer, RTREG, fp_num);   
	
	*ind = TRUE;
	*set = FALSE;
	v = *val;
    	while (  *v ) 
    	{
      		if (cmploc(frame_pointer,v)==0) 
      		{
			v = skiploc(v);
        		if (*v == '+' && islocal(v+1)) 
			{
          			copyloc(code,v+1);
	  			v=skiploc(v+1);
          			*val = v;
		
          			return(TRUE);
        		}
      			else if (islocal(v))
      			{
				copyloc(code,v);
				v=skiploc(v);
				*val = v;

				return(TRUE);
			}
      		}
      		else if (*(v+1) == '[' && mems[(int) *v] != NOTYPE) 
      		{
			char *v2;
        		char memChar=*v;
        		v=v+2; /* skip a mem ref */
			v2=skiploc(v);
        		if (cmploc(frame_pointer,v)==0 && *v2=='+' && islocal(v2+1)) 
        		{

	  			/* skip the "fp+" */
	  			v=v2+1;
          			copyloc(code,v);
  	  			localrecord(code)->memChar=memChar;
	  			v=skiploc(v);
          			if (*v++ == ']') 
          			{
	    				if (*v == '&')  
            				{
	      					if ( memChar == 'W')
							localrecord(code)->memChar = 'X';
	      					else if (memChar == 'B')
							localrecord(code)->memChar = 'C';
	    				} 
	    				else if (*v == '{') 
	    				{
	      					if (memChar == 'W')
							localrecord(code)->memChar = 'Y';
	      					else if (memChar == 'B')
							localrecord(code)->memChar = 'E';
	    				} 
	    				else 
	    				{
						if(localrecord(code)->memChar=='X' || 
	 	   					localrecord(code)->memChar=='Y' ||
		   					localrecord(code)->memChar=='C' || 
		   					localrecord(code)->memChar=='E')
							; /* do nothing */
						else
	      	   					localrecord(code)->memChar=memChar;
	    				}
	    
	    
            				*ind = ind_if_sizes_dont_match(code,memChar);
	    				if(memChar=='B' || memChar=='W') memChar='R';	
            				*type = mems[(int) memChar];
            				if (*v == '=')
              					*set = TRUE;
            				*val = v;
            				return(TRUE);
          			} 
	  			else 
	  			{
	    				int depth=1;
	    				if(memChar=='B' || memChar=='W') memChar='R';	
            					*type = mems[(int) memChar];
            				while (depth > 0) {
	      					if (*v == '[')
							depth++;
	      					else if (*v == ']')
							depth--;
	      					v++;
	    				}
	    
	    				if (*v == '=')
	      					*set = TRUE;

            				*val = v;
            				return(TRUE);
	 			}
      			}
    		}
     		else 
	  		v = skiploc(v);
	}
    	return(FALSE);
}

/*
 * localref - return memory reference for non-global reference
 */
void localref(char *loc, struct locuse *ptr) 
{
    char frame_pointer[REGSTRING];

    /* make the frame pointer */
    bzero(frame_pointer, REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);   

    (void) sprintf(loc, "%c[%s+%s]", memrf(ptr->type), frame_pointer,
	ptr->code);
}

/*
 * locsub - replace a non-global  variable reference with a register
 */
struct list *locsub(struct locuse *ptr, struct list *rtl, int type, char *reg) 
{
    struct list *lptr, *bptr, *fptr;
    int i, set;
    char *a, mref[MAXSTRING], ref[MAXSTRING];
    char frame_pointer[REGSTRING];
#ifdef INTERACT
	char oldval[MAXSTRING];
#endif

    /* make the frame pointer */
    bzero(frame_pointer, REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);   

    /*
     * Look for the memory reference and replace it.  Note that the ARM
     * RTLs can have only one one memory reference per RTL, but we still have
     * to search for more than one because the machine description allows a
     * memory-to-memory move when the source and destination values are
     * identical.
     */

	/* hunt down R[fp+x] */
    (void) sprintf(mref, "[%s+%s]", frame_pointer, ptr->code);
    set = FALSE;
    while (fmatch(rtl->val, mref)) 
    {

      /*
       * Now we have to take care of undoing memory references that have
       * a sign-extension.  On the ARM, a sign extension can be performed
       * on a load, but there is no single instruction which allows a
       * register to be sign-extended, so we have to take care of it here
       * by splitting the sign-extend back out into the sequence of shifts
       * that effectively perform a sign-extension.
       */
	/* {16}16 */
      if (*epos == '{'  && *(epos+1)=='1') 
      { 
	/* links to rtl are no longer valid */
	remv_links_to(rtl);
	remv_links(rtl);

	/* (W[..........]{16)}16	*/
	/*   ^bpos	 ^epos */
	sub(bpos-2,epos+7,reg);
	add_to_reg_assignment_work_list(ptr,rtl,reg,16,TRUE);
	/*  we won't sign extend yet.  when we process the work list ...  */
      }
	/* {24}24 */
      else if (*epos == '{'  && *(epos+1)=='2') 
      { 
	/* links to rtl are no longer valid */
	remv_links_to(rtl);
	remv_links(rtl);

	/* (B[..........]{24)}24	*/
	/*   ^bpos	 ^epos */
	sub(bpos-2,epos+7,reg);
	add_to_reg_assignment_work_list(ptr,rtl,reg,8,TRUE);
	/*  we won't sign extend yet.  when we process the work list ...  */

      }
	/* &255 */
      else if (*epos == '&'  && *(epos+1)=='2') 
      { 
	/* links to rtl are no longer valid */
	remv_links_to(rtl);
	remv_links(rtl);

	/* B[..........]&255	*/
	/*   ^bpos	 ^epos */
	sub(bpos-1,epos+4,reg);

	add_to_reg_assignment_work_list(ptr,rtl,reg,8,FALSE);
	/*  we won't sign extend yet.  when we process the work list ...  */

      }
	/* & 65535 */
      else if (*epos == '&'  && *(epos+1)=='6') 
      { 
	/* links to rtl are no longer valid */
	remv_links_to(rtl);
	remv_links(rtl);

	/* W[..........]&65535	*/
	/*   ^bpos	 ^epos */
	sub(bpos-1,epos+6,reg);

	add_to_reg_assignment_work_list(ptr,rtl,reg,16,FALSE);
	/*  we won't sign extend yet.  when we process the work list ...  */

      }
      else 
      {
        if (*epos == '=')
          set = TRUE;
        (void) sub(bpos-1, epos, reg);
      }
#ifdef INTERACT
      if (swq)
	mod_rtl(rtl, NULL, rtl->val);
#elif defined(VET)
      mod_rtl(rtl);
#endif
    }

	/* hunt down R[x+fp] */
    (void) sprintf(mref, "[%s+%s]", ptr->code, frame_pointer);
    while (fmatch(rtl->val, mref)) 
    {
	
/* this realyl shouldn't happen */
assert(0);

    }

/* now we have to check for a side-effect, such as a pre/post inc/dec */
/* they look like:  r[x]=R[]; r[y]=r[y]+r[z] or similar.  the idea is that */
/* we check for 2 ;'s and move the 2nd effect to a new rtl if necessary */
   
	a=rtl->val;
	if(fmatch(rtl->val,";") && fmatch(a=epos, ";"))
	{
		char new[MAXSTRING];
		strcpy(new,a);	
        	(void) add_rtl(rtl->daddy, rtl->next, ref, rinit());
		*a=0;
	}





    /*
     * Now we need to look at situations where an item is incremented or
     * decremented, but the reference occurs inefficiently so that the
     * combiner will not be able to combine them to create the best sequence
     * of RTLs.  Usually, what we will have is a use of a local that is
     * replaced with a register (r[10] in this case) to result in the following
     * sequence of RTLs:
     *
     *    +5     r[8]=r[10];              -- load value of variable
     *    +6 {5} r[9]=r[8]+const;         -- increment/decrement
     *    +7 {6} r[10]=r[9];      r[9]    -- update variable
     *           ...                      -- possible intervening sequence
     *    +9     r[5]=B[r[8]];            -- use of old value
     *
     * Left as it is, the sequence would combine into:
     *
     *    +5     r[8]=r[10];              -- load value of variable
     *    +6 {5} r[10]=r[8]+const;        -- increment/decrement and update
     *           ...                      -- possible intervening sequence
     *    +9     r[5]=B[r[8]];   r[8]    -- use of old value
     *
     * What the following code attempts to do is to re-arrange the sequence
     * of RTLs to look like the following:
     *
     *    +5     r[8]=r[10];              -- load value of variable
     *           ...                      -- intervening sequence untouched
     *    +9 {5} r[5]=B[r[8]];    r[8]    -- use of old value
     *    +10    r[10]=r[10]+const;       -- increment/decrement and update
     *
     * Now the combiner will be able to modify this new sequence to yield a
     * better sequence of RTLs:
     *
     *     +9    r[5]=B[r[10]];           -- use of old value
     *     +10   r[10]=r[10]+const;       -- increment/decrement and update
     *
     * Now look back at the first sequence of RTLs, since the coloring
     * algorithm may change the local in any order, we must be prepared to
     * recognize this sequence regardless of which local reference (RTL 5 or
     * RTL 7) is replaced with r[10] last.
     */
    if (set && type == RTREG &&
        *rtl->val == *reg && *(rtl->val + 1) == *(reg +1) &&
        *(rtl->val + 2) == '=' && isrg(rtl->val + 3) &&
        *(rtl->val + 5) == ';' && rexists(rtl->val + 3, rtl->deads) &&
        (lptr = rtl->lnks[0]) && cnts(lptr) &&
        *lptr->val == *(rtl->val + 3) && *(lptr->val + 1) == *(rtl->val + 4) &&
        *(lptr->val + 2) == '=' && isrg(lptr->val + 3) &&
        (*lptr->val != *(lptr->val + 3) ||
         *(lptr->val + 1) != *(lptr->val + 4)) &&
/*        (*(lptr->val + 5) == '+' || *(lptr->val + 5) == '-') &&*/
/* it could be any operator, right? */
        (isoper(*(lptr->val + 5))) &&
        (a = is_const(lptr->val + 6)) && *a == ';' &&
        !rexists(lptr->val + 3, lptr->deads) && (bptr = lptr->lnks[0]) &&
        cnts(bptr) && *bptr->val == *(lptr->val + 3) &&
        *(bptr->val + 1) == *(lptr->val + 4) && *(bptr->val + 2) == '=' &&
        *(bptr->val + 3) == *reg && *(bptr->val + 4) == *(reg + 1) &&
        *(bptr->val + 5) == ';' && rexists(bptr->val+3,bptr->deads)) {

      /*
       * We have found the magic sequence.  "lptr->val + 3" points at the
       * temporary register and "lptr->val + 6" points at the constant.
       */
      *ref = *(lptr->val + 3);
      *(ref + 1) = *(lptr->val + 4);
      *(ref + 2) = '\0';

      /*
       * Now we have to search for the use of the temporary register.  If
       * we locate it, we make the transformation described above.
       */
      for (fptr = next_rtl(rtl); fptr; fptr = next_rtl(fptr)) {
        if (cnts(fptr)) {
          if (is_pc(fptr->val))
            break;
          else if (isref(fptr->val, ref) && rexists(ref, fptr->deads)) {
            (void) sprintf(ref, "%s=%s%s", reg, reg, lptr->val + 5);
            (void) add_rtl(fptr->daddy, fptr->next, ref, rinit());
            (void) add_link(fptr, bptr);
	    rdelete(reg,&bptr->deads);
            remv_links_to(lptr);
            remv_links(lptr);
            nullify_rtl(lptr);
            remv_links_to(rtl);
            remv_links(rtl);
            nullify_rtl(rtl);
            return(fptr->next);
            }
          else if (isset(fptr->val, ref))
            break;
          }
        }
      }
    else if (!set && type == RTREG &&
             isrg(rtl->val) && *(rtl->val + 2) == '=' &&
             *(rtl->val + 3) == *reg && *(rtl->val + 4) == *(reg + 1) &&
             *(rtl->val + 5) == ';' && (lptr = rtl->blnks[0]) && cnts(lptr) &&
             isrg(lptr->val) && *(lptr->val + 2) == '=' &&
             (*lptr->val != *rtl->val || *(lptr->val + 1) != *(rtl->val + 1)) &&
             *(lptr->val + 3) == *rtl->val &&
             *(lptr->val + 4) == *(rtl->val + 1) &&
             !rexists(lptr->val + 3, lptr->deads) &&
/*           (*(lptr->val + 5) == '+' || *(lptr->val + 5) == '-') &&*/
/* it could be any operator, right? */
             (isoper(*(lptr->val + 5))) &&
             (a = is_const(lptr->val + 6)) && *a == ';' &&
             (bptr = lptr->blnks[0]) && cnts(bptr) &&
             *bptr->val == *reg && *(bptr->val + 1) == *(reg + 1) &&
             *(bptr->val + 2) == '=' && *(bptr->val + 3) == *lptr->val &&
             *(bptr->val + 4) == *(lptr->val + 1) && *(bptr->val + 5) == ';'
		&& rexists(bptr->val+3,bptr->deads)) {

      /*
       * We have found the magic sequence.  "lptr->val + 3" points at the
       * temporary register and "lptr->val + 6" points at the constant.
       */
      *ref = *(lptr->val + 3);
      *(ref + 1) = *(lptr->val + 4);
      *(ref + 2) = '\0';

      /*
       * Now we have to search for the use of the temporary register.  If
       * we locate it, we make the transformation described above.
       */
      for (fptr = next_rtl(bptr); fptr; fptr = next_rtl(fptr)) {
        if (cnts(fptr)) {
          if (is_pc(fptr->val))
            break;
          else if (isref(fptr->val, ref) && rexists(ref, fptr->deads)) {
            (void) sprintf(ref, "%s=%s%s", reg, reg, lptr->val + 5);
            (void) add_rtl(fptr->daddy, fptr->next, ref, rinit());
            (void) add_link(fptr, rtl);
	    rdelete(reg,&bptr->deads);
            remv_links_to(lptr);
            remv_links(lptr);
            nullify_rtl(lptr);
            remv_links_to(bptr);
            remv_links(bptr);
            nullify_rtl(bptr);
            return(fptr->next);
            }
          else if (isset(fptr->val, ref))
            break;
          }
        }
      }

    /*
     * Register coloring sometimes creates suituations causing a register
     * that is marked dead in the line to now be set so that the death
     * creates problems.  This code simply removes the death of a register
     * that has been assigned to a local if it appeared in the dead list.
     */
    if (rexists(reg, rtl->deads))
      rdelete(reg, &rtl->deads);

    return(rtl);
}

/*
 * load - insert an RTL to load a register from a local
 */
void load(int type, int arg, char *code, struct bblock *cblk,
 struct list *iptr,  char *reg, int argline) {
    register struct list *nptr;
    char new[MAXSTRING];
    char frame_pointer[REGSTRING];
    struct locuse* the_local=localrecord(code);
    char memchar=the_local->memChar;
    char memstr[20],samt=0,prefix[10];
    int mask;
 
    /* make the frame pointer */
    bzero(frame_pointer,REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);   

    sprintf(prefix,"");
    sprintf(memstr,"");

    if(memchar=='W' || memchar=='B')
    {
	fprintf(stderr, "bad memchar %c\n", memchar);
	/* uh oh, we're loading byte/word but don't know
		if we should sign extend or truncate. */
	/* punt for now and truncate */
       if (memchar == 'W')
	   mask = 0xffff;
       else
	   mask = 0xff;
       sprintf(memstr,"&%d",mask);
      
    }

    else if (memchar == 'X' || memchar == 'C') {
      if (memchar == 'X')
	mask = 0xffff;
      else
	mask = 0xff;
      
      sprintf(memstr,"&%d",mask);


    } else if (memchar == 'Y' || memchar == 'E') {
      if (memchar == 'Y')
	samt = 16;
      else
	samt = 24;

      sprintf(memstr,"{%d)}%d",samt,samt);
      sprintf(prefix,"(");

    }

    
    if (memchar == 'X' || memchar == 'Y')
      memchar = 'W';
    else if (memchar == 'C' || memchar == 'E')
      memchar = 'B';
      

    (void) sprintf(new, "%s=%s%c[%s+%s]%s;", reg, prefix,memchar,
		frame_pointer,code,memstr);
    while (iptr && !(iptr->type & RTLINE))
      iptr = iptr->next;
    nptr = add_rtl(cblk, iptr, new, rinit());
    if (argline)
      nptr->type |= ARGLINE;
}

/*
 * store - insert an RTL to store the value of a register to a local
 */
void store(int type, int arg, char *code, struct bblock *cblk,
 struct list *iptr, char *reg, int argline) {
    register struct list *nptr;
    char new[MAXSTRING];
    char frame_pointer[REGSTRING];
    struct locuse* the_local=localrecord(code);
    char memchar=the_local->memChar;

    if (memchar == 'X' || memchar == 'Y')
      memchar = 'W';
    else if (memchar == 'C' || memchar == 'E')
      memchar = 'B';
 
    /* make the frame pointer */
    bzero(frame_pointer,REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);   


    (void) sprintf(new, "%c[%s+%s]=%s;", memchar, frame_pointer,
		code, reg);
    nptr = add_rtl(cblk, iptr, new, rinit());
    if (argline)
      nptr->type |= ARGLINE;
}

int isInvariantOperator(char *s)
{
	if(!s)	return  FALSE;
	if(*s=='&') return TRUE;
	if(*s=='|') return TRUE;
	if(*s=='^') return TRUE;

	return FALSE;
}

int fits_invariant_constraints(struct loopl* loop, struct list* rtlptr, char* reg)
{
	char reg2[REGSTRING];

	struct blist* blocklist=NULL;
	/* make sure we have a pointer to work with */
	if(!rtlptr || !cnts(rtlptr))
		return FALSE;

	/* and it's not a multi-effect rtl */
	if(fmatch(rtlptr->val, ";") && fmatch(epos,";"))
		return FALSE;

	/* and that the destination is the same as the source. */
	if(cmploc(rtlptr->val,reg)!=0)
		return FALSE;

	copyloc(reg2,reg);
	*skiploc(reg2)=0;
	/* and that all uses of the r[4] are dominated by this rtl */
	for(blocklist=loop->blocks;blocklist;blocklist=blocklist->next)
	{
		struct list* rtl;
		for(rtl=blocklist->ptr->rtls; rtl; rtl=rtl->next)
		{
			/* skip the rtl we're trying to determine if it's invariant */
			if(rtl==rtlptr)
				continue;
			if(rtl->val && isaliasref(rtl->val, reg2))
			{
				if(!rtl_dominates(rtlptr,rtl))
					return FALSE;
			}
			if(cnts(rtl) && isaliasset(rtl->val,reg2))
				return FALSE;
		}	
	}

	/* OK, we think this is safe now */
	return TRUE;

}

/*
 * is_invariant - return TRUE if expression is known to be invariant
 */
int is_invariant(char *expr, int writes, struct loopl* loop, struct list* rtlptr)

{
    struct setlist *rptr;
    char* s=expr;

    /*
     * If there are any writes in this loop, then any memory item in the
     * RTL automatically makes it non-invariant.
     */
    if (writes && gtmem(s))
      return(FALSE);

    /*
     * If any registers that are not loop-invariant are referenced, then
     * the expression is not loop-invariant.
     */
    while (s = gtrg(s))
      if (!(rptr = s_lookup(unskiploc(s))) || !rptr->ldead)
      {
		char *c1, *c2, *after_const, *after_const2;

		/* here we do some special tests to see if it's a wierd kind of invariant */
		/* in this particular case, we have: 	
		 	r[4]=r[4]&255 			
		 	r[4] is never seen as invariant.  (because it might have a different 
			value on the first iteration of the loop than the 2nd iteration 
			
			However, if r[4] isn't set elsewhere in the loop, 
			dominates all uses of r[4] and the operator in question
			is going to generate the same value over and over (eg: an AND or OR
			instruction as opposed to a add or subtract) 

		*/

		if(
			isRegister(expr) && 			/* reg */
			isInvariantOperator(skiploc(expr)) &&	/* expr */
			is_const(skiploc(expr)+1) &&		/* const */
			*is_const(skiploc(expr)+1)==0		/* null */
			&& fits_invariant_constraints(loop,rtlptr, expr)
		  )
		{
			return TRUE;
		}
		if(
			*expr=='(' &&						/* (   */
			isRegister(expr+1) && 					/* reg */
			*skiploc(expr+1)=='{' &&				/* {   */
			(after_const=is_const(c1=skiploc(expr+1)+1)) &&		/* const1 */
			*after_const==')' &&					/* )   */
			(*(after_const+1)=='}' || *(after_const+1)=='"') && 	/* } or " */
			(after_const2=is_const(c2=after_const+2)) &&		/* const2 */
			*after_const2==0					/* null */
			&& atoi(c1)==atoi(c2)					/* and c1==c2 */
			&& fits_invariant_constraints(loop,rtlptr, expr+1)
		  )
		{
			return TRUE;
		}
			

	try_next_invar:





        return(FALSE);
      }

    return(TRUE);
}

/*
 * writes_mem - return TRUE if RTL writes (or potentially writes) to memory
 */
int writes_mem(char *s) {

    /*
     * If this RTL contains a memory reference on the left side of the
     * '=', then it definitely writes to memory.  Also, if it is a call,
     * it writes to memory.
     */
    if(is_call(s))
	return TRUE;
	
    while(s=gtmem(s))
	if(*epos=='=')
		return TRUE;
    return(FALSE);
}

/*
 * usetype - return the register type needed to hold a constant expression
 */
int usetype(char *s) {
    register char c;

    c = *s;
    if (isreg(s)) {
      if (ISDTREG(c))
        return(DTREG);
      else if (ISFTREG(c))
        return(FTREG);
      }
    switch (c) {

      case 'F':
        return(FTREG);

      case 'D':
        return(DTREG);


      default:
        while (*s++ != '=');
        if (isreg(s)) {
          if (ISDTREG(*s))
            return(DTREG);
          else if (ISFTREG(*s))
            return(FTREG);
          }
        switch (*s) {

          case 'F':
            return(FTREG);

          case 'D':
            return(DTREG);
	  default:
            return(RTREG);
          }
      }
}

/*
 * const_val - attempt to discover value of constant expression
 */
int const_val(struct list *rtlptr, char *rtlin, int *value) {
    register char *a;
    char val[MAXSTRING];

    a = val;
    while ((*a++ = *rtlin++) != ';');
    *a = '\0';
    simp(val, FALSE);
    if ((a = is_const(val)) && *a == ';') {
      *value = atoi(val);
      return(TRUE);
      }
    return(FALSE);
}

/*
 * insinvar - insert RTL with invariant item
 */
struct list *insinvar(struct bblock *cblk, struct list *rtlptr, char *reg) {

    return(add_rtl(cblk, rtlptr, reg, rinit()));
}

/*
 * is_basic - return TRUE if expression is a basic induction
 */
int is_basic_help(struct list *rtlptr, char *rtlin, int *value) {
    register char *s;

    /*
     *  For details on what a basic induction variable is, see page 643
     *  of Aho, Sethi, and Ullman.
     */

    /*
     *  Make sure we have "item=item+" or "item=item-"
     */
    s = rtlin;
    while (*s++ != '=');
    while (*s++ == *rtlin++);
    if (*(rtlin - 1) != '=' || (*(s - 1) != '+' && *(s - 1) != '-'))
      return FALSE;

    /*
     *  Check to see if we have a numeric constant
     */
    if (*(s - 1) == '-')
      s--;
    return(const_val(rtlptr, s, value));
}

int is_basic(struct list *rtlptr, char *rtlin, int *value) 
{
	char rhs[MAXSTRING];
	char lhs[MAXSTRING];
	char *t;
	if(is_basic_help(rtlptr, rtlin, value))
		return TRUE;
	
/* 
 * otherise this might be a basic induction variable that isn't of
 * the proper form.  One case is:
 * 
 * r[3]=r[12]-4
 * ...		 intermediate use of r[3] 
 * r[12]=r[3]
 * 
 * Thus, we'll expand the RHS and simplify.
 * then check again 
 */

 /* for now, stay out of anything with a memory reference */
 if(gtmem(rtlin))
	return FALSE;
	
 gtds(rtlin, lhs, rhs);

 /* expand the RHS */
 expand(NULL, rtlptr, rhs);

 /* simplify the RHS */
 simp(rhs, FALSE);


 /* put the lhs and rhs back together again */
 strcat(lhs, "=");
 strcat(lhs, rhs);
 strcat(lhs, ";");

 return (is_basic_help(rtlptr, lhs, value));
}

/*
 * is_type - return type of induction expression, if any
 */
int is_type(char *s, struct setlist **fptr, int *cee, char *dee) {
    struct setlist *sptr, *cptr;
    int first, depth;
    char *d, c, temp[MAXSTRING], temp2[MAXSTRING];
    int needs_paren=FALSE;


    /*
     * Initialize return values
     */
    d = dee;
    *d = '\0';
    *cee = 1;

    /*
     * A parentheses signifies the start of a sub-expression, so we call
     * ourselves recursively to obtain its value.
     */
    	if (*s == '(') 
	{
      		sptr = *fptr;
      		first = is_type(++s, &sptr, cee, dee);
      		if (first & NOTINDUCTION)
        		sptr = (struct setlist *) NULL;
      		else if (!(first & (BASIC | INDUCTION)))
        		return(UNASSIGNED);

      		depth = 1;
      		while (depth)
		{
        		if ((c = *s++) == '(')
          		depth++;
        		else if (c == ')')
          		depth--;
		}
                for (d = dee; *d; d++)
                {
                        if (*d == '*' || *d == '{' || *d=='"' || *d=='}')
                                needs_paren=TRUE;
                        if (*d == '+' || *d == '-' || *d==')')
                                needs_paren=FALSE;

                }
      	}

    /*
     * Look for the destination register for this RTL or for a basic or normal
     * induction register.
     */
    else if (isreg(s) && (sptr = s_lookup(s)) &&
        (sptr == *fptr || (sptr->regstatus & (BASIC | INDUCTION))))
      s += 2;

    /*
     * Otherwise note the fact that we haven't yet discovered anything important
     */
    else
      sptr = (struct setlist *) NULL;

    /*
     * If we have found our induction register, we now need to get the value
     * that the register is multiplied by (if any).
     */
    if (sptr) {
      depth = FALSE;
      if (*s == '{'  && is_const(s + 1)) {
        depth = TRUE;
        first = 1 << atoi(++s);
        s = is_const(s);
        }
      else if (*s == '*' && is_const(s + 1)) {
        depth = TRUE;
        first = atoi(++s);
        s = is_const(s);
        }
      if (depth) {
        *cee *= first;
        if (first != 1 && *dee) {

	  /* oops, be careful here, dee has to be a const, and *only* a const.. nothing else */
          if (is_const(dee) && *is_const(dee)==0)
            (void) sprintf(temp, "%d", atoi(dee) * first);
          else
            (void) sprintf(temp, "((%s)*%d)", dee, first);
          (void) strcpy(dee, temp);
          for (d = dee; *d; d++);
          }
        }
      }

    /*
     * Now we can add in all of the constants (that includes local and global
     * offsets as well as loop invariant registers) that we want.
     */
   if(needs_paren && (*s=='-' || *s=='+') && *dee)
   {
        /* put a paren at the beginning of dee */
        sub(dee, dee, "(");
        d++;
        *d++=')';
        *d=0;
   }

    if ((c = *s) == '-' || c == '+')
      s++;
    do {
      first = FALSE;

      /*
       * Add operators to the constant expression (dee) gracefully
       */
      if (!*dee) {
        if (c == '-')
          *d++ = c;
        else
          first = TRUE;
        }
      else
        *d++ = c;

      /*
       * Check for constants
       */
      if (is_const(s))
        do {
          *d++ = *s++;
          } while (*s <= '9' && *s >= '0');

      /*
       * Check for loop invariant registers
       */
      else if (isreg(s) && (!(cptr = s_lookup(s)) || cptr->ldead)) {
        *d++ = *s++;
        *d++ = *s++;
        }

      /*
       * Check for locals or globals
       */
      else if ((*s & 0xc0) == 0x80) {
        *d++ = *s++;
        *d++ = *s++;
        }

      /*
       * Check for labels
       */
      else if (*s == 'L' && is_const(s + 1))
        do {
          *d++ = *s++;
          } while (*s <= '9' && *s >= '0');

      /*
       * This isn't a constant expression, so break out of this loop
       */
      else {
        if (!first)
          d--;
        break;
        }

      } while ((c = *s++) == '+' || c == '-' || c == '{' || c == '*'); /* } */

    *d = '\0';

    /*
     * If we haven't located a significant register yet, give it another try
     */
    if ((sptr || *dee) && (c == '+' || c == '-')) {
      cptr = *fptr;
      first = is_type(s, &cptr, &depth, temp);
      if (first & (BASIC | INDUCTION)) {
        if (sptr)
          return(UNASSIGNED);
        else {
          sptr = cptr;
          if (c == '-')
            *cee = -depth;
          else
            *cee = depth;
          }
        }
      else if (!(first & NOTINDUCTION))
        return(UNASSIGNED);
      if (*temp) {
        if (*dee) {
          (void) sprintf(temp2, "(%s)%c(%s)", dee, c, temp);
          (void) strcpy(dee, temp2);
          simp(dee, FALSE);
          }
        else if (c == '-')
          (void) sprintf(dee, "-%s", temp);
        else
          (void) strcpy(dee, temp);
        }
      c = '\0';
      }
    else if (*dee)
      simp(dee, FALSE);

    if (!c || c == ';' || c == ')') {
      if (sptr) {

        /*
         * If the significant register is the target of this RTL, then we have
         * located a complex induction type expression.
         */
        if (sptr == *fptr)
          return(INDUCTION);

        /*
         * Otherwise, this is a normal induction type expression
         */
        *fptr = sptr;
        return(BASIC);
        }

      /*
       * If expression just had some constants, indicate that fact
       */
      else if (*dee)
        return(NOTINDUCTION);
      }

    /*
     * This expression appears to be of no consequence
     */
    return(UNASSIGNED);
}

/* No count down implemented on this target.
 */
      
/* md_is_count_down_loop - 
 */   
int md_is_count_down_loop(struct loopl *loop, int relop, int loops_back)
{
    return TRUE; /* So that LIB doesnt try to convert */
}     
 
        
/* md_can_convert_count_down - 
 */      
int md_can_convert_count_down(struct loopl *loop, struct setlist *sptr, int used_in,
	        int used_out, int loops_back, char *counter_regs)
{       
    return FALSE;
}   
        
    
/* md_convert_count_down - */
void md_convert_count_down(struct loopl *loop, char *lin, struct list *rtlptr, struct setlist *sptr, int loops_back, char *expr, char *ptr1, char *ptr2)
{
    assert(0); /* Should never get called if md_can_convert_count_down() returns FALSE. */
}

/**********ZOLB************/
/* No ZOLB supported on this target */
/*
 * md_unrepeatable - No loop is repeatable on this target
 */
int md_unrepeatable(struct loopl *loop, int loops_back)
{
    return TRUE;
}

/*
 * md_get_cmp_jmp_rtls - 
 */
struct llist *md_get_cmp_jmp_rtls(struct loopl *loop, struct list *rtlptr, struct setlist *sptr)
{
    assert(0); /* This shouldnt get called */
}

/*
 * md_convert_rptblock - 
 */
int md_convert_rptblock(struct loopl *loop, char *lin, struct list *rtlptr, struct setlist *sptr, int loops_back, char *expr, char *ptr1, char *ptr2, int* single_rpt, char *reg)
{
    assert(0); /* This shouldnt get called */
}
/**********ZOLB************/

/*
   md_replace_induction_var - 
   Optimizer invokes this when it wants to replace an induction variable
   that is used in the loop comparison, with another induction variable.
   (Done after strength reduction, when the original induction variable
   is no longer used for anything but the loop control. So we can replace
   that induction variable with the strength reduced induction variable.)

   rtl - points to the buffer used to make the tentative changes to the rtl.
   rtlptr - points to the rtl that has the old induction variable (oreg).
   loop - Some architectures may need to allocate an extra reg - so loop->regs may be needed.

   ptr1  - points to the old induction reg.
   i_reg - The new induction register that is replacing the old one.

   ptr2_start  - points to start of expr in the rtl.
   ptr2_end    - points to end of expr in the rtl.
   expr_reg - This is the register that contains the new expression with which the
   		end of loop condition needs to be checked. VPO would have initialized
		this expr_reg with the right value in the pre-header.
*/
int md_replace_induction_var(struct loopl *loop, char *rtl, struct list *rtlptr, char *i_reg, 
		char *expr_reg, char *ptr1, char *ptr2_start, char *ptr2_end)
{
	char old_expr_reg[REGSTRING];
	copyloc(ptr1,i_reg);
	if (isRegister(ptr2_start) && (ptr2_end==skiploc(ptr2_start)-1)) {
		/* If expr is a register */
		copyloc(old_expr_reg,ptr2_start);
		*skiploc(old_expr_reg)=0;
		rdelete(old_expr_reg,&rtlptr->deads);
	} 

	(void) sub(ptr2_start, ptr2_end, expr_reg);
	update_rtl(rtlptr,rtl);
	rtlptr->type &= ~SIDEFFECT;
	if (rtlptr->se) 
		update_se(rtlptr,NULL);
	combmark(rtlptr);
}

/* md_can_replace_induction_var - see above for explanation of parameters */
int md_can_replace_induction_var(struct loopl *loop, char *rtl, struct list *rtlptr, char *i_reg, 
		char *expr_reg, char *ptr1, char *ptr2_start, char *ptr2_end)
{
	return TRUE;
}

/*
 * sr_init - insert code to initialize pointer used for loop strength reduction
 */
int sr_init(struct loopl *loop, char *reg, char *expr) {

    return(form_expr(loop, reg, expr) != (struct list *) NULL);
}

/*
 * form_expr - emit the RTLs required to form a complex expression
 */
struct list *form_expr(struct loopl *loop, char *reg, char *expr) {
    register char c;
    struct bblock *cblk;
    struct list *rtl1, *rtl2, *rtl3, *ptr,*rtl4=NULL,*rtl5=NULL;
    int done, cee;
    char *a, op, item[MAXSTRING], new[MAXSTRING], nreg[REGSTRING],nreg1[MAXSTRING],new1[MAXSTRING],new2[MAXSTRING];

    cblk = loop->preheader;
    ptr = (cblk->status & JUMP) ? cblk->rtlend : (struct list *) NULL;

    /*
     * Examine the expression that we need to form and extract the first
     * item from it to begin the expression.
     */
    if ((c = *expr++) != '(') {

      /*
       * Extract the first item from the expression (an item is anything
       * that may be placed between two operators).
       */
      a = item;
      do {
        *a++ = c;
        } while ((c = *expr++) && c != ')' && !isoper(c));
      *a++ = '\0';

      /*
       * If the item is negated, then load the item into the destination
       * register and negate it.  At this point, we don't assume that
       * the target machine can negate if things aren't in the same register.
       * We'll let the machine description take care of this later.
       */
      if (*item == '-') {
        (void) sprintf(new, "%s=%s;", reg, item + 1);
        rtl2 = add_rtl(cblk, ptr, new, rinit());
        (void) sprintf(new, "%s=-%s;", reg, reg);
        rtl1 = add_rtl(cblk, ptr, new, rinit());
        (void) add_link(rtl1, rtl2);
        combmark(rtl2);
        }

      /*
       * If no negation takes place, just start by placing the item in the
       * destination register.
       */
      else {
	/* hey, we have to check to see if this is a valid constant, if
		not we have to or in the pieces */
	if(is_const(item))
	{
		int the_int;
		valid_int(the_int=atoi(item));
		if(valid_integer || valid_flipped)
		{
        		(void) sprintf(new, "%s=%s;", reg, item);
        		rtl1 = add_rtl(cblk, ptr, new, rinit());
		}
		else
		{
			int byte=the_int&255;

			/* move the first byte */
        		(void) sprintf(new, "%s=%d;", reg, byte);
        		rtl1 = add_rtl(cblk, ptr, new, rinit());

			/* the (conditionally) or in the next 3 bytes of the constant) */
			byte=the_int&(255<<8);
			if(byte)
			{
        			(void) sprintf(new, "%s=%s|%d;", reg, reg, byte);
        			rtl1 = add_rtl(cblk, ptr, new, rinit());
			}
			
			byte=the_int&(255<<16);
			if(byte)
			{
        			(void) sprintf(new, "%s=%s|%d;", reg, reg, byte);
        			rtl1 = add_rtl(cblk, ptr, new, rinit());
			}
			
			byte=the_int&(255<<24);
			if(byte)
			{
        			(void) sprintf(new, "%s=%s|%d;", reg, reg, byte);
        			rtl1 = add_rtl(cblk, ptr, new, rinit());
			}
			
		}
	}
	else
	{
        	(void) sprintf(new, "%s=%s;", reg, item);
        	rtl1 = add_rtl(cblk, ptr, new, rinit());
	}
        }
      }

    /*
     * Since the expression starts with another expression inside parentheses
     * we call ourselves recursively to form the expression and load it into
     * the destination register.
     */
    else {
      if (!(rtl1 = form_expr(loop, reg, expr)))
        return(rtl1);
      done = 1;
      while (done)
        if ((c = *expr++) == '(')
          done++;
        else if (c == ')')
          done--;
      c = *expr++;
      }

    /*
     * When we reach this point, the first item of the expression is in the
     * destination register and "rtl1" points to the last RTL that modified
     * that register.
     */
    rtl2 = (struct list *) NULL;

    /*
     * We are now in a position to search for a possible operator and
     * another item to operate on the destination register.  It is also
     * possible that we have come to the end of our expression (denoted
     * by reaching either the end of the expression string or a closing
     * parentheses.
     */
    while (c && c != ')') {

      /*
       * If we have not reached the end of the expression, then we better
       * have a valid operator in our hands.  Although the target machine
       * may support many different operators, we just need to support the
       * few operators that appear in initialization expression formed
       * by the strength reduction phase of the optimizer.  These are
       * addition, subtraction, multiplication and arithmetic left shifts.
       * If the operator is not one of these, then we are perfectly justified
       * emitting an error message and halting the optimizer.
       */
      if ((op = c) != '+' && op != '-' && op != '*' && op != '{') { /* } */
            undo(rtl1);
            return((struct list *) NULL);
        }

      /*
       * Extract a second item from the expression.  This is the second item
       * needed by the binary operations that we have to perform.
       */
      if ((c = *expr++) != '(') {
        a = item;
        do {
          *a++ = c;
          } while ((c = *expr++) && c != ')' && !isoper(c));
        *a++ = '\0';

        /*
         * The mips assembler will not allow us to add a global identifier
         * in an expression, so we are forced to allocate a register and
         * place the value in the register.
         */
        if (((*item & 0xe0) == 0x80) || (*item == 'L' && is_const(item + 1))) {
          if (!cancolor(RTREG, loop->regs, nreg, FALSE)) {
            undo(rtl1);
            return((struct list *) NULL);
            }
          (void) sprintf(new, "%s=%s;", nreg, item);
          rtl2 = add_rtl(cblk, ptr, new, rinit());
          (void) strcpy(item, nreg);
          }
        }

      /*
       * If the second item is wrapped in parentheses, then we allocate a new
       * register and call ourselves recursively to place the item in the new
       * register.  Note that it is possible to fail at this point becase we
       * run out of spare registers.  If this is the case, then we call the
       * undo() function, whose job it to tear down the expression that we
       * have built so far so that we fail in a nice, neat and orderly manner.
       * If we succeed, "rtl2" will point to the last RTL that modified the
       * new register.
       */
      else {
        if (!cancolor(RTREG, loop->regs, item, FALSE) ||
            !(rtl2 = form_expr(loop, item, expr))) {
          undo(rtl1);
          return((struct list *) NULL);
          }
        done = 1;
        while (done)
          if ((c = *expr++) == '(')
            done++;
          else if (c == ')')
            done--;
        c = *expr++;
        }

      /*
       * At this time we have two items and an operation, so we emit the
       * RTLs required to perform the operation.  It might be the case that
       * the target architecture does not support all of the required
       * operations.  In this case, code may have to be emitted which calls
       * an appropriate support function.  This is most likely to happen in the
       * case of a multiply, the greates majority of these involve constants,
       * so that an appropriate sequence of shifts, adds and subtracts can
       * be used to perform the operation.  In cases where it is just too
       * difficult to perform the desired operation, it is permissible to
       * gracefully undo what has been done and return quietly indicating
       * to the caller that the expression could not be formed (by returning
       * a "(struct list *) NULL").
       */

      /*
       * Addition.  Note that if we try to add a negative item, we use
       * subtraction, instead.
       */
      *new=0;
      if (op == '+')
      {
	  if(is_const(item))
		rtl3=add_offset_to_item(cblk, ptr, reg, atoi(item));
	  else if (*item=='-')
          	sprintf(new, "%s=%s%s;", reg, reg, item);
	  else
          	sprintf(new, "%s=%s+%s;", reg, reg, item);
      }

      /*
       * Subtraction.  Note that is we try to subtract a negative item, we
       * use addition, instead.
       */
      else if (op == '-')
      {
	if(is_const(item))
		rtl3=add_offset_to_item(cblk, ptr, reg, -atoi(item));
	else if (*item == '-')
          (void) sprintf(new, "%s=%s+%s;", reg, reg, item + 1);
        else
          (void) sprintf(new, "%s=%s-%s;", reg, reg, item);
      }
      /*
       * Multiplication.  If the multiply is by a constant that is a power of 2,
       * we use a shift to obtain the desired results.
       */
      else if (op == '*') {
        if ((done = atoi(item)) && !(done & (done - 1))) {
          for (cee = 0; done > (1 << cee); cee++);
          (void) sprintf(new, "%s=%s{%d;", reg, reg, cee); /* } */
          }
        else {
	  if (done = atoi(item)) {
	    valid_int(done);

	    if ((!valid_integer && !valid_negated && !valid_flipped) || !cancolor(RTREG, loop->regs, nreg1, FALSE)) {
	      undo(rtl1);
	      return((struct list *) NULL);
            }
	    new2[0]=0;
	    if (valid_negated) {
	      (void) sprintf(new1,"%s=%d;",nreg1,-done);
	      (void) sprintf(new2,"%s=-%s;",nreg1,nreg1);
	    } else if (valid_flipped) {
	      (void) sprintf(new1,"%s=%d;",nreg1,~done);
	      (void) sprintf(new2,"%s=~%s;",nreg1,nreg1);
	    } else
	    	(void) sprintf(new1,"%s=%d;",nreg1,done);
	    rtl4 = add_rtl(cblk, ptr, new1, rinit());
	    if (new2[0] != 0)
	      rtl5 = add_rtl(cblk,ptr,new2,rinit());

	    if (rtl5)
	      (void) add_link(rtl5, rtl4);
	    (void) strcpy(item, nreg1);
	  } 
	  (void) sprintf(new, "%s=%s*%s;", reg, reg, item);
	  
        }
      }

      /*
       * Arithmetic left shift
       */
      else
        (void) sprintf(new, "%s=%s{%s;", reg, reg, item); /* } */

      /*
       * At this point, "new" contains the RTL required to perform the desired
       * operation.  We create a new RTL structure and link it into the
       * expression.  We also release the register that held the second item
       * (if any) since we are finished with it and it can be re-used.
       */
      if(*new)
      	rtl3 = add_rtl(cblk, ptr, new, rinit());
      if (rtl2) {
        (void) add_link(rtl3, rtl2);
      }

      if (rtl4) {
	(void) add_link(rtl3, rtl4);
	rtl4=NULL;
      }

      if (rtl2 || rtl4) {
	releasereg(loop->regs, item);
	rinsert(item, &rtl3->deads);
	rtl2 = (struct list *) NULL;
      }
      
      (void) add_link(rtl3, rtl1);
      combmark(rtl1);
      rtl1 = rtl3;
      }

    /*
     * We have finished emitting the RTLs required to form the expression.
     * We return a pointer to the last RTL which modified the destination
     * register.
     */
    return(rtl1);
}

/*
 * sr_ref - update the shadow variable to follow the induction variable
 */
struct list *sr_ref(struct loopl *loop, struct list *rtlptr, char *reg,
 int inc) {
    struct list *rptr;
    char new[MAXSTRING], areg[REGSTRING];


      /*
       * If the increment value is a large constant, generate a load from
       * a separate register.  Otherwise, we try to solve the problem
       * by generating a sequence of adds or subtracts.
       */

      valid_int(inc);

      /* if it's a funky ole number we're incrimenting by, do it funky like. */
      if (!cancolor(regtype(reg), loop->regs, areg, FALSE) || 
		(!valid_integer && !valid_flipped)) 
      {
        do 
        {
          if (inc < 0) 
          {
            (void) sprintf(new, "%s=%s-255;", reg, reg);
            inc += 255;
          }
          else 
          {
            (void) sprintf(new, "%s=%s+255;", reg, reg);
            inc -= 255;
          }
          rptr = add_rtl(rtlptr->daddy, rtlptr, new, rinit());
        } while (inc > 255 || inc < -255);

        if (inc < 0)
          (void) sprintf(new, "%s=%s%d;", reg, reg, inc);
        else
          (void) sprintf(new, "%s=%s+%d;", reg, reg, inc);

        rptr = add_rtl(rtlptr->daddy, rtlptr, new, rinit());
        return(rptr);
    }
    (void) sprintf(new, "%s=%d;", areg, inc);
    (void) add_rtl(rtlptr->daddy, rtlptr, new, rinit());
    (void) sprintf(new, "%s=%s+%s;", reg, reg, areg);
    rptr = add_rtl(rtlptr->daddy, rtlptr, new, rinit());
    rinsert(areg, &rtlptr->prev->deads);
    return(rptr);
}

/*
 * getpartition - scan memory reference and determine its partition identifier
 */
int getpartition(struct loopl *loop, struct list *rtlptr, char *expr,
 char * handle) {
    register char c, *b;
    struct setlist *sptr;
    int depth, count;

    /*
     * Scan expanded item looking for partition "handle"
     */
    depth = 0;
    b = expr;
    while (c = *b++) {

      /*
       * Stay out of weird memory references
       */
      if (c == '[')
        depth++;
      else if (c == ']')
        depth--;

      /*
       * Locals and globals make great partition handles
       */
      else if (depth < 1 && (c & 0xc0) == 0x80 && *b & 0x80) {
        *handle++ = c;
        *handle++ = *b;
        *handle = '\0';
        return(TRUE);
        }

      /*
       * A label can also be used as a partition handle
       */
      else if (depth < 1 && c == 'L' && *b <= '9' && *b >= '0') {
        do {
          *handle++ = c;
          c = *b++;
          } while (c <= '9' && c >= '0');
        *handle = '\0';
        return(TRUE);
        }
      }

    /*
     * When all else fails, a loop invariant register whose value is not
     * known can be used as a partition handle.
     */
    depth = count = 0;
    b = expr;
    while (c = *b++) {
      if (c == '[')
        depth++;
      else if (c == ']')
        depth--;
      else if (depth < 1 && isreg(b - 1)) {
        count++;
        if ((sptr = s_lookup(b - 1)) && sptr->ldead) {
          *handle = *sptr->item;
          *(handle + 1) = *(sptr->item + 1);
          *(handle + 2) = '\0';
          return(TRUE);
          }
        }
      }

    /*
     * Since all other options have been exhausted, if the expression contains
     * only a single register, then use it as the partition handle.
     */
    if (count == 1 && sptr) {
      *handle = *sptr->item;
      *(handle + 1) = *(sptr->item + 1);
      *(handle + 2) = '\0';
      return(TRUE);
      }

    /*
     * Indicates that we did not locate a partition handle
     */
    return(FALSE);
}

/*
 * sr_initialize - insert code to initialize register used for recurrences
 */
int sr_initialize(struct loopl *loop, struct memitem *mnew, char *reg,
 int type, char *mem, int stride, char *areg) {

    register struct list *rtl;
    struct bblock *cblk;
    char new[MAXSTRING], snew[MAXSTRING];

    /*
     * We start by allocating a register to hold the address from which we
     * have to start reading one or more items.  Then we go ahead and insert
     * the code at the preheader of the loop that is required to load the
     * desired address into the register allocated.  If we fail at either
     * of these two tasks, we return an indication of the failure.
     */
    if (!cancolor(RTREG, loop->regs, areg, FALSE))
      return(FALSE);
    if (!(rtl = form_expr(loop, areg, mem)))
      return(FALSE);

    cblk = loop->preheader;

    /*
     * Take care of the simplest case in which we need to load only a single
     * register from the address requested.
     */
    if (!mnew) {
      if(memrf(type)=='B')
      	(void) sprintf(new, "%s=%c[%s]&255;", reg, memrf(type), areg);
      else if(memrf(type)=='W')
      	(void) sprintf(new, "%s=%c[%s]&65535;", reg, memrf(type), areg);
      else
      	(void) sprintf(new, "%s=%c[%s];", reg, memrf(type), areg);
      if (cblk->status & JUMP)
        (void) add_link(add_rtl(cblk, cblk->rtlend, new, rinit()), rtl);
      else
        (void) add_link(add_rtl(cblk, (struct list *) NULL, new, rinit()), rtl);
      return(TRUE);
      }

    /*
     * Otherwise, we are going to load a sequence of addresses, so we first
     * form the RTL required to skip between successive items.  We are going
     * to build the sequence of loads required from the bottom-up.
     */
    if (stride > 0)
      (void) sprintf(snew, "%s=%s+%d;", areg, areg, stride);
    else
      (void) sprintf(snew, "%s=%s%d;", areg, areg, stride);
    if (cblk->status & JUMP)
      rtl = add_rtl(cblk, cblk->rtlend, snew, rinit());
    else
      rtl = add_rtl(cblk, (struct list *) NULL, snew, rinit());

/*
	this is what we want to do, but it's not that simple 
    (void) sprintf(new, "%s=%c[%s];", reg, memrf(type), areg);
*/
      if(memrf(type)=='B')
      	(void) sprintf(new, "%s=%c[%s]&255;", reg, memrf(type), areg);
      else if(memrf(type)=='W')
      	(void) sprintf(new, "%s=%c[%s]&65535;", reg, memrf(type), areg);
      else
      	(void) sprintf(new, "%s=%c[%s];", reg, memrf(type), areg);


    rtl = add_rtl(cblk, rtl, new, rinit());
    (void) add_link(rtl->next, rtl);
    while (mnew) {
      rtl = add_rtl(cblk, rtl, snew, rinit());
      (void) add_link(rtl->next, rtl);
/*
	again, this is too simple
      (void) sprintf(new, "%s=%c[%s];", mnew->ref, memrf(type), areg);
*/
      if(memrf(type)=='B')
      	(void) sprintf(new, "%s=%c[%s]&255;", mnew->ref, memrf(type), areg);
      else if(memrf(type)=='W')
      	(void) sprintf(new, "%s=%c[%s]&65535;", mnew->ref, memrf(type), areg);
      else
      	(void) sprintf(new, "%s=%c[%s];", mnew->ref, memrf(type), areg);

      rtl = add_rtl(cblk, rtl, new, rinit());
      (void) add_link(rtl->next, rtl);
      mnew = mnew->next;
      }
    (void) add_link(rtl, rtl->prev);
    return(TRUE);
}

/*
 * sr_writereg - alter reference so that write value also goes in register
 */
struct list *sr_writereg(struct list *rtl, char *reg, char *mem) {
    register struct list *rtl1;
    char *a, *b, *pat, temp[MAXSTRING], new[MAXSTRING], se[MAXSTRING];

    (void) strcpy(temp, rtl->val);
    if (fmatch(temp, mem) && *epos == '=') {
      a = new;
      for (b = reg; *b; *a++ = *b++);
      *a++ = '=';
      pat = a;
      b = ++epos;
      while ((*a++ = *b++) != ';');
      *(a - 1) = '\0';
      (void) sub(epos, b - 1, reg);

      b = temp;
      while (fmatch(b, pat)) {
        if (*epos != '=')
          epos = sub(bpos, epos, reg);
        b = epos;
        }
      *(a - 1) = ';';
      *a = '\0';

      side_effect = se;
      *se = '\0';
      if (find(rtl, temp, rtl->deads)) {
        (void) fprintf(stderr, "vpo (sr_writereg): cannot alter reference\n");
        return((struct list *) NULL);
        }
      set(rtl, temp, se);
      side_effect = (char *) NULL;

      rtl1 = add_rtl(rtl->daddy, rtl, new, rinit());
      if (isreg(pat) && rexists(pat, rtl->deads)) {
        rdelete(pat, &rtl->deads);
        rinsert(pat, &rtl1->deads);
        }
      (void) add_link(rtl, rtl1);
      return(rtl1);
      }

    (void) fprintf(stderr, "vpo (sr_writereg): cannot locate '");
    show_rtl(stderr, mem);
    (void) fprintf(stderr, "' in '");
    show_rtl(stderr, temp);
    (void) fprintf(stderr, "'\n");
    return((struct list *) NULL);
}

/*
 * offset - form an expression that references a register plus an offset
 */
int offset(char *reg, int ofs, char *expr, char* memref) {

#ifdef SOFTFLOAT
	/* double memory references can't be 
	 * optimized regardless of the offset 
	 */
	if(memref && memref[0]=='D' && ofs !=0)
		return FALSE;
#endif
#ifdef HARDFLOAT
	if(memref && (memref[0]=='D' || memref[0]=='F') && ((ofs&0x3)!=0))
		return FALSE;
#endif
	/* byte loads/stores can only go 255 on the arm */
    if (ofs > 255 || ofs < -255)
      return(FALSE);


    if (!ofs) {
      (void) strcpy(expr, reg);
      return(TRUE);
      }
    if (ofs >= 1) {
      (void) sprintf(expr, "%s+%d", reg, ofs);
      return(TRUE);
      }
    (void) sprintf(expr, "%s%d", reg, ofs);
    return(TRUE);
}


/*
 * doreduce - return TRUE if triple should be strength reduced
 */
int doreduce(struct itriple *tptr) 
{
    register char *a;
   struct setlist *sptr;
   char pat[MAXSTRING];


    /*
     * If the multiplicative constant is not a power of 2, then we definitely wish to
     * attempt strength reduction on this triple.  If it is a power of 2, then we first
     * need to look more closely at the "dee" value to determine if we want
     * to attempt to perform strength reduction.
     */
    if ((tptr->cee & (tptr->cee-1))==0) 
    {
	/* Cee is a power of two. */
	if(tptr->cee>1)
	{
		/* examine the refs for non-zero items.  only words can have a larger Cee */
		struct llist* refs;
		for(refs=tptr->ref;refs;refs=refs->next)
		{
			if(cnts(refs->ptr))
			{
				if(fmatch(refs->ptr->val,"B["))
					return TRUE;
				if(fmatch(refs->ptr->val,"W["))
					return TRUE;
				if(fmatch(refs->ptr->val,"F["))
					return TRUE;
				if(fmatch(refs->ptr->val,"D["))
					return TRUE;
			}
		}		
	}
      	if (!*tptr->dee)
        	return FALSE;
      	if ((a = is_const(tptr->dee)) && !*a)
	{
		if(atoi(a)<255)	
        		return FALSE;
		else
			return TRUE;
	}
      	if(isareg(tptr->dee))
		return FALSE;
      /*
         In cases where we have a memory reference that is a sum of two
         registers where one is a basic induction variable and the other is a
         constant, then there is no advantage in further reducing such a
         reference on the SPARC.  Also, since the global variable
         "index_reduce" is set TRUE for this machine, we wish to avoid undoing
         what is done by a previous strength reduction phase.
      */
      if ((tptr->status & INDMEM) && isareg(tptr->dee) &&
          (sptr = s_lookup(tptr->dee)) && sptr->ldead) {
         (void) sprintf(pat, "%s+%s", tptr->family->item, tptr->dee);
         if (!strcmp(tptr->pat, pat))
            return (FALSE);
         (void) sprintf(pat, "%s+%s", tptr->dee, tptr->family->item);
         if (!strcmp(tptr->pat, pat))
            return (FALSE);
	}

    }
    return TRUE;
}

/*
 * divconst; strength reduction of division by constant.
 */
struct list *
divconst(int *change, struct list *ptr, vector regs)
{
   return ptr;  /* STUBBED OUT */
}

/*
 * multconst - change constant multiplies to shifts, adds and subtracts
 */
struct list *multconst(int *change, struct list *ptr, vector regs) {
    struct list *nptr;
    int i;
    char dst[REGSTRING], src[REGSTRING];

    if (ptr->val && isreg(ptr->val) && regtype(ptr->val) == RTREG &&
        isreg(ptr->val + 3) && *(ptr->val + 5) == '*' &&
        is_const(ptr->val + 6)) {
      *dst = *ptr->val;
      *(dst + 1) = *(ptr->val + 1);
      *(dst + 2) = '\0';
      *src = *(ptr->val + 3);
      *(src + 1) = *(ptr->val + 4);
      *(src + 2) = '\0';
      if (nptr = addmult(ptr, dst, src, atoi(ptr->val + 6), regs)) {
#ifdef INTERACT
    begin_trans(VET_OPT_TRANS);
#endif
        for (i = 0; i < MAXLINKS && ptr->lnks[i]; i++)
          (void) add_link(nptr, ptr->lnks[i]);
        for (i = 0; i < MAXLINKS && ptr->blnks[i]; i++)
          (void) add_link(ptr->blnks[i], ptr->prev);
        remv_links_to(ptr);
        remv_links(ptr);
        nullify_rtl(ptr);
        *change = TRUE;
#ifdef INTERACT
    end_trans();
#endif
        return(nptr);
      }
      }
    return(ptr);
}

/*
 * addmult - insert code to perform a constant multiply
 */
struct list *addmult(struct list *ptr, char *dst, char *src, int n,
 vector regs) {
    register int i, shiftadd, first, link, dead, same, ip;
    struct bblock *cblk;
    struct list *added[32];
    char new[MAXSTRING];

    /*
     * The purpose of this routine is to change a multiply by a constant into
     * a series of shifts, adds and subtracts that perform the same function.
     * A pointer to the RTL at which the new sequence of RTLs needed to perform
     * the add is to be inserted must be given by "ptr".  The value of the item
     * which is to be multiplied must be in "src".  The destination register
     * which will contain the result of the multiplication is in "dst".  The
     * value in "src" is not guaranteed to be unchanged on output from the
     * sequence.  The argument "n" contains the integer value (positive or
     * negative) to multiply by.  The function return a pointer to the first
     * RTL in the new multiply sequence (if one was created) or NULL if there
     * weren't enough registers available to perform the sequence.  The vector
     * "regs" should contain a register allocation vector indicating which
     * registers are free and which are in use at the current location pointed
     * to by "ptr".  This function may have to allocate a new register, but it
     * will always release them once it has finished with them.
     *
     * This function inserts RTLs in reverse order--that is, the first RTL
     * entered goes at the bottom of the sequence of RTLs emitted.
     */

    /*
     * Obtain a pointer to the basic block in which "ptr" resides.
     */
    cblk = ptr->daddy;

    /*
     * If the item to multiply by is a zero, the the result is zero.
     */
    if (!n) {
#ifdef INTERACT
    begin_trans(VET_OPT_TRANS);
#endif
      (void) sprintf(new, "%s=0;", dst);
      ptr = add_rtl(cblk, ptr, new, rinit());
#ifdef INTERACT
      end_trans();
#endif
      return(ptr);
      }

    ip = 0;

    /*
     * If the multiplication was by a negative number, then negate the
     * result to obtain the correct value.
     */
    if (n < 0) {
      n = -n;
#ifdef INTERACT
    begin_trans(VET_OPT_TRANS);
#endif
      (void) sprintf(new, "%s=-%s;", dst, dst);
      added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
      link = TRUE;
#ifdef INTERACT
    end_trans();
#endif
      }
    else
      link = FALSE;

    /*
     * If the number to multiply by ends in a sequence of zeroes, that is an
     * indication to shift at the end.
     */
    for (i = 0; !(n & 1); i++)
      n >>= 1;
    if (i) {
#ifdef INTERACT
    begin_trans(VET_OPT_TRANS);
#endif
      (void) sprintf(new, "%s=%s{%d;", dst, dst, i); 
      added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
      if (link)
        (void) add_link(ptr->next, ptr);
      link = TRUE;
#ifdef INTERACT
    end_trans();
#endif
      }

    /*
     * This loop calculates the appropriate sequence of shifts, adds and
     * subtracts needed to perform the multiply.
     */
    shiftadd = 0;
    first = dead = TRUE;
    same = FALSE;
    for (;;) {
      for (i = 0; n & 1; i++)
        n >>= 1;
      if (i > 1) {
        if (shiftadd == 1) {
          if (dead && *src == *dst && *(src + 1) == *(dst + 1)) {
            if (!cancolor(regtype(dst), regs, src, FALSE)) {
#ifdef INTERACT
	      begin_trans(VET_OPT_TRANS);
#endif
             while (ip--) {
                remv_links_to(added[ip]);
                remv_links(added[ip]);
                nullify_rtl(added[ip]);
                }
#ifdef INTERACT
	     end_trans();
#endif
              return((struct list *) NULL);
              }
            same = TRUE;
            }
#ifdef INTERACT
	  begin_trans(VET_OPT_TRANS);
#endif
          (void) sprintf(new, "%s=%s-%s;", dst, dst, src);
          added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
          if (dead) {
            if (same)
              rinsert(src, &ptr->deads);
            dead = FALSE;
            }
          if (link)
            (void) add_link(ptr->next, ptr);
          i++;
#ifdef INTERACT
	  end_trans();
#endif
	}
        else {
          if (!first) {
            if (dead && *src == *dst && *(src + 1) == *(dst + 1)) {
              if (!cancolor(regtype(dst), regs, src, FALSE)) {
#ifdef INTERACT
		begin_trans(VET_OPT_TRANS);
#endif
                while (ip--) {
                  remv_links_to(added[ip]);
                  remv_links(added[ip]);
                  nullify_rtl(added[ip]);
                  }
#ifdef INTERACT
		end_trans();
#endif
                return((struct list *) NULL);
                }
              same = TRUE;
              }
#ifdef INTERACT
	    begin_trans(VET_OPT_TRANS);
#endif
            (void) sprintf(new, "%s=%s+%s;", dst, dst, src);
            added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
            if (dead) {
              if (same)
                rinsert(src, &ptr->deads);
              dead = FALSE;
              }
            if (link)
              (void) add_link(ptr->next, ptr);
            if (shiftadd) {
              (void) sprintf(new, "%s=%s{%d;", dst, dst, shiftadd); 
              added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
              (void) add_link(ptr->next, ptr);
              link = TRUE;
	    }
#ifdef INTERACT
	    end_trans();
#endif
	  }
          if (dead && *src == *dst && *(src + 1) == *(dst + 1)) {
            if (!cancolor(regtype(dst), regs, src, FALSE)) {
#ifdef INTERACT
	      begin_trans(VET_OPT_TRANS);
#endif
              while (ip--) {
                remv_links_to(added[ip]);
                remv_links(added[ip]);
                nullify_rtl(added[ip]);
                }
#ifdef INTERACT
	      end_trans();
#endif
              return((struct list *) NULL);
              }
            same = TRUE;
            }
#ifdef INTERACT
	  begin_trans(VET_OPT_TRANS);
#endif
          (void) sprintf(new, "%s=%s-%s;", dst, dst, src);
          added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
          if (dead) {
            if (same)
              rinsert(src, &ptr->deads);
            dead = FALSE;
	  }
#ifdef INTERACT
	  end_trans();
#endif
	}
        if (i) {
#ifdef INTERACT
	  begin_trans(VET_OPT_TRANS);
#endif
          (void) sprintf(new, "%s=%s{%d;", dst, dst, i); 
          added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
          (void) add_link(ptr->next, ptr);
          link = TRUE;
#ifdef INTERACT
	  end_trans();
#endif
          }
        shiftadd = 0;
        }
      else {
        if (!first) {
          if (dead && *src == *dst && *(src + 1) == *(dst + 1)) {
            if (!cancolor(regtype(dst), regs, src, FALSE)) {
#ifdef INTERACT
	      begin_trans(VET_OPT_TRANS);
#endif
              while (ip--) {
                remv_links_to(added[ip]);
                remv_links(added[ip]);
                nullify_rtl(added[ip]);
                }
#ifdef INTERACT
	      end_trans();
#endif
              return((struct list *) NULL);
              }
            same = TRUE;
            }
#ifdef INTERACT
	  begin_trans(VET_OPT_TRANS);
#endif
          (void) sprintf(new, "%s=%s+%s;", dst, dst, src);
          added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
          if (dead) {
            if (same)
              rinsert(src, &ptr->deads);
            dead = FALSE;
            }
          if (link)
            (void) add_link(ptr->next, ptr);
          if (shiftadd) {
            (void) sprintf(new, "%s=%s{%d;", dst, dst, shiftadd); 
            added[ip++] = ptr = add_rtl(cblk, ptr, new, rinit());
            (void) add_link(ptr->next, ptr);
            link = TRUE;
	  }
#ifdef INTERACT
	  end_trans();
#endif
	}
        shiftadd = 1;
        }
      if (!n)
        break;
      while (!(n & 1)) {
        shiftadd++;
        n >>= 1;
        }
      first = FALSE;
      }

    /*
     * Place the initial value in the work register to start the multiply
     */
#ifdef INTERACT
    begin_trans(VET_OPT_TRANS);
#endif
    if (!dead) {
      if (same) {
        releasereg(regs, src);
        (void) sprintf(new, "%s=%s;", src, dst);
        }
      else
        (void) sprintf(new, "%s=%s;", dst, src);
      ptr = add_rtl(cblk, ptr, new, rinit());
      if (link)
        (void) add_link(ptr->next, ptr);
      }
    else if (*src != *dst || *(src + 1) != *(dst + 1)) {
      (void) sprintf(new, "%s=%s;", dst, src);
      ptr = add_rtl(cblk, ptr, new, rinit());
      }
#ifdef INTERACT
    end_trans();
#endif

    return(ptr);
}

/*
 * exit_cond - locate the "control variable" of a loop and its exit value
 */
int exit_cond(struct loopl *loop, struct bblock *cblk, int loops_back,
 char *control, char *value, int *relop) {
    register char *rtlin, *a;
    struct list *rtlptr;

    /*
     * Start at the end of the basic block and search back for the conditional
     * branch RTL.
     */
    for (rtlptr = cblk->rtlend; rtlptr; rtlptr = rtlptr->prev) {
      if (rtlin = cnts(rtlptr)) {
        if ((rtlin = is_pc(rtlin)) && *rtlin++ == '=') {

          /*
           * Since this is a machine does not use integer condition code
           * registers, the control register and comparison value register
           * are in this control transfer RTL.  We attempt to locate these
           * items and return them.
           */
          if (cmploc(rtlin,cc_reg)!=0)
            return(FALSE);
	  copyloc(control,cc_reg);
	  *skiploc(control)=0;
	  rtlin=skiploc(rtlin);

          /*
           * Look at the conditional branch RTL and determine the relational
           * operator used.  The "loops_back" variable is TRUE only if taking
           * the conditional means that the control flow remains inside the
           * current loop.
           */
          switch (*rtlin++) {

            case ':':
              *relop = (loops_back) ? REL_EQ : REL_NE;
              break;

            case '!':
              *relop = (loops_back) ? REL_NE : REL_EQ;
              break;

            case '>':
              *relop = (loops_back) ? REL_GT : REL_LE;
              break;

            case '\'' :
              *relop = (loops_back) ? REL_LE : REL_GT;
              break;

            case '<':
              *relop = (loops_back) ? REL_LT : REL_GE;
              break;

            case '`':
              *relop = (loops_back) ? REL_GE : REL_LT;
              break;

            case 'g':
              *relop = (loops_back) ? REL_GE : REL_LT; /* unsigned */
              break;

            case 'l':
              *relop = (loops_back) ? REL_LT : REL_GE; /* unsigned */
              break;

            case 'h' :
              *relop = (loops_back) ? REL_GT : REL_LE; /* unsigned */
              break;

            case 's' :
              *relop = (loops_back) ? REL_LE : REL_GT; /* unsigned */
              break;

            default:
              return(FALSE);
            }

	   /*
              Since this is a machine with codition codes, back up to
              locate the RTL that set the condition code register.  Once we
              locate this RTL, locate the control variable for this loop
              and the value that the control variable is compared to.  If
              we can locate all of these items, then return them.
           */
	  rtlptr = rtlptr->lnks[0];

	  if(rtlptr==0)
		return (FALSE);
	  if (!(rtlin = cnts(rtlptr)))
	    return (FALSE);
          if(cmploc(cc_reg,rtlin)==0 && *(rtlin=skiploc(rtlin))=='=')
	  {
	    /* skip the equal sign */
	    rtlin++;
	    if (!isreg(rtlin))
	      return (FALSE);
          *control = *rtlin++;
          *(control + 1) = *rtlin++;
          *(control + 2) = '\0';
          /* Make sure we dont go past end of the string  -- Raja */
          while (*rtlin != 0 && *rtlin != '?' && *rtlin != 'u')
	    rtlin++;
          /* Code added by Raja */
          /* start Raja */
          /* if we go past the end of rtl, we haven't seen the
             '?' (comparison) or 'u' (useline?).we have
             something like IC=r[x] op r[y] trailer; i.e., we
             dont have a direct compare of the control
             variable and hence no direct knowledge of the
             exit value. So return FALSE */

          if (*rtlin == 0) {
            return (FALSE);
            /* end Raja */
          }
          rtlin++;
          a = value;

          while ((*a++ = *rtlin++) != ';');
          *(a - 1) = '\0';
          return (TRUE);
	  }
	}
      }
    }

    /*
     * Indicate that we could not locate all of the elements required to
     * determine the number of iterations that this loop will perform.
     */
    return(FALSE);
}

/*
 * comparison - determine if the RTL is a comparison and return the elements
 */
int comparison(char *rtl, struct list *rtlptr, char *reg, char *expr, char **ptr1, char **ptr2) 
{

   if (*rtl++ == cc_reg[0] && *rtl++ == cc_reg[1] && *rtl++ == '=' &&
       *rtl++ == reg[0] && *rtl++ == reg[1] && *rtl++ == '?') {
      *ptr1 = rtl - 3;
      *ptr2 = rtl;
      while ((*expr++ = *rtl++) != ';');
      *(expr - 1) = '\0';
      return (TRUE);
	}


    /*
     * If no comparison was found, return FALSE
     */
    return(FALSE);
}

/*
 * get_memtype - return the type of memory reference
 */
int get_memtype(char *ref) 
{
    register char c;
    int depth, fp, sl, local, global, con, uitem;
    char frame_pointer[REGSTRING];
 
    /* make the frame pointer */
    bzero(frame_pointer,REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);   


    /*
     * The purpose of this function is to examine a memory reference and
     * determine as much as possible what major region of memory the item
     * references.  Possible regions include:
     *
     *   SPILLMEM     This item accesses a spill location generated by the
     *                local register allocator to store temporaries when
     *                there are insufficient registers.  This area of memory
     *                is never referenced through pointer variables and it
     *                is never modified by an external function call.
     *
     *   STACKMEM     This item accesses the argument-passing stack.  These
     *                locations are never referenced through a pointer
     *                variable, but they can be modified by an external
     *                function call.
     *
     *   LOCALMEM     This item accesses a local variable or an argument
     *                variable passed to this function.  These items can
     *                be referenced through pointer variables by this
     *                function and by external function calls provided that
     *                an indirect address reference has been computed for
     *                them.
     *
     *   GLOBALMEM    This item references a global memory location.  It
     *                may be referenced directly or through any pointer
     *                variable either in this function or by an external
     *                function call.
     */

    depth = 0;
    fp = sl = local = con = uitem = global = FALSE;
    while ((c = *ref++)) {

      /*
       * Only items in the upper address level of the memory reference are
       * significant.
       */
      if (c == '[')
        depth++;
      else if (c == ']') {
        if (!--depth)
          return((fp && local) ? LOCALMEM :
                 (fp && sl) ? SPILLMEM :
                 (fp) ? LOCALMEM :
                 (fp && con) ? STACKMEM :
                 (!uitem || global) ? GLOBALMEM : (LOCALMEM | GLOBALMEM));
        }
      if (depth == 1) {

        /*
         * If the item is a register, then a reference of the frame pointer
         * indicates that we are looking at a reference to either a local
         * memory location or a spill location.  A reference to the stack
         * pointer register on this machine indicates a stack memory reference.
         * A reference to any other register indicates an indirect pointer
         * reference to a local or a global item.
         */
        if ((c & 0xc0) == 0xc0) {
          if (c == frame_pointer[0] && *ref == frame_pointer[1])
            fp = TRUE;
          else
            uitem = TRUE;
          ref++;
          }

        /*
         * A local identifier indicates a reference to some local variable
         */
        else if ((c & 0xa0) == 0xa0) {
          local = TRUE;
          ref++;
          }

        /*
         * A global identifier indicates a reference to some global item
         */
        else if ((c & 0xa0) == 0x80) {
          global = TRUE;
          ref++;
          }

        /*
         * A label indicates a reference to some global or local static item
         */
        else if (c == 'L' && *ref >= '0' && *ref <= '9') {
          global = TRUE;
          do {
            c = *++ref;
            } while (c >= '0' && c <= '9');
          }

        /*
         * An SL[ macro indicates the use of a spill memory location
         */
        else if (c == 'S' && *ref == 'L' && *(ref + 1) == '[') {
          sl = TRUE;
          ref++;
          }

        /*
         * A constant along with a frame pointer reference without a local
         * identifier indicates a reference to an argument.
         */
        else if (c >= '0' && c <= '9')
          con = TRUE;

        /*
         * A reference to some memory item is treated as a reference to a
         * register that is not the frame or stack pointer.
         */
        else if (mems[(int) c] != NOTYPE && *ref == '[')
          uitem = TRUE;
        }
      }

    return(LOCALMEM | GLOBALMEM);
}


int possibly_same_mem_location(char *m1, char*m2, int con1, int con2)
{
  int maxsz=4;

  if (!m1 || !m2)
    return FALSE;

  if (*m1 == 'D' || *m2 == 'D')
    maxsz=8;
  else if ((*m1 == 'R' || *m2 == 'R') || (*m1 == 'F' || *m2 == 'F'))
    maxsz=4;
  else if (*m1 == 'W' || *m2 == 'W')
    maxsz=2;
  else if (*m1 == 'B' || *m2 == 'B')
    maxsz=1;

  if ( abs(con1-con2) < maxsz)
    return TRUE;

  return FALSE;
}

int remove_useless_cond_branches(int invocation)
{
        int my_arg_build_size=0;
        struct bblock* cblk, *block2, *block3;
	struct list* rtlptr;
	char* val;
	char cond;
	char left[MAXSTRING];
	char right[MAXSTRING];
	int left_val, right_val;
	int tests_true;
	char* label;
	int change=FALSE;
	if(debug_opt("no_remove_useless_cond_branches"))
		return FALSE;
#ifdef VET
begin_phase(USELESSCONDS_PHASE);
#endif

        for (cblk = top; cblk; cblk = cblk->down)
        {
		if(cblk->left==cblk->right && cblk->left==cblk->down
			&& cblk->down!=0)
		{
			/* hey, we have a conditional branch that's
				useless, get rid of it */

			if(cblk->rtlend->val && is_pc(cblk->rtlend->val))
			{
				remv_links_to(cblk->rtlend);
				remv_links(cblk->rtlend);
				nullify_rtl(cblk->rtlend);
				change=TRUE;
			}
			remv_predecessor(cblk, cblk->left);
			remv_predecessor(cblk, cblk->right);
			add_predecessor(cblk, cblk->left);
			cblk->right=0;


		}
	}
        for (cblk = top; cblk; cblk = cblk->down)
        {
		if((block2=cblk->left) && (block3=cblk->right))
		{
			rtlptr=cblk->rtlend;	
			/* the last rtl should be the jump */
			if(!rtlptr || (val=cnts(rtlptr))==0)
				continue;

			if(!is_pc(val))
				continue;
			/* pc=reg<rel>0,<label> */
			cond=val[5];
			label=&val[8];


			/* backup the the set of the CC */
			/* we should be linked */
			rtlptr=rtlptr->lnks[0];

			/* the next to last should be the CC= line */
			if(!rtlptr || (val=cnts(rtlptr))==0)
				continue;
			if(cmploc(val,cc_reg)!=0)
				continue;

			/* cc=reg?<const or reg>,<label */

			/* hunt for the comparison operator */
			if(!fmatch(&val[3],"?") && !fmatch(&val[3],":") && !fmatch(&val[3],"!"))
				continue;
			gtstr(&val[3],bpos,left);
			strcpy(right,epos);

			if(fmatch(right, ";"))
				*bpos=0;
			else
				continue;

			expand(NULL, rtlptr, right);
			simp(right, FALSE);
			expand(NULL, rtlptr, left);
			simp(left, FALSE);

			change |= try_compare_with_const_opt(left,rtlptr);

			tests_true=get_test_outcome(left, right, cond);
			if(tests_true==COMPARISON_MAYBE_TRUE)
				continue;


			/* here we assume we know the outcome of the branch */
			tests_true=(tests_true==COMPARISON_TRUE);


#ifdef VET
	begin_trans(VET_OPT_TRANS);
#endif

			change=TRUE;

			if(tests_true)
			{
				/* then, this branch is always taken */
				sprintf(cblk->rtlend->val, "PC=%s", label);
                                change=TRUE;

				remv_predecessor(cblk, cblk->left);
				if(cblk->left==cblk->down)
					cblk->down->status &= ~FALLTHRU;
				cblk->status|=JUMP;
				cblk->left=cblk->right;
				cblk->right=0;
				bzero(cblk->rtlend->lnks,sizeof(cblk->rtlend->lnks));
			}
			else
			{
				/* then, this branch is never taken */
				/* remove the branch */
				remv_links_to(cblk->rtlend);
				remv_links(cblk->rtlend);
				nullify_rtl(cblk->rtlend);
                                change=TRUE;

				remv_predecessor(cblk, cblk->right);
				if(cblk->right==cblk->down)
					cblk->down->status &= ~FALLTHRU;
				cblk->right=0;
			}
#ifdef VET
	end_trans();
#endif
		}


	}




#ifdef VET
end_phase(USELESSCONDS_PHASE);
#endif
	return change;
}

void cd_motion_fix_rtl(struct list* rtl, char* pat, char* expr)
{
	/* if this instruction got "fixed" by replace, but it's not avlid
		we need to fix it so that it is valid, this may mean more
		than one rtl. 
	*/	

	char effect1[MAXSTRING], effect2[MAXSTRING];
	struct list* new_rtl;


	/* a multi effect load/store */
	if(fmatch(rtl->val, ";") && fmatch(epos, ";"))
	{

		fmatch(rtl->val, ";");
		gtstr(rtl->val, epos, effect1);
		strcpy(effect2, epos);


		if(gtmem(effect1))
		{
			new_rtl=add_rtl(rtl->daddy, rtl->next, effect2, rtl->deads);
			strcpy(rtl->val, effect1);
		}
		else
		{
			new_rtl=add_rtl(rtl->daddy, rtl->next, effect1, rtl->deads);
			strcpy(rtl->val, effect2);
		}
			
		/* nothing can be dead in rtl1, all the sources are reused in rtl2 */
		rtl->deads=rinit();
	}
}

static struct list* add_offset_to_item(struct bblock* cblk, struct list* ptr, char* item, int offset)
{

	int use_subtract=FALSE;
	int byte=0;
	char new[MAXSTRING];
	if(offset<0)
	{
		use_subtract=TRUE;
		offset=-offset;
	}

	/* we need to return an rtl, one way or another, so we do */
	if(offset==0)
	{
		sprintf(new, "%s=%s;", item, item);
		ptr=add_rtl(cblk, ptr, new, rinit());
		return ptr;
	}

	while(offset!=0)
	{
		valid_int(offset);
		if(valid_integer || valid_negated)
		{
			if(use_subtract)
				sprintf(new, "%s=%s-%d;", item, item, offset);
			else
				sprintf(new, "%s=%s+%d;", item, item, offset);
			ptr=add_rtl(cblk, ptr, new, rinit());
			return ptr;
		}
		else
		{
			/* take 8 bits out of the offset and add them in */
			int new_offset=(offset&(255<<(byte*8)));

			/* then take those 8 bits out of the offset */
			offset=offset&~(255<<(byte*8));
			byte++;
			if(new_offset!=0)
			{
				if(use_subtract)
					sprintf(new, "%s=%s-%d;", item, item, new_offset);
				else
					sprintf(new, "%s=%s+%d;", item, item, new_offset);
				ptr=add_rtl(cblk, ptr, new, rinit());
			}
		}
	}
}

struct list * 
find_unification_point(struct bblock* cblk, char used_regs[], char set_regs[])
{
        char *set_regs_ptr=set_regs, *used_regs_ptr=used_regs;
        struct list* rtlptr;
	char *b;
        char pattern[REGSTRING+1];

        makereg(pattern,CTREG,0);
        *skiploc(pattern)='=';
        *(skiploc(pattern)+1)=0;

        for(rtlptr=cblk->rtlend; rtlptr; rtlptr=rtlptr->prev)
        {
                if(cnts(rtlptr))
                {
                        char *a=rtlptr->val;
                        while(a=gtrg(a))
                        {
                                if(*a=='=')
                                {
					for(b=aliases(unskiploc(a)); *b; b=skiploc(b)+1)
					{
                                        	copyloc(set_regs_ptr,b);
                                        	set_regs_ptr=skiploc(set_regs_ptr);
                                        	*set_regs_ptr=0;
					}
                                }
                                else
                                {
					for(b=aliases(unskiploc(a)); *b; b=skiploc(b)+1)
					{
                                        	copyloc(used_regs_ptr,b);
                                        	used_regs_ptr=skiploc(used_regs_ptr);
                                        	*used_regs_ptr=0;
					}
                                }
                        }
                        a=rtlptr->se;
                        while(a && (a=gtrg(a)))
                        {
                                if(*a=='=')
                                {
					for(b=aliases(unskiploc(a)); *b; b=skiploc(b)+1)
					{
                                        	copyloc(set_regs_ptr,b);
                                        	set_regs_ptr=skiploc(set_regs_ptr);
                                        	*set_regs_ptr=0;
					}
                                }
                                else
                                {
					for(b=aliases(unskiploc(a)); *b; b=skiploc(b)+1)
					{
                                        	copyloc(used_regs_ptr,b);
                                        	used_regs_ptr=skiploc(used_regs_ptr);
                                        	*used_regs_ptr=0;
					}
                                }
                        }
                        if(used_regs_ptr-used_regs > MAXSTRING-((REGSTRING)*4))
                                return NULL;
                        if(set_regs_ptr-set_regs > MAXSTRING-((REGSTRING)*4))
                                return NULL;

                }
                if(cnts(rtlptr) && fmatch(rtlptr->val,pattern))
                {
                        return rtlptr;
                }
        }
	return NULL;
}



/*
 * reverse - negate the branch condition and change target label of RTL
 */
void reverse_and_preserve_equality(struct list *rtl, char *label) 
{
   char new[MAXSTRING];
   char* a=new,*b;
   
   strcpy(new,rtl->val);

   assert(*a=='P'); a++;
   assert(*a=='C'); a++;
   assert(*a=='='); a++;
   assert(isreg(a) && regtype(a)==CTREG && regnum(a)==0);
   a=skiploc(a);

   switch (*a) 
   {

      case ':':
         *a = ':';
         break;

      case '!':
         *a = '!';
         break;

      case '>':
         *a = '<';
         break;

      case '<':
         *a = '>';
         break;

      case '`':
         *a = '\'';
         break;

      case '\'':
         *a = '`';
         break;

      case 'h':
         *a = 'l';
         break;

      case 'l':
         *a = 'h';
         break;

      case 'g':
         *a = 's';
         break;

      case 's':
         *a = 'g';
         break;

      default:
         (void) fprintf(stderr, "vpo (reverse): bad conditional, '%s'\n",
                        rtl->val);
         exit(1);
   }
   while ((*a++) != ',');

    /*
     * Place the new label in the RTL
     */
    b = label;
    while (*a++ = *b++);
    *(a - 1) = ';';
    *a = '\0';
    FREE(rtl->val);
    rtl->val = strcpy(CALLOC(strlen(new) + 1), new);
}



/*
 * needs_extension - In this case, "rtl" is a rtl that's being converted from
 * a load of a (byte or halfword) local variable to a register.  Normally we'd
 * need to sign extend (or zero extend) the register at this point.  However,
 * if we can trace the value of "reg" back to a load or sign (zero) extend then
 * the sign extend is not necessary.  For now, we'll start with a local search back.
 * in the future we may wish to search outside this basic block.
 */
int needs_extension_help(struct locuse* ptr,struct list* initial_rtl, struct list* rtl,struct bblock* cblk, 
	char* initial_reg, char* current_reg, int size, int needs_signed);
int needs_extension(struct locuse* ptr,struct list* rtl,struct bblock* cblk, 
	char* initial_reg, char* current_reg, int size, int needs_signed)
{
	struct bblock* cblk2;
	if(swd && debug_opt("always_needs_extention"))
		return TRUE;
	for(cblk2=top;cblk2;cblk2=cblk2->down)
		cblk2->status &= ~DONE;

	return needs_extension_help(ptr,rtl,rtl,cblk,initial_reg,current_reg,size,needs_signed);
	
}

int needs_extension_help(struct locuse* ptr,struct list* initial_rtl, struct list* rtl,struct bblock* cblk, char* initial_reg, char* current_reg, int size, int needs_signed)
{
/*
	ptr - the local variable that's getting promoted.  We'll want to be careful about references
	to it because it might be in the process of being converted to r3 (or, it might not!)

	rtl - the rtl to start the backwards search

	initial_reg - the register that was initially being assigned.

	current_reg - the current register we're looking for.  If we see a chain rule (eg: a copy)
		then we will recursively call ourselves with the new register

	int size    - the size we're trying to convert to.  For example if we're promoting a halfword reg
		then size will be 16 and we can find any sign extend of more than 16 bits. (eg: a byte
		zero extend will work and we don't need a zero extend to 16 bits)

	int needs_signed - a boolean value to tell this func. whether or not we required a signed (verses a zero)
		extend.
*/
	struct list* rtlptr=NULL;
	struct reg_assignment_work_list_item* temp_item=NULL;
	assert(ptr && cblk && current_reg && *current_reg && initial_reg && *initial_reg && (size==16||size==8));

	/* the inital block is special.  we'll visit that more than once. */
	if(initial_rtl->daddy!=cblk)
	{
		/* if this block has been done, then we know we found no reason to sign extend,
			otherwise we would have halted our search */
		if(cblk->status&DONE)	
			return FALSE;
	}

	/* we can go ahead and mark this block as done now because if we find a reason to not do it, we'll
		return TRUE and everything will unfold w/o checking the DONE bits */
	cblk->status |= DONE;

	for(rtlptr=rtl; rtlptr; rtlptr=prev_rtl(rtlptr))
	{
		char* a;
		if((a=cnts(rtlptr)))
		{
			if(fmatch(a,";") && fmatch(epos,";"))
			{
				/* multi-effect rtl.. be careful */
				if(isaliasset(a,current_reg))
					return TRUE;
				else 
					continue;
			}

			/* OK, at this point we know it's a single effect RTL. */


			/* search for current_reg=W[] */
			if(cmploc(a,current_reg)==0 && gtmem(a))
			{
				if(size==16 && (*bpos=='W' || *bpos=='B')) 
				{
					/* OK, the size is OK, does the signedness match */
					if(needs_signed && *(bpos-1)=='(')
						return FALSE;
					if(!needs_signed && *(bpos-1)=='=')
						return FALSE;
					return TRUE;

				}
				if(size==8 && *bpos=='B') 
				{
					/* OK, the size is OK, does the signedness match */
					if(needs_signed && *(bpos-1)=='(')
						return FALSE;
					if(!needs_signed && *(bpos-1)=='=')
						return FALSE;
					return TRUE;
				}
				/* the signedness doesn't match */
				return TRUE;
			
			}
			/* watch for a chain rule */
			if(cmploc(current_reg,a)==0 && /* curent_reg */
			   isRegister(skiploc(a)+1) && /* = register */
			   *skiploc(skiploc(a)+1)==';' /* ; */	
			  )
		        {
				char new_reg[REGSTRING];
				copyloc(new_reg,skiploc(a)+1);
				*skiploc(new_reg)=0;

				/* if it's a different reg, recurse on the other reg. */
				if(cmploc(new_reg,current_reg)!=0)
				{

				/* note that we don't backup here.  since we've changed regs we'll let the recursive step
					deal with the backup part */

				/* also, we need to mark this block as un-done because we'll be recursing into it again */
					cblk->status &= ~DONE;

					return needs_extension_help(ptr,initial_rtl, rtlptr,rtlptr->daddy, initial_reg, new_reg, size, needs_signed);
				}
				
			}

			/* OK, since we know it isn't a load/store or a chain-copy we'll check to see if 
				the current RTL is a sign (zero) extend */
			if(cmploc(current_reg,a)==0)
			{
				char *new_current, *new_current2;
				int  c1, c2;
				int  is_left;
				int  is_signed;
				/* check to see if this rtl is a shift right that matches the sign */
				if(is_register_shift(rtlptr, &new_current, &c2, &is_left, &is_signed))
				{

					/* so, we're looking for a right shift that's at least <size> bits */
					/* that has a matching sign */
					if(is_signed!=needs_signed)
						return TRUE;
					if(is_left)	
						return TRUE;
					if(c2<(32-size))
						return TRUE;
					/* if so, we check the prev_rtl for a shift left by at least that much */
					/* check to see if this rtl is a shift right that matches the sign */
					if(is_register_shift(prev_rtl(rtlptr), &new_current2, &c1, &is_left, &is_signed))
					{
						if(!is_left)	
							return TRUE;
						if(c1<c2)
							return TRUE;
						if(cmploc(new_current, prev_rtl(rtlptr)->val)==0)
						{
							return FALSE;
						}
					}
				
					
				}
				if(!needs_signed && is_and_isntr(rtlptr,&c1))
				{
					int bits_needed=(1<<size)-1;
					if(c1>=bits_needed && (c1&bits_needed)==bits_needed)
						return FALSE;
				}
				if(is_const(skiploc(a)+1) && *is_const(skiploc(a)+1)==';')
				{
					c1=atoi(skiploc(a)+1);
					if(needs_signed)
					{
						if(c1 <= ((1<<(size-1)-1)) &&  c1 >= (-(1<<(size-1))) )
							return FALSE;
					}
					else
					{
						if(c1 <= (1<<(size)-1) &&  c1 >= 0)
							return FALSE;
					}
					return TRUE;
				}

			}
			if(isaliasset(a,current_reg))
			{
				return TRUE;	
			}

			

		}
		else if (rtlptr->type&SETLINE)
		{
			if(isaliasref(rtlptr->val, current_reg))
				return TRUE;
		}
		else if(rtlptr->type&METADATALINE)
		{
			if(getRegType(current_reg)==RTREG && getRegNum(current_reg)==0)
			{
				if(strcmp(rtlptr->val,"ret=(r[0]{16)}16")==0)
					if(size>=16 && needs_signed)
						return FALSE;
				if(strcmp(rtlptr->val,"ret=(r[0]{24)}24")==0)
					if(size>=8 && needs_signed)
						return FALSE;
				if(strcmp(rtlptr->val,"ret=r[0]&65535")==0)
					if(size>=16 && !needs_signed)
						return FALSE;
				if(strcmp(rtlptr->val,"ret=r[0]&255")==0)
					if(size>=8 && !needs_signed)
						return FALSE;
	
			}
		}
		if( rtlptr!=initial_rtl &&(temp_item=is_in_work_list(rtlptr)) )
		{
			if(temp_item->the_size<=size && needs_signed==temp_item->is_signed)
				return FALSE;

			/* we need to return TRUE here because this item *will* get sign extended
				the way that temp_item says it will.  thus, we'll need
				to sign extend later */
			else
				return TRUE;
		}

		/* OK, we need to check if the next rtl we'll examine is the initial rtl. 
		 * if so, we've gone around a loop and found the initial rtl again and thus,
		 * see no operations on it.  no need to sign extend, i think 
		 */
		if(prev_rtl(rtlptr)==initial_rtl)	
		{
			return FALSE;	
		}

	}

	/* if we get here, we didn't find any reason to stop the search.  We could go back to the preds of cblk. */
	/* however, we'll be simple/quick for now and hope to catch most of it. */
	if(rtlptr==0)
	{
		struct blist *preds;
		/* loop through the preds and check each one. */
		/* if any of them says we need to sign extend, then, it's necessary. */
		/* for now, we'll just guess that we need to for safety */
		if(!cblk->preds)
			return TRUE;
		for(preds=cblk->preds; preds; preds=preds->next)
		{
			if(needs_extension_help(ptr,initial_rtl, preds->ptr->rtlend,preds->ptr, initial_reg, current_reg, size, needs_signed))
				return TRUE;
		}
	}
	/* the sign extend isn't necessary if we've checked all our predicessors */
	return FALSE;

}


int is_register_shift(struct list* rtlptr, char** new_current, int *the_const, int *is_left, int *is_signed)
{

	char *a=NULL;
	char *ptr_to_const;
	char *shift;
	*new_current=0;
	*the_const=0;
	*is_left=0;
	*is_signed=0;
	if(rtlptr==0)	
		return FALSE;
	if(!cnts(rtlptr))
		return FALSE;

	a=cnts(rtlptr);

	/* no multi-effect rtls for now */
	if(fmatch(a,";") && fmatch(epos,";"))
		return FALSE;

	if(isRegister(a) &&
	   *(a=skiploc(a))=='=' &&
	   isRegister(*new_current=a+1) &&
	   (*(shift=a=skiploc(*new_current))=='}' || *a=='"' || *a=='{') &&
	   (a=is_const(ptr_to_const=a+1)) &&
	   *a==';'
	  )
	{
		if(*shift=='}')
		{
			*is_left=FALSE;
			*is_signed=TRUE;
		}
		if(*shift=='"')
		{
			*is_left=FALSE;
			*is_signed=FALSE;
		}
		if(*shift=='{')
		{
			*is_left=TRUE;
			*is_signed=TRUE;
		}
		*the_const=atoi(ptr_to_const);
		return TRUE;
	}
	return FALSE;
}


int is_and_isntr(struct list* rtlptr,int *c1)
{
	char *a=cnts(rtlptr);
	assert(c1);
	*c1=0;
	if(a==0)
		return FALSE;
	if(fmatch(a,";") && fmatch(epos,";"))
		return FALSE;

	if(isRegister(a) && 
	   isRegister(skiploc(a)+1) &&
	   *(skiploc(skiploc(a)+1))=='&'
	  )
	{
		a=skiploc(skiploc(a)+1)+1;
		if(is_const(a) && *is_const(a)==';')
		{
			*c1=atoi(a);
			return TRUE;
		}
	}
	return FALSE;

}




void add_to_reg_assignment_work_list(
	struct locuse* ptr,		/* the local var */
	struct list* rtl,		/* the rtl with the reference */
	char* reg,			/* the register it was replaced with */
	int the_size,			/* the size of the var, 8 or 16 */
	int is_signed			/* whether the var was signed or not */
     )
{

	/* allocate a new item */
	struct reg_assignment_work_list_item* temp_item=
		(struct reg_assignment_work_list_item*)
		CALLOC_PHASE(sizeof(struct reg_assignment_work_list_item));	


	/* initialize it */
	bzero(temp_item,sizeof(struct reg_assignment_work_list_item));
	temp_item->ptr=ptr;
	temp_item->rtl=rtl;
	copyloc(temp_item->reg,reg);
	*skiploc(temp_item->reg)=0;
	temp_item->the_size=the_size;
	temp_item->is_signed=is_signed;

	/* and link it into the list */
	temp_item->next=reg_assignment_work_list;
	reg_assignment_work_list=temp_item;

	return;

}

struct reg_assignment_work_list_item* is_in_work_list(struct list* rtl)
{
	struct reg_assignment_work_list_item* temp_item;
	for(temp_item=reg_assignment_work_list; temp_item;
		temp_item=temp_item->next)
	{
		if(temp_item->rtl==rtl)
			return temp_item;
	}
	return NULL;

}

void process_work_list()
{
	struct reg_assignment_work_list_item* temp_item;
	for(temp_item=reg_assignment_work_list; temp_item;
		temp_item=temp_item->next)
	{
		if(needs_extension(
			temp_item->ptr,
			temp_item->rtl,
			temp_item->rtl->daddy,
		        temp_item->reg,
			temp_item->reg,
			temp_item->the_size,
			temp_item->is_signed
			)
		   )
	      	{
			char ref[MAXSTRING];
			char* reg=temp_item->reg;
			if(temp_item->the_size==8 && !temp_item->is_signed)	
			{	
        			sprintf(ref, "%s=%s&255;", reg,reg);
        			add_rtl(temp_item->rtl->daddy, temp_item->rtl, ref, rinit());
			}
			else
			{
        			sprintf(ref, "%s=%s{%d;", reg,reg, 32-temp_item->the_size);
        			add_rtl(temp_item->rtl->daddy, temp_item->rtl, ref, rinit());

				if(temp_item->is_signed)
				{
        				sprintf(ref, "%s=%s}%d;", reg,reg, 32-temp_item->the_size);
       					add_rtl(temp_item->rtl->daddy, temp_item->rtl, ref, rinit());
				}
				else
				{
        				sprintf(ref, "%s=%s\"%d;", reg,reg, 32-temp_item->the_size);
       					add_rtl(temp_item->rtl->daddy, temp_item->rtl, ref, rinit());
				}
			}
			
		}


	}

	/* forget the work list */
	/* so that next time we can do it right */
	reg_assignment_work_list=0;

}

/*
 *	0=False, 1=TRUE, 2=Maybe
 */
#define COMPARISON_NOT_TRUE 0
#define COMPARISON_TRUE 1
#define COMPARISON_MAYBE_TRUE 2
int get_test_outcome(char* left, char* right, char cond)
{
	char* val;
	int left_val, right_val;
	char* mem_const;
	int tests_true=FALSE;

	/* gtmem sets epos for us */
	if(ismem(left) && gtmem(left) && (strcmp(epos,"&255")==0||strcmp(epos,"&65535")==0))
	{
		mem_const=epos+1;
		if((val=is_const(right))==0 || *val!=0)
			return  COMPARISON_MAYBE_TRUE;
		right_val=atoi(right);
		switch(cond)
		{

			case ':':
				if(right_val<0 || right_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
		
      			case '!':
				if(right_val<0 || right_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '>':
				if(right_val<0)
					return COMPARISON_TRUE;
				else if(right_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '<':
				if(right_val<=0)
					return COMPARISON_NOT_TRUE;
				else if(right_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '`':
				if(right_val<0)
					return COMPARISON_TRUE;
				else if(right_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '\'':
				if(right_val<0)
					return COMPARISON_NOT_TRUE;
				else if(right_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
      			default:
				return  COMPARISON_MAYBE_TRUE;
   		}

	}
	/* gtmem sets epos for us */
	else if(ismem(right) && gtmem(left) && (strcmp(epos,"&255")==0||strcmp(epos,"&65535")==0))
	{
		mem_const=epos+1;
		if((val=is_const(left))==0 || *val!=0)
			return  COMPARISON_MAYBE_TRUE;
		left_val=atoi(left);
		switch(cond)
		{

			case ':':
				if(left_val<0 || left_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
		
      			case '!':
				if(left_val<0 || left_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '>':
				if(left_val<0)
					return COMPARISON_NOT_TRUE;
				else if(left_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '<':
				if(left_val<=0)
					return COMPARISON_TRUE;
				else if(left_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '`':
				if(left_val<0)
					return COMPARISON_NOT_TRUE;
				else if(left_val>atoi(mem_const))
					return COMPARISON_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
			
      			case '\'':
				if(left_val<0)
					return COMPARISON_TRUE;
				else if(left_val>atoi(mem_const))
					return COMPARISON_NOT_TRUE;
				else
					return  COMPARISON_MAYBE_TRUE;
       				break;
      			default:
				return  COMPARISON_MAYBE_TRUE;
   		}

	}


	/* if the left isn't a const, nevermind */ 
	if((val=is_const(left))==0 || *val!=0)
		return 2;
	/* if the right isn't a const, nevermind */ 
	if((val=is_const(right))==0 || *val!=0)
		return 2;

	left_val=atoi(left);
	right_val=atoi(right);

	switch (cond)
	{

		case ':':
			tests_true= left_val == right_val;
       			break;
	
      		case '!':
			tests_true= left_val != right_val;
       			break;
		
      		case '>':
			tests_true= left_val > right_val;
       			break;
		
      		case '<':
			tests_true= left_val < right_val;
       			break;
		
      		case '`':
			tests_true= left_val >= right_val;
       			break;
		
      		case '\'':
			tests_true= left_val <= right_val;
       			break;
      		case 'h':
			tests_true= *(unsigned int*)&left_val > *(unsigned int*)&right_val;
       			break;
		
      		case 'l':
			tests_true= *(unsigned int*)&left_val < *(unsigned int*)&right_val;
       			break;
		
      		case 'g':
			tests_true= *(unsigned int*)&left_val >= *(unsigned int*)&right_val;
       			break;
		
      		case 's':
			tests_true= *(unsigned int*)&left_val <= *(unsigned int*)&right_val;
       			break;
		
      		default:
			return COMPARISON_MAYBE_TRUE;
   	}

	if(tests_true)
		return COMPARISON_TRUE;
	else
		return COMPARISON_NOT_TRUE;



}


/* this function returns true if the size of the local represented by "code"
   is different than the size of memory operation used.

	eg:  code->size==4, memChar='B', we return true, that this is an indirect
		reference to the local
*/
int ind_if_sizes_dont_match(char* code,char memChar)
{
	switch(memChar)
	{
		case 'B':
			return localrecord(code)->size!=1;
		case 'W':
			return localrecord(code)->size!=2;
		case 'R':
			return localrecord(code)->size!=4;
		case 'F':
			return localrecord(code)->size!=4;
		case 'D':
			return localrecord(code)->size!=8;

	}
	return TRUE;
}

/* Return the fetch size for each memory type.  On the ARM, a size
 * of 1 indicates 8 bits.
 */
int mdMemFetchSize(char memType) {
   if ('B' == memType) {
      return 1;
   }
   if ('D' == memType) {
      return 8;
   }
   else if ('F' == memType) {
      return 4;
   }
   else if ('R' == memType) {
      return 4;
   }
   else if ('W' == memType) {
      return 2;
   }
   else {
      assert(("Bad memory type in mdMemFetchSize()", FALSE));
      return 0;
   }
}

/* Return TRUE if location is a spill location, FALSE otherwise. */
int isspill(char *loc) {
   assert(NULL != loc);
   return (('S' == *loc) && ('L' == *(loc + 1)));
}

/* Skip over spill location. */
char *skipspill(char *loc) {
   assert(NULL != loc);
   assert(isspill(loc));
   assert('[' == *(loc + 2));
   loc += 3;  /* Skip over "SL[" */
   loc = is_const(loc); /* Skip over constant after "SL[" */
   assert(NULL != loc);
   assert(']' == *loc);
   ++loc;     /* Skip over closing bracket. */
   return loc;
}

/* Return a list of registers that cannot alias general memory locations,
 * but which are used in address expressions.  This is important for
 * maybe_same() to know that these are not aliases for global or local
 * variables, unlike general purpose registers, which might be aliases.
 * Return value is a count of such registers, which are built in the arg.
 */
int md_aliasfree_regs(char Regs[MAX_ALIASFREE_REGS][REGSTRING]) {
   /* Get the current register number used as the frame pointer in this
    * function from regs2.h::fp_num.  This might be REG_FP or REG_SP,
    * depending on the nature of the function (alloca()use or not, leaf
    * function or not, etc.)
    */
   makereg(&(Regs[0][0]), RTREG, fp_num);
   makereg(&(Regs[1][0]), CTREG, 0);  /* condition codes */
   return 2;
}

/* Perform any machine dependent tests for address aliasing.  Return TRUE
 * if addresses might be, or definitely are, the same.  Return FALSE only when
 * it is possible to say with certainty that the address expressions do NOT
 * refer to the same address.
 */
int md_maybe_same(char *mem, char *expr) {
   /*-
    * This test looks for some patterns particular to the ARM.
    *
    * first:
    *
    * R[expr1+LA[addr1]+expr2] and R[expr1+LA[addr2]+expr2]
    *
    * Since LA[addr1] is definitely different than LA[addr2] if
    * addr1!=addr2, then we know these cannot access
    * the same memory location.
    *
    */

   int bracket_depth = 0;
   int found = FALSE;
   char *a, *b;
   char* mem_la = NULL;
   char* expr_la = NULL;
   char mem2[BIGSTRING];
   char expr2[BIGSTRING];
   char sub_expression1[MAXSTRING];
   char sub_expression2[MAXSTRING];

   strcpy(mem2, mem);
   strcpy(expr2, expr);

   if (!ismem(mem) || !ismem(expr))
      goto next_test2;


   a = mem2 + 2;   /* skip over the mem part */
   bracket_depth = 0;
   found = FALSE;
   while (*a) {
      if (*a == '[')
         bracket_depth++;
      else if(*a == ']')
         bracket_depth--;
      
      if (a[0] == 'L' && a[1] == 'A' && a[2] == '[' && bracket_depth == 0) {
         if (found) {
            /* Damn, more than one outer LA.. let's skip it. */
            goto next_test2;
         }
         /* OK, we've found the outter-most LA[ part for A. */
         found = TRUE;
         mem_la = a;
      }
      a = skiploc(a);
   } /* end while (*a) */
   if (!mem_la)
      goto next_test2;

   bracket_depth = 0;
   found = FALSE;
   a = expr2 + 2;
   while (*a) {
      if (*a== '[')
         bracket_depth++;
      else if (*a == ']')
         bracket_depth--;
         
      if (a[0] == 'L' && a[1] == 'A' && a[2] == '[' && bracket_depth == 0) {
         if (found) {
            /* Damn, more than one outer LA.. let's skip it. */
            goto next_test2;
         }
         /* OK, we've found the outer-most LA[ part for A. */
         found = TRUE;
         expr_la = a;
      }
      a = skiploc(a);
   } /* end while (*a) */

   if (!expr_la)
      goto next_test2;

   /* OK, at this point mem_la points to the first outer LA in the address of
    * mem.  Similarly for expr_la. 
    * Also, we know that there are no other LA's in this expression.
    * Now we have to check that the part outside the LA is constant,
    * and that the part inside the LA is different.  For the latter, we use
    * maybe_same recursively.
    */

   sub_expression1[0] = sub_expression2[0] = 'R';
   sub_expression1[1] = sub_expression2[1] = '[';
   sub_expression1[2] = sub_expression2[2] = 0;
   bracket_depth = 0;
   a = mem_la + 3;
   b = &sub_expression1[2];
   while (bracket_depth >= 0) {
      if (*a == '[') bracket_depth++;  
      if (*a == ']') bracket_depth--;  
      *b++ = *a++;
   }
   *b = 0;

   /* Now, we remove the LA[<addr1>]  from the expression. */ 
   sub(mem_la, a, "");
   bracket_depth = 0;
   a = expr_la + 3;
   b = &sub_expression2[2];
   while (bracket_depth >= 0) {
      if(*a == '[') bracket_depth++; 
      if(*a == ']') bracket_depth--;
      *b++ = *a++;
   }
   /* Now, we remove the LA[<addr2>]  from the expression. */ 
   sub(expr_la, a, "");
   *b = 0;
   if (maybe_same(sub_expression1, sub_expression2))
      goto next_test2;
   /* OK, now we know the addresses for the LA's are different, for sure! 
    * Now we compare the remaining portions of the string.  If they are
    * IDENTICAL then the expressions on the whole must be different. 
    */
   if (strcmp(mem2, expr2) == 0)
      return FALSE;

   /* Otherwise, we can check.  If the expressions are constant, (eg: no
    * registers/locals) then we know that the LA must have been of a global
    * address.  Since they are different globals, then different constants
    * are OK.
    */

   /* This is generally pretty safe to do.  A few, *VERY* few, pathological
    * cases fail this test; thus, we'll control this test with a flag.
    */

   if (!debug_opt("risky_alias_analysis")) {
      a = mem2;
      while (*a) {
         if (isRegister(a) || isLocal(a) || *a == 'L' )
            goto next_test2;
         a = skiploc(a);
      }
      a = expr2;
      while(*a) {
         if (isRegister(a) || isLocal(a) || *a=='L' )
            goto next_test2;
         a = skiploc(a);
      }
   }

   /* OK, the expressions are constant.  We must have a global address here. */
   return FALSE;

next_test2:
   return TRUE;
} /* end of md_maybe_same() */



/*
 * is_cmp - Is this a comparison RTL (for the arm)
 */
int is_cmp(char *start)
{
   char  *sptr = start;
                                                                                
   if (isreg(start) && regtype(start) == CTREG)
   {
      while (*sptr++ != '=')
         ;
      if (!isreg(sptr) || regtype(sptr) != RTREG)
         return TRUE + 1;
      return TRUE;
   }
   return FALSE;
}


/*
 * is_comapre - Check for the compare instruction and return pointer to the
 *              first operand in the compare
 */
char *is_compare(char *rtl)
{
  char *sptr = rtl;

  if(isreg(sptr) && regtype(sptr) == CTREG){

    while(*sptr++ != '=')
      ;
    return sptr;
  }
  else
    return((char *) NULL);
}


/*
 * mark_comment - mark the RTL as a comment line, called from branch chaining
 */
void mark_comment(struct list *rtl)
{
  rtl->val = NULL;
  rtl->val = strcpy(CALLOC(3), "#");
  rtl->type = ASMLINE;
}

#ifdef CALLGRAPH

/* attempt to identify the name of the func being called */
/* return 0 if we can't, otherwise return a pointer to   */
/* the global identifier that tells us the function name */
char* identify_function_name(struct list* rtl)
{
  fprintf(stderr, "Implementation copied from MIPS. Verify implementation \n\n");
  
	struct list *ptr;
	char *l, *aft_eq;
	int done, regNum, regType;

	/* this doesn't appear to be a call */
	if(rtl->val==0 || !is_call(rtl->val))
		return 0;	

	l=rtl->val+3;	/* skip the ST= part */	



	/* look for ST=<funcName> */
	if(isGlobal(l))
		return l;

	/* not a call to a global maybe a call to a register that was set
		very recently */
	if(!isRegister(l))
	{
		fprintf(stderr, "Cannot determine type of call %s\n", ptr->val);
		exit(1);
	}

	ptr=rtl;
	done=FALSE;
	while(!done)
	{

		/* back up one rtl */
		ptr=ptr->prev;	


		/* verify we don't run out of RTL's to look at */
		if(ptr==0)
			return 0;


		/* not an rtl we need to worry about */
		if(ptr->val==0 || ptr->type != RTLINE)
			continue;


		/* if it's not the register in l we don't care */
		if(cmploc(ptr->val, l)!=0 || *skiploc(ptr->val)!='=')
			continue;

		/* get a pointer to the 2nd half of the rtl */
		aft_eq=skiploc(ptr->val)+1;

		/* we found an assignment to the reg we're looking for */
		if(	isGlobal(aft_eq) && 
			*skiploc(aft_eq)==';' &&
			*(skiploc(aft_eq)+1)==0)
		{
			/* yay!  we located the function name */
			return (skiploc(ptr->val)+1);
		}
		if(	isRegister(aft_eq) && 
			*skiploc(aft_eq)==';' &&
			*(skiploc(aft_eq)+1)==0)
		{
			/* it's a reg-to-reg copy */
			/* so we try to look back further on the src reg */
			l=skiploc(ptr->val)+1;
			continue;
		}

		/* uh oh.. we found a define that's a function of some 
			other variables, we give up and assume its
			a call through a pointer */
		return 0;

	}
	

	
	return 0;
}
#endif /*CALLGRAPH*/

#ifdef INTERACT
/*
 * unsignedCompare - return true if the comparison in the loop exit is an
 *                   unsigned compare instruction
 */
char unsignedCompare(struct bblock *eblk)
{
  char *rtlin;
  struct list *jmpRTL;

  jmpRTL = (struct list *)findJumpRtl(eblk);

  if((rtlin=jmpRTL->val) && (rtlin=is_pc(rtlin))){

    rtlin++;
    if(isRegister(rtlin) && regtype(rtlin)==CTREG){
      rtlin = skiploc(rtlin);
      
      if(*rtlin=='g' || *rtlin=='l' || *rtlin=='h' || *rtlin=='s')
	return(*rtlin);
      else if(*rtlin==':' || *rtlin=='!' || *rtlin=='>' ||
	      *rtlin=='\'' || *rtlin=='<' || *rtlin=='`')
	return('\0');
    }
  }

  fprintf(stderr, "Unrecognized branch\n");
  exit(0);
}


/*
 * getCompareComp - get the components of a compare instruction
 */
void getCompareComp(struct bblock *cblk, char *op1, char *relop,
		    char *coper, char *op2, char *rem, char *label)
{
  int i, type;
  char *c, *cmpRTL, *brRTL;

  type = 0;
  
  /*verify that this block is actually a compare and branch block*/
  if(cblk->left && cblk->right){
    
    if((brRTL=is_pc(cblk->rtlend->val)) &&
       (cmpRTL=(char *)(((struct list*)findCompareRtl(cblk))->val))){

      /*get the first operand, the first operand is a register*/
      cmpRTL = is_compare(cmpRTL);
      if(isRegister(cmpRTL)){
	for(i=0 ; i<REGLOCLENGTH ; i++, cmpRTL++)
	  op1[i] = *cmpRTL;
      }
      else{
	fprintf(stderr, "First operand in compare instruction not a register\n");
	exit(0);
      }
      op1[i] = '\0';

      /*scan till the end of the first operand*/
      for(; *cmpRTL!='?' && *cmpRTL!='u' && *cmpRTL!=':' ; cmpRTL++);
      *coper = *cmpRTL;
      cmpRTL++;

      /*get the second operand*/
      for(i=0 ; *cmpRTL!=';' ; i++, cmpRTL++)
	op2[i] = *cmpRTL;
      op2[i] = '\0';

      /*RTL may be composed of more than one component, get the remaining
	parts of the RTL*/
      cmpRTL++;
      rem[0] = '\0';
      if(*cmpRTL){
	for(i=0 ; *cmpRTL!='\0' ; i++, cmpRTL++)
	  rem[i] = *cmpRTL;
	rem[i] = '\0';
      }

      /*get the relational operator*/
      brRTL++;
      brRTL = skiploc(brRTL);
      switch(*brRTL){

      case '<':
      case 'l':
      case '\'':
      case 's':
      case '>':
      case 'h':
      case '`':
      case 'g':
	*relop = *brRTL;
	break;
      case '!':
      case ':':
	*relop = '!';
	break;
      }

      /*skip past the comma to the label*/
      for(; *brRTL!='L' ; brRTL++);

      /*get the label*/
      for(i=0 ; *brRTL!=';' ; i++, brRTL++)
	label[i] = *brRTL;
      label[i] = '\0';
    }
  }
}


/*
 * setCompare - set the compare/branch instructions with the given components
 */
void setCompare(struct bblock *cblk, char *op1, char relop, char coper,
		char *op2, char *rem, char *label)
{
  char c, *rtlin, rtlval[MAXSTRING], creg[REGSTRING];
  struct list *cmpRTL;
    
  /*verify that this block is actually a compare and branch block*/
  if(cblk->left && cblk->right){
    
    if(is_pc(cblk->rtlend->val) && (cmpRTL=(struct list*)findCompareRtl(cblk))){

      /*make the compare register c[0]*/
      makereg(creg,CTREG,0);
	
      /*construct the compare RTL*/
      if(*rem)
	sprintf(rtlval, "%s=%s%c%s;%s", creg, op1, coper, op2, rem);
      else
	sprintf(rtlval, "%s=%s%c%s;", creg, op1, coper, op2);
      if(find(cmpRTL, rtlval, cmpRTL->deads)){
	fprintf(stderr, "RTL not valid\n");
      }
      FREE(cmpRTL->val);
      cmpRTL->val = strcpy(CALLOC(strlen(rtlval) + 1), rtlval);
#ifdef INTERACT
      mod_rtl(cmpRTL, NULL, rtlval);
#endif      

      /*construct the branch RTL*/
      sprintf(rtlval, "PC=%s%c0,%s;", creg, relop, label);
      FREE(cblk->rtlend->val);
      cblk->rtlend->val = strcpy(CALLOC(strlen(rtlval) + 1), rtlval);
#ifdef INTERACT
      mod_rtl(cblk->rtlend, NULL, rtlval);
#endif      
    }
  }
}


/*
 * consCompareIns - construct a normal comparison instruction from the
 *                  supplied components
 */
void consCompareIns(char *rtlval, char *op1, char *op2)
{
  char creg[REGSTRING];

  /*make the control register*/
  makereg(creg, CTREG, 0);
  
  sprintf(rtlval, "%s=%s?%s;", creg, op1, op2);
}


/* consBranchIns - construct a simple branch instruction from the supplied
 *                 arguments
 */
void consBranchIns(char *rtlval, char oper, char *label)
{
  char creg[REGSTRING];

  /*make the control register*/
  makereg(creg, CTREG, 0);
  
  sprintf(rtlval, "PC=%s%c0,%s;", creg, oper, label);
}


/*
 * loop_exit_cond - locate the "control variable" of a loop and its exit
 *                  value. Function entirely similar to the exit_cond
 *                  function, except that 'relop' is returned as a character
 *                  and unsigned operators are also distinctly handled
 */
int loop_exit_cond(struct loopl *loop, struct bblock *cblk, int loops_back,
		   char *control, char *value, char *relop)
{
   register char *rtlin, *a;
   struct list *rtlptr;

   /*
    * Start at the end of the basic block and search back for the conditional
    * branch RTL.
    */
   for (rtlptr = cblk->rtlend; rtlptr; rtlptr = rtlptr->prev) {
      if (rtlin = cnts(rtlptr)) {
         if (rtlin = is_pc(rtlin)) {

            /*
             * Look at the conditional branch RTL and determine the relational
             * operator used.  The "loops_back" variable is TRUE only if taking
             * the conditional means that the control flow remains inside the
             * current loop.
             */
            if (*rtlin++ == '=' && isreg(rtlin) && regtype(rtlin)==CTREG){
	       rtlin = skiploc(rtlin);
               switch (*rtlin) {

                case ':':
                   *relop = (loops_back) ? CMP_EQ : CMP_NE;
                   break;

                case '!':
                   *relop = (loops_back) ? CMP_NE : CMP_EQ;
                   break;

                case '>':
                   *relop = (loops_back) ? CMP_GT : CMP_LE;
                   break;

                case '\'':
                   *relop = (loops_back) ? CMP_LE : CMP_GT;
                   break;

                case '<':
                   *relop = (loops_back) ? CMP_LT : CMP_GE;
                   break;

                case '`':
                   *relop = (loops_back) ? CMP_GE : CMP_LT;
                   break;

                case 'g':
                   *relop = (loops_back) ? CMP_UGE : CMP_ULT;     /* unsigned */
                   break;

                case 'l':
                   *relop = (loops_back) ? CMP_ULT : CMP_UGE;     /* unsigned */
                   break;

                case 'h':
                   *relop = (loops_back) ? CMP_UGT : CMP_ULE;     /* unsigned */
                   break;

                case 's':
                   *relop = (loops_back) ? CMP_ULE : CMP_UGT;     /* unsigned */
                   break;

                default:
                   return (FALSE);
               }

               /*
                * Since this is a machine with codition codes, back up to
                * locate the RTL that set the condition code register.  Once we
                * locate this RTL, locate the control variable for this loop
                * and the value that the control variable is compared to.  If
                * we can locate all of these items, then return them.
                */
               rtlptr = (struct list *)findCompareRtl(cblk);
               if (!(rtlin = cnts(rtlptr)))
                  return FALSE;
	       if(isreg(rtlin) && regtype(rtlin)==CTREG){
		  rtlin = skiploc(rtlin);
		  rtlin++;

                  if (!isreg(rtlin))
                     return FALSE;
		  copyloc(control,rtlin);
		  rtlin=skiploc(rtlin);
                  *(skiploc(control)) = '\0';
                  /* look for comparison, but don't go past end of RTL */
                  while (*rtlin != 0 && *rtlin != '?' && *rtlin != 'u'
                         && *rtlin != ':')
                     rtlin++;

                  /*-
                   * If we go past the end of the RTL, we haven't seen the
                   * '?' (comparison), 'u' (unsigned comparison), or
                   *  the ':' (not equal). We have something like:
                   * IC=r[x] op r[y] trailer;
                   * i.e., we don't have a direct compare of the control
                   * variable and hence no direct knowledge of the
                   * exit value. So return FALSE.
                   */
                  if (*rtlin == 0)
                     return FALSE;

                  rtlin++;
                  a = value;
                  while ((*a++ = *rtlin++) != ';') ;
                  *(a - 1) = '\0';
                  return TRUE;
               }
            }
         }
      }
   }

   /*
    * Indicate that we could not locate all of the elements required to
    * determine the number of iterations that this loop will perform.
    */
   return FALSE;
}

#endif /*INTERACT*/
