/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/rtl.h,v $
 $Date: 2003/12/16 22:24:48 $
 $Revision: 1.14 $
 $Name:  $

 Log of changes:

 $Log: rtl.h,v $
 Revision 1.14  2003/12/16 22:24:48  clc5q
 Add global data placement functions GlobalIsCommonData(),
    GetGlobalPlacementSection(), mdEmitPadBytes(), and mdEmitCommonGlobal().

 Revision 1.13  2003/11/17 22:08:50  clc5q
 Add GlobalIsFunction(), which determines whether a struct globalsym is
    a function based on the contents of its SectionBuffer.

 Revision 1.12  2003/11/02 19:48:42  clc5q
 Add stubbed out function NotProcessingGlobal() for data placement use.

 Revision 1.11  2003/08/01 01:06:55  jg9h
 Support interface changes made due to addition of loop count down and repeat block support

 Revision 1.10  2003/05/01 00:56:56  jg9h
 Added a parameter to comparison()/md_replace_induction_var()/md_can_replace_induction_var()

 Revision 1.9  2003/04/29 20:09:37  jg9h
 Added md_can_replace_induction_var() and md_replace_induction_var()

 Revision 1.8  2003/01/24 20:20:48  clc5q
 Move maybe_same() from each target's rtl.c module up into combine.c.
    Make calls into rtl.c for machine-dependent information or processing.

 Revision 1.7  2002/10/11 17:45:17  clc5q
 Stub out divconst(); currently implemented only in SPARC.

 Revision 1.6  2002/07/16 21:48:10  clc5q
 Export find_unification_point().

 Revision 1.5  2002/07/16 19:42:50  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.4  2002/01/03 16:46:33  jdh8d
 *** empty log message ***

 Revision 1.3  2001/11/21 18:00:28  jdh8d
 *** empty log message ***

 Revision 1.2  2001/07/23 16:10:46  jdh8d
 *** empty log message ***

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.4  1999/01/06 16:00:55  jwd
 Added VET support.

 Revision 1.3  1998/04/29 19:35:57  jwd
 Deleted some symbol definitions that should not have been in
 the header file.
 Revision 1.2  1998/04/07 20:03:39  jwd
 First ANSI C version.
 Revision 1.1  1998/04/07 19:20:13  jwd
 Initial revision

*************************************************************************/

#ifndef RTL_H
#define RTL_H

#include "../lib/combine.h"
#include "../lib/locals.h"

#define MD_LOCATION_BRACKET_DEPTH 1

/*----COMMENTED OUT UNTIL I FIGURE HOW TO LINK IT*/
/* Sun's version is broken in 4.11 */
#if 0
#ifndef lint
int strcmp(char *, char *);
#endif /* !lint */
#endif /* 0 */

extern char *ret;
extern char *opstr;
extern char *pc_equ;
extern int index_reduce;        /* bool: perform index reduction ? */
extern char *lab_mask;          /* Mask to make working labels  */

void mdlinks(struct list *);
void rtlprt(struct list *, int *);
char *findlabel(char *, int *);
void reverse(struct list *, char *);
int is_call(char *);
char *is_pc(char *);
int dont_bother_with(char *);
int is_rjmp(char *);
int locget(char **, char *, int *, int *, int *, struct list *);
void localref(char *, struct locuse *);
struct list *locsub(struct locuse *, struct list *, int, char *);
void load(int, int, char *, struct bblock *, struct list *, char *, int);
void store(int, int, char *, struct bblock *, struct list *, char *, int);
int is_invariant(char *, int, struct loopl*, struct list*);
int writes_mem(char *);
int usetype(char *);
int const_val(struct list *, char *, int *);
struct list *insinvar(struct bblock *, struct list *, char *);
int is_basic(struct list *, char *, int *);
int is_type(char *, struct setlist **, int *, char *);
int sr_init(struct loopl *, char *, char *);
struct list *form_expr(struct loopl*, char *, char *);
struct list *sr_ref(struct loopl *, struct list *, char *, int);
int getpartition(struct loopl *, struct list *, char *, char *);
int sr_initialize(struct loopl *, struct memitem *, char *, int, char *, int, char *);
struct list *sr_writereg(struct list *, char *, char *);
int offset(char *, int, char *, char* memref);
int doreduce(struct itriple *);
struct list *multconst(int *, struct list *, rlist);
struct list *addmult(struct list *, char *, char *, int, rlist);
int exit_cond(struct loopl *, struct bblock *, int, char *, char *, int *);
int comparison(char *, struct list *, char *, char *, char **, char **);
int md_replace_induction_var(struct loopl *loop, char *, struct list *rtlptr, char *i_reg, 
		char *expr_reg, char *ptr1, char *ptr2_start, char *ptr2_end);
int md_can_replace_induction_var(struct loopl *loop, char *, struct list *rtlptr,
		char *i_reg, char *expr_reg,char *ptr1,char *ptr2_start, char *ptr2_end);

int get_memtype(char *);
int md_maybe_same(char *, char *);
int md_aliasfree_regs(char Regs[MAX_ALIASFREE_REGS][REGSTRING]);
int md_memFetchSize(char);
int isspill(char *);
char *skipspill(char *);

#if 0
int SetToFalse(char *rtl);
int SetToTrue(char *rtl);
int IsEqualRelJmp(char *rtl);
int IsNotEqualRelJmp(char *rtl);
#endif

struct list * 
find_unification_point(struct bblock* cblk, char used_regs[], char set_regs[]);

struct list *
divconst(int *, struct list *, vector);

int NotProcessingGlobal(char *);
int GlobalIsFunction(struct globalsym *);
int GlobalIsCommonData(struct globalsym *);
int GetGlobalPlacementSection(struct globalsym *);
void mdEmitPadBytes(struct globalsym *);
void mdEmitCommonGlobal(struct globalsym *);

/* -------------------- Support for Repeat Blocks -------------------- */
int md_unrepeatable(struct loopl *loop, int loops_back);
struct llist *md_get_cmp_jmp_rtls(struct loopl *loop, struct list *rtlptr, struct setlist *sptr);
int md_convert_rptblock(struct loopl *loop, char *lin, struct list *rtlptr, struct setlist *sptr, 
	int loops_back, char *expr, char *ptr1, char *ptr2, int *single_rpt, char *rc_reg);

/* --------------------- Support for count down loops ---------------- */
int md_is_count_down_loop(struct loopl *loop, int relop, int loops_back);
int md_can_convert_count_down(struct loopl *loop, struct setlist *sptr, int used_in,
	                int used_out, int loops_back, char *counter_regs);
void md_convert_count_down(struct loopl *loop, char *lin, struct list *rtlptr, struct setlist *sptr, 
	int loops_back, char *expr, char *ptr1, char *ptr2);
char *is_compare(char *rtl);



#endif
