/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/simp.c,v $
 $Date: 2003/01/24 20:38:08 $
 $Revision: 1.37 $
 $Name:  $

 Log of changes:

 $Log: simp.c,v $
 Revision 1.37  2003/01/24 20:38:08  clc5q
 Move previously machine-dependent simplifications (such as
    distribute_ubstracts() and remove_duplicate_top_level_items() )
    from ARM/Thumb simp.c to machine-independent combine.c.

 Revision 1.36  2002/07/31 18:01:15  jdh8d
 bug fix for predicated rtls in comp()

 Revision 1.35  2002/07/16 19:44:04  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.34  2002/06/21 23:23:45  jdh8d
 *** empty log message ***

 Revision 1.33  2002/06/21 17:09:37  jdh8d
 *** empty log message ***

 Revision 1.32  2002/02/12 15:45:32  jdh8d
 *** empty log message ***

 Revision 1.31  2002/01/15 15:38:21  jdh8d
 *** empty log message ***

 Revision 1.30  2002/01/07 22:00:10  jdh8d
 *** empty log message ***

 Revision 1.29  2002/01/03 21:49:05  jdh8d
 *** empty log message ***

 Revision 1.28  2002/01/03 21:25:47  rv3s
 check for two char macros in is_already_masked and bail out if there is any

 Revision 1.27  2002/01/03 18:44:50  jdh8d
 *** empty log message ***

 Revision 1.26  2002/01/03 16:46:33  jdh8d
 *** empty log message ***

 Revision 1.25  2001/12/31 03:29:46  rv3s
 Remove redundant shifts and masking by expanding. Also change the order of a commutative operation so that shifted register is the 2nd operand

 Revision 1.24  2001/12/30 23:47:12  jdh8d
 *** empty log message ***

 Revision 1.23  2001/12/18 15:21:43  rv3s
 Removed redundant shifts for byte and word load/store operations

 Revision 1.22  2001/12/05 19:12:22  rv3s
 New routine try_compare_with_const_opt added for CC=reg?const optimization

 Revision 1.21  2001/11/21 16:46:31  rv3s
 *** empty log message ***

 Revision 1.20  2001/11/10 05:56:54  jdh8d
 *** empty log message ***

 Revision 1.19  2001/11/10 05:42:40  jdh8d
 *** empty log message ***

 Revision 1.18  2001/11/08 21:09:36  jdh8d
 *** empty log message ***

 Revision 1.17  2001/11/06 20:45:21  rv3s
 *** empty log message ***

 Revision 1.16  2001/11/06 19:45:57  jdh8d
 *** empty log message ***

 Revision 1.15  2001/11/06 19:35:20  jdh8d
 *** empty log message ***

 Revision 1.14  2001/11/06 19:18:16  rv3s
 comp() now checks for CC = const?reg and reverses the comparison (along with the accompanying branch)

 Revision 1.13  2001/11/06 14:30:55  jdh8d
 *** empty log message ***

 Revision 1.12  2001/10/12 21:27:06  jdh8d
 *** empty log message ***

 Revision 1.11  2001/10/12 19:21:46  jdh8d
 *** empty log message ***

 Revision 1.10  2001/10/05 16:19:17  rv3s
 1.Commutative operations are flipped so that they can be recognized by the machine description
 2. Multiplication by a power of 2 constant is changed to shift (in comp())

 Revision 1.9  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.8  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.7  2001/07/20 15:48:49  jdh8d
 *** empty log message ***

 Revision 1.6  2001/06/05 18:55:35  jdh8d
 *** empty log message ***

 Revision 1.5  2001/04/23 00:02:00  jdh8d
 65536->65535 fixed.

 Revision 1.4  2001/04/20 19:23:02  jdh8d
 *** empty log message ***

 Revision 1.3  2001/04/20 19:08:51  jdh8d
 *** empty log message ***

 Revision 1.2  2001/04/04 19:40:18  jdh8d

 changes to support pre/post modification of an address register.

 in simp.c we added support to change:

 	r[X]=R[..];r[Y]=r[Y]; to simply remove the 2nd effect.

 This came from

 	r[X]=R[..];r[Y]=r[Y]+r[Z]; to simply remove the 2nd effect.

 but r[Z] was later recognized to be zero.  It works if the useless
 effect comes first as well.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.2  2000/06/10 18:45:43  jwd
 Converted over to ANSI C.


*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "../lib/vpo.h"
#include "../lib/assign.h"
#include "../lib/controlflow.h"
#include "../lib/misc.h"
#ifdef VET
#include "../lib/view.h"
#endif

#include "regs.h"
#include "regs2.h"
#include "simp.h"

int is_commutative_op(char);
int is_already_extended(char *lin, int cval, char op);
int needs_mask(struct list* rtl, char* reg2, int cval);


/*
 * comp - complicate or modify the RTL for cases where the merge needs help
 */
void comp(char *lin, char *maydie, struct list *ptr,struct list *upper) 
{
	/* we need to look for rtls of the form: 

	 r[x]=R[];r[y]=r[y];	
	 	or of the form		
	 R[]=r[y];r[y]=r[y];			


	This can occur when we get an rtl of the form:

		r[x]=R[r[y]]; r[y]=r[y]+r[x]

	but later CSE comes along and figures out that r[x] is 0, thus it forms

		r[x]=R[r[y]]; r[y]=r[y]+0

	Later, the simplifier runs and makes this:

		r[x]=R[r[y]]; r[y]=r[y]

	We just check for the r[y]=r[y] in the 2nd part and get rid of it if we
	find it.

	*/

	char *a;
	char effect[MAXSTRING];
	char pattern[REGSTRING+1];
	struct blist* exits;
	sprintf(pattern,"%s=",cc_reg);

	if(debug_opt_i("comp"))
	{
		fprintf(stderr, "Comp entered: ");
		show_rtl(stderr, lin);
		fprintf(stderr, "\n");
	}


	if(gtmem(lin) && fmatch(lin, ";") && fmatch(a=epos,";"))
	{

		/* this is a memory operation with 2 ;'s */
		/* a points to the 2nd effect of the rtl */
		a--;
		*a=0; /* temporarily put a 0 over the ; */
		if(!gtmem(a+1))
		{
			if(!fmatch(a+1,"+")  && !fmatch(a+1,"-")
			/* a 2 byte reg, followed by an equal, followed
				2 byte reg followed by a ; */
			 && strlen(a+1)==6 && strncmp(a+1, a+4,2)==0 && *(a+6)==';')
			{
				*(a+1)=0;	
			}
			*a=';';	
		}
		else
		{
			if(!fmatch(a+1,"+")  && !fmatch(a+1,"-")
			/* a 2 byte reg, followed by an equal, followed
				2 byte reg followed by a ; */
			 && strlen(lin)==6 && strncmp(lin, lin+3,2)==0 
				&& *(lin+5)==';')
			{
				/* the first effect is a r[X]=r[X], just use the 2nd effect */
				strcpy(a+1, lin);
			}
			else
				*a=';';	
		}
	}

next:

	if(gtmem(lin) && fmatch(lin, ";") && fmatch(a=epos,";"))
	{
		char temp[MAXSTRING];
		if(gtmem(lin)<a)
			goto next2;

		strcpy(temp,a);
		*a=0;
		strcat(temp,lin);
		strcpy(lin,temp);	
	}

next2:


	/* watch for byte stores that and the reg with 255 and remove the & 255 part */
	a=lin;
	while(a=gtmem(a))
	{
		if(*bpos=='W' && *epos=='=')
		{
			/* it's a byte store */
			if(strlen(epos)>3 && strncmp(epos+3, "&65535;", strlen("&65535;"))==0)
			{
				sub(epos+3, epos+3+strlen("&65535"), "");
			}
			if(strlen(epos)>4 && strncmp(epos+4, "{16)}16;", strlen("{16)}16;"))==0)
			{
				sub(epos+4, epos+4+strlen("{16)}16"), "");
				sub(epos+1, epos+2, "");
			}
			if(strlen(epos)>4 && strncmp(epos+4, "{16)\"16;", strlen("{16)\"16;"))==0)
			{
				sub(epos+4, epos+4+strlen("{16)\"16"), "");
				sub(epos+1, epos+2, "");
			}
		}
		if(*bpos=='B' && *epos=='=')
		{
			/* it's a byte store */
			if(strlen(epos)>3 && strncmp(epos+3, "&255;", strlen("&255;"))==0)
			{
				sub(epos+3, epos+3+strlen("&255"), "");
			}
			if(strlen(epos)>4 && strncmp(epos+4, "{24)}24;", strlen("{24)}24;"))==0)
			{
				sub(epos+4, epos+4+strlen("{24)}24"), "");
				sub(epos+1, epos+2, "");
			}
			if(strlen(epos)>4 &&strncmp(epos+4, "{24)\"24;", strlen("{24)\"24;"))==0)
			{
				sub(epos+4, epos+4+strlen("{24)\"24"), "");
				sub(epos+1, epos+2, "");
			}
		}
	}
next3:

	a=lin;
	while(a=gtmem(a))
	{
		/* is this a (B[]&255)&255 */
		if(*bpos=='B' && bpos>lin && *(bpos-1)=='(' 
			&& strncmp(epos, "&255)&255", strlen("&255)&255"))==0 )
		{
			sub(epos+5,epos+5+strlen("&255"), "");
		}
		/* is this a (W[]&65535)&65535 */
		if(*bpos=='W' && bpos>lin && *(bpos-1)=='(' 
			&& strncmp(epos, "&65535)&65535", strlen("&65535)&65535"))==0 )
		{
			sub(epos+5,epos+5+strlen("&65535"), "");
		}
		
	}

next4:
	
	/* does this instruction match reg=reg2&255 */
	if(isreg(lin) && *(lin+2)=='=' && isreg(lin+3) && 
		strncmp(lin+5,"&255;", strlen("&255;"))==0)
	{
		/* if so, we search backwards for the define of reg2.  
			If it's defined in an unsigned byte load, we can remove the 255 */
		struct list* tptr=ptr;
		char reg_to_find[REGSTRING];
		reg_to_find[0]=lin[3];
		reg_to_find[1]=lin[4];
		reg_to_find[2]=0;

		for(tptr=ptr->prev; tptr; tptr=tptr->prev)
		{
			if((tptr->type& RTLINE)!=RTLINE || tptr->val==0)
				continue;
			a=tptr->val;	
			while(a=gtrg(a))
			{
				if(*(a-2)==reg_to_find[0] && *(a-1)==reg_to_find[1] &&
					*a=='=' && ismem(a+1) && *(a+1)=='B')	
				{
					/* yay, we've found the sequence, simplify */
					sub(lin+5, lin+5+strlen("&255"), "");
					goto next5;
				}
				else if (*(a-2)==reg_to_find[0] && *(a-1)==reg_to_find[1] && *a=='=')
				{
					/* two possibilities, it's a chain rule or a legit define */
					if(isreg(a+1) && *(a+3)==';')	
					{
						/* ooho, it's a chain rule! */
				                reg_to_find[0]=*(a+1);
       					        reg_to_find[1]=*(a+2);
					}
					else
					{
						/* we've found it defined, but it's not 
						an unsigned byte load */
						goto next5;
					}
				}

			}
		}

	}
next5:
	/* does this instruction match reg=reg2&65535 */
	if(isreg(lin) && *(lin+2)=='=' && isreg(lin+3) && 
		strncmp(lin+5,"&65535;", strlen("&65535;"))==0)
	{
		/* if so, we search backwards for the define of reg2.  
			If it's defined in an unsigned byte load, we can remove the 255 */
		struct list* tptr=ptr;
		char reg_to_find[REGSTRING];
		reg_to_find[0]=lin[3];
		reg_to_find[1]=lin[4];
		reg_to_find[2]=0;

		for(tptr=ptr->prev; tptr; tptr=tptr->prev)
		{
			if((tptr->type& RTLINE)!=RTLINE || tptr->val==0)
				continue;
			a=tptr->val;	
			while(a=gtrg(a))
			{
				if(*(a-2)==reg_to_find[0] && *(a-1)==reg_to_find[1] &&
					*a=='=' && ismem(a+1) && *(a+1)=='W')	
				{
					/* yay, we've found the sequence, simplify */
					sub(lin+5, lin+5+strlen("&65535"), "");
					goto next5;
				}
				else if (*(a-2)==reg_to_find[0] && *(a-1)==reg_to_find[1] && *a=='=')
				{
					/* two possibilities, it's a chain rule or a legit define */
					if(isreg(a+1) && *(a+3)==';')	
					{
						/* ooho, it's a chain rule! */
				                reg_to_find[0]=*(a+1);
       					        reg_to_find[1]=*(a+2);
					}
					else
					{
						/* we've found it defined, but it's not 
						an unsigned byte load */
						goto next6;
					}
				}

			}
		}

	}
next6:

	/* Look for patterns like 
	   CC = const comp reg
	   PC = CC cond 0, target

	   and change them to CC = reg comp const, which is a valid
	   rtl. The branch condition also needs to be changed
	*/
	{
	  char *reg2,cvalstr[20],*d,*b,regval[REGSTRING],lbl[20],*x;
	  char tmplin[MAXSTRING];
	  int cval;
	  struct list *p1;
	  /* Disable */
	  strcpy(tmplin,lin);
	  a=lin;
	  if(	cmploc(a,cc_reg)==0    		&& /* CC  */
		*(a=skiploc(a))=='='   		&& /* =   */
		(a = is_const(++a))      	&& /* constant */
		( *a == '?' || *a==':' || *a=='!')	&&
		(isRegister(reg2=(a+1)))        && /* reg */
		(*(skiploc(reg2))==';')
	    ) 
	  {
	    if (fmatch(lin,";") && fmatch(epos,";")) /* Multi effect rtl. do nothing */
	      goto next7;

	    /* First, reverse the operands */
	    b = tmplin;
	    b = skiploc(b);
	    b++; /* Skip over = */
	    cval = atoi(b);
	    copyloc(regval,reg2);
	    *skiploc(regval)=0;
	    
	    sub(b,is_const(b),regval);
	    b = skiploc(b);
	    b++; /* Skip over cond */
	    sprintf(cvalstr,"%d",cval);
	    sub(b,skiploc(b),cvalstr);

	    /* Look for the branch instrn */
	    for (p1 = ptr;p1;p1 = p1->next) 
 	    {
	      if (cnts(p1) && is_pc(p1->val)) 
              {
		for(d = p1->val; *d && *d != ',';d++);
		if (!*d)
		  goto next7;
		d++;
		x = lbl;
		while (*d != ';')
		  *x++ = *d++;
		*x = 0;

		if (rexists(cc_reg, p1->deads) && !find(ptr,tmplin,ptr->deads)) 
                {
		  /* Rtl ok. do the reverse */
		  /* OK, the RTL will be accepted and we can reverse the branch.  do it */
		  strcpy(lin,tmplin);
		  reverse_and_preserve_equality(p1,lbl);
		}
		break;
	      }
		/* if we see some other use of the CC, skip out */
	      else if(cnts(p1) && isref(ptr->val,cc_reg))
		break;
	      else if(p1->se && isset(ptr->val,cc_reg))
		break;
	    }
	  }
	}


next7:

   /* Look for r0=const*r1  */
   {
     char opn,*b,*e;
     char newstr[MAXSTRING];
     a = lin;

     if (isreg(a) &&
	 (*(a = skiploc(a)) == '=') &&
	 (a = is_const(a+1)) &&
	 (is_commutative_op(opn=*a++)) &&
	 isreg(a) &&
	 (*(a = skiploc(a)) == ';')) {
       /* Reverse the opnds */
       b = lin;
       while((*b++ != opn));
       a = newstr;
       while((*a++ = *b++) != ';');
       a--;
       *a++ = opn;
       fmatch(lin,"=");
       b = epos;
       while((*a++ = *b++) != opn);
       *(a-1) = 0;
       b = epos;
       fmatch(lin,";");
       sub(b,bpos,newstr);
     }
       




   }
   
   /* Look for r0=(r1*pow2const) + r3, where pow2const is a
      power-of-2-constant. The instrn can be simplified to
      r0=(r1{val})+r3, which is a valid instrn */

   a = lin;

       /* Look for r0=(r2*r3)+r1; */
   if (!(isreg(a) && 
	 *(a = skiploc(a)) == '=' &&
	 (*(a = a+1) == '(') &&
	 (isreg(a+1)) &&
	 (*(a = skiploc(a+1)) == '*') &&
	 (isreg(a+1)) &&
	 (*(a = skiploc(a+1)) == ')') &&
	 (*(a = a+1) == '+') &&
	 (isreg(a+1)) &&
	 (*(a = skiploc(a+1))) == ';') &&
      
       /* Look for r0=r1+(r2*r3); */
       
       !(isreg(a=lin) && 
	*(a = skiploc(a)) == '=' &&
	(isreg(a+1)) &&
	(*(a = skiploc(a+1)) == '+') &&
	(*(a = a+1) == '(') &&
	(isreg(a+1)) &&
	(*(a = skiploc(a+1)) == '*') &&
	(isreg(a+1)) &&
	(*(a = skiploc(a+1)) == ')') &&
	 (*(a = a+1) == ';')))
     goto next8;



   {
     char *b,*e,*c;
     int cval;
     char newstr[MAXSTRING];


     if (fmatch(lin,"(")) {
       b = a = epos;
       if (c = is_const(a)) {
	 if (*c == '*') {
	   cval = atoi(a);
	 }
       } else {
	 /* Look for constant in the 2nd part */
	 while(*a++ != '*');
	 if (c = is_const(a)) {
	   cval = atoi(c);
	 }
       }

       if (c && (cval = is_power_of_2(cval))) {
	 /* Power of 2. replace by shift */
	 if (!(fmatch(lin,")")))
	   goto next8;
	 e = bpos;
	 e = unskiploc(a);
	 a = newstr;
	 *a++ = *e++;
	 *a++ = *e++;
	 *a++ = '{';
	 sprintf(a,"%d%c",cval,0);
	 sub(b,bpos,newstr);
	     
       }
	   
     }

   }

next8:

	/* 
		here we look for the pattern: 
	
			CC=(reg"const1)&const2 <compare char> 0;

		We'd like to simplify this into:

			CC=reg&(const2{const1) <compare char> 0;



		this is safe because we know the comparion is 
		going to be equal or not equal.  (otherwise it will be 
		rejected by the machine description)

	*/
	{
       	char *new_reg; 
	a=lin;
	if(	cmploc(a,cc_reg)==0    		&& /* CC  */
		*(a=skiploc(a))=='='   		&& /* =   */
		*(++a)=='('	       		&& /* (   */
		isRegister(new_reg=(a+1))       && /* reg */
		*(a=skiploc(a+1))=='"'             /* quote   */
	  )
	{
		char* const1=++a;
		
		if((a=is_const(a)) && 	/* constant */
		   *(a++)==')'	 && 	/* )	    */
		   *(a++)=='&'	  	/* &	    */
		  )
		{
			char* const2=a;
			char* comparison_char;

			if((a=is_const(a)) &&		/* constant */
			   *(comparison_char=a)   &&   	/* comparison character */
			   *(++a)=='0'	   &&   	/* 0 */
			   *(++a)==';'	   &&   	/* ; */
			   *(++a)==0	        	/* null terminator */
			  )
			{
				/* whew, we have found it */
				int c1=atoi(const1);
				int c2=atoi(const2);
				char newreg2[REGSTRING];
				/* if c1<<c2 is going to overflow, we skip out and leave it alone */
				if(((c1<<c2)>>c2)!=c1)
					goto next9;


				copyloc(newreg2,new_reg); *skiploc(newreg2)=0;	
				sprintf(lin,"%s=%s&%d%c0;",
					cc_reg,newreg2,c2<<c1, *comparison_char);


			}
			
		}
	}
	}


next9:

	/*
		Here we watch for bit optimizations that can occur.
		In this case, we want to see the patterns:


			(reg&c1)|c2	

			In some cases, the c1 is clearing bits that
			c2 will immediately set.  We check to see if
			the and is useless by seeing if we're clearing
			a bit that isn't set.  In other words:
			~c1 | c2 == c2 then we can optimize.


		A related case:

			(reg|c1)&c2	

			Here, we're setting bits, then clearing them.  
		So we check to see if there are bits we're setting, but not
		clearing.  In other words:	if c1 & ~c2 == c2; then
		we can optimize


		These seem stupid, but they pop up when the code expander
		generates code to manipulate bitfields.
	 */


	{
	  a=lin;
	  while(*a)
	  {
		char* const1, *const2;
		int c1, c2;
		char *temp;
		if(	*(temp=a)=='(' 			&& 	/* ( 	 */
			isRegister(temp+1) 		&& 	/* reg 	 */
			*(temp=skiploc(temp+1))=='&'	&&	/* &	 */
			(temp=is_const(const1=temp+1)) 	&&	/* const */
			*(temp++)==')'			&&	/* )	 */
			*(temp++)=='|'			&&	/* | 	 */
			is_const(const2=temp)			/* const */
		  )
		{
			c1=atoi(const1);
			c2=atoi(const2);
			if(((~c1)|c2) == c2)
			{
				/* the AND is unnecessary, remove it */
				sub(const1-1,const2-2,"");
				/* resimplify to remove parens, and start over on the str */
				simp(lin,FALSE);
				a=lin;
			}
			else
				a=skiploc(a);
		}
		else if(*(temp=a)=='('             &&	/* (	 */
                        isRegister(temp+1)                &&	/* reg	 */
                        *(temp=skiploc(temp+1))=='|'      &&	/* | 	 */
                        (temp=is_const(const1=temp+1))    &&	/* const */
                        *(temp++)==')'                  &&	/* )	 */
                        *(temp++)=='&'                  &&	/* |	 */
                        is_const(const2=temp)   		/* const */
                  )
                {
                        c1=atoi(const1);
                        c2=atoi(const2);
                        if((c1&(~c2)) == c2)
                        {
                                /* the OR is unnecessary, remove it */
				sub(const1-1,const2-2,"");
				/* resimplify to remove parens, and start over on the str */
				simp(lin,FALSE);
				a=lin;
                        }
			else
				a=skiploc(a);
                }
		else
			a=skiploc(a);
	  }

	}


next10:


next11:
        /*
                Here we watch for bit optimizations that can occur.
                In this case, we want to see the patterns:


                        (reg&~reg1)|reg2

                        the AND is clearly unnecessary if reg1 and reg2 are
                        the same register.

         */


        {
          a=lin;
          while(*a)
          {
                char* reg1, *reg2;
                char *temp2;
                if(     *(temp2=a)=='('                  &&      /* (     */
                        isRegister(temp2+1)              &&      /* reg   */
                        *(temp2=skiploc(temp2+1))=='&'    &&      /* &     */
                        *(++temp2)=='~'                 &&      /* ~     */
                        isRegister(reg1=temp2+1)        &&      /* reg1  */
                        *(temp2=skiploc(reg1))           &&      /* )     */
                        *(++temp2)=='|'                  &&      /* |     */
                        isRegister(reg2=temp2+1)                 /* reg2  */
                  )
                {
                        if( cmploc(reg1,reg2)==0)
                        {
                                /* the AND is unnecessary, remove it */
                                sub(reg1-2,reg2-2,"");
                                /* resimplify to remove parens, and start over on the str */
                                simp(lin,FALSE);
                                a=lin;
                        }
                        else
                                a=skiploc(a);
                }
                else
                        a=skiploc(a);
          }

        }
next12:

   /*
     The following code looks for an add or logical instruction that sets the integer
     codition code.  Consider the standard sequence for comparing two values and jumping
          r[33]=r[34]+r[35];   r[35]r[34]
          CC=r[33]?0;   r[33]
          PC=CC>0,L2
     The peephole optimizer will combine the first two instructions and yield the sequence
          CC=r[34]+r[35]?0;   r[33]
          PC=CC>0,L2
      previously we had described the add instruction so that the first RTL in second sequence
      would be accepted.  This is incorrect, because the addcc instruction does not set
      the condition code identically to the subtract.  We have modified the description of add
      and the logical instructions that set the condition code so they are distinquished from
      the cmp (subcc).  However, we would still like to use the addcc and corresponding logical
      instructions when appropriate.  This requires that we modified the RTL produced by
      by the peephole optimizer when certain jumps are used.  For example, consider the
      following sequence:
          r[33]=r[34]+r[35];   r[35]r[34]
          CC=r[33]?0;   r[33]
          PC=CC:0,L2
      In this case, the best sequence is:
          CC=r[34]+r[35]:0;   r[33]
          PC=CC:0,L2
      to get this we must modify the result of the peephole optimizer to change the comparison
      to an equal comparison.  We can only do this if the jump that uses the condition code
      is an jump equal or jump not equal.
   */
   a = lin;

   if(fmatch(lin, pattern))
   {
		char* expr=epos;
		if(fmatch(expr, "?"))
		{
			char* end_expr=bpos;
			struct list* p1;

			/* if this is a compare, we skip it */
			if(isRegister(expr) && skiploc(expr)==end_expr)
				goto next13;
			/* otherwise the expression is more complicated.  We
				need to search forward for uses of the CC */
         		for (p1 = ptr->next; p1 != NULL; p1 = p1->next)
			{
            			if (cnts(p1) && is_pc(p1->val))
               				break;

				/* if we find some use/set of the CC that's not 
					in a branch, give up */
				if(cnts(p1) && fmatch(p1->val, cc_reg))
					goto next13;


				
			}
         		if (p1 != NULL && p1->val != NULL && IsEqualRelJmp(p1->val)) 
			            *end_expr = ':';
         		if (p1 != NULL && p1->val != NULL && IsNotEqualRelJmp(p1->val))
			            *end_expr = '!';
		}
   }


next13:
	/* Look for rx=(ry{n}n). Expand ry to see if ry is already
	sign/zero extended by the same amount */
	{
	  char *c=lin,*b,*reg,op;
	  if (isrg(lin) && !pseudoreg(lin)) {
	    char right[MAXSTRING];
	    int cval;
	    if (fmatch(lin,";") && fmatch(epos,";")) /* Avoid multi effect rtls */
		goto next17;


	    a = lin;
	    a = gtrg(a);
	    if ((*++a == '(') &&
		(reg = ++a) && 
		isrg(reg) &&
		(a = gtrg(a)) &&
		(*a++ == '{') &&
		(c = a) && 
		(a=is_const(a)) && 
		(*a++ == ')') &&
		(*a == '}' || *a == '"') &&
		(op = *a++) && 
		(b = a) && 
		(a=is_const(a))
		) {
	      
	      if (atoi(b) != atoi(c))
		goto next17;
	      
	      cval = atoi(b);
	      copyloc(right,reg);
	      *(skiploc(right))=0;
	      expand(NULL,upper,right);
	      simp(right,FALSE);
	      if (is_already_extended(right,cval,op)) {
		/* Remove the redundant extension */
		sub(skiploc(reg),a,"");
		a = reg-1;
		sub(a,a+1,"");
	      }
	    }
	      
	  }

	}
	
next17:
	/* Look for the pattern (rx shift const) commutative_op  ry and flip it since some instrns can shift the second operand */
	{
	  char *b,*c,*d;
	  char op;
	  char sec_reg[REGSTRING];
	  char f_expr[MAXSTRING];
	  a =  lin;
	  while (*a) {
	    if (isrg(a) /*&& !pseudoreg(a)*/) {
	      /* Look for the pattern */
	      b = gtrg(a);
	      if (*b == '{' || *b == '}' || *b == '"') {
		b++;
		if (c = is_const(b)) {
		  if (*c == ')') c++;

		  if (is_commutative_op(op = *c++)) {
		    if (isrg(c)) {
		      copyloc(sec_reg,c);
		      *(skiploc(sec_reg)) = 0;
		      
		      /* Ok. lets do it */
		      if (*(a-1) == '(')
			 a--;
		      b = a;
		      d = f_expr;
		      while(*a != op)
			*d++ = *a++;
		      *d = 0;
		      sub(c,skiploc(c),f_expr);
		      sub(b,c-1,sec_reg);
		      a = skiploc(c);
		      continue;
		    }


		  }

		}
		
	      }

	    }

	    a++;
	  }

	}

/* Look for rx=ry&255. Expand ry to see if ry is already
	   masked by 255 */
	{
	  char *c=lin,*b,*reg,op;

	  if (isrg(lin) && !pseudoreg(lin)) {
	    char right[MAXSTRING];
	    int cval;
	    if (fmatch(lin,";") && fmatch(epos,";")) /* Avoid multi effect rtls */
	      goto next20;
	  
	    a = lin;
	    a = gtrg(a);
	    a++;
	    if (isrg(a) &&
		(reg = a) && 
		(a = gtrg(a)) &&
		(*a++ == '&') &&
		(c = a) &&
		(a=is_const(a)) && 
		
		(*a == ';')
		) {
	      cval = atoi(c);
	      copyloc(right,reg);
	      *(skiploc(right))=0;
	      if(fmatch(ptr->val,"&"))
	      	expand(NULL,ptr,right);
	      else
	      	expand(NULL,upper,right);
	      simp(right,FALSE);
	      if (is_already_masked(right,cval) || !needs_mask(ptr,lin,cval)) {
		sub(c-1,a,"");
	      }
	    }
	  }
	}
 next20:

	/* we need to watch for 
	 * 	r[1]=(r[1]+1)&255;	 
	 * check to see if it's in a counted loop
	 * if so, we can eliminate the &255 and be happy 
	 */
	if(!debug_opt("no_subword_induction_promotion"))
	{
		char* reg;
		char reg2[MAXSTRING];
		char* const1, *const2;
		int c1,c2;
		char* oper;
		a=lin;
		if(	isreg(a) && 			/* reg */
	   		*(a=skiploc(a))=='=' && 	/* =   */
	   		*(++a)=='(' &&			/* (   */
			(isreg(reg=a+1)) &&		/* reg */
			(*(oper=a=skiploc(reg))=='+'||*oper=='-') && 	/* + or -  */
			(a=is_const(const1=a+1))&&	/* const */
	   		*(a++)==')' &&			/* )   */
	   		*(a++)=='&' &&			/* &   */
	   		*(a++)=='2' &&			/* 2   */
	   		*(a++)=='5' &&			/* 5   */
	   		*(a++)=='5' &&			/* 5   */
	   		*(a++)==';' &&			/* ;   */
	   		*(a++)==0			/* NULL*/
		  )

		{
			struct loopl* loop=ptr->daddy->loop;
			struct loopl* all_loops;
			struct bblock* cblk;
			struct blist* bptr;
			char control[REGSTRING];
			char value[MAXSTRING];
			
			int relop;
			int val, c3, i;
			int count=0;
			/* we must be part of a loop */
			for(all_loops=loops;all_loops; all_loops=all_loops->next)
			{
				if(block_in_loop(all_loops,ptr->daddy))
				{
					loop=all_loops;
					break;
				}
			}
			if(!loop)
				goto next14;
			c1=atoi(const1);
			/* the constant must be OK, and the reg the right one */
			if(cmploc(lin,reg)!=0 || c1<=0 || c1>=255)
				goto next14;
			if(*oper=='-')
				c1=-c1;

			/* we need a preheader with valid rtls */
			if(loop->preheader==NULL)
			{
				loop->preheader=natural_preheader(loop->ptr);
	
				if(loop->preheader==NULL)
					goto next14;
			}
			if(loop->preheader->rtlend==NULL)
				goto next14;

			/* at least one exit from the loop */
			if(loop->exits==NULL)
				goto next14;


			copyloc(reg2,reg);
			*skiploc(reg2)=0;
			expand(NULL,loop->preheader->rtlend,reg2);

			/* the register must be a constant coming into the loop */
			if(!is_const(reg2) || *is_const(reg2)!=0)
				goto next14;
			/* the initial const */
			c2=atoi(reg2);
/* lets look at all the loop exists and find a suitable one */
for(exits=loop->exits; exits; exits=exits->next)
{

			/* find the loop exit */
			cblk = (struct bblock *) NULL;
			for (bptr = exits->ptr->preds; bptr; bptr = bptr->next) 
			{
				if (block_in_loop(loop, bptr->ptr)) 
					cblk = bptr->ptr;
			}
			if(!cblk)
				goto next14;

			if(!everytime(loop,cblk))
				continue;

			/* check that we know the exit condition */
			if (!exit_cond(loop, cblk, cblk->right && 
				block_in_loop(loop, cblk->right), control, value, &relop)) 
				continue;

			if(cmploc(control,lin)!=0)
				continue;

			/* if we get here, we've found an exit that's suitable, exit now */
			break;
}
			/* we need to bail if we don't find an appropriate exit condition */
			if(exits==NULL)
				goto next14;

			for (bptr = loop->blocks; bptr; bptr = bptr->next) 
			{
				struct list* rtlptr;
				for(rtlptr=bptr->ptr->rtls; rtlptr; rtlptr=rtlptr->next)
				{
					if(cnts(rtlptr) && isaliasset(rtlptr->val,control))
						count++;
					if(rtlptr->se && isaliasset(rtlptr->se,control))
						goto next14;
					if( rtlptr->type&SETLINE||rtlptr->type&RESLINE||
						rtlptr->type&CSLINE	)
					{
						if(isaliasset(rtlptr->val,control))
							goto next14;
					}
				}
			}
			/* this must be the only update in the loop..sorry */
			if(count>2)
				goto next14;

			if(!is_const(value) || *is_const(value)!=0)
				goto next14;
			/* we'll simulate execution of the loop, no more than 
				256 iterations */
			c3=c2;
			val=atoi(value);
			for(i=c2;i<256;i++)
			{
				c2=c2+c1;
				c3=(c3+c1)&255;
				if(c2!=c3)
					goto next14;
				switch(relop)
				{
					case REL_EQ:
						if(c2==val) goto optimize_it;
						break;
					case REL_NE:
						if(c2!=val) goto optimize_it;
						break;
					case REL_GT:
						if(c2>val) goto optimize_it;
						break;
					case REL_LT:
						if(c2<val) goto optimize_it;
						break;
					case REL_GE:
						if(c2>=val) goto optimize_it;
						break;
					case REL_LE:
						if(c2<=val) goto optimize_it;
						break;
				}
			}
			/* if we fell out of the loop, we didn't find the exit cond */
			/* give up for now */
			goto next14;

optimize_it:
/* YES, we know it's safe to optimize this sign extend away */
/* so, lin will become reg=reg+c1 */
			sprintf(lin,"%s=%s+%d;",control,control,c1);


		}
		
	   	
	}	
next14:

next21:

	{
                char* reg;
		char *savlin=lin;
                char *const1, *const2;
		for(savlin=lin;*savlin;savlin++)
		{
                	a=savlin;
                	if(
				(*a++=='&' ) && 			/* &     */
                        	(a=is_const(const1=a))&&      		/* const */
                        	*(a++)==')' 		&&      	/* paren */
                        	*(a++)=='&' &&                  	/* &     */
                        	(a=is_const(const2=a))      		/* const */
			  )
			{
				int newc=atoi(const1)&atoi(const2);
				char newconst[MAXSTRING];
				sprintf(newconst,"%d",newc);

				/* and remove the 2nd AND */
				sub(const2-1,is_const(const2),"");

				/* merge the two constants */
				sub(const1,is_const(const1),newconst);
			}
		}

	}

next22:



	if(!debug_opt("no_fancy_simp"))
	{
		distribute_subtracts(lin);
		remove_duplicate_top_level_items(lin);
	}


	if(debug_opt_i("comp"))
	{
		fprintf(stderr, "Comp left   : ");
		show_rtl(stderr, lin);
		fprintf(stderr, "\n");
	}
	return;
}


int mdsimp(char* lin, int limited)
{

	int change=FALSE,cval;
	int shft1,shft2,shft3,shft4;
	char *a,*b,*c,*d,*c1=0,*c2=0,*c3=0,*c4=0,op;
	/* Look for a single effect rtl like B[]=rx&255 and remove the
	   "&255" since bytestore stores only the LSB. Do it only if its
	   not a multi-effect rtl */
	a = lin;
	if (fmatch(a,";") && fmatch(epos,";"))
	  goto next;
	
	if (is_a_store(a)) {
	  if (fmatch(a,"B[")) {
	    b = gtmem(a);
	    b++; /* Skip over = */
	    d = b;
	    if (*b == '(')
	      b++;


	    if (isRegister(b)) {
	      b = gtrg(b);
	      if (strncmp(b,"&255",strlen("&255"))==0) {
		sub(b,b+strlen("&255"),"");
		change |= TRUE;
	      } else if (*d == '(' && strncmp(b,"{",strlen("{")) == 0) {
		c = is_const(++b);
		if (!c)
		  goto next;
		cval = atoi(b);
		if (*c++ == ')') {
		  if (*c == '"' || *c == '}') {
		    b = c+1;
		    c = is_const(b);
		    if (!c)
		      goto next;
		    if ((cval == atoi(b)) && cval <= 24) {
		      /* Ok. lets substitute */
		      b = d+1;
		      b = skiploc(b);
		      sub(b,c,"");
		      sub(d,d+1,"");
		      change |= TRUE;
		    }
		      
		  }

		}
	      }
	    }
	  }
	}
	
	a = lin;
	if (is_a_load(a)) {
	  if (!fmatch(a,"B[") && !fmatch(a,"W["))
	    goto next;
	  
	  if (fmatch(a,"B["))
	    b = bpos;
	  else {
	    fmatch(a,"W[");
	    b = bpos;
	  }

	  c = gtmem(a);
	  /* Look for redundant shift patterns 
	     rx = ((((B,W[]{n)}n){m)}m), where m <= n. 
	  */
	  /* Also look for (W[]&65535){24"24 */

	  if (*c == '{' &&
	      (c = is_const(c1=c+1)) &&
	      (*c == ')') &&
	      (*++c == '}' || *c == '"') &&
	      (op = *c) && 
	      (c = is_const(c2=c+1)) &&
	      (*c == ')') &&
	      (d = c) &&
	      (*++c == '{') &&
	      (c = is_const(c3=c+1)) &&
	      (*c == ')') &&
	      (*++c == op) &&
	      (c = is_const(c4 = c+1))) {

	    shft1=atoi(c1),shft2=atoi(c2),shft3=atoi(c3),shft4=atoi(c4);
	    goto remove_redundant_shift;

	    

	  }
	  else if ((c = gtmem(a)) &&
		   *c == '&' &&
		   (c = is_const(c1=c+1)) &&
		   (*c == ')') &&
		   (d = c) &&
		   (*++c == '{') &&
		   (c = is_const(c3=c+1)) &&
		   (*c == ')') &&
		   (*++c == '"') &&
		   (c = is_const(c4 = c+1))) {
	    
	    
	    shft1=atoi(c1),shft3=atoi(c3),shft4=atoi(c4);
	    
	    if (shft1 ==65535)
	      shft1 = shft2 = 16;
	    else if (shft1 == 255)
	      shft1 = shft2 = 24;
	    else
	      goto next;
	  } else
	    goto next;

	remove_redundant_shift:
	    if ((shft1 == shft2) && (shft3 == shft4) && (shft3 <= shft1)) {
	      /* Ok. the conditions are satisfied. remove the redundant shifts */
	      sub(d,c,"");
	      /* Go back and remove 2 open paranthesis */
	      
	      assert(*(b-1) == '(' && *(b-2) == '(');
	      b -= 2;
	      sub(b,b+2,"");
	      change |= TRUE;

	    }

	}

next:
#if 0
   /* This code has moved to combine.c::simp(). */
	if(!debug_opt("no_fancy_simp"))
	{
		change|=distribute_subtracts(lin);
		change|=remove_duplicate_top_level_items(lin);
	}
#endif

	return change;
}


/*
 * valid - return TRUE if constant is valid in a limited expression
 */
int valid(int isfloat, char *num) {

    return(TRUE);
}

/*
 * IsEqualRelJmp - return true if rtl is a rel jump with a test equal to zero
 */
int IsEqualRelJmp(char *rtl) {
  return is_rjmp(rtl) && *(rtl + 5) == ':' && *(rtl + 6) == '0';
}

/*
 * isNotEqualRelJmp - return true if rtl is a rel jump with a test not equal
 * to zero
 */
int IsNotEqualRelJmp(char *rtl) {
  return is_rjmp(rtl) && *(rtl + 5) == '!' && *(rtl + 6) == '0';
}

int is_power_of_2(int val)
{
  int count=0;

  if (val <= 1)
    return 0;

  if ((val & (val -1 )) != 0) /* Not a power of 2 */
    return 0;

  while (val = (val >> 1)) count++;

  return count;
}

int is_commutative_op(char opn)
{
  if (opn == '*' || opn == '+' || opn == '^' || opn == '&' || opn == '|')
    return TRUE;

  return FALSE;
}


int try_compare_with_const_opt(char *left, struct list *ptr)
{
  char *reg2,cvalstr[20],*d,*b,regval[REGSTRING],lbl[20],*x,*a;
  char tmplin[MAXSTRING];
  int cval;
  struct list *p1;
  char *right;

  strcpy(tmplin,ptr->val);
  b = tmplin;
  while (*b != ':' && *b != '?' && *b != '!' && *b != ';')
    b++;

  if (*b == ';')
    return FALSE;

  b++;
  right = b;
  
  if(	(a = is_const(left))      	&& /* constant */
	*a == 0 && 
	isRegister(b))
    {
      if (fmatch(ptr->val,";") && fmatch(epos,";")) /* Multi effect rtl. do nothing */
	return FALSE;
      
      /* First, reverse the operands */
      reg2 = right;
      b = tmplin;
      b = skiploc(b);
      b++; /* Skip over = */
      cval = atoi(left);

      if (isRegister(b))
	x = skiploc(b);
      else 
	x = is_const(b);
      

      copyloc(regval,reg2);
      *skiploc(regval)=0;
      
      sub(b,x,regval);
      b = skiploc(b);
      b++; /* Skip over cond */
      sprintf(cvalstr,"%d",cval);
      sub(b,skiploc(b),cvalstr);
      
      /* Look for the branch instrn */
      for (p1 = ptr->next;p1;p1 = p1->next) 
	{

	  if (cnts(p1) && is_pc(p1->val)) 
	    {
	      for(d = p1->val; *d && *d != ',';d++);
	      if (!*d)
		return FALSE;
	      d++;
	      x = lbl;
	      while (*d != ';')
		*x++ = *d++;
	      *x = 0;
	      
	      if (rexists(cc_reg, p1->deads) && !find(ptr,tmplin,ptr->deads)) 
                {
		  /* Rtl ok. do the reverse */
		  /* OK, the RTL will be accepted and we can reverse the branch.  do it */
		  strcpy(ptr->val,tmplin);
#ifdef VET
	begin_trans(VET_OPT_TRANS);
#endif
		  reverse_and_preserve_equality(p1,lbl);
#ifdef VET
	end_trans();
#endif
		  return TRUE;
		} else
		  break;

	    }
	  /* if we see some other use of the CC, skip out */
	  else if(cnts(p1) && isref(ptr->val,cc_reg))
	    break;
	  else if(p1->se && isset(ptr->val,cc_reg))
	    break;
	}
    }

  return FALSE;

}


/* Look for the trailer pattern {cval) op cval */
int is_already_extended(char *lin, int cval, char op)
{
  char *a,*b,*c;
  int boplevel;
  int shftlevel=0;
  int depth=0;
  char shftstr[MAXSTRING];

  /* special care needed for a predicated rtl expression, for now, ignore them */
  if(strstr(lin,",")!=NULL)
        return FALSE;


  c = lin + strlen(lin);
  while (c != lin && *c != '&')
    c--;

  if (c == lin)
    return FALSE;

  a = lin;
  while (fmatch(a,"[")) {
	a = epos-2;
	if ((*a != 'B') && (*a != 'W') && (*a != 'R') && (*a != 'A'))
		return FALSE;
	a = epos;

  }
	
  sprintf(shftstr,"{%d)%c%d",cval,op,cval);
  depth=0;
  if (!unary_op(lin,&boplevel,FALSE)) {
    /* Find the level of the shift operation */
    a = lin;
    while(*a) {
      if (*a == '(')
	depth++;
      else if (*a == ')')
	depth--;
      else if (strncmp(a,shftstr,strlen(shftstr)) == 0)
	shftlevel = depth;
      a++;
    }

    if (shftlevel >= boplevel)
      return FALSE;
  }


  a = c+1;
  if (is_const(a) && atoi(a) == cval) {
    c = c-1;
    if (*c == ')') {
      c--;
      while(*c >= '0' && *c <= '9')
	c--;
      if (*c == '{')
	if (is_const(c+1) && atoi(c+1) == cval)
	  return TRUE;
    }
  }
  return FALSE;
}


/* Return TRUE if this expression is a unary expression */

int unary_op(char *lin,int *level,int mask_check)
{
  int depth=0;
  char *a,*b,*c;
  int pardepth=0;
  int mindepth=100;
  int rval=TRUE;
  *level = 0;

  c = lin;
  for(c=lin;*c;c++) {
    if (*c == '[')
      depth++;
    else if (*c == ']')
      depth--;
    else if (*c == '(')
      pardepth++;
    else if (*c == ')')
      pardepth--;


    if (mask_check) {
      if (!depth && isoper(*c) && (*c != '&')) {
	if (pardepth < mindepth)
	  mindepth = pardepth;
	rval=FALSE;
      }
    }

    else if (!depth && isoper(*c) && (*c != '{') && (*c != '}') && (*c != '"')) {
      

      if (pardepth < mindepth)
	mindepth = pardepth;
      rval=FALSE;
    }
      

  }
  
  *level = mindepth;

  return rval;

}


int needs_mask(struct list* rtl, char* reg2, int cval)
{
	char reg[REGSTRING];
	copyloc(reg,reg2);
	*skiploc(reg)=0;

	if(cval!=255 && cval!=65535)
	{
		return TRUE;
	}

	for(rtl=rtl->next; rtl; rtl=rtl->next)
	{
		if(cnts(rtl))
		{
			if(rtl->se && isaliasref(rtl->se,reg))
				return TRUE;
			if(isaliasref(rtl->val,reg) && !isref(rtl->val,reg))
			{
				return TRUE;
			}	
			if(isref(rtl->val,reg))
			{
				if(fmatch(rtl->val,reg) && fmatch(epos,reg))
					return TRUE;
				if(!ismem(rtl->val))	
					return TRUE;
				if( *rtl->val=='B' || *rtl->val=='W' )
				{
					char* equal_pos=NULL;
					if(*rtl->val=='B')
					{
						/* aah, it's a byte store and a byte/word sign extend */
					}
					else if(*rtl->val=='W')
					{	
						/* or, it's a word store and a byte sign extend */
						if(cval==255)
							return TRUE;
					}

					/* the mem type is OK, make sure the use is the RHS and not in the addr */
					fmatch(rtl->val,"=");
					equal_pos=bpos;
					fmatch(rtl->val, reg);
					if(epos<=equal_pos)
						return TRUE;
				}
				else
					return TRUE;
			}
			if(isaliasset(rtl->val,reg))
				return FALSE;
			if(rexists(reg,rtl->deads))
				return FALSE;
		}
		else if(!(rtl->type&RTLINE))
			return TRUE;
	}
	/* we made it to the end of the block, we need the mask for a successor */
	return TRUE;

}


int is_already_masked(char *lin, int cval)
{
  char *a,*b,*c;
  int boplevel;
  int shftlevel=-1;
  int depth=0;
  char shftstr[MAXSTRING];

  c = lin + strlen(lin);
  while (c != lin && *c != '&')
    c--;

  /* special care needed for a predicated rtl expression, for now, ignore them */
  if(strstr(lin,",")!=NULL)
        return FALSE;

  if (c == lin)
    return FALSE;

  a = lin;
  while (fmatch(a,"[")) {
        a = epos-2;
        if ((*a != 'B') && (*a != 'W') && (*a != 'R') && (*a != 'A'))
                return FALSE;
        a = epos;

  }

  sprintf(shftstr,"&%d",cval);
  depth=0;
  if (!unary_op(lin,&boplevel,TRUE)) {
    /* Find the level of the shift operation */


    a = lin;
    while(*a) {
      if (*a == '(')
	depth++;
      else if (*a == ')')
	depth--;
      else if (strncmp(a,shftstr,strlen(shftstr)) == 0)
	shftlevel = depth;
      a++;
    }

    if (shftlevel >= boplevel)
      return FALSE;
  }

  a = lin;
  depth=0;
  while(*a) {
    
    while(*a && *a!='&') {
      if (*a == '(')
	depth++;
      else if (*a == ')')
	depth--;
      a++;
    }
    if (!*a)
      break;

    a++;
    if (shftlevel >= 0)
      if (depth > shftlevel && depth > boplevel)
	continue;

    if (is_const(a) && atoi(a) == cval) {
      return TRUE;
    }
  }

  return FALSE;
}
