#ifdef INTERACT

int GloError;
char ErrMsg[100];
/*
#define ERR_QUIT(MSG) {\
 sprintf(ErrMsg,"%s", MSG);\
 GloError=-1;\
 }
 */


#define CHECK(CALL)\
 if ((CALL) < 0) {\
    fprintf (stderr, #CALL);\
    GloError=-1;\
 }

#define ERR_RET(MSG) {send_error(MSG); GloError = -1; return;}




/*my definations*/
/*TREG: convert the readable type and number to executable form*/
#define TREG(t, n) { \
  int t1;\
 t1=(0xc0 | (char)(t << 2)); \
 t= (t1 |(char) (n >> 7)); \
n= (0x80 | (char)( n & 0x7f)); \
}

/*UREG: the backward operations of TREG,
 convert the cex rtl to human readable form*/
#define UTREG(t, n) { \
int tmp=t; \
t=((0x3c & t) >>2); \
n= ((tmp & 0x3)<<7 ) +( n & 0x7f); \
}
/*the TLOC is to convert the local names into
 executable type*/
#define TLOC(t, num) { \
  t = 0xa0 | (char)(num >> 7 ); \
  num = 0x80 | (char)(num & 0x007f); \
}
#define TGLO(t, num) { \
   t = 0x80 | (char)(num >> 7 );\
   num = 0x80 | (char)(num & 0x007f);\
}

static char operators[100][10]={"add",     \
			       "addcc",   \
			       "sub",     \
			       "subcc",   \
			       "and",     \
			       "andcc",   \
			       "or" ,     \
			       "orcc" ,   \
			       "orn" ,   \
			       "orncc" ,   \
			       "xor" ,   \
			       "xorcc" ,   \
			       "xnor" ,   \
			       "xnorcc" ,   \
			       "sll" ,   \
			       "srl" ,   \
			       "sra" ,   \
			       "bne",     \
			       "be",      \
			       "bg",      \
			       "ble",      \
			       "bge",      \
			       "bl",      \
			       "bgu",      \
 			       "bleu",      \
 			       "ba"  ,    \
			       "fbg" ,     \
 			       "fbl" ,     \
 			       "fbne",      \
 			       "fbe" ,     \
 			       "fbge",      \
 			       "fble",      \
 			       "ldsb",      \
 			       "ldsh",      \
 			       "ldub",      \
 			       "lduh",      \
 			       "ld"  ,    \
 			       "ldd" ,     \
 			       "stb" ,     \
 			       "sth" ,     \
 			       "st" ,     \
 			       "std",      \
 			       "fadds",      \
 			       "faddd",      \
 			       "fsubs",      \
 			       "fsubd",      \
 			       "fmuls",      \
 			       "fmuld",      \
 			       "fdivs",      \
 			       "fdivd",      \
 			       "fitos",      \
  			       "fitod",      \
 			       "fstoi",      \
 			       "fdtoi",      \
 			       "fstod",      \
 			       "fdtos",      \
 			       "fmovs",      \
 			       "fnegs",      \
 			       "fcmps",      \
 			       "fcmpd",      \
  			       "cmp",      \
 			       "mov",      \
 			       "restore",      \
 			       "save",      \
 			       "sethi",      \
 			       "ret",      \
 			       "retl",     \
 			       "call",     \
 			       "nop"     \
                                    };


enum opt_type { ADD,   \
		ADDCC, \
		SUB,   \
		SUBCC, \
		AND,   \
		ANDCC, \
		OR,    \
		ORCC,  \
		ORN,    \
		ORNCC,  \
		XOR,    \
		XORCC,  \
		XNOR,    \
		XNORCC,  \
		SLL,  \
		SRL,  \
		SRA,  \
		BNE,   \
		BE,    \
		BG,    \
		BLE,    \
		BGE,    \
		BL,    \
		BGU,    \
		BLEU,    \
		BA,    \
		FBG,    \
		FBL,    \
		FBNE,    \
		FBE,    \
		FBGE,    \
		FBLE,    \
		LDSB,    \
		LDSH,    \
		LDUB,    \
		LDUH,    \
		LD,    \
		LDD,    \
		STB,    \
		STH,    \
		ST,    \
		STD,    \
		FADDS,    \
		FADDD,    \
		FSUBS,    \
		FSUBD,    \
		FMULS,    \
		FMULD,    \
		FDIVS,    \
		FDIVD,   \
		FITOS,   \
		FITOD,   \
		FSTOI,   \
		FDTOI,   \
		FSTOD,   \
		FDTOS,   \
		FMOVS,   \
		FNEGS,   \
		FCMPS,   \
		FCMPD,   \
		CMP,   \
		MOV,   \
		RESTORE,   \
		SAVE,   \
		SETHI,   \
		RET,   \
		RETL,   \
		CALL,   \
		NOP   \
                          };

/*register types: bwrfdlohi*/
typedef enum reg_type {B, W, R, F, D, LO, HI} REG_TYPE;
/*operand types*/
typedef enum oprnd_type {REG, LABEL, EXPR_ADDR, REG_ADDR, LOCVAR, GLOVAR,\
			 NUM, HI_VALUE, LO_VALUE, EXPRESSION, VALUE} OPRND_TYPE;

#define MAXOP_LEN 10
#define MAXOPRND_LEN 50
#define MAXOPRNDS_LEN 150
#define MAXSTA_LEN  170

/*The structure to store the operand information*/
typedef struct{
  OPRND_TYPE operand_type;
  REG_TYPE   register_type;
  int operand_no;
  char s_oprnd[20];  
} OPRND;

/*the structure to store the source statement information*/
typedef struct {
  char oprnds[MAXOPRNDS_LEN];
  enum opt_type op_tor;
  OPRND operand[3];
  int n_oprnd;
} STATEMENT;

/*functions used to support the translation*/
int Translate(char *source, char *dst);
void InitStatement(STATEMENT *sta1, char *src);
void CutFix(char *op);
void Trans(char *result, STATEMENT *sta1);
void SubtoSpace(char *oprnd);
OPRND_TYPE ParseExpression(char *s_oprnd, OPRND *oprnd);
OPRND_TYPE ParseValue(char *s_oprnd, OPRND *oprnd);
OPRND_TYPE Parse(char *s_oprnd, OPRND *oprnd);
int HaveSeparator(char *str);
char* GetSepStr(char *srcstr, char *rslstr, char *c);
int IsSeparator(char c);

void ExtractAddr(char *src, char *dst);
void GetOp(char *op,char *oprnd, char *src);
void TypeConv(OPRND  *oprnd,  char *reg_typec);
void RtlGen(STATEMENT  *statem, char *result);
void SynAnalysis(STATEMENT *sta1);
void CexGen(char *result, STATEMENT *statem);
int GetOprndNo(int op);
void Show(FILE * fp, register char *rtl);
void ConvToD(STATEMENT *statem);
void ConvOprndD(OPRND *oprnd);
void ResSaveSpec(STATEMENT *statem);
void IgnoreIt(char *oprnd);
int IsNumber(char *oprnd);

/*copied def*/
#define isrg(s) ((*(s) & 0xc0) == 0xc0)
#define regtype(s) ((((int) *(s)) & 0x3c) >> 2)
#define regnum(s) (((((int) *(s)) & 0x3) << 7) + (((int) *(s + 1)) & 0x7f))
#define locnum(s) ((*s & 0x1f) << 7) + (*(s+1) & 0x7f)
#define glonum(s) ((*s & 0x1f) << 7) + (*(s+1) & 0x7f)

/*Added to get local and global variables*/
#define MAXLEN 20
#define MAXVAR_NO 4096


char locnames[4096][20];
char glonames[4096][20];
int numloc, numglo;

#endif
