
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/assign.c,v $
 $Date: 2004/01/29 01:05:11 $
 $Revision: 1.47 $
 $Name:  $

 Log of changes:

 $Log: assign.c,v $
 Revision 1.47  2004/01/29 01:05:11  clc5q
 Indent gtrg() to make it readable.

 Revision 1.46  2003/11/18 01:52:40  clc5q
 Added gtglobal() to get global reference in RTL.

 Revision 1.45  2003/08/05 20:43:56  clc5q
 Add comments to cancolor() prologue; reindent to make it readable.

 Revision 1.44  2003/08/01 02:16:00  jg9h
 Added a few helper functions.

 Revision 1.43  2003/06/17 13:58:53  clc5q
 Make the function assign() a static private function.  It is only called
    from within this module, and it has a name conflict with the assign()
    function in the Chaco graph partitioning library.

 Revision 1.42  2003/04/03 20:06:08  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.41  2003/04/01 22:19:30  jdh8d
 fixed wrong parameter to freereg

 Revision 1.40  2003/03/30 22:01:09  jdh8d
 added check to loadreg() to avoid reloading a spilled, destination

 Revision 1.39  2003/03/29 05:06:52  jdh8d
 fixed bug in reserve with spilled regs

 Revision 1.38  2003/03/12 15:35:08  jdh8d
 *** empty log message ***

 Revision 1.37  2003/02/06 04:46:26  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.36  2002/10/10 02:01:10  jg9h
 Major change to the local register assigner.
 It no longer bails out on seeing that only conflicting registers
 are available for assignment. (This is important in processors like
 the tms320c54x where it is easy to run out of registers).
 It temporarily uses a conflicting register for the rtl, but frees
 that register right after the rtl.
 Added gt_any_loc().

 Revision 1.35  2002/08/21 20:17:24  clc5q
 Add function gtloc() to get the next local variable in an RTL.

 Revision 1.34  2002/07/11 15:22:29  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.33  2002/06/26 13:56:48  jwd
 Function touchreg (which is used by the scheduler and others) should be using
 the register map.  This is especially true for the instruction scheduler which
 happens after fixentry which maps the registers.

 Revision 1.32  2002/06/05 20:08:52  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.31  2002/03/29 19:43:38  rv3s
 Added bounds check for temporary array index in local register assignment routines

 Revision 1.30  2002/01/01 15:38:26  rv3s
 vpo.c

 Revision 1.29  2001/12/29 13:40:02  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.28  2001/12/18 15:08:53  rv3s
 all_lnks removed whenever lnks are removed

 Revision 1.27  2001/11/27 20:08:58  rv3s
 *** empty log message ***

 Revision 1.26  2001/11/05 17:26:02  jdh8d
 *** empty log message ***

 Revision 1.25  2001/10/30 22:33:35  jdh8d
 *** empty log message ***

 Revision 1.24  2001/10/29 19:23:18  jdh8d
 *** empty log message ***

 Revision 1.23  2001/10/23 15:11:27  jdh8d
 *** empty log message ***

 Revision 1.22  2001/09/25 15:30:30  jdh8d
 *** empty log message ***

 Revision 1.21  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.20  2001/09/10 17:55:43  jdh8d
 *** empty log message ***

 Revision 1.19  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.18  2001/08/30 15:43:29  jdh8d
 *** empty log message ***

 Revision 1.17  2001/08/28 21:05:00  jdh8d
 *** empty log message ***

 Revision 1.16  2001/08/01 18:25:05  rv3s
 In assign_basic_block(), update the rtl only if there is a change reported by assoc()

 Revision 1.15  2001/07/23 18:24:59  rv3s
 Replaced skiploc() with skiplocOr2() for processing dead register list

 Revision 1.14  2001/05/28 17:51:03  jdh8d
 *** empty log message ***

 Revision 1.13  2001/05/23 20:28:19  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.12  2001/05/07 20:21:17  jdh8d
 *** empty log message ***

 Revision 1.11  2001/04/10 16:41:12  rv3s
 Added new routines is_a_load() and is_a_store() to check for load and store rtls (respectively)

 Revision 1.10  2001/03/12 20:02:37  jdh8d
 *** empty log message ***

 Revision 1.9  2001/03/07 15:50:15  jdh8d


 eod fix to observe t* lines

 Revision 1.8  2001/03/06 01:00:47  jks6b
 This is a test change to make sure that the RCS locks did indeed get removed.
 The change is the addition of a single blank line within a multi-line comment.

 Revision 1.7  2000/08/01 14:01:45  jwd
 Modified savregs so that when it was backing up looking for the
 call instruction (to insert a store to save a caller saves register),
 that it made sure it found the call line.  Previously, it just backed
 up to the first RTLINE. This caused it to fail when there was
 a dead line (which is a RTLINE) before the call.

 Revision 1.6  2000/06/09 19:04:43  jwd
 Changed calls to VET so mandatory phases are indicated.

 Revision 1.5  1998/10/06 19:37:29  jwd
 Added vet support.
 Revision 1.4  1998/04/28 19:17:16  jwd
 Added an return (unreachable) to keep compiler from complaining.
 Revision 1.3  1998/04/03 16:47:01  jwd
 First ANSI C version.

*************************************************************************/

/* ------------------------------------------------
   Change history 
   --------------
   7/3/95
   Fixed a bug in findreg. The code was using check to index the conflict
   array. It should have been using loop. It's strange that this never
   popped up before

   1/12/98: Modified the funnction prototyping to be ansi-c compatible
      with modularity by removing nonlocal prototypes
------------------------------------------------*/

#define ASSIGN 1

#define	NEEDS_NOTHING	0
#define	NEEDS_FREE		1
#define	NEEDS_SPILL		2

#ifdef RRLRA
#define CLASSREG
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "vpo.h"
#include "vpo2.h"
#include "assign.h"
#include "controlflow.h"
#include "database.h"
#include "dataflow.h"
#include "links.h"
#include "locals.h"
#include "misc.h"
#include "rtlspec.h"
#include "vectors.h"

#include "inst.h"   /* Machine Dependent */
#include "regs.h"   /* Machine Dependent */
#include "regs2.h"  /* Machine Dependent */
#include "rtl.h"    /* Machine Dependent */

#ifdef VET
#include "view.h"
#endif


int isused[MAXREGS];	/* TRUE if there is a use line for this register */
int usedregs[MAXREGS];	/* TRUE if the register is used as a temporary   */
int usedtemps[MAXTEMP];	/* TRUE if the spill area is used by the fuction */
int maxregs = MAXREGS;	/* Variable used to pass on the value of MAXREGS */
int mrveclen;		/* Length of vector that holds MAXREGS bits      */
int hascs;		/* Will be set to TRUE if function makes calls   */
char *trash_cc = TRASH_CC;	/* String needed to trash condition codes */
char *memprt = MEMPRT;	/* String needed to determine memory types       */

static int work_needed[MAXREGS];
static int spill_loc[MAXREGS];

#ifdef VET
char oldrtl[300];
#endif

#ifdef RRLRA
static int lastfound[MAXCLASSES];	/* Last location where register was
					   found */
#endif

static int assign(struct bblock *);

/*
 * registers_used - scan the function and determines which registers are used
 */
void registers_used() 
{

   register char c;
   register char *rtlin;
   register struct list *ptr;
   register int i;
   regarray tr;
   struct bblock *cblk;
   int rt, rcont;

   /*
      First, mark all registers as NOTUSED
   */
	initassign(&top->regstate);
   tr = (regarray) top->regstate;
   for (i = 0; i < MAXREGS; i++)
      tr->reg[i].status = NOTUSED;

   /*
      Now scan through all of the RTLs and determine which registers are still
      in use.  If a register that occupies only a single allocation item is
      used, then mark it as USED.  If a register item requires more than one
      allocation item or it is a part of a group, then mark each item as
      FOLLOWER.
   */
   for (cblk = top; cblk; cblk = cblk->down)
   {
      for (ptr = cblk->rtls; ptr; ptr = ptr->next)
      {
         if (rtlin = cnts(ptr))
         {
            for (;;)
            {
               while(!isRegister(rtlin) && *rtlin!=0)
               {
                        rtlin=skiploc(rtlin);
               }

               if (!*rtlin)
                  break;
               /*rtlin=unskiploc(rtlin);*/
               if (isRegister(rtlin))
               {
                  rt = regtype(rtlin);
                  if (headgroup(rt) >= 0)
                     rt = headgroup(rt);
                  i = regtoindex(rt, regnum(rtlin));
                  rtlin=skiploc(rtlin);
                  rcont = allocreg(rt);
                  if (rcont == 1)
                  {
                     tr->reg[i].status |= USED;
                  }
                  else
                  {
                     while (rcont--)
                        tr->reg[i++].status |= FOLLOWER;
                  }
               }
               rtlin=skiploc(rtlin);
            }
         }
      }
   }
}

/*
 * local_register_assignment - perform local register assignment
 */
int local_register_assignment(int invocation) {

   register struct bblock *cblk;
   register struct list *rtlptr;
   register int rnum;
   regarray tr;
   int change;
  
#ifdef INTERACT
    begin_phase(REG_ASSIGNMENT_TRANS);
#elif VET
    begin_phase(REGASSIGN_PHASE);
#endif
   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd &&
       debug_opt_i("dump_before_local_register_assignment", invocation))
      dump_function_i("before local_register_assignment()", invocation,
		      SHOW_USE | SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   /*
      Clear out all of the global state
   */
   for (rnum = 0; rnum < MAXREGS; rnum++) {
      isused[rnum] = FALSE;
      usedregs[rnum] = NOTUSED;
		work_needed[rnum]=NEEDS_NOTHING;
   }
   for (rnum = 0; rnum < MAXTEMP; usedtemps[rnum++] = FALSE);

#ifdef RRLRA
   for (rnum = 0; rnum < MAXCLASSES; lastfound[rnum++] = -1);
#endif

   /*
      Set all basic blocks to UNDONE and mark all registers in use lines
   */
   for (cblk = top; cblk; cblk = cblk->down) {
      STATUS(cblk, UNDONE);
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next)
	 if (rtlptr->type & USELINE)
	    isused[rtlptr->cost] = TRUE;
   }

   /*
      This item will be set to TRUE at the end of local register allocation
      only if the current function contains function calls that require the
      caller to save any live registers at the point of the function call.
   */
   hascs = FALSE;

   /*
      Perform local register allocation on the whole function, starting with
      the entry block of the function.
   */
   change = assign(top);

   /*
      Save the state of registers used with the entry block of the function
   */
   regfree(top->regstate);
   initassign(&top->regstate);
   tr = (regarray) top->regstate;
   for (rnum = 0; rnum < MAXREGS; rnum++)
      tr->reg[rnum].status = usedregs[rnum];

   /*
      Clear out any left over entry state records
   */
   for (cblk = top; cblk; cblk = cblk->down)
      cblk->elist = (struct eqvtable *) NULL;

#ifdef INTERACT
	end_phase(REG_ASSIGNMENT_TRANS);
#elif VET
	end_phase(REGASSIGN_PHASE);
#endif

   reset_local_links();

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd &&
       debug_opt_i("dump_after_local_register_assignment", invocation))
      dump_function_i("after local_register_assignment()", invocation,
		      SHOW_USE | SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   /*
      Indicate if any new code has been added during the assignment phase
   */
   return (change);
}

/*
 * assign - perform local register assignment
 */
int assign(struct bblock * cblk) {

   struct blist *bptr;
   int go, save_state;
   int change;

   /*
      No changes to begin with
   */
   change = FALSE;

   /*
      Set the state of the current basic block to waiting, to indicate that
      this block is waiting to have local register allocation performed pending
      the completion of all of the blocks that are predecessors of it (except
      in the case of loops, of course, in which case one of the blocks in the
      loop will have to be allocated before all of its predecessors are
      finished.
   */
   STATUS(cblk, WAITING);

   /*
      Set the "go" state to perform local register allocation on a basic block
      unless it has any live pseudo-registers at the entry point of the basic
      block.  If there are live pseudo-registers, then we check to see there
      are any predecessor basic blocks that have not yet had local register
      allocation done on them.  If we find any such blocks, then we go ahead
      and handle them first.  If we find a predecessor block that is still
      waiting, then we have located a loop and we hold off on performing
      allocation on this basic block until the predecessor block is allocated.
   */
   go = TRUE;
   save_state = FALSE;
   if (rcommon(cblk->ulist, pseudos)) {
      for (bptr = cblk->preds; bptr; bptr = bptr->next) {
	 if (bptr->ptr->status & UNDONE)
	    change |= assign(bptr->ptr);
	 if (bptr->ptr == cblk)
	    save_state = TRUE;
	 else if (bptr->ptr->status & WAITING)
	    go = FALSE;
	 else if (bptr->ptr->status & DORMANT)
	 {
	    save_state = TRUE;
	    go = FALSE;
	 }
      }
   }

   /*
      If we have been given the go-ahead to perform local register allocation
      on this basic block, we initialize a local register allocation vector for
      this basic block, then we handle any conflicts in allocation that may
      exists between the various predecessors of this basic block.  Once that
      is done, we perform local register allocation on this basic block. Then,
      we go ahead and attempt to perform local register allocation on any of
      the children of this basic block that haven't already been allocated.
   */
	if (go) {
		initassign(&cblk->regstate);
		solveconflicts(cblk);
		if (save_state)
			save_entry(cblk);
		change |= assign_basic_block(cblk);
		STATUS(cblk, DONE);
		if (cblk->left) {
			if (cblk->left->status & (UNDONE | DORMANT))
				change |= assign(cblk->left);
			else if (cblk->left->elist)
				loopconflicts(cblk, cblk->left);
		}
		if (cblk->right) {
			if (cblk->right->status & (UNDONE | DORMANT))
				change |= assign(cblk->right);
			else if (cblk->right->elist)
				loopconflicts(cblk, cblk->right);
		}
	}

   /*
      Otherwise, we are waiting for a predecessor block to be allocated, so we
      enter a dormant state and wait for the predecessor block to be allocated
      first.
   */
   else
      STATUS(cblk, DORMANT);

   /*
      Indicate if any new code has been added to the function
   */
   return (change);
}

/*
 * assign_basic_block - perform local register allocation on a basic block
 */
int assign_basic_block(struct bblock * cblk) {

   register char *rtl;
   register int rtnum, update;
   register struct list *ptr,*save_next;
   int change,change1;
	int index;
   char *dptr[MAXRTS];
	regarray cr;
	struct setlist *sptr;
	int rt;
    
#ifdef VET
    begin_trans(VET_REQUIRED_TRANS);
#endif
   /*
      No changes to begin with
   */
   change = FALSE;

   /*
      Examine each line of this basic block
   */
	/* Use save_next, so that if findreg() inserts spills AFTER ptr,
		the local register assigner (ie: this outer loop) can skip 
		those spill rtls.
		eg.
		r[0]=SL[0];
		r[0]=r[0]+r[2];	r[2]  	<--- ptr  (r[45]=r[45]+r[47])
		SL[0]=r[0];			r[0]		<--- new ptr->next after call to findreg()
		w[80]=r[45];					<--- original ptr->next (save_next)
	*/

   cr = (regarray) cblk->regstate;

	for (ptr = cblk->rtls; ptr; ptr=save_next) {
			save_next=ptr->next;

		/*
			If this line is an RTL line, then if it has any effects, scan the line
			and examine each register in the RTL individually.  First, look at all
			register uses.  Map all pseudo registers to corresponding hardware
			registers.  If the pseudo register values needed had been spilled to
			memory, new RTLs may be added to this basic block that load the values
			from memory.  Remember the location of any of the register sets
			located in the RTL, so that we can come back and deal with them later
			without having to re-scan the whole RTL.
		 */
		if (ptr->type & RTLINE) {
			if (rtl = ptr->val) {
#ifdef VET
#ifdef INTERACT
				if (swq)
#endif
				strcpy(oldrtl, rtl);
#endif
				rtnum = 0;
				update = change1 = FALSE;
				while (rtl = gtrg(rtl)) {
					if (*rtl != '=')
						assoc(cblk, ptr, unskiploc(rtl), &change, FALSE);
					else
						dptr[rtnum++] = unskiploc(rtl);
					if (change)
						update = TRUE;
				}

				/*
					Now we deal with the dead register list.  This will tell us
					which registers will no longer be needed, so that we can free up
					the hardware register that are allocated to them.  Note that
					pseudo-register deaths will be altered to represent the hardware
					registers that were allocated to them at this point in the basic
					block.
				 */
				dodeads(cblk, &ptr->deads, FALSE);
				/*
					Now we go back and look at the registers that are set in this
					RTL.  If it is a pseudo-register, it will be mapped to an
					appropriate hardware register.  In some cases, the values
					currently in some hardware register may have to be spilled in
					order to make room for the new value that will be assigned to
					this new register.  If the register is a hardware register, the
					local register allocator will ensure that the indicated hardware
					register is available to hold the value that is being assigned
					to it. We also ensure that none of the registers that are set
					are in the dead register list, since they obviously do not die
					at this point.
				 */
				while (rtnum--) {
					assoc(cblk, ptr, dptr[rtnum], &change, TRUE);
					/* we need to check aliases 
						Consider
						r[0]=f[32]; f[32]
						(We need to remove f[32] from the dead list.)
						After assoc(), this would become
						r[0]=f[0]; f[0]
						cse() would make the above rtl dissappear, because f[0]
						is declared dead. So remove that death from there.
						Strictly speaking such rtls should not even appear in the
						cex file, because fregs are different from the rregs logically.
						f[0] contains the floating point representation of some number.
						So you cant directly assign from one to the other. It has
						to pass through a conversion macro. eg. r[0]=XI[f[0]]; f[0]
						*/
					for (rtl=aliases(dptr[rtnum]);*rtl;rtl=skiploc(rtl)+1)
						rdelete(rtl, &ptr->deads);
				}

	 			for (index = 0; index < MAXREGS; index++) {
					/* If work_needed is either NEEDS_FREE or NEEDS_SPILL, it means that the hw reg was a
						conflicting one and needs to be freed up right now, either by spilling it (if it is
						a dest) or by just reassociating it with its original spill, from which it was loaded
						(if it is a use). */
					if (work_needed[index]==NEEDS_FREE) {
						/* This pseudo register was a 'use'. So we had loaded it from its spill location into
							this hw reg, but hadn't freed that spill loc. So all we do now is to reassociate
							this pseudo with that spill loc. */
						sptr=cr->reg[index].pseudo;
						rt = regtype(sptr->item);
						freereg(cblk, sptr);  /* free up this hw reg */
						marktemp(cblk, sptr, rt, spill_loc[index]);
						work_needed[index]=NEEDS_NOTHING;
					} else if (work_needed[index]==NEEDS_SPILL) {
						/* This pseudo was a destination in this rtl. So it has got a new value, and this
							value has to be saved in a spill location. gtreg() handles the case where a reg is
						 	both a dest and a use (eg. r[32]=r[32]+r[33])- it frees the original spill
							and marks this reg to be NEEDS_SPILL. (this happens because we process the uses first
						   and dsts later.) If a reg is only a dest, then it is marked NEEDS_SPILL straightaway
						 	in findreg(). */
						sptr=cr->reg[index].pseudo;
						rt = regtype(sptr->item);
						spillreg(cblk, ptr->next, index, TRUE); 
						work_needed[index]=NEEDS_NOTHING;
					}
				}

				/*
					If we have made any changes to this RTL, we throw away any cost,
					kind and side effect information that we may have on this RTL,
					since it may now be invalid.
				 */
				if (update) {
					ptr->cost = 0;
					ptr->kind = 0;
					ptr->type &= ~SIDEFFECT;
#ifdef INTERACT
					mod_kind(ptr);
					mod_type(ptr);
#endif
					update_se(ptr,(char*)NULL);
				}
#ifdef VET
				if (strcmp(oldrtl, ptr->val))
#ifdef INTERACT
					mod_rtl(ptr, oldrtl, ptr->val);					
#else
					mod_rtl(ptr);
#endif
#endif
			}

			/*
				If this RTL has no effects, then it may just be here to mark
				certain registers as dead.  We will now free up any such registers,
				except that in this case we do not leave behind the death of any
				pseudo-register, even if it was mapped to a hardware register.
			 */
			else
				dodeads(cblk, &ptr->deads, TRUE);

		}

		/*
			A hardware register may be explicitly reserved at any point in time
			with a reserve line.  The effect is that the local register allocator
			ensures that the register is free and that its value will be preserved
			until it dies.
		 */
		else if (ptr->type & RESLINE)
			ptr = reserve(cblk, ptr, &change);

		/*
			A caller-saves line indicates that the registers indicated must be
			spilled to memory at this point if they contain valid items.  This is
			used to implement caller-saves calling conventions.
		 */
		else if (ptr->type & CSLINE)
			savregs(cblk, ptr, &change);
		else if (ptr->type & PARMLINE)
		{
			rtl=ptr->val;
			while (rtl = gtrg(rtl)) 
				assoc(cblk, ptr, unskiploc(rtl), &change, FALSE);
		}
	}
#ifdef VET
    end_trans();
#endif

   /*
      Since we are finished with this basic block.  We unassociate all our
      links with the register database, so that another basic block may
      establish them.
   */
   unassociate(cblk);

   /*
      Indicate if any new code has been added to the function
   */
   return (change);
}

/*
 * dodeads - examine a dead register list and free up dead registers
 */
void dodeads(struct bblock * cblk, rlist * deads, int empty) 
{
	register char *a;
	register struct setlist *sptr;
	int rt;
	char reg[MAXSTRING], dreg[REGSTRING];

	/*
		Examine each register marked dead at this point
	 */
	reget(*deads, reg);
	for (a = reg; *a; ) {
		sptr = s_add(a);
		switch (sptr->regstatus) {

			case UNASSIGNED:

				/*
					If the register was not assigned to anything, then we simply
					make it disappear from the dead register list unless it was a
					hardware register.  I'm not too sure if we need to keep dead
					unassigned hardware registers around any more (they used to be
					used in place of set lines at call sites), but for now we will
					leave them alone.
				 */
				if (!(sptr->status & HARDWARE))
					rdel(sptr->num, deads);
				break;

			case REGISTER:

				/*
					If the dead item was allocated to a hardware register, then we
					can go ahead and free up the hardware register for allocation.
					If the register was a pseudo-register and this RTL is empty (it
					has no effects), then we can just make such pseudo-registers
					disappear.
				 */
				if (!(sptr->status & HARDWARE))
					rdel(sptr->num, deads);
				if (!empty) {
					rt = regtype(a);
					makerg(dreg, rt, indextoreg(rt, sptr->assign));
					rinsert(dreg, deads);
				}
				/* If we have marked anything to be NEEDS_FREE, then we need to free it up
					here. */
				if (work_needed[sptr->assign]==NEEDS_FREE) 
					freetemp_index(cblk,sptr,spill_loc[sptr->assign]);
				work_needed[sptr->assign]=NEEDS_NOTHING;

				freereg(cblk, sptr);
				sptr->sets = (struct list *) NULL;
				break;

			case TEMP:

				/*
					If the value of the register was spilled to a temporary
					location, then we can go ahead and free up the temporary
					location.
				 */
				freetemp(cblk, sptr);
				rdel(sptr->num, deads);
				break;

			default:
				(void) fprintf(stderr, "vpo (dodeads): register data corrupt\n");
				exit(1);
		}
		if(isRegister(a) || isGlobal(a) || isLocal(a)) a=skiplocOr2(a)+1;
		else a+=3;
	}
}

/*
 * solveconflicts - ensures a consistent register state for all predecessors
 */
void solveconflicts(struct bblock * cblk) {

	register regarray cr, pr;
	struct bblock *fblk;
	struct setlist *sptr;
	struct blist *bptr;
	rlist conflict, deads[MAXXFER];
	int index, rt, rcont, check, change;
	char *c, creg[MAXSTRING], reg[BIGSTRING];


	/*
		There are no conflicts to begin with
	 */
	conflict = rinit();

	/*
		Pointer to register status information of current basic block
	 */
	cr = (regarray) cblk->regstate;

	/*
		If any hardware register is live at the start of the current basic block,
		then mark it as used so that it is not overwritten by a temporary value.
	 */
	reget(cblk->ulist, c = creg);
	while (*c) {
		sptr = s_lookup(c);
		if (sptr->status & HARDWARE) {
			rt = regtype(c);
			index = regtoindex(rt, regnum(c));
			markreg(cblk, sptr, rt, index);
		}
		c = skiplocOr2(c)+1;
	}

	/*
		Search through all of the predecessors of the current basic block
	 */
	for (bptr = cblk->preds; bptr; bptr = bptr->next) {

		/*
			Examine the predecessor if it is not the current basic block and if
			register allocation has been done on it.
		 */
		if (bptr->ptr != cblk && (pr = (regarray) bptr->ptr->regstate)) {

			/*
				Allocate all register items still live from the predecessors
			 */
			for (index = 0; index < MAXREGS; index++) {
				/*
					If a pseudo register is live and the current basic block does
					not have it allocated to the same register as its predecessor,
					then we need to examine it a bit more closely.
				 */
				if (pr->reg[index].status == USED &&
						cr->reg[index].pseudo != (sptr = pr->reg[index].pseudo) &&
						rin(sptr->num, cblk->ulist)) {

					/*
						If it has not yet been assigned to anything in the current
						block, then maybe it just needs an assignment.
					 */
					if (sptr->regstatus == UNASSIGNED) {

						/*
							Check to see if the register will fit in the same place
							that it was allocated to in the predecessor.
						 */
						rt = regtype(sptr->item);
						rcont = contreg(rt);
						for (check = index; rcont--; check++)
							if (cr->reg[check].status != NOTUSED)
								break;

						/*
							If it fits, then go ahead and allocate it to the same
							register, otherwise, add it to the conflict list so that
							it can be resolved later.
						 */
						if (rcont < 0)
							markreg(cblk, sptr, rt, index);
						else {
							rins(sptr->num, &conflict);
							if (cr->reg[index].status == NOTUSED)
								cr->reg[index].status = CONFLICT;
						}
					}

					/*
						If it was already allocated, then there is a definite
						conflict
					 */
					else {
						rins(sptr->num, &conflict);
						if (cr->reg[index].status == NOTUSED)
							cr->reg[index].status = CONFLICT;
					}
				}
			}

			/*
				Allocate all spilled items still live from the predecessors
			 */
			for (index = 0; index < MAXTEMP; index++) {
				if (pr->temp[index].status == USED &&
						cr->temp[index].pseudo != (sptr = pr->temp[index].pseudo) &&
						rin(sptr->num, cblk->ulist)) {
					if (sptr->regstatus == UNASSIGNED) {
						rt = regtype(sptr->item);
						rcont = conttemp(rt);
						for (check = index; rcont--; check++)
							if (cr->temp[check].status != NOTUSED)
								break;
						if (rcont < 0)
							marktemp(cblk, sptr, rt, index);
						else {
							rins(sptr->num, &conflict);
							if (cr->temp[index].status == NOTUSED)
								cr->temp[index].status = CONFLICT;
						}
					}
					else {
						rins(sptr->num, &conflict);
						if (cr->temp[index].status == NOTUSED)
							cr->temp[index].status = CONFLICT;
					}
				}
			}
		}
	}

	/*
		If there are no conflicting items, then we have completed our task, which
		was to set up association links with the register database that are
		consistent with the associations made by all of the predecessors of this
		basic block.
	 */
	if (conflict) {

#ifdef VET
		begin_trans(VET_REQUIRED_TRANS);
#endif
		/*
			Free up every item that is in a conflict
		 */
		reget(conflict, c = creg);
		while (*c) {
			sptr = s_lookup(c);
			if (sptr->regstatus == REGISTER)
				conflictreg(cblk, sptr);
			else if (sptr->regstatus == TEMP)
				conflicttemp(cblk, sptr);
			c = skiplocOr2(c)+1;
		}

		/*
			Allocate all items that were in conflict into items that were not
			implicated in the conflict.
		 */
		c = creg;
		while (*c) {
			sptr = s_lookup(c);
			rt = regtype(c);
			if (fitreg(cblk, cblk->rtls, sptr, rt, &index, &change, FALSE))
				markreg(cblk, sptr, rt, index);
			else if (fittemp(cblk, rt, &index))
				marktemp(cblk, sptr, rt, index);
			else {
				(void) fprintf(stderr, "vpo (solveconflicts): out of temporaries\n");
				exit(1);
			}
			c = skiplocOr2(c)+1;
		}

		/*
			Now free up the items that were implicated in the conflict so that
			they can be used.
		 */
		for (index = 0; index < MAXREGS; index++)
			if (cr->reg[index].status == CONFLICT)
				cr->reg[index].status = NOTUSED;
		for (index = 0; index < MAXTEMP; index++)
			if (cr->temp[index].status == CONFLICT)
				cr->temp[index].status = NOTUSED;

		/*
			Now we must visit each predecessor, and for each item we find where
			the current association does not match that of the predecessor, we
			must generate appropriate transfer RTLs to ensure that the items in
			conflict wind up in the proper locations.
		 */
		for (bptr = cblk->preds; bptr; bptr = bptr->next) {
			pr = (regarray) bptr->ptr->regstate;
			if (pr && bptr->ptr != cblk) {
				fblk = (struct bblock *) NULL;

				/*
					Generate appropriate transfer RTLs to move register conflicts
					into their appropriate locations.
				 */
				for (index = 0; index < MAXREGS; index++) {
					if ((sptr = pr->reg[index].pseudo) && rin(sptr->num, conflict)) {
						rt = regtype(sptr->item);
						if (sptr->regstatus == REGISTER) {
							if (sptr->assign == index)
								continue;
							(void) transfer(reg, deads,
												 REGISTER, rt, indextoreg(rt, sptr->assign),
												 REGISTER, rt, indextoreg(rt, index));
						}
						else
							(void) transfer(reg, deads,
												 TEMP, rt, sptr->assign,
												 REGISTER, rt, indextoreg(rt, index));
						fblk = add_fix_code(bptr->ptr, cblk, fblk, reg, deads);
					}
				}

				/*
					Generate appropriate transfer RTLs to move temporary spill
					locations that are in conflict into appropriate locations.
				 */
				for (index = 0; index < MAXTEMP; index++) {
					if ((sptr = pr->temp[index].pseudo) && rin(sptr->num, conflict)) {
						rt = regtype(sptr->item);
						if (sptr->regstatus == REGISTER)
							(void) transfer(reg, deads,
												 REGISTER, rt, indextoreg(rt, sptr->assign),
												 TEMP, rt, index);
						else {
							if (sptr->assign == index)
								continue;

							/*
								When having to move a temporary location to another
								temporary location, the transfer() routine may indicate
								that the target machine is not capable of doing so
								without using an intermediate register.  If that is the
								case, then we will have to do some work in order to
								ensure that we can provide a register to help perform
								the transfer.
							 */
							if (!transfer(reg, deads, TEMP, rt, sptr->assign,
										TEMP, rt, index)) {

								/*
									If we can locate a free register in the current
									basic block, then we can go ahead and use it to
									transfer the item.
								 */
								if (find_unused_register(cblk, rt, &check)) {
									(void) transfer(reg, deads,
														 REGISTER, rt, indextoreg(rt, check),
														 TEMP, rt, index);
									fblk = add_fix_code(bptr->ptr, cblk, fblk, reg, deads);
									(void) transfer(reg, deads,
														 TEMP, rt, sptr->assign,
														 REGISTER, rt, indextoreg(rt, check));
								}
								else
									(void) fprintf(stderr,
														"vpo (solveconflicts): cannot transfer temporary\n");
							}
						}
						fblk = add_fix_code(bptr->ptr, cblk, fblk, reg, deads);
					}
				}
			}
		}
#ifdef VET
		end_trans();
#endif
	}

	/*
		Release the temporary conflict vector
	 */
	rfree(conflict);
}

/*
 * loopconflicts - fix up any loop conflicts between two basic blocks
 */
void loopconflicts(struct bblock * from, struct bblock * to) {

   register regarray fv, tv;
   struct bblock *fblk;
   struct setlist *sptr, *bptr;
   rlist deads[MAXXFER];
   int index, find, found, check, rcont, rt, reload;
   int sfound, sfind, srt=-1, scont, sfree, sskip, savl;
   char reg[BIGSTRING];
  
#ifdef VET
    begin_trans(VET_REQUIRED_TRANS);
#endif
   fv = (regarray) from->regstate;
   tv = (regarray) to->elist;
   fblk = (struct bblock *) NULL;

   /*
      Look at the items that are allocated to hardware registers in the block
      that we are going to transfer control to.
   */
   for (index = 0; index < MAXREGS; index++) {
      if (sptr = tv->reg[index].pseudo) {

	 /*
	    Attempt to locate the item in our current allocation list.  First,
	    try to see if it is allocated to a register.
	 */
	 found = FALSE;
	 for (find = 0; find < MAXREGS; find++) {
	    if (sptr == fv->reg[find].pseudo) {
	       found = TRUE;

	       /*
	          If all goes well, it should be allocated to the same hardware
	          register, in which case there is no need for us to do
	          anything.
	       */
	       if (index == find)
		  break;

	       /*
	          If we get here, we ran out of luck, so we have to insert some
	          code to get the item from the register that it is mapped to
	          in the current block to the one that it will go to in the
	          destination block.  The first thing we will try is to see if
	          can move the register value from where it is to where we need
	          it directly.
	       */
	       rt = regtype(sptr->item);
	       rcont = contreg(rt);
	       for (check = index; rcont--; check++) {
		  if (fv->reg[check].status != NOTUSED) {

		     /*
		        There is a value in this slot that must be moved
		        elsewhere.  We will attempt to spill it, but we will
		        first scan to see if there is a particular spill
		        location for this item that would fix things up
		        perfectly.
		     */
		     bptr = fv->reg[check].pseudo;
		     srt = regtype(bptr->item);
		     sfound = FALSE;
		     for (sfind = 0; sfind < MAXTEMP; sfind++) {
			if (bptr == tv->temp[sfind].pseudo) {

			   /*
			      We have located a spill location where the
			      register that is blocking our progress should be
			      moved to, so we determine if there is anything
			      impeding us from spilling the item to that
			      location so that we can continue.
			   */
			   scont = conttemp(srt);
			   for (sfree = sfind; scont--; sfree++)
			      if (fv->temp[sfree].status != NOTUSED)
				 break;

			   if (scont < 0) {
			      fv->reg[check].pseudo = (struct setlist *) NULL;
			      scont = contreg(srt);
			      for (sfree = check; scont--; sfree++)
				 fv->reg[sfree].status = NOTUSED;

			      fv->temp[sfind].pseudo = bptr;
			      fv->temp[sfree = sfind].status = USED;
			      scont = conttemp(srt);
			      while (--scont)
				 fv->temp[++sfree].status = FOLLOWER;

			      (void) transfer(reg, deads, TEMP, srt, sfind,
				       REGISTER, srt, indextoreg(srt, check));
			      fblk = add_fix_code(from, to, fblk, reg, deads);

			      sfound = TRUE;
			   }
			   break;
			}
		     }

		     /*
		        If we where not able to locate the final place to store
		        the register item that is blocking our progress, then
		        we look for a spill location that will not block
		        anything if it is used.
		     */
		     if (!sfound) {
			savl = availtemp(srt);
			sskip = skiptemp(srt);
			for (sfind = firsttemp(srt); savl--; sfind += sskip) {
			   scont = conttemp(srt);
			   for (sfree = sfind; scont--; sfree++)
			      if (tv->temp[sfree].status != NOTUSED ||
				  fv->temp[sfree].status != NOTUSED)
				 break;

			   /*
			      If we have located a suitable spill location,
			      then we go ahead and move the blocking register
			      to that spill location, knowing that we will have
			      to move it to some other location later on in
			      this same function.
			   */
			   if (scont < 0) {
			      fv->reg[check].pseudo = (struct setlist *) NULL;
			      scont = contreg(srt);
			      for (sfree = check; scont--; sfree++)
				 fv->reg[sfree].status = NOTUSED;

			      fv->temp[sfind].pseudo = bptr;
			      fv->temp[sfree = sfind].status = USED;
			      scont = conttemp(srt);
			      while (--scont)
				 fv->temp[++sfree].status = FOLLOWER;

			      (void) transfer(reg, deads, TEMP, srt, sfind,
				       REGISTER, srt, indextoreg(srt, check));
			      fblk = add_fix_code(from, to, fblk, reg, deads);

			      sfound = TRUE;
			      break;
			   }
			}
		     }

		     /*
		        If we have failed to locate an appropriate spill
		        location in both instances, then we exit this loop in
		        failure.
		     */
		     if (!sfound)
			break;
		  }
	       }

	       /*
	          If we have not been able to clear out the way for the item,
	          then we have run out of temporary locations that are not
	          affected by either the from or to blocks.
	       */
	       if (rcont >= 0)
		  (void) fprintf(stderr, "vpo (loopconflicts): need to spill\n");

	       /*
	          Free up the register that holds the value that we are moving
	       */
	       fv->reg[find].pseudo = (struct setlist *) NULL;
	       rcont = contreg(rt);
	       for (check = find; rcont--; check++)
		  fv->reg[check].status = NOTUSED;

	       /*
	          Mark the new register assignment that we have just made
	       */
	       fv->reg[index].pseudo = sptr;
	       fv->reg[check = index].status = USED;
	       rcont = contreg(rt);
	       while (--rcont)
		  fv->reg[++check].status = FOLLOWER;

	       /*
	          Generate the code required to transfer the register to its
	          appropriate location.
	       */
	       (void) transfer(reg, deads, REGISTER, rt, indextoreg(rt, index),
			       REGISTER, rt, indextoreg(rt, find));
	       fblk = add_fix_code(from, to, fblk, reg, deads);
	       break;
	    }
	 }

	 /*
	    If the register value was not among any of the registers, then we
	    look for it among the spill locations.
	 */
	 if (!found) {
	    for (find = 0; find < MAXTEMP; find++) {
	       if (sptr == fv->temp[find].pseudo) {

		  /*
		     In this case, the value get need in a register exists in a
		     temporary memory location.  We must generate code to move
		     that value into the appropriate register.  The first thing
		     we will try is to see if can move the register value from
		     where it is to where we need it directly.
		  */
		  rt = regtype(sptr->item);
		  rcont = contreg(rt);
		  for (check = index; rcont--; check++) {
		     if (fv->reg[check].status != NOTUSED) {

			/*
			   There is a value in this slot that must be moved
			   elsewhere.  We will attempt to spill it, but we will
			   first scan to see if there is a particular spill
			   location for this item that would fix things up
			   perfectly.
			*/
			bptr = fv->reg[check].pseudo;
			srt = regtype(bptr->item);
			sfound = FALSE;
			for (sfind = 0; sfind < MAXTEMP; sfind++) {
			   if (bptr == tv->temp[sfind].pseudo) {

			      /*
			         We have located a spill location where the
			         register that is blocking our progress should
			         be moved to, so we determine if there is
			         anything impeding us from spilling the item to
			         that location so that we can continue.
			      */
			      scont = conttemp(srt);
			      for (sfree = sfind; scont--; sfree++)
				 if (fv->temp[sfree].status != NOTUSED)
				    break;

			      if (scont < 0) {
				 fv->reg[check].pseudo = (struct setlist *) NULL;
				 scont = contreg(srt);
				 for (sfree = check; scont--; sfree++)
				    fv->reg[sfree].status = NOTUSED;

				 fv->temp[sfind].pseudo = bptr;
				 fv->temp[sfree = sfind].status = USED;
				 scont = conttemp(srt);
				 while (--scont)
				    fv->temp[++sfree].status = FOLLOWER;

				 (void) transfer(reg, deads, TEMP, srt, sfind,
				       REGISTER, srt, indextoreg(srt, check));
				 fblk = add_fix_code(from, to, fblk, reg, deads);

				 sfound = TRUE;
			      }
			      break;
			   }
			}

			/*
			   If we where not able to locate the final place to
			   store the register item that is blocking our
			   progress, then we look for a spill location that
			   will not block anything if it is used.
			*/
			if (!sfound) {
			   savl = availtemp(srt);
			   sskip = skiptemp(srt);
			   for (sfind = firsttemp(srt); savl--; sfind += sskip) {
			      scont = conttemp(srt);
			      for (sfree = sfind; scont--; sfree++)
				 if (tv->temp[sfree].status != NOTUSED ||
				     fv->temp[sfree].status != NOTUSED)
				    break;

			      /*
			         If we have located a suitable spill location,
			         then we go ahead and move the blocking
			         register to that spill location, knowing that
			         we will have to move it to some other location
			         later on in this same function.
			      */
			      if (scont < 0) {
				 fv->reg[check].pseudo = (struct setlist *) NULL;
				 scont = contreg(srt);
				 for (sfree = check; scont--; sfree++)
				    fv->reg[sfree].status = NOTUSED;

				 fv->temp[sfind].pseudo = bptr;
				 fv->temp[sfree = sfind].status = USED;
				 scont = conttemp(srt);
				 while (--scont)
				    fv->temp[++sfree].status = FOLLOWER;

				 (void) transfer(reg, deads, TEMP, srt, sfind,
				       REGISTER, srt, indextoreg(srt, check));
				 fblk = add_fix_code(from, to, fblk, reg, deads);

				 sfound = TRUE;
				 break;
			      }
			   }
			}

			/*
			   If we have failed to locate an appropriate spill
			   location in both instances, then we exit this loop
			   in failure.
			*/
			if (!sfound)
			   break;
		     }
		  }

		  /*
		     If we have not been able to clear out the way for the
		     item, then we have run out of temporary locations that are
		     not affected by either the from or to blocks.
		  */
		  if (rcont >= 0)
		     (void) fprintf(stderr, "vpo (loopconflicts): need to spill\n");

		  /*
		     Free up the temporary location that holds the value that
		     we are moving.
		  */
		  fv->temp[find].pseudo = (struct setlist *) NULL;
		  rcont = conttemp(rt);
		  for (check = find; rcont--; check++)
		     fv->temp[check].status = NOTUSED;

		  /*
		     Mark the new register assignment that we have just made
		  */
		  fv->reg[index].pseudo = sptr;
		  fv->reg[check = index].status = USED;
		  rcont = contreg(rt);
		  while (--rcont)
		     fv->reg[++check].status = FOLLOWER;

		  /*
		     Generate the code required to transfer the register to its
		     appropriate location.
		  */
		  (void) transfer(reg, deads, REGISTER, rt, indextoreg(rt, index),
				  TEMP, rt, find);
		  fblk = add_fix_code(from, to, fblk, reg, deads);
		  break;
	       }
	    }
	 }
      }
   }

   /*
      Look at the items that are allocated to spill locations in the block that
      we are going to transfer control to.
   */
   for (index = 0; index < MAXTEMP; index++) {
      if (sptr = tv->temp[index].pseudo) {

	 /*
	    Attempt to locate the item in our current allocation list.  First,
	    try to see if it is allocated to a temporary spill location.
	 */
	 found = FALSE;
	 for (find = 0; find < MAXREGS; find++) {
	    if (sptr == fv->temp[find].pseudo) {
	       found = TRUE;

	       /*
	          If all goes well, it should be allocated to the same
	          temporary location, in which case there is no need for us to
	          do anything.
	       */
	       if (index == find)
		  break;

	       /*
	          First thing that we need to do is grab an appropriate
	          register. We try first to find an unused one.
	       */
	       rt = regtype(sptr->item);
	       savl = availreg(rt);
	       sskip = skipreg(rt);
	       for (check = firstreg(rt); savl--; check += sskip) {
		  rcont = contreg(rt);
		  for (sfind = check; rcont--; sfind++)
		     if (tv->reg[check].status != NOTUSED)
			break;
		  if (rcont < 0)
		     break;
	       }

	       /*
	          Failing that, we comandeer the first register available,
	          spill its value so that we can use the register to move spill
	          values around and then we will end up re-loading the spilled
	          value.
	       */
	       reload = FALSE;
	       if (savl < 0) {
		  rcont = contreg(rt);
		  for (check = firstreg(rt); rcont--; check++) {
		     if (tv->reg[check].status == USED) {
			bptr = tv->reg[check].pseudo;
			srt = regtype(bptr->item);
			savl = availtemp(srt);
			sskip = skiptemp(srt);
			for (sfind = firsttemp(srt); savl--; sfind += sskip) {
			   scont = conttemp(srt);
			   for (sfree = sfind; scont--; sfree++)
			      if (tv->temp[sfree].status != NOTUSED ||
				  fv->temp[sfree].status != NOTUSED)
				 break;
			   if (scont < 0)
			      break;
			}

			/*
			   Spill the items required to obtain the items that we
			   need
			*/
			if (savl >= 0) {
			   (void) transfer(reg, deads, TEMP, srt, bptr->uses = sfind,
				       REGISTER, srt, indextoreg(srt, check));
			   fblk = add_fix_code(from, to, fblk, reg, deads);
			   break;
			}
			else
			   (void) fprintf(stderr,
				      "vpo (loopconflicts): need to spill\n");
		     }
		  }

		  check = firstreg(rt);
		  reload = TRUE;
	       }

	       /*
	          Load the register with the temporary value from the "from"
	          block.
	       */
	       (void) transfer(reg, deads, REGISTER, rt, indextoreg(rt, check),
			       TEMP, rt, find);
	       fblk = add_fix_code(from, to, fblk, reg, deads);

	       /*
	          Store the register in the spill location required by the "to"
	          block.
	       */
	       (void) transfer(reg, deads, TEMP, rt, index,
			       REGISTER, rt, indextoreg(rt, check));
	       fblk = add_fix_code(from, to, fblk, reg, deads);

	       /*
	          If we had to spill items to get a free register, then put
	          them back.
	       */
	       if (reload) {
		  rcont = contreg(rt);
		  for (check = firstreg(rt); rcont--; check++) {
		     if (tv->reg[check].status == USED) {
			bptr = tv->reg[check].pseudo;
			srt = regtype(bptr->item);
			(void) transfer(reg, deads,
					REGISTER, srt, indextoreg(srt, check),
					TEMP, srt, bptr->uses);
			fblk = add_fix_code(from, to, fblk, reg, deads);
		     }
		  }
	       }
	    }
	 }

	 if (!found)
	    (void) fprintf(stderr, "vpo (loopconflicts): spill mismatch\n");
      }
   }
#ifdef VET
    end_trans();
#endif
}

/*
 * add_fix_code - add new transfer RTLs to perform a fix
 */
struct bblock *add_fix_code(struct bblock * from, struct bblock * to, struct bblock * cblk, register char *new, rlist * deads) {

   register struct list *iptr;
  
  
   /*
      If we don't already have a suitable block to insert the transfer RTLs
      into, then either find a suitable one or create one.
   */
   if (!cblk)
      cblk = add_fix_block(from, to);

   /*
      Add new transfer RTLs at end of block.  Be sure to place them in front of
      any jump that may exist at the end of the block.
   */
   iptr = (cblk->status & JUMP || cblk->right) ? cblk->rtlend :
    (struct list *) NULL;

   /*
      This mechanism supports adding multiple RTLs to a block.  The RTLs are
      passed in as a single string separated by a single '\0', the end of the
      list is delimited by two consecutive '\0's.
   */
   while (*new) {
      (void) add_rtl(cblk, iptr, new, *deads++);
      while (*new++);
   }

   /*
      Return a pointer to the basic block that the fix code was added to
   */
   return (cblk);
}

/*
 * save_entry - save a copy of the entry state of the assignment vector
 */
void save_entry(struct bblock * cblk) {

   register regarray fv, tv;
   register int index;
   regvec copyreg;
 

   copyreg = reginit();
   initassign(&copyreg);
   fv = (regarray) cblk->regstate;
   tv = (regarray) copyreg;
   for (index = 0; index < MAXREGS; index++)
      tv->reg[index] = fv->reg[index];
   for (index = 0; index < MAXTEMP; index++)
      tv->temp[index] = fv->temp[index];
   cblk->elist = (struct eqvtable *) copyreg;
}

/*
 * initassign - initialize a register assignment vector for a basic block
 */
void initassign(regvec * regstate) {

   register regarray cr;
   register int index;

   if (!(cr = (regarray) * regstate))
      cr = (regarray) (*regstate = (regvec) SALLOC(sizeof(reginfo)));
   for (index = 0; index < MAXREGS; index++) {
      cr->reg[index].status = NOTUSED;
      cr->reg[index].pseudo = (struct setlist *) NULL;
   }
   for (index = 0; index < MAXTEMP; index++) {
      cr->temp[index].status = NOTUSED;
      cr->temp[index].pseudo = (struct setlist *) NULL;
   }
}

/*
 * unassociate - remove all pointers from pseudo registers left alive
 */
void unassociate(struct bblock * cblk) {

   register regarray cr;
   register struct setlist *sptr;
   register int index;

   cr = (regarray) cblk->regstate;
   for (index = 0; index < MAXREGS; index++)
      if (sptr = cr->reg[index].pseudo) {
	 sptr->regstatus = UNASSIGNED;
	 sptr->assign = 0;
      }
   for (index = 0; index < MAXTEMP; index++)
      if (sptr = cr->temp[index].pseudo) {
	 sptr->regstatus = UNASSIGNED;
	 sptr->assign = 0;
      }
}

/*
 * savregs - save used registers before a procedure call
 */
void savregs(struct bblock * cblk, struct list * ptr, int *change) {

   register regarray cr;
   register int i;
   register char *a;
   struct list *cptr;
   int rt, rcont;

   hascs = TRUE;

   /*
      The caller-saves line is always placed following the call, in order to
      ensure that any items used and dead at the call site are not spilled
      needlessly.  The spills themselves, must be placed before the call,
      therefore, we must back up and look for the call RTL.
   */
   for (cptr = ptr->prev; cptr != NULL; cptr = cptr->prev)
      if (cptr->type & RTLINE && cptr->val != NULL && is_call(cptr->val))
         break;
   /*
      For each register indicated in the caller-saves line, we determine if
      that register is allocated to any pseudo-register and, if it is, we spill
      that pseudo-register so that the caller-saves register is no longer live
      at this point.
   */
   cr = (regarray) cblk->regstate;
   for (a = ptr->val; *a; a = skiplocOr2(a)) 
   {
	if(isRegister(a))
      	{
		rt = regtype(a);
      		i = regtoindex(rt, regnum(a));
      		for (rcont = contreg(rt); rcont--; i++) 
		{
	 		if (cr->reg[i].status != NOTUSED) 
			{
	    			while (cr->reg[i].status == FOLLOWER)
	       				i--;
	    			spillreg(cblk, cptr, i, TRUE);
	    			*change = TRUE;
			}
	 	}
      	}
   }
}

/*
 * assoc - change pseudo register into corresponding hardware register
 */
void assoc(struct bblock * cblk, struct list * ptr, char *item, int *change, int dest) {

   register struct setlist *sptr;
   register int rt;
  
   sptr = s_add(item);
   rt = regtype(item);
   makerg(item, rt, gtreg(cblk, ptr, sptr, rt, change, dest));
   sptr->sets = (dest) ? ptr : (struct list *) NULL;
}

/*
 * reserve - assign a particular hardware value to a pseudo-register
 */
struct list *reserve(struct bblock * cblk, struct list * ptr, int *change) {

   register struct setlist *sptr, *pptr;
   register int rt;
   register regarray cr;
   rlist *deads, deadlist[MAXXFER];
   int rnum, find, conflict[MAXREGS];
   char *a, new[BIGSTRING];
#ifdef INTERACT
   char oldval[MAXSTRING];
#endif

 
   /*
      Start by reserving the hardware register value to itself
   */
   rt = regtype(ptr->val);
   pptr = s_add(ptr->val);
   sptr = s_add(skiploc(ptr->val) + 1);
   rnum = gtreg(cblk, ptr, sptr, rt, change, FALSE);

   /*
    * If sptr->item is not dead in this rtl, it's likely going to cause mental issues
    * because the optimizer assumes that the RES line looks like:
    *		rr[34]=r[0]	r[0]
    *  If r[0] is marked dead somewhere else, it'll likely not be removed and an extraneous
    * death will likely cause the optimizer to go nutty. 
    */
   if(!rexists(sptr->item,ptr->deads))
   {
	 (void) fprintf(stderr, "vpo (reserve): register death missing near:\n");
	 show_rtl(stderr,ptr->val);
	 fflush(stderr);
	 exit(1);
   }

   /*
      Modify the reserve line to indicate which register value is reserved.
   */
#ifdef INTERACT
	strcpy(oldval,ptr->val);
#endif
   makerg(ptr->val, rt, rnum);
   *(skiploc(ptr->val)) = '\0';
#ifdef VET
#ifdef INTERACT
	mod_res(ptr, oldval, ptr->val);
#else 
	mod_res(ptr);
#endif
#endif
   sptr->sets = (struct list *) NULL;

   /*
      If the source and destination registers are the same, then we have done
      everything that is required.
   */
   if (pptr == sptr)
      return (ptr);

   /*
      Ensure that the hardware register that we are allocating the
      pseudo-register to is available over the life of the pseudo- register.
      Otherwise, we will have to locate a more suitable register and transfer
      the value to it.
   */
   if (isused[sptr->assign]) {
      conflicts(ptr, pptr->item, conflict, TRUE, NULL);
      if (conflict[sptr->assign]) {
	 find = gtreg(cblk, ptr, pptr, rt, change, TRUE);
	 deads = deadlist;
	 a = new;
	 (void) transfer(a, deads, REGISTER, rt, find, REGISTER, rt, rnum);
	 while (*a) {
	    pptr->sets = add_rtl(cblk, ptr->next, a, *deads++);
	    while (*a++);
	 }
	 freereg(cblk, sptr);
	 return (pptr->sets);
      }
   }

   cr = (regarray) cblk->regstate;

   /* 
    * if pptr->item was previously assigned to a hardware reg,
    * the value in that reg is dead.  We need to dis-associate
    * that value becuase otherwise when we see a set of that 
    * hardware reg, it'll be spilled
    * Here's an example from x86 code:

		r[17]=L[r[16]] r[16]
		...
		L[r[14]]=r[17]
		r[16]=GLO[25]
		ST=r[16]       r[16]
		...
		r[17]=r[0]     r[0]
		Rr[17]
		...
		L[r[18]]=r[17] r[18]r[17]
		...
		r[8]=r[16]     r[16]


	In this example, r[17] in the first rtl was assigned to r[8].
	The reserve line failed to "clear" the pseudo/status fields for
	r[8] when it changed the mapping of r[17] from r[8] to r[0].
	Later, when r[8] was needed as a hardware reg, it spilled r[17]
	(which is really in r[0]) and all hell broke lose after that.
    */

	if(pptr->regstatus==REGISTER)
	{
		freereg(cblk,pptr);
	}
	/* 
	 * Likewise, if pptr->regstatus indicates that the reg is spilled, 
	 * free up the spill location 
	 */
	else if(pptr->regstatus==TEMP)
	{
		freetemp(cblk,pptr);
	}



   /*
      Swap the pseudo-register value and the harware register value
   */
   pptr->regstatus = sptr->regstatus;
   pptr->assign = sptr->assign;
   cr->reg[sptr->assign].pseudo = pptr;
   sptr->regstatus = UNASSIGNED;
   pptr->sets = (struct list *) NULL;
   return (ptr);
}

/*
 * gtreg - return hard register number to associate with pseudo register
 */
int gtreg(struct bblock * cblk, struct list * ptr, struct setlist * sptr, int rt, int *change, int dest) {

	register int index, find, pt;
	struct setlist *pptr;
	char reg[REGSTRING];


	/*
		Determine the current status of the pseudo-register to take the action
		required to return the hardware register mapping for this pseudo-
		register.
	 */
	switch (sptr->regstatus) {

		case UNASSIGNED:

			/*
				If the pseudo-register type belongs to a group, then start with the
				first register type in the group and make a suitable slot which can
				contain all of the registers in the group.  Then, place each item
				in the group into its appropriate slot separately.
			 */
			if ((pt = headgroup(rt)) >= 0) {
				makerg(reg, pt, regnum(sptr->item));
				pptr = s_lookup(reg);
				index = find = findreg(cblk, ptr, sptr, pt, change, dest,FALSE);
				index += contreg(pt);
				while ((pt = nextgroup(pt)) >= 0) {
					makerg(reg, pt, regnum(sptr->item));
					pptr = s_lookup(reg);
					if (sptr == pptr)
						find = index;
					markreg(cblk, pptr, pt, index);
					index += contreg(pt);
				}
				return (indextoreg(rt, find));
			}

			/*
				Allocate a non-group pseudo-register to a hardware register by
				finding (or making) a suitable slot for it.
			 */
			find = findreg(cblk, ptr, sptr, rt, change, dest,FALSE);
			return (indextoreg(rt, find));

		case REGISTER:
			{
				register regarray cr;
				cr = (regarray) cblk->regstate;
				if (dest) { 
					/* This happens only if we have seen a use of this pseudo register in this rtl. */
					if (work_needed[sptr->assign]==NEEDS_FREE) {

						/* first free up the spill location. We cant use freetemp() straight away
							because, it expects sptr->assign to be pointing to the spill location,
							whereas in this case it is actually pointing to a hw reg. */

						freetemp_index(cblk,sptr,spill_loc[sptr->assign]);
						work_needed[sptr->assign]=NEEDS_SPILL;
					}
				}

				/*
					If this pesudo-register is already allocated to a hardware
					register, then return the hardware register mapping.
				 */
				return (indextoreg(rt, sptr->assign));
			}

		case TEMP:

			/*
				If this pseudo-register is currently spilled, then load it up from
				memory into an appropriate hardware register and return the new
				hardware register mapping.
			 */
			if(dest)
			{
				/* if we're redefining a spilled psuedo, we don't need to 
				 * reload, so we simply free the temp location first so we don't reassign
				 */
				freetemp(cblk,sptr);
			}
			find = findreg(cblk, ptr, sptr, rt, change, dest,TRUE);
			return (indextoreg(rt, find));

		default:

			/*
				Something has gone wrong if we get here
			 */
			(void) fprintf(stderr, "vpo (gtreg): register data corrupt\n");
			exit(1);
	}

	/* unreachable, but necessary so compiler doesn't complain (especially lcc) */
	assert(0);
	return (0);
}

/* 
	find_victim_register -  finds a register to spill by searching for a register that is not in the
	conflict list passed to this function, and with the least cost.
	If we are hard_pressed, then it is ok to return a hw register that is live-in, or a hw register that
	has a u-line associated with it in the life of the pseudo register. This is because in findreg() we
	assign this hw reg to the pseudoreg, for the given rtl, and spill it immediately after this rtl.
*/
int find_victim_register(struct bblock * cblk, struct list * ptr, struct setlist * sptr, int rt, int dest, int *conflict, int hard_pressed) 
{
	register regarray cr;
	register int find, loop;
	long cost, check, dist;
	int index, ravl, rskip, rcont, end;
	char reg[REGSTRING];
	/*
		The algorithm that determines which register to spill is cost-driven. The
		basic idea is to spill the register that costs the least to spill and
		will be needed again as far off into the future as possible.
	 */
	cr = (regarray) cblk->regstate;
	ravl = availreg(rt);
	rskip = skipreg(rt);
	rcont = allocreg(rt);
	cost = 0L;
	for (find = index = firstreg(rt); ravl--; find += rskip) {
		end = rcont;

		/*
			If we start "halfway" into a group of allocated registers, back up and
			find the pseudo-register that straddles them all.
		 */
		if (cr->reg[find].status == FOLLOWER) {
			/*
				Back up to find the "start" of the register that we are on. This is
				a special case that allows us to estimate the cost of spilling the
				first item that may be in the way.
			 */
			for (loop = find - 1; cr->reg[loop].status == FOLLOWER; loop--);

			/*
				Now let's find the place where this register is used next and
				calculate a spill cost based on how far away the next use is and
				how large the register is.  If the item will be used in the very
				RTL that we need to spill for, then we cannot make use of the item
				and must continue on to the next one.
			 */
			sptr = cr->reg[loop].pseudo;
			/* note that if a hw reg is live in, it is assigned to itself. 
			 (in solve_conflicts()). Also a hw reg gets assigned to itself, if
			 it is used directly in an rtl (like r[0]=r[0]+r[32];). */
			if(!pseudoreg(sptr->item) && !hard_pressed)
			{
				/* if we are not hard pressed for a reg, then dont even THINK of 
					returning live in registers */
				check=0L;
			}
			else
			{
				/* Can't assign a hw reg that is already in use in this very rtl. */
				if (!(dist = distance(ptr, sptr->item)))
					continue;
				dist /= contreg(regtype(sptr->item));
				check = (dist) ? dist : 1L;
			}
		}
		else
			check = 0L;

		/*
			Check to see if we have to spill more than one item in order to make
			room for this item.  The costs of spilling add up.
		 */
		for (loop = find; end--; loop++) {

			/*
				If this item will be needed sometime before the register that we
				want to assign it to dies, then we cannot use this item.
			 */
			if (isused[loop] && conflict[loop]) {
				check = 0L;
				break;
			}

			/*
				If this item is currently holding a real register value, then we
				calculate the cost of using it.
			 */
			else if (cr->reg[loop].status == USED) {
				char *c;
				sptr = cr->reg[loop].pseudo;

				/* if it's assigned to a pseudo-reg we can spill it.  otherwise
					it had a useline, and it's *not* safe to spill it */

				/* note that if a hw reg is live in, it is assigned to itself. 
					(in solve_conflicts()). Also a hw reg gets assigned to itself, if
					it is used directly in an rtl (like r[0]=r[0]+r[32];). The next
					test will catch the second case. (ie: the reg is being used in this
					same rtl). */
				if(!hard_pressed && !pseudoreg(sptr->item))
				{
				/* if we are not hard pressed for a reg, then dont even THINK of 
					returning live in registers */
					check = 0L;
					break;
				}

				/*
					If the register will be used in the very RTL that we need to
					spill for, then we obviously cannot make use of this item.
				 */
				if (!(dist = distance(ptr, sptr->item))) {
					check = 0L;
					break;
				}

				/*
					Otherwise, it may be the case that the register has already been
					allocated and modified in the RTL, so we check to see if the
					hardware register that it is currently assigned to is used in
					the RTL that we are spilling for.
				 */
				else if (!dest) 
				{
					makereg(reg, rt, indextoreg(rt, loop));
					if (isaliasref(ptr->val, reg)) {
						check = 0L;
						break;
					}
				}
				else if (dest) 
				{
					makereg(reg, rt, indextoreg(rt, loop));
					if (isaliasset(ptr->val, reg)) {
						check = 0L;
						break;
					}
				}

				dist /= contreg(regtype(sptr->item));
				check += ((dist) ? dist : 1);
			}

			/*
				If this slot is currenty empty, then we want to make it as
				attractive to spill as possible.
			 */
			else if (cr->reg[loop].status == NOTUSED)
				check += 10L;
		}

		/*
			Remember the items that are best to spill
		 */
		if (check > cost) {
			cost = check;
			index = find;
		}
	}
	if (!cost) return -1;
	return index;
}


/*
 * findreg - find a free hardware register of the appropriate type
 */
int findreg(struct bblock * cblk, struct list * ptr, struct setlist * sptr, int rt, int *change, int dest, int istemp) {

	register regarray cr;
	register int find;
	long cost, check, dist;
	int index, rcont, conflict[MAXREGS],real_conflicts[MAXREGS];
	int retain_spill_location=0;

			
	cr = (regarray) cblk->regstate;

	/*
		First, try to find an unallocated register to allocate to the
		pseudo-register.  If we find one, then we are done.
	 */
	if (fitreg(cblk, ptr, sptr, rt, &index, change, dest)) {
		work_needed[index]=NEEDS_NOTHING;
		if (!dest && istemp) loadreg(cblk, ptr, sptr, rt, index,FALSE);
		else markreg(cblk, sptr, rt, index);
		return (index);
	}

	/*
		If we get here, then there are no unallocated registers that can be
		allocated to the new pseudo-register, so we have to start considering
		spilling somebody.  Start by getting the allocation parameters for the
		required type of register.
	 */
	conflicts(ptr, sptr->item, conflict, dest,real_conflicts);

	index=find_victim_register(cblk,ptr,sptr,rt,dest,conflict,0);


	/*
		If we cannot locate any suitable registers to spill, it must mean that
		this RTL requires more registers to execute that there are registers to
		allocate.
	 */
	/****************************************************************************
	  At this point, we have found that there is no "suitable" place
	  to put the destination register.  One reason might be because 
	  all the available registers have a "use" line before this
	  register dies (Conflict says that any use line makes the register
	  specified unsuitable for use across that point).
	  We could get around that by looking for a register to assign,
	  knowing that we will immediately spill the register.
	  Here is an example:


	  d[32]=d[0]	d[0]

	  .
	  ud[0]
	  ud[1]
	  ud[2]
	  ud[3]		# all D registers explicitly marked as used 
	  ud[4]
	  ud[5]
	  ud[6]
	  .

	  d[0]=d[32]	d[32]

	  here, we'll get a "too many registers" error because it can't
	  find a place to put d[32].  Instead, it could choose a register,
	  and assign d[32] to it, then immediately spill the register:


	  d[0]=d[0] 	
	  D[r[11]+SP[0]]=d[0]	d[0]

	.
		ud[0]
		ud[1]
		ud[2]
		ud[3]           # all D registers explicitly marked as used 
		ud[4]
		ud[5]
		ud[6]
		.

		d[0]=D[r[11]+SP[0]]
		d[0]=d[0]      

		This should generate correct code and hopefully CSE or the
		combiner can put together the unnecessary spills.  

		*****************************************************************************/

	rcont = allocreg(rt);

	/* comes here because we couldnt' find a free hw register. Next in line are
		non-conflicting registers, and last try - conflicting regs. */
	if (index!=-1) {
		/* we found a non-conflicting non-free register. Spill it, so
			that we can reuse that hw reg for this pseudo. */
		work_needed[index]=NEEDS_NOTHING;
		retain_spill_location=FALSE;
	} else {
		/* Couldnt find a non-conflicting register, so try to find a conflicting register.
			But if we are going to use a conflicting register, then make sure to free
			up that hw register right after this rtl. A hw register conflicts with a pseudo
			if there is a use line for this hw reg in the life-time of this pseudo.

			For uses of this pseudo in this rtl, just load the pseudo register from the 
			spill location into the conflicting hw reg.  But don't free up that spill 
			loc. Instead use the hw reg for this one rtl, and retain the association
			between the pseudo and the hw reg till this rtl is processed (because there 
			may be more references to the same pseudo reg in this rtl.)
		  	Once the rtl is emitted, reset the status fields and disassociate the 
			pseudo and the hw reg, thus freeing up the hw reg. (but we don't emit any
			spills because the value in the pseudo reg has not been changed). Reassociate
			this pseudo with the temp location in which it's value is present.

			Now for defs of a pseudo reg in this rtl, emit a spill right after this rtl. This
			spill would save the new value of that pseudo and also free up the hw reg.

			Implementation: Two static arrays work_needed[] and spill_loc[] are used. 
			When a pseudo is assigned
			to a free or non-conflicting hw reg, the work_needed[index] is set to NEEDS_NOTHING.
			(think of work_needed[index] as a field associated with hw reg index)
			
			If the pseudo is assigned to a conflicting hw reg {
				if it is a use {
					mark the 'work_needed' field of that hw reg to be NEEDS_FREE. Save the
					spill location (it will be overwritten when the pseudo is associated with the hw reg
					using markreg()), so that after processing the rtl, we can reassociate the pseudo
					with this spill loc.
					retain_spill_location=TRUE; < for loadreg() >
				} else if it is a set then {
					This has to be a set without a use because otherwise, we wouldnt have reached this
					part of the code in the first place. 
					(gtreg() would return straightaway if it finds that a pseudo has already been
					assigned a hw reg.)
					hwreg->work_needed=NEEDS_SPILL;
					Also don't bother to do a loadreg.
				}
			}
			
			<make the association between the pseudo and the hw reg. Load the value of the pseudo if
			 this is a use>	
			if (istemp && !dest) loadreg(cblk, ptr, sptr, rt, index,retain_spill_location);
			else markreg(cblk, sptr, rt, index); 


			example 1 - a reg appears as a use alone

			r[32]=r[32]+r[33]
			r[32] is already assigned r[0], but r[33] doesnt have any non-conflicting hw regs that it can
			be assigned. So the local_reg_assigner searches for the first hw reg of the required type, that
			doesnt already appear in this same rtl. Let r[2] be that hw reg.
			So we just assign it r[2], but have to make sure that r[2] is made free right after
			this rtl is processed.
			Since there is a use of r[33], we emit a load -
			SL[2]=r[2]			(save r[2]'s current value)
									(r[33] is in spill SL[0])
			r[2]=SL[0]			(dont free up SL[0] here, just associate r[33] to r[2], and mark it NEEDS_FREE)
			r[0]=r[0]+r[2]
			reassociate r[33] to SL[0], free up r[2]. (no need to emit any rtls) <-- NEEDS_FREE


			example 2	- a reg appears as a dest alone

			r[32]=r[33]+r[34];
			r[32] doesnt have a non-conflicting hw reg.
			Since it is a dest, we mark it NEEDS_SPILL and assign r[0] to it.
			SL[2]=r[0]
			r[0]=r[2]+r[4];
			SL[4]=r[0];	r[0]	(free up r[0] right after this rtl) <-- NEEDS_SPILL
			

			example 3	- a reg appears as a use and a dest.

			r[32]=r[32]+r[33]
			r[33] is already assigned to r[0]. r[32] needs a hw reg. Let r[2] be the first conflicting hw reg
			which doesnt also appear in this rtl.
			r[32] is first seen as a use in this rtl.
			So we emit the load and dont free up its original spill location.
			SL[2]=r[2]
			r[2]=SL[0]	(associate r[32] to r[2], dont free SL[0], mark r[2] as NEEDS_FREE)
			(after processing all the uses, the local reg assigner(gtreg()) sees that r[32] is a dest - so it frees
			 up SL[0], and marks it as NEEDS_SPILL)
			r[2]=r[2]+r[0]
			SL[4]=r[2]	(free up r[2]  - r[32] is now associated with SL[4]) <-- NEEDS_SPILL

	*/
			
		index=find_victim_register(cblk,ptr,sptr,rt,dest,real_conflicts,1);
		if (index==-1) {
			show_rtl(stderr, ptr->val);
			(void) fprintf(stderr, "vpo (findreg): too many registers in %d:'",ptr->rnum);
			(void) fprintf(stderr, "'\n");
			exit(1);
		} /*else
			(void) fprintf(stderr, "'(but I managed by using an unsafe reg)\n");
			*/

		if (!dest) {
			/* load without freeing spill loc */
			work_needed[index]=NEEDS_FREE;
			/* This pseudo has to be in some spill location. Save that value
				so that after this rtl is done, we reassociate this pseudo with
				that spill location. */
			spill_loc[index]=sptr->assign;
			retain_spill_location=TRUE;
		} else {
			work_needed[index]=NEEDS_SPILL;
		}
	}

	/* First spill the victim to free the hw reg */
	for (find = index; cr->reg[find].status == FOLLOWER; find--);
	if (find != index)
		spillreg(cblk, ptr, find, TRUE);
	for (find = index; rcont--; find++) {
		if (cr->reg[find].status == USED)
			spillreg(cblk, ptr, find, TRUE);
	}
	*change = TRUE;


	/* Remember that only the first reference to a register will cause control to come to findreg(). Once
	the register is assigned, gtreg() will return the assigned value straightaway. */
		
	/* The hw reg has been freed. Now load the value of the pseudo (if necessary) into this hw reg. */

	/* can this case arise? */
	if (istemp && dest) freetemp(cblk,sptr); /* we don't need the old value (if any) anymore */

	if (istemp && !dest) loadreg(cblk, ptr, sptr, rt, index,retain_spill_location); /* calls markreg */
	else markreg(cblk, sptr, rt, index); /* associates this pseudo to the hw reg corresponding to index */

	return (index);
}

/*
 * distance - measure the number of RTLs to the next reference of a register
 */
long distance(register struct list * ptr, char *reg) {

   struct bblock *cblk;
   long dist;
  
   dist = 0L;
   cblk = ptr->daddy;
   for (;;) {
      while (ptr) {
	 if (cnts(ptr)) {
	    if (fmatch(ptr->val, reg))
	       return (dist);
	    dist++;
	 }
	 ptr = ptr->next;
      }
      if (cblk = cblk->down)
	 ptr = cblk->rtls;
      else
	 return (dist);
   }
}

/*
 * fitreg - look for a register allocation for a given type
 */
int fitreg(struct bblock * cblk, struct list * ptr, struct setlist * sptr, int rt, int *index, int *change, int dest) {

	register regarray cr;
	register int check, find, end, rcont;
	int ravl, rskip, cflag, conflict[MAXREGS];

#ifdef RRLRA
	int class;
	char reg[REGSTRING];
#endif

	cr = (regarray) cblk->regstate;

	/*
		If we are allocating for a hardware register, then there is no need to
		look for an available hardware register, but we do need to make sure that
		the hardware register is not currently being used for any purpose.
	 */
	if (sptr->status & HARDWARE) {
		*index = end = regtoindex(rt, regnum(sptr->item));
		for (rcont = allocreg(rt); rcont--; end++) {
			if (cr->reg[end].status != NOTUSED) {

				/*
					Here we make a check to see if the item is part of a larger
					hardware register that was reserved earlier. If this is the
					case, then we free up the larger hardware item and put the
					current item where it belongs.
				 */
				for (check = end; cr->reg[check].status == FOLLOWER; check--);
				if (cr->reg[check].pseudo && cr->reg[check].pseudo->status & HARDWARE)
					freereg(cblk, cr->reg[check].pseudo);

				/*
					It is possible that use lines where properly generated, but a
					lack of registers forced us to spill the hardware item before we
					reached the point where it was needed again.  If this is the
					case, then we try to free up the hardware register by spilling
					its current value.  It may be the case that there are other
					registers free at this time that could accept the value
					directly, but checking for that and taking appropriate action
					would require a good bit of care, so I'll leave that for a
					future time.  There is also the chance that the hardware
					register was spilled and then assigned to a pseudo-register item
					that will be used in the next RTL, in which case spilling the
					value and then restoring it will leave behind code that doesn't
					work. I am not sure of what the best way to solve such a problem
					is, since it requires that we re-examine the whole RTL and
					re-map the register we need to restore here that has already
					been modified to another register.  Here is an example:

					r[10]=L[_x];             	            
					r[10]=L[_x];       -- r[10] reserved
					ur[10] 
					r[80]=L[_item];                       
					L[spill1]=r[10];   -- r[10] spill 
					r[10]=L[_item];    -- r[10] re-use     
					r[80]=r[80]+r[10];
					L[spill2]=r[10];   -- r[80] spill            
					r[10]=L[spill1];   -- r[10] restore 
					r[80]=r[10]+r[10]; -- WRONG!

					This case can occur on machines where the number of allocable
					registers for at least one type of registers is very small. The
					example shown has been overly-simplified, but the idea is that a
				particular hardware register value is reserved after a function
					call or for some other purpose.  The lack of registers then
					forces the allocator to spill the r[10] value so that it can
					calculate a new r[80] value.  Finally, we run into an RTL that
					uses both the r[80] value and the spilled r[10] value and r[80]
					shows up before r[10].  So we first look at the sources and
					determine that r[80] is mapped to r[10], so we make the
					appropriate update.  Then we see the need for the r[10] value.
					We then get here and try to obtain the r[10] value into r[10] by
					spilling r[80], which is is r[10] and then loading r[10] from
					its spill location.  The result is not correct.  The only
					solution at this time is to avoid the situation that causes the
					problem, which will probably only happen in certain register
					deprivation experiments.
					*/
				else if (cr->reg[check].status == TEMP) {
					spillreg(cblk, ptr, check, FALSE);
					*change = TRUE;
				}

				/*
					If we get here then we can be fairly sure that the register is
					not available because the code expander failed to emit a use
					line at the appropriate point.  Rather than try to patch up
					things by generating inefficient code and continue, it makes
					more sense to stop and force the user to determine the exact
					cause of the problem.
				 */
				else {
					(void) fprintf(stderr, "vpo (fitreg): hardware register ");
					show_rtl(stderr, sptr->item);
					(void) fprintf(stderr, " not available on demand\n");
					if(ptr->val)
					{
						(void)fprintf(stderr, "When examining: ");
						show_rtl(stderr,ptr->val);
						(void)fprintf(stderr, "\n");
					}
					dassem=0;
					dump_function(SHOW_NORMAL);
					exit(1);
				}
			}
		}
		return (TRUE);
	}

	/*
		This flag is used to indicate that we have performed a search over the
		life of the pseudo-register that we need to allocate a hardware register
		to and determined which hardware registers, if any, cannot be allocated
		to this pseudo-register because its life overlaps a use line indicating
		that a particular hardware register is needed at that point.
	 */
	cflag = FALSE;

	rskip = skipreg(rt);
	rcont = allocreg(rt);

#ifdef RRLRA
	class = classreg(rt);

	/*
		If we have already allocated a register in this class, we try to allocate
		the next available one in a round-robin scheme.
	 */
	if (lastfound[class] >= 0) {

		ravl = availreg(rt);
		for (find = firstreg(rt); find < lastfound[class]; find += rskip)
			ravl--;
		while (ravl-- > 0) {
			end = rcont;
			for (check = find; end--; check++) {

				/*
					Determine if we have reached the end of the scratch registers,
					if so, we fall out of this loop.
				 */
				makerg(reg, rt, check);
				if (!scratchreg(reg)) {
					lastfound[class] = -1;
					goto fail;
				}

				if (cr->reg[check].status != NOTUSED)
					break;
				else if (isused[check]) {
					if (!cflag) {

						/*
							At this point we are considering allocating a hardware
							register that has been marked as used (by the code
							expander through the use line feature) somewhere in the
							function.  What we are going to do now is search from this
							point until the death of the pseudo register that we are
							allocating for.  If we encounter any use lines, then those
							registers marked used cannot be allocated to this pseudo
							register because there would be a future conflict.
						 */
						conflicts(ptr, sptr->item, conflict, dest,NULL);
						cflag = TRUE;
					}
					if (conflict[check])
						break;
				}
			}
			if (end < 0) {
				*index = find;
				lastfound[class] = find + 1;
				return (TRUE);
			}
			find += rskip;
		}
	}
fail:
#endif

	/*
		This loop is the normal allocation loop which begins with the first
		allocable register for the type requested and searches over all of the
		allocable registers.  The least expensive registers are placed first.
	 */
	ravl = availreg(rt);
	for (find = firstreg(rt); ravl--; find += rskip) {
		end = rcont;
		for (check = find; end--; check++) {
			if (cr->reg[check].status != NOTUSED)
				break;
			else if (isused[check]) {
				if (!cflag) {
					conflicts(ptr, sptr->item, conflict, dest,NULL);
					cflag = TRUE;
				}
				if (conflict[check])
					break;
			}
		}
		if (end < 0) {
			*index = find;

#ifdef RRLRA
			lastfound[class] = find + 1;
#endif

			return (TRUE);
		}
	}

#ifdef RRLRA
	lastfound[class] = -1;
#endif

	/*
		We could find no available registers, so we return indicating our
		failure.
	 */
	return (FALSE);
}

/*
 * spillreg - saves a register into a temporary location
 */
void spillreg(struct bblock * cblk, struct list * ptr, int index, int checkuse) {

	struct setlist *sptr;
	struct list *nptr, *bptr;
	rlist *deads, deadlist[MAXXFER];
	int find, rt, used_here, i;
	char *a, new[BIGSTRING];


	/*
		Free up the register that we are about to spill from its current hardware
		register assignment.  First, however, check to see if the register is
		used in the RTL that caused the spill.  If it is, then we must not mark
		the register that we are spilling dead at the point where we spill the
		register, but rather at the last point where the register will be used.
	 */
	sptr = ((regarray) cblk->regstate)->reg[index].pseudo;
	rt = regtype(sptr->item);
	used_here = FALSE;
	if (checkuse && cnts(ptr)) {
		makereg(new, rt, indextoreg(rt, index));
		if (isaliasref(ptr->val, new)) {
			used_here = TRUE;
			if (!isset(ptr->val, new))
				rinsert(new, &ptr->deads);
#ifdef VET
#ifdef INTERACT
			mod_deads(ptr,rinit(),ptr->deads);
#else
			mod_deads(ptr);
#endif
#endif
		}
	}
	freereg(cblk, sptr);

	/*
		Find a temporary spill location to hold this register value
	 */
	if (fittemp(cblk, rt, &find)) {

		/*
			We will now insert the RTLs required to move the register value we
			need to spill to the temporary spill location that has been allocated
			to hold the value.
		 */
		deads = deadlist;
		(void) transfer(new, deads, TEMP, rt, find,
							 (used_here) ? LIVEREG : REGISTER, rt, indextoreg(rt, index));
		a = new;
		while (*a) {
			nptr = add_rtl(cblk, ptr, a, *deads++);
			while (*a++);
		}

		/*
			If the "sets" field for the register that we are spilling points to a
			valid RTL, then the spill code is the first use of the register since
			it was set, so we set up a combiner link and mark the new code for
			attention on the next combiner pass.  In some instances, the register
			set and the spill may combine to produce more efficient code. Note
			that we only set such links if the items are in the same basic block,
			since we might otherwise introduce an unsafe link.
		 */
		if (sptr->sets) {
			remv_links_to(sptr->sets);
			if (sptr->sets->daddy == cblk) {
				(void) add_link(nptr, sptr->sets);
				combmark(sptr->sets);
			}
			sptr->sets = (struct list *) NULL;
		}

		/*
			Otherwise, it may be the case that we still do need to get rid of an
			unsafe link and set up one from this spill to the set in order to
			ensure that the most efficient and correct code is produced, but
			because the register involved has already been assigned in the
			following line, the "sets" pointer has been removed.  Here we examine
			the RTLs that the following line is linked to and, if any of them set
			the register that we are spilling, we remove the link and set it up to
			the spill location instead.
		 */
		else if (used_here) {
			makereg(new, rt, indextoreg(rt, index));
			for (i = 0; i < MAXLINKS && (bptr = ptr->lnks[i]); i++) {
				if (isset(bptr->val, new)) {
					remv_link(bptr->blnks, ptr);
					remv_link(ptr->lnks, bptr);
					remv_link(ptr->all_lnks, bptr);
#ifdef VET
					mod_links(ptr);
#endif
					if (bptr->daddy == cblk) {
						(void) add_link(nptr, bptr);
						combmark(bptr);
					}
					break;
				}
			}
		}

		/*
			Now we update the register database to indicate the new location of
			the value spilled.
		 */
		marktemp(cblk, sptr, rt, find);
	}

	/*
		If we run out of temorary memory locations, then we print a fatal error
		message.  The user will then have to increase the number of temporary
		memory locations by increasing the number of SPILL class items defined in
		the regtool description for this target machine.
	 */
	else {
		(void) fprintf(stderr, "vpo (spillreg): out of temporary locations\n");
		exit(1);
	}
}

/*
 * loadreg - loads a register from a temporary location
 */
void loadreg(struct bblock * cblk, struct list * ptr, struct setlist * sptr, int rt, int index, int retain_spill_location) {

   struct list *nptr;
   rlist *deads, deadlist[MAXXFER];
   char *a, new[BIGSTRING];

 
   deads = deadlist;
   (void) transfer(new, deads, REGISTER, rt, indextoreg(rt, index),
		   TEMP, rt, sptr->assign);
   a = new;
   while (*a) {
      nptr = add_rtl(cblk, ptr, a, *deads++);
      while (*a++);
   }
	if (!retain_spill_location) freetemp(cblk, sptr);
   markreg(cblk, sptr, rt, index);

}


/*
 * fittemp - look for a temporary allocation for a given type
 */
int fittemp(struct bblock * cblk, int rt, int *index) {

	register regarray cr;
	register int check, find, end, tcont;
	int tavl, tskip;

	cr = (regarray) cblk->regstate;
	tavl = availtemp(rt);
	tskip = skiptemp(rt);
	tcont = conttemp(rt);
	for (find = firsttemp(rt); tavl--; find += tskip) {
		end = tcont;
		for (check = find; end--; check++) {
			if (cr->temp[check].status != NOTUSED)
				break;
		}
		if (end < 0) {
			*index = find;
			return (TRUE);
		}
	}
	return (FALSE);
}

/*
 * conflicts - find out which hardware registers we conflict with
 */
void conflicts(register struct list * ptr, char *reg, int *conflict, int dest,int *real_conflicts) {

   register unsigned int ref;
   register struct bblock *mblk;
   struct bblock *cblk;
   
   
   /*
      No conflicts to begin with
   */
   for (ref = 0; ref < MAXREGS; conflict[ref++] = FALSE);
	if (real_conflicts) for (ref = 0; ref < MAXREGS; real_conflicts[ref++] = FALSE);

   cblk = ptr->daddy;
   ref = (unsigned int) regtovec(reg);


   /*
    * If we are assigning a destination register, we conflict with every other
    * destionation reg in this RTL	
    */
	if(dest)
 	{
		char *a=ptr->val;
		while(a=gtrg(a))
		{
			if(*a=='=' && !pseudoreg(unskiploc(a)))
			{		
				int type=regtype(unskiploc(a));
				int num=regnum(unskiploc(a));
				conflict[regtoindexf(type, num)]=TRUE;
				if (real_conflicts) real_conflicts[regtoindexf(type, num)]=TRUE;
			}
		}
	}

   /*
      If we are allocating for an item that is being set, then we do not want
      to examine the dead register list of the current RTL.
   */
   if (dest)
      ptr = ptr->next;

   /*
      Attempt to locate the death of the register, if we encounter any "use"
      type lines before the death of the pseudo register, then those uses
      conflict with the life of the register.
   */
	while (ptr) {
		if (ptr->type & RTLINE && rin(ref, ptr->deads))
			return;
		else if (ptr->type & USELINE)
			conflict[ptr->cost] = TRUE;
		ptr = ptr->next;
	}

   /*
      Set all blocks to unvisited
   */
   for (mblk = top; mblk; mblk = mblk->down)
      mblk->status &= ~DRYRUN;

   /*
      Since the death is not in this block, we need to follow the children and
      continue the search.
   */
   if (cblk->right && rin(ref, cblk->right->ulist))
      doconflicts(cblk->right, ref, conflict);
   if (cblk->left && rin(ref, cblk->left->ulist))
      doconflicts(cblk->left, ref, conflict);
}

/*
 * doconflicts - find out which hardware registers we conflict with
 */
void doconflicts(register struct bblock * cblk, register unsigned int ref, int *conflict) {

   register struct list *ptr;


   /*
      Attempt to locate the death of the register, if we encounter any "use"
      type lines before the death of the pseudo register, then those uses
      conflict with the life of the register.
   */
   for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
      if (ptr->type & RTLINE && rin(ref, ptr->deads))
	 return;
      else if (ptr->type & USELINE)
	 conflict[ptr->cost] = TRUE;
   }

   /*
      Do a depth-first search ensuring that examined blocks are not re-visited
   */
   cblk->status |= DRYRUN;
   if (cblk->right && !(cblk->right->status & DRYRUN) &&
       rin(ref, cblk->right->ulist))
      doconflicts(cblk->right, ref, conflict);
   if (cblk->left && !(cblk->left->status & DRYRUN) &&
       rin(ref, cblk->left->ulist))
      doconflicts(cblk->left, ref, conflict);
}

/*
 * markreg - mark a register as used and associate it with a pseudo register
 */
void markreg(struct bblock * cblk, struct setlist * sptr, int rt, register int index) {

   register regarray cr;
   register int rcont;

   sptr->regstatus = REGISTER;
   sptr->assign = index;
   cr = (regarray) cblk->regstate;
   cr->reg[index].pseudo = sptr;
   cr->reg[index].status = USED;
   rcont = contreg(rt);
   usedregs[index] |= (rcont == 1) ? USED : FOLLOWER;
   while (--rcont) {
      cr->reg[++index].status = FOLLOWER;
      usedregs[index] |= FOLLOWER;
   }
}

/*
 * touchindex - marks a register as used, given the index
 */
void touchindex(vector regs, int index) {
      regs[index >> intscale] |= (((unsigned) 1) << (index & bitsperint));
}

/*
 * touchreg - marks a register as used
 */
void touchreg(vector regs, char *reg) {

   register int index, rcont;
   int rt;

   rt = regtype(reg);
   index = regtoindex(rt, map(reg));
   for (rcont = contreg(rt); rcont--; index++)
      regs[index >> intscale] |= (((unsigned) 1) << (index & bitsperint));
}

/*
 * releasereg - releases a register marked as used
 */
void releasereg(vector regs, char *reg) {

   register int index, rcont;
   int rt;

   rt = regtype(reg);
   index = regtoindex(rt, regnum(reg));
   for (rcont = contreg(rt); rcont--; index++)
      regs[index >> intscale] &= ~(((unsigned) 1) << (index & bitsperint));
}

/*
 * marktemp - marks temporary as used and associates it with a pseudo register
 */
void marktemp(struct bblock * cblk, struct setlist * sptr, int rt, int index) {

   register regarray cr;
   register int tcont;

   sptr->regstatus = TEMP;
   sptr->assign = index;
   cr = (regarray) cblk->regstate;
   cr->temp[index].pseudo = sptr;
   cr->temp[index].status = USED;
   usedtemps[index] = TRUE;
   tcont = conttemp(rt);
   while (--tcont) {
      cr->temp[++index].status = FOLLOWER;
      usedtemps[index] = TRUE;
   }
}

/* 
 * find_spill_location - Return TRUE if a spill location is found of the
 * requested type.
 */ 
int find_spill_location(int type, int *index) 
{
	int tavl, tskip;
	int check, find, end, tcont;
	tavl = availtemp(type);
	tskip = skiptemp(type);
	tcont = conttemp(type);
	for (find = firsttemp(type); tavl--; find += tskip) {
		end = tcont;
		for (check = find; end--; check++) {
			if (usedtemps[check])
				break;
		}
		if (end < 0) {
		    *index = find;
		    tcont = conttemp(type);
		    while (--tcont) {
			usedtemps[find--] = TRUE;
		    }
		    return (TRUE);
		}
	 }
	return (FALSE);
}

/* spill_reg_to_loc - emits rtls to move a register to another location.
 * If type==TEMP, then the register is saved on a spill location.
 * If type==REGISTER then the register is moved into another reg (as specified by tindex)
 */
struct llist *spill_reg_to_loc(struct bblock *cblk, struct list *ptr, char* reg, int type, int tindex){
	rlist *deads, deadlist[MAXXFER];
	char *a, new[BIGSTRING];
	struct list *rtlptr = NULL;
	struct llist *ref = NULL;
	deads = deadlist;
	
	transfer(new, deads, type, regtype(reg), tindex, 
		  REGISTER,	regtype(reg), regnum(reg)); 
	a = new;
	while (*a) {
		rtlptr = add_rtl(cblk,ptr,a, *deads);
		add_to_ref(&ref, rtlptr);
		while (*a++);
	}	
	return ref;
	/* ??? Should I change combiner links */	
}

/*
 * load_reg_from_loc - emits rtls to re-load a register from a location (spill or reg)
 * type=TEMP means spill location.
 * type=REGISTER means another register
 */
struct llist* load_reg_from_loc(struct bblock *cblk, struct list *ptr, char *reg, int type, int tindex) {
	rlist *deads, deadlist[MAXXFER];
	char *a, new[BIGSTRING];
	struct list* rtlptr = NULL;
	struct llist *ref = NULL;

	deads = deadlist;
	
	transfer(new, deads, REGISTER, regtype(reg), regnum(reg), 
			type, regtype(reg), tindex);
	a = new;
	while (*a) {
		rtlptr = add_rtl(cblk,ptr,a, *deads++);
		add_to_ref(&ref, rtlptr);
		while (*a++);
	}
	return ref;
}

/*
 * freereg - frees a register from its association to a pseudo register
 */
void freereg(struct bblock * cblk, struct setlist * sptr) {

   register regarray cr;
   register int index;

   sptr->regstatus = UNASSIGNED;
   index = sptr->assign;
   cr = (regarray) cblk->regstate;
   do {
      cr->reg[index].status = NOTUSED;
      cr->reg[index++].pseudo = (struct setlist *) NULL;
   } while (cr->reg[index].status == FOLLOWER);
}

/*
 * freetemp_index - frees a temporary location which may not be associated with this reg, 
 * but actually belongs to this reg.
 * The only difference from freetemp() is that the index is passed as a parameter here.
 */
void freetemp_index(struct bblock * cblk, struct setlist * sptr, int index) {
   register regarray cr;

   sptr->regstatus = UNASSIGNED; 
   cr = (regarray) cblk->regstate;
   do {
      cr->temp[index].status = NOTUSED;
      cr->temp[index++].pseudo = (struct setlist *) NULL;
   } while (index < MAXTEMP && cr->temp[index].status == FOLLOWER);
}

/*
 * freetemp - frees a register from its association to a temporary location
 */
void freetemp(struct bblock * cblk, struct setlist * sptr) {

   register regarray cr;
   register int index;

   sptr->regstatus = UNASSIGNED;
   index = sptr->assign;
   cr = (regarray) cblk->regstate;
   do {
      cr->temp[index].status = NOTUSED;
      cr->temp[index++].pseudo = (struct setlist *) NULL;
   } while (index < MAXTEMP && cr->temp[index].status == FOLLOWER);
}

/*
 * conflictreg - indicate a conflicting association to a pseudo register
 */
void conflictreg(struct bblock * cblk, struct setlist * sptr) {

   register regarray cr;
   register int index;

   sptr->regstatus = UNASSIGNED;
   index = sptr->assign;
   cr = (regarray) cblk->regstate;
   do {
      cr->reg[index].status = CONFLICT;
      cr->reg[index++].pseudo = (struct setlist *) NULL;
   } while (cr->reg[index].status == CONFLICT ||
	    cr->reg[index].status == FOLLOWER);
}

/*
 * conflicttemp - indicate a conflicting association to a temporary location
 */
void conflicttemp(struct bblock * cblk, struct setlist * sptr) {

   register regarray cr;
   register int index;

   sptr->regstatus = UNASSIGNED;
   index = sptr->assign;
   cr = (regarray) cblk->regstate;
   do {
      cr->temp[index].status = CONFLICT;
      cr->temp[index++].pseudo = (struct setlist *) NULL;
   } while (index < MAXTEMP && (cr->temp[index].status == CONFLICT ||
	    cr->temp[index].status == FOLLOWER));
}

/*
 * find_unused_register - attempt to locate an unused register of a given type
 */
int find_unused_register(struct bblock * cblk, int rt, int *index) {

   register regarray cr;
   register int find, check, end, ravl, rskip, rcont;

   cr = (regarray) cblk->regstate;

   ravl = availreg(rt);
   rskip = skipreg(rt);
   rcont = contreg(rt);
   for (find = firstreg(rt); ravl--; find += rskip) {
      end = rcont;
      for (check = find; end--; check++) {
	 if (cr->reg[check].status != NOTUSED)
	    break;
      }
      if (end < 0) {
	 *index = find;
	 return (TRUE);
      }
   }

   return (FALSE);
}


/*
 * gt_any_loc - get any loc (reg/local/global/label)
 */
char *
gt_any_loc(register char *s) {
	if (!s) return NULL;
	while (*s) {
		if (isloc(s))
			return (s + LOCALLOCLENGTH);
		if (*s=='L') {
			s++;
			while (*s>='0' && *s<='9') s++;
			return s;
		}
		s = skiploc(s);
	}
	return ((char *) s);
}

/*
 * gtloc - get local variable
 */
char *
gtloc(register char *s) {
   if (!s) return NULL;
   for (;;) {
      while (*s) {
         if (isLocal(s))
            return (s + LOCALLOCLENGTH);
         s = skiploc(s);
      }
      return ((char *) NULL);
   }
}

/*
 * gtglobal - get global variable
 */
char *
gtglobal(char *s) {
   if (!s) return NULL;
   for (;;) {
      while (*s) {
         if (isGlobal(s))
            return (s + GLOBALLOCLENGTH);
         s = skiploc(s);
      }
      return ((char *) NULL);
   }
}

/*
 * gtrg - get register of any type
 */
char *gtrg(char *s) {
   char c;

   if (!s)
      return ((char *) NULL);

   for (;;) {
      while (*s) {
        if (isRegister(s))
           return skiploc(s);
        s = skiploc(s);
      }
      return ((char *) NULL);
   }
}

/*
 * gtrgstr - get register of any type and place a copy of it in str
 */
char *gtrgstr(register char *s, register char *str) 
{


   char* t=gtrg(s);
   if(!t)
        return ((char*)NULL);
   copyloc(str,unskiploc(t));
   str=skiploc(str);
   *str='\0';
   return t;
}

/*
 * gthrg - get hardware register
 */
char *gthrg(register char *s) {

   char* t=s;

   while((t=gtrg(t)))
   {
	if(!pseudoreg(unskiploc(t)))
		return t;
   }
   return t;
}

#ifdef FIFOS
/*
 * gtfrg - get fifo register
 */
char *gtfrg(register char *s) {

   char* t=s;
   while((t=gtrg(t)))
   {
        if(fiforeg(unskiploc(t)))
                return t;
   }
   return t;

}

#endif


/*
 * gtstackrg - get stack register
 */
char *gtstackrg(register char *s) {

   char* t=s;
   while((t=gtrg(t)))
   {
        if(stackreg(unskiploc(t)))
                return t;
   }
   return t;

}




/*
 * makerg - make a register of a given type and number
 */
void makerg(char *reg, int rt, int rnum) {
	copyloc(reg,BUILDREG(rt,rnum));
}

/*
 * makereg - make a register of a given type and number
 */
void makereg(char *reg, int rt, int rnum) {
        copyloc(reg,BUILDREG(rt,rnum));
        *(skiploc(reg))=0;
}

/*
 * memtype - returns the type of a memory reference
 */
int memtype(char *mem) {

   register int type;

   if ((type = mems[(int) *mem]) == NOTYPE) {
      (void) fprintf(stderr, "vpo (memtype): bad memory type '%c'\n", *mem);
      exit(1);
   }
   return (type);
}

/*
 * gtmem - return next memory reference in the RTL string
 */
char *gtmem(register char *s) {

   register char c;
   register int depth;

   /*
      If we find a capital letter that denotes a valid memory type, followed by
      a '[' at this point, then we have found the start of a memory reference.
      We then scan forward to find the matching ']' that indicates the end of
      the memory reference, set "epos" and "bpos" appropriately, and return.
   */
   while (c = *s++) {
      if (*s == '[' && mems[(int) c] != NOTYPE) {
	 bpos = s++ - 1;
	 depth = 1;
	 while (c = *s++) {
	    if (c == '[')
	       depth++;
	    if (c == ']' && !--depth)
	       return (epos = s);
	 }
	 return ((char *) NULL);
      }
   }
   return ((char *) NULL);
}

int is_a_store(char *s)
{
  while (s = gtmem(s))
    if (*epos == '=')
      return 1;

  return 0;

}

int is_a_load(char *s)
{
  while (s = gtmem(s))
    if (*epos != '=')
      return 1;

  return 0;

}

/*
 * ismem - return TRUE if the string starts a memory reference
 */
int ismem(char *s) {

   return (mems[(int) *s] != NOTYPE && *(s + 1) == '[');
}

/*
 * canreplace - returns TRUE if there is a register available of a given type
 */
int canreplace(int type, regvec regstate, char *reg, int ifcheap, int ifcs) {

   register int check, rcont, end, find;
   regarray cr;
   int ravl, rskip;
 
   cr = (regarray) regstate;
   if ((type = localtype(type)) >= 0) {
      ravl = availreg(type);
      rskip = skipreg(type);
      rcont = contreg(type);
      for (find = firstreg(type); ravl--; find += rskip) {
	 end = rcont;
	 for (check = find; end--; check++) {
	    if (cr->reg[check].status != NOTUSED || isused[check])
	       break;
	 }
	 if (end < 0) {
	    makereg(reg, type, indextoreg(type, find));
	    if (ifcheap && !scratchreg(reg))
	       *reg = '\0';
	    else if (callersave(reg) > ifcs)
	       *reg = '\0';
	    else {
	       rcont = contreg(type);
	       if (rcont == 1)
		  cr->reg[find].status |= USED;
	       else {
		  while (rcont--)
		     cr->reg[find++].status |= FOLLOWER;
	       }
	       return (TRUE);
	    }
	 }
      }
   }
   return (FALSE);
}

/*
 * cancolor - returns TRUE if there is a register available of a given type.
 *    Argument "type" specifies the type of register needed.
 *    Argument "regs" is the vector specifying which registers are already
 *       used.  It will be updated if we allocate a register.
 *    Argument "reg" contains the result of makereg() on that register.
 *    Argument "ifcheap", if TRUE, specifies that only a scratch register
 *       should be used, because it is not worth allocating this register
 *       otherwise.
 */
int cancolor(int type, vector regs, char *reg, int ifcheap) {

   register unsigned int check;
   register int rcont, end, find;
   int ravl, rskip;

#ifdef RRLRA
   int class;
   char creg[REGSTRING];
#endif

   if ((type = localtype(type)) >= 0) {
      rskip = skipreg(type);
      rcont = allocreg(type);

#ifdef RRLRA
      class = classreg(type);

      if (lastfound[class] >= 0) {
         ravl = availreg(type);
         for (find = firstreg(type); find < lastfound[class]; find += rskip)
            ravl--;
         while (ravl-- > 0) {
            end = rcont;
            for (check = (unsigned int) find; end--; check++) {

               /*
                 Determine if we have reached the end of the scratch
                 registers, if so, we fall out of this loop.
               */
               makerg(creg, type, check);
               if (!scratchreg(creg)) {
                  lastfound[class] = -1;
                  goto fail;
               }

               if (vin(regs, check))
                  break;
            }
            if (end < 0) {
               makereg(reg, type, indextoreg(type, find));
               if (ifcheap && !scratchreg(reg))
                  *reg = '\0';
               else {
                  lastfound[class] = find + 1;
                  for (rcont = allocreg(type);
                       rcont--;
                       vinsert(&regs, (unsigned int) find++));
                  return TRUE;
               }
            }
            find += rskip;
         }
      }
   fail:
#endif

      ravl = availreg(type);
      for (find = firstreg(type); ravl--; find += rskip) {
         end = rcont;
         for (check = (unsigned int) find; end--; check++)
            if (vin(regs, check))
               break;
         if (end < 0) {
            makereg(reg, type, indextoreg(type, find));
            if (ifcheap && !scratchreg(reg))
               *reg = '\0';
            else {

#ifdef RRLRA
               lastfound[class] = find + 1;
#endif

               for (rcont = allocreg(type);
                    rcont--;
                    vinsert(&regs, (unsigned int) find++));
               return TRUE;
            }
         }
      }
   }
   return FALSE;
}

/*
 * regnew - return new register assignment vector
 */
vector regnew() {

   register unsigned int *ptr1, *end;
   register vector nptr;

   nptr = (vector) (ptr1 = MRALLOC);
   for (end = ptr1 + mrveclen; ptr1 != end; *ptr1++ = (unsigned int) 0);
   return (nptr);
}

/*
 * regcopy - copy a register assignment vector to another
 */
void regcopy(vector reg1, vector reg2) {

   register unsigned int *ptr1, *ptr2, *end;

   ptr1 = (unsigned int *) reg1;
   ptr2 = (unsigned int *) reg2;
   for (end = ptr1 + mrveclen; ptr1 != end; *ptr1++ = *ptr2++);
}

#ifdef MEASURE
/*
 * get_freereg - allocate a register that is either scratch or will be saved
 */
int get_freereg(struct bblock * cblk, struct list * ptr, int num, int type, char *reg, char *mapreg) {

   regarray tr;
   vector regs;

   /*
      Determine which registers are live at this point in the function
   */
   regs = live_regs(cblk, ptr);

   /*
      Attempt to allocate a suitable register
   */
   tr = (regarray) top->regstate;
   while (cancolor(type, regs, reg, FALSE)) {

      /*
         Determine which register the register allocated will actually map to
         when it is emitted.
      */
      makereg(mapreg, type, map(reg));

      /*
         If the register maps to a scratch register, then it can be used
         without any problems.
      */
      if (scratchreg(mapreg)) {
	 reg = skiploc(reg)+1;
	 mapreg = skiploc(mapreg)+1;
	 if (!--num) {
	    *reg = *mapreg = '\0';
	    mrfree(regs);
	    return (TRUE);
	 }
      }

      /*
         If the register is already being used elsewhere in the function, then
         go ahead and use it at this point.
      */
      else if (tr->reg[regtoindex(type, regnum(reg))].status != NOTUSED) {
	 reg = skiploc(reg)+1;
	 mapreg = skiploc(mapreg)+1;
	 if (!--num) {
	    *reg = *mapreg = '\0';
	    mrfree(regs);
	    return (TRUE);
	 }
      }
   }

   /*
      Return indicating that no suitable register was available
   */
   mrfree(regs);
   *reg = *mapreg = '\0';
   return (FALSE);
}
#endif


/*
 * inithardregs - set up register mapping info for hardware registers
 */
void inithardregs() {


#ifdef HREGINFO
   int index;
   int new_location;
 
   for (index = 0; index < HREGINFO; index++) {
      (void) strcpy(sets[regallocptr].item, _hrinfo[index].name);
      sets[regallocptr].status = _hrinfo[index].flags;
      sets[regallocptr].num = regallocptr;
      new_location=regname(regallocptr);	
      vecmap[new_location] = regallocptr;
      regallocptr++;
   }
#endif
}

/*
 * markinvariant - mark registers that are always invariant in loops
 */
void markinvariant() {

   register struct setlist *sptr;

   MARKINVARIANT
}

/*
 * aliases - given a hardware register, return a list of all aliases
 */
char *aliases(register char *reg) 
{
	char* ret_value;
	if(isRegister(reg) && !pseudoreg(reg))
   		return (_aliases[regtype(reg)][regnum(reg)]);

	ret_value=CALLOC(REGSTRING);
	copylocOr2(ret_value,reg);
	*skiplocOr2(ret_value)=0;
	*(skiplocOr2(ret_value)+1)=0;
	return ret_value;
}

/*
 * regtoindexf - return regtoindex macro value as a function
 */
int regtoindexf(int rt, int reg) {

   return (regtoindex(rt, reg));
}

/*
 * allocregf - return allocreg() macro value as a function
 */
int allocregf(int rt) {

   return ((int) allocreg(rt));
}

/*
 * contregf - return contreg() macro value as a function
 */
int contregf(int rt) {

   return ((int) contreg(rt));
}

/*
 * is_cc - returns TRUE is the item is a condition code token
 */
int is_cc(register char *s) {

   return (IS_CC(s));
}

/*
 * set_cc - returns TRUE is the RTL sets the condition codes
 */
int set_cc(register char *s) {

   return (SET_CC(s));
}

/*
 * checktype - check two types for global allocation compatibility
 */
int checktype(int prev, int new) {

   return ((prev == NOTYPE) ? new : (int) _checktype[prev][new]);
}

/*
 * find_max_usedtemp - find the largest index in usedtemps that is set
 */
int find_max_usedtemp()
{
  int i;
  for(i=MAXTEMP ; i>=0 ; i--){
    if(usedtemps[i] > 0)
      break;
  }

  return i;
}

/*
 * set_usedtemp - set the value of the max usedtemps index used, read from
 *                cex file
 */
void set_usedtemp(int index)
{
  int i;
  for(i=0 ; i<=index ; i++)
    usedtemps[i] = TRUE;
  for(;i<MAXTEMP ; i++)
    usedtemps[i] = FALSE;
}
