
/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/cdmotion.c,v $
 $Date: 2004/01/21 18:39:50 $
 $Revision: 1.61 $
 $Name:  $

 Log of changes:

 $Log: cdmotion.c,v $
 Revision 1.61  2004/01/21 18:39:50  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.60  2003/12/24 18:29:07  clc5q
 Add debugging output for iterations().
 Compute loop iterations for relational operators REL_GT and REL_GE, which
    previously were not dealt with and had the default value returned from
    iterations().

 Revision 1.59  2003/12/18 00:29:05  clc5q
 Ran through indent tool; cosmetic touchups.

 Revision 1.58  2003/12/16 22:04:11  clc5q
 Eliminate references to the swz flag in the old code conditionally compiled
    for WIDES.  The swz flag now enables data placement optimizations.

 Revision 1.57  2003/11/18 01:54:32  clc5q
 Added LoopAnalysesForProfiling() so that global data profiling can do
    just enough loop analyses to be able to successfully compute loop
    iterations using iterations(), without doing code motion, which
    makes global profiling more difficult.

 Revision 1.56  2003/10/22 13:01:19  jdh8d
 fixed begin_trans/end_trans mismatch

 Revision 1.55  2003/08/28 18:29:34  jdh8d
 changes to get tms working; rtl deleted twice in cdmotion.c

 Revision 1.54  2003/08/01 04:36:21  jg9h
 Added support for loop count down and repeat blocks

 Revision 1.53  2003/07/07 17:25:11  jg9h
 find_live_range() prototype slightly modified

 Revision 1.52  2003/05/01 00:55:00  jg9h
 Added a parameter to comparison()/md_replace_induction_var()/md_can_replace_induction_var()

 Revision 1.51  2003/04/29 19:48:34  jg9h
 Added call to md_can_replace_induction_var. Removed a huge '&& FALSE'ed for loop from induction_variable_elimination.

 Revision 1.50  2003/04/24 22:22:14  jg9h
 Added call to md_replace_induction_var().

 Revision 1.49  2003/04/24 04:55:32  jg9h
 Changed rtl.c:comparison() to take a struct list rather than char*

 Revision 1.48  2003/04/03 20:06:09  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.47  2003/04/02 17:11:53  jdh8d
 added comments about previous bug fix

 Revision 1.46  2003/03/28 14:45:35  jdh8d
 *** empty log message ***

 Revision 1.45  2003/03/20 15:01:50  jdh8d
 sign-ext fix for x86

 Revision 1.44  2003/03/14 01:34:19  jdh8d
 i386 bug fixes

 Revision 1.43  2003/02/15 00:17:46  clc5q
 Add function discard_duplicate_triple() to eliminate the duplicate induction
    variable triples that are created in CISC machines that permit two
    memory references in a single RTL.
 Clean up some indentation.

 Revision 1.42  2003/02/06 04:46:27  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.41  2002/07/17 22:14:40  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.40  2002/07/11 15:22:29  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.39  2002/06/05 20:08:52  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.38  2002/05/16 19:39:40  jdh8d
 some changes from Mas

 Revision 1.37  2002/04/22 15:59:30  jwd
 Added a comment about a potential bug with code motion on predicated machines.  What if
 there was a divide by zero that was  guarded.  We might move it to the preheader and a
 fault could occur when the code is executed.

 Revision 1.36  2002/03/26 02:47:21  rv3s
 Warnings now under optimizer warning flag

 Revision 1.35  2002/03/21 15:43:52  jdh8d
 *** empty log message ***

 Revision 1.34  2002/03/20 18:02:03  jdh8d
 *** empty log message ***

 Revision 1.33  2002/02/14 18:20:22  jwd
 Fixed a problem with induction variables were it would get into an infinite
 loop replacing induction variables.  It would change one to be in terms
 of another, then next time change it back, etc., etc.

 Revision 1.32  2002/01/14 13:14:07  jdh8d
 *** empty log message ***

 Revision 1.31  2001/12/17 16:07:43  rv3s
 close_enough() fix

 Revision 1.30  2001/12/05 17:58:50  jdh8d
 *** empty log message ***

 Revision 1.29  2001/11/22 02:19:23  jdh8d
 *** empty log message ***

 Revision 1.28  2001/11/21 18:00:28  jdh8d
 *** empty log message ***

 Revision 1.27  2001/11/19 15:50:54  jdh8d
 minor bug fix

 Revision 1.26  2001/11/14 19:44:32  jdh8d
 *** empty log message ***

 Revision 1.25  2001/11/13 17:04:50  jdh8d
  fixed memory leaks

 Revision 1.24  2001/11/06 19:23:03  rv3s
 code motion cannot hoist volatile memory loads out of a loop. The volatile_mem_acc variable looks for memory trash lines and ensures that memory loads are not hoisted out of a loop with such a trash line

 Revision 1.23  2001/10/30 22:33:35  jdh8d
 *** empty log message ***

 Revision 1.22  2001/10/30 14:53:17  jdh8d
 *** empty log message ***

 Revision 1.21  2001/10/10 16:15:45  rv3s
 doreduce called at appropriate places to avoid byte/word load offset problems

 Revision 1.20  2001/10/09 15:04:53  jdh8d
 *** empty log message ***

 Revision 1.19  2001/09/24 20:33:21  jdh8d
 *** empty log message ***

 Revision 1.18  2001/08/28 21:05:00  jdh8d
 *** empty log message ***

 Revision 1.17  2001/08/22 22:27:59  jdh8d
 *** empty log message ***

 Revision 1.16  2001/08/22 15:57:18  jdh8d
 *** empty log message ***

 Revision 1.15  2001/08/21 01:38:56  jdh8d
 *** empty log message ***

 Revision 1.14  2001/08/15 21:18:22  jdh8d
 *** empty log message ***

 Revision 1.13  2001/07/23 18:25:58  rv3s
 Replaced skiploc() with skiplocOr2() for processing register lists (except those in rtl->val)

 Revision 1.12  2001/07/23 16:10:53  jdh8d
 *** empty log message ***

 Revision 1.11  2001/05/30 14:03:00  jdh8d
 *** empty log message ***

 Revision 1.10  2001/05/23 20:28:19  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.9  2001/05/12 16:05:00  jdh8d
 *** empty log message ***

 Revision 1.8  2001/04/26 00:00:41  jdh8d
 *** empty log message ***

 Revision 1.7  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.6  2000/03/15 16:25:40  jwd
 Changed call to VET to take parameter indicating if the transformation
 is required or not.

 Revision 1.5  1998/10/06 20:03:40  jwd
 Added VET code.
 Revision 1.4  1998/04/28 19:19:19  jwd
 Moved a local prototype to the cdmotion header file.
 Revision 1.3  1998/04/03 16:48:01  jwd
 First ANSI C version.

*************************************************************************/


/*------------------------------------------------
 History of Changes:
------------------------
   1/8/98: This file was altered to have ansi-c modular protoyping

------------------------------------------------ */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "vpo.h"
#include "assign.h"
#include "cdmotion.h"
#include "combine.h"
#include "controlflow.h"
#include "database.h"
#include "links.h"
#include "live.h"
#include "misc.h"
#ifdef SCHED
#include "sched.h"
#endif
#include "vectors.h"
#include "vpo2.h"

#include "rtl.h"   /* Machine dependent */
#include "regs.h"  /* Machine dependent */
#include "regs2.h" /* Machine dependent */


#ifdef VET
#include "view.h"
#endif


struct itriple *ftriple = NULL; /* Pointer to first triple record   */
struct memgroup *partitions = NULL;     /* Pointer to partition records     */
#ifdef VET
struct bblock *prevblk;
#endif

#ifdef WIDES

/* This appears to be used as a boolean. I can find it nowhere. */
extern update_loop_info;
#endif

int   can_reduce(struct loopl *loop, struct itriple *tptr,
                 struct setlist *fptr, char *reg, char *biv, int complex);

int   can_replace(struct list *rtl, char *pat, char *expr);

int   close_enough(struct list *start, struct list *end, char *reg1,
                   char *reg2);

int   should_replace(struct setlist *fptr, struct loopl *loop);

struct itriple *discard_duplicate_triple();

struct bblock *is_single_exit_loop(struct loopl *loop);


void loop_invariant_init(struct loopl *loop)
{
   register char *rtlin;
   register struct setlist *sptr;
   char  reg[MAXSTRING];

   /*
    * Clear any old loop invariant information we may currently have about
    * this loop.
    */
   if (loop->invareg) {
      rfree(loop->invareg);
      loop->invareg = rinit();
   }
   loop->invaread = FALSE;

   /*
    * Initialize the register information by obtaining the list of
    * registers that are always loop invariant (such as the frame
    * pointer).
    */
   mrfree(loop->regs);
   loop->regs = regnew();
   clrsets();
   markinvariant();

   /*
    * Note the list of registers that are live on entry to the loop.
    * These register will be invariant only if they are not set inside
    * the loop.  The following fields of the register information structure
    * are used by this algorithm:
    *
    *     sets  - points to the RTL containing last set of item in the loop
    *     dead  - if set, then the item has more than one assignment and is
    *             not considered invariant
    *     ldead - points to the RTL outside of the loop that contains the
    *             set for this item.  If it is set, then the item is loop-
    *             invariant.  If the actual RTL where the item is set is
    *             not known, then it will point to "top->rtls" which is
    *             the first RTL in the function and guaranteed to be outside
    *             of the loop.
    */
   reget(loop->ptr->ulist, reg);
   for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
      sptr = s_add(rtlin);
      if (sptr->status & FIFOREG)
         sptr->dead = top->rtls;
      else if (!sptr->local) {
         sptr->sets = top->rtls;
         sptr->assign = TRUE;
         touchreg(loop->regs, rtlin);
      }
   }
}


void loop_invariant_analysis(struct loopl *loop, int first, int analysis_only,
                             int *writes)
{
   register char *rtlin;
   register struct setlist *sptr;
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct setlist *real;
   struct blist *cptr;
   char *a, *st;

   /*
    * Examine each basic block in the current loop
    */
   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

         /*
          * Look at RTLs that have some effect and examine each effect
          * separately.
          */
         if (rtlin = cnts(rtlptr)) {
            while (*rtlin) {

               /*
                * See if the RTL possibly writes to memory
                */
               if (first && !(*writes))
                  *writes = writes_mem(rtlin);

               /*
                * Now look at the registers set in the RTL to determine
                * which ones are loop invariant and which are not.
                */
               if (isrg(rtlin)) {
                  real = s_add(rtlin);
                  for (a = aliases(rtlin); *a; a = skiploc(a) + 1) {
                     sptr = s_add(a);
                     if (sptr->status & FIFOREG)
                        touchreg(loop->regs, a);
                     else if (sptr->sets)
                        sptr->dead = rtlptr;
                     else if (!sptr->dead) {
                        sptr->sets = rtlptr;
                        if (sptr == real) {
                           while (*rtlin++ != '=') ;
                           for (st = rtlin; *rtlin != ';'; rtlin++) ;
                           *rtlin = '\0';
                           if (is_invariant
                               (st, first | *writes, loop, rtlptr))
                              sptr->assign = TRUE;
                           *rtlin = ';';
                        }
                     }
                  }
               }
               while (*rtlin++ != ';') ;
            }

            /*
             * If the RTL has side effects, then we need to check those
             * to ensure that we don't miss out on anything that is set
             * but is not explicit in the actual RTL.
             */
            if (rtlin = rtlptr->se) {
               while (*rtlin) {
                  if (isrg(rtlin)) {
                     real = s_add(rtlin);
                     for (a = aliases(rtlin); *a; a = skiploc(a) + 1) {
                        sptr = s_add(a);
                        if (sptr->status & FIFOREG)
                           touchreg(loop->regs, a);
                        else if (sptr->sets)
                           sptr->dead = rtlptr;
                        else if (!sptr->dead) {
                           sptr->sets = rtlptr;
                           if (sptr == real) {
                              if (first)
                                 touchreg(loop->regs, a);
                              while (*rtlin++ != '=') ;
                              for (st = rtlin; *rtlin != ';'; rtlin++) ;
                              *rtlin = '\0';
                              if (is_invariant
                                  (st, first | *writes, loop, rtlptr))
                                 sptr->assign = TRUE;
                              *rtlin = ';';
                           }
                        }
                     }
                  }
                  while (*rtlin++ != ';') ;
               }
            }

            /*
             * On the first pass, we must also look at which registers are
             * used for allocation purposes.
             */
            if (first)
               for (rtlin = rtlptr->val; rtlin = gtrg(rtlin);
                    touchreg(loop->regs, unskiploc(rtlin))) ;
         }

         /*
          * Treat registers that are implicitly set
          */
         else if (rtlptr->type & SETLINE) {
            for (rtlin = rtlptr->val; *rtlin; rtlin = skiploc(rtlin)) {
               for (a = aliases(rtlin); *a; a = skiploc(a) + 1) {
                  touchreg(loop->regs, a);
                  sptr = s_add(a);
                  sptr->sets = sptr->dead = rtlptr;
               }
            }
         }
      }
   }

   /*
    * Save the list of registers known to be loop invariant in the loop
    * structure so that they can be referenced later by other phases.
    * Also, if there are no memory writes in the loop, note the fact that
    * all memory reads within the loop are loop invariant.
    */
   if (analysis_only) {
      /*
       * Move any item that has been set only once inside the loop to
       * the preheader of the loop.  Note that if the item reads from memory
       * and is not located in the loop so that it is always executed, then
       * do not move it out of the loop since it may be the case that one of
       * the conditions that exit the loop tests to see if the memory item
       * is invalid to read and avoids it in certain cases.  If this is the
       * case, then we may move a memory item to the pre-header that may,
       * in some cases, cause a memory fault.
       */
      for (sptr = setsused; sptr; sptr = sptr->next) {
         if (sptr->assign && !sptr->ldead && !sptr->dead) {
            if ((sptr->ldead = sptr->sets) && sptr->ldead != top->rtls) {
               if (
#ifdef INTERACT
		   /*(swm || !swq) &&*/
		   (swm || swq) &&
#endif
                     (!reads_mem(sptr->ldead->val)
                      || everytime(loop, sptr->ldead->daddy))) ;
               else
                  sptr->ldead = (struct list *) NULL;
            }
         }
         else if (!sptr->ldead) {
            sptr->dead = (struct list *) NULL;
            if (sptr->sets != top->rtls)
               sptr->sets = (struct list *) NULL;
         }
      }
      for (sptr = setsused; sptr; sptr = sptr->next)
         if (sptr->ldead)
            rins(sptr->num, &loop->invareg);
      if (!*writes)
         loop->invaread = TRUE;
   }
}

/*
 * LoopAnalysesForProfiling - global data profiling needs the loop iteration
 * count to be accurate.  In order for iterations() to succeed in determining
 * the iteration count, certain analyses are required.  These are usually
 * performed as part of code motion.  However, code motion moves many global
 * address computations out of their loops, causing references to globals
 * inside loops to be obscured as register-indirect addressing.  Global data
 * profiling is thus best done just prior to code motion, but needs some
 * code motion analyses, which are performed from this function.
 */
int LoopAnalysesForProfiling(struct loopl *loop, char *init,
			      int *inc, char *cval, int *relop)
{
   struct list *rtlptr;
   struct blist *cptr;
   struct bblock *cblk;
   struct setlist *sptr;
   char *rtlin;
   int   writes, flag;
   int   volatile_mem_acc = FALSE;
   int   debug_flag = (swd && debug_opt("loop_iterations"));

   /*
    * Examine passed loop, starting from the innermost loops and moving
    * outwards, for loop invariant items that can be moved to the
    * preheader of the loop.
    */
   loop_invariant_init(loop);

   writes = FALSE;

   /* Make sure there is no trash line. If there is a trash line,
    * we cannot move any reads to preheader and it is the same as if
    * there is a write in the loop.
    */
   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
     for (rtlptr = cptr->ptr->rtls; rtlptr; rtlptr = rtlptr->next) {
       if (rtlptr->type & TRASHLINE) {
	 if (fmatch(rtlptr->val, "&") || fmatch(rtlptr->val, "*")) {
	   volatile_mem_acc = TRUE;
	   goto volatile_check_end;
	 }
       }
     }
   }

 volatile_check_end:

   /*loop_invariant analysis works in 2 stages. The first time it is called,
     we need to do additional analysis and set some structures used in the
     second pass*/
   loop_invariant_analysis(loop, TRUE, TRUE, &writes);
   loop_invariant_analysis(loop, FALSE, TRUE, &writes);
   
   /*
    * Locate the basic induction variables in the loop.  Note that we have
    * to examine both an RTL and its side effects, if any, to get the
    * correct induction variable information.  Also, set and reserve lines
    * warn us about registers that may be modified by external function
    * calls and other special instructions.
    */
   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
     cblk = cptr->ptr;
     for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
       if (rtlin = cnts(rtlptr)) {
	 getbasic(rtlptr, rtlin, loop);
	 if (rtlin = rtlptr->se)
	   getbasic(rtlptr, rtlin, loop);
       }
       else if (rtlptr->type & RESLINE) {
	 if (sptr = s_lookup(rtlptr->val)) {
	   sptr->uses++;
	   sptr->regstatus = NOTINDUCTION;
	 }
       }
       else if (rtlptr->type & SETLINE) {
	 char *a;
	 for (rtlin = rtlptr->val; *rtlin; rtlin = skiploc(rtlin))
	   for (a = aliases(rtlin); *a; a = skiploc(a) + 1)
	     if (sptr = s_lookup(a))
	       sptr->uses++;
       }
     }         /* end for (rtlptr = cblk->rtls; ...) */
   }            /* end for (cptr = loop->blocks; ...) */
   
   /*
    * Any item that is not a basic induction variable is left unassigned
    */
   for (sptr = setsused; sptr; sptr = sptr->next)
     if ((sptr->regstatus & BASIC) == 0)
       sptr->regstatus = UNASSIGNED;
   
   /*
    * If we do not yet know how many times this loop iterates, attempt to
    * determine that fact.  If this value can be determined, it might be
    * possible to reduce the amount of work required to ensure that the loop
    * iterates only the number of times required.  Also, it can be used
    * to decrease the amount of work needed to obtain execution-time counts
    * of the basic blocks in the loop.
    */
   if(init)
     flag = loop_iterations(loop, &loop->control, loop->iterations,
			    init, inc, cval, relop);
   else if(!loop->valid) {
     flag = iterations(loop, &loop->control, loop->iterations);

     if(flag){
       if (debug_flag 
	   && debug_opt_l("loop_iterations", loop->ptr->label)) {
	 (void) fprintf(stderr, "From LoopAnalysesForProfiling() : \n");
	 (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
	 (void) fprintf(stderr, "Number of iterations: ");
	 show_rtl(stderr, loop->iterations);
	 (void) fprintf(stderr, "\n");
	 (void) fprintf(stderr, "Control variable: ");
	 show_rtl(stderr, loop->control->item);
	 (void) fprintf(stderr, "\n");
	 (void) fflush(stderr);
       }
     }
     else if (debug_flag) {
       (void) fprintf(stderr, "From LoopAnalysesForProfiling() : \n");
       (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
       (void) fprintf(stderr, "Unknown number of iterations.\n");
       (void) fflush(stderr);
     }
     loop->valid = TRUE;
   }            /* end if (!loop->valid) */
   return flag;
}                  /* end of LoopAnalysesForProfiling() */

/*
 * code_motion - detect loop-invariant computations and perform code motion
 */
int code_motion(int invocation)
{
   register char *rtlin;
   register struct setlist *sptr;
   register struct list *rtlptr;
   register struct bblock *cblk;
   register struct loopl *loop;
   register int first;
   struct list *nptr;
   struct setlist *real;
   struct blist *cptr;
   int   alter, change, t_change, dif, found, writes;
   char  new[MAXSTRING], reg[MAXSTRING], expr[MAXSTRING], *a, *b, *c, *st;
   char  check[MAXSTRING];
   int   volatile_mem_acc = FALSE;
#ifdef INTERACT
   int   old_rtl_id;
   extern valid_analysis;
   extern unsigned int needs_analysis[NUM_TRANS_TYPES];
   extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];
#endif

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd && debug_opt_i("dump_before_loop_optimizations", invocation))
      dump_function_i("before loop_optimizations()", invocation,
                      SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Examine each loop, starting from the innermost loops and moving
    * outwards, for loop invariant items that can be moved to the
    * preheader of the loop.
    */
   alter = FALSE;
   t_change = change = FALSE;
   for (loop = loops; loop; loop = loop->next) {
#ifdef INTERACT
      if (swq && limited_scope && !loop->ptr->inscope)
         continue;
#endif

      /*
       * Check to see if the user would like to see the state of the
       * function at this point in time.
       */
      if (swd
          && debug_opt_i_l("dump_before_code_motion", invocation,
                           loop->ptr->label))
         dump_function_i_l("before code_motion()", invocation,
                           loop->ptr->label,
                           SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                           SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);


      /*loop for all_loop_trans to occur on each loop in that order*/
      do{

#ifdef INTERACT
	begin_phase(CODE_MOTION_TRANS);
#elif VET
	begin_phase(CODEMOTION_PHASE);
#endif

	loop_invariant_init(loop);
	
	first = TRUE;
	writes = FALSE;
	t_change = FALSE;

	/* Make sure there is no trash line. If there is a trash line,
	 * we cannot move any reads to preheader and is same as if there
	 * is a write in the loop */

	for (cptr = loop->blocks; cptr; cptr = cptr->next) {
	  for (rtlptr = cptr->ptr->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & TRASHLINE) {
	      if (fmatch(rtlptr->val, "&") || fmatch(rtlptr->val, "*")) {
		volatile_mem_acc = TRUE;
		goto volatile_check_end;
	      }
            }
	    
	  }
	}
      volatile_check_end:
	;
	
	do {
	  
	  loop_invariant_analysis(loop, first, FALSE, &writes);
	  change = first = FALSE;
	  
	  /*
	   * Move any item that has been set only once inside the loop to
	   * the preheader of the loop.  Note that if the item reads from memory
	   * and is located such that it may not always be executed, then
	   * do not move it out of the loop since it may be the case that one of
	   * the conditions that exit the loop tests to see if the memory item
	   * is invalid to read and avoids it in certain cases.  If this is the
	   * case, then we may move a memory item to the pre-header that may,
	   * in some cases, cause a memory fault.
	   * Another potential bug: what if there was a divide by zero that was
	   * guarded.  We might move it to the preheader and a fault could occur
	   * when the code is executed.
	   */
         for (sptr = setsused; sptr; sptr = sptr->next) {
            if (sptr->assign && !sptr->ldead && !sptr->dead) {
               if ((sptr->ldead = sptr->sets) && sptr->ldead != top->rtls) {
                  if (
#ifdef INTERACT
                        (swm || !swq) &&
#endif
                        (!reads_mem(sptr->ldead->val)
                         || everytime(loop, sptr->ldead->daddy))) {

                     /* WHOA! bug report! loop_invariant_analysis() sets
                      * sptr->assign = TRUE if the rhs of this effect is
                      * invariant. But just because one effect 
                      * is invariant, doesn't mean the whole RTL can move.
                      * The item may be invariant, but another effect of the
                      * RTL may contain items that are not
                      * invariant.  We need to check for those here.
                      */

                     int   can_move = TRUE;
                     a = sptr->ldead->val;
                     while (a && (a = gtrg(a))) {
                        struct setlist *rptr;
                        if (!(rptr = s_lookup(unskiploc(a)))
                            || !rptr->ldead)
                           can_move = FALSE;
                     }
                     a = sptr->ldead->se;
                     while (a && (a = gtrg(a))) {
                        struct setlist *rptr;

                        /* If in the SE we see: item=; then the item is
                         * destroyed. It's OK to destroy it less often.
                         */
                        if (*a == '=' && *(a + 1) == ';')
                           continue;

                        if (!(rptr = s_lookup(unskiploc(a))) || !rptr->ldead)
                           can_move = FALSE;

                     }
                     /*-
                      * The above check is not strong enough to detect cases 
                      * like:
                      * L[result]=L[result]+1; {n[0]=;}
                      * Here n[0] is found to be invariant, and vpo ends
                      * up hoisting the whole RTL. So, call is_invariant() on
                      * the whole RTL and its side-effect.
                      */
                     if (a = cnts(sptr->ldead))
                        if (!is_invariant
                            (a, writes | volatile_mem_acc, loop, sptr->ldead))
                           can_move = FALSE;
                     if (a = sptr->ldead->se)
                        if (!is_invariant
                            (a, writes | volatile_mem_acc, loop, sptr->ldead))
                           can_move = FALSE;

                     /* Cannot move a memory read into preheader if there is a
                      * volatile mem access in the loop.
                      */
                     if (reads_mem(sptr->ldead->val) && volatile_mem_acc)
                        can_move = FALSE;

                     if (can_move) {

#ifdef VET
                        begin_trans(VET_OPT_TRANS);
#endif
                        move_rtl_to_preheader(loop, sptr->ldead);
#ifdef VET
                        end_trans();
#endif
                        alter = change = TRUE;
                     }
                     else
                        sptr->ldead = (struct list *) NULL;
                  }
                  else
                     sptr->ldead = (struct list *) NULL;
               }
            }
            else if (!sptr->ldead) {
               sptr->dead = (struct list *) NULL;
               if (sptr->sets != top->rtls)
                  sptr->sets = (struct list *) NULL;
            }
         }

         /*
          * Search through the loop for items that are loop invariant but
          * need to be allocated a register because they didn't have the
          * luxury of being placed in an existing register already.
          */
#ifdef INTERACT
         if (swm || !swq) {
#endif
            for (cptr = loop->blocks; cptr; cptr = cptr->next) {
               cblk = cptr->ptr;
               for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
                  if (cnts(rtlptr)) {
#ifdef VET
                     begin_trans(VET_OPT_TRANS);
#endif
                     dif = FALSE;
                     (void) strcpy(rtlin = new, rtlptr->val);

                     /*
                      * Examine each individual effect of the RTL
                      */
                     while (*(c = rtlin)) {
                        while (*rtlin++ != '=') ;
                        for (st = rtlin; *rtlin != ';'; rtlin++) ;
                        *rtlin = '\0';

                        /*
                         * If the expression is loop invariant, it might be
                         * worth moving its calculation outside of the loop.
                         */
                        if (is_invariant
                            (st, writes | volatile_mem_acc, loop, rtlptr)) {
                           *rtlin = ';';

                           /*
                            * Ensure that we know the cost of the initial RTL
                            * to give us an idea of whether or not our changes
                            * are worthwhile.
                            */
                           if (!rtlptr->cost) {
                              if (find(rtlptr, new, rtlptr->deads)) {
                                 (void) fprintf(stderr,
                                              "vpo (docm): cannot assemble '");
                                 show_rtl(stderr, new);
                                 (void) fprintf(stderr, "'\n");
                              }
                              else {
                                 rtlptr->cost = icost;
                                 rtlptr->kind = ikind;
#ifdef INTERACT
                                 mod_kind(rtlptr);
#endif
                              }
                           }

                           a = expr;
                           b = rtlin = st;
                           while ((*a++ = *rtlin++) != ';') ;
                           *a = '\0';
                           found = FALSE;

                           /*
                            * Look at our list of invariant items, and see if
                            * any register already contains this invariant
                            * expression.
                            */
                           for (sptr = setsused; sptr; sptr = sptr->next) {
                              if (sptr->ldead && sptr->ldead != top->rtls) {
                                 a = sptr->ldead->val;
                                 while (*a++ != '=') ;
                                 if (!strcmp(a, expr)) {
                                    rtlin = sub(b, rtlin - 1, sptr->item) + 1;
                                    if (!find(rtlptr, new, rtlptr->deads)
                                        && icost < ((int) rtlptr->cost)) {
                                       rtlptr->cost = icost;
                                       rtlptr->kind = ikind;
                                       dif = TRUE;
                                    }
                                    else
                                       rtlin = sub(b, rtlin - 1, expr) + 1;
                                    found = TRUE;
                                    break;
                                 }
                              }
                           }

			   /*if(!found)
			     fprintf(stderr, "PK: Invariant item not assigned to register\n");
			   */
			   
                           /*
                            * If no matching invariant item is found, then 
                            * attempt to allocate a new register to contain
                            * the loop invariant item.
                            */
                           if (!found
                               && cancolor(usetype(c), loop->regs, reg, FALSE)
                               && (!reads_mem(st) || everytime(loop, cblk))) {

                              int   should_move = TRUE;
                              rtlin = sub(b, rtlin - 1, reg) + 1;
                              a = check;
                              copyloc(a, reg);
                              a = skiploc(a);
                              *a++ = '=';

                              if (swd && debug_opt("size")) {
                                 /* We'll be inserting a copy into the loop and
                                  * moving the RHS to the preheader.
                                  * If we're doing size optimizations, this is
                                  * only a win if the copy goes away.
                                  * We'll find the live range of the copy to
                                  * make sure CSE can get rid of it later.
                                  */

                                 if (isreg(c)) {
                                    rlist lives = rinit();
                                    struct rtl_list *rtlist = NULL;
                                    struct blist *blocklist = NULL;
                                    int   is_use = TRUE;
                                    if (*skiploc(c) == '=')
                                       is_use = FALSE;
                                    if (!find_live_range
                                        (rtlptr, c, is_use, &lives, &rtlist,
                                         &blocklist))
                                       should_move = FALSE;

                                 }
                              }
                              c = expr;
                              while (*a++ = *c++) ;
                              *a = '\0';
#ifdef VET
                              /* Don't wish to send a message about a new RTL
                               * if it is immediately deleted.
                               */
                              delayed_viewing = TRUE;
#endif
                              nptr = insinvar(cblk, rtlptr, check);
                              if (should_move
                                  && !find(nptr, check, nptr->deads)
                                  && !find(rtlptr, new, rtlptr->deads)
                                  && icost < ((int) rtlptr->cost)) {
                                 rtlptr->cost = icost;
                                 rtlptr->kind = ikind;
                                 dif = TRUE;
                                 sptr = s_add(reg);
#ifdef VET
                                 /* Have to set to FALSE here since movetohead
                                  * may cause creation of new block as
                                  * preheader and a new unconditional jump.
                                  */
                                 delayed_viewing = FALSE;
                                 insert_rtl(nptr);
#endif
                                 move_rtl_to_preheader(loop, sptr->ldead =
                                                       nptr);
                              }
                              else {
                                 remv_rtl(nptr);
#ifdef VET
                                 delayed_viewing = FALSE;
#endif
                                 rtlin = sub(b, rtlin - 1, expr) + 1;
                                 releasereg(loop->regs, reg);
                              }
                           }
                        }
                        else
                           *rtlin++ = ';';
                     }

                     /*
                      * If a change has been made to the RTL, update the
                      * appropriate information.
                      */
                     if (dif) {
                        update_rtl(rtlptr, new);
                        rtlptr->type &= ~SIDEFFECT;

                        if (rtlptr->se)
                           update_se(rtlptr, NULL);
                        combmark(rtlptr);
                        alter = TRUE;
                     }
#ifdef VET
                     end_trans();
#endif
                  }
               }
            }
#ifdef INTERACT
         }
#endif

         /*
          * If there are no writes in the loop, then all reads are loop
          * invariant.  We are now going to make a pass through the loop
          * looking for memory references.  If they are located, then we
          * will attempt to move them out of the loop.  We do this first
          * because eliminating memory references from loops is such a
          * big win (on the average).
          */
         if (
#ifdef INTERACT
               (swm || !swq) &&
#endif
               !writes && !volatile_mem_acc) {
            for (cptr = loop->blocks; cptr; cptr = cptr->next) {
#ifdef VET
               begin_trans(VET_OPT_TRANS);
#endif
               cblk = cptr->ptr;
               for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
                  if (cnts(rtlptr) && gtmem(rtlptr->val)) {
                     dif = FALSE;
                     (void) strcpy(rtlin = new, rtlptr->val);

                     /*
                      * Examine each memory reference inside the RTL
                      */
                     while (rtlin = gtmem(rtlin)) {
                        gtstr(b = bpos, rtlin, expr);
                        if (is_invariant(expr, FALSE, loop, rtlptr)) {
                           found = FALSE;

                           /*
                            * Look at our list of invariant items, and see if a
                            * register already contains this invariant
                            * expression.
                            */
                           for (sptr = setsused; sptr; sptr = sptr->next) {
                              if (sptr->ldead && sptr->ldead != top->rtls) {
                                 a = sptr->ldead->val;
                                 while (*a++ != '=') ;
                                 for (c = expr; *a == *c; c++)
                                    a++;
                                 if (!*c && *a == ';') {
                                    rtlin = sub(b, rtlin, sptr->item);
                                    if (!find(rtlptr, new, rtlptr->deads)) {
                                       rtlptr->cost = icost;
                                       rtlptr->kind = ikind;
#ifdef INTERACT
                                       mod_kind(rtlptr);
#endif
                                       dif = TRUE;
                                    }
                                    else
                                       rtlin = sub(b, rtlin, expr);
                                    found = TRUE;
                                    break;
                                 }
                              }
                           }

                           /*
                            * If no matching invariant item is found, then try
                            * to allocate a new register to contain the loop
                            * invariant item.
                            */
                           if (!found && everytime(loop, cblk)
                               && cancolor(memtype(expr), loop->regs, reg,
                                           FALSE)) {
                              rtlin = sub(b, rtlin, reg);
                              a = check;
                              copyloc(a, reg);
                              a = skiploc(a);
                              *a++ = '=';
                              c = expr;
                              while (*a++ = *c++) ;
                              *(a - 1) = ';';
                              *a = '\0';
                              nptr = insinvar(cblk, rtlptr, check);
                              if (!find(nptr, check, nptr->deads)
                                  && !find(rtlptr, new, rtlptr->deads)) {
                                 rtlptr->cost = icost;
                                 rtlptr->kind = ikind;
#ifdef INTERACT
                                 mod_kind(rtlptr);
#endif
                                 dif = TRUE;
                                 sptr = s_add(reg);
                                 move_rtl_to_preheader(loop, sptr->ldead =
                                                       nptr);
                              }
                              else {
                                 remv_rtl(nptr);
                                 rtlin = sub(b, rtlin, expr);
                                 releasereg(loop->regs, reg);
                              }
                           }
                        }
                     }

                     /*
                      * If a change has been made to the RTL, update the
                      * appropriate information.
                      */
                     if (dif) {
                        update_rtl(rtlptr, new);
                        rtlptr->type &= ~SIDEFFECT;
                        if (rtlptr->se)
                           update_se(rtlptr, NULL);
                        combmark(rtlptr);
                        alter = TRUE;
                     }
                  }
               }
#ifdef VET
               end_trans();
#endif
            }
         }

	 t_change |= change;
      } while (change);
#ifdef INTERACT
      end_phase(CODE_MOTION_TRANS);
#elif VET
      end_phase(CODEMOTION_PHASE);
#endif

      /*
       * Save the list of registers known to be loop invariant in the loop
       * structure so that they can be referenced later by other phases.
       * Also, if there are no memory writes in the loop, note the fact that
       * all memory reads within the loop are loop invariant.
       */
      for (sptr = setsused; sptr; sptr = sptr->next)
         if (sptr->ldead)
            rins(sptr->num, &loop->invareg);
      if (!writes && !volatile_mem_acc)
         loop->invaread = TRUE;

      /*
       * Check to see if the user would like to see the state of the
       * function at this point in time.
       */
      if (swd
          && debug_opt_i_l("dump_after_code_motion", invocation,
                           loop->ptr->label))
         dump_function_i_l("after code_motion()", invocation,
                           loop->ptr->label,
                           SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                           SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

      /*
       * Perform strength reduction on this loop if the user has requested
       * it.  Note that the strength reduction phase makes use of the loop
       * invariant and register allocation information collected by the code
       * motion phase.
       */
      if (sws && !(swd && debug_opt_l("no_reduction", loop->ptr->label)))
         change = loop_strength_reduction(loop, invocation);
      alter |= change;

#ifdef WIDES
      if (update_loop_info && swy) {
         depth_first_search(d_f_s_count++);
         clear_loops();
         depth_first_search(d_f_s_count++);
         build_dominator_tree(b_d_t_count++);
         find_loops(3);
         order_loops();
         find_loop_exits();
         update_loop_info = FALSE;
      }
#endif

      t_change |= change;
      }while(t_change);
   }
   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd && debug_opt_i("dump_after_loop_optimizations", invocation))
      dump_function_i("after loop_optimizations()", invocation,
                      SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Indicate if any changes have been made to the function
    */
   return t_change;
} /* end of code_motion() */


/*
 * ind_var_analysis - find basic and regular induction variables in all the
 *                    loops in this function.
 */
void ind_var_analysis(struct loopl *loop)
{
  char *rtlin;
  int change;
  struct bblock *cblk;
  struct blist *cptr;
  struct list *rtlptr;
  struct llist *bptr;
  struct setlist *sptr;
  
  /*
   * Locate the basic induction variables in the loop.  Note that we have
   * to examine both an RTL and its side effects, if any, to get the
   * correct induction variable information.  Also, set and reserve lines
   * warn us about registers that may be modified by external function
   * calls and other special instructions.
   */
  for (cptr = loop->blocks; cptr; cptr = cptr->next) {
    cblk = cptr->ptr;
    for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
      if (rtlin = cnts(rtlptr)) {
	getbasic(rtlptr, rtlin, loop);
	if (rtlin = rtlptr->se)
	  getbasic(rtlptr, rtlin, loop);
      }
      else if (rtlptr->type & RESLINE) {
	if (sptr = s_lookup(rtlptr->val)) {
	  sptr->uses++;
	  sptr->regstatus = NOTINDUCTION;
	}
      }
      else if (rtlptr->type & SETLINE) {
	char *a;
	for (rtlin = rtlptr->val; *rtlin; rtlin = skiploc(rtlin))
	  for (a = aliases(rtlin); *a; a = skiploc(a) + 1)
	    if (sptr = s_lookup(a))
	      sptr->uses++;
      }
    }
  }
  
  /*
   * Any item that is not a basic induction variable is left unassigned
   */
  for (sptr = setsused; sptr; sptr = sptr->next)
    if ((sptr->regstatus & BASIC) == 0)
      sptr->regstatus = UNASSIGNED;
  
  /*
   * Look for regular induction variables.  These are items that are built
   * up from basic induction variables and other induction variables.  These
   * items may be simple, consisting of only a single RTL that uses a basic
   * induction variable, or complex, built up over two or more RTLs.  Since
   * the RTLs are target machine instructions, the number of RTLs required
   * to form a complex induction variable will vary.  What may be a simple
   * induction variable on one machine, may be complex on another.  Here, we
   * will search through every basic block in the loop and look at each item
   * set within the loop.  Note that we may need to scan the loop an
   * arbitrary number of times.  This is because some induction variables may
   * be built up from other induction variables.  On the first pass through
   * the loop, we will recognize only those induction variables that are
   * built up from basic induction variables.  On the second pass, we may
   * find new induction variables built up from the induction variables found
   * in the first pass.  This process can repeat itself through many passes.
   * We continue to scan through the loop until we complete a pass where no
   * new induction variables are found.
   */
  do {
    change = FALSE;
    
    /*
     * Examine each basic block in the current loop
     */
    for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
	
	/*
	 * Examine both the RTL and its side effect, if any, to determine
	 * if the item is a regular induction variable.  Assume that any
	 * item that is set as a side effect is not a regular induction
	 * variable.
	 */
	if (rtlin = cnts(rtlptr)) {
	  getind(loop, cblk, rtlptr, rtlin);
	  if (rtlin = rtlptr->se) {
	    while (*rtlin) {
	      if (isrg(rtlin) && (sptr = s_lookup(rtlin))
		  && !(sptr->status & FIFOREG)
		  && !(sptr->
		       regstatus & (NOTINDUCTION | BASIC | INDUCTION)))
		sptr->regstatus = NOTINDUCTION;
	      while (*rtlin++ != ';') ;
	    }
	  }
	}
	
	/*
	 * Items that are reserved are implicitly set, therefore, since
	 * we cannot determine the nature of their modification, we assume
	 * that they are not valid induction variables.
	 */
	else if (rtlptr->type & RESLINE && rtlptr->val) {
	  if (sptr = s_lookup(rtlptr->val))
	    sptr->regstatus = NOTINDUCTION;
	}
      }
    }
    
    /*
     * Make any registers that are still marked as possible induction
     * variables after the whole loop is examined true induction variables.
     */
    for (sptr = setsused; sptr; sptr = sptr->next) {
      if (sptr->regstatus == MAYBEIND) {
	sptr->regstatus = sptr->triple->status = INDUCTION;
	change = TRUE;
      }
#if 0
      if (sptr->regstatus & (BASIC | INDUCTION) && isreg(sptr->item)) {
	sptr->regstatus |= INAREG;
	sptr->status |= INAREG;
      }
#endif
    }
    
  } while (change);
  
  /*
   * If the user wishes to see the induction variable information gathered
   * for the loop, then display it.
   */
  if (swd && debug_opt_l("loop_strength_reduction", loop->ptr->label)) {
    for (sptr = setsused; sptr; sptr = sptr->next) {
      if (sptr->regstatus & (BASIC | INDUCTION)) {
	if (sptr->regstatus & BASIC)
	  (void) fprintf(stderr, "basic induction var: item=");
	else
	  (void) fprintf(stderr, "induction variable : item=");
	show_rtl(stderr, sptr->item);
	(void) fprintf(stderr, ", family=");
	show_rtl(stderr, sptr->triple->family->item);
	(void) fprintf(stderr, ", cee=%d, dee=", sptr->triple->cee);
	show_rtl(stderr, sptr->triple->dee);
	(void) fprintf(stderr, ", count=%d", sptr->triple->count);
	for (bptr = sptr->triple->ref; bptr; bptr = bptr->next) {
	  (void) fprintf(stderr, ", inc=%d, ", bptr->inc);
	  show_rtl(stderr, bptr->ptr->val);
	}
	(void) fprintf(stderr, "\n");
      }
    }
    (void) fflush(stderr);
  }
}


/*
 * loop_strength_reduction - perform loop strength reduction
 */
int loop_strength_reduction(struct loopl *loop, int invocation)
{
   char *rtlin;
   struct setlist *sptr;
   struct list *rtlptr;
   struct bblock *cblk;
   struct itriple *tptr;
#ifdef STREAM
   struct itriple *mptr;
#endif
   struct list *dptr[10];
   struct llist *bptr;
   struct memgroup *pptr, *preg;
   struct memitem *mref;
   struct blist *cptr;
   struct setlist *fptr;
   int   cee, alter, change, nogo, complex, writeall, readall, clash;
   char *a, dee[MAXSTRING], str[MAXSTRING], new[MAXSTRING];
   char  handle[MAXSTRING], expr[MAXSTRING];
#ifdef INTERACT
   extern int started_trans;
#endif   

   /*
    * Remember if any changes are made to the function during this invocation
    * of the loop strength reduction phase.
    */
   alter = FALSE;

   /*
    * Locate the induction variables in the loops
    */
   ind_var_analysis(loop);

   /*
    * If we do not yet know how many times this loop iterates, attempt to
    * determine that fact.  If this value can be determined, it might be
    * possible to reduce the amount of work required to ensure that the loop
    * iterates only the number of times required.  Also, it can be used
    * to decrease the amount of work needed to obtain execution-time counts
    * of the basic blocks in the loop.
    */
   if (!loop->valid) {
      if (iterations(loop, &loop->control, loop->iterations)) {
         if (swd && debug_opt_l("loop_iterations", loop->ptr->label)) {
            (void) fprintf(stderr, "From loop_strength_reduction() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Number of iterations: ");
            show_rtl(stderr, loop->iterations);
            (void) fprintf(stderr, "\n");
            (void) fprintf(stderr, "Control variable: ");
            show_rtl(stderr, loop->control->item);
            (void) fprintf(stderr, "\n");
            (void) fflush(stderr);
         }
      }
      else {
         if (swd && debug_opt_l("loop_iterations", loop->ptr->label)) {
            (void) fprintf(stderr, "From loop_strength_reduction() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Unknown number of iterations.\n");
            (void) fflush(stderr);
         }
      }
      loop->valid = TRUE;
   }

   /*
    * If we determine that this loop is only executed once, then there is
    * no advantage in performing loop strength reduction, recurrence
    * detection, basic induction elimination, streaming and all that good
    * stuff, so we just return at this point.  There was really no point
    * in performing code motion, either, but that has already been done
    * at this point.  A worthwhile future project may be to go back and
    * re-arrange things so that we determine basic induction variables
    * before performing code motion (although I'm not sure that there aren't
    * any interdependencies there) and determine iterations before we go
    * ahead and do any code motion.
    */
   if (!strcmp(loop->iterations, "1")) {
#ifdef INTERACT
      begin_phase(INDUCT_VAR_ELIM_TRANS);
#elif VET
      begin_phase(INDUCTVARELIM_PHASE);
#endif
      goto exit;
   }

   /*
    * Locate and examine the memory references in the loop and determine
    * if there are any induction values used in the address expressions.
    */
   writeall = readall = clash = FALSE;
   preg = (struct memgroup *) NULL;
   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         if (rtlin = cnts(rtlptr)) {

            /*
             * For lack of interprocedural analysis, we will say that a
             * function call potentially writes all memory.  Since on some
             * machines, all calls don't write to memory, we call writes_mem()
             * to get the final word about calls.
             */
            if (!writeall && is_call(rtlin) && writes_mem(rtlin))
               writeall = TRUE;

            /*
             * Locate and examine each memory reference in every effect of this
             * RTL.
             */
            while (rtlin = gtmem(rtlin)) {

               /*
                * Get a copy of the memory reference and of the address
                * expression inside the reference.
                */
               gtstr(bpos, rtlin, dee);
#ifdef ADDR
               gtstr(bpos + 4, rtlin - 2, str);
#else
               gtstr(bpos + 2, rtlin - 1, str);
#endif

            /*
             * Make a copy of the address expression and expand it to include
             * as much as can be obtained by replacing each register item with
             * the last value it was set to.
             */
            (void) strcpy(new, str);
            expand(loop, rtlptr, new);

               /*
                * Make a copy of the address expression and expand it to
                * include as much as can be obtained by replacing each register
                * item with the last value it was set to.
                */
               (void) strcpy(new, str);
               expand(loop, rtlptr, new);

               /*
                * Now make a copy of the expanded address expression and
                * replace any loop invariant registers in the expression with
                * the actual values assigned to these registers, if they can
                * be determined.
                */
               linvar(loop, new, expr);

               /*
                * Now attempt to locate the partition that the memory reference
                * accesses.
                */
               if (getpartition(loop, rtlptr, expr, handle)) {

                  /*
                   * Locate the partition information structure for the handle
                   * or create a new one if it doesn't already exist.
                   */
                  for (pptr = partitions; pptr; pptr = pptr->next)
                     if (!strcmp(handle, pptr->item))
                        break;
                  if (!pptr)
                     pptr = newpartition(handle);

                  /*
                   * Add this reference to the read or write (depending on
                   * which side of the '=' the memory reference is located)
                   * list in the partition information structure.
                   */
                  mref = newmem(rtlptr, dee, new, memtype(dee));
                  if (*rtlin == '=') {
                     mref->next = pptr->writes;
                     pptr->writes = mref;
                  }
                  else {
                     mref->next = pptr->reads;
                     pptr->reads = mref;
                  }

                  /*
                   * Permit only one partition with a register "handle"
                   */
                  if (preg && (isrg(preg->item) || isrg(handle))
                      && pptr != preg)
                     clash = TRUE;
                  else
                     preg = pptr;
               }

               /*
                * If we cannot determine which partition the address expression
                * references, then we conservatively assume that this
                * reference potentially reads or writes all partitions.
                */
               else {
                  pptr = (struct memgroup *) NULL;
                  if (*rtlin == '=')
                     writeall = TRUE;
                  else
                     readall = TRUE;
               }

               /*
                * Determine if the reference contains a valid induction
                * variable.
                */
               fptr = (struct setlist *) NULL;
               if (is_type(new, &fptr, &cee, dee) == BASIC) {
                  /*
                   * If the address expression contains an induction variable
                   * then create a triple information structure for it.  The
                   * type of this triple is INDMEM, which indicates that the
                   * item is a memory reference with a valid triple in the
                   * address expression field.
                   */
                  tptr = newtriple(fptr);
                  tptr->status = INDMEM;
                  (void) strcpy(tptr->pat, str);
                  remparen(dee);
                  if (fptr->regstatus & BASIC) {
                     tptr->cee = cee;
                     (void) strcpy(tptr->dee, dee);
                     if (tptr->part = pptr) {
                        mref->triple = tptr;
                        linvar(loop, dee, mref->dif);
                     }
                  }
                  else
                     calcinduction(tptr, fptr->triple, cee, dee);
                  tptr->ref = newref(rtlptr);
                  tptr->type = ptr_type;

                  /* On a CISC machine such as the i386, we could have an RTL
                   * such as: memlocation=memlocation+4;
                   * A load-store machine would never see this kind of RTL.
                   * If an induction variable is used in the address
                   * computation, then we will find it twice and try to enter
                   * two triples in our triple list.  We can eliminate the
                   * duplicate entry now to keep the data structure sane, and
                   * to avoid later failed attempts to process the same RTLs
                   * twice.
                   */
                  assert(tptr == ftriple);
                  tptr = discard_duplicate_triple();

                  /*
                   * If the user wishes to see the memory reference information
                   * found for this loop, then display it at this time.
                   */
                  if (swd
                      && debug_opt_l("loop_strength_reduction",
                                     loop->ptr->label)) {
                     (void) fprintf(stderr, "Memory reference: ");
                     show_rtl(stderr, fptr->item);
                     (void) fprintf(stderr, ", %d, ", tptr->cee);
                     show_rtl(stderr, tptr->dee);
                     (void) fprintf(stderr, ", ");
                     show_rtl(stderr, str);

                     (void) fprintf(stderr, ", in: ");
                     show_rtl(stderr, rtlptr->val);

                     (void) fprintf(stderr, "\n");
                     (void) fflush(stderr);
                  }
               }
            }
         }
      }
   }

   /*
    * If there is a reference clash, then we potentially read everything
    * only if there are any reads and we potentially write anything only
    * if there is at least one write.
    */
   if (clash) {
      for (pptr = partitions; pptr; pptr = pptr->next) {
         if (pptr->reads)
            readall = TRUE;
         if (pptr->writes)
            writeall = TRUE;
      }
   }

   /*
    * Having obtained all requisite data on loop memory access, perform
    * recurrence detection and optimization on this loop.
    */
#ifdef INTERACT
   if (1 || swk || !swq)
#endif
      alter |= recurrences(loop, writeall, readall, invocation);

#ifdef STREAM
   if (!swd || !debug_opt_l("no_streaming", loop->ptr->label)) {

      /*
       * Search through the triples looking for items that might be streamed
       */
      for (tptr = ftriple; tptr; tptr = tptr->next) {

         /*
          * Only triples that belong to partitions that have no warnings may
          * be considered for streaming.
          */
         if (tptr->status & INDMEM && !(tptr->status & NOTINDUCTION)
             && (pptr = tptr->part) && !(pptr->warn & ST_WARN)) {

            /*
             * The stride is the multiplicative factor times the increment of
             * the basic induction variable on each iteration of the loop.
             */
            for (mptr = tptr; mptr->status != BASIC;
                 mptr = mptr->family->triple) ;
            cee = tptr->cee * mptr->cee;

            /*
             * The triple looks like a candidate for streaming, so pass it on
             * to the machine-dependent streaming function for final
             * consideration.
             */
            if (stream(loop, tptr, tptr->family->triple, cee)) {
               if (swd && debug_opt_l("streaming", loop->ptr->label)) {
                  show_rtl(stderr, tptr->pat);
                  (void) fprintf(stderr, " can be streamed\n");
                  (void) fflush(stderr);
               }
               tptr->status |= NOTINDUCTION;
               alter = TRUE;
            }
         }
      }
   }
#endif /* STREAM */

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_before_loop_strength_reduction", invocation,
                        loop->ptr->label))
      dump_function_i_l("before loop_strength_reduction()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

#ifdef INTERACT
   begin_phase(LOOP_STRENGTH_REDUCT_TRANS);
#elif VET
   begin_phase(STRENGTHRED_PHASE);
#endif
   /*
    * Look through the set of triples and determine which of them
    * should and can be strength reduced.
    */
   for (tptr = ftriple; tptr; tptr = tptr->next) {
      if ((tptr->status & (INDUCTION | INDMEM))
          && !(tptr->status & NOTINDUCTION) && doreduce(tptr)
          && checkind(tptr) && cancolor(tptr->type, loop->regs, dee, FALSE)) {

#ifdef VET
        begin_trans(VET_OPT_TRANS);
#endif
          /*
           * Determine if the triple being strength reduced is complex enough
           * to require two registers to appropriately shadow it.  This must
           * be done in cases where the basic induction variable of the item
           * in a memory reference is in turn dependent on some other induction
           * variable.  For example:
           *
           *    L31:  r[10] = r[9] * 4;
           *          r[9] = r[9] + 1;
           *          R[r[10]] = .....;
           *          PC = ..., L31;
           *
           * Here we see that r[9] is the basic induction variable and that 
           * r[10] is an induction variable in r[9]'s family.  Suppose we did
           * not use a second shadow variable; we would replace r[10] with the
           * first shadow variable and then we would increment that variable at
           * the point at which the basic induction variable (r[9]) is
           * incremented.  We would get the following (erroneous) code:
           *
           *          r[11] = r[9] * 4;     -- initialize shadow variable
           *    L31:  r[10] = r[9] * 4;     -- trash, will be cleaned up later
           *          r[9] = r[9] + 1;
           *          r[11] = r[11] + 4;    -- right increment, wrong place!
           *          R[r[11]] = .....;     -- r[11] shadows r[10]
           *          PC = ..., L31;
           *
           * Although one could conjure up some simple fixes for the example
           * above that would require only a single variable, in general, we
           * need to use two variables to keep the problem manageable.  The
           * transformations we will actually perform for the case above are:
           *
           *          r[11] = r[9] * 4;     -- initialize shadow variable
           *    L31:  r[10] = r[9] * 4;     -- trash, will be cleaned up later
           *          r[12] = r[11];        -- second shadow set
           *          r[9] = r[9] + 1;
           *          r[11] = r[11] + 4;    -- first shadow increments here
           *          R[r[12]] = .....;     -- second shadow used here
           *          PC = ..., L31;
           */
         fptr = tptr->family;
         (void) strcpy(str, dee);
         nogo = complex = FALSE;
         clash = 0;
         while (fptr->triple->family != fptr) {

            /*
             * We need to allocate a new item and make an assignment at
             * each transfer point.  Sometimes, however, we arrive here and
             * because of transformations made previously in this strength-
             * reduction phase, we find that a second shadow variable is no
             * longer required.
             */
            for (bptr = fptr->triple->ref; bptr; bptr = bptr->next) {
               if ((a = cnts(bptr->ptr))
                   && isref(a, fptr->triple->family->item)) {
                  if (!complex) {
                     if (!cancolor(tptr->type, loop->regs, str, FALSE)) {
                        nogo = TRUE;
                        break;
                     }
                     complex = TRUE;
                  }
                  dptr[clash++] =
                   sr_asg(bptr->ptr->daddy, bptr->ptr, dee, str);
               }
            }
            fptr = fptr->triple->family;
         }

         /*
          * In a case related to the complex expression problem described
          * above, we must also create a second shadow variable to handle
          * induction variables that are built up over more than one RTL.
          */
         if (tptr->ref && tptr->ref->next) {
            if (!cancolor(tptr->type, loop->regs, str, FALSE)) {
               nogo = TRUE;
               break;
            }
            for (bptr = tptr->ref; bptr; bptr = bptr->next) {
               if ((a = cnts(bptr->ptr)) && isref(a, tptr->family->item))
                  dptr[clash++] =
                   sr_asg(bptr->ptr->daddy, bptr->ptr, dee, str);
            }
         }

#ifdef VET
        end_trans();
#endif
         /*
          * If a valid strength-reduction candidate has been found and its
          * corresponding shadow register can be appropriately initialized,
          * then go ahead and perform the appropriate transformations to
          * the code.
          */
#ifdef VET
	begin_trans(VET_OPT_TRANS);
#endif
         if (!nogo) {

            /*
             * If this loop does not have an appropriate loop preheader basic
             * block, build one.
             */
            if (!loop->preheader)
               loop->preheader = preheader(loop->ptr);

            /*
             * Determine the expression value that the register (used to
             * strength reduce the item) must be initialized to.
             */
            if (tptr->cee != 1) {
               if (*tptr->dee) {
                  if (needsparen('+', ']', tptr->dee))
                     (void) sprintf(new, "%s*%d+(%s)", fptr->item, tptr->cee,
                                    tptr->dee);
                  else if (*tptr->dee == '-')
                     (void) sprintf(new, "%s*%d%s", fptr->item, tptr->cee,
                                    tptr->dee);
                  else
                     (void) sprintf(new, "%s*%d+%s", fptr->item, tptr->cee,
                                    tptr->dee);
               }
               else if (tptr->cee < 0)
                  (void) sprintf(new, "%s*(%d)", fptr->item, tptr->cee);
               else
                  (void) sprintf(new, "%s*%d", fptr->item, tptr->cee);
            }
            else {
               if (needsparen('+', ']', tptr->dee))
                  (void) sprintf(new, "%s+(%s)", fptr->item, tptr->dee);
               else if (*tptr->dee == '-')
                  (void) sprintf(new, "%s%s", fptr->item, tptr->dee);
               else
                  (void) sprintf(new, "%s+%s", fptr->item, tptr->dee);
            }

            /*
             * Attempt to add RTLs to the loop's preheader to initialize the
             * register to the desired expression.  If we fail, we must release
             * the register and give up on this expression, otherwise, we go
             * ahead and continue the reduction process on the loop itself.
             */

            if (can_reduce(loop, tptr, fptr, dee, str, complex)
                && sr_init(loop, str, new)) {
               alter = TRUE;
               reduce(loop, tptr, fptr, dee, str, complex);
            }
            else {
               releasereg(loop->regs, dee);
               while (clash--)
                  undo(dptr[clash]);
            }
         }
         else {
            releasereg(loop->regs, dee);
            while (clash--)
               undo(dptr[clash]);
         }
#ifdef VET
         end_trans();
#endif
      }
   }
#ifdef INTERACT
   end_phase(LOOP_STRENGTH_REDUCT_TRANS);
#elif VET
   end_phase(STRENGTHRED_PHASE);
#endif

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_after_loop_strength_reduction", invocation,
                        loop->ptr->label))
      dump_function_i_l("after loop_strength_reduction()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Delete unused basic induction variables first.  This will ensure that
    * we do not try to replace a basic induction variable that may not end
    * up being deleted with one that certainly will.
    */
#ifdef INTERACT
   begin_phase(INDUCT_VAR_ELIM_TRANS);
#elif VET
   begin_phase(INDUCTVARELIM_PHASE);
#endif


#ifdef INTERACT
   if (swb || !swq)
#endif
      alter |= remv_induction_variables(loop);



   /*
    * Now looks like a good time to eliminate induction variables by
    * trying to replace them with some of the other items in their family.
    */
#ifdef INTERACT
   if (swb || !swq)
#endif
      if (!swd
          || !debug_opt_i_l("no_induction_variable_elimination", invocation,
                            loop->ptr->label))
         alter |= induction_variable_elimination(loop, invocation);

 exit:
   /*
    * Any basic induction variable that is only incremented and is not needed
    * outside of the loop can be removed, since it is useless.
    */
#ifdef INTERACT
   if (swb || !swq)
#endif
      alter |= remv_induction_variables(loop);

   if (!swd || !debug_opt("no_zolb"))
      alter |= convert_to_repeat_block(loop, invocation);

      /* convert_to_count_down depends on the information collected
       * by loop_strength_reduction about induction variables.
       * We have to place it within a phase.
       * Also based on the assumption that a repeat block is a better
       * transformation than a convert to count down, we place
       * this after the repeat block conversion. This is for
       * targets that support both conversions.
       */
	 if (!swd || !debug_opt("no_count_down_loop")){
	   alter |= convert_to_count_down(loop, invocation);
#ifdef INTERACT
	   if(started_trans)
	     end_trans();
#endif	   
	 }

#ifdef WIDES
   /*
    * Call the wide load/store
    */
   if (swy)
      doubleldst(loop, ftriple);
#endif
#ifdef INTERACT
   end_phase(INDUCT_VAR_ELIM_TRANS);
#else
#ifdef VET
   end_phase(INDUCTVARELIM_PHASE);
#endif
#endif
   /*
    * Release all space allocated to maintain triple information for this loop
    */
   freetriples();

   /*
    * Indicate if any changes have been made to the function
    */
   return alter;
} /* end of loop_strength_reduction() */


/*
 * recurrences - examine loop for possible recurrences and optimize them
 */
int recurrences(struct loopl *loop, int writeall, int readall, int invocation)
{
   register char *rtlin;
   struct itriple *tptr;
   struct llist *bptr;
   struct memgroup *pptr;
   struct memitem *mref, *sref, *mcan, *mnew, *mscn;
   int   change, c, ok, dif;
   char  reg[MAXSTRING], reg1[REGSTRING], reg2[REGSTRING], areg[MAXSTRING];

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_before_recurrences", invocation,
                        loop->ptr->label))
      dump_function_i_l("before recurrences()", invocation, loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Check to see if the user desires to see recurrence debugging information
    */
   if (swd && debug_opt_l("recurrence", loop->ptr->label)) {
      (void) fprintf(stderr, "Recurrence information for loop %s\n",
                     loop->ptr->label);
      (void) fprintf(stderr, "Writeall: %d\n", writeall);
      (void) fprintf(stderr, "Readall: %d\n", readall);
      for (pptr = partitions; pptr; pptr = pptr->next) {
         (void) fprintf(stderr, "Partition: ");
         show_rtl(stderr, pptr->item);
         (void) fprintf(stderr, "\n");
         (void) fprintf(stderr, "  Reads:\n");
         for (mref = pptr->reads; mref; mref = mref->next) {
            (void) fprintf(stderr, "    ");
            show_rtl(stderr, mref->ref);
            if (mref->triple) {
               (void) fprintf(stderr, " {");
               show_rtl(stderr, mref->triple->family->item);
               (void) fprintf(stderr, ", %d, ", mref->triple->cee);
               show_rtl(stderr, mref->triple->dee);
               (void) fprintf(stderr, "} [");
               show_rtl(stderr, mref->dif);
               (void) fprintf(stderr, "]");
            }
            (void) fprintf(stderr, "\n");
         }
         (void) fprintf(stderr, "  Writes:\n");
         for (mref = pptr->writes; mref; mref = mref->next) {
            (void) fprintf(stderr, "    ");
            show_rtl(stderr, mref->ref);
            if (mref->triple) {
               (void) fprintf(stderr, " {");
               show_rtl(stderr, mref->triple->family->item);
               (void) fprintf(stderr, ", %d, ", mref->triple->cee);
               show_rtl(stderr, mref->triple->dee);
               (void) fprintf(stderr, "} [");
               show_rtl(stderr, mref->dif);
               (void) fprintf(stderr, "]");
            }
            (void) fprintf(stderr, "\n");
         }
      }
      (void) fflush(stderr);
   }

#ifdef INTERACT
   begin_phase(RECURRENCE_ELIM_TRANS);
#elif VET
   begin_phase(RECURRENCES_PHASE);
#endif
   /*
    * Check all partitions for possible recurrences
    */
   change = FALSE;
   for (pptr = partitions; pptr; pptr = pptr->next) {

      /*
       * Ensure that all references in a partition are to the same induction
       * variable.
       */
      tptr = (struct itriple *) NULL;
      for (mref = pptr->reads; mref; mref = mref->next) {
         if (!mref->triple) {
            pptr->warn = (SR_WARN | ST_WARN);
            goto nextpart;
         }
         if (!tptr) {
            tptr = mref->triple->family->triple;
            c = mref->triple->cee;
         }
         else if (tptr != mref->triple->family->triple
                  || c != mref->triple->cee) {
            pptr->warn = (SR_WARN | ST_WARN);
            goto nextpart;
         }
      }
      for (mref = pptr->writes; mref; mref = mref->next) {
         if (!mref->triple) {
            pptr->warn = (SR_WARN | ST_WARN);
            goto nextpart;
         }
         if (!tptr) {
            tptr = mref->triple->family->triple;
            c = mref->triple->cee;
         }
         else if (tptr != mref->triple->family->triple
                  || c != mref->triple->cee) {
            pptr->warn = (SR_WARN | ST_WARN);
            goto nextpart;
         }
      }
      c *= tptr->cee;

      /*
       * Remove all items that each element in a partition have in common
       */
      (void) remexpr(pptr, pptr->item);
      if (!(mref = pptr->reads))
         mref = pptr->writes;
      while (gtrgstr(mref->dif, reg)) {
         if (!remexpr(pptr, reg)) {
            pptr->warn = (SR_WARN | ST_WARN);
            goto nextpart;
         }
      }

      /*
       * Glean out what is hopefully only a constant offset from each item
       */
      for (mref = pptr->reads; mref; mref = mref->next) {
         if (*mref->dif) {
            simp(mref->dif, FALSE);
            if (!(rtlin = is_const(mref->dif)) || *rtlin) {
               pptr->warn = (SR_WARN | ST_WARN);
               goto nextpart;
            }
            else
               mref->aofs = mref->ofs = atoi(mref->dif);
         }
      }
      for (mref = pptr->writes; mref; mref = mref->next) {
         if (*mref->dif) {
            simp(mref->dif, FALSE);
            if (!(rtlin = is_const(mref->dif)) || *rtlin) {
               pptr->warn = (SR_WARN | ST_WARN);
               goto nextpart;
            }
            else
               mref->aofs = mref->ofs = atoi(mref->dif);
         }
      }

      /*
       * Since the induction variable can be incremented at numerous locations,
       * and since these increments affect the offset, determine how these
       * impact the offsets for the current partition items.
       */
      for (mref = pptr->reads; mref; mref = mref->next) {
         for (bptr = tptr->ref; bptr; bptr = bptr->next) {
            if (bptr->ptr != mref->ptr && rtl_dominates(bptr->ptr, mref->ptr))
               mref->ofs += mref->triple->cee * bptr->inc;
         }
      }
      for (mref = pptr->writes; mref; mref = mref->next) {
         for (bptr = tptr->ref; bptr; bptr = bptr->next) {
            if (bptr->ptr != mref->ptr && rtl_dominates(bptr->ptr, mref->ptr))
               mref->ofs += mref->triple->cee * bptr->inc;
         }
      }

      /*
       * Order the writes according to offset.  The direction of the order
       * is determined by the sign of the stride (c) of the partition.
       */
      mref = (struct memitem *) NULL;
      while (pptr->writes) {

         /*
          * Locate the least or greatest offset (next item for sorted list)
          */
         mnew = pptr->writes;
         for (sref = mnew->next; sref; sref = sref->next) {
            if (c < 0 && sref->ofs < mnew->ofs)
               mnew = sref;
            else if (c > 0 && sref->ofs > mnew->ofs)
               mnew = sref;
         }

         /*
          * Locate the structure directly in front of mnew
          */
         mcan = (struct memitem *) NULL;
         for (sref = pptr->writes; sref != mnew; sref = sref->next)
            mcan = sref;

         /*
          * Remove mnew from the writes list and add it to the mref list
          */
         if (mcan)
            mcan->next = mnew->next;
         else
            pptr->writes = mnew->next;
         mnew->next = mref;
         mref = mnew;
      }
      pptr->writes = mref;

      /*
       * Order the reads in the same manner as the writes
       */
      mref = (struct memitem *) NULL;
      while (pptr->reads) {
         mnew = pptr->reads;
         for (sref = mnew->next; sref; sref = sref->next) {
            if (c < 0 && sref->ofs < mnew->ofs)
               mnew = sref;
            else if (c > 0 && sref->ofs > mnew->ofs)
               mnew = sref;
         }
         mcan = (struct memitem *) NULL;
         for (sref = pptr->reads; sref != mnew; sref = sref->next)
            mcan = sref;
         if (mcan)
            mcan->next = mnew->next;
         else
            pptr->reads = mnew->next;
         mnew->next = mref;
         mref = mnew;
      }
      pptr->reads = mref;

      /*
       * Check for reads and writes to unknown partitions
       */
      if (pptr->writes && readall) {
         pptr->warn = ST_WARN;
         goto nextpart;
      }
      if (pptr->reads && writeall) {
         pptr->warn = ST_WARN;
         goto nextpart;
      }

      /*
       * look for two references to the same array element in one iteration
       */
      for (mref = pptr->writes; mref; mref = mref->next) {
         for (sref = pptr->reads; sref; sref = sref->next) {


            dif = mref->ofs - sref->ofs;
            /*
             * if we find a distance of zero, two array references in the same
             * iteration.  We bail out of this patition and hope CSE fixes
             * this before the next call to strength reduction.
             */
            if (dif == 0) {
               goto nextpart;
            }
         }
      }
      /*
       * Compare reads against writes looking for possible recurrences.
       */
      for (mref = pptr->writes; mref; mref = mref->next) {
         for (sref = pptr->reads; sref; sref = sref->next) {

            /*
             * If this read reference has already been optimized, then skip it.
             */
            if (sref->done)
               continue;

            /*
             * Calculate the offset difference between the read and write.
             */
            dif = mref->ofs - sref->ofs;

            /*
             * Ensure that the difference is evenly divisible by the stride of
             * the loop, otherwise we have something funny going on and it's
             * best to just avoid this item.
             */
            if (dif % c || dif / c <= 0)
               continue;

            /*
             * Ensure that at least one of the writes at this offset of this
             * partition will be executed at least once on each iteration of
             * the loop, otherwise, we cannot guarantee that the recurrence
             * register will have the correct value at every iteration of
             * the loop.
             */
            ok = FALSE;
            for (mcan = pptr->writes; mcan; mcan = mcan->next) {
               if (mcan->ofs == mref->ofs) {
                  if (everytime(loop, mcan->triple->ref->ptr->daddy)) {
                     ok = TRUE;
                     break;
                  }
               }
            }
            if (!ok)
               continue;

            /*
             * If we get to this point, then we have located a write and read
             * pair that, given enough registers, we can optimize.
             */
            if (swd && debug_opt_l("recurrence", loop->ptr->label)) {
               (void) fprintf(stderr, "Located recurrence in partition ");
               show_rtl(stderr, pptr->item);
               (void) fprintf(stderr, "\n");
               (void) fprintf(stderr, "Between Write:\t");
               (void) fprintf(stderr, "    ");
               show_rtl(stderr, mref->ref);
               if (mref->triple) {
                  (void) fprintf(stderr, " {");
                  show_rtl(stderr, mref->triple->family->item);
                  (void) fprintf(stderr, ", %d, ", mref->triple->cee);
                  show_rtl(stderr, mref->triple->dee);
                  (void) fprintf(stderr, "} [");
                  show_rtl(stderr, mref->dif);
                  (void) fprintf(stderr, "]");
               }
               (void) fprintf(stderr, "\nAnd Read:    \t");
               (void) fprintf(stderr, "    ");
               show_rtl(stderr, sref->ref);
               if (sref->triple) {
                  (void) fprintf(stderr, " {");
                  show_rtl(stderr, sref->triple->family->item);
                  (void) fprintf(stderr, ", %d, ", sref->triple->cee);
                  show_rtl(stderr, sref->triple->dee);
                  (void) fprintf(stderr, "} [");
                  show_rtl(stderr, sref->dif);
                  (void) fprintf(stderr, "]");
               }
               (void) fprintf(stderr, "\nLoop stride=%d\n", c);
               (void) fflush(stderr);
            }

            /*
             * If the user requests that no recurrence optimzation actually
             * take place, then continue on to the next partition at this
             * point.
             */
            if (swd
		&& debug_opt_l("no_recurrence_optimization",
			       loop->ptr->label))
	      continue;

#ifdef INTERACT
	    if(!swk)
	      continue;
#endif	    

            /*
             * Attempt to allocate the appropriate number of reg*isters to
             * optimize this recurrence.
             */
            mnew = (struct memitem *) NULL;

#ifdef VET
	    begin_trans(VET_OPT_TRANS);
#endif 
            while (dif) {

	      if (!cancolor(sref->type, loop->regs, reg, FALSE))
		goto exit;

               /*
                * Put the first register allocated in reg1
                */
               if (ok) {
                  (void) strcpy(reg1, reg);
                  ok = FALSE;
               }

               /*
                * If we need multiple registers, a list is built and each
                * register allocated is remembered.
                */
               if (dif -= c) {
                  mcan = newmem((struct list *) NULL, reg, reg, sref->type);
                  mcan->next = mnew;
                  mcan->ofs = mref->ofs - dif;
                  mcan->triple = mref->triple;
                  mnew = mcan;
               }
            }

            /*
             * Initialize the recurrence registers in the loop preheader to
             * ensure that it has the appropriate value on the first iteration
             * of the loop.
             */
            if (!loop->preheader)
               loop->preheader = preheader(loop->ptr);
            if (!cancolor(sref->type, loop->regs, reg2, FALSE))
               goto exit;
            if (!sr_initialize
                (loop, mnew, reg, sref->type, sref->mem, c, areg)) {
               releasereg(loop->regs, reg2);
               goto exit;
            }

            /*
             * Replace all of the reads to the offset in this partition with
             * references to the appropriate recurrence register.
             */
            for (mcan = pptr->reads; mcan; mcan = mcan->next) {
               if (!mcan->done && mcan->ofs == sref->ofs) {
                  mcan->done = TRUE;
                  replace(mcan->triple->ref->ptr, mcan->ref, reg2);
                  mcan->triple->status |= NOTINDUCTION;
               }
            }

            /*
             * Locate all of the writes to this offset in this partition and
             * set the recurrence register to the value that is written to
             * the partition.
             */
            for (mcan = pptr->writes; mcan; mcan = mcan->next) {
               if (mcan->ofs == mref->ofs)
                  if (!sr_writereg(mcan->triple->ref->ptr, reg, mcan->ref))
                     goto exit;
            }

            /*
             * Since the item which makes up the recurrence reads from the
             * partition in a manner which can be optimized by strength
             * reduction, go ahead and strength reduce those references.
             */
            if (mnew)
               reduce(loop, mref->triple, mref->triple->family, areg, areg,
                      FALSE);
            /*
             * Replace all of the reads for each offset in the pipe with the
             * register containing the appropriate offset value.
             */
            (void) strcpy(areg, reg);
            for (mscn = mnew; mscn; mscn = mscn->next) {
               for (mcan = pptr->reads; mcan; mcan = mcan->next) {
                  if (!mcan->done && mcan->ofs == mscn->ofs) {
                     mcan->done = TRUE;
                     replace(mcan->triple->ref->ptr, mcan->ref, areg);
                     mcan->triple->status |= NOTINDUCTION;
                  }
               }
               (void) strcpy(areg, mscn->ref);
            }

            /*
             * At the top of the loop, insert a series of register to register
             * transfers to move all of the values in the register "pipe" one
             * item closer.
             */
            for (mscn = mnew; mscn; mscn = mscn->next) {
               mscn->ptr = xfer_recurrence(loop, reg, mscn->ref);
               (void) strcpy(reg, mscn->ref);
            }
            (void) xfer_recurrence(loop, reg1, reg2);

            /*
             * Indicate that a code transformation has been made
             */
            change = TRUE;
            while (mnew) {
               mcan = mnew;
               mnew = mnew->next;
               FREETYPE(mcan, MEMITEMTYPE);
            }

          exit:
#ifdef VET
            end_trans();
#endif
            /*
             * Delete the recurrence item database by returning unused
             * registers and freeing up the temporary structures.
             */
            while (mnew) {
               releasereg(loop->regs, mnew->ref);
               mcan = mnew;
               mnew = mnew->next;
               FREETYPE(mcan, MEMITEMTYPE);
            }
         }
      }

    nextpart:
      ;
   }
#ifdef INTERACT
   end_phase(RECURRENCE_ELIM_TRANS);
#elif VET
   end_phase(RECURRENCES_PHASE);
#endif

   /*
    * Check to see if the user desires to see recurrence debugging information.
    */
   if (swd && debug_opt_l("recurrence", loop->ptr->label)) {
      for (pptr = partitions; pptr; pptr = pptr->next) {
         (void) fprintf(stderr, "Partition: ");
         show_rtl(stderr, pptr->item);
         (void) fprintf(stderr, ", warn = %d\n", pptr->warn);
         (void) fprintf(stderr, "  Reads:\n");
         for (mref = pptr->reads; mref; mref = mref->next) {
            (void) fprintf(stderr, "    ");
            show_rtl(stderr, mref->ref);
            (void) fprintf(stderr, " {%d} [", mref->ofs);
            show_rtl(stderr, mref->dif);
            (void) fprintf(stderr, "]\n");
         }
         (void) fprintf(stderr, "  Writes:\n");
         for (mref = pptr->writes; mref; mref = mref->next) {
            (void) fprintf(stderr, "    ");
            show_rtl(stderr, mref->ref);
            (void) fprintf(stderr, " {%d} [", mref->ofs);

            show_rtl(stderr, mref->dif);
            (void) fprintf(stderr, "]\n");
         }
      }
      (void) fflush(stderr);
   }

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_after_recurrences", invocation,
                        loop->ptr->label))
      dump_function_i_l("after recurrences()", invocation, loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Return indicating if any changes have been made to the function
    */
   return change;
} /* end of recurrences() */

/* touch_regs_present - used by loop_init_reg_in.
 * Go through every register in rtlin, and mark it
 * in the regs_in vector.
 */
void touch_regs_present(vector regs_in, char *rtlin)
{
   char *a;
   a = rtlin;
   while (a = gtrg(a)) {
      touchreg(regs_in, unskiploc(a));
   }
}

void touch_all_hw_regs(vector regs_in)
{
   int   index;
   for (index = 0; index < MAXREGS; index++)
      touchindex(regs_in, index);
}

/*
 * loop_init_reg_in - 
 * Initialize the loop->regs_in. Mark every register seen within
 * the loop. Currently used by convert_to_count_down() to detect
 * which registers are used/set within the loop versus those that
 * are simply live across the loop.
 */
void loop_init_reg_in(struct loopl *loop)
{
   register char *rtlin;
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *cptr;
   char *a, *st, *p;

   mrfree(loop->regs_in);
   loop->regs_in = regnew();

   /*
    * Examine each basic block in the current loop
    */
   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

         if (rtlin = cnts(rtlptr)) {
            touch_regs_present(loop->regs_in, rtlin);
            if (rtlin = rtlptr->se)
               touch_regs_present(loop->regs_in, rtlin);
         }
         /*
          * Treat registers that are implicitly set
          */
         else if (rtlptr->type & (SETLINE | PARMLINE)) {
            touch_regs_present(loop->regs_in, rtlptr->val);
         }
         else if (rtlptr->type & TRASHLINE) {
            if (!strcmp(rtlptr->val, "*")) {
               /* '*' is for all locations */
               touch_all_hw_regs(loop->regs_in);
            }
            else if (!strcmp(rtlptr->val, "@")) {
               /* '@' is for scratch regs */
               /* I am not sure how to mark only scratch regs */
               touch_all_hw_regs(loop->regs_in);
            }
            else if (!strcmp(rtlptr->val, "&")) {
               /* '&' is for memory */
            }
            else {
               /* Touch any registers present in rtlptr->val */
               touch_regs_present(loop->regs_in, rtlptr->val);
            }
         }
      }
   }

}

/* reg_not_in_vector - checks if a register is not in
 * a vector. Used by count_down_get_best_reg().
 */
int reg_not_in_vector(vector list, int index, int rcont)
{
   while (rcont--)
      if (vin(list, index++))
         return FALSE;
   /* Every index++ upto rcont is free in list
    * => this register is present in list.
    */
   return TRUE;
}

/* reg_in_vector - checks if a register is present in
 * a vector. Used by count_down_get_best_reg().
 */
int reg_in_vector(vector list, int index, int rcont)
{
   /* Note the negative check. If we did -
    * if vin(list,index++) return TRUE; we could
    * end up returning true for a wider register
    * if one of its 'constituent' half registers
    * were in our list.
    * What we are checking here is that EVERY index++
    * upto rcont is present in list.
    */
   while (rcont--)
      if (!vin(list, index++))
         return FALSE;
   /* Every index++ upto rcont is present in list
    * => this register is present in list.
    */
   return TRUE;
}

/* 
 * count_down_get_best_reg -
 *
 * Strategy:
 * We need to choose the right register for the count down. Our first
 * preference is to use the current control variable, provided it is present in
 * counter_vreglist, and is free (used_in and used_out are FALSE). This could
 * happen in the case where the loop body doesn't use the control variable
 * except as the loop count. In any other case induction_variable_elimination()
 * would probably replace this 'useless' induction variable with another one.
 *
 * Our second choice is any one of the candidate regs that are free.
 * Last choice is to use a non-free register that is live across the loop, but
 * not live inside. When using a non-free register we generate a spill before
 * the loop and a load after the loop.
 * Also later we need to think about this case - not live in, but live out. We
 * will probably need to add an RTL at the loop exit.
 *
 * Note that if the current control variable is not chosen, then the
 * alternatively chosen register is currently not an induction variable, since
 * it is not used in any way within the loop.
 *
 * params
 * loop         -   The loop we are working on.
 * sptr_control -   The control variable (same as loop->control)
 * used_in      -   The control variable has more uses in the loop than what is
 *                  accounted for by its increments and comparison.
 * used_out     -   The control variable is live out of the loop
 * vreglist     -   List of regs that are potential count down register
 *                  candidates
 * spill_load   -   Out parameter - TRUE if this reg is live across loop and
 *                  needs a spill and reload.
 * found_reg    -   Out parameter - the reg that can be used for count down.
 * free_reg     -   Out parameter - the register that can be used to save a
 *                  live-across count down register.
 *
 * Return: TRUE - success
 *         FALSE - failed to find a suitable register 
 */

int count_down_get_best_reg(struct loopl *loop, struct setlist *sptr_control,
                            int used_in, int used_out, vector vreglist,
                            int *spill_load, char *found_reg, char *free_reg)
{
   char *lin;

   int   is_control_in_reglist;
   int   control_used = used_in || used_out;

   int   savl, sskip, check, rt, rcont, regnum;
   char  reg[REGSTRING];

   char  reg_live_across[REGSTRING];
   int   found_live_across = FALSE;

   *spill_load = FALSE;


   *free_reg = 0;


   rt = regtype(sptr_control->item);
   regnum = regnum(sptr_control->item);

   savl = availreg(rt);
   sskip = skipreg(rt);
   rcont = contreg(rt);

   lin = sptr_control->item;
   if (reg_in_vector(vreglist, regtoindex(rt, regnum), rcont)
       && !control_used) {
      copyloc(found_reg, lin);
      *(skiploc(found_reg)) = 0;
      return TRUE;
   }
   /* We are here because either the control variable wasnt in the reglist, or
    * it has uses, and hence cannot be converted. So now we must search for a
    * free register, and if that isnt available, then a register that is live
    * across but has no uses within the loop.
    */


   /* Go through the hardware registers 
    */
   for (check = firstreg(rt); savl--; check += sskip) {

      /*
       * If this register is present in our reglist, then
       * see if it is free or live across.
       * If it is free, return that immediately.
       * If it is live across, save it and continue
       * searching for a free reg.
       */
      if (reg_in_vector(vreglist, check, rcont)) {

         if (reg_not_in_vector(loop->regs, check, rcont)
             && reg_not_in_vector(loop->regs_in, check, rcont)) {
            /* yay! we have found a free register */
            makereg(found_reg, rt, indextoreg(rt, check));
            *(skiploc(found_reg)) = 0;
            return TRUE;
         }
         else if (reg_not_in_vector(loop->regs_in, check, rcont)) {
            /* This register is either live across or live through the loop.
             * We cannot convert a register that is live through the loop.
             * One may think that if this register was a basic induction
             * variable that has only increment points inside the loop and
             * is not live out, we could convert it. But this is not
             * possible because remv_induction_variables() that is called
             * before convert_to_count_down() would have removed such a
             * useless variable.
             *
             */
            makereg(reg_live_across, rt, indextoreg(rt, check));
            *skiploc(reg_live_across) = 0;
            found_live_across = TRUE;
            /* We cannot stop the search right now because we may yet
             * find a free register.
             */
         }
      }
   }

   /* Did we atleast find a live across register? */
   if (found_live_across) {

      /* We can try one more trick before giving in to the spill/load option.
       * See if another register that is not in the vreglist can be enlisted
       * for saving and restoring our found_reg (instead of doing it to a
       * memory location.
       */
      savl = availreg(rt);
      for (check = firstreg(rt); savl--; check += sskip) {

         if (reg_not_in_vector(vreglist, check, rcont)
             && reg_not_in_vector(loop->regs, check, rcont)
             && reg_not_in_vector(loop->regs_in, check, rcont)) {
            /* We have found a free register. */
            makereg(free_reg, rt, indextoreg(rt, check));
            *(skiploc(free_reg)) = 0;
            /* CHECK: It may not be worthwhile using up a non-scratch free
             * register because non-scratch registers are first preference for
             * register allocation. A scratch register is trashed across a
             * call. So this loop will not find a free register
             * if the loop body has a call.
             */
            if (!scratchreg(free_reg))
               continue;
            break;
         }
      }


      *spill_load = TRUE;
      copyloc(found_reg, reg_live_across);
      *(skiploc(found_reg)) = 0;
      return TRUE;
      /* This is our last choice because it involves spilling and reloading
       * a register.
       */
   }

   return FALSE;   /* Cannot find */
} /* end of count_down_get_best_reg() */

/* is_rtl_valid -
 * Return TRUE if the RTL in val is valid.
 * Return FALSE if not valid.
 * Also return the side-effect if RTL is valid.
 * Note: this function does not update ptr.
 */
int is_rtl_valid(struct list *ptr, char *val, rlist deads, char *side)
{
   int ret = FALSE;

   simp(val, 0);
   *side = 0;
   side_effect = side;
   ret = !find(ptr, val, deads); 
      /* CHECK: deads -> is it an out parameter too? */

   side_effect = 0;     /* This is very important because inst.c simply adds to
                         * side_effect on each call to find(). */
}


/*
 * do_rename_reg - 
 * Replace reg with repl_reg in all RTLs.
 */
void do_rename_reg(struct loopl *loop, char *reg, char *repl_reg)
{
   struct bblock *cblk = NULL;
   struct blist *cptr = NULL;
   struct list *ptr = NULL;
   char *rtlin, *a;
   char  lin[MAXSTRING];
   char  side[MAXSTRING];

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
         if (rtlin = cnts(ptr)) {
            /* replace all instances of 'reg' in rtl with 'repl_reg'
             * in a temporary buffer - 'lin'. */
            strcpy(lin, rtlin);
            a = lin;
            while (fmatch(a, reg)) {
               a = epos;
               copyloc(bpos, repl_reg);
            }
            side_effect = side;
            *side_effect = 0;
            find(ptr, lin, ptr->deads);
            set(ptr, lin, side);        /* combine.c */
         }
      }
   }
}

/*
 * try_rename_reg - 
 * Return TRUE on failure.
 * Return FALSE if all reg can be successfully replaced
 * by repl_reg in all RTLs.
 */
int try_rename_reg(struct loopl *loop, char *reg, char *repl_reg)
{
   struct bblock *cblk = NULL;
   struct blist *cptr = NULL;
   struct list *ptr = NULL;
   char *a, *p, *rtlin;
   char  lin[MAXSTRING];
   char  old_side[MAXSTRING];
   char  new_side[MAXSTRING];

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
         if (rtlin = cnts(ptr)) {
            /* Get the old side effect */
            if (!is_rtl_valid(ptr, ptr->val, ptr->deads, old_side))
               assert(0);       /* Atleast the old rtl should be valid! */
            /* replace all instances of 'reg' in rtl with 'repl_reg'
             * in a temporary buffer - 'lin'. */
            strcpy(lin, rtlin);
            a = lin;
            while (fmatch(a, reg)) {
               a = epos;
               copyloc(bpos, repl_reg);
            }
            if (!is_rtl_valid(ptr, lin, ptr->deads, new_side))
               return TRUE;
            /* The new side should be same as the old one */
            if (strcmp(new_side, old_side))
               return TRUE;

         }
      }
   }

   return FALSE;
}

/*
 * isalias - return TRUE if item is an alias of reg,
 */
int isalias(char *reg, char *item)
{
   char *a;
   if (!isRegister(reg) || pseudoreg(reg))
      return FALSE;
   /* Go through the alias list of hardware
    * register reg and if item matches any
    * reg in the alias list of reg, return
    * TRUE.
    */
   for (a = aliases(reg); *a; a = skiploc(a) + 1) {
      if (!cmploc(a, item))
         return TRUE;
   }
   return FALSE;
}


/* alias_present - return TRUE if an alias of reg
 * is present in string 'a'. Here reg is
 * not considered an alias of itself.
 */
int alias_present(char *a, char *reg)
{
   char *p;
   while (a = gtrg(a)) {
      p = unskiploc(a);
      /* p!=reg, but p is an alias of reg */
      if (cmploc(p, reg) && isalias(p, reg))
         return TRUE;
   }
   return FALSE;
}

/*
 * alias_present_in_loop -
 * Return TRUE, if an alias form of reg is used within the loop.
 * Return FALSE, if no alias of reg is found (but reg itself may be present).
 */

int alias_present_in_loop(struct loopl *loop, char *reg)
{
   struct bblock *cblk = NULL;
   struct blist *cptr = NULL;
   struct list *ptr = NULL;
   char *rtlin;
   char  lin[MAXSTRING];
   char *a, *p, *se;

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
         if (rtlin = cnts(ptr)) {
            if (alias_present(rtlin, reg))
               return TRUE;
            if (ptr->se && alias_present(ptr->se, reg))
               return TRUE;
         } 
         /* If we see reg or its aliases in a SETLINE/PARMLINE/TRASHLINE
          * we have to give up.
          */
         else if ((ptr->type & (SETLINE | PARMLINE))
                  && isaliasref(ptr->val, reg))
            return TRUE;
         else if ((ptr->type & TRASHLINE) && !strcmp(ptr->val, "&"))
            return TRUE;
      }
   }
   return FALSE;
}

/*
 * find_rename_reg - Tries to see if one of the non-count-down registers
 * are free and can help out by substituting for one of the count down
 * candidates so that the count down candidate can act as a count down
 * register.
 * vreglist - the list of count down registers available on this machine.
 * found_reg - The count down register that can be used
 * helper_reg - the register that helped out by taking the place of
 *       found_reg in all the rtls where found_reg was in use originally.
 * Note that this function doesnt actually update anything.
 * The actual renaming is done later.
 * Return TRUE on success.
 * Return FALSE on failure.
 */
int find_rename_reg(struct loopl *loop, vector vreglist, char *found_reg,
                    char *helper_reg)
{
   int   savl, sskip, check, rt, rcont, regnum;
   int   savl2, check2;
   int   found_one_reg = FALSE;


   rt = regtype(loop->control->item);
   regnum = regnum(loop->control->item);

   savl = availreg(rt);
   sskip = skipreg(rt);
   rcont = contreg(rt);

   /* Go through the hardware registers 
    * and find a counter reg
    */
   for (check = firstreg(rt); savl--; check += sskip) {
      if (reg_in_vector(vreglist, check, rcont)) {
         makereg(found_reg, rt, indextoreg(rt, check));
         *(skiploc(found_reg)) = 0;
         if (alias_present_in_loop(loop, found_reg))
            continue;

         savl2 = availreg(rt);
         for (check2 = firstreg(rt); savl2--; check2 += sskip) {
            if (reg_not_in_vector(loop->regs, check2, rcont)
                && reg_not_in_vector(loop->regs_in, check2, rcont)) {
               /* We have found a free register */
               found_one_reg = TRUE;
               makereg(helper_reg, rt, indextoreg(rt, check2));
               *(skiploc(helper_reg)) = 0;
               /* Non scratch registers are used by the register
                * allocator. We dont want to steal from the register
                * allocator.
                */
               if (!scratchreg(helper_reg))
                  continue;
               if (!try_rename_reg(loop, found_reg, helper_reg))
                  return TRUE;
            }
         }
         /* No point going over the outer loop, if we couldnt
          * find even one free register 
          */
         if (!found_one_reg)
            return FALSE;

      }
   }

   /*  Failed to find a reg that could replace */
   return FALSE;

}

/* is_count_down_loop -
 * Return TRUE if this is a count down to zero loop.
 * FALSE means either we couldnt ensure that this is count down
 * or we know that this is not a count down loop.
 */
int is_count_down_loop(struct loopl *loop)
{
   struct setlist *sptr = 0, *fptr = 0;
   struct bblock *cblk;
   char  value[MAXSTRING];
   int   relop;
   char  reg[REGSTRING];
   int   loops_back;

   cblk = is_single_exit_loop(loop);
   if (!cblk)
      return FALSE;
   loops_back = cblk->right && block_in_loop(loop, cblk->right);

   if (!exit_cond(loop, cblk, loops_back, reg, value, &relop))
      return FALSE;

   sptr = loop->control;

   /* If we are already comparing with 0, and decrementing by 1, then we dont
    * have to do anything. We need a machine dependent part because the relop
    * used for a compare to zero depends on the machine. Some machines may
    * compare using '!=', others may have '>=', etc.
    */
   return (!strcmp(value, "0") && sptr->triple->cee == -1
           && md_is_count_down_loop(loop, relop, loops_back));
}


/* save_restore_reg - Save reg into register save_reg at loop preheader
 * and restore from save_reg at loop exit.
 * cblk - the block executed right after the loop is exited.
 * note: save_restore_reg doesnt check if this block has other
 * predecessors.
 */
struct llist *save_restore_reg(struct loopl *loop, struct bblock *exit_cblk,
                               char *reg, int type, int index)
{
   struct bblock *cblk;
   struct llist *refs, *refs2;
   struct list *rtlptr;

   /* Add spill to loop->preheader. The sr_init() below will add the
    * rest of the initialization after the spill.
    * Add load at loop->exits->ptr. We know that this loop has
    * only one exit (because iterations() would have failed
    * for a multi-exit loop).
    */

   cblk = loop->preheader;
   rtlptr = (cblk->status & JUMP) ? cblk->rtlend : (struct list *) NULL;
   refs = spill_reg_to_loc(cblk, rtlptr, reg, type, index);

   cblk = exit_cblk;
   rtlptr = cblk->rtls; /* first rtl in exit */
   refs2 = load_reg_from_loc(cblk, rtlptr, reg, type, index);
   return merge_refs(refs, refs2);
}

/* find_exit_condition -  Return elements of the exit comparison, and also
 * information about the total number of comparisons.
 * 
 * Input parameters
 *    loop - the loop we are working on
 *    exit_cblk - the exit block of this loop.
 *    reg - the control variable
 * Output parameters
 * pcomparisons - number of comparisons.
 * The rest of the parameters are passed to comparison().
 * lin        - buffer used to temporarily hold changes
 * psave_ptr    - the condition checking rtl.
 *    save_expr    - the expression that reg is compared with
 * pptr1      - pointer into lin, pointing to the above reg.
 * pptr2      - pointer into lin, pointing to the above expr.
 *
 * Return FALSE on success.
 * TRUE on failure.
 */
int find_exit_condition(struct loopl *loop, struct bblock *exit_cblk,
                        char *reg, int *pcomparisons, char *lin,
                        struct list **psave_ptr, char *save_expr,
                        char **pptr1, char **pptr2)
{
   int   comparisons = 0;
   char  expr[MAXSTRING];
   char *ptr1, *ptr2;
   struct blist *cptr = NULL;
   struct list *rtlptr = NULL;
   struct blist *bptr;
   char *rtlin;
   struct bblock *cblk;

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         if (rtlin = cnts(rtlptr)) {
            strcpy(lin, rtlin);
            if (comparison(lin, rtlptr, reg, expr, &ptr1, &ptr2)) {
               comparisons++;
               if (rtlptr->daddy == exit_cblk) {
                  /* This is the comparison() that exits the loop.
                   * There could be other comparisons that transfer
                   * control within the loop. For eg. a switch statement
                   * enclosed in the loop.
                   * Remember that iterations() has ensured that there
                   * is only one exit from this loop.
                   */
                  *psave_ptr = rtlptr;
                  strcpy(save_expr, expr);
                  *pptr1 = ptr1;
                  *pptr2 = ptr2;
               }
            }
         }
      }
   }
   *pcomparisons = comparisons;

   if (*psave_ptr) {
      /* 'lin' has been over-written, so copy the rtl contents back.
       * ptr1, ptr2 point into 'lin', so we dont have to update those.
       */
      strcpy(lin, (*psave_ptr)->val);
      return FALSE;     /* success */
   }

   return TRUE;    /* failure */
}

/* touchreg_loops -
 * When a inner loop has been processed, do the outer loop regs
 * need to be updated? I am not sure. The loops are ordered
 * from innermost outwards, and when processing each loop
 * we go through all its blocks. So any changes made to the
 * inner loops will automatically update the outer loops.
 * So I am not calling this any longer. Also strength reduction
 * introduces new induction variables, but doenst seem to
 * do this. 
 */
void touchreg_loops(struct loopl *this_loop, char *reg)
{
   struct listl *lptr;

   /* Go through the loops that enclose the first block 
    * of this loop.
    */
   for (lptr = this_loop->ptr->looplist; lptr; lptr = lptr->next) {
      if (lptr->ptr->regs)
         touchreg(lptr->ptr->regs, reg);
   }
}


/*
 * convert_to_count_down -
 * Takes a loop and sees if it can be converted to a count-down
 * loop, because in some architectures, compare and branch to zero is
 * more efficient and possibly involves fewer registers.
 * For machines that do not want this conversion -
 *      md_can_convert_count_down() should return FALSE.
 * The only machine dependent function that is called in the above case
 * is comparison() which is also used by strength reduction.
 */
int convert_to_count_down(struct loopl *loop, int invocation)
{
   int   change;
   int   flag;
   struct setlist *sptr = 0, *control_sptr;

   struct bblock *cblk = NULL;

   struct bblock *exit_cblk = NULL, *after_exit_cblk = NULL;
   struct list *save_ptr, *rptr;
   char *save_ptr1, *save_ptr2;
   char  save_expr[MAXSTRING];

   char *ptr1, *ptr2, *rtlin;
   char *s;
   int   comparisons = 0;

   char  counter_regs[MAXSTRING];
   char  found_reg[REGSTRING];

   char  free_reg[REGSTRING];
   char  helper_reg[REGSTRING];

   int   used_out, used_in;
   int   spill_load_needed;
   int   rename_needed;
   int   rename_done = FALSE;
   int   loops_back = FALSE;
   int   debug_flag = (swd && debug_opt("loop_iterations"));
   vector counter_vreglist = NULL;


   char  lin[MAXSTRING];
   struct llist *lptr, *nptr;
   struct llist *undo_list = NULL;

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_before_convert_to_count_down", invocation,
                        loop->ptr->label))
      dump_function_i_l("before convert_to_count_down()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   change = FALSE;


#ifdef VET
	begin_trans(VET_OPT_TRANS);
#endif

   /* 
    * iterations() makes sure that there is only a single exit from this loop
    * and that the number of iterations is compile time determinable or
    * loop-invariant.  Sometimes iterations() may fail even though the
    * information is available, just because it cannot find the information.
    */
#define DOOFUS_ATTACK FALSE
#if DOOFUS_ATTACK
   if (!loop->valid) {
#endif
      loop->valid = TRUE;
      if (iterations(loop, &loop->control, loop->iterations)) {
         if (debug_flag 
             && debug_opt_l("loop_iterations", loop->ptr->label)) {
            (void) fprintf(stderr, "From convert_to_count_down() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Number of iterations: ");
            show_rtl(stderr, loop->iterations);
            (void) fprintf(stderr, "\n");
            (void) fprintf(stderr, "Control variable: ");
            show_rtl(stderr, loop->control->item);
            (void) fprintf(stderr, "\n");
            (void) fflush(stderr);
         }
      }
      else {
         if (debug_flag) {
            (void) fprintf(stderr, "From convert_to_count_down() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Unknown number of iterations.\n");
            (void) fflush(stderr);
         }
         return FALSE;
      }
#if DOOFUS_ATTACK
   }
#endif

   if (!loop->preheader)
      loop->preheader = preheader(loop->ptr);

   if (*(loop->iterations) == 0)
      return FALSE;

   if (is_count_down_loop(loop))
      return FALSE;

   control_sptr = loop->control;

#ifdef VET
    end_trans();
#endif    

   /*
    * remv_induction_variables() sets sptr->regstatus |= USEDOUT
    * if this induction var is live out.
    */
   if (!(control_sptr->regstatus & (BASIC | INDUCTION))
       || (control_sptr->regstatus & ELIMED))
      return FALSE;

   /* Couldnt find the exit block */
   if (!(exit_cblk = is_single_exit_loop(loop)))
      return FALSE;


   /* Does the exit condition loop back into the loop? */
   loops_back = exit_cblk->right && block_in_loop(loop, exit_cblk->right);

   /* Find out which is the block that is executed
    * if the loop exit condition becomes true.
    */
   if (loops_back)
      after_exit_cblk = exit_cblk->left;
   else
      after_exit_cblk = exit_cblk->right;


   comparisons = 0;
   save_ptr = NULL;
   if (find_exit_condition
       (loop, exit_cblk, control_sptr->item, &comparisons, lin, &save_ptr,
        save_expr, &save_ptr1, &save_ptr2))
      return FALSE; /* We couldn't find the exit comparison for some reason. */

   used_out = used_in = FALSE;
   /*
    * If the control variable is live across the loop, used_out is TRUE.
    */
   if (control_sptr->regstatus & USEDOUT)
      used_out = TRUE;

   /*
    * If the control variable is used within the loop also.
    * Note that this also means that if comparisons>1, uses will
    * be greater than triple->count+1. This happens when there
    * is control flow on the control variable within the loop -
    * eg. switch within loop.
    */
   if (control_sptr->uses > control_sptr->triple->count + 1)
      used_in = TRUE;

   /* md_can_convert_count_down() takes in the loop, the loop control variable,
    * and wether the loop control is used inside the loop and outside the loop.
    * Here the meaning of 'used inside the loop' is -> used in rtls other than
    * the increment points and the comparisons.
    *
    * It returns a list of registers in counter_regs, which are to be used by
    * vpo to convert to a count down loop. If the md feels that it isn't
    * worth-while to convert this loop, it can return FALSE. The md could also
    * return select registers based on availability by checking loop->regs.
    * E.g. if it feels that spilling a register to convert to count down is not
    * worthwhile, it can return only free registers. Then vpo is forced to use
    * only those. counter_regs is a NULL separated, double NULL terminated
    * list.
    */
   if (!md_can_convert_count_down
       (loop, control_sptr, used_in, used_out, loops_back, counter_regs))
      goto count_down_undo;

   counter_vreglist = regnew();
   for (s = counter_regs; *s; s = skiplocOr2(s) + 1) {
      touchreg(counter_vreglist, s);
   }

   /* We need to recalculate the reg_in vector each time to
    * incorporate any changes made by other optimizations.
    * The reg_in vector is used by count_down_get_best_reg().
    */
   loop_init_reg_in(loop);
   spill_load_needed = rename_needed = FALSE;

   /* free_reg is valid only if spill_load_needed is TRUE, since free_reg is
    * just used to save and restore found_reg, if found_reg is live across the
    * loop.
    */
   if (!count_down_get_best_reg
       (loop, control_sptr, used_in, used_out, counter_vreglist,
        &spill_load_needed, found_reg, free_reg)) {

      rename_needed = TRUE;
      if (!find_rename_reg(loop, counter_vreglist, found_reg, helper_reg))
         return FALSE;
      /* Now you can simply use found_reg to do the count down.
       * helper_reg is the register that replaces found_reg in
       * the loop body, so that found_reg is free to do the count down.
       * Note that find_rename_reg() hasnt yet made any changes.
       * do_rename_reg() is the function that goes ahead
       * and does the renaming.
       */

      /* We are about to replace one register that was used within the loop or
       * was live across with a free register. The old register could have been
       * used anywhere, even in the comparison. Does this mean that we may have
       * invalidated any previous information that we have gathered about
       * this loop, for eg. the iteration count? If the iteration count was
       * based on the old register, since we are ensuring that the new register
       * replaces the old one, it shouldn't be a problem. Thus, unless
       * we have saved up the actual name of the old register, this renaming
       * hasnt really changed the program or the previous analysis. The old
       * register's value simply flows into the loop via another register and
       * flows back into the old register at the exit.
       * The next question is about where to actually do the renaming. 
       * If done here and if for some reason, the count down conversion
       * bails out, we have inserted extra moves and have left the code in a
       * worse state. Correctness however is still maintained. 
       * This is dangerous because it could cause vpo to go into infinite
       * recursion. One part of vpo trying to improve the code, and this
       * undoes that and so on.
       * So we have to be able to undo this.
       * 
       * We need to add the load and restore of the new register (from the old
       * register) before sr_init(). sr_init() is called to load the new
       * register with the iteration count.
       */

   }

   /* reg is the chosen counter register */

   /* We should be able to undo if needed at any point. sr_init() does a
    * bunch of changes, and undo is tough after sr_init() is called.
    * So we keep sr_init() for the last. sr_ref() luckily returns the
    * rtl added. So we can save it and delete it later if we want to 
    * back out. md_replace_induction_var() and md_convert_count_down()
    * both have test functions that can be called before hand namely -
    * md_can_replace_induction_var() and md_can_convert_count_down().
    * So we are fine for now.
    */

   /* We have to do the renaming before we introduce
    * new rtls into this block, or we end up renaming
    * the decrement for instance.
    */

#ifdef VET
   begin_trans(VET_OPT_TRANS);
#endif

   if (rename_needed) {
      struct llist *refs;
      int   rt, index;

      cblk = after_exit_cblk;

      /* Note that if we add the load/restore code to the undo list,
       * we cannot call do_rename_reg() before sr_init().
       * Because if we bail out after do_rename_reg()
       * and the above load/restore is removed, we are left with bad code.
       * So we make this change permanent. As discussed in an earlier comment,
       * if after this point we bail out, then we are left with correct,
       * but less optimal code (extra moves).
       */

      /* If cblk has another predecessor, we cannot insert
       * the load in this block. We need to insert a new
       * block, but for now we just give up.
       */
      if (cblk->preds->next)
         goto count_down_undo;

      /* inserts rtls
       * helper_reg = found_reg; at the loop preheader
       * and
       * found_reg = helper_reg; at loop exit.
       * This allows the value of found_reg to be preserved
       * across the loop.
       */

/* index = regtoindex(rt, regnum(helper_reg));*/

      refs =
       save_restore_reg(loop, cblk, found_reg, REGISTER, regnum(helper_reg));
      undo_list = merge_refs(undo_list, refs);

      do_rename_reg(loop, found_reg, helper_reg);

      rename_done = TRUE;

      /*
       * Since the components of the comparison could have potentially
       * changed, we have to do the renaming before calling 
       * md_can_replace_induction_var(), else md_can_replace_induction_var()
       * could be seeing old information.
       * Since we are only replacing one register with another of the same
       * type, we dont have to worry about changing the rtl in such a way
       * that the pointers get invalidated.
       * Have to change lin also.
       */
      strcpy(lin, save_ptr->val);       /* just in case save_ptr got changed */

      /*
       * Another piece of information that needs updating is
       * the current control variable. Further down, we try to
       * see if the found_reg is same as the current control variable,
       * and if we dont do this update, we will be looking at
       * stale data.
       */
      if (!cmploc(found_reg, control_sptr->item)) {
         /* This means that the current control variable is
          * going to be replaced with the helper_reg. Unless we
          * change control_sptr, the logic below that decides wether
          * to remove the increment points of the current control
          * variable will be acting on old data.
          */
         control_sptr = s_add(helper_reg);
      }
      /* Note that now there is no way that the control_sptr and
       * found_reg are going to be the same. found_reg is a register
       * that we have freed from all uses within the loop, and we have
       * updated control_sptr to the correct register.
       */

   }


   /* reg=reg-1 (add this rtl before the comparison) */
   rptr = sr_ref(loop, save_ptr, found_reg, -1
#ifdef AUTO
                 , FALSE
#endif
    );

   if (!rptr)
      goto count_down_undo;

   add_to_ref(&undo_list, rptr);


   if (spill_load_needed) {
      struct llist *refs;
      int   index, type;

      cblk = after_exit_cblk;
      /* If cblk has another predecessor, we cannot insert
       * the load in this block. We need to insert a new
       * block, but for now we just give up.
       */

      if (cblk->preds->next)
         goto count_down_undo;

      if (*free_reg) {
         /* If we have a free register - save to that,
          * otherwise save to spill location.
          */
         index = regnum(free_reg);
         type = REGISTER;
      }
      else {
         /* 
          * It may not be worthwhile adding spills/loads for the sake
          * of adding a loop instruction.
          */
         find_spill_location(regtype(found_reg), &index);
         type = TEMP;
      }

      /* inserts rtls
       * free_reg = found_reg; at the loop preheader
       * and
       * found_reg = free_reg; at loop exit.
       * This allows the value of found_reg to be preserved
       * across the loop.
       */
      refs = save_restore_reg(loop, cblk, found_reg, type, index);
      undo_list = merge_refs(undo_list, refs);
   }



   /* md_can_replace_induction_var() and
    * md_can_convert_count_down() shouldnt make any changes.
    */
   if (!md_can_replace_induction_var
       (loop, lin, save_ptr, found_reg, "0", save_ptr1, save_ptr2,
        save_ptr2 + strlen(save_expr)))
      goto count_down_undo;

   /* reg=iteration count */
   if (!sr_init(loop, found_reg, loop->iterations))
      goto count_down_undo;

   /* Once sr_init() is done, there is no way to backout. */
   touchreg(loop->regs, found_reg);

   /* See comment with touchreg_loops. 
    * touchreg_loops(loop, found_reg);
    */

   sptr = s_add(found_reg);
   /*
    * md_convert_count_down() 
    * can do machine specific changes.
    * For eg. on the tms320c54x the branch needs to be
    * converted to a '!=0' instead of a '>0'.
    */
   md_convert_count_down(loop, lin, save_ptr, sptr, loops_back, save_expr,
                         save_ptr1, save_ptr2);


   if (sptr == control_sptr) {

      /*
       * Now remove the increment points of the induction variable within
       * the loop.  
       */
      for (nptr = sptr->triple->ref; nptr; nptr = nptr->next) {
         remv_links(nptr->ptr);
         remv_rtl(nptr->ptr);
      }
   }
   /* 
    * Since the correct way to update an rtl is via update_rtl()
    * we cannot directly change the expression. So we do it using
    * md_replace_induction_var().
    * md_can_replace_induction_var() is called above.
    */
   md_replace_induction_var(loop, lin, save_ptr, sptr->item, "0", save_ptr1,
                            save_ptr2, save_ptr2 + strlen(save_expr));

   /* The old triple will be freed in freetriples()
    */

   /* If we dont want to do any analysis ourselves, it is best
    * to mark the register as UNASSIGNED.
    */

   sptr->regstatus = UNASSIGNED;
   sptr->triple = NULL;

#ifdef NOTNEEDED
   nptr = newref(rptr);
   nptr->inc = -1;
   nptr->next = NULL;

   tptr = newtriple(sptr);
   tptr->ref = nptr;
   tptr->cee = -1;
   tptr->count = 1;
   *(tptr->dee) = '\0';

   sptr->uses = 2; /* Just one decrement and one comparison */
   sptr->triple = tptr;

   tptr->type = regtype(sptr->item);
#endif

   change = TRUE;

 count_down_end:
#ifdef VET
    if(started_trans)
      end_trans();
#endif
    
   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_after_convert_to_count_down", invocation,
                        loop->ptr->label))
      dump_function_i_l("after convert_to_count_down()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Indicate if any changes have been made to the function
    */
   return change;

 count_down_undo:

   if (rename_done)     /* Undo the renaming */
      do_rename_reg(loop, helper_reg, found_reg);

   while (undo_list) {
      undo(undo_list->ptr);
      undo_list = undo_list->next;
   }
   goto count_down_end;

}



/*
 * set_ikind -
 * calls find() to set the ikind of each instruction.
 */
void set_ikind(struct loopl *loop)
{
   struct list *rtl;
   struct bblock *cblk;
   struct blist *cptr = NULL;
   side_effect = NULL;

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
         if (cnts(rtl)) {
            icost = -1;
            ikind = rtl->kind;
            find(rtl, rtl->val, rtl->deads);
            rtl->kind = ikind;
            if (icost < 0) {
               fprintf(stderr, "cost not set for rtl : ");
               show_rtl(stderr, rtl->val);
               fprintf(stderr, "\n");
            }
         }
      }
   }
}

/*
 * convert_to_repeat_block - try to eliminate the basic induction variable
 * by replacing it with a special loop counter.
 * For machines that do not want/support this conversion,
 * md_unrepeatable() should return FALSE;
 */
int convert_to_repeat_block(struct loopl *loop, int invocation)
{
   int   change;
   int   flag;
   struct itriple *tptr = 0;
   struct setlist *sptr = 0, *fptr = 0;

   struct bblock *cblk = NULL;
   struct bblock *exit_cblk = NULL;
   struct blist *cptr = NULL;
   struct list *rtlptr = NULL, *save_ptr;

   char *ptr1, *ptr2, *rtlin;
   char *save_ptr1, *save_ptr2;
   int   comparisons = 0;
   char  save_expr[MAXSTRING];
   char  lin[MAXSTRING];
   char  reg[REGSTRING];
   struct llist *lptr, *nptr;
   int   single_rpt = TRUE;
   int   total_inst_count = 0;
   int   remaining_inst_count = 0;
   int   control_used = FALSE;
   int   loops_back;
   int   debug_flag = (swd && debug_opt("loop_iterations"));


   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_before_convert_to_repeat_block", invocation,
                        loop->ptr->label))
      dump_function_i_l("before convert_to_repeat_block()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   change = FALSE;


   /* This flag is passed to the machine description as a hint that
    * this loop can be converted to a single instruction repeat block.
    */
   single_rpt = TRUE;   /* TRUE till proven FALSE */

   /* 
    * iterations() makes sure that there is only a single exit from this loop
    * and that the number of iterations is compile time determinable or
    * loop-invariant.  We will use it for now, but later we should use a more
    * generic function. There is no need to restrict rpt block conversions to
    * single exit loops. Any loop that has an exit based on an induction
    * variable is a candidate (not on the tms320c54x, but potentially on other
    * targets).
    */
#if DOOFUS_ATTACK
   if (!loop->valid) {
#endif
      loop->valid = TRUE;
      if (iterations(loop, &loop->control, loop->iterations)) {
         if (debug_flag 
             && debug_opt_l("loop_iterations", loop->ptr->label)) {
            (void) fprintf(stderr, "From convert_to_repeat_block() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Number of iterations: ");
            show_rtl(stderr, loop->iterations);
            (void) fprintf(stderr, "\n");
            (void) fprintf(stderr, "Control variable: ");
            show_rtl(stderr, loop->control->item);
            (void) fprintf(stderr, "\n");
            (void) fflush(stderr);
         }
      }
      else {
         if (debug_flag) {
            (void) fprintf(stderr, "From convert_to_repeat_block() : \n");
            (void) fprintf(stderr, "Loop %s\n", loop->ptr->label);
            (void) fprintf(stderr, "Unknown number of iterations.\n");
            (void) fflush(stderr);
         }
         return change;
      }
#if DOOFUS_ATTACK
   }
#endif

   /* If iterations() cannot find loop exit condition, we give up. */
   if (*(loop->iterations) == 0)
      return change;

   /* If iterations is 0, we don't bother to do anything. */
   if (!strcmp(loop->iterations, "0"))
      return change;

   /* Try to find the loop exit control block. */
   exit_cblk = is_single_exit_loop(loop);

   /* Couldn't find the exit block. */
   if (!exit_cblk)
      return FALSE;

   loops_back = exit_cblk->right && block_in_loop(loop, exit_cblk->right);

   /*
    * This loop makes sure that all RTLs in the loop are
    * repeatable. 
    */
   set_ikind(loop);


   /*
    * If a quick test reveals that this loop is simply not
    * a repeat block candidate...
    */
   if (!md_unrepeatable(loop, loops_back)) {
      /*
       * Strategy: After making sure that no unrepeatable instructions
       * are present in the loop, ask the machine description to try
       * the conversion.
       */
      sptr = loop->control;
      if ((sptr->regstatus & (BASIC | INDUCTION))
          && !(sptr->regstatus & ELIMED)) {

         /* The information about the comparison is potentially
          * important for some targets. For eg., the instructions
          * involved in a comparison() may be unrepeatable, but since
          * this comparison may disappear after the conversion, the
          * md for such a target should return these rtls in 
          * the ignore list (see below),
          * and the conversion to a rpt block can proceed.
          */

         /*
          * The following loop finds the rtl involved in the comparison
          * and saves that in save_ptr.
          * This along with the other information is passed onto the
          * machine description.
          */
         save_ptr = NULL;
         comparisons = 0;
         find_exit_condition(loop, exit_cblk, sptr->item, &comparisons, lin,
                             &save_ptr, save_expr, &save_ptr1, &save_ptr2);

         if (save_ptr == NULL)
            /* Give up if we couldn't find the 'exit' comparison */
            return FALSE;

         /* 
          * md_get_cmp_jmp_rtls() *should* return the rtls involved
          * in the compare and jmp so that vpo knows which rtls 
          * disappear after the conversion. This also allows vpo
          * to ignore these rtls when checking for unrepeatability.
          */
         lptr = md_get_cmp_jmp_rtls(loop, save_ptr, sptr);

         assert(lptr);

         flag = FALSE;
         total_inst_count = 0;
         for (cptr = loop->blocks; cptr; cptr = cptr->next) {
            cblk = cptr->ptr;
            for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
               if (rtlin = cnts(rtlptr)) {
                  /* NOTE: Instruction count being obtained here */
                  total_inst_count++;
                  if (!is_present_in_ref(lptr, rtlptr)
                      && (rtlptr->kind & UNREPEATABLE)) {
                     flag = TRUE;
                  }
                  /* E.g. on the tms320c54x, a direct memory access is actually
                   * auto-incremented. So the meaning of W[_a] is changed when
                   * placed in single instruction repeat. So we mark direct
                   * access as unrepeatable in single instruction repeat, but 
                   * such an instruction is block repeatable.
                   */
                  if (!is_present_in_ref(lptr, rtlptr)
                      && (rtlptr->kind & UNREPEATABLE_SINGLE)) {
                     single_rpt = FALSE;
                  }
               }
            }
         }
         if (flag)
            return FALSE;

         /* 
          * If there is more than one comparison based on this register, within
          * the loop, it is considered a use of the register.
          */
         if ((sptr->regstatus & USEDOUT)
             || (sptr->uses > sptr->triple->count + 1))
            control_used = TRUE;

         if (control_used)
            remaining_inst_count = total_inst_count - count_ref(lptr);
         else
            remaining_inst_count =
             total_inst_count - count_ref(lptr) - sptr->triple->count +
             count_intersection_ref(lptr, sptr->triple->ref);

         /*  
          * If the control variable is live out or used within the loop for
          * anything other than the exit compare and jmp, we cannot delete the
          * increment points. If the control variable value isn't used
          * elsewhere, then we can delete the increment points too.
          */

         /* Note: if the sptr is being incremented in the same RTL as the 
          * compare and jmp (this happens on the tms320c54x), lptr will have an
          * RTL in common with sptr->triple->ref.
          */

         if (remaining_inst_count > 1)
            single_rpt = FALSE;


         /*
          * If the control variable is used, and is incremented in the
          * compare/jump code, we have an issue;  We'd need to inc the control
          * variable the same way the compare and jump does.  For now, we avoid
          * this hassle by disallowing the conversion if we detect it.
          */
         if (control_used) {
            /* check each compare/jmp rtl */
            for (nptr = lptr; nptr; nptr = nptr->next) {
               if (is_present_in_ref(sptr->triple->ref, nptr->ptr))
                  /* bail on this loop, should be no changes */
                  assert(!change);
               return FALSE;
            }

         }


         /*-
          * We have found an unrepeatable instruction that is not present in
          * the ignore list given by the machine description. So this loop
          * cannot be converted using this induction variable.
          * loop        - the loop we are working on
          * save_ptr->val - pass the same pointer as the first param to
          *                 comparison().
          * save_ptr    - the RTL that has the comparison of the loop exit
          *               condition.
          * sptr        - the induction variable.
          * save_expr   - the expression that the induction variable is being
          *               compared with.
          * save_ptr1   - pointer into the RTL string, pointing at the
          *               induction variable.
          * save_ptr2   - pointer into the RTL string, pointing at start of
          *               'expr'.
          * single_rpt  - if TRUE, vpo is suggesting use of single rpt to md.
          * reg         - return the counter register.
          * md_convert_rptblock() should only add RTLs. vpo will delete the
          *  RTLs returned by md_get_cmp_jmp_rtls().
          */
#ifdef VET
         begin_trans(VET_OPT_TRANS);
#endif
         if (md_convert_rptblock
             (loop, save_ptr->val, save_ptr, sptr, loops_back, save_expr,
              save_ptr1, save_ptr2, &single_rpt, reg)) {
            /* Successfully converted  */

            /* Remove the old compare and jump */
            for (nptr = lptr; nptr; nptr = nptr->next) {
               remv_links(nptr->ptr);
               remv_rtl(nptr->ptr);
            }

            if (!control_used) {
               /* We can remove the increment points only if the control
                * variable isn't used in places other than the compare and
                * jump.
                */
               for (nptr = sptr->triple->ref; nptr; nptr = nptr->next) {

                  /* We want to avoid a duplicate delete in the case that a
                   * compare/jmp RTL also is an increment RTL.
                   */
                  if (!is_present_in_ref(lptr, nptr->ptr)) {
                     remv_links(nptr->ptr);
                     remv_rtl(nptr->ptr);
                  }
               }
            }
            /* The analysis at the beginning of loop_strength_reduction() needs
             * this register to be added to the sets[] cache. Only then will it
             * detect this register as a basic induction variable and gather
             * the required information about this register. Thus all the
             * induction information about this register will be available
             * only on the next pass. But that is better than repeating the 
             * analysis here.
             */
            sptr = s_add(reg);
            touchreg(loop->regs, reg);
            /* See comment with touchreg_loops 
             * touchreg_loops(loop, reg);
             */
            change = TRUE;
         }
#ifdef VET
         end_trans();
#endif

      }
   }

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_after_convert_to_repeat_block", invocation,
                        loop->ptr->label))
      dump_function_i_l("after convert_to_repeat_block()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Indicate if any changes have been made to the function
    */
   return change;

} /* end of convert_to_repeat_block() */


/*
 * induction_variable_elimination - eliminate induction variables
 */
int induction_variable_elimination(struct loopl *loop, int invocation)
{
   struct itriple *tptr = 0;
   struct setlist *sptr = 0, *fptr = 0, *lptr = 0;
   struct llist *bptr = 0, *iptr = 0;
   struct blist *cptr = 0;
   struct bblock *cblk = 0;
   struct list *rtlptr = 0;
   int   related = 0, cee = 0, dcee = 0, fbig = 0, nogo = 0, change = 0;
   char *rtlin = 0, *a = 0, *ptr1 = 0, *ptr2 = 0;
   char  expr[MAXSTRING], reg[REGSTRING], new[MAXSTRING];
   char  lin[MAXSTRING];
   int   remains;


   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_before_induction_variable_elimination",
                        invocation, loop->ptr->label))
      dump_function_i_l("before induction_variable_elimination()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   change = FALSE;


   /*
    * Now we will try to look for associated basic induction variables.  These
    * will most probably be items that were strength reduced in an earlier
    * pass through loop strength reduction or are present because the source
    * code contained items that had been strength reduced by hand (easy to
    * do in a language like C).
    */
   for (sptr = setsused; sptr; sptr = sptr->next) {
      if ((sptr->regstatus & BASIC) && !(sptr->regstatus & ELIMED)) {
         for (fptr = setsused; fptr; fptr = fptr->next) {
            if ((fptr->regstatus & BASIC) && !(fptr->regstatus & ELIMED)) {

               /*
                * Determine the difference in stride between the two basic
                * induction variables.  This difference must be maintained
                * at each increment or decrement location in the loop.  Also,
                * if the basic induction variable that we are trying to replace
                * is live at any exit point of the loop, then we know that it
                * cannot be eliminated entirely, so we avoid tying up any
                * resources to do so.
                */
               if (fptr == sptr)
                  continue;
               if ((fptr->regstatus & INAREG) && (sptr->regstatus & INAREG))
                  continue;
               /* if they have opposite signs */
               if (fptr->triple->cee > 0 && sptr->triple->cee < 0)
                  continue;
               if (fptr->triple->cee < 0 && sptr->triple->cee > 0)
                  continue;
               if (abs(fptr->triple->cee) > abs(sptr->triple->cee)) {
                  if (!sptr->triple->cee || (sptr->regstatus & USEDOUT))
                     continue;
                  if (fptr->triple->cee % sptr->triple->cee)
                     continue;
                  fbig = TRUE;
                  cee = fptr->triple->cee / sptr->triple->cee;
               }
               else if (abs(fptr->triple->cee) < abs(sptr->triple->cee)) {
                  if (!fptr->triple->cee || fptr->regstatus & USEDOUT)
                     continue;
                  if (sptr->triple->cee % fptr->triple->cee)
                     continue;
                  fbig = FALSE;
                  cee = sptr->triple->cee / fptr->triple->cee;
               }

               /* The CEE values are the same. We still may want to eliminate
                * one or the other.
                */
               else {
                  if ((fptr->regstatus & USEDOUT)
                      || (sptr->regstatus & USEDOUT))
                     continue;
                  fbig = FALSE;
                  cee = 1;
               }

               /*
                * Ensure that both basic induction variables are related by
                * ensuring that they are incremented or decremented by the
                * correct amount at the same locations within the loop.
                */
               related = TRUE;
               for (bptr = sptr->triple->ref; bptr; bptr = bptr->next) {
                  for (iptr = fptr->triple->ref; iptr; iptr = iptr->next) {
                     if (!iptr->ptr->next
                         || !close_enough(iptr->ptr, bptr->ptr, fptr->item,
                                          sptr->item)) {
                        related = FALSE;
                        break;
                     }
                     else if (fbig) {
                        if (iptr->inc / bptr->inc != cee) {
                           related = FALSE;
                           break;
                        }
                     }
                     else if (bptr->inc / iptr->inc != cee) {
                        related = FALSE;
                        break;
                     }
                  }
                  if (!related)
                     break;
               }

               /*
                * If "related" is still TRUE at this point, then the two basic
                * induction variables are related enough so that one can be
                * used to replace the other.
                */
               if (related) {
                  if (fbig) {
                     lptr = fptr;
                     fptr = sptr;
                     sptr = lptr;
                  }
                  tptr = sptr->triple;

                  /*
                   * If there are more uses of the induction variable than are
                   * accounted for by the increments, then there are uses which
                   * we may want and may even be able to eliminate.
                   */
                  if (fptr->uses > fptr->triple->count
                      && should_replace(fptr, loop)) {

                     /*
                      * Now we locate all of those extra uses of the basic
                      * induction variable in the loop.  Look for those that
                      * are used in some form of a comparison.
                      * Assume we'll get them all and watch for when we don't.
                      */
                     remains = FALSE;
                     for (cptr = loop->blocks; cptr; cptr = cptr->next) {
                        cblk = cptr->ptr;
                        for (rtlptr = cblk->rtls; rtlptr;
                             rtlptr = rtlptr->next) {
                           if (rtlin = cnts(rtlptr)) {
                              if (isref(rtlin, fptr->item)) {

                                 /*
                                  * Determine if this use of the basic
                                  * induction variable involves a comparison
                                  * that can be altered to use the
                                  * other induction variable.
                                  */
                                 strcpy(lin, rtlptr->val);
                                 if (comparison
                                     (lin, rtlptr, fptr->item, expr, &ptr1,
                                      &ptr2)) {

                                    /*
                                     * If the expression is a loop-invariant
                                     * register, then it is worthwhile to try
                                     * to eliminate this use of the basic
                                     * induction variable. If expr is a
                                     * constant, there is no need to check for
                                     * loop invariance.
                                     */
                                    if ((isareg(expr)
                                         && (lptr = s_lookup(expr))
                                         && lptr->ldead) || is_const(expr)) {
                                       if (cancolor
                                           (tptr->type, loop->regs, reg,
                                            FALSE)) {

#ifdef VET
                                          begin_trans(VET_OPT_TRANS);
#endif
                                          /*
                                           * If this loop does not have an
                                           * appropriate loop preheader basic
                                           * block, build one.
                                           */
                                          if (!loop->preheader)
                                             loop->preheader =
                                              preheader(loop->ptr);

                                          /*
                                           * Build the expression required to
                                           * form the new constant.
                                           */
                                          if (cee == 1)
                                             (void) sprintf(new, "(%s-%s)+%s",
                                                            expr, fptr->item,
                                                            sptr->item);
                                          else
                                             (void) sprintf(new,
                                                            "((%s-%s)*%d)+%s",
                                                            expr, fptr->item,
                                                            cee, sptr->item);

                                          /*
                                           * Attempt to add RTLs to the loop's
                                           * preheader to initialize the
                                           * register to the desired expr.  If
                                           * we fail, we must release the
                                           * register and give up on this
                                           * expression. Otherwise, we continue
                                           * the reduction process on the loop
                                           * itself. However first check if it
                                           * is valid to modify the loop exit
                                           * comparison. If this change is
                                           * allowed on this target, only then
                                           * we try sr_init(). It is possible
                                           * that we may come across a target
                                           * where even choosing the new
                                           * register (done by cancolor above)
                                           * has to be done by the machine 
                                           * dependent part. For now we just
                                           * assume any register of the same
                                           * type as the induction reg is fine.
                                           * 
                                           * md_can_replace_induction_var()
                                           * should not modify any of the
                                           * parameters. Once we do sr_init()
                                           * we cannot back up.
                                           */
                                          if (md_can_replace_induction_var
                                              (loop, lin, rtlptr, sptr->item,
                                               reg, ptr1, ptr2,
                                               ptr2 + strlen(expr))
                                              && sr_init(loop, reg, new)) {
                                             fptr->uses--;
                                             sptr->uses++;
                                             md_replace_induction_var(loop,
                                                               lin, rtlptr,
                                                               sptr->item,
                                                               reg, ptr1, ptr2,
                                                               ptr2 +
                                                                 strlen(expr));
                                             change = TRUE;
                                          }
                                          else
                                             releasereg(loop->regs, reg);
#ifdef VET
                                          end_trans();
#endif
                                       }
                                    }
                                 }
                                 else
                                    remains = TRUE;
                              }
                           }
                        }
                     }

                     /*
                      * Mark the basic induction variable as eliminated so that
                      * we do not attempt to eliminate it again in the future.
                      */
                     if (!remains)
                        fptr->regstatus |= ELIMED;
                  }

                  /*
                   * Put the pointers back so that the loops will terminate
                   * correctly.
                   */
                  if (fbig) {
                     lptr = fptr;
                     fptr = sptr;
                     sptr = lptr;
                  }
               }
            }
         }
      }
   }

   /*
    * Check to see if the user would like to see the state of the
    * function at this point in time.
    */
   if (swd
       && debug_opt_i_l("dump_after_induction_variable_elimination",
                        invocation, loop->ptr->label))
      dump_function_i_l("after induction_variable_elimination()", invocation,
                        loop->ptr->label,
                        SHOW_LABELS | SHOW_FREQ | SHOW_LOOP | SHOW_SUCCS |
                        SHOW_PREDS | SHOW_DFS | SHOW_SE | SHOW_NONRTLS);

   /*
    * Indicate if any changes have been made to the function
    */
   return change;
} /* end of induction_variable_elimination() */

/*
 * remv_induction_variables - delete induction variables that are not used
 */
int remv_induction_variables(struct loopl *loop)
{
   register struct setlist *sptr;
   register struct blist *eptr;
   register struct llist *bptr;
   int   change = FALSE;

   /*
    * Look through the register information structures for basic induction
    * variables.
    */
   for (sptr = setsused; sptr; sptr = sptr->next) {
      if ((sptr->regstatus & BASIC) && !(sptr->regstatus & INAREG)) {

         /*
          * Ensure that the basic induction variable is not live at any of
          * the exit points in the loop.  If it is, mark it as live outside
          * the loop and continue.
          */
         for (eptr = loop->exits; eptr; eptr = eptr->next)
            if (rin(sptr->num, eptr->ptr->ulist)) {
               sptr->regstatus |= USEDOUT;
               break;
            }

         /*
          * If the basic induction variable is not used inside or outside the
          * loop, then remove all of the increment points of the variable
          * within the loop.  Because of the circular dependence of these
          * increments, they would not have been eliminated by the dead
          * variable elimination optimization.
          */
         if (!eptr && sptr->uses == sptr->triple->count) {
#ifdef VET
            begin_trans(VET_OPT_TRANS);
#endif
            for (bptr = sptr->triple->ref; bptr; bptr = bptr->next) {
               remv_links(bptr->ptr);
               remv_rtl(bptr->ptr);
            }
            sptr->triple->status = NOTINDUCTION;
            sptr->regstatus = UNASSIGNED;
            sptr->uses = 0;
            sptr->triple->count = 0;
            change = TRUE;
#ifdef VET
            end_trans();
#endif
         }
      }
   }

   /*
    * Indicate if any induction variables where removed from the loop
    */
   return change;
} /* end of remv_induction_variables() */

/*
 * getbasic - examine RTL to obtain information about basic induction variables
 */
void getbasic(struct list *ptr, char *rtl, struct loopl *loop)
{
   register char *rtlin;
   struct setlist *sptr;
   struct itriple *tptr;
   struct llist *bptr;
   char *a;
   int   cee;

   /*
    * Examine each register set in this RTL to determine if it is a basic
    * induction variable.  A basic induction variable is one that is
    * simply incremented or decremented within the loop.  It may be used,
    * but not set in any way other than the increments or decrements.
    */
   rtlin = rtl;
   while (*rtlin) {

      /*
       * Note that fifo registers are never basic induction variables.  For
       * each basic induction variable, we maintain a list of pointers back to
       * the RTLs at which the items were incremented or decremented along
       * with a count of the total amount added to the item through each
       * iteration of the loop.
       */
      if (isrg(rtlin) && (sptr = s_lookup(rtlin)) && !(sptr->status & FIFOREG)
          && sptr->regstatus != NOTINDUCTION) {

         /*
          * Determine if the item is only incremented or decremented by a
          * constant value.  Determine the net amount that the item is
          * incremented or decremented throughout the loop and remember where
          * these increments took place.
          */
         if (loop->ptr->freq == ptr->daddy->freq
             && is_basic(ptr, rtlin, &cee)) {
            bptr = newref(ptr);
            bptr->inc = cee;
            if (sptr->regstatus & BASIC) {
               tptr = sptr->triple;
               tptr->cee += cee;
               bptr->next = tptr->ref;
            }
            else {
               tptr = newtriple(sptr);
               sptr->regstatus = BASIC;
               tptr->cee = cee;
               sptr->triple = tptr;
               tptr->type = regtype(sptr->item);
            }
            tptr->ref = bptr;

            /*
             * Examine the RTL effect and determine how many uses of the item
             * that we consider to be a basic induction variable are due to
             * references needed to perform the increments or decrements.
             */
            rtlin = skiploc(rtlin) + 1;
            while (*rtlin != ';') {
               if (cmploc(rtlin, sptr->item) == 0)
                  sptr->triple->count++;
               rtlin++;
            }
         }
         else
            sptr->regstatus = NOTINDUCTION;
         /*sptr->regstatus = MAYBEIND; */
      }

      /*
       * Move to the next effect in the RTL
       */
      while (*rtlin++ != ';') ;
   }

   /*
    * Determine the number of uses for each register in this RTL.  We will
    * use this information later to determine which items are incremented
    * in this loop but are not used outside the loop, so may be deleted.
    * These are dead variables, but their circular dependence inside a loop
    * would prevent the normal dead variable elimination phase from detecting
    * them.
    */
   rtlin = rtl;
   while (rtlin = gtrg(rtlin)) {
      if (*rtlin != '=' && (sptr = s_lookup(unskiploc(rtlin)))) {
         sptr->uses++;
      }
   }
} /* end of getbasic() */




/*
 * getind - examine RTL to obtain information about regular induction variables
 */
void getind(struct loopl *loop, struct bblock *cblk, struct list *rtlptr,
            char *rtl)
{
   register struct setlist *ptr;
   register char *a;
   struct itriple *tptr;
   struct llist *bptr;
   struct setlist *fptr;
   int   cee;
   char  dee[MAXSTRING];


   /*
    * Look at each individual effect in this RTL
    */
   while (*rtl) {

      /*
       * Only registers can be induction items (yes, it is possible
       * for other things to be induction items, but that involves
       * a lot of work, and I'm lazy).  FIFO registers cannot be
       * induction items since they do not fit the standard register
       * model.  Don't bother looking at items that we have already
       * determined to be basic or regular induction items or that
       * we have definitely ruled out as being induction items.
       */
      if (isrg(rtl) && (fptr = ptr = s_lookup(rtl))
          && !(ptr->status & FIFOREG)
          && !(ptr->regstatus & (NOTINDUCTION | BASIC | INDUCTION))) {

         /*
          * Examine the source portion of the RTL
          */
         rtl = skiploc(rtl) + 1;
         switch (is_type(rtl, &fptr, &cee, dee)) {

          case BASIC:

             /*
              * Avoid looking at items that are in a loop nested within
              * this loop, since we cannot really determine their cee
              * and dee values just by looking at them (although I
              * suppose that we could, if we knew the number of
              * iterations that the inner loop will make relative to
              * this one--a possible future project).
              */
             if (loop->ptr->freq != cblk->freq
                 || ptr->regstatus != UNASSIGNED) {
                ptr->regstatus = NOTINDUCTION;
                break;
             }

             /*
              * Build a new triple record, since this item might be a possible
              * induction variable.  We get the cee and dee values straight
              * from is_type().  We also count the number of times that the
              * variable is used to build itself up.
              */
             ptr->triple = tptr = newtriple(fptr);
             ptr->regstatus = tptr->status = MAYBEIND;
             tptr->ref = newref(rtlptr);
             tptr->cee = cee;
             remparen(dee);
             (void) strcpy(tptr->dee, dee);
             for (a = rtl; *rtl != ';'; rtl++)
                if (cmploc(rtl, ptr->item) == 0)
                   tptr->count++;
             gtstr(a, rtl, tptr->pat);
             tptr->type = regtype(ptr->item);
             break;

          case INDUCTION:

             /*
              * Again, we must be careful with embedded loops.
              */
             if (loop->ptr->freq != cblk->freq || ptr->regstatus != MAYBEIND) {
                ptr->regstatus = NOTINDUCTION;
                break;
             }

             /* Enter a new scope so we can declare some locals. */
             {

                /* Here we check for the update of a secondary induction
                 * variable spanning a block, or a use.
                 */
                struct list *new_ptr;
                for (new_ptr = rtlptr->prev;
                     new_ptr;
                     new_ptr = new_ptr->prev) {
                   epos = 0;
                   if (cnts(new_ptr) && fmatch(new_ptr->val, ptr->item)
                       && *epos != '=') {
                      /* Uh oh, we found a use. */
                      ptr->regstatus = NOTINDUCTION;
                      if (!sww)
                         fprintf(stderr,
                                 "Warning! induction update may "
                                 "span use\n");

                   }
                   /* We found the define, we're cool. */
                   else if (epos && *epos == '=')
                      break;
                }
                if (!new_ptr) {
                   ptr->regstatus = NOTINDUCTION;
                   if (!sww)
                      fprintf(stderr,
                              "Warning! induction update may span block\n");
                }
             }

             /*
              * This induction variable is complex (more than two RTLs are used
              * to calculate it).  The cee and dee values, then are additive
              * from its previous values.
              */
             tptr = ptr->triple;
             bptr = newref(rtlptr);
             bptr->next = tptr->ref;
             tptr->ref = bptr;
             remparen(dee);
             calcinduction(tptr, tptr, cee, dee);
             for (a = rtl; *rtl != ';'; rtl++)
                if (cmploc(rtl, ptr->item) == 0)
                   tptr->count++;
             gtstr(a, rtl, tptr->pat);
             break;
          default:
             ptr->regstatus = NOTINDUCTION;
         }
      }
      while (*rtl++ != ';') ;
   }
} /* end of getind() */

/*
 * calcinduction - calculate new induction values
 */
void calcinduction(struct itriple *dtriple, struct itriple *striple, int cee,
                   char *dee)
{
   char  str[MAXSTRING];

   dtriple->cee = striple->cee * cee;
   *str = '\0';
   if (*striple->dee) {
      if (cee != 1)
         (void) sprintf(str, "(%s)*%d", striple->dee, cee);
      else
         (void) strcpy(str, striple->dee);
   }
   if (*dee) {
      if (*str)
         (void) sprintf(dtriple->dee, "(%s)+(%s)", str, dee);
      else
         (void) strcpy(dtriple->dee, dee);
   }
   else
      (void) strcpy(dtriple->dee, str);
   remparen(dtriple->dee);
}

/*
 * remexpr - remove an item from the difference expressions in a partition
 */
int remexpr(struct memgroup *pptr, char *item)
{
   register struct memitem *mref;


   for (mref = pptr->reads; mref; mref = mref->next)
      if (fmatch(mref->dif, item)) {
#ifdef ADDR
         if (*epos == ']' && *(bpos - 1) == '[' && *(bpos - 2) == 'A') {
            epos++;
            bpos -= 2;
         }
#endif
         (void) sub(bpos, epos, "0");
      }
      else
         return FALSE;
   for (mref = pptr->writes; mref; mref = mref->next)
      if (fmatch(mref->dif, item)) {
#ifdef ADDR
         if (*epos == ']' && *(bpos - 1) == '[' && *(bpos - 2) == 'A') {
            epos++;
            bpos -= 2;
         }
#endif
         (void) sub(bpos, epos, "0");
      }
      else
         return FALSE;
   return TRUE;
}


int can_reduce(struct loopl *loop, struct itriple *tptr, struct setlist *fptr,
               char *reg, char *biv, int complex)
{

   struct itriple *mptr = 0;
   if (!can_replace(tptr->ref->ptr, tptr->pat, reg))
      return FALSE;

   /*
    * Check to see if any other induction items use the same induction
    * variable.  If so, we can piggy-back onto this one.  Note that the
    * shadow register to use depends on whether or not the item we are
    * replacing was complex enough to require a second shadow variable.
    */
   for (mptr = tptr->next; mptr; mptr = mptr->next) {
      if (mptr->status & (INDUCTION | INDMEM)
          && !(mptr->status & NOTINDUCTION) && mptr->cee == tptr->cee
          && doreduce(mptr) && !strcmp(mptr->dee, tptr->dee)
          && mptr->family == tptr->family) {
         if (complex) {
            if (!can_replace(mptr->ref->ptr, mptr->pat, reg))
               return FALSE;
         }
         else {
            if (!can_replace(mptr->ref->ptr, mptr->pat, biv))
               return FALSE;
         }
      }
   }
   return TRUE;
}

/*
 * reduce - alter the code to strength reduce an induction reference
 */
void reduce(struct loopl *loop, struct itriple *tptr, struct setlist *fptr,
            char *reg, char *biv, int complex)
{
   struct itriple *mptr, *optr;
   struct memgroup *pptr;
   struct memitem *iptr, *jptr;
   struct list *lptr, *rptr;
   struct llist *bptr, *nptr;
   struct setlist *sptr;
   char  creg[REGSTRING], expr[MAXSTRING];

   /*
    * Replace the pattern with the appropriate register reference and
    * make a note of the change.
    */
   replace(tptr->ref->ptr, tptr->pat, reg);
   (void) strcpy(tptr->pat, reg);
   tptr->status |= NOTINDUCTION;

   /*
    * Check to see if any other induction items use the same induction
    * variable.  If so, we can piggy-back onto this one.  Note that the
    * shadow register to use depends on whether or not the item we are
    * replacing was complex enough to require a second shadow variable.
    */
   for (mptr = tptr->next; mptr; mptr = mptr->next) {
      if (mptr->status & (INDUCTION | INDMEM)
          && !(mptr->status & NOTINDUCTION) && mptr->cee == tptr->cee
          && doreduce(mptr) && !strcmp(mptr->dee, tptr->dee)
          && mptr->family == tptr->family) {
         if (complex) {
            replace(mptr->ref->ptr, mptr->pat, reg);
            (void) strcpy(mptr->pat, reg);
         }
         else {
            replace(mptr->ref->ptr, mptr->pat, biv);
            (void) strcpy(mptr->pat, biv);
         }
         mptr->status |= NOTINDUCTION;
      }
   }

   /*
    * Check to see if any other items use the same induction variable with
    * a known offset from the current induction variable.  We do this by
    * looking at the information collected to do recurrences.  If we find
    * such a thing, we can replace it provided our target machine has an
    * addressing mode that permits us to specify a displacement off the
    * strength-reduced address pointer.
    */
   if ((pptr = tptr->part) && !(pptr->warn & SR_WARN)) {

      /*
       * First, locate the data for the current induction variable.  It might
       * be either a read or a write.
       */
      for (iptr = pptr->reads; iptr; iptr = iptr->next) {
         if (iptr->triple == tptr && iptr->ptr == tptr->ref->ptr)
            break;
      }
      if (!iptr) {
         for (iptr = pptr->writes; iptr; iptr = iptr->next) {
            if (iptr->triple == tptr && iptr->ptr == tptr->ref->ptr)
               break;
         }
      }

      /*
       * Now, look for other items related to the current induction variable
       */
      if (iptr) {
         for (mptr = tptr->next; mptr; mptr = mptr->next) {
            if (mptr->status & (INDUCTION | INDMEM) && doreduce(mptr)
                && !(mptr->status & NOTINDUCTION) && mptr->part == pptr) {

               for (jptr = pptr->reads; jptr; jptr = jptr->next) {

                  /* This check was originally just:
                   * if (jptr->triple == mptr) 
                   * However, there is often more than one recurrence
                   * reference that matches a single triple (e.g.:  some might
                   * be 4 off the triple, others 8, etc.)  We need to make sure
                   * we find the recurrence that matches the triple's actual
                   * reference so that we don't accidentally reduce by the
                   * wrong recurrence.  The 2nd part of this check 
                   * (jptr->ptr == mptr->ref->ptr) attempts to accomplish
                   * that.  Note that it's in several places in this function.
                   *
                   * Potential bug warning.  It's possible for several
                   * recurrences to show up in a single RTL.  If it happens,
                   * the check I added isn't strong enough to enforce that
                   * we get the proper recurrence.  If you find a bug here,
                   * check and see if that's what happened.
                   */
                  if (jptr->triple == mptr && jptr->ptr == mptr->ref->ptr)
                     break;
               }
               if (!jptr)
                  for (jptr = pptr->writes; jptr; jptr = jptr->next) {
                     if (jptr->triple == mptr && jptr->ptr == mptr->ref->ptr)
                        break;
                  }

               if (complex) {
                  if (jptr && offset(reg, jptr->aofs - iptr->aofs, expr

#ifdef NEEDS_MEM_TYPE
                     /* 
                      * Some targets need the memory type to figure out if an
                      * offset is valid.  E.g.:  the ARM (soft-float) can't do
                      * strength reduction on doubles, so we have to pass along
                      * the type of the memory reference in order to determine
                      * if it's valid.
                      */
                                     , jptr->ref
#endif
                      )) {
                     replace(mptr->ref->ptr, mptr->pat, expr);
                     if (fmatch(jptr->ref, mptr->pat))
                        (void) sub(bpos, epos, expr);
                     (void) strcpy(mptr->pat, expr);
                     mptr->status |= NOTINDUCTION;
                  }
               }
               else if (jptr && offset(biv, jptr->aofs - iptr->aofs, expr
#ifdef NEEDS_MEM_TYPE
                                       , jptr->ref
#endif
                        )) {
                  replace(mptr->ref->ptr, mptr->pat, expr);
                  if (fmatch(jptr->ref, mptr->pat))
                     (void) sub(bpos, epos, expr);
                  (void) strcpy(mptr->pat, expr);
                  mptr->status |= NOTINDUCTION;
               }
            }
         }
      }
   }

   /*
    * Now we are going to try a third alternative, which is to locate other
    * items that are in the same family of the basic induction variable that
    * this item is in the family of and determine if we can use a set starting
    * offset placed in a register to strength reduce the item using a double
    * register mode which avoids the need to add a new basic induction variable
    * to the loop.
    */
   if (index_reduce
       && !(swd && debug_opt_l("no_index_reduction", loop->ptr->label))) {
      for (mptr = tptr->next; mptr; mptr = mptr->next) {
         if (mptr->status & INDMEM && !(mptr->status & NOTINDUCTION)
             && doreduce(mptr) && mptr->cee == tptr->cee
             && mptr->family == tptr->family) {
            if (cancolor(tptr->type, loop->regs, creg, FALSE)) {
               char  expr2[MAXSTRING];
               if (*tptr->dee)
                  if (*mptr->dee)
                     (void) sprintf(expr2, "(%s)-(%s)", mptr->dee, tptr->dee);
                  else
                     (void) sprintf(expr2, "-(%s)", tptr->dee);
               else
                  (void) strcpy(expr2, mptr->dee);

               if (complex)
                  (void) sprintf(expr, "%s+%s", reg, creg);
               else
                  (void) sprintf(expr, "%s+%s", biv, creg);
               if (can_replace(mptr->ref->ptr, mptr->pat, expr)
                   && sr_init(loop, creg, expr2)) {
                  replace(mptr->ref->ptr, mptr->pat, expr);
                  (void) strcpy(mptr->pat, expr);
                  mptr->status |= NOTINDUCTION;

                  /*
                   * Look for any other items that are identical to this one so
                   * that we can strength reduce them similarly.
                   */
                  for (optr = mptr->next; optr; optr = optr->next) {
                     if (optr->status & INDMEM
                         && !(optr->status & NOTINDUCTION)
                         && optr->family == mptr->family
                         && optr->cee == mptr->cee
                         && !strcmp(optr->dee, mptr->dee)) {
                        replace(optr->ref->ptr, optr->pat, expr);
                        (void) strcpy(optr->pat, expr);
                        optr->status |= NOTINDUCTION;
                     }
                  }
               }
               else
                  releasereg(loop->regs, creg);
            }
         }
      }
   }

   /*
    * Build a triple information structure for the basic induction variable
    * created.  This triple may later be useful in the elimination of the
    * basic induction variable that this triple is in the family of.
    */
   sptr = s_add(biv);
   sptr->regstatus = (BASIC | INAREG);
   sptr->triple = newtriple(sptr);
   sptr->triple->status = (BASIC | INAREG);
   sptr->triple->family = fptr;
   sptr->triple->cee = fptr->triple->cee * tptr->cee;
   (void) strcpy(sptr->triple->dee, tptr->dee);
   sptr->triple->type = regtype(sptr->item);
   sptr->triple->ref = (struct llist *) NULL;

#ifdef AUTO
   /*
    * If the target machine has autoincrement and autodecrement addressing
    * modes, then we will attempt to locate instances where even though the
    * increment and use of a register may taken place far from each other
    * inside a loop, we still place them close in order to take advantage of
    * the auto type addressing modes.
    */
   if (auto_reduce && (tptr->status & INDMEM) && sptr->uses == 1
       && cmploc(reg, biv) == 0 && (bptr = fptr->triple->ref) && !bptr->next
       && !(swd && debug_opt_l("no_auto_reduction", loop->ptr->label))) {
      if (bptr->inc * tptr->cee > 0 && tptr->ref->ptr->next) {
         if (rtl_dominates(tptr->ref->ptr, bptr->ptr)
             && !in_different_loops(tptr->ref->ptr->daddy,
                                    bptr->ptr->daddy)) {
            if (rptr =
                sr_ref(loop, tptr->ref->ptr->next, biv, bptr->inc * tptr->cee,
                       TRUE)) {
               sptr->regstatus |= AUTOMOV;
               sptr->triple->status |= AUTOMOV;
               nptr = newref(rptr);
               nptr->inc = bptr->inc * tptr->cee;
               nptr->next = sptr->triple->ref;
               sptr->triple->ref = nptr;
               sptr->triple->count++;
               sptr->uses++;
               return;
            }
         }
      }
      else if (bptr->inc * tptr->cee < 0) {
         if (rtl_dominates(bptr->ptr, tptr->ref->ptr)
             && !in_different_loops(tptr->ref->ptr->daddy,
                                    bptr->ptr->daddy)) {
            if (rptr =
                sr_ref(loop, tptr->ref->ptr, biv, bptr->inc * tptr->cee,
                       TRUE)) {
               sptr->regstatus |= AUTOMOV;
               sptr->triple->status |= AUTOMOV;
               nptr = newref(rptr);
               nptr->inc = bptr->inc * tptr->cee;
               nptr->next = sptr->triple->ref;
               sptr->triple->ref = nptr;
               sptr->triple->count++;
               sptr->uses++;
               return;
            }
         }
      }
   }
#endif

   /*
    * Now we insert the increments to the shadow variable at each point
    * where the basic induction variable of this item was incremented.
    * There is a bit of a kludge here that allows machine descriptions
    * to be a bit sloppy about side effects.  In some cases, the same
    * side effect will be reported twice in the same instruction
    * when it only happens once.
    */
   lptr = (struct list *) NULL;
   for (bptr = fptr->triple->ref; bptr; bptr = bptr->next) {
      if (lptr != bptr->ptr) {
         if (rptr = sr_ref(loop, lptr = bptr->ptr, biv, bptr->inc * tptr->cee
#ifdef AUTO
                           , FALSE
#endif
             )) {
            nptr = newref(rptr);
            nptr->inc = bptr->inc * tptr->cee;
            nptr->next = sptr->triple->ref;
            sptr->triple->ref = nptr;
            sptr->triple->count++;
            sptr->uses++;
         }
         else {
            (void) fprintf(stderr,
                           "vpo (reduce): cannot add new increment\n");
            exit(1);
         }
      }
   }
} /* end of reduce() */


/*
 * can_replace - determine if it's safe to replace pat with expr in rtl
 */
int can_replace(struct list *rtl, char *pat, char *expr)
{
   char  rtlVal[MAXSTRING];
   char *a = 0;

   strcpy(rtlVal, rtl->val);
   a = rtlVal;
   while (a = gtmem(a)) {
      if (strncmp(bpos + 2, pat, strlen(pat)) == 0)
         sub(bpos + 2, epos - 1, expr);
   }
   return (!find(rtl, rtlVal, rtl->deads));
}

/*
 * replace - replace an item with an expression and update the uses
 */
void replace(struct list *rtl, char *pat, char *expr)
{
   register struct setlist *sptr;
   register char *rtlin;
   int   found;
   char  str[MAXSTRING];


   /*
    * We need to work with a copy of the RTL because there will be cases
    * where the expression which replaces the old pattern will be longer.
    */
   (void) strcpy(str, rtl->val);

   /*
    * Look for the pattern "pat" and make sure that we don't accidentally
    * pick off "pat" as a subexpression of some larger expression.
    */
   found = FALSE;
   for (rtlin = str; fmatch(rtlin, pat); rtlin = epos) {
      if (*epos != '=' && (ismem(pat) || !isoper(*epos))) {
         found = TRUE;
         break;
      }
   }

   /*
    * If the expression was found, change it for the new expression and
    * update the RTL.
    */
   if (found) {
      (void) sub(bpos, epos, expr);
      update_rtl(rtl, str);
      rtl->type &= ~SIDEFFECT;
      if (rtl->se)
         update_se(rtl, NULL);

      /*
       * Increment the use counts for the registers in the new expression
       */
      rtlin = expr;
      while (rtlin = gtrg(rtlin)) {
         if (sptr = s_add(unskiploc(rtlin)))
            sptr->uses++;
      }

      /*
       * Decrement the use counts for the registers used in the expression that
       * was just replaced.
       */
      rtlin = pat;
      while (rtlin = gtrg(rtlin)) {
         if (sptr = s_lookup(unskiploc(rtlin))) {
            sptr->uses--;
            rdel(sptr->num, &rtl->deads);

            /*
             * If by decrementing the use of this register we reach the point
             * where we completely eliminate the use of it in the loop, then,
             * if that reg is a valid induction variable that still remains
             * to be reduced, we mark the triple for it to ensure that it is
             * not reduced, since it will not be used and it would be a waste
             * of resources to reduce in any case.  We do not try to go ahead
             * and remove the RTLs that set this register and free it up for
             * allocation at this time because that is a delicate operation
             * that will be performed by dead variable elimination.  We may
             * choose to do so in the future, because releasing that register
             * now may allow us to use it to strength reduce something that
             * we might have to pass up otherwise (at least during this pass).
             */
            if (sptr->triple && (sptr->triple->status & INDUCTION)) {
               if (!sptr->uses)
                  sptr->triple->status = NOTINDUCTION;
               else if (sptr->uses == sptr->triple->count)
                  sptr->triple->status = NOTINDUCTION;
            }
         }
      }
   }
   else {
      /* guard this with  whether the optimizer warnings are generated */
      OPTIMIZER_WARN((void) fprintf(stderr, "vpo (replace): pattern '");
                     show_rtl(stderr, pat);
                     (void) fprintf(stderr, "' not found in '");
                     show_rtl(stderr, rtl->val);
                     (void) fprintf(stderr, "'\n");)
   }
   found = FALSE;
   for (rtlin = str; fmatch(rtlin, pat); rtlin = epos) {
      if (*epos != '=' && (ismem(pat) || !isoper(*epos))) {
         found = TRUE;
         break;
      }
   }

   /* hey!  it's in here again, lets just recurse to fix up the problem. */
   if (found)
      replace(rtl, pat, expr);

#ifdef CM_FIX_RTL
   else
      cd_motion_fix_rtl(rtl, pat, expr);
#endif

} /* end of replace() */

/*
 * is_single_exit_loop - 
 * return exit block if this loop has only a single exit.
 */
struct bblock *is_single_exit_loop(struct loopl *loop)
{
   struct bblock *cblk;
   struct blist *bptr;

   /*
    * Look for a loop with only one exit point--in the future we may
    * wish to modify this procedure to handle loops with more than one
    * exit point.
    */
   if (loop->exits && !loop->exits->next) {

      /*
       * Since the same basic block can be the target of more than a single
       * exit point out of the loop, we have to check a little bit further
       * to ensure that this loop only has a single exit point.
       */
      cblk = (struct bblock *) NULL;
      for (bptr = loop->exits->ptr->preds; bptr; bptr = bptr->next) {
         if (block_in_loop(loop, bptr->ptr)) {
            if (cblk)
               return NULL;
            cblk = bptr->ptr;
         }
      }
   }
   else
      return NULL;

   return cblk;
}

/*
 * iterations - attempt to determine how many times loop is executed
 */
int iterations(struct loopl *loop, struct setlist **cptr, char *value)
{
   register struct bblock *cblk;
   struct blist *bptr;
   struct llist *lptr;
   struct list *ptr;
   int   val, init, relop, item, before, after;
   char  reg[MAXSTRING], *a, temp[MAXSTRING];
   bzero(reg, sizeof(reg));
   bzero(temp, sizeof(temp));

   *value = '\0';

   cblk = is_single_exit_loop(loop);

   /*
    * At this point, if we have a pointer to a valid basic block, then it is
    * the single exit point from which the loop exits.  We must now examine
    * this block to determine what the control variable of the loop is and
    * if we can determine its initial value and the exit condition of the
    * loop.
    */
   if (!cblk)
      return FALSE;

   /*
    * Check that the exit condition is executed on every iteration
    * through the loop.  Otherwise, there is little we can tell
    * about the exit condition by just looking at the last test.
    */
   if (!everytime(loop, cblk))
      return FALSE;

   /*
    * Given that there is only one exit out of the loop, attempt to
    * locate the "control variable" of the loop and its exit value.
    */
   if (exit_cond
       (loop, cblk, cblk->right
        && block_in_loop(loop, cblk->right), reg, value, &relop)) {

      /*
       * Now check to see if the control variable is a basic induction
       * variable.  If it is, and the increment is performed every time
       * through the loop (a condition that must be true if the basic
       * block in which the increment is located in dominates every
       * predecessor block of the loop header that is also in the loop),
       * then we know how much it is incremented by on each iteration
       * through the loop.
       */
      *cptr = s_lookup(reg);
      if ((*cptr)->regstatus & BASIC) {
         before = after = 0;
         for (lptr = (*cptr)->triple->ref; lptr; lptr = lptr->next) {
            if (!everytime(loop, lptr->ptr->daddy)) {
               *value = '\0';
               return FALSE;
            }
            else if (dominates(lptr->ptr->daddy, cblk))
               before += lptr->inc;
            else
               after += lptr->inc;
         }
         after += before;
         if (!after) {
            *value = '\0';
            return FALSE;
         }

         /*
          * Now all that remains is to look at the preheader of the loop and
          * see if we can find the value that the loop control variable is
          * initialized to.  Knowing this, we can determine exactly how many
          * times the loop is executed.
          */
         if (!(cblk = loop->preheader))
            loop->preheader = cblk = natural_preheader(loop->ptr);
         if (!cblk) {
            /* We couldn't find a pre-header. One reason why this could happen
             * is when the loop exit condition is based on a loop-invariant
             * reg. So the loop entry is protected by a conditional branch that
             * jumps over the loop if the loop condition is not met.
             * In such a case, search for a predecessor of the loop head
             * (loop->ptr) such that it is the only predecessor that is outside
             * the loop.
             */
            struct bblock *hblk, *pblk;
            struct blist *bptr;
            hblk = NULL;
            pblk = NULL;
            /* This loop tries to find two predecessors for loop->ptr, that
             * lie outside the loop. If it fails => we succeeded in our goal.
             */
            for (bptr = loop->ptr->preds; !pblk && bptr; bptr = bptr->next) {
               if (!block_in_loop(loop, bptr->ptr)) {
                  pblk = hblk;
                  hblk = bptr->ptr;
               }
            }
            if (!pblk)
               cblk = hblk;
         }
         if (cblk && (ptr = value_of(cblk->rtlend, reg, rinit(), temp))) {
            expand((struct loopl *) NULL, ptr, temp);
            simp(temp, FALSE);
            if ((a = is_const(temp)) && !*a) {
               init = atoi(temp) + before;

               /*
                * Examine the exit condition value. If the value is a constant,
                * then we can determine how many times the loop is executed.
                */
               if (is_const(value)) {
                  val = atoi(value);
                  switch (relop) {

                   case REL_LE:
                      if (init > val) {
                         (void) strcpy(value, "1");
                         return TRUE;
                      }
                      item = (val - init) / after;
                      if (item > -1) {
                         (void) sprintf(value, "%d", item + 2);
                         return TRUE;
                      }
                      *value = '\0';
                      return FALSE;

                   case REL_GE:
                      if (init < val) {
                         (void) strcpy(value, "1");
                         return TRUE;
                      }
                      item = (init - val) / (-after);
                      if (item > -1) {
                         (void) sprintf(value, "%d", item + 2);
                         return TRUE;
                      }
                      *value = '\0';
                      return FALSE;

                   case REL_LT:
                      if (init >= val) {
                         (void) strcpy(value, "1");
                         return TRUE;
                      }
                      item = (val - init - 1) / after;
                      if (item > -1) {
                         (void) sprintf(value, "%d", item + 2);
                         return TRUE;
                      }
                      *value = '\0';
                      return FALSE;

                   case REL_GT:
                      if (init <= val) {
                         (void) strcpy(value, "1");
                         return TRUE;
                      }
                      item = (init - val - 1) / (-after);
                      if (item > -1) {
                         (void) sprintf(value, "%d", item + 2);
                         return TRUE;
                      }
                      *value = '\0';
                      return FALSE;

                   case REL_NE:
                      if (init <= val && after > 0) {
                         item = (val - init) / after;
                         (void) sprintf(value, "%d", item + 1);
                         return TRUE;
                      }
                      else if (init >= val && after < 0) {
                         item = (init - val) / -after;
                         (void) sprintf(value, "%d", item + 1);
                         return TRUE;
                      }
                      *value = '\0';
                      return FALSE;
                  }
               }

               /*
                * If the value is not a literal constant, we can still use it
                * if we can determine that it is loop invariant, so that it
                * contains the same value at the preheader of the loop as it
                * does at the exit point.
                */
               else if (is_invariant(value, !loop->invaread, loop, NULL)) {
                  switch (relop) {

                   case REL_LE:
                      init -= 2;
                      if (init > 0) {
                         (void) sprintf(temp, "(%s)-%d", value, init);
                         (void) strcpy(value, temp);
                      }
                      else if (init < 0) {
                         (void) sprintf(temp, "(%s)+%d", value, -init);
                         (void) strcpy(value, temp);
                      }
                      if (after != 1) {
                         (void) sprintf(temp, "(%s)/%d", value, after);
                         (void) strcpy(value, temp);
                      }
                      return TRUE;

                   case REL_LT:
                      init--;
                      if (init > 0) {
                         (void) sprintf(temp, "(%s)-%d", value, init);
                         (void) strcpy(value, temp);
                      }
                      else if (init < 0) {
                         (void) sprintf(temp, "(%s)+%d", value, -init);
                         (void) strcpy(value, temp);
                      }
                      if (after != 1) {
                         (void) sprintf(temp, "(%s)/%d", value, after);
                         (void) strcpy(value, temp);
                      }
                      return TRUE;
                  }
               }
            }
         }
      }
   }

   /*
    *  Return the "I don't know" or "infinite" result
    */
   *value = '\0';
   return FALSE;
} /* end of iterations() */

/*
 * everytime - determine if the block is executed on every iteration of the loop
 */
int everytime(struct loopl *loop, struct bblock *cblk)
{
   register struct blist *bptr;

   /*
    * Examine all blocks that are in the loop and are predecessors of the
    * head of the loop (that is, they have the head of the loop as one of
    * their children).  If the given basic block dominates all of these, then
    * we can be certain that it is executed on every iteration of the loop.
    */
   for (bptr = loop->blocks; bptr; bptr = bptr->next)
      if (bptr->ptr->left == loop->ptr || bptr->ptr->right == loop->ptr)
         if (!dominates(cblk, bptr->ptr))
            return FALSE;

   return TRUE;
}

/*
 * move_rtl_to_preheader - move an RTL to the preheader of the specified loop
 */
void move_rtl_to_preheader(struct loopl *loop, struct list *rtlptr)
{
   struct bblock *cblk;
   char *a;
   char  reg[MAXSTRING];
   struct blist *block_list;
   struct list *rtl_iter;

   /*
    * If this loop does not have a preheader basic block, then make one
    */
   if (!loop->preheader)
      loop->preheader = preheader(loop->ptr);

   /*
    * Fix up the RTL that needs to be moved to the preheader by removing
    * all links to it and deleting any registers from the dead register
    * list that are used by the RTL, since we may be moving the RTL ahead
    * of other uses to those registers and do not want them marked dead
    * prematurely.  If they really are dead at the preheader, then the
    * next run of the dead variable elimination phase will insert these
    * deaths back here.
    */
   remv_links(rtlptr);
   reget(rtlptr->deads, reg);
   for (a = reg; *a; a = skiplocOr2(a) + 1) {
      if (isrg(a) && isref(rtlptr->val, a))
         rdelete(a, &rtlptr->deads);
   }

   /*
    * we also need to run through the rtls of the loop
    * and remove the deaths of any registers/locals set in the
    * rtl
    */
   for (block_list = loop->blocks; block_list; block_list = block_list->next) {
      for (rtl_iter = block_list->ptr->rtls; rtl_iter;
           rtl_iter = rtl_iter->next) {
         if (rtl_iter->type & RTLINE) {
            if ((a = rtlptr->val))
               while (a = gtrg(a))
                  if (*a == '=')
                     rdelete(unskiploc(a), &rtl_iter->deads);
            if ((a = rtlptr->se))
               while (a = gtrg(a))
                  if (*a == '=')
                     rdelete(unskiploc(a), &rtl_iter->deads);
         }
      }
   }

   /*
    * Unlink the RTL from its current basic block in the body of the loop
    */
   if (rtlptr->prev)
      rtlptr->prev->next = rtlptr->next;
   else
      rtlptr->daddy->rtls = rtlptr->next;
   if (rtlptr->next) {
      rtlptr->next->prev = rtlptr->prev;
      rtlptr->next = (struct list *) NULL;
   }
   else
      rtlptr->daddy->rtlend = rtlptr->prev;
#ifdef VET
   prevblk = rtlptr->daddy;
#endif

   /*
    * Insert the now disconnected RTL at the end of the preheader.  If the
    * preheader ends with a jump RTL, then we want to insert the RTL before
    * the jump.
    */
   rtlptr->daddy = cblk = loop->preheader;
   if (cblk->status & JUMP) {
      if (rtlptr->prev = cblk->rtlend->prev)
         rtlptr->prev->next = rtlptr;
      else
         cblk->rtls = rtlptr;
      rtlptr->next = cblk->rtlend;
      cblk->rtlend->prev = rtlptr;
   }
   else {
      if (rtlptr->prev = cblk->rtlend)
         rtlptr->prev->next = rtlptr;
      else
         cblk->rtls = rtlptr;
      cblk->rtlend = rtlptr;
   }
#ifdef VET
   move_rtl(rtlptr, prevblk, rtlptr->next, cblk);
#endif
}

/*
 * checkind - check induction variable
 */
int checkind(struct itriple *tptr)
{
   register struct llist *fref;
   struct itriple *fptr;


   /*
    * Ensure that either this induction variable is in the family of a basic
    * induction variable or that all of the items that go into making up this
    * induction variable dominate the RTL in which it is formed.
    */
   fptr = tptr->family->triple;
   if (fptr->status & BASIC)
      return TRUE;
   for (fref = fptr->ref; fref; fref = fref->next)
      if (!rtl_dominates(fref->ptr, tptr->ref->ptr))
         return FALSE;
   return TRUE;
}

/*
 * expand - attempt to expand the RTL as much as possible
 */
void expand(struct loopl *loop, struct list *rtlptr, char *item)
{
   struct list *ptr;
   struct setlist *sptr;
   char *a, temp[MAXSTRING + 10];
   bzero(temp, sizeof(temp));

   /*
    * Expand each register in the expression as much as is possible
    */
   a = item;
   while (a = gtrg(a)) {

      /*
       * Make no attempt to expand induction variables, since we already
       * know their value and delving any deeper into them only gets us
       * into serious trouble.
       */
      if (loop && (sptr = s_lookup(unskiploc(a)))
          && sptr->regstatus & (BASIC | INDUCTION))
         continue;

      /*
       * Start at the previous RTL and return the value of each register.
       * Recursively expand that item itself until we have the most precise
       * value of each register.
       */
      if (ptr = value_of(up_rtl(rtlptr), unskiploc(a), rinit(), temp + 1)) {
         expand(loop, ptr, temp + 1);
         if (needsparen
             ((unskiploc(a) == item) ? '[' : *(unskiploc(a) - 1), *a,
              temp + 1)) {
            *temp = '(';
            (void) strcat(temp, ")");
            if (strlen(item) + strlen(temp) <= MAXSTRING)
               a = sub(unskiploc(a), a, temp);
         }
         else if (strlen(item) + strlen(temp + 1) <= MAXSTRING)
            a = sub(unskiploc(a), a, temp + 1);
      }
   }
} /* end of expand() */

/*
 * linvar - expand loop invariant items in RTL
 */
void linvar(struct loopl *loop, char *item, char *new)
{
   register char *a, *b, c, *d;
   struct bblock *cblk;
   struct list *ptr;
   struct setlist *sptr;
   char  temp[MAXSTRING];
   bzero(temp, sizeof(temp));

   /*
    * Move the item into a temporary location so it can be expanded
    */
   (void) strcpy(new, item);

   /*
    * Look for loop invariant registers whose values are known and expand them
    */
   a = new;
   while (a = gtrg(a)) {
      if ((sptr = s_lookup(unskiploc(a)))
          && (sptr->ldead || sptr->regstatus & (BASIC | INDUCTION))) {

         /*
          * If we know where the item is set, use the value
          */
         if (sptr->ldead && sptr->ldead != top->rtls) {
            d = sptr->ldead->val;
            while (*d++ != '=') ;
            for (b = temp + 1; (c = *d++) != ';'; *b++ = c) ;
            *b = '\0';
            if (needsparen
                ((unskiploc(a) == new) ? '[' : *(unskiploc(a) - 1), *a,
                 temp + 1)) {
               *temp = '(';
               *b++ = ')';
               *b = '\0';
               a = sub(unskiploc(a), a, temp);
            }
            else
               a = sub(unskiploc(a), a, temp + 1);
         }

         /*
          * If we don't know where the item is set, try to find its value
          */
         else if (loop && (cblk = loop->preheader)) {
            if (ptr = value_of(cblk->rtlend, unskiploc(a),
                               rinit(), temp + 1)) {
               expand((struct loopl *) NULL, ptr, temp + 1);
               if (needsparen
                   ((unskiploc(a) == new) ? '[' : *(unskiploc(a) - 1), *a,
                    temp + 1)) {
                  *temp = '(';
                  (void) strcat(temp, ")");
                  a = sub(unskiploc(a), a, temp);
               }
               else
                  a = sub(unskiploc(a), a, temp + 1);
            }
         }
      }
   }
}

/*
 * xfer_recurrence - insert recurrence transfer as far into the loop as
 * possible.
 */
struct list *xfer_recurrence(struct loopl *loop, char *reg1, char *reg2)
{
   struct bblock *cblk;
   struct list *rtl;

   cblk = loop->ptr;
   rtl = cblk->rtls;
   for (;;) {
      while (rtl) {
         if (cnts(rtl)) {
            if (isset(rtl->val, reg1))
               break;
            if (isref(rtl->val, reg2))
               break;
         }
         rtl = rtl->next;
      }
      if (!rtl && cblk->left && !cblk->right && !cblk->left->preds->next) {
         cblk = cblk->left;
         rtl = cblk->rtls;
      }
      else
         break;
   }

   /* Whoa nelly.  If we reached the end of the block but can't go farther,
    * we have to insert before a branch, otherwise we get bad code.
    */
   if (rtl == NULL) {
      if (cblk->rtlend->val && is_pc(cblk->rtlend->val))
         rtl = cblk->rtlend;
   }
   return sr_asg(cblk, rtl, reg2, reg1);
}

/*
 * sr_asg - enter a register-to-register transfer RTL
 */
struct list *sr_asg(struct bblock *cblk, struct list *rtl, char *dst,
                    char *src)
{
   register char *a;
   struct list *nptr;
   struct setlist *sptr;
   rlist *deads, deadlist[MAXXFER];
   char  new[BIGSTRING];



   /*
    * We want to know how often the source register is used, and update that
    * information.  First, we obtain a pointer to the appropriate register
    * information structure.
    */
   sptr = s_add(src);

   /*
    * Now we ask the machine dependent transfer() function to tell us
    * what code needs to be inserted in order to assign the value of the
    * "src" register into the "dst" register.
    */
   deads = deadlist;
   (void) transfer(new, deads, REGISTER, regtype(dst), regnum(dst), LIVEREG,
                   regtype(src), regnum(src));

   /*
    * Since a transfer may potentially require more than one RTL on some
    * target machines, we use a mechanism that can handle that.
    */
   a = new;
   while (*a) {
      nptr = add_rtl(cblk, rtl, a, *deads++);

      /*
       * The fact that we don't catch a register if it starts the RTL
       * is quite intentional.  We don't want to count sets, just uses.
       */
      while (*a) {
         if (cmploc(a, src) == 0) {
            if (*skiploc(a) != '=')
               sptr->uses++;
            a = skiploc(a);
         }
         else
            a++;
      }
   }
   /*
    * Return a pointer to the last RTL inserted by this function
    */
   return nptr;
}

/*
 * undo - get rid of any half-formed expressions
 */
void undo(struct list *rtl)
{
   register struct list *rtl1;

   /*
    * Note that we only examine the first link, but that we do so repeatedly.
    * This works because the recursive call to ourselves will cause
    * remv_links() to be called on "rtl1" before the call returns.  This will
    * remove the reference that we have just looked at and bring the next
    * link, if any, down to the first slot.
    */
   while (rtl1 = rtl->lnks[0])
      undo(rtl1);
   remv_links(rtl);
   remv_rtl(rtl);
}

/*
 * reads_mem - return TRUE if the RTL reads from memory
 */
int reads_mem(char *rtl)
{

   while (rtl = gtmem(rtl)) {
      if (*rtl != '=')
         return TRUE;
   }
   return FALSE;
}

/*
 * remparen - remove any extraneous parentheses from expressions
 */
void remparen(register char *a)
{
   char *b, c, *d;

   assert(NULL != a);

   b = a;
   while (c = *a++) {
      if (c == '(') {
         if (isreg(a)) {
            if (*(skiploc(a)) == ')') {
               copyloc(b, a);
               b = skiploc(b);
               a = skiploc(a) + 1;
               continue;
            }
         }
         else if ((d = is_const(a)) && *d == ')') {
            do {
               *b++ = *a++;
            } while (a != d);
            a++;
            continue;
         }
      }
      *b++ = c;
   }
   *b = '\0';
}


int close_enough(struct list *start, struct list *end, char *reg1, char *reg2)
{
   struct list *rtlptr = NULL;

   assert(NULL != start);
   assert(NULL != end);

   if (start->rnum > end->rnum) {
      /* Swap if they're in the wrong order. */
      rtlptr = end;
      end = start;
      start = rtlptr;
   }

   for (rtlptr = start->next; rtlptr && rtlptr != end; rtlptr = rtlptr->next) {
      if (cnts(rtlptr)) {
         if (isaliasref(rtlptr->val, reg1))
            return FALSE;
         if (isaliasref(rtlptr->val, reg2))
            return FALSE;
         if (isaliasset(rtlptr->val, reg1))
            return FALSE;
         if (isaliasset(rtlptr->val, reg2))
            return FALSE;
      }
      if (rtlptr->se) {
         if (isaliasref(rtlptr->se, reg1))
            return FALSE;
         if (isaliasref(rtlptr->se, reg2))
            return FALSE;
         if (isaliasset(rtlptr->se, reg1))
            return FALSE;
         if (isaliasset(rtlptr->se, reg2))
            return FALSE;
      }
   }
   return (NULL != rtlptr);
}

/*  
 * should_replace - should the induction variable in fptr be replaced in this
 * loop?
 */
int should_replace(struct setlist *fptr, struct loopl *loop)
{
   struct bblock *cblk = NULL;
   struct blist *cptr = NULL;
   struct list *rtlptr = NULL;
   char *ptr1, *ptr2, *rtlin;
   int   comparisons = 0;
   char  expr[MAXSTRING];

   assert(fptr && loop);

   for (cptr = loop->blocks; cptr; cptr = cptr->next) {
      cblk = cptr->ptr;
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         if (rtlin = cnts(rtlptr)) {
            if (comparison
                (rtlptr->val, rtlptr, fptr->item, expr, &ptr1, &ptr2))
               comparisons++;
         }
      }
   }
   return (fptr->uses - fptr->triple->count - comparisons == 0);
}

/*
 * discard_duplicate triple() - if first two triples are the same, then
 * free the memory for the first one and make the second one be the first
 * triple in the triple list and return it.
 */
struct itriple *discard_duplicate_triple()
{
   struct itriple *nptr;
   assert(NULL != ftriple);
   nptr = ftriple->next;        /* shorthand */

   if (NULL != nptr) {
      if ((ftriple->status == nptr->status)
          && (ftriple->type == nptr->type)
          && (ftriple->count == nptr->count)
          && (ftriple->cee == nptr->cee)
          && (ftriple->family == nptr->family)
          && (ftriple->part == nptr->part)
          && (0 == strcmp(ftriple->dee, nptr->dee))
          && (0 == strcmp(ftriple->pat, nptr->pat))
          && ((NULL != ftriple->ref)
              && (NULL != nptr->ref)
              && (ftriple->ref->ptr == nptr->ref->ptr))) {
         /* They are the same triple. */
         struct llist *lptr = ftriple->ref, *next_lptr;
         do {
            next_lptr = lptr->next;
            FREETYPE(lptr, LLISTTYPE);
            lptr = next_lptr;
         } while (lptr);
         FREETYPE(ftriple, ITRIPLETYPE);
         ftriple = nptr;        /* Advance to second element in list. */
      }
   }
   return ftriple;
}
