/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/cdmotion.h,v $
 $Date: 2004/01/21 18:39:51 $
 $Revision: 1.7 $
 $Name:  $

 Log of changes:

 $Log: cdmotion.h,v $
 Revision 1.7  2004/01/21 18:39:51  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.6  2003/11/18 01:54:32  clc5q
 Added LoopAnalysesForProfiling() so that global data profiling can do
    just enough loop analyses to be able to successfully compute loop
    iterations using iterations(), without doing code motion, which
    makes global profiling more difficult.

 Revision 1.5  2003/08/01 04:36:22  jg9h
 Added support for loop count down and repeat blocks

 Revision 1.4  2002/07/11 15:19:42  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.3  2001/11/22 02:19:23  jdh8d
 *** empty log message ***

 Revision 1.2  1998/04/28 19:20:09  jwd
 Removed some commented out code.
 Revision 1.1  1998/04/03 18:16:10  jwd
 Initial revision

*************************************************************************/

#ifndef CDMOTION_H
#define CDMOTION_H

/*  I could not find the origin of the following: 
..................................................*/

#ifdef WIDES
    int doubleldst();
#endif

/*.............................................................
   THIS FUNCTION DEALS WITH BILL WULF's STREAMING ARCHITECTURE
#ifdef STREAM
    int stream();
#endif

/*...........................................................*/


extern struct itriple  *ftriple;
extern struct memgroup *partitions;

int LoopAnalysesForProfiling(struct loopl *loop, char *, int *, char *, int *);

struct bblock *is_single_exit_loop(struct loopl *loop);
struct bblock *natural_preheader(struct bblock *cblk);
void ind_var_analysis(struct loopl *loop);

int
code_motion(int);

int
loop_strength_reduction(struct loopl *, int);

int
recurrences(struct loopl *, int, int, int);

int
induction_variable_elimination(struct loopl *, int);

int
remv_induction_variables(struct loopl *);

void
getbasic(struct list *, char *, struct loopl*);

void
getind(struct loopl *, struct bblock *, struct list *, char *);

void
calcinduction(struct itriple *, struct itriple *, int, char *);

int
remexpr(struct memgroup *, char *);

int convert_to_repeat_block(struct loopl *loop, int invocation);
int convert_to_count_down(struct loopl *loop, int invocation);
/*.....reduce: machine dependent with alpha.......*/
#ifdef __alpha
void
reduce(struct loopl *, struct itriple *, struct setlist *, char *, char *,
       int, char *);
#else
void
reduce(struct loopl *, struct itriple *, struct setlist *, char *,
       char *, int);
#endif

void
replace(struct list *, char *, char *);

int
iterations(struct loopl *, struct setlist **, char *);

int
everytime(struct loopl *, struct bblock *);

void
move_rtl_to_preheader(struct loopl *, struct list *);


int
checkind(struct itriple *);

void
expand(struct loopl *, struct list *, char *);

void
linvar(struct loopl *, char *, char *);

struct list *
xfer_recurrence(struct loopl *, char *, char *);

struct list *
sr_asg(struct bblock *, struct list *, char *, char *);

void
undo(struct list *);

int
reads_mem(char *);

void
remparen(char *);

/* Can be useful to machine dependent part */
int is_count_down_loop(struct loopl *loop);

#endif
