
/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/combine.c,v $
 $Date: 2003/09/08 14:27:34 $
 $Revision: 1.119 $
 $Name:  $

 Log of changes:

 $Log: combine.c,v $
 Revision 1.119  2003/09/08 14:27:34  clc5q
 Ran indent tool over file and fixed up a few cosmetic details by hand.

 Revision 1.118  2003/08/01 04:38:25  jg9h
 Added check for generic register trashlines

 Revision 1.117  2003/07/07 17:34:02  jg9h
 Changes to simp() for the tms320c54x target

 Revision 1.116  2003/05/03 03:38:29  jg9h
 Forgot to return from wrapper function reverse_merge_check()

 Revision 1.115  2003/04/29 19:51:03  jg9h
 tms320c54x specific changes to simp(). Namely use atoll() instead of atol().

 Revision 1.114  2003/03/28 14:45:35  jdh8d
 *** empty log message ***

 Revision 1.113  2003/03/26 19:19:23  clc5q
 Add distribute_adds() as a subroutine called from simp().

 Revision 1.112  2003/03/26 17:29:50  jdh8d
 fixed the combiner to remove extra deaths.. they'll get added later anyhow

 Revision 1.111  2003/03/25 20:27:17  jdh8d
 fix can_move_rtl to not allow PC= to move

 Revision 1.110  2003/03/25 18:00:42  jdh8d
 reverse merge left extra deaths

 Revision 1.109  2003/03/24 18:16:24  jdh8d
 added pushl rtls

 Revision 1.108  2003/03/22 03:48:57  clc5q
 Remove commented-out code. Fix typo in comment.

 Revision 1.107  2003/03/20 21:39:14  jg9h
 Modularized merge_check() using can_move_rtl()

 Revision 1.106  2003/03/20 15:01:50  jdh8d
 sign-ext fix for x86

 Revision 1.105  2003/03/18 20:32:56  jdh8d
 *** empty log message ***

 Revision 1.104  2003/03/14 14:44:13  clc5q
 Make maybe_same() operate on simp()-ed address expressions throughout.

 Revision 1.103  2003/03/14 01:34:19  jdh8d
 i386 bug fixes

 Revision 1.102  2003/03/06 16:13:09  jdh8d
 *** empty log message ***

 Revision 1.101  2003/03/05 15:45:58  clc5q
 Add assertions and diagnostic output.
 
 Revision 1.100  2003/02/15 00:09:31  clc5q
 Get rid of "extern int moreopts;" and other stupid "extern" statements and
   other sources of compiler warnings.

 Revision 1.99  2003/02/06 04:46:27  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.98  2003/01/31 20:28:18  clc5q
 Use skiplocOr2() rather than skiploc() when traversing the dead_regs[]
    list, which is a null-character separated list of locations that
    can include things like "NZ" or "IC" on various targets, which are
    not like the registers, locals, etc. that skiploc() is designed to
    handle.  skiploc() will only advance one character when it sees "NZ",
    for example, leaving us positioned on the "Z".

 Revision 1.97  2003/01/30 05:47:10  clc5q
 Avoid runaway loop in se_check() by properly ordering the conditions for
     "break" and "continue" statements.

  Revision 1.96  2003/01/29 20:48:04  clc5q
 Get rid of nested VET transaction problem in instruction_selection().  Instead
    of surrounding the entire processing of an RTL with a VET_OPT_TRANS
    type of transaction, which causes nesting of the optimizing transactions
    within combine_rtls(), which is called from this loop, just surround
    the mdlinks() call with a VET_REQUIRED_TRANS transaction.

 Revision 1.95  2003/01/28 14:24:08  clc5q
 Merge fix from Joshua into merge_rtls(), discovered due to the TMS320c54x
     autoincrement and autodecrement modes, in which the merge of RTLs was
     losing the decrement or increment effect.

 Revision 1.94  2003/01/24 20:49:35  clc5q
 Get rid of typecast compiler warning.

 Revision 1.93  2003/01/24 20:18:24  clc5q
 Move maybe_same() from each target's rtl.c module up into combine.c.
    Make calls into rtl.c for machine-dependent information or processing.
    Totally re-write maybe_same() to use simp() and case by case processing
    with lots of assertions.

 Revision 1.92  2003/01/07 22:33:53  clc5q
 Combining RTLs and leaving the dead list non-empty on the new RTL
    sometimes left us with a location that is both set and dead in the
    same RTL, which doesn't make sense.  We remove such items from the
    dead list now.

 Revision 1.91  2002/11/18 19:34:01  jdh8d
 debug fixes, arm pre/post modification fixes
 
 Revision 1.90  2002/10/24 17:18:27  clc5q
 Fully implement reverse_mem_merge_check().

 Revision 1.89  2002/10/10 01:26:10  jg9h
 mem_merge_check now uses maybe_same() and is thus less conservative.
 Added some more information to the -dinstruction_selection output
 Added code to prevent moving of a read in a side-effect past a write of that same register in any intervening rtl (in merge_check())

 Revision 1.88  2002/07/11 15:22:29  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.87  2002/06/13 17:41:19  jdh8d
 mips fixes

 Revision 1.86  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.85  2002/03/15 20:35:35  jwd
 Cleaned up the code and bit and add some comments.

 Revision 1.84  2002/02/14 13:59:14  jdh8d
 merge check fixes

 Revision 1.83  2002/01/01 15:34:35  rv3s
 Side effect string cleared if SE is not set for the instrn

 Revision 1.82  2001/12/31 02:45:31  rv3s
 Topmost rtl being merged passed to comp

 Revision 1.81  2001/12/29 13:40:02  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.80  2001/12/18 15:17:34  rv3s
 all_lnks array used to drive the combine rather than the lnks array since
 all_lnks contain both safe and unsafe links and unsafe links are sometimes
 useful in 3-way and reverse merges.

 Revision 1.79  2001/12/06 21:30:34  rv3s
 *** empty log message ***

 Revision 1.78  2001/12/05 19:18:42  rv3s
 isoper() replaces is_op() in simp()

 Revision 1.77  2001/12/05 19:07:51  rv3s
 Additional check in merge_check to ensure that the use of a register does not get past a set (in 3-way merge).

 Revision 1.76  2001/12/05 17:51:03  jdh8d
 *** empty log message ***

 Revision 1.75  2001/12/03 19:52:57  jdh8d
 *** empty log message ***

 Revision 1.74  2001/11/27 21:59:18  rv3s
 In three way merge check, make sure registers defined in the top most merged rtl is not used before the merge rtl

 Revision 1.73  2001/11/27 20:29:11  rv3s
 Check added in simp() to make sure (reg op -const)+const doesnt get combined the wrong way

 Revision 1.72  2001/11/20 17:08:22  jdh8d
 *** empty log message ***

 Revision 1.71  2001/11/19 15:50:54  jdh8d
 minor bug fix

 Revision 1.70  2001/11/16 17:17:33  rv3s
 New routine set_rtl_sides() added to set the SE of a single rtl

 Revision 1.69  2001/11/13 19:05:32  jdh8d
 *** empty log message ***

 Revision 1.68  2001/11/13 17:04:50  jdh8d
  fixed memory leaks

 Revision 1.67  2001/11/06 14:32:17  jdh8d
 *** empty log message ***

 Revision 1.66  2001/11/05 17:26:02  jdh8d
 *** empty log message ***

 Revision 1.65  2001/11/04 06:20:50  jdh8d
 *** empty log message ***

 Revision 1.64  2001/11/03 17:18:13  jdh8d
 *** empty log message ***

 Revision 1.63  2001/11/01 22:46:22  jdh8d
 *** empty log message ***

 Revision 1.62  2001/10/30 22:33:36  jdh8d
 *** empty log message ***

 Revision 1.61  2001/10/29 22:32:40  jdh8d
 *** empty log message ***

 Revision 1.60  2001/10/29 21:58:59  jdh8d
 *** empty log message ***

 Revision 1.59  2001/10/29 21:25:55  jdh8d
 *** empty log message ***

 Revision 1.58  2001/10/29 19:23:19  jdh8d
 *** empty log message ***

 Revision 1.57  2001/10/29 18:37:23  jdh8d
 *** empty log message ***

 Revision 1.56  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.55  2001/10/28 16:42:03  rv3s
 *** empty log message ***

 Revision 1.54  2001/10/22 18:48:29  jdh8d
 *** empty log message ***

 Revision 1.53  2001/10/22 13:57:28  jdh8d
 *** empty log message ***

 Revision 1.52  2001/09/30 17:37:11  jdh8d
 *** empty log message ***

 Revision 1.51  2001/09/25 15:30:30  jdh8d
 *** empty log message ***

 Revision 1.50  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.49  2001/09/19 21:30:04  rv3s
 Dead list fix after merge_rtl. If the maydie list (after merge_rtls) contains
 some items, make sure all aliases of that item are removed from the dead list.
 The following problem was encountered (in arm soft-float)

      1 r[2] = r[1]; r[1]
      2 d[0] = D[r[0]]; r[0]
      3 d[7] = d[0]; r[0]r[1]d[0]f[1]f[2]

   2 and 3 merge into
        d[7] = d[0]; r[0]r[1]f[1]f[2]

 r[0],r[1],f[1] and f[2] are aliases of d[0]. When 2 and 3 merge, d[0] dies.
 But it is not sufficient to remove just d[0] from the death list of the combined
 rtls. We need to remove r[1],f[1] and f[2] (r[0] is referred in the merged rtl).
 Otherwise, CSE may not be able to extend the death of r[1] in rtl 1 if it needs
 to (as r[1] would be dead in the merged rtl), resulting in bad code.

 Revision 1.48  2001/09/14 12:48:50  jdh8d
 no message

 Revision 1.47  2001/09/06 20:32:27  jdh8d
 *** empty log message ***

 Revision 1.46  2001/08/31 17:38:17  jdh8d
 *** empty log message ***

 Revision 1.45  2001/08/31 16:20:23  rv3s
 Useless parenthesis removed before and after the algebraic simplification

 Revision 1.44  2001/08/31 15:45:45  rv3s
 simp() now removes useless paranthesis (such as (r[x])) around registers, locals, globals and constants

 Three-way merge check fixed to merge in the correct order

 Revision 1.43  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.42  2001/08/29 18:16:00  jdh8d
 *** empty log message ***

 Revision 1.41  2001/08/29 17:39:11  jdh8d
 *** empty log message ***

 Revision 1.40  2001/08/29 16:44:31  jdh8d
 *** empty log message ***

 Revision 1.39  2001/08/28 21:05:00  jdh8d
 *** empty log message ***

 Revision 1.38  2001/08/15 21:18:22  jdh8d
 *** empty log message ***

 Revision 1.37  2001/08/14 14:42:12  jdh8d
 *** empty log message ***

 Revision 1.36  2001/08/14 13:50:31  jdh8d
 *** empty log message ***

 Revision 1.35  2001/08/13 23:22:55  jdh8d
 *** empty log message ***

 Revision 1.34  2001/08/01 18:22:21  rv3s
 In se_check(), targets that use the A[] addressing scheme should check if the rtl is autoincr/decr and matches the side effect. If so, the rtls can be combined.

 Revision 1.33  2001/07/27 20:09:48  jdh8d
 *** empty log message ***

 Revision 1.32  2001/07/24 19:04:00  rv3s
 Modified simp() to handle expressions like (r[]+const1)-const2+const3 correctly. simp() wasnt expecting a constant to follow ')'

 Revision 1.31  2001/07/23 18:27:00  rv3s
 Replaced skiploc() with skiplocOr2() and copyloc() with copylocOr2 for processing register lists

 Revision 1.30  2001/07/20 15:48:49  jdh8d
 *** empty log message ***

 Revision 1.29  2001/06/11 19:33:28  jdh8d
 *** empty log message ***

 Revision 1.28  2001/06/08 15:05:51  jdh8d
 *** empty log message ***

 Revision 1.27  2001/06/05 18:55:38  jdh8d
 *** empty log message ***

 Revision 1.26  2001/05/25 13:53:42  jdh8d
 *** empty log message ***

 Revision 1.25  2001/05/25 00:36:05  jdh8d
 *** empty log message ***

 Revision 1.24  2001/05/23 20:28:20  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.23  2001/05/21 18:43:11  jdh8d

 changes to watch register aliases and SE's more clothes

 Revision 1.22  2001/05/12 19:51:01  jdh8d
 *** empty log message ***

 Revision 1.21  2001/05/12 16:05:00  jdh8d
 *** empty log message ***

 Revision 1.20  2001/05/09 19:36:27  jdh8d
 *** empty log message ***

 Revision 1.19  2001/04/24 14:32:50  jdh8d
 *** empty log message ***

 Revision 1.18  2001/04/20 19:08:54  jdh8d
 *** empty log message ***

 Revision 1.17  2001/04/19 15:11:03  jdh8d
 Initial implentation of "if conversion" for basic predicated
 execution.

 Revision 1.16  2001/04/10 14:38:51  jdh8d

 Minor bug in combine.c

 Revision 1.15  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.14  2001/03/28 18:30:43  jdh8d


 Added code to merge_check to see if a memory operation
 is going to move across a t*, to another block across another
 memory operation.  In general, the combiner can't make this
 sort of combine.

 Revision 1.13  2001/03/23 21:58:18  jdh8d

 initialized memChar in locals.c
 fixed combiner bug, see comments in combine.c

 Revision 1.12  2001/03/14 18:17:39  jdh8d

 look at update_equivalence_table;  found and fixed a bug there, hopefully.

 Revision 1.11  2001/03/12 20:02:37  jdh8d
 *** empty log message ***

 Revision 1.10  2000/03/15 16:19:19  jwd
 How side effects are handled was changed.  Previously, if the RTL recognizer
 did not compute a side effects, any existing side effect was eliminated.  This
 caused problems because side effects are used to indicate what registers
 are being used in a function call (the actual use is hidden in the called function).

 Revision 1.9  1999/07/29 15:58:53  jwd
 Fixed a comment that got mangled in reformatting the code.
 Also fixed a call to VET that needed an argument.
 Revision 1.8  1999/03/05 17:12:08  jwd
 Moved some declarations to a header file.
 Revision 1.7  1998/11/16 19:15:06  jwd
 Added VET directives.
 Revision 1.6  1998/10/06 20:10:03  jwd
 Added VET code
 Revision 1.5  1998/04/28 19:21:00  jwd
 Added include of vpo2 header file.
 Revision 1.4  1998/04/03 18:17:48  jwd
 First ANSI C version.
 Revision 1.3  1998/04/03 18:17:06  jwd
 First ANSI C version.

*************************************************************************/


/* HISTORY OF CHANGES ----------------------------

   1/8/98 ANSI-C'fied the parameter declarations. Note

   ALSO NOTE: The header file contains data. We should take this out.

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "vpo.h"
#include "vpo2.h"
#include "assign.h"
#include "combine.h"
#include "database.h"
#include "links.h"
#include "misc.h"
#include "simp.h"
#include "vectors.h"

#include "y.tab2.h"     /*Machine Dependent */
#include "rtl.h"   /*Machine Dependent */
#include "inst.h"  /* Machine Dependent */
#include "isem.h"  /* Machine Dependent */

#ifdef VET
#include "view.h"
#endif

/*
 * This file contains functions that deal with combining and simplifying RTLs
 */

#define PAREN ((char) 1)        /* Add parentheses to this expression        */
#define NOPAREN ((char) 2)      /* No parentheses on this expression         */

struct list *curptr;            /* set to the RTL currently being parsed     */
char *linptr;                   /* pointer to current parse location         */
rlist deadlist;                 /* pointer to the current dead variable list */
char *side_effect = NULL;       /* pointer to side effect result buffer      */
int   erflag;                   /* set when a semantic error is detected     */
int   icost;                    /* returns cost of the instruction parsed    */
int   ikind;                    /* returns kind of the instruction parsed    */
char *reason;                   /* the mach-dependent part can set this so that
                                 * we know why an RTL was rejected.  Useful for
                                 * debugging "cannot assemble" messages, etc.
                                 */

void  set_sides();
int   se_check(struct list *ptr, struct list *bptr, struct list *mptr,
               char *new_side);
int   mdsimp(char *, int);
void  debug_show_rtl(struct list *ptr);

int   rtl_has_conflicts(struct list *ptr, struct list *target);
int   can_move_rtl(struct list *start, struct list *end,
                   struct llist *ignore);

static int merge_check_2(struct list *ptr, struct list *bptr);
static int rtl_has_reg_conflicts_helper(char *val, struct list *ptr);

/* Used in sparc/regs.c */
int   reverse_merge_check(struct list *ptr, struct list *bptr,
                          struct list *mptr);
static int reverse_merge_check_2(struct list *ptr, struct list *bptr);
static int merge_check_3(struct list *ptr, struct list *bptr,
                         struct list *mptr);
static int merge_check_4(struct list *ptr, struct list *bptr,
                         struct list *mptr, struct list *dptr);
void  remove_extraneous_deaths(struct list *ptr);

/* reverse_merge_check - backward compatibility (sparc/regs.c makes a call). */
int reverse_merge_check(struct list *ptr, struct list *bptr,
                        struct list *mptr)
{
   if (mptr)
      return TRUE;
   return reverse_merge_check_2(ptr, bptr);
}

/*
 * instruction_selection - perform instruction selection on the function
 */
#ifdef INTERACT
int instruction_selection(int invocation, int global)
#else
int instruction_selection(int invocation)
#endif
{

   register struct list *ptr;
   register struct bblock *cblk;
   register int rnum;
   int   change, debug;
#ifdef INTERACT
   extern int limited_scope;
#endif

#ifndef INTERACT
#ifdef VET

   if (!moreopts)
      return FALSE;
#endif
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_instruction_selection", invocation))
      dump_function_i("before instruction_selection()", invocation,
                      SHOW_COST | SHOW_SE);

   if (swd && debug_opt("no_instruction_selection"))
      return 0;

   /*
    * Determine if the user wants to see debug information from this phase.
    */
   debug = swd && debug_opt_i("instruction_selection", invocation);

#ifdef VET
#ifdef INTERACT
   if (global)
      begin_phase(GLOBAL_INST_SELECT_TRANS);
   else
      begin_phase(INST_SELECT_TRANS);
#else
   begin_phase(INSTSELECT_PHASE);
#endif
#endif


   /* Some optimizations may not have simplified/complicated all
    * RTLs 100% correctly.  We'll scan them quick just
    * to make sure we're working on the best RTLs we can.
    */
   for (cblk = top; cblk; cblk = cblk->down) {
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
         if ((ptr->type & RTLINE) && ptr->val) {
            comp(ptr->val, NULL, ptr, ptr);
         }
      }
   }
#ifdef INTERACT
   begin_trans(VET_OPT_TRANS);
#endif
   /* Make sure we have up-to-date SE info for all instructions. */
   set_sides();
#ifdef INTERACT
   end_trans();
#endif

   rnum = 1;
   change = FALSE;

   /*
    * Examine each RTL from the entry basic block in output order.  Number each
    * RTL as we come to it so that we can later determine if one RTL came
    * before another.
    */
   for (cblk = top; cblk; cblk = cblk->down) {
#ifdef INTERACT
      if (swq && limited_scope && !cblk->inscope)
         continue;
#endif
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
         if (ptr->type & RTLINE) {
            ptr->rnum = rnum++;

            /*
             * Remember where we last saw the death of a register, so that we
             * can extend the life of a register if a combination causes the
             * life of a register to be extended beyond the point at which it
             * was marked dead.
             */
            if (ptr->deads)
               remember_deaths(ptr);

            /*
             * Some machine require combiner links to be set up from certain
             * special instructions to handle cases that would not be taken
             * care of by the normal method of setting combiner links based on
             * register uses.  The call to the machine-dependent function
             * mdlinks() provides a mechanism to handle such special cases.
             */
            if (ptr->val) {
#ifdef VET
               begin_trans(VET_REQUIRED_TRANS);
#endif
               mdlinks(ptr);
#ifdef VET
               end_trans();
#endif
            }

            /*
             * If this RTL was marked for attention by the next invocation of
             * the instruction selection phase, then attempt to combine it.
             */
            if (ptr->type & COMBLINE)
               change |= combine_rtls(ptr, debug);
         }
      }
   }

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_instruction_selection", invocation))
      dump_function_i("after instruction_selection()", invocation,
                      SHOW_COST | SHOW_SE);

#ifdef VET
#ifdef INTERACT
   if (global)
      end_phase(GLOBAL_INST_SELECT_TRANS);
   else
      end_phase(INST_SELECT_TRANS);
#else
   end_phase(INSTSELECT_PHASE);
#endif
#endif

   /*
    * Indicate whether or not this phase has selected any new instructions.
    */
   return change;
} /* end of instruction_selection() */


/*
 * combine_rtls - combine an RTL with the RTLs that it has combiner links to.
 */
int combine_rtls(struct list *ptr, int debug)
{

   struct list *bptr, *tptr;
   struct setlist *dp;
   int   i, j;
   char *a;
   int   change;
   char  new[MAXSTRING], new3[MAXSTRING], new4[MAXSTRING];
   char  maydie[MAXSTRING], *maydie2, side[MAXSTRING];

   *maydie = 0;
   change = FALSE;

   /*
    * Attempt to merge the current RTL with all of the RTLs that it has
    * combiner links set to.
    */
   for (i = 0; i < MAXLINKS && (bptr = ptr->all_lnks[i]); i++) {

      /*
       * If the link points forward to some RTL that is "ahead" of this one,
       * then pass it up at this time.
       */
      if (ptr->rnum < bptr->rnum)
         continue;

      /*
       * Display debug information if the user requested it.
       */
      if (debug) {
         (void) fprintf(stderr, "Merging : ");
         show_rtl(stderr, bptr->val);
         (void) fprintf(stderr, "\t");
         rshow(bptr->deads);
         (void) fprintf(stderr, "\n");
         (void) fprintf(stderr, "    and : ");
         show_rtl(stderr, ptr->val);
         (void) fprintf(stderr, "\t");
         rshow(ptr->deads);
         (void) fprintf(stderr, "\n");
      }

      /*
       * Merge the two RTLs together using symbolic interpretation.  Call the
       * machine description if we have formed a new RTL and find out if there
       * is a legal instruction on the target machine that performs the desired
       * operation.
       */
      (void) strcpy(new3, ptr->val);
      *maydie = '\0';
      merge_rtls(bptr->val, new, new3, ptr->deads, rinit(), maydie);
      simp(new, FALSE);

#ifdef ADDR
      address(new);
#endif

      comp(new, maydie, ptr, bptr);

      /*
       * Test the new RTL to see if the combination of the two is a legal
       * instruction on the target machine.  If not, go on and try three-way
       * combinations.
       */
      side_effect = side;
      *side = '\0';
      if (!find(ptr, new, ptr->deads)) {

         /*
          *      Display debug information if the user requested it.
          */
         if (debug) {
            (void) fprintf(stderr, "accepted: ");
            show_rtl(stderr, new);
            (void) fprintf(stderr, "\n");
         }

         /*
          * Check the RTLs between the items being merged to ensure that
          * performing the merge does not cause any register set/use problems.
          */
         if (se_check(ptr, bptr, (struct list *) NULL, side)) {
            if (debug) {
               fprintf(stderr, " but side_effect check rejects\t");
               fprintf(stderr, "newside=\"");
               show_rtl(stderr, side);
               fprintf(stderr, "\"\n");
            }
            continue;
         }
         if (merge_check_2(ptr, bptr)) {
            if (debug)
               fprintf(stderr, " but merge check rejects\n");
            if (reverse_merge_check_2(ptr, bptr)) {
               if (debug)
                  fprintf(stderr, " and reverse-merge check rejects\n");
               continue;
            }
            else {
#ifdef VET
               begin_trans(VET_OPT_TRANS);
#endif
               if (debug)
                  fprintf(stderr, " but reverse-merge-check accepts.. yay\n");
               reremember_deaths(bptr, ptr);

               set(ptr, new, side);

               merge_links(ptr, bptr);
#if 0
               merge_deads(ptr, bptr, new);
#endif
               if (bptr->type & ARGLINE)
                  ptr->type |= ARGLINE;



               while (ptr->next && (ptr->next->type & USELINE)) {
                  struct list *useline = ptr->next;

                  /* First, remove useline from after ptr. */
                  if (useline->next)
                     useline->next->prev = ptr;
                  else
                     useline->daddy->rtlend = ptr;
                  ptr->next = useline->next;

                  /* Then, insert the useline after bptr. */
                  useline->prev = bptr;
                  useline->next = bptr->next;
                  if (useline->next)
                     useline->next->prev = useline;
                  else
                     bptr->daddy->rtlend = useline;
                  bptr->next = useline;
                  useline->daddy = bptr->daddy;
               }

               remv_links(ptr);
               remv_links(bptr);
               /* New fix: If a regr is in maydie list, remove any alias 
                * that is not referred in the RTL.
                */
               for (a = maydie; *a; a = skiplocOr2(a) + 1) {
                  char *c = 0;
                  if (pseudoreg(a))
                     continue;
                  c = aliases(a);
                  while (*c) {
                     if (!fmatch(ptr->val, c))
                        rdelete(c, &ptr->deads);
                     c = skiploc(c) + 1;
                  }
               }

               for (dp = setsused; dp; dp = dp->next) {
                  if (dp->ldead == bptr) {
                     dp->ldead = (struct list *) NULL;
                     dp->rnum = 0;
                  }
               }


               /* Now move the RTL value up to bptr instead of ptr.    */
               bptr->val = ptr->val;
               ptr->val = 0;

               /* The deads can't go, so we mark bptrs deads as empty. */
#if 0              /* comment out; too conservative. */
               bptr->deads = rinit();
#endif
               ptr->deads = rinit();

               /* If a register is set in the RTL, it cannot be dead in the
                * same RTL.
                */
               a = bptr->val;
               while (*a) {
                  if (isrg(a) && *skiploc(a) == '=') {
                     rdelete(a, &bptr->deads);
                     a = skiploc(a) - 1;
                  }
                  while (*a++ != ';') ;
               }

               remove_extraneous_deaths(bptr);
               change = TRUE;
               i = -1;
#ifdef VET
               end_trans();
#endif
               break;


            }
         }
         /* merge_check() says OK */
#ifdef VET
         begin_trans(VET_OPT_TRANS);
#endif

         reremember_deaths(bptr, ptr);
         set(ptr, new, side);
         merge_links(ptr, bptr);
         merge_deads(ptr, bptr, new);
         if (bptr->type & ARGLINE)
            ptr->type |= ARGLINE;

         /*
          * Delete the RTL that has been merged into the current RTL from the
          * function after ensuring that any pointers that remain to this RTL
          * in the register information structure are removed.
          */
         for (dp = setsused; dp; dp = dp->next) {
            if (dp->ldead == bptr) {
               dp->ldead = (struct list *) NULL;
               dp->rnum = 0;
            }
         }
         remv_rtl(bptr);

         /* New fix: If a regr is in maydie list, remove any alias 
          * that is not referred in the RTL.
          */
         for (a = maydie; *a; a = skiplocOr2(a) + 1) {
            char *c = aliases(a);
            if (pseudoreg(a))
               continue;
            while (*c) {
               if (!fmatch(ptr->val, c))
                  rdelete(c, &ptr->deads);
               c = skiploc(c) + 1;
            }
         }
         /*
          * Now remove from the new dead variable list any items that may die
          * and do not appear in the new RTL.
          */

         remove_extraneous_deaths(ptr);
         for (a = maydie; *a; a = skiplocOr2(a) + 1)
            if (!fmatch(ptr->val, a))
               rdelete(a, &ptr->deads);

         /*
          * Set up any combiner links to this RTL that may be dictated by the
          * requirements of the target machine.
          */
         mdlinks(ptr);

         /*
          * Indicate that a change has been made to the function and re-start
          * the merge process starting with the first combiner link to handle
          * cases where the change just made now allows a merge with another
          * RTL that we could not previously merge with.
          */
         change = TRUE;
         i = -1;
#ifdef VET
         end_trans();
#endif
         break;
      }

      /*
       * Now, we will attempt to merge three RTLs together to form a single
       * one.  If valid, we merge them all into a single RTL.
       */
      else {

         /*
          * Display debug information if the user requested it
          */
         if (debug) {
            (void) fprintf(stderr, "rejected: ");
            show_rtl(stderr, new);
            (void) fprintf(stderr, "  (erflag = %d)\n", erflag);
         }

         /*
          * Determine where the end of the "maydie" string created in the first
          * merge is, so that we can add to it in the later merges.
          */
         maydie2 = maydie;
         while (*maydie2)
            maydie2 = skiplocOr2(maydie2) + 1;

         for (j = 0; j < MAXLINKS && (tptr = bptr->all_lnks[j]); j++) {

            if (debug) {
               (void) fprintf(stderr, "Merging : ");
               show_rtl(stderr, tptr->val);
               (void) fprintf(stderr, "\t");
               rshow(tptr->deads);
               (void) fprintf(stderr, "\n");
               (void) fprintf(stderr, "    and : ");
               show_rtl(stderr, bptr->val);
               (void) fprintf(stderr, "\t");
               rshow(bptr->deads);
               (void) fprintf(stderr, "\n");
               (void) fprintf(stderr, "    and : ");
               show_rtl(stderr, ptr->val);
               (void) fprintf(stderr, "\t");
               rshow(ptr->deads);
               (void) fprintf(stderr, "\n");
            }

            (void) strcpy(new4, new);

            *maydie2 = '\0';
            merge_rtls(tptr->val, new3, new4, ptr->deads, bptr->deads,
                       maydie2);
            simp(new3, FALSE);

#ifdef ADDR
            address(new3);
#endif

            comp(new3, maydie, ptr, tptr);

            side_effect = side;
            *side = '\0';
            if (find(ptr, new3, ptr->deads)) {

               /*
                * Display debug information if the user requested it.
                */
               if (debug) {
                  (void) fprintf(stderr, "rejected: ");
                  show_rtl(stderr, new3);
                  (void) fprintf(stderr, "  (erflag = %d)\n", erflag);
               }

               continue;
            }

            /*
             * Display debug information if the user requested it.
             */
            if (debug) {
               (void) fprintf(stderr, "accepted: ");
               show_rtl(stderr, new3);
               (void) fprintf(stderr, "\n");
            }

            if (merge_check_3(ptr, bptr, tptr)) {
               if (debug)
                  fprintf(stderr, " but merge check rejects\n");
               continue;
            }
            if (se_check(ptr, bptr, (struct list *) NULL, side)) {
               if (debug) {
                  fprintf(stderr, " but side_effect check rejects\n");
                  fprintf(stderr, "newside=\"");
                  show_rtl(stderr, side);
                  fprintf(stderr, "\"\n");
               }
               continue;
            }

#ifdef VET
            begin_trans(VET_OPT_TRANS);
#endif
            reremember_deaths(tptr, ptr);
            merge_links(bptr, tptr);
            merge_deads(ptr, tptr, new3);
            if (tptr->type & ARGLINE)
               ptr->type |= ARGLINE;

            for (dp = setsused; dp; dp = dp->next) {
               if (dp->ldead == tptr) {
                  dp->ldead = (struct list *) NULL;
                  dp->rnum = 0;
               }
            }
            remv_rtl(tptr);

            merge_links(ptr, bptr);
            merge_deads(ptr, bptr, new3);
            if (bptr->type & ARGLINE)
               ptr->type |= ARGLINE;

            for (dp = setsused; dp; dp = dp->next) {
               if (dp->ldead == bptr) {
                  dp->ldead = (struct list *) NULL;
                  dp->rnum = 0;
               }
            }
            remv_rtl(bptr);
            bptr = 0;

            set(ptr, new3, side);

            /* New fix: If a regr is in maydie list, remove any alias 
             * that is not referred in the RTL.
             */
            for (a = maydie; *a; a = skiplocOr2(a) + 1) {
               char *c;
               if (pseudoreg(a))
                  continue;
               c = aliases(a);
               while (*c) {
                  if (!fmatch(ptr->val, c))
                     rdelete(c, &ptr->deads);
                  c = skiploc(c) + 1;
               }
            }
            remove_extraneous_deaths(ptr);

            /*
             * Now remove from the new dead variable list all items that maydie
             * that do not appear in the new RTL.
             */
            for (a = maydie; *a; a = skiplocOr2(a) + 1)
               if (!fmatch(ptr->val, a))
                  rdelete(a, &ptr->deads);

            /*
             * Set up any combiner links to this RTL that may be dictated by
             * the requirements of the target machine.
             */
            mdlinks(ptr);

            change = TRUE;
            i = -1;
#ifdef VET
            end_trans();
#endif
            break;
         }
      }

      /* If we've succesfully 3-way merged, skip out of fancy 3-way merge. */
      if (bptr == 0)
         continue;

      /* If we get this far, all normal merges have failed.
       * So, we'll try a "fancy" 3 way merge.
       */

      /*
       * Determine where the end of the "maydie" string created in the first
       * merge is, so that we can add to it in the later merges.
       * Note that "maydie2" is already setup and working from the traditional
       * 3-way merge, so we don't have to re-do that.
       */
      for (j = 0; j < MAXLINKS && (tptr = ptr->all_lnks[j]); j++) {
         if (tptr->rnum >= bptr->rnum)
            continue;
         if (debug) {
            (void) fprintf(stderr, "Merging : ");
            show_rtl(stderr, tptr->val);
            (void) fprintf(stderr, "\t");
            rshow(tptr->deads);
            (void) fprintf(stderr, "\n");
            (void) fprintf(stderr, "    and : ");
            show_rtl(stderr, bptr->val);
            (void) fprintf(stderr, "\t");
            rshow(bptr->deads);
            (void) fprintf(stderr, "\n");
            (void) fprintf(stderr, "    and : ");
            show_rtl(stderr, ptr->val);
            (void) fprintf(stderr, "\t");
            rshow(ptr->deads);
            (void) fprintf(stderr, "\n");
         }

         (void) strcpy(new4, new);
         *maydie2 = '\0';
         merge_rtls(tptr->val, new3, new4, ptr->deads, bptr->deads, maydie2);
         simp(new3, FALSE);

#ifdef ADDR
         address(new3);
#endif

         comp(new3, maydie, ptr, tptr);

         side_effect = side;
         *side = '\0';
         if (find(ptr, new3, ptr->deads)) {

            /*
             * Display debug information if the user requested it.
             */
            if (debug) {
               (void) fprintf(stderr, "rejected: ");
               show_rtl(stderr, new3);
               (void) fprintf(stderr, "  (erflag = %d)\n", erflag);
            }

            continue;
         }

         /*
          * Display debug information if the user requested it.
          */
         if (debug) {
            (void) fprintf(stderr, "accepted: ");
            show_rtl(stderr, new3);
            (void) fprintf(stderr, "\n");
         }

         if (merge_check_3(ptr, bptr, tptr)) {
            if (debug)
               fprintf(stderr, " but merge check rejects\n");
            continue;
         }
         if (se_check(ptr, bptr, (struct list *) NULL, side)) {
            if (debug) {
               fprintf(stderr, " but side_effect check rejects\n");
               fprintf(stderr, "newside=\"");
               show_rtl(stderr, side);
               fprintf(stderr, "\"\n");
            }
            continue;
         }

#ifdef VET
         begin_trans(VET_OPT_TRANS);
#endif
         reremember_deaths(tptr, ptr);
         merge_links(bptr, tptr);
         merge_deads(ptr, tptr, new3);
         if (tptr->type & ARGLINE)
            ptr->type |= ARGLINE;

         for (dp = setsused; dp; dp = dp->next) {
            if (dp->ldead == tptr) {
               dp->ldead = (struct list *) NULL;
               dp->rnum = 0;
            }
         }
         remv_rtl(tptr);

         merge_links(ptr, bptr);
         merge_deads(ptr, bptr, new3);
         if (bptr->type & ARGLINE)
            ptr->type |= ARGLINE;

         for (dp = setsused; dp; dp = dp->next) {
            if (dp->ldead == bptr) {
               dp->ldead = (struct list *) NULL;
               dp->rnum = 0;
            }
         }
         remv_rtl(bptr);

         set(ptr, new3, side);

         /* New fix: If a regr is in maydie list, remove any alias that is
          * not referred in the RTL.
          */
         for (a = maydie; *a; a = skiplocOr2(a) + 1) {
            char *c;
            if (pseudoreg(a))
               continue;
            c = aliases(a);
            while (*c) {
               if (!fmatch(ptr->val, c))
                  rdelete(c, &ptr->deads);
               c = skiploc(c) + 1;
            }
         }

         /*
          * Now remove from the new dead variable list all items that maydie
          * that do not appear in the new RTL.
          */
         for (a = maydie; *a; a = skiplocOr2(a) + 1)
            if (!fmatch(ptr->val, a))
               rdelete(a, &ptr->deads);
         remove_extraneous_deaths(ptr);

         /*
          * Set up any combiner links to this RTL that may be dictated by
          * the requirements of the target machine.
          */
         mdlinks(ptr);

         change = TRUE;
         i = -1;
#ifdef VET
         end_trans();
#endif
         break;
      }
   }

   /*
    * Reset the combiner attention flag for this RTL
    */
   if (!change) {
      ptr->type &= ~COMBLINE;
#ifdef INTERACT
      begin_trans(VET_OPT_TRANS);
      mod_type(ptr);
      end_trans();
#endif
   }

   side_effect = (char *) NULL;

   /*
    * Indicate if the RTL was combined with any other RTL
    */
   return change;
} /* end of combine_rtls() */

/*
 * merge_rtls - merge RTLs together
 */
void merge_rtls(register char *prev, char *new, char *old, rlist deadl,
                rlist deadi, char *maydie)
{

   register char c, d, *a, *b, *dst1, *src1;
   register int item;
   int   count, found;
   char *dst[MAXRTS], *src[MAXRTS], *memdst[MAXRTS];

   /*
    * This routine is intentionally written for speed.  It makes a couple of
    * assumptions for the sake of speed.  First:  no substitutable item in an
    * RTL (that is, anything that can exist on the destination side) is less
    * than two characters long.  Second:  MAXRTS is less than 29 (if ASCII is
    * used on this machine, otherwise you best make sure that this routine is
    * not introducing meaningful characters as place holders for expression
    * that need to be substituted).
    */


   /*-
    * jg9h: Added a fix to take care of the following bug:
    * Consider this example -
    *  Merging  : w[2]=w[2]+1;W[w[2]]=1;        <- rtl1 (prev). 
    *      and  : W[w[2]]=2;                    <- rtl2 (old)
    * accepted  : W[w[2]+1]=2;w[2]=w[2]+1;      <- new  
    *  The W[w[2]]=1; is lost!
    *
    * This happens because merge_rtls() sees that the W[w[2]]
    * is being written to in both rtl1 and rtl2. So it gets rid
    * of the first write (W[w[2]]=1;). This is wrong because w[2]
    * itself has changed. 
    * Near the end of this function merge_rtls, 
    * there is code that adds those effects from rtl1, whose
    * destinations dont match the dests in rtl2. What we really need
    * to check is if the destinations match with the forward substituted
    * destinations. (Since memory destinations can potentially change after
    * forward substitution.)
    * So if dst[item] is a memory dest, we also save it in memdst[item].
    * dst[item] is set to NULL, if it matches with a dest in rtl2.
    * After all the effects (with appropriate forward substitution)
    * from rtl2 have been added to new, merge_rtls() goes through
    * the dst[] array and for all non-null items, copies the corresponding
    * effect into new. We add code here that does the following for
    * nulled out dst[] entries - 
    * if (memdst[item] && memdst[item] is not a destination in new) 
    * add this effect to new.
    *
    * NOTE: For some targets there can potentially be other kinds of
    * destinations that are composed of registers (like UP[r1]). In that
    * case change memdst[] to hold any non-register destination instead
    * of just memory destinations.
   */

   /*
    * Set up the src[] and dst[] to point to the start of each source and
    * destination item in the RTL that is being merged in.  Place a '\0' after
    * every destination in the source string (replacing the '=' that normally
    * goes there) so that the destinations look like stand-alone strings.  When
    * we are finished with this loop, "item" should contain the number of
    * discrete destinations in the RTL.
    * After setting up dst[],src[], prev is used simply as a general pointer.
    */


   item = 0;
   while (*prev) {
      dst[item] = prev;
      while (*prev++ != '=') ;
      *(prev - 1) = '\0';      /* Take the '=' out of the rtl and put a 0 in so
                                * these are two strings. We'll restore it
                                * later.
                                */
      src[item++] = prev;
      while (*prev++ != ';') ;
   }

   /*
    * Do the merge only if the RTL being merged in had items in it
    */
   if (count = item) {

      /*
       * Step through each set of source and destination in the RTL being
       * merged in.  If we find that the item appears as a destination in both
       * the RTLs, then set "found" to TRUE.  If the item set in the first RTL
       * (which is prev) is used in the second (old), then replace the item
       * in the second with that value that it is set to in the first.
       * We won't do the replacement just yet, however.
       * What we will do is mark the point were the
       * substitution should take place with a token.  The token consists of at
       * least two characters.  The first character indicates which destination
       * has to be substituted in and the second one tells whether or not
       * parentheses need to be placed around the substituted expression to
       * avoid ambiguities.
       */
      found = FALSE;
      while (item) {
         dst1 = dst[--item];
         src1 = src[item];
         memdst[item] = NULL;
         prev = old;
         c = *dst1;
         while (d = *prev++) {
            if (d == c) {
               b = prev;
               a = dst1 + 1;
               d = *a++;
               while (d == *b++) {
                  if (!(d = *a++)) {
                     if (*b == '=') {
                        if (ismem(dst1))
                           memdst[item] = dst1;
                        found = TRUE;
                        prev = b;
                     }
                     else {
                        /* This uses characters at the lower end of the ASCII
                         * character set that don't conflict with RTL operators
                         */
                        *(prev - 1) = (char) (item + 3);
                        if (needsparen(*(prev - 2), *b, src1))
                           while (prev < b)
                              *prev++ = PAREN;
                        else
                           while (prev < b)
                              *prev++ = NOPAREN;
                     }
                     break;
                  }
               }
            }
         }

         /*
          * If the item was set in both RTLs, then don't add it to the "maydie"
          * list.  If the item was not set in both RTLs but is a register then
          * if this was a three-way merge and the register died in the middle
          * RTL, then don't tack it on to the final merged RTL. If it appears
          * in the dead list of the second RTL, then add it to the "maydie"
          * list.
          */
         if (found) {
            dst[item] = (char *) NULL;
            found = FALSE;
            a = src[item];
            /* Should check that this loop is correct, it could add the
             * next destination to the maydie list
             */
            while (a = gtrg(a)) {
               copylocOr2(maydie, unskiploc(a));
               maydie = skiplocOr2(maydie);
               /*a=skiplocOr2(a); */
               *maydie++ = '\0';
               *maydie = '\0';

            }
         }
         else if (isrg(dst1)) {
            if (rexists(dst1, deadi)) {
               copylocOr2(maydie, dst1);
               maydie = skiplocOr2(maydie);
               dst1 = skiplocOr2(dst1);
               *maydie++ = '\0';
               *maydie = '\0';
               dst[item] = (char *) NULL;
            }
            else if (rexists(dst1, deadl)) {
               copylocOr2(maydie, dst1);
               maydie = skiplocOr2(maydie);
               dst1 = skiplocOr2(dst1);
               *maydie++ = '\0';
               *maydie = '\0';
               dst[item] = (char *) NULL;
            }
         }

         /*
          * Put the '=' back in the RTL being merged in
          */
         *(src1 - 1) = '=';
      }

      /*
       * Now go back looking for those tokens that were put into the second RTL
       * and substitute in the proper items in their place.
       */
      prev = old;
      b = new;
      while (c = *prev++) {
         if (((unsigned int) c) < MAXRTS + 3) {
            a = src[((unsigned int) c) - 3];
            if (*prev == PAREN) {
               while (*++prev == PAREN) ;
               *b++ = '(';
               while ((*b++ = *a++) != ';') ;
               *(b - 1) = ')';
            }
            else {
               while (*++prev == NOPAREN) ;
               while ((*b++ = *a++) != ';') ;
               b--;
            }
         }
         else
            *b++ = c;
      }

      /*
       * Add in any of the effects that aren't wiped out
       */
      item = 0;
      while (item < count) {
         char *ptr;
         if (a = dst[item])
            while ((*b++ = *a++) != ';') ;
         else if (a = memdst[item]) {
            /* This is code added to fix the common memory destination problem
             * as discussed at the beginning of merge_rtls().
             */

            *b = 0;     /* remember that b is forming the 'new' rtl. */
            *(src[item] - 1) = 0;       /* for fmatch */
            found = FALSE;
            ptr = new;
            while (fmatch(ptr, a)) {
               if (*(epos + 1) == '=') {
                  found = TRUE;
                  break;
               }
               else
                  ptr = epos + 2;
            }
            *(src[item] - 1) = '=';
            if (!found)
               while ((*b++ = *a++) != ';') ;
         }
         item++;
      }
      *b = '\0';
   }
} /* end of merge_rtls() */

/*
 * find - return TRUE if the RTL is not valid for the target machine
 */
int find(struct list *ptr, register char *l, rlist deadl)
{

   int   parse_ret = 0;
   extern int check_legal;

   if (*(linptr = l)) {
      sem_ptr = str_ptr = i_ptr = NULL;
      erflag = FALSE;
      curptr = ptr;
      deadlist = deadl;
      icost = -1;
      ikind = 0;
      reason = NULL;
      check_legal = TRUE;
      parse_ret = yyparse();
      check_legal = FALSE;
      if (erflag && reason == NULL)
         reason = "Semantically invalid";
      if (parse_ret != 0 && reason == NULL)
         reason = "Syntactically invalid";
      if (icost < 0 && !dassem && parse_ret == 0 && erflag == FALSE)
         bad_cost_warning("find", icost, ptr);

      if (swd && debug_opt("find")) {
         fprintf(stderr, "find found '");
         show_rtl(stderr, l);
         fprintf(stderr, "' to be ");
         if (parse_ret || erflag) {
            fprintf(stderr, "not valid.  ");
            if (reason)
               fprintf(stderr, "Reason=%s\n", reason);
            else
               fprintf(stderr, "No reason given\n");
         }
         else {
            fprintf(stderr, "valid!!!! icost=%d\n", icost);
         }

      }
      return (parse_ret || erflag);
   }
   return FALSE;
} /* end of find() */

/*
 * needsparen - determine if expr needs paren when inserted between op1 & op2
 */
int needsparen(char op1, char op2, char *expr)
{
   register int l1, l2, dv;

   l1 = (isoper(op1)) ? (op1 == '+') ? 1 : 2 : 0;
   l2 = (isoper(op2)) ? (op2 == '+') ? 1 : 2 : 0;
   if (!(l1 || l2))
      return FALSE;
   if (!(dv = dowrap(expr)))
      return FALSE;
   if (!l1 && (l2 == 1 || op2 == '-') && dv == 1)
      return FALSE;
   if (l1 == 2 || l2 == 2 || dv == 2)
      return TRUE;
   return FALSE;
}

/*
 * dowrap - test expression to see if it should be wrapped in parentheses
 */
int dowrap(register char *s)
{
   register char c, p;
   register int depth, level;

   /*
    * The first character is given special treatment because unary operators do
    * not constitute an excuse to wrap the expression. Note also that special
    * treatment is given '-' and '+' operations if they follow the 'e' in a
    * floating point constant.
    */
   level = 0;
   if (c = *s++) {
      depth = (c == '[' || c == '(') ? 1 : 0;
      p = c;
      while (c = *s++) {
         if (c == '[' || c == '(')
            depth++;
         else if (c == ']' || c == ')')
            depth--;
         else if (!depth && isoper(c))
            if (c == '+') {
               if (p != 'e')
                  level = 1;
            }
            else if (c == '-') {
               if (p != '+' && p != 'e')
                  return 2;
            }
            else
               return 2;
         else if (c == ';')
            return level;
         p = c;
      }
   }
   return level;
} /* end of dowrap() */

/*
 * merge_deads - merge dead lists and remove anything set in the RTL
 */
void merge_deads(register struct list *ptr, struct list *optr, char *rtl)
{
   register char *p;
   register struct setlist *sptr;
   struct list *dptr;
   int   i;

   /*-
    * Examine the register information structure for each register that is
    * referenced in the newly-combined RTL. If this RTL extends the life of a
    * register that was marked in an earlier RTL, then extend its life by
    * moving the obituary down to the new RTL.  
    * 
    * &&&&&&&&&&&
    * 
    * BUG WARNING:
    * We aren't extending the life of a register if the register is defined.
    * Thus, only remove the dead for used registers.  Defined registers can
    * remain dead.  Here's an example:
    * 
    * 
    * +7              6       r[36]=R[r[36]+4+0];
    * +12                     r[0]=0;
    * +13                     r[1]=0;
    * +14                     ST=expand_expr;
    * +15                     r[0]r[1]
    * +30             7       r[1]=r[36];  r[36]
    * 
    * In this case, rtl 7 and 30 were being combined.   When it
    * looked backwards to extend the life of r[1], it removed the
    * death of r[1] from the call.  
    * 
    * Later, a spill was inserted before the call which saved
    * r[1], and marked it as dead.   After the call, r[1] got
    * restored.  
    * 
    * 
    * +7                      r[36]=R[r[36]+4+0];
    * +12                     r[0]=0;
    * +13                     r[1]=0;
    * +13b                    R[r[11]+SL[0]]=r[1]     r[1]
    * +14                     ST=expand_expr;
    * +15                             r[0]
    * +29                     r[1]=R[r[11]+SL[0]]
    * +30                     r[1]=r[36];  r[36]
    * 
    * 
    * Unfortunately though, CSE came by later and said
    * Gee, we can use r[0] to spill and save the set of r[1], nifty!
    * Too bad r[1] had the wrong value for the call.  Oopsie.
    * Heres the entire sequence after all optimizations:
    * 
    * 
    * +12                     r[0]=0;
    * +13                  R[r[11]+SL[0]]=r[0]
    * +14                     ST=expand_expr;
    * +15                             r[0]
    * +29                  r[1]=R[r[11]+SL[0]];
    * +30                     r[1]=R[r[36]+4+0]; r[36]
    * 
    * Not what we want.  Hopefully this fixes things.
    * 
    * &&&&&&&&&&&
    * 
    * 
    * Also, if we are linked back to
    * an RTL that set this register, break the link because we know that there
    * is an interveining use of it.  We do have to be careful though and make
    * sure that there really was an interveining use.
    * 
    * 
    * 
    * &&&&&&&&&&&
    * YAYABW
    * 
    * EEk!  we created a new RTL, r[1]=r[1]; and this extends the life of r[1].
    * However, we don't remove the death of r[1] on the first iteration of
    * this while loop (because we see r[1] is set, thus not extending a life)
    * but by the 2nd iteration, the link has been removed and we no longer
    * know where it's dead.  Thus, we break this loop into two parts,
    * first, we remove all the deaths, then we go back and remove all the
    * links.
    * 
    * &&&&&&&&&&&
    * 
    * 
    */
   p = rtl;
   while (p = gtrg(p)) {
      if ((sptr = s_lookup(unskiploc(p))) && sptr->rnum
          && ptr->rnum > sptr->rnum && sptr->rnum > optr->rnum
          && fmatch(optr->val, sptr->item))
         if (sptr->ldead)
            if (*p != '=') {
               rdel(sptr->num, &sptr->ldead->deads);
            }
   }

   p = rtl;
   while (p = gtrg(p)) {
      if ((sptr = s_lookup(unskiploc(p))) && sptr->rnum
          && ptr->rnum > sptr->rnum && sptr->rnum > optr->rnum
          && fmatch(optr->val, sptr->item)) {
         if (sptr->ldead) {
            for (i = 0; i < MAXLINKS && (dptr = ptr->all_lnks[i]); i++) {
               if (isset(dptr->val, sptr->item)) {
                  remv_link(ptr->lnks, dptr);
                  remv_link(ptr->all_lnks, dptr);
#ifdef VET
                  mod_links(ptr);
#endif
                  remv_link(dptr->blnks, ptr);
                  break;
               }
            }
         }
         rins(sptr->num, &ptr->deads);
         sptr->ldead = ptr;
         sptr->rnum = ptr->rnum;
      }
   }


   /*
    * Merge the dead register lists of the two RTLs into one leaving out any
    * registers or condition codes that are set in the new RTL.  Also, if the
    * register information structure of the items that are set indicates that
    * they die at this RTL, then forget that piece of information since they
    * are also set here and thus never actually die (at least not here).
    */
   runion(&ptr->deads, optr->deads);
   p = rtl;
   while (*p) {
      if (isrg(p) || is_cc(p)) {
         if (sptr = s_lookup(p)) {
            rdel(sptr->num, &ptr->deads);
            if (sptr->ldead == ptr)
               sptr->ldead = (struct list *) NULL;
            if (!sptr->ldead)
               sptr->rnum = 0;
         }
         else
            rdelete(p, &ptr->deads);
      }
      while (*p++ != ';') ;
   }

   if (ptr->deads)
      remember_deaths(ptr);
} /* end of merge_deads() */


/* debug_show_rtl - */
void debug_show_rtl(struct list *ptr)
{
   if (!debug_opt("instruction_selection"))
      return;
   show_rtl(stderr, ptr->val);
   (void) fprintf(stderr, "\t");
   rshow(ptr->deads);
   (void) fprintf(stderr, "\t");
   if (ptr->se)
      show_rtl(stderr, ptr->se);

   (void) fprintf(stderr, "\n");
}

/* merge_check_2 -
   Return FALSE if bptr can be merged down into ptr.
   bptr -> pointer to first RTL.
   ptr  -> pointer to later RTL.
*/
static int merge_check_2(struct list *ptr, struct list *bptr)
{
   return (!(can_move_rtl(bptr, ptr, NULL)));
}

/* 
   reverse_merge_check_2 -
   Return FALSE if ptr can be merged up into bptr.
   bptr -> pointer to first RTL.
   ptr  -> pointer to later RTL.
*/
int reverse_merge_check_2(struct list *ptr, struct list *bptr)
{
   /* The reverse merge check is more complicated, we need
    * same blocks to be sure things work OK.
    */
   if (ptr->daddy != bptr->daddy)
      return TRUE;

   if (can_move_rtl(ptr, bptr, NULL)) {
      /*-
       * Here's a weird case that fails in a reverse merge.
       * We'll fix it here to avoid extra compile time overhead
       * of doing reverse merges the "correct" way.
       
       r[12]=r[4];
       r[0]=r[12];
       c[0]=r[12]?0;  r[12]
       
       the normal merge trys to put together RTL 1 and 3
       and finds a valid combo:
       
       c[0]=r[4]?0;   
       
       however, merge_check fails, so a reverse merge is attempted.
       
       unfortuately a "proper" reverse merge would generate a different
       RTL:
       
       c[0]=r[4]?0;r[12]=r[4];
       
       Thus, we avoid this case by checking for a register that's dead
       in ptr, set in bptr, and used inbetween!
       */
      char *a = bptr->val;
      while (a = gtrg(a)) {
         /* if set in ptr and dead in bptr */
         if (*a == '=' && rexists(unskiploc(a), ptr->deads)) {
            /* check for a use in between bptr and ptr */
            char  check[MAXSTRING];
            struct list *temp_ptr;
            copyloc(check, unskiploc(a));
            *skiploc(check) = '=';
            *(skiploc(check) + 1) = ';';
            *(skiploc(check) + 2) = '\0';

            for (temp_ptr = bptr->next; temp_ptr != ptr;
                 temp_ptr = temp_ptr->next) {
               if (rtl_has_reg_conflicts_helper(check, temp_ptr))
                  return TRUE;
            }
         }
      }


      /* OK, our special case didn't occur, we're safe */
      return FALSE;
   }

   /* ugh, other issues */
   return TRUE;
}

/*
 *    Return FALSE if mptr,bptr and ptr can be merged into
 *    the location of the current ptr RTL.
 *    mptr -> pointer to middle RTL.
 *    bptr -> pointer to first RTL.
 *    ptr  -> pointer to last RTL.
 */

static int merge_check_3(struct list *ptr, struct list *bptr,
                         struct list *mptr)
{
   struct llist *ignore;
   ignore = newref(bptr);

   if (can_move_rtl(bptr, ptr, NULL) && can_move_rtl(mptr, ptr, ignore))
      return FALSE;
   else
      return TRUE;
}

static int merge_check_4(struct list *ptr, struct list *bptr,
                         struct list *mptr, struct list *dptr)
{
   int   ret;
   struct llist *ignore;
   ignore = newref(bptr);
   add_to_ref(&ignore, mptr);

   if (can_move_rtl(bptr, ptr, NULL) && can_move_rtl(mptr, ptr, ignore)
       && can_move_rtl(dptr, ptr, ignore))
      return FALSE;
   else
      return TRUE;
}


/* can_move_rtl - Returns TRUE if RTL 'ptr1' can be moved to RTL 'ptr2'.
 * This function would search for RAW/WAW/WAR hazards between ptr1 and all RTLs
 * between ptr1 and ptr2 ignoring rtls in the ignore list.
 * This function can handle moving RTLs in either direction (down or up).
 */

int can_move_rtl(struct list *ptr1, struct list *ptr2, struct llist *ignore)
{
   struct list *start, *end, *ptr;
   char *s;


   if (ptr1->daddy != ptr2->daddy) {
      /* Currently we consider only moves within the same block */
      return FALSE;
   }

   /* An rtl that manipulates the PC cannot be moved */
   if ((s = cnts(ptr1)) && (is_pc(s) || is_call(s)))
      return FALSE;

   if (ptr1->rnum < ptr2->rnum) {
      start = ptr1;
      end = ptr2;
   }
   else {
      start = ptr2;
      end = ptr1;
   }


   for (ptr = start->next; ptr && ptr != end; ptr = ptr->next) {
      if (is_present_in_ref(ignore, ptr))
         continue;

      if (cnts(ptr) && is_pc(cnts(ptr)))
         return FALSE;
      if (cnts(ptr1) && is_pc(cnts(ptr1)))
         return FALSE;
      if (rtl_has_conflicts(ptr1, ptr))
         return FALSE;
   }

   /* No problems at all */
   return TRUE;
}

/* rtl_has_conflicts -
 * Checks if 'ptr' has any conflict with 'target'.
 * 'ptr' is assumed to be of type RTLINE.
 */
static int rtl_has_reg_conflicts(struct list *ptr, struct list *target);
static int rtl_has_mem_conflicts(struct list *ptr, struct list *target);
int rtl_has_conflicts(struct list *ptr, struct list *target)
{
   if (rtl_has_reg_conflicts(ptr, target)
       || rtl_has_mem_conflicts(ptr, target))
      return TRUE;
   else
      return FALSE;
}


/* rtl_has_mem_conflicts - 
 * Checks if there are any memory conflicts between ptr and target.
 * No assumption is made regarding the program
 * order between the two rtls.
 * ptr is assumed to be an RTLINE.
 */
static int rtl_has_mem_conflicts_helper(char *val_a, char *val_b,
                                        int assume_sets_a);
static int rtl_has_mem_conflicts(struct list *ptr, struct list *target)
{
   /* This check is necessary because if ptr doesnt
    * contain a memory reference, and if target is
    * a TRASHLINE, we should return FALSE.
    * Remember: gtmem cant handle NULL pointer parameter.
    */

   /* If 'ptr' doesnt have a memory reference, return
    * FALSE immediately.
    */
   if (!ptr->se && ptr->val && !gtmem(ptr->val))
      return FALSE;
   else if (ptr->se && !gtmem(ptr->val) && !gtmem(ptr->se))
      return FALSE;
   /* We assume that we can't have an rtl that has just a side-effect, 
    * but no valid 'val' field (above).
    */

   if (cnts(target)) {
      if (rtl_has_mem_conflicts_helper(ptr->val, target->val, FALSE))
         return TRUE;
      if (target->se && gtmem(target->se)
          && rtl_has_mem_conflicts_helper(ptr->val, target->se, FALSE))
         return TRUE;
      if (ptr->se && gtmem(ptr->se)) {
         /* Since having a side-effect with memory access is rare,
          * we avoid these two calls most of the time.
          */
         if (rtl_has_mem_conflicts_helper(ptr->se, target->val, FALSE))
            return TRUE;
         if (target->se && gtmem(target->se)
             && rtl_has_mem_conflicts_helper(ptr->se, target->se, FALSE))
            return TRUE;
      }
   }
   else if ((target->type & TRASHLINE)) {
      if (strcmp(target->val, "*") == 0) {
         debug_show_rtl(target);
         return TRUE;
      }
      else if (strcmp(target->val, "&") == 0) {
         debug_show_rtl(target);
         return TRUE;
      }
      else if (strcmp(target->val, "@") == 0) {
         /* No action needed - '@' means scratch regs */
      }
      else {
         /* Third parameter is TRUE to indicate that all mem access in
          * target->val should be considered as 'stores'.
          */
         if (rtl_has_mem_conflicts_helper(target->val, ptr->val, TRUE))
            return TRUE;
      }
   }
   /* If target is any other kind of rtl (ie: not RTLINE or TRASHLINE), 
    *  we assume there is no problem.
    */
   return FALSE;
}

/* rtl_has_mem_conflicts_helper - 
 * Helper function to rtl_has_mem_conflicts.
 * val_a and val_b are either the 'val' field of an rtl or the
 * 'se' (side-effect) field. Checks for hazards between them.
 * If assume_sets is TRUE, then all memory accesses in val_a
 * are considered to be sets (instead of depending on position
 * of '='). This is useful for trash line checks.
 */
static int rtl_has_mem_conflicts_helper(char *val_a, char *val_b,
                                        int assume_sets_a)
{
   char *a, *b, *mem_ref_1, *mem_ref_2;
   int   isstore, isptrstore;

   /* We put a gtmem() check to optimize for the common case
    *      that most rtls may not have a memory reference at all. 
    * Otherwise the outerloop would check if val_b has
    * a memory reference for every memory reference in val_a.
    */
   if (val_b && !gtmem(val_b))
      return FALSE;
   a = val_a;
   while (a = gtmem(a)) {
      /* For each memory reference in val_a, go through
       * all memory references in val_b.
       */
      mem_ref_1 = bpos;
      isstore = assume_sets_a ? TRUE : (*a == '=');

      b = val_b;
      while (b = gtmem(b)) {
         mem_ref_2 = bpos;
         isptrstore = (*b == '=');

         /* If these memory references are successfully
          * disambiguated - then it is ok */
         if (!maybe_same(mem_ref_1, mem_ref_2))
            continue;
         /* The mem refs *could* be same 
          * If any one of the references is a store
          *      then we know that the move would be illegal.
          */
         if (isstore || isptrstore)
            return TRUE;
      }

   }
   return FALSE;
}


/* rtl_has_reg_conflicts - 
 * Checks if there are any register conflicts between ptr and target.
 * No assumption is made regarding the program
 * order between the two rtls.
 * ptr is assumed to be an RTLINE.
 */
static int rtl_has_reg_conflicts(struct list *ptr, struct list *target)
{
   if (rtl_has_reg_conflicts_helper(ptr->val, target)
       || rtl_has_reg_conflicts_helper(ptr->se, target))
      return TRUE;
   else
      return FALSE;
}

/* rtl_has_reg_conflicts_helper - 
 * Helper function to rtl_has_reg_conflicts_helper that does the actual work of checking for hazards.
 */
static int rtl_has_reg_conflicts_helper(char *val, struct list *ptr)
{
   char *p, *dp, reg[REGSTRING];
   /*-
    * #define RTLINE     (1 << 0)     Line contains a register transfer        
    * #define ASMLINE    (1 << 1)     Line contains an item for the assembler  
    * #define TRASHLINE  (1 << 2)     Contains a trash item for the CSE phase  
    * #define USELINE    (1 << 3)     Contains a register used item           
    * #define RESLINE    (1 << 4)     Contains a register reserve item         
    * #define COMMENT    (1 << 5)     Line contains a comment                  
    * #define COMBCHECK  (1 << 6)     Used to check for circular links         
    * #define FUNCNAME   (1 << 7)     Used to keep track of the entry point    
    * #define CASELINE   (1 << 8)     Line contains a case table entry         
    * #define SETLINE    (1 << 9)     Line contains a list of registers set    
    * #define CSLINE     (1 << 10)    Callersave registers line                
    * #define ARGBLINE   (1 << 11)    Argument build area size line            
    * 
    * #define DELAYLINE  (1 << 12)    Line should not be emitted until the end 
    * #define ARGLINE    (1 << 13)    RTL loads an argument into a register    
    * #define SIDEFFECT  (1 << 14)    Side effect for line has been determined 
    * #define COMBLINE   (1 << 15)    Line is marked for combiner's attention  
    * #define PARMLINE   (1 << 16)    Line contains register parameters read 
    * by callee 
    * #define METADATALINE (1<<17)    a line that contains metadata; ptr->val
    * contains the payload
    * These are the line types. The register-hazard-checker only needs to
    * consider RTLINE/TRASHLINE/RESLINE/SETLINE/PARMLINE. If it is an
    * RTLINE, it also needs to check the side effects.
    * The RESLINE could be of two forms -
    * (The RESLINE just tells the register allocator to assign r[0] to r[33])
    * The new style is
    * +r[33]=r[0]  r[0]
    * Rr[0]
    * Here there has to be a SETLINE right above, that has r[0].
    * The old style is
    * rr[33]=r[0]; r[0]
    * Here this line is both an RTLINE and a RESLINE. So the set of r[33] 
    * will be checked appropriately.
    * Thus either case, there is no need to test for a RESLINE specifically.
    * 
    * The USELINE is to be thrown out as soon as possible. It simply 
    * duplicates information already present in the previous rtl. So we 
    * don't need to check that. It is used only by the local register 
    * assigner and the information is invalid once local register 
    * assignment is done.
    * 
    * Note that to check if a register is present in a SETLINE, you need
    * to use isaliasref() and not isaliasset(). isaliasset() will check
    * for presence of an '=' right after the rtl. A SETLINE is a sequence
    * of registers with no '='.
    */

/* Search for RAW/WAR/WAW between val and the rtls from start to end,
 * that aren't in the ignore list.
 */
   p = val;
   /* Note: gtrg can handle p==NULL */
   while (p = gtrg(p)) {

      copyloc(reg, unskiploc(p));
      *(skiploc(reg)) = 0;

      /* ptr can't set reg. Check if this RTLINE/SETLINE sets reg. (WAR/WAW) */
      if ((ptr->type & RTLINE)
          && (isaliasset(ptr->val, reg) || isaliasset(ptr->se, reg)))
         return TRUE;

      /* Note that with SETLINE, you need to use isaliasref() to test
       *      for references to reg within the SETLINE 
       */
      else if ((ptr->type & SETLINE) && isaliasref(ptr->val, reg))
         return TRUE;

      /* 
       *      '*' -> all
       *      '@' -> scratch regs
       *      '&' -> all mem
       *       General -> any expression.
       */
      if ((ptr->type & TRASHLINE)) {
         if (strcmp(ptr->val, "*") == 0) {
            debug_show_rtl(ptr);
            return TRUE;
         }
         else if (strcmp(ptr->val, "@") == 0) {
            if (scratchreg(reg)) {
               debug_show_rtl(ptr);
               return TRUE;
            }
         }
         else if (strcmp(ptr->val, "&") == 0) {
            /* '&' is for memory. So we don't have to worry about this line. */
         }
         else {
            /*
             *  Check all the register references in this expression.
             */
            if (isaliasref(ptr->val, reg))
               return TRUE;
         }
      }

      /* ptr can't use reg only if reg is being set in ptr1 (RAW) */
      if ((*p == '=')
          && ((ptr->type & RTLINE) || (ptr->type & PARMLINE))
          && (isaliasref(ptr->val, reg) || isaliasref(ptr->se, reg)))
         return TRUE;

      /* ptr can't set a reg thats dead in ptr1 
       * Currently commented this out, till we find out exactly how
       *      to handle deads for both forward merging and reverse merging.
       */
      /*
       * if (dp=dead_regs) {
       * if (ptr->type & RTLINE)
       * while (*dp) {
       * if (isaliasset(ptr->val,dp)) 
       * return TRUE; 
       * dp=skiplocOr2(dp)+1; 
       * }             
       * if (ptr->type & SETLINE)
       * while (*dp) {
       * if (isaliasref(ptr->val,dp)) 
       * return TRUE; 
       * dp=skiplocOr2(dp)+1; 
       * }             
       * }
       */
   }
   return FALSE;
}

/* regs is a "list" of regs, we need to know if one is defined 
in the rtl */
int isdefined(char *regs, char *rtl)
{
   while (*regs) {
      if (!pseudoreg(regs)) {
         char *alias = aliases(regs);
         while (*alias) {
            if (fmatch(rtl, alias) && *epos == '=')
               return TRUE;
            alias = skiploc(alias) + 1;
         }
      }
      else if (fmatch(rtl, regs) && *epos == '=')
         return TRUE;
      regs = skiploc(regs) + 1;
   }
   return FALSE;
}


/*
 * se_check - determine if the side effect detroys a live reg 
 */
int se_check(struct list *ptr, struct list *bptr, struct list *mptr,
             char *new_side)
{
   char *a;
   char *b;
   char  reg[REGSTRING];
   char  used_regs[MAXSTRING];
   struct list *rtl;
   *used_regs = 0;


   /* we need to check a few things, first if a defined register
    * is somehow killed by a side effect */
   a = bptr->val;
   b = used_regs;
   while (a = gtrg(a)) {
      if (*a != '=') {
         copyloc(b, unskiploc(a));
         b = skiploc(b);
         *b++ = 0;
         *b = 0;
      }
   }
   b = used_regs;
   for (rtl = bptr->next; rtl; rtl = rtl->next) {
      if (rtl == ptr)
         break;
      if (rtl->se == 0 || (rtl->type & RTLINE) != RTLINE)
         continue;
      if (isdefined(used_regs, rtl->se))
         return TRUE;
   }

   if (mptr) {
      a = mptr->val;
      b = used_regs;
      while (a = gtrg(a)) {
         if (*a != '=') {
            copyloc(b, unskiploc(a));
            b = skiploc(b);
            *b++ = 0;
            *b = 0;
         }
      }
      b = used_regs;
      for (rtl = ptr->next; rtl; rtl = rtl->next) {
         if (rtl->se == 0 || (rtl->type & RTLINE) != RTLINE)
            continue;
         if (rtl == ptr)
            break;
         if (isdefined(used_regs, rtl->se))
            return TRUE;
      }
   }



   /* if the new side effect is empty, then there's no reason why we can't
    * combine */
   if (new_side == 0 || *new_side == 0)
      return FALSE;


#ifdef ADDR
   /* If it is autoincr/decr and if the SE does the corresp incr/decr, its ok */
   if (auto_incr_decr(ptr, bptr, new_side))
      return FALSE;

#endif
   a = new_side;
   while (a = gtrg(a)) {
      int   OK = TRUE;
      for (b = aliases(unskiploc(a)); *b; b = skiploc(b) + 1)
         if (rexists(b, ptr->deads))
            OK = FALSE;
      if (*a == '=' && OK) {
         copyloc(reg, unskiploc(a));
         *skiploc(reg) = 0;
         /* then this reg is set, check to see if it's live across the new rtl */
         for (rtl = ptr->prev; rtl; rtl = rtl->prev) {
            char *c;
            if (rtl->val == 0 || (rtl->type & RTLINE) != RTLINE)
               continue;

            /* if we make it back to bptr, and bptr has a SE, we're
             * most likely just moving that SE to a new spot */
            if (rtl == bptr && bptr->se)
               return FALSE;

            /* if the first reference is as a dead, then we're cool,
             * break out of the loop and look at the next reg */
            if (rexists(unskiploc(a), rtl->deads))
               break;


            b = rtl->val;

            /* look for all uses of reg */
            if (isRegister(reg) && !pseudoreg(reg)) {
               /* watch for aliases if it's a reg */
               for (c = aliases(reg); *c; c = skiploc(c) + 1)
                  /* if it's used/defined, it may be live 
                   * if it were dead here, we'd
                   * exit and be a-ok 
                   */
                  if (fmatch(b, c))
                     return TRUE;
            }
            else if (fmatch(b, reg))
               return TRUE;

            /* if it's a pseudoreg it may get assigned to what we're looking at */
            while (b = gtrg(b))
               if (pseudoreg(unskiploc(b)))
                  return TRUE;
            /* otherwise, we can try the next rtl */
         }
         /* if we found the beginning of the block, give up */
         /* and reject */
         if (rtl == 0) {
            /* we know it's not dead before this RTL,
             * thus, if it's used in this block,
             * we have to return TRUE;
             */
            if (rexists(unskiploc(a), ptr->daddy->ulist))
               return TRUE;

            /* if it's live-out, but not defined,
             * it must be live-in.  Thus, we can't combine.
             */
            if (rexists(unskiploc(a), ptr->daddy->olist)
                && !rexists(unskiploc(a), ptr->daddy->dlist))
               return TRUE;
         }
      }
   }

   /* return that there is no reason why not to combine */
   return FALSE;
}




/*
 * set - set the fields of a newly changed RTL
 */
void set(struct list *ptr, char *new, char *side)
{

   ptr->cost = icost;
   ptr->kind = ikind;

#ifdef INTERACT
   mod_kind(ptr);
#endif

   update_rtl(ptr, new);
   /* It is never the case that a side effect is eliminated by the MD
    * recognition routines.  Therefore if "side" comeback with the NULL string
    * then leave the "se" field of the RTL structure alone.  If "side"
    * is not empty we replace the "se" field of the RTL structure.
    * Note: This is probably not the best fix.  The reason we are
    * doing this is that the side effect is being used to indicate what
    * registers are by a call (e.g., the parameters).
    */
   if (*side)
      update_se(ptr, strcpy(CALLOC(strlen(side) + 1), side));
   ptr->type |= SIDEFFECT;
#ifdef INTERACT
   mod_type(ptr);
#endif
}

void set_sides()
{
   struct list *rtl;
   struct bblock *cblk;
   char  side[MAXSTRING];
   for (cblk = top; cblk; cblk = cblk->down) {
      for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
         if ((rtl->type & RTLINE) && rtl->val) {
            simp(rtl->val, 0);
            side_effect = side;
            *side = 0;
            icost = -1;
            ikind = rtl->kind;
            find(rtl, rtl->val, rtl->deads);
            rtl->kind = ikind;
            if (icost < 0) {
               fprintf(stderr, "cost not set for rtl : ");
               show_rtl(stderr, rtl->val);
#ifdef VET
               fprintf(stderr, " (%d)", opttransnum);
#endif
               fprintf(stderr, "\n");
            }
            rtl->cost = icost;
            if (*side) {
               update_se(rtl, strcpy(CALLOC(strlen(side) + 1), side));
               rtl->type |= SIDEFFECT;
#ifdef INTERACT
               /* Send it over to VET because the type has changed. */
               mod_type(rtl);
#endif
            }
            else {
               if (rtl->se)
                  FREE(rtl->se);
               rtl->se = NULL;
               rtl->type &= ~SIDEFFECT;
            }
         }
      }
   }
   side_effect = 0;
}


#if __tms320c54x
extern int sxm_status;
#endif

int   distribute_subtracts(char *);
int   distribute_adds(char *);
int   remove_duplicate_top_level_items_from_rhs(char *);
int   remove_duplicate_top_level_items(char *);
char *get_next_item(char *, char *, char *, char *);

/*
 * simp - numeric simplifier
 */
void simp(char *lin, int limited)
{

   register char *a, *b, *f, p, c, op, n, *savlin;
   register sign, xfloat, yfloat, err;
   double xd, yd;
   int   change = FALSE;
   char  prev = 0;

   int   k;

#ifdef  __tms320c54x
   long long x, y;
   long long nbits = (((unsigned long long) -1) >> 24); /* 40 bits */
   long long t;
   int   reverse = FALSE;
#else
   int   x, y;
   int   nbits = 0;
#endif

   char  nbuf[BIGSTRING], new[BIGSTRING];

   if (debug_opt("simp")) {
      fprintf(stderr, " simp entered: ");
      show_rtl(stderr, lin);
      fprintf(stderr, "\n");
   }
   savlin = lin;

 start_simp:

   change = FALSE;
   if (*lin == '+') {
      sub(lin, lin + 1, "");
      change = TRUE;
   }
   /*
    * Here we do a simple transformation that deals with the unary complement
    * operator '~'.  We do two things.  First, we get rid of the double
    * complement sequence "~~" which effectively cancels itself out.  Second,
    * we convert a item of the form "~constant" into the appropriate constant
    * value.
    */
   a = nbuf;
   b = lin;
   while (c = *b++) {
      if (c == '~')
         if (*b == '~')
            b++;
         else if (is_const(b)) {
#ifdef __tms320c54x
            /* Initially used atoll(), but switched to atol() because 
             * atoll() didnt seem to be working.
             * Moreover, any constant would be 32 bits in the rtl format. */
            sprintf(a, "%lld", (long long) (~((long long) atoll(b))) & nbits);
            if (debug_opt("simp"))
               (void) fprintf(stderr, "XX~%lld = %s\n", atoll(b), a);
#else
            sprintf(a, "%d", ~(atol(b)));
#endif
            b = is_const(b);
            while (*a)
               a++;
         }
         else
            *a++ = c;
      else
         *a++ = c;
   }
   *a++ = '\0';

   /*
    * In this section we are going to do the serious work of this routine. We
    * are going to locate all sequences of constants separated by an operator
    * and replace that with the constant that is yielded by performing the
    * operation.  We handle both integer and floating point constants.  As a
    * side effect of parsing constants, we remove the "--" sequence which
    * effectively cancels itself out.
    */
   a = nbuf;
   p = '[';
   while (c = *a++) {

      /*
       * Look for the begining of a constant.  They can start only after a
       * number of special characters or an operator.  The '.' or 'e'
       * characters will be encountered if the constant is a floating point
       * value.
       */
      if ((c == '-' || (c <= '9' && c >= '0'))
          && (p == '[' || p == '(' || p == '=' || p == ')' || isoper(p))) {
         b = a - 1;
         if (c == '-') {
            sign = -1;
            while ((c = *a++) == '-')
               sign = -sign;
         }
         else
            sign = 1;
         if (c <= '9' && c >= '0') {
            f = new;
            xfloat = FALSE;
            x = 0;
            do {
               *f++ = c;
               x = (x << 3) + x + x + (int) c - (int) '0';
            } while ((c = *a++) <= '9' && c >= '0');
            if (c != '.' && c != 'e') {
               if (sign == -1)
                  x = -x;
            }
            else {
               xfloat = TRUE;
               if (c == '.') {
                  do {
                     *f++ = c;
                  } while ((c = *a++) <= '9' && c >= '0');
               }
               if (c == 'e') {
                  *f++ = c;
                  c = *a++;
                  if (c == '+' || c == '-') {
                     *f++ = c;
                     c = *a++;
                  }
                  do {
                     *f++ = c;
                  } while ((c = *a++) <= '9' && c >= '0');
               }
               *f = '\0';
               (void) sscanf(new, "%lf", &xd);
               if (sign == -1)
                  xd = -xd;
            }

            /*
             * Now we look to see if the constant is followed by any one of the
             * standard operators that we know about.  If it is, then we go on
             * to look for a second constant following that.
             */
            if (c == '+' || c == '-' || c == '*' || c == '/' || c == '&'
                || c == '|' || c == '^' || c == '{' || c == '}' || c == ' '
                || c == '"' || c == '@' || c == '\\' || c == '$'
                || c == 'b') {
               op = c;

               /*
                * Here we look for the second constant.  This code is nearly
                * identical to the code that parsed the first constant.
                */
               if ((c = *a++) == '-' || (c <= '9' && c >= '0')) {
                  if (c == '-') {
                     sign = -1;
                     while ((c = *a++) == '-')
                        sign = -sign;
                  }
                  else
                     sign = 1;
                  if (c <= '9' && c >= '0') {
                     f = new;
                     yfloat = FALSE;
                     y = 0;
                     do {
                        *f++ = c;
                        y = (y << 3) + y + y + (int) c - (int) '0';
                     } while ((c = *a++) <= '9' && c >= '0');
                     if (c != '.' && c != 'e') {
                        if (sign == -1)
                           y = -y;
                     }
                     else {
                        yfloat = TRUE;
                        if (c == '.') {
                           do {
                              *f++ = c;
                           } while ((c = *a++) <= '9' && c >= '0');
                        }
                        if (c == 'e') {
                           *f++ = c;
                           c = *a++;
                           if (c == '+' || c == '-') {
                              *f++ = c;
                              c = *a++;
                           }
                           do {
                              *f++ = c;
                           } while ((c = *a++) <= '9' && c >= '0');
                        }
                        *f = '\0';
                        (void) sscanf(new, "%lf", &yd);
                        if (sign == -1)
                           yd = -yd;
                     }
                     if (xfloat && !yfloat)
                        yd = y;
                     if (yfloat && !xfloat) {
                        xd = x;
                        xfloat = TRUE;
                     }

                     /*
                      * If the two constants and the operator are present, we
                      * look to see if they are wrapped in parentheses.  If
                      * they are, we include the parentheses into the string
                      * that we replace with the corresponding result.  This
                      * action works well only if we refrain from using
                      * parentheses anywhere other than expressions.  This is
                      * the reason that this rule was added to the RTL
                      * standard.
                      */
                     if (c == ')' && b != nbuf && *(b - 1) == '(') {
                        b--;
                        sign = -1;
                     }
                     else {
                        a--;
                        sign = 0;
                     }

                     /*
                      * Now that we have two constants and an operator, perform
                      * the operation to yield a new constant.  The flag, "err"
                      * is set if there is a problem with the operation.
                      */
                     err = FALSE;
                     switch (op) {

                      case '+':
                         if (xfloat)
                            (void) sprintf(new, "%1.32e", xd + yd);
                         else {
#ifdef __tms320c54x
                            t = (x + y);
                            /* If result is a negative 40 bit number,
                             * store as a negative number. */
                            if (t & ((nbits >> 1) + 1)) {
                               t |= ~nbits;
                               sprintf(new, "%lld", t);
                            }
                            else
                               sprintf(new, "%lld", t & nbits);
#else
                            sprintf(new, "%d", x + y);
#endif
                         }
                         break;

                      case '-':
                         if (xfloat)
                            (void) sprintf(new, "%1.32e", xd - yd);
                         else {
#ifdef __tms320c54x
                            t = (x - y);
                            /* If result is a negative 40 bit number,
                             * store as a negative number. */
                            if (t & ((nbits >> 1) + 1)) {
                               t |= ~nbits;
                               sprintf(new, "%lld", t);
                            }
                            else
                               sprintf(new, "%lld", t & nbits);
#else
                            sprintf(new, "%d", x - y);
#endif
                         }
                         break;

                      case '*':
                         if (xfloat)
                            (void) sprintf(new, "%1.32e", xd * yd);
                         else {
#ifdef __tms320c54x
                            t = (x * y);
                            /* If result is a negative 40 bit number,
                             * store as a negative number. */
                            if (t & ((nbits >> 1) + 1)) {
                               t |= ~nbits;
                               sprintf(new, "%lld", t);
                            }
                            else
                               sprintf(new, "%lld", t & nbits);
#else
                            sprintf(new, "%d", x * y);
#endif
                         }
                         break;

                      case '@':
                         if (xfloat)
                            err = TRUE;
                         else {
#ifdef __tms320c54x
                            (void) sprintf(new, "%llu",
                                           (((unsigned long long) x) *
                                            (unsigned long long) y) & nbits);
#else
                            (void) sprintf(new, "%u",
                                           ((unsigned int) x) *
                                           (unsigned int) y);
#endif
                         }
                         break;

                      case '/':
                         if (xfloat)
                            if (!yd) {
                               (void) fprintf(stderr,
                                             "vpo (simp): division by zero\n");
                               err = TRUE;
                            }
                            else
                               (void) sprintf(new, "%1.32e", xd / yd);
                         else if (!y) {
                            (void) fprintf(stderr,
                                           "vpo (simp): division by zero\n");
                            err = TRUE;
                         }
                         else {
#ifdef __tms320c54x
                            t = (x / y);
                            /* If result is a negative 40 bit number,
                             * store as a negative number. */
                            if (t & ((nbits >> 1) + 1)) {
                               t |= ~nbits;
                               sprintf(new, "%lld", t);
                            }
                            else
                               sprintf(new, "%lld", t & nbits);
#else
                            sprintf(new, "%d", x / y);
#endif
                         }
                         break;

                      case '\\':
                         if (xfloat)
                            err = TRUE;
                         else if (!y) {
                            (void) fprintf(stderr,
                                           "vpo (simp): division by zero\n");
                            err = TRUE;
                         }
                         else {
#ifdef __tms320c54x
                            (void) sprintf(new, "%llu",
                                           (((unsigned long long) x) /
                                            (unsigned long long) y) & nbits);
#else
                            (void) sprintf(new, "%u",
                                           ((unsigned int) x) /
                                           ((unsigned int) y));
#endif
                         }
                         break;

                      case '&':
                         if (xfloat)
                            err = TRUE;
                         else {

#ifdef __tms320c54x
                            (void) sprintf(new, "%lld", (x & y) & nbits);
                            if (debug_opt("simp"))
                               (void) fprintf(stderr,
                                              "XX%lld & %lld = %lld\n", x, y,
                                              (x & y) & nbits);
#else
                            (void) sprintf(new, "%d", x & y);
#endif
                         }

                         break;

                      case 'b':
                         if (xfloat)
                            err = TRUE;
                         else {
#ifdef __tms320c54x
                            sprintf(new, "%lld", (x & ~y) & nbits);
#else
                            sprintf(new, "%d", x & ~y);
#endif
                         }
                         break;

                      case '|':
                         if (xfloat)
                            err = TRUE;
                         else {
#ifdef __tms320c54x
                            sprintf(new, "%lld", (x | y) & nbits);
#else
                            sprintf(new, "%d", x | y);
#endif
                         }
                         break;

                      case '^':
                         if (xfloat)
                            err = TRUE;
                         else {
#ifdef __tms320c54x
                            sprintf(new, "%lld", (x ^ y) & nbits);
#else
                            sprintf(new, "%d", x ^ y);
#endif
                         }
                         break;

                      case '{':
                         if (xfloat)
                            err = TRUE;
                         else {

#ifdef __tms320c54x
                            /* set all upper bits to 1, if nbit bit is 1 */
                            if (x & ((nbits >> 1) + 1)) {
                               x |= ~nbits;
                            }
                            reverse = FALSE;
                            t = y;
                            if (t & 0x20) {     /*  a negative integer */
                               t = (t & 0x3f);
                               t = 64 - t; /* 63-t+1. e.g. t=63 -> gives you 1.
                                            * 63 is actually -1.
                                            */
                               reverse = !reverse;
                            }
                            else
                               t = t & 0x3f;
                            if (reverse) {
                               if (sxm_status == 1)
                                  (void) sprintf(new, "%lld",
                                                 (x >> t) & nbits);
                               else
                                  (void) sprintf(new, "%lld",
                                                 ((unsigned long long) x >> t)
                                                 & nbits);
                            }
                            else
                               (void) sprintf(new, "%lld", (x << t) & nbits);
                            if (debug_opt("simp")) {
                               if (reverse) {
                                  if (sxm_status == 1)
                                     (void) fprintf(stderr,
                                                    "XX%lld >> %lld = %lld\n",
                                                    x, t, (x >> t) & nbits);
                                  else
                                     (void) fprintf(stderr,
                                                    "XX%lld \" %lld = %lld\n",
                                                    x, t,
                                                    ((unsigned long long) x >>
                                                     t) & nbits);
                               }
                               else
                                  (void) fprintf(stderr,
                                                 "XX%lld << %lld = %lld\n", x,
                                                 t, (x << t) & nbits);
                            }
#elif VPO_MOD_SHIFT
                            (void) sprintf(new, "%d", x << y);
#else
                            (void) sprintf(new, "%d",
                                           x << ((y > (8 * sizeof(int)))
                                                 ? (8 * sizeof(int)) : y));
#endif
                         }

                         break;

                      case '}':
                         if (xfloat)
                            err = TRUE;
                         else {

#ifdef __tms320c54x
                            if (x & ((nbits >> 1) + 1)) {
                               /* We have a negative number - so dont AND out
                                * the higher bits (ANDing out would make this
                                * a positive number). E.g. -2 in 40 bits is
                                * actually just a big positive
                                * number in 64 bits (long long).
                                */
                               x |= ~nbits;
                               (void) sprintf(new, "%lld", (x >> y));
                            }
                            else {
                               (void) sprintf(new, "%lld", (x >> y) & nbits);
                            }
                            if (debug_opt("simp"))
                               (void) fprintf(stderr,
                                              "XX%lld >> %lld = %lld\n", x, y,
                                              (x >> y) & nbits);
#elif VPO_MOD_SHIFT
                            (void) sprintf(new, "%d", x >> y);
#else
                            (void) sprintf(new, "%d",
                                           x >> ((y > (8 * sizeof(int)))
                                                 ? (8 * sizeof(int)) : y));
#endif
                         }

                         break;


                      case '"':
                         if (xfloat)
                            err = TRUE;
                         else {

#ifdef __tms320c54x
                            (void) sprintf(new, "%lld",
                                           ((unsigned long long) x >> y) &
                                           nbits);

                            if (debug_opt("simp"))
                               (void) fprintf(stderr,
                                              "XX%lld \" %lld = %lld\n", x, y,
                                              ((unsigned long long) x >> y) &
                                              nbits);
#elif VPO_MOD_SHIFT
                            (void) sprintf(new, "%d",
                                           ((unsigned long) x) >>
                                           ((unsigned long) y));
#else
                            (void) sprintf(new, "%d",
                                           ((unsigned long) x) >>
                                           ((unsigned
                                             long) (((y >
                                                      (8 *
                                                       sizeof(int))) ? (8 *
                                                                        sizeof
                                                                        (int))
                                                     : y))));
#endif
                         }

                         break;

                      case ' ':
                         if (xfloat)
                            err = TRUE;
                         else {

                            (void) sprintf(new, "%u",
                                           ((unsigned int) x) <<
                                           ((unsigned long) y));
                         }

                         break;

                      case '$':
                         if (xfloat || (y != 7 && y != 15))
                            err = TRUE;
                         else if (y == 7)
                            (void) sprintf(new, "%d", (char) x);
                         else
                            (void) sprintf(new, "%d", (short) x);
                         break;

                     }


                     if (!err && (!limited || valid(xfloat, new))) {
                        (void) sub(b, a, new);
                        if (sign) {
                           a = nbuf;
                           c = '[';
                        }
                        else {
                           a = b;
                           c = p;
                        }
                     }
                  }
               }
            }
         }
      }
      if (!(p = c))
         break;
   }

   /*-
    * Here we make a simple pass to remove some simple algebraic identities
    * such as:
    *
    *            expr + 0    ==>    expr          (Addition)
    *            expr - 0    ==>    expr          (Subtraction)
    *            expr | 0    ==>    expr          (Bitwise OR)
    *            expr ^ 0    ==>    expr          (Bitwise exclusive OR)
    *            expr * 1    ==>    expr          (Multiplication)
    *            expr @ 1    ==>    expr          (Unsigned multiplication)
    *            expr / 1    ==>    expr          (Division)
    *            expr \ 1    ==>    expr          (Unsigned division)
    *
    * We do, however, have to be a little careful about removing items
    * from and around floating point constants.  For example, we check
    * for the 'e' because we don't want to transform "1.00e+0" to "1.00e".
    * Also, we have to be careful with the string "=-0", since it should be
    * left as "=0" instead of "=".
    */
   p = ' ';
   op = ' ';
   b = lin;
   for (a = nbuf; c = *a++; op = c) {
      if (c == '0' && p != 'e' && ((n = *a) > '9' || n < '0') && n != '.'
          && (op == '+' || op == '-' || op == '|' || op == '^')) {
         if (p == '=' && op == '-')
            *(b - 1) = c;
         else
            b--;
      }
      else if (c == '1' && ((n = *a) > '9' || n < '0') && n != '.'
               && (op == '*' || op == '@' || op == '/' || op == '\\'))
         b--;
      else
         *b++ = c;
      p = op;
   }

   *b = '\0';


   /* Remove parentheses around items -- regs, globals,locals,constants */
   a = savlin;
   while (c = *a++) {
      if (c == '(') {
         if (isreg(a) || isglob(a) || islocal(a))
            b = skiplocOr2(a);
         else
            b = is_const(a);
         if (b && *b == ')') {
            /* Remove the parenthesis */
            sub(b, b + 1, "");
            sub(a - 1, a, "");
            /* we'll back up one just to see if we can catch another set
             * around this item */
            if (a > savlin + 1)
               a -= 2;
         }


      }
   }

   /*-
     HERE we make a simple pass to remove some simple algebraic identities
     such as:

     0 + expr    ==>    expr              (Addition) 
     0 | expr    ==>    expr              (Bitwise OR) 
     0 ^ expr    ==>    expr              (Bitwise exclusive OR) 
     1 * expr    ==>    expr              (Multiplication) 
     1 @ expr    ==>    expr              (Unsigned multiplication)

    */
   while (c = *lin++)
      if (c == '=' || c == '[' || c == '(')
         if ((*lin == '0'
              && ((n = *(lin + 1)) == '+' || n == '|' || n == '^'))
             || (*lin == '1' && ((n = *(lin + 1)) == '*' || n == '@'))) {
            a = lin;
            if (*(b = lin + 2) == '(') {
               sign = 1;
               b++;
               for (;;) {
                  if ((p = *b++) == '(')
                     sign++;
                  else if (p == ')' && !--sign)
                     break;
                  *a++ = p;
               }
            }
            while (*a++ = *b++) ;
         }

   /* Remove parentheses around items -- regs, globals,locals,constants */
   a = savlin;
   while (c = *a++) {
      if (c == '(') {
         if (isreg(a) || isglob(a) || islocal(a))
            b = skiplocOr2(a);
         else
            b = is_const(a);
         if (b && *b == ')') {
            /* Remove the parentheses */
            sub(b, b + 1, "");
            sub(a - 1, a, "");
            change = TRUE;
            a -= 2;
         }


      }
   }

   /* The right shifts confuse vi - so added matching right shifts. */
   /* {{{ Compose two right shifts into one
    * i.e., (r1}x)}y is same as (r1}(x+y)).
    */
   a = savlin;
   while (c = *a++) {
      int   const1, const2;
      char *d;

      if (c == '}' || c == '{' || c == '"') {

         b = a;
         if (!(b = is_const(a)))
            continue;

         const1 = atoi(a);

         if (*b == ')' && *(b + 1) == c) {
            d = b + 2;
            if (!(b = is_const(d)))
               continue;

            const1 += atoi(d);
            d = b;
         }
         else
            continue;
         /* Replace (r[x] shft const1) shft const2
          * by r[x] shft const1+const2.
          */
         {
            char  newconst[10];
            int   depth = 0;

            sprintf(newconst, "%d", const1);
            b = a;
            sub(b, d, newconst);
            while (depth >= 0) {
               if (*b == ')')
                  depth++;
               if (*b == '(')
                  depth--;
               b--;
            }
            sub(b + 1, b + 2, "");      /* Remove ( */
            change = TRUE;
         }
      }

   }

   /* Compose two adds/subs one i.e., (r1-x)+y is same as (r1+(-x+y)) */
   a = savlin;
   for (; c = *a++; prev = c) {
      int   const1 = 0, const2 = 0;
      char *d = 0;
      char  op1 = 0, op2 = 0;


      if (c == '+' || c == '-') {
         op1 = c;

         /* Watch for unary minus */
         if (prev && isoper(prev))
            continue;

         b = a;
         if (!(b = is_const(a)))
            continue;

         const1 = atoi(a);

         if (*b == ')' && (*(b + 1) == '+' || *(b + 1) == '-')) {
            op2 = *(b + 1);
            d = b + 2;
            if (!(b = is_const(d)))
               continue;

            const2 = atoi(d);
            d = b;
         }
         else
            continue;
         /* Replace (r[x] op1 const1) shft op2
          * by r[x] shft (op1 const1 op2 const2).
          */

         {
            char  newconst[10];
            int   depth = 0;
            if (op1 == '-' && op2 == '-')
               sprintf(newconst, "%d", -const1 - const2);
            else if (op1 == '-' && op2 == '+')
               sprintf(newconst, "%d", -const1 + const2);
            else if (op1 == '+' && op2 == '-')
               sprintf(newconst, "%d", +const1 - const2);
            else if (op1 == '+' && op2 == '+')
               sprintf(newconst, "%d", const1 + const2);
            b = a;
            if (op1 == '-')
               *(b - 1) = '+';
            sub(b, d, newconst);
            while (depth >= 0) {
               if (*b == ')')
                  depth++;
               if (*b == '(')
                  depth--;
               b--;
            }
            sub(b + 1, b + 2, "");      /* Remove ( */
            change = TRUE;
         }
      }

   }
   a = savlin;
   while (*a) {
      if (a[0] == '(' && a[1] == '0' && a[2] == '*') {
         char *b = &a[3];
         int   depth = 0;
         while (*b) {
            if (isoper(*b) && *b != '*' && depth == 0) {
               break;
            }
            if (*b == '[')
               depth++;
            if (*b == '(')
               depth++;
            if (*b == ']')
               depth--;
            if (*b == ')')
               depth--;
            if (depth < 0)
               break;
            b++;
         }
         if (*b == ')')
            sub(a, b + 1, "0");
         else
            sub(a + 1, b, "0");
         change = TRUE;
      }
      if (a[0] == '(' && a[1] == '1' && a[2] == '*') {
         sub(a + 1, a + 2, "");
         change = TRUE;
      }
      a++;
   }

   if (!debug_opt("no_fancy_simp")) {
      change |= distribute_subtracts(savlin);
      change |= distribute_adds(savlin);
      change |= remove_duplicate_top_level_items(savlin);
   }

   change |= mdsimp(savlin, limited);

   if (change && !limited) {
      lin = savlin;
      goto start_simp;
   }

   if (debug_opt("simp")) {
      fprintf(stderr, " simp exited: ");
      show_rtl(stderr, savlin);
      fprintf(stderr, "\n");
   }
} /* end of simp() */

int distribute_subtracts(char *lin)
{
   /*-
     OK, so, here we're looking for subtracts that need to be distributed
     to remove parenthesis. Here's an example from the ARM:

     LA[LA[L1]+4]+3-(LA[LA[L1]+4]+11)

     Once we distribute over the parentheses, it'll be possible to simplify away
     complex items that are negated.

     return TRUE if there is a change
    */

   int   change = FALSE;
   if (debug_opt("distribute_subtracts")) {
      fprintf(stderr, "distribute_subtracts entered with: ");
      show_rtl(stderr, lin);
      fprintf(stderr, "\n");
   }

   epos = lin;
   while (fmatch(epos, "-(")) {

      int   depth = 1;
      char *a = epos;
      while (*a) {
         if (*a == '[' || *a == '(')
            depth++;
         if (*a == ']' || *a == ')')
            depth--;
         if (depth == 0) {
            /* let's look at the char after the paren.
             * if it's an add, subtract, close paren, or end of
             * effect we can distribute.  otherwise we can't
             */

            a++;
            if (*a != '+' && *a != '-' && *a != ')' && *a != ';' && *a != 0)
               goto try_next_one;
            break;
         }
         if (isoper(*a) && depth == 1) {
            if (*a != '+' && *a != '-')
               goto try_next_one;
         }
         a++;
      }

      /* If we get here, we know it's safe to distribute this negative */
      /* thus, we go ahead and do it */
      a = epos;
      depth = 1;
      change = TRUE;
      while (*a) {
         if (*a == '[' || *a == '(')
            depth++;
         if (*a == ']' || *a == ')')
            depth--;
         if (depth == 1) {
            /* change the sign of each add/subtract */
            /* for each thing on the level 1 list */
            if (*a == '+')
               *a = '-';
            else if (*a == '-')
               *a = '+';
         }
         if (depth == 0) {
            /* remove the closing parenthesis */
            sub(a, a + 1, "");
            break;
         }
         a++;
      }
      /* if the first item is explicitly marked plus/minus, we
       * substitute a "+" in to keep the sign of it right.
       */
      if (bpos[2] == '+' || bpos[2] == '-')
         sub(bpos, bpos + 2, "+");

      /* Otherwise we leave the neg sign to flip the sign of the first
       * item.
       */
      else
         sub(bpos, bpos + 2, "-");

    try_next_one:
      ;
   }               /* end while (fmatch(epos, "-(")) */

   if (debug_opt("distribute_subtracts")) {
      (void) fprintf(stderr, "distribute_subtracts left with: ");
      show_rtl(stderr, lin);
      (void) fprintf(stderr, "\n");
   }
   return change;
}                  /* end of distribute_subtracts() */


int distribute_adds(char *lin)
{

   /*-
    * Here we're looking for additions that need to be distributed
    * to remove parentheses. Here's an example from the SPARC
    *
    * r[20]=R[r[15]+local1+(local2-local1)];
    *
    * Once we distribute over the parentheses, it'll be possible to simplify
    * away complex items that are negated.
    *
    * return TRUE if there is a change
    */

   int   change = FALSE;
   if (debug_opt("distribute_adds")) {
      fprintf(stderr, "distribute_adds entered with: ");
      show_rtl(stderr, lin);
      fprintf(stderr, "\n");
   }

   epos = lin;
   while (fmatch(epos, "+(")) {

      int   depth = 1;
      char *a = epos;
      while (*a) {
         if (*a == '[' || *a == '(')
            depth++;
         if (*a == ']' || *a == ')')
            depth--;
         if (depth == 0) {
            /* Let's look at the char after the paren.
             * If it's an add, subtract, close paren, or end of
             * effect we can distribute.  Otherwise we can't
             */

            a++;
            if (*a != '+' && *a != '-' && *a != ')' && *a != ';' && *a != 0)
               goto try_next_add;
            break;
         }
         if (isoper(*a) && depth == 1) {
            if (*a != '+' && *a != '-')
               goto try_next_add;
         }
         a++;
      }

      /* If we get here, we know it's safe to distribute this addition */
      /* thus, we go ahead and do it */
      a = epos;
      depth = 1;
      change = TRUE;
      while (*a) {
         if (*a == '[' || *a == '(')
            depth++;
         if (*a == ']' || *a == ')')
            depth--;
         if (depth == 0) {
            /* remove the closing parenthesis */
            sub(a, a + 1, "");
            break;
         }
         a++;
      }
      /* if the first item is explicitly marked minus, we
       * substitute a "-" for the outer "+" to keep the sign of it right.
       */
      if (bpos[2] == '-')
         sub(bpos, bpos + 2, "-");

      /* Otherwise we leave the outer plus sign to keep the sign of the first
       * item.
       */
      else
         sub(bpos, bpos + 2, "+");

    try_next_add:
      ;
   }               /* end while (fmatch(epos, "+(")) */

   if (debug_opt("distribute_adds")) {
      (void) fprintf(stderr, "distribute_adds left with: ");
      show_rtl(stderr, lin);
      (void) fprintf(stderr, "\n");
   }
   return change;
}                  /* end of distribute_adds() */


int remove_duplicate_top_level_items(char *lin)
{
   int   change = FALSE;
   int   found;

   if (!fmatch(lin, ";")) {
      assert(!fmatch(lin, "="));
      return remove_duplicate_top_level_items_from_rhs(lin);
   }
   else {
      char  effect[MAXSTRING] = { 0, };
      char *rhs_start = 0, *rhs_end = 0;
      epos = lin;

      while (fmatch(epos, "=")) {
         /* get the current RHS into effect */
         rhs_start = epos;
         found = fmatch(epos, ";");
         assert(found);
         rhs_end = bpos;
         gtstr(rhs_start, rhs_end, effect);
         if (remove_duplicate_top_level_items_from_rhs(effect)) {
            change = TRUE;
            sub(rhs_start, rhs_end, effect);
            found = fmatch(rhs_start, ";");
         }
      }
   }
   return change;
}                  /* end of remove_duplicate_top_level_items() */

/* WARNING!  This function won't work on a multiple effect RTL.  Call
 * the above function to split it apart and handle things right.
 */
int remove_duplicate_top_level_items_from_rhs(char *effect)
{
   char  item1[MAXSTRING];
   char  item2[MAXSTRING];
   char  save[MAXSTRING];
   char  oper1 = 0, oper2 = 0;
   char *item1_ptr, *item2_ptr;
   int   depth = 0;
   char *a = 0;
   char *b = 0;

   assert(!fmatch(effect, "="));
   assert(!fmatch(effect, ";"));


   /* this doesn't work across a comparison operator */
   if (fmatch(effect, "?"))
      return FALSE;
   if (fmatch(effect, "!"))
      return FALSE;
   if (fmatch(effect, ":"))
      return FALSE;

   if (debug_opt("remove_duplicate_top_level")) {
      strcpy(save, effect);
   }

   a = effect;
   while (a = get_next_item(item1, &oper1, effect, a)) {
      b = a + strlen(item1);
      while (b = get_next_item(item2, &oper2, effect, b)) {
         if (strcmp(item1, item2) == 0) {
            /* wow, we've located a duplicate item */
            if ((oper1 == '+' && oper2 == '-')
                || (oper1 == '-' && oper2 == '+')) {
               /* subbing A moves B... so, sub B first */
               sub(b, b + strlen(item2), "0");
               sub(a, a + strlen(item1), "0");
               /* we've made a change.. lets start over on this string */
               a = effect;
               simp(effect, FALSE);
               if (debug_opt("remove_duplicate_top_level")) {
                  fprintf(stderr,
                          "remove_dup_top_level_items_from_rhs entered with: ");
                  show_rtl(stderr, save);
                  fprintf(stderr, "\n");
                  fprintf(stderr,
                          "remove_dup_top_level_items_from_rhs left with: ");
                  show_rtl(stderr, effect);
                  fprintf(stderr, "\n");
               }
               return TRUE;
            }
         }
         /* skip over the item */
         b += strlen(item2);
      }            /* end while (b = get_next_item(...)) */

      /* skip over the item */
      a += strlen(item1);
   }               /* end while (a = get_next_item(...)) */
   return FALSE;
}                  /* end of remove_duplicate_top_level_items_from_rhs() */

char *get_next_item(char *item, char *oper, char *start, char *where)
{
   char *a = where;
   char *item_start = 0;
   char *ret_value = 0;
   int   depth = 0;
   *item = 0;

   while (*a) {
      if (a == start && !isoper(*a))
         item_start = a;
      if (!isoper(*a))
         item_start = a;

      /* careful on unary minus operators */
      if (isoper(*a) && *(a + 1) == '-') {
         item_start = a + 1;
      }

      if (item_start) {
         ret_value = item_start;
         if (item_start == start)
            *oper = '+';
         else
            *oper = *(item_start - 1);

         depth = 0;

         /* copy any unary operators off the start of this item */
         while (isoper(*item_start) && *item_start)
            *item++ = *item_start++;

         /* the unary operators shouldn't exhaust the string */
         assert(*item_start);

         while (1) {

            if (isoper(*item_start) && depth == 0)
               return ret_value;
            if (*item_start == '[' || *item_start == '(')
               depth++;
            else if (*item_start == ']' || *item_start == ')')
               depth--;


            /* When our depth is less than 0, we're about to walk
             * past a close paren we don't want.
             */
            if (depth < 0)
               return ret_value;

            if (*item_start == 0) {
               /* We shouldn't hit the end of string before the
                * end of item.
                */
               assert(depth == 0);
               return ret_value;
            }
            /* otherwise, it's safe to copy the char, do so */
            *item++ = *item_start++;
            *item = 0;
         }         /* end of while(1) */
      }            /* end if (item_start) */
      a++;
   }               /* end while (*a) */
   return NULL;
}                  /* end of get_next_item() */

#ifdef ADDR

/*
 * address - deal with address expressions
 */
void address(char *lin)
{

   register char *a, *b;
   register change;

   /*
    * First, simplify to remove any A[...] items that are not needed
    */
   simpaddr(lin);

   /*
    * Add A[...] around expressions that need them
    */
   change = FALSE;
   b = lin;
   while (*b) {
      a = b;
      while (*a++ != '=') ;
      if (needsaddr(b, a)) {
         a = sub(a, a, "A[");
         while (*a++ != ';') ;
         if (*a) {
            (void) sub(a - 1, a - 1, "]");
            a++;
         }
         else {
            *(a - 1) = ']';
            *a++ = ';';
            *a = '\0';
         }
         change = TRUE;
      }
      else
         while (*a++ != ';') ;
      b = a;
   }

   /*
    * Now resimplify any expression that needs it
    */
   if (change)
      simpaddr(lin);
}

/*
 * simpaddr - remove redundant A[...] items from RTL
 */
void simpaddr(register char *b)
{

   register char c, *a, *e;
   char  expr[BIGSTRING];
   int   iopen, d;

   /*-
    * On some machines, addressing modes are complex enough that it is very
    * difficult to tell whether an expression should be treated as an address
    * or not.  In order to get around this problem, the A[...] notation was
    * introduced.  Even though it solves one problem, it introduces another
    * (which is easier to solve).  When two RTLs containing address expressions
    * are combined, it is often the case that the addressing notation combines
    * in such a way as to leave redundant A[...] items in the RTL.  For
    * example, the following RTLs:
    * 
    * r[5] = A[_global1]; r[5] = A[r[5] - _global2 + 8];
    * 
    * combine to form:
    * 
    * r[5] = A[A[_global1] - _global2 + 8];
    * 
    * The task of this function is to remove the redundant A[...] and leave the
    * desired RTL which is:
    * 
    * r[5] = A[_global1 + global2 + 8];
    * 
    * Some machines (like the VAX 11) are so complex as to have instances where
    * memory references can be included inside address expressions. When this
    * is the case, the A[...] inside the memory reference should be left alone.
    */

   /*
    * Do a quick search for the first 'A'.  Often none will be found.
    */
   while ((c = *b++) && c != 'A') ;
   if (!c)
      return;

   /*
    * We have found the start of an address expression, so from this point on
    * we have to crank through it a little bit more carefully.
    */
   a = b;
   do {
      if (c == 'A' && *b == '[') {
         d = 1;
         *a++ = *b++;
         while (d)
            if ((c = *b++) == ']') {
               d--;
               *a++ = c;
            }
            else if (c == '[') {
               d++;
               *a++ = c;
            }
            else if (c == 'A' && *b == '['
                     && !(*(b - 2) == '[' && ismem(b - 3))) {
               iopen = 1;
               b++;
               e = expr;
               while (c = *b++) {
                  if (c == '[')
                     iopen++;
                  else if (c == ']') {
                     iopen--;
                     if (!iopen)
                        break;
                  }
                  *e++ = c;
               }
               *e = '\0';
               if (needsparen('[', *b, expr)) {
                  *a++ = '(';
                  for (e = expr; *e; *a++ = *e++) ;
                  *a++ = ')';
               }
               else
                  for (e = expr; *e; *a++ = *e++) ;
            }
            else
               *a++ = c;
      }
   } while (c = *a++ = *b++);
}


#endif

#ifdef ADDR
int auto_incr_decr(struct list *ptr, struct list *bptr, char *new_side)
{
   /* Look for A[dr[]] or A[r[]i] */
   char *rtl = ptr->val, *a;
   int   autodecr = 0, autoincr = 0;
   char  reg[REGSTRING];

   if (a = rtl) {
      while (a = gtrg(a)) {
         if (*(unskiploc(a) - 1) == 'd') {
            autodecr = 1;
            copyloc(reg, unskiploc(a));
            break;
         }
         else if (*(a) == 'i') {
            autoincr = 1;
            copyloc(reg, unskiploc(a));
            break;
         }
      }



   }

   rtl = bptr->val;
   if (a = rtl) {
      while (a = gtrg(a)) {
         if (*(unskiploc(a) - 1) == 'd') {
            autodecr = 1;
            break;
         }
         else if (*(a) == 'i') {
            autoincr = 1;
            break;
         }
      }

   }

   if (autoincr && autodecr)
      return FALSE;

   if (autodecr || autoincr) {
      /* Check the side effect */
      a = new_side;
      while (a = gtrg(a)) {
         if (cmploc(unskiploc(a), reg))
            return FALSE;

      }
      return TRUE;
   }
   return FALSE;
}

#endif

void set_rtl_sides(struct list *rtl)
{
   char  side[MAXSTRING];
   if ((rtl->type & RTLINE) && rtl->val) {
      simp(rtl->val, 0);
      side_effect = side;
      *side = 0;
      icost = -1;
      ikind = rtl->kind;
      find(rtl, rtl->val, rtl->deads);
      rtl->kind = ikind;
      if (icost < 0)
         fprintf(stderr, "cost not set for rtl\n");
      rtl->cost = icost;
      if (*side) {

         update_se(rtl, strcpy(CALLOC(strlen(side) + 1), side));
         rtl->type |= SIDEFFECT;
      }
      else {
         if (rtl->se)
            FREE(rtl->se);
         rtl->se = NULL;
         rtl->type &= ~SIDEFFECT;
      }
   }
   side_effect = 0;
}

/*
 * maybe_same - determine if two items might reference the same location
 */
int   maybe_same2(char *, char *);

int maybe_same(char *mem, char *expr)
{
   int   result = maybe_same2(mem, expr);
   if (debug_opt("maybe_same")) {
      show(mem);
      (void) fprintf(stderr, " and ");
      show(expr);
      if (result)
         (void) fprintf(stderr, " are maybe the same\n");
      else
         (void) fprintf(stderr, " are NOT the same\n");
   }
   return result;
}

/*
 * Look at the memory items given and, if we can ensure without a doubt that
 * they do not reference the same locations, return a FALSE.  In this
 * function, it is best to be conservative.  The argument "mem" always
 * contains a single memory location.  The argument "expr" may contain any
 * arbitrary expression but always starts with a memory reference, which is
 * the only item that needs to be checked.
 */
int maybe_same2(char *mem, char *expr)
{
   register char c, *a, *b;
   int   depth;
   char *d, item[MAXSTRING], *item_ptr;
   char  memAddr[MAXSTRING], exprAddr[MAXSTRING];
   char  memLocType, exprLocType;
   char  FPSPregs[MAX_ALIASFREE_REGS][REGSTRING];
   char  memIDs[MAXSTRING];     /* list of identifier names found in memAddr. */
   char *IDptr;                 /* pointer into memIDs[] */
   struct setlist *sptr;
   int   count, addrDifference, i;

   /* booleans */
   int   found, done;
   int   memLocal = FALSE, memGlobal = FALSE, memSpill = FALSE, memUnknown =
    FALSE;
   int   exprLocal = FALSE, exprGlobal = FALSE, exprSpill =
    FALSE, exprUnknown = FALSE;


   /*
    * First we will check to see if the references are different because they
    * differ only in a non-zero constant value.  We start by skipping over
    * the memory types and operators and left brackets, then extracting
    * each address expression.
    */

   assert(NULL != mem);
   assert(NULL != expr);

   item[0] = '\0';
   depth = 0;
   count = 0;
   a = mem;
   d = memAddr;
   memLocType = *mem;
   exprLocType = *expr;

   while (c = *a++) {
      if (c == ']') {
         --depth;
         if (depth < MD_LOCATION_BRACKET_DEPTH)
            break;
      }

      if (depth >= MD_LOCATION_BRACKET_DEPTH)
         /* We can now extract the address expression. */
         memAddr[count++] = c;

      if (c == '[')
         ++depth;
   }
   memAddr[count] = '\0';

   depth = 0;
   count = 0;
   b = expr;
   while (c = *b++) {
      if (c == ']') {
         --depth;
         if (depth < MD_LOCATION_BRACKET_DEPTH)
            break;
      }

      if (depth >= MD_LOCATION_BRACKET_DEPTH)
         /* We can now extract the address expression. */
         exprAddr[count++] = c;

      if (c == '[')
         ++depth;
   }
   exprAddr[count] = '\0';

   /* Work on the simplified address expressions. */
   simp(memAddr, FALSE);
   simp(exprAddr, FALSE);

   if (0 == strcmp(memAddr, exprAddr))
      /* Identical complete address expressions. */
      return TRUE;

   /* If we subtract one address expression from the other and pass that
    * difference expression to simp(), we might reduce it all down to a
    * constant.  E.g. if memAddr is "r[5]+4" and exprAddr is "r[5]", then
    * simp() will return the constant "4" when we subtract:
    * "r[5]+4-(r[5])" and simplify.  This tells us that the two addresses
    * differ only by a constant value of 4.  Based on machine-dependent
    * memory transfer sizes for different memory types, we can then determine
    * if two memory accesses overlap.  For example, on a machine with 1-byte
    * 'B' memory and 4-byte 'R' memory, locations R[r[5]] and B[r[5]+1]
    * overlap.  In that case, we should return TRUE.  On the other hand,
    * R[r[5]] and B[r5]+7] do not overlap, and we should return FALSE.
    */

   /* Build up the difference string in item[]. */
   (void) sprintf(item, "%s-(%s)", memAddr, exprAddr);

   /* Now we have "memAddr-(exprAddr)" in item.  Ready to simplify. */
   simp(item, FALSE);

   /* Did it all simplify to a constant? */
   if ((d = is_const(item))     /* constant at beginning  ... */
       &&(*d == '\0')) {        /* ... and nothing after the constant */
      /* If the machine-dependent code determines that the addresses overlap,
       * we return TRUE; else we return FALSE.
       */
      addrDifference = atoi(item);
      if (addrDifference < 0)   /* "mem" address precedes "expr" address. */
         return ((mdMemFetchSize(memLocType) + addrDifference) > 0);
      else         /* "expr" address precedes or coincides with "mem" address. */
         return (mdMemFetchSize(exprLocType) > addrDifference);
   }

   /* The easiest cases have been handled.  Now, let us analyze the two
    * locations by first determining what kind of address expressions they
    * are.  If either one is a local variable that is NOT indirectly
    * referenced, then it cannot be an alias of the other, so we can return
    * FALSE immediately.  The tougher cases are global variables, indirectly
    * addressed local variables, and addresses formed from registers and
    * constants and arithmetic operations with no global or local names.
    * In order to identify these three cases  more easily, we skip over frame
    * and stack pointers and other registers that cannot hold aliases for
    * globals, such as condition code registers and certain special registers
    * that don't hold addresses, as well as constants and operators, until we
    * reach the items that could hold an address (e.g. local variable,
    * global variable, general purpose register, or special machine dependent
    * operator). This is machine dependent.
    * NOTE: It would be possible to do less analysis and short-circuit out
    * of this code at more points.  In the past, we would return FALSE
    * as soon as we encountered a spill location, for example, because they
    * were not used in complex addressing expressions to alias anything else.
    * The code below continues processing and sets boolean flags to indicate
    * what it has seen in the address.  This allows us to easily change the
    * logic of when we return FALSE and when we return TRUE in the future.
    * In addition, it allows us to flag bizarre combinations with assertions
    * in order to help us wring the errors out of maybe_same(), simp(), and
    * all callers of maybe_same().
    */
   count = md_aliasfree_regs(FPSPregs);
   assert((0 <= count) && (MAX_ALIASFREE_REGS >= count));

   a = memAddr;
   IDptr = memIDs;
   *IDptr = '\0';
   done = FALSE;
   do {
      if (isglob(a)) {
         memGlobal = TRUE;
         /* Save names (codes) of globals. */
         copyloc(IDptr, a);
         *skiploc(IDptr) = '\0';
         IDptr = skiploc(IDptr);
         a = skiploc(a);
         /* Spill locations should not be mixed with others. */
         assert(!memSpill);
      }
      else if (isspill(a)) {
         memSpill = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!(memGlobal || memLocal || memUnknown));
         a = skipspill(a);
      }
      else if (islocal(a)) {
         memLocal = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!memSpill);
         /* A local that is never indirectly referenced cannot alias
          * anything else.
          */
         if ((sptr = s_add(a)) && !sptr->local->indref) {
            assert(!(memGlobal || memSpill || memUnknown));
            return FALSE;       /* Cannot alias anything. */
         }
         /* Save names (codes) of indirectly referenced locals. */
         copyloc(IDptr, a);
         *skiploc(IDptr) = '\0';
         IDptr = skiploc(IDptr);
         a = skiploc(a);
      }
      else if (isoper(*a) || is_const(a)) {
         a = skiploc(a);
      }
      else if (isreg(a)) {
         /* If it cannot alias another memory address, skip over it, else
          * we declare it to be in the Unknown category.
          */
         for (i = 0; i < count; ++i) {
            if (0 == cmploc(FPSPregs[i], a))
               break;
         }
         /* If we had no matches and did not break out of the for loop,
          * we have a general purpose register that could hold the address
          * (i.e. alias) of anything.  Otherwise, "a" skips
          * over the harmless register and we continue.
          */
         if (i >= count) {
            memUnknown = TRUE;
            /* Spill locations should not be mixed with others. */
            assert(!memSpill);
         }
         a = skiploc(a);
      }
      else {       /* We don't know what it is. Could alias anything. */
         /* Not even sure if skiploc() will handle whatever it is; exit. */
         done = memUnknown = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!memSpill);
      }
      if (!a || ('\0' == *a))
         done = TRUE;
   } while (!done);

   a = exprAddr;
   done = FALSE;
   do {
      if (isglob(a)) {
         exprGlobal = TRUE;
         /* Try to find this name in the memIDs[] list. */
         IDptr = memIDs;
         found = FALSE;
         while (*IDptr) {
            if (0 == cmploc(IDptr, a)) {
               found = TRUE;
               break;
            }
            IDptr = skiploc(IDptr);
         }
         if (!found)
            return (exprUnknown || memUnknown);
         a = skiploc(a);
         /* Spill locations should not be mixed with others. */
         assert(!exprSpill);
      }
      else if (isspill(a)) {
         exprSpill = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!(exprGlobal || exprLocal || exprUnknown));
         a = skipspill(a);
      }
      else if (islocal(a)) {
         exprLocal = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!exprSpill);
         /* A local that is never indirectly referenced cannot alias
          * anything else.
          */
         if ((sptr = s_add(a)) && !sptr->local->indref) {
            assert(!(exprGlobal || exprSpill || exprUnknown));
            return FALSE;
         }
         /* Try to find this name in the memIDs[] list. */
         IDptr = memIDs;
         found = FALSE;
         while (*IDptr) {
            if (0 == cmploc(IDptr, a)) {
               found = TRUE;
               break;
            }
            IDptr = skiploc(IDptr);
         }
         if (!found)
            return (exprUnknown || memUnknown);
         a = skiploc(a);
      }
      else if (isoper(*a) || is_const(a)) {
         a = skiploc(a);
      }
      else if (isreg(a)) {
         /* If it cannot alias another memory address, skip over it, else
          * we declare it to be in the Unknown category.
          */
         for (i = 0; i < count; ++i) {
            if (0 == cmploc(FPSPregs[i], a))
               break;
         }
         /* If we had no matches and did not break out of the for loop,
          * we have a general purpose register that could hold the address
          * (i.e. alias) of anything.  Otherwise, "a" skips
          * over the harmless register and we continue.
          */
         if (i >= count) {
            exprUnknown = TRUE;
            /* Spill locations should not be mixed with others. */
            assert(!exprSpill);
         }
         a = skiploc(a);
      }
      else {       /* We don't know what it is. Could alias anything. */
         /* Not even sure if skiploc() will handle whatever it is; exit. */
         done = exprUnknown = TRUE;
         /* Spill locations should not be mixed with others. */
         assert(!exprSpill);
      }
      if (!a || ('\0' == *a))
         done = TRUE;
   } while (!done);

   /* If we are looking at two spill locations, they either are the identical
    * strings or they are not.  If they were identical, the simp() code
    * would have exposed that fact.  So, at this point, any spill location
    * cannot be an alias of the other memory location.
    */
   if (memSpill || exprSpill)
      return FALSE;

   /* There could be certain machine dependent addressing expressions that
    * involve memory operators, such as "LA" on the ARM target.  It could
    * be profitable to return FALSE when we can ascertain that the addresses
    * are not aliased, but this must be done in machine dependent code.
    * If we call this code, and it returns FALSE, then we can just return
    * FALSE immediately.  Otherwise, we continue our own processing.
    * NOTE: We might have set memUnknown or exprUnknown because of the
    * machine-dependent memory operator.  We are going to let md_maybe_same()
    * have a shot at analyzing the two addresses before we let these
    * "Unknown" flags have the first priority.
    */
   if (!md_maybe_same(mem, expr))
      return FALSE;

   /*-
    * Globals can be indirectly referenced without it being recorded in any
    * data structure, unlike locals.  For example, the address of a global
    * could be taken in another function and passed into this function in
    * a register.  The only situation in which we are not worried about this
    * is when we have a global in "mem" and a local in "expr" (or vice versa)
    * and neither one of them has any registers added to or subtracted from
    * them.  This is because if we take the alias of a global:
    * r[5]=globalname;
    * R[fp+localname]=r[5];
    * r[7]=R[fp+localname];
    * R[r[7]]=r[2];           *** store into alias here 
    * r[6]=R[r[5]];
    *
    * We will do maybe_same() comparisons on RTLs with register addresses,
    * such as the last two, before doing any dangerous RTL combinations.
    * We treat such register addresses as possible aliases of any global
    * or any indirectly addressed local, so they will not combine across
    * either of the variable names above them.
    * There are no dangerous combinations among the first 3 RTLs that will
    * escape detection in maybe_same(). 
    *
    * On the other hand, an expression such as "globalname+r[5]" could be
    * an alias for any other location except a local that is !indref (and
    * we have already returned FALSE for those locals).  Ditto for an
    * expression such as "localname-r[6]".  We are also leery of any machine
    * dependent operators applied to memory addresses, such as the "RA"
    * (Range of Addresses) operator used in Intel i386 Move String RTLs.
    *  So, we need to know if there is anything other than constants and
    * arithmetic operators mixed in with a global or local name.  If so,
    * we return TRUE because we don't know what kind of aliasing might be
    * taking place. Otherwise, we just have two address expressions that
    * did not have registers or unknown operators, and which did not get
    * simplified to a constant when subtracted, e.g. R[%fp+local] and
    * R[globalname], where "local" is indirectly addressed. In that case,
    * we return FALSE, because they are not the same address.
    *
    * NOTE: The safe thing to do is to return TRUE here.  That way, if the
    * simp() processing was not powerful enough to reveal that two addresses
    * were the same, then we don't get burned.  For example, if we are given
    * "12+stackpointer+local1+4" and "16+local1+stackpointer" and we fail to
    * simplify them to the same address, then there are no "unknowns" and the
    * memUnknown and exprUnknown flags will be FALSE, causing us to return
    * FALSE. We can be a little dangerous until we have shaken out all the
    * simp() errors that we can find, then we could revert to returning TRUE
    * if some problem is unsolveable.
    */
#if 1
   return (exprUnknown || memUnknown);
#else
   return TRUE;
#endif
}                  /* end of maybe_same2() */

void reremember_deaths(struct list *start, struct list *end)
{
   if (start->daddy != end->daddy) {
      fprintf(stderr, "Warning, re-remembering deaths from multi-blocks\n");
   }
   assert(start->rnum < end->rnum);

   while (start && start != end) {
      if (start->type & RTLINE && start->deads)
         remember_deaths(start);
      start = start->next;
   }
}



void remove_extraneous_deaths(struct list *ptr)
{
   char  regs[BIGSTRING];
   char *a;
   reget(ptr->deads, regs);

   a = regs;
   while (*a) {
      int   ref = FALSE;
      if (ptr->val && isaliasref(ptr->val, a))
         ref = TRUE;
      if (ptr->se && isaliasref(ptr->se, a))
         ref = TRUE;
      if (!ref)
         rdelete(a, &ptr->deads);

      a = skiploc(a) + 1;
   }
}
