/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/combine.h,v $
 $Date: 2003/06/24 13:16:36 $
 $Revision: 1.8 $
 $Name:  $

 Log of changes:

 $Log: combine.h,v $
 Revision 1.8  2003/06/24 13:16:36  clc5q
 Export prototype of reverse_merge_check(), which is called from sparc/regs.c.

 Revision 1.7  2003/03/14 01:34:20  jdh8d
 i386 bug fixes

 Revision 1.6  2003/02/06 04:48:21  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.5  2003/01/24 20:18:24  clc5q
 Move maybe_same() from each target's rtl.c module up into combine.c.
    Make calls into rtl.c for machine-dependent information or processing.
 
 Revision 1.4  2002/07/11 15:19:42  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.3  2001/11/16 17:15:16  rv3s
 *** empty log message ***

 Revision 1.2  1998/04/28 19:21:30  jwd
 Removed some commented out code.
 Revision 1.1  1998/04/03 16:53:30  jwd
 Initial revision

*************************************************************************/

#ifndef COMBINE_H
#define COMBINE_H

/* How many registers that are used in address expressions cannot possibly
 * hold an alias of a given memory location? For example, the frame pointer
 * cannot be an alias for some global variable's address, etc.
 */
#define MAX_ALIASFREE_REGS 4  /* FramePointer, StackPointer, ?? */

extern char *reason;
extern char *side_effect;
extern char *linptr;
extern int icost;
extern int ikind;
extern int erflag;
extern struct list *curptr;
extern rlist deadlist;

#define cannot_assemble_warning(func, rtl) {                            \
        fprintf(stderr,"\n(vpo:%s) Warning:  Cannot assemble RTL:", func);\
        show(rtl->val);                                                 \
        fprintf(stderr,"Occurring at line %d of %s\n", __LINE__, __FILE__); \
        if (NULL != reason) {                                           \
           fprintf(stderr, "Reason: %s\n", reason);                     \
        }                                                               \
}


#define bad_rtl_line_warning(func, rtlType) {                                \
        fprintf(stderr, "\n(vpo:%s): bad line, type %x\n", func, rtlType);   \
        fprintf(stderr,"Occurring at line %d of %s\n", __LINE__, __FILE__);  \
}                                                                            \


#define bad_cost_warning(func, cost, rtl) {                                  \
        fprintf(stderr, "\n(vpo:%s): bad cost = %d RTL = \n", func, cost);   \
        show(rtl->val);                                                      \
        fprintf(stderr,"Occurring at line %d of %s\n", __LINE__, __FILE__);  \
}                                                                            \

#ifdef INTERACT
int 
instruction_selection(int, int);
#else
int 
instruction_selection(int);
#endif

int
combine_rtls(struct list *, int);

void
merge_rtls(char *, char *, char *, rlist, rlist, char *);

int
maybe_same(char *, char *);

int
find(struct list *, char *, rlist);

int
needsparen(char, char, char *);

int
dowrap(char *);

void
merge_deads(struct list *, struct list *, char *);

int
merge_check(struct list *, struct list *, struct list *);

int reverse_merge_check(struct list *, struct list *, struct list *);

void
set(struct list *, char *, char *);

void
simp(char *, int);

void
set_rtl_sides(struct list*);

#ifdef ADDR
void
address(char *);

void
simpaddr(register char *);
#endif

#endif

void reremember_deaths(struct list* start, struct list* end);
