
/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/cse.c,v $
 $Date: 2004/01/29 01:13:01 $
 $Revision: 1.61 $
 $Name:  $

 Log of changes:

 $Log: cse.c,v $
 Revision 1.61  2004/01/29 01:13:01  clc5q
 Initialize an uninitialized local identified by Purify.
 Cosmetic fixes.

 Revision 1.60  2003/10/22 13:13:00  jdh8d
 removed extraneous code from update_equiv_list

 Revision 1.59  2003/10/21 00:13:44  jdh8d
 fixed CSE efficiency bug introduced in v1.57

 Revision 1.58  2003/10/12 12:42:20  jdh8d
 made cse handle setlines properly

 Revision 1.57  2003/07/07 18:55:14  jg9h
 Bug fix in update_equivalence_table to handle rtls like  w[5]=w[5]+1; W[w[5]]=1;, where the memory reference uses a register (w[5]) that is set in another effect.

 Revision 1.56  2003/04/03 20:05:05  jg9h
 Added a fix to backup() and to ckse() to handle uses in side-effects.

 Revision 1.55  2003/03/20 15:01:50  jdh8d
 sign-ext fix for x86

 Revision 1.54  2003/03/12 15:35:08  jdh8d
 *** empty log message ***

 Revision 1.53  2003/02/15 00:14:36  clc5q
 Make rplfast() use a copy of an RTL when it calls simp() on it, because
    the RTL could change length in simp(), invalidating the pointers into
    the RTL that are live across the call to simp().
 Have all four places in rplfast() that need such an RTL copy use the same
    buffer for the copy, reducing the stack frame size. Previously, one
    site made no copy and the other three sites used three different
    temporary buffers.

 Revision 1.52  2003/02/06 04:46:28  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.51  2002/08/25 03:25:37  clc5q
 Integrate all code changes from Sampoorani Deivasigamani to optimize
 multiplications and divisions by integer constants.

 Revision 1.50  2002/07/11 15:22:30  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.49  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.48  2002/03/26 02:47:07  rv3s
 CSE warnings now under optimizer warning flag

 Revision 1.47  2002/03/21 21:41:41  jdh8d
 fixed problem with all links

 Revision 1.46  2002/03/20 18:02:03  jdh8d
 *** empty log message ***

 Revision 1.45  2002/02/12 17:03:10  rv3s
 Invocation limit (per func) placed for CSE to prevent flipping

 Revision 1.44  2001/12/18 15:09:02  rv3s
 all_lnks removed whenever lnks are removed

 Revision 1.43  2001/12/06 15:29:33  jdh8d
 *** empty log message ***

 Revision 1.42  2001/12/06 14:27:45  rv3s
 simp() called in rplfast and other places to simplify rtls during item replacement

 Revision 1.41  2001/12/04 16:32:44  jdh8d
 *** empty log message ***

 Revision 1.40  2001/11/26 15:32:19  jdh8d
 *** empty log message ***

 Revision 1.39  2001/11/13 17:04:50  jdh8d
  fixed memory leaks

 Revision 1.38  2001/11/07 01:48:06  jdh8d
 *** empty log message ***

 Revision 1.37  2001/11/01 17:24:10  jdh8d
 no message

 Revision 1.36  2001/10/30 22:33:36  jdh8d
 *** empty log message ***

 Revision 1.35  2001/10/10 21:29:28  jdh8d
 *** empty log message ***

 Revision 1.34  2001/10/02 13:18:28  jdh8d
 *** empty log message ***

 Revision 1.33  2001/09/15 01:57:05  jdh8d
 *** empty log message ***

 Revision 1.32  2001/09/14 12:48:51  jdh8d
 no message

 Revision 1.31  2001/09/12 20:32:42  jdh8d
 *** empty log message ***

 Revision 1.30  2001/09/10 17:55:43  jdh8d
 *** empty log message ***

 Revision 1.29  2001/09/03 16:54:27  rv3s
 rbackup now checks to see if all the rtls to be backed up (removed) can be removed. Its "all or nothing" for the rtls to be backedup. This is true especially incases involving rtls with multiple effects.

 The check_rbackup routine checks this and rbackup is called only if all rtls can be backed-up. The split_mertls_and_check checks to see if remove one effect (the effect containing the register set to be backed-up) in the multi-effect rtl leaves a valid rtl behind. If so, backup can be done. split_mertls_and_backup does the actual backup on a multi-effect rtl. Check the comments before check_rbackup for details

 Revision 1.28  2001/08/31 20:33:02  rv3s
 add_link should not be called from cse. Instead, set_local_links is called after the CSE phase

 Revision 1.27  2001/08/29 21:20:38  jdh8d
 *** empty log message ***

 Revision 1.26  2001/08/23 01:42:11  jdh8d
 *** empty log message ***

 Revision 1.25  2001/08/15 21:18:22  jdh8d
 *** empty log message ***

 Revision 1.24  2001/08/08 18:29:20  jdh8d
 *** empty log message ***

 Revision 1.23  2001/08/07 19:33:38  jdh8d
 *** empty log message ***

 Revision 1.22  2001/07/23 18:29:58  rv3s
 1. Replaced skiploc() with skiplocOr2() for processing dead register list
 2. In update_equivalence_list(), if the old and new items do not contain
 registers, check to see if there is a pattern match.

 Revision 1.21  2001/07/20 15:48:50  jdh8d
 *** empty log message ***

 Revision 1.20  2001/06/13 15:47:47  rv3s
 Simplify rtls before searching for the fastest version/entering into the equivalnce table

 Revision 1.19  2001/05/28 20:30:20  jdh8d
 *** empty log message ***

 Revision 1.18  2001/05/23 20:28:20  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.17  2001/05/23 18:53:40  rv3s
 Changed upduse to update the use counts of all aliases of a register used in
 the rtl.

 Revision 1.16  2001/05/21 18:43:11  jdh8d

 changes to watch register aliases and SE's more clothes

 Revision 1.15  2001/05/12 16:05:00  jdh8d
 *** empty log message ***

 Revision 1.14  2001/04/13 21:49:53  jdh8d
 *** empty log message ***

 Revision 1.13  2001/04/12 22:14:51  jdh8d

 fixed bug.

 Revision 1.12  2001/04/10 16:42:08  rv3s
 In update_equivalence_table, make sure nptr != eptr before setting the pequiv and nequiv links (otherwise, we end up with links to self in the equiv list)

 Revision 1.11  2001/04/10 14:38:51  jdh8d

 Minor bug in combine.c

 Revision 1.10  2001/04/09 16:03:02  rv3s
 e_insert can return null -- added a check in places where it was assumed that e_insert would not return NULL

 Revision 1.9  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.8  2001/03/14 18:17:39  jdh8d

 look at update_equivalence_table;  found and fixed a bug there, hopefully.

 Revision 1.7  2001/03/13 19:29:05  rv3s
 CSE bug fix. Remove all r*[reg#x] from equivalence table if an rtl such as
 r[reg#y]=r[reg#x]+..; is removed (optimized away).

 Revision 1.6  2000/03/15 16:24:52  jwd
 Changed call to VET to accept the phase name.

 Revision 1.5  1999/01/06 15:45:19  jwd
 Added VET directives.
 Revision 1.4  1998/04/28 20:11:43  jwd
 Included some necessary header files.
 Revision 1.3  1998/04/03 18:18:24  jwd
 First ANSI C version.

*************************************************************************/

#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "vpo.h"
#include "vpo2.h"
#include "assign.h"
#include "combine.h"
#include "controlflow.h"
#include "database.h"
#include "links.h"
#include "misc.h"
#include "cse.h"
#include "vectors.h"

#include "y.tab2.h"     /* Machine Dependent */
#include "rtl.h"        /* Machine Dependent */
#include "inst.h"       /* Machine Dependent */
#include "isem.h"       /* Machine Dependent */

#ifdef VET
#include "view.h"
#endif

/*
 * This file contains functions that perform common subexpression elimination
 * and copy propagation on a procedure.
 */

/* ---------History of Modifications ----------------------
   1/9/98 : Took ansi-c prototypes into account from created header files,
              and eliminated non-ansi in-function function prototyping so
	      that the code would be ansi asa a whole.

	      NOTE: UPDATE_EQUIVALENCE_TABLE had a malformed function 
	            definition for the FIFOS case. As a result, I was unable
		    to repair the formal parameter data types with certainty.
		   Particularly the last one, 'last'

	      NOTE: ALSO THE FIFO directive refers to a function 'loadof'.
	          which is referenced and no other file and could not be found.
                  So no prototype for the function is given. Nor code defintion
*/

#ifdef VET
char  oldse[MAXSTRING];
#endif


int
      cse_special_backup(char *item, struct list *ptr);


/*
 * common_subexpression_elimination - perform common subexpression elimination
 */
int
common_subexpression_elimination(int invocation)
{

   register struct bblock *cblk;
   int   change;

   if (invocation > ITER_LIMIT)
      return FALSE;

#ifdef VET
#ifdef INTERACT
	begin_phase(COMMON_SUBEXPR_ELIM_TRANS);	
#else
   begin_phase(COMMONSUBEXPR_PHASE);
#endif
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd
       && debug_opt_i("dump_before_common_subexpression_elimination",
                      invocation))
      dump_function_i("before common_subexpression_elimination()", invocation,
                      SHOW_LABELS | SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   change = FALSE;

   /*
    * Because there are certain instances where CSE and dead variable
    * elimination can get into an endless cycle of do/undo, the constant
    * "MAXCSUBS" is used to limit the number of times that CSE is applied to a
    * function.
    */
   if (invocation <= MAXCSUBS) {

      /*
       * Mark all of the basic blocks UNDONE and perform CSE on the function
       * starting with the entry block.
       */
      for (cblk = top; cblk; cblk = cblk->down)
         STATUS(cblk, UNDONE);
      change |= remv_common_subexpressions(top, invocation);

      /*
       * Go back and pick up any blocks that were left in a dormant state
       * because of strange controlflow graphs.
       */
      for (cblk = top; cblk; cblk = cblk->down)
         if (cblk->status & (DRYRUN | DORMANT))
            change |= remv_common_subexpressions(cblk, invocation);

      /*
       * Ensure that we have turned off the request for side effect information
       * from the machine description.
       */
      side_effect = (char *) NULL;

      /*
       * Make a final pass through the basic blocks to ensure that every block
       * was properly examined and that equivalence tables are returned to the
       * free memory list so that they can be re-used in the next pass.
       */
      for (cblk = top; cblk; cblk = cblk->down) {

         /* warn the user about missed blocks if we're compiler writers */
         /*OPTIMIZER_WARN(if (!(cblk->status & DONE))
	   (void) fprintf(stderr,
	   "vpo (common_subexpression_elimination): basic block not examined\n")
	   ) ;*/

	if (cblk->elist) {
	  clrequiv(cblk->elist);
	  FREETYPE(cblk->elist, EQVTABLETYPE);
	  cblk->elist = (struct eqvtable *) NULL;
	}
      }
   }
#ifdef VET
#ifdef INTERACT
 end_phase(COMMON_SUBEXPR_ELIM_TRANS);	
#else
   end_phase(COMMONSUBEXPR_PHASE);
#endif
#endif

   /* PK: Inverse copy propogation
      CSE attempts to perform copy propogation on the code. However, in
      some cases it is unable to eliminate the copy instruction. Inverse
      copy propogation may help in such cases.
      Step 1: Find a copy instruction of the form r[i] = r[j];
      Step 2: Check if the preceeding r[j]=...; can be replaced by
      r[i]=...;
      Step 3: Check if all uses of r[j] can be replaced by r[i]
      Step 4: Replace the def and all uses of r[j] in this live range
      with r[i], and eliminate the copy instruction
   */
#ifdef INTERACT   
   do_needed_analysis(LOCAL_LINK_ANALYSIS|LIVE_VAR_ANALYSIS|REGS_USED_ANALYSIS|DEAD_VAR_ANALYSIS);
#endif
   
#ifdef VET
#ifdef INTERACT
	begin_phase(COMMON_SUBEXPR_ELIM_TRANS);	
#else
   begin_phase(COMMONSUBEXPR_PHASE);
#endif
#endif
   change |= inverse_copy_propogation();

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd
       && debug_opt_i("dump_after_common_subexpression_elimination",
                      invocation))
      dump_function_i("after common_subexpression_elimination()", invocation,
                      SHOW_LABELS | SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

#ifdef VET
#ifdef INTERACT
 end_phase(COMMON_SUBEXPR_ELIM_TRANS);	
#else
   end_phase(COMMONSUBEXPR_PHASE);
#endif
#endif

   /*
    * Indicate if any changes have been made to the function
    */
   return (change);
}

/*
 * remv_common_subexpressions - perform common subexpression elimination
 */
int
remv_common_subexpressions(register struct bblock *cblk, int invocation)
{

   register struct blist *bptr;
   register int go, dryrun;
   int   change;

   change = FALSE;

   /*
    * Determine if this basic block has been dry runned.  A dry run is an
    * initial trial pass through the basic blocks that make up a loop.  The
    * intent of a dry run is to determine if there are any equivalences that
    * are available at the end of each loop that match those available at the
    * entry point.
    */
   dryrun = (cblk->status & DRYRUN);

   /*
    * Set the status of the current block to WAITING.  This will allow us to
    * determine that this block is being worked on when recursive calls are
    * made to this function.
    */
   STATUS(cblk, WAITING);

   /*
    * Set the "go" status to permit this basic block to be examined.  Later, we
    * may encounter circumstances that will prevent us from going ahead and
    * examining this basic block at this time.
    */
   go = TRUE;

   /*
    * If this basic block has predecessors, then we need to determine what we
    * know about the equivalences at this point from them.
    */
   if (bptr = cblk->preds) {

      /*
       * If this basic block has more than one predecessor, then we are going
       * to have to merge equivalence classes to obtain the equivalence items
       * that are valid for this basic block.
       */
      if (bptr->next) {

         /*
          * We first examine each predecessor and try to ensure that CSE has
          * been performed on each of them.  Since many functions contain
          * loops, there will be cases where not all of the predecessors can
          * have CSE performed on them at this time.
          */
         while (bptr) {

            /*
             * If we have not yet performed CSE on the predecessor to this
             * basic block, then we should go ahead and try do so in order to
             * be able to start with more than just a blank equivalence list
             * for this basic block.
             */
            if (bptr->ptr->status & UNDONE)
               change |= remv_common_subexpressions(bptr->ptr, invocation);

            /*
             * If something has prevented us from performing CSE on the
             * predecessor, then we clear the "go" flag which will prevent us
             * from attempting to perform CSE on the current basic block just
             * yet.
             */
            if (bptr->ptr != cblk && bptr->ptr->status & WAITING)
               go = FALSE;

            bptr = bptr->next;
         }

         /*
          * If we still have a "go" indication for this basic block, we can
          * continue the process of merging the equivalence lists of the
          * predecessors.
          */
         if (go) {

            /*
             * If any predecessors indicate that they have not has CSE
             * performed on them appropriately, then we cannot go ahead and do
             * CSE on the current basic block.  This will happen when a loop
             * that has not yet been dry runned is encountered.
             */
            for (bptr = cblk->preds; bptr; bptr = bptr->next) {
               if (bptr->ptr->status & ~(DONE | DRYRUN | CLEAR)
                   && !(dryrun && bptr->ptr == cblk)) {
                  go = FALSE;
                  break;
               }
            }

            /*
             * If we have valid information for all of the predecessors, then
             * we can go ahead and merge their equivalence information to yield
             * a list of the equivalences that are available from all of the
             * possible control flow paths into this basic block.
             */
            if (go) {
               dryrun = FALSE;
               bptr = cblk->preds;

               /*
                * We need to pick a place to start our merging process, if the
                * current basic block has itself as a predecessor, then if we
                * wish to start off the merge list by obtaining that
                * equivalence information first before we end up wiping it out
                * to hold the new merge list.
                */
               if (bptr->ptr != cblk) {

                  /*
                   * The first predecessor it not this current basic block, but
                   * a quick check can be used here to determine if we will be
                   * finding this block later in the predecessor list.  If so,
                   * we grab the equivalence information first (if there is
                   * any) so that we have it before it becomes corrupted.  If
                   * we encounter it later in the merging process, we will know
                   * to ignore it.
                   */

                  if (cblk->left == cblk || cblk->right == cblk) {
                     /*
                      * In the case that we don't have any information for our
                      * own basic block, we start with a blank equivalence
                      * table.
                      */
                     if (!cblk->elist)
                        cblk->elist = newequiv();

                     /*
                      * We expect to have an equivalence list to merge in for
                      * every predecessor, and we complain if we do not.
                      */
                     if (!bptr->ptr->elist) {
                        OPTIMIZER_WARN((void)
                                       fprintf(stderr,
                                               "vpo (remv_common_subexpressions): elist not available\n"));
                     }
                     else
                        e_merge(cblk->elist, bptr->ptr->elist);

                     /*
                      * Return the equivalence table of the predecessor that we
                      * have just merged in to the free list if we determine
                      * that we will not be needing it again in the future.
                      */
                     if (!(bptr->ptr->status & DRYRUN)
                         && !--bptr->ptr->elist->uses) {
                        clrequiv(bptr->ptr->elist);
                        FREETYPE(bptr->ptr->elist, EQVTABLETYPE);
                        bptr->ptr->elist = (struct eqvtable *) NULL;
                     }
                  }

                  /*
                   * The current basic block is not a predecessor of itself, so
                   * we can go ahead and start a merge list without considering
                   * any equivalence table information that this basic block
                   * might have had.
                   */
                  else {

                     /*
                      * If we had a previous equivalence list, then we go ahead
                      * and return it to the free list.
                      */
                     if (cblk->elist) {
                        clrequiv(cblk->elist);
                        FREETYPE(cblk->elist, EQVTABLETYPE);
                     }

                     /*
                      * If we will need to reference the predecessor's
                      * equivalence information in the future, then we make a
                      * copy of it in order to start our own merge list.
                      */
                     if (bptr->ptr->status & DRYRUN
                         || --bptr->ptr->elist->uses > 0) {
                        cblk->elist = newequiv();
                        if (!bptr->ptr->elist) {
                           OPTIMIZER_WARN((void)
                                          fprintf(stderr,
                                                  "vpo (remv_common_subexpressions): elist not available\n"));
                        }
                        else
                           e_copy(cblk->elist, bptr->ptr->elist);
                     }

                     /*
                      * Otherwise, we will not need the predecessor's
                      * equivalence information again, so instead of copying
                      * it, we go ahead and take it so that it will now be the
                      * start of our merge list.
                      */
                     else {
                        if (!(cblk->elist = bptr->ptr->elist)) {
                           OPTIMIZER_WARN((void)
                                          fprintf(stderr,
                                                  "vpo (remv_common_subexpressions): elist not available\n"));
                           cblk->elist = newequiv();
                        }
                        bptr->ptr->elist = (struct eqvtable *) NULL;
                     }
                  }
               }

               /*
                * The merging process continues over all of the predecessors of
                * the current basic block.
                */
               while (bptr = bptr->next) {

                  /*
                   * Never bother to merge our own information with ourselves,
                   * since we have already taken it into account at the start
                   * of the merge process.  Otherwise, continue to merge in all
                   * of the predecessor information to determine what, if
                   * anything, is equivalent when we reach this basic block.
                   */
                  if (bptr->ptr != cblk) {

                     /*
                      * We should have an equivalence structure for each
                      * predecessor, but we check here just for the sake of
                      * paranoia and print out an error if we don't have one.
                      */
                     if (bptr->ptr->elist)
                        e_merge(cblk->elist, bptr->ptr->elist);
                     else {
                        OPTIMIZER_WARN((void)
                                       fprintf(stderr,
                                               "vpo (remv_common_subexpressions): elist not available\n"));
                        e_merge(cblk->elist, bptr->ptr->elist = newequiv());
                     }

                     /*
                      * Return the equivalence table of the predecessor that we
                      * have just merged in to the free list if we determine
                      * that we will not be needing it again in the future.
                      */
                     if (!(bptr->ptr->status & DRYRUN)
                         && !--bptr->ptr->elist->uses) {
                        clrequiv(bptr->ptr->elist);
                        FREETYPE(bptr->ptr->elist, EQVTABLETYPE);
                        bptr->ptr->elist = (struct eqvtable *) NULL;
                     }
                  }
               }
            }

            /*
             * Otherwise, if the block was initially set up for a dry run, then
             * we continue to leave it in that state.
             */
            else if (dryrun) {
               STATUS(cblk, DRYRUN);
               return (change);
            }

            /*
             * Otherwise, it is time to perform a real dry run from this basic
             * block, so we initialize a new equivalence list and start the dry
             * run at this point.
             */
            else {
               go = dryrun = TRUE;

               /*
                * Check to see if we have loop information for this basic
                * block. If we do, we might be able to take advantage of loop
                * invariant information gathered by the code motion phase.
                */
               if (cblk->loop) {

                  if (swd
                      &&
                      debug_opt_i_l("common_subexpression_elimination_dryrun",
                                    invocation, cblk->label))
                     (void) fprintf(stderr, "Dryrun for %s\n", cblk->label);

                  /*
                   * In order to take advantage of the loop invariant items
                   * that may enter this loop, we go ahead and merge in the
                   * equivalences of all of the predecessors that we have
                   * equivalence information for.
                   */
                  for (bptr = cblk->preds; bptr; bptr = bptr->next) {
                     if (!block_in_loop(cblk->loop, bptr->ptr)
                         && bptr->ptr->status & DONE && bptr->ptr->elist) {
                        if (swd
                            &&
                            debug_opt_i_l
                            ("common_subexpression_elimination_dryrun",
                             invocation, cblk->label)) {
                           if (bptr->ptr->label)
                              (void) fprintf(stderr, "%s\n",
                                             bptr->ptr->label);
                           e_show(bptr->ptr->elist);
                        }
                        if (cblk->elist)
                           e_merge(cblk->elist, bptr->ptr->elist);
                        else {
                           cblk->elist = newequiv();
                           e_copy(cblk->elist, bptr->ptr->elist);
                        }
                     }
                  }

                  /*
                   * Remove any equivalences that contain non-constant items,
                   * leaving only valid constant and loop-invariant items to
                   * start the loop with.
                   */

                  if (cblk->elist)
                     e_invar(cblk->elist, cblk->loop);
                  else
                     cblk->elist = newequiv();

                  if (swd
                      &&
                      debug_opt_i_l("common_subexpression_elimination_dryrun",
                                    invocation, cblk->label)) {
                     (void) fprintf(stderr, "End of dryrun for %s\n",
                                    cblk->label);
                     e_show(cblk->elist);
                  }
               }

               /*
                * If we have no loop information for this basic block, start
                * the dry run with an empty equivalence table.
                */
               else
                  cblk->elist = newequiv();
            }
         }
      }

      /*
       * Otherwise, this basic block has only a single predecessor, so we do
       * not need to merge equivalence lists.
       */
      else {

         /*
          * If we have not yet performed CSE on the predecessor to this basic
          * block, then we should go ahead and do so in order to be able to
          * start with more than just a blank equivalence list for this basic
          * block.
          */
         if (bptr->ptr->status & UNDONE)
            change |= remv_common_subexpressions(bptr->ptr, invocation);

         /*
          * If we were able to perform CSE on the predecessor block, then go
          * ahead and set up a equivalence list so that we can perform CSE on
          * this block.
          */
         if (bptr->ptr->status & (DONE | DRYRUN)) {

            /*
             * If the CSE pass on the predecessor was a dry run, then the
             * current basic block must also be part of a loop so that this
             * will also be the dry run for this basic block.
             */
            if (dryrun = (bptr->ptr->status & DRYRUN)) {

               /*
                * If the preceeding basic block has more than one child, then
                * we make a copy of its equivalence list.
                */
               if (bptr->ptr->elist->uses > 0) {
                  cblk->elist = bptr->ptr->elist;
                  bptr->ptr->elist = newequiv();
                  if (cblk->elist)
                     e_copy(bptr->ptr->elist, cblk->elist);
                  else {
                     OPTIMIZER_WARN((void)
                                    fprintf(stderr,
                                            "vpo (remv_common_subexpressions): elist not available\n"));
                     cblk->elist = newequiv();
                  }
               }

               /*
                * Otherwise, we can go ahead and take the equivalence list,
                * since no one else will be needing it at this point.
                */
               else {
                  if (!(cblk->elist = bptr->ptr->elist)) {
                     OPTIMIZER_WARN((void)
                                    fprintf(stderr,
                                            "vpo (remv_common_subexpressions): elist not available\n"));
                     cblk->elist = newequiv();
                  }
                  bptr->ptr->elist = (struct eqvtable *) NULL;
               }
            }

            /*
             * Otherwise, this is not a dry run, so we proceed with a copy of
             * the predecessor's equivalence list.  In this case, the
             * predecessor has more than one child, and it has not given a copy
             * to all of it's children yet, so we just make a copy of the
             * equivalence list and leave the original one for the other child.
             */
            else if (--bptr->ptr->elist->uses > 0) {
               cblk->elist = newequiv();
               if (bptr->ptr->elist)
                  e_copy(cblk->elist, bptr->ptr->elist);
               else {
                  OPTIMIZER_WARN((void)
                                 fprintf(stderr,
                                         "vpo (remv_common_subexpressions): elist not available\n"));
                  e_copy(cblk->elist, newequiv());
               }
            }

            /*
             * Otherwise, we can take the equivalence list from the preceeding
             * basic block, since no one else will need to use it.
             */
            else {
               if (!(cblk->elist = bptr->ptr->elist)) {
                  OPTIMIZER_WARN((void)
                                 fprintf(stderr,
                                         "vpo (remv_common_subexpressions): elist not available\n"));
                  cblk->elist = newequiv();
               }
               bptr->ptr->elist = (struct eqvtable *) NULL;
            }
         }

         /*
          * Otherwise, we were not able to perform CSE on the predecessor, so
          * we must put this block on hold for now.
          */
         else
            go = FALSE;
      }
   }

   /*
    * Otherwise, this must be the entry block to the function, so we start with
    * a clear equivalence list.
    */
   else
      cblk->elist = newequiv();

   /*
    * If everything is set up to perform CSE on this basic block, then so so.
    * If this was just a dry run pass, then mark the block as having gone
    * through its dry run, otherwise, mark it done.  Once a block is examined,
    * move on to its children and call this function recursively in order to
    * attempt to examine all of the basic blocks.  If this block has more than
    * one child, then forget set information, so we don't try to delete sets
    * that may be needed in more than one place.
    */
   if (go) {
      if (cblk->loop) {
         if (cblk->elist)
            e_invar(cblk->elist, cblk->loop);
         else
            cblk->elist = newequiv();
      }

      change |= cse_basic_block(cblk, invocation);


      if (dryrun)
         STATUS(cblk, DRYRUN);
      else
         STATUS(cblk, DONE);
      if (cblk->right)
         e_clrsets(cblk->elist);
      if (cblk->left && (cblk->left->status & (UNDONE | DORMANT | DRYRUN)))
         change |= remv_common_subexpressions(cblk->left, invocation);
      if (cblk->right && (cblk->right->status & (UNDONE | DORMANT | DRYRUN)))
         change |= remv_common_subexpressions(cblk->right, invocation);
   }

   /*
    * If we do not get the go-ahead for this basic block, then place it in a
    * dormant state for now.  We will be picked up again at some point in the
    * future when the status of any of our predecessors changes.
    */
   else
      STATUS(cblk, DORMANT);

   /*
    * Return indicating if any changes have been made to the function
    */
   return (change);
}

/*
 * cse_basic_block - eliminate common subexpressions from a basic block
 */
int
cse_basic_block(struct bblock *cblk, int invocation)
{

   struct list *ptr;
   char *rtl, *a, *b;
   struct eqvlist *ptr1, *ptr2;
   struct eqvtable *old_list;
   int   change, cost, diff, i, check, kind;
   char *s, new[NEW_BIGSTRING], src[BIGSTRING], dst[BIGSTRING], se[MAXSTRING];
   char  all_dsts[MAXSTRING], *all_dsts_ptr;
   int   total_dsts;
   struct list *next_rtl = 0;
	
   change = FALSE;

   if (swd && cblk->label
       && debug_opt_i_l("common_subexpression_elimination", invocation,
                        cblk->label))
      (void) fprintf(stderr, "%s:\n", cblk->label);

   /*
    * Look at each line in the basic block
    */
   for (ptr = cblk->rtls; ptr; ptr = next_rtl) {
#ifdef VET
   begin_trans(VET_OPT_TRANS);
#endif
      next_rtl = ptr->next;
      /*
       * Examine each RTL line, look for common subexpressions and make any
       * changes that are appropriate.
       */
      if (ptr->type & RTLINE) {
         if (rtl = ptr->val) {
            deadlist = ptr->deads;
            curptr = ptr;

            /*
             * Ensure that we have the most up-to-date information on the cost
             * and side effects of this RTL.
             */
            if (ptr->cost && (ptr->type & SIDEFFECT)) {
               if (ptr->se)
                  (void) strcpy(se, ptr->se);
               else
                  *se = '\0';
               cost = ptr->cost;
               kind = ptr->kind;
            }
            else {
               sem_ptr = str_ptr = i_ptr = erflag = FALSE;
               linptr = rtl;
               side_effect = se;
               *se = '\0';
               icost = -1;
               ikind = 0;
               if (find(ptr, ptr->val, ptr->deads)) {
                  (void) fprintf(stderr,
                                 "vpo (cse_basic_block): cannot assemble ");
                  show_rtl(stderr, rtl);
                  (void) fprintf(stderr, "\n");
                  continue;
               }
               else {
                  cost = ptr->cost = icost;
                  kind = ptr->kind = ikind;
               }
            }
            if (cost < 0) {
               (void) fprintf(stderr,
                              "vpo (cse_basic_block): icost not set for ");
               show_rtl(stderr, rtl);
               (void) fprintf(stderr, "\n");
               exit(1);
            }

            if (swd
                && debug_opt_i_l("common_subexpression_elimination",
                                 invocation, cblk->label)) {
               e_show(cblk->elist);
               (void) fprintf(stderr, "Examining: ");
               show_rtl(stderr, rtl);
               (void) fprintf(stderr, "\t");
               rshow(deadlist);
               (void) fprintf(stderr, "\n");
               (void) fflush(stderr);
            }

            /*
             * Examine the RTL and replace any components with the oldest or
             * cheapest values possible.
             */

            diff = FALSE;

            a = new;
            while (*a++ = *rtl++) ;
            simp(new, FALSE);
            rtl = new;
            while (*rtl && cost) {
               if (ismem(b = rtl)) {
                  a = (rtl += 2);
                  while (*rtl++ != '=') ;
                  rtl =
                   rplfast(cblk->elist, (struct eqvlist *) NULL, new, a,
                           rtl - 2, se, &cost, &diff, &kind) + 2;
                  *dst = '\0';
                  simp(new, FALSE);
               }
               else {
                  a = dst;
                  while ((*a++ = *rtl++) != '=') ;
                  *(a - 1) = '\0';
               }

               a = rtl;
               while (*rtl++ != ';') ;
               ptr1 =
                (isreg(dst)) ? e_lookup_reg(cblk->elist,
                                            dst) : (struct eqvlist *) NULL;
               rtl =
                rplfast(cblk->elist, ptr1, new, a, rtl - 1, se, &cost, &diff,
                        &kind) + 1;
               if (!cost) {

                  /*
                   * Check to see if we are merging two lifes together by
                   * seeing if there if the is a death of the destination item.
                   * If there is, then we must get rid of it because we have
                   * just merged it into this new life.
                   */
                  if (ptr1 && ptr1->dead) {
                     rdelete(ptr1->item, &ptr1->dead->deads);
                     combmark(ptr1->dead);
                     ptr1->dead = (struct list *) NULL;
                  }

                  /*
                   * Remove the recalculation effect and ensure that the result
                   * is valid.
                   */
                  (void) gtds(b, dst, src);
                  rtl = sub(b, rtl, "");
                  if (*new) {
                     rtl = new;
                     while (fmatch(new, src))
                        (void) sub(bpos, epos, dst);

                     sem_ptr = str_ptr = i_ptr = erflag = FALSE;
                     simp(new, FALSE);
                     linptr = new;
                     side_effect = se;
                     *se = '\0';
                     icost = -1;
                     ikind = 0;
                     if (find(curptr, linptr, deadlist)) {
                        (void) fprintf(stderr,
                                       "vpo (cse_basic_block): cannot recalculate ");
                        show_rtl(stderr, new);
                        (void) fprintf(stderr, "\n");
                     }
                     else {
                        cost = icost;
                        kind = ikind;
                     }
                  }
               }
            }

            /*
             * If the RTL left performs a useful function, then update the
             * items it uses so that they are preserved.
             */
            if (cost) {

               /*
                * If the instruction has been changed, call the numeric
                * simplifier on the new instruction.  Also, simplify any
                * address expressions, if the machine uses them.
                */
               if (diff)
                  simp(new, FALSE);

               /*
                * Update the use counts on each item used by the instruction.
                * Note that items comprising the address of a memory reference
                * are used, not set.
                */
               rtl = new;
               while (rtl = gtds(rtl, dst, src)) {
                  if (ismem(dst))
                     upduse(cblk->elist, dst + 2, ptr);
                  upduse(cblk->elist, src, ptr);
               }

               /*
                * The following code examines each of the items set in the side
                * effects of an instruction.  Any item which is also set in the
                * actual instruction is removed from the side effect.  The
                * reason this is done is to prevent the following senario:
                * 
                * r[1] = R[r[1]++];       (side effect) = r[1] = r[1] + 4;
                * 
                * Since the side effects are parsed after the main instruction,
                * this particular beastie would leave the equivalence table
                * indicating that r[1] had a value that was four greater than
                * its actual value.  This, of course, has the underlying
                * assumption that well-behaved machines would not increment
                * r[1] after storing a new value into it.  You might also be
                * asking yourself why anybody would be using an autoincrement
                * when the value of the register incremented will be thrown
                * away?  The answer is that there probably exists a machine
                * that can only reference memory with an autoincrement.
                * 
                * Note that we also take this opportunity to update the reference
                * counts of each item used in the side effect. In this case we
                * do not check for memory references in the destination,
                * because no machine yet encountered has required a side effect
                * that sets a memory location.
                */
               if (*se) {
                  rtl = b = se;
                  while (*(s = b)) {
                     a = dst;
                     while ((*a++ = *b++) != '=') ;
                     *(a - 1) = '\0';
                     if (isset(new, dst))
                        while (*b++ != ';') ;
                     else {
                        a = src;
                        while ((*a++ = *b++) != ';') ;
                        *(a - 1) = '\0';
                        if (*src)
                           upduse(cblk->elist, src, ptr);
                        b = s;
                        while ((*rtl++ = *b++) != ';') ;
                     }
                  }
                  *rtl = '\0';
               }
            }

            /*
             * Examine the dead register list and handle the effect that
             * register deaths have on the equivalence list and the code.
             */
            change |= cse_dead_register_list(cblk->elist, ptr, new);

            /*
             * If the instruction has a cost, then it performs some useful
             * function and must be kept.
             */
            if (cost) {

               /*
                * Examine the combiner links of this RTL to ensure that they
                * are still safe and valid.  Remove any that are not.
                */
               for (i = 0; i < MAXLINKS && ptr->lnks[i]; i++) {
                  if (rtl = ptr->lnks[i]->val) {
                     while (rtl = gtds(rtl, dst, src)) {
                        if (ismem(src)) {
                           check = TRUE;
                           if (isreg(dst)) {
                              b = src;
                              while (b = gtrg(b))
                                 if (cmploc(dst, unskiploc(b)) != 0) {
                                    check = TRUE;
                                    break;
                                 }
                                 else
                                    check = FALSE;
                           }
                        }
                        else if (isreg(dst)) {
                           check = FALSE;
                           b = src;
                           while (b = gtrg(b))
                              if (cmploc(dst, unskiploc(b)) == 0) {
                                 check = TRUE;
                                 break;
                              }
                        }
                        else
                           check = TRUE;
                        if (check) {
                           (void) oldest(cblk->elist, src);
                           if ((ptr1 = e_lookup(cblk->elist, dst))
                               && (ptr2 = e_lookup(cblk->elist, src))) {
                              while (ptr1->pequiv)
                                 ptr1 = ptr1->pequiv;
                              while (ptr2->pequiv)
                                 ptr2 = ptr2->pequiv;
                           }
                           if (!ptr1 || !ptr2 || ptr1 != ptr2) {
                              register int j;
                              remv_link(ptr->lnks[i]->blnks, ptr);
                              remv_link(ptr->all_lnks, ptr->lnks[i]);
                              remv_link(ptr->lnks, ptr->lnks[i]);

/*
 * lets just call remv_lnk instead of trying to save a few cycles here 
 * 
			      for (j = i + 1; j <= MAXLINKS; j++)
				 if (j == MAXLINKS)
				    ptr->lnks[j - 1] = (struct list *) NULL;
				 else
				    ptr->lnks[j - 1] = ptr->lnks[j];
*/

#ifdef VET
                              mod_links(ptr);
#endif
                              i--;
                              break;
                           }
                        }
                     }
                  }
               }

               /*
                * Enter each RTL and side effect item into the CSE equivalence
                * list database for this basic block.
                */
               rtl = new;
               all_dsts_ptr = all_dsts;
               all_dsts_ptr[0] = 0;
               all_dsts_ptr[1] = 0;
               total_dsts = 0;
               while (rtl = gtrg(rtl)) {
                  if (*rtl == '=') {
                     copyloc(all_dsts_ptr, unskiploc(rtl));
                     all_dsts_ptr = skiploc(all_dsts_ptr);
                     *(all_dsts_ptr++) = 0;
                     *(all_dsts_ptr) = 0;
                     total_dsts++;
                  }
               }
               if (fmatch(new,";") && fmatch(epos,";")) {
                  old_list = newequiv();
                  e_copy(old_list, cblk->elist);
               }
               else
                  old_list = cblk->elist;

               rtl = new;
               while (rtl = gtds(rtl, dst, src))
#ifdef FIFOS
                  change |=
                   update_equivalence_table(cblk->elist, dst, src, ptr,
                                            (*rtl) ? FALSE : TRUE, all_dsts,
                                            old_list);
#else
                  change |=
                   update_equivalence_table(cblk->elist, dst, src, ptr,
                                            all_dsts, old_list);
#endif

               rtl = se;
               all_dsts_ptr = all_dsts;
               all_dsts_ptr[0] = 0;
               all_dsts_ptr[1] = 0;
               total_dsts = 0;
               while (rtl = gtrg(rtl)) {
                  if (*rtl == '=') {
                     copyloc(all_dsts_ptr, unskiploc(rtl));
                     all_dsts_ptr = skiploc(all_dsts_ptr);
                     *(all_dsts_ptr++) = 0;
                     *(all_dsts_ptr) = 0;
                  }
               }
               if (fmatch(se,";") && fmatch(epos,";")) {
                  old_list = newequiv();
                  e_copy(old_list, cblk->elist);
               }
               else
                  old_list = cblk->elist;


               rtl = se;

               while (rtl = gtds(rtl, dst, src))
#ifdef FIFOS
                  change |=
                   update_equivalence_table(cblk->elist, dst, src, ptr,
                                            (*rtl) ? FALSE : TRUE, all_dsts,
                                            old_list);
#else
                  change |=
                   update_equivalence_table(cblk->elist, dst, src, ptr,
                                            all_dsts, old_list);
#endif

               if (swd
                   && debug_opt_i_l("common_subexpression_elimination",
                                    invocation, cblk->label)) {
                  (void) fprintf(stderr, "Leaving  : ");
                  show_rtl(stderr, new);
                  (void) fprintf(stderr, "\t");
                  rshow(deadlist);
                  (void) fprintf(stderr, "\n");
                  (void) fflush(stderr);
               }

               /*
                * If we have made changes to the RTL, then update the RTL
                * structure to reflect these changes.
                */
               if (diff) {
						update_rtl(ptr,new);
#ifdef INTERACT
                  if (*se)
                     update_se(ptr, strcpy(CALLOC(strlen(se) + 1), se));
						else if (ptr->se)
                     update_se(ptr, NULL);
#else
                  if (*se) {
                     if (ptr->se)
                        if (strlen(ptr->se) < strlen(se)) {
                           FREE(ptr->se);
                           ptr->se = strcpy(CALLOC(strlen(se) + 1), se);
                        }
                        else
                           (void) strcpy(ptr->se, se);
                     else
                        ptr->se = strcpy(CALLOC(strlen(se) + 1), se);
#ifdef VET
                     mod_side(ptr);
#endif
                  }
                  else if (ptr->se) {
                     FREE(ptr->se);
                     ptr->se = (char *) NULL;
#ifdef VET
                     mod_side(ptr);
#endif
                  }
#endif
                  combmark(ptr);
                  ptr->cost = cost;
                  ptr->kind = kind;
#ifdef INTERACT
						mod_kind(ptr);
#endif
                  change = TRUE;
               }
               else if (*se && !ptr->se)
                  update_se(ptr, strcpy(CALLOC(strlen(se) + 1), se));
               ptr->type |= SIDEFFECT;
#ifdef INTERACT
					mod_type(ptr);
#endif
            }

            /*
             * If the instruction is useless, remove it from the function
             */
            else {
               remv_links(ptr);
               remv_deads(ptr);
               remv_rtl(ptr);
               change = TRUE;
            }
         }

         /*
          * This RTL line contains only a dead register list, but we still need
          * to examine it in order to determine if any registers that were set
          * were not used.
          */
         else
            change |= cse_dead_register_list(cblk->elist, ptr, ptr->val);
      }

      /*
       * Handle trash line.  A trash line is the mechanism whereby the code
       * expander can inform the CSE phase to "trash" (forget) a particular
       * variable.
       */
      else if (ptr->type & TRASHLINE) {

         /*
          * A "*" is the wild card item, which causes the CSE phase to forget
          * everything.
          */
         if (*ptr->val == '*' && !*(ptr->val + 1))
            clrequiv(cblk->elist);

         /*
          * A "@" is the normal function call item, which causes the CSE phase
          * to forget all items that contain scratch registers or memory
          * locations.
          */
         else if (*ptr->val == '@' && !*(ptr->val + 1))
            clrscratchmem(cblk->elist);

         else if ((*ptr->val == '&') && !*(ptr->val + 1))
            clrmem(cblk->elist);

         /*
          * A "#" is the utility function call item, which causes the CSE phase
          * to forget all items containing scratch register values.
          */
         else if (*ptr->val == '#' && !*(ptr->val + 1))
            clrscratch(cblk->elist);

         /*
          * Otherwise, we are to forget an individual item
          */
         else {

            /*
             * If the item to trash is a register, we also trash its old value.
             */
            if (isreg(ptr->val)) {
               mangleReg(dst, ptr->val, "*");
               strcpy(skipmangledreg(dst, "*"), skiploc(ptr->val));
               e_delete(cblk->elist, dst);
            }

            adstroy(cblk->elist, ptr->val);
         }
      }

      /*
       * Items that are reserved are implicitly set
       */
      else if (ptr->type & RESLINE) {
         if (ptr->val)
            if (ptr1 = e_lookup_reg(cblk->elist, ptr->val))
               ptr1->dead = (struct list *) NULL;
      }
      else if (ptr->type & SETLINE) 
      {

	/* look at each SETLINE in the func, destroy any expressions containing
	 * these registers 
	 */
	char *a, b[REGSTRING];
	a=ptr->val;
	assert(a);
	while(a=gtrg(a))
	{
		copyloc(b,unskiploc(a));
		*skiploc(b)=0;
		adstroy(cblk->elist, b);
	}
      }
#ifdef VET
      end_trans();
#endif
   }

   /*
    * Indicate if any changes have been made to the function
    */
   return (change);
}

/*
 * cse_dead_register_list - process a dead register list
 */
int
cse_dead_register_list(struct eqvtable *list, struct list *ptr, char *new)
{

   register char *a;
   struct eqvlist *eptr;
   int   change;
   char  reg[MAXSTRING], recal[MAXSTRING];


   change = FALSE;

   /*
    * Examine the dead register list of this RTL item by item
    */
   reget(ptr->deads, a = reg);
   while (*a) {

      /*
       * Handle register here.  Note that the dead register list can also
       * contain locals and condition codes.
       */
      if (isrg(a)) {

         /*
          * If the register is referenced in this RTL
          */
         if (ptr->val && isaliasref(ptr->val, a)) {
            if (eptr = e_lookup_reg(list, a)) {

               /*
                * If the register is dead and we know where it was set and
                * there are no uses of the register, then it looks like a good
                * thing to get rid of.
                */
               if (eptr->uses <= 0 && eptr->sets) {
                  if (backup(a, eptr->sets)) {
                     char *b;
                     change = TRUE;
                     eptr->sets = (struct list *) NULL;
                     for (b = aliases(a); *b; b = skiploc(b) + 1)
                        rdelete(b, &ptr->deads);

                     /*
                      * Since we cannot be sure that the call to backup() got
                      * rid of every set to reg, then we must assume that the
                      * recalculated value is no longer available.  It is best
                      * at this time to forget it and let a subsequent pass of
                      * the common subexpression eliminator figure out if it is
                      * still available or not.
                      */
                     mangleReg(recal, a, "*");
                     *skipmangledreg(recal, "*") = 0;
                     e_delete(list, recal);
                     adstroy(list, a);
                  }
               }

               /*
                * If there were previous uses of the register, extend the known
                * life of it by marking this RTL as the last place were it was
                * seen.
                */
               else {
                  if (eptr->dead && !dont_bother_with(eptr->item))
                     rdelete(a, &eptr->dead->deads);
                  eptr->dead = ptr;
               }
            }
         }

         /*
          * If not, there are two possibilities.  One is that the register was
          * just marking the death of a register and we should go ahead and
          * just remove it from the equivalence list.  The second, more subtle
          * (because it bit me once) reason is that this death is here because
          * the code in upduse() moved it here, in which case the item is in
          * the new, improved, replacement line and should not be removed from
          * the equivalence list.
          */
         else if (!new || !*new || !isaliasref(new, a)) {

            /*
             * Since we are getting rid of a register item from the equivalence
             * list, it is also a good idea to get rid of any recalculation
             * value that we might have for it.
             */
            mangleReg(recal, a, "*");
            *skipmangledreg(recal, "*") = 0;
            adstroy(list, recal);
            adstroy(list, a);
         }


         /*
          * Remove the death of a register that was used in the RTL before it
          * was modified and is not used now.
          */
         if (ptr->val && fmatch(ptr->val, a) && !fmatch(new, a))
            rdelete(a, &ptr->deads);
      }

      /*
       * Always destroy the status of the condition codes if they are dead
       */
      else if (is_cc(a))
         adstroy(list, a);

      a = skiplocOr2(a) + 1;
   }

   /*
    * Indicate if any changes have been made to the function
    */
   return (change);
}

/*
 * rplfast - replace item with fastest version known
 */
char *
rplfast(struct eqvtable *list, struct eqvlist *setp, char *rtl, char *a,
        char *b, char *se, int *cost, int *diff, int *kind)
{

   register struct eqvlist *eptr, *optr;
   register char *s, *r;
   struct eqvlist *bptr;
   int   best, found, blin, bkind;

   char  rpl[BIGSTRING], old[NEW_BIGSTRING],
    reg[BIGSTRING], sav[BIGSTRING], temp[BIGSTRING];

   char  cse[MAXSTRING], ose[MAXSTRING];


   /*
    * Save a copy of the current side effects and the string that we wish to
    * replace with the fastest known sequence.
    */



   (void) strcpy(ose, se);
   gtstr(a, b, rpl);


   /* Make sure we simplify the expression before searching for a
    * replacement/storing it in the equivalence table. The simplification
    * is necessary to identify addresses like R[r[0]] and R[r[0]+0] as
    * equivalent. e_lookup simply does a string compare and would treat
    * the above 2 addresses as distinct and we might miss some CSEs
    */

   simp(rpl, FALSE);

   if (old == NULL) {
      fprintf(stderr, "rplfast: Cannot allocate memory of size %d\n",
              strlen(rpl) + 1);
      exit(1);
   }


   if (!(eptr = e_lookup(list, rpl))) {

      /*
       * If we have no immediate substitution for the replacement string, see
       * if we can form a cannonical (oldest) representation of the replacement
       * string.  If not, then we return the original expression as the fastest
       * (and only known) expression.
       */

      if (!oldest(list, strcpy(old, rpl)))
         goto rplfast_end;
      /*return (b); */

      if (!(optr = e_lookup(list, old))) {

         /*
          * If a new oldest expression was constructued and its value not
          * found, then determine if it is valid on the target machine.  If it
          * is and its value is cheaper than the original expression, then
          * return it as the fastest value.
          */
         simp(old, FALSE);
         b = sub(a, b, old);
         sem_ptr = str_ptr = i_ptr = erflag = FALSE;
         side_effect = cse;
         *cse = '\0';
         linptr = temp;
         strcpy(temp, rtl);
         simp(temp, FALSE);
         icost = -1;
         ikind = 0;
         if (strlen(rtl) < MAXSTRING && !(find(curptr, linptr, deadlist))
             && ckse(ose, cse)
#ifdef FIFOS
             && ismem(rpl) == ismem(old)
#endif
          ) {
            if (icost <= *cost) {
               *cost = icost;
               *kind = ikind;
               *diff = TRUE;
               (void) strcpy(se, cse);
               goto rplfast_end;
               /*return (b); */
            }
         }
         best = *cost;
         bkind = *kind;

         /*
          * Replace each register in the expression with the fastest available
          * value for that register.
          */
         r = rpl;
         while (r = gtrgstr(r, sav)) {
            if (eptr = e_lookup_reg(list, sav)) {
               s = unskiploc(r);
               blin = TRUE;
               found = FALSE;
               for (optr = eptr; optr->pequiv; optr = optr->pequiv) ;
               for (bptr = (struct eqvlist *) NULL; optr && best;
                    optr = optr->nequiv)
                  if (optr == eptr)
                     found = TRUE;
                  else
#ifdef FIFOS
                  if (!gtfrg(optr->item))
#endif

                  {
                     if (needsparen
                         ((s == rpl) ? '[' : *(s - 1), *r, optr->item)) {
                        *reg = '(';
                        (void) strcpy(reg + 1, optr->item);
                        (void) strcat(reg, ")");
                        r = sub(s, r, reg);
                     }
                     else
                        r = sub(s, r, optr->item);
                     blin = FALSE;
                     if (strcmp(rpl, old)) {
                        sem_ptr = str_ptr = i_ptr = erflag = FALSE;
                        b = sub(a, b, rpl);
                        side_effect = cse;
                        *cse = '\0';
                        linptr = rtl;
                        strcpy(temp, rtl);
                        simp(temp, FALSE);
                        linptr = temp;
                        icost = -1;
                        ikind = 0;
                        if (strlen(rtl) < MAXSTRING
                            && !(find(curptr, linptr, deadlist))
                            && ckse(ose, cse)) {
                           if (icost < best || (!found && icost == best)) {
                              bptr = optr;
                              blin = TRUE;
                              found = TRUE;
                              best = icost;
                              bkind = ikind;
                              (void) strcpy(se, cse);
                           }
                        }
                     }
                  }
               if (!blin) {
                  if (bptr)
                     if (needsparen
                         ((s == rpl) ? '[' : *(s - 1), *r, bptr->item)) {
                        *reg = '(';
                        (void) strcpy(reg + 1, bptr->item);
                        (void) strcat(reg, ")");
                        r = sub(s, r, reg);
                     }
                     else
                        r = sub(s, r, bptr->item);
                  else
                     r = sub(s, r, sav);
                  b = sub(a, b, rpl);
               }
               if (bptr && bptr != eptr) {

#ifdef FIFOS
                  if (fiforeg(sav) && !rexists(sav, deadlist)
                      && (eptr = e_lookup_reg(list, sav)) && eptr->sets) {
                     backup(sav, eptr->sets);
                     consume(list, sav);
                  }
#endif

                  *diff = TRUE;
                  *cost = best;
                  *kind = bkind;
               }
            }
         }

#ifndef FIFOS

         /*
          * Replace each memory reference in the expression with the fastest
          * available value for that memory reference.
          */
         r = rpl;
         while (r = gtmem(r)) {
            gtstr(s = bpos, r, sav);
            if (eptr = e_lookup(list, sav)) {
               blin = TRUE;
               found = FALSE;
               for (optr = eptr; optr->pequiv; optr = optr->pequiv) ;
               for (bptr = (struct eqvlist *) NULL; optr && best;
                    optr = optr->nequiv)
                  if (optr == eptr)
                     found = TRUE;
                  else {
                     if (needsparen
                         ((s == rpl) ? '[' : *(s - 1), *r, optr->item)) {
                        *reg = '(';
                        (void) strcpy(reg + 1, optr->item);
                        (void) strcat(reg, ")");
                        r = sub(s, r, reg);
                     }
                     else
                        r = sub(s, r, optr->item);
                     blin = FALSE;
                     if (strcmp(rpl, old)) {
                        b = sub(a, b, rpl);
                        sem_ptr = str_ptr = i_ptr = erflag = FALSE;
                        side_effect = cse;
                        *cse = '\0';
                        (void) strcpy(temp, rtl);
                        simp(temp, FALSE);
                        linptr = temp;
                        icost = -1;
                        ikind = 0;
                        if (strlen(rtl) < MAXSTRING
                            && !(find(curptr, linptr, deadlist))
                            && ckse(ose, cse)) {
                           if (icost < best || (!found && icost == best)) {
                              bptr = optr;
                              blin = TRUE;
                              found = TRUE;
                              best = icost;
                              bkind = ikind;
                              (void) strcpy(se, cse);
                           }
                        }
                     }
                  }
               if (!blin) {
                  if (bptr)
                     if (needsparen
                         ((s == rpl) ? '[' : *(s - 1), *r, bptr->item)) {
                        *reg = '(';
                        (void) strcpy(reg + 1, bptr->item);
                        (void) strcat(reg, ")");
                        r = sub(s, r, reg);
                     }
                     else
                        r = sub(s, r, bptr->item);
                  else
                     r = sub(s, r, sav);
                  b = sub(a, b, rpl);
               }
               if (bptr && bptr != eptr) {
                  *diff = TRUE;
                  *cost = best;
                  *kind = bkind;
               }
            }
         }
#endif

         /*
          * Return the best expression found
          */
         goto rplfast_end;
         /*return (b); */
      }

      /*
       * If a cannonical expression was found, go back to the oldest value
       * available for it.
       */
      while (optr->pequiv)
         optr = optr->pequiv;
   }
   else {

      /*
       * If a cannonical expression was found, go back to the oldest value
       * available for it.
       */
      for (optr = eptr; optr->pequiv; optr = optr->pequiv) ;


   }

   /*
    * If the destination for this expression is a register, then form the
    * string which indicates the previous value placed in this register so that
    * we can determine if a re-calculation is taking place.
    */
   if (setp && setp->sets) {
      mangleReg(sav, setp->item, "*");
      strcpy(skipmangledreg(sav, "*"), skiploc(setp->item));
   }
   else
      *sav = '\0';

   best = *cost;
   bkind = *kind;
   blin = TRUE;
   found = FALSE;
   for (bptr = (struct eqvlist *) NULL; optr && best && optr != optr->nequiv;
        optr = optr->nequiv) {
      if (optr == eptr) {
         /* no older expressions */
         found = TRUE;
      }
      else
#ifdef FIFOS
      if (!gtfrg(optr->item))
#endif

      {
         if (strcmp(optr->item, sav))
            b = sub(a, b, optr->item);
         else {
            /* blin is set to FALSE if and only if setp->item is used in rtl */
            blin = TRUE;
            r = rtl;
            while (blin && fmatch(r, setp->item))
               if (*(r = epos) != '=' && (bpos < a || bpos > b))
                  blin = FALSE;

            if (blin
                && check_rbackup(list, setp->item, setp->item, setp->sets)) {
               /* Before setting the cost to zero, make sure the rest of the
                * RTL (incase this is a multiple-effect RTL) is valid on
                * removing this effect.
                */
               strcpy(temp, rtl);
               sub(unskiploc(a - 1), b + 1, "");
               if (!(*rtl && find(curptr, rtl, deadlist))) {
                  strcpy(rtl, temp);
                  /* No use of setp->item is found in the RHS of this RTL, 
                   * so we can backup, first we need to look for intervening 
                   * uses though. */
                  rbackup(list, setp->item, setp->item, setp->sets);
                  if (setp->pequiv)
                     setp->pequiv->nequiv = setp->nequiv;
                  if (setp->nequiv)
                     setp->nequiv->pequiv = setp->pequiv;
                  if (setp->pequiv = optr->pequiv)
                     optr->pequiv->nequiv = setp;
                  if (setp->nequiv = optr->nequiv)
                     optr->nequiv->pequiv = setp;
                  setp->sets = optr->sets;
                  setp->uses = optr->uses;
                  setp->dead = optr->dead;
                  optr->nequiv = optr->pequiv = (struct eqvlist *) NULL;
                  e_delete(list, optr->item);
                  *diff = TRUE;
                  *cost = 0;
                  *kind = 0;
                  *se = '\0';
                  return (sub(a, b, rpl));
               }
               else {
                  strcpy(rtl, temp);
               }
            }
         }

         blin = FALSE;
         sem_ptr = str_ptr = i_ptr = erflag = FALSE;
         side_effect = cse;
         *cse = '\0';
         linptr = rtl;
         icost = -1;
         ikind = 0;
         if (strlen(rtl) < MAXSTRING && !(find(curptr, linptr, deadlist))
             && ckse(ose, cse)
#ifdef FIFOS
             && ismem(rpl) == ismem(optr->item)
#endif
          ) {
            if (icost < best || (!found && icost == best)) {
               bptr = optr;
               blin = TRUE;
               found = TRUE;
               best = icost;
               bkind = ikind;
               (void) strcpy(se, cse);
            }
         }
      }
   }
   if (!blin)
      if (bptr)
         b = sub(a, b, bptr->item);
      else
         b = sub(a, b, rpl);
   if (bptr) {
      if (bptr != eptr) {
         *diff = TRUE;
         *cost = best;
         *kind = bkind;
      }
   }
 rplfast_end:
   return (b);
}

/*
 * update_equivalence_table - add a new item to an equivalence table
 */

#ifdef FIFOS
int
update_equivalence_table(struct eqvtable *list, char *new, char *old,
                         struct list *ptr, int last, char *all_dsts,
                         struct eqvtable *old_list)
#else
int
update_equivalence_table(struct eqvtable *list, char *new, char *old,
                         struct list *ptr, char *all_dsts,
                         struct eqvtable *old_list)
#endif
{
   struct eqvlist *eptr = NULL;
   char *a;
   struct eqvlist *nptr;
   struct list *dies;
   int   change, match;
   char *p1, *p2, reg[BIGSTRING], memref[BIGSTRING];
   char *alias;
   int dont_update=FALSE;

#ifdef FIFOS
   char  sav[BIGSTRING], savnew[BIGSTRING];
#endif

   assert(NULL != old);

#ifdef AUTO
   /*
    * Remove any auto-increment and auto-decrement artifacts from the RTL to
    * reveal the actual value of each item in the destination.
    */
   remauto(new);
#endif

   change = FALSE;

   /*
    * If there is no source for the new (destination) item and the old value of
    * the item was never used, then back up and remove the old value. Also, we
    * just remove the destination item from the equivalence table to indicate
    * that we no longer know what value it contains and return.
    */
   if (!*old) {
      if ((eptr = e_lookup(list, new)) && eptr->uses <= 0 && eptr->sets
          && eptr->sets != ptr) {
         if (backup(new, eptr->sets))
            change = TRUE;
         eptr->sets = FALSE;
      }
      if (isareg(new)) {
         alias = aliases(new);
         while (*alias) {
            char  reg[MAXSTRING];
            mangleReg(reg, alias, "*");
            *skipmangledreg(reg, "*") = 0;
            adstroy(list, alias);
            adstroy(list, reg);
            alias = skiploc(alias) + 1;
         }
      }
      else
         e_delete(list, new);
      return change;
   }

#ifdef AUTO

   /*
    * Remove auto-increment and decrement artifacts from each item in the
    * source expression.
    */
   remauto(old);
#endif

   /*
    * Any register which is used in the source whose re-computable value is
    * known can no longer be re-computable, so go ahead and remove its value
    * from the equivalence list.  Also, if the destination is a register and it
    * is used in the source, set match TRUE.
    */
   match = FALSE;
   a = old;
   while (a = gtrg(a)) {
      if (cmploc(new, unskiploc(a)) != 0 || !*new) {
         mangleReg(reg, unskiploc(a), "*");
         *(skipmangledreg(reg, "*")) = 0;
         e_delete(list, reg);
      }
      else
         match = TRUE;
   }



   /*
    * If there is no destination item given, or if the destination item is
    * something that CSE should not bother with, then return now without
    * bothering to enter anything in the equivalence table.
    */
   if (!*(p2 = new) || dont_bother_with(new)) {

#ifdef FIFOS

      /*
       * A fifo register value is consumed once it is used.  If there are
       * values queued up for the fifo consumed, then alter their labels to
       * move up the fifo values.
       */
      a = old;
      while (a = gtfrg(a)) {
         gtstr(unskiploc(a), a, reg);
         consume(list, reg);
      }
#endif

      return change;
   }

   /*
    * If a register is used in a memory reference then its old re-computable
    * value cannot be rescued, so go ahead and remove it from the equivalence
    * list.
    *
    * note that we need to do this, even if we dont_bother_with the old/new 
    */
   while (p2 = gtmem(p2)) {
      a = memref;
      gtstr(bpos + 2, epos - 1, a);
      while (a = gtrg(a)) {
         mangleReg(reg, unskiploc(a), "*");
         *(skipmangledreg(reg, "*")) = 0;
         e_delete(list, reg);
      }
   }

   /*
    * If the source is something that CSE should not be bothering with, then
    * remove any knowledge of the destination item from the equivalence table
    * and return at this point.
    */
   if (dont_bother_with(old)) {
      adstroy(list, new);
      if (ismem(new)) {
         a = new;
         while (a = gtmem(a)) {
            gtstr(p1 = bpos + 2, p2 = epos - 1, memref);
            if (oldest(list, memref))
               if (a > p2)
                  a = sub(p1, p2, memref) + 1;
               else
                  (void) sub(p1, p2, memref);
         }
         mem_aliases(list, new);
      }
      return change;
   }

   dies = (struct list *) NULL;

#ifdef FIFOS
   (void) strcpy(savnew, new);
   (void) strcpy(sav, old);

   /*
    * We give FIFO registers a different treatment when they are assigned a new
    * value.  If they have an old value, then the new value does not replace
    * the old one, rather, the new value is queued so that it does not become
    * the value of the fifo register until all of the queued values are
    * consumed.  In the equivalence list, there is no structure for keeping
    * track of queues, so we simulate the effect by assigning the value at the
    * head of the queue to the fifo register (let's call it f[0] for this
    * example).  The value queued behind the head of the queue is noted by the
    * label "f*0*[0]", and the one after that is "f*1*[0]" and so on.  So the
    * queued form of register f[0] is f*n*[0], where n is a number that
    * differentiates the queue order.  The following code runs through the
    * existing fifo values for a fifo register and changes the string "new" to
    * the appropriate label to queue up this assignment to the fifo register.
    */
   if (isreg(new) && fiforeg(new)) {
      if (eptr = e_lookup_reg(list, new)) {
         for (match = 0; eptr; match++) {
            (void) sprintf(memref, "%c*%d*%s", *new, match, new + 1);
            eptr = e_lookup(list, memref);
         }
         (void) strcpy(new, memref);
      }
   }
   else
#endif

      /*
       * If the destination is a register and it is not used in the source, and
       * we had an old value for the register, then save that old value because
       * we might just be re-computing what we had in the register.  The old
       * value is saved as the register string with an '*' inserted as the
       * second character.
       */

      /* match is true IFF new (the dest) is used in the source side as well */
   if (!match && isreg(new) && (eptr = e_lookup_reg(list, new))) {
      mangleReg(memref, new, "*");
      *(skipmangledreg(memref, "*")) = 0;

      if (nptr = e_insert(list, memref)) {
         nptr->sets = eptr->sets;
         nptr->uses = eptr->uses;
         /* nptr->dead = 0;  */
         nptr->dead = eptr->dead;
         if (nptr->dead == ptr)
            dies = nptr->dead;
         if (nptr->pequiv)
            nptr->pequiv->nequiv = nptr->nequiv;
         if (nptr->nequiv) {
            nptr->nequiv->pequiv = nptr->pequiv;
            nptr->nequiv = (struct eqvlist *) NULL;
         }
         while (eptr->nequiv)
            eptr = eptr->nequiv;
         eptr->nequiv = nptr;
         nptr->pequiv = eptr;
      }
   }
   /* if it's a register, we have to make sure the previous "old value" gets
    * deleted one way or another.  check here */
   else if (isreg(new) && (eptr == NULL)) {
      mangleReg(memref, new, "*");
      *(skipmangledreg(memref, "*")) = 0;
      if (nptr = e_lookup(list, memref)) {
         e_delete(list, memref);
      }
   }


   /*
    * Replace memory reference of the destination with the oldest value
    */
   a = new;
   while (a = gtmem(a)) {
      gtstr(p1 = bpos + 2, p2 = epos - 1, memref);
      /* here we need the elist from before the statement started */
      if (oldest(old_list, memref))
         if (a > p2)
            a = sub(p1, p2, memref) + 1;
         else
            (void) sub(p1, p2, memref);
   }

   /*
    * If the destination is an item that was previously set but never used,
    * then we attempt to back up and remove the previous set of the item.
    */
   if ((eptr = e_lookup(list, new)) && eptr->uses <= 0 && eptr->sets
       && eptr->sets != ptr) {


      int   ok_to_delete = TRUE;
      if (ismem(new)) {
         /* hey, we have to be careful here */
         /* if we're deleting a store we have to make sure */
         /* no intervenening loads can get in the way */

         char *new_a;
         struct list *new_lptr;
         char  new_dst[MAXSTRING], new_src[MAXSTRING];
         char  mem_str[MAXSTRING];
         for (new_lptr = eptr->sets; new_lptr && new_lptr != ptr;
              new_lptr = new_lptr->next) {
            if (new_a = cnts(new_lptr)) {
               while (new_a = gtmem(new_a)) {
                  int   cost, diff, kind;
                  /* storing here */
                  if (*new_a == '=')
                     continue;
                  gtstr(bpos, epos, mem_str);
                  if (maybe_same(mem_str, new)) {
                     ok_to_delete = FALSE;
                  }
               }
            }
         }
      }


      if (ok_to_delete) {
         if (cse_special_backup(new, eptr->sets)) {
            change = TRUE;

            /*
             * This code was added to take care of a problem that appeared to be
             * caused by the previous backup() removing code which was a part of
             * the recalculation value currently in the equivalence list.  This
             * code removes the recalculation value of that item, thus ensuring
             * that the wrong value is not left behind.
             */
            if (isreg(new)) {
               mangleReg(memref, new, "*");
               *(skipmangledreg(memref, "*")) = 0;
               e_delete(list, memref);
            }

         }
         eptr->sets = FALSE;
      }
   }


   /*
    * If the destination item is a memory location, then examine the
    * equivalence list and remove any memory locations that may be aliases.
    */
   if (ismem(new))
      mem_aliases(list, new);

   /* If 'new' has a memory reference then check if the mem ref uses
    * registers that are set in other effects ('all_dsts' contains
    * dsts from all effects). If such sets are found, then
    * we should not add this memory reference to the equivalence
    * list. Eg. w[5]=w[5]+1; W[w[5]]=1; is an rtl with two effects.
    * Without the below check, we end up with
    * W[w[5]]=1 being added to the equivalence list.
    * This is wrong, since it is actually W[w[5]-1] that is in
    * the equivalence list.
    */
   if (gtmem(new)) {
       char *a,*b;
       char *end;
       char item[MAXSTRING];

       char *new_a;
       char *alias;
       a=bpos+2;
       end=epos;

       while ((a=skiplocOr2(a)) && a<=epos && !dont_update) {
	   b=unskiploc(a);
	   if (!isRegister(b))
	       continue;
	   copyloc(item,b); 
	   new_a=all_dsts;
	   while (*new_a) {
	       if (isareg(new_a)) {
		   alias = aliases(new_a);
		   while (*alias) {
		       /* 
			* One of the destinations match
			* with one of the uses in M[expr].
			* So we cannot add M[expr] to the
			* equivalence list.
			*/
		       if (!cmploc(item, alias)) {
			   dont_update=TRUE;
			   break;
		       }
		       alias = skiploc(alias) + 1;
		   }
	       }
	       new_a = skiploc(new_a) + 1;
	   }
       }
   }

   if (dont_update) {
       /* 
	* We dont update, but we still have to remove this destination
	* from all entries in the equivalence table, since we are changing
	* the value at this destination (new).
	*/
       adstroy(list, new);
   } else  {
       /* The main purpose of the code below, is to update the 
	* equivalence table with the destination item. So we avoid
	* the update, if 'dont_update' is FALSE.
	*/

       /*
	* Obtain the oldest representaion of the destination item
	*/
       /* here we need the list from when the statement started */
       (void) oldest(old_list, old);

       /*
	* Look to see if we already have an equivalence entry for the source item
	* in the equivalence table and if the destination item is used in the
	* source expression.
	*/

   	match = FALSE;
   	{
      		char *new_a = all_dsts;
      		char *alias;
      		while (!match && *new_a) 
		{
         		if (isareg(new_a) && !pseudoreg(new_a)) 
			{
            			alias = aliases(new_a);
            			while (*alias && !match) 
				{
               				if (fmatch(old, alias))
                  				match = TRUE;
               				alias = skiploc(alias) + 1;
            			}
         		}
         		else if (fmatch(old, new_a))
            			match = TRUE;
         		new_a = skiploc(new_a) + 1;
      		}
	
      		if (!match && fmatch(old, new))
         		match = TRUE;
   	}

       if (match && (eptr = e_lookup(list, old))) {


	   /*
	    * The source and destinations may be equivalent, so we have to be a
	    * little careful about how we manipulate them.
	    */
	   if (strcmp(old, new)) {

	       /*
		* Disengage the destination item from the equivalence table.
		* Re-insert it back in so that it now has no equivalences.
		*/
	       e_delete(list, new);
	       if (nptr = e_insert(list, new)) {

		   /*
		    * Attach the destination item to the equivalence set of the source
		    * item, and remove the source item from its equivalence set.
		    */
		   nptr->nequiv = eptr->nequiv;
		   nptr->pequiv = eptr->pequiv;
		   if (nptr->pequiv)
		       nptr->pequiv->nequiv = nptr;
		   if (nptr->nequiv)
		       nptr->nequiv->pequiv = nptr;
	       }

	       eptr->nequiv = (struct eqvlist *) NULL;
	       eptr->pequiv = (struct eqvlist *) NULL;
	   }
	   else
	       nptr = eptr;

	   /*
	    * The following is a cheap trick.  It is intended to delete all
	    * equivalence list references to the destination item, which is being
	    * changed, except for the actual item that has just been inserted.  The
	    * method employed is to hide the name of the destination item so that it
	    * will not match the deletion criteria.
	    */
	   if (nptr) {
	       a = nptr->item;
	       nptr->item = "*";
	       adstroy(list, new);
	       nptr->item = a;
	   }
       }
       else
	   /*
	    * Otherwise, destroy all references that use the destination item, whose
	    * value is now changed.
	    */
	   adstroy(list, new);

       /*
	* Update the destination item's information to reflect the fact that it has
	* just been assigned at this point.
	*/
       if (nptr = e_insert(list, new)) {
	   nptr->sets = ptr;
	   nptr->dead = dies;
	   nptr->uses = 0;
       }
       /*
	* If the source item has no releation to the destination and it has not
	* already appeared before, add it to the equivalence list and note its
	* equivalence to the source.
	*/

       if (!match && (eptr = e_insert(list, old)) && nptr && eptr != nptr) {
	   while (eptr->nequiv)
	       eptr = eptr->nequiv;
	   eptr->nequiv = nptr;
	   if (nptr)
	       nptr->pequiv = eptr;
       }
   }

#ifdef FIFOS

   /*
    * A fifo register value is consumed once it is used.  If there are values
    * queued up for the fifo consumed, then alter their labels to move up the
    * fifo values.
    */
   if (last) {
      a = sav;
      while (a = gtfrg(a)) {
         gtstr(unskiploc(a), a, reg);
         consume(list, reg);
      }
      p2 = savnew;
      while (p2 = gtmem(p2)) {
         a = memref;
         gtstr(bpos + 2, epos - 1, a);
         while (a = gtfrg(a)) {
            gtstr(unskiploc(a), a, reg);
            consume(list, reg);
         }
      }
   }
#endif

   /*
    * Indicate if any changes were made to the function while updating the
    * equivalence table.
    */
   return (change);
}

#ifdef FIFOS

/*
 * consume - consume a fifo value and move any queued items up
 */
void
consume(struct eqvtable *list, char *reg)
{

   register struct eqvlist *nptr, *eptr;
   int   i;
   char  fifo[MAXSTRING];
   char  newtemp[MAXSTRING];

   if (nptr = e_lookup_reg(list, reg)) {
      i = 0;
      for (;;) {
         if (nptr->pequiv)
            nptr->pequiv->nequiv = nptr->nequiv;
         if (nptr->nequiv)
            nptr->nequiv->pequiv = nptr->pequiv;
         (void) sprintf(newtemp, "*%d*", i++);
         mangleReg(fifo, reg, newtemp);
         *(skipmangledreg(fifo, newtemp)) = 0;

         if (eptr = e_lookup(list, fifo)) {
            nptr->nequiv = eptr->nequiv;
            nptr->pequiv = eptr->pequiv;
            if (nptr->pequiv)
               nptr->pequiv->nequiv = nptr;
            if (nptr->nequiv)
               nptr->nequiv->pequiv = nptr;
            nptr->sets = eptr->sets;
            nptr->dead = eptr->dead;
            nptr->uses = eptr->uses;
            nptr = eptr;
         }
         else
            break;
      }
      nptr->nequiv = nptr->pequiv = (struct eqvlist *) NULL;
      e_delete(list, nptr->item);
   }
}

#endif

/*
 * rbackup - delete the calculation of a whole expression
 */
void
rbackup(struct eqvtable *list, char *item, char *reg, struct list *ptr)
{

   register char *b;
   register int i, found;
   register struct list *rtl;
   char  tmp[REGSTRING];
   char  newreg[REGSTRING + 2];

   /*Added by Raja */
   /* Get rid of r*[reg#] entries in the equiv table */
   mangleReg(newreg, reg, "*");
   *(skipmangledreg(newreg, "*")) = 0;
   if (strcmp(reg, item)) {
      e_delete(list, newreg);
      e_delete(list, reg);
   }
   /* end addition */
   /*
    * Examine this RTL and see if the item that we wish to remove is set here.
    */
   if ((b = ptr->val) && isset(b, reg)) {
      /* OK, it's possible we've found an RTL we can remove.    */
      /* however, "other" items may be set that we still need.  */
      /* thus, we can't get rid of those.  Look for other items */
      /* that are set, and clear found if we find one           */
      found = TRUE;
      while (*b) {
         if (*b == '=') {
            if (isreg(unskiploc(b))) {
               if (cmploc(unskiploc(b), reg) != 0) {
                  split_mertls_and_backup(list, item, reg, ptr);
                  found = FALSE;
                  return;
               }
            }
            else
               found = FALSE;

         }
         b++;
      }
   }
   else
      found = FALSE;

   /* yay, we've found an RTL worth deleteing */
   if (found) {

      /*
       * Now scan the RTL and for every register that is used here that is also
       * set or dies here, go back and remove that register.  First try to
       * follow the combiner links, but if that fails go after it by searching
       * back from the current RTL.
       */
      b = ptr->val;
      while (b = gtrgstr(b, tmp)) {
         if (*b != '=') {
            if (isset(ptr->val, tmp) || rexists(tmp, ptr->deads)) {
               found = FALSE;
               for (i = 0; i < MAXLINKS && (rtl = ptr->lnks[i]); i++)
                  if (rtl->val && isset(rtl->val, tmp)) {
                     rbackup(list, item, tmp, rtl);
                     found = TRUE;
                     break;
                  }
               if (!found) {
                  for (rtl = ptr->prev; rtl; rtl = rtl->prev)
                     if (cnts(rtl)) {
                        if (isset(rtl->val, tmp)) {
                           rbackup(list, item, tmp, rtl);
                           break;
                        }
                        if (isaliasref(rtl->val, tmp)
                            || isaliasset(rtl->val, tmp))
                           break;
                     }
                     else if (rtl->type & RESLINE && !strcmp(rtl->val, tmp))
                        break;
               }
            }
         }
      }

      /*
       * If the register that we are deleting is not the original recalculation
       * item that started this whole process, then get rid of its value in the
       * equivalence table, since we are getting rid of the set to it.
       */
      if (strcmp(item, reg))
         e_delete(list, reg);

      /*
       * Remove the RTL and any of its associated links
       */
      remv_links(ptr);
      remv_deads(ptr);
      remv_rtl(ptr);
   }


}

/*
 * backup - backup and attempt to remove the set of an item that is not used
 */
int
backup(char *item, struct list *ptr)
{

   register struct setlist *dp;
   register char *ref;
   struct list *chold;
   rlist dhold;
   char *s, *a, dst[BIGSTRING], rtl[BIGSTRING], reg[REGSTRING], se[MAXSTRING];

   /*
    * Ignore any request to delete the setting of the condition codes
    */
   if (is_cc(item))
      return (FALSE);

   /*
    * When we get here, it is because we have determined that an item set in
    * this RTL is not going to be used in the future.  It would be nice if we
    * could just delete the set and continue, but it is not quite that simple.
    * To begin with, the set might not even be in the instruction.  This is not
    * because we cannot keep track of which RTL we last saw an item set in, but
    * becuse the set could have been made as a side effect of the RTL.  The
    * next few lines attempt to find the location of the item being set in the
    * RTL.  Failing that, it exits the procedure leaving the RTL alone.  Since
    * we are going to have to mainpulate the RTL before making a final
    * determination on what we can do to it, we first make a copy of it to work
    * with.
    */
   (void) strcpy(rtl, ptr->val);
   (void) strcpy(dst, item);
   (void) strcat(dst, "=");
   if (!fmatch(rtl, dst))
      return (FALSE);

   /*
    * At this point, we know that the RTL sets the item and we have its
    * location marked by "bpos" and "epos" (as a side effect of calling
    * fmatch().  Our instincts tell us to just delete this RTL and get on with
    * it (a long time ago, this is just what this procedure did). We cannot,
    * however, because some RTLs have more than one effect. The next few lines
    * single out only the effect which sets the item and removes it (by
    * substituting the empty string for it).  Before making the substitution,
    * the effect is moved into "dst" for later use.
    */
   a = dst;
   ref = bpos;
   while ((*a++ = *ref++) != ';') ;
   *a = '\0';
   (void) sub(bpos, ref, "");

   /*
    * Now we check to see if anything remains of the RTL.  If something does,
    * then we have to ensure that what remains is a valid instruction. We have
    * to do this because there are multiple-effect RTLs that do do not
    * translate into valid target machine instructions when one of the effects
    * is removed.
    */
   if (*rtl) {

      /*
       * Since part of the RTL still remains, we must consult the machine
       * description to verify that it is a valid instruction.  We also need to
       * save the global variables that CSE sets once and assumes will be left
       * alone by everyone else (us included).
       */
      dhold = deadlist;
      deadlist = ptr->deads;
      chold = curptr;
      curptr = ptr;
      sem_ptr = str_ptr = i_ptr = erflag = FALSE;
      linptr = rtl;
      side_effect = se;
      *se = '\0';
      icost = -1;
      ikind = 0;
      if (find(curptr, linptr, deadlist) || (ptr->se && !ckse(ptr->se, se))) {
         deadlist = dhold;
         curptr = chold;
         side_effect = (char *) NULL;
         return (FALSE);
      }

      /*
       * Now that we know that the remaining RTL is still valid, we can update
       * the original structure.
       */
      set(ptr, rtl, se);
      combmark(ptr);
      deadlist = dhold;
      curptr = chold;
      side_effect = (char *) NULL;
   }
   else if (ptr->se) {

#ifdef VET
#ifdef INTERACT
		if (swq)
#endif
      strcpy(oldse, ptr->se);
#endif
      /*
       * Now we have another problem.  We have discovered that if we delete the
       * item from the RTL, that nothing remains, but we still have a side
       * effect to contend with.  The first thing that we are going to do is
       * ensure that the side effect does not contain any items that are
       * ambiguous (that is, of the form "item=;", which indicates that item is
       * set, but the value that it is set to cannot be determined). If we have
       * any such items, we can safely remove them, since, being ambiguous, we
       * are certain that they cannot have been utilized later in the
       * procedure.
       */
      ref = rtl;
      a = ptr->se;
      while (*(s = a)) {
         while (*a++ != '=') ;
		 /* If this is of the form '=item;', then 'a' now points to
		  *	s+1. This test allows us to eliminate uses.
		  */
         if (*a != ';' && a!=s+1) {
            a = s;
            while ((*ref++ = *a++) != ';') ;
         }
         else {
			 if (a==s+1)
				 while (*a++!=';');
			 else
				 a++;
		 }
      }
      *ref = '\0';

      /*
       * Now that we have removed all ambiguous sets from the side effect, we
       * look to see if anything remains.  If nothing does remain, we can
       * continue and eventually remove this RTL from the procedure.
       */
      if (*rtl) {

         /*
          * If a side effect still remains we now go ahead and see if the
          * target machine can perform the side effect as an instruction. If
          * not, then we cannot remove the original RTL, otherwise, we can
          * replace the RTL we removed with one that performs the side effect.
          * One final twist is that we must also ensure that by moving the old
          * side effects to the RTL that we do not introduce any new side
          * effects that may disturb the existing code in any way.
          */
         dhold = deadlist;
         deadlist = ptr->deads;
         chold = curptr;
         curptr = ptr;
         sem_ptr = str_ptr = i_ptr = erflag = FALSE;
         linptr = rtl;
         side_effect = se;
         *se = '\0';
         icost = -1;
         ikind = 0;
         if (find(curptr, linptr, deadlist) || *se) {
            deadlist = dhold;
            curptr = chold;
            side_effect = (char *) NULL;
            return (FALSE);
         }
         set(ptr, rtl, se);
         combmark(ptr);
         deadlist = dhold;
         curptr = chold;
         side_effect = (char *) NULL;
      }
#ifdef VET
      if (strcmp(oldse, ptr->se) != 0)
#ifdef INTERACT
			mod_side(ptr, oldse, ptr->se);			
#else
         mod_side(ptr);
#endif
#endif
   }

   /*
    * For each register that appeared in the section of the RTL that we are
    * about throw away delete any links back to this RTL that were attributed
    * only to the section (that is, they were referenced only in the section we
    * are throwing out).
    */
   ref = dst;
   while (ref = gtrgstr(ref, reg)) {
      if (dp = s_lookup(reg))
         if (dp->dead == ptr && *rtl && !fmatch(rtl, reg))
            dp->dead = (struct list *) NULL;

#ifdef FIFOS

      /*
       * If we delete a fifo register, then it's imperative that we also remove
       * the corresponding load of the register.
       */
      if (fiforeg(reg) && !*rtl)
         if (!(chold = loadof(ptr, dst, ref - 2)) || !backup(reg, chold))
            return (FALSE);
#endif
   }

   /*
    * If nothing remains of the RTL, remove the structure from the procedure.
    * Also, make sure no links remain to haunt us in the future.
    */
   if (!*rtl) {
      remv_links(ptr);
      remv_deads(ptr);
      if (!ptr->daddy->elist) {
         for (dp = setsused; dp; dp = dp->next) {
            if (dp->sets == ptr)
               dp->sets = (struct list *) NULL;
            if (dp->dead == ptr)        /*&& ptr->deads==0) */
               dp->dead = (struct list *) NULL;
         }
      }
      remv_rtl(ptr);
   }

   /*
    * Indicate that a change has been made to the RTL
    */
   return (TRUE);
}

/*
 * upduse - update the use of an expression
 */
void
upduse(struct eqvtable *list, char *lptr, struct list *ptr)
{

   char *a, *c;
   int   b;
   struct eqvlist *eptr;
   struct list *bptr;
   int   i, j;
   char  expr[BIGSTRING];
   char  oldReg[REGSTRING];

   /*
    * Update memory usage.  In order to ensure that we have the right memory
    * value, make sure that the expression has the oldest values (canonical
    * form) available.
    */
   a = lptr;
   while (a = gtmem(a)) {
      gtstr(bpos, epos, expr);
      (void) oldest(list, expr);

#ifdef AUTO
      remauto(expr);
#endif

      if (eptr = e_insert(list, expr))
         eptr->uses++;
   }

   /*
    * Now update the reference counts on each register used
    */
   c = lptr;
   while (c = gtrg(c)) {
      /* Make sure we update the use count of all aliases of this register */
      a = aliases(unskiploc(c));
      while (*a) {
         if (eptr = e_insert_reg(list, a)) {
            if (!eptr->uses++ && eptr->sets
                && ptr->daddy == eptr->sets->daddy) {

               /*
                * We have to check links to be sure that the register used here is
                * not used in any of the following RTLs.  If we use the value of a
                * register before the RTL that previously used it first, we must
                * get rid of any links that might now be unsafe.
                */
               for (i = 0; i < MAXLINKS && (bptr = eptr->sets->blnks[i]); i++) {
                  if (bptr != ptr && bptr->val) {
                     if (isref(bptr->val, eptr->item)) {
                        remv_link(bptr->lnks, eptr->sets);
                        remv_link(bptr->all_lnks, eptr->sets);
#ifdef VET
                        mod_links(bptr);
#endif

/* it's be nice to call remv_link instead of this.. however... */
                        for (j = i + 1; j <= MAXLINKS; j++) {
                           if (j == MAXLINKS)
                              eptr->sets->blnks[j - 1] = (struct list *) NULL;
                           else
                              eptr->sets->blnks[j - 1] = eptr->sets->blnks[j];
                        }
                        i--;
                     }
                  }
               }

               /*
                * If this is the first use of the register, and there is nothing
                * preventing us from linking this use to its set, then link it and
                * mark it for attention on the next combiner pass.
                */
               /*if (!set_cc(eptr->sets->val) &&
                * arequiv(list, eptr->item, eptr->sets->val) &&
                * add_link(ptr, eptr->sets))
                * combmark(ptr); */
            }

            /*
             * If there was a previous death of this register, we need to get rid
             * of it since its still in use.  If we don't set the register at the
             * current line, then we go ahead and mark the register dead at this
             * point because we have extended the life of the register to this new
             * point.  We go ahead and mark both lines for consideration by the
             * next combiner phase.
             */
            if (eptr->dead && !dont_bother_with(eptr->item)) {
               rdelete(a, &eptr->dead->deads);
               combmark(eptr->dead);
               if (!isset(ptr->val, eptr->item))
                  rinsert(a, &ptr->deads);
               combmark(ptr);
               eptr->dead = ptr;
            }
         }
         a = skiploc(a) + 1;
      }
   }



}

/*
 * adstroy - remove all references to an expression and its aliases
 */
void
adstroy(struct eqvtable *list, char *exp)
{

   register char *a;


   if (isareg(exp)) {
      for (a = aliases(exp); *a; a = skiploc(a) + 1)
         dstroy(list, a);
   }
   else
      dstroy(list, exp);
}

/*
 * arequiv - verify that the value of a register is still available
 */
int
arequiv(struct eqvtable *list, char *reg, char *rtl)
{

   register struct eqvlist *ptr, *ptr1, *ptr2;

   char *a, *b, src[BIGSTRING];


   /*
    * In order to determine that the register is still equivalent to the last
    * value that it was set to, we must first find the value that it was last
    * assigned.
    */
   if (a = isset(rtl, reg)) {
      b = src;
      while ((*b++ = *a++) != ';') ;
      *(b - 1) = '\0';
      (void) oldest(list, src);

      /*
       * Lookup the register and the canonical form of its value and ensure
       * that they are still in the same equivalence set.
       */
      if ((ptr1 = e_lookup_reg(list, reg)) && (ptr2 = e_lookup(list, src))) {
         for (ptr = ptr1; ptr; ptr = ptr->nequiv)
            if (ptr == ptr2)
               return (TRUE);
         for (ptr = ptr1->pequiv; ptr; ptr = ptr->pequiv)
            if (ptr == ptr2)
               return (TRUE);
      }
   }

   /*
    * If we cannot find the value that the register is set to, then we cannot
    * determine if it is equivalent, so make the conservative decision.
    */
   return (FALSE);
}

/*
 * oldest - replace registers with oldest expression available
 */
int
oldest(struct eqvtable *list, register char *lin)
{

   register char *a;
   register struct eqvlist *eptr;
   register int change;
   char  expr[BIGSTRING];

   change = FALSE;
   a = lin;

   /*
    * Look up each register in the expression and replace it with the oldest
    * value equivalent to that in the register.
    */
   while (a = gtrg(a)) {
      if ((eptr = e_lookup_reg(list, unskiploc(a))) && eptr->pequiv) {
         while (eptr->pequiv)
            eptr = eptr->pequiv;

#ifdef FIFOS
         if (!gtfrg(eptr->item)) {
#endif

            if (needsparen
                (((unskiploc(a)) == lin) ? '[' : *(unskiploc(a) - 1), *a,
                 eptr->item)) {
               *expr = '(';
               (void) strcpy(expr + 1, eptr->item);
               (void) strcat(expr, ")");
               a = sub(unskiploc(a), a, expr);
            }
            else
               a = sub(unskiploc(a), a, eptr->item);
            change = TRUE;

#ifdef FIFOS
         }
#endif
      }
   }

#ifdef ADDR

   /*
    * If the target machine has complex address expressions, then we have to
    * simplify the address expressions bacause we have made changes to the
    * expression.
    */
   if (change)
      simpaddr(lin);
#endif

   /*
    * Return TRUE if we have modified the original expression and FALSE if we
    * haven't.
    */
   return (change);
}

/*
 * ckse - ensure that all registers set in old side effect are set in new one
 */
int
ckse(register char *ose, char *nse)
{
   char *a,*b;
   char  reg[REGSTRING];

   /*
   while (*ose) {
      if (!is_cc(ose)) {
         a = reg;
         while ((*a++ = *ose++) != '=') ;
         *(a - 1) = '\0';
         if (!isset(nse, reg))
            return (FALSE);
      }
      while (*ose++ != ';') ;
   }
   */
    /* Every set in the new se should also
	 * be a set in the old one and vice-versa.
	 * Every use in the new se should also
	 * be a use in the old se. (but the old se
	 * could have more uses that dont appear in
	 * the new one)
	 */

   a=ose;
   while (a=gtrg(a))  {
	   b=unskiploc(a);
	   copyloc(reg,b);
	   *(skiploc(reg))=0;
	   if (*a=='=' &&  !isset(nse,reg))
		   return FALSE;
   }
   a=nse;
   while (a=gtrg(a))  {
	   b=unskiploc(a);
	   copyloc(reg,b);
	   *(skiploc(reg))=0;
	   /*
		  Disabling this test for now. Too restrictive.
		  reg is probably not-live in most cases..
	   if (*a=='=' &&  !isset(ose,reg))
		   return FALSE;
		*/

	   if (*a!='=' && !isref(ose,reg))
		   return FALSE;
   }
   return (TRUE);
}

/*
 * e_show - print out equivalence list
 */
void
e_show(struct eqvtable *list)
{

   register struct eqvlist *ptr, *sptr;


   (void) fprintf(stderr, "Equivalences -------\n");
   for (ptr = list->used; ptr; ptr = ptr->ndef)
      if (!ptr->pequiv) {
         showeqv(stderr, ptr->item);
         for (sptr = ptr->nequiv; sptr; sptr = sptr->nequiv) {
            (void) fprintf(stderr, " = ");
            showeqv(stderr, sptr->item);
         }
         (void) fprintf(stderr, "\n");
      }
   (void) fprintf(stderr, "--------------------\n");
   (void) fflush(stderr);
}

/*
 * showeqv - print out RTL in a readable format
 */
void
showeqv(FILE * fp, register char *rtl)
{
   char *mangler;
   char  c;

   while (c = *rtl)
      if (isreg(rtl)) {
         (void) fprintf(fp, "%c[%d]", regprt[regtype(rtl)], regnum(rtl));
         rtl = skiploc(rtl);
      }
      else if (isMangledReg(rtl, "*")) {        /*((c & 0xc0) == 0xc0 && *(rtl + 1) == '*' && *(rtl + 2) & 0x80) */
         char  newtemp[REGSTRING];
         demangleReg(newtemp, rtl, "*");
         (void) fprintf(fp, "%c*[%d]", regprt[regtype(newtemp)],
                        regnum(newtemp));
         rtl = skipmangledreg(rtl, "*");
      }
      else if ((mangler = isMangledReg(rtl, "*?*"))) {
         char  newtemp[REGSTRING];
         demangleReg(newtemp, rtl, mangler);
         (void) fprintf(fp, "%c%s[%d]", regprt[regtype(newtemp)], mangler,
                        regnum(newtemp));
         rtl = skipmangledreg(rtl, mangler);
      }
      else if (islocal(rtl)) {
         (void) fprintf(fp, "%s", localname(rtl));
         rtl = skiploc(rtl);
      }
      else if (isglob(rtl)) {
         (void) fprintf(fp, "%s", globalname(rtl));
         rtl = skiploc(rtl);
      }
      else {
         (void) putc(c, fp);
         rtl++;
      }
}

/*
 * remv_deads - get rid of any links to an RTL that is about to be removed
 */
void
remv_deads(register struct list *ptr)
{

   register struct eqvlist *eptr;
   register struct bblock *cblk;

   for (cblk = top; cblk; cblk = cblk->down) {
      if (cblk->elist) {
         for (eptr = cblk->elist->used; eptr; eptr = eptr->ndef) {
            if (eptr->sets == ptr)
               eptr->sets = (struct list *) NULL;
            if (eptr->dead == ptr)
               eptr->dead = (struct list *) NULL;
         }
      }
   }
}


/* First check to make sure all items that set reg will be removed. It
   all or nothing. This is to avoid a scenario like this

1   r0 = R[r1+r5];r1=r1+r5;
2   r0 = r0{24;
3   r0 = r0"28;

   CSE might decide to remove all sets of r0, but rtl #1 cannot be
   removed as it is a multi-effect rtl. Removing only 2 and 3 leaves
   us with wrong code.  To handle this case, we first check if all
   relevant rtls can be removed. If not and if there are multi-effect
   rtls, break into individual ones (if possible) and check if it'd
   work. If none of these works, the check fails and we dont do
   rbackup */


int
check_rbackup(struct eqvtable *list, char *item, char *reg, struct list *ptr)
{
   int   rval = TRUE;
   char *a, *b;
   register int i;
   register struct list *rtl;
   char  tmp[REGSTRING];

   if (ptr->val == NULL)
      return TRUE;

   if ((b = ptr->val) && isset(b, reg)) {
      /* OK, it's possible we've found an RTL we can remove.    */
      /* however, "other" items may be set that we still need.  */
      /* thus, we can't get rid of those.  Look for other items */
      /* that are set, and clear found if we find one           */
      while (*b) {
         if (*b == '=') {
            if (isreg(unskiploc(b))) {
               if (cmploc(unskiploc(b), reg) != 0) {
                  /* Multi-effect rtl. Try splitting them */
                  rval &= split_mertls_and_check(list, item, reg, ptr);
               }
            }
            else
               rval &= FALSE;

         }
         b++;
      }
   }
   else
      rval = FALSE;

   if (!rval)
      return rval;

   b = ptr->val;
   while ((b = gtrgstr(b, tmp)) && rval) {
      if (*b != '=') {
         if (isset(ptr->val, tmp) || rexists(tmp, ptr->deads)) {
            int   found = FALSE;
            for (i = 0; i < MAXLINKS && (rtl = ptr->lnks[i]) && rval; i++) {
               if (rtl->val && isset(rtl->val, tmp)) {
                  rval &= check_rbackup(list, item, tmp, rtl);
                  found = TRUE;
                  break;
               }
            }
            for (rtl = ptr->prev; rtl && rval; rtl = rtl->prev) {
               if (cnts(rtl)) {
                  if (isset(rtl->val, tmp)) {
                     rval &= check_rbackup(list, item, tmp, rtl);
                     found = TRUE;
                     break;
                  }
                  if (isaliasref(rtl->val, tmp) || isaliasset(rtl->val, tmp))
                     break;
               }
               else if (rtl->type & RESLINE && !strcmp(rtl->val, tmp))
                  break;
            }
            if (found == FALSE)
               rval = FALSE;
         }
      }
   }

   return rval;
}

/* Split multi-effect rtls if possible. Check to see if we delete one or more of the multi-effect rtls as part of backup. If we can, leave them split. Otherwise restore them */

int
split_mertls_and_check(struct eqvtable *list, char *item, char *reg,
                       struct list *ptr)
{
   int   rval = TRUE;
   char *a, *b, *e;
   char  tmp[MAXSTRING], srtl[MAXSTRING];

   /* We look at multi-effect rtls with mem ops only */

   strcpy(tmp, ptr->val);
   e = b = tmp;
   while (fmatch(b, ";")) {

      a = srtl;
      while ((*a++ = *b++) != ';') ;
      *a = 0;

      if (isset(srtl, reg)) {
         sub(e, epos, "");
         /* Remove the effect and check if the rest of the rtl is valid */
         if (find(ptr, tmp, ptr->deads))        /* Invalid  effect */
            return FALSE;

      }

      e = epos;
      b = epos;


   }

   return rval;


}

/* If we are called, we can be sure that the mutli-effect rtl can be split and rbackup can be done */

void
split_mertls_and_backup(struct eqvtable *list, char *item, char *reg,
                        struct list *ptr)
{
   struct list *rtlcopy, *newrtl, *fnew;
   int   rval = TRUE;
   char *a, *b, *e;
   char *tmp, srtl[MAXSTRING];

   /* We look at multi-effect rtls with mem ops only */

   e = tmp = b = ptr->val;
   newrtl = ptr;
   while (fmatch(b, ";")) {

      a = srtl;
      while ((*a++ = *b++) != ';') ;
      *a = 0;

      if (isset(srtl, reg)) {
         /* reg is set in the first component. */
         sub(e, epos, "");
         /* The rest of the rtl is valid (already checked) */
      }
      e = epos;
      b = epos;
   }

}


/*
 * cse_special_backup - item may be a memory that's set in ptr, but the
 * address "look" different in ptr and item.  this causes backup to fail
 * unduely.  This function addresses that by passing backup the proper item
 * to remove.  If more than one memory item is set, we bail.
 */
int
cse_special_backup(char *item, struct list *ptr)
{
   char *a;
   char *the_mem = 0;
   char  new_item[MAXSTRING];
   if (!ismem(item)) {
      return backup(item, ptr);

   }
   a = ptr->val;
   while (a = gtmem(a)) {
      if (*a == '=') {
         /* if there're 2 memory sets, we can't 
          * determine which to remove safely */
         if (the_mem) {
            return FALSE;
         }
         the_mem = bpos;
      }

   }
   if (ptr->se && gtmem(ptr->se))
      return FALSE;

   if (the_mem == 0)
      return FALSE;


   /* if we get here, we know there is only one mem item in this rtl.
    * thus, we get that item, then have backup see if we can remove it */
   gtmem(the_mem);
   gtstr(bpos, epos, new_item);

   return backup(new_item, ptr);
}

/*
 * is_copy_ins - check if the RTL is a copy RTL of the form r[i] = r[j]
 */
int is_copy_ins(struct list *rtl, char *def, char *use)
{
  char *rtlin, *c;
  struct setlist *sptr;

  rtlin = rtl->val;

  if(isreg(rtlin) && (*(rtlin=skiploc(rtlin))=='=') && isreg(rtlin+1) &&
     (*(rtlin=skiploc(rtlin+1))==';')){
    rtlin = rtl->val;
    copyreg(def, rtlin);
    rtlin = skiploc(rtlin)+1;
    copyreg(use, rtlin);


    /*verify that this rtl has no further effects*/
    rtlin = skiploc(rtlin);
    rtlin++;
    if(*rtlin)
      /*this rtl may have multiple effects. Do not handle this at present*/
      return FALSE;
    
  /*return false if rtl has side-effects*/
    if(rtl->se)
      return FALSE;
    
    return TRUE;
  }

  /*return FALSE if the rtl in not a copy rtl*/
  return FALSE;
}

/*
 * can_replace_def - The def register should not be referenced (either used
 *                   or defined) between the place of definition of r[i] and
 *                   the copy instruction. Return the place where the 'use'
 *                   register was last set
 */
struct list *can_replace_def(struct list *rtl, char *def, char *use)
{
  char *rtlin, *c;
  struct setlist *sptr;
  struct list *splace, *rtlptr;

  /*find the place the 'use' register was set. Only look in the current block*/
  splace = NULL;
  for(rtlptr=rtl->prev ; rtlptr ; rtlptr=rtlptr->prev){
    if(rtlin = cnts(rtlptr)){
      if(isreg(rtlin) && (*(rtlin=skiploc(rtlin))=='=')){
	c = unskiploc(rtlin);
	if(cmploc(c, use) == 0){
	  splace = rtlptr;
	  break;
	}
      }
    }
    else if(rtlptr->type & (RESLINE|SETLINE)){
      /*if the last place the use register was set is a RESLINE then we
	cannot remove the copy instruction, as the RESLINE cannot be
	changed*/
      if(rtlin = rtlptr->val){
	while(rtlin = gtrg(rtlin)){
	  if(cmploc(unskiploc(rtlin), use) == 0)
	    return NULL;
	}
      }
    }
  }
  
  if(splace){
      
    /*verify that the def register is not live between these two points*/
    for(rtlptr=rtl->prev ; rtlptr!=splace ; rtlptr=rtlptr->prev){
      if(rtlin = cnts(rtlptr)){
	while(rtlin = gtrg(rtlin)){
	  if(cmploc(unskiploc(rtlin), def) == 0)
	    return NULL;
	}
      }
      else if(rtlptr->type & (RESLINE|PARMLINE|SETLINE)){
	/* treat reserved items as being set,
	   treat parameter items as being used */
	if(rtlin = rtlptr->val){
	  while(rtlin = gtrg(rtlin)){
	    if(cmploc(unskiploc(rtlin), def) == 0)
	      return NULL;
	  }
	}
      }
    }
    return splace;
  }
  
  return NULL;
}

/*
 * can_replace_uses - check that the use register is dead in this block to
 *                    limit the scope of this optimization. Also verify that
 *                    the def register is not redefined before that point.
 */
struct list *can_replace_uses(struct list *rtl, char *def, char *use)
{
  char *rtlin, *c, reg[BIGSTRING];
  struct setlist *sptr;
  struct list *splace, *rtlptr;

  /*determine the place the use register dies, if in this block*/
  splace = NULL;
  for(rtlptr=rtl ; rtlptr ; rtlptr=rtlptr->next){
    
    if(cnts(rtlptr)){
      
      /*due to our implementation of the deads_detection algorithm, a value
	dead in some register is not indicated there, if the same value is also
	redefined again at the same point. The following code is to guard
	against such a case. Eg. r[12] = LA[r[12]];*/
      if((rtlin=rtlptr->val) && isreg(rtlin) && (cmploc(rtlin, use)==0)){
	if(*(c = skiploc(rtlin)) == '='){

	  /*the 'use' register is redefined at this point. If the
	    dead_variable_analysis is propoerly done, then the 'use' register
	    must also be used in this rtl, otherwise it would have appeared
	    on the dead register list of some earlier RTL. Verify this.*/
	  if(!isref(rtlptr->val, use)){
	    fprintf(stderr, "Error in can_replace_uses. Should never happen\n");
	    exit(0);
	  }
	  splace = rtlptr;
	}
      }

      /*check the dead register list*/
      reget(rtlptr->deads, reg);
      for(rtlin=reg ; *rtlin ; rtlin=skiplocOr2(rtlin)+1){
	if(isreg(rtlin) && (cmploc(rtlin, use)==0)){
	  splace = rtlptr;
	  break;
	}
      }
      
      if(splace)
	break;
    }
  }

  /*verify that the def register is not redefined between 'rtl' and 'splace'*/
  if(splace && rtl!=splace){
    for(rtlptr=rtl->next ; rtlptr!=splace ; rtlptr=rtlptr->next){
      if(rtlin = cnts(rtlptr)){
	if(isreg(rtlin) && *(rtlin=skiploc(rtlin))=='='){
	  c = unskiploc(rtlin);
	  if(cmploc(c, def) == 0)
	    return NULL;
	}
      }
      else if(rtlptr->type & (RESLINE|SETLINE)){
	/* treat reserved items as being set,
	   treat parameter items as being used */
	if(rtlin = rtlptr->val){
	  while(rtlin = gtrg(rtlin)){
	    if(cmploc(unskiploc(rtlin), def) == 0)
	      return NULL;
	  }
	}
      }
    }
  }
  
  return splace;
}


/*
 * inverse_copy_propogation - eliminate register-to-register move
 *                            instructions by replacing the use in the copy
 *                            instruction with the def
 */
int inverse_copy_propogation()
{
  char def[REGSTRING+1], use[REGSTRING+1], *rtlin, *c;
  int change, flag;
  struct bblock *cblk;
  struct list *crtl, *nrtl, *rtlptr, *splace, *eplace;
  extern struct bblock *top;

  change = FALSE;
  
  /* Optimization currently works on basic block at a time*/
  for(cblk=top ; cblk ; cblk=cblk->down){

    for(crtl=cblk->rtls ; crtl ; crtl=nrtl){
      nrtl = crtl->next;

      /* Step 1: Check if the current instruction is a copy instruction*/
      if(cnts(crtl) && is_copy_ins(crtl, def, use)){

	/* Step 2: Check if the definition of the 'use' register can be
	   replaced by the 'def' register. 
	   This can happen if there are no uses of the 'def' register between
	   the copy instruction and the definition of 'use'
	*/
	if(splace = can_replace_def(crtl, def, use)){
	  
	  /* Step 3: Check if all the uses of the 'use' register, until it
	     is dead in this block can be replaced by the 'def' register.
	     This is possible if the 'use' register dies in this block, and
	     'def' is not redefined until the death of 'use'.
	  */
	  if(eplace = can_replace_uses(crtl, def, use)){

	    /*fprintf(stderr, "Copy instruction detected:");
	      show_rtl(stderr, crtl->val);
	      fprintf(stderr, "\n");*/
	    change |= TRUE;

	    /* Step 4: Replace the 'use' register in all its uses
	       by the 'def' register between the points splace and
	       eplace. Eliminate the copy instruction. 
	    */
#ifdef INTERACT	    
	    sub(splace->val, skiploc(splace->val), def);
#ifdef VET
	    begin_trans(VET_OPT_TRANS);
#endif    
	    if(swq)
	      mod_rtl(splace, NULL, splace->val);
#ifdef VET
	    end_trans();
#endif
	    
	    for(rtlptr=splace->next ; rtlptr!=eplace->next ; rtlptr=rtlptr->next){
	      if(rtlin = cnts(rtlptr)){
		flag = FALSE;
		/*skip until the '=' symbol*/
		while(*rtlin && *rtlin != '=')
		  rtlin++;
		while(rtlin = gtrg(rtlin)){
		  rtlin = unskiploc(rtlin);
		  if(cmploc(rtlin, use) == 0){
		    sub(rtlin, skiploc(rtlin), def);
		    flag = TRUE;
		  }
		  rtlin = skiploc(rtlin);
		}
		
		if(flag && swq){
#ifdef VET
		  begin_trans(VET_OPT_TRANS);
#endif    
		  mod_rtl(rtlptr, NULL, rtlptr->val);
#ifdef VET
		  end_trans();
#endif
		}
	      }
	    }
	    
	    /*delete the copy RTL*/
#ifdef VET
	    begin_trans(VET_OPT_TRANS);
#endif    
	    backup(def, crtl);
#ifdef VET
	    end_trans();
#endif    	    
	    
#endif /*INTERACT*/	    
	  }
	}
      }
    }
  }
  return FALSE;
}
