/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/cse.h,v $
 $Date: 2002/07/11 15:20:48 $
 $Revision: 1.5 $
 $Name:  $

 Log of changes:

 $Log: cse.h,v $
 Revision 1.5  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.4  2001/09/03 16:49:52  rv3s
 Prototypes for new routines

 Revision 1.3  2001/04/13 21:49:53  jdh8d
 *** empty log message ***

 Revision 1.2  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.1  1998/04/03 16:53:34  jwd
 Initial revision

*************************************************************************/

#ifndef CSE_H
#define CSE_H


#ifdef FIFOS
/* Remember, this formal parameter set might not be right. See note in cse.c */
int 
update_equivalence_table(struct eqvtable *, char *, char *, struct list *,
                         int last, char* all_dsts, struct eqvtable *);

void 
consume(struct eqvtable *, char *);
#else
/* This one should be ok. */
int 
update_equivalence_table(struct eqvtable *, char *, char *, struct list *,
                         char* all_dsts, struct eqvtable *);
#endif

int common_subexpression_elimination(int);
int remv_common_subexpressions(struct bblock *, int);
int cse_basic_block(struct bblock *, int);
int cse_dead_register_list(struct eqvtable *, struct list *, char *);
char *rplfast(struct eqvtable *, struct eqvlist *, char *, char *, char *,
              char *, int *, int *, int *);

void rbackup(struct eqvtable *, char *, char *, struct list *);
int check_rbackup(struct eqvtable *, char *, char *, struct list *);
int split_mertls_and_check(struct eqvtable *, char *, char *, struct list *);
void split_mertls_and_backup(struct eqvtable *, char *, char *, struct list *);
int backup(char *, struct list *);
void upduse(struct eqvtable *, char *, struct list *);
void adstroy(struct eqvtable *, char *);
int arequiv(struct eqvtable *, char *, char *);
int oldest(struct eqvtable *, char *);
int ckse(char *, char *);
void e_show(struct eqvtable *);
void showeqv(FILE *, char *);
void remv_deads(struct list *);

#endif










