/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/database.h,v $
 $Date: 2002/07/11 15:20:48 $
 $Revision: 1.6 $
 $Name:  $

 Log of changes:

 $Log: database.h,v $
 Revision 1.6  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.5  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.4  2001/07/23 18:31:17  rv3s
 *** empty log message ***

 Revision 1.3  2001/04/09 16:05:23  rv3s
 New item size limit to limit the entry size in the equivalence table

 Revision 1.2  1998/04/28 20:14:57  jwd
 Included some necessary header files.
 Deleted some commented out code.

 Revision 1.1  1998/04/03 16:53:37  jwd
 Initial revision

*************************************************************************/

#ifndef DATABASE_H
#define DATABASE_H

#define ITEM_SIZE_LIMIT		200

extern struct setlist *setsused;

struct setlist *
s_add(char *);

void
remember_deaths(struct list *);

void
clrsets(void);

void
clrsetdeads(void);

struct eqvlist *
e_insert(struct eqvtable *, char *);

struct eqvlist *
e_insert_reg(struct eqvtable *, char *);

void
dstroy(struct eqvtable *, char *);

void
mem_aliases(struct eqvtable *, char *);

void
e_delete(struct eqvtable *, char *);

struct eqvlist *
e_lookup(struct eqvtable *, char *);

struct eqvlist *
e_lookup_reg(struct eqvtable *, char *);

void
clrequiv(struct eqvtable *);

struct eqvtable *
newequiv(void);

void
e_clrsets(struct eqvtable *);

void
e_copy(struct eqvtable *, struct eqvtable *);

void
e_merge(struct eqvtable *, struct eqvtable *);

void
merge_deaths(struct eqvlist *, struct eqvlist *);

void
e_invar(struct eqvtable *, struct loopl *);

void
clrscratchmem(struct eqvtable *);

void
clrmem(struct eqvtable *);

void
clrscratch(struct eqvtable *);

#endif
