/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/dataflow.c,v $
 $Date: 2004/01/21 18:39:53 $
 $Revision: 1.51 $
 $Name:  $

 Log of changes:

 $Log: dataflow.c,v $
 Revision 1.51  2004/01/21 18:39:53  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.50  2003/11/18 01:58:05  clc5q
 Make number_basic_blocks() return the number of blocks in the function,
    and make calls to it reflect the fact that it now returns an int.

 Revision 1.49  2003/07/11 20:59:10  clc5q
 If live_variable_analysis() is about to analyze locals and veclen is still
    zero, call number_basic_blocks() and number_rtls() to prepare.

 Revision 1.48  2003/04/03 20:06:10  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.47  2003/04/01 17:34:03  jdh8d
 minor remv_dead_var bug with reserve lines, effected arm-sf

 Revision 1.46  2003/03/14 01:34:20  jdh8d
 i386 bug fixes

 Revision 1.45  2003/03/12 15:35:09  jdh8d
 *** empty log message ***

 Revision 1.44  2003/03/06 16:14:18  jdh8d
 *** empty log message ***

 Revision 1.43  2003/02/15 00:09:31  clc5q
 Get rid of "extern int moreopts;" and other stupi "extern" statements and
   other sources of compiler warnings.

 Revision 1.42  2003/02/06 04:46:28  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.41  2003/01/30 02:29:10  clc5q
 Do not allow remv_dead_variables() to remove local variables that have been
    indirectly referenced, as they might only appear to be unused when they
    are actually being used through an alias.

 Revision 1.40  2003/01/07 22:40:39  clc5q
 Guard against NULL pointer dereferencing in locget() by not calling it if
    rtl->val is NULL.

 Revision 1.39  2002/11/18 19:34:01  jdh8d
 debug fixes, arm pre/post modification fixes

 Revision 1.38  2002/08/25 03:28:09  clc5q
 Integrate all code changes from Sampoorani Deivasigamani to optimize
 multiplications and divisions by integer constants.

 Revision 1.37  2002/07/11 15:22:31  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.36  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.35  2002/05/16 19:39:41  jdh8d
 some changes from Mas

 Revision 1.34  2002/02/12 16:08:34  jdh8d
 *** empty log message ***

 Revision 1.33  2002/01/01 15:37:08  rv3s
 parameter line processing in remv_dead_variables now keeps track of aliases of regs set in the paramline

 Revision 1.32  2001/11/30 17:01:47  jdh8d
 *** empty log message ***

 Revision 1.31  2001/11/27 20:34:31  rv3s
 New element lv_freq added to interference graph node to count frequency of access the way LVA expects. The freq field counts the  frequency, possibly across blobs

 Revision 1.30  2001/11/03 17:18:13  jdh8d
 *** empty log message ***

 Revision 1.29  2001/11/02 14:16:48  jdh8d
 *** empty log message ***

 Revision 1.28  2001/11/01 22:46:22  jdh8d
 *** empty log message ***

 Revision 1.27  2001/11/01 17:24:10  jdh8d
 no message

 Revision 1.26  2001/10/30 22:33:37  jdh8d
 *** empty log message ***

 Revision 1.25  2001/10/10 17:00:58  rv3s
 Restored frequency increase of same variables in a loop (in different blobs)

 Revision 1.24  2001/09/30 17:37:11  jdh8d
 *** empty log message ***

 Revision 1.23  2001/09/25 21:26:54  jdh8d
 *** empty log message ***

 Revision 1.22  2001/09/25 21:21:25  jdh8d
 *** empty log message ***

 Revision 1.21  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.20  2001/09/15 01:57:05  jdh8d
 *** empty log message ***

 Revision 1.19  2001/09/12 17:13:03  jdh8d
 *** empty log message ***

 Revision 1.18  2001/08/22 22:27:59  jdh8d
 *** empty log message ***

 Revision 1.17  2001/08/21 23:29:42  jdh8d
 *** empty log message ***

 Revision 1.16  2001/07/23 18:31:58  rv3s
 Replaced skiploc() with skiplocOr2() and copyloc() with copylocOr2 for processing register lists

 Revision 1.15  2001/06/13 15:52:51  rv3s
 Frequency of access of the same local (in different blobs in a loop) is not changed. With a new register allocation strategy (over the life time of loop), the frequency change is not required

 Revision 1.14  2001/06/05 18:55:38  jdh8d
 *** empty log message ***

 Revision 1.13  2001/05/23 20:28:20  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.12  2001/04/24 14:40:35  rv3s
 Modified build_interference_graph to give preference (increase frequency) of local variables in a loop that are accessed more than once.

 Revision 1.11  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.10  2001/03/30 02:10:51  jdh8d

 Disallowed removal of sets to volatile variables.

 Revision 1.9  2000/10/18 02:27:03  jwd
 Made the size of some character arrays BIGSTRING instead of MAXSTRING.

 Revision 1.8  2000/06/09 19:19:37  jwd
 Treat parameter lines as uses in terms of dataflow.

 Revision 1.7  2000/03/15 16:24:21  jwd
 Modified live_variable_analysis so that when dealing with sets and uses
 of a hardware register, it also does the same action for the aliases of the registers.
 This is important.  For example, on machines where the fp registers can be
 accessed as doubles and as single precision (d[2] and f[2]/f[3]) if d[2] is set,
 we must record that f[2]/f[3] were set also.
  
 Revision 1.6  1999/11/11 21:30:03  jwd
 Added parameter to begin_trans to indicate whether the transformation
 is required or not.
 Revision 1.5  1999/01/06 15:45:47  jwd
 Added VET directives.
 Revision 1.4  1998/04/28 20:15:50  jwd
 Included machine-dependent file regs2.h.
 Revision 1.3  1998/04/03 18:19:13  jwd
 First ANSI C version.

*************************************************************************/

#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "vpo.h"
#include "assign.h"
#include "combine.h"
#include "cse.h"
#include "database.h"
#include "dataflow.h"
#include "links.h"
#include "locals.h"
#include "misc.h"
#include "vectors.h"
#include "vpo2.h"

#include "rtl.h"        /* Machine Dependent */
#include "regs2.h"      /* Machine dependent */

#ifdef VET
#include "view.h"
#endif

/*
 * This file contains functions that analyze and optimize the data flow
 * of procedures.
 */

/*--------------History of Changes---------------------
  1/9/98:  Took ANSI C function prototypes and utilized them, adding header
           file references and removing local scope prototypes.
------------------------------------------------------------*/


/*
 * live_variable_analysis - perform live variable analysis on the function
 */
void
live_variable_analysis(int invocation, int locals, int delay_slots)
{

   register char *rtlin;
   register struct setlist *sptr;
   register int rtnum;
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct locuse *ptr;
   struct setlist *dptr[MAXRTS];
   struct blist *bptr;
   int   change, type, ind, lset;
   char *c, reg[BIGSTRING];

#ifdef VET
#ifdef INTERACT
	if (started_phase == 0)
		 begin_phase(REG_ALLOCATION_TRANS);
#else
   begin_phase(REGASSIGN_PHASE);
#endif
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_live_variable_analysis", invocation))
      dump_function_i("before live_variable_analysis()", invocation,
                      SHOW_LABELS | SHOW_DFS | SHOW_NONRTLS | SHOW_SE);

   /*
    * Clear out any previous register set and use information
    */
   clrsets();

   /*
    * If we are to include locals in the analysis, clean out the old local
    * variable information.
    */
   if (locals) {
      clean_locals();
      /* If veclen is 0, we will want to call number_rtls() before we
       * hit the call to vinsert() below.
       */
      if (0 == veclen) {
         (void) number_basic_blocks();
         number_rtls();
      }
   }
   /*
    * Examine every block in the function
    */
   for (cblk = top; cblk; cblk=cblk->down){

     /*
       * Release any previous data-flow information on this basic block
       */
      rfree(cblk->dlist);
      rfree(cblk->ulist);
      rfree(cblk->olist);
      cblk->dlist = rinit();
      cblk->ulist = rinit();
      cblk->olist = rinit();

      /*
       * If instructions have been moved into delay slots
       */
      if (delay_slots) {

         /*
          * If this basic block has predecessors, check to see if any of them
          * end with RTLs in delay slots that really belong to this basic
          * block. If they do, then treat them as if they were present at the
          * start of this basic block.  For a description of what is done with
          * the RTL, see the comments below for the RTLs found in the basic
          * block itself. Note that both "delay_slot" and "locals" flags are
          * never expected to be TRUE during the same invocation of this
          * function.
          */
         for (bptr = cblk->preds; bptr; bptr = bptr->next) {
            if (bptr->ptr->rtlend && (bptr->ptr->rtlend->type & RTLINE)
                &&
                ((((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == TAKEN)
                  && bptr->ptr->right == cblk)
                 ||
                 (((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == NOTAKEN)
                  && bptr->ptr->left == cblk))) {
               if (rtlin = bptr->ptr->rtlend->val) {
                  rtnum = 0;
                  while (rtlin = gtrg(rtlin)) {
                     sptr = s_add(unskiploc(rtlin));
                     if (*rtlin == '=')
                        dptr[rtnum++] = sptr;
                     else if (!sptr->sets)
                        sptr->uses = TRUE;
                  }
                  if (rtlin = bptr->ptr->rtlend->se) {
                     while (rtlin = gtrg(rtlin)) {
                        sptr = s_add(unskiploc(rtlin));
                        if (*rtlin == '=')
                           dptr[rtnum++] = sptr;
                        else if (!sptr->sets)
                           sptr->uses = TRUE;
                     }
                  }
                  while (rtnum--) {
                     sptr = dptr[rtnum];
                     sptr->sets = bptr->ptr->rtlend;
                     if (!sptr->uses)
                        sptr->assign = TRUE;
                  }
               }
            }
         }
      }

      /*
       * Examine each RTL in the current basic block.  Note which items are
       * defined by the basic block, which items are used, and which items are
       * defined before they are used.
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

#ifdef FILL

         /*
          * If this RTL is in a delay slot and it will execute only if the
          * conditional branch that it follows takes a specific path, then
          * don't consider this RTL as belonging to this basic block.
          */
         if (((rtlptr->kind & (TAKEN | NOTAKEN)) == TAKEN)
             || ((rtlptr->kind & (TAKEN | NOTAKEN)) == NOTAKEN))
            continue;
#endif

         if (rtlptr->type & RTLINE) {

            /*
             * If the RTL has an effect, examine the sets and uses of it
             */
            if (rtlin = rtlptr->val) {

               /*
                * We must have complete side effect information to perform
                * accurate live-variable analysis for locals.
                */
               if (locals && !(rtlptr->type & SIDEFFECT)) {
                  side_effect = reg;
                  *reg = '\0';
                  if (find(rtlptr, rtlin, rtlptr->deads)) {
                     (void) fprintf(stderr,
                                    "vpo (live_variable_analysis): cannot assemble ");
                     show_rtl(stderr, rtlin);
                     (void) fprintf(stderr, "\n");
                  }
                  else {
#ifdef VET
		    begin_trans(VET_REQUIRED_TRANS);
#endif							
                     rtlptr->cost = icost;
                     rtlptr->kind = ikind;
#ifdef INTERACT
		     mod_kind(rtlptr);
#endif							
                     if (*reg)
		       update_se(rtlptr, strcpy(CALLOC(strlen(reg) + 1), reg));
                     rtlptr->type |= SIDEFFECT;
#ifdef VET
#ifdef INTERACT
		     mod_type(rtlptr);
#endif							
                     /*
                      * Send it to VET because type has changed.
                      * Side_effect is global variable and "find"
                      * sets it and therefore *reg is changed
                      * causing rtlptr->se to be set.
                      */
                     end_trans();
#endif
                  }
                  side_effect = (char *) NULL;
               }

               /*
                * Now look at all of the register items in the RTL.  Those that
                * set, are remembered until all of the uses have been looked
                * at. If a register is used before it has been defined in the
                * basic block, then the "uses" flag is set TRUE for that
                * register. The side effect line is checked along with the
                * regular RTL effect.
                */
               rtnum = 0;
               while (rtlin = gtrg(rtlin)) {
                  sptr = s_add(unskiploc(rtlin));
                  if (*rtlin == '=')
                     dptr[rtnum++] = sptr;
                  else if (!sptr->sets)
                     sptr->uses = TRUE;
               }
               if (rtlin = rtlptr->se) {
                  while (rtlin = gtrg(rtlin)) {
                     sptr = s_add(unskiploc(rtlin));
                     if (*rtlin == '=')
                        dptr[rtnum++] = sptr;
                     else if (!sptr->sets)
                        sptr->uses = TRUE;
                  }
               }

               /*
                * Examine line for local references if the kind field of the
                * RTL indicates that a local reference is likely and locals are
                * to be included in this analysis.  Here we also remember where
                * locals are referenced and if a local is referenced
                * indirectly.
                */
               if (locals && rtlptr->kind & LOCREF) {
                  c = rtlptr->val;
                  while (locget(&c, reg, &type, &ind, &lset, rtlptr)) {
                     sptr = s_add(reg);
                     if (lset)
                        dptr[rtnum++] = sptr;
                     else if (!sptr->sets)
                        sptr->uses = TRUE;
                     ptr = sptr->local;
                     vinsert(&ptr->olist, rtlptr->onum);
                     if (ind)
                        ptr->nouse = ptr->indref = TRUE;

                     /*
                      * Add this reference to the estimated variable reference
                      * count. Keep the list sorted by estimated reference
                      * count.
                      */
                     ptr->reps += (cblk->freq << 4) + 1;
#ifdef INTERACT
		     begin_trans(VET_OPT_TRANS);
		     update_locuse(ptr);
		     end_trans();
#endif

                     reorder_local(ptr);
                  }
               }

               /*
                * Now remember where each item was set.  Also, if the item is
                * not used before it is first set, then it is placed in the
                * define list by setting the "assign" flag to TRUE.
                */
               while (rtnum--) {
                  sptr = dptr[rtnum];
                  sptr->sets = rtlptr;
                  if (!sptr->uses)
                     sptr->assign = TRUE;
               }
            }
         }

         /*
          * If this is a reserve line, then treat the item as a set
          */
         else if (rtlptr->type & RESLINE) {
               sptr = s_add(rtlptr->val);
               sptr->sets = rtlptr;
               if (!sptr->uses)
                  sptr->assign = TRUE;
         }

         /*
          * If this is a set line, then treat the item as a set
          */
         else if (rtlptr->type & SETLINE) {
            for (rtlin = rtlptr->val; *rtlin; rtlin = skiplocOr2(rtlin)) {
               sptr = s_add(rtlin);
               sptr->sets = rtlptr;
               if (!sptr->uses)
                  sptr->assign = TRUE;
            }
         }

         /*
          * If this is a parameter line, then treat the item as uses
          */
         else if (rtlptr->type & PARMLINE) {
            for (rtlin = rtlptr->val; *rtlin; rtlin = skiploc(rtlin)) {
               sptr = s_add(rtlin);
               if (!sptr->sets)
                  sptr->uses = TRUE;
            }
         }
      }

      /*
       * Now set the use and def vectors with the information that was
       * collected for each item examined in the basic block.
       */
      for (sptr = setsused; sptr; sptr = sptr->next) {
         sptr->sets = (struct list *) NULL;
         if (sptr->uses) {
            rins(sptr->num, &cblk->ulist);
            sptr->uses = FALSE;
         }
         if (sptr->assign) {
            rins(sptr->num, &cblk->dlist);
            sptr->assign = FALSE;
         }
      }
   }

   /*
    * Perform the iterative algorithm for live variable analysis.  Use the
    * reverse depth-first-search basic block order to minimize the number of
    * iterations required.
    */
   change = FALSE;
   for (cblk = bottom; cblk; cblk = cblk->prev_dfs) {
      cblk->status |= DONE;
      if (cblk->right)
         runion(&cblk->olist, cblk->right->ulist);
      if (cblk->left)
         runion(&cblk->olist, cblk->left->ulist);
      if (runiond(&cblk->ulist, cblk->olist, cblk->dlist))
         change = TRUE;
   }
   while (change) {
      rtnum = change = FALSE;
      for (cblk = bottom; cblk; cblk = cblk->prev_dfs) {
         if (cblk->right && cblk->right->status & DONE) {
            rtnum = TRUE;
            runion(&cblk->olist, cblk->right->ulist);
         }
         if (cblk->left && cblk->left->status & DONE) {
            rtnum = TRUE;
            runion(&cblk->olist, cblk->left->ulist);
         }
         if (rtnum) {
            if (runiond(&cblk->ulist, cblk->olist, cblk->dlist)) {
               cblk->status |= DONE;
               change = TRUE;
            }
            else
               cblk->status &= ~DONE;
            rtnum = FALSE;
         }
         else
            cblk->status &= ~DONE;
      }
   }

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_live_variable_analysis", invocation))
      dump_function_i("after live_variable_analysis()", invocation,
                      SHOW_LABELS | SHOW_DFS | SHOW_USE | SHOW_DEF | SHOW_OUT
                      | SHOW_NONRTLS | SHOW_SE);
#ifdef VET
#ifdef INTERACT
   if (started_phase == REG_ALLOCATION_TRANS)
     end_phase(REG_ALLOCATION_TRANS);	
#else
   end_phase(REGASSIGN_PHASE);
#endif
#endif
}

/*
 * build_minimal_ssa_form - build the minimal static single assignment form
 */
void
build_minimal_ssa_form(int invocation)
{

   register char *rtlin;
   register struct setlist *sptr;
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr, *dptr;
   struct phi *pphi, *dphi;
   struct phi_list *pphil, *dphil;
   struct defnode *pdef, *ddef;
   int   work;

   /*
    * The purpose of this function is to build the static single assignment
    * form for the current function.  In order to perform this task correctly,
    * this function assumes that the live variable analysis and dominance
    * frontier information for the current function have been calculated and
    * are up-to-date.
    */

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_build_minimal_ssa_form", invocation))
      dump_function_i("before build_minimal_ssa_form()", invocation,
                      SHOW_LABELS | SHOW_PREDS | SHOW_USE | SHOW_OUT |
                      SHOW_DOM | SHOW_FRONTIER | SHOW_NONRTLS | SHOW_SE);

   /*
    * Clear the register and local item list so that we can create a list of
    * all of the items that we need to include in the static single assignment
    * form.
    */
   clrsetdeads();

   /*
    * Loop through every basic block in the function and build a list of items
    * that are assigned within each basic block.  Also, for each item, build a
    * list of basic blocks in which the item is assigned.
    */
   for (cblk = top; cblk; cblk = cblk->next) {

      /*
       * Throw away any previous SSA information
       */
      pphi = cblk->phi_funcs;
      while (pphi) {
         pphil = pphi->sets;
         while (pphil) {
            dphil = pphil;
            pphil = pphil->next;
            FREETYPE(dphil, PHILISTTYPE);
         }
         dphi = pphi;
         pphi = pphi->next;
         FREETYPE(dphi, PHITYPE);
      }
      cblk->phi_funcs = (struct phi *) NULL;
      pdef = cblk->sets_out;
      while (pdef) {
         ddef = pdef;
         pdef = pdef->next;
         FREETYPE(ddef, DEFNODETYPE);
      }
      cblk->sets_out = (struct defnode *) NULL;

      /*
       * Indicate that no variable item has been processed in this basic block
       */
      cblk->bnum = 0xffff;

      /*
       * Loop through all of the lines in the basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

         /*
          * If it is a register transfer line with some effects (note that some
          * RTLs have only a dead register list).
          */
         if (rtlin = cnts(rtlptr)) {

            /*
             * Scan the register transfer and note which register items are set
             * in this basic block.  Specifically, we wish to remember the last
             * RTL in which the item was set.
             */
            while (*rtlin) {
               if (isrg(rtlin)) {

                  /*
                   * Obtain a pointer to the register information structure for
                   * this register.  Add one if none exists.
                   */
                  sptr = s_add(rtlin);
                  sptr->sets = rtlptr;
               }

               /*
                * Skip to the next effect in this RTL
                */
               while (*rtlin++ != ';') ;
            }

            /*
             * If the line has a side effect, then process the side effect list
             * as well.
             */
            if (rtlin = rtlptr->se) {
               while (*rtlin) {
                  if (isrg(rtlin)) {
                     sptr = s_add(rtlin);
                     sptr->sets = rtlptr;
                  }
                  while (*rtlin++ != ';') ;
               }
            }
         }

         /*
          * If this is a reserve line, then the register is definitely set
          */
         else if (rtlptr->type & RESLINE) {
            if (*(skiploc(rtlptr->val)) == '=') {
               sptr = s_add(rtlptr->val);
               sptr->sets = rtlptr;
            }
         }

         /*
          * If this is a set line, then the register is definitely set
          */
         else if (rtlptr->type & SETLINE) {
            for (rtlin = rtlptr->val; *rtlin; rtlin = skiplocOr2(rtlin)) {
               sptr = s_add(rtlin);
               sptr->sets = rtlptr;
            }
         }
      }

      /*
       * Calculate the list of definitions that reach the end of this basic
       * block because they are generated by the basic block.  This is
       * basically a pointer to the last RTL which sets each item set within
       * the basic block.  Here, we need to keep track only of the items that
       * will be used in the future.
       */
      for (sptr = setsused; sptr; sptr = sptr->next) {
         if (sptr->sets) {
            if (rin(sptr->num, cblk->olist)) {

               /*
                * Build a list for this basic block indicating which items are
                * set in the basic block and which RTL contains the set whose
                * definition reaches the end of the basic block.
                */
               pdef =
                (struct defnode *) SALLOCTYPE(sizeof(struct defnode),
                                              DEFNODETYPE);
               pdef->next = cblk->sets_out;
               pdef->item = sptr;
               pdef->set_rtl = sptr->sets;
               cblk->sets_out = pdef;

               /*
                * Add this basic block to the list of basic blocks in which
                * this item is assigned a value.
                */
               bptr =
                (struct blist *) SALLOCTYPE(sizeof(struct blist), BLISTTYPE);
               bptr->next = sptr->setin;
               bptr->ptr = cblk;
               sptr->setin = bptr;
            }

            sptr->sets = (struct list *) NULL;
         }
      }
   }

   /*
    * Now we can go ahead and place the phi functions in the function by
    * looking at every item that was set and placing a phi function at the set
    * of basic blocks in the dominance frontier of every block that contains an
    * assignment to the variable.
    */
   for (sptr = setsused; sptr; sptr = sptr->next) {
      if (bptr = sptr->setin) {

         /*
          * Initialize the work set for each basic block in the set of basic
          * blocks that this item is assigned a value in.  The variable "work"
          * keeps track of how many basic blocks are currently in the work set.
          */
         work = 0;
         while (bptr) {
            bptr->ptr->bnum = sptr->num;
            bptr->ptr->status &= ~DONE;
            bptr->ptr->status |= UNDONE;
            work++;

            /*
             * We can get rid of the assignment set item at this point
             */
            dptr = bptr;
            bptr = bptr->next;
            FREETYPE(dptr, BLISTTYPE);
         }

         sptr->setin = (struct blist *) NULL;

         /*
          * While there are items left in the work set, locate the next item
          */
         cblk = top;
         while (work) {
            do {
               cblk = (cblk->next) ? cblk->next : top;
            } while (!(cblk->status & UNDONE));

            /*
             * Remove this basic block from the work set
             */
            cblk->status &= ~UNDONE;
            work--;

            /*
             * Now we have to place a phi function at every basic block in this
             * block's dominance frontier and add each of these blocks to the
             * work set, provided that they have not already been placed in the
             * work set for this item.
             */
            for (bptr = cblk->dom_front; bptr; bptr = bptr->next) {

               /*
                * If this item is not live at the entry point of the basic
                * block in the dominance frontier, then there is no need to
                * place a phi function for this item here.
                */
               if (!rin(sptr->num, bptr->ptr->ulist))
                  continue;

               /*
                * If we have not yet considered this basic block while
                * processing this item, initialize it to indicate that we have
                * now seen it and it has been placed in the work set and has
                * not had a phi function placed at the begining.
                */
               if (bptr->ptr->bnum != sptr->num) {
                  bptr->ptr->bnum = sptr->num;
                  bptr->ptr->status &= ~DONE;
                  bptr->ptr->status |= UNDONE;
                  work++;
               }

               /*
                * If we have not yet placed phi function at this basic block,
                * then we go ahead and do so.  Note that since we are building
                * the minimal SSA form, that we do not fill in the phi function
                * with the assignments that it collects.
                */
               if (!(bptr->ptr->status & DONE)) {
                  bptr->ptr->status |= DONE;
                  pphi =
                   (struct phi *) SALLOCTYPE(sizeof(struct phi), PHITYPE);
                  pphi->next = bptr->ptr->phi_funcs;
                  pphi->item = sptr;
                  pphi->sets = (struct phi_list *) NULL;
                  bptr->ptr->phi_funcs = pphi;
               }
            }
         }
      }
   }

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_build_minimal_ssa_form", invocation))
      dump_function_i("after build_minimal_ssa_form()", invocation,
                      SHOW_LABELS | SHOW_PREDS | SHOW_USE | SHOW_OUT |
                      SHOW_SETS | SHOW_PHI | SHOW_FRONTIER | SHOW_NONRTLS |
                      SHOW_SE);
}

/*
 * remv_dead_variables - remove dead variable sets and clean up dead registers
 */
int remv_dead_variables(int invocation, int locals, int remv_sets)
{

   char *rtlin;
   struct list *rtlptr;
   struct setlist *sptr;
   int   rtnum;
   struct bblock *cblk;
   struct setlist *dptr[MAXRTS];
   rlist live;
   int   alter, change, type, ind, lset;
   char *c, reg[BIGSTRING], loc[BIGSTRING];
   extern int i_s_count;

#ifdef VET
#ifdef INTERACT
   begin_phase(DEAD_ASG_ELIM_TRANS);
#else
   if (!moreopts)
      return FALSE;
   begin_phase(DEADVARELIM_PHASE);

#endif

#endif

   if (swd && debug_opt("no_remv_dead_variables"))
      return FALSE;
   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_remv_dead_variables", invocation))
      dump_function_i("before remv_dead_variables()", invocation,
                      SHOW_LABELS | SHOW_NONRTLS | SHOW_SE | SHOW_USE |
                      SHOW_OUT);

   /*
    * Initialize a vector to keep track of live items
    */
   live = rinit();

   /*
    * Examine each basic block in the function
    */
   alter = FALSE;
   for (cblk = top; cblk; cblk = cblk->down) {

#ifdef VET
      begin_trans(VET_OPT_TRANS);
#endif
      do {

         /*
          * Initially, the only items that are live at the entry point of the
          * basic block are those that are in the block's "use" list.
          */
         change = FALSE;
         rcpy(&live, cblk->ulist);
         clrsetdeads();

         /*
          * Examine only the RTL lines in the basic block
          */
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
	   if (rtlptr->type & RTLINE) {

               /*
                * Examine the RTL and its side effects.  Note which items are
                * set and which items are used in each RTL.
                */
               rtnum = 0;
               if (rtlin = rtlptr->val) {
                  while (rtlin = gtrg(rtlin)) {
                     if (pseudoreg(c = unskiploc(rtlin))) {
                        if (sptr = s_lookup(c)) {
                           if (*rtlin == '=')
                              dptr[rtnum++] = sptr;
                           else {
                              sptr->sets = (struct list *) NULL;
                              sptr->dead = rtlptr;
                           }
                        }
                     }
                     else {
                        for (c = aliases(unskiploc(rtlin)); *c;
                             c = skiploc(c) + 1) {
                           if (sptr = s_lookup(c)) {
                              if (*rtlin == '=')
                                 dptr[rtnum++] = sptr;
                              else {
                                 sptr->sets = (struct list *) NULL;
                                 sptr->dead = rtlptr;
                              }
                           }
                        }
                     }
                  }
                  if (rtlin = rtlptr->se) {
                     while (rtlin = gtrg(rtlin)) {
                        if (sptr = s_lookup(unskiploc(rtlin))) {
                           if (*rtlin == '=')
                              dptr[rtnum++] = sptr;
                           else
                              sptr->sets = sptr->dead = (struct list *) NULL;
                        }
                     }
                  }
                  if (locals && rtlptr->kind & LOCREF) {
                     c = rtlptr->val;
                     while (locget(&c, reg, &type, &ind, &lset, rtlptr)) {
                        if (sptr = s_lookup(reg)) {
                           if (lset)
                              dptr[rtnum++] = sptr;
                           else {
                              sptr->sets = (struct list *) NULL;
                              sptr->dead = rtlptr;
                           }
                        }
                     }
                  }
               }

               /*
                * Examine the dead register list of the RTL.  If something dies
                * and was not used since the last set, then attempt to back up
                * and remove that item.
                */
               reget(rtlptr->deads, reg);
	       for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)  {
		 if (!is_cc(rtlin) && (sptr = s_lookup(rtlin)))  {
		   if (isrg(rtlin))  {
		     
		     /* if it's dead and we can backup, do so */
		     if (remv_sets && sptr->sets && backup(sptr->item, sptr->sets)) {
		       alter = change = TRUE;
		       sptr->sets = (struct list *) NULL;
		       sptr->dead = NULL;
		       rdel(sptr->num, &rtlptr->deads);
		     }
		     /* otherwise, if we know where it was last used, 
			move the death indicator to there */
		     else if (sptr->dead && !rin(sptr->num, sptr->dead->deads)) 
		       {
			 /* if we're inserting it somewhere, we better 
			    remove it from this dead list */
			 rdel(sptr->num, &rtlptr->deads);
			 rins(sptr->num, &sptr->dead->deads);
			 combmark(sptr->dead);
			 /*
			   sptr->dead = rtlptr;
			 */
		       }
		     sptr->sets = (struct list *) NULL;
		   }
		   else 
		     {
		       sptr->dead = rtlptr;
		       if (remv_sets && locals)
			 rdel(sptr->num, &rtlptr->deads);
		     }
		   rdel(sptr->num, &live);
		 }
		 
	       }
               /*
                * Now go back and look at those items that were set in the RTL
                */
               while (rtnum--) {
                  sptr = dptr[rtnum];
                  if (sptr->local) {
                     localref(loc, sptr->local);
                     if (remv_sets && sptr->sets && backup(loc, sptr->sets))
                        alter = change = TRUE;
                     if (sptr->dead && sptr->dead != rtlptr)
                        rins(sptr->num, &sptr->dead->deads);
                     if (!sptr->local->nouse)
                        sptr->sets = rtlptr;
                  }
                  else {
                     if (remv_sets && sptr->sets && backup(sptr->item, sptr->sets))
                        alter = change = TRUE;
                     if (sptr->dead && sptr->dead != rtlptr
                         && !rin(sptr->num, sptr->dead->deads)) {
                        if (cnts(sptr->dead)
                            && isref(sptr->dead->val, sptr->item)) {
                           rins(sptr->num, &sptr->dead->deads);
                           combmark(sptr->dead);
                        }
                     }
                     if (!(sptr->status & FIFOREG))
                        sptr->sets = rtlptr;
                  }
                  sptr->dead = (struct list *) NULL;
                  rins(sptr->num, &live);
               }
            }

            /*
             * Treat reserved items as being set, but don't remember where,
             * since we cannot delete this kind of a set even if it is dead.
             */
            else if (rtlptr->type & RESLINE) {
               if (rtlptr->val && (sptr = s_lookup(rtlptr->val)))
                  sptr->sets = sptr->dead = (struct list *) NULL;

		/* if this is pre-local_reg_assign, then we need to "use" the rhs of this actual rtl */
               if(*skiploc(rtlptr->val)=='=' && (sptr = s_lookup(skiploc(rtlptr->val)+1)))
                  sptr->sets = sptr->dead = (struct list *) NULL;
            }
            /*
             * Treat parameter items as being used
             */
            else if (rtlptr->type & PARMLINE) {
               char *a;
               rtlin = rtlptr->val;
               while (rtlin = gtrg(rtlin))
                  for (a = aliases(unskiploc(rtlin)); *a; a = skiploc(a) + 1)
                     if (sptr = s_lookup(a))
                        sptr->sets = sptr->dead = (struct list *) NULL;
            }
            else if (rtlptr->type & SETLINE) {
               char *a;
               rtlin = rtlptr->val;
               while (*rtlin) {
                  if (isRegister(rtlin))
                     for (a = aliases(rtlin); *a; a = skiploc(a) + 1) {
                        if (sptr = s_lookup(a)) {
                           if (remv_sets && sptr->sets && backup(sptr->item, sptr->sets))
                              alter = change = TRUE;
                           if (sptr->dead && sptr->dead != rtlptr
                               && !rin(sptr->num, sptr->dead->deads)) {
                              rins(sptr->num, &sptr->dead->deads);
                              combmark(sptr->dead);
                           }

                           sptr->dead = (struct list *) NULL;
                           rins(sptr->num, &live);
                        }
                     }
                  else {
                     a = rtlin;
                     if (sptr = s_lookup(a)) {
                        if (remv_sets && sptr->sets && backup(sptr->item, sptr->sets))
                           alter = change = TRUE;
                        if (sptr->dead && sptr->dead != rtlptr
                            && !rin(sptr->num, sptr->dead->deads)) {
                           rins(sptr->num, &sptr->dead->deads);
                           combmark(sptr->dead);
                        }

                        sptr->dead = (struct list *) NULL;
                        rins(sptr->num, &live);
                     }
                  }
                  rtlin = skiplocOr2(rtlin);
               }
	       
	       
            }
	 }

         /*
          * If an item is still live at the end of a basic block, but it is not
          * used in any of the basic block's children, then if it was not used
          * its last set can be deleted.  If used, then perhaps we need to mark
          * the death of the register on the dead variable list of its last
          * use.
          */
         reget(live, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
            if (sptr = s_lookup(rtlin)) {
               if (sptr->local) {
		 if (!rin(sptr->num, cblk->olist)) {
		   if (sptr->sets) {
		     localref(loc, sptr->local);
		     /* Whoa, Nelly!  Don't get rid of this if it's a
		      * volatile or indirectly referenced local!
		      */
		     if (!sptr->local->vol && !sptr->local->indref)
		       if (remv_sets && backup(loc, sptr->sets))
			 alter = change = TRUE;
		   }
		   else if (sptr->dead)
		       rins(sptr->num, &sptr->dead->deads);
		 }
		 sptr->sets = sptr->dead = (struct list *) NULL;
	       }
               else {
                  if (!raliasin(sptr->item, cblk->olist)) {
		    if (sptr->sets) {
		      if (remv_sets && backup(sptr->item, sptr->sets))
			alter = change = TRUE;
		    }
		    else if (sptr->dead
			     && !rin(sptr->num, sptr->dead->deads)) {
		      rins(sptr->num, &sptr->dead->deads);
		      combmark(sptr->dead);
		    }
		    sptr->sets = sptr->dead = (struct list *) NULL;
                  }
               }
            }
         }
	 
         /*
          * If an item was marked on a dead variable list, but it is still
          * alive, then we remove it from the dead variable list since the
          * obituary was premature.
          */

          /* 
	   * note that this code is attempting to fix up a problem
	   * in the rtls.  A variable should never be dead, but 
	   * live out of a block.  if it occurs, it's an error
	   */
         reget(cblk->olist, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
            if ((sptr = s_lookup(rtlin)) && (rtlptr = sptr->dead)
                && rin(sptr->num, rtlptr->deads)) {

#if 0
		/* we'd like to say this is an error... however
		 * phases tend to do this :( and it's hard to 
		 * fix them
		 */
		assert(0);
#endif
#if 1
               rdel(sptr->num, &rtlptr->deads);
               combmark(rtlptr);
               sptr->dead = (struct list *) NULL;
#endif
            }
         }
      } while (change);
#ifdef VET
      end_trans();
#endif
   }
#ifdef VET
#ifdef INTERACT
   end_phase(DEAD_ASG_ELIM_TRANS); 	
#else
   end_phase(DEADVARELIM_PHASE);
#endif
#endif

   /*
    * Release the vector used to maintain live variable information
    */
   rfree(live);

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_remv_dead_variables", invocation))
      dump_function_i("after remv_dead_variables()", invocation,
                      SHOW_LABELS | SHOW_NONRTLS | SHOW_SE | SHOW_USE |
                      SHOW_OUT);

   /*
    * Indicate if any changes have been made to the function
    */
   return (alter);
}

/*
 * build_interference_graph - build the interference graph for the function
 */
void
build_interference_graph()
{

   char *rtlin;
   struct list *rtlptr;
   struct ignode *ptr, *ptr1;
   struct setlist *sptr;
   int   rtnum;
   struct bblock *cblk;
   struct ignode *ptr2;
   struct setlist *dptr[MAXRTS];
   rlist live;
   int   type, ind, lset, tptr[MAXRTS];
   char *c, reg[BIGSTRING], reg1[BIGSTRING];

   /*
    * Allocate a vector to maintain live variable information
    */
   live = rinit();

   for (cblk = top; cblk; cblk = cblk->down) {

      /*
       * On entry to a block, live variables are those in the in list for the
       * basic block.
       */
      rcpy(&live, cblk->ulist);

      /*
       * Determine which local variables are live at the entry point of this
       * basic block.
       */
      cblk->conin = (struct ignode *) NULL;
      reget(cblk->ulist, reg);
      for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
         if ((sptr = s_lookup(rtlin)) && sptr->local && !sptr->local->nouse) {
            sptr->local->conptr = ptr = newignode(sptr);
            if (ptr->conin = ptr->conout = cblk->conin)
               cblk->conin->conprev = ptr;
            cblk->conin = ptr;
            ptr->ptr = cblk;
         }

      /*
       * All live registers conflict with all live locals at this point
       */
      cblk->conout = cblk->conin;
      for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
         if (isrg(rtlin))
            for (ptr = cblk->conout; ptr; ptr = ptr->conout)
               touchreg(ptr->regs, rtlin);

      /*
       * Indicate that all locals live at the start of the basic block conflict
       * with each other.
       */
      for (ptr2 = cblk->conout; ptr2; ptr2 = ptr2->conout)
         for (ptr = cblk->conout; ptr; ptr = ptr->conout)
            if (ptr != ptr2)
               iconflict(ptr2, ptr);

      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         if (rtlptr->type & RTLINE) {
            rtnum = 0;

            /*
             * Search through each RTL for set and uses of locals
             */
            if ( (rtlptr->kind & LOCREF) && (NULL != rtlptr->val)) {
               c = rtlptr->val;
               while (locget(&c, reg, &type, &ind, &lset, rtlptr)) {
                  if (sptr = s_lookup(reg)) {
                     if (lset) {
                        tptr[rtnum] = type;
                        dptr[rtnum++] = sptr;
                     }
                     else if (sptr->local && (ptr = sptr->local->conptr)) {
                        struct list *rtlptr1;
                        if (!(ptr->status & ISSET))
                           ptr->status |= ISUSED;
                        if (!ptr->start)
                           ptr->start = rtlptr;
                        ptr->end = rtlptr;
                        if ((ptr->type = checktype(ptr->type, type)) == NOTYPE) {
			  sptr->local->nouse = TRUE;
#ifdef INTERACT
			  begin_trans(VET_OPT_TRANS);
			  update_locuse(sptr->local);
			  end_trans();
#endif
								}

                        if (!(rtlptr->type & ARGLINE)) {
                           ptr->freq += (cblk->freq << 4) + 1;
                           ptr->lv_freq += (cblk->freq << 4) + 1;
                        }
                        /* If we are in a loop, peek forward to see if the 
			   local var is set/used anywhere in the block */
                        /* we aren't doing this anymore because it's taken
                         * care of during coloring... and it's way expensive too */

                        if (cblk->loop && !ptr->loop_peeking_done) {
                           char *c1;
                           int   type1, ind1, lset1;
                           for (rtlptr1 = rtlptr->next; rtlptr1;
                                rtlptr1 = rtlptr1->next) {
                              if (!(rtlptr1->kind & LOCREF))
                                 continue;
                              c1 = rtlptr1->val;
                              bzero((void *) reg1, 50);
                              while (locget
                                     (&c1, reg1, &type1, &ind1, &lset1,
                                      rtlptr1)) {
                                 if (!strcmp(reg, reg1))
                                    if (sptr = s_lookup(reg1))
                                       if (lset1
                                           || (sptr->local
                                               && sptr->local->conptr)) {

                                          ptr->freq += cblk->freq << 4 + 1;
                                       }
                              }

                           }



                        }
                        ptr->loop_peeking_done = 1;

                     }
                  }
               }
            }

            /*
             * Examine the dead variable list
             */
            reget(rtlptr->deads, rtlin = reg);
            for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
               if (!is_cc(rtlin) && (sptr = s_lookup(rtlin))) {
                  if (isrg(rtlin))
                     rdel(sptr->num, &live);
                  else if (sptr->local && (ptr = sptr->local->conptr)) {
                     if (ptr->conout)
                        ptr->conout->conprev = ptr->conprev;
                     if (ptr->conprev)
                        ptr->conprev->conout = ptr->conout;
                     else
                        cblk->conout = ptr->conout;
                     ptr->conout = (struct ignode *) NULL;
                     sptr->local->conptr = (struct ignode *) NULL;
                  }
               }
            }

            /*
             * Go back and look at the locals that are set in this RTL
             */
            while (rtnum--) {
               sptr = dptr[rtnum];
               if (sptr->local && !sptr->local->nouse) {
                  if (!(ptr = sptr->local->conptr)) {
                     sptr->local->conptr = ptr = newignode(sptr);
                     for (ptr2 = cblk->conout; ptr2; ptr2 = ptr2->conout) {
                        iconflict(ptr, ptr2);
                        iconflict(ptr2, ptr);
                     }
                     if (ptr->conout = cblk->conout)
                        cblk->conout->conprev = ptr;
                     cblk->conout = ptr;
                     ptr->ptr = cblk;
                     ptr->start = rtlptr;
                     reget(live, reg);
                     for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
                        if (isrg(rtlin))
                           touchreg(ptr->regs, rtlin);
                  }
                  ptr->status |= ISSET;
                  if (!ptr->start)
                     ptr->start = rtlptr;
                  ptr->end = rtlptr;
                  if ((ptr->type = checktype(ptr->type, tptr[rtnum])) == NOTYPE) {
							sptr->local->nouse = TRUE;
#ifdef INTERACT
							begin_trans(VET_OPT_TRANS);
							update_locuse(sptr->local);
							end_trans();
#endif
						}		
                  if (!(rtlptr->type & ARGLINE)) {
                     ptr->freq += (cblk->freq << 4) + 1;
                     ptr->lv_freq += (cblk->freq << 4) + 1;
                  }
               }
            }

            /*
             * Now look at the registers that are set in this RTL
             */
            if (rtlin = rtlptr->val) {
               while (*rtlin) {
                  if (isrg(rtlin) && (sptr = s_lookup(rtlin))) {
                     if (!rin(sptr->num, live)) {
                        rins(sptr->num, &live);
                        for (ptr = cblk->conout; ptr; ptr = ptr->conout)
                           touchreg(ptr->regs, sptr->item);
                     }
                  }
                  while (*rtlin++ != ';') ;
               }
               if (rtlin = rtlptr->se) {
                  while (*rtlin) {
                     if (isrg(rtlin) && (sptr = s_lookup(rtlin))) {
                        if (!rin(sptr->num, live)) {
                           rins(sptr->num, &live);
                           for (ptr = cblk->conout; ptr; ptr = ptr->conout)
                              touchreg(ptr->regs, sptr->item);
                        }
                     }
                     while (*rtlin++ != ';') ;
                  }
               }
            }
         }

         else if (rtlptr->type & RESLINE) {
            if (!rexists(rtlptr->val, live)) {
               rinsert(rtlptr->val, &live);
               for (ptr = cblk->conout; ptr; ptr = ptr->conout)
                  touchreg(ptr->regs, rtlptr->val);
            }
         }

         else if (rtlptr->type & SETLINE) {
            for (rtlin = rtlptr->val; *rtlin; rtlin = skiploc(rtlin))
               for (ptr = cblk->conout; ptr; ptr = ptr->conout)
                  touchreg(ptr->regs, rtlin);
         }
      }

      /*
       * Remove the pointer from the local information structure to the current
       * life "blob" for each local item that is still live.
       */
      for (ptr = cblk->conout; ptr; ptr = ptr->conout)
         if (ptr->item->local && ptr->item->local->conptr)
            ptr->item->local->conptr = (struct ignode *) NULL;
   }

   /*
    * Release vector holding live information
    */
   rfree(live);

   arg_lifes();

   merge_blobs();
}

/*
 * merge_blobs - merge "blobs" of lifes together
 */
void
merge_blobs()
{

   register struct ignode *ptr, *ptr2, *ptr3;
   register struct blist *bptr;
   register struct bblock *cblk;

   /*
    * Visit every block to join "blobs" of lifes together to those that are
    * related.
    */
   for (cblk = top; cblk; cblk = cblk->down) {
      for (bptr = cblk->preds; bptr; bptr = bptr->next) {

         /*
          * Examine each item in the in list of this basic block and attempt to
          * merge it with a corresponding out item in each of the predecessors
          * of this basic block.
          */
         for (ptr2 = cblk->conin; ptr2; ptr2 = ptr2->conin) {

            /*
             * Look for an item in the out list of the predecessor of the block
             * that matches the current item.
             */
            for (ptr = bptr->ptr->conout; ptr && ptr->item != ptr2->item;
                 ptr = ptr->conout) ;

            /*
             * If an item is found, then add the current item to the list of
             * related siblings provided that it is not already there.
             */
            if (ptr) {
               for (ptr3 = ptr->nsib; ptr3 != ptr && ptr3 != ptr2;
                    ptr3 = ptr3->nsib) ;
               if (ptr3 != ptr2) {
                  ptr2->psib->nsib = ptr->nsib;
                  ptr->nsib->psib = ptr2->psib;
                  ptr->nsib = ptr2;
                  ptr2->psib = ptr;
               }
            }
         }
      }
   }
}

/*
 * arg_lifes - if arguments come from the stack, then shorten argument lifes
 */
void
arg_lifes()
{

   register struct ignode *ptr, *ptr2;
   register struct setlist *sptr;
   register char *rtlin;
   struct ignode *ptr3;
   struct conflict *cptr, *fptr;
   struct bblock *cblk;
   struct list *nptr;
   char  reg[MAXSTRING];

   /*
    * Examine the lives of all of the locals that are live at the entry point
    * of the function.  These locals are either arguments (that are used before
    * they are defined) or locals that can potentially be used before they are
    * defined.
    */
   ptr2 = top->conin;
   while (ptr2) {

      /*
       * If the item is an argument whose value enters the function in a
       * register, then permit its life to extend to the entry point of the
       * function regardless of its use pattern.
       */
      sptr = ptr2->item;
      if (sptr->local->arg && regarg(sptr->local)) {
         ptr2 = ptr2->conin;
         continue;
      }

      /*
       * Mark all blocks as unvisited
       */
      for (cblk = top; cblk; cblk = cblk->down)
         STATUS(cblk, UNDONE);

      /*
       * Mark all blocks where the current item is actually live as DONE
       */
      for (cblk = top; cblk; cblk = cblk->down) {
         if (cblk->status & UNDONE) {
            for (ptr = cblk->conin; ptr && ptr->item != sptr;
                 ptr = ptr->conin) ;
            if (ptr && ptr->freq) {
               usearch(ptr, cblk);
               continue;
            }
            for (ptr = cblk->conout; ptr && ptr->item != sptr;
                 ptr = ptr->conout) ;
            if (ptr && ptr->freq)
               usearch(ptr, cblk);
         }
      }

      /*
       * Examine the life(s) and determine which blocks should contain the
       * loads of the arguments.
       */
      (void) lcsearch(ptr2, top);
      ptr2 = ptr2->conin;

      for (cblk = top; cblk; cblk = cblk->down) {

         /*
          * A block is marked DORMANT if the item does not have to be in a
          * register at this block (even if it is live).  This would be true if
          * we can put off loading it into a register until a later time. In
          * this case we can remove the "blob" of life for this item at this
          * basic block.
          */
         if (cblk->status & DORMANT) {
            for (ptr = cblk->conin; ptr && ptr->item != sptr;
                 ptr = ptr->conin) ;
            if (ptr)
               remvignode(ptr);
         }

         /*
          * A block is marked WAITING if the item should be loaded into a
          * register before it is first used.
          */
         else if (cblk->status & WAITING) {

            /*
             * Locate the life at the start of the basic block.  Remember its
             * parent in the list, so that we can easily remove the life from
             * the linked list.
             */
            ptr3 = (struct ignode *) NULL;
            for (ptr = cblk->conin; ptr && ptr->item != sptr;
                 ptr = ptr->conin)
               ptr3 = ptr;
            if (ptr) {

               /*
                * If the item is an argument, then it must be loaded before its
                * first use, otherwise, it is a local that is used before it is
                * set and loading it won't make a bit of good.
                */
               if (sptr->local->arg)
                  ptr->status |= MUSTLOAD;

               /*
                * If this block is not marked DONE, then the value loaded will
                * not be used in the block itself, so the load is placed at the
                * end of the block instead of the beginning.  Since the current
                * conflict information is based on the whole block, we will be
                * able to do a better job of allocating this variable if we
                * recalculate the interference graph information so that this
                * item conflicts only with items live at the very end of the
                * basic block where the load will be placed.
                */
               if (!(cblk->status & DONE)) {

                  /*
                   * First, we forget the registers that this item cannot be
                   * allocated to and re-compute them.  Since the item will we
                   * live only at the very end of the basic block, then only
                   * those register that are live at the end of the basic block
                   * conflict with this item.
                   */
                  mrfree(ptr->regs);
                  ptr->regs = regnew();
                  reget(cblk->olist, reg);
                  for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
                     if (isrg(rtlin))
                        touchreg(ptr->regs, rtlin);
                  }

                  /*
                   * If this basic block ends with a relational jump, then this
                   * will prevent a conflict with the registers that are used
                   * to generate the status of the condition codes.  Also, on
                   * some machine it is possible to have memory references in
                   * compare instructions, so we will use "nptr" to remember
                   * the value of any conflicting RTL so that we can scan it
                   * for locals later.
                   */
                  nptr = (struct list *) NULL;
                  if (cnts(cblk->rtlend) && is_rjmp(cblk->rtlend->val)) {
                     reget(cblk->rtlend->deads, reg);
                     for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
                        if (isrg(rtlin))
                           touchreg(ptr->regs, rtlin);
                     }
                     if (nptr = cblk->rtlend->prev) {
                        reget(nptr->deads, reg);
                        for (rtlin = reg; *rtlin;
                             rtlin = skiplocOr2(rtlin) + 1) {
                           if (isrg(rtlin))
                              touchreg(ptr->regs, rtlin);
                        }
                     }
                  }

                  /*
                   * Otherwise, if the block ends in a case statement, then
                   * this code will prevent a conflict with the register that
                   * carries the switch value.
                   */
                  else if ((nptr = cblk->rtlend) && nptr->val
                           && is_pc(nptr->val)) {
                     reget(nptr->deads, reg);
                     for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1) {
                        if (isrg(rtlin))
                           touchreg(ptr->regs, rtlin);
                     }
                  }
                  if (nptr && !(nptr->kind & LOCREF))
                     nptr = (struct list *) NULL;

                  /*
                   * Remove all conflicts with the other locals that are live
                   * in this block, but are not live at the exit point of the
                   * block. Also, if the load of the item is not at the very
                   * end of the block because of a condition code set or switch
                   * table lookup, then ensure that we still conflict with any
                   * local used in the relevant RTL.
                   */
                  cptr = ptr->conflicts;
                  while (cptr) {
                     fptr = cptr->next;
                     if (!rin(cptr->ptr->item->num, cblk->olist))
                        if (!nptr
                            || !fmatch(nptr->val, cptr->ptr->item->item))
                           dconflict(ptr, cptr->ptr);
                     cptr = fptr;
                  }

                  /*
                   * We also remove it from the live item list at the start of
                   * the basic block but leave it alone at the end.
                   */
                  if (ptr3)
                     ptr3->conin = ptr->conin;
                  else
                     cblk->conin = ptr->conin;
                  ptr->conin = (struct ignode *) NULL;
               }
            }
         }
      }
   }
}

/*
 * lcsearch - mark blocks suitable to load an argument
 */
int
lcsearch(register struct ignode *ptr, register struct bblock *cblk)
{

   register struct ignode *ptr2;
   register struct blist *bptr;
   int   status;

   /*
    * The purpose of this routine is to perform a type of depth-first-search of
    * the flow-graph while marking each basic block encountered in a fashion
    * which permits us to determine where the most advantageous places to load
    * arguments allocated to registers are.  The problem is that since the
    * value of an argument comes from outside of the procedure, the life of an
    * argument extends all of the way up to the entry block of the function.
    * Since arguments are often passed on the stack and are available at any
    * point of the function directly from the activation record, it makes more
    * sense to delay the initial load of the argument into a register until we
    * are close to the place where the argument is first needed.  In order to
    * ensure that we only perform the load once, we must avoid placing the
    * initial load of the argument in any block that is part of a loop. The job
    * of this procedure is to mark those blocks that must contain the load of a
    * register with the initial argument value as WAITING. In the course of the
    * search blocks will be marked as follows:
    * 
    * UNDONE    If a block is marked UNDONE, it means that the block has not yet
    * been visited and its actual status is undetermined.
    * 
    * DONE      If a block is marked DONE, it means that the block must have the
    * value of the argument loaded some time before the block is executed.
    * 
    * WAITING   A block that is marked WAITING must contain a load of the
    * argument's value into a register.  Such a block will never belong to a
    * loop.  It might, however, also be a DONE block!
    * 
    * DORMANT   A block that is marked DORMANT has alrady been examined and it has
    * been determined that such a block does not need to contain a load of the
    * argument since there is no path between it and any DONE block that is not
    * already marked as WAITING.
    * 
    * DRYRUN    A block that is marked DRYRUN has a path to a DONE block that does
    * not go through a WAITING block and would itself have been marked as a
    * WAITING block except for the fact that it is inside a loop and therefore
    * not suitable for containing the load of the argument.
    */
   if (cblk->status & DONE) {
      if (cblk->status & WAITING)
         return (FALSE);
      if (cblk->freq || (cblk->rtlend && cblk->rtlend->type & CASELINE))
         return (TRUE);
      for (bptr = cblk->preds; bptr && !(bptr->ptr->status & DONE);
           bptr = bptr->next) ;
      if (bptr)
         return (TRUE);
      cblk->status |= WAITING;
      return (FALSE);
   }
   status = FALSE;
   STATUS(cblk, DORMANT);
   if (cblk->left)
      if (cblk->left->status & (UNDONE | DONE)) {
         for (ptr2 = cblk->left->conin; ptr2 && ptr2->item != ptr->item;
              ptr2 = ptr2->conin) ;
         if (ptr2)
            if (lcsearch(ptr2, cblk->left))
               status = TRUE;
      }
      else if (cblk->left->status & DRYRUN)
         status = TRUE;
   if (cblk->right)
      if (cblk->right->status & (UNDONE | DONE)) {
         for (ptr2 = cblk->right->conin; ptr2 && ptr2->item != ptr->item;
              ptr2 = ptr2->conin) ;
         if (ptr2)
            if (lcsearch(ptr2, cblk->right))
               status = TRUE;
      }
      else if (cblk->right->status & DRYRUN)
         status = TRUE;
   if (status)
      if (cblk->freq || (cblk->rtlend && cblk->rtlend->type & CASELINE))
         STATUS(cblk, DRYRUN);
      else {
         STATUS(cblk, WAITING);
         status = FALSE;
      }
   return (status);
}

/*
 * usearch - mark all blocks where argument register must be available
 */
void
usearch(register struct ignode *ptr, register struct bblock *cblk)
{

   register struct ignode *ptr2;

   /*
    * This procedure is called when a basic block is encountered that has a use
    * of an argument.  A depth-first-search of the flow-graph is done starting
    * from that block and going on to mark all of the blocks that the argument
    * is then live in.
    */
   STATUS(cblk, DONE);
   if (cblk->left)
      if (cblk->left->status & UNDONE) {
         for (ptr2 = cblk->left->conin; ptr2 && ptr2->item != ptr->item;
              ptr2 = ptr2->conin) ;
         if (ptr2)
            usearch(ptr2, cblk->left);
      }
   if (cblk->right)
      if (cblk->right->status & UNDONE) {
         for (ptr2 = cblk->right->conin; ptr2 && ptr2->item != ptr->item;
              ptr2 = ptr2->conin) ;
         if (ptr2)
            usearch(ptr2, cblk->right);
      }
}

/*
 * simple_strength_reduction - replace expensive operations with cheaper ones
 */
int
simple_strength_reduction(int invocation)
{

   register struct list *rtlptr;
   register char *rtlin;
   struct bblock *cblk;
   vector regs;
   int   change;
   char  reg[MAXSTRING];

#ifdef VET
#ifdef INTERACT
	begin_phase(STRENGTH_REDUCT_TRANS);	
#else
   begin_phase(CHEAPERINST_PHASE);
#endif
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd
       && debug_opt_i("dump_before_simple_strength_reduction", invocation))
      dump_function_i("before simple_strength_reduction()", invocation,
                      SHOW_LABELS | SHOW_USE | SHOW_NONRTLS | SHOW_SE);

   /*
    * Operate on each basic block individually
    */
   change = FALSE;
   for (cblk = top; cblk; cblk = cblk->down) {

      /*
       * At the entry point of the basic block, all live registers are not
       * available for allocation.
       */
      regs = regnew();
      reget(cblk->ulist, reg);
      for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
         if (isrg(rtlin))
            touchreg(regs, rtlin);

      /*
       * Examine each RTL line in the basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
			if (rtlptr->type & RTLINE
#ifdef INTERACT
					&& (!swq || !limited_scope || cblk->inscope)
#endif
				) {				

            /*
             * Items marked dead can be released
             */
            reget(rtlptr->deads, reg);
            for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
               if (isrg(rtlin))
                  releasereg(regs, rtlin);

            /*
             * Check to see if we can change constant multiplies
             */
            rtlptr = multconst(&change, rtlptr, regs);

            /*
             * Check to see if we can change divisions by constants 
             */
            rtlptr = divconst(&change, rtlptr, regs);

            /*
             * Items set are unavailable for allocation
             */
            if (rtlin = rtlptr->val) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
            if (rtlin = rtlptr->se) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
         }

         /*
          * Treat a reserve line as a set
          */
         else if (rtlptr->type & RESLINE)
            touchreg(regs, rtlptr->val);
      }

      mrfree(regs);
   }

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_simple_strength_reduction", invocation))
      dump_function_i("after simple_strength_reduction()", invocation,
                      SHOW_LABELS | SHOW_USE | SHOW_NONRTLS | SHOW_SE);

#ifdef VET
#ifdef INTERACT
   end_phase(STRENGTH_REDUCT_TRANS);	
#else
   end_phase(CHEAPERINST_PHASE);
#endif
#endif
   /*
    * Indicate if any changes have been made to the function
    */
   return (change);
}

/*
 * live_regs - returns the current live register state at the indicated RTL
 */
vector
live_regs(struct bblock * cblk, struct list * ptr)
{

   struct list *rtlptr;
   char *rtlin;
   vector regs;
   char  reg[MAXSTRING];

#ifdef FILL
   struct blist *bptr;
#endif

   /*L
    * Start with a register allocation vector that indicates which registers
    * are live at the start of the basic block.
    */
   regs = regnew();
   reget(cblk->ulist, reg);
   for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
      if (isrg(rtlin))
         touchreg(regs, rtlin);

#ifdef FILL

   /*
    * If there are any delay slots in a previous block that belong to this
    * block, then we must consider those items as being here.
    */
   for (bptr = cblk->preds; bptr; bptr = bptr->next) {
      if (bptr->ptr->rtlend && (bptr->ptr->rtlend->type & RTLINE)
          &&
          ((((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == TAKEN)
            && bptr->ptr->right == cblk)
           || (((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == NOTAKEN)
               && bptr->ptr->left == cblk))) {

         /*
          * Items marked dead can be released
          */
         reget(bptr->ptr->rtlend->deads, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
            if (isrg(rtlin))
               releasereg(regs, rtlin);

         /*
          * Items set are unavailable for allocation
          */
         if (rtlin = bptr->ptr->rtlend->val) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
         if (rtlin = bptr->ptr->rtlend->se) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
      }
   }
#endif

   /*
    * Examine each RTL line in the basic block until we arrive at the RTL
    * indicated.
    */
   for (rtlptr = cblk->rtls; rtlptr && rtlptr != ptr; rtlptr = rtlptr->next) {
      if (rtlptr->type & RTLINE) {

#ifdef FILL

         /*
          * If the next item following RTL is in the delay slot of this RTL,
          * then look at it first.
          */
         if (rtlptr->next && (rtlptr->next->type & RTLINE)
             && (rtlptr->next->kind & (TAKEN | NOTAKEN))) {

            /*
             * Items marked dead can be released
             */
            reget(rtlptr->next->deads, reg);
            for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
               if (isrg(rtlin))
                  releasereg(regs, rtlin);

            /*
             * Items set are unavailable for allocation
             * 
             */
            if (rtlin = rtlptr->next->val) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
            if (rtlin = rtlptr->next->se) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
         }

         /*
          * If this item is in a delay slot, then we have already considered
          * its effect, so we skip it here.
          */
         if (rtlptr->kind & (TAKEN | NOTAKEN))
            continue;
#endif

         /*
          * Items marked dead can be released
          */
         reget(rtlptr->deads, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
            if (isrg(rtlin))
               releasereg(regs, rtlin);

         /*
          * Items set are unavailable for allocation
          */
         if (rtlin = rtlptr->val) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
         if (rtlin = rtlptr->se) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
      }

      /*
       * Treat a reserve line as a set
       */
      else if (rtlptr->type & RESLINE)
         touchreg(regs, rtlptr->val);
   }

   return (regs);
}

#ifdef INTERACT
/*
 * live_regs2 - returns the current live register state at the indicated RTL
 *              (similar to live_regs, but uses rveclen instead of mrveclen)
 */
vector
live_regs2(struct bblock * cblk, struct list * ptr)
{
   unsigned int *ptr1, *end;
   struct list *rtlptr;
   char *rtlin;
   rlist regs;
   char  reg[MAXSTRING];

#ifdef FILL
   struct blist *bptr;
#endif

   /*L
    * Start with a register allocation vector that indicates which registers
    * are live at the start of the basic block.
    */
   regs = (rlist) (ptr1 = RALLOC);
   for (end = ptr1 + rveclen; ptr1 != end; *ptr1++ = 0);
   reget(cblk->ulist, reg);
   for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
      if (isrg(rtlin))
         touchreg(regs, rtlin);

#ifdef FILL

   /*
    * If there are any delay slots in a previous block that belong to this
    * block, then we must consider those items as being here.
    */
   for (bptr = cblk->preds; bptr; bptr = bptr->next) {
      if (bptr->ptr->rtlend && (bptr->ptr->rtlend->type & RTLINE)
          &&
          ((((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == TAKEN)
            && bptr->ptr->right == cblk)
           || (((bptr->ptr->rtlend->kind & (TAKEN | NOTAKEN)) == NOTAKEN)
               && bptr->ptr->left == cblk))) {

         /*
          * Items marked dead can be released
          */
         reget(bptr->ptr->rtlend->deads, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
            if (isrg(rtlin))
               releasereg(regs, rtlin);

         /*
          * Items set are unavailable for allocation
          */
         if (rtlin = bptr->ptr->rtlend->val) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
         if (rtlin = bptr->ptr->rtlend->se) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
      }
   }
#endif

   /*
    * Examine each RTL line in the basic block until we arrive at the RTL
    * indicated.
    */
   for (rtlptr = cblk->rtls; rtlptr && rtlptr != ptr; rtlptr = rtlptr->next) {
      if (rtlptr->type & RTLINE) {

#ifdef FILL

         /*
          * If the next item following RTL is in the delay slot of this RTL,
          * then look at it first.
          */
         if (rtlptr->next && (rtlptr->next->type & RTLINE)
             && (rtlptr->next->kind & (TAKEN | NOTAKEN))) {

            /*
             * Items marked dead can be released
             */
            reget(rtlptr->next->deads, reg);
            for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
               if (isrg(rtlin))
                  releasereg(regs, rtlin);

            /*
             * Items set are unavailable for allocation
             * 
             */
            if (rtlin = rtlptr->next->val) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
            if (rtlin = rtlptr->next->se) {
               while (*rtlin) {
                  if (isrg(rtlin))
                     touchreg(regs, rtlin);
                  while (*rtlin++ != ';') ;
               }
            }
         }

         /*
          * If this item is in a delay slot, then we have already considered
          * its effect, so we skip it here.
          */
         if (rtlptr->kind & (TAKEN | NOTAKEN))
            continue;
#endif

         /*
          * Items marked dead can be released
          */
         reget(rtlptr->deads, reg);
         for (rtlin = reg; *rtlin; rtlin = skiplocOr2(rtlin) + 1)
            if (isrg(rtlin))
               releasereg(regs, rtlin);

         /*
          * Items set are unavailable for allocation
          */
         if (rtlin = rtlptr->val) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
         if (rtlin = rtlptr->se) {
            while (*rtlin) {
               if (isrg(rtlin))
                  touchreg(regs, rtlin);
               while (*rtlin++ != ';') ;
            }
         }
      }

      /*
       * Treat a reserve line as a set
       */
      else if (rtlptr->type & RESLINE)
         touchreg(regs, rtlptr->val);
   }

   return (regs);
}
#endif /*INTERACT*/
