/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/dataflow.h,v $
 $Date: 2003/04/03 20:06:12 $
 $Revision: 1.6 $
 $Name:  $

 Log of changes:

 $Log: dataflow.h,v $
 Revision 1.6  2003/04/03 20:06:12  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.5  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.4  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.3  2002/01/11 13:26:17  jdh8d
 *** empty log message ***

 Revision 1.2  1998/04/28 20:16:32  jwd
 Add void to some function prototypes (not sure why they were
 not there to begin with).

 Revision 1.1  1998/04/03 16:53:39  jwd
 Initial revision

*************************************************************************/

#ifndef DATAFLOW_H
#define DATAFLOW_H

vector live_regs(struct bblock *, struct list *);
void live_variable_analysis(int, int, int);
void build_minimal_ssa_form(int);
int remv_dead_variables(int, int, int);
void build_interference_graph(void);
void merge_blobs(void);
void arg_lifes(void);
int lcsearch(struct ignode *, struct bblock *);
void usearch(struct ignode *, struct bblock *);
int simple_strength_reduction(int);

#ifdef INTERACT
vector live_regs2(struct bblock *, struct list *);
#endif

#endif
