#ifdef INTERACT

#define MAX_STR_LEN 200
#define MAX_MSG_NUM 10
#define MAX_MSG_LEN 20
#define MAX_LABEL_LEN 20



struct message{
  char msg_type;
  int block_id;
  int new_ptr_id;        /*for mod_bb_ptr use*/
  int rtl_id;
  char *label;
  /*and more*/
  /*for move_rtl use*/
  int before_id;
  int new_block_id;
  /*for new_rtl use*/
  char *rtl_val;
  unsigned int rtl_type;
} ;

typedef enum code_type {NORMAL, UCJMP, INDJMP, RJMP, RETURN} CODE_TYPE;


int get_next_component(char **, char *);
int get_real_string(char **, char *);
int get_assem(char **, char *);
void get_hand_msg_string(char **, char *);
void get_hand_msg_file(FILE *, char *);
void hand_trans(char *);
int is_digits(char *);
void parse_label_msg(char **, struct message *);
void parse_newbb_msg(char **, struct message *);
void parse_delbb_msg(char **, struct message *);
void parse_modbb_ptrs(char **, struct message *, char );
void parse_delrtl_msg(char **, struct message *);
void parse_movertl_msg(char **, struct message *);
void parse_newrtl_msg(char **, struct message *);
void parse_modrtl_msg(char **, struct message *);
void parse_newassem_msg(char **, struct message *);
void parse_modassem_msg(char **, struct message *);
int parse_messages(char *, struct message []);
void exec_msg(struct message *);
struct bblock *find_block_id(int);
struct list *find_rtl_id(int, int);
void change_bb_label(int, char *);
void insert_basic_block(int);
struct bblock *find_bottom();
void delete_basic_block(int);
void change_bb_ptrs(char, int, int);
void move_rtl_id(int, int, int, int);
void real_move_rtl(struct list *, struct bblock *, 
		   struct list *, struct bblock *);
struct list  *insert_new_rtl(int, unsigned int, char *, int, int);
void send_error(char *);
void quit(int);
char *get_label_str(char *);
struct bblock *get_label_down(char *);
int is_pc_begin(register char *);
int is_rt(char *);
CODE_TYPE get_code_type(char *);
int check_jump_semantics(char *,  CODE_TYPE, struct message *);
int update_control_flow_insert(struct bblock *, struct bblock *, CODE_TYPE);
int update_control_flow_delete(struct list *, struct bblock *);
struct list *find_last_rtl(struct bblock *);
void verify_hand_trans(char *hand_trans);
int verify_hand_msg(struct message *msg_ptr, char ret_msg[]);
int check_syn_sem(char *rtl, int before_id, char msg_ret[]);
#endif
