#ifndef LIG_H
#define LIG_H
#ifdef STACHE

/*
        a local interference graph LIG is represetned
        by a list of nodes.  Each node has a pointer
        to the local variable it represents and and
        pointer to locals that interfere with it
*/

struct LIG_node;

struct LIG_edge
{

        /* what node does this edge point to? */
        struct LIG_node* node;
        /* what edge is next in this list */
        struct LIG_edge* next;
};

struct LIG_node
{
        /* the local we represent */
        struct call_graph_local_info* the_local;

        /* the next node in the list */
        struct LIG_node* next;

        /* the first edge in the list of interferences */
        struct LIG_edge* first_edge;

	/* has this node been "removed" from the graph */
	unsigned int removed:1;

	/* did coloring put this node into the stache? */
	unsigned int stache_alloced:1;

	/* when removing nodes, was there room for this one */
	unsigned int should_color:1;

	unsigned int precolored:1;
	char* precolor_name;
	int precolor_size;

	/* Where in the stache this thing starts. */
	/* if size>4 this will be a multiple of 8.*/
	/* otherwise, it might be a multiple of 4 */ 
	unsigned int start_location;


	/* a pointer to the previously removed LIG_node */ 
	struct LIG_node* prev_removed;

	/* the sum of the neighbors edges so we */
 	/* can quickly check if there is room for us or not */
	/* this doesn't include the size of neighbors that're */
	/* removed, consequently when we remove a neighbor, */
	/* we must adjust this size */ 
	int neighbors_size;

	

};


void build_LIG();
void dump_LIG();

#endif
#endif
