
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/links.c,v $
 $Date: 2003/03/27 13:52:29 $
 $Revision: 1.37 $
 $Name:  $

 Log of changes:

 $Log: links.c,v $
 Revision 1.37  2003/03/27 13:52:29  jdh8d
 added code to avoid links on PC=RT's

 Revision 1.36  2003/03/18 16:44:17  jdh8d
 *** empty log message ***

 Revision 1.35  2003/02/06 04:46:28  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.34  2002/10/03 15:49:36  clc5q
 Replace "extern ..." garbage in *.c files with extern declarations in
 header files.

 Revision 1.33  2002/07/11 15:22:31  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.32  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.31  2002/04/02 21:13:06  jwd
 Minor code and documentation clean up.

 Revision 1.30  2002/03/26 14:53:08  jdh8d
 *** empty log message ***

 Revision 1.29  2002/03/21 21:40:44  jdh8d
 more effecient way of recalcing dominators

 Revision 1.28  2002/03/20 18:02:03  jdh8d
 *** empty log message ***

 Revision 1.27  2002/03/19 22:19:56  rv3s
 build_minimal_ssa_form() called at the top of set_global_links() to ensure that the SSA form is up to date

 Revision 1.26  2002/01/01 15:38:26  rv3s
 vpo.c

 Revision 1.25  2001/12/19 21:40:08  jdh8d
 *** empty log message ***

 Revision 1.24  2001/12/18 18:31:03  rv3s
 *** empty log message ***

 Revision 1.23  2001/12/18 15:16:03  rv3s
 set_local_links now adds unsafe links (safe=FALSE) along with safe links. The
 unsafe links (and the safe links) are together held in the all_lnks array in
 the rtl structure. The original lnks array is left untouched. Since all_lnks
 include safe links too, it is updated whenever lnks are updated. A new routine
 add_unsafe_link has been added when set_local_links reports a link as unsafe

 Bug fix: The following sequence was discovered in gcc (spec2k)
 	+184	PC = c[0]:0, L1
 	+185	184 PC=L2

 The combiner puts these two together into
 	PC=L2
 thereby eliminating the first branch instruction, which is clearly wrong.
 The link between 185 and 184 is wrong. Fixed links.c to handle
 this case -- a link is added to the previous rtl only if the previous rtl is
 not PC. I think the fix can be made in another place too -- in merge_check.
 Currently, I dont think the merge_check looks to see if the merging rtls both
 overwrite PC

 Revision 1.22  2001/12/03 19:52:57  jdh8d
 *** empty log message ***

 Revision 1.21  2001/11/21 18:00:28  jdh8d
 *** empty log message ***

 Revision 1.20  2001/11/08 19:51:09  jdh8d
 *** empty log message ***

 Revision 1.19  2001/11/01 17:24:11  jdh8d
 no message

 Revision 1.18  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.17  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.16  2001/08/29 16:44:32  jdh8d
 *** empty log message ***

 Revision 1.15  2001/08/28 21:05:00  jdh8d
 *** empty log message ***

 Revision 1.14  2001/08/22 22:27:59  jdh8d
 *** empty log message ***

 Revision 1.13  2001/07/23 18:33:44  rv3s
 Replaced skiploc() with skiplocOr2() for processing register lists

 Revision 1.12  2001/05/23 20:28:20  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.11  2001/05/21 18:43:11  jdh8d

 changes to watch register aliases and SE's more clothes

 Revision 1.10  2001/04/26 19:03:53  jdh8d

 Changes for first arm version of scheduling.

 Revision 1.9  2001/03/28 18:30:43  jdh8d


 Added code to merge_check to see if a memory operation
 is going to move across a t*, to another block across another
 memory operation.  In general, the combiner can't make this
 sort of combine.

 Revision 1.8  2001/03/09 04:42:27  jdh8d
 *** empty log message ***

 Revision 1.7  2000/06/09 19:40:41  jwd
 Cleaned up the formatting of a comment that got hosed.

 Revision 1.6  1999/03/12 20:57:41  jwd
 Changed calls to VET/VPOISO to support whether a transformation is
 required or not.
 Revision 1.5  1999/03/05 16:57:19  jwd
 The function set_global_links was missing the end_phase() call
 at the end.
 Revision 1.4  1999/01/06 15:36:40  jwd
 Added VET directives.
 Revision 1.3  1998/04/03 18:19:29  jwd
 First ANSI C version.

*************************************************************************/

/*------History of Changes------------------
  1/12/98: Modified to maintain ANSI-C function prototyping
--------------------------------------------*/

#include <stdio.h>

#include "vpo.h"
#include "assign.h"
#include "database.h"
#include "links.h"
#include "misc.h"
#include "vectors.h"
#include "vpo2.h"

#ifdef VET
#include "view.h"
#endif

/*
 * This file contains functions that deal with setting, moving and deleting
 * RTL combiner links.
 */


/*
 * set_local_links - set up safe combiner links within a basic block
 */
int set_local_links(int invocation) {

   register struct list *rtlptr;
   register struct setlist *sptr;
   register char *rtlin;
   register int rtnum;
   struct bblock *cblk;
   struct list *rptr, *lptr;
   struct setlist *cptr, *dptr[MAXRTS];
   char *a;
   int rnum, safe, i, change;
   struct list *ptr;
   char mem[MAXSTRING];

#ifdef VET
	if(!moreopts)		
		return FALSE;
#ifdef INTERACT
	begin_phase(INST_SELECT_TRANS);	
#else
	begin_phase(SETLOCALLINKS_PHASE);
#endif
#endif

   /*
      Combiner links are very useful within the optimizer.  Instead of
      performing peephole optimization based on physical adjacency, VPO uses
      combiner links.  These links are set up so that the first use of a
      register is linked back to the RTL where it is set.  At this point in
      time, we will set up combiner links strictly within the confines of a
      basic block (locally), so there is no need to have performed any global
      data-flow analysis before invoking this function.
   */

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_before_set_local_links", invocation)))
      dump_function_i("before set_local_links()", invocation,
		      SHOW_NONRTLS | SHOW_SE);

   /*
      Forget any previous information we may have had about where registers are
      set or last used.
   */
   clrsetdeads();

   /*
      For each basic block, look through each line.  The "rnum" field in each
      RTL will be used to determine if a previously visited RTL comes before or
      after another previously visited RTL.  Since we have just ensured that
      all previous register set and use information has been deleted, we can be
      confident that we will only be looking at RTLs that we have already
      processed.
   */
   change = FALSE;
   rnum = 1;
   for (cblk = top; cblk; cblk = cblk->down) {
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

#ifdef VET
	begin_trans(VET_REQUIRED_TRANS);
#endif

	 /*
	    If this item is an RTL, assign it a number and examine it to
	    determine which registers it sets and which registers it uses.
	 */
	 if (rtlptr->type & RTLINE) {


		struct list* temp;
		temp=rtlptr->prev;
		while(temp && rtlptr->val && (is_cc(rtlptr->val) || is_pc(rtlptr->val))) 
		{
			/* We'd like to explicitly link each rtl to the previous rtl. */
			if((temp->type&RTLINE) && temp->val)
			{
			        /* how can it be a jump?, ask Raja to comment */
				/* jason's guess as to why/how it could be a jump:
				 * two  jumps accidentally got put in one block, causing
				 * them to combine and eliminate one.. this "fixes" that.
				 */
                                if (!is_pc(temp->val))
				{

				   /* on a more real note, if rtlptr is a return
				    * instruction, linking can be dangerous, consider:
				
						f[0]=CV[d[0]];
						PC=RT;	=f[0];		f[0]

					when these combine, the set of f[0] disappears
					because it's dead.  we avoid the link to avoid
					the problem.
				    */
				   if(!fmatch(rtlptr->val,"RT"))
				   	add_link(rtlptr, temp);
				}
				break;
			}
			temp=temp->prev;
		}
	    rtlptr->rnum = rnum++;
	    if (rtlin = rtlptr->val) {

	       /*
	          Here we loop through the RTL looking for register references.
	          At this point we just remember where the register sets are
	          and deal with the uses (because all uses happen before all
	          sets).
	       */
	       rtnum = 0;
	       while (rtlin = gtrg(rtlin)) {
		  if (*rtlin == '=')
		     dptr[rtnum++] = s_add(unskiploc(rtlin));
		  else if (sptr = s_lookup(unskiploc(rtlin))) {

		     /*
		        We look to see if this is the first use of the register
		        since it was set (and also that the set took place
		        within the current basic block).  If this is the case,
		        we may potentially need to set a combiner link.
		     */
		     if ((rptr = sptr->sets) && rptr->daddy == cblk) {

			/*
			   Check to ensure that the link is safe.  An unsafe
			   link is one that would link back to the use of a
			   hardware register that has been set at later point.
                           At this point, cptr->dead is really the last place
                           this register was set.  We don't use cptr->sets because
                           it is cleared when first used.
			*/
			safe = TRUE;
			a = rptr->val;
			while (a = gthrg(a)) {
			   if (*a != '=' && (cptr = s_lookup(unskiploc(a))) &&
			       cptr->dead && cptr->dead->rnum > rptr->rnum) {
			      safe = FALSE;
			      break;
			   }
			}


			/*
			   Set a combiner link from the use of this register
			   back to the point where it was set if it is safe to
			   do so.
			*/
			if (safe)
			   change |= add_link(rtlptr, rptr);
			else
			  change |= add_unsafe_link(rtlptr,rptr);
		     }

		     /*
		        Forget about the set of this register, since we have
		        just seen a use of it and no other uses beyond this
		        point have any business being linked back to the set.
		     */
		     sptr->sets = (struct list *) NULL;
		  }
	       }

	       /*
	          Now we set the "sets" field on the register information
	          structure of each register that is set to point to this RTL.
	          In the future, we can use this value to place a link back to
	          this point.
	       */
	       while (rtnum--)
		  dptr[rtnum]->sets = dptr[rtnum]->dead = rtlptr;
	    }
	 }

	 /*
	    A reserved item is implicitly set, so we treat it as a set whose
	    set point is unknown (that is, we forget its last set point, if
	    any).
	 */
	 else if (rtlptr->type & RESLINE) {
	    rtlptr->rnum = rnum++;
	    sptr = s_add(rtlptr->val);
	    sptr->sets = (struct list *) NULL;
	    sptr->dead = rtlptr;
	 }

	 /*
	    Set line items are treated similarly
	 */
	 else if (rtlptr->type & SETLINE) {
	    char* a;
	    rtlptr->rnum = rnum++;
	    for (rtlin = rtlptr->val; *rtlin; rtlin = skiplocOr2(rtlin)) {
		if(isRegister(rtlin))
		{
			for(a=aliases(rtlin);*a;a=skiploc(a)+1)
			{
	       			sptr = s_add(a);
	       			sptr->sets = (struct list *) NULL;
	       			sptr->dead = rtlptr;
			}
		}
		else
		{
	       		sptr = s_add(rtlin);
	       		sptr->sets = (struct list *) NULL;
	       		sptr->dead = rtlptr;
		}
	    }
	 }
        /*
         * If the contents of a memory location are trashed and there is a
         * preceding load from this location, then get rid of the "sets" 
         * information for the register holding the contents of the 
         * location. This is to avoid a link  between this set and
         * subsequent use of this register
         */ 
        else if (rtlptr->type & TRASHLINE) {
          rtlin = rtlptr->val;

          /*
           * If this line indicates that a memory reference is being
           * trashed, then investigate further
           */
          if (ismem(rtlin) ) {

            /* 
             * Search till the top of the basic block for an rtl that
             * is a memory load. If the memory reference is the same as the 
             * one on the trashline, then remove the sets information for the 
             * destination register of the load. If this information is
             * removed, no link will be set between this rtl and the 
             * rtl containing the first use of this register.
             * For example, consider the following piece of code. Assume that 
             * there are no hidden dependencies
             *            1             ...                                   
             *            2             ...                                   
             *            3             r[2]=R[r[5]+3]                       
             *            4             ...
             *            5             ...                     
             *            6             tR[r[5]+3] 
             *            7             r[4]=r[2]
             * If TRASHLINE is ignored by this function, we get the
             * following code. 
             *            1             ...                                   
             *            2             ...                                   
             *            3             r[2]=R[r[5]+3]                       
             *            4             ...
             *            5             ...                     
             *            6             tR[r[5]+3] 
             *            7         {3} r[4]=r[2]
             * The instruction selection phase will eventually merge the
             * instructions 3 and 7, which results in incorrect code.
             * But if the TRASHLINE is not ignored, then no link is set, and
             * the instruction selection phase does not merge instructions
             * 3 and 7. The original code remains unchanged.
             *            1             ...                                   
             *            2             ...                                   
             *            3             r[2]=R[r[5]+3]                       
             *            4             ...
             *            5             ...                     
             *            6             tR[r[5]+3] 
             *            7             r[4]=r[2]
             */
            for (ptr = rtlptr->prev; ptr; ptr = ptr->prev) {
               if (ptr->val != NULL && isreg(ptr->val) && (a = gtmem(skiploc(ptr->val) + 1))) {
                  gtstr(bpos, a, mem);
                  if (!strcmp(mem, rtlin)) {
                     sptr = s_lookup(ptr->val);
                     sptr->sets = (struct list *) NULL;
                     break;
                  }
               }
            }
         }
      }
#ifdef VET
	end_trans();
#endif
    }
 }

#ifdef INTERACT
	begin_trans(VET_REQUIRED_TRANS);
#endif
	
/* lets just set machine specific links here */
   for (cblk = top; cblk; cblk = cblk->down) 
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) 
		if(cnts(rtlptr))
			mdlinks(rtlptr);

#ifdef INTERACT
   end_trans();
#endif

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_after_set_local_links", invocation)))
      dump_function_i("after set_local_links()", invocation,
		      SHOW_NONRTLS | SHOW_SE);

#ifdef VET
#ifdef INTERACT
   end_phase(INST_SELECT_TRANS);	
#else
    end_phase(SETLOCALLINKS_PHASE);
#endif
#endif
   /*
      Indicate whether or not any new combiner links have been introduced into
      the function.
   */
   return (change);
}

/*
 * set_global_links - set up safe combiner links across basic blocks
 */
int set_global_links(int invocation) {

   register char *rtlin;
   register struct list *rtlptr;
   struct list *ptr;
   register struct setlist *sptr;
   register struct bblock *cblk;
   register int rtnum;
   struct bblock *aptr;
   struct phi *pphi;
   struct defnode *pdef;
   struct list *rptr, *lptr;
   struct setlist *cptr;
   int change, rnum, safe, i;
   char *a, reg[BIGSTRING], *dptr[MAXRTS], mem[MAXSTRING];

   /*
      This function determines where combiner links can be set across basic
      blocks.  In order to work correctly, the live variable analysis,
      dominator tree and minimal SSA form information must be up-to-date for
      the current function.
   */

   /* Build SSA */
   /*rebuild_dom_front();*/
   clear_dominators();
   depth_first_search(d_f_s_count++);
   build_dominator_tree(b_d_t_count++);
   find_dominance_frontiers(f_d_f_count++);

   build_minimal_ssa_form(1);
#ifdef VET
#ifdef INTERACT
  begin_phase(GLOBAL_INST_SELECT_TRANS);	
#else
    begin_phase(SETGLOBALLINKS_PHASE);
#endif
#endif
   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_before_set_global_links", invocation)))
      dump_function_i("before set_global_links()", invocation,
		      SHOW_LABELS | SHOW_DOM | SHOW_USE | SHOW_SETS |
		      SHOW_PHI | SHOW_NONRTLS | SHOW_SE);

   change = FALSE;
   rnum = 1;

   /*
      Examine each basic block to determine if there are any items that should
      be linked across basic blocks.
   */
   for (cblk = top; cblk; cblk = cblk->down) {

      /*
         Forget all previous set information
      */
      clrsetdeads();

      /*
         Examine all of the registers that are live on entry to this block
      */
      reget(cblk->ulist, a = reg);
      for (a = reg; *a; a = skiplocOr2(a)+1) {
	 if ((sptr = s_lookup(a)) && !(sptr->status & HARDWARE)) {

	    /*
	       First, determine if there is only a single assignment that
	       reaches this basic block for this item.  We can determine this
	       by looking from this basic block upwards through the dominator
	       tree until we locate the last assignment for this item.  If the
	       assignment is a phi function, then more than one definition of
	       the item reaches this basic block and we know that we cannot
	       link the first use of the item to its last assignment.
	    */
	    aptr = cblk;
	    do {
	       for (pphi = aptr->phi_funcs; pphi; pphi = pphi->next) {
		  if (pphi->item == sptr)
		     break;
	       }
	       if (pphi)
		  break;
	       if (!(aptr = aptr->idom))
		  break;
	       for (pdef = aptr->sets_out; pdef; pdef = pdef->next) {
		  if (pdef->item == sptr) {
		     sptr->sets = pdef->set_rtl;
		     break;
		  }
	       }
	    } while (!sptr->sets);

	    /*
	       If the set point was something other than an RTL, then we do not
	       want to attempt to set a link back to it.
	    */
	    if (sptr->sets && !(sptr->sets->type & RTLINE))
	       sptr->sets = (struct list *) NULL;

	    /*
	       If we have determined that there is only a single definition of
	       the item that can reach this point, we must also ensure that
	       this block has the only uses of the item for this definition.
	       We do so by initialing a global search starting at the
	       assignment point.
	    */
	    if (sptr->sets) {

	       /*
	          Start by marking all of the basic blocks as unvisited except
	          for the current basic block.
	       */
	       for (aptr = top; aptr; aptr = aptr->next)
		  aptr->status &= ~DONE;
	       cblk->status |= DONE;

	       /*
	          Start at the current item and ensure that there are no uses
	          of the variable.
	       */
	       if (search_for_use(sptr->item, sptr->num,
				  sptr->sets->daddy, sptr->sets->next))
		  sptr->sets = (struct list *) NULL;
	    }
	 }
      }

      /*
         Now that we have information on items that can be safely linked across
         basic blocks, examine this basic block to see if any combiner links
         can be set from here to other blocks.
      */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
	 if (rtlptr->type & RTLINE) {
	    rtlptr->rnum = rnum++;
	    rtnum = 0;
	    if (rtlin = rtlptr->se) 
	       while (rtlin = gtrg(rtlin)) 
		  if (*rtlin == '=')
		     dptr[rtnum++] = unskiploc(rtlin);
	    if (rtlin = rtlptr->val) {

	       /*
	          Look at the registers used by this RTL and see if they should
	          link back to previous sets.
	       */
	       while (rtlin = gtrg(rtlin)) {
		  if (*rtlin == '=')
		     dptr[rtnum++] = unskiploc(rtlin );
		  else if (sptr = s_lookup(unskiploc(rtlin ))) {
		     if (rptr = sptr->sets) {

			/*
			   Since the condition codes on most machines are not
			   represented as true registers whose use information
			   has been correctly tracked, it is best to avoid
			   setting global links to items that set the condition
			   codes, since they are usually unsafe to (globally)
			   link to.
			*/
			if (!set_cc(rptr->val) && !(sptr->status & HARDWARE)) {
			   safe = TRUE;
			   a = rptr->val;
			   while (a = gthrg(a)) {
			      if (*a != '=' && (cptr = s_lookup(unskiploc(a))) &&
			      cptr->ldead && cptr->ldead->rnum > rptr->rnum) {
				 safe = FALSE;
				 break;
			      }
			   }
			   if (safe) {
			      for (i = 0; i < MAXLINKS && (lptr = rptr->lnks[i]); i++) {
				 if (a = lptr->val) {
				    while (a = gthrg(a)) {
				       if (*a != '=' && (cptr = s_lookup(unskiploc(a))) &&
					   cptr->ldead && cptr->ldead->rnum > rptr->rnum) {
					  safe = FALSE;
					  break;
				       }
				    }
				    if (!safe)
				       break;
				 }
			      }
			   }


/*


We found a case like so:

+30                     r[44]=R[r[35]];
+31                     r[45]=r[13];
+32                     r[46]=396;
+33                     r[35]=r[35]+4;
+34             32 31   r[46]=r[46]+r[45];
+35		33	r[47]=r[35];    r[35]
L3:
	.
	.
	PC=CC?0:L3;


+44             30      r[3]=r[44];     r[44]


Thus, rtl 44 is linked to rtl 30 because of
r[44] not being used in the loop.  However,
r[35] is modifed before r[44] is used.
We need to start a global search from line 30
to find defines of r[35].

In the general case, before it's safe to
link rtl A to rtl B, we need to know that
all variables used in A are still valid when
B is reached.  Thus, look through the
rtls in output order for defines that 
could break the combiner.
*/

{
struct list* goo;
for(goo=rptr; goo && goo!=rtlptr && safe; goo=goo->next)
{
	char *a1, *a2;
	if(cnts(goo))
	{
		a1=goo->val;
		while((a1=gtrg(a1)) && safe)
		{
			/* is it defined? */
			if(*a1=='=')
			{
				a2=rptr->val;
				while((a2=gtrg(a2)) && safe)
				{
					if(*a2!='=' && 
						cmploc(unskiploc(a1), 
						unskiploc(a2))==0)
					   safe = FALSE;
				}

			}
		}
	}
}
}












			   /*
			      If all looks well, set up a link from this use to
			      the last set.
			   */
#ifdef VET
		    begin_trans(VET_REQUIRED_TRANS);
#endif
			   if (safe && add_link(rtlptr, rptr))
			      change = TRUE;
#ifdef VET
		    end_trans();
#endif
			}
			sptr->sets = (struct list *) NULL;
		     }
		  }
	       }

	       /*
	          Remember where items where last set
	       */
	       while (rtnum--) {
		  if (sptr = s_lookup(dptr[rtnum]))
		     sptr->sets = sptr->ldead = rtlptr;
	       }
	    }
	 }

	 /*
	    Treat a reserve line as a register set
	 */
	 else if (rtlptr->type & RESLINE) {
	    rtlptr->rnum = rnum++;
	    sptr = s_add(rtlptr->val);
	    sptr->sets = (struct list *) NULL;
	    sptr->ldead = rtlptr;
	 }

	 /*
	    Treat a set line item as a register set (may be more than one)
	 */
	 else if (rtlptr->type & SETLINE) {
	    char* a;
	    rtlptr->rnum = rnum++;
	    for (rtlin = rtlptr->val; *rtlin; rtlin = skiplocOr2(rtlin)) {
	      	if(isRegister(rtlin))
		{
                	for(a=aliases(rtlin);*a;a=skiploc(a)+1)
                	{
                        	sptr = s_add(a);
                        	sptr->sets = (struct list *) NULL;
                        	sptr->dead = rtlptr;
                	}
		}
 		else
		{
                        sptr = s_add(rtlin);
                        sptr->sets = (struct list *) NULL;
                        sptr->dead = rtlptr;
		}

	    }
	 }
         else if (rtlptr->type & TRASHLINE) {
            rtlin = rtlptr->val;

            /*
             * If this line indicates that a memory reference is being
             * trashed, then investigate further
             */
            if (ismem(rtlin)) {

               /* 
                * Search till the top of the basic block for an rtl that
                * is a memory load. If the memory reference is the same as the 
                * one on the trashline, then remove the sets information for
                * the destination register of the load. If this information is
                * removed, no link will be set between this rtl and the 
                * rtl containing the first use of this register.
                * For example, consider the following piece of code. Assume
                * that there are no hidden dependencies
                *            1             ...
                *            2             ...
                *            3             r[2]=R[r[5]+3]
                *            4             ...
                *            5             ...                     
                *            6             tR[r[5]+3] 
                *            7             r[4]=r[2]
                * If TRASHLINE is ignored by this function, we get the
                * following code. 
                *            1             ... 
                *            2             ...
                *            3             r[2]=R[r[5]+3]
                *            4             ...
                *            5             ...                     
                *            6             tR[r[5]+3] 
                *            7         {3} r[4]=r[2]
                * The instruction selection phase will eventually merge the
                * instructions 3 and 7, which results in incorrect code.
                * But if the TRASHLINE is not ignored, then no link is set, and
                * the instruction selection phase does not merge instructions
                * 3 and 7. The original code remains unchanged.
                *            1             ...
                *            2             ...
                *            3             r[2]=R[r[5]+3]
                *            4             ...
                *            5             ...                     
                *            6             tR[r[5]+3] 
                *            7             r[4]=r[2]
                */
                for (ptr = rtlptr->prev; ptr; ptr = ptr->prev) {
                   if (ptr->val != NULL && isreg(ptr->val) && (a = gtmem(ptr->val + 3))) {
                      gtstr(bpos, a, mem);
                      if (!strcmp(mem, rtlin)) {
                         sptr = s_lookup(ptr->val);
                         sptr->sets = (struct list *) NULL;
                         break;
                      }
                   }
                }
             }
          }
       }
   }

#ifdef VET
#ifdef INTERACT
   end_phase(GLOBAL_INST_SELECT_TRANS);
#else
   end_phase(SETGLOBALLINKS_PHASE);
#endif
#endif
   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_after_set_global_links", invocation)))
      dump_function_i("after set_global_links()", invocation,
		      SHOW_LABELS | SHOW_DOM | SHOW_USE | SHOW_SETS |
		      SHOW_PHI | SHOW_NONRTLS | SHOW_SE);

   /*
      Indicate whether or not any new combiner links have been introduced into
      the function.
   */
   return (change);
}

/*
 * search_for_use - look for any uses for an assignment
 */
int search_for_use(char *item, unsigned int rnum, struct bblock * cblk, register struct list * rtlptr) {


   /*
      Mark this basic block as searched so that loops do not cause us to search
      forever.
   */
   cblk->status |= DONE;

   /*
      Start at the current RTL and search for a use of the item.  If one is
      found, then we return the value TRUE.
   */
   while (rtlptr) {
      if (cnts(rtlptr) && isref(rtlptr->val, item))
	 return (TRUE);
      rtlptr = rtlptr->next;
   }

   /*
      If this basic block has a left child and that child has not yet been
      searched for a set and the item that we are looking for is live on the
      path toward that child, then continue the search along that child.
   */
   if (cblk->left && !(cblk->left->status & DONE) &&
       rin(rnum, cblk->left->ulist)) {
      if (search_for_use(item, rnum, cblk->left, cblk->left->rtls))
	 return (TRUE);
   }

   /*
      Do the same with the right child, if any
   */
   if (cblk->right && !(cblk->right->status & DONE) &&
       rin(rnum, cblk->right->ulist)) {
      if (search_for_use(item, rnum, cblk->right, cblk->right->rtls))
	 return (TRUE);
   }

   /*
      Indicate that no use of the item was found following this path
   */
   return (FALSE);
}

int remv_forward_links_in_block(struct bblock* cblk) 
{

   register struct list *ptr;
   register int rnum;
   struct list *lptr;
   int change;

   /*
      Number all RTLs, so we can tell forward links from back links
   */
   rnum = 1;
   for (ptr = cblk->rtls; ptr; ptr = ptr->next) 
   {
	 if (ptr->type & RTLINE)
	    ptr->rnum = rnum++;
   }

   change = FALSE;

   /*
      Now search out improper forward links and remove them
   */
   for (ptr = cblk->rtls; ptr; ptr = ptr->next) 
   {
	 if (ptr->type & RTLINE) 
         {
	    for (rnum = 0; rnum < MAXLINKS && (lptr = ptr->all_lnks[rnum]); rnum++) 
            {
	       if (lptr->rnum > ptr->rnum) 
               {
		  remv_link(lptr->blnks, ptr);
		  remv_link(ptr->lnks, lptr);
		  remv_link(ptr->all_lnks, lptr);
#ifdef VET
#ifdef INTERACT
		  if (swq)
#endif
	          mod_links(ptr);
#endif
		  rnum--;
		  change = TRUE;
	       }
	    }
	 }
   }

   /*
      Indicate if any forward links were detected and removed
   */
   return (change);
}

/*
 * remv_forward_links - remove forward pointing links
 */
int remv_forward_links(int invocation) 
{

   register struct list *ptr;
   register int rnum;
   struct bblock *cblk;
   struct list *lptr;
   int change;

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_before_remv_forward_links", invocation)))
      dump_function_i("before remv_forward_links()", invocation, SHOW_SE);

   /*
      Number all RTLs, so we can tell forward links from back links
   */
   rnum = 1;
   for (cblk = top; cblk; cblk = cblk->down) {
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
	 if (ptr->type & RTLINE)
	    ptr->rnum = rnum++;
      }
   }

   change = FALSE;

   /*
      Now search out improper forward links and remove them
   */
   for (cblk = top; cblk; cblk = cblk->down) {
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {
	 if (ptr->type & RTLINE) {
	    for (rnum = 0; rnum < MAXLINKS && (lptr = ptr->all_lnks[rnum]); rnum++) {
	       if (lptr->rnum > ptr->rnum) {
		  remv_link(lptr->blnks, ptr);
		  remv_link(ptr->lnks, lptr);
		  remv_link(ptr->all_lnks,lptr);
#ifdef VET
	      mod_links(ptr);
#endif
		  rnum--;
		  change = TRUE;
	       }
	    }
	 }
      }
   }

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && (debug_opt_i("dump_after_remv_forward_links", invocation)))
      dump_function_i("after remv_forward_links()", invocation, SHOW_SE);

   /*
      Indicate if any forward links were detected and removed
   */
   return (change);
}
/*
 * merge_links - merge combiner links from two RTLs and eliminate self-reference
 */
void merge_links(register struct list * p, register struct list * n) {

   register struct list *ptr;
   register int i;


   /* there is no "safe" way to merge links.  Sorry charlie */
   remv_links_to(n);
   remv_links(n);

   remv_link(p->lnks, n);
   remv_link(p->all_lnks, n);

#ifdef VET
    mod_links(p);
#endif
   for (i = 0; i < MAXLINKS && (ptr = n->blnks[i]); i++) {
      if (ptr != p) {
	 remv_link(ptr->lnks, n);
	 remv_link(ptr->all_lnks, n);
#ifdef VET
	mod_links(ptr);
#endif
	 if(ptr->rnum<p->rnum)
	 	(void) add_link(ptr, p);
      }
   }
   for (i = 0; i < MAXLINKS && (ptr = n->all_lnks[i]); i++) {
      	remv_link(ptr->blnks, n);
 	if(ptr->rnum<p->rnum)
      		add_link(p, ptr);
   }
}

/*
 * add_link - set up a combiner link between two RTLs
 */
int add_link(register struct list * p, register struct list * n) {

   int i, j;

   /*
      Note that links go both ways.  lnks[] contains the links used by
      combiner.  blnks[] allow for the proper deletion of all lnks[] references
      to a line when it is deleted by combiner.
   */
   if (!(n->type & RTLINE))
      (void) fprintf(stderr, "vpo (add_link): setting link to bad RTL\n");
   else if (!(p->type & RTLINE))
      (void) fprintf(stderr, "vpo (add_link): setting link from bad RTL\n");
   else if (p == n)
      (void) fprintf(stderr, "vpo (add_link): attempt to link RTL to itself\n");
   else {
      for (i = 0; i < MAXLINKS; i++) {
	 if (n->blnks[i] == p)
	    return (FALSE);
	 else if (!n->blnks[i]) {
	    n->blnks[i] = p;

	    for (j = 0; j < MAXLINKS; j++) {
	       if (!p->all_lnks[j]) {
		  p->all_lnks[j] = n;
		  break;
	       }
	    }

	    for (j = 0; j < MAXLINKS; j++) {
	       if (!p->lnks[j]) {
		  p->lnks[j] = n;
		  p->type |= COMBLINE;
#ifdef VET
#ifdef INTERACT
		  mod_type(p);
#endif
	      mod_links(p);
#endif
		  return (TRUE);
	       }
	    }
	    break;
	 }
      }
      (void) fprintf(stderr, "vpo (add_link): not enough links available\n");
   }
   return (FALSE);
}

/*
 * add_unsafe_link - set up an unsafe link between two RTLs
 */
int add_unsafe_link(register struct list * p, register struct list * n) 
{

   register int i;

   /*
      Note that links go both ways.  lnks[] contains the links used by
      combiner.  blnks[] allow for the proper deletion of all lnks[] references
      to a line when it is deleted by combiner.
   */
   if (!(n->type & RTLINE))
      (void) fprintf(stderr, "vpo (add_link): setting link to bad RTL\n");
   else if (!(p->type & RTLINE))
      (void) fprintf(stderr, "vpo (add_link): setting link from bad RTL\n");
   else if (p == n)
      (void) fprintf(stderr, "vpo (add_link): attempt to link RTL to itself\n");
   else {
      for (i = 0; i < MAXLINKS; i++) {
	 if (n->blnks[i] == p)
	    return (FALSE);
	 else if (!n->blnks[i]) {
	    n->blnks[i] = p;

	    for (i = 0; i < MAXLINKS; i++) {
	       if (!p->all_lnks[i]) {
		  p->all_lnks[i] = n;
		  p->type |= COMBLINE;
#ifdef VET
#ifdef INTERACT
		  mod_type(p);
#endif		  
		  mod_links(p);
#endif	  
		  return TRUE;
	       }
	    }
	    break;
	 }

      }
      (void) fprintf(stderr, "vpo (add_link): not enough links available\n");
   }
   return (FALSE);
}

/*
 * remv_links - remove all combiner links to and from an RTL
 */
void remv_links(register struct list * ptr) {

   register int i;
   
   for (i = 0; i < MAXLINKS; i++) {
      if (ptr->blnks[i]) {
	 remv_link(ptr->blnks[i]->lnks, ptr);
	 remv_link(ptr->blnks[i]->all_lnks, ptr);
#ifdef VET
        mod_links(ptr->blnks[i]);
#endif
      }

      else 
	break;
   }
   for (i = 0; i < MAXLINKS; i++) 
   {
      	if (ptr->all_lnks[i])
	{
	 	remv_link(ptr->all_lnks[i]->blnks, ptr);
	}
      	else 
		break;
   }

   bzero(ptr->lnks, sizeof(ptr->lnks));
   bzero(ptr->blnks, sizeof(ptr->blnks));
   bzero(ptr->all_lnks, sizeof(ptr->all_lnks));
}

/*
 * remv_links_to - delete combiner links to an RTL
 */
void remv_links_to(register struct list * p) {

   register int i;
   
   for (i = 0; i < MAXLINKS && p->blnks[i]; i++) 
   {
      remv_link(p->blnks[i]->lnks, p);
      remv_link(p->blnks[i]->all_lnks, p);
#ifdef VET
      mod_links(p->blnks[i]);
#endif
      p->blnks[i] = (struct list *) NULL;
   }     
}

/*
 * remv_link - delete a combiner link from a link array
 */
void remv_link(struct list ** lnks, struct list * ptr) 
{

   register struct list *rtl;
   register int i;

   for (i = 0; i < MAXLINKS && (rtl = lnks[i]); i++) {
      if (rtl == ptr) {
	 for (i++; i < MAXLINKS; i++)
	    lnks[i - 1] = lnks[i];
	 lnks[MAXLINKS - 1] = (struct list *) NULL;
	 return;
      }
   }
}

/*
 * combmark - mark an RTL and all RTLs linked to it for recombination
 */
void combmark(register struct list * rtl) {

   register int loop;
   
   /*
      The status value COMBCHECK is used to ensure that we don't get into an
      infinite recursion state when RTLs are linked in a circular fashion (even
      though such a state isn't supposed to happen, we have found a few
      pathological cases where it does and this is the best solution for them).
   */
   if (rtl->type & COMBCHECK)
      return;
   if (rtl->type & RTLINE) {
      rtl->type |= (COMBLINE | COMBCHECK);
      for (loop = 0; loop < MAXLINKS && rtl->blnks[loop]; loop++)
	 combmark(rtl->blnks[loop]);
      rtl->type &= ~COMBCHECK;
#ifdef INTERACT
      /*add one line to send the mod_type message*/
      mod_type(rtl);
#endif		
   }
   else {
      (void) fprintf(stderr, "vpo (combmark): bad link at: ");
      show_rtl(stderr, rtl->val);
      (void) fprintf(stderr, "\n");
      exit(1);
   }
}


void reset_local_links()
{
   struct bblock* cblk;
   struct list* rtlptr;
   /* links that were Ok may be bogus now.. we'll clear them and let set_local_links redo them
        later */
   for (cblk = top; cblk; cblk = cblk->down)
   {
        for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next)
        {
                memset((void*)(&(rtlptr->lnks[0])), 0, sizeof(rtlptr->lnks));
                memset((void*)(&(rtlptr->blnks[0])), 0, sizeof(rtlptr->blnks));
                memset((void*)(&(rtlptr->all_lnks[0])), 0, sizeof(rtlptr->all_lnks));
        }
   }
#ifdef VET
   if(moreopts)
#endif
   set_local_links(0);
/* we don't want to set global links so often, it requires rebuilding a lot of crap */  
/*   if(swg) set_global_links(0);*/

}
