/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/measure.h,v $
 $Date: 2004/01/21 18:39:58 $
 $Revision: 1.5 $
 $Name:  $

 Log of changes:

 $Log: measure.h,v $
 Revision 1.5  2004/01/21 18:39:58  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.3  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.2  1998/04/28 20:24:25  jwd
 Delete some commented out code.

 Revision 1.1  1998/04/03 18:15:51  jwd
 Initial revision

*************************************************************************/

#ifndef MEASURE_H
#define MEASURE_H

#ifdef MEASURE
extern int totalblks;      /* Total number of blocks in this function    */
extern int equiv_classes;  /* Number of equivalence classes in function  */
extern int insttype;       /* Instruction type of last item parsed       */
extern int numinsts[];     /* Number of instructions in each small block */
extern int numblks[];      /* Number of blocks in an equivalence class   */
extern int blksinec[];     /* List of blocks in an equivalence class     */
extern int func_instinfo[];/* Contains execution frequency information   */
extern int *info_ptr;      /* Pointer to next free information item      */

void measure_freq();
void measure_cache();
void measure_time();
void add_block_to_class(struct bblock *);
void class_has_call(struct bblock *);
void enter_call();
void exit_call(struct list *);
void branch_measure(struct bblock *, struct list *);

#ifdef INTERACT
char *getline(FILE *file);
void do_reqd_optimization();
int get_measure(struct freq_counts **measure_cnt, int);
void take_measures();
int read_next_function();
void do_fn_prereqs();
void do_fn_clean();
struct freq_counts *make_dummy_counts();
#endif

#endif /* MEASURE */

#endif /* MEASURE_H */

