/***********************************************************************/
/* remjump.h                                                           */
/* header file for removing jumps                                      */
/***********************************************************************/

#ifndef REMJUMP_H
#define REMJUMP_H

#define MAX_RET_BLK  50
#define MAX_EXIT_BLK 50
#define MAX_REP_BLK  50
#define MAX_UJUMPS   50
#define LEFT          1
#define RIGHT         2

/*gather some information about the current basic block*/
struct block_info{
  int num_rtl;         /*number of RTLs in block*/
  struct bblock *ptr;  /*pointer to block in bblock structure */
};

/*function prototypes*/
void find_shortest_path(int weights[][MAX_BLOCKS], int start, int nodes,
			int distance[], int paths[]);
struct bblock *dup_block(struct bblock *cblk,
			 struct bblock *pblk, struct bblock *nblk);
int remove_jumps();
int init_rem_jump(struct block_info binfo[], int weights[][MAX_BLOCKS]);
int det_cheap_path(struct block_info binfo[], int start, int dist[],
		   int path[], int rep_path[]);
struct bblock *copy_block(struct bblock *cblk);
struct list *get_last_rtl(struct bblock *cblk);
void change_branch_label(struct list *rtl, char *label);
int find_uncond_jumps(struct bblock* ujmps[]);
void sort_uncond_jumps(int num, struct bblock* ujmps[]);
int in_blist(struct blist *list, struct bblock *blk);
void adjust_fn_labels();
#endif
