/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/schedule.h,v $
 $Date: 2002/07/11 15:21:13 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: schedule.h,v $
 Revision 1.3  2002/07/11 15:21:13  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.2  1998/04/29 19:21:01  jwd
 Added void to some prototypes and deleted some commented out
 code.

 Revision 1.1  1998/04/03 18:16:03  jwd
 Initial revision

*************************************************************************/

#ifndef SCHEDULE_H
#define SCHEDULE_H

#if SCHED || FILL 

int canfollow(struct bblock *, struct list *, struct list *);
struct list *prevexec(struct bblock *, struct list *, struct list *);
void depend_setup(void);
void sets_uses(struct list *);
int depends(struct list *, struct list *);
void uses(struct list *, int *, int *, rlist, rlist);
struct list *prevexec2(struct list *, struct list *);
struct list *nextexec(struct list *, struct list *);

#ifdef SCHED
void instruction_scheduling(int);
void release_ready(struct bblock *, struct list *);
struct list *ready_set(struct bblock *, int);
void choose_rtl(struct bblock *, struct list **, int);
void issue_non_rtl(struct bblock *, struct list *);
void add_noops(void);
void insert_ready(struct bblock *, struct list **, struct list *);
void advantage(struct list *);
void issue_noop(struct bblock *, unsigned int, int, char *);
void issue_rtl(struct list **, struct list *, int, char *);
#endif


#ifdef FILL
int fill_delay_slots(int);
struct list *fill_both(struct list *);
struct list *fill_taken(struct list *);
struct list *fill_notaken(struct list *);
#endif 

#endif  /* SCHED || FILL */

#endif




















