
/************************************************************************/
/*                                                                      */
/* Copyright (c) 2000				                        */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************

 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/stache.h,v $
 $Date: 2002/07/16 22:01:17 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: stache.h,v $
 Revision 1.3  2002/07/16 22:01:17  clc5q
 Export global_vars and globals_found for MIPS target.

 Revision 1.2  2002/07/16 19:40:13  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.1  2002/06/05 20:08:54  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"



************************************************************************/

/* if we aren't compiling for the stache, junk this */
#ifdef STACHE


void drive_stache_allocation_phase1(void);
void drive_stache_allocation_phase2(void);
void cleanup_stacheables(void);
void read_globals_profile(void);

#define NO_STACHE	  	0
#define STUPID_STACHE_POLICY 	1
#define COLORING_STACHE_POLICY 	2
#define GLOBALS_STACHE_POLICY 	3 
#define BOTH_STACHE_POLICY 	4 
#define LAST_STACHE 		5	/* keep this last */

#define MAX_GLOBALS	16*1024		/* 16K globals max */

struct global_var
{
	/* the symbol name */	
	char* 	name;		

	/* the 4-character ID for the symbol */
	char	id[REGSTRING];	

	/* how many times this is used in the profile run */
	int   	use_count; 

	/* what % of the total is this for the program */
	float   rel_use_count;

	/* the size of this variable */
	int 	size;		

	/* is this one that we are compiling? */
	unsigned int 	compiling:1;	

	/* is this variable in the stache */
	unsigned int    is_stached:1; 

	/* the benefit of putting this in the stache 
 	 * first attempt will be use_count/size*compiling 
	 */
	float   rel_benefit;	
};


extern struct global_var global_vars[];
extern int globals_found;

extern int stache_size;
extern int stache_policy;


#endif







