/***********************************************************************
 * 
 * Copyright (c) 2000 Baosheng Cai.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /uf4/ab5y/vet/vpo/lib/RCS/undo.h,v 
 * $Revision: 1.2 $
 ***********************************************************************/

/* FILE: undo.h: the header of undo.c*/

#ifdef INTERACT

#ifndef UNDO_H
#define UNDO_H

#define ERR_QUIT(MSG) {\
 fprintf(stderr,MSG);\
 exit (-1);\
 }

#ifdef INTERACT
extern int undoing_transformation;

/*phase_name: used for providing debug information
 about the phase name, corresponding to phase number.*/
static char phase_names[NUM_TRANS_TYPES][40]={   "UNDEFINED TRANS", \
						 "BRANCH_CHAINING_TRANS", \
						 "ELIM_EMPTY_BLOCKS_TRANS",\
						 "USELESS_JUMP_ELIM_TRANS", \
						 "DEAD_CODE_ELIM_TRANS", \
						 "REVERSE_BRANCHES_TRANS", \
						 "LOCK_REORDERING_TRANS",\
						 "MERGE_BLOCKS_TRANS",\
						 "INST_SELECT_TRANS", \
						 "FIX_CONTROL_FLOW_TRANS", \
						 "EVAL_ORDER_DETER_TRANS",\
						 "GLOBAL_INST_SELECT_TRANS",\
						 "REG_ASSIGNMENT_TRANS", \
						 "MINIMIZE_LOOP_JUMPS_TRANS",\
						 "DEAD_ASG_ELIM_TRANS", \
						 "REG_ALLOCATION_TRANS",\
						 "COMMON_SUBEXPR_ELIM_TRANS",\
						 "CODE_MOTION_TRANS", \
						 "LOOP_STRENGTH_REDUCT_TRANS", \
						 "RECURRENCE_ELIM_TRANS",\
						 "INDUCT_VAR_ELIM_TRANS", \
						 "STRENGTH_REDUCT_TRANS", \
						 "FIX_ENTRY_EXIT_TRANS",\
						 "INST_SCHED_TRANS", \
						 "FILL_DELAY_SLOTS_TRANS"};
#endif

/*functions for undo oeprations*/
void undo_interact();
void print_phases();
void undo_from_list();
void undo_changes(int num);
void undo_transes(int num);

void sync_neighbours(struct list *rtlptr);
void sync_old_neighbours(struct list *rtlptr);
void dump_left_right(char *filename);

void clear_all_preds();
void clear_bb_preds(struct bblock *cblk);
void recalculate_all_preds();
void calc_status();
void blkerrmsg(struct bblock *, char *, int);


/*
The following functions are to check the synchronizations between old fields
and new fields
*/
void check_all_syn();
void check_bb_syn(struct bblock *cblk);
void check_rtl_syn(struct list *rtlptr);
/*check the consistency of the undo list*/
int check_undo_list();

/*Global variables:*/
int undo_begin;


/*for testing purposes
 should be deleted afterwards*/
short regtovec_call(char *rtl);
unsigned short USP_call(char *s);

#endif

#endif
