/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/vectors.h,v $
 $Date: 2003/11/18 01:58:05 $
 $Revision: 1.10 $
 $Name:  $

 Log of changes:

 $Log: vectors.h,v $
 Revision 1.10  2003/11/18 01:58:05  clc5q
 Make number_basic_blocks() return the number of blocks in the function,
    and make calls to it reflect the fact that it now returns an int.

 Revision 1.9  2003/02/06 04:48:22  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.8  2002/08/09 19:58:19  clc5q
 Add extern declarations of dveclen and veclen.

 Revision 1.7  2002/07/11 15:21:13  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.6  2002/03/25 17:18:05  rv3s
 Added prototype for rempty()

 Revision 1.5  2002/02/12 16:08:34  jdh8d
 *** empty log message ***

 Revision 1.4  2000/06/09 19:44:30  jwd
 Fixed a prototype so the compiler wouldn't complain.

 Revision 1.3  1998/06/26 21:01:11  jwd
 Fixed the prototypes for ddelete and dcpy.
 Revision 1.2  1998/04/29 19:21:58  jwd
 Added void to some prototypes.
 Deleted some commented out code.
 Revision 1.1  1998/04/03 18:16:08  jwd
 Initial revision

*************************************************************************/

#ifndef VECTORS_H
#define VECTORS_H

extern int rveclen;
extern int dveclen;
extern int veclen;

void
vinsert(rlist *, unsigned int);

int
vin(rlist, unsigned int);

void
number_rtls(void);

void
dinsert(rlist *, unsigned short);

int
din(rlist, unsigned short);

int
number_basic_blocks(void);

void
runion(rlist *, rlist);

int
runiond(rlist *, rlist, rlist);

int
rcommon(rlist, rlist);

void
rinsert(char *, rlist *);

void
rins(unsigned int, rlist *);

void
rdelete(char *, rlist *);

void
rdel(unsigned int, rlist *);

void
rcpy(rlist *, rlist);

void
reget(rlist, char *);

int
rexists(char *, rlist);

int
rin(unsigned int, rlist);

int
raliasin(char *, rlist);

int
rempty(rlist);


void
dinter(dvector, dvector);

void
ddelete(dvector *, unsigned short);

dvector
dall(void);

void
dcpy(dvector *, dvector);

int
dcmp(dvector, dvector);

void realloc_vectors(int old_vlen, int new_vlen);
void realloc_dvectors(int old_vlen, int new_vlen);
void vec2char(vector vec, char *c_vec);

#endif /* VECTORS_H */
