/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/vpo.h,v $
 $Date: 2004/01/29 01:06:31 $
 $Revision: 1.63 $
 $Name:  $

 Log of changes:

 $Log: vpo.h,v $
 Revision 1.63  2004/01/29 01:06:31  clc5q
 Add a blockCount field to struct loopl.

 Revision 1.62  2004/01/21 18:40:04  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.61  2003/12/16 22:15:29  clc5q
 Add struct locuse field PadBytes.

 Revision 1.60  2003/11/18 01:59:13  clc5q
 Add call_graph_node pointer to struct varl for global profiling use.

 Revision 1.59  2003/11/04 15:58:35  clc5q
 Add a name field to struct DataProfile for use by global profiling.
 Add DeallocateDataProfile() for use by global profiling.

 Revision 1.58  2003/10/05 12:14:35  clc5q
 Export process_metaline() for callgraph use.

 Revision 1.57  2003/09/02 18:55:58  jdh8d
 *** empty log message ***

 Revision 1.56  2003/09/02 15:52:58  jdh8d
 undoing broken changes

 Revision 1.54  2003/08/19 19:34:05  jdh8d
 changes to make tms320c54x better (ease, etc)

 Revision 1.53  2003/07/29 21:11:18  jg9h
 Added regs_in field to loopl structure.

 Revision 1.52  2003/07/17 04:33:39  jg9h
 VISTA update

 Revision 1.51  2003/07/07 18:58:52  jg9h
 Added UNREPEATABLE/MAYBE_UNREPEATABLE flags

 Revision 1.50  2003/07/03 23:59:43  clc5q
 Add the PlacementPartition field to struct locuse to support data placement
     optimizations.

 Revision 1.49  2003/04/23 16:37:29  clc5q
 Add "struct varl" type and "struct DataProfile" type. Add the "prof" pointer
     to a struct DataProfile in each basic block so that we can record data
     profiling information.

 Revision 1.48  2003/04/09 20:54:54  clc5q
 Link each ignode and basic block to the loops that contain it.

 Revision 1.47  2003/04/04 04:23:04  jg9h
 Deleted duplicate equivnum declaration within INTERACT

 Revision 1.46  2003/04/03 20:06:12  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.45  2003/03/12 15:35:09  jdh8d
 *** empty log message ***

 Revision 1.44  2003/02/06 04:48:22  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.43  2002/10/28 18:39:45  clc5q
 Add load coalescing fields to struct locuse.

 Revision 1.42  2002/10/11 17:51:29  clc5q
 Fix MIPS compile/link errors. Add externs to headers. 

 Revision 1.41  2002/08/08 18:57:38  clc5q
 Add new field addr_mode to struct locuse for use in rearranging stack
 variables.

 Revision 1.40  2002/07/16 19:40:13  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.39  2002/07/11 15:21:13  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.38  2002/06/09 20:30:27  jdh8d
 *** empty log message ***

 Revision 1.37  2002/06/05 20:08:54  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.36  2002/04/22 16:03:08  jwd
 Fixed some spelling errors in a comment.

 Revision 1.35  2002/03/26 02:46:30  rv3s
 New macro for optimizer warnings added

 Revision 1.34  2002/03/25 17:17:41  rv3s
 Added prototype for remove_null_rtls

 Revision 1.33  2002/02/12 17:15:19  rv3s
 *** empty log message ***

 Revision 1.32  2002/02/12 17:03:10  rv3s
 Invocation limit (per func) placed for CSE to prevent flipping

 Revision 1.31  2002/01/30 19:53:28  jdh8d
 *** empty log message ***

 Revision 1.30  2001/12/29 13:40:03  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.29  2001/12/18 15:08:30  rv3s
 New array all_lnks added to the rtl structure to hold both safe and unsafe links

 Revision 1.28  2001/11/27 20:37:12  rv3s
 New fields loop_peeking_done and lv_freq added to interference graph node to avoid multiple frequency counting and following LVA frequency counting (respectively). The macro CHAIN is now a function call is_chain that looks for a block with only one RTLINE (or an empty BB with no RTLINEs)

 Revision 1.27  2001/11/16 15:12:20  rv3s
 The CHAINS macro modified to use only_one_useful_rtl() to look for a block
 with just a jump statement

 Revision 1.26  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.25  2001/10/16 15:07:14  jdh8d
 *** empty log message ***

 Revision 1.24  2001/08/21 23:29:42  jdh8d
 *** empty log message ***

 Revision 1.23  2001/07/27 20:57:39  jdh8d
 *** empty log message ***

 Revision 1.22  2001/07/20 15:48:50  jdh8d
 *** empty log message ***

 Revision 1.21  2001/07/16 17:43:48  jdh8d


 Add a new type of rtl.  METADATALINE.  VPO ignores the
 assuming that the meta-data is used by the machine
 dependent portions.  Later, machine-independent meta-data
 may become available.  None-so-far.

 Revision 1.20  2001/06/06 22:34:31  rv3s
 Support for WIN32

 Revision 1.19  2001/05/30 18:44:36  jdh8d
 *** empty log message ***

 Revision 1.18  2001/05/24 14:54:23  jdh8d
 *** empty log message ***

 Revision 1.17  2001/05/23 20:28:22  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.16  2001/05/09 19:36:27  jdh8d
 *** empty log message ***

 Revision 1.15  2001/04/15 21:49:43  jdh8d
 *** empty log message ***

 Revision 1.14  2001/04/13 21:49:53  jdh8d
 *** empty log message ***

 Revision 1.13  2001/04/10 16:42:34  rv3s
 *** empty log message ***

 Revision 1.12  2001/04/09 16:05:58  rv3s
 Size of NEW_BIGSTRING reduced to 12000 since we do not allow equivalence table entries of more than ITEM_SIZE_LIMIT

 Revision 1.11  2001/04/09 15:48:42  jdh8d

 Debugging w/o DISPOSE turned on.

 Revision 1.10  2001/03/13 19:33:42  rv3s
 Increased BIGSTRING to handle really long rtls. Added NEW_BIGSTRING to fix buffer size problems in CSE

 Revision 1.8  2000/10/18 02:32:56  jwd
 Added memChar to the local variable definition record.  This tracks
 the memory type of the local variable.  This is now different from
 the memtype which is used to determine what type of register can
 hold this type of local variable.  For example, on the SPARC a short
 local variable ('W' type of memory) is held in an 'r' register.

 Revision 1.7  2000/06/09 19:51:44  jwd
 Added PARMLINE type.  Changed the type field in struct list
 to be an unsigned integer (to accommodate more types).

 Revision 1.6  1999/01/06 15:54:35  jwd
 Originally the side effect field was used to hold the initial dead list
 which was a string. During initialization, the SE field was converted
 to a bit vector representation and SE was used for real side effects.
 This caused numerous problems (with VET and other phases). A
 new field (InitialDeads) was added to hold the initial list of dead
 registers.
 Revision 1.5  1998/06/26 21:07:26  jwd
 Added the ARGBLINE to the RTL line types.
 Revision 1.4  1998/04/29 19:23:45  jwd
 Changed FT to FALLTHRU to avoid a conflict with two letter
 constants in scan.h.
 Revision 1.3  1998/04/03 18:20:47  jwd
 First ANSI C version.

*************************************************************************/

#ifndef VPO_H
#define VPO_H

#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <string.h>

extern char *memprt;  /* avoid circular include with assign.h */

#ifdef INTERACT
extern int user_directed, save_trans, limited_scope, measure_init;
extern int transform_sanity_check;
extern int phase_sanity_check;
extern unsigned int trans_done;
#endif

#ifndef MAXSTRING

/*#define MAXSTRING 400*//* Longest string length for common processing */

/* Changed by raja */
#define MAXSTRING 1000
#endif

#ifndef BIGSTRING
#ifdef __alpha
#define BIGSTRING 6000  /* Big string, used by common subexpressions */
#else

/* Following changes by Raja */

/*#define BIGSTRING 2000 *//* Big string, used by common subexpressions */
#define BIGSTRING 10000
#define NEW_BIGSTRING 120000
#endif
#endif

#ifdef __alpha
#ifndef HUGESTRING
#define HUGESTRING 10000        /* Huge string, used by common subexpr. */
#endif
#endif

#ifndef MAXRTS
#define MAXRTS 12       /* Max effects per RTL, including side effects */
#endif

#ifndef MAXLINKS
#define MAXLINKS 10     /* Maximum number of combiner links per line */
#endif

#ifndef MAXCSUBS
#define MAXCSUBS 16     /* Max number of iterations of the CSE phase */
#endif

#ifndef MAXXFER
#define MAXXFER 8       /* Max number of RTLs to perform a transfer */
#endif

#define REGSTRING 10    /* Largest string length needed to hold register */
#define MAXCHARS 256    /* Maximum number of different characters */
#define MAXLOOPS 1024   /* Maximum loop nesting depth */
#define ESIZE 64        /* Equivalence list hash table size (power of 2) */
                            /* Also, it must be >= 64 */
#define MAXOPTIONS 64   /* Maximum number of debug options */

#define TRUE 1
#define FALSE 0

#define NOTUSED        0        /* Hardware register status types */
#define USED     (1 << 1)       /* Assigned to a pseudo register */
#define FOLLOWER (1 << 2)       /* This reg is part of a pair or triple */
#define CONFLICT (1 << 3)       /* There is a conflict at this register */

#define UNASSIGNED 0    /* Pseudo register status types */
#define REGISTER   1    /* Currently held in a hardware register */
#define TEMP       2    /* Currently spilled */
#define LIVEREG    3    /* Register does not die at this point */

#define NOTYPE -1       /* Local has no declared type */

/*
 * The following items are used to indicate the state of a triple structure
 * during the strength reduction phase.
 */
#define BASIC        (1 << 0)   /* Item is a basic induction variable */
#define INDUCTION    (1 << 1)   /* Item is an induction variable */
#define INDMEM       (1 << 2)   /* Item is an induction variable in mem ref */
#define NOTINDUCTION (1 << 3)   /* Item is not an induction variable */
#define MAYBEIND     (1 << 4)   /* Item may be an induction variable */
#define INAREG       (1 << 5)   /* Item is available in a register */
#define USEDOUT      (1 << 6)   /* Item is used outside the loop */
#define ELIMED       (1 << 7)   /* Item has been eliminated from the loop */
#define AUTOMOV      (1 << 8)   /* Increment moved by auto reference mode */
#ifdef __alpha
#define SIGNEXT      (1 << 9)   /* This induction variable is sign extended */
#endif

/*
 * The following items are used to indicate the warning levels for a
 * memory group partition during the strength reduction and recurrence
 * detection and elimination phases.
 */
#define SR_WARN (1 << 0)        /* Warning applies to strength reduction */
#define ST_WARN (1 << 1)        /* Warning applies to streaming */

/*
 * The following items are used to indicate the state of an item during
 * the coloring global register allocation phase.
 */
#define COLORED    (1 << 0)     /* Item is already colored */
#define MUSTLOAD   (1 << 1)     /* Item must be loaded before using */
#define MUSTSPILL  (1 << 2)     /* Item must be spilled after usage */
#define ISUSED     (1 << 3)     /* Item is used in this life */
#define ISSET      (1 << 4)     /* Item is set in this life */
#define CONSIDERED (1 << 5)     /* Item has been considered as a group */

/*
 * The following items are used to indicate loop exit conditions
 */
#define REL_EQ     1    /* Equal */
#define REL_NE     2    /* Not equal */
#define REL_GT     3    /* Greater-than */
#define REL_LT     4    /* Less-than */
#define REL_GE     5    /* Greater-than-or-equal */
#define REL_LE     6    /* Less-than-or-equal */

/*constants for comparison operators*/
#define CMP_LT '<'
#define CMP_LE '\''
#define CMP_GT '>'
#define CMP_GE '`'
#define CMP_EQ '='
#define CMP_NE '!'
#define CMP_ULT 'l'
#define CMP_ULE 's'
#define CMP_UGT 'h'
#define CMP_UGE 'g'

/*
 * The following items are used in the "type" fields of "list" structures
 * to indicate what is contained in an input line.
 * NOTE: This field is currently a short.  It probably needs to grow.
 */
#define RTLINE     (1 << 0)     /* Line contains a register transfer        */
#define ASMLINE    (1 << 1)     /* Line contains an item for the assembler  */
#define TRASHLINE  (1 << 2)     /* Contains a trash item for the CSE phase  */
#define USELINE    (1 << 3)     /* Contains a register used item            */
#define RESLINE    (1 << 4)     /* Contains a register reserve item         */
#define COMMENT    (1 << 5)     /* Line contains a comment                  */
#define COMBCHECK  (1 << 6)     /* Used to check for circular links         */
#define FUNCNAME   (1 << 7)     /* Used to keep track of the entry point    */
#define CASELINE   (1 << 8)     /* Line contains a case table entry         */
#define SETLINE    (1 << 9)     /* Line contains a list of registers set    */
#define CSLINE     (1 << 10)    /* Callersave registers line                */
#define ARGBLINE   (1 << 11)    /* Argument build area size line            */

#define DELAYLINE  (1 << 12)    /* Line should not be emitted until the end */
#define ARGLINE    (1 << 13)    /* RTL loads an argument into a register    */
#define SIDEFFECT  (1 << 14)    /* Side effect for line has been determined */
#define COMBLINE   (1 << 15)    /* Line is marked for combiner's attention  */
#define PARMLINE   (1 << 16)    /* Line contains register parameters read 
                                 * by callee */
#define METADATALINE (1<<17)    /* a line that contains metadata; ptr->val
                                 * contains the payload */

#ifdef INTERACT
#define IGNORE_RTL (1<<18)
#define DELETE_RTL (1<<19)
#define UNROLL_BLOCK (1<<20)
#endif

#define BASETYPE(t)  (t&~(COMBLINE|SIDEFFECT))

/*
 * The following items are used in the "status" field of "bblock" structures
 */
#define JUMP     (1 << 0)       /* Block contains a direct jump as last RTL */
#define FALLTHRU (1 << 1)       /* The block above us falls through to us   */
                            /* Room to grow--but keep it inside a short     */
                            /* If new status types are added which are      */
                            /* meant to be pervasive, they must also be     */
                            /* added to the definition of CLEAR.            */
#define UNDONE  (1 << 11)       /* Used for register allocation and CSE     */
#define DONE    (1 << 12)       /* Block has been processed by  CSE phase   */
#define WAITING (1 << 13)       /* Block awaiting processing by CSE phase   */
#define DORMANT (1 << 14)       /* Block waiting for predecessors to finish */
#define DRYRUN  (1 << 15)       /* Block has been examined once in dryrun   */
#define USE_LR_DONE (1 << 16)   /* Block has been processed by the
                                 * live_range_set phase                     */
#define SET_LR_DONE (1 << 17)   /* Block has been processed by the
                                 * live_range_use phase                     */
#define UNROLLED (1 << 18)      /* Block is the header of a loop which has
				   been unrolled                            */
/* This mask identifies the pervasive status */
#define CLEAR  (JUMP | FALLTHRU | UNROLLED)        

/*
 * The following items are used in the "kind" field of "list" structures.
 * These items are the machine-independent items that must be appropriately
 * set by all machine descriptions.  Machine-dependent items may be defined
 * for specific target machines provided that they use bits that are not
 * defined here.
 */
#define BASEINST       1023     /* Lower 10 bits are reserved for base kind */
                            /* Bits 10 through 19 reserved for the machine
                             * dependent portion of the scheduler           */

#define UNREPEATABLE_SINGLE	(1 << 21)    /* This instruction cannot come in a repeat single */
#define UNREPEATABLE		(1 << 22)    /* This instruction cannot come in a repeat block */
#define MAYBE_UNREPEATABLE	(1 << 23)    /* This instruction is unrepeatable, but may disappear
						when the block is converted to a repeat block */

#define NOMOVE    (1 << 24)     /* Do not move this item into a delay slot  */
#define DTAKEN    (1 << 25)     /* May delay on the taken branch path       */
#define DNOTAKEN  (1 << 26)     /* May delay on the not taken branch path   */
#define DBOTH     (1 << 27)     /* May delay on both the taken and untaken  */
#define READY     (1 << 28)     /* RTL has already been placed in ready set */
#define TAKEN     (1 << 29)     /* Execute instruction only if branch taken */
#define NOTAKEN   (1 << 30)     /* Execute instruction only if not taken    */
#define LOCREF    (1 << 31)     /* RTL has reference to a local identifier  */

#define BASEKIND(k) (k&~(NOMOVE|DTAKEN|DNOTAKEN|DBOTH|READY|TAKEN|NOTAKEN))

/*
 * The following items are used in the "memtype" field of an "eqvlist"
 * structure to indicate what types of memory items a particular memory
 * reference might touch.
 */
#define NOMEM            0      /* Item contains no memory references       */
#define SPILLMEM   (1 << 0)     /* Item contains a spill location reference */
#define STACKMEM   (1 << 1)     /* Item references argument-passing stack   */
#define LOCALMEM   (1 << 2)     /* Item contains a local memory reference   */
#define GLOBALMEM  (1 << 3)     /* Item contains a global memory reference  */

/*
 * The following items are used for fast freeing and reclaiming of data
 */
#define BBLOCKTYPE    0
#define LISTTYPE      1
#define EQVTABLETYPE  2
#define EQVLISTTYPE   3
#define BLISTTYPE     4
#define LOOPLTYPE     5
#define LLISTTYPE     6
#define ITRIPLETYPE   7
#define MEMGROUPTYPE  8
#define MEMITEMTYPE   9
#define IGNODETYPE   10
#define CONFLICTTYPE 11
#define VECTORTYPE   12
#define RLISTTYPE    13
#define MRVECTORTYPE 14
#define PHITYPE      15
#define PHILISTTYPE  16
#define DEFNODETYPE  17

#ifdef INTERACT
#define UNDOTYPE     18
#define LORDERTYPE   19
#define LISTLTYPE    20
#define ENDFREETYPES 21    /* Always last--used to declare an array */

#else
#define LISTLTYPE    18
#define ENDFREETYPES 19    /* Always last--used to declare an array */

#endif

/*
 * The following items are used to indicate to dump_function() which items
 * should be displayed during a debug output.
 */
#define SHOW_NORMAL         0   /* Show a normal display with no information */
#define SHOW_LABELS   (1 << 0)  /* Show all basic block labels               */
#define SHOW_STATUS   (1 << 1)  /* Show basic block status                   */
#define SHOW_BNUM     (1 << 2)  /* Show basic block bit vector position      */
#define SHOW_CLASS    (1 << 3)  /* Show basic block equivalence class number */
#define SHOW_FREQ     (1 << 4)  /* Show basic block execution frequency      */
#define SHOW_ESTIMATE (1 << 5)  /* Show basic block execution estimate       */
#define SHOW_LOOP     (1 << 6)  /* Indicate which blocks are the loop heads  */
#define SHOW_UP       (1 << 7)  /* Show basic block output order list        */
#define SHOW_DFS      (1 << 8)  /* Show depth-first-search list              */
#define SHOW_PARENT   (1 << 9)  /* Show depth-first-search parent            */
#define SHOW_DOM      (1 << 10) /* Show immediate dominator & semidominator  */
#define SHOW_SUCCS    (1 << 11) /* Show basic block successor links          */
#define SHOW_PREDS    (1 << 12) /* Show basic block predecessor links        */
#define SHOW_FRONTIER (1 << 13) /* Show basic block dominance frontier       */
#define SHOW_USE      (1 << 14) /* Show basic block use list                 */
#define SHOW_DEF      (1 << 15) /* Show basic block def list                 */
#define SHOW_OUT      (1 << 16) /* Show basic block out list                 */
#define SHOW_SETS     (1 << 17) /* Show basic block assignment items         */
#define SHOW_PHI      (1 << 18) /* Show the phi functions in the basic block */
#define SHOW_NONRTLS  (1 << 19) /* Show the non-RTL items in the basic block */
#define SHOW_COST     (1 << 20) /* Show cost information for each RTL        */
#define SHOW_SE       (1 << 21) /* Show side effect information for each RTL */

#ifdef INTERACT

/*
 * The following represent the different possible types of transformations
 * that can be performed.
 */
#define PROBABILISTIC_BATCH        -50   /* apply sequence based on prob.    */
#define PROFILE_FUNC_LOG           -46   /* log sequence if active           */
#define PROFILE_FUNC_SAVE          -45   /* store function instance in mem   */
#define PROFILE_FUNC_OPT           -44   /* new optimization sequence        */
#define PROFILE_FUNC_BASE          -43   /* base sequence                    */
#define PROFILE_FUNC               -42   /* delimit profiling commands       */
#define EX_DFS_END                 -38   /* denotes end of ex. dfs. algo.    */
#define EX_DFS                     -37   /* DFS exhaustive search            */
#define EX_DFS_INIT                -36   /* initialize DFS exhaustive search */
#define EX_DFS_REINIT              -35   /* steps during restarting search   */
#define IND_SEQ_INIT               -33
#define IND_SEQ_MEASURE            -32
#define BATCH_COMP_OPT             -31   /* execute batch optimization seq   */
#define VERIFY_HAND_TRANS          -30   /* verify hand transform msgs       */
#define DE_OPTIMIZE_FUNC           -29   /* de-optimize the current function */
#define IF_LOOP_FALSE_GOTO_TRANS   -28   /* check condition for while loops  */
#define END_LOOP                   -27   /* indicates end of loop            */
#define BEGIN_LOOP                 -26   /* indicates begining of loop       */
#define CHANGE_TEST_CONFIG         -25   /* modify info in the config file   */
#define GOTO                       -23   /* unconditional jump               */
#define END_COMBINATION            -22   /* end of sequence                  */
#define SELECT_BEST_COMBINATION    -21   /* iterate over this set            */
#define DONE_SELECT                -20   /* Select best sequence over        */
#define NEXT_SEQUENCE              -19   /* next optimization sequence       */
#define SELECT_BEST_SEQUENCE       -18   /* select best optimization seq     */
#define START_MEASUREMENT          -16   /* start measurements               */
#define STOP_MEASUREMENT           -17   /* stop measurements                */
#define FREQUENCY_REQ              -15   /*request for execution measurements*/
#define SANITY_CHECK_REQ           -14   /* request for a sanity check       */
#define BLOCK_QUERY                -13   /* query for basic block info       */
#define LIVE_REGS_QUERY            -11   /* query for live register info     */
#define LOOPS_QUERY                -10   /* get a loops query                */
#define UNDO_CHANGE                -9    /* undo a certain number of changes */
#define HAND_TRANS                 -8    /* hand specified transformation    */
#define INSERT_UNDO_STOP           -7    /* used to implement an undo oper   */
#define CMP_FILES_TRANS            -6    /* compare files for equality       */
#define WRITE_RTLS_TRANS           -5    /* write RTLs to a file             */
#define UNDO_TRANS                 -4    /* undo transformations             */
#define IF_FALSE_GOTO_TRANS        -3    /* if no changes branch via offset  */
#define IF_LOOP_TRUE_GOTO_TRANS    -2    /* if changes branch via offset     */
#define QUIT_TRANS                 -1    /* no more trans in this sequence   */
#define STOP_TRANS                 -100  /* no more trans for the function   */
#define NEXT_FUNC                  -99   /* proceed to the next function     */
#define IGNORE_COMMAND              0
#define BRANCH_CHAINING_TRANS       1
#define ELIM_EMPTY_BLOCKS_TRANS     2
#define USELESS_JUMP_ELIM_TRANS     3
#define DEAD_CODE_ELIM_TRANS        4
#define REVERSE_BRANCHES_TRANS      5
#define BLOCK_REORDERING_TRANS      6
#define MERGE_BLOCKS_TRANS          7
#define INST_SELECT_TRANS           8
#define FIX_CONTROL_FLOW_TRANS      9
#define EVAL_ORDER_DETER_TRANS     10
#define GLOBAL_INST_SELECT_TRANS   11
#define REG_ASSIGNMENT_TRANS       12
#define MINIMIZE_LOOP_JUMPS_TRANS  13
#define DEAD_ASG_ELIM_TRANS        14
#define REG_ALLOCATION_TRANS       15
#define COMMON_SUBEXPR_ELIM_TRANS  16
#define CODE_MOTION_TRANS          17
#define LOOP_STRENGTH_REDUCT_TRANS 18
#define RECURRENCE_ELIM_TRANS      19
#define INDUCT_VAR_ELIM_TRANS      20
#define STRENGTH_REDUCT_TRANS      21
#define FIX_ENTRY_EXIT_TRANS       22
#define INST_SCHED_TRANS           23
#define FILL_DELAY_SLOTS_TRANS     24
#define ALL_LOOP_TRANS             25   /* perform all loop transforms      */
#define PREDICATION_TRANS	   26
#define AVOID_UJUMP_TRANS          31
#define CROSS_JUMP_TRANS           27
#define REG_RENAME_TRANS           30

#ifdef DEOPT
#define DEOPT_REG_ALLOC_TRANS      27    /* Deoptimize register allocation */
#define COALESCE_FP_MOVES_TRANS    30
#define DEOPT_LOOP_INV_CDMOTION_TRANS 28 /* Deoptimize loop inv. code motion */
#endif /*DEOPT*/

#define HAND_TRANS_NUMBER          28
#define LOOP_UNROLL_TRANS          29
#define NUM_TRANS_TYPES            32
#define DEBUG_TRANS                27   /* for sending info to viewer */
#define USELESSCONDS_TRANS         29

/*
 * The following represent the types of transformations as bit positions.
 */
#define BRANCH_CHAINING_BIT        (1 << BRANCH_CHAINING_TRANS)
#define ELIM_EMPTY_BLOCKS_BIT      (1 << ELIM_EMPTY_BLOCKS_TRANS)
#define USELESS_JUMP_ELIM_BIT      (1 << USELESS_JUMP_ELIM_TRANS)
#define DEAD_CODE_ELIM_BIT         (1 << DEAD_CODE_ELIM_TRANS)
#define REVERSE_BRANCHES_BIT       (1 << REVERSE_BRANCHES_TRANS)
#define BLOCK_REORDERING_BIT       (1 << BLOCK_REORDERING_TRANS)
#define MERGE_BLOCKS_BIT           (1 << MERGE_BLOCKS_TRANS)
#define INST_SELECT_BIT            (1 << INST_SELECT_TRANS)
#define FIX_CONTROL_FLOW_BIT       (1 << FIX_CONTROL_FLOW_TRANS)
#define EVAL_ORDER_DETER_BIT       (1 << EVAL_ORDER_DETER_TRANS)
#define GLOBAL_INST_SELECT_BIT     (1 << GLOBAL_INST_SELECT_TRANS)
#define REG_ASSIGNMENT_BIT         (1 << REG_ASSIGNMENT_TRANS)
#define MINIMIZE_LOOP_JUMPS_BIT    (1 << MINIMIZE_LOOP_JUMPS_TRANS)
#define DEAD_ASG_ELIM_BIT          (1 << DEAD_ASG_ELIM_TRANS)
#define REG_ALLOCATION_BIT         (1 << REG_ALLOCATION_TRANS)
#define COMMON_SUBEXPR_ELIM_BIT    (1 << COMMON_SUBEXPR_ELIM_TRANS)
#define CODE_MOTION_BIT            (1 << CODE_MOTION_TRANS)
#define LOOP_STRENGTH_REDUCT_BIT   (1 << LOOP_STRENGTH_REDUCT_TRANS)
#define RECURRENCE_ELIM_BIT        (1 << RECURRENCE_ELIM_TRANS)
#define INDUCT_VAR_ELIM_BIT        (1 << INDUCT_VAR_ELIM_TRANS)
#define STRENGTH_REDUCT_BIT        (1 << STRENGTH_REDUCT_TRANS)
#define FIX_ENTRY_EXIT_BIT         (1 << FIX_ENTRY_EXIT_TRANS)
#define INST_SCHED_BIT             (1 << INST_SCHED_TRANS)
#define FILL_DELAY_SLOTS_BIT       (1 << FILL_DELAY_SLOTS_TRANS)
#define COALESCE_FP_MOVES_BIT      (1 << COALESCE_FP_MOVES_TRANS)
#define PREDICATION_BIT		   (1 << PREDICATION_TRANS)
#define AVOID_UJUMP_BIT            (1 << AVOID_UJUMP_TRANS)
#define LOOP_UNROLL_BIT            (1 << LOOP_UNROLL_TRANS)
#define CROSS_JUMP_BIT             (1 << CROSS_JUMP_TRANS)
#define ALL_LOOP_BIT               ( (1 << CODE_MOTION_TRANS)|(1 << LOOP_STRENGTH_REDUCT_TRANS)|(1 << RECURRENCE_ELIM_TRANS)|(1 << INDUCT_VAR_ELIM_TRANS)|(1 << ALL_LOOP_TRANS) )

#define IS_LOOP_TRANS(x) ((x) & (MINIMIZE_LOOP_JUMPS_BIT|CODE_MOTION_BIT|LOOP_STRENGTH_REDUCT_BIT|RECURRENCE_ELIM_BIT|INDUCT_VAR_ELIM_BIT))

#define IS_BLOCK_TRANS(x) ((x) & (BRANCH_CHAINING_BIT|ELIM_EMPTY_BLOCKS_BIT|USELESS_JUMP_ELIM_BIT|REVERSE_BRANCHES_BIT|BLOCK_REORDERING_BIT|MERGE_BLOCKS_BIT|EVAL_ORDER_DETER_BIT))

#define IS_RTL_TRANS(x) ((x) & (INST_SELECT_BIT|GLOBAL_INST_SELECT_BIT|STRENGTH_REDUCT_BIT))

#define ONCE_TRANS(x) ((x) & (REG_ASSIGNMENT_BIT|FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT|LOOP_UNROLL_BIT))

#define NECESSARY_TRANS(x) ((x) & (REG_ASSIGNMENT_BIT|FIX_ENTRY_EXIT_BIT))

#endif /*INTERACT*/

/*
 * The following represent the different types of analysis that is invoked
 * from the high level optimize function.
 */
#define LOCAL_LINK_ANALYSIS         (1 << 0)
#define GLOBAL_LINK_ANALYSIS        (1 << 1)
#define LIVE_VAR_ANALYSIS           (1 << 2)
#define DOMINATOR_ANALYSIS          (1 << 3)
#define LOOP_ANALYSIS               (1 << 4)
#define EXEC_FREQ_ANALYSIS          (1 << 5)
#define REGS_USED_ANALYSIS          (1 << 6)
#define DEPTH_FIRST_SEARCH_ANALYSIS (1 << 7)
#define DEAD_VAR_ANALYSIS           (1 << 8)
#define LOOP_INVARIANT_ANALYSIS     (1 << 9)
#define CALC_STATUS_ANALYSIS        (1 << 10)
#define COUNT_LOCAL_REFS            (1 << 11)
#define MERGE_BLOCKS_ANALYSIS       (1 << 12)
#define ELIM_EMPTY_BLOCKS_ANALYSIS  (1 << 13)
#define RECALC_PREDS                (1 << 14)
#define DEAD_CODE_ANALYSIS          (1 << 15)
#define NUM_ANALYSIS_TYPES          16


/*
 * STATUS macro will set a temporary status while preserving the pervasive ones
 */
#define STATUS(cblk, st) ((cblk)->status = ((cblk)->status & CLEAR) | st)

/*
 * ISBASE macro returns the base kind of an instruction
 */
#define ISBASE(ptr, inst) (((ptr->kind) & BASEINST) == inst)

/*
 * Hash function for CSE
 */
#define hash(type) (((int) *(type)) & (ESIZE - 1))

/*
 * The following items deal with register mapping
 */
#define HARDWARE   (1 << 0)     /* Hardware register type indicator      */
#define SCRATCH    (1 << 1)     /* Scratch register type indicator       */
#define FIFOREG    (1 << 2)     /* FIFO register type indicator          */
#define STACKREG   (1 << 3)     /* Stack register type indicator         */

/*
 * The following items are often used macros
 */

/* "cnts" returns contents of an RTL, if it is an RTLINE; NULL otherwise */
#define cnts(ptr) ((ptr && (ptr->type & RTLINE)) ? ptr->val : (char *) NULL)

/* is "c" an operator (+, -, etc.) ? */
#define isoper(c) opers[(unsigned char) c]

/* is "t" a memory reference ? */
#define memrf(t) memprt[t]

#define rinit() ((rlist) NULL)
#define dinit() ((dvector) NULL)
#define vinit() ((vector) NULL)
#define reginit() ((regvec) NULL)

/* Prevent infinite iteration of optimizations, e.g. CSE, by limiting
 * the invocations to ITER_LIMIT. */
#define ITER_LIMIT	50

typedef unsigned int *rlist;    /* register list type            */
typedef unsigned int *vector;   /* RTL list type                 */
typedef unsigned int *dvector;  /* basic block list type         */
typedef unsigned int *regvec;   /* pointer to register status    */
 
/* structure for frequency counts */
struct freq_counts {
  int count;
  struct freq_counts *next;
};
 
#define MAXCMDS 1000
#define MAX_HAND_TRANS_LEN 200
#define MAXSCOPEITEMS 100
 
struct command {
   int oper;                      /* operation to perform       */
   int offset;                    /* offset for branches        */
   int rtl_id;                    /* used for live reg query    */
   int block_id;                  /* used for live reg query    */
   char hand_msg[MAX_HAND_TRANS_LEN];
                                  /* for hand trans use         */

   /*numscope and blocks are used for restricting scope*/
   int numscope;                  /* number of scope items used
                                     for restricting the scope
                                     to apply optimization      */
   int blocks[MAXSCOPEITEMS];      /* blocks to apply trans     */
   char filename1[MAXSTRING];      /* filename                  */
   char filename2[MAXSTRING];      /* filename                  */
};

struct listl {
   struct loopl *ptr;
   struct listl *next;
};

struct call_graph_node;

/* Accessed local variables chain within a basic block. */
struct varl {
   int index;        /* Index into a Locals[] array of struct locuse ptrs. */
   char *name;       /* Name of local (or function in global profiling.) */
   struct varl *next;
   struct call_graph_node *cgnode; /* For functions in global profiling. */
};

struct DataProfile {
   float LeftEdgeWeight;
   float RightEdgeWeight;
   int   CaseFlag;          /* TRUE -> (blk->rtlend->type & CASELINE) */
   int   LeftBackEdgeFlag;  /* TRUE -> (blk to left edge is a back edge) */
   int   RightBackEdgeFlag; /* TRUE -> (blk to right edge is a back edge) */
   struct varl *FirstLocal;   /* First local referenced in block */
   struct varl *LastLocal;    /* Last local referenced in block */
};

/* Basic blocks; kept as multiply linked list. */
struct bblock {
    struct bblock *next;          /* links all outstanding blocks  */
    struct bblock *left;          /* unconditional successor       */
    struct bblock *right;         /* conditional successor         */
    struct blist *preds;          /* links back to predecessors    */
    struct bblock *up;            /* previous block for output     */
    struct bblock *down;          /* next block for output         */
    struct bblock *idom;          /* immediate dominator           */
    struct bblock *sdom;          /* semidominator of this block   */
    struct bblock *prev_dfs;      /* previous depth-first-search   */
    struct bblock *next_dfs;      /* next depth-first-search       */
    struct bblock *parent_dfs;    /* our parent in the dfs tree    */
    struct blist *dom_front;      /* dominance frontier            */
    char *label;                  /* block label, if any           */
    int status;        		  /* status of basic block         */
    unsigned short freq;          /* loop nesting level of block   */
    unsigned short bnum;          /* bit vector location of block  */
    unsigned int dnum;            /* debug display number of block */
    float estimate;               /* estimate of times executed    */
    struct list *rtls;            /* pointer to first RTL in block */
    struct list *rtlend;          /* pointer to last RTL in block  */
    struct loopl *loop;           /* loop information structure    */
    rlist ulist;                  /* uses for this basic block     */
    rlist dlist;                  /* defs for this basic block     */
    rlist olist;                  /* outs for this basic block     */
    struct phi *phi_funcs;        /* SSA form phi functions at top */
    struct defnode *sets_out;     /* assignments defined in block  */
    regvec regstate;              /* register assignment info      */
    struct eqvtable *elist;       /* equivalence list for block    */
    struct ignode *conin;         /* "in" conflicts list           */
    struct ignode *conout;        /* "out" conflicts list          */
    struct listl *looplist;       /* list of loops containing bblock */
    struct DataProfile *prof;     /* data profiling info for block */
    int block_id;                 /* uniquely identifies the block */
#ifdef WIDES
    struct bblock *dup;
#endif
#if defined(MEASURE) || defined(INTERACT)
    dvector dom;                  /* blocks that dominate this one */
#endif
#ifdef MEASURE
   dvector equivclass;          /* blocks in equivalence class   */
#endif
#ifdef WIDES
    struct alist *ainfo;
#endif
#ifdef INTERACT
    short inscope;                /* is trans applied to block?    */ 
#endif
  
#ifdef INTERACT
    /*
     * To store the undo information.  Now routines that save the
     * old values of these fields can be invoked either before or
     * after the regular fields have been updated.  This does waste
     * space, but it simplifies the placement of the calls to save
     * this information.
     */
    struct bblock *old_next;        /* old links to the next block */
    struct bblock *old_left;        /* old unconditional successor */
    struct bblock *old_right;       /* old conditional successor   */
    struct bblock *old_down;        /* old down block for output   */
    struct bblock *old_up;          /* old up block for output     */  
    struct list *old_rtls;          /* old pointer to first RTL    */
    struct list *old_rtlend;        /* old pointer to last RTL     */
    int frequency;                  /* block instruction exec. count */
#endif
#ifdef MEASURE
	/* this is needed for interact and measure codes */
    int equivnum;                   /* equivalence class number      */
#endif
#ifdef DEOPT
     struct rig_node *blkins;        /* RIG nodes coming into the block */
     struct rig_node *blkouts;       /* RIG nodes going out of the block */
#endif 
};

/* list of RTLs in a basic block. */
struct list {
   struct bblock *daddy;        /* father block for this RTL     */
   struct list *next;           /* pointer to next RTL           */
   struct list *prev;           /* pointer to previous RTL       */
   char *val;                   /* contents of list in text form */
   char *se;                    /* side effect of line           */
   char *InitialDeads;          /* deads initially read in       */
   rlist deads;                 /* dead registers list           */
   unsigned int type;           /* type of list (its contents)   */
   unsigned short cost;         /* last known cost of the RTL    */
   unsigned int kind;           /* kind of instruction           */
   unsigned int onum;           /* order number given when read  */
   unsigned int rnum;           /* number assigned for output    */
#if SCHED || FILL
   vector uses;                 /* registers used by this RTL    */
   vector sets;                 /* registers set by this RTL     */
   unsigned int does;           /* set of things that RTL does   */
   unsigned int blocks;         /* set of things that block RTL  */
#endif
#ifdef STACHE
   char  *variable;		/* the variable accessed if this instr is
				   a load or store */
   char  *sp_used;		/* if the stack pointer ends up in this
				   RTL, it's a reference to the
				   variable pointed to by sp_used */
#endif
   struct list *lnks[MAXLINKS]; /* combiner "window" links       */
   struct list *blnks[MAXLINKS];/* back links to allow deletions */
   struct list *all_lnks[MAXLINKS];     /* Unsafe + safe links   */

#ifdef INTERACT
    int rtl_id;                   /* uniquely identifies the rtl   */
    /*
     * To store the undo information.  Now routines that save the
     * old values of these fields can be invoked either before or
     * after the regular fields have been updated.  This does waste
     * space, but it simplifies the placement of the calls to save
     * this information.
     */
    struct bblock *old_daddy;     /* old father block for this RTL */
    struct list *old_next;        /* old pointer to next RTL       */
    struct list *old_prev;        /* old pointer to previous RTL   */
    unsigned int old_type;        /* old type of list              */
    unsigned int old_kind;        /* old kind of instruction       */
	 int exit_flag;                  /*exit function called if set    */
#endif
    };

/* list of sets into destination items in an RTL. */
struct setlist {
   char item[REGSTRING];        /* item referenced               */
   int status;                  /* type and status of item       */
   struct setlist *valid;       /* item is currently defined     */
   struct setlist *next;        /* pointer to next item          */
   struct list *sets;           /* last place register was set   */
   struct list *dead;           /* last place register was used  */
   struct list *ldead;          /* last place register died      */
   unsigned int rnum;           /* keeps number of last death    */
   int assign;                  /* register currently allocated  */
   int regstatus;               /* allocation status of register */
   int uses;                    /* times that item is used       */
   unsigned int num;            /* rlist vector position of item */
   struct itriple *triple;      /* triple record for this item   */
   struct locuse *local;        /* information record for locals */
   struct blist *setin;         /* blocks where the item is set  */
};

/* Hash table of equivalence lists. */
struct eqvtable {
   struct eqvlist *used;        /* pointer to defined items      */
   struct eqvlist *eqiv[ESIZE]; /* hash table for referencing    */
   int uses;                    /* blocks that need this list    */
};

/* Equivalence list of equivalent expressions for CSE use. */
struct eqvlist {
   struct eqvlist *next;        /* pointer to next item          */
   struct eqvlist *prev;        /* pointer to previous item      */
   struct eqvlist *nequiv;      /* next equivalence item         */
   struct eqvlist *pequiv;      /* previous equivalence item     */
   struct eqvlist *ndef;        /* pointer to next definition    */
   struct eqvlist *pdef;        /* pointer to previous definition */
   char *item;                  /* item referenced               */
   struct list *sets;           /* outstanding set pointer       */
   struct list *dead;           /* last place register is used   */
   int uses;                    /* number of register uses       */
   int memtype;                 /* memory reference types found  */
   short seen;                  /* flag to facilitate merging    */
   short reg;                   /* item is a register flag       */
};

/* Linked list of basic blocks. */
struct blist {
   struct blist *next;          /* pointer to next predecessor   */
   struct bblock *ptr;          /* pointer to basic block        */
};

#ifdef STACHE
struct stacheable
{
   struct locuse* next;

	/* is this really allocated to the stache */
   unsigned int is_alloced_to_stache:1;	

	/* what benefit is there to allocating to the stache */
   int benefit;			

	/* the stache offset if it's the coloring model */
	int offset;
};
#endif

/* Info about all references to a local variable within a function. */
struct locuse {
   struct locuse *next;         /* pointer to next local record  */
   struct locuse *prev;         /* pointer to previous local rec */
   char *item;                  /* name of item referenced       */
   int level;                   /* declaration level of item     */
   int size;                    /* size of item                  */
   int reps;                    /* reference count of item       */
   int offset;                  /* location (when its up to vpo) */
   char code[REGSTRING];        /* code used for reference       */
   vector olist;                /* occurence list                */
   dvector setin;               /* blocks where variable is set  */
   dvector usedin;              /* blocks where variable is used */
   short nouse;                 /* variable ineligible flag      */
   short type;                  /* declaration type of variable  */
   short atype;                 /* allocation type of variable   */
   short arg;                   /* item is an argument flag      */
   short reg;                   /* assigned to a register flag   */
   short vol;                   /* item is volatile flag         */
   char regin[REGSTRING];       /* register assigned upon entry  */
   char csreg[REGSTRING];       /* callersaves register assigned */
   struct ignode *conptr;       /* pointer to current ignode     */
   short structure;             /* item is a structure           */
   short indref;                /* item has an indirect ref      */
   short addr_mode;             /* machine-dependent: referenced
                                 * from frame pointer, stack pointer,
                                 * always allocated in a register, etc.
                                 */
   short PlacementPartition;    /* Grouping number for data placement. */
   short PadBytes;              /* Padding for alignment. */
   unsigned short CoalescingStatus;  /* Used by machine-dependent load
                                      * coalescing optimizations.
                                      */
   struct locuse *CoalescedLSNeighbor; /* Coalesced local that is always
                                        * in Least Significant address
                                        * direction from this local.
                                        */
   struct locuse *CoalescedMSNeighbor; /* Coalesced local that is always
                                        * in Most Significant address
                                        * direction from this local.
                                        */
   char memChar;                /* char used for a memory reference to this
                                 * variable. Set by locget and used by
                                 * load() and store()
                                 */
#ifdef STACHE
   struct stacheable* stache_data;/* local data for use with the stache */
   int is_stacheable:1;           /* if the optimizer is stache enabled
					                      can this local go into an infinitely
					                      sized stache? */   
#endif
};


/* Info about each register (used in machine-dependent register arrays). */
struct reglist {
   int status;                  /* current status of register    */
   struct setlist *pseudo;      /* pseudo register assigned      */
};

/* Doubly-linked list of loops. */
struct loopl {
   struct loopl *next;          /* pointer to next loop record   */
   struct loopl *prev;          /* pointer to previous loop      */
   struct bblock *ptr;          /* pointer to head block of loop */
   struct bblock *preheader;    /* pointer to preheader of loop  */
   struct blist *blocks;        /* blocks in the loop            */
   struct blist *exits;         /* exit blocks out of the loop   */
   vector regs;                 /* allocation status of the loop */
   vector regs_in;              /* to mark regs used within loop */
   rlist invareg;               /* loop invariant registers      */
   rlist stored;                /* items stored in pre-header    */
   rlist loaded;                /* items loaded at exit points   */
   char iterations[MAXSTRING];  /* Number of times loop executed */
   struct setlist *control;     /* Control variable of the loop  */
   short valid;                 /* TRUE if iterations correct    */
   short invaread;              /* Memory reads are invariant    */
   int blockCount;              /* Number of blocks in the loop. */
};

struct llist {
   struct llist *next;          /* pointer to next item          */
   struct list *ptr;            /* pointer to register transfer  */
   int inc;                     /* amount item is incremented by */
};

struct itriple {
   struct itriple *next;        /* next triple record            */
   int status;                  /* status of this item           */
   struct setlist *family;      /* family of induction variable  */
   struct llist *ref;           /* list of references or uses    */
   struct memgroup *part;       /* partition which includes item */
   int type;                    /* type of register represented  */
   int count;                   /* references to this item       */
#ifdef __alpha
   long cee;                    /* induction value is cee*i+dee  */
#else
   int cee;                     /* induction value is cee*i+dee  */
#endif
   char dee[MAXSTRING];         /* see above                     */
   char pat[MAXSTRING];         /* pattern to look for           */
#ifdef __alpha
   int unalign;                 /* Is the reference a unaligned one */
#endif
};

struct memgroup {
   struct memgroup *next;       /* next memgroup item            */
   char item[MAXSTRING];        /* group identifier item         */
   struct memitem *reads;       /* items that read this group    */
   struct memitem *writes;      /* items that write this group   */
   short warn;                  /* warning flag                  */
#ifdef WIDES
   int ld_sd_rtl;               /* if set, dont examone the part. */
#endif
};

struct memitem {
   struct memitem *next;        /* next memitem in list          */
   struct list *ptr;            /* RTL containing reference      */
   char ref[MAXSTRING];         /* actual reference pattern      */
   char dif[MAXSTRING];         /* difference expression         */
   char mem[MAXSTRING];         /* complete address of item      */
   int ofs;                     /* offset from base item         */
   int aofs;                    /* actual offset from induction  */
   struct itriple *triple;      /* triple of controlling item    */
   short done;                  /* item has been examined flag   */
   short type;                  /* type of memory reference      */
#ifdef WIDES
   int modified;                /* see if the item is modified   */
#endif
};

/* Interference graph node, used in coloring register allocation. */
struct ignode {
   struct setlist *item;        /* local item pointer            */
   short status;                /* current status of this node   */
   short type;                  /* register type needed          */
   int freq;                    /* frequency of usage            */
   struct bblock *ptr;          /* basic block covered by item   */
   struct list *start;          /* first RTL of live range       */
   struct list *end;            /* last RTL of live range        */
   struct conflict *conflicts;  /* conflicts for this item       */
   struct ignode *nsib;         /* next sibling item             */
   struct ignode *psib;         /* previous sibling item         */
   struct ignode *next;         /* next item in graph            */
   struct ignode *prev;         /* previous item in graph        */
   struct ignode *conin;        /* "in" list pointer             */
   struct ignode *conout;       /* "out" list pointer            */
   struct ignode *conprev;      /* "out" list previous pointer   */
   vector regs;                 /* allocation status of item     */
   short loop_peeking_done;     /* Was loop peeking was done for this item */
   int lv_freq;                 /* Actual freq as expected by LVA */
   struct loopl* loop;          /* Loop containing the basic block */
};

struct igsort {
   int freq;                    /* frequency of usage            */
   struct ignode *ptr;          /* pointer to ignode to sort     */
};

struct conflict {
   struct ignode *ptr;          /* pointer to node               */
   struct conflict *next;       /* pointer to next conflict item */
};

struct hreginfo {
   int flags;                   /* register type flags           */
   char name[REGSTRING];        /* register name                 */
};

struct callfunc {
   struct callfunc *next;       /* point to the next item        */
   char name[MAXSTRING];        /* function identifier           */
};

/* SSA phi function. */
struct phi {
   struct phi *next;            /* point to next phi function    */
   struct setlist *item;        /* base item of phi function     */
   struct phi_list *sets;       /* assignment list for phi func  */
};

/* linked list of phi functions. */
struct phi_list {
   struct phi_list *next;       /* point to next phi func item   */
   int type;                    /* type of item referenced here  */
   union {
      struct list *set_rtl;     /* assignment in an RTL item     */
      struct phi *set_phi;      /* assignment in a phi function  */
   } ptr;
};

struct defnode {
   struct defnode *next;        /* point to next definition      */
   struct setlist *item;        /* base item of this definition  */
   struct list *set_rtl;        /* RTL in which item is assigned */
};

#ifdef WIDES
struct alist {
   struct alist *next;
   int aligned;
   char name[MAXSTRING];
   struct bblock *blk;
};

struct mem_cand {
   struct memitem *short_mem;
   int offset;
   struct mem_cand *next;
};
#endif /* WIDES */

/* pull in specs for how big registers/locals/globals are.
 * needed here for defines like GLOBALS.
 * NOTE: There is a circular include problem that dictates that
 * we put this include way down here. rtlspec.h includes regs.h,
 * a machine-dependent header. regs.h references the reglist struct
 * type, defined above. Thus, every module which includes vpo.h
 * will get rtlspec.h and regs.h, and reglist and other struct types
 * need to be visible in regs.h.
 */

#include "rtlspec.h"


#ifdef MUSTALIGN
#define USP_help(s) ((((int) *(s)&0x7f) + (((int) *((s) + 1)&0x7f) << 7))&(MAPREGS - 1))
#else
#define USP_help(s) (*((unsigned short *) (s)) & (MAPREGS - 1))
#endif


#define USP(s) USP_func(s)

static int
USP_func(char *s)
{
   return ((isreg(s) ? (getRegNum(s) | ((getRegType(s) + 3) << 16))
            : (islocal(s) ? (getLocalNum(s) | (1 << 16))
               : (isglob(s) ? (getGlobalNum(s) | (2 << 16)) : USP_help(s))))
           & (MAPREGS - 1));
}


#define regname(r) USP(sets[r].item)
#define regtovec(s) vecmap[USP(s)]
#define pseudoreg(s) (!(sets[vecmap[USP(s)]].status & HARDWARE))
#define scratchreg(s) (sets[vecmap[USP(s)]].status & SCRATCH)
#define fiforeg(s) (sets[vecmap[USP(s)]].status & FIFOREG)
#define stackreg(s) (sets[vecmap[USP(s)]].status & STACKREG)
#define globalname(s)  get_glob_name(s)
#define isDefinedGlobal(s) (vecmap[USP(s)]!=-1)

char *get_glob_name(char *s);

#define localname(s) (sets[regtovec(s)].local->item)
#define localrecord(s) (sets[regtovec(s)].local)
#define s_lookup(s) (sets[regtovec(s)].valid)



extern struct locuse *prev_loc;

/*
 * The following external declarations facilitate the use of the macros
 */
extern char basename[];         /* C file base name without extension. */
extern char *fn;                /* current function name */
extern char *sret;              /* side effect for return label */
extern struct bblock *ret_block; /* return block */
extern struct bblock *top, *bottom; /* top and bottom blocks in func */
extern struct bblock *last;     /* last block by order number */
extern unsigned int gallocptr;  /* global id allocation pointer   */
extern int regallocptr;         /* register vector allocation ptr */
extern int hregnum;				  /* number of hardware registers */

/* Three variables only for VET use. */
extern volatile int moreopts;
extern int maxtrans;
extern jmp_buf my_env;

extern int varargs;             /* were varargs used in this function ? */
extern int LeafFunction;        /* is this function a leaf function ? */

/* File names for STACHE profiling use. */
extern char profileName[];
extern char dataProfileName[];
extern char libraryFilename[];

extern int bitsperint;          /* # bits in an int on this machine */
extern int intscale;
extern int int2char;

extern int d_f_s_count; /* # calls to depth_first_search() */
extern int b_d_t_count; /* # calls to build_dominator_tree() */
extern int c_s_e_count; /* # calls to common_subexpression_elimination() */
extern int f_d_f_count; /* # calls to find_dominance_frontiers() */

#ifdef DISPOSE
extern char *startmem;          /* pointer to start of allocated memory */
#endif

extern char **freeptrs[ENDFREETYPES];
extern int vecmap[MAPREGS];
extern struct setlist sets[MAXRVEC];
extern char globals[GLOBALS];
extern char regprt[MAXSTRING];
extern int opers[MAXCHARS];
extern int mems[MAXCHARS];      /* memory type lookup array */
extern rlist pseudos;           /* vector of pseudo-regs. */
extern char *memprt;

/* Flags.  See vpo.c for further details */
extern int swpa;
extern int swpb;
extern int swpc;
extern int swpd;
extern int swpe;
extern int swpf;
extern int swpg;
extern int swph;
extern int swpi;
extern int swpj;
extern int swpk;
extern int swpl;
extern int swpm;
extern int swpn;
extern int swpo;
extern int swpp;
extern int swpq;
extern int swpr;
extern int swps;
extern int swpt;
extern int swpu;
extern int swpv;
extern int swpw;
extern int swpx;
extern int swpy;
extern int swpz;

extern int swa;
extern int swb;
extern int swc;

extern int swd;
extern int swe;
extern int swf;
extern int swg;
extern int swh;
extern int swi;
extern int swj;
extern int swk;
extern int swl;
extern int swm;
extern int swn;
extern int swo;
extern int swp;
extern int swq;

extern int swr;
extern int sws;
extern int swt;
extern int swu;
extern int swv;
extern int sww;
extern int swx;
extern int swy;
extern int swz;

extern int swtm;  /* for VET use */

#ifdef MEASURE    /* for EASE use */
extern int swef;  /* frequency measurement option   */
extern int swei;  /* trace instruction option       */
extern int swed;  /* trace data option              */
extern int swep;  /* precision timing option        */
#endif

void remove_null_rtls();
void clear_dominators();

#define OPTIMIZER_WARN(x) { \
   if (swq) {  \
      x; \
   }  \
}

extern char* reason;
/* Flags.  See vpo.c for further details */

void process_metaline(char *);
void DeallocateDataProfile(struct bblock *);

#define MAX_BLOCKS        1000
#ifdef INTERACT

#define MAX_BEST_SEQUENCE  50
#define MAX_OPT            50
#define EXHAUSTIVE_SEARCH   1
#define INTELLIGENT_SEARCH  2
#define LEAF_SEARCH         3
#define MAX_JUMPS          10
#define SAME_PSEUDO_REG     2
#define LIVE_REG_STATE      3
#define BATCH_SEQUENCE    (1 << 1)
#define TREE_SEARCH       (1 << 2)
#define USELESS_TRANSFORM (1 << 3)
#define REPEAT_SAME_PHASE (1 << 4)
#define HASHTABLE_SEARCH  (1 << 5)
#define SUCC_HTABLE       (1 << 6)
#define ENABLE_PHASE      (1 << 7)
#define SORT_PHASES       (1 << 8)
#define FUNC_CHECKS       (1 << 9)
#define CONTROL_FLOW_EXEC (1 << 10)
#define ENABLE_PROB       (1 << 11)
#define SANITY            (1 << 12)
#define SIMULATION        (1 << 13)
#define MAX_JUMPS         10
#define EXECUTE           (1 << 1)
#define SIMULATE          (1 << 2)
#define COMPILE_ONLY      (1 << 3)
#define EASE              (1 << 4)
#define IS_FUNC_EXEC      (1 << 5)

/* Exhaustive search options*/
#define EOD_AND_RA (1 << 1)

#define APPLY_FROM_LIST 0
#define APPLY_FROM_FILE 1
#define NUM_HTABLE_ELEMENTS 199
#define NUM_CRC_ELEMENTS 49
#define MAX_CHROMOSOMES 50
#define MAX_GENES 50
#define COLLISION_TABLE_SIZE 2000
#define SUCC_COLLISION_TABLE_SIZE 1000
#define INT_INFI 64000
#define INFINITY          (unsigned long long)999999999L
#define DINFINITY         (double)999999999.0
#define SUSPEND -2
#define COMB_MAX_STAGNATE 100
#define LEAF_MAX_STAGNATE 1000

/*structure to store the details during searching a best sequence*/
struct com_stack{
  unsigned long long best_measure;
  int trans_done;
  int best_pc, curr_pc, sequence_count;
  int start_pc, end_pc, viewing, weight;
};

/*structure to store details during SELECT_BEST_COMBINATION*/
struct comb_struct{
  int base_opt[MAX_GENES], reverse_base[MAX_GENES], best_opt[MAX_GENES];
  int max_comb, valid_comb, done_comb, opt_mask;
  int no_comb, start_pc, length;
  int trans_done, viewing, sequence_count, pass;
  int strlength, weight, search_option, popu_size, gen_size;
  int popu_count, gen_count, flags, stagnate;
  unsigned long long best_smeasure, best_dmeasure;
  unsigned long long base_smeasure, base_dmeasure;
  unsigned long long term_smeasure, term_dmeasure;
  unsigned long long last_smeasure, last_dmeasure;
  double best_measure;
};

/*structure to store the transformations applied to a function*/
struct transform_list{
  char mod_flag;
  char *string;
  struct transform_list *next;
};

/*structure to store one chromosome during a genetic algorithm search*/
struct chromosome{
  int chrom[MAX_GENES], succ_phases[MAX_GENES], succ_num;
  unsigned long long s_measure, d_measure;
};

/*the hashtable to store seen strings during genetic search*/
struct HASHTABLE{
  int no_phases;                   /*number of phases in the sequence*/
                                   /*measurement counts for this seq*/
  unsigned long long s_measure, d_measure;       
  int chrom[MAX_GENES];            /*the chromosome string*/
  struct HASHTABLE *next;          /*next chrom. colliding at this index*/
  int seq;
};

/*hashtable to store function CRC checksums after each phase. A node in this
  structure also contains a link to a node in the tree, the prefix at which
  point generates the function instance for that CRC value*/
struct CRCTABLE{
  unsigned int crc_val, tree_node;
  struct CRCTABLE *next;
};

/*data structures for comparing the function instances generated by different
  sequences. If the same, then the second function need not be executed to
  get performance measures*/

/*definition of some constants*/
#define RTL_HASH          256
#define MAX_RTL           1000
#define MAX_LABELS        500
#define MAX_CEX_LABELS    500
#define FUNC_HASH         128
#define NUM_TREE_NODES    65535
#define START_NODE        2
#define UNSUCC            0
#define UNSEEN            1
#define MAX_FUNC_INST     1000
#define FINDEX            2047
#define F2INDEX           2047
#define MAX_CEX_LINES     10000
#define MAX_PRO_LEVELS    50
#define SMALLSTRING       500
#define MAXPHASES         30
#define PH_CONTEXT        0
#define STD_DEV           0  /*needs PH_CONTEXT to be ON*/
#define PH_CONTEXT1       0
#define PH_ALL_PATHS      0
#define PINDEX            255
#define ACTPHASES 15
#define ALL_PH_COMB 32768


/*structure to hold information for each RTL*/
struct RTL_hash{
  unsigned int hashvalue;     /*sum of the all bytes in the RTL*/
  char *rtl;                  /*the RTL string value*/
  struct RTL_hash *next_rtl;  /*next RTL in the hash table bucket*/
};

/*structure to hold the function information*/
struct Func_hash{
  unsigned int tree_node;      /*node in tree for this CRC value*/
  unsigned int hashvalue;      /*sum of hashvalues of all RTLs in function*/
  unsigned int CRC_hash;       /*hashvalue calculated using the CRC algo. */
  int num_rtls;                /*number of RTLs in this function instance*/
  struct Func_hash *next_func; /*next function in same hash bucket*/
  unsigned long long s_measure, d_measure;
  int succ_phases[MAX_OPT], succ_num;
};

/*template definition for creating a tree based structure to check for
  repetitions in the attempted sequence, successful sequence and for doing
  prefix-controlled mutations during the genetic algorithm search*/
struct tree_struct{
  short int no_succ_phases;                /*no. of phases possible*/
  unsigned short int parent;               /*parent node in the tree*/
  unsigned short int opt[NUM_TRANS_TYPES]; /*child nodes*/
  unsigned long long s_measure, d_measure;
  struct Func_hash *func_node;             /*node in function hashtable
                                             corr. to this tree node*/
};


/*structure used to store function instance information like CRC value,
  during profiling to help identify distinct function instances*/
struct func_inst{
  int rtl_count;
  unsigned int CRC, fhash;
};

/*list to hold distinct function instances during profiling*/
struct FHASH{
  unsigned int CRC, fhash, r_CRC, r_fhash;
  int rcount;
  struct FHASH *next;
};

/*sturcture to hold the checksums and perf. num*/
struct perf_hash{
  unsigned int CRC, fhash;
  int rcount;
  long long s_measure, d_measure;
  struct perf_hash *next;
};

/*structures to hold the control flow information of a function*/
struct CFList{
  int numBlocks, serial_id;
  struct BlockList *blist;
  struct CFList *next;
};

struct BlockList{
  int id, left, right, rcount, loads, stalls, status;
  long long cycle, exe_count;
  struct BlockList *down;
};

/*structure to hold per level informations during depth-first exhaustive
  search of the optimization space*/
struct dfs_struct{
  int opt_num;
  int opt, prev_opt;
  char optstr[MAXSTRING];
  unsigned int ex_trans_done;
};

/*structure to hold information about the number of blocks currently in scope
  of optimizations*/
struct blk_inscope{
  int limited_scope;
  int num_blks;
  int blk_id[MAX_BLOCKS];
};

/*list of nodes to hold information pertinent to different optimization
  contexts during DFS exhaustive search*/
struct PH_CON{
  int context, flag;
#if PH_CONTEXT  
  double opt[ACTPHASES];
  int seen[ACTPHASES];
  double fn_active[ACTPHASES], degrade[ACTPHASES];
#if PH_ALL_PATHS
  /*during a phase context directed DFS optimization search, holds information
    about which phases to apply after each context*/
  int paths[ACTPHASES], pind, cind;
#endif

#elif PH_CONTEXT1  
  double better[ACTPHASES][ACTPHASES];
  int seen[ACTPHASES][ACTPHASES];
#endif  
  struct PH_CON *next;
};

/*structure to hold info. needed to bookmark function instances*/
struct bk_fn_info{
  struct bblock *top, *bottom, *ret_block;
};

void end_sel_comb(struct comb_struct *comb);
#endif /*INTERACT*/

#ifdef CALLGRAPH
extern FILE* optimal_assignment_fn;
#endif

#endif  /* VPO_H */
