/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/vpo2.h,v $
 $Date: 2003/04/03 20:06:12 $
 $Revision: 1.5 $
 $Name:  $

 Log of changes:

 $Log: vpo2.h,v $
 Revision 1.5  2003/04/03 20:06:12  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.4  2003/02/06 04:48:22  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.1.1.1  2002/05/31 15:17:20  kulkarni
 vista start

 Revision 1.1.1.3  2001/09/21 19:24:05  mabailey
 Zephyr release dated 09-13-01.

 Revision 1.3  2000/10/18 02:33:54  jwd
 Added clear_opt_flags to facilitate resetting the optimization flags
 on the fly.

 Revision 1.2  1998/04/29 19:24:16  jwd
 Added void to some prototypes.
 Deleted some commented out code.

 Revision 1.1  1998/04/03 16:53:27  jwd
 Initial revision

*************************************************************************/

#ifndef VPO2_H
#define VPO2_H

int main(int, char **);
void parse_arguments(int, char **);
void clear_opt_flags(void);
int debug_opt(char *);
int debug_opt_i(char *, int);
int debug_opt_l(char *, char *);
int debug_opt_i_l(char *, int, char *);
void optimize(void);
void dump_function_i(char *, int, int);
void dump_function_l(char *, char *, int);
void dump_function_i_l(char *, int, char *, int);
void dump_function(int);
void show(char *);


void rshow(rlist);
#ifdef INTERACT
void rshowmsg(rlist, char *);
void dshowmsg(dvector, char *);
#endif

#ifdef ENDFILE
   void endfile();
#endif

#ifdef INTERACT
void establish_trans_dependences();
void interactive_optimize();
void dump_func_to_file(char *);


/*Added some functions for INTERACT/UNDO use*/

/*The following functions are defined in vpo.c*/
void init_old_all(struct bblock *v_top);
void init_old_bb(struct bblock *cblk);
void init_old_rtls(struct bblock *first_rtl);
void init_old_single_rtl(struct list *rtlptr);
char *copy_string(char *src);

void clear_all_links(struct bblock *v_top);
void clear_bb_links(struct bblock *cblk);

void m_rcpy(rlist * dst, rlist src);
void m_show_preds(FILE *fout, struct bblock *cblk);
void m_rshow(FILE *fout, rlist vec);
void show_links(FILE *fout, struct list *rtlptr);
void m_show_status(FILE *fout, struct bblock *cblk);


/*End functions for INTERACT/UNDO*/
/*defined by Cai, Baosheng*/
struct list *alloc_new_rtl();

/*functions defined in ../sparc/inst.c, by cai, baosheng */
/**function defined by Cai, Baosheng*/
char *trans_to_assem(struct list *rtl);     
int check_syntax(char *rtlval);
void send_error(char *err_msg);
void quit(int n);
char *get_label_str(char *src);
struct bblock *get_label_down(char *label);
int is_pc_begin(register char *s);
struct list *find_last_rtl(struct bblock *cblk);

void loops_query();

#endif
#endif


