
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/decode/decode.c,v $
 $Date: 2000/08/22 21:10:33 $
 $Revision: 1.1.1.1 $
 $Name:  $

 Log of changes:

 $Log: decode.c,v $
 Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 Created directory structure

 Revision 1.4  1998/08/07 16:22:56  jwd
 Added support for handling the P line (parameters).

 Revision 1.3  1998/04/08 17:09:35  jwd
 Got rid of the void argument specifier and made function
 main() have the standard prototype main(int, char **).
 Revision 1.2  1998/04/08 16:02:48  jwd
 First ANSI version.

*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "decode.h"

char regprt[17] = "?bwdfp??????????";

int main(int argc, char *argv[]) {
    return (decode());
}

int decode() {

    register int c, state;
    int save;

    save = 0;
    state = 1;
    while ((c = getchar()) != EOF)
      switch (state) {

        case 0:
          putchar(c);
          if (c == (int) '\n')
            state = 1;
          break;

        case 1:
          putchar(c);
          state = (c == (int) '+') ? 2 :
                  (c == (int) 'u') ? 2 :
                  (c == (int) 'S') ? 2 :
                  (c == (int) 'P') ? 2 :
                  (c == (int) 'r') ? 2 :
                  (c == (int) 't') ? 2 :
                  (c == (int) 's') ? 2 :
                  (c == (int) 'd') ? 2 :
                  (c == (int) 'C') ? 2 :
                  (c == (int) 'M') ? 4 : 0;
          break;

        case 2:
          if (((int) c) & 0x80) {
            state = 3;
            save = c;
            }
          else {
            putchar(c);
            state = (c == (int) '\n') ? 1 : 2;
            }
          break;

        case 3:
          if (c & 0x80) {
            if ((save & 0xc0) == 0xc0)
              printf("%c[%d]", regprt[(save & 0x3c) >> 2],
                               ((save & 0x3) << 7) + (c & 0x7f));
            else if ((save & 0xe0) == 0xa0)
              printf("LOC[%d]", ((save & 0x1f) << 7) + (c & 0x7f));
            else
              printf("GLO[%d]", ((save & 0x1f) << 7) + (c & 0x7f));
            state = 2;
            }
          else {
            putchar(save);
            putchar(c);
            state = (c == (int) '\n') ? 1 : 2;
            }
          save = 0;
          break;

        case 4:
          putchar(c);
          if (c == (int) '\n') {
            while (save < 16)
              regprt[save++] = ' ';
            state = 1;
            }
          else {
            regprt[save++] = (char) c;
            if (save == 16)
              state = 0;
            }
          break;

        default:
          fprintf(stderr, "decode: Oops!\n");
          return(1);
        }
    if (state == 3)
      putchar(save);
    return(0);
}










