
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/encode/encode.c,v $
 $Date: 2000/08/22 21:10:33 $
 $Revision: 1.1.1.1 $
 $Name:  $

 Log of changes:

 $Log: encode.c,v $
 Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 Created directory structure

 Revision 1.5  2000/06/10 18:10:30  jwd
 Added support for the 'P' line (parameter) and the 'R' line (return
 value).

 Revision 1.4  1998/10/06 14:42:29  jwd
 Operators that were characters that conflicted with register
 names (e.g., 'b', 'w', etc.) caused encode to not encode
 a register that followed. For example, the RTL
    +r[34]=r[34]br[35]
 would be incorrectly encoded as the register following the
 b (bitwise and not operator on the SPARC) would not be
 encode.
 Revision 1.3  1998/08/07 16:27:43  jwd
 Fixed minor errors with the return for main.
 Revision 1.2  1998/04/08 17:17:28  jwd
 Changed prototypes slightly and added source code control
 header information.

*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "encode.h"

/*--------------------------------------------------------
	History of Changes:
	1/29/98: Modified to to support ansi C prototyping

---------------------------------------------------------*/


int low = 1, high = 6;

char regprt[17] = "?bwdfp??????????";

int main(int argc, char *argv[]) {

    return (decode());
}

int decode() {

    register int c, state;
    int save;
    int i, reg_type, num, lineno;
    char c1, c2, third, fourth;

    lineno = 0;
    save = 0;
    state = 1;
    while ((c = getchar()) != EOF) {
      switch (state) {

        case 0:
          putchar(c);
          if (c == (int) '\n')
            state = 1;
          break;

        case 1:
          ++lineno;
          putchar(c);
          state = (c == (int) '+') ? 2 :
                  (c == (int) 'u') ? 2 :
                  (c == (int) 'S') ? 2 :
                  (c == (int) 'P') ? 2 :
                  (c == (int) 'R') ? 2 :
                  (c == (int) 'r') ? 2 :
                  (c == (int) 't') ? 2 :
                  (c == (int) 's') ? 2 :
                  (c == (int) 'd') ? 2 :
                  (c == (int) 'C') ? 2 :
                  (c == (int) 'M') ? 6 : 0;
          break;

        case 2:
          for ( i = low; i < high; i++ ) {
             if ( c == regprt[i] ) {
                reg_type = i;
                break;
             }
          }
          if ( i < high ) {
             save = c; state = 3;
          }
          else if ( c == 'G' ) {
             save = c; state = 4;
          }
          else if ( c == 'L' ) {
             save = c; state = 5;
          }
          else {
            putchar(c);
            state = (c == (int) '\n') ? 1 : 2;
          }
          break;

        case 3:       /*** looking for register via 'r[' ***/
          if ( c == '[' ) {
             num = 0;
             while ( (c=getchar()) != ']' )
                num = 10*num + (int) (c - '0');
             c1 = 0xc0 | (char)(reg_type << 2 );
             c1 = c1 | (char)(num >> 7 );
             c2 = 0x80 | (char)(num & 0x007f);
             putchar(c1); putchar(c2);
             state = 2;
          }
          else {
 	     /* it wasn't a register, output char and start over */
             putchar(save);
             ungetc(c, stdin);
             state = 2;
          }
          save = 0;
          break;
             
        case 4:         /*** have seen 'G', looking for 'GLO[' ***/
          if ( c == 'L' ) {
             if ( (third=getchar()) == 'O' ) {
                if ( (fourth=getchar()) == '[' ) {
                   num = 0;
                   while ( (c=getchar()) != ']' )
                      num = 10*num + (int) (c - '0');
                   c1 = 0x80 | (char)(num >> 7 );
                   c2 = 0x80 | (char)(num & 0x007f);
                   putchar(c1); putchar(c2);
                }
                else {
                   putchar(save); putchar(c);
                   putchar(third); putchar(fourth);
                   c = fourth;
                }
             }
             else {
                putchar(save); putchar(c);
                putchar(third);
                c = third;
             }
          }
          else {
             putchar(save);
             putchar(c);
          }
          state = (c == (int) '\n') ? 1 : 2;
          save = 0;
          break;
      
        case 5:         /*** have seen 'L', looking for 'LOC[' ***/
          if ( c == 'O' ) {
             if ( (third=getchar()) == 'C' ) {
                if ( (fourth=getchar()) == '[' ) {
                   num = 0;
                   while ( (c=getchar()) != ']' )
                      num = 10*num + (int) (c - '0');
                   c1 = 0xa0 | (char)(num >> 7 );
                   c2 = 0x80 | (char)(num & 0x007f);
                   putchar(c1); putchar(c2);
                }
                else {
                   putchar(save); putchar(c);
                   putchar(third); putchar(fourth);
                   c = fourth;
                }
             }
             else {
                putchar(save); putchar(c);
                putchar(third);
                c = third;
             }
          }
          else {
             putchar(save);
             putchar(c);
          }
          state = (c == (int) '\n') ? 1 : 2;
          save = 0;
          break;
      
        case 6:
          putchar(c);
          if ( save < low && c != '?' )
             low = save;
          else if ( c != ' ' )
             high = save + 1;

          if (c == (int) '\n') {
            while (save < 16)
              regprt[save++] = ' ';
            state = 1;
            }
          else {
            regprt[save++] = (char) c;
            if (save == 16)
              state = 0;
            }
          break;

        default:
          fprintf(stderr, "encode: Oops! at line %d\n", lineno);
          return(1);
        }
    }
    if (state == 3)
      putchar(save);
    return(0);
}

