

#include "build_data_structure.h"
#include "parsepd.h"
#include "scanpd.h"
#include "misc.h"

#define usage() fatal("Usage: pdtool {-ss|-vpo} < input > ouptut");


void output_ss()
{
	/* output partitions */
	part_list_t* first_part;
	cache_list_t* first_cache;
	ident_list_t* first_ident;


	printf("# part name latency size ports offchip [default]\n");
	for(first_part=pd.parts;first_part;first_part=first_part->next)
	{
		printf("part %s %d %d %d %d", first_part->name, first_part->latency, 
			first_part->size,
			first_part->rw_ports,
			first_part->offchip
			);
		if(first_part->default_item)
			printf(" default");	
		printf("\n");
	}

	printf("# cache name:<config> hit_latency miss_latency ports offchip parts_cache_list [misses_to]\n");
	for(first_cache=pd.caches;first_cache;first_cache=first_cache->next)
	{
		printf("cache %s:%d:%d:%d:%s %d %d %d %d ", 
			first_cache->name, 
			first_cache->sets, 
			first_cache->blocksize, 
			first_cache->assoc, 
			first_cache->replacement, 
			first_cache->hit_latency, 
			first_cache->extra_miss_latency,
			first_cache->rw_ports,
			first_cache->offchip);

		for(first_ident=first_cache->parts_cached; first_ident;first_ident=first_ident->next)
		{
			printf("%s", first_ident->name);
			if(first_ident->next)
				printf(",");
		}
		if(first_cache->misses_to)
			printf(" %s", first_cache->misses_to);
		printf("\n");
	}
	
	
	

}

void output_vpo()
{
	fatal("VPO output not yet implemented");
}


main(int argc, char* argv[])
{

	if(argc!=2)
		fatal("Usage: pdtool {-ss|-vpo} < input > ouptut");

	/* build data structure from the standard input */
	if(pdtoolparse())
	{
		usage();
	}


	if(strcmp(argv[1], "-ss")==0)		
		output_ss();
	else if(strcmp(argv[1], "-vpo")==0)		
		output_vpo();
	else
		usage();

	return 0;
}


