
%{
#include "build_data_structure.h"
#include "parsepd.h"
int linenumber=0;
%}

%%

"partition"		{ return PD_PARTITION; }
"cache"			{ return PD_CACHE; }
"end"			{ return PD_END; }
"access_latency"	{ return PD_ACCESS_LATENCY; }
"default"		{ return PD_DEFAULT; }
"size"			{ return PD_SIZE; }
"sets"			{ return PD_SETS; }
"assoc"			{ return PD_ASSOC; }
"replacement"		{ return PD_REPLACEMENT; }
"hit_latency"		{ return PD_HIT_LATENCY; }
"extra_miss_latency"	{ return PD_EXTRA_MISS_LATENCY; }
"parts_cached"		{ return PD_PARTS_CACHED; }
"misses_serviced_by"	{ return PD_MISSES_SERVICED_BY; }
"blocksize"		{ return PD_BLOCKSIZE; }
"offchip"		{ return PD_OFFCHIP; }
"ports"			{ return PD_PORTS; }
"+\n"           	{ linenumber ++; }
[A-Za-z][A-Za-z0-9\_]*    { return PD_IDENTIFIER; }
[0-9]+			{ return PD_CON; }
"#".*"\n"           	{ linenumber ++; /* ignore comments */ }
" "             	{ /* ignore whitespace */ }
"\t"             	{ /* ignore tabs */ 	}
"\n"             	{ linenumber ++; }
.			{ return pdtooltext[0]; }

%%


#ifndef pdtoolwrap
int pdtoolwrap()
{
	return 1;
}
#endif

int pdtoolerror()
{
	fprintf(stderr,"Parse error while parsing parts description at or before line %d\n", linenumber);
	exit(1);
}



