
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1990, 1991, 1992 -                                     */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/regtool/regtool.h,v $
 $Date: 2000/08/22 21:10:33 $
 $Revision: 1.1.1.1 $
 $Name:  $

 Log of changes:

 $Log: regtool.h,v $
 Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 Created directory structure

 Revision 1.3  2000/07/18 18:40:01  jdh8d
 changes to get mips to compile/run under new system

 Revision 1.2  1998/04/08 18:07:26  jwd
 First ANSI C version.

*************************************************************************/


/*
 * This file contains general definitions for regtool
 */

#define MAXTYPES   16        /* Maximum number of types                  */
#define MAXID     128        /* Maximum length of an identifier          */
#define MAXCODES   64        /* Maximum number of codition codes         */
#define VECLEN   1024        /* Size of a vector                         */

#define FIFOC   (1 << 0)     /* Indicates class to be fifo registers     */
#define STACKC  (1 << 1)     /* Indicates class to be stack register     */
#define SPILLC  (1 << 2)     /* Indicates class to be the spill area     */

#define TRUE 1               /* Boolean constant TRUE                    */
#define FALSE 0              /* Boolean constant FALSE                   */

struct vector {
  short num[VECLEN];
  };

struct align_expr {
  int align;
  int offset;
  };

struct typeinfo {
  struct typeinfo *next;
  char *name;
  int number;
  int first;
  int tfirst;
  int avail;
  int tavail;
  int skip;
  int tskip;
  struct classinfo *class;
  struct classinfo *spill;
  struct typeinfo *alias;
  struct typeinfo *talias;
  struct align_expr *alignment;
  struct align_expr *talignment;
  int size;
  int tsize;
  int llimit;
  int ulimit;
  int head;
  struct typeinfo *group;
  struct typeinfo *htype;
  struct vector *invariant;
  struct typeinfo *localtype;
  int noalloc;
  int compatible[MAXTYPES];
  char memchar;
  char regchar;
  };

struct classinfo {
  struct classinfo *next;
  char *name;
  int flags;
  int num;
  int number;
  int first;
  int ralloc;
  struct vector *layout;
  struct vector *scratch;
  struct vector *reserve;
  struct vector *order;
  struct typeinfo *types;
  };
