/******************************************************************************
 *
 * Copyright (c) 1993 by Mark W. Bailey.
 *
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made as to
 * whether it serves any particular purpose or even works at all.
 *
 *****************************************************************************/

/******************************************************************************
 *
 * File: op.c
 *
 * Author: Mark W. Bailey
 *
 * Created: 12/1/93
 *
 * Description:
 *	Contains the operator table.
 *
 * RCS Header:
 * 	$Header: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/rtlprep/op.c,v 1.1.1.1 2000/08/22 21:10:33 zephyr Exp $
 *
 * Change Log:
 *	$Log: op.c,v $
 *	Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 *	Created directory structure
 *	
 *	Revision 1.1  1998/01/29 20:53:54  jch8f
 *	Initial revision
 *	
 * Revision 1.1  1994/01/13  16:40:52  mwb5y
 * Initial revision
 *
 *
 *****************************************************************************/

/* 
 * __OP_C__ used in op.h to exclude external declarations from being 
 * included
 */

#define __OP_C__
#include "op.h"

/* 
 * Operators is a table of operator information. It is indexed by the 
 * enumerated type OpIndex. We use this to map the internal name of 
 * the operator (OpIndex value) onto the necessary string to emit 
 * based on whether the operator is binary or unary, and whether we 
 * are generating code for vpo or ntro.
 */

OpInfo Operators[] = {

    /* ntro Binary	vpo Binary	ntro Unary	vpo Unary */

    { { "TOKEN_MODULO",		"%" }, },
    { { "TOKEN_AND",		"&" }, },
    { { "TOKEN_MULTIPLY",	"*" }, },
    { { "TOKEN_ADDITION",	"+" }, },
    { { "TOKEN_LIST",		"," }, },
    { { "TOKEN_SUBTRACTION",	"-" },	{ "TOKEN_NEGATE",	"-" } },
    { { "TOKEN_DIVISION",	"/" }, },
    { { "TOKEN_LESS",		"<" }, },
    { { "TOKEN_GREATER",	">" }, },
    { { "TOKEN_COMPARISON",	"?" }, },
    { { "TOKEN_XOR",		"^" }, },
    { { "TOKEN_OR",		"|" }, },
    { { "",			"" },	{ "TOKEN_NOT",		"~" } }, 
    { { "TOKEN_NOT_EQUAL",	"!" }, },
    { { "TOKEN_LESS_EQUAL",	"\'" }, },
    { { "TOKEN_THEN",		"," }, },
    { { "TOKEN_EQUAL",		":" }, },
    { { "TOKEN_GREATER_EQUAL",	"`" }, },
    { { "TOKEN_LEFT_SHIFT",	"{" }, },
    { { "TOKEN_RIGHT_SHIFT",	"}" }, },
};


