/***********************************************************************
 * 
 * Copyright (c) 1996 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 * 
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/basicblock.h,v $
 * $Revision: 1.1.1.1 $
 ***********************************************************************/

#ifndef	__BASICBLOCK_H__
#define	 __BASICBLOCK_H__

typedef struct vet_bblock *Bblockptr; /* ptr to VET's bblock struc */

#ifdef XWINDOWS
#include <Xm/Xm.h>
#endif
#include "process_input.h"	/* needs Bblockptr typedef */
#include "rtl.h"

typedef struct vet_bblock{
    int address;		/* bb address from vpo -- unique id */
    Bblockptr next;		/* ptr to next basic block */
    Bblockptr prev;		/* ptr to previous basic block */
    int number;			/* basic block number */
    int left;			/* unconditional successor bb num */
    int right;			/* conditional successor bb num */
    int down;			/* next bb num for output */
    int down_displayed;		/* down bb being displayed */
    char *label;		/* block label, if any */
    Rtlptr rtls;		/* ptr to first rtl in basic block */
#ifdef XWINDOWS
    Widget bb_widget;		/* Pointer to bb widget */
    Widget label_widget;	/* Pointer to label widget */
    Widget down_widget;		/* Pointer to fall through widget */
    Widget nofall_widget;	/* Pointer to no fallthrough widget */
    Widget left_widget;		/* Pointer to uncond. widget */
    Widget right_widget;	/* Pointer to cond. widget */
    Widget success_widget;	/* Pointer to widget to hold arrows */
    Widget rtl_scroll;		/* Point containing rtl widget */
    Widget rtl_widget;		/* Pointer to list widget for rtls */
#endif
} Bblocknode;

Bblockptr process_bb(Bblockptr *); /* function that sets up a new bb */
Bblockptr insert_newbb_operation(int);
Bblockptr find_bb(int);		   /* searchs hash table for bb num and returns
				      ptr to allocated bb node */
Bblockptr find_bb_num(int);		   /* searchs hash table for bb num and returns
				      bb number */
void delete_bb_node(Bblockptr);    /* removes bb node from VET's structure 
				      clear ptr in hash_table. */
void delete_bb_hash_table(void);	   /* deallocates hash table & clears entries */
void new_bb_hash_table(void);  	   /* reset entries to NULL */
void free_bb_wrapper(void *);

#endif
