/***********************************************************************
 * 
 * Copyright (c) 1998 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 * 
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/process_input.h,v $
 * $Revision: 1.1.1.1 $
 ***********************************************************************/
#ifndef	__PROCESS_INPUT_H__
#define __PROCESS_INPUT_H__

#include <stdio.h>

/* Function node pointer */
typedef struct function *Funcptr;

#include "basicblock.h"
#include "rtl.h"

/* Operations node (for each transformation */
typedef struct operation *Operptr;

typedef struct operation {
    int		bbaddr;
    int		rtladdr;
    char	*label;
    char	msgid;
    int		rtltype;	/* rtl type for new rtls */
    int		bbptr;		/* used for another bb ptr */
    int		ptr;		/* used for new ptr or next rtl ptr */
    int		newlinks[MAXLINKS]; /* address of rtls linked to */
    int		number;		/* number assigned to rtl */
    char	*newline;
    Addrptr	rtls;		/* ptr to first rtl for update trans. */
    Addrptr	oldrtls;	/* ptr to previous first rtl for update trans. */
    Operptr	next;
    Operptr	prev;		/* ptr for undo */
} Opernode;

/* Transformation node */
typedef struct transformation *Transptr;

typedef struct transformation {
    int		num;
    Operptr	operation;
    Transptr	prev;
    Transptr	next;
} Transnode;

/* Phase node */
typedef struct phase *Phaseptr;

typedef struct phase {
    Phaseptr	prev;
    Phaseptr	next;
    char	*name;
    Transptr	first_trans;
    char	phase_read;		/* Flag to determine if trans read in */
} Phasenode;

/* Function node -- first node in structure for active bbs */
typedef struct function {
    Bblockptr	first_bb;
    Bblockptr	first_displayed_bb;
    char        *name;
    Phaseptr	first_phase;
    int		num_trans;
} Funcnode;


Funcptr initialize_function(void);
void free_function(void);
void process_initial_set(void);
Phaseptr initialize_phase(void);
Transptr initialize_transformation(Phaseptr);
void apply_all_transformations(Transptr);
void apply_single_transformation(Transptr);
void undo_all_transformations(Transptr);
void undo_single_transformation(Transptr);
void process_input(void);
void process_sanity(void);
void sanity_dialog();

#ifndef	__PROCESS_INPUT_C__
extern char *phasenames[];
extern const int NUMPHASES;
extern int num_trans;
#endif

#ifdef XWINDOWS
XmString create_rtl_string(Rtlptr);
#endif
#endif
