/***********************************************************************
 * 
 * Copyright (c) 1998 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 * 
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/rtl.h,v $
 * $Revision: 1.1.1.1 $
 ***********************************************************************/
#ifndef	__RTL_H__
#define __RTL_H__

typedef struct rtl *Rtlptr;
typedef struct addr *Addrptr;

#include "vpo.h"
#include "basicblock.h"

typedef struct rtl {
    int		type;		/* type of rtl */
    char	*line;		/* rtl value   */
#ifdef XWINDOWS
    XmString	rtlstr;		/* XmString for displaying rtl line */
    char	selected;	/* Boolean whether rtl line is selected */
#endif    
    int		address;	/* rtl address from vpo -- unique id */
    int		number;		/* rtl number */
    int		links[MAXLINKS]; /* address of rtls linked to */
    char	*side;		/* rtl side effects */
    char	*deads;		/* rtl deads 	    */
    Rtlptr	next;		/* ptr to next rtl  */
    Rtlptr	prev;		/* ptr to prev rtl  */
} Rtlnode;

typedef struct addr {
    int		address;	/* rtl address from vpo -- unique id */
    Addrptr	next;		/* ptr to next rtl  */
} Addrnode;

Rtlptr process_rtl(Rtlptr *);		 /* creates a new rtl node */
Rtlptr create_rtl(void);		 /* mallocs space for rtl node */
void add_rtl_address(Addrptr *, int);
Rtlptr insert_newrtl_operation(int);
Rtlptr find_rtl(int);
Rtlptr find_rtl_num(int);
void delete_rtl_node(Bblockptr bb, Rtlptr rtl);
void free_rtl_wrapper(void *);
void free_rtl_addresses(Addrptr);
void new_rtl_hash_table(void);
void delete_rtl_hash_table(void);

#endif
