/***********************************************************************
 * 
 * Copyright (c) 1998 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/vet.c,v $
 * $Revision: 1.1.1.1 $
 * 
 ***********************************************************************/
#define __VET_C__

#include <stdio.h>
#include "vet.h"
#include "vet_init.h"
#include "vet_socket.h"

#ifdef XWINDOWS
#include "vet_xinit.h"
#include "vet_callbacks.h"
#else
#include "process_state.h"
#endif

char *rshcommand;	/* remote shell command for VPO */
char **arguments;

/*********************************************************************
 *
 * main - parse arguments, setup sockets before displaying first
 *	  function's inital set. If XWINDOWS version start loop.
 *
 *********************************************************************/
int main (int argc, char **argv) {

#ifdef XWINDOWS
    XtAppContext app_context;
#endif

    /*
     * Parse the command line to determine what the user's
     * arguments for VET and VPO are.
     */
    rshcommand = parse_arguments(argc, argv);
    
#ifndef XWINDOWS
    /* 
     * Set up socket for communication between VPO and VET.
     * This starts VPO.
     * XWindows version uses a different function when user
     * presses button to start VPO.
     */
    setup_sockets(rshcommand, argv);
#endif

    /* Create hash tables for basic blocks and rtls */
    new_bb_hash_table();
    new_rtl_hash_table();

#ifdef XWINDOWS
    /* 
     * Save arguments in a different variable to be used later
     * when user presses Start VPO button.
     */
    arguments = argv;

    app_context = initialize_xwindow(argc, argv);

    XtAppMainLoop(app_context);

#else
    /* Display first function's initial set */
    process_function();
#endif
    return 0;

} /* end main */

#ifdef XWINDOWS
/*********************************************************************
 * 
 * startvpo - this function is a callback for the Start VPO button.
 *	      Sockets are setup and this function starts the event
 *	      for displaying the first function's initial set.
 *
 *********************************************************************/
void startvpo(Widget parent, XtPointer client_data,
	      XtPointer call_data) {

    /* 
     * Set up socket for communication between VPO and VET.
     * This starts VPO.
     * XWindows version this is called when user presses
     * button to start VPO.
     */
    setup_sockets(rshcommand, arguments);

    /* Display first function name */
    next_func_pressed(NULL, NULL, NULL);

} /* end startvpo */
#endif

