/***********************************************************************
 * 
 * Copyright (c) 1996 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/vet_io.c,v $
 * $Revision: 1.1.1.1 $
 * 
 ***********************************************************************/
#include <stdio.h>
#include <malloc.h>
#include "vet_io.h"
#include "vet_socket.h"

/*********************************************************************
 *
 * write_line - write a string to VPO.
 *
 *********************************************************************/
void write_line(char *command) {

    /* Call function to write characters to socket. */
    write_on_socket(command);

} /* end write_line */

/*********************************************************************
 *
 * write_char - write a single character to VPO.
 *
 *********************************************************************/
void write_char(char id) {
    char command[MAXSTRING];	/* VPO defines MAXSTRING */

    /* Format character as a string. */
    sprintf(command, "%c", id);

    /* Call function to write character to socket. */
    write_on_socket(command);

} /* end write_char */

/*********************************************************************
 *
 * read_line - read in a string from VPO.
 *
 *********************************************************************/
char *read_line(void) {

    char *line;		/* Characters read from socket. */
    char *new;		/* New memory location for characters. */

    /* Read line from socket. */
    line = read_from_socket();

    /* Allocate memory for string read from socket. */
    new = malloc(strlen(line) + 1);

    /* Copy line read from socket to newly allocated memory. */
    strcpy(new,line);

    /* Return line */
    return new;

} /* end read_line */

/*********************************************************************
 *
 * read_char - read a character from VPO.
 *
 *********************************************************************/
char read_char(void) {

    char *line;		/* String read from socket. */
    char id;		/* Character from string. */

    /* Read string from socket. */
    line = read_from_socket();

    /* Convert string to character. */
    sscanf(line, "%c", &id);

    /* Return character. */
    return id;

} /* end read_char */

/*********************************************************************
 *
 * read_num - read an integer from VPO.
 *
 *********************************************************************/
int read_num(void) {

    char *line;		/* String read from socket. */
    int num;		/* Number converted from string. */

    /* Read in string from socket. */
    line = read_from_socket();

    /* Converted string to number. */
    sscanf(line, "%d", &num);
    
    /* Return number. */
    return num;

} /* end read_num */

