
#include <Macros.h>
#include <OptionsDatabase.h>
#include <BaseObject.h>

using namespace std;

BaseObject::BaseObject() 
	: options(0), name(0)
{

};


BaseObject::BaseObject(OptionsDatabase * opt) 
	: options(opt), name(0)
{

}

BaseObject::BaseObject(const BaseObject& obj)
	: options(obj.getOptions())
{ 
	if(obj.getName()==0)
	{
		name=0;
	}
	else	
	{
		char *newName=new char[strlen(name)+20];
		sprintf(newName, "Copy of %s", obj.getName());
		setName(newName);
		GetRidOfArray(newName);
		
	}
}
 
	
		
BaseObject::~BaseObject()
{
	GetRidOfArray(name);
}	

void BaseObject::setName(char* newName)
{
	if(newName!=0)
		name=strdup(newName);
	else
	{
		GetRidOfArray(name);
	}
};

char* BaseObject::getName() const
{
	return name;
}

OptionsDatabase* BaseObject::getOptions() const 
{
	assert(options);
	return getExactOptions();
}


OptionsDatabase* BaseObject::getExactOptions() const 
{ 
	return options; 
}

















