#ifndef _BASERTLFILE_H
#define _BASERTLFILE_H

#include <Macros.h>
#include <Function.h>
#include <BaseObject.h>

class OptionsDatabase;


//
//  This class represents a RTL file, mostly, it's a list of functions
//  note that some functions may be empty, and even some files may be empty.
//
class BaseRtlFile : public BaseObject
{

	public:

		// constructers
		BaseRtlFile() NOT_IMPLEMENTED;
		BaseRtlFile(const BaseRtlFile&) NOT_IMPLEMENTED;
		BaseRtlFile(OptionsDatabase* obj) : BaseObject(obj) {}	
		~BaseRtlFile();


		// an inspecters to tell if the file is empty.  note it's considered empty when there
		// are no functions.  if a function exists (even if the function is empty!) then
		// we are not empty.
		int isEmptyFile() { return functions.empty(); }

		// get the listof functions.  
		// this is used for optimizations that may wish to modify/print the functions
		// in a file
		list<Function*> * getFunctions() { return &functions; } 

	private:

	protected:

		list<Function*> functions;

			
};

#endif
