
#ifndef _FUNCTION_H
#define _FUNCTION_H

using namespace std;

#include <Macros.h>
#include <BaseObject.h>
#include <Rtl.h>


//
//  A function is a possibly empty list of (pointers to) RTLs.
//
class Function : public BaseObject
{
	public:
		Function() {};
		// we explicitly mark this as not implemented to
		// avoid any shallow copying that may occur.  we'll fail if
		// we try to copy a function.
		Function(const Function&)  NOT_IMPLEMENTED;
		~Function();


		// add an RTL.  the valid types are defined in another file.
		void addRtl(char type, char* value);

		// output the function in .cex encoded format.
		void output(FILE* fout);
		

		// return the list of rtls for someone to process
		list<Rtl*>*  getRtls() { return &rtls; }

	
	private:
	protected:

		list<Rtl*> rtls;
};
#endif
