

//
// return the name of a variable that is being declared global in asmLine, or NULL if none
// eg:  if asmline = ".global foo"  it should return a pointer to "foo"
//
char* getGlobalDeclareName(char* asmLine);

//
// return the name of a variable that is being declared static in asmLine, or NULL if none
// eg:  if asmline = ".local foo"  it should return a pointer to "foo"
//
char* getStaticDeclareName(char* asmLine);




//
// return the name of a variable being declared in asmLine, or NULL if none
// This must find the declaration regardless of whether it's static or not.
//
// eg:  if asmline="foo: .word 0" it should return "foo"
//
char* findDeclare(char* asmLine);

//
// this should return true if a variable that's not declared as global or static
// is in actuality a static variable.  False otherwise.
//
int unknownsAreLocal();


//
//  Replace references in asmline with the revised version:
//
//  eg: asmline=".global foo_1"  map={(foo_1 -> foo_37), (goo_1 -> goo_38)}
//	return:  ".global foo_37"
//
//  eg2: asmline=".L3: .word 0 "  map={(foo_1 -> foo_37), (goo_1 -> goo_38), (L3 -> L8)}
//	return:  ".L8: .word 0"
//
char* replaceReferences(map<string, string, less<string> > allMapping, char* asmLine);


//
//  Replace references in asmline with the revised version:
//
//  eg: asmline="r[33]=L1"  map={(L1 -> L3), (L3 -> L8)}
//	return:  "r[33]=L3"
//
//  eg2: asmline="r[33]=foo_1"  map={(L1 -> L3), (L3 -> L8), (foo_1 -> foo_37)}
//	return:  "r[33]=foo_37"
//
char* fixRtl(map<string, string, less<string> > allMapping, char* asmLine);




