#include <strings.h>
#include <string>
#include "my_stl.h"
#include <stdio.h>

extern "C" {
#include "rtlspec.h"
};

using namespace std;

char* getData(string &a);

//
// sub - substitute str for pos1 thru pos2, return new pos2
//
static char *sub(char *pos1, char *pos2, char *str) 
{

   char *a;
   char blah[1000];

   a = blah;
   while (*a++ = *pos2++) ;
   while (*pos1++ = *str++) ;
   pos2 = blah;
   a = --pos1;
   while (*a++ = *pos2++) ;
   return pos1;
}


// 
// Determine if this  asmline contains a global declaration
//
char* getGlobalDeclareName(char* asmLine)
{
   char* a;
   if ((a = strstr(asmLine, ".global")) != 0) {
      // it's a .global 
      while (*a++!=' ') ; // skip the .globl 

      return strdup(a);
   }
   else
      return 0;
}


//
//  Determine if this line contains a "static" declaration.  On SPARC this is
//  a ".local" directive.
//  On MIPS, there is no directive.
//
char* getStaticDeclareName(char* asmLine)
{
   char* a;
   if ((a = strstr(asmLine, ".local")) != 0) {
      // it's a .local 
      while (*a++!=' ') ; // skip the .local 

      return strdup(a);
   }
   else
      return 0;
}


//
// Find a declaration of a variable.  For SPARC we look for <identifier>: to
//   make this a declare.
// Also, look for "common" declares, in the form of ".common".
//
char* findDeclare(char* asmLine)
{
   char temp[1000];
   char* a;

   strcpy(temp, asmLine);
   if ((a = strstr(temp, ":")) != 0) {
      *a = 0;
      return strdup(temp);
   }
   if ((a = strstr(temp, ".common")) != 0) {
      while (*a++ != ' ') ;  // skip over ".common "
      *strstr(a, ",") = 0;
      return strdup(a);
   }
   return 0;
}


//
// This function should return TRUE iff a variable that is declared, but not
// declared global/static is really a static variable.  This is assembler
// dependent.  On MIPS, there's a .globl directive for non-static,
// or no directive for static. On SPARC, there is an explicit ".local"
// directive for some static variables, and ".global" for non-static globals,
// but some static local temporaries have no directive at all.
//  Thus, we return TRUE here for both MIPS and SPARC to say that if there is
// no directive indicating whether the variable is static or not, that it
// really is static.
//
int unknownsAreLocal()
{
   return 1;
}

//
//  This function takes a mapping from an old global name to a new one, and
// fixes the assembly line to contain references to the new one.  On MIPS, we
// need to look for ".globl" ".ent" ".end" ".word"  ".lcomm" or label lines
// and fix them.  On SPARC, we look for ".global" ".local" ".common" ".type"
// ".word" or label lines and fix them.
//
//  If we make changes, we return the new value for the RTL.
//  Otherwise we return NULL to indicate that there were no changes.
//
char* replaceReferences(map<string, string, less<string> > allMapping, char* asmLine)
{
   char temp[1000];
   strcpy(temp,asmLine);

   // called for asm lines 
   // need to look for .global, .local, <label>:, .type, .common or possibly
   // a .word with a label for a switch statement.

   if (strstr(temp, ".global") !=0 || 
       strstr(temp, ".local"  ) !=0 ||
       strstr(temp, ".type"  ) !=0) {

      char* b = temp;
      while (*b!=' ' && *b!='\t') b++;  // skip directive
      while (*b==' ' || *b =='\t') b++; // skip white space
      char name[1000];
      strcpy(name, b);
      if (allMapping.find(string(name)) != allMapping.end()) {
         *b = 0;
         int len = strlen(b);
         strcpy(b, getData(allMapping[string(name)]));
         return strdup(temp);
      }
   }

   if (strstr(temp, ".word" ) !=0) {
      char* b = temp;
      while (*b!= ' ' && *b != '\t') b++;  // skip directive
      while (*b== ' ' || *b == '\t') b++;  // skip white space
      if (*b=='.') {
         b++; // if it starts with a dot, it's a label
              // leave the dot even if we rename this label
      }
      char name[1000];
      strcpy(name, b);
      if (allMapping.find(string(name)) != allMapping.end()) {
         strcpy(b, getData(allMapping[string(name)]));
         return strdup(temp);
      }

      char* c = strstr(b, "+");

      // look for things of the form .word blah+4
      if (c!=0) {
         *c = 0; // temporarily put a null here so we can get the name.
         strcpy(name, b);
         if (allMapping.find(string(name))!= allMapping.end()) {
            *c = '+'; // put the + back 
            strcpy(name, getData(allMapping[string(name)]));
            sub(b, c, name);
            return strdup(temp);
         }
      }

      c = strstr(b, "-");

      // look for things of the form .word blah-4
      if (c != 0) {
         *c = 0; // temporarily put a null here so we can
                 // get the name
         strcpy(name, b);
         if (allMapping.find(string(name))!= allMapping.end()) {
            *c = '-'; // put the - back
            strcpy(name, getData(allMapping[string(name)]));
            sub(b, c, name);
            return strdup(temp);
         }
      }
   }  // end if (strstr(temp, ".word" ) !=0)

   if (strstr(temp, ".common") != 0) {
      char* b = temp;
      while (*b != ' ' && *b != '\t') b++;  // skip directive
      while (*b == ' ' || *b == '\t') b++;  // skip white space
      char name[1000];
      strcpy(name, b);
      char* pos1 = b;
      char* pos2 = strstr(b, ",");
      *(strstr(name, ",")) = 0;
      if (allMapping.find(string(name)) != allMapping.end()) {
         char mytemp2[1000];
         strcpy(mytemp2, getData(allMapping[string(name)]));
         sub(pos1, pos2, mytemp2);
         return strdup(temp);
      }
   }
   
   char* b;
   if ((b = strstr(temp, ":")) != 0) {
      *b = 0;   // temporarily get rid of ":"
      if (allMapping.find(string(temp)) != allMapping.end()) {
         strcpy(temp, getData(allMapping[string(temp)]));
         strcat(temp, ":");
         return strdup(temp);
      }
   }
   return 0;
}


int isRegisterUse(char* id2);


//
//  This function takes the same mapping as replaceReferences but works on an 
//  actual RTL.  We look for branches and label copies.  Although MIPS and
//  SPARC support labels in more than these RTLs (e.g., call <label>, etc.)
//  we only need to worry about what the code expanders actually emit.
//  Thus, this is good enough to get it working.
//
//  If we make changes, we return the new value for the RTL.
//  Otherwise we return NULL to indicate that there were no changes.
//
//
char* fixRtl(map<string, string, less<string> > allMapping, char* asmLine)
{
   // Need to look for function names and labels in RTLs. 
   // On the MIPS and SPARC we only have to worry about r[x]=LABEL 
   // or branches/jumps (i.e. "PC=labelname;").
   char temp[1000];
   strcpy(temp, asmLine);
   char* a = temp;
   if (isRegisterUse(a) || (*a =='P' && *(a + 1) == 'C')) {
      if (*a == 'P')
         a += 2;
      else
         a = skiploc(a);
      if (*a == '=') {
         a++;
         if (allMapping.find(string(a)) != allMapping.end()) {
            strcpy(a, getData(allMapping[string(a)]));
            return strdup(temp);
         }
         else if (( a = strstr(a, ",")) != 0) {
            char mytemp[1000];
            char* b = mytemp;
            a++; // skip the comma
            char* pos1 = a;
            while (*a != '\t' && *a != 0) {
               *b++ = *a++;
            }
            char* pos2 = a; // we want to leave tab or null
            *b = 0;
            if (allMapping.find(string(mytemp)) != allMapping.end()) {
               char mytemp2[1000];
               strcpy(mytemp2, getData(allMapping[string(mytemp)]));
               sub(pos1, pos2, mytemp2);
               return strdup(temp);
            }
         }
      } // end if (*a == '=') 
   } // end if (isRegisterUse(a) || (*a =='P' && *(a+1) == 'C'))

   return 0;
}
