/************************************************************************/
/*                                                                      */
/* Copyright (c) 1990, 1991, 1992 -                                     */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/yyfast/yyfast.h,v $
 $Date: 2003/03/12 15:35:10 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: yyfast.h,v $
 Revision 1.3  2003/03/12 15:35:10  jdh8d
 *** empty log message ***

 Revision 1.2  2002/01/03 16:46:33  jdh8d
 *** empty log message ***

 Revision 1.1.1.1  2000/08/22 21:10:35  zephyr
 Created directory structure

 Revision 1.2  1998/04/08 18:40:16  jwd
 First ANSI C version.


*************************************************************************/

/*
 * This file contains the declarations needed by the yyfast utility
 */

#define STRINGSIZE 2048
#define ARRAYSIZE 4096     /* This value MUST be a power of two */
#define MAXSTATES 2048
#define MAXTOKEN 1024     /* This value MUST be greater than 128 */
#define MAXGOTO 1024
#define TRUE 1
#define FALSE 0

typedef char string[STRINGSIZE];
typedef char *string_pointer;

typedef struct ARRAY_ELEMENT {
    struct ARRAY_ELEMENT *next;
    short value[ARRAYSIZE];
    } array_element;
typedef array_element *array;

typedef struct ACTION {
    struct ACTION *next;
    short number;
    string_pointer reference;
    string_pointer body;
    } action;
typedef action *action_pointer;

typedef struct {
    unsigned int needs_shift : 1;
    unsigned int needs_state : 1;
    unsigned int uses_exception : 1;
    unsigned int complex_token : 1;
    unsigned int complex_check : 1;
    unsigned int visited : 1;
    unsigned int might_shift : 1;
    unsigned int might_reduce : 1;
    unsigned int save_yylval : 1;
    short token_checks;
    } state_info;

typedef struct {
    string_pointer ident;
    unsigned int complex_token : 1;
    unsigned int uses_yylval : 1;
    } token_info;

typedef struct {
    short uses;
    short state;
    short state_checks;
    short reduce_label_num;
    unsigned int label_emitted : 1;
    } reduce_info;
