
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/misc.c,v $
 $Date: 2004/01/29 01:11:38 $
 $Revision: 1.55 $
 $Name:  $

 Log of changes:

 $Log: misc.c,v $
 Revision 1.55  2004/01/29 01:11:38  clc5q
 Initialize the conin and conout fields in new_basic_block().
 Make initialization preprocessor macros correspond to the declarations
   (e.g. MEASURE, INTERACT, SCHED, FILL)
 Cosmetic fixes.

 Revision 1.54  2004/01/21 18:39:58  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.53  2004/01/15 15:43:38  jdh8d
 fixed C++ style comments .. don't put them in again, YOU HEAR ME WHOEVER DID THIS??

 Revision 1.52  2003/08/28 18:29:35  jdh8d
 changes to get tms working; rtl deleted twice in cdmotion.c

 Revision 1.51  2003/08/27 02:45:37  jdh8d
 minor changes to make VISTA build

 Revision 1.50  2003/08/19 16:33:51  jdh8d
 fixed multiline constants added by (i think) indent tool

 Revision 1.49  2003/08/01 04:40:14  jg9h
 Added more rtl list manipulation functions.
 Changed calls to prev_rtl() into up_rtl().

 Revision 1.48  2003/07/17 04:33:41  jg9h
 VISTA update

 Revision 1.47  2003/07/11 21:03:24  clc5q
 Reset veclen to zero in clear_function().
 Add assertion in frmalloc().
 Delete stupid "extern" declarations inside do_fn_clean().

 Revision 1.46  2003/07/07 02:53:10  jg9h
 Moved real_move_rtl() from hand_trans to misc.c

 Revision 1.45  2003/04/23 17:51:36  clc5q
 Initialize new "prof" pointer to NULL in each new basic block.

 Revision 1.44  2003/04/09 20:54:55  clc5q
 Link each ignode and basic block to the loops that contain it.

 Revision 1.43  2003/04/04 04:35:52  jg9h
 Removed C++ style comment from INTERACT code

 Revision 1.42  2003/04/03 20:06:10  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.41  2003/03/20 21:38:10  jg9h
 Added is_present_in_ref() and add_to_ref() routines.

 Revision 1.40  2003/03/03 20:36:29  jg9h
 update_label() didnt set the label if VET was off

 Revision 1.39  2003/02/18 15:56:23  jdh8d
 minor tweaks/callgraph improvements

 Revision 1.38  2003/02/06 04:46:29  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.37  2003/01/07 22:45:57  clc5q
 Use an assertion in gtline() to guard against buffer overflow.

 Revision 1.36  2002/11/25 14:40:32  jwd
 Made changes so EASE functionality can be built.  It had gotten out of sync
 with the rest of the compiler.  This required moving some functions from
 rtlspec.c to misc.c because the EASE library uses rtlspec.c.
 
 Revision 1.35  2002/10/03 15:49:37  clc5q
 Replace "extern ..." garbage in *.c files with extern declarations in
 header files.

 Revision 1.34  2002/07/11 15:22:31  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.33  2002/06/05 20:08:53  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.32  2002/03/29 19:53:58  rv3s
 Added a new routine clear_block_info() that clears all data held by a basic
 block. Called by remv_unreachable_code to remove all info on a block (but not
 the block itself as it might have asm lines)

 Revision 1.31  2002/03/25 17:13:20  rv3s
 New routine nullify_rtl() added to null out rtl values, instead of deleting the rtls. Machine dependent modules should not use remv_rtl to delete an rtl. Instead, they should call nullify_rtl to remove the effects of the rtl, and let remove_null_rtls() in the optimizer main loop to remove them

 Revision 1.30  2002/03/19 01:28:58  jdh8d
 *** empty log message ***

 Revision 1.29  2002/03/18 22:21:28  jdh8d
 *** empty log message ***

 Revision 1.28  2002/01/03 16:46:33  jdh8d
 *** empty log message ***

 Revision 1.27  2001/12/30 23:47:12  jdh8d
 *** empty log message ***

 Revision 1.26  2001/12/18 15:07:45  rv3s
 Initialized all_lnks to NULL

 Revision 1.25  2001/11/27 20:27:30  rv3s
 *** empty log message ***

 Revision 1.24  2001/11/13 17:04:50  jdh8d
  fixed memory leaks

 Revision 1.23  2001/10/31 18:48:51  jdh8d
 *** empty log message ***

 Revision 1.22  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.21  2001/10/25 22:08:36  jdh8d
 added some checks to avoid excessive memory usage

 Revision 1.20  2001/09/24 20:35:36  jdh8d
 *** empty log message ***

 Revision 1.19  2001/09/12 17:13:04  jdh8d
 *** empty log message ***

 Revision 1.18  2001/09/06 20:32:27  jdh8d
 *** empty log message ***

 Revision 1.17  2001/08/03 20:23:32  jdh8d
 *** empty log message ***

 Revision 1.16  2001/07/27 20:57:39  jdh8d
 *** empty log message ***

 Revision 1.15  2001/07/23 18:34:19  rv3s
 Replaced skiploc() with skiplocOr2() for processing register lists

 Revision 1.14  2001/07/20 15:48:50  jdh8d
 *** empty log message ***

 Revision 1.13  2001/06/26 20:00:33  rv3s
 size of str in gtline changed to BIGSTRING to enable debug support

 Revision 1.12  2001/05/23 20:28:21  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.11  2001/05/21 18:43:11  jdh8d

 changes to watch register aliases and SE's more clothes

 Revision 1.10  2001/04/13 21:49:53  jdh8d
 *** empty log message ***

 Revision 1.9  2001/04/09 15:48:42  jdh8d

 Debugging w/o DISPOSE turned on.

 Revision 1.8  2000/06/10 19:16:01  jwd
 Raja found a bug in fmatch.  If either the string or the pattern
 are NULL, return FALSE.

 Revision 1.7  2000/06/09 19:42:55  jwd
 Changed calls to VET to indicate which phases are mandatory and
 which are optional.
 Revision 1.6  1999/03/05 17:01:21  jwd
 Added more code to support VET.
 Revision 1.5  1999/01/06 15:51:32  jwd
 Originally the side effect field was used to hold the initial dead list
 which was a string. During initialization, the SE field was converted
 to a bit vector representation and SE was used for real side effects.
 This caused numerous problems (with VET and other phases). A
 new field (InitialDeads) was added to hold the initial list of dead
 registers.
 
 Added VET support too.
 Revision 1.4  1998/08/07 16:20:01  jwd
 NT does not have sbrk. Added conditional compilation
 code to use malloc when compiling for WIN32.
 Revision 1.3  1998/04/03 18:19:53  jwd
 First ANSI C version.

*************************************************************************/

/*-----History of Changes------------------
   1/12/98: Function Prototypes modified to use header files instead of
   local defintion for improved modularity and ANSI-C compatibility

   Note: Could not find reference for FIFO option afifo!

   NOTE: THis code uses malloc. I included <malloc.h> Use a different malloc?
  ------------------------------------------------*/

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <malloc.h>
#include <assert.h>
#include <sys/time.h>

#include "vpo.h"
#include "arena.h"
#include "assign.h" 
#include "cdmotion.h"
#include "controlflow.h"
#include "locals.h"
#include "misc.h"
#include "vectors.h"
#include "vpo2.h"
#include "stache.h"
#include "rtl.h"
#include "de_optimize.h"
#include "instdef.h"

#include "regs2.h"  /*Hardware dependent */

#ifdef INTERACT
#define CRC32_MASK 0xFF000000
#define CRC32_SHIFT 24

/*FILE *remap_fp;
int remap_count=0;
char filename[MAXSTRING], filebuf[BUFSIZ];*/

unsigned int CRC32Table[] =
  {
        0x00000000,	0x04c11db7,	0x09823b6e,	0x0d4326d9,
	0x130476dc,	0x17c56b6b,	0x1a864db2,	0x1e475005,
	0x2608edb8,	0x22c9f00f,	0x2f8ad6d6,	0x2b4bcb61,
	0x350c9b64,	0x31cd86d3,	0x3c8ea00a,	0x384fbdbd,
	0x4c11db70,	0x48d0c6c7,	0x4593e01e,	0x4152fda9,
	0x5f15adac,	0x5bd4b01b,	0x569796c2,	0x52568b75,
	0x6a1936c8,	0x6ed82b7f,	0x639b0da6,	0x675a1011,
	0x791d4014,	0x7ddc5da3,	0x709f7b7a,	0x745e66cd,
	0x9823b6e0,	0x9ce2ab57,	0x91a18d8e,	0x95609039,
	0x8b27c03c,	0x8fe6dd8b,	0x82a5fb52,	0x8664e6e5,
	0xbe2b5b58,	0xbaea46ef,	0xb7a96036,	0xb3687d81,
	0xad2f2d84,	0xa9ee3033,	0xa4ad16ea,	0xa06c0b5d,
	0xd4326d90,	0xd0f37027,	0xddb056fe,	0xd9714b49,
	0xc7361b4c,	0xc3f706fb,	0xceb42022,	0xca753d95,
	0xf23a8028,	0xf6fb9d9f,	0xfbb8bb46,	0xff79a6f1,
	0xe13ef6f4,	0xe5ffeb43,	0xe8bccd9a,	0xec7dd02d,

	0x34867077,	0x30476dc0,	0x3d044b19,	0x39c556ae,
	0x278206ab,	0x23431b1c,	0x2e003dc5,	0x2ac12072,
	0x128e9dcf,	0x164f8078,	0x1b0ca6a1,	0x1fcdbb16,
	0x018aeb13,	0x054bf6a4,	0x0808d07d,	0x0cc9cdca,
	0x7897ab07,	0x7c56b6b0,	0x71159069,	0x75d48dde,
	0x6b93dddb,	0x6f52c06c,	0x6211e6b5,	0x66d0fb02,
	0x5e9f46bf,	0x5a5e5b08,	0x571d7dd1,	0x53dc6066,
	0x4d9b3063,	0x495a2dd4,	0x44190b0d,	0x40d816ba,
	0xaca5c697,	0xa864db20,	0xa527fdf9,	0xa1e6e04e,
	0xbfa1b04b,	0xbb60adfc,	0xb6238b25,	0xb2e29692,
	0x8aad2b2f,	0x8e6c3698,	0x832f1041,	0x87ee0df6,
	0x99a95df3,	0x9d684044,	0x902b669d,	0x94ea7b2a,
	0xe0b41de7,	0xe4750050,	0xe9362689,	0xedf73b3e,
	0xf3b06b3b,	0xf771768c,	0xfa325055,	0xfef34de2,
	0xc6bcf05f,	0xc27dede8,	0xcf3ecb31,	0xcbffd686,
	0xd5b88683,	0xd1799b34,	0xdc3abded,	0xd8fba05a,

	0x690ce0ee,	0x6dcdfd59,	0x608edb80,	0x644fc637,
	0x7a089632,	0x7ec98b85,	0x738aad5c,	0x774bb0eb,
	0x4f040d56,	0x4bc510e1,	0x46863638,	0x42472b8f,
	0x5c007b8a,	0x58c1663d,	0x558240e4,	0x51435d53,
	0x251d3b9e,	0x21dc2629,	0x2c9f00f0,	0x285e1d47,
	0x36194d42,	0x32d850f5,	0x3f9b762c,	0x3b5a6b9b,
	0x0315d626,	0x07d4cb91,	0x0a97ed48,	0x0e56f0ff,
	0x1011a0fa,	0x14d0bd4d,	0x19939b94,	0x1d528623,
	0xf12f560e,	0xf5ee4bb9,	0xf8ad6d60,	0xfc6c70d7,
	0xe22b20d2,	0xe6ea3d65,	0xeba91bbc,	0xef68060b,
	0xd727bbb6,	0xd3e6a601,	0xdea580d8,	0xda649d6f,
	0xc423cd6a,	0xc0e2d0dd,	0xcda1f604,	0xc960ebb3,
	0xbd3e8d7e,	0xb9ff90c9,	0xb4bcb610,	0xb07daba7,
	0xae3afba2,	0xaafbe615,	0xa7b8c0cc,	0xa379dd7b,
	0x9b3660c6,	0x9ff77d71,	0x92b45ba8,	0x9675461f,
	0x8832161a,	0x8cf30bad,	0x81b02d74,	0x857130c3,

	0x5d8a9099,	0x594b8d2e,	0x5408abf7,	0x50c9b640,
	0x4e8ee645,	0x4a4ffbf2,	0x470cdd2b,	0x43cdc09c,
	0x7b827d21,	0x7f436096,	0x7200464f,	0x76c15bf8,
	0x68860bfd,	0x6c47164a,	0x61043093,	0x65c52d24,
	0x119b4be9,	0x155a565e,	0x18197087,	0x1cd86d30,
	0x029f3d35,	0x065e2082,	0x0b1d065b,	0x0fdc1bec,
	0x3793a651,	0x3352bbe6,	0x3e119d3f,	0x3ad08088,
	0x2497d08d,	0x2056cd3a,	0x2d15ebe3,	0x29d4f654,
	0xc5a92679,	0xc1683bce,	0xcc2b1d17,	0xc8ea00a0,
	0xd6ad50a5,	0xd26c4d12,	0xdf2f6bcb,	0xdbee767c,
	0xe3a1cbc1,	0xe760d676,	0xea23f0af,	0xeee2ed18,
	0xf0a5bd1d,	0xf464a0aa,	0xf9278673,	0xfde69bc4,
	0x89b8fd09,	0x8d79e0be,	0x803ac667,	0x84fbdbd0,
	0x9abc8bd5,	0x9e7d9662,	0x933eb0bb,	0x97ffad0c,
	0xafb010b1,	0xab710d06,	0xa6322bdf,	0xa2f33668,
	0xbcb4666d,	0xb8757bda,	0xb5365d03,	0xb1f740b4
  };

double enable_table[30][30]= {
      0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.12, 0.00, 0.92, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 1.14, 0.00, 0.02, 0.00, 50.33, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 15.58, 0.00, 0.00, 95.21, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.18, 
    0.00, 84.56, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 16.54, 0.00, 2.36, 3.41, 0.00, 1.85, 0.00, 3.68, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.01, 2.74, 1.89, 0.00, 0.00, 0.00, 
    0.00, 3.04, 0.00, 0.00, 0.00, 1.34, 0.00, 0.05, 0.00, 8.31, 
    0.00, 16.54, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 30.19, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 41.58, 99.87, 30.81, 0.00, 0.00, 0.00, 
    0.00, 50.00, 0.00, 0.00, 0.00, 70.70, 0.00, 10.21, 0.00, 29.92, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 65.88, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 3.33, 0.00, 0.00, 0.00, 0.00, 0.12, 0.00, 0.41, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.42, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 20.17, 
    0.00, 0.00, 0.00, 0.03, 0.01, 0.00, 0.00, 0.00, 20.35, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 52.12, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 15.61, 0.00, 0.01, 0.00, 0.05, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 93.66, 0.00, 
    0.00, 0.00, 0.00, 0.00, 12.59, 0.00, 2.59, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 16.61, 0.00, 0.00, 22.30, 0.00, 0.00, 0.00, 31.48, 0.00, 
    16.67, 0.00, 0.00, 0.00, 9.25, 100.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 83.33, 0.00, 0.00, 0.00, 80.26, 0.00, 3.96, 0.00, 2.34, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.31, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 54.75, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 9.70, 0.00, 0.18, 0.00, 3.48, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.55, 44.23, 2.71, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.23, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 15.75, 0.00, 7.44, 25.42, 16.34, 18.72, 0.00, 35.04, 0.00, 
    3.76, 0.00, 0.00, 1.58, 42.07, 10.54, 53.66, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.02, 0.00, 0.00, 0.00, 18.02, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.09, 0.00, 0.10, 9.30, 0.00, 0.00, 0.00, 0.89, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 13.67, 0.65, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.68, 0.00, 0.00, 0.00, 0.00
};

double disable_table[30][30] ={
      0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 39.09, 0.00, 0.00, 0.01, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.02, 0.00, 0.00, 0.00, 16.67, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 100.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 16.67, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 3.49, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 1.55, 0.00, 0.00, 0.00, 16.67, 
    0.00, 0.00, 0.00, 0.00, 11.81, 0.00, 2.40, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.21, 0.00, 0.00, 0.00, 0.32, 
    0.00, 0.00, 0.00, 52.97, 0.00, 10.14, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 16.67, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 1.56, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.47, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.01, 0.00, 0.02, 0.00, 0.03, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 83.33, 100.00, 100.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 28.38, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 16.25, 14.99, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.01, 0.00, 0.00, 0.01, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.03, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.29, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 1.46, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.10, 0.00, 0.00, 0.05, 0.00, 0.00, 0.00, 2.69, 0.00, 
    0.03, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.03, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 63.34, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 10.83, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.06, 0.34, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.01, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 7.85, 0.00, 0.03, 0.03, 0.07, 0.10, 0.00, 0.96, 0.00, 
    0.00, 0.00, 0.00, 0.47, 10.29, 4.45, 5.00, 0.00, 0.00, 0.00, 
    0.00, 14.79, 0.00, 0.00, 0.00, 64.27, 0.00, 0.00, 0.00, 49.19, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 31.31, 0.00, 0.00, 0.00, 0.00, 10.08, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 
    0.00, 0.00, 0.00, 0.00, 0.00, 0.03, 0.00, 0.00, 0.00, 0.00
};

#endif

#ifdef INTERACT

/*#define GENETIC_ALGO1 */
#define GENETIC_ALGO2

extern int dassem;
extern int erflag;
extern int str_ptr;
extern int i_ptr;
extern char *linptr;
extern struct list *curptr;
#ifdef INTERACT
	extern int rtl_id;
#endif

char assem_out_str[MAXSTRING];
static char *assem_out_ptr = assem_out_str;
static char assem_ret_str[MAXSTRING];

#define SHORTSTRING 20
#define MAX_SEQ     10
#define MAX_RTL_EXCEED 2
/*
 * mapregs - actually replaces the registers with their mapped
 *           ones for each RTL
 */

extern struct bblock *top;

unsigned long file_checksum(FILE *filename) {
  int c;
  unsigned long checksum = 0;
  
  while ((c = getchar()) != EOF)
    checksum += (unsigned char) c;

  rewind(filename);
  return checksum;
}

/************************************************************
functions defined for writing the result to a string, instead of the
stdout
*************************************************************/

#include <stdarg.h>


int sfprintf(char *format, ...) {
  va_list ap;
  char tmpstr[SHORTSTRING];

  va_start(ap, format);
  assem_out_ptr += vsprintf(assem_out_ptr, format, ap);
  va_end(ap);
}

/*sfputs: used to substitute fputs*/
void sfputs(const char *s, FILE *stream)
{
  if (s) {
     while (*assem_out_ptr++ = *s++)
       ;
     assem_out_ptr -= 1;
  }
}
/*sfputs: used to substitute fputs*/
void sputs(const char *s)
{
   while (*assem_out_ptr++ = *s++)
     ;

   *(assem_out_ptr - 1) = '\n';
/*?
   *assem_out_ptr = '\0';
*/
}


/*sfputc: used to substitute putchar*/
void sfputc(int c, FILE *stream)
{
/*?
  if (c == ' ')
    c = ' ';
*/
  *assem_out_ptr++ = c;
}


#ifdef INTERACT
/*yyparse: call stdout_yyparse
 It is just an alternative of yyparse. I will
 first empty the global string assem_out_str, and then call yyparse.
 then it output this string to the standard output to be serve the function
 of the old yyparse. */
int yyparse()       
{
   int ret;
   /*empty the global destination*/
   assem_out_ptr = assem_out_str;
   /*call yyparse*/
   ret = stdout_yyparse();
   if (assem_out_ptr != assem_out_str) {
      *assem_out_ptr = '\0';
      printf("%s", assem_out_str);
   }
   return ret;
}
#endif

/*another alternative to yyparse. Only called from the dump_rtl_asm function
  in vpo.c*/
int dump_yyparse(char str[])       
{
   int ret;
   /*empty the global destination*/
   assem_out_ptr = assem_out_str;
   /*call yyparse*/
   ret = stdout_yyparse();
   if (assem_out_ptr != assem_out_str) {
      *assem_out_ptr = '\0';
      strcpy(str, assem_out_str);
   }
   return ret;
}

/************************************************************************
trans_to_assem: call yyparse
The difference with syyparse is that this function only write to a global
string, without output to standard output
**************************************************************************/
char *trans_to_assem(struct list *rtlptr)       
{
   char *p, *r;

   int tmp_dassem;
   char *tmp_linptr;
   struct list *tmp_curptr;
   int tmp_sem_ptr, tmp_erflag, tmp_str_ptr, tmp_i_ptr;
   static int ndebug=0;
   int i;
   char *tmpstr;
   extern int sem_ptr;
   /*save old values of global variables*/
   tmp_dassem = dassem;
   tmp_linptr = linptr;
   tmp_curptr = curptr;
   /*added Aug. 29, 2000*/
   tmp_sem_ptr = sem_ptr; tmp_erflag = erflag;
   tmp_str_ptr = str_ptr; tmp_i_ptr = i_ptr;
   /*if the rtlptr->val is NULL, then return null*/
   if (!rtlptr->val)
      return NULL;
   /*set the new value to the global variables*/
   dassem = 1;
   linptr = rtlptr->val;
   curptr = rtlptr;
   sem_ptr = erflag = str_ptr = i_ptr = 0;
   /*empty the global destination*/
   assem_out_ptr = assem_out_str;
   /*call yyparse*/
/*
   fprintf(stderr, "Decoding rtl: ");
   show_rtl(stderr, rtlptr->val);
   fprintf(stderr, "\n");
*/

   stdout_yyparse();

   /*restore the global variables*/
   linptr = tmp_linptr;
   dassem = tmp_dassem;
   curptr = tmp_curptr;
   /**/
   sem_ptr = tmp_sem_ptr; erflag = tmp_erflag;
   str_ptr = tmp_str_ptr; i_ptr = tmp_i_ptr;

   /*for debugging purposes
   ndebug ++;
   if (ndebug >= 725)
      fprintf(stderr, "ndebug is %d\n", ndebug);
   
   /*end for debugging*/
   /*strip the \n*/

   p = assem_out_str;
   r = assem_ret_str;

   while (p != assem_out_ptr && *p != '\n') {
     if (isprint(*p) || isspace(*p))
       *r++ = *p;
     p++;
   }

   *p = '\n';
   if (*p == '\n')
     *r = '\0';
   else {
      fprintf(stderr, "No new line character: `%s'\n", assem_ret_str);
   }

   return assem_ret_str;
}


/************************************************************************
check_syntax: call yyparse
if the syntax is correct, return 0;
Otherwise return 1;
**************************************************************************/

int check_syntax(char *rtlval)       
{
   int ret;
   int tmp_dassem;
   char *tmp_linptr;
   struct list *tmp_curptr;
   int tmp_sem_ptr, tmp_erflag, tmp_str_ptr, tmp_i_ptr;
   static int ndebug=0;
   int i;
   char *tmpstr;
   extern int sem_ptr, check_legal;
   /*save old values of global variables*/
   tmp_dassem = dassem;
   tmp_linptr = linptr;
   tmp_curptr = curptr;
   /*added Aug. 29, 2000*/
   tmp_sem_ptr = sem_ptr; tmp_erflag = erflag;
   tmp_str_ptr = str_ptr; tmp_i_ptr = i_ptr;
   /*if the rtlptr->val is NULL, then return null*/
   if (!rtlval)
      return 0;
   /*set the new value to the global variables*/
   dassem = 0;
   linptr = rtlval;
   /*curptr = rtlptr;*/
   sem_ptr = erflag = str_ptr = i_ptr = 0;
   /*empty the global destination*/
   assem_out_ptr = assem_out_str;
   /*call yyparse*/
   check_legal = TRUE;
   ret = stdout_yyparse();
   check_legal = FALSE;
   
   /*restore the global variables*/
   linptr = tmp_linptr;
   dassem = tmp_dassem;
   curptr = tmp_curptr;
   
   sem_ptr = tmp_sem_ptr; erflag = tmp_erflag;
   str_ptr = tmp_str_ptr; i_ptr = tmp_i_ptr;

   return ret;
}
#endif


#ifdef VET
#include "view.h"
#endif

int block_id = 0;
#ifdef INTERACT
int afterinit_block_id, afterinit_rtl_id;
#endif


char *bpos;		/* set to start of pattern matched */
char *epos;		/* set to end of pattern matched   */
int ignums = 1;		/* total interference graph nodes  */
struct callfunc *ext_funcs = (struct callfunc *) NULL;
 /* list of external function calls */
int ext_num = 0;	/* number of external functions    */


/*
 * allocate_reg_bit_positions - allocate a bit for every pseudo-register used
 */
void allocate_reg_bit_positions() {

   register char *s, *a;
   register struct list *ptr;
   register struct bblock *cblk;

   /* #ifdef FIFOS int afifo(); #endif */

   /*
      Examine all of the basic blocks in the function
   */
   for (cblk = top; cblk; cblk = cblk->next) {
      for (ptr = cblk->rtls; ptr; ptr = ptr->next) {

	 /*
	    Examine each RTL.  Note that along with the process of assigning a
	    bit vector position for each pseudo-register, that we also create a
	    register information structure for it.
	 */
	 if (ptr->type & RTLINE) {

	    /*
	       Look at the registers that are set in this RTL and allocate a
	       register vector position for all those that don't currently have
	       one.  We will assume that the optimizer will never encounter the
	       use of a register that is not explicitly set, a hardware
	       register (pre-allocated by inithardregs()) or on the dead
	       register list of some RTL.  Since this is the case, we need look
	       only at the registers that are set by this RTL.
	    */
	    if (s = ptr->val) {
	       while (*s) {
		  if (isrg(s)) {
		     if (regtovec(s) < 0) {
			if (regallocptr == MAXRVEC) {
			   (void) fprintf(stderr,
					  "vpo (allocate_reg_bit_positions): too many items\n");
			   exit(1);
			}

#ifdef FIFOS
			if (afifo(s))
			   sets[regallocptr].status |= FIFOREG;
			else
			   sets[regallocptr].status &= ~FIFOREG;
#endif

			a = sets[regallocptr].item;
                        copyloc(a,s);
                        a=skiploc(a);
                        s=skiploc(s);
                        *a = '\0';
			sets[regallocptr].num = regallocptr;
			sets[regallocptr].local = NULL;
			vecmap[regname(regallocptr)] = regallocptr;
			regallocptr++;
		     }
		  }
		  while (*s++ != ';');
	       }
	    }

	    /*
	       At this point, the "se" field of the RTL contains not the side-
	       effect, but a the literal list of dead registers for this item.
	       Although we should have all of the registers that appear in
	       these lists already allocated to a register vector position, we
	       will allow new ones to be allocated here because its easy to do
	       and might actually come in handy in a future version of the
	       optimizer.  Once we have determined how many different registers
	       are used in this function, the register vector length can be
	       determined and the function vectorize_deads() will be called to
	       transform this literal list of registers into an actual register
	       vector.
	    */
	    if (s = ptr->InitialDeads) {
	       while (*s) {
		  if (regtovec(s) < 0) {
		     if (regallocptr == MAXRVEC) {
			(void) fprintf(stderr,
			"vpo (allocate_reg_bit_positions): too many items\n");
			exit(1);
		     }

#ifdef FIFOS
		     if (afifo(s))
			sets[regallocptr].status |= FIFOREG;
		     else
			sets[regallocptr].status &= ~FIFOREG;
#endif

		     a = sets[regallocptr].item;
                     copylocOr2(a,s);
                     a=skiplocOr2(a);
                     s=skiplocOr2(s);
                     *a = '\0';
		     sets[regallocptr].num = regallocptr;
		     sets[regallocptr].local = NULL;
		     vecmap[regname(regallocptr)] = regallocptr;
		     regallocptr++;
		  }
		  else
		     s = skiplocOr2(s);
	       }
	    }
	 }

	 /*
	    Look also at local register assigment reserve lines to ensure that
	    all of the pseudo-registers used are given a bit vector position.
	 */
	 else if (ptr->type & RESLINE) {
	    if (s = ptr->val) {
	       if (isrg(s)) {
		  if (regtovec(s) < 0) {
		     if (regallocptr == MAXRVEC) {
			(void) fprintf(stderr,
			"vpo (allocate_reg_bit_positions): too many items\n");
			exit(1);
		     }

#ifdef FIFOS
		     if (afifo(s))
			sets[regallocptr].status |= FIFOREG;
		     else
			sets[regallocptr].status &= ~FIFOREG;
#endif

		     a = sets[regallocptr].item;
                     copyloc(a,s);
                     a=skiploc(a);
                     s=skiploc(s);
                     *a = '\0';
		     sets[regallocptr].num = regallocptr;
		     sets[regallocptr].local = NULL;
		     vecmap[regname(regallocptr)] = regallocptr;
		     regallocptr++;
		  }
	       }
	    }
	 }
      }
   }
}

/*
 * vectorize_deads - transforms literal dead registers lists to bit vectors
 */
void vectorize_deads(int invocation) {

   register char *s;
   register struct list *rtl;
   register struct bblock *cblk;

   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && debug_opt_i("dump_before_vectorize_deads", invocation))
      dump_function_i("before vectorize_deads()", invocation,
		      SHOW_NONRTLS | SHOW_SE);

#ifdef VET
   /*
      Only turn on this phase for debugging purposes. Sanity check
      fails on the deads because before deads are vectorized they
      are unorderd. This phase will resend all the deads so that
      VET updates the deads.
      Visit each RTL in the function and for each RTL that contains a literal
      dead register list (found temporarily in the initial deads field),
      transfer that list to an actual bit vector.
   */
#ifdef INTERACT
	if (swq) 
#else
    if (sanity_enabled) 
#endif
	 { /* placed the opening brace here so as to avoid confusing editors in their
			brace matching */
#ifdef INTERACT
		 begin_phase(DEBUG_TRANS);
#else
		 begin_phase(VECTORIZEDEADS_PHASE);
#endif
	begin_trans(VET_OPT_TRANS);
    }
    /* 
     * Tell viewer dead register list is now in form of bit 
     * vectors and therefore can use the dead register list.
     * Do this before the actual event occurs so that the deads
     * lists being changed are sent to VET.
     */
    DeadsareBitVectors = TRUE;

#endif

    /*
     * Visit each RTL in the function and for each RTL that contains a
     * literal dead register list (found temporarily attached to the
     * side effect field), transfer that list to an actual bit vector.
     */
   for (cblk = top; cblk; cblk = cblk->next) {
      for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
	 if (s = rtl->InitialDeads) {
	    while (*s) {
	       rinsert(s, &rtl->deads);
	       s = skiplocOr2(s);
	    }
	    FREE(rtl->InitialDeads);
	    rtl->InitialDeads = (char *) NULL;
	 }
      }
   }

#ifdef VET
#ifdef INTERACT
	if (swq) 
#else
    if (sanity_enabled) 
#endif
	 {
	end_trans();
#ifdef INTERACT
	end_phase(DEBUG_TRANS);
#else
	end_phase(VECTORIZEDEADS_PHASE);
#endif

    }
#endif
   /*
      Check to see if the user would like to see the state of the function at
      this point in time.
   */
   if (swd && debug_opt_i("dump_after_vectorize_deads", invocation))
      dump_function_i("after vectorize_deads()", invocation,
		      SHOW_NONRTLS | SHOW_SE);
}

/*
 * clear_call_graph - dispose of all functions called from this function
 */
void clear_call_graph() {


#ifndef DISPOSE
   struct callfunc *ptr, *dptr;

   ptr = ext_funcs;
   while (ptr) {
      dptr = ptr;
      ptr = ptr->next;
      free((char *) dptr);
   }
#endif

   ext_funcs = (struct callfunc *) NULL;
   ext_num = 0;
}

/*
 * add_func - add a new external function identifier to the global list
 */
void add_func(char *id) {

   struct callfunc *ptr;


   ptr = (struct callfunc *) SALLOC(sizeof(struct callfunc));
   ptr->next = ext_funcs;
   (void) strcpy(ptr->name, id);
   ext_funcs = ptr;
   ext_num++;
}

/*
 * clear_function - releases the function to the heap
 */
void clear_function() {


#ifndef DISPOSE
   register struct bblock *cblk, *dblk;
 

   /*
      Free up the space taken up by each basic block in the function
   */
   cblk = top;
   while (cblk) {
      dblk = cblk;
      cblk = cblk->next;
      free_basic_block(dblk);
   }
   FREE(sret);
#endif

   /*
      Clear the items used to maintain access to the function
   */
   top = last = ret_block = bottom = (struct bblock *) NULL;
   fn = (char *) NULL;
   sret = (char *) NULL;
   varargs = FALSE;
   veclen = 0;
}

/*
 * new_basic_block - returns a new basic block record
 */
struct bblock *new_basic_block(char *label) {

   register struct bblock *cblk;

   /*
      Allocate the space for a new basic block structure and link it into the
      next list that keeps track of all of the basic blocks.
   */
   if (last) {
      cblk = last->next = BALLOC;
      last = cblk;
   }
   else
      cblk = last = BALLOC;

   block_id ++;
   cblk->block_id = block_id;

   /*
      Initialize all of the fields of the new basic block
   */
   cblk->preds = (struct blist *) NULL;
   cblk->label = label;
   cblk->next = (struct bblock *) NULL;
   cblk->up = cblk->down = (struct bblock *) NULL;
   cblk->prev_dfs = cblk->next_dfs = cblk->parent_dfs = (struct bblock *) NULL;
   cblk->idom = cblk->sdom = (struct bblock *) NULL;
   cblk->dom_front = (struct blist *) NULL;
   cblk->bnum = cblk->dnum = 0;

#if defined(MEASURE) || defined(INTERACT)
   cblk->dom = dinit();
#endif
#ifdef MEASURE
   cblk->equivclass = dinit();
   cblk->equivnum = 0;
#endif

   cblk->loop = (struct loopl *) NULL;
   cblk->looplist = (struct listl *) NULL;
   cblk->prof = (struct DataProfile *) NULL;
   cblk->rtls = cblk->rtlend = (struct list *) NULL;
   cblk->left = cblk->right = (struct bblock *) NULL;
   cblk->status = cblk->freq = 0;
   cblk->estimate = 0.0;
   cblk->dlist = rinit();
   cblk->ulist = rinit();
   cblk->olist = rinit();
   cblk->phi_funcs = (struct phi *) NULL;
   cblk->sets_out = (struct defnode *) NULL;
   cblk->regstate = reginit();
   cblk->elist = (struct eqvtable *) NULL;
   cblk->conin = cblk->conout = (struct ignode *) NULL;
#ifdef INTERACT
  if (swq) {
      cblk->inscope = FALSE;
      cblk->old_next = (struct bblock *) NULL;
      cblk->old_right = (struct bblock *) NULL;
      cblk->old_down = (struct bblock *) NULL;
      cblk->old_up = (struct bblock *) NULL;
      cblk->old_rtls = (struct list *) NULL;
      cblk->old_rtlend = (struct list *) NULL;
   }	
#endif
#ifdef VET
    new_bb(cblk);
#endif
   return (cblk);
}

/*
 * remv_basic_block - remove the basic block from the function and release it
 */
void remv_basic_block(struct bblock * cblk) {

   register struct bblock *prev, *find;
   register struct loopl *loop;
 

   /*
      If this basic block happened to be the preheader of some loop at some
      point, then we better indicate that it no longer is.
   */
   for (loop = loops; loop; loop = loop->next) {
      if (loop->preheader == cblk) {
	 loop->preheader = (struct bblock *) NULL;
	 break;
      }
   }

   /*
      Remove the basic block that we are about to delete from the next list
   */
   prev = (struct bblock *) NULL;
   for (find = top; find; find = find->next) 
   {
	   if (find == cblk) 
	   {
		   if (prev)
			   prev->next = cblk->next;
		   else 
		   {
			   (void) fprintf(stderr,
				   "vpo (remv_basic_block): attempt to remove the entry block\n");
			   exit(1);
		   }
		   if (!cblk->next)
			   last = prev;
		   break;
	   }
	   prev = find;
   }

   /*
      Return the basic block to the heap
   */
   free_basic_block(cblk);
}

/*
 * free_basic_block - returns a basic block to the heap
 */
void free_basic_block(register struct bblock * cblk) {

   register struct list *rtlptr, *drtl;
   register struct blist *bptr, *dptr;
   struct phi *pphi, *dphi;
   struct phi_list *pphil, *dphil;
   struct defnode *pdef, *ddef;

   /*
      Release all records making up the predecessor list
   */
   bptr = cblk->preds;
   while (bptr) {
      dptr = bptr;
      bptr = bptr->next;
#ifndef VET
    /*
     * VET relies on receiving a unique ptr id for each
     * BB during the compilation of a function.
     */
      FREETYPE(dptr, BLISTTYPE);
#endif
   }

   /*
      Release all of the RTLs in the basic block
   */
   rtlptr = cblk->rtls;
   while (rtlptr) {
      drtl = rtlptr;
      rtlptr = rtlptr->next;
      FREE(drtl->val);
      FREE(drtl->se);
      FREE(drtl->InitialDeads);
      rfree(drtl->deads);
#ifdef VET
      del_rtl(drtl);
#endif
#ifndef VET
      /* VET relies on receiving a unique ptr id for each RTL during
         the compilation of a function. */
      FREETYPE(drtl, LISTTYPE);
#endif
   }

   /*
      Release all records making up the dominance frontier
   */
   bptr = cblk->dom_front;
   while (bptr) {
      dptr = bptr;
      bptr = bptr->next;
      FREETYPE(dptr, BLISTTYPE);
   }

   /*
      Release any SSA form information
   */
   pphi = cblk->phi_funcs;
   while (pphi) {
      pphil = pphi->sets;
      while (pphil) {
	 dphil = pphil;
	 pphil = pphil->next;
	 FREETYPE(dphil, PHILISTTYPE);
      }
      dphi = pphi;
      pphi = pphi->next;
      FREETYPE(dphi, PHITYPE);
   }
   pdef = cblk->sets_out;
   while (pdef) {
      ddef = pdef;
      pdef = pdef->next;
      FREETYPE(ddef, DEFNODETYPE);
   }

   /*
      Release the storage used to hold the block label unless it is the return
      label, whose storage is in a static memory location.
   */
   if (cblk != ret_block && cblk->label)
      FREE(cblk->label);

#ifdef MEASURE
   dfree(cblk->dom);
   dfree(cblk->equivclass);
#endif

   rfree(cblk->dlist);
   rfree(cblk->ulist);
   rfree(cblk->olist);
   regfree(cblk->regstate);
#ifdef VET
    del_bb(cblk);
#endif
#ifndef VET
    /*
     * VET relies on receiving a unique ptr id for each
     * BB during the compilation of a function.
     */
   FREETYPE(cblk, BBLOCKTYPE);
#endif
}

/*
 * add_predecessor - adds a basic block to a predecessor list
 */
void add_predecessor(struct bblock *pred, struct bblock *child) {

   register struct blist *ptr;

   /*check if the child pred already exists in child's pred list*/
   for(ptr=child->preds ; ptr ; ptr=ptr->next){
     if(ptr->ptr == pred)
       return;
   }
   
   /*
      Create a new basic block list structure and add it to the predecessor
      list of the basic block.
   */
   ptr = (struct blist *) SALLOCTYPE(sizeof(struct blist), BLISTTYPE);
   ptr->next = child->preds;
   ptr->ptr = pred;
   child->preds = ptr;
}

/*
 * change_predecessor - change the predecessor list to replace an item
 */
void change_predecessor(struct bblock * old_pred, struct bblock * new_pred, struct bblock * child) {

   register struct blist *ptr, *ptr2;

   /*check if the child pred already exists in child's pred list*/
   for(ptr=child->preds ; ptr ; ptr=ptr->next){
     if(ptr->ptr == new_pred)
       break;
   }
       
   /*simply remove the reference to old_pred*/
   if(ptr && ptr->ptr == new_pred){
     remv_predecessor(old_pred, child);
     return; 
   }
     
   /*
     Search through the child's predecessor list.  When the reference to
     "old_pred" is located, replace it with a reference to "new_pred".
   */
   for (ptr = child->preds; ptr; ptr = ptr->next) {
     if (ptr->ptr == old_pred) {
       ptr->ptr = new_pred;
       break;
     }
   }
}

/*
 * remv_predecessor - removes "pred" from the "child" predecessor list
 */
void remv_predecessor(struct bblock * pred, struct bblock * child) {

   register struct blist *ptr, *prev;

   /*if the pred has two pointers to child then do not remove the pred entry
     in the child unless both pointers are removed*/
   
   /*
      Since the predecessor list is only linked one way, we have to remember
      the previous list item so that we can remove the item that we are looking
      for from the list.
   */
   prev = (struct blist *) NULL;
   for (ptr = child->preds; ptr; ptr = ptr->next) {
      if (ptr->ptr == pred) {
	 if (prev)
	    prev->next = ptr->next;
	 else
	    child->preds = ptr->next;
	 FREETYPE(ptr, BLISTTYPE);
	 break;
      }
      prev = ptr;
   }
}

/*
 * add_frontier_basic_block - add a basic block to a dominance frontier list
 */
void add_frontier_basic_block(struct bblock *cblk, struct bblock *front) {

   register struct blist *ptr, *last;

   /*
      Check to ensure that the basic block is not already a part of this
      dominance frontier list.
   */
   last = (struct blist *) NULL;
   for (ptr = cblk->dom_front; ptr; ptr = ptr->next) {
      if (ptr->ptr == front)
	 return;
      last = ptr;
   }

   /*
      Create a new basic block list structure and add it to the dominance
      frontier list of the basic block.
   */
   ptr = (struct blist *) SALLOCTYPE(sizeof(struct blist), BLISTTYPE);
   ptr->ptr = front;
   ptr->next = (struct blist *) NULL;
   if (last)
      last->next = ptr;
   else
      cblk->dom_front = ptr;
}

/*
 * add_rtl - add a new RTL to a basic block
 */
struct list *add_rtl(struct bblock *cblk, struct list *ptr, char *new, rlist deads) {

   register struct list *rtl;
   struct list *end;
 

   /*
      Since the new_rtl() function always inserts the new RTL structure at the
      end of the basic block indicated, we need to save a pointer to the
      current end of the basic block if we add the new RTL to the middle of the
      basic block.
   */
   end = cblk->rtlend;
   if (ptr) {
      if (ptr->daddy != cblk)
	 (void) fprintf(stderr, "vpo (add_rtl): cblk is not ptr->daddy\n");
      rtl = new_rtl(cblk, RTLINE, ptr->prev);
      cblk->rtlend = end;
      rtl->next = ptr;
      ptr->prev = rtl;
   }
   else
      rtl = new_rtl(cblk, RTLINE, end);

   /*
      Give the RTL the value and dead register list given
   */
   if (new)
      rtl->val = strcpy(CALLOC(strlen(new) + 1), new);
   rtl->deads = deads;

#ifdef VET
    insert_rtl(rtl);
    if (deads)
#ifdef INTERACT
		 mod_deads(rtl, rinit(), deads);
#else
	 mod_deads(rtl);
#endif
#endif
   return (rtl);
}

/*
 * add_rtl_with_type - add a new RTL to a basic block but don't
 *		       assume type is RTLINE use parameter.
 */
struct list *add_rtl_with_type(struct bblock *cblk, struct list *ptr, char *new, rlist deads,
 unsigned int type) {
   register struct list *rtl;
    struct list *end;
  
    /*
     * Since the new_rtl() function always inserts the new RTL structure at
     * the end of the basic block indicated, we need to save a pointer to the
     * current end of the basic block if we add the new RTL to the middle of
     * the basic block.
     */
    end = cblk->rtlend;
    if (ptr) {
      if (ptr->daddy != cblk)
        (void) fprintf(stderr, "vpo (add_rtl_with_type): cblk is not ptr->daddy\n");
      rtl = new_rtl(cblk, type, ptr->prev);
      cblk->rtlend = end;
      rtl->next = ptr;
      ptr->prev = rtl;
      }
    else
      rtl = new_rtl(cblk, type, end);

    /*
     * Give the RTL the value and dead register list given
     */
    if (new)
      rtl->val = strcpy(CALLOC(strlen(new) + 1), new);
    rtl->deads = deads;

#ifdef VET
    insert_rtl(rtl);
    if (deads)
#ifdef INTERACT
    mod_deads(rtl, rinit(), deads);
#else
	mod_deads(rtl);
#endif
#endif
    return(rtl);
}

/*
 * add_rtl_with_type_trans - single add_rtl_with_type transformation.
 */
struct list *add_rtl_with_type_trans(struct bblock *cblk, struct list *ptr, char *new, rlist deads,
 unsigned int type) {
#ifdef VET
  begin_trans(VET_REQUIRED_TRANS);
#endif

  add_rtl_with_type(cblk, ptr, new, deads, type);

#ifdef VET
  end_trans();
#endif
}

/*
 * new_rtl - allocate and initialize a new RTL structure
 */
struct list *new_rtl(struct bblock *cblk, int type, struct list *prev)
{
   struct list *rtl;
   int i;
   rtl = (struct list *) SALLOCTYPE(sizeof(struct list), LISTTYPE);

#ifdef INTERACT
   if (swq) {
      rtl_id++;
      rtl->rtl_id = rtl_id;
   }
#endif
   /*
    * Insert the new structure into the basic block indicated
    */
   rtl->next = (struct list *) NULL;
   if (rtl->daddy = cblk)
      cblk->rtlend = rtl;
   if (rtl->prev = prev)
      prev->next = rtl;
   else if (cblk)
      cblk->rtls = rtl;

   /*
      Initialize the fields of the structure
   */
   rtl->val = rtl->se = rtl->InitialDeads = (char *) NULL;
   rtl->deads = rinit();
   rtl->type = type;
   rtl->kind = 0;
   rtl->cost = rtl->rnum = rtl->onum = 0;

#if defined(SCHED) || defined(FILL)
   rtl->sets = vinit();
   rtl->uses = vinit();
   rtl->does = rtl->blocks = 0;
#endif

#ifdef STACHE
	rtl->variable = 0;
	rtl->sp_used = 0;
#endif

   for (i = 0; i < MAXLINKS; i++)
      rtl->lnks[i] = rtl->blnks[i] = rtl->all_lnks[i] = (struct list *) NULL;

#ifdef INTERACT
   rtl->old_daddy = (struct bblock *) NULL;
   rtl->old_next = (struct list *) NULL;
   rtl->old_prev = (struct list *) NULL;
   rtl->old_type = 0;
   rtl->old_kind = 0;
#endif	

   return (rtl);
}

/*
 * up_rtl - return the previous RTL in the control-flow graph
 * This differs from prev_rtl(ptr) in that prev_rtl makes sure that
 * the control flow is straight both backwards and forwards from
 * the returned rtl to ptr. This means that it doesnt move up a block
 * that has a conditional branch.
 * up_rtl(ptr) on the other hand only makes sure that the control flow
 * is straight backwards. This means that if 'ptr' is executed, then
 * the rtl returned by up_rtl() has also been executed, but vice-versa 
 * need not be true.
 * Used in cdmotion.c:expand(), because expand() is only trying to find
 * the the oldest values that form the rtl.
 */
struct list *up_rtl(register struct list * ptr) {

   struct bblock *cblk;

   /*
      If there is an immediate previous RTL, return it
   */
   if (ptr->prev)
      return (ptr->prev);

   /*
      If there is only a single predecessor to this basic block, then we can
      follow it on up the control-flow graph looking for the previous RTL.
   */
   cblk = ptr->daddy;
   while (cblk) {
      if (cblk->preds && !cblk->preds->next) {
	 cblk = cblk->preds->ptr;
      }
      else
	 return ((struct list *) NULL);

      if (cblk->rtlend)
	 return (cblk->rtlend);
   }

   return ((struct list *) NULL);
}

/*
 * prev_rtl - return the previous RTL in the control-flow graph
 */
struct list *prev_rtl(register struct list * ptr) {

   struct bblock *cblk;

   /*
      If there is an immediate previous RTL, return it
   */
   if (ptr->prev)
      return (ptr->prev);

   /*
      If there is only a single predecessor to this basic block, then we can
      follow it on up the control-flow graph looking for the previous RTL.
   */
   cblk = ptr->daddy;
   while (cblk) {
      if (cblk->preds && !cblk->preds->next) {
	 cblk = cblk->preds->ptr;
	 if (cblk->left && cblk->right)
	    return ((struct list *) NULL);
      }
      else
	 return ((struct list *) NULL);

      if (cblk->rtlend)
	 return (cblk->rtlend);
   }

   return ((struct list *) NULL);
}

/*
 * next_rtl - return the next RTL in the control-flow graph
 */
struct list *next_rtl(register struct list * ptr) {

   struct bblock *cblk;

   /*
      If there is an immediate previous RTL, return it
   */
   if (ptr->next)
      return (ptr->next);

   /*
      If there is only a single successor to this basic block, then we can
      follow it on down the control-flow graph looking for the next RTL.
   */
   cblk = ptr->daddy;
   while (cblk) {
      if (cblk->left && !cblk->right && !cblk->left->preds->next)
	 cblk = cblk->left;
      else if (!cblk->left && cblk->right && !cblk->right->preds->next)
	 cblk = cblk->right;
      else
	 return ((struct list *) NULL);

      /*
         If the basic block has any RTLs, then return the first one
      */
      if (cblk->rtls)
	 return (cblk->rtls);
   }

   return ((struct list *) NULL);
}

/*
 * show_rtl - display an encoded RTL value in a readable format
 */
void show_rtl(FILE * fp, register char *rtl) {

   register char c;

   if(!rtl)
     return;
   
   while (c = *rtl)
      if (isreg(rtl)) {
	 if (regtovec(rtl) < 0 || pseudoreg(rtl))
	    (void) fprintf(fp, "%c[%d]", regprt[regtype(rtl)], regnum(rtl));
	 else
	    (void) fprintf(fp, "%c[%d]", regprt[regtype(rtl)], map(rtl));
	 rtl = skiploc(rtl);
      }
      else if (islocal(rtl)) {
	 (void) fprintf(fp, "%s", localname(rtl));
	 rtl = skiploc(rtl);
      }
      else if (isglob(rtl) ) {
	 (void) fprintf(fp, "%s", globalname(rtl));
	 rtl = skiploc(rtl);
      }
      else {
	 (void) putc(c, fp);
	 rtl++;
      }
}


/*
 * real_move_rtl - really move the rtls.
 */
void real_move_rtl(struct list *rtlptr, struct bblock *oldblk, 
                     struct list *before, struct bblock *newblk)
{
   /* first, delete this rtl from the current position */
   if (rtlptr->next)
      rtlptr->next->prev = rtlptr->prev;
   else
      rtlptr->daddy->rtlend = rtlptr->prev;
   if (rtlptr->prev)
      rtlptr->prev->next = rtlptr->next;
   else
      rtlptr->daddy->rtls = rtlptr->next;

   /* change the fields in rtlptr */
   rtlptr->daddy = newblk;
   rtlptr->next = before;
   if (before)
      rtlptr->prev = before->prev;
   else
      rtlptr->prev = newblk->rtlend;

   /* update the fields in the neighbors */
   if (rtlptr->next)
      rtlptr->next->prev = rtlptr;
   else
      rtlptr->daddy->rtlend = rtlptr;
   if (rtlptr->prev)
      rtlptr->prev->next = rtlptr;
   else
      rtlptr->daddy->rtls = rtlptr;   
}

/*
 * copy_rtl - make a duplicate copy of an RTL
 */
struct list *copy_rtl(struct bblock * cblk, struct list * ins, register struct list * rtl) {

   register struct list *ptr;

    ptr = add_rtl_with_type(cblk, ins, rtl->val, rinit(), rtl->type);
    if (rtl->se) 
		 update_se(ptr,strcpy(CALLOC(strlen(rtl->se) + 1), rtl->se));
   ptr->cost = rtl->cost;
   ptr->kind = rtl->kind;

#ifdef INTERACT
	mod_kind(ptr);
#endif

   rcpy(&ptr->deads, rtl->deads);
#ifdef VET
    if (ptr->deads)
#ifdef INTERACT
		 mod_deads(ptr, rinit(), ptr->deads);		 
#else
       mod_deads(ptr);
#endif
#endif
#if SCHED || FILL
   ptr->does = rtl->does;
   ptr->blocks = rtl->blocks;
   if (rtl->uses) {
      ptr->uses = regnew();
      regcopy(ptr->uses, rtl->uses);
   }
   if (rtl->sets) {
      ptr->sets = regnew();
      regcopy(ptr->sets, rtl->sets);
   }
#endif

   return (ptr);
}

/*
 * remv_rtl - remove an RTL from a basic block
 */
void remv_rtl(register struct list * nptr) {


   /*
      Remove the RTL from the basic block that it belongs to
   */
   remv_links_to(nptr);
   remv_links(nptr);
   if (nptr->prev)
      nptr->prev->next = nptr->next;
   else
      nptr->daddy->rtls = nptr->next;
   if (nptr->next)
      nptr->next->prev = nptr->prev;
   else
      nptr->daddy->rtlend = nptr->prev;
#ifdef VET
    del_rtl(nptr);
#endif

   /*
      Release its value and side effect strings.  Also, return its dead
      register list bit vector to the heap.
   */
   FREE(nptr->val);
   FREE(nptr->se);
   rfree(nptr->deads);

#ifndef VET
   /*
     * Release the RTL structure to the heap.
     *
     * VET relies on receiving a unique ptr id for each
     * RTL during the compilation of a function.
   */
   FREETYPE(nptr, LISTTYPE);
#endif
}

/*
 * newref - return a new llist structure
 */
struct llist *newref(struct list * rtlptr) {

   struct llist *ptr;

   ptr = (struct llist *) SALLOCTYPE(sizeof(struct llist), LLISTTYPE);
   ptr->next = (struct llist *) NULL;
   ptr->ptr = rtlptr;
   return (ptr);
}

/*
 * is_present_in_ref
 */
int is_present_in_ref(struct llist *lptr, struct list *ptr)
{
	while (lptr) {
		if (ptr==lptr->ptr) return TRUE;
		lptr=lptr->next;
	}
	return FALSE;
}

int count_intersection_ref(struct llist *ref1, struct llist *ref2)
{
    struct list *ptr1, *ptr2;
    struct llist *p1, *p2;
    int count=0;
    for (p1 = ref1; p1; p1 = p1->next) {
	for (p2 = ref2; p2; p2 = p2->next) {
	    if (p1->ptr == p2->ptr)
		count++;
	}
    }
    return count;
}

/*
 * count_ref - return the number of entries in lptr.
 */
int count_ref(struct llist *lptr)
{
    int count;
    count=0;
    while (lptr) {
	lptr=lptr->next;
	count++;
    }
    return count;
}

/*           
 * merge_refs -
 * Note that lptr1 remains the head of the merged list.
 * However if lptr1 is NULL, then merge_refs returns
 * lptr2. So it is safer to use the return value.
 */
struct llist *merge_refs(struct llist *lptr1, struct llist *lptr2)
{
    struct llist *ptr = lptr1;
    if (!lptr1)
	return lptr2;
    /* Go to the end of the first list
       and add the second list to the end. */
    while (ptr->next)
	ptr=ptr->next;
    ptr->next=lptr2;
    return lptr1;
}

/*           
 * add_to_ref -
 */
void add_to_ref(struct llist **lptr, struct list *ptr)
{
	struct llist* newlptr=newref(ptr);
	newlptr->next=*lptr;
	*lptr=newlptr;
}

/*
 * newtriple - return a new itriple structure
 */
struct itriple *newtriple(struct setlist * family) {

   struct itriple *ptr;

   /*
      Allocate a new triple information structure and initialize all of its
      appropriate fields to default values.
   */
   ptr = (struct itriple *) SALLOCTYPE(sizeof(struct itriple), ITRIPLETYPE);
   ptr->status = BASIC;
   ptr->family = family;
   ptr->part = (struct memgroup *) NULL;
   ptr->count = 0;
   ptr->cee = 1;
   ptr->ref = (struct llist *) NULL;
   *ptr->dee = '\0';

   /*
      Note that triples are placed on the triple list in reverse order so that
      when they are later scanned, transformations will be made with the most
      complex items first.
   */
   ptr->next = ftriple;
   return (ftriple = ptr);
}

/*
 * freetriples - release all triples and partitions
 */
void freetriples() {

   register struct llist *bptr, *dbptr;
   register struct itriple *tptr, *dptr;
   register struct memgroup *pptr, *dpptr;
   register struct memitem *mptr, *dmptr;

   /*
      Release all triple structures
   */
   tptr = ftriple;
   while (tptr) {
      dptr = tptr;
      tptr = tptr->next;
      bptr = dptr->ref;
      while (bptr) {
	 dbptr = bptr;
	 bptr = bptr->next;
	 FREETYPE(dbptr, LLISTTYPE);
      }
      FREETYPE(dptr, ITRIPLETYPE);
   }

   /*
      Release all partition information
   */
   pptr = partitions;
   while (pptr) {
      dpptr = pptr;
      pptr = pptr->next;
      mptr = dpptr->reads;
      while (mptr) {
	 dmptr = mptr;
	 mptr = mptr->next;
	 FREETYPE(dmptr, MEMITEMTYPE);
      }
      mptr = dpptr->writes;
      while (mptr) {
	 dmptr = mptr;
	 mptr = mptr->next;
	 FREETYPE(dmptr, MEMITEMTYPE);
      }
      FREETYPE(dpptr, MEMGROUPTYPE);
   }

   ftriple = (struct itriple *) NULL;
   partitions = (struct memgroup *) NULL;
}

/*
 * newpartition - return a new memgroup structure
 */
struct memgroup *newpartition(char *item) {

   struct memgroup *ptr;
   

   ptr = (struct memgroup *) SALLOCTYPE(sizeof(struct memgroup), MEMGROUPTYPE);
   ptr->next = partitions;
   (void) strcpy(ptr->item, item);
   ptr->reads = ptr->writes = (struct memitem *) NULL;
   ptr->warn = FALSE;

#ifdef WIDES
   ptr->ld_sd_rtl = FALSE;
#endif

   return (partitions = ptr);
}

/*
 * newmem - return a new memitem structure
 */
struct memitem *newmem(struct list * rtlptr, char *ref, char *mem, int type) {

   struct memitem *ptr;
   

   ptr = (struct memitem *) SALLOCTYPE(sizeof(struct memitem), MEMITEMTYPE);
   ptr->next = (struct memitem *) NULL;
   ptr->ptr = rtlptr;
   (void) strcpy(ptr->ref, ref);
   (void) strcpy(ptr->mem, mem);
   ptr->triple = (struct itriple *) NULL;
   *ptr->dif = '\0';
   ptr->ofs = 0;
   ptr->done = FALSE;
   ptr->type = type;

#ifdef WIDES
   ptr->modified = FALSE;
#endif

   return (ptr);
}

/*
 * newignode - return a new ignode structure
 */
struct ignode *newignode(struct setlist * item) {

   register struct ignode *ptr;
 
   ptr = (struct ignode *) SALLOCTYPE(sizeof(struct ignode), IGNODETYPE);
   ptr->item = item;
   ptr->type = NOTYPE;
   ptr->status = ptr->freq = 0;
   ptr->ptr = (struct bblock *) NULL;
   ptr->start = ptr->end = (struct list *) NULL;
   ptr->conflicts = (struct conflict *) NULL;
   ptr->nsib = ptr->psib = ptr;
   ptr->conin = ptr->conout = ptr->conprev = (struct ignode *) NULL;
   ptr->next = (struct ignode *) NULL;
   if (igptr) {
      ptr->prev = iglast;
      iglast->next = ptr;
      iglast = ptr;
   }
   else {
      ptr->prev = (struct ignode *) NULL;
      igptr = iglast = ptr;
   }
   ptr->regs = regnew();
   ptr->loop_peeking_done = 0;
   ptr->lv_freq = 0;
   ignums++;
   ptr->loop = (struct loopl *) NULL;
   return ptr;
}

/*
 * remvignode - remove an ignode from a basic block
 */
void remvignode(register struct ignode * ptr) {

   register struct ignode *cptr, *fptr;
 

   while (ptr->conflicts)
      dconflict(ptr, ptr->conflicts->ptr);
   for (cptr = ptr->ptr->conout; cptr && cptr != ptr; cptr = cptr->conout);
   if (cptr) {
      if (ptr->conprev)
	 ptr->conprev->conout = ptr->conout;
      else
	 ptr->ptr->conout = ptr->conout;
      if (ptr->conout)
	 ptr->conout->conprev = ptr->conprev;
   }
   if (ptr->prev)
      ptr->prev->next = ptr->next;
   else
      igptr = ptr->next;
   if (ptr->next)
      ptr->next->prev = ptr->prev;
   else
      iglast = ptr->prev;
   fptr = (struct ignode *) NULL;
   for (cptr = ptr->ptr->conin; cptr; cptr = cptr->conin) {
      if (cptr == ptr) {
	 if (fptr)
	    fptr->conin = cptr->conin;
	 else
	    ptr->ptr->conin = cptr->conin;
	 break;
      }
      fptr = cptr;
   }
   mrfree(ptr->regs);
   FREETYPE(ptr, IGNODETYPE);
   ignums--;
}

/*
 * iconflict - insert a new conflict between two local items
 */
void iconflict(struct ignode * ptr, struct ignode * ptr2) {

   struct conflict *new;

   new = (struct conflict *) SALLOCTYPE(sizeof(struct conflict), CONFLICTTYPE);
   new->next = ptr->conflicts;
   new->ptr = ptr2;
   ptr->conflicts = new;
}

/*
 * dconflict - delete a conflict between two local items
 */
void dconflict(struct ignode * ptr, struct ignode * ptr2) {

   register struct conflict *cptr, *fptr;

   fptr = (struct conflict *) NULL;
   for (cptr = ptr->conflicts; cptr; cptr = cptr->next) {
      if (cptr->ptr == ptr2) {
	 if (fptr)
	    fptr->next = cptr->next;
	 else
	    ptr->conflicts = cptr->next;
	 FREETYPE(cptr, CONFLICTTYPE);
	 break;
      }
      fptr = cptr;
   }

   fptr = (struct conflict *) NULL;
   for (cptr = ptr2->conflicts; cptr; cptr = cptr->next) {
      if (cptr->ptr == ptr) {
	 if (fptr)
	    fptr->next = cptr->next;
	 else
	    ptr2->conflicts = cptr->next;
	 FREETYPE(cptr, CONFLICTTYPE);
	 break;
      }
      fptr = cptr;
   }
}

/*
 * clear_interference_graph - return all interference graph information
 */
void clear_interference_graph() {

   register struct conflict *cptr, *cdptr;
   register struct ignode *ptr, *dptr;

   ptr = igptr;
   while (ptr) {
      cptr = ptr->conflicts;
      while (cptr) {
	 cdptr = cptr;
	 cptr = cptr->next;
	 FREETYPE(cdptr, CONFLICTTYPE);
      }
      dptr = ptr;
      ptr = ptr->next;
      mrfree(dptr->regs);
      FREETYPE(dptr, IGNODETYPE);
   }

   igptr = iglast = (struct ignode *) NULL;
   ignums = 1;
}

/*
 * getlabel - return a pointer to the basic block with the given label
 */
struct bblock *getlabel(char *label) {

   register struct bblock *cblk;
 

   for (cblk = top; cblk; cblk = cblk->next) {
      if (cblk->label && !strcmp(cblk->label, label))
	 return (cblk);
   }
   return ((struct bblock *) NULL);
}

/*
 * gtrtl - returns an RTL and its dead variable list
 */
void gtrtl(char **rtl, char **deads) {

   register char *s;
   register int len;
   char new[MAXSTRING], lrtl[MAXSTRING], ldeads[MAXSTRING];
   extern char **pro_cex_file;
   extern int pro_cex_line, pro_is_cex_file; 

   if(pro_is_cex_file){

     lrtl[0] = '\0';
     ldeads[0] = '\0';
     if(pro_cex_file[pro_cex_line][1] == '\t')
       sscanf(&pro_cex_file[pro_cex_line][1], "\t%s\n", ldeads);
     else
       sscanf(&pro_cex_file[pro_cex_line][1], "%s\t%s\n", lrtl, ldeads);
     if(lrtl[0]){
       *rtl = strcpy(CALLOC(strlen(lrtl)+2), lrtl);
       (*rtl)[strlen(lrtl)] = ';';
       (*rtl)[strlen(lrtl)+1] = '\0';
     }
     if(ldeads[0]){
       *deads = strcpy(CALLOC(strlen(ldeads)+1), ldeads);
     }
     return;
   }
   
   s = new;
   for (len = 1; (*s = getchar()) != '\t' && *s != '\n'; len++)
   {
	if(*s==-1 && feof(stdin))
	{
		/* fatal error, premature end of file */
		fprintf(stderr, "End of file midway through rtl.  Did front-end fault too?\n");
		exit(-1);
	}
      	s++;
   }


   if (*s == '\t') {
      if (len > 1) {
	 *s++ = ';';
	 len++;
	 *s = '\0';
	 *rtl = strcpy(CALLOC(len), new);
      }
      s = new;
      for (len = 1; (*s = getchar()) != '\n'; len++)
      {
		if(*s==-1 && feof(stdin))
		{
			/* fatal error, premature end of file */
			fprintf(stderr, "End of file midway through rtl.  Did front-end fault too?\n");
			exit(-1);
		}
		s++;
      }
      *s = '\0';
      if (len > 1)
	 *deads = strcpy(CALLOC(len), new);
   }
   else {
      *s++ = ';';
      len++;
      *s = '\0';
      *rtl = strcpy(CALLOC(len), new);
   }
}

/*
 * gtline - return remainder of input line
 */
char *gtline() {

   register int len;
   register char *a;
   char str[BIGSTRING];
   extern char **pro_cex_file;
   extern int pro_cex_line, pro_is_cex_file;
 
   if(pro_is_cex_file){
     len = strlen(pro_cex_file[pro_cex_line]) + 1;
     return (strcpy(CALLOC(len), &(pro_cex_file[pro_cex_line][1])));
   }
   a = str;
   for (len = 1; (*a++ = getchar()) != '\n'; len++) {
		assert(BIGSTRING >= len);
	}
   *(a - 1) = '\0';
   return (strcpy(CALLOC(len), str));
}

/*
 * gtlab - return label from input file
 */
char *gtlab() {

   register int len;
   register char *a;
   char str[MAXSTRING];
   extern char **pro_cex_file;
   extern int pro_cex_line, pro_is_cex_file;
 

   if(pro_is_cex_file){
     strcpy(str, pro_cex_file[pro_cex_line]);
     return (strcpy(CALLOC(strlen(str)+1), str));
   }
   a = str;
   *a++ = 'L';
   for (len = 2; (*a++ = getchar()) != '\n'; len++);
   *--a = '\0';
   return (strcpy(CALLOC(len), str));
}

/*
 * fmatch - fast matcher no metacharacters
 */int fmatch(register char *lin, char *pat) {

   register char c, d, *a, *b;

   if (!lin || !pat)
      return (FALSE);
   c = *pat++;
   while (d = *lin++) {
      if (d == c) {
	 b = lin;
	 a = pat;
	 if (d = *a++) {
	    while (d == *b++) {
	       if (!(d = *a++)) {
		  bpos = lin - 1;
		  epos = b;
		  return (TRUE);
	       }
	    }
	 }
	 else {
	    bpos = lin - 1;
	    epos = b;
	    return (TRUE);
	 }
      }
   }
   return (FALSE);
}

/*
 * gtstr - get string specified by start and end
 */
void gtstr(register char *start, register char *end, register char *dst) {

   while (start < end)
      *dst++ = *start++;
   *dst = '\0';
}

/*
 * gtds - get the source and destination portions of an RTL
 */
char *gtds(register char *rt, register char *dst, register char *src) {

   if (!*rt)
      return ((char *) NULL);
   while ((*dst++ = *rt++) != '=');
   while ((*src++ = *rt++) != ';');
   *(dst - 1) = *(src - 1) = '\0';
   return (rt);
}

/*
 * sub - substitute str for pos1 thru pos2, return new pos2
 */
char *sub(register char *pos1, register char *pos2, register char *str) {

   register char *a;
   char new[BIGSTRING];

   a = new;
   while (*a++ = *pos2++);
   while (*pos1++ = *str++);
   pos2 = new;
   a = --pos1;
   while (*a++ = *pos2++);
   return (pos1);
}

/*
 * isset - return TRUE if the item is set in the RTL
 */
char *isset(register char *rtl, char *item) 
{
   char *a;
   int commonChars = 0;

   if (rtl == NULL)
      return NULL;

   while (*rtl) {
      if (*rtl != '=') {
         a = item;
         while (*rtl++ == *a++)
            ++commonChars;
         if (commonChars && (*(rtl - 1) == '='))
            return rtl;
      }
      while (*rtl && *rtl++ != ';')
         ;   /* Skip forward to the next effect. */
   }
   return ((char *) NULL);
}

char *isaliasset(register char *rtl, char *item) 
{

   register char *a, *b;
   if(!isRegister(item) || pseudoreg(item))
	return isset(rtl,item);
   for(a=aliases(item); *a; a=skiploc(a)+1)
   {
	b=isset(rtl,a);
	if(b) return b;
   }
  

   return ((char *) NULL);
}



/*
 * isref - return TRUE is the item is referenced (used) in the RTL
 */
int isref(char *rtl, char *item) {


   while (fmatch(rtl, item))
      if (*epos != '=')
	 return (TRUE);
      else
	 rtl = epos;
   return (FALSE);
}

int isaliasref(char *rtl2, char *item) 
{
  char *a;
  char *rtl;
  if(rtl2==0)
      return FALSE;
  if(pseudoreg(item))
      return isref(rtl2, item);
  a=aliases(item);
  while(*a)
  {
   rtl=rtl2;
   while (fmatch(rtl, a))
      if (*epos != '=')
         return (TRUE);
      else
         rtl = epos;
   a=skiploc(a)+1;
  }
  return (FALSE);
}


/*
 * is_const - return pointer to character following integer constant
 */
char *is_const(register char *s) {

   if (*s == '-')
      s++;
   if (*s <= '9' && *s >= '0') {
      for (s++; *s <= '9' && *s >= '0'; s++);
      return (s);
   }
   return ((char *) NULL);
}

/*
 * value_of - attempt to follow RTLs back to obtain the value of an item
 */
struct list *value_of(struct list * ptr, char *item, rlist prev_set, char *value) 
{

   register char c, *d, *e, *f;
   rlist set;
   char newexpr[MAXSTRING]={0,};


   /*
      Inisialize the set vector to contain a copy of the vector passed in
      prev_set.
   */
   set = rinit();

   /*
      Search back up the RTLs from this point as far as we can go
   */
   for (rcpy(&set, prev_set); ptr; ptr = up_rtl(ptr)) {

      /*
         If a set of the item is found, expand the RTL
      */
      if (ptr->type & RTLINE) {
	 if (d = ptr->val) {
	    if (e = isset(d, item)) {

	       /*
	          If we find that the item uses any of the registers marked in
	          the set list (that is, set between the start of our search
	          and this point, then the expression that the item is set to
	          must not be returned.  One way of avoiding the problem is to
	          try to expand on the value of the item itself, to see if we
	          can discover that it is made up of more benign items.
	       */
               d=value;
               while (*e != ';') {
                  if (isreg(e)) {
                     if (rexists(e , set)) {
                        if (value_of(up_rtl(ptr), e , set, newexpr)) {

			   /* make sure we don't overflow accidentally */
			   if((strlen(value)+strlen(newexpr)+2)>MAXSTRING)
				return ((struct list*)NULL);
                           *d++ = '(';
                           f=newexpr;
                           while (*f) {
                              if (isreg(f)) 
                                 if (rexists(f , set))
                                    return ((struct list *) NULL);
                              copyloc(d,f); f=skiploc(f); d=skiploc(d);
                           }
                           *d++ = ')';
                           e=skiploc(e);
                        } else {
                           return ((struct list *) NULL);
                        }
                     } else {
                        copyloc(d,e); d=skiploc(d); e=skiploc(e);
                     }
                  } else {
                        copyloc(d,e); d=skiploc(d); e=skiploc(e);
                  }
               }

	       *d = '\0';
	       return (ptr);
	    }

	    /*
	       Look at each register set and make a note of it as we go up the
	       list of RTLs so that we know which expressions are no longer
	       valid when we get to them.
	    */
	    while (*d) {
	       if (isrg(d))
		  rinsert(d, &set);
	       while (*d++ != ';');
	    }
	 }

	 /*
	    Do the same thing with the side-effects of the RTL as well
	 */
	 if (d = ptr->se) {
	    if (e = isset(d, item)) {
	       if (*e != ';') {
                  d=value;
                  while(*e)
                  {
                     if (isreg(e) && rexists(e , set))
                           return ((struct list *) NULL);

                     copyloc(d,e);
                     e=skiploc(e);
                     d=skiploc(d);
                  }
		  *d = '\0';
		  return (ptr);
	       }
	       return ((struct list *) NULL);
	    }
	    while (*d) {
	       if (isrg(d))
		  rinsert(d, &set);
	       while (*d++ != ';');
	    }
	 }

	 /*
	    If we see a death of this item at any point, then stop the search
	 */
	 if (rexists(item, ptr->deads))
	    return ((struct list *) NULL);
      }

      /*
         If the item appears on a set line, then stop the search
      */
      else if (ptr->type & SETLINE) 
      {
	 if(isaliasref(ptr->val,item))
	       return ((struct list *) NULL);
      }
   }
   rfree(set);

   return ((struct list *) NULL);
}

#define SBRKSIZE 0xc00000    /* Allocation size -- larger than any request */
int nearly_exhausted_memory = FALSE;
static int total_memory_used = 0;
static int max_memory_to_use = 300*1024*1024;


#ifndef DISPOSE

/*
 * salloc - allocate space and check for error
 */
char *salloc(int siz) {

   char *ptr;

   siz += 48;

   if ((siz < 0) || (siz > SBRKSIZE)) {
      (void) fprintf(stderr, "bad size on call to salloc\n");
      exit(EXIT_FAILURE);
   }

   errno = 0;
   if (!(ptr = malloc((unsigned) siz))) {
      (void) fprintf(stderr, "vpo (salloc): out of memory\n");
      exit(EXIT_FAILURE);
   }

   if (errno == ENOMEM) {
      (void) fprintf(stderr, "vpo (salloc): out of memory\n");
      exit(EXIT_FAILURE);
   }
   return ptr;
}

void do_free(void* ptr)
{
	if(ptr==0)
		return;
	free(ptr);	
}

#endif  /* ifndef DISPOSE */

#ifdef DISPOSE

static Arena_T perm=0;
static Arena_T func=0;
static Arena_T phase=0;
static Arena_T pabs=0;

#ifdef INTERACT
static Arena_T sel_comb=0;
static Arena_T trans_list=0;
static Arena_T profile_space=0;
static Arena_T temp_pro_space=0;
static Arena_T memprob=0;


/* here we write a wrapper so that only misc.c needs to know what arenas
   there are */
void* myalloc_tpro(long size)
{
	if(temp_pro_space==0)	temp_pro_space=Arena_new();
	return Arena_alloc(temp_pro_space,size);
}
void dispose_tpro(void)
{
	if(temp_pro_space!=0)	
		Arena_dispose(&temp_pro_space);
}
void* myalloc_profile(long size)
{
	if(profile_space==0)
	  profile_space=Arena_new();
	return Arena_alloc(profile_space,size);
}
void dispose_profile(void)
{
	if(profile_space!=0)	
		Arena_dispose(&profile_space);
}
void* myalloc_comb(long size)
{
	if(sel_comb==0)
	  sel_comb=Arena_new();
	return Arena_alloc(sel_comb,size);
}
void dispose_comb(void)
{
	if(sel_comb!=0)	
		Arena_dispose(&sel_comb);
}
void* myalloc_trans(long size)
{
	if(trans_list==0)
	  trans_list=Arena_new();
	return Arena_alloc(trans_list,size);
}
void dispose_trans(void)
{
	if(trans_list!=0)	
		Arena_dispose(&trans_list);
}
void* myalloc_prob(long size)
{
	if(memprob==0)	memprob=Arena_new();
	return Arena_alloc(memprob,size);
}
void dispose_prob(void)
{
	if(memprob!=0)	
		Arena_dispose(&memprob);
}
#endif

void* myalloc_pabs(long size)
{
  if(pabs==0)
    pabs = Arena_new();
  return Arena_alloc(pabs, size);
}

void dispose_pabs(void)
{
  if(pabs!=0)
    Arena_dispose(&pabs);
}

/*permanant storage across all functions, e.g., globals*/
void* myalloc_perm(long size)
{
	if(perm==0)	perm=Arena_new();
	return Arena_alloc(perm,size);
}
void dispose_perm(void)
{
	if(perm!=0)	
		Arena_dispose(&perm);
}

void* myalloc_func(long size)
{
	if(func==0)	func=Arena_new();
	return Arena_alloc(func,size);
}
void dispose_func(void)
{
	if(func!=0)	
		Arena_dispose(&func);
}

void* myalloc_phase(long size)
{
	if(phase==0)	phase=Arena_new();
	return Arena_alloc(phase,size);
}
void dispose_phase(void)
{
	if(phase!=0)	
		Arena_dispose(&phase);
}

/*
 * frmalloc - get an item directly off the free list
 */
unsigned int *frmalloc(int type) {

   static char **ptr;

   ptr = freeptrs[type];
   assert(NULL != ptr);
   freeptrs[type] = (char **) *ptr;
   return ((unsigned int *) ptr);
}


void myfree(char *ptr)
{
}


#endif   /* ifdef DISPOSE */

#ifdef INTERACT
/*
 * get_num - get a number from a string
 */
void get_num(char **str, int *num)       
{
   int ret;

   /*delete the head space chars*/
   while(isspace(**str))
      (*str)++;
   
   /* convert the string to a number */
   sscanf(*str, "%d", num);

   /* skip to the next whitespace character */
   for (; **str; (*str)++) {
      if (isspace(**str)) {
         (*str)++;
         break;
      }
   }
}

/*
 * get_string - extract a string of nonwhitespace characters
 */
void get_string(char **src, char *dst)       
{
   /* extract the string */
   sscanf(*src, "%s", dst);   

   /* skip to the next whitespace character */
   for (; **src; (*src)++) {
      if (isspace(**src)) {
         (*src) ++;
         break;
      }
   }
}

#endif

/*
 * update_label - updates a label associated with a basic block
 */
void update_label(struct bblock *cblk, char *label)
{
#ifdef VET
#ifdef INTERACT
   if (swq)
      label_bb(cblk, cblk->label, label);
	cblk->label = label;
#else
	cblk->label = label;
	label_bb(cblk, label);
#endif
#else
	cblk->label = label;
#endif

}

/*
 * update_se - updates a side effect associated with an RTL
 */
void update_se(struct list *ptr, char *se)
{
#ifdef VET
#ifdef INTERACT
	if (swq)
		mod_side(ptr, ptr->se, se);		
	FREE(ptr->se);
   ptr->se = se;
#else
	FREE(ptr->se);
   ptr->se = se;
	mod_side(ptr);
#endif
#else
	FREE(ptr->se);
   ptr->se = se;
#endif
}

/*
 * update_rtl - updates the val field associated with an RTL
 */
void update_rtl(struct list *ptr, char *s)
{
   char oldval[MAXSTRING];

   if (ptr->val) {
      strcpy(oldval, ptr->val);
      if (strcmp(oldval, s) == 0)
         return;
      if (strlen(s) > strlen(oldval)) {
         FREE(ptr->val);
         ptr->val = strcpy(CALLOC(strlen(s)+1), s);
      } else if (!*s) {
			FREE(ptr->val);
         ptr->val = (char *) NULL;
		} else
         (void) strcpy(ptr->val, s);
   }
   else {
      oldval[0] = '\0';
      ptr->val = strcpy(CALLOC(strlen(s)+1), s);
   }
#ifdef VET
#ifdef INTERACT
   if (swq)
      mod_rtl(ptr, oldval, s);
#else
      mod_rtl(ptr);
#endif

#endif
}

/*
 * update_left - update the left pointer of a block and send message to
 *               viewer
 */
void update_left(struct bblock *blk, struct bblock *left)
{
  blk->left = left;
  
#ifdef INTERACT
  mod_bb_ptrs(MOD_LEFT, blk, left);
#endif  
}

/*
 * update_right - update the right pointer of a block and send message to
 *                viewer
 */
void update_right(struct bblock *blk, struct bblock *right)
{
  blk->right = right;
  
#ifdef INTERACT
  mod_bb_ptrs(MOD_RIGHT, blk, right);
#endif  
}

/*
 * update_down - update the down pointer of a block and send message to
 *               viewer
 */
void update_down(struct bblock *blk, struct bblock *down)
{
  blk->down = down;
  
#ifdef INTERACT
  mod_bb_ptrs(MOD_DOWN, blk, down);
#endif  
}

/*
 * update_kind - update the kind field of an RTL and send message to viewer
 */
void update_kind(struct list *rtl, int nkind)
{
  rtl->kind = nkind;
#ifdef INTERACT
  mod_kind(rtl);
#endif  
}

/*
 * update_type - update the type field of an RTL and send message to viewer
 */
void update_type(struct list *rtl, int ntype)
{
  rtl->type = ntype;
#ifdef INTERACT
  mod_type(rtl);
#endif  
}


#ifdef INTERACT

/*
 * combine_phases - combine 2 similar sucessive phases into 1
 */
void combine_phases()
{
  int prev_phase, curr_phase;
  struct transform_list *ptr, *prev_ptr, *prev;
  extern struct transform_list *transform_head;

  prev_phase = ' ';
  prev_ptr = NULL;
  prev = NULL;
  for(ptr = transform_head ; ptr ; prev=ptr, ptr=ptr->next){
    if(ptr->mod_flag == ENDPHASE) {

      /*get the current phase number*/
      sscanf(ptr->string, "%d\n", &curr_phase);
      if(prev_ptr){

	/*if the phases are same then join the phases by skipping over two phases*/
	if(prev_phase == curr_phase){
	  prev_ptr->next = prev_ptr->next->next->next;
	}
      }
      prev_ptr = prev;
      prev_phase = curr_phase;
    }
  }
}

/*
 * clear_transform_list - clear the memory allocated to storing all
 *                        transformations in a list
 */
void clear_transform_list()
{
  extern struct transform_list *transform_head, *transform_tail;

  /*free up space allocated to each indivisual element in the list*/
  dispose_trans();
  transform_head = NULL;
  transform_tail = NULL;
}

/*
 * get_sequence - function stores the sequence in SEL...COMB and returns the
 *                number  of transformations
 */
int get_sequence(struct comb_struct *comb, struct command commands[], int *pc)
{
  int i, j, flag, addinfo_length;
  int counter=0, store_pc, pos;
  int source, destination, start_pc, length;

  /*flag to indiate when we should increment the counter for number of
    transformations. SEL...SEQ is considered as 1 transformation*/
  flag = 0;
  j = 0;
  start_pc = *pc;
  for(i=0 ; commands[*pc].oper!=END_COMBINATION ; i++, (*pc)++){

    /*store the transformation in base array*/
    comb->base_opt[j] = commands[*pc].oper;
    comb->reverse_base[comb->base_opt[j]] = j++;
    
    switch(commands[*pc].oper){
    case SELECT_BEST_SEQUENCE:
      counter++;
      flag++;
      break;
    case DONE_SELECT:
      flag--;
      break;
    default:
      if(!flag)
	counter++;      
    }
  }
  comb->base_opt[j] = END_COMBINATION;
  store_pc = (*pc)++;
  
  /*read in the other data related to SEL...COMB*/
  comb->strlength = commands[(*pc)++].oper;
  comb->weight = commands[(*pc)++].oper;
  comb->search_option = commands[(*pc)++].oper;
  comb->popu_size = commands[(*pc)++].oper;
  comb->gen_size = commands[(*pc)++].oper;
  addinfo_length = 5;
  comb->length = j + (comb->strlength-counter);

  /*determine the max number of possible combinations*/
  if(comb->search_option == EXHAUSTIVE_SEARCH){
    /*for exhaustive search*/
    comb->max_comb = 1;
    for (i=0 ; i<comb->strlength ; i++)
      comb->max_comb *= counter;
  }
  else if(comb->search_option == INTELLIGENT_SEARCH){
    /*for intelligent search*/
    comb->max_comb = comb->popu_size * comb->gen_size;
  }
  else{
    /*for combinatorial search*/
    comb->max_comb = 1;
    for (i=comb->strlength ; i>1 ; i--)
      comb->max_comb *= i;
  }    

  /*remove the additional information from SEL...COMB*/
  for(i=*pc ; commands[i].oper != QUIT_TRANS ; i++)
    commands[i-addinfo_length].oper = commands[i].oper;
  commands[i-addinfo_length].oper = QUIT_TRANS;
  
  /*Adjust the length and data in the commands array if the strlength does
    not match the num phases specified*/ 
  if(comb->strlength > counter){

    /*move all information after back END_COMBINATION by the difference*/
    for(i=store_pc ; commands[i].oper != QUIT_TRANS ; i++);
    source = i;
    destination = i + (comb->strlength - counter);

    for(i=source ; commands[i].oper!=END_COMBINATION ; i--)
      commands[destination--].oper = commands[i].oper;
    commands[destination].oper = END_COMBINATION;
    pos = destination - 1;
  }
  else if(comb->strlength < counter){

    /*move all information after END_COMBINATION forward by the difference*/
    destination = store_pc + (comb->strlength - counter);
    pos = destination - 1;

    for(i=store_pc ; commands[i].oper!=QUIT_TRANS ; i++)
      commands[destination++].oper = commands[i].oper;
    commands[destination].oper = QUIT_TRANS;
  }
  else
    pos = store_pc - 1;
  
  /*restore pc*/
  (*pc) = pos;
  
  /*return the number of transformations*/
  return counter;
}


/*
 * get_first_sequence - store the offsets of transformations in the list in
 *                      another array
 */
void get_first_sequence(struct comb_struct comb, int next_seq[],
			int phase_indices[], int curr_pos[], int *popu_count,
			int *gen_count)
{
  int i, j;
  int flag=0, poss_comb;
  time_t t;
  int discard_chrom[MAX_GENES];
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*get the array locations of the start of each optimization phase.
    eg. for base_opt = {8, 12, -18, 14, 15, -20, 22}, we may have
        phase_indices = {0, 1, 2, 6} to indicate the start of each distinct
	optimization phase and
	curr_pos = {0, 3, 1, 3} where there are strlength positions and each
	index can go upto no_phases, current position of the index
	next_seq = {0, 6, 1, 6} gives actual phases to perform, are indices
	in base_opt*/
  if(comb.search_option==EXHAUSTIVE_SEARCH ||
     comb.search_option==INTELLIGENT_SEARCH){
    /*initialise phase_indices*/
    for(i=0,j=0 ; comb.base_opt[i]!=END_COMBINATION ; i++){
      /*store offset of this transformation*/
      if(!flag)
	phase_indices[j++] = i;
      
      switch(comb.base_opt[i]){
      case SELECT_BEST_SEQUENCE:
	flag++;
	break;
      case DONE_SELECT:
	flag--;
	break;
      }
    }
  }

  /*initialize the initial optimizaion sequence*/
  if(comb.search_option == EXHAUSTIVE_SEARCH){

    /*for exhaustive search initialise the array to 0*/
    for(i=0 ; i<comb.strlength ; i++)
      curr_pos[i] = next_seq[i] = 0;
  }
  else if(comb.search_option == INTELLIGENT_SEARCH){
    /*for intelligent search*/

    /*check if the number of chromosomes and the number of genes are within
      the limits set by the static data structure*/
    if(comb.popu_size>MAX_CHROMOSOMES || comb.strlength>MAX_GENES){
      fprintf(stderr, "Data structure limits for genetic algorithm  exceeded\n");
      exit(0);
    }
    
    /*initialize the rand() function with a different seed value depending on
      the current time of day*/
    /*srand((unsigned int)time(&t));*/

    /*calculate the total number of possible permutations of the given string
      of sequences*/
    for(i=0, poss_comb=1 ; i<comb.strlength ; i++)
      poss_comb *= comb.no_comb;

    /*if a sequence is pre-specified by the user then we only need to
      generate the remaining sequences*/
    if(comb.flags & BATCH_SEQUENCE){
      /*We replace the first sequence by the sequence given by the batch
	compiler. I intend to initialize the remaining chromosomes in the
	population the same, so we generate and discard the first sequence so
	that rand() behaves the same*/
      i = 1;
      get_random_seq(discard_chrom, &comb);
    }
    else
      i = 0;
    
    /*generate all the strings in the current population*/
    for(; i<comb.popu_size ; i++){
      get_random_seq(popu[i].chrom, &comb);

      /*if this sequence has been generated previously in this generation
	then get another sequence*/
      for(j=0 ; j<i ; j++){
	if(poss_comb<comb.popu_size &&
	   is_same_seq(popu[i].chrom, popu[j].chrom, comb.strlength)){
	  i--;
	  break;
	}
      }
    }

    /*generate the first sequence*/
    if(comb.max_comb > 0){
      for(i=0 ; i<comb.strlength ; i++)
	next_seq[i] = phase_indices[popu[0].chrom[i]];
      (*popu_count)++;
      (*gen_count)++;
    }
  }
  else if(comb.search_option == LEAF_SEARCH){
    /*do nothing here, each phase would be determined one at a time*/
  }
  else{
    /*for combinatorial search*/
    for(i=0,j=0 ; comb.base_opt[i]!=END_COMBINATION ; i++){
      /*store offset of this transformation*/
      if(!flag)
	next_seq[j++] = i;
      
      switch(comb.base_opt[i]){
      case SELECT_BEST_SEQUENCE:
	flag++;
	break;
      case DONE_SELECT:
	flag--;
	break;
      }
    }
  }
}


/*
 * get_random_seq - generate a random optimization sequence during a genetic
 *                  algo. search during SEL...COMB
 */
void get_random_seq(int popu_str[], struct comb_struct *comb)
{
  int i, j, gene, opt, count;
  unsigned int prev_done, done_trans;
  unsigned int occured_phases[NUM_TRANS_TYPES];
  extern unsigned int trans_done;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];

  done_trans = trans_done;
  
  /*generate a random sequence consisting of strlength elements*/
  for(i=0 ; i<comb->strlength ; i++){

    count = 0;
    do{
      gene = wrapper_rand() % comb->no_comb;
      opt = comb->base_opt[gene];
      count++;
    }while(!is_opt_valid(opt, &done_trans) && count < MAX_ATTEMPTS);

    popu_str[i] = gene;
  }

  /*check if this phase cannot be successfully applied to this function*/
  if(comb->flags & USELESS_TRANSFORM){
    
    done_trans = trans_done;
    for(i=0 ; i<comb->strlength ; i++){

      gene = popu_str[i];
      opt = comb->base_opt[gene];
      count = 0;
      if(comb->opt_mask & (1<<opt) || !is_opt_valid(opt, &done_trans)){
	
	do{
	  /*get the gene to replace*/
	  gene = get_rand() % comb->no_comb;
	  opt = comb->base_opt[gene];
	  count++;
	}while(((comb->opt_mask & (1<<opt)) || !is_opt_valid(opt, &done_trans))
	       && count < MAX_ATTEMPTS);
      }
      if(count < MAX_ATTEMPTS)
	popu_str[i] = gene;
    }
  }

  /*check if a non-repeatable phase has been repeated*/
  if(comb->flags & (REPEAT_SAME_PHASE|ENABLE_PHASE)){

    done_trans = trans_done;

    /*initialize*/
    for(i=0 ; i<NUM_TRANS_TYPES ; i++)
      occured_phases[i] = ~(0);
    
    for(i=0 ; i<comb->strlength ; i++){

      gene = popu_str[i];
      opt = comb->base_opt[gene];
      count = 0;
      /*check if this phase can produce change at this stage*/
      if(!(enable_phase[opt] & occured_phases[opt]) ||
	 !is_opt_valid(opt, &done_trans)){
	
	do{
	  /*replace the phase with a random phase with 100% probability*/
	  gene = get_rand() % comb->no_comb;
	  opt = comb->base_opt[gene];
	  count++;
	}while((!(enable_phase[opt] & occured_phases[opt]) || !is_opt_valid(opt, &done_trans) ||
		(comb->flags & USELESS_TRANSFORM && comb->opt_mask & (1<<opt)))
	       && count < MAX_ATTEMPTS);
      }

      occured_phases[opt] = 0;
      for(j=0 ; j<NUM_TRANS_TYPES ; j++)
	occured_phases[j] |= (1 << opt);
      if(count < MAX_ATTEMPTS)
	popu_str[i] = gene;
    }
  }
}


/*
 * same_seq - returns 1 if the 2 sequences are same
 */
int is_same_seq(int str1[], int str2[], int strlength)
{
  int i;

  for(i=0 ; i<strlength ; i++){
    if(str1[i] != str2[i])
      return 0;
  }
  return 1;
}

/* get_next_intel_seq - get the next sequence during SEL...COMB using the
 *                      biased sampling search approach
 */
int get_next_intel_seq(struct comb_struct *comb, int next_seq[],
		       int phase_indices[], int sort_phases[], int *hits)
{
  char str[MAXSTRING];
  int i, res_rand, seq_no, count, best, sorted_list[MAX_CHROMOSOMES];
  unsigned long long s_measure, d_measure;
  float avg_measure;
  extern int resume_mode;
  extern struct chromosome popu[MAX_CHROMOSOMES];
  extern FILE *comb_log;
  extern unsigned long long tot_rand;
  extern long resume_log_ptr;

  while(comb->done_comb < comb->max_comb){

    /*The first sequence has already been generated earlier, so here we only
      generate the other sequences*/
    if(comb->done_comb){
    
      /*generate the next sequence*/
      /*all sequences in this generation have been tried. Generate a new
	generation*/
      if(comb->popu_count >= comb->popu_size){
	
#ifdef GENETIC_ALGO2
	/*sort the population based on the fitness value*/
	sort_population(*comb, sorted_list);
	best = sorted_list[0];
	
	/*sort the population in descending order of number of active
	  phases*/
	/*best = sort_popu_active(*comb, sorted_list);*/
#endif
	/*check if there is an improvement in this generation over the
	  previous one*/
	if(comb->term_dmeasure){
	  if(popu[best].d_measure < comb->last_dmeasure){
	    comb->stagnate = 0;
	    comb->last_dmeasure = popu[best].d_measure;
	  }
	  else
	    comb->stagnate++;
	  
	  /*terminate if the best sequence in this generation produces the
	    optimal code or if the best sequence found during the genetic
	    algorithm has been stagnant for more than COMB_MAX_STAGNATE*/
	  if(popu[best].d_measure <= comb->term_dmeasure){
	    fprintf(comb_log, "Optimal sequence found in generation %d\n",
		    comb->gen_count);
	    end_sel_comb(comb);
	    return -1;
	  }
	  if(comb->stagnate > COMB_MAX_STAGNATE){
	    fprintf(comb_log, "Unable to reach optimal after %d generations\n",
		    comb->gen_count);
	    end_sel_comb(comb);
	    return -1;
	  }
	}
	else if(comb->term_smeasure){
	  if(popu[best].s_measure < comb->last_smeasure){
	    comb->stagnate = 0;
	    comb->last_smeasure = popu[best].s_measure;
	  }
	  else
	    comb->stagnate++;
	  
	  /*terminate if the best sequence in this generation produces the
	    optimal code or if the best sequence found during the genetic
	    algorithm has been stagnant for more than COMB_MAX_STAGNATE*/
	  if(popu[best].s_measure <= comb->term_smeasure){
	    fprintf(comb_log, "Optimal sequence found in generation %d\n",
		    comb->gen_count);
	    end_sel_comb(comb);
	    return -1;
	  }
	  if(comb->stagnate > COMB_MAX_STAGNATE){
	    fprintf(comb_log, "Unable to reach optimal after %d generations\n",
		    comb->gen_count);
	    end_sel_comb(comb);
	    return -1;
	  }
	}
    
	/*calculate the average measuement count in this generation. Invalid
	  strings are not counted*/
	avg_measure = 0;
	count = 0;
	for(i=0 ; i<comb->popu_size ; i++){
	  if(popu[i].s_measure != 0){
	    avg_measure += ((popu[i].d_measure*(comb->weight)/100) +
			    (popu[i].s_measure*4*(100-comb->weight)/ 100));
	    count++;
	  }
	}
	avg_measure = avg_measure / count;
	fprintf(stderr, "For this generation: \nAverage Count: %.2f \nCount\n\n",
		avg_measure, count);
	
	
	/*perform reproduction to get new population, based on their fitness
	  values*/
	reproduction(*comb, sorted_list);
	log_random_numbers(tot_rand);
	
#ifdef GENETIC_ALGO1      
	/*replace some strings using crossover operation*/
	crossover(*comb);
	
	/*perform mutation with low probability*/
	/*mutation(comb);*/
#endif      
	
	/*initialize counters*/
	comb->popu_count = 0;
	comb->gen_count++;
      }

      /*get the next string of optimizations to apply*/
      comb->popu_count++;

      /*copy over the string found to the appropriate array*/
      for(i=0 ; i<comb->strlength ; i++)
	next_seq[i] = phase_indices[popu[comb->popu_count-1].chrom[i]];
    }

    seq_no = (comb->gen_count-1)*comb->popu_size + comb->popu_count;

    /*arrange the current sequence so that consecutive
      independent phases are sorted. If flag is not set,
      simple array copy would be perform.*/
    sort_ind_phases(comb->strlength, comb->flags, comb->base_opt,
		    next_seq, sort_phases, seq_no, TRUE);

    /*for genetic search, search hashtable for a match*/
    if(in_hashtable(sort_phases, comb->flags, comb->strlength,
		    &s_measure, &d_measure)){
      log_htable_msg();
      comb->valid_comb++;
      htable_msg(comb, next_seq, s_measure, d_measure);
      comb->done_comb++;
      (*hits)++;
      continue;
    }
  
    if(is_sequence_valid(next_seq, comb->base_opt, comb->strlength)){
      log_valid_msg(TRUE);
      comb->valid_comb++;
      break;
    }
    else{
      /*if the sequence is invalid then send this sequence
	to the viewer anyway, without taking any measurements*/
      sel_comb_msg(comb, next_seq, s_measure, d_measure);
      log_valid_msg(FALSE);
      comb->done_comb++;

      /*save the measures for genetic search*/
      popu[comb->popu_count-1].s_measure = 0;
      popu[comb->popu_count-1].d_measure = INFINITY;
    }
  }
  return seq_no;
}

/*
 * get_next_comb_seq - get the next sequence during the combinatorial search
 *                     approach in SEL...COMB
 */
void get_next_comb_seq(struct comb_struct *comb, int s[], int phase_indices[])
{
  int n, m, p, q, k;
  unsigned long long s_measure, d_measure;
  extern FILE *comb_log;

  /*generate sequences till we find a valid sequence*/
  while(comb->done_comb < comb->max_comb){

    /*the first sequence has already been generated*/
    if(comb->done_comb){
      
      n = comb->no_comb - 1;
      m = n-1;
      while(s[m] > s[m+1])
	m = m - 1;
    
      k = n;
      while(s[m] > s[k])
	k = k - 1;
    
      swapint(&s[m], &s[k]);
      p = m + 1;
      q = n;
    
      while(p < q){
	swapint(&s[p], &s[q]);
	p = p+1;
	q = q-1;
      }
    }

    if(is_sequence_valid(s, comb->base_opt, comb->strlength)){
      fprintf(comb_log, "is valid\n");
      comb->valid_comb++;
      break;
    }
    else{
      /*if the sequence is invalid then send this sequence
	to the viewer anyway, without taking any measurements*/
      sel_comb_msg(comb, s, s_measure, d_measure);
      fprintf(comb_log, "is invalid\n");
      comb->done_comb++;
    }
  }
}

/*
 * init_phase_prob - initilize phase probabilities for LEAF_SEARCH
 */
void init_phase_prob(struct comb_struct *comb, double phase_prob[])
{
  int i;
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  int test_phases[NUM_TRANS_TYPES] = {0, 1, 0, 3, 4, 5, 6, 0, 8, 0, 10, 0, 0, 13, 14, 15, 16, 0, 0, 0, 0, 21, 0, 0, 0, 25, 0, 27, 0, 29, 0, 0};

#if 1
  for(i=0 ; i<NUM_TRANS_TYPES ; i++)
    phase_prob[i] = denable_phase[0][i];
#else
  for(i=0 ; i<NUM_TRANS_TYPES ; i++){
    if(test_phases[i])
      phase_prob[i] = 1.0;
    else
      phase_prob[i] = 0.0;
  }
#endif  
}

/*
 * update_phase_prob - update phase probability tables for LEAF_SEARCH
 */
void update_phase_prob(struct comb_struct *comb, double phase_prob[],
		       int opt, int change)
{
  int i;
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  int test_phases[NUM_TRANS_TYPES] = {0, 1, 0, 3, 4, 5, 6, 0, 8, 0, 10, 0, 0, 13, 14, 15, 16, 0, 0, 0, 0, 21, 0, 0, 0, 25, 0, 27, 0, 29, 0, 0};

#if 1
  /*if a phase is unsuccessful then adjust prob. that the sequence could be
    terminated early. This is to take into account functions for which the
    best function instance is not a leaf*/
  if(change)
    phase_prob[0] = 0;
  else
    phase_prob[0] = (1.0-phase_prob[0]) * (phase_prob[opt] * 0.5);
      
  phase_prob[opt] = 0.0;
  if(change){
    for(i=1 ; i<NUM_TRANS_TYPES ; i++)
      phase_prob[i] += (((1.0-phase_prob[i]) * denable_phase[opt][i]) -
			((phase_prob[i]) * (ddisable_phase[opt][i])));
  }
#else
  phase_prob[opt] = 0.0;
  if(change){
    for(i=0 ; i<NUM_TRANS_TYPES ; i++){
      if(test_phases[i] && i!=opt)
	phase_prob[i] = 1.0;
      else
	phase_prob[i] = 0.0;
    }
  }
#endif  
}

/*
 * get_next_leaf_phase - determine the next phase to evaluate
 */
void get_next_leaf_phase(struct comb_struct *comb, int *pc, int change)
{
  int i, j, done_trans, opt, cnt, illegal_phase, curr_oper;
  double choose_prob[NUM_TRANS_TYPES], en_prob;
  static double phase_prob[NUM_TRANS_TYPES];
  extern unsigned int trans_done;
  extern struct command commands[MAXCMDS];
  extern FILE *comb_log;

  *pc = *pc - 1;
  curr_oper = commands[*pc].oper;

  /*initialize the probability tables for the first phase*/
  if(curr_oper < 0){

    /*check if we have attained the terminating comdition*/
    if(comb->best_dmeasure < INFINITY){

      /*check if we bettered the previous best during the last run*/
      if(comb->best_dmeasure < comb->last_dmeasure){
	comb->last_dmeasure = comb->best_dmeasure;
	comb->stagnate = 0;
      }
      else
	comb->stagnate++;

      /*terminate if we have reached the best performance*/
      if(comb->term_dmeasure && comb->best_dmeasure <= comb->term_dmeasure){
	fprintf(comb_log, "Optimal sequence found in sequence %d\n",
		comb->done_comb);
	end_sel_comb(comb);
	comb->max_comb = comb->done_comb;
	commands[*pc].oper = QUIT_TRANS;
	return;
      }
      else if(comb->stagnate > LEAF_MAX_STAGNATE){
	fprintf(comb_log, "Unable to reach optimal after %d sequences\n",
		comb->done_comb);
	end_sel_comb(comb);
	comb->max_comb = comb->done_comb;
	commands[*pc].oper = QUIT_TRANS;
	return;
      }
    }
    comb->max_comb = comb->done_comb + 2;
    init_phase_prob(comb, phase_prob);
  }
  else
    update_phase_prob(comb, phase_prob, curr_oper, change);

  /*find the next phase to attempt*/
  en_prob = 0.0;
  opt = cnt = 0;
  illegal_phase = 0;
  do{
    if(opt){
      illegal_phase |= (1 << opt);
      opt = 0;
    }

    done_trans = trans_done;
    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
      if(!(illegal_phase & (1<<j)) && (phase_prob[j] > 0.0)){
	choose_prob[j] = phase_prob[j] + en_prob;
	en_prob += phase_prob[j];
      }
      else
	choose_prob[j] = 0.0;
    }

    /*find a phase based on its prob. of being active*/
    en_prob = (double)((double)wrapper_rand() / (double)RAND_MAX) * en_prob;
    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
      if(choose_prob[j] > en_prob){
	opt = j;
	break;
      }
    }
    cnt++;
  }while((!opt || !is_opt_valid(opt, &done_trans)) && (cnt<NUM_TRANS_TYPES));

  /*set the next phase to attempt in the command array. If there is a phase
    that can be attempted, then perform it, else end the sequence*/
  if(opt){
    commands[*pc].oper = opt;
    if(opt == LOOP_UNROLL_TRANS)
      commands[*pc].offset = 2;
  }
  else
    commands[*pc].oper = END_COMBINATION;
}

/*
 * get_next_ex_phase - get the next optimization phase during the
 *                     combinatorial search approach in SEL...COMB
 */
int get_next_ex_phase(struct comb_struct *comb, int next_seq[], int length,
		       int phase_indices[], int curr_pos[], int curr_ptree)
{
  int i, opt, gene;
  unsigned int done_trans;
  unsigned long long s_measure, d_measure;
  static int opt_pos, preceeding_phases[NUM_TRANS_TYPES];
  extern FILE *comb_log;
  extern struct tree_struct *tree;
  extern unsigned int trans_done;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];

  if(length == comb->strlength)
    return END_COMBINATION;

  if(curr_ptree == START_NODE){

    /*if this is the start of this sequence, then we need to do some
      initializations*/
    if(comb->flags & ENABLE_PHASE){
      
      /*The set of phases seen before each phase is initialized to zero*/
      for(i=0 ; i<NUM_TRANS_TYPES ; i++)
	preceeding_phases[i] = ~(0);
    }

    /*We are here to get the next phase to attempt. We search linearly, at
      this point in the tree, all the phases which have have been
      successful before or have not yet been attempted, to find the first
      such phase. This variable marks the point in the tree where this
      linear search begins*/
    opt_pos = 0;
  }
  else
    opt_pos++;

  /*find the first phase which can be successfully applied*/
  if(comb->flags & (TREE_SEARCH|ENABLE_PHASE)){

    do{
      /*if there are phases after the current phase, which have been
	successful or not yet attempted*/
      if(tree[curr_ptree].no_succ_phases > 0){

	/*get the first possible phase at this stage*/
	while(tree[curr_ptree].opt[opt_pos]==UNSUCC && opt_pos<NUM_TREE_NODES)
	  opt_pos++;

	if(opt_pos < NUM_TREE_NODES){
	  
	  opt = comb->base_opt[opt_pos];

	  /*check if this is the first occurance of this phase in the
	    sequence, or if the phase has been enabled by some phase, after
	    its previous occurance*/
	  if(comb->flags & ENABLE_PHASE){
	    
	    if(!(enable_phase[opt] & preceeding_phases[opt])){

	      /*if this phase is not enabled, mark this phase as unsuccessful
		in the tree and go back to find another phase*/
	      tree[curr_ptree].opt[opt_pos] = UNSUCC;
	      tree[curr_ptree].no_succ_phases--;
	      continue;
	    }
	  }
	}
	else
	  /*no phases after this point can be successful. So truncate the
	    exhaustive tree at this point and take the measure as a composite
	    measure of all unsuccessful paths below this point*/
	  return 0;
      }
      else
	return 0;

      done_trans = trans_done;
    }while(!(is_opt_valid(opt, &done_trans)));

    return opt;
  }
  else{
    /*if TREE_SEARCH is not enabled, then we go back to the naive approach
      of evaluating all combinations*/

    /*if the previous sequence has been completely generated and evaluated
      then generate the next sequence*/
    if(length == -1){
      
      /*generate sequences till we find a valid sequence*/
      while(comb->done_comb < comb->max_comb){
	
	/*the first sequence has already been generated*/
	if(comb->done_comb){
	  
	  /*for exhaustive search generate next sequence by just increasing the
	    index of the least possible array position. Search for the first
	    occurance of an index which is less than the maximum number of
	    opt. phases. Generate the whole sequence the first time*/
	  for(i=comb->strlength-1 ; i>=0 ; i--){
	    if(curr_pos[i]+1 < comb->no_comb){
	      curr_pos[i]++;
	      next_seq[i] = phase_indices[curr_pos[i]];
	      
	      /*reset all following positions to 0*/
	      for(i=i+1; i<comb->strlength ; i++){
		curr_pos[i] = 0;
		next_seq[i] = 0;
	      }
	      break;
	    }
	  }
	  
	  if(i<0)
	    /*should never get here*/
	    fprintf(stderr, "error in get_next_opt_sequence\n");
	}
	
	if(is_sequence_valid(next_seq, comb->base_opt, comb->strlength)){
	  fprintf(comb_log, "is valid\n");
	  comb->valid_comb++;
	  break;
	}
	else{
	  /*if the sequence is invalid then send this sequence
	    to the viewer anyway, without taking any measurements*/
	  sel_comb_msg(comb, next_seq, s_measure, d_measure);
	  fprintf(comb_log, "is invalid\n");
	  comb->done_comb++;
	}
      }
      return 0;
    }
    return comb->base_opt[next_seq[length]];
  }
}

/*
 * update_hashtable - store the current population in the hash table to avoid
 *                    unnecessary measurements later
 */
void update_hashtable(struct comb_struct *comb, int sort_phases[])
{
  int i, index, pi;
  struct HASHTABLE *hptr, *prev_hptr, *new;
  extern struct HASHTABLE *htable[NUM_HTABLE_ELEMENTS];
  extern struct chromosome popu[MAX_CHROMOSOMES];
  extern int cindex;

  pi = comb->popu_count -1;
  /*calculate the index in the hashtable*/
  for(index=0, i=0 ; i<comb->strlength ; i++){
    if(sort_phases[i] > 0)
      index += (i+1) * sort_phases[i];
    else
      index -= (i+1) * sort_phases[i];
  }
  index = index % NUM_HTABLE_ELEMENTS;

  /*We enter this function only if this sequence is not found in the
    hashtable. So we can directly move on to insert this sequence in its
    proper bucket in the hashtable*/

  /*create a new hashtable element*/
  new = myalloc_comb(sizeof(struct HASHTABLE));
  new->no_phases = comb->strlength;
  for(i=0 ; i<comb->strlength ; i++)
    new->chrom[i] = sort_phases[i];
  new->s_measure = popu[pi].s_measure;
  new->d_measure = popu[pi].d_measure;
  new->seq = (comb->gen_count-1)*comb->popu_size+comb->done_comb;
  new->next = NULL;

  /*insert this element in the proper location*/
  if(htable[index] == NULL)
    htable[index] = new;
  else{
    prev_hptr = htable[index];
    hptr = htable[index]->next;
    while(hptr){
      prev_hptr = hptr;
      hptr = hptr->next;
    }

    prev_hptr->next = new;
  }
}

/*
 * in_hashtable - returns the measure if the string is already present in the
 *                hashtable, else returns 0
 */
int in_hashtable(int seq[], int flags, int strlength,
		 unsigned long long *s_measure,
		 unsigned long long *d_measure)
{
  int i, index, count;
  int opt, found=FALSE;
  unsigned int tree_ptr;
  struct HASHTABLE *hptr, *prev_hptr;
  extern struct HASHTABLE *htable[NUM_HTABLE_ELEMENTS];
  extern struct chromosome popu[MAX_CHROMOSOMES];
  extern struct tree_struct *tree;

  /*currently tree search is always disabled. The code works and we can
    enable it later*/
  if(0){
    
    /*traverse the tree to determine if this sequence has previously been
      seen*/
    for(tree_ptr=START_NODE, i=0 ; i<strlength ; i++){
      opt = seq[i];
      
      /*if this optimization has not been seen at this position*/
      if(tree[tree_ptr].opt[opt] == UNSEEN)
	break;
      
      /*if this opt. had been encountered in this position before*/
      if(tree[tree_ptr].opt[opt] > START_NODE)
	/*traverse the link to the next optimization*/
	tree_ptr = tree[tree_ptr].opt[opt];
      else
	/*this optimization was unsuccessful, no need to change pointers*/
	;
    }
    
    /*if the entire sequence has been traversed and the node reached is a leaf
      node, then the current sequence is the same as some previous sequence*/
    if(i==strlength && tree[tree_ptr].s_measure > 0){
      found = TRUE;
      *s_measure = tree[tree_ptr].s_measure;
      *d_measure = tree[tree_ptr].d_measure;
    }
  }
  else if(flags & HASHTABLE_SEARCH){
    
    /*determine the index of this string*/
    for(index=0, i=0 ; i<strlength ; i++){
      if(seq[i] > 0)
	index += (i+1) * seq[i];
      else
	index -= (i+1) * seq[i];
    }
    index = index % NUM_HTABLE_ELEMENTS;

    /*search all strings in this bucket in the hashtable for a match*/
    hptr = htable[index];
    while(hptr){
      
      if(is_same_seq(hptr->chrom, seq, strlength)){
	
	/*same string is found, return the measure to calling routine*/
	*s_measure = hptr->s_measure;
	*d_measure = hptr->d_measure;
	return 1;
      }
      hptr = hptr->next;
    }
  }
    
  /*string is not found in the hash table*/
  return 0;
}

/*
 * update_succ_htable - store the successful sequence  in the hash table to
 *                      avoid unnecessary measurements later
 */
void update_succ_htable(struct comb_struct *comb, int seq[], int length,
			unsigned long long s_measure,
			unsigned long long d_measure)
{
  int i, index, prev_index, count;
  struct HASHTABLE *prev_hptr, *hptr, *new;
  extern struct HASHTABLE *succ_htable[NUM_HTABLE_ELEMENTS];

  /*calculate the index in the hashtable*/
  for(index=0, i=0 ; i<length ; i++)
    index += (i+1) * seq[i];
  index = index % NUM_HTABLE_ELEMENTS;
  
  /*We enter this function only if this sequence is not found in the
    hashtable. So we can directly move on to insert this sequence in its
    proper bucket in the hashtable for successful sequences*/

  /*create a new hashtable element*/
  new = myalloc_comb(sizeof(struct HASHTABLE));
  new->no_phases = length;
  for(i=0 ; i<length ; i++)
    new->chrom[i] = seq[i];
  new->s_measure = s_measure;
  new->d_measure = d_measure;
  new->seq = (comb->gen_count-1)*comb->popu_size+comb->done_comb;
  new->next = NULL;

  /*insert this element in the proper location*/
  if(succ_htable[index] == NULL)
    succ_htable[index] = new;
  else{
    prev_hptr = succ_htable[index];
    hptr = succ_htable[index]->next;
    while(hptr){
      prev_hptr = hptr;
      hptr = hptr->next;
    }

    prev_hptr->next = new;
  }
}

/*
 * in_succ_htable - returns the measure if the string is already present in the
 *                  hashtable, else returns 0
 */
int in_succ_hashtable(int seq[], int length,
		      unsigned long long *s_measure,
		      unsigned long long *d_measure)
{
  int i, index, count;
  struct HASHTABLE *sptr;
  extern struct HASHTABLE *succ_htable[NUM_HTABLE_ELEMENTS];

  /*determine the index of this string*/
  for(index=0, i=0 ; i<length ; i++)
    index += (i+1) * seq[i];
  index = index % NUM_HTABLE_ELEMENTS;

  /*search all strings in this bucket in the hashtable for a match*/
  sptr = succ_htable[index];
  while(sptr){
    
    if(length==sptr->no_phases && is_same_seq(sptr->chrom, seq, length)){
      
      /*same string is found, return the measure to calling routine*/
      *s_measure = sptr->s_measure;
      *d_measure = sptr->d_measure;
      return 1;
    }
    sptr = sptr->next;
  }

  /*string is not found in the hash table*/
  return 0;
}


/*
 * reproduction - the genetic algorithm step of copying over strings to new
 *                generation based on fitness
 */
void reproduction(struct comb_struct comb, int s[])
{
#ifdef GENETIC_ALGO1
  int i, j, k, invalid, total, sum, psum;
  int max, *weights, *tweights;
  float random_num;
  struct chromosome new_popu[MAX_CHROMOSOMES];
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*allocate space to the weights*/
  weights = (int *)SALLOC(sizeof(int)*comb.popu_size);
  tweights = (int *)SALLOC(sizeof(int)*comb.popu_size);

  /*count the number of invalid combinations and find the max fitness value*/
  for(invalid=0, max=0, i=0 ; i<comb.popu_size ; i++){
    if(popu[i].s_measure == 0)
      invalid++;
    tweights[i] = ((popu[i].d_measure*(comb.weight)/100) +
		   (popu[i].s_measure*4*(100-comb.weight)/ 100));
    if(tweights[i] > max)
      max = tweights[i];
  }

  /*the fitness values currently show the one having the least fitness as the
    best. Attempting to reverse that so that the one with the highest weight
    is the best. This helps in finding strings to copy over to the next
    generation*/
  max = max + 0.5*max;
  for(i=0, total=0 ; i<comb.popu_size ; i++){
    if(tweights[i])
      weights[i] = max - tweights[i];
    else
      weights[i] = 0;
    total += weights[i];
  }

  /*introduce new random strings equal in number to the invalid strings in
    the previous generation*/
  for(i=0 ; i<invalid ; i++){
    get_random_seq(new_popu[i].chrom, &comb);

    /*if this sequence has been generated previously in this generation
      then get another sequence*/
    for(j=0 ; j<i ; j++){
      if(is_same_seq(new_popu[i].chrom, new_popu[j].chrom, comb.strlength)){
	i--;
	break;
      }
    }
  }

  /*copy over the remaining strings from the previous generation with
    probability equal to their fitness*/
  for( ; i<comb.popu_size ; i++){
    random_num = (float)rand() / (float)RAND_MAX;
    sum = random_num * total;
    for(j=0, psum=0 ; j<comb.popu_size ; j++){
	psum += weights[j];
      if(psum > sum)
	break;
    }

    /*copy the located sequence*/
    for(k=0 ; k<comb.strlength ; k++)
      new_popu[i].chrom[k] = popu[j].chrom[k];
  }

  /*copy over the newly generated population to its array*/
  for(i=0 ; i<comb.popu_size ; i++)
    for(j=0 ; j<comb.strlength ; j++)
      popu[i].chrom[j] = new_popu[i].chrom[j];
#endif

#ifdef GENETIC_ALGO2
  int i, half, to_change, cross_pt;
  int upp1, upp2, low1, low2, worst;
  float random_num;
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*divide the population in 2 equal halves*/
  half = comb.popu_size / 2;

  /*the crossover point is at half the string length*/
  cross_pt = comb.strlength / 2;
  /*random_num = (float)rand() / (float)RAND_MAX;
    cross_pt = random_num * comb.strlength;*/

  /*number of strings to modify from the lower half is 20% of the
    population*/
  to_change = comb.popu_size  / 5;
  if(comb.popu_size % 5 != 0)
    to_change++;

  /*Replace all strings leading to invalid combinations in this population by
    random strings in the next generation*/
  for(i=comb.popu_size-1 ; i>=0 && popu[s[i]].s_measure==0 ; i--){
    get_random_seq(popu[s[i]].chrom, &comb);

    /*if this sequence has been generated previously in this generation
      then get another sequence*/
    /*for(j=comb.popu_size-1 ; j>i ; j--){
      if(is_same_seq(new_popu[s[i]].chrom, new_popu[s[j]].chrom, comb.strlength)){
	i++;
	break;
      }
      }*/
  }

  /*if there are no valid strings then no point to continue and we can return
    at this point*/
  if(i >= 0){
    worst = i;
    if(i < half)
      half = i;
  }
  else
    return;

  /*Ideally the strings generated above using the random algorithm should not
    be replaced during crossover. But to keep the algo simple and since
    invalid combinations do not occur very often, this is not yet handled*/

  
  /*replace some strings from the lower half by crossover*/
  for(i=0 ; i<to_change ; i+=2){
    
    /*randomly select 2 strings from the upper half of the population to
      mate*/
    upp1 = wrapper_rand() % half;
    upp2 = wrapper_rand() % half;

    /*randomly select a string from the lower half of the population to
      replace. Always replace the worst string*/
    if(!i)
      low1 = worst;
    else{
      low1 = wrapper_rand() % half + half;
    }
    low2 = wrapper_rand() % half + half;
    
    /*generate 2 new strings using crossover*/
    gen_crossover(popu[s[upp1]].chrom, popu[s[upp2]].chrom, popu[s[low1]].chrom,
		  popu[s[low2]].chrom, cross_pt, comb.strlength);

    /*we check if the sequence is valid here, because generally these 2
      sequences undergoing crossover are not mutated. But if they are
      invalid, then it is better to mutate them*/
    if(is_sequence_valid(popu[s[low1]].chrom, comb.base_opt, comb.strlength)){
      popu[s[low1]].s_measure = 0;
      popu[s[low1]].d_measure = 0;
    }
    if(is_sequence_valid(popu[s[low2]].chrom, comb.base_opt, comb.strlength)){
      popu[s[low2]].s_measure = 0;
      popu[s[low2]].d_measure = 0;
    }
  }

  /*perform mutation on valid and unchanged strings with a low probability*/
  for(i=1 ; i<half ; i++){
    if(popu[s[i]].s_measure)
      mutation(&(popu[s[i]]), comb.base_opt, comb.reverse_base,
	       comb.strlength, comb.no_comb, comb.flags, comb.opt_mask, 5);
  }
  for(; i<comb.popu_size ; i++){
    if(popu[s[i]].s_measure)
      mutation(&(popu[s[i]]), comb.base_opt, comb.reverse_base,
	       comb.strlength, comb.no_comb, comb.flags, comb.opt_mask, 10);
  }
#endif
}

#ifdef GENETIC_ALGO2
/*
 * gen_crossover - crossover during a genetic algo search
 */
void gen_crossover(int base1[], int base2[], int replace1[],
		   int replace2[], int cross_pt, int length)
{
  int i;

  /*copy the first 'cross_pt' elements from 1 <--> 1 and 2 <--> 2*/
  for(i=0 ; i<cross_pt ; i++){
    replace1[i] = base1[i];
    replace2[i] = base2[i];
  }

  /*copy the remaining elements from 1 <--> 2 and 2 <--> 1*/
  for(; i<length ; i++){
    replace1[i] = base2[i];
    replace2[i] = base1[i];
  }
}
#endif
/*
 * crossover - does the drossover operation during a genetic algo. search
 */
void crossover(struct comb_struct comb)
{
#ifdef GENETIC_ALGO1
  int i, j, crossover_pt;
  float random_num;
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*mate two adjacent strings in the population*/
  for(i=0 ; i<comb.popu_size ; i+=2){

    /*find the crossover point*/
    crossover_pt = rand() % comb.strlength;

    /*swap all elements from crossover_pt to the string length*/
    for(j=crossover_pt ; j<comb.strlength ; j++)
      swapint(&popu[i].chrom[j], &popu[i+1].chrom[j]);
  }
#endif

#ifdef GENETIC_ALGO2
#endif
}


/*
 * phase_dormant - check if a phase os dormant by traversing the tree of past
 *                 sequences. If dormant, then return the list of potentially
 *                 active phases.
 */
int phase_dormant(int opt, int t_ptr, int flags, int base_opt[], int chrom[],
		  int preceeding_phases[], int *active)
{
  int i;
  extern struct tree_struct *tree;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];

  *active = 0;
  /*mutate dormant phases*/
  if(t_ptr!=-1 && (flags & TREE_SEARCH)){

    /*for each optimization, if we know that it would be unsuccessful
      then we mutate it with 100% probability and replace it with some
      opt. that has been successful before or some which has not been
      seen as yet*/ 
    if(tree[t_ptr].opt[opt] == UNSUCC){

      for(i=0 ; i<tree[t_ptr].no_succ_phases ; i++){
	if(tree[t_ptr].opt[i] == UNSUCC)
	  (*active) |= (1 << i);
      }
      (*active) = ~(*active);
      return TRUE;
    }
  }

  /*mutate phases which cannot be active at this time*/
  if(flags & ENABLE_PHASE){

    /*check if the current phase is enabled at this point. A phase is said
      to be enabled if
      a. it is the first occurance of the phase in this seq. and if we
         haven't encountered it as previously UNSUCC in the tree
      b. it has been re-enabled by a SUCC phase since its last occurance
         in the seq. and we haven't encountered it as previously UNSUCC in
         the tree
    */
    if(!(enable_phase[opt] & preceeding_phases[opt])){
      
      /*are we still on some previously encountered prefix*/
      if(t_ptr != -1){
	
	/*replace this phase by some phase which has not been previously
	  encountered as UNSUCC*/
	for(i=0 ; i<tree[t_ptr].no_succ_phases ; i++){
	  if(tree[t_ptr].opt[i] == UNSUCC)
	    (*active) |= (1 << i);
	}
      }
      (*active) = ~(*active);
      return TRUE;
    }
  }

  (*active) = ~(*active);
  return FALSE;
}


/*
 * mutation - the mutation process during a genetic algorithm search
 */
void mutation(struct chromosome *popu, int base_opt[], int reverse_base[],
	      int length, int phases, int flags, int opt_mask, int probability)
{
#ifdef GENETIC_ALGO2
  int i, j, k, gene, prob, done_trans, prev_done, is_traverse_tree;
  float random_num;
  int opt, p_opt, t_ptr, prev_phase, is_RA_done, count, enable_tptr;
  int act_opt, cnt, illegal_phase, sind, pind;
  unsigned int occured_phases[NUM_TRANS_TYPES];
  unsigned int preceeding_phases[NUM_TRANS_TYPES];
  double phase_prob[NUM_TRANS_TYPES], choose_prob[NUM_TRANS_TYPES], en_prob;
  extern unsigned long long mutation_count;
  extern struct tree_struct *tree;
  extern unsigned int trans_done;
  extern unsigned int after_trans_dependences[NUM_TRANS_TYPES];
  extern unsigned int enable_phase[NUM_TRANS_TYPES];
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];

  sind = 0;
  prev_phase = -1;
  t_ptr = enable_tptr = START_NODE;
  is_RA_done = FALSE;
  done_trans = trans_done;
  is_traverse_tree = TRUE;

  /*initialize*/
  for(i=0 ; i<NUM_TRANS_TYPES ; i++){
    /*disable phases we know are not succ. as the first phases in a sequence*/
    if(flags & (ENABLE_PHASE|TREE_SEARCH)){
      if(tree[START_NODE].opt[i] == UNSUCC)
	preceeding_phases[i] = 0;
      else
	preceeding_phases[i] = ~(0);
    }
    if(flags & ENABLE_PROB){
      /*initialize the array of current probabilities with probability of a
	phase being active at start*/
      phase_prob[i] = denable_phase[0][i];
    }
    occured_phases[i] = ~(0);
  }

  /*mutate the chromosome with the given probability*/
  for(i=0 ; i<length ; i++){

    prev_done = done_trans;
    opt = base_opt[popu->chrom[i]];
    p_opt = opt;

    /*carry out the normal mutation routine*/
    random_num = (float)wrapper_rand() / (float)RAND_MAX;
    prob = random_num * 100;

    /*mutate a phase if it is illegal in the sequence, or if it is known to
      be unsuccessful in its current position, or if it is selected due to
      probability*/    
    if((phase_dormant(opt, t_ptr, flags, base_opt, popu->chrom,
		      preceeding_phases, &act_opt)) ||
       !is_opt_valid(opt, &done_trans) || prob<=probability){
      
      /*if there is no phase that can be active after this point then
	return*/
      if(!act_opt)
	return;
      
      /*replace this gene with a random gene such that the sequence remains
	valid, loop till we find a suitable replacement*/
      count = 0;
      illegal_phase = 0;
      do{

	cnt = opt = 0;
	done_trans = prev_done;
	do{
	  /*get the gene to replace*/
	  if(flags & ENABLE_PROB){

	    /*if we are back here then it means that the previous phase was
	      invalid, mark it*/
	    if(opt){
	      illegal_phase |= (1 << opt);
	      phase_prob[opt] = 0.0;
	      opt = 0;
	    }

	    pind = 0;
	    en_prob = 0.0;
	    /*rank the active phases based on their probabilities*/
	    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
	      if(!(illegal_phase & (1<<j)) && (phase_prob[j] > 0.0)){
		choose_prob[j] = phase_prob[j] + en_prob;
		en_prob += phase_prob[j];
	      }
	      else
		choose_prob[j] = 0.0;
	    }
	    /*find a phase based on its prob. of being active*/
	    en_prob = (double)((double)wrapper_rand() / (double)RAND_MAX) * en_prob;
	    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
	      if(choose_prob[j] > en_prob){
		opt = j;
		break;
	      }
	    }
	    
	    if(opt){
	      gene = reverse_base[opt];
	      cnt++;
	    }
	  }
	  if(!(flags & ENABLE_PROB) || ((flags & ENABLE_PROB) && !opt)){
	    if(cnt == 0)
	      gene = wrapper_rand() % phases;
	    else
	      gene = get_rand() % phases;
	    opt = base_opt[gene];
	    cnt++;
	  }
	  
	}while((!is_opt_valid(opt, &done_trans) || !(act_opt & (1<<opt)))
	       && cnt < NUM_TRANS_TYPES);
	if(cnt < NUM_TRANS_TYPES){
	  popu->chrom[i] = gene;
	  mutation_count++;
	}
	count++;
	
	/*check if this phase cannot be successfully applied to this function*/
	if((flags & USELESS_TRANSFORM) && (opt_mask & (1<<opt)))
	  continue;
	
	/*check if a non-repeatable phase has been repeated*/
	if(flags & REPEAT_SAME_PHASE){
	  
	  if(!(enable_phase[opt] & occured_phases[opt]))
	    continue;
	}
	
	/*if we reach this point then the selected optimization is what we
	  need. We can break the loop at this point*/
	break;
      }while(count < MAX_ATTEMPTS);
      
      /*update information for next mutation pass for next optimization phase
	in this sequence*/
      if(flags & REPEAT_SAME_PHASE){
	occured_phases[opt] = 0;
	for(j=0 ; j<NUM_TRANS_TYPES ; j++)
	  occured_phases[j] |= (1 << opt);
      }
      
      /*traverse the tree until the prefix matches some already encountered*/
      if(flags & TREE_SEARCH && t_ptr != -1){
	
	/*check if we are still on a previously seen sequence. If not, then
	  the tree can no longer be traversed*/
	if(tree[t_ptr].opt[opt] > START_NODE)
	  t_ptr = tree[t_ptr].opt[opt];
	else
	  t_ptr = -1;
      }
      
      /*test if a phase is enabled at this point*/
      if(flags & ENABLE_PHASE && t_ptr != -1){
	
	if(tree[t_ptr].opt[opt] > START_NODE)
	  t_ptr = tree[t_ptr].opt[opt];
	else
	  t_ptr = -1;
      
	/*include this phase in the set of preceeding phases seen*/
	preceeding_phases[opt] = 0;
	for(j=0 ; j<NUM_TRANS_TYPES ; j++){
	  if(t_ptr != -1){
	    if(tree[t_ptr].opt[j] == UNSUCC)
	      preceeding_phases[j] = 0;
	    else
	      preceeding_phases[j] |= (1 << opt);
	  }
	  else
	    preceeding_phases[j] |= (1 << opt);
	}
      }
    }

    /*update the probability numbers*/
    if(flags & ENABLE_PROB){
      phase_prob[opt] = 0.0;
      if(popu->succ_phases[sind] == REG_ASSIGNMENT_TRANS)
	sind++;

      /*only successful phases should affect the probability tables*/
      if((sind < popu->succ_num) && (p_opt == popu->succ_phases[sind])){
	for(j=0 ; j<NUM_TRANS_TYPES ; j++)
	  phase_prob[j] += (((1.0-phase_prob[j]) * denable_phase[opt][j]) -
			    ((phase_prob[j]) * (ddisable_phase[opt][j])));
	sind++;
      }
    }
  }
#endif
}


/*
 * sort_popu_active - sort population in decending order of active sequence
 *                    length. Return index of best performance
 */
int sort_popu_active(struct comb_struct comb, int list[])
{
  long long perf;
  int i, j, index, max, best;
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*initialize the list with the unsorted order of chromosomes*/
  for(i=0 ; i<comb.popu_size ; i++)
    list[i] = i;
  
  /*sort, actually the order of elements in the population is not changed,
    the list array contains pointers to each chromosome in the population and
    this list is sorted*/
  for(i=0 ; i<comb.popu_size ; i++){
    max = 0;
    perf = INFINITY;
    for(j=i ; j<comb.popu_size ; j++){
      if(popu[j].succ_num > max){
	max = popu[j].succ_num;
	perf = popu[j].d_measure;
	index = j;
      }
      else if(popu[j].succ_num == max){
	if(popu[j].d_measure < perf){
	  perf = popu[j].d_measure;
	  index = j;
	}
      }
    }
    swapint(&list[i], &list[index]);
  }

  /*find the best dynamic performance*/
  perf = INFINITY;
  for(i=0 ; i<comb.popu_size ; i++){
    if(popu[i].d_measure < perf){
      perf = popu[i].d_measure;
      index = i;
    }
  }

  return index;
}

/*
 * sort_population - sort the population of chromosomes based on fitness
 *                   value
 */
void sort_population(struct comb_struct comb, int list[])
{
  int i, j, index;
  double sta_measure, dyn_measure;
  double min, weights[MAX_CHROMOSOMES];
  extern struct chromosome popu[MAX_CHROMOSOMES];

  /*initialize the list with the unsorted order of chromosomes*/
  for(i=0 ; i<comb.popu_size ; i++)
    list[i] = i;

  /*calculate the weights for each optimization string*/
  for(i=0 ; i<comb.popu_size ; i++){
    if(popu[i].s_measure){
      sta_measure =
	(double)( (double)((double)popu[i].s_measure/(double)comb.base_smeasure)*
		  (100-comb.weight) );
      if(comb.base_dmeasure)
	dyn_measure =
	  (double)( (double)((double)popu[i].d_measure/(double)comb.base_dmeasure)*comb.weight);
      else
	dyn_measure = comb.weight;
      weights[i] = sta_measure + dyn_measure;
    }
    else
      weights[i] = DINFINITY;
  }
    

  /*sort, actually the order of elements in the population is not changed,
    the list array contains pointers to each chromosome in the population and
    this list is sorted*/
  for(i=0 ; i<comb.popu_size ; i++){
    min = DINFINITY;
    for(j=i ; j<comb.popu_size ; j++){
      if(weights[j] < min){
	min = weights[j];
	index = j;
      }
    }
    if((DINFINITY - min) > (double)0.00001){
      swapint(&list[i], &list[index]);
      swapdouble(&weights[i], &weights[index]);
    }
  }
	
  for(i=0 ; i<comb.popu_size ; i++)
    fprintf(stderr, "%lf ", weights[i]);
}

/*sort_ind_phases - Function to arrange the sequence so that independent
                    phases within the sequence are sorted. For remap=TRUE,
                    seq contains 'base_opt' array indices and not the actual
                    phase numbers, so we remap it to phase numbers.
*/
void sort_ind_phases(int strlength, int flags, int base_opt[],
		     int seq[], int sort_phases[], int seq_no, int remap)
{
  char temp[MAXSTRING];
  char char_seq[MAXSTRING], str[MAXSTRING];
  int i, changes;
  long resume_log_ptr;
  extern int resume_mode;
  extern FILE *comb_log;

  /*store the current pointer to the log file*/
  resume_log_ptr = 0;
  if(resume_mode)
    resume_log_ptr = ftell(comb_log);
  
  /*copy the current sequence into sort_phases. This array will hold the
    sorted phases*/
  for(i=0 ; i<strlength ; i++){
    if(remap)
      sort_phases[i] = base_opt[seq[i]];
    else
      sort_phases[i] = seq[i];
  }

  /*original sequence*/
  if(remap){
    /*construct original sequence*/
    sprintf(char_seq, "Sequence %d: ", seq_no);
    for(i=0 ; i<strlength ; i++){
      sprintf(temp, "%d ", sort_phases[i]);
      strcat(char_seq, temp);
    }
    strcat(char_seq, "\n");
    
    if(resume_mode){
      fgets(str, MAXSTRING-1, comb_log);
      if(strcmp(str, char_seq) != 0){
	fprintf(stderr, "Opt sequence %d does not match in resume mode\n", seq_no);
	resume_mode = FALSE;
	fseek(comb_log, resume_log_ptr, SEEK_SET);
      }
    }
    if(!resume_mode)
      fprintf(comb_log, "%s", char_seq);
  }

  if(flags & SORT_PHASES){
    changes = TRUE;
    /*for sequences which explicitly enumerate reg_asg. as a phase*/
    if(remap){
      while(changes)
	changes = sort_ind_phases_pass(strlength, seq, sort_phases);
    }
    else{
      while(changes)
	changes = sort_ind_phases_pass_RA(strlength, seq, sort_phases);
    }
  }

  /*sorted sequence*/
  /*  fprintf(comb_log, "Sorted   %d: ", seq_no);
      for(i=0 ; i<strlength ; i++)
      fprintf(comb_log, "%d ", sort_phases[i]);
      fprintf(comb_log, "\n");*/
}

/*sorting a sequence which does not explicitly list register assignment as a
  phase*/ 
int sort_ind_phases_pass(int strlength, int seq[], int sort[])
{
  int i, temp, changes;
  int opt1, opt2;
  int after_reg_asg, reg_asg_done;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];
  extern unsigned int ind_phase[NUM_TRANS_TYPES];

  /*mark the phases which can only be done after register assugnment*/
  after_reg_asg = DEAD_ASG_ELIM_BIT | REG_ALLOCATION_BIT |
    COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT | ALL_LOOP_BIT;

  changes = FALSE;
  reg_asg_done = FALSE;
  for(i=0 ; i<strlength-1; i++){

    /*if either phase 'A' can be enabled by 'B' or 'B' can be enabled by 'A',
      then they are not independent*/
    /*If a phase can affect register assignment, then it is important that
      the relative order of register assignment and that phase remains the
      same. So we do not interchange phases opt1 and opt2, if opt2 affects
      reg_asg, opt1 requires reg_asg to be done before it, and reg_asg has
      not been done at the point of opt1*/
    opt1 = sort[i];
    opt2 = sort[i+1];
    
    if(opt1 > opt2
       && (!((ind_phase[opt1] & (1<<opt2)) ||(ind_phase[opt2] & (1<<opt1))))
       && (!(!reg_asg_done && (ind_phase[REG_ASSIGNMENT_TRANS] & (1<<opt2)) &&
	     (after_reg_asg & (1<<opt1))))){
      temp = sort[i];
      sort[i] = sort[i+1];
      sort[i+1] = temp;
      changes = TRUE;
    }

    if(!reg_asg_done && after_reg_asg & (1 << sort[i]))
      reg_asg_done = TRUE;
  }
  
  return changes;
}

/*sorting a sequence which lists register assignment explicitly in the
  sequence */
int sort_ind_phases_pass_RA(int strlength, int seq[], int sort[])
{
  int i, temp, changes;
  int opt1, opt2;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];
  extern unsigned int ind_phase[NUM_TRANS_TYPES];

  changes = FALSE;
  for(i=0 ; i<strlength-1; i++){

    /*if either phase 'A' can be enabled by 'B' or 'B' can be enabled by 'A',
      then they are not independent*/
    opt1 = sort[i];
    opt2 = sort[i+1];
    
    if(opt1 > opt2
       && (!((ind_phase[opt1] & (1<<opt2)) ||(ind_phase[opt2] & (1<<opt1))))){
      temp = sort[i];
      sort[i] = sort[i+1];
      sort[i+1] = temp;
      changes = TRUE;
    }
  }
  
  return changes;
}


/*
 * swapint - swap 2 integers
 */
void swapint(int *a, int *b)
{
  int c;

  c = *a;
  *a = *b;
  *b = c;
}

/*
 * swaplong - swap 2 long integers
 */
void swapdouble(double *a, double *b)
{
  double c;

  c = *a;
  *a = *b;
  *b = c;
}

/*
 * get_search_flags - read the flags for the intelligent search, specified by
 *                    the user in the external file "search_flags"
 */
int get_search_flags(struct comb_struct *comb, char *fn)
{
  char ch, str[MAXSTRING], buff[BUFSIZ], func[MAXSTRING];
  int flags, opt, i, count, is_seq, last_opt;
  FILE *fp;
  extern struct chromosome popu[MAX_CHROMOSOMES];
  extern FILE *rand_fp;
  extern char rand_buf[BUFSIZ];

  /*initialize flags to indicate that all user options are disabled*/
  flags = HASHTABLE_SEARCH;
  rand_fp = NULL;

  /*open the user configuration file*/
  if( (fp = fopen("search_flags", "r")) == 0){
    fprintf(stderr, "File search_flags cannot be opened\n");
    return 0;
  }
  setbuf(fp, buff);

  /*set the flags as specified by the user*/
  fgets(str, MAXSTRING-1, fp);
  while(!feof(fp)){
    
    /*Check if the user wants to provide the genetic algorithm with a
      pre-specified sequence*/
    if((sscanf(str, "Batch Sequence: %c\n", &ch)) == 1){
      if(ch == 'Y' || ch == 'y'){
	flags = flags | BATCH_SEQUENCE;

	is_seq = FALSE;
      }
    }
    /*find the sequence for the current function*/
    else if((sscanf(str, "Function: %s\n", func)) == 1){
      
      if((flags & BATCH_SEQUENCE) && (strcmp(func, fn) == 0)){
	
	/*initialize the first chromosome to the sequence specified by the
	  user. The sequence is not stored as optimization numbers but by the
	  indices where they appear in the "base_opt" array. It is assumed that
	  all optimizations specified in this file are also selected by the user
	  in the viewer*/
	count = 0;
	fscanf(fp, " %d", &opt);
	while(opt != -1){
	  for(i=0 ; i<comb->no_comb ; i++){
	    if(comb->base_opt[i] == opt){
	      popu[0].chrom[count++] = i;
	      break;
	    }
	  }
	  if(i == comb->no_comb)
	    fprintf(stderr, "Batch optimization %d not found\n", opt);
	  else
	    last_opt = i;
	  
	  /*read the next optimization in the sequence*/
	  fscanf(fp, " %d", &opt);
	}
	/*initialize the remaining length of the chromosome to the last sequence*/
	for(; count<comb->strlength ; count++)
	  popu[0].chrom[count] = last_opt;
	
	fscanf(fp, " \n");
	is_seq = TRUE;
      }
      else
	/*read the optimization sequence*/
	fgets(str, MAXSTRING-1, fp);
    }
    else if((sscanf(str, "Tree Search: %c\n", &ch)) == 1){
	
      /*check if the user wants to use the tree structure*/
      if(ch == 'Y' || ch == 'y')
	flags = flags | TREE_SEARCH;
    }
    else if((sscanf(str, "Hashtable Search: %c\n", &ch)) == 1){
	
      /*check if the user wants to use the tree structure*/
      if(ch == 'Y' || ch == 'y')
	flags = flags | HASHTABLE_SEARCH;
      else
	flags = flags & ~(HASHTABLE_SEARCH);
    }
    else if((sscanf(str, "Successful Hashtable Search: %c\n", &ch)) == 1){
	
      /*check if the user wants to use the tree structure*/
      if(ch == 'Y' || ch == 'y')
	flags = flags | SUCC_HTABLE;
    }
    else if((sscanf(str, "Function Checks After Phase: %c\n", &ch)) == 1){
	
      /*check if the user wants to use the tree structure*/
      if(ch == 'Y' || ch == 'y')
	flags = flags | FUNC_CHECKS;
    }
    else if((sscanf(str, "Useless Transforms: %c\n", &ch)) == 1){

      /*check if the user wants the compiler to avoid doing phases which
	would not prove useful for this function*/
      if(ch =='Y' || ch =='y')
	flags = flags | USELESS_TRANSFORM;
    }
    else if((sscanf(str, "Repeated Transforms: %c\n", &ch)) == 1){

      /*check if the user wants the compiler to not repeat phases which
	cannot be successfully performed twice consecutively without any
	interwining phase*/
      if(ch == 'Y' || ch == 'y')
	flags = flags | REPEAT_SAME_PHASE;
    }
    else if((sscanf(str, "Enable Transforms: %c\n", &ch)) == 1){

      /*check if the user wants to enable phases based on pre-defined
	compiler user knowledge and empirical data*/
      if(ch == 'Y' || ch == 'y'){
	flags |= ENABLE_PHASE;
	flags &= ~(REPEAT_SAME_PHASE);
	flags &= ~(TREE_SEARCH);
      }
    }
    else if((sscanf(str, "Enable Probabilities: %c\n", &ch)) == 1){

      /*use enable/disable probabilities during mutation to find the next
	phase to apply*/
      if(ch == 'y' || ch == 'Y')
	flags |= ENABLE_PROB;
    }
    else if((sscanf(str, "Control Flow Only Executions: %c\n", &ch)) == 1){

      /*only execute/simulate the program on producing a different control
	flow */
      if(ch == 'Y' || ch == 'y')
	flags |= CONTROL_FLOW_EXEC;
    }

    /*read the next line in the file*/
    fgets(str, MAXSTRING-1, fp);
  }
  fclose(fp);

  if( (flags & BATCH_SEQUENCE) && !is_seq ){
    fprintf(stderr, "Batch sequence for current function not found\n");
    flags &= ~BATCH_SEQUENCE;
  }

  /*open the file containing pre-computed pseudo-random numbers*/
  if((rand_fp = fopen("random_numbers", "r"))== NULL)
    fprintf(stderr, "File: random_numbers cannot be opened\n");
  else
    setbuf(rand_fp, rand_buf);
  
  return flags;
}

/*
 get_rand - get a new random number for a file
*/
int get_rand()
{
  int random;
  extern FILE *rand_fp;
  extern FILE *comb_log;

  /*if(rand_fp && feof(rand_fp))
    fseek(rand_fp, 0, SEEK_SET);

  if(rand_fp && !feof(rand_fp)){
    fscanf(rand_fp, "%d ", &random);
    return random;
  }
  else{
    fprintf(comb_log, "Error in getting number from random_numbers\n");
    random = wrapper_rand();
    return random;
    }*/
  random = rand();
  return random;
}

int wrapper_rand()
{
  int random;
  extern FILE *comb_log;
  extern unsigned long long tot_rand;

  tot_rand++;
  random = rand();
  /*fprintf(comb_log, "%d ", random);*/
  return random;
}

/*
 * is_sequence_valid - determine if a sequence of optimizations is valid
 */
int is_sequence_valid(int seq[], int base_opt[], int n)
{
  extern unsigned int trans_done;
  extern unsigned int before_trans_dependences[NUM_TRANS_TYPES];
  extern unsigned int after_trans_dependences[NUM_TRANS_TYPES];
  int i, j, depend, opt, flag;
  unsigned int done_trans;

  /*checking for transformations which should precede some transformation*/
  /*assume that register assignment hasalready been done. Later during
    applyin the sequence, if register assignment is needed for some
    optimization phase, it will be performed at that time*/
  done_trans = trans_done;
  flag = 0;
  for(i=0, j=0 ; i<n ;){
    opt = base_opt[seq[i]+j];
    switch(opt){
    case SELECT_BEST_SEQUENCE:
      flag++;
      j = 0;;
      break;
    case DONE_SELECT:
      j = 0;
      flag--;
      break;
    default:
      depend = after_trans_dependences[opt];
      /*check if register assignment needs to be done before this opt. If
	needed it would be performed by the compiler automatically at this
	point */
      if(depend && ((depend & done_trans) == (depend & ~(1<<REG_ASSIGNMENT_TRANS))))
	done_trans |= 1 << REG_ASSIGNMENT_TRANS;
      if((depend & done_trans) != depend)
	return 0;
      /*check if any transforms which can only be done after this phase have
	already been performed*/
      depend = before_trans_dependences[opt];
      if(depend & done_trans)
	return 0;
      if(ONCE_TRANS(1 << opt) && (1<<opt)&done_trans)
	return 0;
      done_trans |= (1 << opt);
    }
    if(flag)
      j++;
    else
      i++;
  }

  return 1;
}

/*
 * is_opt_valid - determine if a sequence of optimizations is valid
 */
int is_opt_valid(int opt, unsigned int *done_trans)
{
  extern unsigned int before_trans_dependences[NUM_TRANS_TYPES];
  extern unsigned int after_trans_dependences[NUM_TRANS_TYPES];
  int depend, t_done_trans;
  
  t_done_trans = *done_trans;

  /*checking for transformations which should precede some transformation*/
  depend = after_trans_dependences[opt];
  
  /*check if register assignment needs to be done before this opt. If
    needed it would be performed by the compiler automatically at this
    point */
  if(depend && (depend & t_done_trans) == (depend & ~(1<<REG_ASSIGNMENT_TRANS)))
    t_done_trans |= 1 << REG_ASSIGNMENT_TRANS;
  if((depend & t_done_trans) != depend)
    return 0;

  /*check if any transforms which can only be done after this phase have
    already been performed*/
  depend = before_trans_dependences[opt];
  if(depend & t_done_trans)
    return 0;
  if(ONCE_TRANS(1 << opt) && (1<<opt)&t_done_trans)
    return 0;

  t_done_trans |= (1 << opt);

  *done_trans = t_done_trans;
  return 1;
}

/*
 * is_better_seq - determine if the current sequence is better than the best
 *                 sequence found so far
 */
int is_better_seq(struct comb_struct *comb, unsigned long long smeasure,
		  unsigned long long dmeasure, int seq[], double *measure)
{
  double sta_measure, dyn_measure;

  sta_measure =
    (double)( (double)((double)smeasure/(double)comb->base_smeasure)*(100-comb->weight));
  if(comb->base_dmeasure)
    dyn_measure =
      (double)( (double)((double)dmeasure/(double)comb->base_dmeasure)*comb->weight);
  else
    dyn_measure = comb->weight;

  *measure = sta_measure + dyn_measure;

  /*return true if this sequence is a clear winner*/
  if((comb->best_measure - *measure) > (double)0.0000001)
    return 1;

  /*if this sequence is as good as the best sequence*/
  else if((*measure - comb->best_measure) < (double)0.00001){

    /*if we only used instruction counts for the comparison then resolve the
      tie using code size*/
    if(comb->weight == 100){
      if(smeasure < comb->best_smeasure)
	return 1;
    }

    /*if we use only code size for the comparison then resolve the tie using
      the dynamic measures*/
    if(comb->weight == 0){
      if(dmeasure < comb->best_dmeasure)
	return 1;
    }

    /*else, if this sequence has more number of distinct phases optimization
      sequences then send it as the better sequence*/
    /*if(distinct_phases(comb->best_opt, comb->strlength) <
       distinct_phases(seq, comb->strlength))
       return 1;*/
  }
  return 0;
}

/*
 * get_time_diff - get the time elapsed since the time in the argument
 */
void get_time_diff(struct timeval ctime, unsigned long long *sec, unsigned long long *usec)
{
  struct timeval tp;

  gettimeofday(&tp, NULL);
  *sec = tp.tv_sec - ctime.tv_sec;
  *usec = tp.tv_usec - ctime.tv_usec;
}

/*
 * distinct_phases - returns the number of distinct phases in the argument
 *                   sequence, during a SEL...COMB
 */
int distinct_phases(int sequence[], int length)
{
  int i, distinct, phases[MAX_OPT];
  int ph;

  for(i=0 ; i<length ; i++)
    phases[i] = 0;

  distinct = 0;
  for(i=0 ; i<length ; i++){
    ph = sequence[i];
    
    if(!phases[ph]){
      distinct++;
      phases[ph]++;
    }
  }

  return distinct;
}

/*
 * get_seffects - update the side effects for RTLs
 */
void get_seffects()
{
  struct bblock *cblk;
  struct list *ptr;
  char se[MAXSTRING];
  extern char *side_effect;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){

    /*for each RTL in the basic block*/ 
    for(ptr=cblk->rtls ; ptr ; ptr=ptr->next){

      /*if the line is a RTL line*/
      if(cnts(ptr)){
	side_effect = se;
	*se = '\0';

	/*parse the RTL*/
	if(!find(ptr, ptr->val, ptr->deads)){

	  /*set the side-effects of this RTL*/
	  if(*se){
	    FREE(ptr->se);
	    ptr->se = CALLOC(strlen(se)+1);
	    strcpy(ptr->se, se);
	    ptr->type |= SIDEFFECT;
	  }
	}
      }
    }
  }
  side_effect = (char*) NULL;
}

/*
 * init_command_array - initialise the command array with the new sequence
 *                     during SEL...COMB
 */
void init_command_array(int length, int strlength, int pc,
			struct command commands[], int base_opt[], int next_seq[])
{
  int i, j, m, flag=0;
  extern int resume_mode;
 
  m = 0;
  /*if we are resuming execution, then initialize next sequence by zeros*/
  if(!resume_mode){

    for(i=0, j=0, m=0 ; i<strlength ; m++){
      commands[pc+m].oper = base_opt[next_seq[i]+j];

      /*set loop unroll factor to 2, need to change later*/
      if(commands[pc+m].oper == LOOP_UNROLL_TRANS)
	commands[pc+m].offset = 2;
      
      switch(base_opt[next_seq[i]+j]){
      case SELECT_BEST_SEQUENCE:
	flag++;
	break;
      case DONE_SELECT:
	flag--;
	j=0;
	break;
      }
      
      if(flag)
	j++;
      else
	i++;
    }
  }

  /*initialize remaining command array*/
  for(; m<length ; m++)
    commands[pc+m].oper = IGNORE_COMMAND;
}


/* sel_seq_measures - execute the function and get the static and dynamic
                      measures during select best sequence
*/
unsigned long long sel_seq_measures(int seq_count, int weight)
{
  int i;
  unsigned long long s_measure, d_measure, measure;
  int ins_counts[MAX_BLOCKS];
  struct bblock *cblk;
  struct freq_counts *freq_measure;
  extern struct bblock *top;

  s_measure = d_measure = 0;
  
  /*get the static code size*/
  for(cblk=top ; cblk ; cblk=cblk->down)
    s_measure += getRTLCount(cblk);

  /* get the number of instructions in each block*/
  for(i=0, cblk=top ; cblk ; cblk=cblk->down)
    ins_counts[i++] = getRTLCount(cblk);

#ifdef MEASURE		    

  if(get_measure(&freq_measure, seq_count)){
    /* error during the process of getting measurements*/
    fprintf(stderr, "Error in measurement process during sel best sequence\n");
  }
#endif

  /*determine the dynamic number of instructions executed*/
  for(i=0,cblk=top ; cblk ; cblk=cblk->down)
    d_measure += ins_counts[i++] * cblk->frequency;

  /*calsulate the weighted measure*/
  measure = (d_measure*weight/100) + (s_measure*(100-weight)/100);

  return measure;
}


/*
 * get_perf_file - extract the filename where the performance counts are
 *                 dumped
 */
void get_perf_file(char line[], char filename[], int exe_stat)
{
  int i;

  /*if the file is executed*/
  if(exe_stat & EXECUTE){

    strcpy(filename, line);
    for(i=strlen(filename)-1 ; i>0 && filename[i]!='.' ; i--);
    if(i > 0)
      filename[i] = '\0';
    strcat(filename, ".cnt");
  }
  else if(exe_stat & SIMULATE){

    for(i=0 ; i<strlen(line)-10 ; i++){
      if(line[i]=='-' && strncmp(&(line[i]), "-redir:sim", 10)==0)
	break;
    }
    if((sscanf(&line[i], "-redir:sim %s", filename)) != 1)
      filename[0] = '\0';
  }
}


/*
 * get_sim_counts - get the dynamic instruction counts or cycle counts from
 *                  the simulator output file.
 */
unsigned long long get_sim_counts(char file[])
{
  char str[MAXSTRING], cmd[MAXSTRING], base[MAXSTRING];
  unsigned long long cycles, dy_ins, func_cycles;
  FILE *fp;
  char fpbuff[BUFSIZ];
  extern char pathname[];

  /*get the name of the simulator output file from test.config*/
  if(file == NULL){

    /*open the configuration file which contains commands to execute/simulate
      the program to generate performance measures*/
    sprintf(cmd, "%stest.config", pathname);
    if((fp = fopen(cmd, "r")) == NULL){
      fprintf(stderr, "Unable to open file %s in get_sim_counts\n", cmd);
      exit(0);
    }
    setbuf(fp, fpbuff);

    /*read till we get the execute command, we then extract the execute
      command*/
    base[0] = '\0';
    fgets(str, MAXSTRING, fp);
    while(!(feof(fp))){
      if( (sscanf(str, "execute command: %[^\n]\n", base)) == 1)
	break;
      fgets(str, MAXSTRING, fp);      
    }
    fclose(fp);

    get_perf_file(base, cmd, SIMULATE);
    fp = fopen(cmd, "r");
  }
  else
    fp = fopen(file, "r");
  
  if(fp == NULL){
    fprintf(stderr, "File %s cannot be opened to read perf counts\n", file);
    return 0;
  }

  func_cycles = cycles = dy_ins = 0;
  fgets(str, MAXSTRING-1, fp);
  while(!(feof(fp))){

    sscanf(str, "sim_cycle %lld", &cycles);
    sscanf(str, "func_cycle %lld", &func_cycles);
    sscanf(str, "sim_num_insn %lld", &dy_ins);
    
    fgets(str, MAXSTRING-1, fp);
  }
  fclose(fp);

  fprintf(stderr, "Simulator Counts, cycles %lld, dy_ins: %lld\n",
	  cycles, dy_ins);

  if(func_cycles)
    return func_cycles;
  /*  else if(cycles)
    return cycles;
  else
  return dy_ins;*/
  return 0;
}


/*
 * get_perf_num - dump the current function, produce the assembly file and
 *                get perofrmance numbers. The first invocation of this
 *                function at the start of the search also determines if the
 *                function is to be executed during later evaluations
 */
unsigned long long get_perf_num(struct comb_struct *comb, int seq[],
				unsigned long long *s_measure,
				unsigned long long *d_measure)
{
  char fpbuff[BUFSIZ], base[MAXSTRING], str[MAXSTRING];
  char string[MAXSTRING], cmd[MAXSTRING], line[MAXSTRING];
  int i, ins_counts[MAX_BLOCKS], new_cf, total_changes;
  unsigned long long actual_count, save_smeasure;
  long long sim_count;
  FILE *fp;
  struct bblock *cblk;
  struct freq_counts *measures;
  struct CFList *func_cf;
  struct BlockList *bl;
  extern char *fn, pathname[], genreport_path[];
  extern int valid_analysis, is_take_measure, execute_status;
  extern struct bblock *top;
  extern struct CFList *cflist;
  extern FILE *comb_log;

  *s_measure = 0;
  *d_measure = 0;
  new_cf = FALSE;

  /*get the static code size*/
  for(cblk=top ; cblk ; cblk=cblk->down)
    *s_measure += getRTLCount(cblk);
  /**s_measure += block_cycles(cblk);*/  
  save_smeasure = *s_measure;
  
  /*perform the required transformations if not yet applied*/
  apply_epilogue_trans(&valid_analysis);
  
  /*check if we need to get dynamic measures. We only get dynamic measures,
    if they are requested by the user (weight > 0), and the current function
    is executed, or to break ties when two functions have the same code-size
    and weight = 0*/
  if( (is_take_measure && comb->weight!=0) ||
      (is_take_measure && (comb->weight==0 &&
			   *s_measure<=comb->best_smeasure)) ){

    if(comb->flags & CONTROL_FLOW_EXEC){
      /*get the function control flow information*/
      func_cf = get_func_cf(&new_cf);
      
      /*store the RTL counts in the CF structure*/
      if(!new_cf){
	for(cblk=top, bl=func_cf->blist ; bl ; bl=bl->down){
	  bl->cycle = block_cycles(cblk);
	  /*bl->cycle = getRTLCount(cblk);*/
	  cblk = cblk->down;
	}
      }
    }
    else{
      
      /*store the number to instructions in each block, to calculate dynamic 
	ins. count manually, if the reading the genreport fails*/
      for(i=0,cblk=top ; cblk ; cblk=cblk->down)
	ins_counts[i++] = getRTLCount(cblk);
      new_cf = TRUE;
    }      

    /*we only need to get measures for function instances which have a yet
      unseen control flow*/
    if(new_cf){
    
      /*take measurements*/
      if(get_measure(&measures, comb->sequence_count)){

	/*if these are not the baseline measures, then since the measures are
	  for some sequence, we can be sure that the seq array will not be
	  NULL*/ 
	if(seq){
	
	  /*if this sequence produced incorrect executable*/
	  get_opt_sequence(string, comb->base_opt, seq, comb->strlength);
	  fprintf(comb_log, "%s produced incorrect output\n", string);
	  *s_measure = INFINITY;
	  *d_measure = INFINITY;
	  
	  /*invalidate the last control flow*/
	  if(comb->flags & CONTROL_FLOW_EXEC){
	    for(func_cf=cflist ; func_cf->next && func_cf->next->next;
		func_cf=func_cf->next);
	    if(func_cf->next)
	      func_cf->next = NULL;
	    else
	      cflist = NULL;
	  }
	  return INFINITY;
	}
	/*for the baseline measures*/
	else{
	  fprintf(stderr, "Baseline produced incorrect output. Cannot proceed\n");
	  comb->done_comb = comb->max_comb;
	  return 0;
	}
      }
    }
    /*if this sequence is not executed, then we still need to roll back the
      changes made by this optimization sequence*/
    else{
      total_changes = get_num_changes(get_num_transforms());
      undo_changes(total_changes - comb->sequence_count);
      clear_all_links(top);
      set_function_name(fn);
    }

    /*get the dynamic and static performance counts*/
    if(comb->flags & CONTROL_FLOW_EXEC){

      if(new_cf && (execute_status & SIMULATE))
	*d_measure = get_sim_counts(NULL);
      if(execute_status & EASE){
	if(new_cf)
	  read_ease_counts(func_cf);
	*d_measure = (long long)get_dy_ease_counts(func_cf, new_cf);
      }
    }
    else{

      if(execute_status & EXECUTE){
	
	/*open the configuration file which contains commands to
	  execute/simulate the program to generate performance measures*/ 
	sprintf(cmd, "%stest.config", pathname);
	if((fp = fopen(cmd, "r")) == NULL){
	  fprintf(stderr, "Unable to open file %s in get_perf_num\n", cmd);
	  return INFINITY;
	}
	setbuf(fp, fpbuff);

	/*read till we get the execute command, we then extract the execute
	  command*/
	base[0] = '\0';
	fgets(line, MAXSTRING, fp);
	while(!(feof(fp))){
	  if( (i = sscanf(line, "execute command: %[^\n]\n", base)) == 1)
	    break;
	  fgets(line, MAXSTRING, fp);      
	}
	fclose(fp);

	/*get the base name of the count file. This is used to generate
	  genreport files and also to get dynamic counts manually if
	  genreport fails*/ 
	if(base[0] != '\0'){
	  for(i=strlen(base)-1 ; i>0 && base[i]!='.' ; i--);
	  base[i] = '\0';
	}
	  
	/*get the static and dynamic counts for this function*/
	if(read_genreport(genreport_path, base, fn, s_measure, d_measure) == 0){
	  
	  *s_measure = save_smeasure;
	  /*get the dynamic instruction counts from count file directly*/
	  *d_measure = 0;
	  for(i=0, cblk=top ; cblk ; cblk=cblk->down)
	    *d_measure += ins_counts[i++] * cblk->frequency;
	}
	else if(comb->weight == 0){
	  
	  /*always determine the static code size by directly reading the RTLs*/
	  *s_measure = save_smeasure;
	}
      }
      else{
	/*if the program is to be simulated then we get measures using a
	  different script*/
	get_perf_file(line, base, SIMULATE);
	*d_measure = get_sim_counts(base);
	*s_measure = save_smeasure;
      }
    }

    /*for the baseline measurement, if the dynamic count is zero then we
      stop further executions of this function*/
    if(!seq && *d_measure==0)
      is_take_measure = FALSE;
    
    /*calculate the measures as a weighted sum of dynamic measurements and
      code size(assuming each instruction occupies 4 bytes)*/
    actual_count = (*d_measure*(comb->weight)/100) +
      (*s_measure*4*(100-comb->weight)/100);
  }
  else{
    actual_count = *s_measure * 4 * (100-comb->weight)/100;
    total_changes = get_num_changes(get_num_transforms());
    undo_changes(total_changes - comb->sequence_count);
    clear_all_links(top);
    set_function_name(fn);
  }
  
  valid_analysis = 0;    
  fprintf(stderr, "Actual count at start: %llu\n", actual_count);
  if(comb_log)
    fprintf(comb_log, "codesize: %llu, inscount: %llu, effective: %llu\n",
	    *s_measure, *d_measure, actual_count);
  else
    fprintf(stderr, "codesize: %llu, inscount: %llu, effective: %llu\n",
	    *s_measure, *d_measure, actual_count);
  
  return actual_count;
}


/* read_perf_num - the function has already been executed/simulated. We read
 *                 execute commands to generate the result files and read the
 *                 peformance numbers
 */
void read_perf_num(unsigned long long *s_measure,
		   unsigned long long *d_measure)
{
  int i;
  unsigned long long save_smeasure;
  char cmd[MAXSTRING], base[MAXSTRING], fpbuff[BUFSIZ], line[MAXSTRING];
  struct bblock *cblk;
  FILE *fp;
  extern char *fn, pathname[], genreport_path[];
  extern int execute_status;
  extern struct bblock *top;

  *s_measure = 0;
  *d_measure = 0;

  /*get the static code size*/
  for(cblk=top ; cblk ; cblk=cblk->down)
    *s_measure += getRTLCount(cblk);
  save_smeasure = *s_measure;

  /*open the configuration file which contains commands to execute/simulate
    the program to generate performance measures*/
  sprintf(cmd, "%stest.config", pathname);
  if((fp = fopen(cmd, "r")) == NULL){
    fprintf(stderr, "Unable to open file %s in get_perf_num\n", cmd);
    return;
  }
  setbuf(fp, fpbuff);
  
  /*read till we get the execute command, we then extract the execute
    command*/
  base[0] = '\0';
  fgets(line, MAXSTRING, fp);
  while(!(feof(fp))){
    if( (i = sscanf(line, "execute command: %[^\n]\n", base)) == 1)
      break;
    fgets(line, MAXSTRING, fp);      
  }
  fclose(fp);

  /*if we are executing the current program then these are the steps we
    need to follow*/
  if(execute_status & EXECUTE){
      
    /*get the base name of the count file. This is used to generate genreport
      files and also to get dynamic counts manually if genreport fails*/
    if(base[0] != '\0'){
      
      for(i=strlen(base)-1 ; i>0 && base[i]!='.' ; i--);
      base[i] = '\0';
    }
    
    /*get the static and dynamic counts for this function*/
    if(read_genreport(genreport_path, base, fn, s_measure, d_measure) == 0){
      
      *s_measure = save_smeasure;
      *d_measure = 0;
    }
  }
  else if(execute_status & SIMULATE){
    
    /*if the program is to be simulated then we get measures using a
      different script*/
    get_perf_file(line, base, SIMULATE);
    *d_measure = get_sim_counts(base);
    *s_measure = save_smeasure;
  }
  else{
    *d_measure = 0;
    *s_measure = save_smeasure;
  }
}


/*
 * read_genreport - generate and read the report file and get the counts for
 *                  the argument function name
 */
int read_genreport(char path[], char exec[], char *fn,
		    unsigned long long *s_measure,
		    unsigned long long *d_measure){

  char cmd[MAXSTRING], line[MAXSTRING], func[MAXSTRING];
  char fpbuff[BUFSIZ];
  int i;
  unsigned long long  ins, ref, call;
  FILE *fp;
  extern int execute_status;

  /*if processor is not the SPARC then the program cannot so executed and
    count file cannot be produced. In such a case return 0 and the calling
    procedure will count the static number of instructions in the function
    directly. This should be present in the test configuration file */
  if(!(execute_status & (EXECUTE|SIMULATE))){
      return 0;
  }
  
  /*run genreport and generate the reports*/
  sprintf(cmd, "%s -f %s > %s.drep", path, exec, exec);
  if(system(cmd))
    return 0;
  sprintf(cmd, "%s -sf %s > %s.srep", path, exec, exec);
  if(system(cmd))
    return 0;

  /*read the report file and get the dynamic measure for the argument
    function*/
  sprintf(cmd, "%s.drep", exec);
  if((fp = fopen(cmd, "r")) == NULL){
    fprintf(stderr, "Unable to open file: %s\n", cmd);
    return 0;
  }
  setbuf(fp, fpbuff);

  fgets(line, MAXSTRING, fp);
  while(!feof(fp)){
    if(strncmp(line, "function name", 13) == 0)
      break;
    fgets(line, MAXSTRING, fp);
  }
  fgets(line, MAXSTRING, fp);

  /*get to the required function*/
  while(!feof(fp)){
    
    if( (fscanf(fp, " %s %lld %lld %lld\n", func, &ins, &ref, &call) == 4) &&
	(strcmp(func, fn) == 0) ){
      *d_measure = ins;
      break;
    }
  }
  fclose(fp);

  /*read the report file and get the static measure for the argument
    function*/
  sprintf(cmd, "%s.srep", exec);
  if((fp = fopen(cmd, "r")) == NULL){
    fprintf(stderr, "Unable to open file: %s\n", cmd);
    return 0;
  }
  setbuf(fp, fpbuff);

  fgets(line, MAXSTRING, fp);
  while(!feof(fp)){
    if(strncmp(line, "function name", 13) == 0)
      break;
    fgets(line, MAXSTRING, fp);
  }
  fgets(line, MAXSTRING, fp);

  /*get to the required function*/
  while(!feof(fp)){
    
    if( (fscanf(fp, " %s %lld %lld %lld\n", func, &ins, &ref, &call) == 4) &&
	(strcmp(func, fn) == 0) ){
      *s_measure = ins;
      break;
    }
  }
  fclose(fp);
  return 1;
}  


/*
 * read_ease_counts - read the information about number of times each block
 *                    is executed from EASE produced .cnt file
 */
void read_ease_counts(struct CFList *cf)
{
  int found;
  int i, j, junk, num_eq, code, flen;
  long long dy_counts[MAX_BLOCKS], count;
  char str[MAXSTRING], filename[MAXSTRING], tfn[MAXSTRING];
  struct bblock *cblk;
  FILE *fp;
  struct BlockList *bl;
  extern struct bblock *top;
  extern char *fn;

  /*open the test.config file which contains commands useful during getting
    performance measures*/
  if((fp=fopen("test.config", "r")) == NULL){
    fprintf(stderr, "File test.config cannot be opened in read_ease_counts\n");
    exit(0);
  }

  /*get the filename of the EASE generated file*/
  fgets(str, MAXSTRING-1, fp);
  while(!(feof(fp))){
    if((sscanf(str, "EASE file: %s\n", filename)) == 1)
      break;
    fgets(str, MAXSTRING-1, fp);
  }
  fclose(fp);
  
  /*open the file generated by EASE*/
  if((fp=fopen(filename, "r")) == NULL){
    fprintf(stderr, "File %s cannot be opened in read_ease_counts\n", filename);
    exit(0);
  }

  /* Skip over the not taken counts */
  for (i = 0; i < NUMJREL; i++){
    fgets(str, MAXSTRING-1, fp);
    sscanf(str, "%d ", &junk);
  }

  /*loop till we reach the counts for the current function*/
  found = FALSE;
  flen = strlen(fn);
  fgets(str, MAXSTRING-1, fp);
  while(!feof(fp)){  
    
    /*skip over the line containing number of equivalence classes. For our case
      this number matches the number of basic blocks in the function*/
    if((sscanf(str, "-1 %d\n", &num_eq)) == 1){
      
      /*record the counts for this function. The function name appears at the
	end of these numbers*/
      for(i=0 ; i<num_eq ; i++){
	fscanf(fp, "%lld\n", &count);
	dy_counts[i] = count;
      }
    }
    else if((sscanf(str, "%s\n", tfn)) == 1){
      if(strcmp(tfn, fn) == 0){
	found = TRUE;
	break;
      }
    }
    fgets(str, MAXSTRING-1, fp);
  }
  
  /*there should be count present for each basic block*/
  if(found){
    count = 0;
    for(bl=cf->blist ; bl ; bl=bl->down){
      if(bl->rcount || bl->cycle)
	bl->exe_count = dy_counts[count++];
      else
	bl->exe_count = 0;
    }
  }
  
  /*if the number of blocks and the number of equivalence classes do not
    match then we have a problem*/
  if(count!=num_eq || !found){
    if(!found)
      fprintf(stderr, "Current function %s not found in file\n", fn);
    else
      fprintf(stderr, "Number of blocks do not match number of equivalence classes in %s file, EQ: %d Bocks: %lld\n", filename, num_eq, count);
  }
  fclose(fp);
}


/*
 * blk_empty - check if the block has RTLs
 */
int blk_empty(struct bblock *cblk)
{
  struct list *rtl;

  for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
    if(cnts(rtl))
      return FALSE;
  }
  return TRUE;
}


/*
 * read_options_from_file - Used only during debugging. Very limited support
 *                          provided for this feature. Instead of starting
 * the viewer and getting user clicks, only the compiler is started and
 * options are read from a file
 */
int read_options_from_file(char options[])
{
  char filename[] = "viewer_commands.txt";
  char buff[1001];
  int opt;
  static FILE *opt_fp= NULL;
  extern int swq_noviewer;

  if(!swq_noviewer){
    fprintf(stderr, "Function read_options_from_file reached when debugging mode not set \n");
    exit(0);
  }

  if(opt_fp == NULL){
    if((opt_fp = fopen(filename, "r")) == NULL){
      fprintf(stderr, "File %s cannot be opened in read_options_from_file\n",
	      filename);
      exit(0);
    }
  }

  fgets(options, 1000, opt_fp);

  if(!(feof(opt_fp))){

    /*if((sscanf(buff, "%d", &opt)) == 1){
      if(opt > 0)
	strcpy(options, "0 ");
      else
	options[0] = '\0';
      strcat(options, buff);
      if(options[strlen(options)-1] == '\n')
	options[strlen(options)-1] = '\0';
      strcat(options, " -1");
      }*/
  }
  else{
    sprintf(options, "%d -1", STOP_TRANS);
  }

  return (strlen(options));
}

/*
 * scan_numbers -
 */
void scan_numbers(int ph, char seq[], int flag)
{
  int i, j, en_ph;
  double times;
  int test_phases[30] = {0, 1, 0, 3, 4, 5, 6, 0, 8, 0, 10, 0, 0, 13, 14, 15, 16, 0, 0, 0, 0, 21, 0, 0, 0, 25, 0, 27, 0, 29};
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int denable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int ddisable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double dperf_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int dperf_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];

  for(i=0 ; i<30 ; i++){
    if(test_phases[i]){
      if((sscanf(seq, "%lf %[^\n]", &times, seq)) != 2)
	sscanf(seq, "lf", &times);
      
      if(times >= 0.0){
	if(flag == 1){
	  denable_phase[ph][i] += times;
	  denable_cnt[ph][i] += 1;
	}
	else if(flag == 2){
	  ddisable_phase[ph][i] += times;
	  ddisable_cnt[ph][i] += 1;
	}
	else if(flag == 3){
	  dperf_phase[ph][i] += times;
	  dperf_cnt[ph][i] += 1;
	}
      }
    }
  }
}

/*
 * populate_en_dis_tables - populate and initialize the enable/disable tables
 *                          for the current function
 */
void populate_en_dis_tables(struct comb_struct *comb)
{
  int i, j, count, flag, ph, act_start;
  long long perf;
  char cph, file[MAXSTRING], curr_fn[MAXSTRING], str[MAXSTRING];
  char seq[MAXSTRING], path[MAXSTRING], temp[MAXSTRING];
  FILE *fp, *nfp;
  extern int func_in_file;
  extern char basename[];
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int denable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int ddisable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double dperf_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int dperf_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES], basepath[];
  extern FILE *comb_log;

  /*construct the "enable" filename for the current function*/
  sprintf(curr_fn, "%s_dfs_enable_%d", basename, func_in_file);

  /*count the number of files scanned*/
  count = 0;

  /*open the file contaning the list of "enable" files*/
  if((nfp = fopen("enable_filelist", "r")) == NULL){
    fprintf(stderr, "File enable_filelist cannot be found\n");
    exit(0);
  }

  for(i=0 ; i<NUM_TRANS_TYPES ; i++){
    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
      denable_phase[i][j] = 0.0;
      ddisable_phase[i][j] = 0.0;
      denable_cnt[i][j] = 0;
      ddisable_cnt[i][j] = 0;
    }
  }

  /*scan all the enable files listed*/
  fgets(str, MAXSTRING, nfp);
  while(!feof(nfp)){

    if((sscanf(str, "Path: %s", path)) == 1){
    }
    else if((sscanf(str, "Benchmark: %s", temp)) == 1){
    }
    else if((sscanf(str, "File: %s %d", str, &i)) == 2){

      /*if(str[strlen(str)-1] == '\n')
	str[strlen(str)-1] = '\0';*/
      sprintf(file, "%s/%s_dfs_enable_%d", path, str, i);
      if((fp = fopen(file, "r")) == NULL){
	fprintf(stderr, "File %s cannot be opened\n", file);
	fgets(str, MAXSTRING, nfp);
	continue;
      }
      /*get average enabling/disabling information over all functions except
	the current function*/
      if(!((strcmp(str, basename)==0) && i==func_in_file)){

	flag = 0;
	fgets(str, MAXSTRING, fp);
	while(!feof(fp)){
	  if((sscanf(str, "Phases Active at Start: %d\n", &act_start)) == 1){
	    for(i=0 ; i<NUM_TRANS_TYPES ; i++){
	      if(act_start & (1 << i))
		denable_phase[0][i] += 100.0;
	      denable_cnt[0][i] += 1;
	    }
	  }
	  else if((strncmp(str, "Enabling stats", 13)) == 0)
	    flag = 1;
	  else if((strncmp(str, "Disabling stats", 14)) == 0)
	    flag = 2;
	  else if((strncmp(str, "Independence stats", 14)) == 0)
	    flag = 4;
	  else if((strncmp(str, "Performance comparison stats", 28)) == 0)
	    flag = 3;
	  else if((strncmp(str, "Merging stats", 13)) == 0){
	    flag = 0;
	  }
	  else if((strncmp(str, "Sequence: ", 10)) == 0){
	  }
	  else if((strncmp(str, "Codesize: ", 10)) == 0){
	  }
	  else if(str[0]>='A' && str[0]<='Z'){
	  }
	  else if(flag && (sscanf(str, "%c %[^\n]", &cph, seq)) == 2){
	    if(ph = get_phase_index(cph))
	      scan_numbers(ph, seq, flag);
	  }
	  else
	    flag = 0;

	  fgets(str, MAXSTRING, fp);
	}
	count++;
      }
#if STD_DEV      
      else if (!(strcmp(str, basename)==0) && i==func_in_file)
	strcpy(basepath, path);
#endif      
	
      /*for the current function get information regarding the minimum and
	maximum performance measures to use for search terminating
	condition*/ 
      else if(comb){
	fgets(str, MAXSTRING, fp);
	while(!feof(fp)){
	  if((sscanf(str, "Minimum Codesize: %lld", &perf)) == 1)
	    comb->term_smeasure = perf;
	  else if((sscanf(str, "Minimum Dy. Count: %lld", &perf)) == 1){
	    comb->term_dmeasure = perf;
	    fprintf(comb_log, "Optimal Count: %lld\n", perf);
	  }
	  fgets(str, MAXSTRING, fp);
	}
      }
      fclose(fp); 
    }
    fgets(str, MAXSTRING, nfp);
  }
  fclose(nfp);

  /*calculate average counts*/
  for(i=0 ; i<NUM_TRANS_TYPES ; i++){
    for(j=0 ; j<NUM_TRANS_TYPES ; j++){
      if(denable_cnt[i][j])
	denable_phase[i][j] = (double)((double)denable_phase[i][j] /
				       (double)denable_cnt[i][j])/100.0;
      if(ddisable_cnt[i][j])	
	ddisable_phase[i][j] = (double)((double)ddisable_phase[i][j] /
					(double)ddisable_cnt[i][j])/100.0;
      if(dperf_cnt[i][j])
	dperf_phase[i][j] = (double)((double)dperf_phase[i][j]/
				     (double)dperf_cnt[i][j]);
    }
  }
#if STD_DEV
  store_as_cex(list_cex_files[1], 0, FALSE);
#endif  
#if PH_CONTEXT
  calc_pcon(0);
   #if PH_ALL_PATHS  
     init_ph_paths();
     /*store the un-optimized function instance so that multiple path
       compilations can be supported. Position 0 in list_cex_files is used in
       this algorithm to roll-back after unwarranted RA effects. So we use
       index 1 */
     store_as_cex(list_cex_files[1], 0, FALSE);
   #endif  
#endif  
#if PH_CONTEXT1
  calc_pcon(0);
#endif
}


#if PH_CONTEXT || PH_CONTEXT1
/*
 * new_pcon_node - creates and initializes a new node
 */
struct PH_CON *new_pcon_node(int context)
{
  int i, j;
  struct PH_CON *new;

  new = (struct PH_CON*)myalloc_prob(sizeof(struct PH_CON));
  new->context = context;
  new->flag = FALSE;
  
#if PH_CONTEXT
  for(i=0 ; i<ACTPHASES ; i++){
    new->opt[i] = 0.0;
    new->seen[i] = 0;
    new->fn_active[i] = 0.0;
    new->degrade[i] = 0.0;
  }
#if PH_ALL_PATHS  
  new->pind = new->cind = 0;
#endif  
#elif PH_CONTEXT1  
  for(i=0 ; i<ACTPHASES ; i++){
    for(j=0 ; j<ACTPHASES ; j++){
      new->better[i][j] = 0.0;
      new->seen[i][j] = 0;
    }
  }
#endif  
  new->next = NULL;

  return new;
}

/*
 * update_pcon_list - add a new node to a pcon list
 */
void update_pcon_list(struct PH_CON *pnode)
{
  int hash;
  extern struct PH_CON *pcon[PINDEX+1];

  hash = pnode->context % PINDEX;
  pnode->next = pcon[hash];
  pcon[hash] = pnode;
}

/*
 * find_pcon_node - find and return a pointer to an existing pcon node
 */
struct PH_CON *find_pcon_node(int context)
{
  int hash;
  struct PH_CON *pnode;
  extern struct PH_CON *pcon[];

  hash = context % PINDEX;
  for(pnode=pcon[hash] ; pnode ; pnode=pnode->next){
    if(pnode->context == context)
      break;
  }
  return pnode;
}
#endif /*PH_CONTEXT||PH_CONTEXT1*/


#if PH_CONTEXT
/*
 * calc_pcon - calculate average probability of a phase reaching optimal given
 *             the context of the optimizations performed before it
 */
void calc_pcon(int nread)
{
  char str[MAXSTRING], fname[MAXSTRING], base[MAXSTRING], path[MAXSTRING];
  int i, j, k, context, fnum, ph, count, tot_fn;
  double percent, prob, deg;
  FILE *efp, *fp;
  struct PH_CON *ptr;
  extern int func_in_file;
  extern char basename[], basepath[];
  extern int ph_pos[], rev_ph_pos[];
  extern int fn_found;
  extern struct PH_CON *pcon[PINDEX+1];
  extern struct loopl *loops;
  
  /*initialize*/
  tot_fn = 0;
  for(i=0 ; i<=PINDEX ; i++)
    pcon[i] = NULL;
  fn_found = FALSE;

#if STD_DEV
  /*open the file containing names of all executed functions*/
  sprintf(fname, "%s/%s_dev_%d.txt", basepath, basename, func_in_file);
  if((efp = fopen(fname, "r")) == NULL){
    fprintf(stderr, "File %s not found\n", fname);
    fn_found = FALSE;
    return;
  }

  /*do not consider this function's measure during its analysis*/
  i = 0;
  if(nread > 1){
    fgets(str, MAXSTRING, efp);
    i = 1;
  }

  /*read specified number of functions from this file*/
  for(; i<nread ; i++){
    
    fgets(str, MAXSTRING, efp);
    sscanf(str, "%s", path);

    if((fp = fopen(path, "r")) == NULL){
      fprintf(stderr, "File %s cannot be found\n", path);
    }
    else{
      fgets(str, MAXSTRING, fp);
      while(!feof(fp)){
	if((sscanf(str, "Context: %d\n", &context)) == 1){
	  if((ptr = find_pcon_node(context)) == NULL){
	    ptr = new_pcon_node(context);
	    update_pcon_list(ptr);
	  }
	}
	else if((sscanf(str, "Phase: %d Prob: %lf Degrade: %lf\n",
			&j, &prob, &deg)) == 3){
	  ph = ph_pos[j];
	  deg = deg - 100.0;
	  ptr->opt[ph] += prob;
	  ptr->seen[ph] += 1;
	  if(prob > 0.0 && deg == 0.0)
	    ptr->fn_active[ph] += 1.0;
	  if(deg > ptr->degrade[ph])
	    ptr->degrade[ph] = deg;
	}
	fgets(str, MAXSTRING, fp);
      }
      fclose(fp);
      tot_fn++;
    }
  }
  fclose(efp);
  fn_found = TRUE;
#else  
  /*open the file containing names of all executed functions*/
  if((efp = fopen("exec_filelist", "r")) == NULL){
    fprintf(stderr, "File exec_filelist not found\n");
    exit(0);
  }
  fgets(str, MAXSTRING, efp);
  while(!feof(efp)){
    if((sscanf(str, "Path: %s\n", path)) == 1){
    }
    else if((sscanf(str, "File: %s %d", base, &fnum)) == 2){
      if(!((strcmp(base, basename)==0) && fnum==func_in_file)){

	sprintf(fname, "%s/%s_pcon_goodpath_%d.txt", path, base, fnum, ph);
	if((fp = fopen(fname, "r")) == NULL){
	  fprintf(stderr, "File %s cannot be found\n", fname);
	}
	else{
	  fgets(str, MAXSTRING, fp);
	  while(!feof(fp)){
	    if((sscanf(str, "Context: %d\n", &context)) == 1){
	      if((ptr = find_pcon_node(context)) == NULL){
		ptr = new_pcon_node(context);
		update_pcon_list(ptr);
	      }
	    }
	    else if((sscanf(str, "Phase: %d Prob: %lf Degrade: %lf\n",
			    &j, &prob, &deg)) == 3){
	      ph = ph_pos[j];
	      deg = deg - 100.0;
	      ptr->opt[ph] += prob;
	      ptr->seen[ph] += 1;
	      if(prob > 0.0 /*&& deg == 0.0*/)
		ptr->fn_active[ph] += 1.0;
	      if(deg > ptr->degrade[ph])
		ptr->degrade[ph] = deg;
	    }
	    fgets(str, MAXSTRING, fp);
	  }
	  fclose(fp);
	  tot_fn++;
	}
      }
      else{
	/*indicate the current function as being present in the executed list
	  of functions*/
	fn_found = TRUE;
      }
    }
    fgets(str, MAXSTRING, efp);
  }
  fclose(efp);
#endif /*STD_DEV*/
  
  /*calculate out the average information over all executed functions*/
  /*for(i=0 ; i<=PINDEX ; i++){
    for(ptr=pcon[i] ; ptr ; ptr=ptr->next){
      for(j=0 ; j<ACTPHASES ; j++){
	ptr->opt[j] = ptr->opt[j] / (double)tot_fn;
	if(ptr->seen[j])
	  ptr->fn_active[j] = ptr->fn_active[j] / ptr->seen[j];
      }
    }
  }*/
}

#if PH_ALL_PATHS
/*
 * init_ph_paths - initialize the minimum phases that provide optimal paths
 *                 after each context
 */
void init_ph_paths()
{
  int i, j, ph;
  struct PH_CON *ptr;
  extern int ph_pos[];

  /*statically initialize the structures for now. If needed then this
    function can be changed to initialize all contexts from a file*/
  ptr = find_pcon_node(0);
  ptr->paths[0] = 10;
  ptr->paths[1] = 8;
  ptr->paths[2] = 16;
  ptr->pind = 3;

  ptr = find_pcon_node(1<<ph_pos[10]);
  ptr->paths[0] = 8;
  ptr->paths[1] = 5;
  ptr->paths[2] = 1;
  ptr->pind = 3;

  ptr = find_pcon_node(1<<ph_pos[8]);
  ptr->paths[0] = 1;
  ptr->paths[1] = 15;
  ptr->paths[2] = 10;
  ptr->paths[3] = 14;
  ptr->pind = 4;

  ptr= find_pcon_node(1<<ph_pos[16]);
  ptr->paths[0] = 8;
  ptr->paths[1] = 1;
  ptr->paths[2] = 14;
  ptr->pind = 3;
}
#endif
#endif /*PH_CONTEXT*/


#if PH_CONTEXT1
/*
 * parse_pcon_lines - parse information for each context
 */
void parse_pcon_lines(struct PH_CON *ptr, FILE *fp)
{
  char *ch, str[MAXSTRING];
  int i, j, k, ph;
  double val;

  for(ph=0 ; ph<ACTPHASES ; ph++){
    fgets(str, MAXSTRING, fp);
    ch = str;
    for(i=0 ; i<ACTPHASES ; i++){

      /*skip past any spaces*/
      while(*ch == ' ')
	ch++;
      val = atof(ch);
      if(val >= 0.0){
	ptr->better[ph][i] += val;
	ptr->seen[ph][i] += 1;
      }

      /*skip past this value*/
      while(!(*ch==' ' || *ch=='\0'))
	ch++;
    }
  }
}

/*
 * calc_pcon - calculate average probability of a phase reaching optimal given
 *             the context of the optimizations performed before it
 */
void calc_pcon(int t)
{
  char str[MAXSTRING], fname[MAXSTRING], base[MAXSTRING], path[MAXSTRING];
  int i, j, k, context, fnum, ph, count;
  double percent, prob;
  FILE *efp, *fp;
  struct PH_CON *ptr;
  extern int func_in_file;
  extern int fn_found;
  extern char basename[];
  extern struct PH_CON *pcon[PINDEX+1];

  /*initialize the variables*/
  for(i=0 ; i<=PINDEX ; i++)
    pcon[i] = NULL;

  /*open the file containing names of all executed functions*/
  if((efp = fopen("exec_filelist", "r")) == NULL){
    fprintf(stderr, "File exec_filelist not found\n");
    exit(0);
  }
  fgets(str, MAXSTRING, efp);
  while(!feof(efp)){
    if((sscanf(str, "Path: %s\n", path)) == 1){
    }
    else if((sscanf(str, "File: %s %d", base, &fnum)) == 2){
      if(!((strcmp(base, basename)==0) && fnum==func_in_file)){
	
	sprintf(fname, "%s/%s_pcon_%d.txt", path, base, fnum);
	if((fp = fopen(fname, "r")) == NULL){
	  fprintf(stderr, "File %s cannot be opened\n", fname);
	}
	else{
	  fgets(str, MAXSTRING, fp);
	  while(!feof(fp)){
	    if((sscanf(str, "Context: %d\n", &context)) == 1){
	      if((ptr = find_pcon_node(context)) == NULL){
		ptr = new_pcon_node(context);
		update_pcon_list(ptr);
	      }
	      parse_pcon_lines(ptr, fp);
	    }
	    fgets(str, MAXSTRING, fp);
	  }
	  fclose(fp);
	}
      }
      else{
	/*indicate the current function as being present in the executed list
	  of functions*/
	fn_found = TRUE;
      }
    }
    fgets(str, MAXSTRING, efp);
  }
  fclose(efp);

  /*average out all the information*/
  for(i=0 ; i<=PINDEX ; i++){
    for(ptr=pcon[i] ; ptr ; ptr=ptr->next){
      for(j=0 ; j<ACTPHASES ; j++){
	for(k=0 ; k<ACTPHASES ; k++){
	  if(ptr->seen[j][k])
	    ptr->better[j][k] = ptr->better[j][k] / ptr->seen[j][k];
	}
      }
    }
  }
}
#endif


/*
 * init_hashtables - initialize the hash tables and related pointers and
 *                   indexes used during a Sel... Comb
 */
void init_hashtables(struct comb_struct *comb)
{
  int i, dummy_phases[5];
  unsigned long long s_measure, d_measure;
  struct Func_hash *func_node;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];
  extern unsigned int ind_phase[NUM_TRANS_TYPES];
  extern struct HASHTABLE *htable[NUM_HTABLE_ELEMENTS];
  extern struct HASHTABLE *succ_htable[NUM_HTABLE_ELEMENTS];
  extern struct RTL_hash *rtl_hash[RTL_HASH], *remap_rtl[RTL_HASH];
  extern struct Func_hash *func_hash[FUNC_HASH], *remap_func[FUNC_HASH];
  extern struct tree_struct *tree;
  extern unsigned int tree_ptr;
#ifdef DEOPT
  extern rlist no_replace_regs;
#endif
  
  /*hashtable for comparing optimization sequences before
    applying to the function. In our search options, only
    INTELLIGENT SEARCH can repeat optimization seq*/
  if(comb->search_option == INTELLIGENT_SEARCH){
    for(i=0 ; i<NUM_HTABLE_ELEMENTS ; i++)
      htable[i] = NULL;
  }
  
  /*hashtable to compare only the list of successful
    phases. If equal, no need for measurements*/
  if(comb->flags & SUCC_HTABLE){
    for(i=0 ; i<NUM_HTABLE_ELEMENTS ; i++)
      succ_htable[i] = NULL;
  }

#if 0  
  /*hashtable to search for common RTLs*/
  for(i=0 ; i<RTL_HASH ; i++){
    rtl_hash[i] = NULL;
    remap_rtl[i] = NULL;
  }
#endif
  
  /*hashtable to search for common function instances*/
  for(i=0 ; i<FUNC_HASH ; i++){
    func_hash[i] = NULL;
    remap_func[i] = NULL;
  }

  if(comb->flags & (TREE_SEARCH | ENABLE_PHASE | FUNC_CHECKS)){
  
    /*allocate space and initialize the tree structure*/
    tree = (struct tree_struct*)myalloc_comb(sizeof(struct tree_struct) * NUM_TREE_NODES);
    
    /*opt[i]=UNSEEN: indicates that the corresponding opt. at this position has not
                     yet been seen
      opt[i]=UNSUCC: indicates that the opt. was unsuccessful
    */
    for(i=0 ; i<NUM_TRANS_TYPES ; i++)
      tree[START_NODE].opt[i] = UNSUCC;
    tree[START_NODE].s_measure = tree[START_NODE].d_measure = 0;
    
    /*currently, for the first node all user-selected phases, which can be
      successfully applied are enabled*/
    tree[START_NODE].no_succ_phases = 0;
    for(i=0 ; i<comb->no_comb ; i++){
      if(!(comb->opt_mask & (1 << comb->base_opt[i]))){
	tree[START_NODE].opt[comb->base_opt[i]] = UNSEEN;
	tree[START_NODE].no_succ_phases++;
      }
    }

    /*get a new function node for the base function instance, with no
      optimizations applied*/
    if(comb->flags & FUNC_CHECKS){
      check_func_instance(&s_measure, &d_measure, &func_node, dummy_phases, 0, FALSE, 0);
      tree[START_NODE].s_measure = comb->base_smeasure;
      tree[START_NODE].d_measure = comb->base_dmeasure;
      if(func_node)
	func_node->tree_node = START_NODE;
      tree[START_NODE].func_node = func_node;
    }
    
    tree_ptr = START_NODE + 1;
  }

  /*initialize the probabilistic enable and disable tables*/
  populate_en_dis_tables(comb);

  if(comb->flags & SANITY ||
     comb->flags & (REPEAT_SAME_PHASE|ENABLE_PHASE|SORT_PHASES)){

    /*initialize the phases which can potentially enable a phase*/
    for(i=0 ; i<NUM_TRANS_TYPES ; i++)
      enable_phase[i] = ~(0);

    enable_phase[BRANCH_CHAINING_TRANS] &=
      ~(INST_SELECT_BIT | REG_ALLOCATION_BIT | STRENGTH_REDUCT_BIT | BRANCH_CHAINING_BIT |
	DEAD_CODE_ELIM_BIT | REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[ELIM_EMPTY_BLOCKS_TRANS] &=
      ~(MERGE_BLOCKS_BIT | REG_ALLOCATION_BIT | STRENGTH_REDUCT_BIT |
	DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT | REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT |
	EVAL_ORDER_DETER_BIT |INST_SELECT_BIT | MINIMIZE_LOOP_JUMPS_BIT);
    enable_phase[USELESS_JUMP_ELIM_TRANS] &=
      ~(INST_SELECT_BIT | DEAD_ASG_ELIM_BIT | REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT |
	USELESS_JUMP_ELIM_BIT | STRENGTH_REDUCT_BIT | DEAD_CODE_ELIM_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[DEAD_CODE_ELIM_TRANS] &=
      ~(INST_SELECT_BIT | MINIMIZE_LOOP_JUMPS_BIT | MERGE_BLOCKS_BIT | REG_ALLOCATION_BIT |
	COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT | USELESS_JUMP_ELIM_BIT | STRENGTH_REDUCT_BIT |
	DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT | REVERSE_BRANCHES_BIT |
	BLOCK_REORDERING_BIT | EVAL_ORDER_DETER_BIT | DEAD_ASG_ELIM_BIT);
    enable_phase[REVERSE_BRANCHES_TRANS] &=
      ~(INST_SELECT_BIT | REG_ALLOCATION_BIT | STRENGTH_REDUCT_BIT |
	DEAD_CODE_ELIM_BIT | REVERSE_BRANCHES_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[BLOCK_REORDERING_TRANS] &=
      ~(INST_SELECT_BIT | MERGE_BLOCKS_BIT | DEAD_ASG_ELIM_BIT | REG_ALLOCATION_BIT |
	COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT | DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT |
	REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[MERGE_BLOCKS_TRANS] &=
      ~(INST_SELECT_BIT | MERGE_BLOCKS_BIT | DEAD_ASG_ELIM_BIT | REG_ALLOCATION_BIT |
	COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT | DEAD_CODE_ELIM_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[INST_SELECT_TRANS] &=
      ~(INST_SELECT_BIT | BRANCH_CHAINING_BIT | DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT |
	REVERSE_BRANCHES_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[MINIMIZE_LOOP_JUMPS_TRANS] &=
      ~(INST_SELECT_BIT | MINIMIZE_LOOP_JUMPS_BIT | REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT |
	STRENGTH_REDUCT_BIT | DEAD_CODE_ELIM_BIT |EVAL_ORDER_DETER_BIT |DEAD_ASG_ELIM_BIT);
    enable_phase[REG_ALLOCATION_TRANS] &=
      ~(REG_ALLOCATION_BIT | USELESS_JUMP_ELIM_BIT | BRANCH_CHAINING_BIT | DEAD_CODE_ELIM_BIT |
	ELIM_EMPTY_BLOCKS_BIT | REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | EVAL_ORDER_DETER_BIT);
    enable_phase[STRENGTH_REDUCT_TRANS] &=
      ~(DEAD_ASG_ELIM_BIT | USELESS_JUMP_ELIM_BIT | STRENGTH_REDUCT_BIT | BRANCH_CHAINING_BIT |
	DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT | REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT |
	MINIMIZE_LOOP_JUMPS_BIT | MERGE_BLOCKS_BIT | REG_ALLOCATION_BIT | EVAL_ORDER_DETER_BIT);
  }

  /*Phases which are not independant of each other i.e. phases which have the
    potential of enabling or disabling a particular phase.
    We found that merge_basic_blocks affects the way register assignment is
    performed. So, even though register assignment is not an optimizing
    phase, phases which affect register assignment cannot be allowed to be
    interchanges with it*/
  if(comb->flags & SORT_PHASES){
    for(i=0 ; i<NUM_TRANS_TYPES ; i++)
      ind_phase[i] = 0;

    ind_phase[BRANCH_CHAINING_TRANS] |= USELESS_JUMP_ELIM_BIT | DEAD_CODE_ELIM_BIT |
      REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | MERGE_BLOCKS_BIT |
      MINIMIZE_LOOP_JUMPS_BIT | DEAD_ASG_ELIM_BIT | COMMON_SUBEXPR_ELIM_BIT;
    ind_phase[ELIM_EMPTY_BLOCKS_TRANS] |= DEAD_CODE_ELIM_BIT | USELESS_JUMP_ELIM_BIT |
      REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | DEAD_ASG_ELIM_BIT |
      COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[USELESS_JUMP_ELIM_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | MERGE_BLOCKS_BIT | MINIMIZE_LOOP_JUMPS_BIT;
    ind_phase[DEAD_CODE_ELIM_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | MERGE_BLOCKS_BIT | REG_ALLOCATION_BIT |
      COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[REVERSE_BRANCHES_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      USELESS_JUMP_ELIM_BIT | DEAD_CODE_ELIM_BIT | BLOCK_REORDERING_BIT | MERGE_BLOCKS_BIT |
      MINIMIZE_LOOP_JUMPS_BIT | DEAD_ASG_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[BLOCK_REORDERING_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      USELESS_JUMP_ELIM_BIT | DEAD_CODE_ELIM_BIT | REVERSE_BRANCHES_BIT |
      MERGE_BLOCKS_BIT | MINIMIZE_LOOP_JUMPS_BIT;
    ind_phase[MERGE_BLOCKS_TRANS] |= BRANCH_CHAINING_BIT | USELESS_JUMP_ELIM_BIT |
      DEAD_CODE_ELIM_BIT | REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | INST_SELECT_BIT |
      EVAL_ORDER_DETER_BIT | REG_ASSIGNMENT_BIT | MINIMIZE_LOOP_JUMPS_BIT | REG_ALLOCATION_BIT |
      COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[INST_SELECT_TRANS] |= MERGE_BLOCKS_BIT | EVAL_ORDER_DETER_BIT |
      REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT | ALL_LOOP_BIT |
      DEAD_ASG_ELIM_BIT;
    ind_phase[EVAL_ORDER_DETER_TRANS] |= MERGE_BLOCKS_BIT | INST_SELECT_BIT | DEAD_ASG_ELIM_BIT |
      REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT;
    ind_phase[REG_ASSIGNMENT_TRANS] |= MERGE_BLOCKS_BIT | INST_SELECT_BIT;
    ind_phase[MINIMIZE_LOOP_JUMPS_TRANS] |= BRANCH_CHAINING_BIT | USELESS_JUMP_ELIM_BIT |
      REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT | REG_ASSIGNMENT_BIT | MERGE_BLOCKS_BIT |
      REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[DEAD_ASG_ELIM_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      REVERSE_BRANCHES_BIT | EVAL_ORDER_DETER_BIT | REG_ASSIGNMENT_BIT | REG_ALLOCATION_BIT |
      COMMON_SUBEXPR_ELIM_BIT | INST_SELECT_BIT | ALL_LOOP_BIT;
    ind_phase[REG_ALLOCATION_TRANS] |= DEAD_CODE_ELIM_BIT | MERGE_BLOCKS_BIT | INST_SELECT_BIT |
      REG_ASSIGNMENT_BIT | MINIMIZE_LOOP_JUMPS_BIT | DEAD_ASG_ELIM_BIT |
      COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT | ALL_LOOP_BIT | EVAL_ORDER_DETER_BIT;
    ind_phase[COMMON_SUBEXPR_ELIM_TRANS] |= BRANCH_CHAINING_BIT | ELIM_EMPTY_BLOCKS_BIT |
      DEAD_CODE_ELIM_BIT | MERGE_BLOCKS_BIT | INST_SELECT_BIT | EVAL_ORDER_DETER_BIT |
      REG_ASSIGNMENT_BIT | MINIMIZE_LOOP_JUMPS_BIT | DEAD_ASG_ELIM_BIT | REG_ALLOCATION_BIT |
      STRENGTH_REDUCT_BIT | ALL_LOOP_BIT;
    ind_phase[STRENGTH_REDUCT_TRANS] |= INST_SELECT_BIT | EVAL_ORDER_DETER_BIT |
      REG_ASSIGNMENT_BIT | REG_ALLOCATION_BIT | COMMON_SUBEXPR_ELIM_BIT | ALL_LOOP_BIT;
    ind_phase[ALL_LOOP_TRANS] |= ELIM_EMPTY_BLOCKS_BIT | DEAD_CODE_ELIM_BIT |
      REVERSE_BRANCHES_BIT | MERGE_BLOCKS_BIT | INST_SELECT_BIT | REG_ASSIGNMENT_BIT |
      REG_ALLOCATION_BIT | MINIMIZE_LOOP_JUMPS_BIT | DEAD_ASG_ELIM_BIT |
      COMMON_SUBEXPR_ELIM_BIT | STRENGTH_REDUCT_BIT;    
  }
}


/*
 * analyse_func - analyse the function during SEL...COMB to determine
 *                optimizations which are not possible on this
 *                function. Return an integer with those phases masked
 */
int analyse_func(int seq_count)
{
  int opt_mask, analysis, total_changes;
  int num_bb, is_jump, is_branch, is_loops, is_locals, is_jump_or_ret, is_ret;
  int num_rtls;
  struct bblock *cblk;
  struct list *crtl;
  extern char *fn;
  extern struct bblock *top;
  extern struct locuse *locs;
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];

  /*initialize all the flags*/
  num_bb = 0;           /*number of basic blocks in the function*/
  is_jump = FALSE;      /*true, if the function has jumps*/
  is_branch = FALSE;    /*true, if the function contains branches*/
  is_loops = FALSE;     /*true, if the function contains loops*/
  is_locals = FALSE;    /*true, if the function contains locals/parameters*/
  is_ret = FALSE;       /*true, if the last RTL in the function is a return*/
  is_jump_or_ret = FALSE;

  /*perform dead code elimination to provide for the case when a loop appears
    unstructured due to unreachable code*/
  analysis = needs_analysis[DEAD_CODE_ELIM_TRANS];
  do_needed_analysis(analysis);
  remv_unreachable_code(1);
  analysis = needs_analysis[ALL_LOOP_TRANS];
  do_needed_analysis(analysis);

  /*scan the basic block list*/
  for(cblk=top ; cblk ; cblk=cblk->down){

    /*find the natural loops in the function by locating the back edges in
      the control flow graph*/
    if(cblk->right && dominates(cblk->right, cblk) ||
       cblk->left && dominates(cblk->left, cblk)){
      is_loops = TRUE;
      break;
    }
  }

  /*undo the cahnges done by unreachable code elimination*/
  total_changes = get_num_changes(get_num_transforms());
  undo_changes(total_changes - seq_count);
  clear_all_links(top);
  set_function_name(fn);

  /*do remaining analysis after we undo the changes by unreachable code
    elimination*/
  for(cblk=top ; cblk ; cblk=cblk->down){

    /*if the last instruction in a block is a branch*/
    if(cblk->rtlend && cnts(cblk->rtlend) &&
       cblk->left && cblk->right && is_rjmp(cblk->rtlend->val))
	is_branch = TRUE;

    /*check if the block contains a jump*/
    if(cblk->left && !cblk->right && cblk->status & JUMP){
      /*JUMP flag is also set for returns. Check if the last statement in
	this block is a return*/
      for(crtl=cblk->rtlend ; crtl ; crtl=crtl->prev){
	if(cnts(crtl))
	  break;
      }
      if(crtl && !is_return(crtl->val)){
	is_jump = TRUE;
      }
      /*if this is the last block, then we can still phase out
	DEAD_CODE_ELIM*/
      if(cblk->down)
	is_jump_or_ret = TRUE;
    }

    /*if there are only two basic blocks, check if the second basic block
      contains only a return. Even for a simple function, the frontend
      inserts a label before the last return, so there are always 2 blocks,
      with the second block only containing a reutrn*/
    if(num_bb == 1){
      num_rtls = 0;
      for(crtl=cblk->rtls ; crtl ; crtl=crtl->next){
	if(cnts(crtl)){
	  num_rtls++;
	  is_ret = FALSE;
	  if(num_rtls > 1)
	    break;
	  
	  if(is_return(crtl->val))
	    is_ret = TRUE;
	}
      }
    }

    num_bb++;
  }
  
  /*check if locals are referenced in this function*/
  if(locs)
    is_locals = TRUE;
  
  /*based on the above analysis mask out the phases which could not be
    successfully attempted*/
  opt_mask = 0;

  /*if there are only 2 basic blocks, and the second block is just a return,
    and there are no jumps and branches, then we can nullify some phases*/
  if(num_bb == 2){
    if(!is_jump && !is_branch && is_ret)
    opt_mask |= BRANCH_CHAINING_BIT | USELESS_JUMP_ELIM_BIT | BLOCK_REORDERING_BIT |
      FIX_CONTROL_FLOW_BIT | DEAD_CODE_ELIM_BIT | ELIM_EMPTY_BLOCKS_BIT;
  }
  if(!is_jump){
    opt_mask |= REVERSE_BRANCHES_BIT | BLOCK_REORDERING_BIT;
    if(!is_loops)
      opt_mask |= BRANCH_CHAINING_BIT;
  }
  if(!is_jump_or_ret)
    opt_mask |= DEAD_CODE_ELIM_BIT;
  if(!is_branch)
    opt_mask |= REVERSE_BRANCHES_BIT;
  if(!is_loops)
    opt_mask |= MINIMIZE_LOOP_JUMPS_BIT | ALL_LOOP_BIT;
  if(!is_locals)
    opt_mask |= REG_ALLOCATION_BIT;

  return opt_mask;
}

/*
 * is_same_func - check if this function instance is the same as some
 *                previously encountered instance during SEL...COMB
 */
int is_same_func(int *v_analysis, unsigned long long *s_measure,
		 unsigned long long *d_measure, struct Func_hash **ret_index,
		 struct Func_hash **remap_f, int succ_phases[], int succ_num,
		 int is_fn_check, int is_remap_check)
{
  int status;
  struct bblock *cblk;
  struct list *rtl;
  extern struct bblock *top;
  extern int resume_mode;

  status = 0;

  /*first check if the function instance is the same without remapping
    registers*/
  if(is_fn_check){
    *ret_index = NULL;
    status = check_func_instance(s_measure, d_measure, ret_index,
				 succ_phases, succ_num, FALSE, 0);
  }

  
#ifdef DEOPT

  /*if the function instances are not the same then remap registers and check
    again*/
  if(is_remap_check && !status){

    /*if we are reading performance counts from file, then we do not need to
      instrument function*/
    if(!resume_mode)
      *remap_f = NULL;
    
    status = check_func_instance(s_measure, d_measure, remap_f,
				 succ_phases, succ_num, TRUE, v_analysis);

    if(status){
      (*ret_index)->s_measure = *s_measure;
      (*ret_index)->d_measure = *d_measure;
      status = 2;
    }
  }
#endif /*DEOPT*/
  
  return status;
}


/*
 * check_func_instance - determine if current function instance is identical
 *                       to that produced by some other sequence
 */
int check_func_instance(unsigned long long *s_measure,
			unsigned long long *d_measure, struct Func_hash **ret_index,
			int succ_phases[], int succ_num, int is_remap, int *analysis)
{
  unsigned int f_hashvalue, hvalue;
  unsigned int CRC_reg;
  int i, rtl_count, index, status, p_index, hcount;
  FILE *fp;
  struct bblock *cblk;
  struct RTL_hash *p_loc, *c_loc;
  struct Func_hash *fptr, *prev_fptr, *new;
  extern int pptr_rtl;
  extern int remap_label_num, label_table[MAX_LABELS];
  extern int remap_cex_label_num, cex_label_table[MAX_CEX_LABELS];
  extern struct bblock *top;
  extern struct Func_hash *func_hash[FUNC_HASH], *remap_func[FUNC_HASH];
  extern struct RTL_hash *rtl_hash[RTL_HASH];
  extern struct RTL_hash *rtl_ptr[MAX_RTL];
  extern struct RTL_hash *remap_rtl[RTL_HASH];
  extern char basename[];
  extern FILE *comb_log;
  extern int resume_mode;

  /*if we are resuming execution, then read relevant variable values from
    file*/
  if(resume_mode){
    resume_hashvalues(&f_hashvalue, &CRC_reg, &rtl_count, is_remap);
  }
  else{
    
    /*initialize variables*/
    pptr_rtl = 0;

    /*get the hashvalues for this function instance*/
    rtl_count = get_func_hash(&f_hashvalue, &CRC_reg, is_remap, analysis);
    
    /*store the hashvalues for the current function to file*/
    log_hashvalues(f_hashvalue, CRC_reg, rtl_count, is_remap);
    
  } /*end if(resume_mode)*/
  
  hvalue = f_hashvalue & (FUNC_HASH - 1);
  
  /*compare to check if this function has been encountered before*/
  if(is_remap)
    fptr = remap_func[hvalue];
  else
    fptr = func_hash[hvalue];
  hcount = 0;
  /*if there exists an earlier function with same hash value check all
    records at this hash value bucket*/
  while(fptr){
    i = 0;
    
    /*comapre all RTLs in the 2 functions. We only need to check the
      pointers to the RTLs in the 2 functions*/
    if(fptr->hashvalue==f_hashvalue && fptr->num_rtls==rtl_count &&
       fptr->CRC_hash==CRC_reg){
      
      /*************************
	not checking if RTLs match
      **************************/
      break;
#if 0	
	
      /*construct the RTL filename for this hash value*/
      if(is_remap)
	sprintf(filename, "remap_%s%d_%d.prtl", basename, hvalue, hcount);
      else
	sprintf(filename, "%s%d_%d.prtl", basename, hvalue, hcount);
      
      /*if present open the file containing RTL pointers for all functions at
	this hash value*/
      if( (fp = fopen(filename, "r")) == NULL)
	fprintf(stderr, "File %s cannot be opened for reading\n", filename);
      else{
	setbuf(fp, filebuf);
	
	/*comapre all RTLs*/
	for(; i<rtl_count ; i++){
	  
	  /*get the locations of the two RTLs*/
	  fscanf(fp, "%u ", &c_loc);
	  p_loc = (struct RTL_hash*)rtl_ptr[i];
	  if(c_loc != p_loc){
	    fprintf(stderr, "Hash values match, function mis-match\n");
	    break;
	  }
	}
	/*close the RTL file*/
	fclose(fp);
      }
#endif	
    }

    /*if the 2 functions are different then check the current func
      instance with the next function in hash table*/
    if(i < rtl_count){
      fptr = fptr->next_func;
      hcount++;
    }
    else
      break;
  }

  /*if there exists a previous function instance similar to the current
    instance then there is no need to collect execution measures for this
    instance*/
  if(fptr){
    *s_measure = fptr->s_measure;
    *d_measure = fptr->d_measure;
    *ret_index = (struct Func_hash *)fptr;
    
    /***** analysis ******/
    if(!resume_mode){
      fprintf(comb_log, "Current succ seq: ");
      for(i=0 ; i<succ_num ; i++)
	fprintf(comb_log, "%d ", succ_phases[i]);
      fprintf(comb_log, "\nMatched succ seq: ");
      for(i=0 ; i<fptr->succ_num ; i++)
	fprintf(comb_log, "%d ", fptr->succ_phases[i]);
      fprintf(comb_log, "\n");
    }
    else{
      /*read in the two lines from the log file*/
      char str[MAXSTRING];
      fgets(str, MAXSTRING-1, comb_log);
      fgets(str, MAXSTRING-1, comb_log);
    }
    /*******************/

    return 1;
  }

  /*if there is no previous function instance similar to current, then insert
    instance in hash table*/
  
  /*create a new function hashtable instance*/
  new = (struct Func_hash *)myalloc_comb(sizeof(struct Func_hash));
  new->hashvalue = f_hashvalue;
  new->CRC_hash = CRC_reg;
  new->num_rtls = rtl_count;
  new->next_func = NULL;
  new->s_measure = 0;
  *ret_index = (struct Func_hash *)new;
  
  /*insert this record in the right hashtable bucket*/
  hcount = 0;
  if(is_remap && remap_func[hvalue] == NULL)
    remap_func[hvalue] = new;
  else if(!is_remap && func_hash[hvalue] == NULL)
    func_hash[hvalue] = new;
  else{
    if(is_remap)
      prev_fptr = remap_func[hvalue];
    else
      prev_fptr = func_hash[hvalue];
    fptr = prev_fptr->next_func;
    hcount++;
    while(fptr){
      prev_fptr = fptr;
      fptr = fptr->next_func;
      hcount++;
    }
    prev_fptr->next_func = new;
  }

  /****** for analysis ******/
  for(i=0 ; i<succ_num ; i++)
    new->succ_phases[i] = succ_phases[i];
  new->succ_num = succ_num;
  /***********/

  /*************************
  not checking if RTLs match
  **************************/
  return 0;

#if 0  
  /*store all RTL pointers for this function instance in the proper .prtl
    file*/

  /*construct the RTL filename for this hash value*/
  if(is_remap)
    sprintf(filename, "remap_%s%d_%d.prtl", basename, hvalue, hcount);
  else
    sprintf(filename, "%s%d_%d.prtl", basename, hvalue, hcount);
  
  /*open the RTL file for writing*/
  if( (fp = fopen(filename, "w")) == NULL)
    fprintf(stderr, "File %s cannot be opened for writing\n", filename);
  else{
    setbuf(fp, filebuf);
    for(i=0 ; i<rtl_count ; i++)
      fprintf(fp, "%u ", (struct RTL_hash *)rtl_ptr[i]);
    fclose(fp);
  }
  
  /*need to take measurements*/
  return 0;
#endif
}


/*
 * check_rtl_instance - determine if the current RTL has been encountered
 *                      before. If not then insert it
 */
int check_rtl_instance(struct list *rtl, unsigned int *hashvalue,
		       unsigned int *CRC_reg, int pos, int is_remap)
{
  unsigned int hvalue, CRC_index;
  int index, p_index;
  char *ptr, rtlval[MAXSTRING];
  struct RTL_hash *rptr, *prev_rptr, *new;
  extern int pptr_rtl, rtl_debug;
  extern FILE *crc_fp;
  extern struct RTL_hash *rtl_hash[RTL_HASH];
  extern struct RTL_hash *rtl_ptr[MAX_RTL];
  extern struct RTL_hash *remap_rtl[RTL_HASH];

  /*copy the RTL val, mapping the label, if present*/
  /*rtlval = strcpy((char*)CALLOC(strlen(rtl->val)+100), rtl->val);*/
  strcpy(rtlval, rtl->val);

  /*labels can only occur in conditional/unconditional jumps*/
  if(is_pc(rtlval)){
    for(ptr=rtlval ; ptr && *ptr ; ptr++){
      if(*ptr=='L' && (ptr+1) && *(ptr+1)>='0' && *(ptr+1)<='9')
	remap_label2(rtl, rtlval, ptr);
    }
  }

#ifdef DEOPT
  /*get the remapped rtl, if so specified*/
  if(is_remap){
    get_remapped_rtl(rtl, rtlval, is_remap);
  }
#endif  
  
  /*find the sum hashvalue and CRC hashvalue of this RTL*/
  *hashvalue = 0;
  for(ptr=rtlval ; ptr && *ptr!='\0'; ptr++){

    /*for CRC-32 the mask is 32 bit and we shift by 24 bits*/ 
    CRC_index = (*CRC_reg & CRC32_MASK) >> CRC32_SHIFT;
    /*remove the top byte in the register which is used for indexing into the
      static CRC table*/
    *CRC_reg = *CRC_reg << 8;
    *CRC_reg = *CRC_reg ^ (unsigned int)*ptr;
    *CRC_reg = *CRC_reg ^ CRC32Table[CRC_index];
    *hashvalue += *ptr + pos;
  }
  if(rtl_debug){
    fprintf(crc_fp, "%u %u ", *CRC_reg, *hashvalue);
    show_rtl(crc_fp, rtlval);
    fprintf(crc_fp, "\n");
  }

#if 0
  /*check for boundary conditions*/
  if(pptr_rtl+1 >= MAX_RTL)
    fprintf(stderr, "RTL pointer table overflow\n");

  /*This is the code which compares if the current RTL has been seen
    before. It stores all distinct instances of the RTLs. Earlier in the
    implementation, if the hasvalues of two functions matched, we verified if
    the RTLs are infact the same by comparing the pointers to all the stored
    RTLs. These pointers to RTLs were stored in files with the extension
    ".prtl". Since then, to reduce the time overhead we have changed the
    implementation to deduce that functions are same only after comparing the
    hashvalues and we no longer compare indivisual RTLs. All this code is
    enclosed in #if 0....#endif*/
  hvalue = *hashvalue & (RTL_HASH - 1);

  prev_rptr = NULL;
  if(is_remap)
    rptr = remap_rtl[hvalue];
  else
    rptr = rtl_hash[hvalue];
  while(rptr){
    
    /*if similar RTL already exists*/
    if(rptr->hashvalue==*hashvalue && !(strcmp(rptr->rtl, rtlval)) )
      break;

    /*compare next RTL having same hash value*/
    prev_rptr = rptr;
    rptr = rptr->next_rtl; 
  }

  /*if similar RTL is not found, make a new record for it in the hash table
    in the appropriate bucket*/
  if(rptr == NULL){

    /*make a new record in hash table*/
    new = (struct RTL_hash *)myalloc_comb(sizeof(struct RTL_hash));
    new->hashvalue = *hashvalue;
    new->rtl = (char *)myalloc_comb(strlen(rtlval)+1);
    strcpy(new->rtl, rtlval);
    new->next_rtl = NULL;

    /*insert this record in the proper bucket in the RTL hashtable*/
    if(is_remap && remap_rtl[hvalue] == NULL)
      remap_rtl[hvalue] = new;
    else if(!is_remap && rtl_hash[hvalue] == NULL)
      rtl_hash[hvalue] = new;
    else
      prev_rptr->next_rtl = new;

#if 0    
    /*make entry in table of pointers to RTLs for this function*/
    rtl_ptr[pptr_rtl++] = new;
#endif
    return 1;
  }
  else{
#if 0    
    /*if similar RTL is found then just make entry in the table of pointers
      to RTLs for current function*/
    if(pptr_rtl+1 >= MAX_RTL)
      return MAX_RTL_EXCEED;
    rtl_ptr[pptr_rtl++] = rptr;
#endif
    
    return 0;
  }
#endif

  return 0;
}


/*
 * get_func_hash - generate the hashvalues for the current instance of the
 *                 function in memory. Return the RTL count
 */
int get_func_hash(unsigned int *CRC_hash, unsigned int *func_hash,
		  int is_remap, int *v_analysis)
{
  unsigned int rtl_hash, CRC_index;
  int i, rtl_count, b_pos, pos, is_new_rtl;
  int old_regallocptr, onum, is_rtl;
  struct bblock *cblk;
  struct list *rtl;
  extern struct bblock *top;
  extern int remap_label_num, label_table[MAX_LABELS];
  extern int remap_cex_label_num, cex_label_table[MAX_CEX_LABELS];
  extern int remap_regs[MAXREGS];
#ifdef DEOPT  
  extern rlist no_replace_regs;
#endif

  /*We calculate two hashvalues. The first is based on the CRC algorithm to
    calculate the CRC hashvalue. The second is just a simple count of the
    characters of all legal RTLs in the function*/
  rtl_count = 0;
  *CRC_hash = 0;
  *func_hash = 0;
  rtl_hash = 0;
  is_new_rtl = 0;
  pos = b_pos = 0;

#ifdef DEOPT  
  
  /*initialize the table of labels, used for remapping labels*/
  if(is_remap){

    /*apply the compulsory and epilogue transformations*/
    apply_epilogue_trans(v_analysis);

    /*assign the same pseudo register to each hardware register*/
    if(is_remap == SAME_PSEUDO_REG){
      
      /*initialize the table of register remappings*/
      for(i=0 ; i<MAXREGS ; i++)
	remap_regs[i] = 0;

      init_deopt(&no_replace_regs);
    }
    /*assign a different pseudo register to each live range*/
    else{
      
      old_regallocptr = regallocptr;
      
      /*before comparing function instances, we re-assign live ranges to pseudo
	registers so that 2 instances similar in all aspects except the register
	numbers, match. At this point we do some analysis and calculate live
	range information. We will do the actual register remapping on the fly
	during comparison of RTLs*/
      if(!(calc_live_ranges())){
	fprintf(stderr, "Error during calculation of live range information\n");
	return 0;
      }

      if(is_remap == LIVE_REG_STATE)
	do_needed_analysis(LIVE_VAR_ANALYSIS|DEAD_VAR_ANALYSIS);
    }
  }
#endif /*DEOPT*/  

  /*re-number all RTLs in this function*/
  onum = 1;
  for (cblk = top; cblk; cblk = cblk->down) {
    for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
      if(cnts(rtl))
	rtl->onum = onum++;
    }
  }
  
  /*for each basic block*/
  pos = 0;
  for(cblk=top ; cblk ; cblk=cblk->down){
      
    /*If there are empty basic blocks in the function, then since they do
      not contain any RTLs, they are not considered in any hash-sum, which
      we also believe is the right way to do things. But, some analysis was
      found to change before and after removal of those basic blocks. So, a
      phase which was unsuccessful before, after removing unreachable code,
      becomes successful. So, this is a hack to also consider empty basic
      blocks*/
    /*b_pos++;
     *func_hash += b_pos;*/
    is_rtl = FALSE;
    
    /*for each RTL in the basic block*/
    for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
	
      /*if the RTL-line contains a register transfer, check if this RTL has
	already been encountered before. If not, insert it in the list and
	return 1. */
      if(cnts(rtl)){
	  
	/*pos++;*/
	is_new_rtl |= check_rtl_instance(rtl, &rtl_hash, CRC_hash, pos, is_remap);
	*func_hash += rtl_hash;
	rtl_count++;
	is_rtl = TRUE;
      }
    }
    /*increment once for each basic block encountered*/
    /*if(is_rtl)
     *func_hash = *func_hash + 1;*/
  }
    
  /*to get the remainder in the CRC register we need to repeat the algorithm
    for 4 more iterations for 32 bit registers*/
  for(i=0 ; i<sizeof(int) ; i++){
      
    /*for CRC-32 the mask is 32 bit and we shift by 24 bits*/ 
    CRC_index = (*CRC_hash & CRC32_MASK) >> CRC32_SHIFT;
    
    /*remove the top byte in the register which is used for indexing into the
      static CRC table*/
    *CRC_hash = *CRC_hash << 8;
    *CRC_hash = *CRC_hash ^ CRC32Table[CRC_index];
  }
  
  /*if there is any overflow during RTL insertion then set flag*/
  if(is_new_rtl & MAX_RTL_EXCEED){
    fprintf(stderr, "get_func_hash: RTLs in this function exceed the max table size allocated to store RTLs\n");
  }

#ifdef DEOPT  
  if(is_remap){

    if(is_remap == SAME_PSEUDO_REG){
    }

    else{
      /*Now we undo the changes to the function we made during calculating live
	ranges to take care of delay slots*/
      for(cblk=top ; cblk ; cblk=cblk->down){
	for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
	  
	  if(rtl->type & IGNORE_RTL){
	    rtl->type |= RTLINE;
	    rtl->type &= ~IGNORE_RTL;
	  }
	  else if(rtl->type & DELETE_RTL){
	    if(rtl != cblk->rtls){
	      fprintf(stderr, "is_same_func: Should never happen\n");
	      return 0;
	    }
	    cblk->rtls = rtl->next;
	    cblk->rtls->prev = NULL;
	  }
	}
      }
      regallocptr = old_regallocptr;
    }
  }
#endif /*DEOPT*/  
  
  return rtl_count;
}


/*
 * remap_label2 - a different algorithm to remap labels to detect 2 function
 *                instances differing only in the labels as identical
 */
void remap_label2(struct list *rtl, char rtlval[], char *rtlptr)
{
  struct bblock *cblk, *left, *right, *target;
  struct list *crtl;
  char label[MAXSTRING];
  int lnum, found, blknum;

  /*the label number is the rtlid of the first rtl in the block following
    this label*/
  if((sscanf(rtlptr, lab_mask, &lnum))==1 ||
     (sscanf(rtlptr, "L%d", &lnum)) == 1){
    
    cblk = rtl->daddy;
    if((left=cblk->left) && (right=cblk->right))
      target = right;
    else
      target = left;

    found = FALSE;
    /*check if the block label is actually what we expect*/
    if(target->label && ((sscanf(target->label, "L%d", &blknum))==1) &&
       blknum==lnum){ 
    
      /*locate the first RTL*/
      for(cblk=target ; cblk ; cblk=cblk->down){
	for(crtl=cblk->rtls ; crtl ; crtl=crtl->next){
	  if(cnts(crtl)){
	    found = TRUE;
	    break;
	  }
	}
	if(found)
	  break;
      }
    
      if(found)
	lnum = crtl->onum;
      else
	lnum = 0;
      sprintf(label, lab_mask, lnum);
      *rtlptr = '\0';
      sprintf(rtlval, "%s%s;", rtlval, label);
    }
  }
}


/*
 * remap_label - remap labels generated during certain optimizations to take
 *               care of phase-ordering, so that two function instances
 *               differing only in the label numbers can be detected
 *               identical. We only change the labels of the RTLs and not for
 *               basic blocks, although we mark basic block labels.
 */
void remap_label(char *label, int is_modify)
{
  int label_num;
  extern int remap_label_num, label_table[MAX_LABELS];
  extern int remap_cex_label_num, cex_label_table[MAX_CEX_LABELS];
  extern FILE *comb_log;

  /*check if the label is present, and if it is a label generated by some
    optimization phase, instead of a label read from the input file. Labels
    from the input file have the signature "L%d", while other labels have a
    a different signature. Sparc labels have the signature "L00%d"*/

  /*check for labels defined in VPO*/
  if((sscanf(label, lab_mask, &label_num)) == 1){
    
    /*enter this label in the label table*/
    if(!is_modify){
      if(label_num < MAX_LABELS){
	if(label_table[label_num] < 0)
	  label_table[label_num] = remap_label_num++;
      }
      else if(comb_log)
	fprintf(comb_log, "remap_label: Max label number exceeded %d\n", label_num);
    }
    
    /*for RTL, remap the label with a label from the table*/
    else{
      if(label_table[label_num] >= 0){
	sprintf(label, lab_mask, label_table[label_num]);
      }
      else if(comb_log)
	fprintf(comb_log, "Label for RTL not found: %d\n", label_num);
    }
  }
  
  /*check for labels read in from the cex file*/
  else if((sscanf(label, "L%d", &label_num)) == 1){
    
    if(!is_modify){
      if(label_num < MAX_CEX_LABELS){
	if(cex_label_table[label_num] < 0)
	  cex_label_table[label_num] = remap_cex_label_num++;
      }
      else if(comb_log)
	fprintf(comb_log, "remap_label: Max label number exceeded %d\n", label_num);
    }
    
    else{
      if(cex_label_table[label_num] >= 0){
	sprintf(label, "L%d", cex_label_table[label_num]);
      }
      else if(comb_log)
	fprintf(comb_log, "Label for RTL not found: %d\n", label_num);
    }
  }
}


#ifdef DEOPT
/*
 * get_remapped_rtl - modify the rtl replacing hardware registers with
 *                    corresponding psuedo regs during SEL...COMB
 */
void get_remapped_rtl(struct list *rtl, char *rtlval, int remap)
{
  int o_num, n_num;
  char clive[MAXSTRING], *cptr, *rtlptr, *c;
  char original_reg[REGSTRING+1], new_reg[REGSTRING+1];
  vector regs_live;
  extern int remap_regs[MAXREGS];

  /*We perform this by scanning the RTL looking for registers set and
    used. After each register is located, the corresponding psuedo register
    is located by calling a function. This is then replaced in the register
    string*/
  if(!rtlval)
    fprintf(stderr, "get_remapped_rtl: Null register string\n");
  else{
    rtlptr = rtlval;
    while(*rtlptr){
      if(isRegister(rtlptr)){

	/*copy only the register into another string*/
	strncpy(original_reg, rtlptr, REGSTRING);
	cptr = skiploc(original_reg);
	*cptr = '\0';
	
	/*store a pointer to this location, so that we can replace this
	  register later*/
	cptr = rtlptr;

	/*map each register to the same pseudo reg*/
	if(remap == SAME_PSEUDO_REG){
	  o_num = regnum(original_reg);
	  n_num = next_pseudo(original_reg, new_reg, remap_regs[o_num]);
	  remap_regs[o_num] = n_num;
	  rtlptr = skiploc(rtlptr);
	}
	else{
	  
	  /*if we find a register, then we check if its a set or use*/
	  rtlptr = skiploc(rtlptr);
	  if(*rtlptr == '=')
	    /*this is a set of the register*/
	    get_pseudo_reg(rtl, original_reg, new_reg, 0);
	  else
	    /*this is a use of the register*/
	    get_pseudo_reg(rtl, original_reg, new_reg, 1);
	}
	
	/*replace the original hardware register with this new pseudo
	  register in the RTL*/
	if(c = new_reg){
	  while(*c){
	    *cptr = *c;
	    c++; cptr++;
	  }
	}
      }
      else
	rtlptr++;
    }

    /*calculate the number of registers live at this point and append this
      information to the remapped RTL*/
    if(remap == LIVE_REG_STATE){
      regs_live = (vector)live_regs2(rtl->daddy, rtl);

      /*convert the vector containing live register information into a
	character string*/
      vec2char(regs_live, clive);
      sprintf(rtlval, "%s%s", rtlval, clive);
    }
  }
}

/*
 * calc_live_ranges - calculate the live range information for correct
 *                    register re-mapping 
 */
int calc_live_ranges()
{
  int i;
  char *ptr;
  struct bblock *cblk;
  struct list *rtl;
  struct blist *bptr;
#ifdef DEOPT  
  extern rlist no_replace_regs;
#endif
  extern struct bblock *top;
  
#ifdef FILL  
  /*if delay slots have been filled, then to calculate the correct live
    ranges information we need to relocate the annuled branch back in its
    basic block*/
  if(trans_done & FILL_DELAY_SLOTS_BIT){
    
    for(cblk=top ; cblk ; cblk=cblk->down){
      
      /*If this basic block has predecessors, we check if any of them end with
	RTLs in delay slots that really belong to this block.*/
      for(bptr = cblk->preds ; bptr ; bptr=bptr->next){
	if( (bptr->ptr->rtlend->type & RTLINE) &&
	    (bptr->ptr->rtlend->kind & (TAKEN|NOTAKEN) == TAKEN) &&
	    bptr->ptr->right == cblk )
	  break;
      }
      
      /*If atleast one pred. block contains a delayed branch, we verify if
	all pred. have the same instruction as their last instruction*/
      ptr = NULL;
      if(bptr){
	for(bptr=cblk->preds ; bptr ; bptr=bptr->next){
	  if(ptr == NULL)
	    ptr = bptr->ptr->rtlend->val;
	  else if(strcmp(ptr, bptr->ptr->rtlend->val) != 0){
	    fprintf(stderr, "calc_live_ranges: Delay slots do not match in pred. blocks\n");
	    return 0;
	  }
	}
      }

      /*If there is an annuled instruction then modify its type so that it no
	longer is recognizied as a valid RTL and then copy over that
	instruction to its original block*/
      if(ptr){
	for(bptr=cblk->preds ; bptr ; bptr=bptr->next){
	  /*if( (bptr->ptr->rtlend->type & RTLINE) &&
	      (bptr->ptr->rtlend->kind & (TAKEN|NOTAKEN) == TAKEN) &&
	      bptr->ptr->right == cblk ){*/

	    bptr->ptr->rtlend->type |= IGNORE_RTL;
	    bptr->ptr->rtlend->type &= ~RTLINE;
	    /*}*/
	}
	rtl = new_rtl(NULL, RTLINE|DELETE_RTL, NULL);
	rtl->daddy = cblk;
	rtl->val = strcpy(CALLOC(strlen(ptr) + 1), ptr);
	rtl->prev = NULL;
	rtl->next = cblk->rtls;
	cblk->rtls->prev = rtl;
	cblk->rtls = rtl;
      }
    }
  }
#endif /*FILL*/

  /*get the live variable information for this function*/
  live_variable_analysis(1, FALSE, FALSE);

  /*initialize machine dependant data before building the interference
    graph*/
  init_deopt(&no_replace_regs);
  
  /*build the interference graph for live ranges without merging use-set ranges*/
  build_rig(0);

  /*we must recalculate the end of the
    hardware registers, locals and other declarations. This
    method will eliminate the excess pseudoregisters.*/
  for (i = hregnum; i < regallocptr; i++)
    {
      if (isreg(sets[i].item) && pseudoreg(sets[i].item))
	break;
    }
  regallocptr = i;

  /*Assign pseudo registers to all nodes in the RIG*/
  /*assign_pseudo_regs();*/

  return 1;
}
#endif /*DEOPT*/

/*
 * gen_CRC_table - algorithm used to generate the table values to be used
 *                 during CRC-32 hash calculation. Only used once to generate
 *                 the static table.
 */
void gen_CRC_table()
{
  /* The standard CRC-32 polynomial used in ethernet*/
  static int CRC_poly = 0x04c11db7;

  int i, num, bin_num;
  int value;
  FILE *fp;

  fp = fopen("CRC_table", "w");

  /*to each possible 8-bit configuration, generate the table value*/
  for(num=0 ; num<256 ; num++){

    bin_num = num << 24;
    value = 0;

    for(i=0 ; i<8 ; i++){

      /*check the most significant bit*/
      if(bin_num & 0x80000000){
	bin_num = bin_num << 1;
	bin_num = (bin_num ^ CRC_poly);
	value = (value << 1) ^ CRC_poly;
      }
      else{
	bin_num = bin_num << 1;
	value = value << 1;
      }
    }

    fprintf(fp, "\t0x%08x,", value);
    if( (num+1)%4 == 0)
      fprintf(fp, "\n");
    if( (num+1)%64 == 0)
      fprintf(fp, "\n");
  }
  fclose(fp);
}


/*
 * update_tree - update the tree of sequences during SEL...COMB search using
 *               genetic algorithms. Returns the modified for the current
 *               position of the sequence in the tree
 */
unsigned int  update_tree(struct comb_struct *comb, int opt, unsigned int curr_ptree,
			  int change, int succ_num, int succ_phases[])
{
  char str[MAXSTRING];
  int i, parent, status;
  unsigned long long s_measure, d_measure;
  struct Func_hash *func_node;
  extern struct tree_struct *tree;
  extern struct chromosome popu[MAX_CHROMOSOMES];
  extern unsigned int tree_ptr;
  extern FILE *comb_log;
  extern int resume_mode;

  /*If the sequence upto this point has been encountered before, then
    a link should already be present for this optimization number*/
  if(tree[curr_ptree].opt[opt] >= START_NODE)
    return tree[curr_ptree].opt[opt];

  /*if the current optimization is successful*/
  if(change > 0){

    /*if sequence upto this point has not been seen before, then a new node
      should be created here*/

    /*should never get here*/
    if(tree[curr_ptree].opt[opt] == UNSUCC){
      if(!resume_mode)
	fprintf(comb_log, "Should never get here: %d %d\n", curr_ptree, opt);
      else
	fgets(str, MAXSTRING-1, comb_log);
      fprintf(stderr, "Should never get here: %d %d\n", curr_ptree, opt);
      fprintf(stderr, "Number: %d    ", (comb->gen_count-1)*comb->popu_size+comb->popu_count);
      for(i=0 ; i<comb->strlength ; i++)
	fprintf(stderr, "%d ", comb->base_opt[popu[comb->popu_count-1].chrom[i]]);
      fprintf(stderr, "\n");
      print_tree_path(curr_ptree, comb_log);
    }
      
    /*before creating the new node, check if the current function instance is
      same as some previous instance, in which case we don not create the new
      node and just link the current node to the node, the prefix upto which
      point results in the same sequence. This will result in the tree being
      transformed into a DAG. The value returned is the tree node matching
      the matched function, or 0 if no match is found.*/
    if(comb->flags & FUNC_CHECKS)
      status = check_func_instance(&s_measure, &d_measure, &func_node,
				   succ_phases, succ_num, FALSE, 0);
    else{
      status = 0;
      func_node = NULL;
    }

    if(!status){
    
      /*assign a new tree node*/
      if(tree_ptr < NUM_TREE_NODES){
	tree[curr_ptree].opt[opt] = tree_ptr;
      
	/*initialize the new node*/
	for(i=0 ; i<NUM_TRANS_TYPES ; i++)
	  tree[tree_ptr].opt[i] = UNSUCC;
      
	/*this optimization phase can be followed by any phases selected by
	  the user, but which have not be nullified previously by the analysis*/
	tree[tree_ptr].no_succ_phases = 0;
	for(i=0 ; i<comb->no_comb ; i++){
	  if((!comb->flags & USELESS_TRANSFORM) ||
	     (!(comb->opt_mask & (1 << comb->base_opt[i])))){
	    tree[tree_ptr].opt[comb->base_opt[i]] = UNSEEN;
	    tree[tree_ptr].no_succ_phases++;
	  }	    
	}
      
	/*if this phase followed by itself cannot lead to any useful change
	  then disable it*/
	if(comb->flags & (REPEAT_SAME_PHASE|ENABLE_PHASE)){
	  if(opt!=CODE_MOTION_TRANS && opt!=LOOP_STRENGTH_REDUCT_TRANS &&
	     opt!=RECURRENCE_ELIM_TRANS && opt!=INDUCT_VAR_ELIM_TRANS &&
	     opt!=ALL_LOOP_TRANS && opt!=COMMON_SUBEXPR_ELIM_TRANS &&
	     opt!=DEAD_ASG_ELIM_TRANS){
	    tree[tree_ptr].opt[opt] = UNSUCC;
	    tree[tree_ptr].no_succ_phases--;
	  }
	}
	
	/*set the back link for this tree node*/
	tree[tree_ptr].parent = curr_ptree;
      
	/*indicate that this is not a leaf node since it has no measures
	  associated with it. If this is the last optimization then after
	  taking measures, this node would be updated*/
	tree[tree_ptr].s_measure = tree[tree_ptr].d_measure = 0;
	if(func_node)
	  func_node->tree_node = tree_ptr;
	tree[tree_ptr].func_node = func_node;
	tree_ptr++;
	
	return tree_ptr-1;
      }
      /*if there are no more modes allocated*/
      else{
	fprintf(stderr, "No more tree nodes to allocate\n");
	return curr_ptree;
      }
    }
    /*if current function instance matches some previous instance, then just
      link the current tree node to the tree node returned*/
    else{
      tree[curr_ptree].opt[opt] = func_node->tree_node;
      return func_node->tree_node;
    }
  }

  /*if the current optimization is not successful then indicate this*/
  else{
    if(tree[curr_ptree].opt[opt] != UNSUCC){
      tree[curr_ptree].opt[opt] = UNSUCC;
      tree[curr_ptree].no_succ_phases--;
    }
    return curr_ptree;
  }
}

/*
 * make_pseudo_reg - construct a pseudo register. The original function
 *                   uses 9 bits and constructs 512 registers only. Since
 *                   there are only 4 types, we can reduce the length of type
 *                   field from 4 bits to 2, to get 4 times as many registers
 */
void make_pseudo_reg(char *pseudo, int reg_type, int number)
{
  /* note the static array
   * we use it so we don't have to allocate memory
   * each time this func is called
   * however, the caller needs to be careful to copy/discard
   * the results before calling this function again.
   */
  static char temp[REGLOCLENGTH+1]; 
  
  /* not all 8 bits are usuable, the upper bit must be 1 */
  int useableBitsPerByte=USEABLECHARBITS;
  
  /* and here we make masks for the lower 7 bits */
  int maxByteVal=(1<<useableBitsPerByte)-1;
  
  /* and the top-bit */
  int topBitMask=(1<<useableBitsPerByte);
  
  /* loop index */
  int i;	
  int typeMask;

  if(number < 0 || number > (1 << 11) ||
     reg_type < 0 || reg_type > 4){
    fprintf(stderr, "Bounds exceeded for register type and number\n");
    fprintf(stderr, "Type: %d, Number: %d\n", reg_type, number);
  }
  else{

    /* we set the last character and the first character to 0. */
    /* the rest get set in the for-loop */
    temp[0]=0;
    temp[REGLOCLENGTH]=0;
    for(i=REGLOCLENGTH-1; i>=0; i--) {
      temp[i]=(number&maxByteVal);
      temp[i]|=topBitMask;
      number=number>>useableBitsPerByte;
    }
    
    
    reg_type = reg_type << 4;
    temp[0] |= reg_type;	
    
    temp[0] |= (1 << 6);

    strcpy(pseudo, temp);
  }
}

  
/* count_local_references - count the number of times each local variable is
 *                          referenced in the function
 */
void count_local_references()
{
  register struct locuse *ptr;
  register struct list *rtl;
  register struct bblock *cblk;
  int type, ind, set, i;
  char *c, code[REGSTRING];
  extern struct bblock *top;
  extern struct locuse *locs;

  /*reset the reps field*/
  for(ptr=locs ; ptr ; ptr=ptr->next)
    ptr->reps = 0;

  for (cblk = top; cblk; cblk = cblk->down) {
    for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
      if (c = cnts(rtl)) {
	while (locget(&c, code, &type, &ind, &set, rtl)) {
	  i = vecmap[USP(code)];
	  
	  ptr = sets[i].local;
	  ptr->reps += (cblk->freq << 4) + 1;
	  reorder_local(ptr);
#ifdef VET
	  update_locuse(ptr);
#endif
	}
      }
    }
  }
}  

/*
 * reset_kind_cost - reset the kind and cost field of all RTLs
 */
void reset_kind_cost()
{
  struct bblock *cblk;
  struct list *rtl;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){
    for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
      if(cnts(rtl)){
	rtl->kind = 0;
	rtl->cost = 0;
      }
    }
  }
}


/*
 * apply_epilogue_trans - apply the compulsory phases and some other phases
 *                        which are applied after fix entry exit in the batch
 *                        compiler, before taking measures during SEL...COMB
 */
void apply_epilogue_trans(int *valid_analysis)
{
  int analysis, done_trans;
  extern int locals_change;
  extern unsigned int trans_done;
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];

  done_trans = trans_done;
  /*first apply the compulsory phases*/
  do_reqd_optimization(TRUE, TRUE, valid_analysis);

  /*instruction scheduling*/
  if(!(trans_done & (1 << INST_SCHED_TRANS))){
    reset_kind_cost();
    instruction_scheduling(1);
    trans_done |= INST_SCHED_BIT;
  }
					       
#ifdef FILL
  /*fill delay slots*/
  /*if (!(trans_done & (1 << FILL_DELAY_SLOTS_TRANS))){
     analysis = needs_analysis[FILL_DELAY_SLOTS_TRANS] & ~(*valid_analysis);
     (*valid_analysis) |= do_needed_analysis(analysis);
     fill_delay_slots(1);
     (*valid_analysis) &= invalidates_analysis[FILL_DELAY_SLOTS_TRANS];
     if(locals_change)
       *valid_analysis &= ~(LIVE_VAR_ANALYSIS);
     trans_done |= FILL_DELAY_SLOTS_BIT;
     }*/
#endif  
}

/* do_needed_analysis - do the analysis needed for a particular phase before
                        attempting that phase. Returns the analysis that is
                        valid after this point
*/
int do_needed_analysis(unsigned int analysis)
{
  int valid_analysis, writes;
  struct loopl *loop;
  
  extern unsigned int trans_done;
  extern int d_f_s_count, b_d_t_count, f_d_f_count, l_v_a_count;
  extern int r_d_v_count;
  extern struct loopl *loops;
  extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern int limited_branch_chaining, limited_scope;
  extern struct blk_inscope dfs_scope;

  valid_analysis = 0;
  limited_scope = FALSE;

  /*another special analysis is the elimination of empty basic blocks. This
    should be done anytime loop and dominator analysis is needed as it
    enables the compiler to accurately determine dominators. Otherwise, some
    block which has 2 preds, of which one is empty, does not set the right
    dominators*/
  if(analysis & (ELIM_EMPTY_BLOCKS_ANALYSIS)){
    /*calc_status();*/
    do_needed_analysis(needs_analysis[BRANCH_CHAINING_TRANS]);
    limited_branch_chaining = TRUE;
    remv_branch_chains(1);
    limited_branch_chaining = FALSE;
    remv_useless_basic_blocks(1);
    analysis |= CALC_STATUS_ANALYSIS;
    valid_analysis |= ELIM_EMPTY_BLOCKS_ANALYSIS;
  }
  /*this is for the special MERGE_BLOCK analysis, so that merge basic block
    never appears as a distinct active phase in VPO*/
  if(analysis & MERGE_BLOCKS_ANALYSIS) {
    calc_status();
    merge_basic_blocks(1);
    valid_analysis &= ~invalidates_analysis[MERGE_BLOCKS_TRANS];
    valid_analysis |= MERGE_BLOCKS_ANALYSIS;
  }
  if(analysis & DEAD_CODE_ANALYSIS){
    calc_status();
    remv_unreachable_code(1);
    valid_analysis |= DEAD_CODE_ANALYSIS;
    /*analysis |= invalidates_analysis[DEAD_CODE_ELIM_TRANS];*/
  }
  if(analysis & RECALC_PREDS){
    recalculate_all_preds();
    valid_analysis |= RECALC_PREDS;
  }
  if (analysis & CALC_STATUS_ANALYSIS) {
    calc_status();
    valid_analysis |= CALC_STATUS_ANALYSIS;
  }
  if (analysis & LOCAL_LINK_ANALYSIS) {
    /*after register coloring occurs, we need to clear any previous
     * local_links and change the parameter sent to set_local_links
     * to >=2 */
    /*if (trans_done & (1 << REG_ALLOCATION_TRANS)) {*/
    clear_all_links(top);
    (void) set_local_links(2);
    /*}
    else
    (void) set_local_links(1);*/
    valid_analysis |= LOCAL_LINK_ANALYSIS;
  }
  if (analysis & DEPTH_FIRST_SEARCH_ANALYSIS ||
      analysis & DOMINATOR_ANALYSIS) {
    number_basic_blocks();
    depth_first_search(d_f_s_count++);
    valid_analysis |= DEPTH_FIRST_SEARCH_ANALYSIS;
  }
  if (analysis & GLOBAL_LINK_ANALYSIS) {
    (void) set_global_links(1);
    valid_analysis |= GLOBAL_LINK_ANALYSIS;
  }
  if (analysis & DOMINATOR_ANALYSIS) {
    build_dominator_tree(b_d_t_count++);
    find_dominance_frontiers(f_d_f_count++);
    valid_analysis |= DOMINATOR_ANALYSIS;
  }
  if (analysis & LOOP_ANALYSIS) {
    clear_loops();
    (void) find_loops(1);
    order_loops();
    find_loop_exits();
    find_loop_preheaders();
    valid_analysis |= LOOP_ANALYSIS;
  }
  if (analysis & LOOP_INVARIANT_ANALYSIS) {
    /*needs live variable analysis to be done before it and messes up sets
      and uses, so we need to perform live variable again after it*/
    freetriples();
    live_variable_analysis(l_v_a_count++, trans_done & REG_ASSIGNMENT_BIT, FALSE);
    for(loop=loops ; loop ; loop=loop->next){
      writes = 0;
      loop_invariant_init(loop);
      loop_invariant_analysis(loop, TRUE, TRUE, &writes);
      /*loop_invariant analysis works in 2 stages. The first time it is called,
	we need to do additional analysis and set some structures used in the
	second pass*/
      loop_invariant_analysis(loop, FALSE, TRUE, &writes);
    }
    live_variable_analysis(l_v_a_count++, trans_done & REG_ASSIGNMENT_BIT, FALSE);
    analysis = analysis & ~(LIVE_VAR_ANALYSIS);
    valid_analysis |= LOOP_INVARIANT_ANALYSIS | LIVE_VAR_ANALYSIS;
  }	    
  if (analysis & LIVE_VAR_ANALYSIS) {
    live_variable_analysis(l_v_a_count++,
			   /*curr_oper == REG_ALLOCATION_TRANS ||
			     (curr_oper == DEAD_ASG_ELIM_TRANS &&
			     commands[pc+1].oper ==
			     REG_ALLOCATION_TRANS),*/
			   trans_done & REG_ASSIGNMENT_BIT,
			   FALSE);
    valid_analysis |= LIVE_VAR_ANALYSIS;
  }
  if (analysis & DEAD_VAR_ANALYSIS) {
    if(trans_done & REG_ASSIGNMENT_BIT){
      clear_deads();
      remv_dead_variables(r_d_v_count++,
			  trans_done & REG_ASSIGNMENT_BIT, FALSE);
      valid_analysis |= DEAD_VAR_ANALYSIS;
    }
  }
  if (analysis & REGS_USED_ANALYSIS) {
    registers_used();
    valid_analysis |= REGS_USED_ANALYSIS;
  }
  if (analysis & COUNT_LOCAL_REFS){
    count_local_references();
  }
  if (analysis & EXEC_FREQ_ANALYSIS) {
    (void) estimate_execution_frequency(1);
    valid_analysis |= EXEC_FREQ_ANALYSIS;
  }

  limited_scope = dfs_scope.limited_scope;
  return valid_analysis;
}

/* clear_deads - clear the dead register lists in all RTLs
 */
void clear_deads()
{
  struct bblock *cblk;
  struct list *prtl;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){
    for(prtl=cblk->rtls ; prtl ; prtl=prtl->next){
      if(cnts(prtl) && !is_rjmp(prtl->val)){
	rfree(prtl->deads);
	prtl->deads = rinit();
      }
    }
  }
}


/* do_reqd_optimization - function will check if the required optimizations
                          have been performed and if not then perform those,
			  namely register allocation and fix entry-exit
*/
void do_reqd_optimization(int is_reg_assign, int is_fix_entry_exit, int *valid_analysis)
{
  struct list *ptr;
  int analysis;
  extern int locals_change;
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];
  
  /*check if register assignment is needed. Perform any required analysis*/
  if (is_reg_assign && !(trans_done & (1 << REG_ASSIGNMENT_TRANS))){

    analysis = needs_analysis[REG_ASSIGNMENT_TRANS] & ~(*valid_analysis);

    /*do the required analysis if not currently valid*/
    (*valid_analysis) |= do_needed_analysis(analysis);

    (void) local_register_assignment(1);
    (*valid_analysis) &= ~invalidates_analysis[REG_ASSIGNMENT_TRANS];
    if(locals_change)
      *valid_analysis &= ~(LIVE_VAR_ANALYSIS);
    trans_done |= REG_ASSIGNMENT_BIT;
  }

  /*check if fix entry exit needs to be done*/
  if (is_fix_entry_exit && !(trans_done & (1 << FIX_ENTRY_EXIT_TRANS))) {
    registers_used();
    analysis = needs_analysis[FIX_ENTRY_EXIT_TRANS] & ~(*valid_analysis);

    for (ptr = top->rtls; ptr && !(ptr->type & FUNCNAME); ptr = ptr->next);
    if (ptr){
      (*valid_analysis) |= do_needed_analysis(analysis);

      fixentry(ptr, ret_block->preds);
      (*valid_analysis) &= ~invalidates_analysis[FIX_ENTRY_EXIT_TRANS];
      if(locals_change)
	*valid_analysis &= ~(LIVE_VAR_ANALYSIS);
      trans_done |= FIX_ENTRY_EXIT_BIT;
    }
  }
}

/*
 * execute_type - determine the method of getting performance measures, as
 *                specified by the user in the configuration file.
 *                Return type = 1 - Direct executution
 *                              2 - Simulation
 *                              0 - Only code size measures
 */
int execute_type()
{
  static int display_msg = 1;
  char ch, str[MAXSTRING];
  FILE *fp;

  /*the first line in the test.config file will tell us the type of execution
    requested*/
  if((fp=fopen("test.config", "r")) == NULL){
    fprintf(stderr, "Execution type cannot be determined in execute_type()\n");
    return 0;
  }
  
  /*the first line in the configuration file should indicate the type of
    performance measure desired*/
  fgets(str, MAXSTRING-1, fp);

  /*close the file*/
  fclose(fp);

  if((sscanf(str, "execution type: %c\n", &ch)) == 1){

    /*execute*/
    if(ch == 'e' || ch == 'E')
      return EXECUTE;
    /*simulate*/
    else if(ch == 's' || ch == 'S')
      return SIMULATE;
    /*code size only*/
    else 
      return 0;
  }
  else{
    if(display_msg){
      fprintf(stderr, "The first line in the configuration file should be:\nexecution type: \n");
      display_msg = 0;
    }
  }  
  
  return 0;
}


/*
 * insert_sim_flags - this function will insert certain flags in the assembly
 *                    instruction for the simulator to interpret. The
 *                    simulator's execution will depend on these flags
 */
void insert_sim_flags(char str[])
{
  int i, j, no_tabs=0;
  char c, t_str[MAXSTRING];

  return;
  

  /*---- currently we do not tag any instructions. This might be useful in
         the future
    ------*/	 
  if(strncmp(str, "\tnop", 4) == 0)
    strcpy(str, "\tnop/a");
  else if(strncmp(str, "\trestore", 8) == 0)
    strcpy(str, "\trestore/a");
  else{
    for(i=0,j=0 ; str[i]!='\0' ; i++){
      
      if(str[i] == '\t'){
	
	no_tabs++;
	/*we insert the flags immediately after the opcode, and before the
	  arguments. That would be before the second tab*/
	if(no_tabs == 2){
	  t_str[j++] = '/';
	  t_str[j++] = 'a';
	}
      }
      t_str[j++] = str[i];
    }
    t_str[j] = '\0';
    strcpy(str, t_str);
  }
}


/*
 * add_simulator_ins - add instructions which would be interpreted by the
 *                     simulator to do various things
 */
void add_simulator_ins(struct list *rtl, FILE *fp, int ins_type)
{
  static int was_prev_ins_call=FALSE;
  extern char *fn;

  /*if this is the very next instruction after the call, then we add another
    instruction to re-start cycle measurement*/
  if(was_prev_ins_call){
    add_start_cycle_ins(fp);
    was_prev_ins_call = FALSE;
  }

  if(ins_type == ASMLINE){

    /*add another nop before the return instruction*/
    if(is_add_before_ret(rtl))
      add_end_cycle_ins(fp);
  }    

  if(ins_type == RTLINE){
    
    /*before the return or exit instruction we add instruction to stop cycle
      accurate simulate measures*/
    /*if(callsexit(rtl) || is_return(rtl->val))*/
    if(is_end_ins(rtl))
      add_end_cycle_ins(fp);
    
    /*before every call instruction we add an instruction to indicate to the
      simulator to stop doing cycle accurate simulations*/
    else if(is_call(rtl->val)){
      add_end_cycle_ins(fp);
      was_prev_ins_call = TRUE;
    }
  }
}


/*
 * add_start_cycle_ins - add an instruction to indicate to the simulator to
 *                       start taking cycle accurate measures in the
 *                       simulator
 */
void add_start_cycle_ins(FILE *fp)
{
  char add_rtl[MAXSTRING], en_rtl[MAXSTRING], add_assem[MAXSTRING];
  char *tmp_linptr;
  int tmp_dassem;
  struct list *tmp_curptr;

  /*encode the RTL to be added*/
  sprintf(add_rtl, "r[0]=r[0]&r[0];");
  encode_rtl(add_rtl, en_rtl);

  /*parse the RTL to assembly language instruction*/

  /*first store the global variables used during parsing*/
  tmp_linptr = linptr;
  tmp_dassem = dassem;
  tmp_curptr = curptr;

  /*set the new values for the global variables*/
  linptr = en_rtl;
  dassem = 1;

  /*parse and add the new instruction to the output file*/
  dump_yyparse(add_assem);
  fprintf(fp, "%s\n", add_assem);

  /*restore global variables*/
  linptr = tmp_linptr;
  dassem = tmp_dassem;
  curptr = tmp_curptr;
}

/*
 * add_start_cycle_ins - add an instruction to indicate to the simulator to
 *                       start taking cycle accurate measures in the
 *                       simulator
 */
void add_end_cycle_ins(FILE *fp)
{
  char add_rtl[MAXSTRING], en_rtl[MAXSTRING], add_assem[MAXSTRING];
  char *tmp_linptr;
  int tmp_dassem;
  struct list *tmp_curptr;

  /*encode the RTL to be added*/
  sprintf(add_rtl, "r[0]=r[0]|r[0];");
  encode_rtl(add_rtl, en_rtl);

  /*parse the RTL to assembly language instruction*/

  /*first store the global variables used during parsing*/
  tmp_linptr = linptr;
  tmp_dassem = dassem;
  tmp_curptr = curptr;

  /*set the new values for the global variables*/
  linptr = en_rtl;
  dassem = 1;

  /*parse and add the new instruction to the output file*/
  dump_yyparse(add_assem);
  fprintf(fp, "%s\n", add_assem);

  /*restore global variables*/
  linptr = tmp_linptr;
  dassem = tmp_dassem;
  curptr = tmp_curptr;
}


/*
 * resume_execution - check if iterative algorithm is to be resumed from some
 *                    previous point
 */
int resume_execution()
{
  char ch, str[MAXSTRING];
  int status;
  FILE *fp;

  if((fp = fopen("test.config", "r")) == NULL){
    fprintf(stderr, "File test.config not present\n");
    return FALSE;
  }

  status = FALSE;
  fgets(str, MAXSTRING-1, fp);
  while(!(feof(fp))){
    if((sscanf(str, "Resume Execution: %c\n", &ch)) == 1){
      if(ch=='y' || ch=='Y')
	status = TRUE;
    }
    fgets(str, MAXSTRING-1, fp);
  }
  fclose(fp);

  return status;
}


/*
 * find_curr_fn - check if records for the current function exist
 */
int find_curr_fn(char *fn, struct comb_struct *comb)
{
  int strlength, weight, s_option, p_size, g_size;
  char str[MAXSTRING], func[MAXSTRING];
  extern FILE *comb_log;

  /*get to the current function*/
  fgets(str, MAXSTRING-1, comb_log);
  while(!(feof(comb_log))){
    if((sscanf(str, "Function: %s\n", func)) == 1){
      if(strcmp(func, fn) == 0)
	break;
    }
    fgets(str, MAXSTRING-1, comb_log);
  }

  /*If we find the function, we also need to verify that we still have the
    same search parameters*/
  if(!(feof(comb_log))){

    fgets(str, MAXSTRING-1, comb_log);
    if((sscanf(str, "strlength: %d, weight: %d, search_option: %d, popu_size: %d gen_size: %d\n", &strlength, &weight, &s_option,
	       &p_size, &g_size)) == 5){
      if(strlength==comb->strlength && weight==comb->weight &&
	 s_option==comb->search_option && p_size==comb->popu_size &&
	 g_size==comb->gen_size)
	
	return TRUE;
    }
  }
  
  return FALSE;
}


/*
 * store_parameters - store the current iterative algorithm parameters to
 *                    file
 */
void store_parameters(char *fn, struct comb_struct *comb)
{
  char str[MAXSTRING];
  int analysis, flags;
  extern int resume_mode;
  extern FILE *comb_log;

  /*if resume_mode, then we only verify the parameters*/
  if(resume_mode){

    /*read the line expected next in the log file*/
    fgets(str, MAXSTRING-1, comb_log);
    if((sscanf(str, "Function Analysis: %d, Flags: %d\n", &analysis, &flags)) == 2){

      if(flags != comb->flags){
	fprintf(stderr, "Current search flags differ from previous flags. Compiler will generate different messages for the log file. Cannot continue resume mode. Exiting to preserve the log file.\n");
	exit(0);
      }
      if(analysis != comb->opt_mask){
	fprintf(stderr, "Function analysis mask differs for same function!!\n");
      }
    }
  }
  else{

    /*write the line to the comb file*/
    fprintf(comb_log, "Function: %s\n", fn);
    fprintf(comb_log, "strlength: %d, weight: %d, search_option: %d, popu_size: %d gen_size: %d\n", comb->strlength, comb->weight,
	    comb->search_option, comb->popu_size, comb->gen_size);
    fprintf(comb_log, "Function analysis: %d, Flags: %d\n",
	    comb->opt_mask, comb->flags);
  }
}

/*
 * resume_perf_num - read the perf execution numbers from the log file,
 *                   when in the resume execution mode
 */
int resume_perf_num(unsigned long long *s_measure,
		    unsigned long long *d_measure)
{
  unsigned long long eff;
  char str[MAXSTRING];
  extern FILE *comb_log;

  fgets(str, MAXSTRING-1, comb_log);
  if((sscanf(str, "codesize: %lld, inscount: %lld, effective: %lld\n",
	     s_measure, d_measure, &eff)) == 3){
    return TRUE;
  }

  /*could not find the expected line, stop resume mode*/
  return FALSE;
}

/*
 * log_active_seq - output the active sequence to file. In case we are
 *                  resuming execution, we do the reverse job of reading the
 *                  active sequence from file
 */
void log_active_seq(int seq_no, int *succ_num, int succ_phases[])
{
  char str[MAXSTRING], seq[MAXSTRING];
  int i, phase, count;
  extern int resume_mode;
  extern FILE *comb_log;

  if(resume_mode){

    /*read the line of active sequence*/
    fgets(str, MAXSTRING-1, comb_log);
    if((sscanf(str, "Active Sequence %d %[^\n]\n", &seq_no, seq)) == 2){
      count = 0;
      
      while((sscanf(seq, "%d %[^\n]", &phase, seq)) == 2)
	succ_phases[count++] = phase;
      if((sscanf(seq, "%d", &phase)) == 1)
	succ_phases[count++] = phase;
      *succ_num = count;      
    }
    else{
      fprintf(stderr, "Active sequence line expected in resume mode\n");
    }
  }
  else{
    fprintf(comb_log, "Active Sequence %d ", seq_no);
    for(i=0 ; i<*succ_num ; i++)
      fprintf(comb_log, "%d ", succ_phases[i]);
    fprintf(comb_log, "\n");
  }
}

/*
 * log_best_seq_msg - write best seq message to log file
 */
void log_best_seq_msg(double measure, long long sec, long long usec)
{
  char str[MAXSTRING];
  extern int resume_mode;
  extern FILE *comb_log;

  if(resume_mode){
    fgets(str, MAXSTRING-1, comb_log);
    if(strncmp(str, "This is best seq so far", 23) != 0){
      fprintf(stderr, "Best seq message expected in log file\n");
    }
  }
  else
    fprintf(comb_log, "This is best seq so far %lf, time: %lldsec %lldusec\n",
	    measure, sec, usec);
}

/*
 * log_random_numbers - record the number of random numbers generated for
 *                      debugging purposes
 */
void log_random_numbers()
{
  int res_rand;
  char str[MAXSTRING];
  extern unsigned long long tot_rand;
  extern FILE *comb_log;
  extern int resume_mode;
  
  if(resume_mode){
    /*get blank line*/
    fgets(str, MAXSTRING-1, comb_log);
    fgets(str, MAXSTRING-1, comb_log);
    if((sscanf(str, "Total Random numbers: %lld\n", &res_rand)) == 1){
      if(res_rand != tot_rand)
	fprintf(stderr, "Different random numbers in resume mode\n");
    }
    else{
      fprintf(stderr, "Expected 'Random Numbers' line not present in file in resume mode\n");
    }
  }
  else
    fprintf(comb_log, "\nTotal Random numbers: %lld\n", tot_rand);
}

/*
 * log_htable_msg - write htable match/not-match message in log file
 */
void log_htable_msg()
{
  char str[MAXSTRING];
  long log_ptr;
  extern FILE *comb_log;
  extern int resume_mode;  

  log_ptr = 0;
  if(resume_mode){
    log_ptr = ftell(comb_log);
    
    fgets(str, MAXSTRING-1, comb_log);
    if(strncmp(str, "Seq in htable", 13) != 0){
      fprintf(stderr, "Sequence expected in hashtable in resume mode\n");
      resume_mode = FALSE;
      fseek(comb_log, log_ptr, SEEK_SET);
    }
  }
  if(!resume_mode)
    fprintf(comb_log, "Seq in htable\n");
}

/*
 * log_valid_msg - write seq valid/invalid msg in log file
 */
void log_valid_msg(int is_valid)
{
  char str[MAXSTRING];
  long log_ptr;
  extern FILE *comb_log;
  extern int resume_mode;

  log_ptr = 0;
  
  if(is_valid){
    if(resume_mode){
      log_ptr = ftell(comb_log);
      fgets(str, MAXSTRING-1, comb_log);
      if(strncmp(str, "is valid", 8) != 0){
	fprintf(stderr, "Sequence expected to be valid in resume mode\n");
	resume_mode = FALSE;
	fseek(comb_log, log_ptr, SEEK_SET);
      }
    }
    if(!resume_mode)
      fprintf(comb_log, "is valid\n");
  }
  else{
    if(resume_mode){
      log_ptr = ftell(comb_log);
      fgets(str, MAXSTRING-1, comb_log);
      if(strncmp(str, "is invalid", 10) != 0){
	fprintf(stderr, "Sequence expected to be invalid in resume mode\n");
	resume_mode = FALSE;
	fseek(comb_log, log_ptr, SEEK_SET);
      }
    }
    else
      fprintf(comb_log, "is invalid\n");
  }
}

/*
 * log_link_error - write link error to file
 */
void log_error(char *error, int length)
{
  char str[MAXSTRING];
  extern FILE *comb_log;
  extern int resume_mode;

  if(resume_mode){
    fgets(str, MAXSTRING-1, comb_log);
    if(strncmp(str, error, length) != 0){
      fprintf(stderr, "%s message expected\n", error);
    }
  }
  else if(comb_log)
    fprintf(comb_log, "%s\n", error);
  else
    fprintf(stderr, "%s\n", error);
}

/*
 * map_phases_succ - In resume mode, get the attempted and active sequences
 *                   from the file and map the attempted sequence to active/
 *                   dormant phases
 */
void map_phases_succ(struct comb_struct *comb, int next_seq[],
		     int succ_map[], int att_seq[])
{
  int i, j, att_phase, succ_seq[MAX_OPT], scount;
  int log_ptr, seq_no, phase;
  char str[MAXSTRING], seq[MAXSTRING];
  extern FILE *comb_log;

  log_ptr = ftell(comb_log);
  
  /*get the active sequence from file*/
  fgets(str, MAXSTRING-1, comb_log);
  while(!(feof(comb_log))){
    if((sscanf(str, "Active Sequence %d %[^\n]\n", &seq_no, seq)) == 2){
      scount = 0;
      
      while((sscanf(seq, "%d %[^\n]", &phase, seq)) == 2)
	succ_seq[scount++] = phase;
      if((sscanf(seq, "%d", &phase)) == 1)
	succ_seq[scount++] = phase;
      break;
    }
    fgets(str, MAXSTRING-1, comb_log);
  }

  if(scount == 0){
    fprintf(stderr, "Active sequence not found\n");
  }
  else{
    /*get the mapping*/
    for(i=0, j=0 ; i<comb->strlength ; i++){
      att_phase = comb->base_opt[next_seq[i]];
      att_seq[i] = att_phase;

      if(succ_seq[j] == REG_ASSIGNMENT_TRANS)
	j++;
      if(j<scount && att_phase==succ_seq[j]){
	succ_map[i] = 1;
	j++;
      }
      else
	succ_map[i] = 0;
    }
  }

  /*reset file pointer*/
  fseek(comb_log, log_ptr, SEEK_SET);
}

/*
 * resume_hashvalues - read function hashvalues from log file during resuming
 *                     execution mode
 */
void resume_hashvalues(unsigned int *f_hash, unsigned int *CRC_reg,
		       int *rtl_count, int is_remap)
{
  char str[MAXSTRING];
  extern FILE *comb_log;

  fgets(str, MAXSTRING-1, comb_log);

  /*for normal function hash values*/
  if(!is_remap){
    if((sscanf(str, "Function hashvalues: %u, %u, %d\n",
	       f_hash, CRC_reg, rtl_count)) != 3){
      fprintf(stderr, "Function hashvalues line expected in resume log\n");
      *f_hash = *CRC_reg = *rtl_count = 0;
    }
  }
  /*for remapped hashvalues*/
  else{
    if((sscanf(str, "Remap function hashvalues: %u, %u, %d\n",
	       f_hash, CRC_reg, rtl_count)) != 3){
      fprintf(stderr, "Remap function hashvalues line expected in resume log\n");
      *f_hash = *CRC_reg = *rtl_count = 0;
    }
  }    
}

/*
 * log_hashvalues - record hashvalues for current function in log file
 */
void log_hashvalues(unsigned int f_hash, unsigned int CRC_reg,
		    int rtl_count, int is_remap)
{
  extern FILE *comb_log;

  if(!is_remap)
    fprintf(comb_log, "Function hashvalues: %u, %u, %d\n",
	    f_hash, CRC_reg, rtl_count);
  else
    fprintf(comb_log, "Remap function hashvalues: %u, %u, %d\n",
	    f_hash, CRC_reg, rtl_count);
}

/*
 * log_function_match_line - write appropriate message to the log file
 */
void log_function_match_line(int count, int is_remap)
{
  char str[MAXSTRING];
  extern FILE *comb_log;
  extern int resume_mode;

  if(resume_mode){

    /*read the line from file*/
    fgets(str, MAXSTRING-1, comb_log);

    if(!is_remap){
      if(strncmp(str, "same function repeated:", 23) != 0){
	fprintf(stderr, "same function repeated line expected in resume log\n");
      }
    }
    else{
      if(strncmp(str, "remapped function match:", 24) != 0){
	fprintf(stderr, "remapped function match line expected in resume log\n");
      }
    }      
  }
  else{
    if(!is_remap){
      fprintf(comb_log, "same function repeated: %d\n", count);
    }
    else{
      fprintf(comb_log, "remapped function repeated: %d\n", count);
    }
  }
}

/*
 * log_succ_seq_line - write the succ seq found line to file
 */
void log_succ_seq_line(int scount)
{
  char str[MAXSTRING];
  extern int resume_mode;
  extern FILE *comb_log;

  if(resume_mode){
    fgets(str, MAXSTRING-1, comb_log);

    if(strncmp(str, "successful sequence repeated:", 29) != 0){
      fprintf(stderr, "succ seq repeated line expected in log file\n");
    }
  }
  else{
    fprintf(comb_log, "successful sequence repeated: %d\n", scount);
  }
}


/*
 * ex_dfs_init - initialize structures for DFS exhaustive search
 */
void ex_dfs_init(int pc, int *analysis)
{
  int i, j, is_new, opt, rcount, fn_ins;
  int block, left, right, status;
  long long count;
  unsigned int CRC, fhash, r_CRC, r_fhash;
  char str[MAXSTRING], seq[MAXSTRING];
  FILE *fp;
  struct CFList *curr_cf, *p_cflist;
  struct BlockList *prev_bl;
  extern char pro_fbase[];
  extern int measure_flag, save_measure_flag, profile_cnt;
  extern int pro_opt_level, pro_cex_opt[MAX_PRO_LEVELS];
  extern struct FHASH *finst[FINDEX+1][F2INDEX+1], *r_finst[FINDEX+1][F2INDEX+1];
  extern struct CFList *cflist;
  extern char **pro_cex_file, *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
  extern struct dfs_struct dfs_level[MAX_PRO_LEVELS];
  extern struct command commands[MAXCMDS];
  extern int func_inst_cnt, phase_order[MAXPHASES], pro_is_fn_exec, ex_flags;

  /*initialize data structures*/
  for(i=0 ; i<=FINDEX ; i++){
    for(j=0 ; j<=F2INDEX; j++){
      finst[i][j] = (struct FHASH *)NULL;
      r_finst[i][j] = (struct FHASH *)NULL;
    }
  }
  cflist = NULL;
  ex_flags = 0;
  pro_opt_level = 0;
  func_inst_cnt = 0;
  profile_cnt = 0;
  p_cflist = curr_cf = NULL;

  /*store the unoptimized function instance*/
  store_as_cex(list_cex_files[pro_opt_level], 0, FALSE);
  
  /*initialize the array of stored cex files at each point*/
  for(i=pro_opt_level+1 ; i<MAX_PRO_LEVELS ; i++)
    list_cex_files[i][0] = NULL;
  
  /*create log file to dump information*/
  if((fp=fopen("curr_func_inst", "w")) == NULL){
    fprintf(stderr, "init_profile_func: file cannot be opened\n");
    exit(0);
  }
  fclose(fp);

  /*stop sending messages to viewer and stop writing messages to transform
    list*/
  save_measure_flag = measure_flag;
  measure_flag = TRUE;

  /* read the flags relating to compilation/execution and search options*/
  read_measure_flags();
  ex_flags = read_search_flags();

  /*if curr_func_inst.restart is present in the current directory, then this
    function was inappropriately terminated and needs to be re-started*/
  if((fp = fopen("curr_func_inst.restart", "r")) != NULL){

    /*initialize the CRC hash tables*/
    fgets(str, MAXSTRING-1, fp);
    if((sscanf(str, "Function Executed: %d\n", &opt)) == 1)
      pro_is_fn_exec = opt;
    is_new = FALSE;
    fgets(str, MAXSTRING-1, fp);
    while(!feof(fp)){

      if((strncmp(str, "New Function Instance", 21)) == 0){

	/*update the hash tables for the previous record. This is done
	  because we do not want to update the hash tables for the last
	  record. The last sequence would be attempted again*/
	if(is_new == TRUE){
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	  alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	}
	else if(is_new == 2)
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);	
	is_new = TRUE;
      }
      else if((strncmp(str, "Old Function Instance (remapped)", 31)) ==0){
	if(is_new == TRUE){
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	  alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	}
	else if(is_new == 2)
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	is_new = 2;
      }
      else if((strncmp(str, "Old Function Instance", 21)) == 0){
	if(is_new == TRUE){
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	  alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	}
	else if(is_new == 2)
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	is_new = FALSE;
      }
      else if((sscanf(str, "Sequence: %[^\n]", seq)) == 1){
      }
      else if((sscanf(str, "CRC: %u fhash: %u rcount: %d r_CRC: %u r_fhash: %u\n",
		      &CRC, &fhash, &rcount, &r_CRC, &r_fhash)) == 5){
      }
      else if((sscanf(str, "Function Instance: %d\n", &fn_ins)) == 1){

	/*initialize control flow pointer*/
	curr_cf = NULL;

	/*allocate a new record for this control flow instance*/
	curr_cf = new_cf(fn_ins, p_cflist);
	p_cflist = curr_cf;
	prev_bl = NULL;
      }
      else if((sscanf(str, "Number of Blocks: %d\n", &block)) == 1){

	if(!curr_cf){
	  fprintf(stderr, "Invalid order of lines read in from input file\n");
	  exit(0);
	}
	curr_cf->numBlocks = block;
      }
      else if((sscanf(str, "Block: %d Left: %d Right: %d Status: %d Counts: %lld\n",
		      &block, &left, &right, &status, &count)) == 5){

	if(!curr_cf){
	  fprintf(stderr, "Inavlid order of lines read in from input file\n");
	  exit(0);
	}
	prev_bl = update_cf_blk(curr_cf, prev_bl, block, left, right, status, count);
      }
      fgets(str, MAXSTRING-1, fp);
    }
    fclose(fp);

    /*move the file to the current working file*/
    strcpy(str, "mv curr_func_inst.restart curr_func_inst");
    system(str);

    /*build up the commands array from the last sequence encountered*/
    pc++;
    while((sscanf(seq, "%d %[^\n]", &opt, seq)) == 2){
      commands[pc++].oper = opt;
      if(opt == LOOP_UNROLL_TRANS)
	commands[pc-1].offset = 2;
      commands[pc++].oper = EX_DFS_REINIT;
    }
    if((sscanf(seq, "%d", &opt)) == 1){
      commands[pc++].oper = opt;
      if(opt == LOOP_UNROLL_TRANS)
	commands[pc-1].offset = 2;
      /*commands[pc++].oper = EX_DFS_REINIT;*/
    }
    commands[pc++].oper = EX_DFS;
    commands[pc++].oper = EX_DFS_END;
    commands[pc++].oper = QUIT_TRANS;
  }
  else{
    /*calculate and store the function instance information for the base
      unoptimized function*/
    log_profile_func(0, FALSE, analysis, FALSE);
    
    /*need to get back the original function*/
    undo_from_list(pro_opt_level+1);  
    
    /*initialize the array of future phases to apply*/
    commands[pc+1].oper = phase_order[0];
    commands[pc+2].oper = EX_DFS;
    commands[pc+3].oper = EX_DFS_END;
    commands[pc+4].oper = QUIT_TRANS;
  }
  
  /*start the depth first exhaustive search from the first phase in the
    sequence */
  dfs_level[pro_opt_level].opt_num = 0;
  dfs_level[pro_opt_level].opt = phase_order[0];
  dfs_level[pro_opt_level].prev_opt = -1;
  dfs_level[pro_opt_level].ex_trans_done = 0;
  dfs_level[pro_opt_level].optstr[0] = '\0';
  pro_cex_opt[pro_opt_level] = 0;
    
  /*increment the level to apply the first optimization phase*/
  pro_opt_level++;
}

/*
 * ex_dfs_reinit - called during re-starting of the DFS exhaustive search
 *                 after some fault
 */
void ex_dfs_reinit(int pc)
{
  int i, opt;
  extern int pro_opt_level, pro_cex_opt[MAX_PRO_LEVELS];
  extern char pro_fbase[];
  extern char **pro_cex_file, *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
  extern struct dfs_struct dfs_level[MAX_PRO_LEVELS];
  extern int phase_order[MAXPHASES];
  extern struct command commands[MAXCMDS];

  /*initialize the data structure at the previous level*/
  opt = commands[pc-1].oper;
  dfs_level[pro_opt_level - 1].opt = opt;
  for(i=0 ; phase_order[i]!=-1 ; i++){
    if(phase_order[i] == opt){
      dfs_level[pro_opt_level - 1].opt_num = i;
      break;
    }
  }
  if(pro_opt_level > 1)
    dfs_level[pro_opt_level - 1].prev_opt = dfs_level[pro_opt_level - 2].opt;
  
  /*store the current function instance at this level*/
  store_as_cex(list_cex_files[pro_opt_level], 0, FALSE);
  dfs_level[pro_opt_level].ex_trans_done = trans_done;
  sprintf(dfs_level[pro_opt_level].optstr, "%s %d",
	  dfs_level[pro_opt_level-1].optstr, opt);
  sprintf(pro_fbase, "%s ", dfs_level[pro_opt_level].optstr);
  pro_cex_opt[pro_opt_level] = opt;

  /*load the function again to make everything consistent with normal
    execution, otherwise there are some blank RTLs in the code*/
  /*undo_from_list(pro_opt_level+1);
    trans_done = dfs_level[pro_opt_level].ex_trans_done;*/

  /*we know that the next command in the commands array is the next
    optimization phase to be applied, since that is how we initialize the
    structure. If this is not the last opt. in the sequence then the
    structure at the same level will be re-initialized when we come back to
    this function, but it should not be a big overhead.*/
  opt = commands[pc+1].oper;
  dfs_level[pro_opt_level].opt = opt;
  for(i=0 ; phase_order[i]!=-1 ; i++){
    if(phase_order[i] == opt){
      dfs_level[pro_opt_level].opt_num = i;
      break;
    }
  }
  if(pro_opt_level)
    dfs_level[pro_opt_level].prev_opt = dfs_level[pro_opt_level - 1].opt;
  
  /*go to the next level*/
  pro_opt_level++;
}

/*
 * log_dfs_func - things to do after each phase is applied during a depth
 *                first search of the optimization phase order space
 */
void log_dfs_func(int change, int *valid_analysis, int *pc)
{
  int i, new_fn, opt, p_opt, curr_opt_num, level_change, curr_opt;
  unsigned int t_done;
  extern unsigned int trans_done;
  extern int func_inst_cnt, pro_opt_level, pro_cex_opt[MAX_PRO_LEVELS];
  extern char pro_fbase[];
  extern char **pro_cex_file, *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
  extern struct dfs_struct dfs_level[MAX_PRO_LEVELS];
  extern struct command commands[MAXCMDS];
  extern int phase_order[MAXPHASES];

  /*store trans_done, so that it can be restored after re-reading the
    function instance*/
  t_done = trans_done;
  
  /*determing the CRCs requires us to instrument the code with EASE and
    fixentry instructions which change the original function. So, we need to
    record the original function before doing that. If this function instance
    has been previously seen, then we waste the effort of recording it, but I
    do not see any way out of this as yet. If there were some way to tag the
    EASE/fixentry instructions then we could skip this step and do this
    later, only if the function instance is new*/
  new_fn = FALSE;
  if(change){
    store_as_cex(list_cex_files[pro_opt_level], 0, FALSE);
  
    /*check if the last optimization phase produced a change and record
      necessary information*/
    new_fn = log_profile_func(TRUE, change, valid_analysis, FALSE);
  }

  /*If this is a new function instance then we need to explore all the
    children of this node by applying all possible optimization phases to
    this node*/
  if(new_fn){
    
    /*read back the current function instance to get rid of unwanted
      statements inserted by EASE/fixentry*/
    undo_from_list(pro_opt_level + 1);
    *valid_analysis = 0;
    trans_done = t_done;
    
    /*store the current function instance at the current level*/
    opt = dfs_level[pro_opt_level-1].opt;
    pro_cex_opt[pro_opt_level] = opt;
    
    /*update data structures*/
    curr_opt_num = 0;
    curr_opt = phase_order[curr_opt_num];
    t_done = trans_done;
    while(((opt==phase_order[curr_opt_num]) ||
	   !is_opt_valid(curr_opt, &t_done)) && curr_opt!=-1){
      curr_opt_num++;
      curr_opt = phase_order[curr_opt_num];
      t_done = trans_done;
    }
    
    if(curr_opt != -1){
      dfs_level[pro_opt_level].opt_num = curr_opt_num;
      dfs_level[pro_opt_level].opt = phase_order[curr_opt_num];
      dfs_level[pro_opt_level].prev_opt = opt;
      dfs_level[pro_opt_level].ex_trans_done = trans_done;
      sprintf(dfs_level[pro_opt_level].optstr, "%s %d",
	      dfs_level[pro_opt_level-1].optstr, opt);
      sprintf(pro_fbase, "%s ", dfs_level[pro_opt_level].optstr);
      
      /*update commands array with next command to execute*/
      commands[*pc].oper = phase_order[curr_opt_num];
      commands[*pc+1].oper = EX_DFS;
      commands[*pc+2].oper = EX_DFS_END;
      commands[*pc+3].oper = QUIT_TRANS;
      *pc = *pc - 1;
      
      /*increment to start the next level*/
      pro_opt_level++;
    }
    else{
      /*should never happen since there is always atleast some phase valid
	after every phase in VPO*/
      fprintf(stderr, "Should never happen\n");
      exit(0);
    }
    func_inst_cnt++;
  }
  /*if this is not a new function instance, then we try to apply the next
    optimization phase in our list to the same instance. If there are no
    additional phases to apply then we backtrack to the previous level*/
  else{

    /*change the state to the next legal optimization phase at the current
      level*/
    curr_opt_num = dfs_level[pro_opt_level - 1].opt_num + 1;
    opt = phase_order[curr_opt_num];
    p_opt = dfs_level[pro_opt_level - 1].prev_opt;
    
    t_done = dfs_level[pro_opt_level - 1].ex_trans_done;
    while(((opt == p_opt) || !is_opt_valid(opt, &t_done)) && opt!=-1){
      curr_opt_num++;
      opt = phase_order[curr_opt_num];
      t_done = dfs_level[pro_opt_level - 1].ex_trans_done;
    }

    level_change = 0;
    while(pro_opt_level>1 && opt == -1){
      
      /*we now need to again start working on the function instance at the
	previous level*/
      pro_opt_level--;
      curr_opt_num = dfs_level[pro_opt_level - 1].opt_num + 1;
      opt = phase_order[curr_opt_num];
      p_opt = dfs_level[pro_opt_level - 1].prev_opt;

      t_done = dfs_level[pro_opt_level - 1].ex_trans_done;
      while(((opt == p_opt) || !is_opt_valid(opt, &t_done)) && opt!=-1){
	curr_opt_num++;
	opt = phase_order[curr_opt_num];
	t_done = dfs_level[pro_opt_level - 1].ex_trans_done;
      }
      level_change++;
    }
     
    if(pro_opt_level && opt != -1){

      /*read back the current working copy of the function, only if the
	current phase produced changes, which means that we calculated the
	CRC values for them, and thus changed the function, or if the level
	has changed, which implies that we have the read back some previous
	function instance*/
      if(change || level_change){
	undo_from_list(pro_opt_level);
	trans_done = dfs_level[pro_opt_level-1].ex_trans_done;
	*valid_analysis = 0;
      }

      /*update data structures*/
      dfs_level[pro_opt_level-1].opt_num = curr_opt_num;
      dfs_level[pro_opt_level-1].opt = phase_order[curr_opt_num];
      sprintf(pro_fbase, "%s ", dfs_level[pro_opt_level-1].optstr);
      
      /*go back 2 in the commands array to go back over EX_DFS and the last
       *optimization phase at this level*/
      *pc = *pc - (1 + level_change);
      opt = phase_order[curr_opt_num];
      commands[*pc].oper = opt;
      if(opt == LOOP_UNROLL_TRANS)
	commands[*pc].offset = 2;
      commands[*pc+1].oper = EX_DFS;
      commands[*pc+2].oper = EX_DFS_END;
      commands[*pc+3].oper = QUIT_TRANS;
      *pc = *pc - 1;
    }
  }
}


/*
 * init_profile_func - initialization to be done during profiling
 */
void init_profile_func(int level)
{
  char ch, str[MAXSTRING], line[MAXSTRING];
  unsigned int CRC, fhash, r_CRC, r_fhash;
  int i, j, rcount, is_func, cf_id, fn_ins, block, left, right, status;
  long file_offset;
  long long count;
  FILE *fp;
  struct CFList *curr_cf, *p_cflist;
  struct BlockList *prev_bl;
  extern int measure_flag, save_measure_flag;
  extern int cex_offset, pro_opt_level, pro_cex_opt[], pro_is_fn_exec;
  extern struct FHASH *finst[FINDEX+1][F2INDEX+1], *r_finst[FINDEX+1][F2INDEX+1];
  extern struct CFList *cflist;
  extern char **pro_cex_file, *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  for(i=0 ; i<=FINDEX ; i++){
    for(j=0 ; j<=F2INDEX ; j++){
      finst[i][j] = (struct FHASH *)NULL;
      r_finst[i][j] = (struct FHASH *)NULL;
    }
  }
  cflist = NULL;
  p_cflist = NULL;
  
  /*initilialize the structure of previous function instances seen*/
  if(level){
    
    if((fp=fopen("all_func_inst", "r")) == NULL){
      fprintf(stderr, "init_profile_func: File cannot be opened\n");
      exit(0);
    }

    fgets(str, MAXSTRING-1, fp);
    while(!feof(fp)){

      if((sscanf(str, "CRC: %u fhash: %u rcount: %d r_CRC: %u r_fhash: %u\n",
		 &CRC, &fhash, &rcount, &r_CRC, &r_fhash)) == 5){
	alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
      }
      else if((sscanf(str, "Control Flow Instance: %d\n", &cf_id)) == 1){
	/*allocate this controlflow id to this function instance*/

      }
      else if((sscanf(str, "Function Executed: %d\n", &pro_is_fn_exec)) == 1){
      }
      else if((sscanf(str, "Function Instance: %d\n", &fn_ins)) == 1){

	/*initialize control flow pointer*/
	curr_cf = NULL;

	/*allocate a new record for this control flow instance*/
	curr_cf = new_cf(fn_ins, p_cflist);
	p_cflist = curr_cf;
	prev_bl = NULL;
      }
      else if((sscanf(str, "Number of Blocks: %d\n", &block)) == 1){

	if(!curr_cf){
	  fprintf(stderr, "Inavlid order of lines read in from input file\n");
	  exit(0);
	}
	curr_cf->numBlocks = block;
      }
      else if((sscanf(str, "Block: %d Left: %d Right: %d Status: %d Counts: %lld\n",
		      &block, &left, &right, &status, &count)) == 5){

	if(!curr_cf){
	  fprintf(stderr, "Inavlid order of lines read in from input file\n");
	  exit(0);
	}
	prev_bl = update_cf_blk(curr_cf, prev_bl, block, left, right, status, count);
      }
      
      fgets(str, MAXSTRING-1, fp);
    }
    fclose(fp);

    /*debug code... remove later, allows to restart after error*/
    if(level > 100){

      if((fp=fopen("curr_func_inst", "r")) == NULL){
	fprintf(stderr, "init_profile_func: File cannot be opened\n");
	exit(0);
      }

      fgets(str, MAXSTRING-1, fp);
      while(!feof(fp)){

	if((sscanf(str, "CRC: %u fhash: %u rcount: %d r_CRC: %u r_fhash: %u\n",
		   &CRC, &fhash, &rcount, &r_CRC, &r_fhash)) == 5){
	  alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	  alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	}
	fgets(str, MAXSTRING-1, fp);
      }
      fclose(fp);
    }
    /*end of debug code*/
  }

  /*create log file to dump information*/
  if((fp=fopen("curr_func_inst", "w")) == NULL){
    fprintf(stderr, "init_profile_func: file cannot be opened\n");
    exit(0);
  }
  if(level)
    fprintf(fp, "Function Executed: %d\n", pro_is_fn_exec);
  fclose(fp);
  
  /*we can bookmark the function at this point*/

#ifndef WRITE_CEX
  
  /*for the ARM '*' does not always denote the end of the function. Sometimes
    it gives the information like the symbol table. '*' encountered after
    getting the function name though is always the end of the function*/
  is_func = FALSE;
  
  /*read the cex file again*/
  file_offset = ftell(stdin);
  if(fseek(stdin, cex_offset, SEEK_SET) == 0){

    pro_cex_file = (char **)list_cex_files[0];
    rcount = 0;
    ch = '0';
    fgets(str, MAXSTRING-1, stdin);
    while(!(feof(stdin) || (is_func && ch=='*'))){
      if(str[0] != '\n'){
	pro_cex_file[rcount] = (char *)myalloc_profile(strlen(str)+1);
	strcpy(pro_cex_file[rcount], str);
	if(pro_cex_file[rcount][strlen(str)-1] == '\n')
	  pro_cex_file[rcount][strlen(str)-1] = '\0';
	rcount++;
	ch = str[0];
	if(ch == 'f')
	  is_func = TRUE;
      }
      fgets(str, MAXSTRING-1, stdin);
    }
  }
  else
    fprintf(stderr, "init_profile_func: unable to seek\n");
  fseek(stdin, file_offset, SEEK_SET);

#else /*ifdef WRITE_CEX*/
  
  /*store the base cex file*/
  store_as_cex(list_cex_files[0], 0, FALSE);
  
  /*initialize the array of stored cex files at each point*/
  for(i=1 ; i<MAX_PRO_LEVELS ; i++)
    list_cex_files[i][0] = NULL;
  
  pro_opt_level = 1;
  pro_cex_opt[0] = 0;
  pro_cex_opt[1] = 0;
#endif

  /*stop sending messages to viewer and stop writing messages to transform
    list*/
  save_measure_flag = measure_flag;
  measure_flag = TRUE;
  
  read_measure_flags();
}

/*
 * read_measure_flags - set flags used by the measurement process
 */
void read_measure_flags()
{
  char ch, str[MAXSTRING], line[MAXSTRING];
  FILE *fp;
  extern int execute_status;
  
  /*determine the method of getting dynamic counts (EXECUTE, SIMULATE,
    COMPILE_ONLY, EASE) by reading from the test.config file*/
  execute_status = FALSE;
  if((fp = fopen("test.config", "r")) == NULL){
    fprintf(stderr, "File test.config not found\n");
    exit(0);
  }
  fgets(str, MAXSTRING, fp);
  while(!feof(fp)){
    if((sscanf(str, "EASE file: %s\n", line)) == 1){
      if(!(line[0]=='N' && line[1]=='O' && line[2]=='\0'))
	execute_status |= EASE;
    }
    else if((sscanf(str, "execution type: %c\n", &ch)) == 1){
      if(ch == 's' || ch == 'S')
	execute_status |= SIMULATE;
      else if(ch == 'e' || ch == 'E')
	execute_status |= EXECUTE;
      else if(ch == 'c' || ch == 'C')
	execute_status = COMPILE_ONLY;
    }
    fgets(str, MAXSTRING, fp);
  }
  fclose(fp);
}


/*
 * read_search_flags - read the flags relating to the configuration of the
 *                     exhaustive search
 */
int read_search_flags()
{
  int i, curr, flags = 0, opt;
  char str[MAXSTRING];
  FILE *fp;
  extern int phase_order[];

  if((fp = fopen("search.flags", "r")) == NULL){
    fprintf(stderr, "File search flags cannot be opened. Default search options assumed\n");
    return 0;
  }

  fgets(str, MAXSTRING, fp);
  while(!feof(fp)){
    if((sscanf(str, "Evaluation order determination and register assignment: %d",
	       &opt)) == 1){
      /*this option implies that EOD will never be performed explicitly, but
	will always be performed implicitly before register assignment. To
	implement this, it might be easiest to just change the phase_order
	array that contains the order of applying phases during exhaustive
	search*/
      for(i=0,curr=0 ; i<MAXPHASES ; i++){
	opt = phase_order[i];
	if(opt != EVAL_ORDER_DETER_TRANS)
	  phase_order[curr++] = phase_order[i];
      }
      phase_order[curr] = -1;
      flags |= (EOD_AND_RA);
    }
    fgets(str, MAXSTRING, fp);
  }
  fclose(fp);
  return flags;
}

/*
 * new_cf - allocate space and initialize structure for a new instance of
 *          control flow. Add the new structure after prev
 */
struct CFList *new_cf(int id, struct CFList *prev)
{
  struct CFList *new;
  extern struct CFList *cflist;

  new = (struct CFList *)myalloc_profile(sizeof(struct CFList));
  new->numBlocks = 0;
  new->serial_id = id;
  new->blist = NULL;
  new->next = NULL;

  if(!prev)
    cflist = new;
  else
    prev->next = new;

  return new;
}


/*
 * update_cf_blk - update the blocks record in the control flow instance
 */
struct BlockList * update_cf_blk(struct CFList *curr_cf, struct BlockList *prev,
	      int blk, int left, int right, int status, long long count)
{
  struct BlockList *new;

  new = (struct BlockList *)myalloc_profile(sizeof(struct BlockList));
  new->id = blk;
  new->left = left;
  new->right = right;
  new->status = status;
  new->exe_count = count;
  new->down = NULL;

  if(prev)
    prev->down = new;
  else
    curr_cf->blist = new;

  return new;
}

/*
 * block_cycles - simple simulation of a processor pipeline to return number
 *                of cycles
 */
long long block_cycles(struct bblock *cblk)
{
  int rnum, rtype, unit_avail[10], flag, is_exec;
  int i, rcount, dst, src1, cycle, src2, reg_avail[MAXREGS];
  double sup_cycle, est_cycle;
  struct list *ptr, *prev, *issue;

#ifdef EST_CYCLE
  
  sup_cycle = 0.0;
  rcount = 0;
  prev = NULL;
  fu_unit_init();
  for(i=0 ; i<MAXREGS ; i++)
    reg_avail[i] = 0;
  for(i=0 ; i<10 ; i++)
    unit_avail[i] = 0;

  /*repeat loop until there is something in any of the pipe stages*/
  issue = NULL;
  cycle = is_exec = 0;
  sup_cycle = 0.0;
  ptr = cblk->rtls;

  /*get the first RTL*/
  while(ptr && !cnts(ptr))
    ptr = ptr->next;
  if(cnts(ptr))
    issue = ptr;
  else
    return 0.0;
  
  do{
    cycle++;

    /*if there is something to execute then attempte to execute it during
      this cycle*/
    if(is_exec)
      is_exec = exec_ins(cycle);

    /*issue an instruction to execute*/
    if(issue && (is_exec=issue_ins(issue, &sup_cycle, cycle)))
      issue = NULL;
    
    /*fetch the next instrction*/
    if(!issue && ptr){
      ptr = ptr->next;
      while(ptr && !cnts(ptr))
	ptr = ptr->next;

      if(cnts(ptr))
	issue = ptr;
    }
  }while(issue || is_exec);

  /*subtract the number of cycles to fill the pipe*/
  /*est_cycle = (double)(cycle-1) + sup_cycle;
  return est_cycle;*/
  return (cycle - 1);
  
#else  
  
  rcount = getRTLCount(cblk);
  return rcount;
#endif  
}


/*
 * block_weight - block weight is a sum of the number of instructions, loads
 *                and number of potential stalls in this block
 */
double block_weight(struct bblock *cblk)
{
  char *rtlin;
  int rnum, rtype, unit_avail[10];
  int i, rcount, dst, src1, cycle, src2, reg_avail[MAXREGS];
  double sup_cycle, est_cycle;
  struct list *ptr, *prev;

#ifdef EST_CYCLE
  sup_cycle = 0.0;
  rcount = cycle = 0;
  prev = NULL;
  for(i=0 ; i<MAXREGS ; i++)
    reg_avail[i] = 0;
  for(i=0 ; i<10 ; i++)
    unit_avail[i] = 0;
  
  for(ptr=cblk->rtls ; ptr ; ptr=ptr->next){
    
    if(cnts(ptr)){
      
      /*add the number of cycles required for this instruction execution to
	determine when the destination register would be available*/
      cycle = ins_latency(ptr, cycle, &sup_cycle, reg_avail, unit_avail);
      
      rcount++;
      prev = ptr;
    }
  }

  est_cycle = (double)cycle /*+ sup_cycle*/;
  return est_cycle;
#else  
  
  rcount = getRTLCount(cblk);
  return (double)rcount;
#endif  
}


/*
 * get_func_cf - get the function control flow and compare it with all
 *               previously encountered function instances to check for
 *               match. Return a pointer to the current record
 */
struct CFList *get_func_cf(int *is_new)
{
  int i, numBlocks, next_num, serial_id, block_map[MAX_BLOCKS];
  struct bblock *cblk, *left, *right;
  struct CFList *curr_cf, *cfptr, *prev_cfptr;
  struct BlockList *bl, *lbl, *bl1, *bl2;
  extern struct bblock *top;
  extern struct CFList *cflist;

  for(i=0 ; i<MAX_BLOCKS ; i++)
    block_map[i] = 0;
  
  /*scan the down list and assign a number to each block in order of their
    position in the down list*/
  numBlocks = 0;
  for(cblk=top ; cblk ; cblk=cblk->down){
    if(cblk->block_id >= MAX_BLOCKS){
      fprintf(stderr, "get_fun_cf: Max block id number exceeds array dimension\n");
      exit(0);
    }
    block_map[cblk->block_id] = ++numBlocks;
  }
  /*account for any blocks not present in the down list but present in the
    next list*/
  next_num = numBlocks;
  for(cblk=top ; cblk ; cblk=cblk->next){
    if(!block_map[cblk->block_id])
      block_map[cblk->block_id] = ++next_num;
  }

  /*search the list to check for a match */
  serial_id = 1;
  prev_cfptr = NULL;
  *is_new = TRUE;
  for(cfptr=cflist ; cfptr ; cfptr=cfptr->next){

    if(cfptr->numBlocks == numBlocks){

      bl1 = cfptr->blist;
      cblk = top;
      left = cblk->left;
      right = cblk->right;
      *is_new = FALSE;
      for(i=0 ; i<numBlocks ; i++){
	left = cblk->left;
	right = cblk->right;
	if(((bl1->left==0 && left!=NULL) || (bl1->left!=0 && left==NULL) ||
	    (bl1->left!=0 && left!=NULL && bl1->left!=block_map[left->block_id])) ||
	   ((bl1->right==0 && right!=NULL) || (bl1->right!=0 && right==NULL) ||
	    (bl1->right!=0 && right!=NULL && bl1->right!=block_map[right->block_id])) ||
	   ((cblk->status & UNROLLED)!=bl1->status)){

	  /*left and right do not point to equivalent control flow points*/
	  *is_new = TRUE;
	  break;
	}
	bl1 = bl1->down;
	cblk = cblk->down;
      }

      /*if this control flow has been previously seen*/
      if(!(*is_new))
	return cfptr;
    }
    serial_id++;
    prev_cfptr = cfptr;
  }

  /*this is a previously unseen control flow. Add this to the list*/

  /*store the CF structure*/
  curr_cf = (struct CFList *)myalloc_profile(sizeof(struct CFList));
  curr_cf->serial_id = serial_id;
  curr_cf->numBlocks = numBlocks;
  curr_cf->blist = NULL;
  curr_cf->next = NULL;
  for(cblk=top ; cblk ; cblk=cblk->down){
    bl = (struct BlockList *)myalloc_profile(sizeof(struct BlockList));
    bl->id = block_map[cblk->block_id];
    bl->exe_count = 0;
    /*bl->cycle = getRTLCount(cblk);*/
    bl->cycle = block_cycles(cblk);
    /*bl->rcount = getRTLCount(cblk);*/
    bl->rcount = 0;
    if(cblk->status & UNROLLED)
      bl->status = UNROLLED;
    else
      bl->status = 0;
    if(cblk->left)
      bl->left = block_map[cblk->left->block_id];
    else
      bl->left = 0;
    if(cblk->right)
      bl->right = block_map[cblk->right->block_id];
    else
      bl->right = 0;
    bl->down = NULL;

    if(curr_cf->blist == NULL)
      curr_cf->blist = bl;
    else
      lbl->down = bl;
    lbl = bl;
  }

  /*update list of all function control flows*/
  if(prev_cfptr)
    prev_cfptr->next = curr_cf;
  else
    cflist = curr_cf;

  return curr_cf;
}


/*
 * end_profile_func - dump the information about function control flows to
 *                    log file 
 */
void end_profile_func()
{
  int i;
  struct BlockList *bl;
  struct CFList *cfptr;
  FILE *fp;
  extern int func_inst_cnt, profile_cnt, measure_flag, save_measure_flag;
  extern struct CFList *cflist;

  /*dump information about function control flows to log file*/
  if((fp=fopen("curr_func_inst", "a")) == NULL){
    fprintf(stderr, "end_profile_func: file cannot be opened\n");
    exit(0);
  }

  fprintf(fp, "Distinct Function Instances: %d\n", func_inst_cnt);
  fprintf(fp, "Optimization Phases Attempted: %d\n", profile_cnt);
  /*for(cfptr=cflist ; cfptr ; cfptr=cfptr->next){
    fprintf(fp, "Function Instance: %d\n", cfptr->serial_id);
    fprintf(fp, "Number of Blocks: %d\n", cfptr->numBlocks);
    for(bl=cfptr->blist ; bl ; bl=bl->down)
      fprintf(fp, "Block: %d Left: %d Right: %d Status: %d Counts: %lld\n",
	      bl->id, bl->left, bl->right, bl->status, bl->exe_count);
	      }*/

  fclose(fp);

  measure_flag = save_measure_flag;
}


/*
 * alloc_rec - allocate function instance record during profiling
 */
void alloc_rec(unsigned int CRC, unsigned int fhash, int rcount,
	       unsigned int r_CRC, unsigned int r_fhash)
{
  int i, hash, hash2;
  struct FHASH *new, *ptr;
  extern struct FHASH *finst[FINDEX+1][F2INDEX+1];

  /*allocate a new record structure*/
  new = (struct FHASH *)myalloc_profile(sizeof(struct FHASH));
  new->CRC = CRC;
  new->fhash = fhash;
  new->rcount = rcount;
  new->r_CRC = r_CRC;
  new->r_fhash = r_fhash;
  new->next = NULL;

  /*insert the record in the proper bucket*/
  hash = fhash & FINDEX;
  hash2 = CRC & F2INDEX;
  if(finst[hash][hash2] != NULL){
    new->next = finst[hash][hash2];
    finst[hash][hash2] = new;
    /*for(ptr=finst[hash] ; ptr->next ; ptr=ptr->next);
      ptr->next = new;*/
  }
  else
    finst[hash][hash2] = new;  
}


/*
 * alloc_remap_rec - allocate function instance record during profiling
 */
void alloc_remap_rec(unsigned int CRC, unsigned int fhash, int rcount,
	       unsigned int r_CRC, unsigned int r_fhash)
{
  int i, hash, hash2;
  struct FHASH *new, *ptr;
  extern struct FHASH *r_finst[FINDEX+1][F2INDEX+1];

  /*allocate a new record structure*/
  new = (struct FHASH *)myalloc_profile(sizeof(struct FHASH));
  new->CRC = CRC;
  new->fhash = fhash;
  new->rcount = rcount;
  new->r_CRC = r_CRC;
  new->r_fhash = r_fhash;
  new->next = NULL;

  /*insert the record in the proper bucket*/
  hash = r_fhash & FINDEX;
  hash2 = r_CRC & F2INDEX;
  if(r_finst[hash][hash2] != NULL){
    new->next = r_finst[hash][hash2];
    r_finst[hash][hash2] = new;
    /*for(ptr=r_finst[hash] ; ptr->next ; ptr=ptr->next);
      ptr->next = new;*/
  }
  else
    r_finst[hash][hash2] = new;  
}



/*
 * find_rec - check if a similar record already exists in the list of
 *            function instances
 */
int find_rec(unsigned int CRC, unsigned int fhash, int rcount,
	     unsigned int *r_CRC, unsigned int *r_fhash)
{
  int hash, hash2;
  struct FHASH *ptr;
  extern struct FHASH *finst[FINDEX+1][F2INDEX+1];

  hash = fhash & FINDEX;
  hash2 = CRC & F2INDEX;
  for(ptr=finst[hash][hash2] ; ptr ; ptr=ptr->next){

    if(ptr->CRC==CRC && ptr->fhash==fhash && ptr->rcount==rcount){
      *r_CRC = ptr->r_CRC;
      *r_fhash = ptr->r_fhash;
      return TRUE;
    }
  }
  return FALSE;
}


/*
 * find_remap_rec - check if a similar record already exists in the list of
 *                  function instances based on remaped hash values
 */
int find_remap_rec(unsigned int CRC, unsigned int fhash, int rcount,
		   unsigned int r_CRC, unsigned int r_fhash)
{
  int hash, hash2;
  struct FHASH *ptr;
  extern struct FHASH *r_finst[FINDEX+1][F2INDEX+1];

  hash = r_fhash & FINDEX;
  hash2 = r_CRC & F2INDEX;
  for(ptr=r_finst[hash][hash2] ; ptr ; ptr=ptr->next){

    if(ptr->r_CRC==r_CRC && ptr->r_fhash==r_fhash && ptr->rcount==rcount)
      return TRUE;
  }
  return FALSE;
}


#ifdef WRITE_CEX

void store_profile_base(char **seq, char base[])
{
  char str[MAXSTRING], opt_str[MAXSTRING];
  int opt, i, first;
  extern int pro_is_cex_file, pro_opt_level, pro_cex_opt[];
  extern char **pro_cex_file;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  first = TRUE;
  pro_opt_level = 1;
  base[0] = '\0';
  strcpy(str, *seq);

  while((sscanf(str, "%s %[^\n]", opt_str, str)) == 2){
    
    sscanf(opt_str, "%d", &opt);
    if(opt == PROFILE_FUNC_SAVE)
      break;
    if(pro_cex_opt[pro_opt_level]==opt){
      pro_opt_level++;
      get_num(seq, &i);
    }
    else{
      if(first){

	pro_is_cex_file = TRUE;
	pro_cex_file = (char **)list_cex_files[pro_opt_level-1];
	undo_transes(-1);
	pro_is_cex_file = FALSE;
	pro_cex_opt[pro_opt_level] = 0;
	for(i=1 ; i<pro_opt_level ; i++)
	  trans_done |= (1 << pro_cex_opt[i]);
	first = FALSE;
      }
    }
    sprintf(base, "%s%s ", base, opt_str);
  }
}

#else /*if not WRITE_CEX

/*
 * store_profile_base - store base optimization sequence
 */
void store_profile_base(char **seq, char base[])
{
  char str[MAXSTRING], opt_str[MAXSTRING];
  int opt;
  static int first=TRUE;
  extern int pro_is_cex_file, pro_opt_level, pro_cex_opt[];
  extern char **pro_cex_file;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  /*we need to undo the transes, except for the first time*/
  pro_is_cex_file = TRUE;
  pro_cex_file = (char **)list_cex_files[0];
  if(!first)
    undo_transes(-1);
  pro_is_cex_file = FALSE;
  
  first = FALSE;
  base[0] = '\0';
  strcpy(str, (*seq));

  while((sscanf(str, "%s %[^\n]", opt_str, str)) == 2){
    
    sscanf(opt_str, "%d", &opt);
    if(opt == PROFILE_FUNC_SAVE)
      break;
    sprintf(base, "%s%s ", base, opt_str);
  }
}

#endif /*WRITE_CEX*/

/*
 * store_profile_func - store a copy of the function instance after only the
 *                      base sequence has been applied
 */
void store_profile_func()
{
  extern unsigned int base_CRC, base_fhash;
  extern int base_rcount;

  /*I have observed that many phases which are recorded as having changed the
    function produce no discernible change to the function produced after
    base sequence been applied. We store the function instance at this point
    and if it remains the same after some optimization, we do not need to
    undo and reapply base sequence*/
  base_rcount = get_func_hash(&base_CRC, &base_fhash, FALSE, 0);
}


/*
 * get_dy_ease_counts - calculate the dynamic counts from those recorded in
 *                      the control flow structure
 */
long long get_dy_ease_counts(struct CFList *func_cf, int new_cf)
{
  double t_dy_count;
  long long dy_count;
  int blk_rtl;
  struct bblock *cblk;
  struct BlockList *blk;
  extern struct bblock *top;

  dy_count = 0;
  t_dy_count = 0.0;
  for(blk=func_cf->blist ; blk ; blk=blk->down){
    t_dy_count += blk->cycle * (double)blk->exe_count;
  }

  dy_count = (long long)t_dy_count;
  return dy_count;
}


/*
 * get_batch_exec_counts - get execution counts for executed functions
 */
void get_batch_exec_counts(int *rcount, int *dy_count)
{
  char str[MAXSTRING], file[MAXSTRING];
  long long dy, sim_count;
  int cs, new_cf, flag;
  struct CFList *b_cf;
  FILE *fp, *ofp;
  extern char *fn;
  extern int execute_status, valid_analysis;

  /*only get measures for functions which are executed. This information is
    read from the file "exec_funclist" in the current directory*/
  if((fp=fopen("exec_funclist", "r")) == NULL){
    fprintf(stderr, "File exec_funclist cannot be opened\n");
    return;
  }

  /*open output file*/
  sprintf(file, "%s_batch.txt", fn);
  if((ofp = fopen(file, "w")) == NULL){
    fprintf(stderr, "File %s cannot be opened\n", file);
    exit(0);
  }
  cs = count_RTL();
  dy = sim_count = 0;
  flag = FALSE;
  fgets(str, MAXSTRING, fp);
  while(!feof(fp)){
    if(strncmp(str, fn, strlen(str)-1) == 0){

      apply_epilogue_trans(&valid_analysis);

      b_cf = (struct CFList *)get_func_cf(&new_cf);
      get_measure(NULL, 0);
      if(execute_status & SIMULATE && !(execute_status & EASE))
	dy = get_sim_counts(NULL);
      else if(execute_status & EASE){
	read_ease_counts(b_cf);
	dy = get_dy_ease_counts(b_cf, TRUE);
      }
      if(dy_count){
	if(dy)
	  *dy_count = dy;
      }
      if(rcount)
	*rcount = cs;
      if(dy_count==NULL){
	fprintf(stdout, "Function: %s Codesize: %d Dy. Count: %lld\n",
		fn, cs, dy);
      }
      flag = TRUE;
      break;
    }
    fgets(str, MAXSTRING, fp);
  }
  
  if(!flag && dy)
    fprintf(stdout, "Function: %s Codesize: %d Dy. Count: %lld\n",
	    fn, cs, dy);
  fclose(fp);
  if(ofp){
    fprintf(ofp, "Function: %s Codesize: %d Dy. Count: %lld\n",
	    fn, cs, dy);
    fclose(ofp);
  }
}

/*
 * is_func_exec - determine if the current function is executed by scanning
 *                for the current function name in the file "exec_funclist"
 */
int is_func_exec()
{
  char str[MAXSTRING];
  extern char *fn;
  FILE *fp;

  if((fp=fopen("exec_funclist", "r")) == NULL){
    fprintf(stderr, "File exec_funclist cannot be opened\n");
    return TRUE;
  }

  fgets(str, MAXSTRING, fp);
  while(!feof(fp)){
    if(strncmp(str, fn, strlen(str)-1) == 0){
      return TRUE;
    }
    fgets(str, MAXSTRING, fp);
  }

  return FALSE;
}

/*
 * ind_seq_init - initialization
 */
int ind_seq_init()
{
  int i, is_exec;
  extern char *fn;
  extern struct CFList *cflist;
  extern struct perf_hash *ind_hash[FINDEX];

  fprintf(stdout, "Function: %s\n", fn);
  for(i=0 ; i<FINDEX ; i++)
    ind_hash[i] = (struct perf_hash *)NULL;
  cflist = NULL;

  is_exec = is_func_exec();
  return is_exec;
}


/*
 * func_found - scan hashtable to search for function instance
 */
long long func_found(unsigned int CRC, unsigned int fhash)
{
  int hash;
  struct perf_hash *ptr;
  extern struct perf_hash *ind_hash[FINDEX];

  hash = fhash % FINDEX;
  for(ptr=ind_hash[hash] ; ptr ; ptr=ptr->next){
    if(ptr->CRC==CRC && ptr->fhash==fhash){
      return ptr->d_measure;
    }
  }

  return 0;
}

/*
 * add_func - add function instance record to the hashtable
 */
struct perf_hash *add_func_hash(unsigned int CRC, unsigned int fhash)
{
  int hash;
  struct perf_hash *ptr, *new;
  extern struct perf_hash *ind_hash[FINDEX];

  new = (struct perf_hash *)myalloc_profile(sizeof(struct perf_hash));
  new->CRC = CRC;
  new->fhash = fhash;
  new->d_measure = 0;
  new->next = NULL;

  hash = fhash % FINDEX;
  if(ind_hash[hash] != NULL){
    new->next = ind_hash[hash];
    ind_hash[hash] = new;
  }
  else
    ind_hash[hash] = new;

  return new;
}

/*
 * ind_seq_measure - measure the performance of this sequence
 */
void ind_seq_measure(long long *cs, long long *dy, int is_exec)
{
  int i, rcount, new_cf, status;
  unsigned int CRC, fhash;
  long long dy_count;
  struct CFList *func_cf;
  struct bblock *cblk;
  struct BlockList *bl;
  struct perf_hash *hash_ptr;
  extern struct bblock *top;
  extern int valid_analysis, execute_status;

  /*apply the compulsory phases before getting performance counts*/
  apply_epilogue_trans(&valid_analysis);
  rcount = count_RTL();

  /*get the remaped checksum. We only execute if the checksums are distinct*/
  if(is_exec){
    get_func_hash(&CRC, &fhash, TRUE, &valid_analysis);
    if(dy_count = func_found(CRC, fhash)){
      *cs = rcount;
      *dy = dy_count;
      fprintf(stderr, "Execution Status: found in hashtable\n");
      fprintf(stdout, "Codesize: %d Dy_count: %lld\n", rcount, dy_count);
      undo_transes(-1);
      return;
    }
    hash_ptr = add_func_hash(CRC, fhash);
  }
  
  
  func_cf = get_func_cf(&new_cf);
#if 1
  new_cf = TRUE;
#endif  
  
  status = 0;
  dy_count = 0;
  if(is_exec){
    if(!new_cf){
      for(cblk=top, bl=func_cf->blist ; bl ; bl=bl->down){
	bl->cycle = block_weight(cblk);
	cblk = cblk->down;
      }
    }

    if(new_cf){
      status = get_measure(NULL, 0);
      fprintf(stderr, "Execution Status: %d\n", status);

      if((execute_status & SIMULATE) && !(execute_status & EASE))
	dy_count = get_sim_counts(NULL);
      else if(execute_status & EASE){
	read_ease_counts(func_cf);
	dy_count = get_dy_ease_counts(func_cf, new_cf);
      }
    }
    else{
      undo_transes(-1);
      if(execute_status & EASE)
	dy_count = get_dy_ease_counts(func_cf, new_cf);
    }
    hash_ptr->d_measure = dy_count;
  }
  else
    undo_transes(-1);

  if(!status){
    *cs = rcount;
    *dy = dy_count;
  }
  else{
    *cs = INFINITY;
    *dy = INFINITY;
  }
  fprintf(stdout, "Codesize: %d Dy_count: %lld\n", rcount, dy_count);
}


/*
 * log_profile_func - if this function instance has not been seen before then
 *                    make an entry in the log file
 */
int log_profile_func(int level, int change, int *analysis, int is_undo)
{
  char pfname[MAXSTRING];
  int i, hash, rcount, new_cf, new_fn, blk_rtl, status;
  unsigned int CRC, fhash, r_CRC, r_fhash;
  long long dy_count, sim_count;
  FILE *fp;
  struct BlockList *bl;
  struct bblock *cblk;
  struct CFList *func_cf;
  extern struct command commands[];
  extern unsigned int base_CRC, base_fhash;
  extern int base_rcount, pro_opt_level, pro_cex_opt[];
  extern int pc, pro_apply_base, pro_is_cex_file, pro_is_fn_exec;
  extern int execute_status, profile_cnt;
  extern char pro_fbase[];
  extern char **pro_cex_file;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
  extern struct bblock *top;

  if((fp=fopen("curr_func_inst", "a")) == NULL){
    fprintf(stderr, "log_profile_func: file cannot be opened\n");
    exit(0);
  }
  dy_count = sim_count = 0;
  new_fn = FALSE;
  new_cf = FALSE;
  
  /*for level 0 simply make an entry in the log file*/
  if(!level){

    /*calculate the hash value for this function instance*/
    rcount = get_func_hash(&CRC, &fhash, FALSE, analysis);

    /*calculate and store the remap hash value for this function instance*/
    /*get_func_hash(&r_CRC, &r_fhash, SAME_PSEUDO_REG, analysis);*/
    /*get_func_hash(&r_CRC, &r_fhash, LIVE_REG_STATE, analysis);*/
    get_func_hash(&r_CRC, &r_fhash, TRUE, analysis);

    alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
    alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);

    /*store the CF info for the base function instance*/
    func_cf = get_func_cf(&new_cf);

    if(!(execute_status & COMPILE_ONLY)){
      get_measure(NULL, -1);
      if(execute_status & SIMULATE)
	sim_count = get_sim_counts(NULL);
      else if(execute_status & EASE){
	read_ease_counts(func_cf);
	dy_count = get_dy_ease_counts(func_cf, new_cf);
      }
    }
	
    if(dy_count || sim_count)
      pro_is_fn_exec = TRUE;
    else
      pro_is_fn_exec = FALSE;

    fprintf(fp, "Function Executed: %d\n", pro_is_fn_exec);
    fprintf(fp, "New Function Instance\n");
    fprintf(fp, "CRC: %u fhash: %u rcount: %d r_CRC: %u r_fhash: %u\n",
	    CRC, fhash, rcount, r_CRC, r_fhash);
    /*fprintf(fp, "Unique Changes: %d\n", change);*/
    fprintf(fp, "Sequence:  \n");
    fprintf(fp, "Control Flow Instance: %d Dynamic Count: %lld Simulator Count: %lld\n",
	    func_cf->serial_id, dy_count, sim_count);
    new_fn = TRUE;
  }
  else if(change){
    func_cf = NULL;
    
    /*calculate the hash value for this function instance*/
    rcount = get_func_hash(&CRC, &fhash, FALSE, analysis);

    /*verify that this function instance is not identical to the base
      function instance*/
    if(!(CRC==base_CRC && fhash==base_fhash && rcount==base_rcount)){
    
      /*check if this function instance has already been encountered before*/
      if(!find_rec(CRC, fhash, rcount, &r_CRC, &r_fhash)){

	/*check if remapped function instance has been previously seen*/
	/*get_func_hash(&r_CRC, &r_fhash, SAME_PSEUDO_REG, analysis);*/
	/*get_func_hash(&r_CRC, &r_fhash, LIVE_REG_STATE, analysis);*/
	get_func_hash(&r_CRC, &r_fhash, TRUE, analysis);

	if(!find_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash)){

	  /*this is a completely new function instance*/
	  alloc_remap_rec(CRC, fhash, rcount, r_CRC, r_fhash);
	  fprintf(fp, "New Function Instance\n");
	  new_fn = TRUE;

	  /*get function control flow information*/
	  func_cf = get_func_cf(&new_cf);

	  /*store the RTL counts in the CF structure*/
	  if(!new_cf){
	    for(cblk=top, bl=func_cf->blist ; bl ; bl=bl->down){
	      bl->cycle = block_cycles(cblk);
	      bl->rcount = 0;
	      /*bl->cycle = getRTLCount(cblk);*/
	      cblk = cblk->down;
	    }
	  }
#if 0
	  /*To simulate all distinct function instances regardless of control
	    flow we consider each CF distinct*/
	  new_cf = TRUE;/* */
#endif
	
	  /*get the block counts for this instance of the control flow. For
	    this we need to simulate/execute the application. Don't re-apply
	    previous transformations since we are going to read the .cex file
	    with changes from memory. Note that this will only work if
	    WRITE_CEX is on, since otherwise the .cex file read in has not
	    applied the base sequence, so the number of blocks might be
	    different from the blocks after opts*/
	  dy_count = sim_count = 0;
      
	  if(pro_is_fn_exec){
	    if(new_cf){
	      status = get_measure(NULL, -1);
	      fprintf(fp, "Execution Status: %d\n", status);
	    }
	    if(new_cf && (execute_status & SIMULATE))
	      sim_count = get_sim_counts(NULL);
	  
	    /*instead of using genreport of reading the simulated cycle counts,
	      here we need to read the number of number each block was
	      executed. Record the counts in the frequency field of each basic
	      block*/ 
	    if(execute_status & EASE){
	      if(new_cf)
		read_ease_counts(func_cf);
	      dy_count = get_dy_ease_counts(func_cf, new_cf);
	    }
	  }
	}
	else
	  fprintf(fp, "Old Function Instance (remapped)\n");
	
	alloc_rec(CRC, fhash, rcount, r_CRC, r_fhash);
      }
      else
	fprintf(fp, "Old Function Instance\n");

      fprintf(fp, "CRC: %u fhash: %u rcount: %d r_CRC: %u r_fhash: %u\n",
	      CRC, fhash, rcount, r_CRC, r_fhash);
      /*fprintf(fp, "Unique Changes: %d\n", change);*/
      if(commands[pc-2].oper == REG_ASSIGNMENT_TRANS)
	fprintf(fp, "Sequence: %s%d %d\n",
		pro_fbase, commands[pc-2].oper, commands[pc-1].oper);
      else
	fprintf(fp, "Sequence: %s%d\n", pro_fbase, commands[pc-1].oper);
	/*fprintf(fp, "Sequence: %s%d ,%d\n", pro_fbase, commands[pc-1].oper, profile_cnt);*/
      fprintf(fp, "Profile Count: %d\n", profile_cnt);
      if(func_cf)
	fprintf(fp, "Control Flow Instance: %d Dynamic Count: %lld Simulator Count: %lld\n",
		func_cf->serial_id, dy_count, sim_count);

      /*if the last sequence produced a change, then we need to get back to the
	point right after applying the base sequence to try out the next
	opt. sequence */
      if(is_undo)
	undo_from_list(pro_opt_level);
      
      /*re-apply base sequence, we should never have to re-apply base*/
#ifdef WRITE_CEX
      pro_apply_base = FALSE;
#else
      pro_apply_base = TRUE;
#endif /*WRITE_CEX*/      
    }
    else
      pro_apply_base = FALSE;
  }
  else
    pro_apply_base = FALSE;

  /*dump the control flow information if required*/
  if(new_cf){
    fprintf(fp, "Function Instance: %d\n", func_cf->serial_id);
    fprintf(fp, "Number of Blocks: %d\n", func_cf->numBlocks);
    for(bl=func_cf->blist ; bl ; bl=bl->down)
      fprintf(fp, "Block: %d Left: %d Right: %d Status: %d Counts: %lld\n",
	      bl->id, bl->left, bl->right, bl->status, bl->exe_count);
  }
    
  fflush(fp);
  fclose(fp);
  return(new_fn);
}


/*
 * dump_paths_recur - recursive function dump all basic block paths
 */
void dump_paths_recur(struct bblock *blk, int plist[], int len, FILE *fp)
{
  int i, seen, flag;

  seen = FALSE;
  blk->status |= DONE;
  
  if(blk->left){

    flag = FALSE;
    for(i=0 ; i<len ; i++){
      if(plist[i] == blk->left->block_id){
	flag = TRUE;
	break;
      }
    }
    if(!flag){
      plist[len] = blk->block_id;
      dump_paths_recur(blk->left, plist, len+1, fp);
      seen = TRUE;
    }
  }
  if(blk->right){

    flag = FALSE;
    for(i=0 ; i<len ; i++){
      if(plist[i] == blk->right->block_id){
	flag = TRUE;
	break;
      }
    }
    if(!flag){
      plist[len] = blk->block_id;
      dump_paths_recur(blk->right, plist, len+1, fp);
      seen = TRUE;
    }
  }    

  /*print out the path if this is a leaf block*/
  if(!seen){
    for(i=0 ; i<len ; i++)
      fprintf(fp, "%d ", plist[i]);
    fprintf(fp, "%d\n", blk->block_id);
  }
}

/*
 * dump_paths - setup function to dump all basic block paths
 */
void dump_paths()
{
  int i;
  int plist[MAX_BLOCKS];
  char str[MAXSTRING];
  struct bblock *cblk;
  FILE *fp;
  extern char *fn;
  
  /*open file for writing the list of all possible program paths*/
  sprintf(str, "%s.paths", fn);
  if((fp = fopen(str, "w")) == NULL){
    fprintf(stderr, "File %s cannot be opened for writing\n", str);
    return;
  }

  /*reset the 'done' bit for each basic block*/
  for(cblk=top ; cblk ; cblk=cblk->down)
    cblk->status &= ~DONE;
  
  /*recursively call this function on the two subgraphs of this node*/
  dump_paths_recur(top, plist, 0, fp);
}


/*
 * requires_RA - returns true if the phase passed requires register
 * assignment
 */
int requires_RA(int phase)
{
  switch(phase){
  case DEAD_ASG_ELIM_TRANS:
  case REG_ALLOCATION_TRANS:
  case COMMON_SUBEXPR_ELIM_TRANS:
  case CODE_MOTION_TRANS:
  case LOOP_STRENGTH_REDUCT_TRANS:
  case RECURRENCE_ELIM_TRANS:
  case INDUCT_VAR_ELIM_TRANS:
  case ALL_LOOP_TRANS:
  case PREDICATION_TRANS:
  case STRENGTH_REDUCT_TRANS:
  case FIX_ENTRY_EXIT_TRANS:
  case INST_SCHED_TRANS:
  case FILL_DELAY_SLOTS_TRANS:
  case AVOID_UJUMP_TRANS:
  case LOOP_UNROLL_TRANS:
  case CROSS_JUMP_TRANS:
    return TRUE;
  }

  return FALSE;
}

#ifdef WRITE_CEX
/*
 * store_as_cex - store the RTLs in .cex file format
 */
void store_as_cex(char *store_ptr[MAX_CEX_LINES], char store_file[], int is_file)
{
  int i, line, flag, rtltype, rt, rcont;
  char str[BIGSTRING], buf[BIGSTRING], reg[BIGSTRING], rtlval[MAXSTRING];
  FILE *fp;
  struct bblock *cblk;
  struct list *rtl;
  struct locuse *loc;
  struct callfunc *cfunc;
  extern struct bblock *top;

  /*determine where the RTLs are to be stored*/
  if(is_file == FALSE){
    line = 0;

    /*check if we have reached this level before. If not, then we allocate
      memory once to all locations of this array*/
    if(store_ptr[0] == NULL){
      for(i=0 ; i<MAX_CEX_LINES ; i++)
	store_ptr[i] = (char *)NULL;
    }
  }
  else{
    if((fp=fopen(store_file, "w")) == NULL){
      fprintf(stderr, "store_as_cex: File cannot be opened\n");
      exit(0);
    }
  }

  for(cblk=top ; cblk ; cblk=cblk->down){

    if(cblk->label){
      sprintf(buf, "%s", cblk->label);
      store_cex_line(buf, store_ptr, fp, &line, is_file);
    }
    
    for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){

      if((rtl->type & ASMLINE) && (rtl->type & ~ASMLINE))
	rtltype = rtl->type & ~ASMLINE;
      else
	rtltype = rtl->type;
      rtltype = rtltype & ~(SIDEFFECT | COMBLINE | ARGLINE);
      buf[0] = '\0';
      switch(rtltype){

      case ARGBLINE:
	if(rtl->val)
	  sprintf(buf, "A%s", rtl->val);
	break;

      case DELAYLINE:
	if(rtl->val)
	  sprintf(buf, "_%s", rtl->val);
	break;

      case CASELINE:
	if(rtl->val)
	  sprintf(buf, "c%s", rtl->val);
	break;

      case FUNCNAME:
	sprintf(buf, "f%s", rtl->val);
	store_cex_line(buf, store_ptr, fp, &line, is_file);
	
	/*write out the local declarations*/
	for(i=hregnum ; i < regallocptr ; i++){
	  if(sets[i].local){
	    
	    loc = (struct locuse *)sets[i].local;
	    sprintf(buf, "d%s\t%s\t%d\t%d\t%d\t%d\t%d", loc->item, loc->code,
		    loc->level, loc->type, loc->size, loc->offset, loc->vol);
	    store_cex_line(buf, store_ptr, fp, &line, is_file);
	    
	    /*additional information stored for each local*/
	    sprintf(buf, "e%s\t%d\t%d\t%d\t%d\t%d\t%s", loc->item, loc->reg,
		    loc->nouse, loc->reps, loc->atype, loc->arg, loc->regin);
	    store_cex_line(buf, store_ptr, fp, &line, is_file);
	  }
	  else{
	    /*if(sets[i].valid && sets[i].next)
	      sprintf(buf, "D%s\t%d\t%d\t%d\t%d\t%d\t%d", sets[i].item, sets[i].num,
		      sets[i].status, (sets[i].valid)->num, (sets[i].next)->num,
		      sets[i].assign, sets[i].regstatus);
	    else if(sets[i].valid)
	      sprintf(buf, "D%s\t%d\t%d\t%d\t%d\t%d\t%d", sets[i].item, sets[i].num,
		      sets[i].status, (sets[i].valid)->num, 0,
		      sets[i].assign, sets[i].regstatus);
	    else if(sets[i].next)
	      sprintf(buf, "D%s\t%d\t%d\t%d\t%d\t%d\t%d", sets[i].item, sets[i].num,
		      sets[i].status, 0, (sets[i].next)->num,
		      sets[i].assign, sets[i].regstatus);
		      else*/
	    sprintf(buf, "D%s\t%d\t%d\t0\t0\t%d\t%d", sets[i].item, sets[i].num,
		    sets[i].status, sets[i].assign, sets[i].regstatus);
	    
	    store_cex_line(buf, store_ptr, fp, &line, is_file);
	  }
	}
	break; 

      case USELINE:
	if(rtl->val){
	  sprintf(buf, "u%s", rtl->val);
	  rt = regtype(rtl->val);
	  if((rcont = contregf(rt)) > 1){
	    while(--rcont)
	      rtl=rtl->next;
	  }
	}
	break;
	
      case ASMLINE:
	if(rtl->val)
	  sprintf(buf, "-%s", rtl->val);
	break;

      case TRASHLINE:
	if(rtl->val)
	  sprintf(buf, "t%s", rtl->val);
	break;
	
      case RESLINE:
	if(rtl->val || rtl->deads){
	  store_rtl(buf, rtl, reg);
	  store_cex_line(buf, store_ptr, fp, &line, is_file);
	  sprintf(buf, "R%s", reg);
	}
	break;

      case PARMLINE:
	if(rtl->val)
	  sprintf(buf, "P%s", rtl->val);
	break;
	
      case SETLINE:
	if(rtl->val)
	  sprintf(buf, "S%s", rtl->val);
	break;

      case CSLINE:
	if(rtl->val)
	  sprintf(buf, "C%s", rtl->val);
	break;

      case METADATALINE:
	if(rtl->val)
	  sprintf(buf, "m%s", rtl->val);
	break;

      case COMMENT:
	if(rtl->val)
	  sprintf(buf, "#%s", rtl->val);
	break;

      case RTLINE:
	if(rtl->val || rtl->deads)
	  store_rtl(buf, rtl, reg);
	if((rtl->type & SIDEFFECT) && rtl->se){
	  store_cex_line(buf, store_ptr, fp, &line, is_file);
	  sprintf(buf, "i%s", rtl->se);
	}
	break;

      default:
	fprintf(stderr, "store_as_cex: Un-recognized type\n");
	exit(0);
      }

      if(buf[0] && !(rtltype & FUNCNAME))
	store_cex_line(buf, store_ptr, fp, &line, is_file);
    }

    /*store status of unrolled loops*/
    if(cblk->status & UNROLLED){
      sprintf(buf, "U Block Unrolled");
      store_cex_line(buf, store_ptr, fp, &line, is_file);
    }
  }

  /*side effect line*/
  if(sret){
    sprintf(buf, "s%s", sret);
    store_cex_line(buf, store_ptr, fp, &line, is_file);
  }

  /*if register assignment has been done, then we need to store the
    usedtemps[] array, which is used later during fixentry*/
  if(trans_done & REG_ASSIGNMENT_BIT){
    int max_usedtemp = find_max_usedtemp();
    sprintf(buf, "T%d", max_usedtemp);
    store_cex_line(buf, store_ptr, fp, &line, is_file);
  }

  /*store information about all global functions referenced in this
    function. This is extra information needed by EASE*/
  cfunc = ext_funcs;
  if(ext_num>0 && cfunc!=NULL){
    while(cfunc){
      sprintf(buf, "g%s", cfunc->name);
      store_cex_line(buf, store_ptr, fp, &line, is_file);
      cfunc = cfunc->next;
    }
  }

  /*store function termination*/
  sprintf(buf, "*");
  store_cex_line(buf, store_ptr, fp, &line, is_file);
  
  if(is_file)
    fclose(fp);
}

/*
 * store_rtl - copy the RTL line in the given buffer
 */
void store_rtl(char *buf, struct list *rtl, char *reg)
{
  char *a;
  
  if(rtl->val){
    sprintf(buf, "+%s", rtl->val);
    if(buf[strlen(buf)-1] == ';')
      buf[strlen(buf)-1] = '\0';
  }
  else
    sprintf(buf, "+");

  if(rtl->deads){
    sprintf(buf, "%s\t", buf);
    reget(rtl->deads, reg);
    for(a = reg ; *a ; a = skiplocOr2(a)+1)
      sprintf(buf, "%s%s", buf, a);
  }
}


/*
 * store_cex_line - store a single line into the file ot string
 */
void store_cex_line(char *line, char **str_store, FILE *fp, int *num, int is_file)
{
  if(is_file){
    fprintf(fp, "%s\n", line);
  }
  else{
    if(str_store[*num] == NULL){
      if(strlen(line) < MAXSTRING)
	str_store[*num] = (char *)myalloc_profile(MAXSTRING);
      else if(strlen(line) < BIGSTRING)
	str_store[*num] = (char *)myalloc_profile(BIGSTRING);
      else{
	fprintf(stderr, "Cannot allocate string in store_cex_line\n");
	while(1)
	  sleep(10);
      }
    }
    
    strcpy(str_store[*num], line);
    (*num)++;

    if((*num) > MAX_CEX_LINES){
      fprintf(stderr, "Max lines in cex file exceed those allocated\n");
      exit(0);
    }
  }
}

#endif /*WRITE_CEX*/


/*
 * do_branch_opt - perform all the branch optimizations until there are any
 *                 changes
 */
int do_branch_opt(int *valid_analysis)
{
  int t_change, change, ph_change;
  int analysis;
  extern int limited_branch_chaining, limited_scope;
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern unsigned int invalidates_analysis[NUM_TRANS_TYPES];
  extern struct blk_inscope dfs_scope;

  fprintf(stderr, "Function: %s\n", fn);
  change = FALSE;
  limited_scope = FALSE;
  
  do{
    t_change = FALSE;

    do_needed_analysis(MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS);
    
    analysis = needs_analysis[BRANCH_CHAINING_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    limited_branch_chaining = TRUE;
    t_change |= remv_branch_chains(1);
    limited_branch_chaining = FALSE;
    /*if(ph_change = remv_branch_chains(1))
      fprintf(stderr, "Branch Chaining active\n");
      t_change |= ph_change;*/
    (*valid_analysis) &= ~invalidates_analysis[BRANCH_CHAINING_TRANS];

    analysis = needs_analysis[USELESS_JUMP_ELIM_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = remv_useless_jumps(1));
    /*fprintf(stderr, "Useless Jumps active\n");*/
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[USELESS_JUMP_ELIM_TRANS];
    
    analysis = needs_analysis[DEAD_CODE_ELIM_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = remv_unreachable_code(1));
      /*fprintf(stderr, "Unreachable code active\n");*/
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[DEAD_CODE_ELIM_TRANS];
    
    /*if(ph_change = remv_branch_chains(1))
      fprintf(stderr, "Branch Chaining active\n");
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[BRANCH_CHAINING_TRANS];
 
     analysis = needs_analysis[USELESS_JUMP_ELIM_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = remv_useless_jumps(1))
      fprintf(stderr, "Useless Jumps active\n");
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[USELESS_JUMP_ELIM_TRANS];
    
    analysis = needs_analysis[DEAD_CODE_ELIM_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = remv_unreachable_code(1))
      fprintf(stderr, "Unreachable code active\n");
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[DEAD_CODE_ELIM_TRANS];

    analysis = needs_analysis[REVERSE_BRANCHES_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = reverse_jumps(1))
      fprintf(stderr, "Reverse Jumps active\n");
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[REVERSE_BRANCHES_TRANS];
    
    analysis = needs_analysis[BLOCK_REORDERING_TRANS] & ~(*valid_analysis);
    (*valid_analysis) |= do_needed_analysis(analysis);
    if(ph_change = minimize_jumps(1))
      fprintf(stderr, "Block Reordering active\n");
    t_change |= ph_change;
    (*valid_analysis) &= ~invalidates_analysis[BLOCK_REORDERING_TRANS];*/

    change |= t_change;
  }while(t_change);

  limited_scope = dfs_scope.limited_scope;
  return change;
}


/*
 * bk_rtl - copy the exact contents of the RTL during bookmarking
 */
struct list *bk_rtl(struct bblock *cblk, struct bblock *oblk, struct list *rtl)
{
  struct list *nrtl;

  nrtl = (struct list *)myalloc_tpro(sizeof(struct list));
}


/*
 * bk_block - copy the exact contents of the basic during bookmarking
 */
struct bblock *bk_block(struct bblock *oblk)
{
  struct bblock *cblk;

  cblk = (struct bblock *)myalloc_tpro(sizeof(struct bblock));
  cblk->block_id = oblk->block_id;

  /*     
	 Initialize all of the fields of the new basic block
  */
  cblk->preds = (struct blist *) NULL;
  if(oblk->label){
    cblk->label = (char *)myalloc_tpro(strlen(oblk->label)+1);
    strcpy(cblk->label, oblk->label);
  }
   cblk->next = (struct bblock *) NULL;
   cblk->up = cblk->down = (struct bblock *) NULL;
   cblk->prev_dfs = cblk->next_dfs = cblk->parent_dfs = (struct bblock *) NULL;
   cblk->idom = cblk->sdom = (struct bblock *) NULL;
   cblk->dom_front = (struct blist *) NULL;
   cblk->bnum = oblk->bnum;
   cblk->dnum = oblk->dnum;

#if defined(MEASURE) || defined(INTERACT)
   cblk->dom = dinit();
#endif
#ifdef MEASURE
   cblk->equivclass = dinit();
   cblk->equivnum = 0;
#endif

   cblk->loop = (struct loopl *) NULL;
   cblk->looplist = (struct listl *) NULL;
   cblk->prof = (struct DataProfile *) NULL;
   cblk->rtls = cblk->rtlend = (struct list *) NULL;
   cblk->left = cblk->right = (struct bblock *) NULL;
   cblk->status = oblk->status;
   cblk->freq = oblk->freq;
   cblk->estimate = 0.0;
   cblk->dlist = rinit();
   cblk->ulist = rinit();
   cblk->olist = rinit();
   cblk->phi_funcs = (struct phi *) NULL;
   cblk->sets_out = (struct defnode *) NULL;
   cblk->regstate = reginit();
   cblk->elist = (struct eqvtable *) NULL;
   cblk->conin = cblk->conout = (struct ignode *) NULL;
#ifdef INTERACT
  if (swq) {
      cblk->inscope = oblk->inscope;
      cblk->old_next = (struct bblock *) NULL;
      cblk->old_right = (struct bblock *) NULL;
      cblk->old_down = (struct bblock *) NULL;
      cblk->old_up = (struct bblock *) NULL;
      cblk->old_rtls = (struct list *) NULL;
      cblk->old_rtlend = (struct list *) NULL;
   }	
#endif

  return (cblk);
}


/*
 * bmark_fn_inst - copy the basic block structure along with the RTLs. This
 *                 will make the roll-back operation faster as now we do not
 *                 have to do any file I/O
 */
void bmark_fn_inst(struct bk_fn_info fn_copy)
{
  int i;
  struct bblock *dup_blocks[MAX_BLOCKS];
  struct bblock *cblk, *nblk, *new, *ntop, *nbottom;
  struct bblock *tup, *tdown, *tnext, *tleft, *tright;
  struct list *rtl, *prtl;
  extern int rtl_id, block_id;
  extern struct bblock *top, *bottom, *ret_block;

  for(i=0 ; i<MAX_BLOCKS ; i++)
    dup_blocks[i] = 0;
  
  /*copy all the blocks, rtls and other information to a new location*/
  for(cblk=top ; cblk ; cblk=cblk->next){

    prtl = (struct list *)NULL;
    new = (struct bblock *)bk_block(cblk);
    for(rtl=cblk->rtls ; rtl ; rtl=rtl->next)
      prtl = bk_rtl(new, cblk, rtl);
    dup_blocks[cblk->block_id] = new;
  }

  /*link the blocks*/
  for(cblk=top ; cblk ; cblk=cblk->next){

    nblk = dup_blocks[cblk->block_id];
    if(tup=cblk->up)
      nblk->up = dup_blocks[tup->block_id];
    if(tdown=cblk->down)
      nblk->down = dup_blocks[tdown->block_id];
    if(tnext=cblk->next)
      nblk->next = dup_blocks[tnext->block_id];
    if(tleft=cblk->left)
      nblk->left = dup_blocks[tleft->block_id];
    if(tright=cblk->right)
      nblk->right = dup_blocks[tright->block_id];
  }

  /*since we are not cleaning the entire function we cannot dispose off that
    Arena. This makes it worthwhile to store this "main" function instance in
    the structure, and work on the structure from memory which we can free*/
  fn_copy.top = top;
  fn_copy.bottom = bottom;
  fn_copy.ret_block = ret_block;
  /*fn_copy.block_id = block_id;
    fn_copy.rtl_id = rtl_id;*/

  top = dup_blocks[top->block_id];
  bottom = dup_blocks[bottom->block_id];
  ret_block = dup_blocks[ret_block->block_id];
}


/*sanity_analysis - debug function to check if the phases turned off as a
 *                  result of various analysis is actually valid
 */
void sanity_analysis(struct comb_struct *comb, int succ[MAX_OPT], int s_num, int mask)
{
  int i, j, s_count, is_succ;
  int gene, opt;
  unsigned int occured_phases[NUM_TRANS_TYPES];
  extern FILE *comb_log;
  extern unsigned int enable_phase[NUM_TRANS_TYPES];
  extern struct chromosome popu[MAX_CHROMOSOMES];

  for(i=0 ; i<s_num ; i++){
    if(mask & (1 << succ[i])){
      fprintf(comb_log, "Analysis: %d should not have occured\n", succ[i]);
    }
  }

  for(i=0 ; i<NUM_TRANS_TYPES ; i++)
    occured_phases[i] = ~(0);

  s_count = 0;
  for(i=0 ; i<comb->strlength ; i++){
    
    gene = popu[comb->popu_count-1].chrom[i];
    opt = comb->base_opt[gene];
    if(s_count < s_num && succ[s_count] == opt){
      s_count++;
      is_succ = TRUE;
    }
    else
      is_succ = FALSE;

    if(is_succ && !(enable_phase[opt] & occured_phases[opt])){
      fprintf(comb_log, "Repeat: %d should not have repeated: %d\n", opt, i);
    }

    occured_phases[opt] = 0;
    for(j=0 ; j<NUM_TRANS_TYPES ; j++)
      occured_phases[j] |= (1 << opt);
  }
}


/* add_phase - add the specified phase at the specified location in the
 *             commands array
 */
void add_phase(int *pc, int phase)
{
  extern struct command commands[MAXCMDS];

  if(phase == MERGE_BLOCKS_TRANS)
    return;

  if(phase==CODE_MOTION_TRANS || phase==LOOP_STRENGTH_REDUCT_TRANS ||
     phase==RECURRENCE_ELIM_TRANS || phase==INDUCT_VAR_ELIM_TRANS)
    phase = ALL_LOOP_TRANS;
  
  commands[*pc].oper = phase;
  if(phase == LOOP_UNROLL_TRANS)
    commands[*pc].offset = 2;
  (*pc)++;
}

static int loop_stack[MAX_JUMPS], if_stack[MAX_JUMPS];
static int top_stack=-1, top_if=-1;

/* begin_do_loop - start a new do loop. Record the start position of the
 *                 current loop
 */
void begin_do_loop(int *pc)
{
  extern struct command commands[MAXCMDS];

  commands[*pc].oper = BEGIN_LOOP;
  (*pc)++;

  top_stack++;
  loop_stack[top_stack] = *pc;
}

/* end_do_loop - add appropriate messages to end the do-while loop
 */
void end_do_loop(int *pc)
{
  extern struct command commands[MAXCMDS];

  commands[*pc].oper = IF_LOOP_TRUE_GOTO_TRANS;
  commands[*pc].offset = loop_stack[top_stack] - (*pc);
  top_stack--;
  (*pc)++;
  commands[*pc].oper = END_LOOP;
  (*pc)++;
}

/* begin_if - add messages to command array to start if construct
 */
int begin_if(int *pc)
{
  extern struct command commands[MAXCMDS];

  commands[*pc].oper = IF_FALSE_GOTO_TRANS;
  top_if++;
  if_stack[top_if] = *pc;
  (*pc)++;
}

/* end_if - add message to command array to jump over 'then' part of the if
 */
void end_if(int pc)
{
  int if_pc;
  extern struct command commands[MAXCMDS];

  if_pc = if_stack[top_if];
  top_if--;
  commands[if_pc].offset = pc - if_pc;
}


/*
 * batch_comp_opt - perform all the optimizations as would have been
 *                  performed by the batch compiler. The sequence of
 *                  opts. has been carefully extracted by hand from the batch
 *                  compiler to reduce clutter in the main optimize()
 *                  routine. As a drawback, this will need to be modified
 *                  each time optimize() is changed
 */
int batch_comp_opt(int start_pc)
{
  int pc;
  extern int r_b_c_count, r_u_j_count, r_u_c_count;
  extern int r_j_count, m_j_count, i_s_count, l_v_a_count, g_a_count, m_c_s_count;
  extern int c_s_e_count, r_d_v_count, c_m_count, s_s_r_count, r_u_b_count;
  extern int m_b_b_count, f_d_f_count, r_u_c_b_count, p_count;
  extern int cj_count, csalloc, r_d_f_c;
  extern int stache_policy;
  extern struct command commands[MAXCMDS];

  pc = start_pc+1;
  
  if(swl){
    begin_do_loop(&pc);
       add_phase(&pc, BRANCH_CHAINING_TRANS);
       add_phase(&pc, ELIM_EMPTY_BLOCKS_TRANS);
       add_phase(&pc, USELESS_JUMP_ELIM_TRANS);
       add_phase(&pc, DEAD_CODE_ELIM_TRANS);
       add_phase(&pc, REVERSE_BRANCHES_TRANS);
       add_phase(&pc, BLOCK_REORDERING_TRANS);
       add_phase(&pc, MERGE_BLOCKS_TRANS);
    end_do_loop(&pc);
  }

  add_phase(&pc, INST_SELECT_TRANS);

#ifdef FIX
  if (swn)
    add_phase(&pc, FIX_CONTROL_FLOW_TRANS);
#endif
  
  if (swv)
    add_phase(&pc, EVAL_ORDER_DETER_TRANS);
  
  if (swg)
    add_phase(&pc, GLOBAL_INST_SELECT_TRANS);

  add_phase(&pc, REG_ASSIGNMENT_TRANS);

  add_phase(&pc, INST_SELECT_TRANS);
  
  if (swr || swo){

    if (swl) {
      add_phase(&pc, MINIMIZE_LOOP_JUMPS_TRANS);
      begin_if(&pc);
         add_phase(&pc, MERGE_BLOCKS_TRANS);
      end_if(pc);
    }
  }
      

  begin_do_loop(&pc);
    
     if (swr || swo){
       begin_do_loop(&pc);
    
          begin_do_loop(&pc);
             add_phase(&pc, DEAD_ASG_ELIM_TRANS);
             add_phase(&pc, INST_SELECT_TRANS);
          end_do_loop(&pc);
    
       if (swl){
         begin_do_loop(&pc);
            add_phase_simplify_controlflow(&pc);
         end_do_loop(&pc);
      
         add_phase(&pc, REG_ALLOCATION_TRANS);
         add_phase(&pc, INST_SELECT_TRANS);
       }
    
       end_do_loop(&pc);
     }
  
     if (swl){
       begin_do_loop(&pc);
          add_phase_simplify_controlflow(&pc);
       end_do_loop(&pc);
     }
  
     begin_do_loop(&pc);
  
        add_phase(&pc, INST_SELECT_TRANS);
        if (swc) {
          add_phase(&pc, COMMON_SUBEXPR_ELIM_TRANS);
          add_phase(&pc, DEAD_ASG_ELIM_TRANS);
        }

	if (swm && swl)
	  add_phase(&pc, CROSS_JUMP_TRANS);
  
        if (swl){
          begin_do_loop(&pc);
             add_phase_simplify_controlflow(&pc);
          end_do_loop(&pc);
        }
  
        if (swm && (swr || swo)) 
          add_phase(&pc, CODE_MOTION_TRANS);
  
        if (swl)
          add_phase(&pc, USELESS_JUMP_ELIM_TRANS);
  
        if (swl){
          begin_do_loop(&pc);
             add_phase_simplify_controlflow(&pc);
          end_do_loop(&pc);
        }
  
        if (sws) {
          add_phase(&pc, DEAD_ASG_ELIM_TRANS);
          add_phase(&pc, STRENGTH_REDUCT_TRANS);
        }
  
        add_phase(&pc, INST_SELECT_TRANS);
  
     end_do_loop(&pc);
  
  end_do_loop(&pc);
  
  if (swl){
    add_phase(&pc, BRANCH_CHAINING_TRANS);
    add_phase(&pc, DEAD_CODE_ELIM_TRANS);
    add_phase(&pc, ELIM_EMPTY_BLOCKS_TRANS);
    add_phase(&pc, REVERSE_BRANCHES_TRANS);
    add_phase(&pc, BLOCK_REORDERING_TRANS);
  }

  add_phase(&pc, LOOP_UNROLL_TRANS);
  add_phase_simplify_controlflow(&pc);
  add_phase(&pc, INST_SELECT_TRANS); /**can remove if not required***/
  
#ifdef PRED
  if (swp){
    int   change = TRUE;
    int   p_count = 0;

    begin_do_loop(&pc);
       add_phase(&pc, PREDICATION_TRANS);
       add_phase_simplify_controlflow(&pc);
    end_do_loop(&pc);
  }
#endif

  /*add_phase(&pc, FIX_ENTRY_EXIT_TRANS);*/
  
#ifdef SCHED
  if (swi){
    add_phase(&pc, INST_SCHED_TRANS);
  }
#endif
  
#ifdef FILL
  if (swf){
    add_phase(&pc, FILL_DELAY_SLOTS_TRANS);
    begin_if(&pc);
       add_phase(&pc, USELESS_JUMP_ELIM_TRANS);
       add_phase(&pc, BRANCH_CHAINING_TRANS);
    end_if(pc);
  }
#endif

  add_phase(&pc,QUIT_TRANS);  
}


/* add_phase_simplify_controlflow - called only from batch_comp_opt
 */
void add_phase_simplify_controlflow(int *pc)
{
  extern  int swl;
  
  add_phase(pc, DEAD_ASG_ELIM_TRANS);
  add_phase(pc, USELESS_JUMP_ELIM_TRANS);
  add_phase(pc, BRANCH_CHAINING_TRANS);
  add_phase(pc, DEAD_CODE_ELIM_TRANS);
  add_phase(pc, ELIM_EMPTY_BLOCKS_TRANS);
  add_phase(pc, REVERSE_BRANCHES_TRANS);
  add_phase(pc, BLOCK_REORDERING_TRANS);
  add_phase(pc, MERGE_BLOCKS_TRANS);

  if(swl){
    add_phase(pc, BRANCH_CHAINING_TRANS);
    add_phase(pc, ELIM_EMPTY_BLOCKS_TRANS);
    add_phase(pc, USELESS_JUMP_ELIM_TRANS);
    add_phase(pc, DEAD_CODE_ELIM_TRANS);
    add_phase(pc, REVERSE_BRANCHES_TRANS);
    add_phase(pc, BLOCK_REORDERING_TRANS);
    add_phase(pc, MINIMIZE_LOOP_JUMPS_TRANS);
    add_phase(pc, MERGE_BLOCKS_TRANS);
  }
}

#if PH_CONTEXT && PH_ALL_PATHS
/*
 * update_path_index - recursive algorithm to update next phase selection
 *                     indices during supporting multiple paths in phase
 *                     context DFS search
 */
void update_path_index()
{
  int i, j, ph, curr_ph;
  struct PH_CON *ptr, *ptr2;
  extern int ph_pos[];

  ptr = find_pcon_node(0);
  curr_ph = ptr->paths[ptr->cind];
  ptr2 = find_pcon_node(1<<ph_pos[curr_ph]);
  ptr2->cind++;
  if(ptr2->cind >= ptr2->pind){
    ptr->cind++;
    if(ptr->cind >= ptr->pind)
      ptr->cind++;
  }
}
#endif

#if PH_CONTEXT
/*
 * calc_context - calculate the new context
 */
int calc_context(int context, int ph)
{
  int num, pos, mask;
  extern int ph_pos[], ph_mask[], ph_shift[];

  pos = ph_pos[ph];
  num = context >> ph_shift[pos];
  num++;
  num &= ph_mask[pos];
  num = num << ph_shift[pos];

  /*mask the relevant bits in the previous context*/
  mask = 0;
  mask |= ph_mask[pos];
  mask = mask << ph_shift[pos];
  context &= ~mask;
  context |= num;
  return context;
}
#endif

/*variable to be used during old_batch or prob_batch*/
static double ph_prob[MAXPHASES]; 

/*
 * init_batch_prob - initialize the active probabilities of phases
 */
void init_batch_prob()
{
  int i;
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];

  for(i=0 ; i<MAXPHASES ; i++)
    ph_prob[i] = denable_phase[0][i];
}

/*
 * update_batch_prob - update the probability of a phase being active during
 *                     batch compilation. Should only be called when both the
 *                     flags, old_batch, and acive_batch are on
 */
int update_batch_prob(int phase, int change)
{
  int i;
  double en_prob, dis_prob;
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];

  /*disable current phase*/
  ph_prob[phase] = 0.0;
    
  /*update the probabilities of each phase based on the enable/diable
    probability of the current phase*/
  if(change){
    for(i=1 ; i<MAXPHASES ; i++){
      en_prob = (1.0 - ph_prob[i]) * denable_phase[phase][i];
      dis_prob = (ph_prob[i]) * (ddisable_phase[phase][i]);
      ph_prob[i] += en_prob - dis_prob;
    }
  }
}

/*
 * get_batch_prob - get the active probability of the current phase
 */
int is_phase_active(int phase)
{
  if(ph_prob[phase] > 0.0)
    return 1;
  return 0;
}

/*
 * get_next_prob_phase - determine the next phase to be applied dynamically
 *                       based on phase interaction probabilities
 */
void get_next_prob_phase(int *pc, int change, int is_first)
{
  unsigned int t_trans_done;
  int i, j, phase, found, pos, perf_cnt[MAXPHASES];
  double comp, en_prob, dis_prob, max, max_fn, perf_prob[MAXPHASES];
  static int count, is_RA_done, RA_trans_done, phase_context;
  static double threshold = 0.0;
  extern unsigned int trans_done;
  extern struct command commands[];
  extern double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern double dperf_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern int dperf_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
  extern unsigned int after_trans_dependences[NUM_TRANS_TYPES];
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
  extern int ph_pos[], func_in_file;
  extern char basename[];
#if PH_CONTEXT || PH_CONTEXT1 
  int ph;
  struct PH_CON *pptr;
  extern int fn_found;
#if STD_DEV
  static int dev_num= 1;
#endif
#endif


#if PH_CONTEXT || PH_CONTEXT1
  /*if the current function is not in the list of executed functions then do
    nothing for this function*/
  if(!fn_found)
    return;
#endif  
  
  /*the first time this function is called we have to initialize the
    probability tables for this function*/
  if(is_first){

    is_RA_done = FALSE;
    phase_context = 0;
#if STD_DEV
    /*free up previous space*/
    if(dev_num > 1)
      dispose_prob();

    /*calculate the average heuristics over some number of close functions*/
    calc_pcon(dev_num);
    dev_num++;
#endif    
  }
  else{

    /*disable current phase*/
    phase = commands[(*pc)-1].oper;
    ph_prob[phase] = 0.0;

    /*if RA has not officially been done, and the last phase needed RA but
      was unsucessful, then we need to roll back the RA performed to
      eliminate side-effects*/
    if(!is_RA_done && (after_trans_dependences[phase] & REG_ASSIGNMENT_BIT)){
      if(change)
	is_RA_done = TRUE;
      else{
	/*read the previous version of the function back*/
	undo_from_list(1);
	trans_done = RA_trans_done;
      }
    }

    if(change){
      /*if this is not the first time, then update the probabilities of all
	phases based on the probability of enabling and disabling of the last
	phase */
      for(i=1 ; i<MAXPHASES ; i++){
	en_prob = (1.0 - ph_prob[i]) * denable_phase[phase][i];
	dis_prob = (ph_prob[i]) * (ddisable_phase[phase][i]);
	ph_prob[i] += en_prob - dis_prob;
      }
#if PH_CONTEXT || PH_CONTEXT1      
      pos = ph_pos[phase];
      phase_context = calc_context(phase_context, phase);
      /*phase_context |= (1<<pos);*/
#endif      
    }
  }

  found = FALSE;
  max = 0.0;
  max_fn = 0.0;

#if PH_CONTEXT

  if((pptr = find_pcon_node(phase_context)) == NULL){
    fprintf(stderr, "Node for context %d not found\n", phase_context);
  }
  else{

#if PH_ALL_PATHS
    if(is_first || change){
      if(pptr->pind){
	phase = pptr->paths[pptr->cind];
	found = TRUE;
      }
    }
    else{
      pptr->cind++;
      if(pptr->cind < pptr->pind){
	phase = pptr->paths[pptr->cind];
	found = TRUE;
      }
    }
#endif  
    
    /*select the next active phase that can potentially lead to optimal across
      the largest spectrum of functions. In case of a tie, select the phase
      with the highest ratio of opt_paths/tot_paths*/
    if(!found){
      for(i=0 ; i<MAXPHASES ; i++){
	t_trans_done = trans_done;
	if((ph_prob[i]>threshold) && (is_opt_valid(i, &t_trans_done))){
	  pos = ph_pos[i];
	  if(pptr->fn_active[pos] > max_fn){
	    max_fn = pptr->fn_active[pos];
	    max = pptr->opt[pos];
	    phase = i;
	    found = TRUE;
	  }
	  else if(pptr->fn_active[pos] == max_fn){
	    if(pptr->degrade[pos] < max){
	      max = pptr->degrade[pos];
	      phase = i;
	    }
	  }
	}
      }
    }
  }

#elif PH_CONTEXT1
  if((pptr = find_pcon_node(phase_context)) == NULL){
    fprintf(stderr, "Node for context %d not found\n", phase_context);
  }
  else{

    /*select the phase having the best relative performance numbers*/
    max = 0.0;
    found = FALSE;
    for(i=1 ; i<MAXPHASES ; i++){
      t_trans_done = trans_done;
      if((ph_prob[i] > threshold) && (is_opt_valid(i, &t_trans_done))){
      
	perf_prob[i] = 0.0;
	perf_cnt[i] = 0;
	ph = ph_pos[i];
	for(j=0 ; j<ACTPHASES ; j++){
	  if(ph_prob[j] > threshold){
	    perf_prob[i] += (pptr->better[ph][j] - pptr->better[j][ph]);
	    perf_cnt[i]++;
	  }
	}
	perf_prob[i] = perf_prob[i] / perf_cnt[i];
	if(perf_prob[i] > max){
	  max = perf_prob[i];
	  phase = i;
	  found = TRUE;
	}
      }
    }
  }
#else 
  /*select the phase having the best relative performance numbers*/
  max = 0.0;
  found = FALSE;
  for(i=1 ; i<MAXPHASES ; i++){
    t_trans_done = trans_done;
    if((ph_prob[i] > threshold) && (is_opt_valid(i, &t_trans_done))){
      
      perf_prob[i] = 0.0;
      perf_cnt[i] = 0;
      for(j=1 ; j<MAXPHASES ; j++){
	if(ph_prob[j] > threshold){
	  perf_prob[i] += (dperf_phase[i][j] - dperf_phase[j][i]);
	  perf_cnt[i]++;
	}
      }
      perf_prob[i] = perf_prob[i] / perf_cnt[i];
      if(perf_prob[i] > max){
	max = perf_prob[i];
	phase = i;
	found = TRUE;
      }
    }
  }
#endif

  /*find the phase with the highest probability*/
  found = FALSE;
  if(!found){
    comp = 0.0;
    for(i=1 ; i<MAXPHASES ; i++){
      if(ph_prob[i] > threshold && ph_prob[i] > comp){
	
	/*check if the phase is legal to attempt at this point*/
	t_trans_done = trans_done;
	if(is_opt_valid(i, &t_trans_done)){
	  found = TRUE;
	  phase = i;
	  comp = ph_prob[i];
	}
      }
    }
  }
  
  /*put the new phase into the command array*/
  if(found){

    if(phase == 27){
      RA_trans_done = trans_done;
      store_as_cex(list_cex_files[2], 0, FALSE);
      undo_from_list(3);
      trans_done = RA_trans_done;
    }

    /*if the phase found requires register assignment to be performed and
      evaluation order determination has not yet being performed, then do so
      now */
    if((after_trans_dependences[phase] & REG_ASSIGNMENT_BIT) &&
       !(trans_done & REG_ASSIGNMENT_BIT) &&
       !(trans_done & EVAL_ORDER_DETER_BIT))
      commands[(*pc)+1].oper = EVAL_ORDER_DETER_TRANS;
    else
      commands[(*pc)+1].oper = phase;
    if(phase == LOOP_UNROLL_TRANS)
      commands[(*pc)+1].offset = 2;
    commands[(*pc)+2].oper = PROBABILISTIC_BATCH;
    commands[(*pc)+2].offset = 0;
    count++;

    /*Before RA is officially performed, if the phase selected needs RA then
      it is possible that RA will be implicitly performed and the current
      phase will be unsuccessful at changing the function. This affects the
      registers used by later phases which are seelcted based on the DAG
      which currently is assuming the RA is not performed. So store the
      function instance at this point and restore it later if the current
      phase is unsuccessful*/
    if((after_trans_dependences[phase] & REG_ASSIGNMENT_BIT) &&
       !(trans_done & REG_ASSIGNMENT_BIT)){
      store_as_cex(list_cex_files[0], 0, FALSE);
      RA_trans_done = trans_done;
    }
  }
  else{
#if PH_CONTEXT && PH_ALL_PATHS
    /*call a recursive algorithm to update next_phase indices*/
    update_path_index(0);
    pptr = find_pcon_node(0);
    if(pptr->cind < pptr->pind){
      undo_from_list(2);
      trans_done = 0;
      *pc = -1;
      fprintf(stdout, "\nSequence: ");
    }
    else
      commands[(*pc)+1].oper = -1;
#elif STD_DEV
    if(dev_num <= 78){
      undo_from_list(2);
      trans_done = 0;
      *pc = -1;
      fprintf(stdout, "\nSequence: ");
      fprintf(stderr, "Sequence %d finished for %s_%d\n",
	      dev_num, basename, func_in_file);
      fflush(stdout);
      fflush(stderr);
    }
    else{
      commands[(*pc)+1].oper = -1;
      dev_num = 1;
    }
#else    
    commands[(*pc)+1].oper = -1;
#endif    
  }
}


/* read the next function from the cex file. Returns 1 if this is the last
   function in the file*/
int read_next_function()
{
  char type, litem[MAXSTRING], line2[MAXSTRING], tstr[MAXSTRING], *cptr;
  int i, j, direct, rcont, rt, index;
  int noflow, num, valid, next, max_labnum=-1;
  char *label, *opt_flags[2], *line, *fptr;
  struct list *ptr, *prev, *curr_rtl;
  struct bblock *cblk, *exists;
  struct loopl *lptr;
  struct locuse *locptr;

  extern int swa, LeafFunction, pro_is_cex_file, pro_cex_line;
  extern struct loopl *loops;
  extern struct locuse *locs;
  extern char **pro_cex_file;

  cblk = top;
  noflow = TRUE;
  prev = (struct list *) NULL;

  if(pro_is_cex_file){
    pro_cex_line = 0;
  }
  for (;;) {
    if(pro_is_cex_file)
      type = pro_cex_file[pro_cex_line][0];
    else
      type = getchar();
    switch (type) {
      
      /*End of the input file */
    case EOF:
#ifdef ENDFILE
      endfile();
#endif
      return 1;

      /*Read in the basename of the source file being compiled.*/
    case (int) 'n':
      strcpy(basename, gtline());
      break;
      
      /*End of function*/
    case (int) '*':
#ifdef INTERACT
      /*On the ARM, '*' occurs not only at the end of the function, but also
	there are some lines which occur after the end of the current
	function and before the start of the next function. These lines do
	not contain RTLs but may contain symbol table like values. These are
	considered a part of the current function*/
      if(fn){
#endif	
      /*Indicate the end of the function if the output file should be in RTL
	file format*/
      if (!swa)
	(void) printf("*\n");
	
      return 0;
#ifdef INTERACT
      }
      else
	break;
#endif      
      
      /*
	Argument build area size line
      */
    case (int) 'A':
      ptr = new_rtl(cblk, ARGBLINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      LeafFunction = FALSE;
      break;
      
      /*
	Assembly line
      */
    case (int) '-':
      
      /* If we are doing data placement, we need to copy this line
       * into our global symbol table structure IF we are currently
       * processing a global definition, then free the memory for
       * the original line, discarding it.  It will be emitted at the
       * end of the function after the order of data items has been
       * determined.  If we are not processing a global definition,
       * then we just add a new RTL for this ASMLINE as usual.
       */
      line = gtline();
      /*Sometimes the comment lines are output as assembly lines. Check
	for this here (seen this happen on the SPARC)*/
      if(swq && line[0]=='!')
	ptr = new_rtl(cblk, COMMENT, prev);
      else
	ptr = new_rtl(cblk, ASMLINE, prev);
      ptr->val = line;
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Delayed assembly line
      */
    case (int) '_':
      
      /*
	All we have to do is read and retain the line for now
      */
      line = gtline();
      /*Sometimes the comment lines are output as assembly lines. Check
	for this here (seen this happen on the SPARC)*/
      if(swq && line[0]=='!')
	ptr = new_rtl(cblk, COMMENT, prev);
      else
	ptr = new_rtl(cblk, ASMLINE | DELAYLINE, prev);
      ptr->val = line;
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Trash line for the common subexpression eliminator
      */
    case (int) 't':
      
      /*
	All we have to do is read and retain the line for now
      */
      ptr = new_rtl(cblk, TRASHLINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Reserve line for the local register allocator
      */
    case (int) 'r':
      
      /*
	All we have to do is read and retain the line for now
      */
      ptr = new_rtl(cblk, RESLINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /* New style reserve line. We need to mark the previous
	 line.  We should check that the register being specified
	 is used in the previous line. Add this later
      */

    case (int) 'R':
      prev->type = RESLINE;
      line = gtline();
      FREE(line);
      break;
      
      /* Set optimization flags. These flags remain in effect until set again */
    case (int) 'O':
      line = gtline();
      opt_flags[0] = NULL;
      opt_flags[1] = line;
      clear_opt_flags();
      parse_arguments(2, opt_flags);
      FREE(line);
      break;  
      
      /*
	Parameter register line. This line contains the registers
	that have outgoing parameters.  We must build a side
	effect line and put store it in the side effect field of
	the previous instruction, which should be a call.  We need
	to check.
      */
    case (int) 'P':
      /*
	Read in the line and keep it for now
      */
      ptr = new_rtl(cblk, PARMLINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Set line
      */
    case (int) 'S':
      { 
	/*
	  Locate all of the items and note each of them as a set.
	*/
	char *temp_line=gtline();
	ptr = new_rtl(cblk, SETLINE, prev);
	ptr->val = temp_line;
	prev = ptr;
	noflow = FALSE;
	break;
      }
      /*
	Caller-save line
      */
    case (int) 'C':
      
      /*
	Read in the line and keep it for now
      */
      ptr = new_rtl(cblk, CSLINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /* 
       * Metadata line
       */
    case (int) 'm':
      /*
       * We just read it up and pass it along to the output
       */
      ptr = new_rtl(cblk, METADATALINE, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Comment line
      */
    case (int) '#':
      
      /*
	We just read it up and pass it along to the output
      */
      ptr = new_rtl(cblk, COMMENT, prev);
      ptr->val = gtline();
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Register type map
      */
    case (int) 'M':
      
      /*
	This line contains a map indicating which letter should be used
	to denote each register type when printing RTLs in decoded
	format.
      */
      line = gtline();
      if (strlen(line) < MAXSTRING)
	(void) strcpy(regprt, line);
      FREE(line);
      break;
      
      /*
	Function name line
      */
    case (int) 'f':
      
      /*
	This line contains the name of the current function, which is
	read so that it can be referred to using the "fn" variable.
      */
      if (fn) {
	(void) fprintf(stderr, "vpo (main): attempt to rename %s()\n", fn);
	line=gtline();
	FREE(line);
      }
      else {
	ptr = new_rtl(cblk, ASMLINE | FUNCNAME, prev);
	fn = ptr->val = gtline();
	prev = ptr;
	noflow = FALSE;
      }
      /*we found the function name, so the global declarations are
	over. Now set this flag to the next level not allowing any data
	to be written to the socket*/
      if(measure_init == 1)
	measure_init = 2;
      
      break;
      
      /*
	Global reference line
      */
    case (int) 'g':
      
      /*
	This line contains the name of a function that is referenced
	somewhere in this function.  This information is used when
	building a call graph for EASE.
      */
      add_func(line = gtline());
      FREE(line);
      break;
      
      /*
	Side effect line
      */
    case (int) 's':
      
      /*
	This line contains the side effect of returning
      */
      if (sret) {
	(void) fprintf(stderr, "vpo (main): redefined return effect\n");
	line=gtline();
	FREE(line);
      }
      else
	sret = gtline();
      break;
      
      /*
	Varargs line
      */
    case (int) 'V':
      
      /*
	This line indicates that varargs is used in this function
      */
      varargs = TRUE;
      (void) getchar();
      break;
      
      /*
	Use line
      */
    case (int) 'u':
      
      /*
	In order to speed up register allocation in the future, we need
	to obtain the internal index number of the register being used.
	In the case that the register used actually takes up more than
	one index position, new use lines are internally created, each
	holding one of the register index positions affected by the use
	of the register.  Note that the cost field of the list structure
	holds the register index number.
      */
      ptr = new_rtl(cblk, USELINE, prev);
      ptr->val = gtline();
      rt = regtype(ptr->val);
      ptr->cost = index = regtoindexf(rt, regnum(ptr->val));
      if ((rcont = contregf(rt)) > 1) {
	while (--rcont) {
	  prev = ptr;
	  ptr = new_rtl(cblk, USELINE, prev);
	  ptr->cost = ++index;
	}
      }
      prev = ptr;
      noflow = FALSE;
      break;
      
      /*
	Declaration line
      */
    case (int) 'd':
      
      /*ignore this line during a measure init phase to ignore globally
	defined items which were considered earlier and already exist in
	the data structure */
      if(measure_init == 1)
	{
	  line = gtline();
	  FREE(line);
	  break;
	}
      /*
	If declaration() returns a zero, then the line contained a
	global identifier.  If it returns a one, the line contained an
	argument and if it returns a value greater than one, the line
	was a local.
      */
      if (!declaration(line = gtline()))
	FREE(line);
      break;

#ifdef WRITE_CEX

      /*other records in the sets structure*/
    case 'D':

      line = gtline();
      sscanf(line, "%s\t%d\t%[^\n]", litem, &num, line2);
      if(num == regallocptr){
	strcpy(sets[regallocptr].item, litem);
	sets[regallocptr].num = regallocptr;
	vecmap[regname(regallocptr)] = regallocptr;
	sscanf(line2, "%d\t%d\t%d\t%d\t%d", &(sets[num].status), &valid, &next,
	       &(sets[num].assign), &(sets[num].regstatus));
	sets[num].valid = NULL;
	sets[num].next = NULL;
	sets[num].local = NULL;
	if(valid)
	  sets[num].valid = (struct setlist *)&(sets[valid]);
	if(next)
	  sets[num].next = (struct setlist *)&(sets[next]);
	regallocptr++;
      }
      else
	fprintf(stderr, "read_next_function: number from file does not match regallocptr\n");
      break;
      
      /*additional line only used when additional information is stored in
	the cex file, written from VPO*/
    case (int) 'e':

      locptr = (struct locuse *)sets[regallocptr-1].local;
      line = gtline();
      sscanf(line, "%s\t%[^\n]", litem, line2);

      if(strcmp(locptr->item, litem) == 0){
	cptr = line2;
	get_num(&cptr, &num);
	locptr->reg = num;
	get_num(&cptr, &num);
	locptr->nouse = num;
	get_num(&cptr, &num);
	locptr->reps = num;
	get_num(&cptr, &num);
	locptr->atype = num;
	get_num(&cptr, &num);
	locptr->arg = num;
	get_string(&cptr, locptr->regin);
      }
      else
	fprintf(stderr, "read_next_function: Locals structure not matching\n");
      break;

    case 'U':
      cblk->status |= UNROLLED;
      break;
      
#endif /*WRITE_CEX*/      
      /*
	Case line
      */
    case (int) 'c':
      
      /*
	This line is part of a jump address lookup table indicating
	where a switch statement may potentially transfer control to.
	What is important here is that the rest of the line, although
	treated as an assembly line, contains a label reference that has
	to be integrated to assemble an accurate representation of the
	control flow graph for this function.
      */
      ptr = new_rtl(cblk, ASMLINE | CASELINE, prev);
      ptr->val = gtline();
      prev = ptr;
      label = findlabel(ptr->val, &direct);
      if (!(cblk->right = getlabel(label)))
	cblk->right = new_basic_block(label);
      add_predecessor(cblk, cblk->right);
      cblk->down = cblk->left = new_basic_block((char *) NULL);
      cblk->down->up = cblk;
      add_predecessor(cblk, cblk->left);
      cblk = cblk->left;
      cblk->status |= FALLTHRU;
      prev = (struct list *) NULL;
      noflow = FALSE;
      break;
      
    case (int) 'l':
      line = gtline();
      ptr->type |= CASELINE;
      label = findlabel(line, &direct);
      if (!(cblk->right = getlabel(label)))
	cblk->right = new_basic_block(label);
      add_predecessor(cblk, cblk->right);
      cblk->down = cblk->left = new_basic_block((char *) NULL);
      cblk->down->up = cblk;
      add_predecessor(cblk, cblk->left);
      cblk = cblk->left;
      cblk->status |= FALLTHRU;
      prev = (struct list *) NULL;
      noflow = FALSE;
      FREE(line);     
      break;
      
      /*
	End-flow label
      */
    case (int) 'E':
      
      /*
	Note that this line is a label, and it is treated just as if it
	began with an 'L', then only difference is that this label cuts
	the normal flow, so that the code immediately above the label is
	not assumed to fall into the code below the label.  This type of
	label can be used to properly represent the control flow created
	by lookup table sequences on certain target machines.
      */
      noflow = TRUE;
      
      /*
	Label line
      */
    case (int) 'L':
      
      /*
	We must start a new basic block.  First, see if we have already
	seen this label referenced and already allocated a block for it.
      */
      if (exists = getlabel(label = gtlab())) {
	
	/*
	  If we have already allocated a basic block for this label,
	  then there are a couple of things we have to do depending on
	  the state of the current basic block.  First, we check to see
	  if the current basic block has anything in it at all (RTLs or
	  a label).  If it does, then we just indicate that it falls
	  into this new block.  If not, then there is no need to have
	  an empty block just lying around, so we put it aside and
	  connect the new block to the empty blocks predecessor.
	*/
	if (cblk->label || cblk->rtls) {
	  cblk->down = exists;
	  cblk->down->up = cblk;
	  if (!noflow) {
	    cblk->left = exists;
	    add_predecessor(cblk, cblk->left);
	  }
	}
	else {
	  if (exists->up = cblk->up) {
	    exists->up->down = exists;
	    if (exists->up->left == cblk) {
	      exists->up->left = exists;
	      if (cblk->preds)
		cblk->preds->next = exists->preds;
	      exists->preds = cblk->preds;
	      cblk->preds = (struct blist *) NULL;
	    }
	  }
	  exists->status = cblk->status;
	  remv_basic_block(cblk);
	}
	cblk = exists;
	prev = (struct list *) NULL;
      }
      else if (cblk->label || prev) {
	cblk->down = cblk->left = new_basic_block(label);
	cblk->down->up = cblk;
	if (!noflow) {
	  cblk->left = cblk->down;
	  add_predecessor(cblk, cblk->left);
	}
	cblk = cblk->down;
	prev = (struct list *) NULL;
      }
      else
	cblk->label = label;
      if (!noflow)
	cblk->status |= FALLTHRU;
      noflow = FALSE;

#ifdef INTERACT
      if((sscanf(label, lab_mask, &num)) == 1){
	if(num > max_labnum){
	  labnum = num + 1;
	  max_labnum = num;
	}
      }
#endif      
      break;
      
      
      /*
	RTL line
      */
    case (int) '+':
      /*
	First we read the line in and store it away, then we determine
	if it affects the control flow of the function.  If it does, we
	need to reflect the fact in the control flow data structure.
      */
      noflow = FALSE;
      ptr = new_rtl(cblk, RTLINE, prev);
      gtrtl(&ptr->val, &ptr->InitialDeads);
      curr_rtl = ptr;
      prev = ptr;
      if (ptr->val) {
	if ((label = is_pc(ptr->val)) &&
	    (label = findlabel(label + 1, &direct))) {
	  if (direct) {
	    cblk->status |= JUMP;
	    if (!(cblk->left = getlabel(label))) {
	      cblk->left = new_basic_block(label);
	      /* if this is a return instruction, its target is the return block */
	      /* remember the return block if we haven't already done so */
	      if (ret_block == NULL && fmatch(label, ret))
		ret_block = cblk->left;
	    }
	    add_predecessor(cblk, cblk->left);
	    cblk->down = new_basic_block((char *) NULL);
	    cblk->down->up = cblk;
	    cblk = cblk->down;
	    noflow = TRUE;
	  }
	  else {
	    if (!(cblk->right = getlabel(label)))
	      cblk->right = new_basic_block(label);
	    add_predecessor(cblk, cblk->right);
	    cblk->down = cblk->left = new_basic_block((char *) NULL);
	    cblk->down->up = cblk;
	    add_predecessor(cblk, cblk->left);
	    cblk = cblk->down;
	    cblk->status |= FALLTHRU;
	  }
	  prev = (struct list *) NULL;
	}
      }
      break;

      /*
	Side Effect line
      */
    case 'i':
      line = gtline();
      curr_rtl->type |= SIDEFFECT;
      curr_rtl->se = line;
      break;

      /*
	used temp line - only present when cex file is written from within
	VPO and register assignment is done*/
    case 'T':
      line = gtline();
      index = atoi(line);
      set_usedtemp(index);
      break;

    case '\n':
      break;
      /*
	If we get here, then the input file is not valid RTL format
      */
    default:
      (void) fprintf(stderr, "vpo (main): bad input '%c'\n", (char) type);
#ifdef INTERACT
      /*happens on the ARM when sometime it is not able to detect the end of
	file*/
      return 1;
#else      
      exit(1);
#endif      
    }

    if(pro_is_cex_file)
      pro_cex_line++;
  }
}


/* do some initializations before applying transformations*/
void do_fn_prereqs()
{
  int i, store;
  extern int fill_delay_done, DeadsareBitVectors, regallocptr;
  extern int bitsperint, rveclen, intscale;
  extern volatile int moreopts;
  extern int measure_flag, valid_analysis;
  extern unsigned int needs_analysis[NUM_TRANS_TYPES];
  extern rlist pseudos;
  extern int limited_dead_code_elim, pro_is_cex_file, limited_scope;
  extern struct setlist sets[MAXRVEC];
  extern struct blk_inscope dfs_scope;
  struct bblock *cblk;
  
  /* perform some initialization */
  init_old_all(top);
  fill_delay_done = 0;
  for (cblk = top; cblk; cblk = cblk ->down)
    cblk->inscope = FALSE;
  
  /*if scope is limited then set the block scopes again*/
  if(dfs_scope.limited_scope){
    for (i = 0; i < dfs_scope.num_blks; i++) {
      for (cblk = top; cblk; cblk = cblk->down)
	if (cblk->block_id == dfs_scope.blk_id[i]) {
	  cblk->inscope = TRUE;
	  break;
	}
      if (!cblk) {
	fprintf(stderr,
		"interactive_optimize (vpo) - block not found\n");
	exit(EXIT_FAILURE);
      }
    }
  }

  /*not required when the cex file is read from an array*/  
#ifdef EARLY_FRAME_SETUP
#ifndef WRITE_CEX  
  early_frame_setup();
#else
  if(!pro_is_cex_file)
    early_frame_setup();
#endif
#endif
  
  /* Deads are not bit vectors before vectorize_deads are
   * called later in optimize */
  DeadsareBitVectors = FALSE;
  
  /* Allocate vector positions for pseudo registers, and then go back and fix
     the dead list on each RTL to use a register vector.  While we are at it,
     we create a register vector named "pseudos" which contains all pseudo
     registers (and only pseudo registers).  Note that we do this after having
     removed unreachable basic blocks (if the user requested control flow
     optimizations), so that we do not allocate bit positions for pseudo
     registers that were used only in those blocks.  We must do this before we
     attempt to perform any data flow analysis or instruction selection
     phases. */
  i = regallocptr;
  allocate_reg_bit_positions();
  rveclen = regallocptr >> intscale;
  if (regallocptr & bitsperint)
    rveclen++;
  /*for (pseudos = rinit(); i < regallocptr;
    rins((unsigned int) i++, &pseudos));*/
  for(pseudos=rinit(), i=hregnum ; i<regallocptr ; i++){
    if(isRegister(sets[i].item) && pseudoreg(sets[i].item))
      rins((unsigned int)i, &pseudos);
  }
  store = measure_flag;
  measure_flag = TRUE;
  vectorize_deads(1);
  measure_flag = store;
  
#ifdef VET
  moreopts = TRUE;
  trans_done = 0;
  
  /*preds are correctly initlialized after function is read*/
  valid_analysis = RECALC_PREDS;
  prep_for_funcstart();
#endif
  
  /* the compiler always creates a useless empty basic block at the
     end. Remove this basic block before proceeding*/
  measure_flag = TRUE;
#ifdef WRITE_CEX
  if(pro_is_cex_file){
    do_needed_analysis(needs_analysis[ELIM_EMPTY_BLOCKS_TRANS] & ~RECALC_PREDS);
    remv_useless_basic_blocks(1);
  }
  else
    do_branch_opt(&valid_analysis);
#else
  do_branch_opt(&valid_analysis);
#endif   
  measure_flag = store;
}


/* do some cleanup to prepare for reading next function */
void do_fn_clean()
{
  int type;
  extern int rtl_id, valid_analysis;
  extern int labnum, curr_fn_labnum;
  
  /*Clear out all the garbage left behind by the optimization process.*/
  for (type = hregnum; type < regallocptr; type++)
    vecmap[regname(type)] = -1;
  regallocptr = hregnum;
  clrsets();
  clear_locals();
  clear_loops();
  clear_function();
  clear_call_graph();
  freetriples();

  /*Reset the id counters*/
  block_id = rtl_id = 0;
  
#ifdef DISPOSE
  
  /* Reclaim all of the storage used by the function that we have just
     optimized in  one move.  Re-initialize the free list pointers.*/
  dispose_func();
  for (type = 0; type < ENDFREETYPES; type++)
    freeptrs[type] = (char **) NULL;
  /*we can free up space used by the trans list*/
  clear_transform_list();
#endif
  
  /* Re-initialize variables to get ready for the next procedure in the input file*/
  LeafFunction = TRUE;
  initmap();
  fn = sret = (char *) NULL;
  last = bottom = (struct bblock *) NULL;
  top = new_basic_block((char *) NULL);
  ret_block = (struct bblock *) NULL;
  varargs = FALSE;

  /*reset labnum to what it was at the start of this function call*/
  labnum = curr_fn_labnum;
}


/*debug function to print RTLs to file*/
void print_function(char filename[MAXSTRING])
{
  FILE *fp;

  if((fp = fopen(filename, "w")) == NULL){
    fprintf(stderr, "File cannot be opened\n");
    exit(0);
  }

  dump_rtl_asm(0, fp, 0);
  fclose(fp);
}

/*debug function to print by block number*/
void print_block(int blk)
{
  struct bblock *cblk;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->next){
    if(cblk->block_id == blk)
      break;
  }
  if(cblk)
    dump_block(cblk, 0);
}

/*debug function to print the preds*/
void print_preds()
{
  struct blist *bl;
  struct bblock *cblk;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){

    fprintf(stderr, "Block: %d Preds: ", cblk->block_id);
    for(bl=cblk->preds ; bl ; bl=bl->next)
      fprintf(stderr, "%d ", bl->ptr->block_id);
    fprintf(stderr, "\n");
  }
}

/*debug function to write out and new .cex file to check errors in that part
  of the logic*/
void debug_update_cex()
{
  int temp_trans;
  extern unsigned int trans_done;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  temp_trans = trans_done;
  store_as_cex(list_cex_files[0], 0, 0);
  undo_from_list(1);
  trans_done = temp_trans;
}

/*debug function to print the dynamic frequency counts*/
void print_dy_count(int apply_epilogue)
{
  int status, new_cf;
  long long dy_count;
  struct CFList *func_cf;
  int temp_trans;
  struct BlockList *bl;
  struct bblock *cblk;
  extern unsigned int trans_done;
  extern int valid_analysis;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  if(apply_epilogue){
    temp_trans = trans_done;
    store_as_cex(list_cex_files[0], 0, 0);
    apply_epilogue_trans(&valid_analysis);
  }

  func_cf = get_func_cf(&new_cf);
  if(new_cf){
    status = get_measure(NULL, -1);
    fprintf(stderr, "Execution Status: %d\n", status);
    read_ease_counts(func_cf);
  }
  else{
    for(cblk=top, bl=func_cf->blist ; bl ; bl=bl->down){
      bl->cycle = block_cycles(cblk);
      bl->rcount = 0;
      cblk = cblk->down;
    }
  }

  for(bl=func_cf->blist ; bl ; bl=bl->down)
    fprintf(stderr, "%d ", bl->cycle);
  fprintf(stderr, "\n");
  
  dy_count = get_dy_ease_counts(func_cf, new_cf);
  fprintf(stderr, "Dynamic Counts: %lld\n", dy_count);

  if(apply_epilogue){
    undo_from_list(1);
    trans_done = temp_trans;
  }
  fflush(stderr);
}

/*debug function to write out contents of cex array to file*/
void print_cex(int level, char filename[MAXSTRING])
{
  int i;
  char *c;
  FILE *fp;
  extern char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];

  if((fp = fopen(filename, "w")) == NULL){
    fprintf(stderr, "File cannot be opened\n");
    exit(0);
  }

  for(i=0 ; ; i++){
    if(list_cex_files[level][i][0] == '*')
      break;
    fprintf(fp, "%s\n", list_cex_files[level][i]);
  }

  fclose(fp);
}

void print_euses()
{
  struct bblock *cblk;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){
    fprintf(stderr, "Block %d: ", cblk->block_id);
    if(cblk->elist)
      fprintf(stderr, "%d\n", cblk->elist->uses);
  }
}

void print_eqvtable(struct eqvtable *list)
{
  int i;
  struct eqvlist *ptr;

  for(i=0 ; i<ESIZE ; i++){
    for(ptr = list->eqiv[i] ; ptr ; ptr=ptr->next){

      show(ptr->item);
      if(ptr->sets)
	fprintf(stderr, "Sets: %d ", ptr->sets->rtl_id);
      if(ptr->dead)
	fprintf(stderr, "Dead: %d ", ptr->dead->rtl_id);
      fprintf(stderr, "Uses: %d\n", ptr->uses);
    }
  }
}

void print_elist(struct bblock *cblk)
{
  struct eqvlist *elist;

  if(cblk->elist){
    fprintf(stderr, "Uses: %d\n", cblk->elist->uses);
    for(elist=cblk->elist->eqiv[0] ; elist ; elist=elist->next){
      show(elist->item);
      if(elist->sets)
	show(elist->sets->val);
      else
	fprintf(stderr, "Not set\n");
    }
  }
}


/*print the depth-first neighbours of each basic block*/
void print_dfs()
{
  struct bblock *cblk;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){
    
    fprintf(stderr, "Block: %d: ", cblk->block_id);
    if(cblk->prev_dfs)
      fprintf(stderr, "prev:%d, ", cblk->prev_dfs->block_id);
    if(cblk->next_dfs)
      fprintf(stderr, "next:%d, ", cblk->next_dfs->block_id);
    if(cblk->parent_dfs)
      fprintf(stderr, "parent:%d, ", cblk->parent_dfs->block_id);
    if(cblk->idom)
      fprintf(stderr, "idom: %d", cblk->idom->block_id);
    if(cblk->sdom)
      fprintf(stderr, "sdom: %d, ", cblk->sdom->block_id);
    fprintf(stderr, "bnum: %d", cblk->bnum);
    fprintf(stderr, "\n");
  }
}

/* print the contents of the data structure locuse*/
void print_locuse(struct locuse *loc_ptr, char *filename)
{
  FILE *fp;
  struct locuse *lptr;

  /*open the output file*/
  fp = fopen(filename, "w");

  /*print the contents*/
  fprintf(fp, "\n\n");
  for(lptr=loc_ptr ; lptr ; lptr=lptr->next)
    {
      fprintf(fp, "Name: %s\n", lptr->item);
      fprintf(fp, "Level: %d, Size:%d, Ref count: %d\n", lptr->level,
	      lptr->size, lptr->reps);
      fprintf(fp, "Variable aligible(nouse): %d\n", lptr->nouse);
      /*fprintf(fp, "Declaration type: %d\n", lptr->type);*/
      fprintf(fp, "arg flag: %d, reg flag: %d\n\n", lptr->arg, lptr->reg);
    }
  fclose(fp);
}

void print_loops()
{
  struct blist *bl;
  struct loopl *l;
  extern struct loopl *loops;

  for(l=loops ; l ; l=l->next){

    fprintf(stderr, "Loop: %d :: ", l->ptr->block_id);
    for(bl=l->blocks ; bl ; bl=bl->next){
      fprintf(stderr, "%d ", bl->ptr->block_id);
    }
    fprintf(stderr, "Exits: ");
    for(bl=l->exits ; bl ; bl=bl->next)
      fprintf(stderr, "%d ", bl->ptr->block_id);
    fprintf(stderr, "\n");
  }
}

void print_dominators_all()
{
  struct bblock *cblk;
  extern struct bblock *top;

  fprintf(stderr, "Printing list of dominators\n");
  for(cblk=top ; cblk ; cblk=cblk->down)
    print_dominators(cblk->block_id);
}

void print_dominators(int block_id)
{
  struct bblock *cblk, *blk1;
  extern struct bblock *top;
  
  /*find the block*/
  for(cblk=top ; cblk ; cblk=cblk->down){
    if(cblk->block_id == block_id)
      break;
  }
  
  if(cblk){
    
    fprintf(stderr, "Dominators of block %d: ", cblk->block_id);
    for(blk1=top ; blk1 ; blk1=blk1->down){
      if(dominates(blk1, cblk))
	fprintf(stderr, "%d ", blk1->block_id);
    }
    fprintf(stderr, "\n");
  }
}


void print_blk_conout(char *filename)
{
  FILE *fp;
  struct bblock *cblk;
  struct ignode *ptr;

  fp = fopen(filename, "w");

  fprintf(fp, "\n\n");
  for(cblk=top ; cblk ; cblk=cblk->down){
    fprintf(fp, "Block_id: %d\n", cblk->block_id);
    fprintf(fp, "Conouts: ");
    for(ptr=cblk->conout ; ptr ; ptr=ptr->conout)
      fprintf(fp, "%s  ", ptr->item->local->item);
    fprintf(fp, "\n");
  }
  fclose(fp);
}



/* print the contents of the data structure ignode*/
void print_ignode()
{
  struct ignode *iptr;

  for(iptr=igptr ; iptr ; iptr=iptr->next)
    {
      fprintf(stdout, "local: %s freq: %d start=%x\n",
	      iptr->item->local->item, iptr->freq, iptr->start);
    }
  fflush(stdout);
}

/*print contents of ulist field of basic blocks*/
void print_ulist()
{
  struct bblock *blk;

  for(blk=top ; blk ; blk=blk->down)
    {
      fprintf(stderr, "Block_id: %d :: ", blk->block_id);
      rshow(blk->ulist);
      fprintf(stderr, "\n");
    }
}

/*print contents of the structure setlist*/
void print_setlist()
{
  extern struct setlist *setsused;
  struct setlist *set;

  for(set=setsused ; set ; set=set->next)
    {
      if(set->item[0])
	show(set->item);
      if(set->valid)
	fprintf(stderr, "Valid: 1 ");
      else
	fprintf(stderr, "Valid: 0 ");
      if(set->sets && set->sets->val){
	fprintf(stderr, "Sets: ");
	show(set->sets->val);
      }
      if(set->dead && set->dead->val){
	fprintf(stderr, "Dead: ");
	show(set->dead->val);
      }
      fprintf(stderr, "Assign: %d Regstatus: %d Uses: %d\n",
	      sets->assign, set->regstatus, set->uses);
      if(set->local)
	fprintf(stderr, "local: %s\n", set->local->item);
    }
}

/*print the block ids of all blocks in next list*/
void print_blocks()
{
  struct bblock *bblk;

  fprintf(stderr, "next list: ");
  for(bblk=top ; bblk ; bblk=bblk->next)
    fprintf(stderr, "%d ", bblk->block_id);
  fprintf(stderr, "\n");
  fprintf(stderr, "down list: ");
  for(bblk=top ; bblk ; bblk=bblk->down)
    fprintf(stderr, "%d ", bblk->block_id);
  fprintf(stderr, "\n");
  fprintf(stderr, "left list: ");
  for(bblk=top ; bblk ; bblk=bblk->next)
    if(bblk->left)
      fprintf(stderr, "%d ", bblk->left->block_id);
  fprintf(stderr, "\n");
}


/* print the rtls in a basib block*/
void print_rtls(int block)
{
  struct list *ptr;
  struct bblock *cblk;

  for(cblk=top ; cblk ; cblk=cblk->down){
    if(cblk->block_id == block)
      break;
  }

  if(cblk){
    for(ptr=cblk->rtls ; ptr ; ptr=ptr->next)
      fprintf(stderr, "%d ", ptr->rtl_id);
    fprintf(stderr, "\n");
  }
}

/* print content of the rtl */
void print_rtl_val(int rtl_id)
{
  struct bblock *bblk;
  struct list *lptr;

  for(bblk=top ; bblk ; bblk=bblk->next)
    {
      for(lptr=bblk->rtls ; lptr ; lptr=lptr->next)
	{
	  if(lptr->rtl_id == rtl_id)
	    {
	      fprintf(stderr, "Block: %d ", bblk->block_id);
	      if(lptr->val)
		show(lptr->val);
	    }
	}
    }
}

void print_RTLCount()
{
  int sum;
  struct bblock *cblk;
  extern struct bblock *top;

  sum = 0;
  for(cblk=top ; cblk ; cblk=cblk->down){
    sum += getRTLCount(cblk);
  }

  fprintf(stderr, "RTL Count: %d\n", sum);
  fflush(stderr);
}


void print_regtovec(char *s)
{
  int num;

  num = regtovec(s);
  fprintf(stderr, "Regtovec ");
  show(s);
  fprintf(stderr, "%d\n", num);
}


void print_CRC(int is_remap, int *analysis, char filename[100])
{
  unsigned int CRC, fhash;
  int rcount, old_debug;
  extern int rtl_debug;
  extern FILE *crc_fp;

  CRC = 0;
  fhash = 0;
  rcount = 0;
  if(strcmp(filename, "NULL") != 0)
    crc_fp = fopen(filename, "w");
  else
    crc_fp = stderr;

  old_debug = rtl_debug;
  rtl_debug = TRUE;
  rcount = get_func_hash(&CRC, &fhash, is_remap, analysis);
  fprintf(crc_fp, "CRC: %u fhash: %u rcount: %d\n", CRC, fhash, rcount);
  fclose(crc_fp);
  rtl_debug = old_debug;
}

void flush(int file)
{
  if(file == 1)
    fflush(stdout);
  else if(file == 2)
    fflush(stderr);
  else{
    fflush(stdout);
    fflush(stderr);
  }
}

/*
 * get_func_info - get additional information about the function
 *                 characteristics
 */
void get_func_info(int is_append)
{
  char fname[MAXSTRING], str[MAXSTRING], file[MAXSTRING];
  int nlocal, nblock, new_cf, cnt, memref, indref, stores, loads;
  int i, nrtl, njump, nbranch, nloop1, nloop2, nloop3, nloopn;
  long long exe_count[MAX_BLOCKS];
  FILE *fp;
  struct bblock *cblk;
  struct list *rtl;
  struct locuse *local;
  struct loopl *loop;
  struct CFList *func_cf;
  struct BlockList *bl;
  struct blist *blk;
  extern char *fn;
  extern int regallocptr;
  extern int hregnum, valid_analysis;
  extern struct bblock *top;
  extern struct setlist sets[];
  extern struct loopl *loops;

#if 0  
  /*execute the function once to get block execution counts*/
  fprintf(stderr, "Only execute this function to get profile information before the acture exhaustive runs\n");
  do_reqd_optimization(TRUE, FALSE, &valid_analysis);
  func_cf = get_func_cf(&new_cf);
  get_measure(NULL, -1);
  read_ease_counts(func_cf);
#endif
  
  /*write information to this file*/
  sprintf(fname, "%s_info.txt", fn);
  if(is_append)
    fp = fopen(fname, "a");
  else
    fp = fopen(fname, "w");
  if(fp == NULL){
    fprintf(stderr, "File %s cannot be opened\n", fname);
    return;
  }

  fprintf(stdout, "%s\n", fn);
  
  /*initialize counters*/
  nlocal = nblock = nrtl = njump = nbranch = 0;
  nloop1 = nloop2 = nloop3 = nloopn = 0;

  for(cblk=top ; cblk ; cblk=cblk->down){

    if(cblk->rtlend && cnts(cblk->rtlend) && is_pc(cblk->rtlend->val)){
      if(is_rjmp(cblk->rtlend->val))
	nbranch++;
      else
	njump++;
    }
    nrtl += getRTLCount(cblk);
    nblock++;
  }

  /*get local information*/
  indref = 0;
  for(i=hregnum ; i<regallocptr ; i++){
    if((local=sets[i].local) && local->level>0){
      nlocal++;
      if(local->indref)
	indref++;
    }
  }

  /*get loop information*/
  do_needed_analysis(CALC_STATUS_ANALYSIS|DEPTH_FIRST_SEARCH_ANALYSIS|
		     DOMINATOR_ANALYSIS|LOOP_ANALYSIS|LIVE_VAR_ANALYSIS);
  for(loop=loops ; loop ; loop=loop->next){
    if(loop->ptr->freq == 1)
      nloop1++;
    else if(loop->ptr->freq == 2)
      nloop2++;
    else if(loop->ptr->freq == 3)
      nloop3++;
    else
      nloopn++;
  }

  /*count the number of memory references*/
  memref = stores = loads = 0;
  for(cblk=top ; cblk ; cblk=cblk->down){
    for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
      if(cnts(rtl)){
	if(gtmem(rtl->val))
	  memref++;
	if(is_a_store(rtl->val))
	  stores++;
	if(is_a_load(rtl->val))
	  loads++;
      }
    }
  }

  /*write out the information*/
  fprintf(fp, "Function            Blocks  RTLs  Branches     Loops       Locals M_ref  St  Ld  IndRef\n");
  fprintf(fp, "%-20s %3d   %4d    %2d %2d    %2d %2d %2d %2d     %2d  %5d  %3d  %3d  %3d\n",
	  fn, nblock, nrtl, nbranch, njump, nloop1, nloop2, nloop3, nloopn, nlocal, memref, stores, loads, indref); 

#if 0  
  /*print out block execution counts*/
  for(cblk=top, bl=func_cf->blist ; cblk ; cblk=cblk->down, bl=bl->down)
    exe_count[cblk->block_id] = bl->exe_count;

  cnt = 0;
  for(loop=loops ; loop ; loop=loop->next){
    fprintf(fp, "Loop: %d depth: %d\n", cnt, loop->ptr->freq);
    for(blk=loop->blocks ; blk ; blk=blk->next){
      cblk = blk->ptr;
      fprintf(fp, "Block: %d Count: %lld\n", cblk->block_id,
	      exe_count[cblk->block_id]);
    }
    cnt++;
  }

  fprintf(fp, "Loop %d:\n", cnt);
  for(cblk=top ; cblk ; cblk=cblk->down){
    fprintf(fp, "Block: %d Count: %lld\n", cblk->block_id,
	    exe_count[cblk->block_id]);
  }
#endif  

  fclose(fp);
#if 0
 {
  extern char basename[];
  extern int func_in_file;
  int is_exec, is_and;
  char *c;
  
  /*check if the file is executed*/
  if((fp = fopen("exec_filelist", "r")) == NULL){
    fprintf(stderr, "File exec_filelist cannot be opened\n");
    exit(0);
  }
  is_exec = FALSE;
  fgets(str, MAXSTRING, fp);
  while(!feof(fp)){
    if((sscanf(str, "File: %s %d\n", file, &i)) == 2){
      if(strcmp(file, basename)==0 && i==func_in_file){
	is_exec = TRUE;
	break;
      }
    }
    fgets(str, MAXSTRING, fp);
  }
  /*check if the file has ANDI instruction*/
  if(is_exec){
    is_and = FALSE;
    for(cblk=top ; cblk ; cblk=cblk->down){
      for(rtl=cblk->rtls ; rtl ; rtl=rtl->next){
	if(cnts(rtl)){
	  for(c=rtl->val ; *c ; c++){
	    if(*c == '&')
	      is_and = TRUE;
	  }
	}
      }
    }
  }

  if(is_exec && is_and){
    fprintf(stdout, "Function %s_%d is executed and contains AND ins\n",
	    basename, func_in_file);
  }
 }
#endif /*0/1*/ 
}


void scantriples() {

   register struct llist *bptr, *dbptr;
   register struct itriple *tptr, *dptr;
   register struct memgroup *pptr, *dpptr;
   register struct memitem *mptr, *dmptr;

   /*
      Scan all triple structures
   */
   tptr = ftriple;
   while (tptr) {
      dptr = tptr;
      tptr = tptr->next;
      bptr = dptr->ref;
      while (bptr) {
	 dbptr = bptr;
	 bptr = bptr->next;
      }
   }
}

/*


/* Debug function to check if the daddy pointer in structure list is always
   valid. Remove this later*/
void check_daddy()
{
  struct bblock *cblk;
  struct list *rtlptr;
  
  for(cblk=top ; cblk ; cblk=cblk->down)
    {
      for(rtlptr=cblk->rtls ; rtlptr ; rtlptr=rtlptr->next)
	{
	  if(rtlptr->daddy->block_id);
	}
    }
}

/*debug function to print the succ. phases upto this node*/
void print_tree_path(int node, FILE *fp)
{
  char str[MAXSTRING];
  int i, parent, length, arr[100];
  extern struct tree_struct *tree;
  extern unsigned int tree_ptr;
  extern int resume_mode;

  length = 0;
  while(node != START_NODE){
    parent = tree[node].parent;
    for(i=0 ; i<NUM_TRANS_TYPES ; i++){
      if(tree[parent].opt[i] == node){
	arr[length++] = i;
	break;
      }
    }
    node = parent;
  }

  if(!resume_mode){
    if(fp == NULL)
      fp = stderr;
    fprintf(fp, "Nodes: ");
    for(i=length-1 ; i>=0 ; i--)
      fprintf(fp, "%d ", arr[i]);
    fprintf(fp, "\n");
  }
  else{
    /*verify that we have the expected string in the file*/
    fgets(str, MAXSTRING-1, fp);
  }
}

int get_phase_index(char ph)
{
  switch(ph){
    
  case 'b':
    return 1;
  case 'u':
    return 3;
  case 'd':
    return 4;
  case 'r':
    return 5;
  case 'i':
    return 6;
  case 's':
    return 8;
  case 'o':
    return 10;
  case 'j':
    return 13;
  case 'h':
    return 14;
  case 'k':
    return 15;
  case 'c':
    return 16;
  case 'q':
    return 21;
  case 'l':
    return 25;
  case 'n':
    return 27;
  case 'g':
    return 29;
  }

  /*fprintf(stderr, "Undefined phase %c\n", ph);*/
  return(0);
}

#endif /*INTERACT*/

void set_next_prev_ptrs()
{
  struct bblock *cblk;
  struct list *crtl;
  extern struct bblock *top;

  for(cblk=top ; cblk ; cblk=cblk->down){
    for(crtl=cblk->rtls ; crtl ; crtl=crtl->next){

      if(crtl->next && crtl->next->prev != crtl){
	fprintf(stderr, "Prev pointer does not match next in rtllist\n");
	crtl->next->prev = crtl;
      }
    }
  }
}


/*
 * bshow - print out a formatted version of an BB (for debug purposes)
 */
void bshow(struct bblock *cblk, int links)
{
   struct list *crtl;
   int i;
                                                                                
                                                                                
   fprintf(stderr, "--------------------------------------------------\n");
                                                                                
   if (!cblk)
      return;
                                                                                
   fprintf(stderr, "Block[%d] %d: ",cblk->block_id, cblk->dnum);
   if (cblk->ulist)
   {
      fprintf(stderr, "INS: ");
       rfshow(stderr, cblk->ulist);
      fprintf(stderr, "\n");
   }
   if (cblk->olist)
   {
      fprintf(stderr, "\tOUTS: ");
      rfshow(stderr,cblk->olist);
      fprintf(stderr, "\n");
   }
                                                                                
   if(cblk->label)
      fprintf(stderr, "%s\n",cblk->label);
   else
      fprintf(stderr, "\n");
                                                                                
   fprintf(stderr, "|rnum|onum|\n");
   for (crtl = cblk->rtls; crtl; crtl = crtl->next)
    {
      if(cnts(crtl))
      {
         fprintf(stderr, "|%4d|%4d| ", crtl->rnum, crtl->onum);
                                                                                
         if (links)
         {
            for (i = 0; i < MAXLINKS && crtl->lnks[i]; i++)
               fprintf(stderr, "%d ", crtl->lnks[i]->rnum);
         }
                                                                                
         show_rtl(stderr, crtl->val);
         fprintf(stderr, " ");
                                                                                
                                                                                
         if(crtl->deads && !rempty(crtl->deads))
         {
            fprintf(stderr, "deads -> ");
              rshow(crtl->deads);
            fprintf(stderr, " ");
         }
         fprintf(stderr, "\n");
                                                                                
      }
   }
   fprintf(stderr, "--------------------------------------------------\n");
   fflush(stderr);
}

/*
 * rfshow - print out the values in an rlist vector (for debug purposes)
 */
void rfshow(FILE *fp, rlist vec)
{
                                                                                
   register char  *a;
   char            reg[MAXSTRING];
                                                                                
   /*
    * This procedure is declared to make it easier to look at register
    * vectors while in dbx.  To print out the contents of a register vector,
    * use "call rshow(vector)".
    */
   reget(vec, reg);
                                                                                
   for (a = reg; *a; a = skiplocOr2(a) + 1)
      show_rtl(fp, a);
   fflush(fp);                                                                              
}

#ifdef INTERACT
void show_block(int block_id)
{
  struct bblock *cblk;
   struct list *crtl;
   int i;
   extern struct bblock *top;

   for(cblk=top ; cblk ; cblk=cblk->down){
     if(cblk->block_id == block_id)
       break;
   }

   if(!cblk)
     return;

   fprintf(stderr, "-------------------------\n");
   if(cblk->label)
      fprintf(stderr, "%s\n",cblk->label);
   for (crtl = cblk->rtls; crtl; crtl = crtl->next)
   {
      if(cnts(crtl))
      {
         fprintf(stderr, "*%d* ", crtl->rnum);
         for (i = 0; i < MAXLINKS && crtl->lnks[i]; i++)
            fprintf(stderr, "%d ", crtl->lnks[i]->rnum);

         show_rtl(stderr, crtl->val);
         fprintf(stderr, " ");
         if(crtl->deads)
         {
            fprintf(stderr, "deads -> ");
            rshow(crtl->deads);
            fprintf(stderr, " ");
         }
         fprintf(stderr, "\n");

      }
   }
   fprintf(stderr, "-------------------------\n");
   fflush(stderr);
}

#else

void show_block(struct bblock *cblk)
{
   struct list *crtl;
   int i;

   fprintf(stderr, "-------------------------\n");
   if(cblk->label)
      fprintf(stderr, "%s\n",cblk->label);
   for (crtl = cblk->rtls; crtl; crtl = crtl->next)
   {
      if(cnts(crtl))
      {
         fprintf(stderr, "*%d* ", crtl->rnum);
         for (i = 0; i < MAXLINKS && crtl->lnks[i]; i++)
            fprintf(stderr, "%d ", crtl->lnks[i]->rnum);

         show_rtl(stderr, crtl->val);
         fprintf(stderr, " ");
         if(crtl->deads)
         {
            fprintf(stderr, "deads -> ");
            rshow(crtl->deads);
            fprintf(stderr, " ");
         }
         fprintf(stderr, "\n");

      }
   }
   fprintf(stderr, "-------------------------\n");
}

#endif

void nullify_rtl(struct list *rtl)
{
  if (rtl == NULL)
    return;

  remv_links(rtl);

  if (rtl->val) {
    FREE(rtl->val);
    rtl->val = NULL;
  }

  if (rtl->deads) {
    rfree(rtl->deads);
    rtl->deads = rinit();
  }

  if (rtl->se) {
    FREE(rtl->se);
    rtl->se = NULL;

  }

}


/*
 * clear_block_info - clear basic block data
 */
void clear_block_info(register struct bblock * cblk) {

   register struct list *rtlptr, *drtl;
   register struct blist *bptr, *dptr;
   struct phi *pphi, *dphi;
   struct phi_list *pphil, *dphil;
   struct defnode *pdef, *ddef;
   struct loopl *loop;

   /*
      Release all records making up the predecessor list
   */
   bptr = cblk->preds;
   while (bptr) {
      dptr = bptr;
      bptr = bptr->next;
#ifndef VET
    /*
     * VET relies on receiving a unique ptr id for each
     * BB during the compilation of a function.
     */
      FREETYPE(dptr, BLISTTYPE);
#endif
   }

   cblk->preds = (struct blist*) NULL;
   /*
      Release all records making up the dominance frontier
   */
   bptr = cblk->dom_front;
   while (bptr) {
      dptr = bptr;
      bptr = bptr->next;
      FREETYPE(dptr, BLISTTYPE);
   }

   cblk->dom_front = (struct blist*)NULL;
   /*
      Release any SSA form information
   */
   pphi = cblk->phi_funcs;
   while (pphi) {
      pphil = pphi->sets;
      while (pphil) {
	 dphil = pphil;
	 pphil = pphil->next;
	 FREETYPE(dphil, PHILISTTYPE);
      }
      dphi = pphi;
      pphi = pphi->next;
      FREETYPE(dphi, PHITYPE);
   }

   cblk->phi_funcs = (struct phi*)NULL;

   pdef = cblk->sets_out;
   while (pdef) {
      ddef = pdef;
      pdef = pdef->next;
      FREETYPE(ddef, DEFNODETYPE);
   }

   cblk->sets_out = (struct defnode*)NULL;

   /*
      Release the storage used to hold the block label unless it is the return
      label, whose storage is in a static memory location.
   */
   if (cblk != ret_block && cblk->label) {
      FREE(cblk->label);
   }

#ifdef MEASURE
   dfree(cblk->dom);
   dfree(cblk->equivclass);
#endif

   rfree(cblk->dlist);
   rfree(cblk->ulist);
   rfree(cblk->olist);
   regfree(cblk->regstate);

   /*
      If this basic block happened to be the preheader of some loop at some
      point, then we better indicate that it no longer is.
   */
   for (loop = loops; loop; loop = loop->next) {
      if (loop->preheader == cblk) {
	 loop->preheader = (struct bblock *) NULL;
	 break;
      }
   }


   /* Null out all other basic block data */
   cblk->conin = cblk->conout = (struct ignode*) NULL;
   cblk->left = cblk->right = (struct bblock*)NULL;
}


char* get_glob_name(char* s)
{
        int a=vecmap[USP(s)];
        if(a==-1)
        {
                fprintf(stderr, "Attempt to get name of undefined global "
			" (%o %o %o %o)\n", s[0], s[1], s[2], s[3] );
                exit(1);
        }
        return globals+a;
}

void freetype_func(void* ptr, int type)
{
}


void FREE_func(void *ptr, int type)
{
  (*((char ***) ptr)) = freeptrs[type];
  freeptrs[type] = (char **) ptr;
  freetype_func(ptr, type);
  ptr = NULL;
}


void display_free_list(int type, FILE* fp)
{

	void* start=(void*)freeptrs[type];
	if(fp==NULL)  fp=stderr;

	while(start)
	{
		fprintf(fp,"%x ",start);
		start=(void*)*(int**)start;
	}	

	fflush(fp);
	
	return;
}

/*
 * RTL_sum - find the sum of all characters in the RTL
 */
int RTL_sum(struct list *rtl)
{
  char *c;
  int sum = 0;

  if(!cnts(rtl))
    return 0;
  
  for(c=rtl->val ; *c ; c++)
    sum += *c;
  
  return sum;
}

