
/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
  Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/vpo.c,v $
 $Date: 2004/01/21 18:40:02 $
 $Revision: 1.127 $
 $Name:  $

 Log of changes:

 $Log: vpo.c,v $
 Revision 1.127  2004/01/21 18:40:02  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.126  2004/01/15 15:43:38  jdh8d
 fixed C++ style comments .. don't put them in again, YOU HEAR ME WHOEVER DID THIS??

 Revision 1.125  2003/12/16 22:20:00  clc5q
 Move processing of ASMLINEs to dump_function() from optimize(), so that
    we will not affect the creation of ASMLINE RTLs that vpo needs.

 Revision 1.124  2003/11/18 01:58:05  clc5q
 Make number_basic_blocks() return the number of blocks in the function,
    and make calls to it reflect the fact that it now returns an int.

 Revision 1.123  2003/11/06 14:58:32  clc5q
 Define L2_DATA_CACHE_LINE_SIZE for non-CALLGRAPH targets.

 Revision 1.122  2003/11/06 13:38:55  clc5q
 Get rid of NotProcessingGlobal() stub for non-CALLGRAPH targets, as they
    all have stubs now in their rtl.c files.

 Revision 1.121  2003/11/04 16:02:44  clc5q
 Add swz flag for data placement optimizations.
 Add DeallocateDataProfile() for use by global profiling.
 Continue implementation of global profiling and data placement.  Make use of
    NotProcessingGlobal() and emitAsmForGlobals, and stub out the former for
    non-CALLGRAPH targets.

 Revision 1.120  2003/10/28 19:27:18  jdh8d
 added if(moreopts) check to remove_null_rtls()

 Revision 1.119  2003/10/14 09:25:07  jdh8d
 fixed vet/vista phase name issue when VET turned on

 Revision 1.118  2003/10/08 15:17:08  jdh8d
 fixed begin/end_trans mismatch

 Revision 1.117  2003/10/06 08:59:01  clc5q
 Enhance debugging output.
 Fix a comment.

 Revision 1.116  2003/10/05 12:14:35  clc5q
 Export process_metaline() for callgraph use.

 Revision 1.115  2003/09/03 19:52:22  clc5q
 Ran indent tool over file and fixed up a few cosmetic details by hand.

 Revision 1.114  2003/09/02 15:45:22  jdh8d
 changes to support partitioning/callgraph

 Revision 1.113  2003/08/28 18:29:35  jdh8d
 changes to get tms working; rtl deleted twice in cdmotion.c

 Revision 1.112  2003/08/27 02:45:38  jdh8d
 minor changes to make VISTA build

 Revision 1.111  2003/08/21 20:30:29  jdh8d
 changes to ease for tms

 Revision 1.110  2003/08/19 16:33:50  jdh8d
 fixed multiline constants added by (i think) indent tool

 Revision 1.109  2003/07/17 04:33:39  jg9h
 VISTA update

 Revision 1.108  2003/05/19 13:11:51  clc5q
 Remove calls to estimate_execution_frequency().  This will be called in
     the future only from machine-dependent code when it is needed.

 Revision 1.107  2003/04/29 19:58:50  jg9h
 Some VISTA fixes.

 Revision 1.106  2003/04/23 21:52:37  jg9h
 *** empty log message ***

 Revision 1.105  2003/04/23 21:47:28  jg9h
 Call to instruction_scheduling put within #ifdef SCHED

 Revision 1.104  2003/04/04 04:36:48  jg9h
 Removed C++ style comments from INTERACT code

 Revision 1.103  2003/04/03 23:09:40  jg9h
 If the code-expander emits a metaline with reg/local/glob size info - make a safety check.

 Revision 1.102  2003/04/03 20:06:11  jg9h
 Merged latest in VISTA with latest in vpo.

 Revision 1.101  2003/03/26 20:27:44  jdh
 added call to remv_dead_var's before l_r_a

 Revision 1.100  2003/03/26 17:30:13  jdh8d
 lva needs to always be called.. can't control with if(moreopts)

 Revision 1.99  2003/03/20 15:01:50  jdh8d
 sign-ext fix for x86

 Revision 1.98  2003/03/18 16:44:17  jdh8d
 *** empty log message ***

 Revision 1.97  2003/03/14 01:34:20  jdh8d
 i386 bug fixes

 Revision 1.96  2003/03/06 16:14:19  jdh8d
 *** empty log message ***

 Revision 1.95  2003/02/18 15:56:23  jdh8d
 minor tweaks/callgraph improvements

 Revision 1.94  2003/02/06 04:46:30  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.93  2002/11/21 22:45:36  jwd
 Added tail call optimization flag (the B flag).

 Revision 1.92  2002/10/03 19:13:15  clc5q
 Ran through indent tool. Made other cosmetic fixes by hand.

 Revision 1.91  2002/10/03 15:49:37  clc5q
 Replace "extern ..." garbage in *.c files with extern declarations in
 header files.

 Revision 1.90  2002/07/11 15:22:53  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.89  2002/06/17 21:52:52  clc5q
 Bug Fix: evaluation_order_determination() was not called if FIX symbol
 was not defined and -N was not given on the command line, because of
 accidental nesting of if-statements that resulted.

 Revision 1.88  2002/06/05 20:08:54  jdh8d
 Changes to support the stache, including routines to build a callgraph.

 Some cosmetic changes.

 Minor bug fixes.

 Changed build scripts to build the mips compiler for SimpleScalar if
 SSAS is set to "-DSS_AS"

 Revision 1.87  2002/06/04 15:29:12  jwd
 Modified rshow to use the correct macro.  Some items on the deadlist might
 be two characters.

 Revision 1.86  2002/04/02 21:17:06  rv3s
 rebuild_dom_front() called after minimize_registers to make sure loop information such as loop invariants are correctly cleared out after minimize_registers

 Revision 1.85  2002/04/02 21:14:02  jwd
 Removed an unnecessary call to set_global_links and reformatted some code.

 Revision 1.84  2002/03/26 02:47:52  rv3s
 New optimizer option 'Q' turns on optimizer warnings

 Revision 1.83  2002/03/25 17:09:13  rv3s
 New routine remove_null_rtls added to remove rtls with empty value and deadlist

 Revision 1.82  2002/03/21 15:43:53  jdh8d
 *** empty log message ***

 Revision 1.81  2002/03/19 22:19:15  rv3s
 *** empty log message ***

 Revision 1.80  2002/03/18 20:13:29  jdh8d
 *** empty log message ***

 Revision 1.79  2002/03/18 15:49:39  jdh8d
 *** empty log message ***

 Revision 1.78  2002/01/17 15:50:01  jdh8d
 *** empty log message ***

 Revision 1.77  2002/01/15 15:38:21  jdh8d
 *** empty log message ***

 Revision 1.76  2002/01/11 13:26:17  jdh8d
 *** empty log message ***

 Revision 1.75  2002/01/07 22:00:10  jdh8d
 *** empty log message ***

 Revision 1.74  2002/01/01 15:38:26  rv3s
 vpo.c

 Revision 1.73  2001/12/31 02:46:47  rv3s
 controlflow optimization done until no change before local register assignment

 Revision 1.72  2001/12/29 13:40:02  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.71  2001/12/19 21:40:08  jdh8d
 *** empty log message ***

 Revision 1.70  2001/12/11 14:48:07  jdh8d
 *** empty log message ***

 Revision 1.69  2001/12/03 19:52:57  jdh8d
 *** empty log message ***

 Revision 1.68  2001/11/27 21:02:59  jdh8d
 *** empty log message ***

 Revision 1.67  2001/11/27 20:38:17  rv3s
 simplify_controlflow() called before color_global_allocation. instruction_selection called before CSE

 Revision 1.66  2001/11/21 18:00:29  jdh8d
 *** empty log message ***

 Revision 1.65  2001/11/16 17:16:20  rv3s
 set_sides() call at the end of simplify_controlflow removed. set_rtl_sides now used to set SE for individual rtls wherever required

 Revision 1.64  2001/11/16 15:11:10  rv3s
 New routine dump_block_by_label() added to display blocks by their label. The
 routine returns the block which can then be used to display other blocks.

 set_sides() called at the end of simplify_controlflow() to make sure side
 effects are correctly set for subsequent processing (sparc failed gap and vpr
 because of this)

 Revision 1.63  2001/11/15 19:18:54  rv3s
 *** empty log message ***

 Revision 1.62  2001/11/14 19:44:33  jdh8d
 *** empty log message ***

 Revision 1.61  2001/11/13 17:04:51  jdh8d
  fixed memory leaks

 Revision 1.60  2001/11/09 18:12:26  jdh8d
 *** empty log message ***

 Revision 1.59  2001/11/08 21:09:36  jdh8d
 *** empty log message ***

 Revision 1.58  2001/11/07 01:48:06  jdh8d
 *** empty log message ***

 Revision 1.57  2001/11/06 19:23:54  rv3s
 simplify_controlflow() called after predicate_basic_blocks since predication now includes moving rtls from branch target

 Revision 1.56  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.55  2001/10/25 22:08:36  jdh8d
 added some checks to avoid excessive memory usage

 Revision 1.54  2001/10/22 20:42:53  jdh8d
 *** empty log message ***

 Revision 1.53  2001/10/09 14:10:59  jdh8d
  changes to put _16 on implicit func names in sanyo mode

 Revision 1.52  2001/10/08 15:15:56  jdh8d
 *** empty log message ***

 Revision 1.51  2001/10/03 13:12:18  jdh8d

 Changes to support only 2-letter tokens that don't
 interfere with memory reference.

 EG:

 	d[0]=ID[r[0]] looks like a memory reference.

 We've now disallowed two character tokens that end in
 a letter that's used as a memory reference.

 (exceptions: PC, ST, and RT are always allowed, even if
 C, or T memory types are defined)

 Revision 1.50  2001/10/01 01:49:01  jdh8d
 *** empty log message ***

 Revision 1.49  2001/09/30 17:37:11  jdh8d
 *** empty log message ***

 Revision 1.48  2001/09/25 19:34:20  jdh8d
 *** empty log message ***

 Revision 1.47  2001/09/25 15:30:31  jdh8d
 *** empty log message ***

 Revision 1.46  2001/09/24 14:08:59  jdh8d
 *** empty log message ***

 Revision 1.45  2001/09/15 01:57:05  jdh8d
 *** empty log message ***

 Revision 1.44  2001/08/31 21:00:33  jdh8d
 *** empty log message ***

 Revision 1.43  2001/08/31 20:32:39  rv3s
 set_local_links called after CSE to make sure links are set right

 Revision 1.42  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.41  2001/08/30 15:43:29  jdh8d
 *** empty log message ***

 Revision 1.40  2001/08/28 21:05:00  jdh8d
 *** empty log message ***

 Revision 1.39  2001/08/22 22:28:00  jdh8d
 *** empty log message ***

 Revision 1.38  2001/08/20 22:01:48  jdh8d
 *** empty log message ***

 Revision 1.37  2001/08/15 21:18:22  jdh8d
 *** empty log message ***

 Revision 1.36  2001/08/14 13:50:31  jdh8d
 *** empty log message ***

 Revision 1.35  2001/07/27 18:51:51  jdh8d
 *** empty log message ***

 Revision 1.34  2001/07/26 16:13:58  jdh8d
 *** empty log message ***

 Revision 1.33  2001/07/23 18:35:28  rv3s
 Replaced skiploc() with skiplocOr2() for processing register lists

 Revision 1.32  2001/07/16 17:43:47  jdh8d


 Add a new type of rtl.  METADATALINE.  VPO ignores the
 assuming that the meta-data is used by the machine
 dependent portions.  Later, machine-independent meta-data
 may become available.  None-so-far.

 Revision 1.31  2001/06/18 19:35:43  jdh8d
 *** empty log message ***

 Revision 1.30  2001/06/08 15:05:51  jdh8d
 *** empty log message ***

 Revision 1.29  2001/06/05 18:55:38  jdh8d
 *** empty log message ***

 Revision 1.28  2001/06/04 11:07:17  jdh8d
 *** empty log message ***

 Revision 1.27  2001/05/24 14:54:23  jdh8d
 *** empty log message ***

 Revision 1.26  2001/05/23 20:28:21  jdh8d


 Re-worked all of the backend to support variable
 sized registers.  IT IS  NO LONGER SAFE TO ASSUME
 THAT REGISTERS ARE TWO BYTES.  Mips currently has
 4-byte registers, others will follow (or be destroyed!)

 Revision 1.25  2001/05/21 18:43:11  jdh8d

 changes to watch register aliases and SE's more clothes

 Revision 1.24  2001/05/16 18:53:40  jdh8d
 Changes to support "soft floating point"

 Revision 1.23  2001/04/25 21:18:49  jdh8d
 *** empty log message ***

 Revision 1.22  2001/04/25 19:40:45  jdh8d

 changed controlflow to check for "useless" blocks
 by checking that there are no "useful" rtls.  added
 an optimization to view.h so we can vpoiso some stuff,
 and made vpo.c call some of the label optimizations more
 frequently.

 Revision 1.21  2001/04/25 16:05:13  jdh8d

 Added remove_useless_cond_branches.  This may go to mach. independent
 sometime soon.  It's pretty useful.

 Revision 1.20  2001/04/19 15:11:03  jdh8d
 Initial implentation of "if conversion" for basic predicated
 execution.

 Revision 1.19  2001/04/12 22:14:52  jdh8d

 fixed bug.

 Revision 1.18  2001/04/09 20:48:34  jdh8d
 *** empty log message ***

 Revision 1.17  2001/04/09 15:48:42  jdh8d

 Debugging w/o DISPOSE turned on.

 Revision 1.16  2001/04/04 19:41:39  jdh8d

 fixed bugs and lots of them.  cse was removing a "redundant" store
 because it didn't recognize an aliased load.  Code motion was calculating
 the offset wrong if the update of the induction variable happened
 in the same RTL as the load/store using that var, etc.

 Revision 1.15  2001/01/28 21:28:18  jwd
 Modified call to fixentry to only pass the preds of the return block
 when the return block pointer was non-NULL.  Most functions always
 have a return, but for C++ EDG does not always generate a return for
 a function when an exception handler is called.  In this case, there
 is no return block.

 Revision 1.14  2000/10/18 02:28:53  jwd
 Added a new vpo directive (O<flags>) where flags are optimization
 flags.  This gives us the ability to turn different optimizations
 on for different functions withing the same module.  This is useful
 for debugging as you can isolate an error down to a function.

 Revision 1.13  2000/10/10 19:52:46  jwd
 Clean up some printfs in some of the debugging routines.

 Revision 1.12  2000/09/19 23:09:26  jwd
 The return basic block is allocated only when needed.  This was changed
 so that we could handle the SPARC's structure return protocol.

 Revision 1.11  2000/06/09 19:49:01  jwd
 Added parameter line to indicate that a registers is used as a parameter.  This
 required making the type word of the struct list be an integer
 instead of a short.

 Revision 1.10  2000/03/15 16:20:40  jwd
 Made the fix control-flow code (for the SUIF front end) controlled by conditional
 compilation.
 
 Also added a routine for debugging.  It shows the set lines.
 Revision 1.9  1999/03/18 20:13:08  jwd
 Merged in support for vpoiso.
 Revision 1.8  1999/03/05 17:12:54  jwd
 Added a debug function ShowPreds().
 Revision 1.7  1999/01/06 15:55:33  jwd
 Originally the side effect field was used to hold the initial dead list
 which was a string. During initialization, the SE field was converted
 to a bit vector representation and SE was used for real side effects.
 This caused numerous problems (with VET and other phases). A
 new field (InitialDeads) was added to hold the initial list of dead
 registers.
 
 Added VET support too.
 Revision 1.6  1998/07/02 20:11:18  jwd
 Made LeafFunction be defined in this module. Some targets
 do not require leaf optimizations, therefore they should not
 be responsible for the definition of LeafFunction.
 Revision 1.5  1998/06/26 21:06:09  jwd
 The include file linstinfo.h was misspelled.
 
 Added the global LeafFunction.  This object is initially set to true.
 If an ARGBUILD directive is encountered, LeafFunction is set
 to false.
 
 Added the P directive. This directive contains the registers that
 have the outgoing parameters.  This enables us to build a
 side-effect line which says these values are used.  Otherwise
 the optimizer will delete their sets.
 Revision 1.4  1998/04/29 19:22:56  jwd
 Change FT to FALLTHRU to avoid a conflict with two
 letter constants found in scan.h.
 Revision 1.3  1998/04/03 18:20:38  jwd
 First ANSI C version.

 ************************************************************************/

/*------------------------------------------------
  History of Changes
  -------------------
  1/13/98: Removed local prototypes in order to make code more modular and
           to support ANSI-C function prototyping.
------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <sys/wait.h>
#include <sys/time.h>

#include "vpo.h"
#include "assign.h"
#include "cdmotion.h"
#include "cross.h"
#include "cse.h"
#include "combine.h"
#include "controlflow.h"
#include "database.h"
#include "dataflow.h"
#include "eod.h"
#include "locals.h"
#include "links.h"
#include "live.h"
#include "misc.h"
#include "vectors.h"
#include "vpo2.h"

#include "inst.h"  /* Machine Dependent */
#include "isem.h"  /* Machine Dependent */
#include "regs2.h" /* Machine Dependent */
#include "rtl.h"   /* Machine Dependent */
#include "y.tab2.h"     /* Tools Dependent */

#ifdef STACHE
#include "stache.h"
#include "placement.h" /* Machine Dependent */
#endif

#ifndef CALLGRAPH
#ifndef L2_DATA_CACHE_LINE_SIZE
#define L2_DATA_CACHE_LINE_SIZE 64
#endif
#endif

#ifdef VET
#include <setjmp.h>
#include "view.h"
#endif

#ifdef MEASURE
#include "addrdef.h"
#include "linstinfo.h"  /* Machine Dependent */
#include "measure.h"
#endif

#if SCHED || FILL
#include "schedule.h"
#endif

#ifdef INTERACT
#include "view_socket.h"
#include "hand_trans.h"
#endif

/*

  The following items can be defined during compilation of vpo in order
  to customize it to the various different needs of the host machine:

    DISPOSE       If defined, vpo will utilize a fast memory allocation
                  algorithm that does not free up memory except between
                  procedures.  This method is much faster than the standard
                  malloc() and free() utilized if DISPOSE is not defined.
                  DISPOSE should be defined unless the host machine does
                  not have enough memory to compile large procedures.

    ADDR          Must be defined if the target machine description uses
                  the A[..] notation to indicate address expressions in
                  the RTLs.

    AUTO          Must be defined if the target machine description uses
                  autoincrement or autodecrement addressing modes that are
                  referenced in the RTLs using a C-like notation.

    SCHED         If defined, code to support instruction scheduling is
                  included.

    FILL          If defined, code to support filling in of instruction
                  delay slots is included.

    FIFOS         If defined, calls are made to fifocheck() before combiner
                  attempts combinations in order to ensure that fifo ordering
                  is maintained.

    STREAM        If the machine has stream instructions, this item should
                  be defined.

    MEASURE       This item should be defined if measurements from the
                  execution of programs is desired.

    MUSTALIGN     This item must be defined on systems where the host
                  machine must have all shorts aligned on word boundaries.
                  This prevents the optimizer from trying to decode
                  regsiters inside RTL strings by casting them through
                  unsigned short pointers.

    ENDFILE       If this item is defined, the optimizer will invoke a function
                  named endfile() immediately before successfully exiting.  The
                  purpose of this function is to allow any machine-dependent or
                  special measurement features to emit any final information to
                  the output file or the user.

    VET           This item is defined so that viewing or error isolation
                  can be performed.

    RRLRA         This enables the experimental Round Robin Local Register
                  Allocator.

    WIDES         Enables load and store coalescing optimization on machines
                  such as the Alpha that have 64-bit loads and stores.

    PRED          Enables predication of code on machines that have
                  predicated instructions, such as the ARM.

*/

#ifdef INTERACT
int   limited_scope;
#endif

/*set when yyparse is called during debugging, which allows the compiler to
  return an error instead of quitting*/
int check_legal;
int   maxtrans;
volatile int moreopts;
jmp_buf my_env;

int   swa = FALSE;              /* assembly output option         */
#ifdef INTERACT
int   swb = FALSE;              /* basic I.V. elimination option  */
#else
int   swb = FALSE;              /* tail call optimization */
#endif
int   swc = FALSE;              /* common subexpression option    */
int   swd = 0;                  /* debug mode option              */

#if defined(MEASURE) || defined(INTERACT)
int   swef = FALSE;             /* frequency measurement option   */
int   swei = FALSE;             /* instruction cache option       */
int   swed = FALSE;             /* data cache option              */
int   swep = FALSE;             /* precision timing option        */
#endif

#ifdef FILL
int   swf = FALSE;              /* fill delay slots option        */
#endif

int   swg = FALSE;              /* link across blocks option      */
#ifdef SCHED
int   swi = FALSE;              /* instruction scheduling option  */
#endif

#ifdef INTERACT
int   swk = FALSE;              /* recurrence optimization option */
#endif
int   swl = FALSE;              /* label optimizations option     */
int   swm = FALSE;              /* code motion option             */
int   swn = FALSE;              /* fix up control flow            */
int   swo = FALSE;              /* register coloring option       */

#ifdef PRED
int   swp = FALSE;              /* Attempt to predicate basic blocks */
#endif

int swur = FALSE;               /* Start loop Unrolling */
#ifdef INTERACT
int   swq = FALSE;              /* interactive compilation option */
int   swq_noviewer = FALSE;        /* vista debug option, no viewer */
int   user_directed = FALSE;    /* user can send requests to vpo  */
int   save_trans = FALSE;       /* save all transactions to a .trans file */
#else 
int   swq = FALSE;              /* Optimizer warnings */
#endif

int   swr = FALSE;              /* simple reg allocation option   */
int   sws = FALSE;              /* strength reduction option      */
#ifdef VET
#ifdef INTERACT
int   swth = TRUE;              /* remote host name follows       */
int   swtp = TRUE;              /* port number follows            */
#else
int   swth = FALSE;             /* remote host name follows       */
int   swtp = FALSE;             /* port number follows            */
#endif
int   swtd = FALSE;             /* dump num transformation flag   */
int   swtm = FALSE;             /* max num transformation flag    */
#endif
int   swv = FALSE;              /* evaluation order determination */
int   sww = FALSE;              /* suppress warning messages flag */
int   swx = FALSE;              /* execution timing profile flag  */
int   swz = FALSE;              /* data placement optimizations   */

int   sw1 = FALSE;     /* to turn off register assignment  */

/* swp followed by another letter are the STACHE placement switches. */
int   swpa = FALSE;    /* use address paradigm.  +I shouldn't be specified */
int   swpb = FALSE;
int   swpc = FALSE;
int   swpd = FALSE;
int   swpe = FALSE;
int   swpf = FALSE;

int   swpg = FALSE;    /* Build an interprocedural call graph
                        * for use when optimizing functions
                        * Warning:  this flag requires input to come 
                        * from a file so that a 2nd pass can be made.
                        */
int   swph = FALSE;

int   swpi = FALSE;    /* Use the instruction paradigm;
                        * +A shouldn't be specified.
                        */
int   swpj = FALSE;
int   swpk = FALSE;

int   swpl = FALSE;    /* The program libraries are included in this .cex file
                        * so even more aggressive cross-module optimizations
                        * can be made.  Should be used with +W
                        */

int   swpm = FALSE;
int   swpn = FALSE;


int   swpo = FALSE;    /* Specifies a file to read a user specified
                        * assignment from.
                        */
char  optimal_assignment_filename[MAXSTRING] = { 0, };
FILE *optimal_assignment_fn = NULL;

int   swpp = FALSE;             /* emit a special file for the profile */
char  profile_filename[MAXSTRING] = { 0, };
FILE *profile_fn = NULL;

int   swpq = FALSE;
int   swpr = FALSE;
int   swps = FALSE;

int   swpt = FALSE;

int   swpu = FALSE;    /* Use profile info generated by swpp+simplescalar to
                        * generate code for a partitioned version of this
                        * machine.
                        */
char  input_profile_filename[MAXSTRING] = { 0, };

int   swpv = FALSE;    /* Specify partition description file. */
char  partition_description_filename[MAXSTRING] = { 0, };


int   swpw = FALSE;    /* The whole-program is represented in this .cex file.
                        * Optimizations that require information about the
                        * entire program are safe.
                        */

int   swpx = FALSE;
int   swpy = FALSE;
int   swpz = FALSE;
int lcount;

/* we want these global so we can simplify the main control loop */
int   csalloc, r_b_c_count, r_u_j_count, r_u_c_count;
int   r_j_count, m_j_count, i_s_count, l_v_a_count, g_a_count, m_c_s_count;
int   c_s_e_count, r_d_v_count, c_m_count, s_s_r_count, r_u_b_count;
int   m_b_b_count, f_d_f_count, r_u_c_b_count, p_count;
int   cj_count = 0;
int   r_d_f_c = 1;
#ifndef WIDES
int   d_f_s_count, b_d_t_count;
#endif

#ifdef INTERACT

/* Flags to enable sanity check after each phase or each transform. */
int   phase_sanity_check = FALSE;
int   transform_sanity_check = FALSE;

/* Flags to enable getting frequency measurements. */
int   measure_phase = FALSE;
int   measure_init = 0;
char *measure_fn;

/* Flag to set frequency measurements after each phase. */
int   continuous_measures = FALSE;

/* Variable to store current phase execution measure. */
int   phase_measure = -1;

/* Store the number of transformations to be applied from the trans file. */
int   apply_trans;

/* To hold the current optimization phase being attempted. */
int   curr_oper;
#endif /* INTERACT */

/*
 * The following item contains the list of debug options given to the
 * optimizer in the command line, if any.
 */
char  d_options[MAXOPTIONS][MAXSTRING];

struct bblock *top;             /* entry basic block              */
struct bblock *ret_block;       /* exit "return" basic block      */
struct bblock *bottom;          /* last item in depth-first-order */
struct bblock *last;            /* last basic block allocated     */
int   bitsperint;               /* bits in an integer on the host */
int   intscale;                 /* log2(bitsperint), scale factor */
int   int2char;                 /* scale factor to yield bytes    */
int   regallocptr;              /* register vector allocation ptr */
unsigned int gallocptr;         /* global id allocation pointer   */
int   hregnum;                  /* number of hardware registers   */
char *fn;                       /* name of the current function   */
char *sret;                     /* side effect for return label   */
int   varargs;                  /* indicates that varargs is used */
char **freeptrs[ENDFREETYPES];  /* free structures pointers       */
int   vecmap[MAPREGS];          /* register lookup information    */
char  globals[GLOBALS];         /* global identifier storage      */
char  regprt[MAXSTRING];        /* type-to-register map info      */
int   opers[MAXCHARS];          /* operator lookup array          */
int   mems[MAXCHARS];           /* memory type lookup array       */
rlist pseudos;                  /* vector containing pseudo-regs  */

/* Used to store the filename when profiling */
char  profileName[MAXCHARS];

/* Used to specify the filename for data symbol info */
char  dataProfileName[MAXCHARS];

/* Used to store the filename of the file
 * that describes stache usage for a library 
 */
char  libraryFilename[MAXCHARS];

#ifdef DISPOSE
char  inbuf[BUFSIZ];            /* input file buffer              */
char  outbuf[BUFSIZ];           /* output file buffer             */
char  errbuf[BUFSIZ];           /* error file buffer              */
char  instbuf[BUFSIZ];          /* instrumented assembly file buf */
char  asmbuf[BUFSIZ];           /* assembly file buffer           */
char  rtlbuf[BUFSIZ];           /* RTL file buffer                */
char  combbuf[BUFSIZ];          /* results log file buffer        */
char *startmem;                 /* pointer to allocated mem start */
#endif
#ifdef INTERACT
char  optbuf[BUFSIZ];           /* options file buffer            */
char  transbuf[BUFSIZ];         /* trans file buffer              */

int   links_modified = 0;       /* indicates that a mod_links
                                 * function was called in view.c  */
int   num_trans_done[NUM_TRANS_TYPES];  /* indicates the number of
                                         * transformations done of each
                                         * type.
                                         */
unsigned int trans_done;        /* indicates if one or more
                                 * transformations of a given type
                                 * have been performed            */
int   rtl_id = 0;               /* used to generate unique RTL ids */
int   session_over = FALSE;     /* indicates if the interactive
                                 * session has been terminated    */
#endif

#ifdef VET
#ifndef MAXHOSTNAMELEN  /* Solaris defines this           */
#define MAXHOSTNAMELEN 64       /* this is a SunOS constant       */
#endif
char  host[MAXHOSTNAMELEN + 1]; /* host running VET               */
int   port;                     /* port number on VET host        */
char  basename[100];            /* basename of C file compiled    */
#endif

#ifdef INTERACT
FILE *fopt;                     /* interactive options stream     */
char  pathname[100];            /* pathname of C file compiled    */
int   fill_delay_done = 0;      /* indicates if the fill delay
                                 * slots phase has been done      */
extern int glo_sockfd;
#endif

int   LeafFunction = TRUE;

void  clear_dominators();
void  rebuild_dom_front(int invocation);

#ifdef WIDES
int   d_f_s_count, b_d_t_count;
#endif

#ifdef INTERACT

/* INTERACT sets instfp to a file.
   MEASURE just uses stdout
*/
FILE *instfp;
FILE *asmfile;
#endif

#ifdef INTERACT
#define ERR_EXIT(MSG) { send_error(MSG); exit(EXIT_FAILURE); }
unsigned long cex_checksum;
unsigned long file_checksum(FILE * filename);

int   measure_flag, save_measure_flag;

/*assembly file pointer*/
FILE *rtlfile,*conf_fp, *conf_fp, *comb_log;
char asm_filename[100], rtl_filename[100], inst_filename[100];

void  dump_rtl_asm(int dump_swa, FILE * fp, int is_gen_flags);
int   read_one_command(int sockfd, char *option);
int   show_ASM = FALSE;
int   show_RTL = FALSE;

/* Store old file offsets, to reset during the measurements phase. */
long  cex_offset, s_offset, rtl_offset, trans_offset;

/* Variables used in interactive_optimize during reading optimizations. */
int   pc, valid_analysis;

/* Number of the current function. */
int   function_number = 0;

/* Records if this phase caused any change by checking if any messages are
 * sent to the viewer.*/
 int   is_change;

/*variable to track the transforms which actually produce a change*/
int real_change;

/*variable to check if dead variable list has been changed during the phase*/
int dead_list_change;

/*variable to check if local information like "nouse, reps" has been
  changed*/
int locals_change;

/* One measurement after hand transformations, after end_phase. */
int   hand_measure = FALSE;

/* Initial frequency measurement of the function. */
struct freq_counts *initial_count=NULL;

/* To hold the current population during genetic algorithm search. */
struct chromosome popu[MAX_CHROMOSOMES];

/*the hashtable used during a gentic algorithm search*/
struct HASHTABLE *htable[NUM_HTABLE_ELEMENTS];

/*hashtable to check is the successfully applied phases match during the
  genetic algorithm */
struct HASHTABLE *succ_htable[NUM_HTABLE_ELEMENTS];

/*do not take measures during a SEL..COMB, if that function is never called
  and so always has execution count of 0*/
int is_take_measure;

/*variable to hold the genreport path, read in from a configuration file*/
char genreport_path[MAXSTRING];

/*hashtable of RTLs for fast comparisons during Sel..Comb*/
struct RTL_hash *rtl_hash[RTL_HASH];
/*hashtable of re-mapped RTLs*/
struct RTL_hast *remap_rtl[RTL_HASH];

/*hashtable of distinct functions for fast comparisons*/
struct Func_hash *func_hash[FUNC_HASH];
/*hashtable of function with remapped RTLs*/
struct Func_hash *remap_func[FUNC_HASH];

/*hashtable of distinct CRC values for distinct function instances*/
struct CRCTABLE *crc_htable[NUM_CRC_ELEMENTS];

/*table of pointers to RTLs. This table contains complete lists of RTLs for
  each function. Thus, RTLs may be repeated here*/
struct RTL_hash *rtl_ptr[MAX_RTL];
int pptr_rtl;

/*table for remappping labels, one from labels defined in VPO and one for
  labels read in from the input .cex file*/
int label_table[MAX_LABELS], cex_label_table[MAX_CEX_LABELS];
int remap_label_num, remap_cex_label_num;
int remap_regs[MAXREGS];

/*tree structure to check for repetitions in attempted and successful
  sequences*/
struct tree_struct *tree;
unsigned int tree_ptr;

/*pointer to the file containing random numbers*/
FILE *rand_fp;
char rand_buf[BUFSIZ];

/*counter to count the number of times mutation occured*/
unsigned long long mutation_count;
unsigned long long tot_rand = 0;

/*flag to indicate if execution is to be resumed from some previous point*/
int resume_mode;
/*pointer to log file, used during resume execution mode*/
long resume_log_ptr=0;

/*limited version of branch chaining where only empty blocks would be
  eliminated*/
int limited_branch_chaining=FALSE;
int limited_dead_code_elim=FALSE;

/*variables for DFS exhaustive search*/
int is_ex_search= FALSE;
struct dfs_struct dfs_level[MAX_PRO_LEVELS];
struct blk_inscope dfs_scope;
int phase_order[MAXPHASES] = {1, 3, 4, 5, 6, 8, 10, 13, 14, 15, 16, 21, 25, 27, 29, -1};

/*new function instance profiling variables*/
struct FHASH *finst[FINDEX+1][F2INDEX+1], *r_finst[FINDEX+1][F2INDEX+1];
struct perf_hash *ind_hash[FINDEX];
struct CFList *cflist=NULL;
char pro_fbase[MAXSTRING];
unsigned int base_CRC, base_fhash;
int pro_apply_base=FALSE, profile_level, pro_cnt, pro_is_cex_file=FALSE;
int pro_cex_line, pro_opt_level, base_rcount, pro_cex_opt[MAX_PRO_LEVELS];
int is_pro_base=FALSE, pro_is_fn_exec, ex_flags=0;
int old_batch=FALSE, prob_batch=FALSE, active_batch=FALSE;
int execute_status=0, func_inst_cnt, profile_cnt;
char **pro_cex_file;
char *list_cex_files[MAX_PRO_LEVELS][MAX_CEX_LINES];
struct bk_fn_info pro_fn_start;
int rtl_debug=0;
FILE *crc_fp;

/*store labnum at the start of this function*/
int curr_fn_labnum;

/*variables needed during probabilistic batch compilation using phase context
  information*/
int ph_pos[MAXPHASES] = {-1, 0, -1, 1, 2, 3, 4, -1, 5, -1, 6, -1, -1, 7, 8, 9, 10, -1, -1, -1, -1, 11, -1, -1, -1, 12, -1, 13, -1, 14};
int rev_ph_pos[ACTPHASES] = {1, 3, 4, 5, 6, 8, 10, 13, 14, 15, 16, 21, 25, 27, 29};/*during collecting phase context, we have 31 bits in an integer, but only
  have 15 phases. This means that we can assign multiple bits to some phases
  which are active multiple times. Although this still does not get us phase
  ordering information, it is more information than just counting it phase
  has been done or not. We define some additional helper arrays to do this
  work*/
int ph_shift[ACTPHASES]={0, 2, 3, 4, 5, 6, 11, 13, 14, 16, 19, 23, 25, 28, 30};
int ph_mask[ACTPHASES]={3, 1, 1, 1, 1, 31, 3, 1, 3, 7, 15, 3, 7, 3, 1};
char basepath[MAXSTRING];

#if PH_CONTEXT || PH_CONTEXT1
int fn_found;
struct PH_CON *pcon[PINDEX+1];
#endif

#endif /*INTERACT*/

void process_metaline(char *val);

/* DeallocateDataProfile - free the memory in a struct DataProfile
 * contained in the given basic block.
 */
void DeallocateDataProfile(struct bblock *cblk) {
   struct varl *temp, *temp2;

   assert(NULL != cblk);
   assert(NULL != cblk->prof);

   temp = cblk->prof->FirstLocal;

   while (NULL != temp) {
      temp2 = temp->next;
      FREE(temp);
      temp = temp2;
   }
   cblk->prof->FirstLocal = NULL;
   cblk->prof->LastLocal = NULL;
   FREE(cblk->prof);
} /* end of DeallocateDataProfile() */

/*
 * main - read input file a procedure at a time and call the optimizer
 */
#ifdef INTERACT
int vpo_main(int argc, char **argv)
{
#else
int main(int argc, char **argv)
{
#endif

#ifdef ARM_TARGET
   int   first_star = 0;
#endif
   register struct bblock *cblk;
   register struct list *ptr;
   register int type;
   char line2[MAXSTRING], litem[MAXSTRING], tstr[MAXSTRING];
   int num, valid, next;
   struct bblock *exists;
   struct list *prev;
   struct locuse *locptr;
   int   noflow, direct, rt, index, rcont;
   unsigned int ui;
   int   LineNumber = 0, max_labnum=-1;
   char *a, *label, *line, *setptr, *cptr, setline[MAXSTRING];
   char *opt_flags[2];  /* For resetting optimization flags on the fly. */
   struct list *curr_rtl;
#ifdef VET
   int   i = 0;
#endif

#ifdef INTERACT
   char  cmd[MAXSTRING];
   extern int viewing;
   FILE *genreportfp;
   char  filename[100];
#endif

   /*
    * Check that none of the two-letter tokens conflict with 
    * a memory reference.
    */
   check_tokens();

   /*
    * Parse the command line arguments with which the optimizer was invoked.
    */
   parse_arguments(argc, argv);

   /*
    * Initialize the free list for the various structures that are often
    * re-claimed.
    */
   for (type = 0; type < ENDFREETYPES; type++)
      freeptrs[type] = (char **) NULL;

   /* Startup external viewer - VET */
#ifdef VET
#ifdef INTERACT
   if (swq)
#endif
      if (swth && swtp && !swq_noviewer)
         startup_viewer(host, port);
#endif

#ifdef DISPOSE
   /*
    * This is required to protect the I/O buffers on systems where these
    * buffers are automatically malloced the first time that they are used.  If
    * these setbufs are left out, the buffers would be returned to the heap and
    * improperly re-alocated to something else after the first call to
    * dispose().
    */
   setbuf(stdin, inbuf);
   setbuf(stdout, outbuf);
   setbuf(stderr, errbuf);
#endif
#ifdef VET
#ifdef INTERACT
   if (swtd)
      initnumtranslist(argv[2], "numtrans.txt");
   else if (swtm)
      initnumtranslist(argv[2], "maxtrans.txt");
#else
   if (swtd)
      initnumtranslist(argv[1], "numtrans.txt");
   else if (swtm)
      initnumtranslist(argv[1], "maxtrans.txt");
#endif

#endif  /* VET */

   /*
    * Now we are going to find out some things about the host machine.  First,
    * find out how many bits make up an unsigned integer.  This number is
    * needed to determine what length of bit vectors must be to contain the
    * required number of bits.  Note that "bitsperint" is adjusted down to the
    * nearest power of two (which on every machine I can think of, it already
    * is) and subtracted by one.  In addition, "intscale" is set to the number
    * of right-shift operations required to scale a number in bits to a number
    * in ints (or log2(bitsperint)).  The last item we need is the number of
    * times that we need to shift an amount in ints left to obtain the
    * appropriate number of chars (so that if we know how long a bit vector is
    * in terms of ints, we can figure out how many chars we need to ask
    * SALLOC() for).
    */
   ui = bitsperint = 1;
   while (ui <<= 1)
      bitsperint++;
   for (intscale = 0; bitsperint > 1; bitsperint >>= 1)
      intscale++;
   bitsperint = (bitsperint << intscale) - 1;
   index = rt = sizeof(unsigned int);
   for (int2char = 0; index > 1; index >>= 1)
      int2char++;
   if (rt > (((unsigned int) 1) << int2char))
      int2char++;

   /*
    * Calculate the length of the register bit vector that can contain all of
    * the hardware registers.
    */
   mrveclen = maxregs >> intscale;
   if (maxregs & bitsperint)
      mrveclen++;

   /*
    * Initialize variables to prepare for the first procedure from the input
    * file.
    */
   gallocptr = 0;
   for (type = 0; type < MAXCHARS; opers[type++] = FALSE) ;
   for (line = opstr; *line; isoper(*line++) = TRUE) ;
   for (type = 0; type < MAXCHARS; mems[type++] = NOTYPE) ;
   type = 0;
   for (line = memprt; *line; line++) {
      if (mems[(int) *line] == NOTYPE)
         mems[(int) *line] = type;
      type++;
   }
   (void) strcpy(regprt, " bwrfd          ");
   for (type = 0; type < MAPREGS; type++)
      vecmap[type] = -1;
   for (type = 0; type < MAXRVEC; type++) {
      sets[type].valid = (struct setlist *) NULL;
      sets[type].local = (struct locuse *) NULL;
      sets[type].status = 0;
   }
   regallocptr = 0;
   inithardregs();
   hregnum = regallocptr;

   /*
    * Initialize the global items that need to be initialized for each new
    * function.
    */
   initmap();
   fn = sret = (char *) NULL;
   last = bottom = (struct bblock *) NULL;
   top = new_basic_block((char *) NULL);
   ret_block = (struct bblock *) NULL;
   varargs = FALSE;

   /*
    * Initialize the local items that control the read phase
    */
   noflow = TRUE;
   cblk = top;
   prev = (struct list *) NULL;

   /*
    * If the user specified that an extra pass should be made to 
    * to collect a call graph, we do that now so it's avaiable to the
    * optimization phase later
    */
#ifdef PARTITIONING
   if (swpu && swpw)
      read_locality(input_profile_filename);
#endif

#if PK   
#ifdef STACHE
   if (swpd) {
      read_globals_profile();
   }
   if (stache_policy == GLOBALS_STACHE_POLICY
       || stache_policy == BOTH_STACHE_POLICY) {
      assign_globals_to_stache();
   }
#endif
#endif /*PK*/
   
#ifdef CALLGRAPH
   swpg = swpw = TRUE; /*PK: Always get call graph*/
   if (swpg && swpw) {

      build_call_graph();

      /*
       * Clear out all the garbage left behind by the optimization
       * process.
       */
      for (type = hregnum; type < regallocptr; type++)
         vecmap[regname(type)] = -1;
      regallocptr = hregnum;
      clrsets();
      clear_locals();
      clear_loops();
      clear_function();
      clear_call_graph();

#ifdef DISPOSE

      /*
       * Reclaim all of the storage used by the function that we have
       * just optimized in one move.  Re-initialize the free list
       * pointers.
       */
      dispose_func();
      for (type = 0; type < ENDFREETYPES; type++)
         freeptrs[type] = (char **) NULL;
#endif

      /*
       * Re-initialize variables to get ready for the next procedure in
       * the input file.
       */
      LeafFunction = TRUE;
      initmap();
      top = new_basic_block((char *) NULL);
      ret_block = NULL;

      /*
       * Re-initialize the local items that control the read phase
       */
      noflow = TRUE;
      cblk = top;
      prev = (struct list *) NULL;
      fn = NULL;

   }
#endif



#ifdef INTERACT
   /* Establish the transformation dependences. */
   if (swq)
      establish_trans_dependences();

   /* Initialize the file pointer offsets. */
   trans_offset = 0;
   cex_offset = ftell(stdin);

   /*read in the genreport path from a configuration file*/
   if((genreportfp = fopen("genreport.path", "r")) == 0){
     fprintf(stderr, "Config file containing genreport path not found. Genreport executable assumed to reside in the current directory\n");
   }
   else{
     fgets(genreport_path, MAXSTRING-1, genreportfp);
     if(genreport_path[strlen(genreport_path)-1] == '\n')
       genreport_path[strlen(genreport_path)-1] = '\0';
     fclose(genreportfp);
   }
#endif

   /*
    * This loop reads in the input file in RTL file format.  The first
    * character of each line indicates what kind of information is present on
    * the rest of the line.  The main switch statement uses the first character
    * to transfer control to the appropriate case which handles the remaining
    * information (if any) on that line.  There is no error recovery here.  The
    * format is either correct or an error message is printed and the process
    * terminates with a non-zero exit condition.
    */
   for (;;) {
      ++LineNumber;
      type = getchar();

      switch (type) {

          /*
           * End of the input file
           */
       case EOF:

          /*
           * Optimize the last procedure, dump it to the output file and
           * return.
           */
#ifdef INTERACT
          if (user_directed)
             interactive_optimize();
          else
#endif
             optimize();

#ifdef CALLGRAPH
          /* If we did data placement, emit the ASMLINEs that were gathered
           * up into the global symbol table.
           */
          if (swz)
             emitAsmForGlobals(L2_DATA_CACHE_LINE_SIZE);
#endif

#ifdef PARTITIONING
          if (swpu && swpw && swpv)
             emit_partition_assignments();
#endif

#ifdef MEASURE
#ifdef INTERACT
	  if(execute_status & EASE){
	    if(!swef){
	      swef = TRUE;
	      end_info(instfp);
	      swef = FALSE;
	    }
	    else
	      end_info(instfp);
	  }
#else
	    if(swef)
	      end_info();
#endif
#endif

#ifdef VET
#ifdef INTERACT
          if (swq && !measure_phase) {
             if (save_trans) {
                sprintf(cmd, "cp %s%s.transout %s%s.trans", pathname,
                        basename, pathname, basename);
                system(cmd);
             }
          }

          /*close the file containing instrumented assembly code */
          if (instfp)
             fclose(instfp);
#endif
          /* Close connection to VET. */
          end_viewer();
          if (swtd)
             printnumtranslist("numtrans.txt");

#endif

#ifdef ENDFILE
          endfile();
#endif

          /* close the profile output if it's open */
          if (profile_fn)
             fclose(profile_fn);

          /*Terminate the optimizer normally */
          exit(EXIT_SUCCESS);

#ifdef VET
          /*
           * Read in the basename of the source file being compiled.
           */
       case (int) 'n':
#ifdef INTERACT
          if (swq)
#endif
             strcpy(basename, gtline());
          break;
#endif

          /*
           * End of function
           */
       case (int) '*':

	 if(fn){
          /*
           * Optimize this procedure and dump it to the output file
           */
#ifdef INTERACT
          if (user_directed)
             interactive_optimize();
          else
#endif
             optimize();

#ifdef VET
          /*
           * Send message indicating the end of current function
           * and no more transformations will occur.
           */
#ifdef INTERACT
          if (swq)
#endif
          {

             if (viewing && !quit_vpo)
                send_end_func(fn);
#ifdef INTERACT
             else
                initial_set_sent = FALSE;
             if (!save_trans)
                wait_for_next_func();
#endif
          }
#endif

#ifdef DISPOSE

          /*
           * Display memory usage information for each function
           */

#if 0
/*
 * I'd like to find a way to re-instate this.. but the new allocation
 * policy isn't so straight-forward; in the future ...
 */

          if (swd && debug_opt("memory_usage")) {
             (void) fprintf(stderr,
                  "vpo (main): %u bytes used to optimize %s()\n",
                  mal_next - startmem, fn);
             (void) fflush(stderr);
          }

#endif
#endif  /* DISPOSE */

          /*
           * Clear out all the garbage left behind by the optimization
           * process.
           */
          for (type = hregnum; type < regallocptr; type++)
             vecmap[regname(type)] = -1;
          regallocptr = hregnum;
          clrsets();
          clear_locals();
          clear_loops();
          clear_function();
          clear_call_graph();

#ifdef DISPOSE
          /*
           * Reclaim all of the storage used by the function that we have
           * just optimized in one move.  Re-initialize the free list
           * pointers.
           */
          dispose_func();
          for (type = 0; type < ENDFREETYPES; type++)
             freeptrs[type] = (char **) NULL;
#endif

          /*
           * Re-initialize variables to get ready for the next procedure in
           * the input file.
           */
          LeafFunction = TRUE;
          initmap();
          top = new_basic_block((char *) NULL);
          ret_block = (struct bblock *) NULL;

          /*
           * Re-initialize the local items that control the read phase
           */
          noflow = TRUE;
          cblk = top;
          prev = (struct list *) NULL;

          /*
           * Indicate the end of the function if the output file should be in
           * RTL file format.
           */

          if (!swa)
             (void) printf("*\n");

#ifdef INTERACT
          if (!measure_phase) {
             /*store the input file offset at this point */
             cex_offset = ftell(stdin);

             /*initialise the variables used to perform optimizations */
             pc = 0;
             valid_analysis = 0;
          }
#endif
          /*
           * Eat the end-of-line marker
           */
          (void) getchar();
	 }
          break;

          /*
           * Argument build area size line
           */
       case (int) 'A':
          ptr = new_rtl(cblk, ARGBLINE, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          LeafFunction = FALSE;
          break;

          /*
           * Assembly line
           */
       case (int) '-':

          /* If we are doing data placement, we need to copy this line
           * into our global symbol table structure IF we are currently
           * processing a global definition, then free the memory for
           * the original line, discarding it.  It will be emitted at the
           * end of the function after the order of data items has been
           * determined.  If we are not processing a global definition,
           * then we just add a new RTL for this ASMLINE as usual.
           */
          line = gtline();
	  /*Sometimes the comment lines are output as assembly lines. Check
	    for this here (seen this happen on the SPARC*/
	  if(swq && line[0]=='!')
	    ptr = new_rtl(cblk, COMMENT, prev);
	  else
	    ptr = new_rtl(cblk, ASMLINE, prev);
          ptr->val = line;
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Delayed assembly line
           */
       case (int) '_':

          /*
           * See comment for assembly line just above.
           */
          line = gtline();
	  if(swq && line[0]=='!')
	    ptr = new_rtl(cblk, COMMENT, prev);
	  else
	    ptr = new_rtl(cblk, ASMLINE | DELAYLINE, prev);
          ptr->val = line;
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Trash line for the common subexpression eliminator
           */
       case (int) 't':

          /*
           * All we have to do is read and retain the line for now
           */
          ptr = new_rtl(cblk, TRASHLINE, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Reserve line for the local register allocator
           */
       case (int) 'r':

          /*
           * All we have to do is read and retain the line for now
           */
          ptr = new_rtl(cblk, RESLINE, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          break;

          /* New style reserve line. We need to mark the previous
           * line.  We should check that the register being specified
           * is used in the previous line. Add this later
           */

       case (int) 'R':
          prev->type = RESLINE;
          line = gtline();
          FREE(line);
          break;

          /* Set optimization flags. These remain in effect until set again */
       case (int) 'O':
          line = gtline();
          opt_flags[0] = NULL;
          opt_flags[1] = line;
          clear_opt_flags();
          parse_arguments(2, opt_flags);
          FREE(line);
          break;

          /*
           * Parameter register line. This line contains the registers
           * that have outgoing parameters.  We must build a side
           * effect line and put store it in the side effect field of
           * the previous instruction, which should be a call.  We need
           * to check.
           */
       case (int) 'P':
          /*
           * Read in the line and keep it for now
           */
          ptr = new_rtl(cblk, PARMLINE, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Set line
           */
       case (int) 'S':
          {
             /*
              * Locate all of the items and note each of them as a set.
              */
             char *temp_line = gtline();
             ptr = new_rtl(cblk, SETLINE, prev);
             ptr->val = temp_line;
             prev = ptr;
             noflow = FALSE;
             break;
          }

          /*
           * Caller-save line
           */
       case (int) 'C':

          /*
           * Read in the line and keep it for now
           */
          ptr = new_rtl(cblk, CSLINE, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          break;

          /* 
           * Metadata line
           */
       case (int) 'm':
          /*
           * We just read it up and pass it along to the output
           */
          ptr = new_rtl(cblk, METADATALINE, prev);
          ptr->val = gtline();
          process_metaline(ptr->val);
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Comment line
           */
       case (int) '#':

          /*
           * We just read it up and pass it along to the output
           */
          ptr = new_rtl(cblk, COMMENT, prev);
          ptr->val = gtline();
          prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Register type map
           */
       case (int) 'M':

          /*
           * This line contains a map indicating which letter should be used
           * to denote each register type when printing RTLs in decoded
           * format.
           */
          line = gtline();
          if (strlen(line) < MAXSTRING)
             (void) strcpy(regprt, line);
          FREE(line);
          break;

          /*
           * Function name line
           */
       case (int) 'f':

          /*
           * This line contains the name of the current function, which is
           * read so that it can be referred to using the "fn" variable.
           */
          if (fn) {
             (void) fprintf(stderr, "vpo (main): attempt to rename %s()\n",
                            fn);

             /* Don't combine these next two lines!
              * FREE may evaluate to NULL and thus we won't read the line.
              */
             line = gtline();
             FREE(line);
          }
          else {
             ptr = new_rtl(cblk, ASMLINE | FUNCNAME, prev);
             fn = ptr->val = gtline();
             prev = ptr;
             noflow = FALSE;

#ifdef VET
             /* 
              * If viewer is running and if user has not aborted
              * but wants VPO to continue to completion.
              */
             if (viewing && !quit_vpo) {
                send_func_name(fn);
             }
#endif
          }
#ifdef INTERACT
          if (!measure_phase)
             measure_fn = strcpy(CALLOC(strlen(fn)), fn);

          /* We found the function name, so the global declarations are
           * over. Now set this flag to the next level not allowing any data
           * to be written to the socket.
           */
          if (measure_init == 1)
             measure_init = 2;
#endif

          break;

          /*
           * Global reference line
           */
       case (int) 'g':

          /*
           * This line contains the name of a function that is referenced
           * somewhere in this function.  This information is used when
           * building a call graph for EASE.
           */
          add_func(line = gtline());
          FREE(line);
          break;

          /*
           * Side effect line
           */
       case (int) 's':

          /*
           * This line contains the side effect of returning
           */
          if (sret) {
             (void) fprintf(stderr, "vpo (main): redefined return effect\n");
             line = gtline();
             FREE(line);
          }
          else
             sret = gtline();
          break;

          /*
           * Varargs line
           */
       case (int) 'V':

          /*
           * This line indicates that varargs is used in this function
           */
          varargs = TRUE;
          (void) getchar();
          break;

          /*
           * Use line
           */
       case (int) 'u':

          /*
           * In order to speed up register allocation in the future, we need
           * to obtain the internal index number of the register being used.
           * In the case that the register used actually takes up more than
           * one index position, new use lines are internally created, each
           * holding one of the register index positions affected by the use
           * of the register.  Note that the cost field of the list structure
           * holds the register index number.
           */
 	  ptr = new_rtl(cblk, USELINE, prev);
	  ptr->val = gtline();
	  rt = regtype(ptr->val);
	  ptr->cost = index = regtoindexf(rt, regnum(ptr->val));
	  if ((rcont = contregf(rt)) > 1) {
	    while (--rcont) {
	      prev = ptr;
	      ptr = new_rtl(cblk, USELINE, prev);
	      ptr->cost = ++index;
	    }
	  }
	  prev = ptr;
          noflow = FALSE;
          break;

          /*
           * Declaration line
           */
       case (int) 'd':
          {

#ifdef INTERACT
             /* Ignore this line during a measure init phase to ignore globally
              * defined items which were considered earlier and already exist
              * in the data structure.
              */
             if (measure_init == 1) {
                line = gtline();
                FREE(line);
                break;
             }
#endif
             /*
              * If declaration() returns a zero, then the line contained a
              * global identifier.  If it returns a one, the line contained an
              * argument and if it returns a value greater than one, the line
              * was a local.
              */
             if (!declaration(line = gtline()))
                FREE(line);
             break;

          }
#ifdef WRITE_CEX

	  /*other records in the sets structure*/
      case 'D':
	
	line = gtline();
	sscanf(line, "%s\t%d\t[^\n]", litem, &num, line2);
	if(num == regallocptr){
	  strcpy(sets[regallocptr].item, litem);
	  sets[regallocptr].num = regallocptr;
	  vecmap[regname(regallocptr)] = regallocptr;
	  sscanf(line2, "%d\t%d\t%d\t%d\t%d", &(sets[num].status), &valid, &next,
		 &(sets[num].assign), &(sets[num].regstatus));
	  if(valid)
	    sets[num].valid = (struct setlist *)&(sets[valid]);
	  if(next)
	    sets[num].next = (struct setlist *)&(sets[next]);
	  regallocptr++;
	}
	else
	  fprintf(stderr, "read_next_function: number from file does not match regallocptr\n");
	break;
	
	/*additional line only used when additional information is stored in
	  the cex file, written from VPO*/
      case (int) 'e':
	
	locptr = (struct locuse *)sets[regallocptr-1].local;
	line = gtline();
	sscanf(line, "%s\t%[^\n]", litem, line2);
	
	if(strcmp(locptr->item, litem) == 0){
	  cptr = line2;
	  get_num(&cptr, &num);
	  locptr->reg = num;
	  get_num(&cptr, &num);
	  locptr->nouse = num;
	  get_num(&cptr, &num);
	  locptr->reps = num;
	  get_num(&cptr, &num);
	  locptr->atype = num;
	  get_num(&cptr, &num);
	  locptr->arg = num;
	  get_string(&cptr, locptr->regin);
	}
	else
	  fprintf(stderr, "read_next_function: Locals structure not matching\n");
	break;
	
      case 'U':
	cblk->status |= UNROLLED;
	break;
      
#endif /*WRITE_CEX*/      
	
	/*
           * Case line
           */
       case (int) 'c':

          /*
           * This line is part of a jump address lookup table indicating
           * where a switch statement may potentially transfer control to.
           * What is important here is that the rest of the line, although
           * treated as an assembly line, contains a label reference that has
           * to be integrated to assemble an accurate representation of the
           * control flow graph for this function.
           */
          ptr = new_rtl(cblk, ASMLINE | CASELINE, prev);
          ptr->val = gtline();
          prev = ptr;
          label = findlabel(ptr->val, &direct);
          if (!(cblk->right = getlabel(label)))
             cblk->right = new_basic_block(label);
          add_predecessor(cblk, cblk->right);
          cblk->down = cblk->left = new_basic_block((char *) NULL);
          cblk->down->up = cblk;
          add_predecessor(cblk, cblk->left);
          cblk = cblk->left;
          cblk->status |= FALLTHRU;
          prev = (struct list *) NULL;
          noflow = FALSE;
          break;

       case (int) 'l':
          line = gtline();
          ptr->type |= CASELINE;
          label = findlabel(line, &direct);
          if (!(cblk->right = getlabel(label)))
             cblk->right = new_basic_block(label);
          add_predecessor(cblk, cblk->right);
          cblk->down = cblk->left = new_basic_block((char *) NULL);
          cblk->down->up = cblk;
          add_predecessor(cblk, cblk->left);
          cblk = cblk->left;
          cblk->status |= FALLTHRU;
          prev = (struct list *) NULL;
          noflow = FALSE;
          FREE(line);
          break;

          /*
           * End-flow label
           */
       case (int) 'E':

          /*
           * Note that this line is a label, and it is treated just as if it
           * began with an 'L', then only difference is that this label cuts
           * the normal flow, so that the code immediately above the label is
           * not assumed to fall into the code below the label.  This type of
           * label can be used to properly represent the control flow created
           * by lookup table sequences on certain target machines.
           */
          noflow = TRUE;

          /*
           * Label line
           */
       case (int) 'L':

          /*
           * We must start a new basic block.  First, see if we have already
           * seen this label referenced and already allocated a block for it.
           */
          if (exists = getlabel(label = gtlab())) {

             /*
              * If we have already allocated a basic block for this label,
              * then there are a couple of things we have to do depending on
              * the state of the current basic block.  First, we check to see
              * if the current basic block has anything in it at all (RTLs or
              * a label).  If it does, then we just indicate that it falls
              * into this new block.  If not, then there is no need to have
              * an empty block just lying around, so we put it aside and
              * connect the new block to the empty blocks predecessor.
              */
             if (cblk->label || cblk->rtls) {
                cblk->down = exists;
                cblk->down->up = cblk;
                if (!noflow) {
                   cblk->left = exists;
                   add_predecessor(cblk, cblk->left);
                }
             }
             else {
                if (exists->up = cblk->up) {
                   exists->up->down = exists;
                   if (exists->up->left == cblk) {
                      exists->up->left = exists;
                      if (cblk->preds)
                         cblk->preds->next = exists->preds;
                      exists->preds = cblk->preds;
                      cblk->preds = (struct blist *) NULL;
                   }
                }
                exists->status = cblk->status;
                remv_basic_block(cblk);
             }
             cblk = exists;
             prev = (struct list *) NULL;
          }
          else if (cblk->label || prev) {
             cblk->down = cblk->left = new_basic_block(label);
             cblk->down->up = cblk;
             if (!noflow) {
                cblk->left = cblk->down;
                add_predecessor(cblk, cblk->left);
             }
             cblk = cblk->down;
             prev = (struct list *) NULL;
          }
          else
             cblk->label = label;
          if (!noflow)
             cblk->status |= FALLTHRU;
          noflow = FALSE;

#ifdef INTERACT
	  if((sscanf(label, lab_mask, &num)) == 1){
	    if(num > max_labnum){
	      labnum = num + 1;
	      max_labnum = num;
	    }
	  }
#endif	  
          break;

          /*
           * RTL line
           */
       case (int) '+':
          /*
           * First we read the line in and store it away, then we determine
           * if it affects the control flow of the function.  If it does, we
           * need to reflect the fact in the control flow data structure.
           */
          noflow = FALSE;
          ptr = new_rtl(cblk, RTLINE, prev);
          gtrtl(&ptr->val, &ptr->InitialDeads);
	  curr_rtl = ptr;
          prev = ptr;
          if (ptr->val) {
             if ((label = is_pc(ptr->val))
                 && (label = findlabel(label + 1, &direct))) {
                if (direct) {
                   cblk->status |= JUMP;
                   if (!(cblk->left = getlabel(label))) {
                      cblk->left = new_basic_block(label);
                      /* If this is a return instruction, its target is the
                       * return block. Remember the return block if we haven't
                       * already done so.
                       */
                      if (ret_block == NULL && fmatch(label, ret))
                         ret_block = cblk->left;
                   }
                   add_predecessor(cblk, cblk->left);
                   cblk->down = new_basic_block((char *) NULL);
                   cblk->down->up = cblk;
                   cblk = cblk->down;
                   noflow = TRUE;
                }
                else {
                   if (!(cblk->right = getlabel(label)))
                      cblk->right = new_basic_block(label);
                   add_predecessor(cblk, cblk->right);
                   cblk->down = cblk->left = new_basic_block((char *) NULL);
                   cblk->down->up = cblk;
                   add_predecessor(cblk, cblk->left);
                   cblk = cblk->down;
                   cblk->status |= FALLTHRU;
                }
                prev = (struct list *) NULL;
             }
          }
          break;

	  /*
	    Side Effect line
	  */
      case 'i':
	line = gtline();
	curr_rtl->type |= SIDEFFECT;
	curr_rtl->se = line;
	break;
	
       case '\n':
          break;
          /*
           * If we get here, then the input file is not valid RTL format
           */
       default:
          (void) fprintf(stderr, "vpo (main): bad input '%c' near line %d\n",
                         (char) type, LineNumber);
          exit(EXIT_FAILURE);
      }
   }
   return 0;
} /* end of main() */

void process_metaline(char *val)
{
   char *s;
   char *end;
   char *metadata[] = { "registerSize", "globalSize", "localSize", NULL };
   int   backend_size[] = { REGLOCLENGTH, GLOBALLOCLENGTH, LOCALLOCLENGTH };
   int   i;
   char  tmp[MAXSTRING];
   int   num;
   for (i = 0; metadata[i]; i++) {
      if (s = strstr(val, metadata[i])) {
         s = s + strlen(metadata[i]) + 1;       /* skip over '=' */
         sscanf(s, "%d", &num);
         if (num > 0 && num != backend_size[i]) {
            fprintf(stderr,
                    "vpo (process_metaline): RTL file specifies"
                    " %s=%d, but backend compiled for %s=%d.\n",
                    metadata[i], num, metadata[i], backend_size[i]);
            exit(EXIT_FAILURE);
         }
      }
   }
}


/*
 * parse_flags - parse the compiler optimization flags
 */
void parse_flags(char *flags)
{
  char *a;
  
  while (*flags) {
    switch (*flags) {

    case 'A':
    case 'a':
      swa = TRUE;
      break;
      
    case 'B':
    case 'b':
      swb = TRUE;
      break;
      
    case 'C':
    case 'c':
      swc = TRUE;
      break;
      
    case 'D':
    case 'd':
      if (!*(flags + 1)) {
	(void) fprintf(stderr, "vpo: debug option expected\n");
	break;
      }
      while (*(flags + 1)) {
	if (swd >= MAXOPTIONS) {
	  (void) fprintf(stderr, "vpo: too many debug options\n");
	  exit(EXIT_FAILURE);
	}
	a = d_options[swd++];
	do {
	  if (*(flags + 1) == ',') {
	    flags++;
	    break;
	  }
	  *a++ = *++flags;
	} while (*(flags + 1));
	*a = '\0';
      }
      break;
      
    case 'E':
    case 'e':
      
#ifdef MEASURE
      if (!*(flags + 1)) {
	(void) fprintf(stderr, "vpo: EASE option expected\n");
	break;
      }
      switch (*++flags) {
	
      case 'D':
      case 'd':
	swed = TRUE;
	break;
	
      case 'F':
      case 'f':
	swef = TRUE;
	break;
	
      case 'I':
      case 'i':
	swei = TRUE;
	break;
	
      case 'P':
      case 'p':
	swep = TRUE;
	break;
	
      case 'U':
      case 'u':
	swei = TRUE;
	swed = TRUE;
	break;
	
      default:
	(void) fprintf(stderr, "vpo: illegal EASE option '%c'\n",
		       *flags);
	exit(EXIT_FAILURE);
      }
#else
      if (*(flags + 1))
	flags++;
      (void) fprintf(stderr, "vpo: EASE not available\n");
#endif
      
      break;
      
    case 'F':
    case 'f':
      
#ifdef FILL
      swf = TRUE;
#else
      (void) fprintf(stderr, "vpo: no delay slot filler\n");
#endif
      
      break;
      
    case 'G':
    case 'g':
      swg = TRUE;
      break;
      
    case 'I':
    case 'i':
      
#ifdef SCHED
      swi = TRUE;
#else
      (void) fprintf(stderr, "vpo: no instruction scheduler\n");
#endif
      
      break;
      
#ifdef INTERACT
    case 'K':
    case 'k':
      swk = TRUE;
      break;
#endif
      
    case 'L':
    case 'l':
      swl = TRUE;
      break;
      
    case 'M':
    case 'm':
      swm = TRUE;
      break;
      
    case 'N':
    case 'n':
      swn = TRUE;
      break;
      
    case 'O':
    case 'o':
      swo = TRUE;
      break;
      
    case 'P':
    case 'p':
#ifdef PRED
      swp = TRUE;
      break;
#else
      fprintf(stderr,
	      "Switch P can only be used with a predication build\n");
      break;
#endif
      
    case 'R':
    case 'r':
      swr = TRUE;
      break;
      
    case 'S':
    case 's':
      sws = TRUE;
      break;
      
#ifdef VET
    case 'T':
    case 't':
#ifdef INTERACT
      if (swq) {
#endif
	if (*(flags + 1))
	  flags++;
	else {
	  fprintf(stderr, "vpo (main): VET option expected\n");
	  break;
	}
	switch (*flags) {
	case 'D':
	case 'd':
	  swtd = TRUE;
	  break;
	  
	case 'H':
	case 'h':
#ifdef INTERACT
	  fprintf(stderr,
		  "vpo (main): -th is not supported in this\
					      version of vpo: ignored\n");
#endif
	  if (*++flags == '=') {
	    flags++;
	    strcpy(host, flags);
	    /* Need to set next character to EOS to break out of
	     * outside while to cause it to increment to next
	     * argument and enter switch. 
	     */
	    *(flags + 1) = '\0';
	    swth = TRUE;
	  }
	  else {
#ifndef INTERACT
	    fprintf(stderr,
		    "vpo (main): Usage: VET option: -Th=hostname\n");
#endif
	  }
	  break;
	  
	case 'M':
	case 'm':
	  swtm = TRUE;
	  break;
	  
	case 'P':
	case 'p':
#ifdef INTERACT
	  fprintf(stderr,
		  "vpo (main): -tp is not supported in this"
		  " version of vpo: ignored\n");
#endif
	  if (*++flags == '=') {
	    flags++;
	    sscanf(flags, "%d", &port);
	    /* Need to set next character to EOS to break out of
	     * outside while to cause it to increment to next
	     * argument and enter switch. 
	     */
	    *(flags + 1) = '\0';
	    swtp = TRUE;
	  }
	  else {
#ifndef INTERACT
	    fprintf(stderr,
		    "vpo (main): Usage: VET option: -Tp=portnumber\n");
#endif
	  }
	  break;
	  
	default:
	  fprintf(stderr,
		  "vpo (main): illegal transformation option '%c'\n",
		  *flags);
	  exit(EXIT_FAILURE);
	}
#ifdef INTERACT
      }  /* end if (swq) */
#endif
      break;
#endif  /* ifdef VET */
    case 'q':
    case 'Q':
      swq = TRUE;
      break;
      
    case 'V':
    case 'v':
      swv = TRUE;
      break;
      
    case 'W':
    case 'w':
      sww = TRUE;
      break;
      
    case 'X':
    case 'x':
      swx = TRUE;
      break;
      
#ifdef WIDES
    case 'Y':
    case 'y':
      swy = TRUE;
      break;
#endif
    case 'Z':
    case 'z':
      swz = TRUE;
      break;
#ifdef INTERACT
    case '1':
      sw1 = TRUE;
      break;
#endif
    default:
      (void) fprintf(stderr, "vpo: illegal option -'%c'\n", *flags);
      exit(EXIT_FAILURE);
    }
    flags++;
  }
}

/*
 * parse_arguments - parse the command line options to the optimizer
 */
void parse_arguments(int argc, char **argv)
{
   int   input_is_file = FALSE;
   register char *line;
   register int direct, erout, toomany;
#ifdef INTERACT
   int   stdin_cex = TRUE;
   int   asmout;
#endif
   char *a;

   /*
    * Parse the command line arguments.  The optimizer expects to be invoked in
    * the following manner:
    * 
    * vpo -options rtl_file out_file err_file
    * 
    * where "options" may be any of the following:
    * 
    * A - If present the output of vpo will be in assembler format, otherwise
    * RTLs will be emitted.
    * 
    * B - If present, tail call and leaf function optimizations will be
    *     performed.
    * 
    * C - The common subexpression elimination phase will be invoked.
    * 
    * D - If present additional information about the internal basic block data
    * structure and global data flow information will be printed along with the
    * output for debugging purposes.
    * 
    * E - Invoke the EASE measuring tools.  One of the following characters
    *     must immediately follow:
    * 
    *    D - Instrument the code with a data cache simulator.
    * 
    *    F - Instrument the code to obtain instruction execution measurements.
    * 
    *    I - Instrument the code with an instruction cache simulator.
    * 
    *    P - Instrument the code with a precision timer.
    * 
    *    U - Instrument the code with a unified cache simulator.
    * 
    * F - If present, branch delay slots will be filled when possible.
    * 
    * G - If present the global link phase, which is responsible for setting
    *     "safe" combiner links across basic blocks, will be invoked.
    * 
    * I - If instruction scheduling is included in the machine, the
    *     instruction scheduling phase will be invoked.
    * 
    * L - If present control-flow optimizations, e.g. removing branch chains,
    *     will be performed.
    * 
    * M - If present code motion will be performed.  Code motion requires that
    *     global register allocation (see -R and -O) also be performed.
    * 
    * O - If present register coloring will be the algorithm used to allocate
    * registers to locals.  In most cases, it will do a better job of register
    * allocation than the standard allocator (see -R).
    * 
    * P - If present, predication of basic blocks will be attempted on
    *     targets that support predication.
    * 
    * R - If present global register allocation will be performed.  This option
    * does not use a coloring algorithm and will usually not produce code as
    * good as the -O option would.  This option will be ignored if -O is used.
    * 
    * S - If present the strength reduction and code motion phases will be
    * invoked.  Loop strength reduction requires that the global register phase
    * (see -O or -R) and code motion phase (see -M) also be invoked.
    * 
    * V - If present the evaluation order determination phase will be invoked.
    * 
    * W - If present, warning messages are not printed.
    * 
    * X - If present the optimizer is instructed to generate code required to
    * perform a execution time profile of the compiled program.
    * #ifdef WIDES
    * Z - The attempt to combine narrow loads and stores to wide loads
    *     and stores will be made. Strength reduction and induction variable
    *     elimination should also be invoked.
    * #endif
    * 
    * 1 - Register assignment, fix entry/exit and filling delay
    *     slots will not be performed
    *
    * 2 - Loop unrolling will be performed. One argument can be passed in
    *     which will indicate the unroll factor. This can be done by annoting
    *     it with a '+' sign, like -2+3, for an unroll factor of 3.
    * 
    * In addition, up to three file names may be placed on the command
    * line. The first will be taken as the name of the input RTL file.  The
    * second as the name of the output file.  The third will be the name of the
    * error output file. The input file must be in RTL file format (see the
    * document titled "Register Transfer List File Format" for a full
    * description).  If no files are specified, then the standard input,
    * output, and error files will be used.  A lone "-" can be used in lieu of
    * a file name to indicate that the default file should be used.
    */

   direct = erout = toomany = FALSE;
#ifdef INTERACT
   asmout = FALSE;
   rtlfile = asmfile = NULL;
#endif

   while (--argc > 0) {
      line = *++argv;
      if (*line == '-' && *(line + 1)) {
	parse_flags(++line);
      }
      else if (*line == '+') {
#if PK
         /* Use +T to specify a profile generated from gprof to read in
          * when building the call-graph */
         if (toupper(line[1]) == (int) 'T' && line[2] == 0) {
#ifdef STACHE
            line = *++argv;
            --argc;
            if (argc > 0) {
               if (strcmp(line, "stupid") == 0) {
                  stache_policy = STUPID_STACHE_POLICY;
                  if (!sww)
                     fprintf(stderr, "Stupid stache allocation" " enabled\n");
               }
               else if (strcmp(line, "coloring") == 0) {
                  if (!sww)
                     fprintf(stderr,
                             "Coloring stache allocation " "enabled\n");
                  stache_policy = COLORING_STACHE_POLICY;
               }
               else if (strcmp(line, "globals") == 0) {
                  if (!sww)
                     fprintf(stderr, "Global stache allocation " "enabled\n");
                  stache_policy = GLOBALS_STACHE_POLICY;
               }
               else if (strcmp(line, "both") == 0) {
                  if (!sww)
                     fprintf(stderr,
                             "Global+Local stache allocation " "enabled\n");
                  stache_policy = BOTH_STACHE_POLICY;
               }
               else
                  fprintf(stderr, "Warning: Unknown stache policy\n");
            }
#else
            fprintf(stderr, "Warning: +T specified and unknown\n");
#endif
         }
         else if (toupper(line[1]) == (int) 'R' && line[2] == 0) {
#ifdef STACHE
            line = *++argv;
            --argc;

            /* Look for ways to start a valid filename. */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* This doesn't appear to be a filename. */
               fprintf(stderr, "+R used without filename, " "disabling +R\n");
            }
            else {
               swpr = TRUE;
               strcpy(profileName, line);
               if (!sww)
                  fprintf(stderr, "Attempt to read profile from " "%sd\n",
                          profileName);
            }
#else
            fprintf(stderr, "Warning: +R specified and unknown\n");
#endif
         }
         else if (toupper(line[1]) == (int) 'D' && line[2] == 0) {
#ifdef STACHE
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+D used without filename, " "disabling +D\n");
            }
            else {
               swpd = TRUE;
               strcpy(dataProfileName, line);
               if (!sww)
                  fprintf(stderr, "Attempt to read data profile from " "%s\n",
                          dataProfileName);
            }
#else
            fprintf(stderr, "Warning: +D specified and unknown\n");
#endif
         }
         else if (toupper(line[1]) == (int) 'S' && line[2] == 0) {
#ifdef STACHE
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0 || !isdigit(line[0])) {
               /* this doesn't appear to be a filename */
               fprintf(stderr,
                       "+S used without stache size, " "disabling +S\n");
            }
            else {
               swps = TRUE;
               stache_size = atoi(line);
               if (!sww)
                  fprintf(stderr, "Stache size set to %d\n", stache_size);
            }
#else
            fprintf(stderr, "Warning: +R specified and unknown\n");
#endif
         }

         else if (toupper(line[1]) == (int) 'L' && line[2] == 0) {
#ifdef CALLGRAPH
            /* read library information */
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+L used without filename, " "disabling +L\n");
            }
            else {
               swpl = TRUE;
               strcpy(libraryFilename, line);
            }
#else
            fprintf(stderr, "Warning: +L specified and unknown\n");
#endif

         }
         else if (toupper(line[1]) == (int) 'P' && line[2] == 0) {
#ifdef CALLGRAPH
            if (swpp) {
               fprintf(stderr, "+P used more than once, error!\n");
               exit(EXIT_FAILURE);
            }


            /* profile filename and turn on profiling info */
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+P used without filename, " "disabling +P\n");
            }
            else {
               swpp = TRUE;
               strcpy(profile_filename, line);
               if (!(profile_fn = fopen(profile_filename, "w"))) {
                  fprintf(stderr, "Cannot open %s for writing.\n",
                          profile_filename);
                  exit(EXIT_FAILURE);
               }
            }
#else
            fprintf(stderr, "Warning: +P specified and unknown\n");
#endif

         }
         else if (toupper(line[1]) == (int) 'O' && line[2] == 0) {
#ifdef CALLGRAPH
            if (swpo) {
               fprintf(stderr, "+O used more than once, error!\n");
               exit(EXIT_FAILURE);
            }


            /* profile filename and turn on profiling info */
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+O used without filename, " "disabling +O\n");
            }
            else {
               swpo = TRUE;
               strcpy(optimal_assignment_filename, line);
               if (!
                   (optimal_assignment_fn =
                    fopen(optimal_assignment_filename, "r"))) {
                  fprintf(stderr, "Cannot open %s for writing.\n",
                          optimal_assignment_filename);
                  exit(EXIT_FAILURE);
               }
            }
#else
            fprintf(stderr, "Warning: +O specified and unknown\n");
#endif

         }

         else if (toupper(line[1]) == (int) 'U' && line[2] == 0) {
#ifdef PARTITIONING
            if (swpu) {
               fprintf(stderr, "+U used more than once, error!\n");
               exit(EXIT_FAILURE);
            }


            /* the filename of a profile generated by swpp */
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+u used without filename, disabling +U\n");
            }
            else {
               swpu = TRUE;
               strcpy(input_profile_filename, line);
            }
#else
            fprintf(stderr, "Warning: +U specified and unknown\n");
#endif
         }
         else if (toupper(line[1]) == (int) 'V' && line[2] == 0) {
#ifdef PARTITIONING
            if (swpv) {
               fprintf(stderr, "+V used more than once, error!\n");
               exit(EXIT_FAILURE);
            }


            /* the filename of a partition description */
            line = *++argv;
            --argc;

            /* look for ways to start a valid filename */
            if (argc <= 0
                || (!isalpha(line[0]) && line[0] != '.' && line[0] != '~'
                    && line[0] != '/' && !isdigit(line[0]))) {
               /* this doesn't appear to be a filename */
               fprintf(stderr, "+V used without filename, disabling +U\n");
            }
            else {
               swpv = TRUE;
               strcpy(partition_description_filename, line);
            }
#else
            fprintf(stderr, "Warning: +V specified and unknown\n");
#endif
         }
         else {
            while (*++line) {
               switch (*line) {

                case 'A':
                case 'a':
                   swpa = TRUE;
                   break;
                case 'B':
                case 'b':
                   swpb = TRUE;
                   break;
                case 'C':
                case 'c':
                   swpc = TRUE;
                   break;
                case 'D':
                case 'd':
                   swpd = TRUE;
                   break;
                case 'E':
                case 'e':
                   swpe = TRUE;
                   break;
                case 'F':
                case 'f':
                   swpf = TRUE;
                   break;
                case 'G':
                case 'g':
                   swpg = TRUE;
                   break;
                case 'H':
                case 'h':
                   swph = TRUE;
                   break;
                case 'I':
                case 'i':
                   swpi = TRUE;
                   break;
                case 'J':
                case 'j':
                   swpj = TRUE;
                   break;
                case 'K':
                case 'k':
                   swpk = TRUE;
                   break;
                case 'L':
                case 'l':
                   swpl = TRUE;
                   break;
                case 'M':
                case 'm':
                   swpm = TRUE;
                   break;
                case 'N':
                case 'n':
                   swpn = TRUE;
                   break;
                case 'O':
                case 'o':
                   swpo = TRUE;
                   break;
                case 'P':
                case 'p':
                   swpp = TRUE;
                   break;
                case 'Q':
                case 'q':
                   swpq = TRUE;
                   break;
                case 'S':
                case 's':
                   swps = TRUE;
                   break;
                case 'T':
                case 't':
                   swpt = TRUE;
                   break;
                case 'U':
                case 'u':
                   swpu = TRUE;
                   break;
                case 'V':
                case 'v':
                   swpv = TRUE;
                   break;
                case 'W':
                case 'w':
                   swpw = TRUE;
                   break;
                case 'X':
                case 'x':
                   swpx = TRUE;
                   break;
                case 'Y':
                case 'y':
                   swpy = TRUE;
                   break;
                case 'Z':
                case 'z':
                   swpz = TRUE;
                   break;
	       case '2':
		   swur = TRUE;
		   if(*(line+1) == '+' && is_const(line+2)){
		     swur = atoi((line+2));
		     line = is_const(line+2) - 1;
		   }
		   break;
                default:
                   (void) fprintf(stderr, "vpo: illegal option +'%c'\n",
                                  *line);
                   exit(EXIT_FAILURE);
               }
            }
         }
#endif /*PK*/	 
      }
      else if (toomany) {
         (void) fprintf(stderr, "vpo: too many file names\n");
         exit(EXIT_FAILURE);
      }
      else if (erout) {
         if (strcmp(line, "-")) {
            if (!freopen(line, "w", stderr)) {
               (void) fprintf(stderr, "vpo: cannot open '%s' for output\n",
                              line);
               exit(EXIT_FAILURE);
            }
         }
         toomany = TRUE;
      }
#ifdef INTERACT
      else if (asmout) {
         if (strcmp(line, "-")) {
            if (!(asmfile = fopen(line, "w"))) {
               fprintf(stderr, "vpo:cannot open %s for asm output\n", line);
               exit(EXIT_FAILURE);
            }
            setbuf(asmfile, asmbuf);
         }
         erout = TRUE;
         show_ASM = TRUE;
         strcpy(asm_filename, line);
      }
#endif
      else if (direct) {
         if (strcmp(line, "-")) {
#ifdef INTERACT
            if (!(rtlfile = fopen(line, "w"))) {
               fprintf(stderr, "vpo:cannot open %s for rtl output\n", line);
               exit(EXIT_FAILURE);
            }
            setbuf(rtlfile, rtlbuf);

            asmout = TRUE;
            show_RTL = TRUE;
            strcpy(rtl_filename, line);
#else
            if (!freopen(line, "w", stdout)) {
               (void) fprintf(stderr, "vpo: cannot open '%s' for output\n",
                              line);
               exit(EXIT_FAILURE);
            }
#endif
         }
      }
      else {
         if (strcmp(line, "-")) {
            if (!freopen(line, "r", stdin)) {
               (void) fprintf(stderr, "vpo: cannot open '%s' for input\n",
                              line);
               exit(EXIT_FAILURE);
            }
#ifdef INTERACT
            stdin_cex = FALSE;
#endif
            input_is_file = TRUE;
         }
         direct = TRUE;
      }
   }

   /* Complain if the input comes from stdin and we've specified +G */
   if (swpg && input_is_file == FALSE) {
      fprintf(stderr, "specified +G with input from stdin, turning off +G\n");
      swpg = FALSE;
   }
   if (swpa && swpi) {
      fprintf(stderr,
              "Error:  +A (address)" " and +I (instruction) both set\n");
      exit(EXIT_FAILURE);
   }
   if(swpa && swpi)
   {
	fprintf(stderr, "Error:  +A (address)"
		" and +I (instruction) both set\n");
	exit(1);
   }


   /* the profile info isn't of any use unless we're building a call-graph */
   if (swpr && !swpg) {
      fprintf(stderr,
              "Warning: +R will be ignored because call-graph is "
              "not being built\n");
      swpr = FALSE;
   }

   /*
    * Complain if the "M" option is given without the required "O" or "R"
    * options.
    */
   if (swm && !swr && !swo)
      (void) fprintf(stderr, "vpo: -M ignored without -O or -R\n");
   if (swo && swr)
      (void) fprintf(stderr, "vpo: -R ignored with -O\n");

#ifdef MEASURE

   /*
    * Complain if both cache simulations and frequency measurements are
    * requested.
    */
   if (swef && (swed || swei)) {
      (void) fprintf(stderr,
               "vpo: Cannot perform both cache and frequency measurements.\n");
      (void) fprintf(stderr,
                     "vpo: Only frequency measurements will be performed.\n");
      swed = swei = FALSE;
   }
#endif

#ifdef INTERACT
   if (swq) {
      if (stdin_cex) {
         fprintf(stderr,
                 "vpo: cex input must come from file with -q option\n");
         exit(EXIT_FAILURE);
      }
      cex_checksum = file_checksum(stdin);
   }

   /* clear the .transout file which will be used to temporarily save all
    * transactions. This file is copied to a .trans file at the end of the
    * program */
   if (save_trans) {
      char  filename[MAXSTRING];
      FILE *f;
      char *b, *d;

      if (!*argv) {
         fprintf(stderr, "vpo: must open input file with swq option\n");
         exit(EXIT_FAILURE);
      }
      for (a = *argv + strlen(argv[0]) - 1; *a != '/' && a != *argv; a--) ;
      if (*a == '/') {
         for (d = pathname, b = *argv; b != a; b++, d++)
            *d = *b;
         *d++ = '/';
         *d = '\0';
         a++;
      }
      else
         pathname[0] = '\0';
      for (b = basename; *a && *a != '.'; a++, b++)
         *b = *a;
      *b = '\0';

      /* clear out the file if it exists */
      sprintf(filename, "%s%s.transout", pathname, basename);
      f = fopen(filename, "w");
      fprintf(f, "k%u\n", cex_checksum);
      fclose(f);

   }

   /*open a new file which will contain the instrumented assembly code */
   sprintf(inst_filename, "%s%s.inst.s", pathname, basename);
   if(instfp = fopen(inst_filename, "w"))
     setbuf(instfp, instbuf);
   else{
     fprintf(stderr, "Unable to create .inst.s file\n");
   }
#endif

}

/*
 * debug_opt - determine if the user specified a certain debug option
 */
int debug_opt(char *option)
{

   register char *a, *b;
   register int i;

   /*
    * Look through the defaults given to determine if the debug option was
    * specified in the command line.  A debug option is a string that can be
    * further qualified by appending a '@' followed by the name of the function
    * for which the option holds.  For example:
    * 
    * -dmemory_usage Indicates that the amount of memory allocated by the
    * optimizer should be displayed after every function is optimized.
    * 
    * -dmemory_usage@foo Indicates that the amount of memory allocated by the the
    * optimizer while it was optimizing the function "foo" should be displayed.
    */
   for (i = 0; i < swd; i++) {
      a = option;
      b = d_options[i];
      while (*a && *a == *b) {
         a++;
         b++;
      }
      if (*a)
         continue;
      while (*b == '@') {
         b++;
         if (a = fn) {
            while (*a && *a == *b) {
               a++;
               b++;
            }
            if (*a)
               goto next_opt;
         }
      }
      if (!*b)
         return TRUE;
    next_opt:
      ;
   }

   return FALSE;
}

/*
 * debug_opt_i - determine if the user specified a certain debug option
 */
int debug_opt_i(char *option, int invocation)
{

   register char *a, *b;
   register int i;

   /*
    * Look through the defaults given to determine if the debug option was
    * specified in the command line.  A debug option is a string that can be
    * further qualified by appending a '@' followed by the name of the function
    * for which the option holds and further qualified by a '@' followed by a
    * number indicating which invocation of the given option the option is
    * valid for.  For example:
    * 
    * -ddump_after_remv_branch_chains Indicates that the current state of the
    * function should be dumped after every invocation of the
    * remv_branch_chains phase.
    * 
    * -ddump_after_remv_branch_chains@foo Indicates that the current state of the
    * function should be dumped after every invocation of the
    * remv_branch_chains phase while the optimizer is processing the function
    * "foo".
    * 
    * -ddump_after_remv_branch_chains@1 Indicates that the current state of the
    * function should be dumped after the first invocation of the
    * remv_branch_chains phase.
    * 
    * -ddump_after_remv_branch_chains@foo@1 Indicates that the current state of
    * the function should be dumped after the first invocation of the
    * remv_branch_chains phase while the optimizer is processing the function
    * "foo".
    */
   for (i = 0; i < swd; i++) {
      a = option;
      b = d_options[i];
      while (*a && *a == *b) {
         a++;
         b++;
      }
      if (*a)
         continue;
      while (*b == '@') {
         b++;
         if (*b <= '9' && *b >= '0') {
            if (atoi(b) != invocation)
               goto next_opt;
            do {
               b++;
            } while (*b <= '9' && *b >= '0');
         }
         else if (a = fn) {
            while (*a && *a == *b) {
               a++;
               b++;
            }
            if (*a)
               goto next_opt;
         }
      }
      if (!*b)
         return TRUE;
    next_opt:
      ;
   }

   return FALSE;
}

/*
 * debug_opt_l - determine if the user specified a certain debug option
 */
int debug_opt_l(char *option, char *label)
{

   register char *a, *b;
   register int i;
   char *h;

   /*
    * Look through the defaults given to determine if the debug option was
    * specified in the command line.  A debug option is a string that can be
    * further qualified by appending a '@' followed by the name of the block
    * label for which the option holds.  For example:
    * 
    * -dafter_preheader Indicates that the current state of the function should
    * be dumped after every invocation of the preheader() function.
    * 
    * -dafter_preheader@L42 Indicates that the current state of the function
    * should be dumped after the invocation of the function preheader() for the
    * loop whose entry block is labeled "L42".
    * 
    * -dafter_preheader@foo Indicates that the current state of the function
    * should be dumped after every invocation of the preheader() function
    * during the optimization of function "foo".
    */
   for (i = 0; i < swd; i++) {
      a = option;
      b = d_options[i];
      while (*a && *a == *b) {
         a++;
         b++;
      }
      if (*a)
         continue;
      if (*b == '@') {
         b++;
         h = b;
         if (a = label) {
            while (*a && *a == *b) {
               a++;
               b++;
            }
            if (!*a && !*b)
               return TRUE;
         }
         b = h;
         if (a = fn) {
            while (*a && *a == *b) {
               a++;
               b++;
            }
            if (*a)
               goto next_opt;
         }
      }
      if (!*b)
         return TRUE;
    next_opt:
      ;
   }

   return FALSE;
}

/*
 * debug_opt_i_l - determine if the user specified a certain debug option
 */
int debug_opt_i_l(char *option, int invocation, char *label)
{

   register char *a, *b;
   register int i;
   char *h;


   /*
    * Look through the defaults given to determine if the debug option was
    * specified in the command line.  A debug option is a string that can be
    * further qualified by appending a '@' followed by the name of the block
    * label for which the option holds.  Also, the option can be qualified by
    * giving the number of the invocation and the name of the function for
    * which the option holds.  For example:
    * 
    * -dafter_code_motion Indicates that the current state of the function
    * should be dumped after every invocation of the code motion phase.
    * 
    * -dafter_code_motion@L42 Indicates that the current state of the function
    * should be dumped after the invocation of the code motion phase for the
    * loop whose entry block is labeled "L42".
    * 
    * -dafter_code_motion@foo Indicates that the current state of the function
    * should be dumped after every invocation of the code motion phase during
    * the optimization of function "foo".
    * 
    * -ddump_after_code_motion@1 Indicates that the current state of the
    * function should be dumped after the first invocation of the code motion
    * phase for every loop.
    * 
    * -ddump_after_code_motion@foo@1 Indicates that the current state of the
    * function should be dumped after the first invocation of the code motion
    * phase for every loop while the optimizer is processing the function
    * "foo".
    * 
    * -ddump_after_code_motion@L42@1 Indicates that the current state of the
    * function should be dumped after the first invocation of the code motion
    * phase while the loop whose entry block is labeled L42 is being processed.
    */
   for (i = 0; i < swd; i++) {
      a = option;
      b = d_options[i];
      while (*a && *a == *b) {
         a++;
         b++;
      }
      if (*a)
         continue;
      while (*b == '@') {
         b++;
         if (*b <= '9' && *b >= '0') {
            if (atoi(b) != invocation)
               goto next_opt;
            do {
               b++;
            } while (*b <= '9' && *b >= '0');
         }
         else {
            h = b;
            if (a = label) {
               while (*a && *a == *b) {
                  a++;
                  b++;
               }
               if (!*a && !*b)
                  return TRUE;
               if (!*a && *b == '@')
                  continue;
            }
            b = h;
            if (a = fn) {
               while (*a && *a == *b) {
                  a++;
                  b++;
               }
               if (*a)
                  goto next_opt;
            }
         }
      }
      if (!*b)
         return TRUE;
    next_opt:
      ;
   }

   return FALSE;
}



#ifdef INTERACT

/*
 * clear_all_links - used to clear all links after a hand specified
 *                   transformation or an undo operation
 */
void clear_all_links(struct bblock *v_top)
{
   struct bblock *cblk;
   for (cblk = v_top; cblk; cblk = cblk->down) {
      clear_bb_links(cblk);
   }
}

/*
 * clear_bb_links - used to clear all the links in a basic block
 */
void clear_bb_links(struct bblock *cblk)
{
   struct list *rtlptr;
   int   i;

   if (cblk->rtls) {
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         for (i = 0; i < MAXLINKS; i++)
            rtlptr->lnks[i] = rtlptr->blnks[i] = rtlptr->all_lnks[i] =
             (struct list *) NULL;
      }
   }
}

/*
 * init_old_all - Save the old information for blocks and RTLs.
 *                Used after performing an undo operation.
 */
void init_old_all(struct bblock *v_top)
{
   struct bblock *cblk;
   for (cblk = v_top; cblk; cblk = cblk->down) {
      init_old_bb(cblk);
   }
}

/*
 * init_old_bb - Save the old information for a single basic block.
 */
void init_old_bb(struct bblock *cblk)
{
   cblk->old_left = cblk->left;
   cblk->old_right = cblk->right;
   cblk->old_down = cblk->down;
   cblk->old_up = cblk->up;
   cblk->old_rtls = cblk->rtls;
   cblk->old_rtlend = cblk->rtlend;
   /*initialize all the rtls in the list */
   if (cblk->rtls)
      init_old_rtls(cblk);
}

/*
 * init_old_rtls - Save the old rtl information for a single basic block.
 */
void init_old_rtls(struct bblock *cblk)
{
   struct list *rtlptr;
   if (!cblk->rtls) {
      fprintf(stderr, "first rtl is NULL\n");
      exit(EXIT_FAILURE);
   }

   for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
      init_old_single_rtl(rtlptr);
   }
}

/*
 * init_old_single_rtl - Save the information for a single RTL.
 */
void init_old_single_rtl(struct list *rtlptr)
{
   int   i;

   if (!rtlptr)
      return;

   /*copy all the information needed to the old fields */

   rtlptr->old_daddy = rtlptr->daddy;

   rtlptr->old_next = rtlptr->next;
   rtlptr->old_prev = rtlptr->prev;
   rtlptr->old_type = rtlptr->type;
   rtlptr->old_kind = rtlptr->kind;
}

/*
 * m_rcpy - copy an rlist without freeing up the destination
 *          (not sure this is needed, check on this later - DBW)
 */
void m_rcpy(rlist * dst, rlist src)
{

   register unsigned int *ptr1, *ptr2, *end;


   if (ptr2 = (unsigned int *) src) {
      if (!(ptr1 = (unsigned int *) *dst))
         *dst = (rlist) (ptr1 = RALLOC);
      for (end = ptr1 + rveclen; ptr1 != end; *ptr1++ = *ptr2++) ;
   }
   else {
      /*rfree(*dst); */
      *dst = rinit();
   }

}


#define MAXLABEL            10

struct command commands[MAXCMDS];

/* contains the total number of transformations in the command array*/
int   tot_commands;

/* phases that must be performed before another phase */
unsigned int before_trans_dependences[NUM_TRANS_TYPES];

/* phases that must be performed after another phase */
unsigned int after_trans_dependences[NUM_TRANS_TYPES];

/* required analysis for each phase */
unsigned int needs_analysis[NUM_TRANS_TYPES];

/* analysis invalidated by each phase */
unsigned int invalidates_analysis[NUM_TRANS_TYPES];

/* phases which can enable a particular phase */
unsigned int enable_phase[NUM_TRANS_TYPES];
double denable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
double ddisable_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
int denable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
int ddisable_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
double dperf_phase[NUM_TRANS_TYPES][NUM_TRANS_TYPES];
int dperf_cnt[NUM_TRANS_TYPES][NUM_TRANS_TYPES];

/* phases which do not enable/disable a particular phase */
unsigned int ind_phase[NUM_TRANS_TYPES];

/* indicates if the optimization phases to be performed are to
   be limited to a specified set of blocks in the function */
int   limited_scope = FALSE;

/*indicates the number of functions that precede this function in this file*/
int func_in_file = -1;
int isSelCombPhase;

/*
 * establish_trans_dependences - establish dependences between transformations
 */
void establish_trans_dependences()
{
   int   i;

   /* establish for each transformation, the set of transformations it
    * must follow */
   for (i = 0; i < NUM_TRANS_TYPES; i++)
      after_trans_dependences[i] = 0;
   after_trans_dependences[DEAD_ASG_ELIM_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[REG_ALLOCATION_TRANS] =
     REG_ASSIGNMENT_BIT|INST_SELECT_BIT;
   after_trans_dependences[COMMON_SUBEXPR_ELIM_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[CODE_MOTION_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[LOOP_STRENGTH_REDUCT_TRANS] =
    INST_SELECT_BIT|REG_ASSIGNMENT_BIT | REG_ALLOCATION_BIT;
   after_trans_dependences[RECURRENCE_ELIM_TRANS] =
    INST_SELECT_BIT|REG_ASSIGNMENT_BIT | REG_ALLOCATION_BIT;
   after_trans_dependences[INDUCT_VAR_ELIM_TRANS] =
      INST_SELECT_BIT|REG_ASSIGNMENT_BIT|REG_ALLOCATION_BIT|LOOP_STRENGTH_REDUCT_BIT;
   after_trans_dependences[ALL_LOOP_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[PREDICATION_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[STRENGTH_REDUCT_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[FIX_ENTRY_EXIT_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[INST_SCHED_TRANS] =
    REG_ASSIGNMENT_BIT | FIX_ENTRY_EXIT_BIT;
   after_trans_dependences[FILL_DELAY_SLOTS_TRANS] =
    REG_ASSIGNMENT_BIT | FIX_ENTRY_EXIT_BIT;
   after_trans_dependences[AVOID_UJUMP_TRANS] = REG_ASSIGNMENT_BIT;
   after_trans_dependences[LOOP_UNROLL_TRANS] = REG_ASSIGNMENT_BIT|
     INST_SELECT_BIT|REG_ALLOCATION_BIT;
   after_trans_dependences[CROSS_JUMP_TRANS] = REG_ASSIGNMENT_BIT;

   /* establish for each transformation, the set of transformations it
    * must precede */
   for (i = 0; i < NUM_TRANS_TYPES; i++)
      before_trans_dependences[i] = 0;
   before_trans_dependences[INST_SELECT_TRANS] = 
     /*FIX_ENTRY_EXIT_BIT|*/FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[COMMON_SUBEXPR_ELIM_TRANS] = 
     /*FIX_ENTRY_EXIT_BIT|*/FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[INDUCT_VAR_ELIM_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[GLOBAL_INST_SELECT_TRANS] = 
      REG_ASSIGNMENT_BIT|FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[DEAD_ASG_ELIM_TRANS] = 
     /*FIX_ENTRY_EXIT_BIT|*/FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[INST_SCHED_TRANS] = 
      FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[STRENGTH_REDUCT_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[RECURRENCE_ELIM_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[MINIMIZE_LOOP_JUMPS_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[MERGE_BLOCKS_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[BLOCK_REORDERING_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[CODE_MOTION_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[FIX_CONTROL_FLOW_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[REG_ALLOCATION_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[REG_ASSIGNMENT_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[FIX_ENTRY_EXIT_TRANS] = 
      FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[LOOP_STRENGTH_REDUCT_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[EVAL_ORDER_DETER_TRANS] = 
      GLOBAL_INST_SELECT_BIT|REG_ASSIGNMENT_BIT|FIX_ENTRY_EXIT_BIT|
      FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[ALL_LOOP_TRANS] =
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[PREDICATION_TRANS] =
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[AVOID_UJUMP_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[LOOP_UNROLL_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;
   before_trans_dependences[CROSS_JUMP_TRANS] = 
      FIX_ENTRY_EXIT_BIT|FILL_DELAY_SLOTS_BIT;

   /* establish the analysis on which each transformation depends */
   for (i = 0; i < NUM_TRANS_TYPES; i++)
     needs_analysis[i] = RECALC_PREDS/* | DEAD_CODE_ANALYSIS*/;
   needs_analysis[BRANCH_CHAINING_TRANS] |= CALC_STATUS_ANALYSIS |
     DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS;
   needs_analysis[ELIM_EMPTY_BLOCKS_TRANS] |= CALC_STATUS_ANALYSIS|
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS;
   needs_analysis[USELESS_JUMP_ELIM_TRANS] |= CALC_STATUS_ANALYSIS |
    ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[DEAD_CODE_ELIM_TRANS] |= CALC_STATUS_ANALYSIS |
    ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[REVERSE_BRANCHES_TRANS] =
     DEPTH_FIRST_SEARCH_ANALYSIS| DOMINATOR_ANALYSIS | LOOP_ANALYSIS;
   needs_analysis[BLOCK_REORDERING_TRANS] |= CALC_STATUS_ANALYSIS;
   needs_analysis[MERGE_BLOCKS_TRANS] |= CALC_STATUS_ANALYSIS |
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[INST_SELECT_TRANS] |= LOCAL_LINK_ANALYSIS | DEAD_VAR_ANALYSIS |
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LIVE_VAR_ANALYSIS |
    MERGE_BLOCKS_ANALYSIS;
   needs_analysis[EVAL_ORDER_DETER_TRANS] |= LOCAL_LINK_ANALYSIS;
   needs_analysis[GLOBAL_INST_SELECT_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LIVE_VAR_ANALYSIS |
    GLOBAL_LINK_ANALYSIS;
   needs_analysis[REG_ASSIGNMENT_TRANS] |= DEAD_VAR_ANALYSIS |
    DEPTH_FIRST_SEARCH_ANALYSIS | LIVE_VAR_ANALYSIS;
   needs_analysis[MINIMIZE_LOOP_JUMPS_TRANS] |= CALC_STATUS_ANALYSIS |
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS |
    EXEC_FREQ_ANALYSIS | LIVE_VAR_ANALYSIS | DEAD_VAR_ANALYSIS |
    ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[DEAD_ASG_ELIM_TRANS] |= DEAD_VAR_ANALYSIS | DOMINATOR_ANALYSIS |
    DEPTH_FIRST_SEARCH_ANALYSIS | LIVE_VAR_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[REG_ALLOCATION_TRANS] |=
     DEPTH_FIRST_SEARCH_ANALYSIS|DOMINATOR_ANALYSIS|DEAD_VAR_ANALYSIS|
     LOOP_ANALYSIS|EXEC_FREQ_ANALYSIS|LIVE_VAR_ANALYSIS|ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[COMMON_SUBEXPR_ELIM_TRANS] |= LOCAL_LINK_ANALYSIS|
    DEPTH_FIRST_SEARCH_ANALYSIS|DOMINATOR_ANALYSIS|LOOP_ANALYSIS|
    LOOP_INVARIANT_ANALYSIS|DEAD_VAR_ANALYSIS|LIVE_VAR_ANALYSIS|
     MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[CODE_MOTION_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS |
    LIVE_VAR_ANALYSIS | MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[LOOP_STRENGTH_REDUCT_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS |
    LIVE_VAR_ANALYSIS;
   needs_analysis[RECURRENCE_ELIM_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS | LOOP_ANALYSIS |
    LIVE_VAR_ANALYSIS;
   needs_analysis[INDUCT_VAR_ELIM_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS|DOMINATOR_ANALYSIS|LOOP_ANALYSIS|
    LIVE_VAR_ANALYSIS | MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[ALL_LOOP_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS|DOMINATOR_ANALYSIS|LOOP_ANALYSIS|
    LIVE_VAR_ANALYSIS | MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[STRENGTH_REDUCT_TRANS] |=
    DEPTH_FIRST_SEARCH_ANALYSIS | LIVE_VAR_ANALYSIS;
   needs_analysis[FIX_ENTRY_EXIT_TRANS] |= COUNT_LOCAL_REFS |
    DEPTH_FIRST_SEARCH_ANALYSIS | REGS_USED_ANALYSIS | LIVE_VAR_ANALYSIS |
    DEAD_VAR_ANALYSIS;
   needs_analysis[FILL_DELAY_SLOTS_TRANS] |= DEAD_VAR_ANALYSIS |
     LOCAL_LINK_ANALYSIS | LIVE_VAR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS |
     DOMINATOR_ANALYSIS | LOOP_ANALYSIS | LOOP_INVARIANT_ANALYSIS;
   needs_analysis[AVOID_UJUMP_TRANS] |= DEPTH_FIRST_SEARCH_ANALYSIS |
     DOMINATOR_ANALYSIS | LOOP_ANALYSIS;
   needs_analysis[LOOP_UNROLL_TRANS] |= DEPTH_FIRST_SEARCH_ANALYSIS |
     DOMINATOR_ANALYSIS | LOOP_INVARIANT_ANALYSIS | LOOP_ANALYSIS |
     LIVE_VAR_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   needs_analysis[CROSS_JUMP_TRANS] |= 0;
   needs_analysis[PREDICATION_TRANS] |= CALC_STATUS_ANALYSIS |
     DEPTH_FIRST_SEARCH_ANALYSIS | DOMINATOR_ANALYSIS;
   
   /* establish the analysis that each transformation invalidates */
   for (i = 0; i < NUM_TRANS_TYPES; i++)
      invalidates_analysis[i] = 0;
   invalidates_analysis[BRANCH_CHAINING_TRANS] = ELIM_EMPTY_BLOCKS_ANALYSIS |
     DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS | LOOP_ANALYSIS |
     EXEC_FREQ_ANALYSIS | CALC_STATUS_ANALYSIS | DEAD_CODE_ANALYSIS |
     MERGE_BLOCKS_ANALYSIS;
   invalidates_analysis[ELIM_EMPTY_BLOCKS_TRANS] =
     DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS | LOOP_ANALYSIS |
     EXEC_FREQ_ANALYSIS | CALC_STATUS_ANALYSIS;
   invalidates_analysis[USELESS_JUMP_ELIM_TRANS] = CALC_STATUS_ANALYSIS |
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[DEAD_CODE_ELIM_TRANS] =
     DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS | LOOP_ANALYSIS |
     EXEC_FREQ_ANALYSIS;
   invalidates_analysis[REVERSE_BRANCHES_TRANS] =
     DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS | LOOP_ANALYSIS |
     EXEC_FREQ_ANALYSIS | CALC_STATUS_ANALYSIS | DEAD_CODE_ANALYSIS;
   invalidates_analysis[BLOCK_REORDERING_TRANS] = CALC_STATUS_ANALYSIS |
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[MERGE_BLOCKS_TRANS] =
     DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS | LOOP_ANALYSIS |
     EXEC_FREQ_ANALYSIS | CALC_STATUS_ANALYSIS;
   invalidates_analysis[INST_SELECT_TRANS] =
     REGS_USED_ANALYSIS | DEAD_VAR_ANALYSIS | LOCAL_LINK_ANALYSIS |
     LIVE_VAR_ANALYSIS | DOMINATOR_ANALYSIS | DEPTH_FIRST_SEARCH_ANALYSIS;
   invalidates_analysis[GLOBAL_INST_SELECT_TRANS] =
     REGS_USED_ANALYSIS | LIVE_VAR_ANALYSIS;
   invalidates_analysis[REG_ASSIGNMENT_TRANS] =
     DEAD_VAR_ANALYSIS | REGS_USED_ANALYSIS | LIVE_VAR_ANALYSIS;
   invalidates_analysis[MINIMIZE_LOOP_JUMPS_TRANS] = RECALC_PREDS | 
     DEPTH_FIRST_SEARCH_ANALYSIS | GLOBAL_LINK_ANALYSIS | DOMINATOR_ANALYSIS |
     LOOP_ANALYSIS | LIVE_VAR_ANALYSIS | EXEC_FREQ_ANALYSIS | LOCAL_LINK_ANALYSIS |
     LOOP_INVARIANT_ANALYSIS | CALC_STATUS_ANALYSIS | DEAD_VAR_ANALYSIS |
     MERGE_BLOCKS_ANALYSIS | ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[DEAD_ASG_ELIM_TRANS] = DEAD_VAR_ANALYSIS|
     REGS_USED_ANALYSIS|LIVE_VAR_ANALYSIS|LOOP_INVARIANT_ANALYSIS|
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[REG_ALLOCATION_TRANS] = DEAD_VAR_ANALYSIS|
     REGS_USED_ANALYSIS|LIVE_VAR_ANALYSIS|LOCAL_LINK_ANALYSIS|
     LOOP_ANALYSIS|LOOP_INVARIANT_ANALYSIS;
   invalidates_analysis[COMMON_SUBEXPR_ELIM_TRANS] = LOCAL_LINK_ANALYSIS|
     LIVE_VAR_ANALYSIS|REGS_USED_ANALYSIS|DEAD_VAR_ANALYSIS|
     LOOP_INVARIANT_ANALYSIS|ELIM_EMPTY_BLOCKS_ANALYSIS|RECALC_PREDS;
   invalidates_analysis[CODE_MOTION_TRANS] = DEAD_VAR_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|GLOBAL_LINK_ANALYSIS|DOMINATOR_ANALYSIS|
     LOOP_ANALYSIS|LIVE_VAR_ANALYSIS|EXEC_FREQ_ANALYSIS|CALC_STATUS_ANALYSIS|
     MERGE_BLOCKS_ANALYSIS;
   invalidates_analysis[LOOP_STRENGTH_REDUCT_TRANS] = DEAD_VAR_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|GLOBAL_LINK_ANALYSIS|DOMINATOR_ANALYSIS|
     LOOP_ANALYSIS|LIVE_VAR_ANALYSIS|EXEC_FREQ_ANALYSIS;
   invalidates_analysis[ALL_LOOP_TRANS] = DEAD_VAR_ANALYSIS|CALC_STATUS_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|GLOBAL_LINK_ANALYSIS|DOMINATOR_ANALYSIS|
     LOOP_ANALYSIS|LIVE_VAR_ANALYSIS|EXEC_FREQ_ANALYSIS|MERGE_BLOCKS_ANALYSIS|
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[PREDICATION_TRANS] = DEAD_VAR_ANALYSIS|CALC_STATUS_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|GLOBAL_LINK_ANALYSIS|DOMINATOR_ANALYSIS|
     LOOP_ANALYSIS|LIVE_VAR_ANALYSIS|EXEC_FREQ_ANALYSIS|LOCAL_LINK_ANALYSIS|
     LOOP_INVARIANT_ANALYSIS|ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[RECURRENCE_ELIM_TRANS] = DEAD_VAR_ANALYSIS|
     GLOBAL_LINK_ANALYSIS|DOMINATOR_ANALYSIS|LOOP_ANALYSIS|LIVE_VAR_ANALYSIS|
     EXEC_FREQ_ANALYSIS;
   invalidates_analysis[INDUCT_VAR_ELIM_TRANS] =
     LIVE_VAR_ANALYSIS | REGS_USED_ANALYSIS | LOOP_INVARIANT_ANALYSIS;
   invalidates_analysis[STRENGTH_REDUCT_TRANS] = REGS_USED_ANALYSIS;
   invalidates_analysis[FILL_DELAY_SLOTS_TRANS] =  DEAD_VAR_ANALYSIS |
     LIVE_VAR_ANALYSIS;
   invalidates_analysis[AVOID_UJUMP_TRANS] = DOMINATOR_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|LOOP_ANALYSIS|EXEC_FREQ_ANALYSIS|
     CALC_STATUS_ANALYSIS|LOCAL_LINK_ANALYSIS|LIVE_VAR_ANALYSIS|
     REGS_USED_ANALYSIS|DEAD_VAR_ANALYSIS|MERGE_BLOCKS_ANALYSIS|
     ELIM_EMPTY_BLOCKS_ANALYSIS;
   invalidates_analysis[LOOP_UNROLL_TRANS] = DOMINATOR_ANALYSIS|
     DEPTH_FIRST_SEARCH_ANALYSIS|LOOP_ANALYSIS|EXEC_FREQ_ANALYSIS|
     CALC_STATUS_ANALYSIS|LOCAL_LINK_ANALYSIS|LIVE_VAR_ANALYSIS|
     REGS_USED_ANALYSIS|DEAD_VAR_ANALYSIS|LOOP_INVARIANT_ANALYSIS|
     MERGE_BLOCKS_ANALYSIS|RECALC_PREDS|ELIM_EMPTY_BLOCKS_ANALYSIS|
     DEAD_CODE_ANALYSIS;
   invalidates_analysis[CROSS_JUMP_TRANS] = LOCAL_LINK_ANALYSIS|LIVE_VAR_ANALYSIS|
     DEAD_VAR_ANALYSIS|ELIM_EMPTY_BLOCKS_ANALYSIS;
}

#define MAX_OPT_LEN 200 /* maximum number of characters to receive
                         * from the socket for options             */

void  validate_incoming_message(int);

/*get the commands from the socket*/
void getcmds_from_socket(struct command commands[])
{
   static int pro_is_base=FALSE;
   int   i, j, k, blk, oper;
   struct bblock *cblk;
   char  *c, options[MAX_OPT_LEN];
   int   len, offset;
   char *opt_ptr;
   /*debugging_mode-- just for debugging */
   extern int debugging_mode, pro_is_undo;

   offset = tot_commands;
   if (offset > MAXCMDS) {
     fprintf(stderr, "getcmd (vpo) - too many commands in sequence, resetting array\n");
     offset = tot_commands = pc = 0;
   }
   
   if (debugging_mode)
      write_char('G');
   /*read the options from the socket to a string */
   if(pro_apply_base){
     len = sprintf(options, "0 %s -1", pro_fbase);
     pro_apply_base = FALSE;
   }
   else if(!swq_noviewer)
     len = read(glo_sockfd, options, MAX_OPT_LEN);
   else
     len = read_options_from_file(options);

   if (len == 0) {
      fprintf(stderr, "getcmds: No options received\n");
      exit(EXIT_SUCCESS);
   }
   if (len == -1) {
      fprintf(stderr, "getcmds: Apparently the user interface was killed\n");
      exit(EXIT_SUCCESS);
   }

   /*substitute the \0 with a \n */
   if (options[len - 1] == '\0') {
      options[len - 1] = '\n';
      options[len] = '\0';
   }
   opt_ptr = options;

   /* read in the type of operation to be performed */
   get_num(&opt_ptr, &oper);

   validate_incoming_message(oper);
   /* check for the command to stop */
   if (oper == STOP_TRANS || oper == NEXT_FUNC) {
      commands[offset].oper = oper;
      return;
   }

   /* these are special commands (not a sequence of optimization
    * phases to be performed */
   if (oper == PROFILE_FUNC_BASE){
     store_profile_base(&opt_ptr, pro_fbase);
     is_pro_base = TRUE;
     oper = 0;
   }
   else if(oper == PROFILE_FUNC_OPT){
     oper = 0;
   }
   if (oper < 0) {
      commands[offset].numscope = 0;
      commands[offset].oper = oper;
      if (oper == UNDO_TRANS || oper == UNDO_CHANGE)
         get_num(&opt_ptr, &commands[offset].offset);
      else if (oper == WRITE_RTLS_TRANS)
         get_string(&opt_ptr, commands[offset].filename1);
      else if (oper == CMP_FILES_TRANS) {
         get_string(&opt_ptr, commands[offset].filename1);
         get_string(&opt_ptr, commands[offset].filename2);
      }
      else if (oper==HAND_TRANS || oper==VERIFY_HAND_TRANS)
         get_hand_msg_string(&opt_ptr, commands[offset].hand_msg);

      else if (oper == LOOPS_QUERY) ;
      else if (oper == LIVE_REGS_QUERY) {
         get_num(&opt_ptr, &commands[offset].rtl_id);
         get_num(&opt_ptr, &commands[offset].block_id);
      }
      else if (oper == BLOCK_QUERY)
         get_num(&opt_ptr, &commands[offset].block_id);

      /*request to perform a sanity check from the client */
      else if (oper == SANITY_CHECK_REQ) ;
      else if (oper == FREQUENCY_REQ) ;
      else if (oper == START_MEASUREMENT || oper == STOP_MEASUREMENT) ;
      else if (oper == CHANGE_TEST_CONFIG) ;
      else if (oper == DE_OPTIMIZE_FUNC) ;
      else if (oper == BATCH_COMP_OPT){
	get_string(&opt_ptr, commands[offset].filename1);
	get_num(&opt_ptr, &active_batch);
	old_batch = TRUE;
	if(is_func_exec())
	  execute_status |= (1 << IS_FUNC_EXEC);
      }
      else if (oper == PROFILE_FUNC){
	get_num(&opt_ptr, &commands[offset].offset);	
      }
      else if (oper == EX_DFS_INIT || oper == EX_DFS_END ||
	       oper == EX_DFS_REINIT){
	dfs_scope.limited_scope = FALSE;
	get_num(&opt_ptr, &commands[offset].numscope);
	dfs_scope.num_blks = commands[offset].numscope;
	for(i=0 ; i<commands[offset].numscope ; i++){
	  get_num(&opt_ptr, &commands[offset].blocks[i]);
	  dfs_scope.blk_id[i] = commands[offset].blocks[i];
	}
	if(dfs_scope.num_blks > 0)
	  dfs_scope.limited_scope = TRUE;
      }
      else if (oper == PROBABILISTIC_BATCH){
	get_num(&opt_ptr, &commands[offset].offset);
	prob_batch = TRUE;
	if(is_func_exec())
	  execute_status |= (1 << IS_FUNC_EXEC);
      }
      else if(oper==IND_SEQ_INIT || oper==IND_SEQ_MEASURE);
      else
         ERR_EXIT("getcmds_from_socket (vpo) - No such special command\n");

      /* read in QUIT_TRANS to indicate the end */
      get_num(&opt_ptr, &commands[offset + 1].oper);
      if (commands[offset + 1].oper != QUIT_TRANS)
         ERR_EXIT("getcmds (vpo) - end of message needed\n");

      return;
   }

   /* read the number of blocks in which the scope is limited and
    * the ids for each of these blocks */
   commands[offset].numscope = oper;
   for (i = 0; i < commands[offset].numscope; i++) {
      get_num(&opt_ptr, &commands[offset].blocks[i]);
      if (!find_block_id(commands[offset].blocks[i]))
         ERR_EXIT("getcmds (vpo) - has no matching block\n");
   }

   /*now read in the sequence of optimizations to be performed */
   do {

      /* get the next command */
      get_num(&opt_ptr, &oper);
      commands[offset].oper = oper;

      validate_incoming_message(oper);
      /*for loop unrolling get the loop unroll factor*/
      if(oper == LOOP_UNROLL_TRANS){

	/*search back for the '+' sign*/
	for(c=opt_ptr ; *c!='+' ; c--);
	if(is_const(++c))
	  commands[offset].offset = atoi(c);
	else
	  fprintf(stderr, "Loop Unroll factor not found %s\n", options);
      }
      /* if a branch command, then we need to read in an offset as well */
      if (oper == IF_LOOP_TRUE_GOTO_TRANS || oper == IF_FALSE_GOTO_TRANS
          || oper == GOTO)
         get_num(&opt_ptr, &commands[offset].offset);

      if (oper == SELECT_BEST_SEQUENCE || oper == NEXT_SEQUENCE)
         commands[offset].offset = -1;

      if (offset > 1 && oper == STOP_TRANS) {
         fprintf(stderr,
                 "getcmd (vpo) - sequence must be terminated by QUIT_TRANS\n");
         exit(EXIT_FAILURE);
      }
      offset++;
   } while (oper != STOP_TRANS && oper != QUIT_TRANS);
}


/* read in one command from the user interface*/
int read_one_command(int sockfd, char *option)
{
   int   n, rc;
   char  c, *ptr;

   ptr = option;
   n = 0;
   do {
      if ((rc = read(sockfd, &c, 1)) == 1) {
         *ptr++ = c;
         n += rc;
      }
      else if (rc == 0)
         break;
   } while (c != '\n');

   return n;
}

int wait_for_next_func()
{
   int   pc = 0;
   if (swq) {
      /* Read in superfluous NEXT_FUNC commands that Wankang sends over */

      getcmds_from_socket(commands);
      while (commands[pc].oper != STOP_TRANS
             && commands[pc].oper != NEXT_FUNC)
         pc += 1;
   }

   return pc;
}

/*
 * interactive_optimize - interactively optimize the current function
 */
void interactive_optimize()
{
   register int i, j;
   struct list *ptr;
   struct bblock *cblk;
   struct loopl *loop;
   struct locuse *locptr;
   struct transform_list *tptr;
   extern struct transform_list *transform_head;
   struct freq_counts *freq_measure;
   struct timeval ctime;
   struct timeval start_time, end_time;
   int goto_change[MAX_JUMPS], loop_index, changes_last;
   int t_change;
   int change, newallocations;
   char cmd[100];
   int initial_count_sent;
   int sdepth, next_pc, offset, ins_counts[MAX_BLOCKS];
   struct com_stack best_seq[MAX_BEST_SEQUENCE];
   struct comb_struct best_comb;
   int isComb_pass, next_seq[MAX_OPT], phase_indices[MAX_OPT], curr_pos[MAX_OPT];
   int succ_phases[MAX_OPT], succ_num, succ_map[MAX_OPT], att_seq[MAX_OPT], map_count;
   int sort_phases[MAX_OPT], sort_succ_phases[MAX_OPT];
   int pass2, isSelBestSeq, is_exec;
   struct Func_hash *fptr, *remap_fptr;
   int seq_no, scount, fcount, rcount, start_label, count;
   unsigned int curr_ptree;
   long long time_sec, time_usec;
   long long c_time_sec, c_time_usec, diff_time;
   unsigned int sanity_mask;
   int profile_level = -1, prev_opt_active;
   int num_att_opt, num_active_opt;
   FILE *sim_fp;

#ifndef WIDES
   int   d_f_s_count, b_d_t_count;
#endif
   int   status;
   unsigned long long s_measure, d_measure, total_ins;
   long long best_s_measure, best_d_measure;
   unsigned int depend, analysis;
   double measure;
   static int comb_log_status = 0;
   static int comb_htable_hits = 0;
   static int func_num = 0;
   char  line[MAXSTRING], oldbasename[MAXSTRING];
   extern struct loopl *loops;
   extern struct locuse *locs;
   extern int initial_set_sent, block_id, labnum;
   extern int afterinit_block_id, afterinit_rtl_id;
   extern struct transform_list *transform_tail;

   /* save the block id and rtl id for debugging purposes */
   afterinit_block_id = block_id;
   afterinit_rtl_id = rtl_id;

   /* perform some initialization */
   init_old_all(top);
   fill_delay_done = 0;
   for (cblk = top; cblk; cblk = cblk->down)
      cblk->inscope = FALSE;

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_interactive_optimize", 1))
      dump_function_i("before interactive_optimize()", 1,
                      SHOW_LABELS | SHOW_STATUS | SHOW_UP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

#ifdef EARLY_FRAME_SETUP
   early_frame_setup();
#endif


   /*
    * Set up invocation counters for some of the more prolific optimization
    * phases.
    */
   r_b_c_count = 1;
   r_u_b_count = 1;
   r_u_j_count = 1;
   r_u_c_count = 1;
   r_j_count = 1;
   m_j_count = 1;
   m_b_b_count = 1;
   i_s_count = 1;
   d_f_s_count = 1;
   f_d_f_count = 1;
   l_v_a_count = 1;
   b_d_t_count = 1;
   g_a_count = 1;
   m_c_s_count = 1;
   c_s_e_count = 1;
   r_d_v_count = 1;
   c_m_count = 1;
   s_s_r_count = 1;
   p_count = 1;
   cj_count = 1;

   /*save labnum*/
   curr_fn_labnum = labnum;
   
   /*initialize best sequence variables */
   sdepth = 0;
   curr_oper = 0;

   /*
    * Deads are not bit vectors before vectorize_deads are
    * called later in optimize.
    */
   DeadsareBitVectors = FALSE;

   /*
    * Allocate vector positions for pseudo registers, and then go back and fix
    * the dead list on each RTL to use a register vector.  While we are at it,
    * we create a register vector named "pseudos" which contains all pseudo
    * registers (and only pseudo registers).  Note that we do this after having
    * removed unreachable basic blocks (if the user requested control flow
    * optimizations), so that we do not allocate bit positions for pseudo
    * registers that were used only in those blocks.  We must do this before we
    * attempt to perform any data flow analysis or instruction selection
    * phases.
    */
   i = regallocptr;
   allocate_reg_bit_positions();
   rveclen = regallocptr >> intscale;
   if (regallocptr & bitsperint)
      rveclen++;
   for (pseudos = rinit(); i < regallocptr;
        rins((unsigned int) i++, &pseudos)) ;
   measure_flag = TRUE;
   vectorize_deads(1);
   measure_flag = FALSE;

   /*set the flags for measurement*/
   read_measure_flags();

#ifdef VET
   if (fn) {
      moreopts = TRUE;
      trans_done = 0;
      prep_for_funcstart();
      clear_transform_list();

      /* the compiler always creates a useless empty basic block at the
	 end. Remove this basic block before proceeding. It also makes sense
	 to apply the basic branch optimizations at this point to simplify
	 the control flow. This is more important for the ARM which has a
	 ridiculously complex controlflow handed down to the optimizer by the
	 code-expander*/
      measure_flag = TRUE;
      valid_analysis = 0;
      func_in_file++;

#if FUNC_INFO
      /*get additional information about the function*/
      get_func_info(FALSE);
#endif /*FUNC_INFO*/

      /*write the function name to a file for sim-outorder to get cycle
	counts for that function alone*/
#if 1
      if((sim_fp = fopen("vpo_function.txt", "w")) == NULL)
	fprintf(stderr, "File vpo_function.txt cannot be written\n");
      else{
	fprintf(sim_fp, "Function: %s\n", fn);
	fclose(sim_fp);
      }
#else
      /*if we care to get simulator counts over all the functions in the
	application, without library code*/
      if((sim_fp = fopen("vpo_function.txt", "a")) == NULL)
	fprintf(stderr, "File vpo_function.txt cannot be written\n");
      else{
	fprintf(sim_fp, "Function: %s\n", fn);
	fclose(sim_fp);
      }
#endif      
      
      do_branch_opt(&valid_analysis);

      /*do_needed_analysis(needs_analysis[ELIM_EMPTY_BLOCKS_TRANS] & ~RECALC_PREDS);
	remv_useless_basic_blocks(1);*/
      measure_flag = FALSE;

      /*
       * If viewer is started and user wants to view RTLs
       * for this function, then send the initial RTL set.
       */
      if (viewing && send_messages) {
         send_init_set(fn);

         /* perform some initialization for reading in the commands */
         pc = 0;
         for (i = 0; i < NUM_TRANS_TYPES; i++)
            num_trans_done[i] = 0;

         /*initialize the command array variables */
         tot_commands = 0;
         pc = 0;
      }

      /*preds are correctly set when coming in*/
      valid_analysis = RECALC_PREDS;

      /*
       * apply the initial transformations from the trans file.
       */
      initial_count = NULL;
      initial_count_sent =
       apply_inittrans(&initial_count, -1, APPLY_FROM_FILE);
#ifdef MEASURE
      if (continuous_measures && initial_count == NULL) {
         get_measure(&initial_count, -1);
	 read_perf_num(&s_measure, &d_measure);
         if (viewing && !session_over)
            send_measures(initial_count, s_measure, d_measure);
         if (viewing && send_messages)
            write_char(ENDSEQ);
      }
#endif
   }
#endif

   pc = tot_commands;
   pass2 = isSelCombPhase = 0;
   /* if there is a function to compile */
   if (fn && !session_over && !measure_phase) {
      num_att_opt = num_active_opt = 0;

      /* read the commands to perform */
      getcmds_from_socket(commands);

      if(old_batch || prob_batch){
	if(prob_batch || (old_batch && active_batch)){
	  populate_en_dis_tables(NULL);
	  init_batch_prob();
	}
	fprintf(stdout, "Initial RTLs in %s: %d\n", fn, count_RTL());
	fprintf(stdout, "Sequence: ");
      }
      gettimeofday(&start_time, NULL);	      
      
      /* to store if there is some change in between 2 goto_trans */
      loop_index = 0;
      for (i = 0; i < MAX_JUMPS; i++)
         goto_change[i] = FALSE;
      changes_last = FALSE;

      /* while we do not encounter a STOP command */
      while (commands[pc].oper != STOP_TRANS
             && commands[pc].oper != NEXT_FUNC) {

         /* Limit the region in which the transformation will be applied.
          * It should be set once for an entire sequence of commands. */
         if (limited_scope = (commands[pc].numscope > 0)) {
            for (i = 0; i < commands[pc].numscope; i++) {
               for (cblk = top; cblk; cblk = cblk->down)
                  if (cblk->block_id == commands[pc].blocks[i]) {
                     cblk->inscope = TRUE;
                     break;
                  }
               if (!cblk) {
                  fprintf(stderr,
                          "interactive_optimize (vpo) - block not found\n");
                  exit(EXIT_FAILURE);
               }
            }
         }

         /* interpret the commands */
         while ((curr_oper = commands[pc].oper) != QUIT_TRANS) {

	    /*if the command is the start of a looping construct */
	    if (curr_oper == BEGIN_LOOP){
	      loop_index += 1;
	      goto_change[loop_index] = FALSE;
	      pc++;
	      continue;
	    }

	    /* if the command is the end of a looping construct */
	    if (curr_oper == END_LOOP){
	      loop_index -= 1;
	      pc++;
	      continue;
	    }
	    
            /* if the command is a loop condition check for do loops */
            if (curr_oper == IF_LOOP_TRUE_GOTO_TRANS) {

               /* either branch by that offset if there have been
                * changes or skip to the next transformation */
               if (goto_change[loop_index]) {
                  pc += commands[pc].offset;
                  goto_change[loop_index] = FALSE;
               }
               else
                  pc += 1;
               continue;
            }

            /* if the command is a loop condition check for while loops */
            else if (curr_oper == IF_LOOP_FALSE_GOTO_TRANS) {
               if (!goto_change[loop_index]) {
                  /* For the first iteration we need to check if the last phase
                   * produced any changes. For any other iteration changes_last
                   * cannot be true unless goto_change[loop_index] is also true
                   */
                  if (changes_last)
                     pc += 1;
                  else
                     pc += commands[pc].offset;
               }
               else {
                  pc += 1;
                  goto_change[loop_index] = FALSE;
               }
               continue;
            }

            /* if the command is a false branch */
            else if (curr_oper == IF_FALSE_GOTO_TRANS) {
               if (!changes_last)
                  pc += commands[pc].offset;
               else
                  pc += 1;
               continue;
            }

            /* if the command is an unconditional jump */
            else if (curr_oper == GOTO) {

               /*update pc by the offset given */
               pc += commands[pc].offset;
               continue;
            }

	    /*check if we are only allowing enabled phases (batch_prob)
	      during batch compilation (old_batch). If so, then determine if
	      the phase is a positive probability of being active, else
	      suppress the phase*/
	    if(old_batch && active_batch){
	      if(curr_oper>0 && !is_phase_active(curr_oper)){
		pc++;
		continue;
	      }
	    }

            /* check if this type of analysis has been done and cannot be done
             * again */
            if (curr_oper > 0 && ONCE_TRANS(1 << curr_oper)
                && (1 << curr_oper) & trans_done) {
	      /*fprintf(stderr,
                "interactive_optimize (vpo) - trans %d cannot be performed again\n",
		curr_oper);*/
	       pc++;
	       continue;
               /*exit(EXIT_FAILURE);*/
            }

            /* check if this transformation had to follow another
             * transformation */
            if (curr_oper > 0)
               depend = after_trans_dependences[curr_oper];
            else
               depend = 0;

            /* If reg assign is the only dependency required for this phase
             * then do this phase now */
            if (curr_oper > 0 && depend && ((depend & trans_done) ==
					    (depend & ~(1 << REG_ASSIGNMENT_TRANS)))){

               /*change the current phase to register assignment so that the
                * viewer can correctly interpret it */
               curr_oper = REG_ASSIGNMENT_TRANS;

	       /*EXHAUSTIVE_SEARCH: check if we should perform EOD before RA*/
	       if(is_ex_search && (ex_flags & EOD_AND_RA)){
		 analysis = needs_analysis[EVAL_ORDER_DETER_TRANS];
		 valid_analysis |= do_needed_analysis(analysis);
		 evaluation_order_determination(1);
		 valid_analysis &= ~invalidates_analysis[EVAL_ORDER_DETER_TRANS];
	       }

               /*do only register assignment and not fix entry exit */
               do_reqd_optimization(TRUE, FALSE, &valid_analysis);
               trans_done |= (1 << REG_ASSIGNMENT_TRANS);

	       /*record register assignment as a succ. phase during the sel...comb*/
	       if(isSelCombPhase)
		 succ_phases[succ_num++] = curr_oper;
	       
               /*reset the phase back to current phase */
               curr_oper = commands[pc].oper;

            }
            if ((depend & trans_done) != depend) {
               fprintf(stderr,
                   "interactive_optimize (vpo) - trans %d did not follow %d\n",
                       curr_oper, depend);
	       pc++;
	       continue;
               /*exit(EXIT_FAILURE);*/
            }

            /* check if this transformation had to precede another
             * transformation */
            if (curr_oper > 0)
               depend = before_trans_dependences[curr_oper];
            else
               depend = 0;
            if (depend & trans_done) {
               fprintf(stderr,
                  "interactive_optimize (vpo) - trans %d did not precede %d\n",
                       curr_oper, depend);
	       pc++;
	       continue;
               /*exit(EXIT_FAILURE);*/
            }

            /* check to see if any analysis has to be performed */
            if (curr_oper > 0){
	      analysis = needs_analysis[curr_oper] & ~valid_analysis;
	      /*analysis = needs_analysis[curr_oper];*/
	    }
	    else
	      analysis = 0;

	    /*perform the needed analysis*/
	    valid_analysis |= do_needed_analysis(analysis);
	    
	    /*initialize the flags detecting it an optimization produced changes*/
            change = FALSE;
	    is_change = FALSE;
	    real_change = FALSE;
	    dead_list_change = FALSE;
	    
            /* perform the appropriate transformation */
            switch (curr_oper) {

                /* remove branch chains */
             case BRANCH_CHAINING_TRANS:
                change |= remv_branch_chains(r_b_c_count++);
                break;

                /* remove empty basic blocks */
             case ELIM_EMPTY_BLOCKS_TRANS:
                change |= remv_useless_basic_blocks(r_u_b_count++);
                break;

                /* remove useless unconditional jumps and branches */
             case USELESS_JUMP_ELIM_TRANS:
                change |= remv_useless_jumps(r_u_j_count++);
                break;

                /* remove unreachable code */
             case DEAD_CODE_ELIM_TRANS:
                change |= remv_unreachable_code(r_u_c_count++);
                break;

                /* reverse conditional branches to avoid unconditional
                 * jumps */
             case REVERSE_BRANCHES_TRANS:
                change |= reverse_jumps(r_j_count++);
                break;

                /* reorder basic blocks to eliminate unconditional jumps */
             case BLOCK_REORDERING_TRANS:
                change |= minimize_jumps(m_j_count++);
                break;

                /* merge basic blocks together when possible */
             case MERGE_BLOCKS_TRANS:
                change |= merge_basic_blocks(m_b_b_count++);
                break;

                /* perform instruction selection within basic blocks */
             case INST_SELECT_TRANS:
	       while (t_change = instruction_selection(i_s_count++, 0)){
		 valid_analysis &= ~invalidates_analysis[curr_oper];		 
		 valid_analysis |= do_needed_analysis(needs_analysis[curr_oper] & ~valid_analysis);
		 change |= t_change;
	       }
	       break;

                /* fix control flow to deal with boolean expressions */
             case FIX_CONTROL_FLOW_TRANS:
#ifdef FIX
                change |= fix_control_flow(1);
#endif
                  break;
   
               /* perform evaluation order determination 
                  (don't know how to detect if this transformation
                   caused any changes) */
               case EVAL_ORDER_DETER_TRANS:
                  evaluation_order_determination(1);
                  change |= FALSE;
                  break;
   
               /* perform instruction selection across basic blocks */
               case GLOBAL_INST_SELECT_TRANS:
                  change |= instruction_selection(i_s_count++, 1);
                  break;
   
               /* assign pseudo registers to hardware registers */
               case REG_ASSIGNMENT_TRANS:
		  if(!sw1){
		    change |= local_register_assignment(1);
		    rfree(pseudos);
		    number_rtls();
		  }

		  /* in case register assignment does not make any changes,
		     send dummy messages to the viewer to indiacte that it
		     has been done*/
		  if(!is_change)
		    send_phase_msgs(REG_ASSIGNMENT_TRANS);
		  break;
   
               /* minimize jumps in loops */
               case MINIMIZE_LOOP_JUMPS_TRANS:
   	          change |= minimize_loop_jumps(1);
                  break;
   
               /* eliminate dead assignments and update dead register
                  information */
               case DEAD_ASG_ELIM_TRANS:
                  dump_left_right("left.before");
		  if(!(trans_done & (1 << INST_SELECT_TRANS))){
		    get_seffects();
		    live_variable_analysis(l_v_a_count++,
					   /*curr_oper == REG_ALLOCATION_TRANS ||
					   (curr_oper == DEAD_ASG_ELIM_TRANS &&
					    commands[pc+1].oper ==
					    REG_ALLOCATION_TRANS),*/
					   trans_done & REG_ASSIGNMENT_BIT,
					   FALSE);
		  }
		  if(remv_dead_variables(r_d_v_count++, TRUE, TRUE)){
		    change |= TRUE;
		    /*clrsets();*/
		  }
                  break;
		  
               /* allocate local variables and parameters to registers */
               case REG_ALLOCATION_TRANS:
		 /*change |= color_global_allocation(g_a_count++);*/
		 while (t_change = color_global_allocation(g_a_count++)){
		   valid_analysis &= ~invalidates_analysis[curr_oper];		 
		   valid_analysis |=
		     do_needed_analysis(needs_analysis[curr_oper] & ~valid_analysis);
		   change |= t_change;
		 }
		 break;
   
               /* perform common subexpression elimination */
               case COMMON_SUBEXPR_ELIM_TRANS:
		 while((t_change=common_subexpression_elimination(c_s_e_count))){
		   valid_analysis &= ~invalidates_analysis[curr_oper];
		   valid_analysis = 0;
		   valid_analysis |=
		     do_needed_analysis(needs_analysis[curr_oper] & ~valid_analysis);
		   change |= t_change;
		 }
		 break;
   
               /* perform loop invariant code motion */
               case CODE_MOTION_TRANS:
                  swm = TRUE;
   	          change |= code_motion(c_m_count++);
                  swm = FALSE;
                  break;
   
               /* eliminate redundant loads from loops caused by recurrences */
               case RECURRENCE_ELIM_TRANS:
                  swk = TRUE;
   	          change |= code_motion(c_m_count++);
                  swk = FALSE;
                  break;
   
               /* perform loop strength reduction */
               case LOOP_STRENGTH_REDUCT_TRANS:
                  sws = TRUE;
   	          change |= code_motion(c_m_count++);
                  sws = FALSE;
                  break;
   
               /* eliminate basic induction variables that are only
                  incremented */
               case INDUCT_VAR_ELIM_TRANS:
                  swb = TRUE;
   	          change |= code_motion(c_m_count++);
                  swb = FALSE;
                  break;

	       /* perform all four loop transformations*/
	       case ALL_LOOP_TRANS:
		 swm = swk = sws = swb = TRUE;

		 /*do not perform recurrences after loop unrolling, since
		   recurrences is not currently robust enough to handle two
		   incremenents of the loop variable correctly each time*/
		 if(trans_done & LOOP_UNROLL_BIT)
		   swk = FALSE;
		 count = 0;
		 while((t_change = code_motion(c_m_count++))){
		   valid_analysis &= ~invalidates_analysis[curr_oper];
		   valid_analysis |=
		     do_needed_analysis(needs_analysis[curr_oper] & ~valid_analysis);
		   change |= t_change;
		   if(++count > 3)
		     break;
		 }
		 swm = swk = sws = swb = FALSE;
		 break;

#ifdef PRED		  
	       /* predication on machines with support for it*/
	       case PREDICATION_TRANS:
		 change |= predicate_basic_blocks(p_count++);
		 break;
#endif

	       /*remove uncondition jumps by code replication*/
	       case AVOID_UJUMP_TRANS:
		 change |= remove_jumps();
		 break;
		 
               /* perform reduction in strength */
               case STRENGTH_REDUCT_TRANS:
   	          change |= simple_strength_reduction(s_s_r_count++);
                  break;

	       /* perform loop unrolling*/
	       /* loop unroll may increase the number of blocks and RTLs in
		  the function which may cause an increase in the 'veclen'.
		  We will need to handle this condition*/
	       case LOOP_UNROLL_TRANS:
		 change |= loop_unroll(commands[pc].offset);
		 break;

	       /* cross jumping */
	       case CROSS_JUMP_TRANS:
		 change |= cross_jumping(cj_count++);
		 break;
   
               /* adjust the entry and exit of the function to enforce the
                  calling sequence of the machine */
               case FIX_ENTRY_EXIT_TRANS:
                  for (ptr = top->rtls; ptr && !(ptr->type & FUNCNAME);
                       ptr = ptr->next)
                     ;
                  if (ptr){
		    registers_used();
		    fixentry(ptr, ret_block->preds);
		  }

		  /* in case fix entry exit does not make any changes,
		     send dummy messages to the viewer to indiacte that it
		     has been done*/
		  if(!is_change)
		    send_phase_msgs(FIX_ENTRY_EXIT_TRANS);
                  break;
   
               /* perform instruction scheduling to avoid stalls from data
                  hazards */
               case INST_SCHED_TRANS:
#ifdef SCHED		 
                  instruction_scheduling(1);
                  break;
#endif
		  
               /* perform filling of delay slots */
               case FILL_DELAY_SLOTS_TRANS:
#ifdef FILL
                  change |= fill_delay_slots(1);
		  fill_delay_done = 1;
#endif
                  break;
#ifdef DEOPT
	       /* coalesce fp moves*/
	       case COALESCE_FP_MOVES_TRANS:
		 change |= coalesce_fp_moves();
		 break;
#endif

	       /*verify hand specified transformations*/
	    case VERIFY_HAND_TRANS:
	      verify_hand_trans(commands[pc].hand_msg);
	      break;
		 
	       /*perform hand specified transformation*/
	       case HAND_TRANS:
		  hand_trans(commands[pc].hand_msg);
		  break;

               /* undo a specified number of changes */
	       case UNDO_CHANGE:
		  undo_changes(commands[pc].offset);
		  
                  /* clear all analysis since we are not sure what effect
                     undoing transformations will cause */
		  if (valid_analysis &
		      (LOCAL_LINK_ANALYSIS|GLOBAL_LINK_ANALYSIS)){
		     if (links_modified)
		        clear_all_links(top);
		  }
		  valid_analysis=0;
		  break;
#ifdef UNDO_CODE
               /* insert an undo stop command in the undo linked list */
	       case INSERT_UNDO_STOP:
		  insert_undo_stop();
                  break;
#endif
	       /* request to perform a sanity check*/
	       case SANITY_CHECK_REQ:
		 sanity_check(top);
		 break;

               /* undo a specified number of transformations */
               case UNDO_TRANS:
		  undo_transes(commands[pc].offset);

                  /* clear all analysis since we are not sure what effect
                     undoing transformations will cause */
		  if (valid_analysis &
		      (LOCAL_LINK_ANALYSIS|GLOBAL_LINK_ANALYSIS)){
		     if (links_modified)
		        clear_all_links(top);
		  }
		  valid_analysis=0;
		  break;
		  /*if continuous_measures then get a frequency measurement*/

#ifdef MEASURE		 
	       /* request to execute the program and get measurements*/
	       case FREQUENCY_REQ:
		 get_measure(&freq_measure, -1);
		 read_perf_num(&s_measure, &d_measure);
		 valid_analysis = 0;
		 send_measures(freq_measure, s_measure, d_measure);
		 break;

		 /*messgae to start taking continuous measurements*/
	         case START_MEASUREMENT:
		   continuous_measures = TRUE;
		   get_measure(&freq_measure, -1);
		   read_perf_num(&s_measure, &d_measure);
		   valid_analysis = 0;
		   send_measures(freq_measure, s_measure, d_measure);
		   break;
		   
		  /*message to stop taking continuous measures*/
	          case STOP_MEASUREMENT:
		    continuous_measures = FALSE;
		    break;
#endif

#ifdef DEOPT		    
	       /* de-optimize the current function */
	       case DE_OPTIMIZE_FUNC:
		 fprintf(stderr, "de-optimizing the current function\n");
		 change = de_optimize_func();
		 break;
#endif /*DEOPT*/

		 /*invoke routine to apply optimizations as performed by the
		   batch compiler. We could have either changed the batch
		   compiler optimize() routine, or construct another routine
		   which does the same thing. To reduce clutter in optimize,
		   we are doing the latter*/
	       case BATCH_COMP_OPT:
		 if(TRUE || execute_status & (1<<IS_FUNC_EXEC)){
		   /*set all the flags*/
		   parse_flags(commands[pc].filename1);
		   batch_comp_opt(pc);
		 }
		 break;
		 
               /* write the current state of RTLS to a file */
               case WRITE_RTLS_TRANS:

		  /* use label[0] field in commands[] struct to know which
                     filename to open */
                  dump_func_to_file(commands[pc].filename1);
                  break;

	       case CHANGE_TEST_CONFIG:
		 /* create / modify the test configuration script */
		 change_test_config();
		 break;
		 
	       case SELECT_BEST_COMBINATION:
		 /*if called from within SEL...SEQ, and after the best
		   sequence has been determined, the best COMBINATION also
		   been determined and is stored in the command array*/
		  if(isSelBestSeq && pass2)
		    break;
		  
		  /*store the start address of SEL...COMB sequence*/
		  pc = pc + 1;
		  best_comb.start_pc = pc;
		  
		  /*read in the entire sequence of optimizations and return
		    the number of distinct phases in the sequence*/
		  best_comb.max_comb = 0;
		  best_comb.no_comb = get_sequence(&best_comb,
						   commands, &pc);

		  /*initialize other elements in the structure*/
		  best_comb.flags = 0;
		  best_comb.valid_comb = 0;
		  best_comb.done_comb= 0; 
		  best_comb.popu_count = 0;
		  best_comb.gen_count = 0;
		  best_comb.best_measure = DINFINITY;
		  best_comb.best_smeasure = INFINITY;
		  best_comb.best_dmeasure = INFINITY;
		  best_comb.base_smeasure = 0;
		  best_comb.base_dmeasure = 0;
		  best_comb.term_dmeasure = best_comb.term_smeasure = 0;
		  best_comb.last_dmeasure = INFINITY;
		  best_comb.last_smeasure = INFINITY;
		  best_comb.stagnate = 0;
		  best_comb.trans_done = trans_done;
		  best_comb.viewing = viewing;
		  start_label = labnum;
		  cflist = NULL;
		  read_measure_flags();

		  /*determine the number of tranformations currently applied
		    to the function*/
		  best_comb.sequence_count = 0;
		  best_comb.sequence_count = get_num_changes(get_num_transforms());
		    
		  /*store messages in undo list and send no messages to viewer*/
		  viewing = FALSE;
		  /*if continuous measurements is enabled then suspend it*/
		  if(continuous_measures)
		    continuous_measures = SUSPEND;
		  isSelCombPhase = TRUE;
		  is_take_measure = TRUE;
		  srand(1);
		  seq_no = scount = fcount = rcount = 1;
		  mutation_count = 0;
		  tot_rand = 0;

		  /*open a log file to store results*/
		  sprintf(line, "%s%s.log", pathname, basename);
		  if(resume_mode = resume_execution()){
		    if((comb_log = fopen(line, "r+"))){
		      setbuf(comb_log, combbuf);
		      if(resume_mode = find_curr_fn(fn, &best_comb))
			comb_log_status = 1;
		    }
		    else
		      resume_mode = FALSE;
		  }
		  if(!resume_mode){
		    if(comb_log_status){
		      if(!(comb_log = fopen(line, "a")))
			comb_log = stderr;
		      else
			setbuf(comb_log, combbuf);
		    }
		    else{
		      if(!(comb_log = fopen(line, "w")))
			comb_log = stderr;
		      else
			setbuf(comb_log, combbuf);
		      comb_log_status = 1;
		    }
		  }

		  /*read the options specified by the user for the
		    INTELLIGENT SEARCH*/
		  if(best_comb.search_option == INTELLIGENT_SEARCH ||
		     best_comb.search_option == LEAF_SEARCH)
		    best_comb.flags = get_search_flags(&best_comb, fn);

		  /*sort independent phases in a sequence, so that 2
		    sequences differing only in independent phases are detected
		    equivalent. Once this technique is verified to be safe,
		    we can arrange to this always, without the flag*/
		  best_comb.flags |= SORT_PHASES;
		  /*best_comb.flags |= SANITY;*/

		  /*make an initial pass over the function to determine which
		    optimizations are not possible*/
		  best_comb.opt_mask = 0;
		  if(best_comb.flags & USELESS_TRANSFORM){
		    best_comb.opt_mask = analyse_func(best_comb.sequence_count);
		    if(best_comb.opt_mask == 0)
		      best_comb.flags &= ~(USELESS_TRANSFORM);
		  }
		  else if(best_comb.flags & SANITY)
		    sanity_mask = analyse_func(best_comb.sequence_count);

		  /*store the iterative algorithm parameters to file*/
		  store_parameters(fn, &best_comb);
		  
		  /*get ready for the first pass*/
		  if(best_comb.search_option == LEAF_SEARCH){
		    isComb_pass = FALSE;
		    pc = pc + 1;
		  }
		  else
		    isComb_pass = TRUE;
		  
		  /*initialise next_seq with the offsets of transformations
		    in the list, SEL...SEQ is considered as 1 transformation*/ 
		  get_first_sequence(best_comb, next_seq, phase_indices,
				     curr_pos, &best_comb.popu_count,
				     &best_comb.gen_count);
		  

		  /*send messages to viewer about the initial measures and
		    number of combinations to be performed*/
		  if(resume_mode){
		    resume_mode = resume_perf_num(&best_comb.base_smeasure,
						  &best_comb.base_dmeasure);
		  }
		  if(!resume_mode)
		    get_perf_num(&best_comb, NULL, &best_comb.base_smeasure,
				 &best_comb.base_dmeasure);
		  sel_comb_initial_msg(best_comb.max_comb, best_comb.weight,
				       best_comb.strlength,
				       best_comb.base_smeasure,
				       best_comb.base_dmeasure);

		  /*initialize the hashtables and related pointers and indexes*/
		  /* init_hashtables(&best_comb);*/

		  comb_htable_hits = 0;
		  c_time_sec = c_time_usec = 0;
		  gettimeofday(&ctime, NULL);
		  break;

	       case END_COMBINATION:
		 if(!isSelCombPhase || (isSelBestSeq && pass2))
		   /*end of SEL..COMB, continue with next optimizing phase*/
		   break;

		 /*this is the first pass when the optimization sequence is
		    determined*/ 
		 if(isComb_pass){

		   curr_ptree = START_NODE;
		   /*get the next sequence to evaluate, depending on the
		     search algorithm to be used*/
		   if(best_comb.search_option == EXHAUSTIVE_SEARCH)
		     get_next_ex_phase(&best_comb, next_seq, -1,
				       phase_indices, curr_pos, START_NODE);
		   else if(best_comb.search_option == INTELLIGENT_SEARCH)
		     seq_no = get_next_intel_seq(&best_comb, next_seq, phase_indices,
						 sort_phases, &comb_htable_hits);
		   else
		     get_next_comb_seq(&best_comb, next_seq, phase_indices);

		   if(seq_no > 0){
		     
		     /*if we are reading execution sequences from the log file,
		       then we need to find a mapping from phases to
		       succ/unsucc phases when FUNC_CHECKS flags in on*/
		     if(resume_mode && (best_comb.flags & (FUNC_CHECKS|TREE_SEARCH|ENABLE_PHASE))){
		       map_phases_succ(&best_comb, next_seq, succ_map, att_seq);
		       map_count = 0;
		     }
		     
		     /*put the valid combination in the command array*/
		     if(best_comb.done_comb < best_comb.max_comb){
		       pc = best_comb.start_pc;
		       if(!(best_comb.search_option == EXHAUSTIVE_SEARCH))
			 init_command_array(best_comb.length,
					    best_comb.strlength,
					    pc, commands,
					    best_comb.base_opt, next_seq);
		     }
		     pc--;
		     isComb_pass = FALSE;
		     trans_done = best_comb.trans_done;
		     /*before applying this sequence, set the count of number
		       of successfully applied phases in this seq. to zero, and
		       reset the start of new label numbers*/
		     succ_num = 0;
		     labnum = start_label;
		     valid_analysis = 0;
		   }
		 }
		 
		 /*this is the second pass, the optimization sequence has
		   been applied. Take measurements, if this is the best
		   sequence till now then store it*/
		 else{
		   /*check if the user has interruted the process*/
		   if(is_interrupt()){
		     int total_changes;
		     total_changes = get_num_changes(get_num_transforms());
		     undo_changes(total_changes - best_comb.sequence_count);
		     clear_all_links(top);
		     set_function_name(fn);
		     fprintf(stderr, "User interrupted the process\n");
		     best_comb.done_comb = best_comb.max_comb;
		     write_to_socket("ACK");
		   }
		   /* get the number of instructions in each block*/
		   else if(best_comb.done_comb < best_comb.max_comb){

		     if(best_comb.flags & SANITY)
		       sanity_analysis(best_comb, succ_phases, succ_num, sanity_mask);

		     /*print the active sequence*/
		     log_active_seq(seq_no, &succ_num, succ_phases);
		     
		     total_ins = 0;
		     /*we only check for repetitions of succ. seq and same
		       function if we need to get execution measures*/
		     if(is_take_measure && best_comb.weight>0){

		       if(best_comb.flags & SUCC_HTABLE){
			 
			 /*sort the sequence of successful phases*/
			 sort_ind_phases(succ_num, best_comb.flags, best_comb.base_opt,
					 succ_phases, sort_succ_phases, seq_no, FALSE);
		       
			 /*check if the sequence of successful phases matches
			   some sequence in the hash table*/
			 total_ins = in_succ_hashtable(sort_succ_phases, succ_num,
						       &s_measure, &d_measure);
		       }
		       else if(0 && !(best_comb.flags & HASHTABLE_SEARCH)){
			 /*Search the tree if measures for
			   this sequence are alreay available, then we do not
			   need to execute again*/
			 if(tree[curr_ptree].s_measure>0){
			   s_measure = tree[curr_ptree].s_measure;
			   d_measure = tree[curr_ptree].d_measure;
			   total_ins = TRUE;
			 }
		       }
		       
		       if(!total_ins){

			 /*Since we check for function matches after each
			   phase, we do not need to check functions again*/
			 if(best_comb.flags & FUNC_CHECKS){
			   fptr = tree[curr_ptree].func_node;
			   if( fptr->s_measure > 0 ){
			     s_measure = fptr->s_measure;
			     d_measure = fptr->d_measure;
			     log_function_match_line(fcount, FALSE);
			     total_ins = TRUE;
			     fcount++;
			   }
			   /*if function instances are not same, check if
			     remapped instances match*/
			   else{
			     remap_fptr = NULL;
			     total_ins = is_same_func(&valid_analysis, &s_measure, &d_measure,
						      &fptr, &remap_fptr, sort_succ_phases, succ_num,
						      FALSE, TRUE);
			     if(total_ins == 2){
			       log_function_match_line(rcount, TRUE);
			       rcount++;
			     }
			   }
			 }
			 else if(best_comb.flags & SUCC_HTABLE){
			   /*check if the current function instance is the same as
			     some previous instance*/
			   remap_fptr = fptr = NULL;
			   total_ins = is_same_func(&valid_analysis, &s_measure, &d_measure,
						    &fptr, &remap_fptr, sort_succ_phases, succ_num,
						    TRUE, TRUE);
			   if(total_ins == 1){
			     log_function_match_line(fcount, FALSE);
			     fcount++;
			   }
			   else if(total_ins == 2){
			     log_function_match_line(rcount, TRUE);
			     rcount++;
			   }
			   
			   /*update the hashtable of successfully applied phases*/
			   if(total_ins)
			     update_succ_htable(&best_comb, sort_succ_phases, succ_num,
						s_measure, d_measure);
			 }
		       }
		       else{
			 log_succ_seq_line(scount);
			 scount++;
		       }
		     }
		     
		     if(!total_ins){
		     
		       /*if seq is not found in the hashtable, then send
			 execution updates after getting measures*/
		       if(resume_mode){
			 resume_perf_num(&s_measure, &d_measure);
		       }
		       else
			 total_ins = get_perf_num(&best_comb, next_seq,
						  &s_measure, &d_measure);
		       sel_comb_msg(&best_comb, next_seq, s_measure, d_measure);
		       /*total_ins = sel_comb_msg(&best_comb, next_seq,
			 &s_measure, &d_measure, 1);*/

		       if(is_take_measure && best_comb.weight>0){
			 
			 /*update the hashtable of successfully applied
			   phases*/
			 if(best_comb.flags & SUCC_HTABLE)
			   update_succ_htable(&best_comb, sort_succ_phases, succ_num,
					      s_measure, d_measure);

			 /*enter measures for the current function in hashtable
			   of previously encountered functions*/
			 if(fptr){
			   fptr->s_measure = s_measure;
			   fptr->d_measure = d_measure;
			 }
			 if(remap_fptr){
			   remap_fptr->s_measure = s_measure;
			   remap_fptr->d_measure = d_measure;
			 }
		       }
		     }
		     else{
		       if(!resume_mode){
			 int total_changes;
			 total_changes = get_num_changes(get_num_transforms());
			 undo_changes(total_changes - best_comb.sequence_count);
			 clear_all_links(top);
			 set_function_name(fn);
		       }
		       succ_htable_msg(&best_comb, next_seq, s_measure, d_measure);
		     }
		     
		     /*check if this is the best sequence so far
		       use a tie-break to determine the best sequence in
		       case this sequence gives the same result as the
		       best sequence*/
		     if(is_better_seq(&best_comb, s_measure, d_measure,
				      next_seq, &measure)){
		       get_time_diff(ctime, &time_sec, &time_usec);
		       best_comb.best_measure = measure;
		       best_comb.best_smeasure = s_measure;
		       if(best_comb.weight!=0 ||
			  (best_comb.weight==0&&d_measure!=0))
			 best_comb.best_dmeasure = d_measure;
		       for(i=0 ; i<best_comb.strlength ; i++)
			 best_comb.best_opt[i] = next_seq[i];
		       log_best_seq_msg(measure, time_sec, time_usec);
		     }
		     
		     /*save the measures for genetic search*/
		     if(best_comb.search_option == INTELLIGENT_SEARCH){
		       popu[best_comb.popu_count-1].s_measure = s_measure;
		       popu[best_comb.popu_count-1].d_measure = d_measure;
		       popu[best_comb.popu_count-1].succ_num = succ_num;
		       for(i=0 ; i<succ_num ; i++)
			 popu[best_comb.popu_count-1].succ_phases[i] = succ_phases[i];
		       if(best_comb.flags & HASHTABLE_SEARCH)
			 update_hashtable(&best_comb, sort_phases);
		     }
		     
		     /*update the leaf node of the tree with these
		       measures*/
		     if(best_comb.flags & (TREE_SEARCH|FUNC_CHECKS)){
		       tree[curr_ptree].s_measure = s_measure;
		       tree[curr_ptree].d_measure = d_measure;
		     }
		   }
		   
		   if(best_comb.search_option == LEAF_SEARCH)
		     isComb_pass = FALSE;
		   else
		     isComb_pass = TRUE;
		   best_comb.done_comb++;
		   /*flush the file buffers*/
		   fflush(comb_log);
		   fflush(stderr);
		   fflush(stdout);
		   
		   /*at the end of testing all combinations*/
		   if(best_comb.done_comb >= best_comb.max_comb){
		     
		     /*end SEL...COMB*/
		     end_sel_comb(&best_comb);
		     isSelCombPhase = FALSE;
		     
		     if(!resume_mode){
		       fprintf(comb_log, "Mutation Count: %lld\n", mutation_count);
		       get_time_diff(ctime, &time_sec, &time_usec);
		       fprintf(comb_log, "Total Time: %lldsec %lldusec\n",
			       time_sec, time_usec);
		       fprintf(comb_log, "Compilation Time: %lldsec %lldusec\n",
			       c_time_sec, c_time_usec);
		       fprintf(comb_log, "Number of Htable hits: %d\n",
			       comb_htable_hits);
		       fprintf(comb_log, "Succ seq: %d\n", scount-1);
		       fprintf(comb_log, "Same Function: %d\n", fcount-1);
		       fprintf(comb_log, "Remap func: %d\n", rcount-1);
		     }
		   }
		   /*else should get DONE again to generate next sequence*/ 
		   else if(best_comb.search_option != LEAF_SEARCH)
		     pc--;
		 }
		 valid_analysis = 0;
		 break;

	       /*done in 2 passes, in the first pass the best sequence is
		 determined and that is recorded in the data structure. On
		 receiving DONE, pass 2 is started and control goes back to
		 start of sequence. It then jumps to the start of the best
		 sequence and after executing that sequence we fall out*/
	       case SELECT_BEST_SEQUENCE:
		  /*if called from within SEL...COMB, do nothing*/
		  if(isSelCombPhase)
		    break;
		 
		  /*already determined the best sequence and now attempting
		    to excute that sequence*/
		  if(pass2){
		    /*sdepth++;*/
		    pc = best_seq[sdepth].best_pc;
		  }
		  /*initializations to determine the best path during pass1*/
		  else{
		    /*initialise the information structure*/
		    /*sdepth++;*/
		    /* do not send messages to viewer*/
		    best_seq[sdepth].viewing = viewing;
		    viewing = FALSE;
		    
		    if(sdepth > MAX_BEST_SEQUENCE){
		      fprintf(stderr, "depth of best sequence exceeded");
		      exit(1);
		    }
		    best_seq[sdepth].best_measure = INFINITY;
		    best_seq[sdepth].sequence_count = 0;
		    best_seq[sdepth].trans_done = trans_done;
		    best_seq[sdepth].curr_pc = pc;
		    best_seq[sdepth].best_pc = pc;
		    best_seq[sdepth].start_pc = pc;
		    for(i=pc ; commands[i].oper!=DONE_SELECT ; i++);
		    best_seq[sdepth].weight = commands[i+1].oper;
		    /*determine the number of tranformations currently applied
		      to the function*/
		    best_seq[sdepth].sequence_count =
		      get_num_changes(get_num_transforms);
		    
		    /*if continuous measurements is enabled then suspend it*/
		    if(continuous_measures)
		      continuous_measures = SUSPEND;
		    isSelBestSeq = TRUE;
		  }
		  break;

	       case NEXT_SEQUENCE:
		  /*in pass 2 skip over the remaining sequences and jump to
		    DONE*/
		  if(pass2){
		    pc = best_seq[sdepth].end_pc - 1;
		    break;
		  }
		  /*determine if the current sequence is the best and update
		    data structure*/
		  else{
#ifdef MEASURE		    
		    /*execute the function and get measurements*/
		    total_ins = sel_seq_measures(best_seq[sdepth].sequence_count,
						 best_seq[sdepth].weight);
		    valid_analysis = 0;
#endif
		    fprintf(stderr, "total_ins: %lld\n", total_ins);

		    /*determine the best sequence till now*/
		    if(total_ins < best_seq[sdepth].best_measure){
		      /*if this seq is the best seq*/
		      best_seq[sdepth].best_measure = total_ins;
		      best_seq[sdepth].best_pc = best_seq[sdepth].curr_pc;
		    }

		    /*set curr_pc to the next seq to be considered*/
		    best_seq[sdepth].curr_pc = pc;

		    /*re-initialize transformations done*/
		    trans_done = best_seq[sdepth].trans_done;
		  }
		  break;

	       case DONE_SELECT:
		  /*if called from within SEL...COMB, do nothing*/
		  if(isSelCombPhase)
		    break;

		  /*in pass 1 determine the best sequence and jump to the
		    best sequence*/
		  if(!pass2){
#ifdef MEASURE		    
		    /*execute the function and get measurements*/
		    total_ins = sel_seq_measures(best_seq[sdepth].sequence_count,
						 best_seq[sdepth].weight);
		    valid_analysis = 0;
#endif
		    fprintf(stderr, "total_ins: %lld\n", total_ins);
		    
		    /*determine the best sequence till now*/
		    if(total_ins < best_seq[sdepth].best_measure){
		      /*if this seq is the best seq*/
		      best_seq[sdepth].best_measure = total_ins;
		      best_seq[sdepth].best_pc = best_seq[sdepth].curr_pc;
		    }
		    best_seq[sdepth].end_pc = pc;

		    /*reset trans done*/
		    trans_done = best_seq[sdepth].trans_done;

		    /*start sending messages and jump to start of sequence to
		      start pass 2 if we are in outermost level*/
		    viewing = best_seq[sdepth].viewing;
		    pass2 = TRUE;
		    pc = best_seq[sdepth].start_pc - 1;
		    /*sdepth--;*/

		    /*reinitialize measurements*/
		    if(continuous_measures == SUSPEND){
		      continuous_measures = TRUE;
		    }
		  }
		  /*during pass 2*/
		  else if(pass2){
		    if(sdepth == 0 || !viewing)
		      pass2 = FALSE;
		    if(sdepth == 0)
		      isSelBestSeq = FALSE;
		    /*sdepth--;*/

		    /*increment by 1 to offset for the weight parameter*/
		    pc++;
		  }
		  break;
		  
               /* compare two files to see if they are equal */
	       case CMP_FILES_TRANS:
                  {
                     char msg[MAXSTRING];

                     sprintf(line, "cmp -s %s %s", commands[pc].filename1,
                             commands[pc].filename2);
                     if (system(line)) {
                        strcpy(msg, "The files differ.\n");
                        fprintf(stderr, "%s", msg);
   		        write_to_socket(msg);
                     }
                     else {
                        strcpy(msg, "The files are the same.\n");
                        fprintf(stderr, "%s", msg);
   		        write_to_socket(msg);
                     }
                  }
	          break;

               /* retrieve information about loops */
	       case LOOPS_QUERY:

                  /*perform the dominator analysis first*/
		  depth_first_search(d_f_s_count++);
		  build_dominator_tree(b_d_t_count++);
		  find_dominance_frontiers(f_d_f_count++);
		  
		  /*perform the loops analysis*/
		  clear_loops();
		  (void) find_loops(1);
		  order_loops();
		  find_loop_exits();

                  /* update the analysis that is valid */
		  valid_analysis |= LOOP_ANALYSIS | DOMINATOR_ANALYSIS;

		  /*write the loops out to the user interface */
		  write_loops();
		  break;

               /* retrieve information about what registers are live */
	       case LIVE_REGS_QUERY:
		  {
		     vector regs;
		     struct bblock *cblk;
                     struct list *rtlptr;
                     char regs_string[MAXSTRING];

                     /* This query should not be made unless register
                        assignment has been done. */
                     if (!(trans_done & (1 << REG_ASSIGNMENT_TRANS))) {
                        send_error("interactive_optimize: needs register assignment to be done first.");
                        break;
                     }

                     /* perform the live variable analysis analysis first */
                     if (!(valid_analysis & LIVE_VAR_ANALYSIS)) {
                        live_variable_analysis(l_v_a_count++, FALSE,
                                               fill_delay_done);
                        valid_analysis |= LIVE_VAR_ANALYSIS;
                     }

                     /* get the live register information */
                     if (!(cblk = find_block_id(commands[pc].block_id))) {
                        send_error("interactive_optimize: block_id not found");
                        break;
                     }
                     if (!(rtlptr = find_rtl_id(commands[pc].rtl_id,
                                                commands[pc].block_id))) {
                        send_error("interactive_optimize: rtl_id not found");
                        break;
                     }
                     regs = live_regs(cblk,rtlptr);
                     vec2string(regs_string, regs);

                     /* write the live register information to the user
                        interface */
		     write_record_id(BEGIN_LIVEREG);   
		     write_to_socket(regs_string);
                     /*
		     write_record_id(END_LIVEREG);   
                     */
		     fprintf(stderr, "the registers are: %s\n", regs_string);
		  }
		  break;

	       case BLOCK_QUERY:
		  {
                     char msg[MAXSTRING];
                     int bnum;
                     extern int dveclen;

                     if (!(analysis & DOMINATOR_ANALYSIS)) {
                       /*
   	                depth_first_search(d_f_s_count++);
                        build_dominator_tree(b_d_t_count++);
                        find_dominance_frontiers(f_d_f_count++);
                       */
                        bnum = 1;
                        for (cblk = top; cblk; cblk = cblk->down)
                           cblk->bnum = (unsigned short) bnum++;
                        dveclen = bnum >> intscale;
                        if (bnum & bitsperint)
                           dveclen++;
                        find_dominators();
                        valid_analysis &= ~DOMINATOR_ANALYSIS;
                     }
                     if (!(valid_analysis & LIVE_VAR_ANALYSIS)) {
                        live_variable_analysis(l_v_a_count++, FALSE,
                                               fill_delay_done);
                        valid_analysis |= LIVE_VAR_ANALYSIS;
                     }

                     /* get the live register information */
                     if (!(cblk = find_block_id(commands[pc].block_id))) {
                        send_error("interactive_optimize: block_id not found");
                        break;
                     }
		     write_record_id(BLOCK_INFO);   
                     rshowmsg(cblk->ulist, msg);
		     write_to_socket(msg);
                     rshowmsg(cblk->olist, msg);
		     write_to_socket(msg);
                     dshowmsg(cblk->dom, msg);
		     write_to_socket(msg);
                  }
                  break;

	       case IND_SEQ_INIT:
		 is_exec = ind_seq_init();
		 best_s_measure = best_d_measure = 0;
		 break;

	       case IND_SEQ_MEASURE:
		 ind_seq_measure(&s_measure, &d_measure, is_exec);
		 if(!best_s_measure || s_measure < best_s_measure)
		   best_s_measure = s_measure;
		 if(!best_d_measure || d_measure < best_d_measure)
		   best_d_measure = d_measure;
		 fflush(stdout);
		 fflush(stderr);
		 break;

	       case EX_DFS_INIT:
		 /*initialize the structures for DFS search*/
		 ex_dfs_init(pc, &valid_analysis);
		 is_ex_search = TRUE;
		 profile_cnt = 0;
		 break;

	       case EX_DFS_REINIT:
		 ex_dfs_reinit(pc);
		 break;

	       case EX_DFS:
		 log_dfs_func(prev_opt_active, &valid_analysis, &pc);
		 if((profile_cnt & 127) == 127){
		   fprintf(stderr, "Sequences attempted: %d\n", profile_cnt);
		   fflush(stderr);
		   fflush(stdout);
		 }
		 profile_cnt++;
		 break;

	       case EX_DFS_END:
		 end_profile_func();
		 break;
		  
	       case PROFILE_FUNC:
		 if(profile_level == -1){
		   init_profile_func(commands[pc].offset);
		   profile_level = commands[pc].offset;
		   if(profile_level > 100)
		     profile_level = profile_level - 100;
		   profile_cnt = 0;
		 }
		 else
		   end_profile_func();
		 break;

	       case PROFILE_FUNC_SAVE:
		 store_profile_func();
		 is_pro_base = FALSE;
		 break;

	       case PROFILE_FUNC_LOG:
		 log_profile_func(profile_level, prev_opt_active,
				  &valid_analysis, TRUE);
		 if((profile_cnt & 127) == 127)
		   fprintf(stderr, "Sequences attempted: %d\n", profile_cnt);
		 fflush(stderr);
		 fflush(stdout);
		 profile_cnt++;
		 break;

	        case PROBABILISTIC_BATCH:
		  if(TRUE || execute_status & (1<<IS_FUNC_EXEC))
		    get_next_prob_phase(&pc, prev_opt_active, commands[pc].offset);
		  break;

	       case IGNORE_COMMAND:
		  break;
	       default:
                  fprintf(stderr,
                          "interactive_optimize (vpo) - unknown operator %d\n",
                          curr_oper);
                  exit(1);
            }

            /* update what analysis is no longer valid and
               the transformations that have been done */
            if (curr_oper > 0) {

	      if((old_batch || prob_batch) && (change||real_change)){
		num_active_opt++;
		fprintf(stdout, "%d ", curr_oper);
	      }
	      if(old_batch && active_batch)
		update_batch_prob(curr_oper, (change||real_change));
	      num_att_opt++;
      
	      /*'real_change' does not mark dead list changes. Since that
		also affects the analysis results, we check that as well*/
	      if(real_change || dead_list_change || swq_noviewer)
		valid_analysis &= ~invalidates_analysis[curr_oper];
	      if(locals_change)
		valid_analysis &= ~(LIVE_VAR_ANALYSIS);
	      
	      /*post-analysis phase: Some newer analysis routines we have
		added change the code. So these should be done immediately
		after the phase which invalidates them*/
	      /*if(invalidates_analysis[curr_oper] & DEAD_CODE_ANALYSIS){
		valid_analysis |= do_needed_analysis(DEAD_CODE_ANALYSIS);
		}*/
	      if((analysis=invalidates_analysis[curr_oper]&
		  (RECALC_PREDS|MERGE_BLOCKS_ANALYSIS|
		   ELIM_EMPTY_BLOCKS_ANALYSIS))){
		valid_analysis |= do_needed_analysis(analysis);
	      }

	      /* always perform dead_variable_elimination for cleanup*/
	      /*********************************************************/
	      /*if((change||real_change) && (curr_oper==16||curr_oper==21||
					   curr_oper==25||curr_oper==29)){
		analysis = needs_analysis[DEAD_ASG_ELIM_TRANS];
		valid_analysis |= do_needed_analysis(analysis);
		remv_dead_variables(r_d_v_count++, TRUE, TRUE);
		valid_analysis &= ~invalidates_analysis[DEAD_ASG_ELIM_TRANS];
		}*/
	      /************************************************************/
	      
	      /* not sure if this statement should be within the following
		 'if', or before it*/
	      trans_done |= (1 << curr_oper);
	      if(change || real_change){
		num_trans_done[curr_oper]++;
	      
		if(curr_oper == ALL_LOOP_TRANS){
		  trans_done |= (1 << CODE_MOTION_TRANS);
		  num_trans_done[CODE_MOTION_TRANS]++;
		  
		  trans_done |= (1 << RECURRENCE_ELIM_TRANS);
		  num_trans_done[RECURRENCE_ELIM_TRANS]++;
		  
		  trans_done |= (1 << LOOP_STRENGTH_REDUCT_TRANS);
		  num_trans_done[LOOP_STRENGTH_REDUCT_TRANS]++;
		  
		  trans_done |= (1 << INDUCT_VAR_ELIM_TRANS);
		  num_trans_done[INDUCT_VAR_ELIM_TRANS]++;
		}	       
	      }
	      prev_opt_active = real_change;
	    }

#ifdef WRITE_CEX	    
	    /*only during profiling*/
	    if(is_pro_base){
	      store_as_cex(list_cex_files[pro_opt_level], 0, FALSE);
	      pro_cex_opt[pro_opt_level] = curr_oper;
	      pro_opt_level++;
	    }
#endif	      

	    /*combine the phases which are 1 phase but appear as 2 due to
	      initial analysis carried out on them*/
	    combine_phases();
	    
	    /* update variable if there is some change in a transformation*/
	    /* It is assumed that a change is made when any messages are sent
	       to the viewer */ 
	    for(i=loop_index ; i>=0 ; i--)
	      goto_change[i] |= change;
	    changes_last = change;
	    
	    /* advance to the next command */
	    if(commands[pc].oper > 0 || commands[pc].oper == HAND_TRANS)
	      {
#ifdef MEASURE
		struct freq_counts *freq = NULL;
		/*check if continuous execution measures are requested*/
		if((continuous_measures==TRUE && is_change &&
		    commands[pc].oper!=HAND_TRANS)  ||
		   (continuous_measures==TRUE && hand_measure))
		  {
		    /*execute the program and get measurements*/
		    get_measure(&freq, -1);
		    read_perf_num(&s_measure, &d_measure);
		    
		    /*store the measures with endtrans in the transform
		      list*/
		    if(viewing && !session_over)
		      send_measures(freq, s_measure, d_measure);

		    /*one measurement takem after hand transforms*/
		    hand_measure = FALSE;
		    
		    /*invalidate any previous analysis that had been done*/
		    valid_analysis = 0;
		  }
		if(is_change)
		  add_measures_transform_list(transform_tail, freq);

#endif /*MEASURE*/	     
	      }

	    /******** debugging - remove later ********/
	    /*if(curr_oper > 0 && (change||real_change)){
	      int RA_trans_done;
	      store_as_cex(list_cex_files[0], 0, FALSE);
	      RA_trans_done = trans_done;
	      undo_from_list(1);
	      trans_done = RA_trans_done;
	      }*/
		
	    /* advance to the next command*/
	    pc = pc + 1;

	    if(isSelCombPhase){
	      
	      /*During the SEL...COMB phase record each successful phase in the
		sequence*/
	      if(curr_oper>0 && real_change>0)
		succ_phases[succ_num++] = curr_oper;
	    
	      /*During SEL...COMB phase, maintain the pointers in the tree
		after each optimization*/
	      if(best_comb.flags & (TREE_SEARCH|ENABLE_PHASE|FUNC_CHECKS) && curr_oper>0)
		curr_ptree = update_tree(&best_comb, curr_oper, curr_ptree, real_change,
					 succ_num, sort_succ_phases);
	      else if(resume_mode && best_comb.flags &(TREE_SEARCH|ENABLE_PHASE|FUNC_CHECKS)
		      && att_seq[map_count]){
		curr_ptree = update_tree(&best_comb, att_seq[map_count], curr_ptree,
					 succ_map[map_count], succ_num, sort_succ_phases);
	      }
	      map_count++;


	      /*During exhaustive search in SEL...COMB, get the next phase to
		evaluate*/
	      if(best_comb.search_option == EXHAUSTIVE_SEARCH)
		commands[pc].oper = get_next_ex_phase(&best_comb, next_seq,
		   pc-best_comb.start_pc, phase_indices, curr_pos, curr_ptree);
	      else if(best_comb.search_option == LEAF_SEARCH){
		get_next_leaf_phase(&best_comb, &pc, change|real_change);
		if(curr_oper < 0){
		  trans_done = best_comb.trans_done;
		  succ_num = 0;
		  labnum = start_label;
		  valid_analysis = 0;
		}
	      }
	    }
	    
	    /* write the ENDPHASE identifier to the viewer. Currently the
	       analysis phases are showing up in the viewer as separate phases
	       which is causing clutter, also they have no measurement
	       information. This will enable the viewer to identify proper
	       phases */
	    /*if(curr_oper > 0 && viewing)
	      write_char(ENDPROPERPHASE);*/
	 }
	 
         /* clean up scope information */
         if (limited_scope) {
            for (i = 0; i < commands[tot_commands].numscope; i++) {
               struct bblock *cblk;

               cblk = find_block_id(commands[tot_commands].blocks[i]);
               if (cblk)
                  cblk->inscope = FALSE;
            }
            limited_scope = FALSE;
	 }

	 /* before reading another setof commands, should send a ENDSEQ
	    message to the user interface */
	 if(viewing && !(commands[pc-1].oper==START_MEASUREMENT ||
	      commands[pc-1].oper==FREQUENCY_REQ ||
	      commands[pc-1].oper==STOP_MEASUREMENT ||
	      commands[pc-1].oper==CHANGE_TEST_CONFIG))
	   write_char(ENDSEQ);

         /* read another set of commands to perform */
	 tot_commands = pc;
	 getcmds_from_socket(commands);
       }

      /* check if the user has terminated the interactive session */
      if (commands[pc].oper == STOP_TRANS) {
         session_over = TRUE;
         viewing = FALSE;
      }
   }

   /*get code size measure*/
   if(fn){
     gettimeofday(&end_time, NULL);
     diff_time = (end_time.tv_sec-start_time.tv_sec)*1000000 +
       (end_time.tv_usec-start_time.tv_usec);
     c_time_sec = diff_time / 1000000;
     c_time_usec = diff_time % 1000000;
     /*fprintf(stdout, "Compilation Time: %lldsec %lldusec\n",
       c_time_sec, c_time_usec);*/
     /*fprintf(stdout, "\nTotal RTLs in %s: %d\n", fn, count_RTL());
     /*fprintf(stdout, "Function: %s Best codesize: %lld best dy_count: %lld\n",
     fn, best_s_measure, best_d_measure);*/
   }
   
   /*call procedural abstraction*/
   /*procedural_abs();*/
   
   if(fn){
     /*get batch execution results*/
     if(old_batch || prob_batch){
       cflist = NULL;
       /*get_batch_exec_counts(NULL, NULL);*/
       old_batch = FALSE;
       fprintf(stdout, "\n");
       fprintf(stdout, "Final RTLs in %s: %d\n", fn, count_RTL());
       fprintf(stdout, "Phases Attempted: %d Active: %d Time: %lldsec %lldusec\n",
	       num_att_opt, num_active_opt, c_time_sec, c_time_usec);
       fflush(stdout);
       fflush(stderr);
       if(prob_batch)
	 dispose_prob();
     }

     /*dump all program paths*/
     /*dump_paths();*/
   }
   
   /* else make sure that the required transformations have been performed */
   measure_flag = TRUE;
   /*perform both register assignment and fix entry exit if not performed
     before*/
   apply_epilogue_trans(&valid_analysis);
   /*do_reqd_optimization(TRUE, TRUE, &valid_analysis);*/
   measure_flag = FALSE;

   /*dump out the RTLs to output file*/
   if(show_RTL && !measure_phase)
     {
       dump_rtl_asm(0, rtlfile, 0);

       /*dump out the assembly code to another file*/
       if(show_ASM){
	 dump_rtl_asm(1, asmfile, 0);
	 /*reset information array pointer field*/
	 reset_info_length();
       }
     }

   /*dump out the transformations*/
   dump_trans(initial_count);

#if FUNC_INFO
      /*get additional information about the function*/
      get_func_info(TRUE);
#endif /*FUNC_INFO*/

#ifdef MEASURE
   /*
      Collect instruction information for static and dynamic measurements
   */
   if ((execute_status & EASE) && top && fn) {

     swef = TRUE;
     measure_flag = TRUE;
     
      /*
       * Before calculating the equivalence classes to instrument the function,
       * we remove the basic blocks in the function to reduce the size of the
       * data structures that are needed to maintain the information about the
       * basic blocks in the function, and determine the impact of calling the
       * "exit()" function on the control flow graph of the function.
       */
      (void) remv_useless_basic_blocks(r_u_b_count++);
      reveal_exit_points(1);

      /*perform loop analysis on the function
       */
      depth_first_search(d_f_s_count++);
      build_dominator_tree(b_d_t_count++);
      find_dominance_frontiers(f_d_f_count++);
      clear_loops();
      (void) find_loops(1);
      
      /*
       * In order to be able to determine which registers are live at any given
       * point in the function in order to ensure that the instrumented code
       * does not affect any of the registers used, determine the live variable
       * information for the function.
       */
#ifdef FILL
      live_variable_analysis(l_v_a_count++, FALSE, swf);
#else
      live_variable_analysis(l_v_a_count++, FALSE, FALSE);
#endif

      /*
       * Also determine which registers are used in the function
       */
      registers_used();

      /*
       * Number each RTL in the function so that we can tell the RTLs that
       * are part of the original function from those that are added in
       * order to instrument the code.
       */
      number_rtls();

      if (swef)
         measure_freq();
      else if (swei || swed)
         measure_cache();
      else if (swep)
         measure_time();

      measure_flag = FALSE;
   }
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_optimize", 1))
      dump_function_i("after optimize()", 1,
                      SHOW_LABELS | SHOW_STATUS | SHOW_UP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   /*
    * Dump out the optimized procedure to the output file
    */
   if (!show_RTL)
      dump_function(SHOW_NORMAL);

   /*dump out the instrumented code to the output file */
   dump_rtl_asm(1, instfp, 0);
   fflush(instfp);

   /*
    * Reset the id counters.
    */
   block_id = rtl_id = 0;
#ifdef MEASURE

   /*
    * Emit any additional declarations needed to perform measurements on this
    * function.
    */
   if (fn && (execute_status & EASE)) {
      if (swef)
         freq_info(instfp);
      else if (swei && swed)
         unified_info(instfp);
      else if (swei)
         inst_info(instfp);
   }
#if 0
   /* don't we want to instrument all funcs? */
   swef = FALSE;
#endif
#endif

   if(fn){
     {
       int ins, blk;
       FILE *fp;
       struct bblock *cblk;
       struct list *rtl;
       extern struct bblock *top;

       ins = blk = 0;
       if((fp = fopen("filesize", "a")) != NULL){

	 for(cblk=top ; cblk ; cblk=cblk->down){
	   blk++;
	   ins += getRTLCount(cblk);
	 }

	 fprintf(fp, "Function: %30s, Blocks: %d, RTLs: %d\n", fn, blk, ins);
       }
     }
   }
   
   /* goto the next function, increment function number */
   if (!measure_phase)
      function_number++;
}
#endif  /* very long INTERACT */



/*
 * optimize - optimize the current function
 */
void optimize()
{
   register int i;
   struct list *ptr;
   int   change, newallocations;
   int   main_loop_count = 0;
   extern int block_id;
#ifdef INTERACT
   int   pc;
   struct bblock *cblk;
   extern int *info_ptr;
   extern int func_instinfo[];
#endif

#ifdef INTERACT
   info_ptr = func_instinfo;
   if (save_trans) {
      /* perform some initialization */
      fill_delay_done = 0;
      for (cblk = top; cblk; cblk = cblk->down)
         cblk->inscope = FALSE;
   }
#endif


   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_before_optimize", 1))
      dump_function_i("before optimize()", 1,
                      SHOW_LABELS | SHOW_STATUS | SHOW_UP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   /*
    * Set up invocation counters for some of the more prolific optimization
    * phases.
    */

#ifdef PARTITIONING
   if (swpu && swpv && swpw)
      promote_variables_from_this_function();
#endif
#ifdef EARLY_FRAME_SETUP
   early_frame_setup();
#endif

   r_b_c_count = 1;
   r_u_b_count = 1;
   r_u_j_count = 1;
   r_u_c_b_count = 1;
   r_u_c_count = 1;
   r_j_count = 1;
   m_j_count = 1;
   m_b_b_count = 1;
   i_s_count = 1;
   d_f_s_count = 1;
   f_d_f_count = 1;
   l_v_a_count = 1;
   b_d_t_count = 1;
   g_a_count = 1;
   m_c_s_count = 1;
   c_s_e_count = 1;
   r_d_v_count = 1;
   c_m_count = 1;
   s_s_r_count = 1;

#ifdef VET
#ifdef INTERACT
   if (swq) {
#endif
      if (fn) {
         moreopts = TRUE;
         prep_for_funcstart();
      }

      /*
       * Deads are not bit vectors before vectorize_deads are
       * called later in optimize.
       */
      DeadsareBitVectors = FALSE;

#ifdef INTERACT
      /*
       * Allocate vector positions for pseudo registers, and then go back and
       * fix the dead list on each RTL to use a register vector.  While we are
       * at it, we create a register vector named "pseudos" which contains all
       * pseudo registers (and only pseudo registers).
       *  Note that we do this after having
       * removed unreachable basic blocks (if the user requested control flow
       * optimizations), so that we do not allocate bit positions for pseudo
       * registers that were used only in those blocks.  We must do this before
       * we attempt to perform any data flow analysis or instruction selection
       * phases.
       */
      if (save_trans) {
         i = regallocptr;
         allocate_reg_bit_positions();
         rveclen = regallocptr >> intscale;
         if (regallocptr & bitsperint)
            rveclen++;
         for (pseudos = rinit(); i < regallocptr;
              rins((unsigned int) i++, &pseudos)) ;
         vectorize_deads(1);
      }
#endif

      /*
       * If viewer is started and user wants to view RTLs
       * for this function, then send the initial RTL set
       * to the visual debugger VET.
       */
      if (viewing && send_messages) {
         send_init_set(fn);
      }

      /* check if maximum number of transactions is to be set */
      if (fn && (swtd || swtm)) {
         if (swtd)
            maxtrans = -1;
         else {
            maxtrans = maxtransforfunc(fn);
            if (maxtrans == 0)
               moreopts = FALSE;
         }
      }
#ifdef INTERACT
   }               /* end if (swq) */
#endif
#endif


   /*
    * Perform the following optimization phases only if the user has
    * specified that control flow optimizations should be performed.
    */
   if (swl) {
#ifndef INTERACT
      change = TRUE;
      while (change) {
         change = FALSE;
#endif

         /*
          * Locate and remove branch chains.  These are jumps that transfer
          * control directly to another jump.  At this time, we do not care if
          * the phase made any changes to the control flow graph.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif

            change |= remv_branch_chains(r_b_c_count++);

         /*
          * Remove any useless basic blocks from the function.  These are empty
          * basic blocks that do not provide any useful control flow function.
          * Ignore the change status at this time.
          */

#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= remv_useless_basic_blocks(r_u_b_count++);

         /*
          * Locate and remove useless jumps.  These are jumps that transfer
          * control to the basic block that follows them.  We do not care if
          * the phase makes any changes to the control flow graph.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= remv_useless_jumps(r_u_j_count++);

         /*
          * Mark basic blocks that are used and dispose of those that are not.
          * Since these basic blocks could never be executed, removing them
          * reduces the size of the function and does not affect the semantics
          * of the code.  At this point, we do not care if the phase makes any
          * changes to the control flow graph.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= remv_unreachable_code(r_u_c_count++);

         /*
          * Eliminate jump sequences that consist of a conditional branch
          * followed by an unconditional jump and then the target of the
          * conditional branch by reversing the condition, changing the target
          * of the conditional branch to match that of the jump and removing
          * the jump.  This sequence has the same semantics, but removes the
          * need for the jump.  Note that
          * we are not concerned with whether or not the control flow of the
          * function is altered by this phase.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= reverse_jumps(r_j_count++);

         /*
          * Perform simple jump minimization by moving the location of some
          * basic blocks. We do not need to know if the phase makes any changes
          * in the function at this point.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= minimize_jumps(m_j_count++);

         /*
          * Merge basic blocks where possible.  This will not only reduce the
          * amount of memory that we will need to optimize this function, it
          * will also make it possible to make some of the combiner links that
          * would have been global local.
          */
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
            change |= merge_basic_blocks(m_b_b_count++);
#ifndef INTERACT
      }
#endif
   }

   /*
    * Allocate vector positions for pseudo registers, and then go back and fix
    * the dead list on each RTL to use a register vector.  While we are at it,
    * we create a register vector named "pseudos" which contains all pseudo
    * registers (and only pseudo registers).  Note that we do this after having
    * removed unreachable basic blocks (if the user requested control flow
    * optimizations), so that we do not allocate bit positions for pseudo
    * registers that were used only in those blocks.  We must do this before we
    * attempt to perform any data flow analysis or instruction selection
    * phases.
    */
   i = regallocptr;
   allocate_reg_bit_positions();
   rveclen = regallocptr >> intscale;
   if (regallocptr & bitsperint)
      rveclen++;
   for (pseudos = rinit(); i < regallocptr;
        rins((unsigned int) i++, &pseudos)) ;
   vectorize_deads(1);

   /*
    * Perform an initial instruction selection pass through the code to bring
    * it to a more compact, less naive state.  This should, depending on the
    * machine, reduce the number of RTLs we have to work with in half (more on
    * CISC machines).  To do this, we first set up local combiner links between
    * promising RTLs and then invoke the instruction selection phase.  Note
    * that we invoke the instruction selection phase even if the the local
    * combiner links phase reports that no links were introduced.  This is
    * because there are certain special cases where, depending on the target
    * machine, the instruction selection phase will consider some physically
    * adjacent instructions as possible candidates for merging, and we would
    * want to make sure that such cases have been considered at least once.
    */
#ifdef VET
   if (swtm)
      setjmp(my_env);
   if (moreopts)
#endif
      (void) set_local_links(1);


#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (moreopts || !swq)
#else
   if (moreopts)
#endif
#endif
   {
      if (!debug_opt("no_early_instruction_selection"))
         /* otherwise, run early IS */
#ifdef INTERACT
         while (instruction_selection(i_s_count++, 0)) ;
#else
         while (instruction_selection(i_s_count++)) ;
#endif
   }

   /*
    * fix-up control-flow/boolean expression from suif
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (swn && (moreopts || !swq))
#else
   if (swn && moreopts)
#endif
#else
   if (swn)
#endif
#ifdef FIX
      fix_control_flow(1);
#endif

   /*
    * If the user specified that evaluation order determination should be
    * performed, then do it at this time (when only local combiner links
    * exist).
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (swv && (moreopts || !swq))
#else
   if (swv && moreopts)
#endif
#else
   if (swv)
#endif
   {
      evaluation_order_determination(1);
   }
#ifdef VET
   if (moreopts)
#endif
      reset_local_links();


   /*
    * Perform a depth-first-search of the control-flow graph.  This
    * information, although not absolutely essential to the proper functioning
    * of the iterative data-flow algorithms, does reduce the number of
    * iterations they have to make significantly.
    */
   depth_first_search(d_f_s_count++);

   /*
    * If the global flag is set, then perform data-flow analysis and set up
    * global combiner links across basic blocks.  Since we currently don't
    * expect full side effect information to be available for each RTL, we
    * abstain from seting global links to hardware registers.
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (swg && (moreopts || !swq))
#else
   if (swg && moreopts)
#endif
#else
   if (swg)
#endif
   {

      /*
       * Determine the dominance frontier for each basic block in the function
       * so that we can build the static single assignment form.
       */

      build_dominator_tree(b_d_t_count++);
      find_dominance_frontiers(f_d_f_count++);

      /*
       * Perform live variable analysis, wich is also required to properly
       * generate the static single assignment form and to set global combiner
       * links.
       */
      live_variable_analysis(l_v_a_count++, FALSE, FALSE);

      /*
       * Now that we have calculated the dominance frontiers and the live
       * variable information, we can build the static single assignment form
       * of the function, which is required to set combiner links across basic
       * blocks.
       */
      build_minimal_ssa_form(1);

      /*
       * Set up any safe combiner links across basic blocks and, if any new
       * combiner links are created, invoke the instruction selection phase so
       * that it will attempt to combine the instructions containing these new
       * links.
       */

      if (set_global_links(1)) {
#ifdef VET
#ifdef INTERACT
         if (swtm && swq)
            setjmp(my_env);
         if (moreopts || !swq)
#else
         if (swtm)
            setjmp(my_env);
         if (moreopts)
#endif
#endif
#ifdef INTERACT
            while (instruction_selection(i_s_count++, 1))
#else
            while (instruction_selection(i_s_count++))
#endif
            {
               live_variable_analysis(l_v_a_count++, FALSE, FALSE);
               set_local_links(0);
               if (swg)
                  set_global_links(0);
            }

         live_variable_analysis(l_v_a_count++, FALSE, FALSE);

      }
   }


   /*
    * Update the live variable information for the function, since the local
    * register assigner requires this information in order to assign registers
    * correctly.
    */
   else {
#ifdef VET
      if (moreopts)
#endif
         set_local_links(0);
      /* lva needs to occur even if not moreopts */
      live_variable_analysis(l_v_a_count++, FALSE, FALSE);
   }

   /*
    * Perform local register assignment (that is, assign an appropriate
    * hardware register for every pseudo register).  After that is over, Note
    * that the local register allocator will indicate that the function has
    * been changed only if it is forced to add code to the function (to either
    * spill temporaries or fix up assignment conflicts between basic blocks).
    */

   change = local_register_assignment(1);

   /*
    * After local register allocation is performed, no pseudo registers remain
    * in the function, so we no longer have any use for a register vector that
    * contains all of the pseudo registers.
    */
   rfree(pseudos);

   /*
    * Perform another instruction selection pass if any of the previous phases
    * since the last pass made changes to the code.
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (change && (moreopts || !swq))
#else
   if (swtm)
      setjmp(my_env);
   if (change && moreopts)
#endif
#else
   if (change)
#endif
#ifdef INTERACT
      while (instruction_selection(i_s_count++, 0)) ;
#else
      while (instruction_selection(i_s_count++)) ;
#endif


   /*
    * Determine if the user has requested some form of global register
    * allocation.
    */
#ifdef VET
#ifdef INTERACT
   if ((swr || swo) && (moreopts || !swq))
#else
   if ((swr || swo) && moreopts)
#endif
#else
   if (swr || swo)
#endif
   {
      /*
       * Prior to locating the loops in the current function, we must obtain
       * the dominator tree for the function.
       */
      depth_first_search(d_f_s_count++);
      build_dominator_tree(b_d_t_count++);

      /*
       * Perform control flow analysis on the function to locate loops. Also,
       * perform loop-dependent control flow optimizations if the user has
       * requested that control flow optimizations be applied.
       */
      if (find_loops(1)) {
         if (swl) {
            (void) remv_forward_links(1);
            if (minimize_loop_jumps(1)) {
               (void) merge_basic_blocks(m_b_b_count++);
               clear_loops();
               depth_first_search(d_f_s_count++);
               build_dominator_tree(b_d_t_count++);
               (void) find_loops(2);
            }
         }

         /*
          * Order the loop information structures (from outer to inner loops)
          * and determine the exit blocks for each loop if we have to use such
          * information.
          */
         if (swm || (swr && hascs))
            order_loops();
         if (swm || (swr && hascs) || swo)
            find_loop_exits();
      }

#ifdef INTERACT
      /*
       * Attempt to determine an estimate to how often each basic block will be
       * executed.
       */
      (void) estimate_execution_frequency(1);
#endif
      /*
       * Determine the impact of calls on the use of registers that must be
       * saved and restored around function calls if we are using the simple
       * global register allocator.  Also, we allow for the possibility that
       * unreachable code elimination may have removed callersave points from
       * the function.
       */
      if (swr && hascs)
         hascs = count_caller_save();

      /*
       * Set the "onum" field of each RTL and count them so that the length of
       * RTL vectors, used in global register allocation to keep track of where
       * local references were found, can be determined.
       */
      number_rtls();
   }



   change = TRUE;
   do {

#ifdef STACHE
      /* Try to identify load/store pairs that are broken. */
#if PK
      (void) set_local_links(1);
      drive_stache_allocation_phase1();
      (void) set_local_links(1);
#endif      
#endif

      /*
       * If the user has requested one of the global register allocators, then
       * invoke them as long as changes can be made to the function.
       */
#ifdef VET
#ifdef INTERACT
      if ((swr || swo) && (moreopts || !swq))
#else
      if ((swr || swo) && moreopts)
#endif

#else
      if (swr || swo)
#endif
      {
         do {

            /*
             * Perform the requested method of global register allocation
             */
            newallocations = FALSE;
            if (swr) {
               csalloc = FALSE;
               (void) number_basic_blocks();
               newallocations =
                simple_global_allocation(g_a_count++, &csalloc);
            }
            else {

               /*
                * Perform live-variable analysis (including local references)
                * on the current function and remove dead variables before
                * performing coloring global register allocation.
                */

               int   change2 = TRUE;

               while (change2) {

                  change2 = FALSE;
                  set_local_links(0);
                  if (swg)
                     set_global_links(0);
                  live_variable_analysis(l_v_a_count++, TRUE, FALSE);
                  change2 |= remv_dead_variables(r_d_v_count++, TRUE, TRUE);
#ifdef INTERACT
                  change2 |= instruction_selection(i_s_count++, 0);
#else
                  change2 |= instruction_selection(i_s_count++);
#endif
                  newallocations |= change2;
               }

#ifdef VET
               if (swl && moreopts)
#else
               if (swl)
#endif
                  while (simplify_controlflow())
                     newallocations |= TRUE;

               if (color_global_allocation(g_a_count++)) {
                  newallocations = TRUE;
                  /* This is necessary here because c_g_a() may actually
                   * change the control flow.
                   */
                  clear_loops();
                  find_loops(1);
                  find_loop_exits();
               }
            }


            /*
             * If we have caller save registers and we have used the simple
             * global register allocator, then we should attempt to move save
             * and restore items out of loops.
             */
            if (newallocations && swr && csalloc)
               move_caller_save(m_c_s_count++);

            /*
             * If we have allocated any local items to registers, then there is
             * a good chance that we have created opportunities to select
             * better instructions.
             */
            if (newallocations) {
               change = TRUE;
#ifdef VET
               if (moreopts)
#endif
                  set_local_links(0);
#ifdef VET
               if (moreopts)
#endif
                  if (swg)
                     set_global_links(0);
#ifdef VET
               if (moreopts)
#endif
#ifdef INTERACT
                  newallocations = instruction_selection(i_s_count++, 0);
#else
                  newallocations = instruction_selection(i_s_count++);
#endif
               clrsets();
            }

            /* 
             * If phase iteration has been disabled, then exit this loop
             */
            if (swd && debug_opt("no_phase_iteration"))
               break;
#ifdef DISPOSE
            {
               if (nearly_exhausted_memory)
                  break;
            }
#endif

            /*
             * If we are using the simple global register allocator, the
             * changes that have been made to the function may have released
             * registers that were previously used, so we determine which
             * registers are still in use before we re-invoke the allocator.
             */
            if (newallocations && swr)
               registers_used();

         } while (newallocations);
      }
      else
         newallocations = FALSE;

#ifdef VET
      if (swl && moreopts)
#else
      if (swl)
#endif
         while (simplify_controlflow())
            newallocations |= TRUE;

      do {
         change = FALSE;

#ifdef VET
         if (!moreopts)
            break;
#endif
         /*
          * Perform common subexpression elimination and remove dead variables
          * at this time, if the user has requested it.
          */
#ifdef INTERACT
         while (instruction_selection(i_s_count++, 0)) ;
#else
         while (instruction_selection(i_s_count++)) ;
#endif
         if (swc) {
            change |= common_subexpression_elimination(c_s_e_count++);
            reset_local_links(0);
            live_variable_analysis(l_v_a_count++, swo, FALSE);
            change |= remv_dead_variables(r_d_v_count++, swo, TRUE);
         }

#ifdef VET
         if (moreopts)
#endif
            if (swm && swl)
               newallocations |= cross_jumping(cj_count++);

#ifdef VET
         if (moreopts)
#endif
            if (swl)
               while (simplify_controlflow())
                  newallocations |= TRUE;
         rebuild_dom_front(r_d_f_c++);
         /*
          * Perform code motion, loop strength reduction, recurrence
          * elimination and induction variable elimination if the user
          * requested them.
          */
         if (swm && (swr || swo)) {
            if (!swc)
               live_variable_analysis(l_v_a_count++, FALSE, FALSE);

            change |= code_motion(c_m_count++);
         }

         if (swl)
            change |= remv_useless_jumps(r_u_j_count++);

         if (swl)
            while (simplify_controlflow())
               newallocations |= TRUE;
         /*
          * Perform simple strength reduction if the user requested it
          */
         if (sws) {
            live_variable_analysis(l_v_a_count++, FALSE, FALSE);
            if (remv_dead_variables(r_d_v_count++, swo, TRUE))
               live_variable_analysis(l_v_a_count++, FALSE, FALSE);
            change |= simple_strength_reduction(s_s_r_count++);
         }

         /*
          * Perform another instruction selection pass in case changes have
          * been made to the function.
          */

#ifdef INTERACT
         while (instruction_selection(i_s_count++, 0))
#else
         while (instruction_selection(i_s_count++))
#endif
         {
            change |= TRUE;
         }
         if (change) {
            set_local_links(1);
            if (swg)
               set_global_links(1);
         }


         /*
          * If phase iteration has been disabled, then exit this loop
          */
         if (swd && debug_opt("no_phase_iteration"))
            break;

         newallocations |= change;
      }
#ifdef VET
      while (change && moreopts);       /* end of do-while loop */
#else
      while (change);   /* end of do-while loop */
#endif

      /*
       * If phase iteration has been disabled, then exit this loop
       */
      if (swd && debug_opt("no_phase_iteration"))
         break;

      /*
       * If we have made changes to the function and the simple register
       * allocator is to be used next, then determine which registers are still
       * used in the function.
       */
      if (newallocations && swr)
         registers_used();

      /* Let's minimize registers once before fixentry(). */
#ifdef VET
      if (moreopts)
#endif
         if (main_loop_count < 1) {
            int   minimized = FALSE;
            while (minimize_registers()) {
               newallocations |= TRUE;
               minimized = TRUE;
            }
            if (minimized) {
               newallocations |= TRUE;
               reset_local_links(0);
               rebuild_dom_front(r_d_f_c++);
            }
            main_loop_count++;
         }
         else if (!newallocations && main_loop_count < 2) {
            int   minimized = FALSE;
            while (minimize_registers()) {
               newallocations |= TRUE;
               minimized = TRUE;
            }
            if (minimized) {
               newallocations |= TRUE;
               reset_local_links(0);
               rebuild_dom_front(r_d_f_c++);
            }
            main_loop_count++;
         }
         else
            while (minimize_registers()) ;

      /* Remove rtls with null value and empty dead list */
      remove_null_rtls();
      rebuild_dom_front(r_d_f_c++);
   } while (newallocations);


/* Perform phase2 of the stache allocation. */
#ifdef STACHE
#if PK  
   (void) set_local_links(1);
   drive_stache_allocation_phase2();
   (void) set_local_links(1);
#endif   
#endif

   /*
    * Attempt to optimize the control flow of the function a second time. It is
    * worth attempting these optimizations again because some of the
    * optimizations that have been performed on this function may have made
    * changes to the control flow of the function that allows for these
    * optimizations to be performed.
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (swl && (moreopts || !swq))
#else
   if (swtm)
      setjmp(my_env);
   if (swl && moreopts)
#endif
#else
   if (swl)
#endif
   {
      (void) remv_branch_chains(r_b_c_count++);
      (void) remv_unreachable_code(r_u_c_count++);
      (void) remv_useless_basic_blocks(r_u_b_count++);
      (void) reverse_jumps(r_j_count++);
      (void) minimize_jumps(m_j_count++);
   }
#ifdef PRED
#ifdef VET
   if (swtm)
      setjmp(my_env);
   if (swp && moreopts)
#else
   if (swp)
#endif
   {
      int   change = TRUE;
      int   p_count = 0;
      while (change) {
         change = FALSE;
#ifdef VET
         if (moreopts)
#endif
            change |= predicate_basic_blocks(p_count++);

#ifdef VET
         if (moreopts)
#endif
            clear_loops();
         clear_dominators();
#ifdef VET
         if (moreopts)
#endif
            depth_first_search(d_f_s_count++);
#ifdef VET
         if (moreopts)
#endif
            build_dominator_tree(b_d_t_count++);
#ifdef VET
         if (moreopts)
#endif
            find_dominance_frontiers(f_d_f_count++);

#ifdef VET
         if (moreopts)
#endif
            change |= simplify_controlflow();
      }
   }
#endif



   /* Let's minimize registers once before fixentry(). */
#ifdef VET
   if (moreopts)
#endif
      minimize_registers();

   /*
    * Set up the activation record for this function.  We first determine which
    * registers are still in use in the function and then determine where in
    * the entry block the prolouge code should be inserted.
    */
   registers_used();
   for (ptr = top->rtls; ptr && !(ptr->type & FUNCNAME); ptr = ptr->next) ;

   /* LVA needs to be called because VPOISO may jump here from any point
    * and fixentry() requires up to date info.
    */
   live_variable_analysis(l_v_a_count++, TRUE, FALSE);
   if (ptr)
      fixentry(ptr, ret_block == NULL ? NULL : ret_block->preds);

#ifdef STACHE
#if PK   
   if (stache_policy == GLOBALS_STACHE_POLICY
       || stache_policy == BOTH_STACHE_POLICY) {
      promote_globals();
   }
#endif   
#endif



/* If we're compiling for a STACHE, then we cleanup here,
	all decisions about the stache are made, and fixentry has
	been called. 
*/
#ifdef STACHE
#if PK   
   cleanup_stacheables();
#endif   
#endif

#ifdef SCHED

   /*
    * Perform instruction scheduling on this procedure
    */
#ifdef VET
#ifdef INTERACT
   if (swtm && swq)
      setjmp(my_env);
   if (swi && (moreopts || !swq))
#else
   if (swtm)
      setjmp(my_env);
   if (swi && moreopts)
#endif
#else
   if (swi)
#endif
#ifdef SCHED
      instruction_scheduling(1);
#endif
#endif

#ifdef FILL

   /*
    * Fill in delay slots by locating code that can be moved into the delay
    * slots available in the function.  Note that filling in delay slots will
    * sometimes leave behind useless jumps, so if any delay slots are filled,
    * we will go back and remove any useless jumps that may have been left
    * behind.
    */
#ifdef VET
#ifdef INTERACT
   if (swf && (moreopts || !swq))
#else
   if (swf && moreopts)
#endif
#else
   if (swf)
#endif
   {
      if (fill_delay_slots(1) && swl) {
         (void) remv_useless_jumps(r_u_j_count++);
         (void) remv_branch_chains(r_b_c_count++);
      }
   }
#endif

#ifdef VET
   /* Update number of improving transformations for function. */
#ifdef INTERACT
   if (fn && swtd && swq)
#else
   if (fn && swtd)
#endif
      addtonumtranslist(basename, fn, opttransnum);
#endif


#ifdef MEASURE
   /*
    * Collect instruction information for static and dynamic measurements
    */
   if (top && fn) {

      /*
       * Before calculating the equivalence classes to instrument the function,
       * we remove the basic blocks in the function to reduce the size of the
       * data structures that are needed to maintain the information about the
       * basic blocks in the function, and determine the impact of calling the
       * "exit()" function on the control flow graph of the function.
       */
      if (swef) {
         (void) remv_useless_basic_blocks(r_u_b_count++);
         reveal_exit_points(1);
      }

      /*
       * In order to be able to determine which registers are live at any given
       * point in the function in order to ensure that the instrumented code
       * does not affect any of the registers used, determine the live variable
       * information for the function.
       */
      if (swef || swei || swed || swep) {

#ifdef FILL
         live_variable_analysis(l_v_a_count++, FALSE, swf);
#else
         live_variable_analysis(l_v_a_count++, FALSE, FALSE);
#endif

         /*
          * Also determine which registers are used in the function
          */
         registers_used();

         /*
          * Number each RTL in the function so that we can tell the RTLs that
          * are part of the original function from those that are added in
          * order to instrument the code.
          */
         number_rtls();
      }

      if (swef)
         measure_freq();
      else if (swei || swed)
         measure_cache();
      else if (swep)
         measure_time();
   }
#endif

   /*
    * Check to see if the user would like to see the state of the function at
    * this point in time.
    */
   if (swd && debug_opt_i("dump_after_optimize", 1))
      dump_function_i("after optimize()", 1,
                      SHOW_LABELS | SHOW_STATUS | SHOW_UP | SHOW_SUCCS |
                      SHOW_PREDS | SHOW_NONRTLS | SHOW_SE);

   /*
    * Dump out the optimized procedure to the output file
    */
#ifdef INTERACT
   /*dump out the instrumented code to the output file */
   dump_rtl_asm(1, instfp, 0);

   /*dump out the RTLs to output file */
   if (show_RTL) {
      dump_rtl_asm(0, rtlfile, 0);

      /*dump out the assembly code to another file */
      if (show_ASM)
         dump_rtl_asm(1, asmfile, 0);
   }
   else
#endif
   {
      dump_function(SHOW_NORMAL);
   }


   /* reset block_id to zero for the next function. The blocks are created
    * outside this function, so do not reset block_id at the start of the
    * function */
   

#ifdef INTERACT
   /* for non-interactive mode with saving transformations enabled */
   if (save_trans) {
      /* dump the transformations to a file */
      dump_trans();
      rtl_id = 0;

      if (!session_over) {
         /* send the UI endfunc message so that it can give next command */
         send_end_func(fn);

         /* get next user request */
         pc = wait_for_next_func();

         /* check if the UI has been closed */
         if (commands[pc].oper == STOP_TRANS) {
            session_over = TRUE;
            viewing = FALSE;
         }
      }
   }
#endif


#ifdef MEASURE

   /*
    * Emit any additional declarations needed to perform measurements on this
    * function.
    */
   if (fn) {
      if (swef)
#ifdef INTERACT
         freq_info(asmfile);
#else
         freq_info();
#endif
      else if (swei && swed)
#ifdef INTERACT
         unified_info(asmfile);
#else
         unified_info();
#endif
      else if (swei)
#ifdef INTERACT
         inst_info(asmfile);
#else
         inst_info();
#endif
   }
#if 0
   swef = FALSE;
#endif
#endif
}

/*
 * clear_opt_flags - clear the optimization flags
 */
void clear_opt_flags()
{
   swa = FALSE;    /* assembly output option         */
   swc = FALSE;    /* common subexpression option    */
   swd = 0;        /* debug mode option              */

#ifdef MEASURE
   swef = FALSE;   /* frequency measurement option   */
   swei = FALSE;   /* trace instruction option       */
   swed = FALSE;   /* trace data option              */
   swep = FALSE;   /* precision timing option        */
#endif

#ifdef FILL
   swf = FALSE;    /* fill delay slots option        */
#endif

   swg = FALSE;    /* link across blocks option      */

#ifdef SCHED
   swi = FALSE;    /* instruction scheduling option  */
#endif

   swl = FALSE;    /* label optimizations option     */
   swn = FALSE;    /* fix up control flow            */
   swm = FALSE;    /* code motion option             */
   swo = FALSE;    /* register coloring option       */
   swr = FALSE;    /* simple reg allocation option   */
   sws = FALSE;    /* strength reduction option      */

#ifdef VET
   swth = FALSE;   /* remote host name follows       */
   swtp = FALSE;   /* port number follows            */
   swtd = FALSE;   /* dump num transformation flag   */
   swtm = FALSE;   /* max num transformation flag    */
#endif
   swv = FALSE;    /* evaluation order determination */
   sww = FALSE;    /* suppress warning messages flag */
   swx = FALSE;    /* execution timing profile flag  */

   sw1 = FALSE;
}

#ifdef INTERACT
/*
 * end_sel_comb - steps to come out of SEL...COMB
 */
void end_sel_comb(struct comb_struct *comb)
{
  extern int viewing;
 
  if(comb->valid_comb > 0){
    pc = comb->start_pc;
    init_command_array(comb->length, comb->strlength, pc, commands,
		       comb->base_opt, comb->best_opt);
    pc--;
  }

  viewing = comb->viewing;
  if(continuous_measures == SUSPEND)
    continuous_measures = TRUE;
  
  /*free up space help up by the hastables*/
  dispose_comb();
  
  if(comb_log && comb_log != stderr)
    fclose(comb_log);
  if(rand_fp)
    fclose(rand_fp);

  isSelCombPhase = FALSE;
}
#endif

/*
 * dump_function_i - dump the current state of the function to the output file
 */
void dump_function_i(char *messg, int invocation, int debug)
{

   register char *a;

   if (a = messg) {
      (void) printf("Dump ");
      while (*a != ' ')
         (void) printf("%c", *a++);
      (void) printf(" the %d%s invocation of", invocation,
                    ((invocation % 10) == 1) ? "st" : ((invocation % 10) ==
                                                       2) ? "nd"
                    : ((invocation % 10) == 3) ? "rd" : "th");
      while (*a)
         (void) printf("%c", *a++);
      (void) printf("\n");
   }
   dump_function(debug);
   (void) printf("End of dump\n");
}

/*
 * dump_function_l - dump the current state of the function to the output file
 */
void dump_function_l(char *messg, char *label, int debug)
{

   register char *a;

   if (a = messg) {
      (void) printf("Dump ");
      while (*a != ' ')
         (void) printf("%c", *a++);
      (void) printf(" the invocation of");
      while (*a)
         (void) printf("%c", *a++);
      if (label)
         (void) printf(" for %s\n", label);
      else
         (void) printf("\n");
   }
   dump_function(debug);
   (void) printf("End of dump\n");
}

/*
 * dump_function_i_l - dump the current state of the function to the output file
 */
void dump_function_i_l(char *messg, int invocation, char *label, int debug)
{

   register char *a;

   if (a = messg) {
      (void) printf("Dump ");
      while (*a != ' ')
         (void) printf("%c", *a++);
      (void) printf(" the %d%s invocation of", invocation,
                    ((invocation % 10) == 1) ? "st" : ((invocation % 10) ==
                                                       2) ? "nd"
                    : ((invocation % 10) == 3) ? "rd" : "th");
      while (*a)
         (void) printf("%c", *a++);
      if (label)
         (void) printf(" for %s\n", label);
      else
         (void) printf("\n");
   }
   dump_function(debug);
   (void) printf("End of dump\n");
}

/*
 * dump_function - dump the current state of the function to the output file
 */
void dump_function(int debug)
{

   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr;
   struct phi *pphi;
   struct defnode *pdef;
   int   rnum, i, pass2;
   char *a, reg[BIGSTRING];
   int   contains_pseudo = 0;

   /*
    * Number the basic blocks for a debug display
    */
   if (debug) {
      for (cblk = top; cblk; cblk = cblk->next)
         cblk->dnum = 0;
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down)
         cblk->dnum = rnum++;
      for (cblk = top; cblk; cblk = cblk->next)
         if (!cblk->dnum)
            cblk->dnum = rnum++;
   }

   /*
    * Number all RTLs, so we can tell forward links from back links
    */
   if (!swa) {
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & RTLINE)
               rtlptr->rnum = rnum++;
         }
      }
   }

   dassem = 1;
   rnum = 1;
   pass2 = FALSE;

   /*
    * Go through all of the basic blocks starting with the entry block and
    * continuing along in the output order.
    */
   for (cblk = top; cblk; cblk = cblk->down) {

      /*
       * If the user has requested debug output, show some of the information
       * that we have on this basic block.
       */
      if (debug) {

         i = FALSE;
         if (debug & SHOW_LABELS || debug_opt("show_labels")) {
            (void) printf("Number: %d", cblk->dnum);
            (void) printf(" (%s)  ",
                          (cblk->label) ? cblk->label : "no label");
            i = TRUE;
         }
         if (debug & SHOW_STATUS || debug_opt("show_status")) {
            (void) printf("Status: %x", cblk->status);
            if (cblk->status & FALLTHRU)
               if (cblk->status & JUMP)
                  (void) printf(" (FALLTHRU, JUMP)  ");
               else
                  (void) printf(" (FALLTHRU)  ");
            else if (cblk->status & JUMP)
               (void) printf(" (JUMP)  ");
            else
               (void) printf("  ");
            i = TRUE;
         }
         if (debug & SHOW_BNUM || debug_opt("show_bnum")) {
            (void) printf("Bnum: %d  ", cblk->bnum);
            i = TRUE;
         }

#ifdef MEASURE
         if (debug & SHOW_CLASS || debug_opt("show_class")) {
            (void) printf("Class: %d  ", cblk->equivnum);
            i = TRUE;
         }
#endif

         if (debug & SHOW_FREQ || debug_opt("show_freq")) {
            (void) printf("Freq: %d  ", cblk->freq);
            i = TRUE;
         }
         if (debug & SHOW_ESTIMATE || debug_opt("show_estimate")) {
            (void) printf("Estimate: %6.4f  ", cblk->estimate);
            i = TRUE;
         }
         if (cblk->loop && (debug & SHOW_LOOP || debug_opt("show_loop")))
            (void) printf("Loop head\n");
         else if (i)
            (void) printf("\n");

         i = FALSE;
         if (cblk->up && (debug & SHOW_UP || debug_opt("show_up"))) {
            (void) printf("Up: %d  ", cblk->up->dnum);
            i = FALSE;
         }
         if (debug & SHOW_SUCCS || debug_opt("show_succs")) {
            if (cblk->left) {
               (void) printf("Left: %d  ", cblk->left->dnum);
               i = TRUE;
            }
            if (cblk->right) {
               (void) printf("Right: %d  ", cblk->right->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DFS || debug_opt("show_dfs")) {
            if (cblk->prev_dfs) {
               (void) printf("Prev-dfs: %d  ", cblk->prev_dfs->dnum);
               i = TRUE;
            }
            if (cblk->next_dfs) {
               (void) printf("Next-dfs: %d  ", cblk->next_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PARENT || debug_opt("show_parent")) {
            if (cblk->parent_dfs) {
               (void) printf("Parent: %d  ", cblk->parent_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DOM || debug_opt("show_dom")) {
            if (cblk->idom) {
               (void) printf("Idom: %d  ", cblk->idom->dnum);
               i = TRUE;
            }
            if (cblk->sdom) {
               (void) printf("Sdom: %d  ", cblk->sdom->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PREDS || debug_opt("show_preds")) {
            (void) printf("Preds: {");
            bptr = cblk->preds;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }
         else if (i)
            (void) printf("\n");

         if (debug & SHOW_FRONTIER || debug_opt("show_frontier")) {
            (void) printf("Dominance frontier: {");
            bptr = cblk->dom_front;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }

         if (debug & SHOW_USE || debug_opt("show_use")) {
            (void) printf("Use: ");

            /* reget returns a list of register will null seperators    
             * so we need to use a skiploc(a)+1 here.. i think */
            reget(cblk->ulist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_DEF || debug_opt("show_def")) {
            (void) printf("Def: ");
            reget(cblk->dlist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_OUT || debug_opt("show_out")) {
            (void) printf("Out: ");
            reget(cblk->olist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_PHI || debug_opt("show_phi")) {
            (void) printf("Phi: ");
            for (pphi = cblk->phi_funcs; pphi; pphi = pphi->next) {
               show_rtl(stdout, pphi->item->item);
               (void) printf("() ");
            }
            (void) printf("\n");
         }

         if (debug & SHOW_SETS || debug_opt("show_sets")) {
            (void) printf("Sets: ");
            for (pdef = cblk->sets_out; pdef; pdef = pdef->next) {
               show_rtl(stdout, pdef->item->item);
               (void) printf("[%d] ", pdef->set_rtl->rnum);
            }
            (void) printf("\n");
         }
      }

      /*
       * If this basic block has a label, determine if we need to show it. A
       * label is needed only if there is some item that uses it elsewhere in
       * this function.  This will be true only if the basic block has more
       * than one predecessor or if the block has a single predecessor but that
       * predecessor does not fall through into this basic block.
       */
      if (cblk->label && cblk != ret_block && cblk->preds
          && (cblk->preds->next || !(cblk->status & FALLTHRU))
       ) {
         if (swa)
            (void) printf(labprt, cblk->label);
         else
            (void) printf("\t%s\n", cblk->label);
      }

      /*
       * Display the items in this basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         switch (rtlptr->
                 type & ~(ARGLINE | SIDEFFECT | COMBLINE | FUNCNAME | CASELINE
                          | DELAYLINE)) {

          case TRASHLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("t");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case RESLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("r");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case SETLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("S");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ARGBLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("A");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case USELINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("u");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case CSLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("C");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case PARMLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("P");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ASMLINE:
             if (swz && !NotProcessingGlobal(rtlptr->val))
                ;  /* Swallowed line for emitAsmForGlobals(). */
             else if (rtlptr->type & DELAYLINE) {
                if (debug)
                   (void) printf("_%s\n", rtlptr->val);
                else
                   pass2 = TRUE;
             }
             else if (!(rtlptr->type & FUNCNAME)) {
                if (swa)
                   (void) printf("%s\n", rtlptr->val);
                else
                   (void) printf("-%s\n", rtlptr->val);
             }
             else if (debug
                      && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls")))
                (void) printf("f%s\n", rtlptr->val);
             break;

          case COMMENT:
             if (swa) {
                if (!debug_opt("no_asm_comments"))
                   (void) printf(acomment, rtlptr->val);
             }
             else {
                if (!debug_opt("no_asm_comments"))
                   (void) printf("#%s\n", rtlptr->val);
             }
             break;

          case RTLINE:
          case SIDEFFECT:
             if (swa) {
                if (rtlptr->val && *rtlptr->val) {
                   char *a = rtlptr->val;
                   contains_pseudo = FALSE;
                   sem_ptr = str_ptr = i_ptr = 0;
                   linptr = rtlptr->val;
                   deadlist = rtlptr->deads;
                   curptr = rtlptr;

                   /* 
                    * When compiling with minimal optimizations (eg -AW)
                    * sometimes things don't get reg-assigned.  We don't
                    * emit these RTLs because they're useless
                    * and might cause the parser to crash
                    * or generate bad machine language.
                    */
                   while (a = gtrg(a)) {
                      if (pseudoreg(unskiploc(a)))
                         contains_pseudo = TRUE;
                   }
                   if (!contains_pseudo) {
                      if (yyparse()) {
                         if (fn)
                            (void) fprintf(stderr,
                              "vpo (dump_function): in %s: cannot assemble ",
                               fn);
                         else
                            (void) fprintf(stderr,
                                     "vpo (dump_function): cannot assemble ");

                         show(rtlptr->val);
                      }
                   }
                }
             }
             else {
                rtlptr->rnum = rnum++;
#ifdef VET
                /* We don't want to print out the rnum info when vpo is called
                 * from VPOISO, so as to avoid confusing the diff of the
                 * correct and incorrect outputs.
                 */
                if (!debug_opt("no_rtl_line_nums"))
#endif
                {
                   (void) printf("+%d\t\t", rtlptr->rnum);

                   for (i = 0; i < MAXLINKS && rtlptr->all_lnks[i]; i++)
                      (void) printf("%d ", rtlptr->all_lnks[i]->rnum);
                   (void) printf("\t");
                }

                if (rtlptr->val)
                   show_rtl(stdout, rtlptr->val);
                (void) printf("\t");

                reget(rtlptr->deads, reg);
                for (a = reg; *a; a = skiplocOr2(a) + 1)
                   show_rtl(stdout, a);

                if (debug && (debug & SHOW_COST || debug_opt("show_cost")))
                   (void) printf(" {%d}", rtlptr->cost);
                if (debug && rtlptr->se
                    && (debug & SHOW_SE || debug_opt("show_se"))) {
                   (void) printf(" {");
                   show_rtl(stdout, rtlptr->se);
                   (void) printf("}");
                }

#ifdef STACHE
                if (debug && debug_opt("show_sp_info")) {
                   if (rtlptr->sp_used)
                      printf("\tsp for: %s", localname(rtlptr->sp_used));
                   else
                      printf("\tno sp");
                }
                if (debug && debug_opt("show_sp_info")) {
                   if (rtlptr->variable
                       && strcmp(rtlptr->variable, "Unknown") != 0) {
                      printf("\tvar:");
                      show(rtlptr->variable);
                   }
                   else
                      printf("\tno var");
                }
#endif

                (void) printf("\n");
             }
             rtlprt(rtlptr, &rnum);
             break;
          case METADATALINE:
             if (!swa && (debug & SHOW_NONRTLS))
                printf("m%s\n", rtlptr->val);
             break;

          default:
             (void) fprintf(stderr,
                            "vpo (dump_function): bad line, type %x\n",
                            rtlptr->type);
         }
      }
   }

   /*
    * In the second pass through the RTLs, dump only those items marked as
    * DELAYLINE.  These items will all go at the end of the output.
    */
   if (pass2) {
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & DELAYLINE) {
               if (swa)
                  (void) printf("%s\n", rtlptr->val);
               else
                  (void) printf("_%s\n", rtlptr->val);
            }
         }
      }
   }

   dassem = 0;

#ifdef VET
   if (fn && (swtd || swtm)) {
      char  line[MAXSTRING];

      sprintf(line, "end of %s\n", fn);
      printf(acomment, line);
   }
#endif
   (void) fflush(stdout);
}

/*
 * show - print out a human readable version of an RTL (for debug purposes)
 */
void show(char *rtl)
{

   /*
    * This procedure is declared to make it easier to look at items while in
    * dbx.  To print out the contents of a string that contains encrypted
    * registers and identifiers, use "call show(string)".
    */
   show_rtl(stderr, rtl);
   (void) fprintf(stderr, "\n");
   (void) fflush(stderr);
}

void printRTL(struct list *rtl)
{
  if(rtl==NULL || rtl->val[0]=='\0')
    return;
  show(rtl->val);
}

/*
 * rshow - print out the values in an rlist vector (for debug purposes)
 */
void rshow(rlist vec)
{

   register char *a;
   char  reg[MAXSTRING];

   /*
    * This procedure is declared to make it easier to look at register vectors
    * while in dbx.  To print out the contents of a register vector, use "call
    * rshow(vector)".
    */
   reget(vec, reg);
   for (a = reg; *a; a = skiploc(a) + 1)
      show_rtl(stderr, a);
   (void) fflush(stderr);
}

#ifdef INTERACT

/*
 * show_opfile - write RTLs in human readable form to a file
 */
void show_opfile(char *rtl, FILE *fp)
{
  show_rtl(fp, rtl);
  fprintf(fp, "\n");
}


/*
 * rshowmsg - store the values in an rlist vector (for debug purposes)
 */
void rshowmsg(rlist vec, char *msg)
{

   register char *a;
   char  regs[MAXSTRING], reg[10];

   msg[0] = '\0';
   reget(vec, regs);
   for (a = regs; *a; a += 3)
      if (isrg(a)) {
         if (regtovec(a) < 0 || pseudoreg(a))
            (void) sprintf(reg, "%c[%d]", regprt[regtype(a)], regnum(a));
         else
            (void) sprintf(reg, "%c[%d]", regprt[regtype(a)], map(a));
      }
   strcat(msg, reg);
}

/*
 * dshowmsg - save the blocks in a dvector to a string
 */
void dshowmsg(dvector d, char *msg)
{
   int   i, j;
   char  num[10];
   extern int dveclen;

   msg[0] = '\0';
   for (i = 0; i < dveclen; i++)
      for (j = 0; j < sizeof(unsigned int) * 8; j++)
         if (din(d, i * 32 + j)) {
            sprintf(num, " %d", i * 32 + j);
            strcat(msg, num);
         }
}

#endif

/*
 * ShowPreds - print out the predecessor list
 */
void ShowPreds(struct bblock *cblk)
{
   struct blist *bptr;

   (void) printf("Preds: {");
   bptr = cblk->preds;
   while (bptr) {
      (void) printf("%d", bptr->ptr->dnum);
      if (bptr = bptr->next)
         (void) printf(", ");
   }
   (void) printf("}\n");
}

/*
 * show_setlist - show a setlist for debugging purposes
 */
void show_setlist(struct setlist *p)
{
   do {
      printf("setlist for ");
      show_rtl(stdout, p->item);
      printf("\n");
      if (p->sets != NULL) {
         printf("\tset @ rtl %d: ", p->sets->rnum);
         show_rtl(stdout, p->sets->val);
      }
      else
         printf("\tno sets");
      printf("\n");
      if (p->dead != NULL) {
         printf("\tlast used @ rtl %d: ", p->dead->rnum);
         show_rtl(stdout, p->dead->val);
      }
      else
         printf("\tno last use");
      printf("\n");
      if (p->ldead != NULL) {
         printf("\tlast died @ rtl %d: ", p->ldead->rnum);
         show_rtl(stdout, p->ldead->val);
      }
      else
         printf("\tno last died");
      printf("\n");
      printf("\tregister allocated %d \n", p->assign);
      printf("\tuses = %d\n", p->uses);
      p = p->next;
   } while (p != NULL);
   return;
}


void dump_block(struct bblock *cblk2, int debug)
{
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr;
   struct phi *pphi;
   struct defnode *pdef;
   int   rnum, i, pass2;
   char *a, reg[BIGSTRING];

   /*
    * Number the basic blocks for a debug display
    */
   if (debug) {
      for (cblk = top; cblk; cblk = cblk->next)
         cblk->dnum = 0;
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down)
         cblk->dnum = rnum++;
      for (cblk = top; cblk; cblk = cblk->next)
         if (!cblk->dnum)
            cblk->dnum = rnum++;
   }

   /*
    * Number all RTLs, so we can tell forward links from back links
    */
   if (!swa) {
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & RTLINE)
               rtlptr->rnum = rnum++;
         }
      }
   }

   dassem = 1;
   rnum = 1;
   pass2 = FALSE;

   /* do only the block specified */
   for (cblk = cblk2; cblk; cblk = (struct bblock *) 0) {

      /*
       * If the user has requested debug output, show some of the information
       * that we have on this basic block.
       */
      if (debug) {

         i = FALSE;
         if (debug & SHOW_LABELS || debug_opt("show_labels")) {
            (void) printf("Number: %d", cblk->dnum);
            (void) printf(" (%s)  ",
                          (cblk->label) ? cblk->label : "no label");
            i = TRUE;
         }
         if (debug & SHOW_STATUS || debug_opt("show_status")) {
            (void) printf("Status: %x", cblk->status);
            if (cblk->status & FALLTHRU)
               if (cblk->status & JUMP)
                  (void) printf(" (FALLTHRU, JUMP)  ");
               else
                  (void) printf(" (FALLTHRU)  ");
            else if (cblk->status & JUMP)
               (void) printf(" (JUMP)  ");
            else
               (void) printf("  ");
            i = TRUE;
         }
         if (debug & SHOW_BNUM || debug_opt("show_bnum")) {
            (void) printf("Bnum: %d  ", cblk->bnum);
            i = TRUE;
         }

#ifdef MEASURE
         if (debug & SHOW_CLASS || debug_opt("show_class")) {
            (void) printf("Class: %d  ", cblk->equivnum);
            i = TRUE;
         }
#endif

         if (debug & SHOW_FREQ || debug_opt("show_freq")) {
            (void) printf("Freq: %d  ", cblk->freq);
            i = TRUE;
         }
         if (debug & SHOW_ESTIMATE || debug_opt("show_estimate")) {
            (void) printf("Estimate: %6.4f  ", cblk->estimate);
            i = TRUE;
         }
         if (cblk->loop && (debug & SHOW_LOOP || debug_opt("show_loop")))
            (void) printf("Loop head\n");
         else if (i)
            (void) printf("\n");

         i = FALSE;
         if (cblk->up && (debug & SHOW_UP || debug_opt("show_up"))) {
            (void) printf("Up: %d  ", cblk->up->dnum);
            i = FALSE;
         }
         if (debug & SHOW_SUCCS || debug_opt("show_succs")) {
            if (cblk->left) {
               (void) printf("Left: %d  ", cblk->left->dnum);
               i = TRUE;
            }
            if (cblk->right) {
               (void) printf("Right: %d  ", cblk->right->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DFS || debug_opt("show_dfs")) {
            if (cblk->prev_dfs) {
               (void) printf("Prev-dfs: %d  ", cblk->prev_dfs->dnum);
               i = TRUE;
            }
            if (cblk->next_dfs) {
               (void) printf("Next-dfs: %d  ", cblk->next_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PARENT || debug_opt("show_parent")) {
            if (cblk->parent_dfs) {
               (void) printf("Parent: %d  ", cblk->parent_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DOM || debug_opt("show_dom")) {
            if (cblk->idom) {
               (void) printf("Idom: %d  ", cblk->idom->dnum);
               i = TRUE;
            }
            if (cblk->sdom) {
               (void) printf("Sdom: %d  ", cblk->sdom->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PREDS || debug_opt("show_preds")) {
            (void) printf("Preds: {");
            bptr = cblk->preds;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }
         else if (i)
            (void) printf("\n");

         if (debug & SHOW_FRONTIER || debug_opt("show_frontier")) {
            (void) printf("Dominance frontier: {");
            bptr = cblk->dom_front;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }

         if (debug & SHOW_USE || debug_opt("show_use")) {
            (void) printf("Use: ");
            reget(cblk->ulist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_DEF || debug_opt("show_def")) {
            (void) printf("Def: ");
            reget(cblk->dlist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_OUT || debug_opt("show_out")) {
            (void) printf("Out: ");
            reget(cblk->olist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_PHI || debug_opt("show_phi")) {
            (void) printf("Phi: ");
            for (pphi = cblk->phi_funcs; pphi; pphi = pphi->next) {
               show_rtl(stdout, pphi->item->item);
               (void) printf("() ");
            }
            (void) printf("\n");
         }

         if (debug & SHOW_SETS || debug_opt("show_sets")) {
            (void) printf("Sets: ");
            for (pdef = cblk->sets_out; pdef; pdef = pdef->next) {
               show_rtl(stdout, pdef->item->item);
               (void) printf("[%d] ", pdef->set_rtl->rnum);
            }
            (void) printf("\n");
         }
      }

      /*
       * If this basic block has a label, determine if we need to show it. A
       * label is needed only if there is some item that uses it elsewhere in
       * this function.  This will be true only if the basic block has more
       * than one predecessor or if the block has a single predecessor but that
       * predecessor does not fall through into this basic block.
       */
      if (cblk->label && cblk != ret_block && cblk->preds
          && (cblk->preds->next || !(cblk->status & FALLTHRU))) {
         if (swa)
            (void) printf(labprt, cblk->label);
         else
            (void) printf("\t%s\n", cblk->label);
      }

      /*
       * Display the items in this basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         switch (rtlptr->
                 type & ~(ARGLINE | SIDEFFECT | COMBLINE | FUNCNAME | CASELINE
                          | DELAYLINE)) {

          case TRASHLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("t");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case RESLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("r");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case SETLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("S");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ARGBLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("A");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case USELINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("u");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case CSLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("C");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case PARMLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("P");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ASMLINE:
             if (rtlptr->type & DELAYLINE) {
                if (debug)
                   (void) printf("_%s\n", rtlptr->val);
                else
                   pass2 = TRUE;
             }
             else if (!(rtlptr->type & FUNCNAME)) {
                if (swa)
                   (void) printf("%s\n", rtlptr->val);
                else
                   (void) printf("-%s\n", rtlptr->val);
             }
             else if (debug
                      && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls")))
                (void) printf("f%s\n", rtlptr->val);
             break;

          case COMMENT:
             if (swa)
                (void) printf(acomment, rtlptr->val);
             else
                (void) printf("#%s\n", rtlptr->val);
             break;
          case METADATALINE:
             if (!swa)
                (void) printf("m%s\n", rtlptr->val);
             break;

          case RTLINE:
          case SIDEFFECT:
             if (swa) {
                if (rtlptr->val && *rtlptr->val) {
                   sem_ptr = str_ptr = i_ptr = 0;
                   linptr = rtlptr->val;
                   deadlist = rtlptr->deads;
                   curptr = rtlptr;
		   check_legal = TRUE;
                   if (yyparse()) {
                      (void) fprintf(stderr,
                                     "vpo (dump_block): cannot assemble ");
                      show(rtlptr->val);
                   }
		   check_legal = FALSE;
                }
             }
             else {
                rtlptr->rnum = rnum++;
                (void) printf("+%d\t\t", rtlptr->rnum);

                for (i = 0; i < MAXLINKS && rtlptr->all_lnks[i]; i++)
                   (void) printf("%d ", rtlptr->all_lnks[i]->rnum);
                (void) printf("\t");

                if (rtlptr->val)
                   show_rtl(stdout, rtlptr->val);
                (void) printf("\t");

                reget(rtlptr->deads, reg);
                for (a = reg; *a; a = skiploc(a) + 1)
                   show_rtl(stdout, a);

                if ((debug && (debug & SHOW_COST)) || debug_opt("show_cost"))
                   (void) printf(" {%d}", rtlptr->cost);
                if (debug && rtlptr->se
                    && (debug & SHOW_SE || debug_opt("show_se"))) {
                   (void) printf(" {");
                   show_rtl(stdout, rtlptr->se);
                   (void) printf("}");
                }

                (void) printf("\n");
             }
             rtlprt(rtlptr, &rnum);
             break;

          default:
             (void) fprintf(stderr, "vpo (dump_block): bad line, type %x\n",
                            rtlptr->type);
         }
      }
   }

   /*
    * In the second pass through the RTLs, dump only those items marked as
    * DELAYLINE.  These items will all go at the end of the output.
    */
   if (pass2) {
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & DELAYLINE) {
               if (swa)
                  (void) printf("%s\n", rtlptr->val);
               else
                  (void) printf("_%s\n", rtlptr->val);
            }
         }
      }
   }

   dassem = 0;

#ifdef VET
   if (fn && (swtd || swtm)) {
      char  line[MAXSTRING];

      sprintf(line, "end of %s\n", fn);
      printf(acomment, line);
   }
#endif
   (void) fflush(stdout);
}

struct bblock *dump_block_by_label(char *label, int debug)
{
   struct bblock *cblk;
   if (!label)
      return;

   for (cblk = top; cblk; cblk = cblk->next) {
      if (cblk->label && strcmp(cblk->label, label) == 0) {
         dump_block(cblk, debug);
         return cblk;
      }
   }
}

void dump_function_range(int debug, int start, int end)
{

   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr;
   struct phi *pphi;
   struct defnode *pdef;
   int   rnum, i, pass2;
   char *a, reg[BIGSTRING];
   int   dumped_so_far = 0;

   /*
    * Number the basic blocks for a debug display
    */
   if (debug) {
      for (cblk = top; cblk; cblk = cblk->next)
         cblk->dnum = 0;
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down)
         cblk->dnum = rnum++;
      for (cblk = top; cblk; cblk = cblk->next)
         if (!cblk->dnum)
            cblk->dnum = rnum++;
   }

   /*
    * Number all RTLs, so we can tell forward links from back links
    */
   if (!swa) {
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            rtlptr->rnum = rnum++;
         }
      }
   }

   dassem = 1;
   rnum = 1;
   pass2 = FALSE;

   /*
    * Go through all of the basic blocks starting with the entry block and
    * continuing along in the output order.
    */
   for (cblk = top; cblk; cblk = cblk->down) {

      /*
       * If the user has requested debug output, show some of the information
       * that we have on this basic block.
       */
      if (debug) {

         if (dumped_so_far >= start) {

            i = FALSE;
            if (debug & SHOW_LABELS || debug_opt("show_labels")) {
               (void) printf("Number: %d", cblk->dnum);
               (void) printf(" (%s)  ",
                             (cblk->label) ? cblk->label : "no label");
               i = TRUE;
            }
            if (debug & SHOW_STATUS || debug_opt("show_status")) {
               (void) printf("Status: %x", cblk->status);
               if (cblk->status & FALLTHRU)
                  if (cblk->status & JUMP)
                     (void) printf(" (FALLTHRU, JUMP)  ");
                  else
                     (void) printf(" (FALLTHRU)  ");
               else if (cblk->status & JUMP)
                  (void) printf(" (JUMP)  ");
               else
                  (void) printf("  ");
               i = TRUE;
            }
            if (debug & SHOW_BNUM || debug_opt("show_bnum")) {
               (void) printf("Bnum: %d  ", cblk->bnum);
               i = TRUE;
            }

#ifdef MEASURE
            if (debug & SHOW_CLASS || debug_opt("show_class")) {
               (void) printf("Class: %d  ", cblk->equivnum);
               i = TRUE;
            }
#endif

            if (debug & SHOW_FREQ || debug_opt("show_freq")) {
               (void) printf("Freq: %d  ", cblk->freq);
               i = TRUE;
            }
            if (debug & SHOW_ESTIMATE || debug_opt("show_estimate")) {
               (void) printf("Estimate: %6.4f  ", cblk->estimate);
               i = TRUE;
            }
            if (cblk->loop && (debug & SHOW_LOOP || debug_opt("show_loop")))
               (void) printf("Loop head\n");
            else if (i)
               (void) printf("\n");

            i = FALSE;
            if (cblk->up && (debug & SHOW_UP || debug_opt("show_up"))) {
               (void) printf("Up: %d  ", cblk->up->dnum);
               i = FALSE;
            }
            if (debug & SHOW_SUCCS || debug_opt("show_succs")) {
               if (cblk->left) {
                  (void) printf("Left: %d  ", cblk->left->dnum);
                  i = TRUE;
               }
               if (cblk->right) {
                  (void) printf("Right: %d  ", cblk->right->dnum);
                  i = TRUE;
               }
            }
            if (debug & SHOW_DFS || debug_opt("show_dfs")) {
               if (cblk->prev_dfs) {
                  (void) printf("Prev-dfs: %d  ", cblk->prev_dfs->dnum);
                  i = TRUE;
               }
               if (cblk->next_dfs) {
                  (void) printf("Next-dfs: %d  ", cblk->next_dfs->dnum);
                  i = TRUE;
               }
            }
            if (debug & SHOW_PARENT || debug_opt("show_parent")) {
               if (cblk->parent_dfs) {
                  (void) printf("Parent: %d  ", cblk->parent_dfs->dnum);
                  i = TRUE;
               }
            }
            if (debug & SHOW_DOM || debug_opt("show_dom")) {
               if (cblk->idom) {
                  (void) printf("Idom: %d  ", cblk->idom->dnum);
                  i = TRUE;
               }
               if (cblk->sdom) {
                  (void) printf("Sdom: %d  ", cblk->sdom->dnum);
                  i = TRUE;
               }
            }
            if (debug & SHOW_PREDS || debug_opt("show_preds")) {
               (void) printf("Preds: {");
               bptr = cblk->preds;
               while (bptr) {
                  (void) printf("%d", bptr->ptr->dnum);
                  if (bptr = bptr->next)
                     (void) printf(", ");
               }
               (void) printf("}\n");
            }
            else if (i)
               (void) printf("\n");

            if (debug & SHOW_FRONTIER || debug_opt("show_frontier")) {
               (void) printf("Dominance frontier: {");
               bptr = cblk->dom_front;
               while (bptr) {
                  (void) printf("%d", bptr->ptr->dnum);
                  if (bptr = bptr->next)
                     (void) printf(", ");
               }
               (void) printf("}\n");
            }

            if (debug & SHOW_USE || debug_opt("show_use")) {
               (void) printf("Use: ");
               reget(cblk->ulist, reg);
               for (a = reg; *a; a = skiploc(a) + 1)
                  show_rtl(stdout, a);
               (void) printf("\n");
            }

            if (debug & SHOW_DEF || debug_opt("show_def")) {
               (void) printf("Def: ");
               reget(cblk->dlist, reg);
               for (a = reg; *a; a = skiploc(a) + 1)
                  show_rtl(stdout, a);
               (void) printf("\n");
            }

            if (debug & SHOW_OUT || debug_opt("show_out")) {
               (void) printf("Out: ");
               reget(cblk->olist, reg);
               for (a = reg; *a; a = skiploc(a) + 1)
                  show_rtl(stdout, a);
               (void) printf("\n");
            }

            if (debug & SHOW_PHI || debug_opt("show_phi")) {
               (void) printf("Phi: ");
               for (pphi = cblk->phi_funcs; pphi; pphi = pphi->next) {
                  show_rtl(stdout, pphi->item->item);
                  (void) printf("() ");
               }
               (void) printf("\n");
            }

            if (debug & SHOW_SETS || debug_opt("show_sets")) {
               (void) printf("Sets: ");
               for (pdef = cblk->sets_out; pdef; pdef = pdef->next) {
                  show_rtl(stdout, pdef->item->item);
                  (void) printf("[%d] ", pdef->set_rtl->rnum);
               }
               (void) printf("\n");
            }
         }
      }

      /*
       * If this basic block has a label, determine if we need to show it. A
       * label is needed only if there is some item that uses it elsewhere in
       * this function.  This will be true only if the basic block has more
       * than one predecessor or if the block has a single predecessor but that
       * predecessor does not fall through into this basic block.
       */
      if (dumped_so_far >= start)
         if (cblk->label && cblk != ret_block && cblk->preds
             && (cblk->preds->next || !(cblk->status & FALLTHRU))) {
            if (swa)
               (void) printf(labprt, cblk->label);
            else
               (void) printf("\t%s\n", cblk->label);
         }

      /*
       * Display the items in this basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {

         dumped_so_far = rtlptr->rnum;
         if (dumped_so_far < start)
            continue;
         if (dumped_so_far > end) {
            (void) fflush(stdout);
            return;
         }


         switch (rtlptr->
                 type & ~(ARGLINE | SIDEFFECT | COMBLINE | FUNCNAME | CASELINE
                          | DELAYLINE)) {

          case TRASHLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("t");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case RESLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("r");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case SETLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("S");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ARGBLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("A");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case USELINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("u");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case CSLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("C");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case PARMLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("P");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ASMLINE:
             if (rtlptr->type & DELAYLINE) {
                if (debug)
                   (void) printf("_%s\n", rtlptr->val);
                else
                   pass2 = TRUE;
             }
             else if (!(rtlptr->type & FUNCNAME)) {
                if (swa)
                   (void) printf("%s\n", rtlptr->val);
                else
                   (void) printf("-%s\n", rtlptr->val);
             }
             else if (debug
                      && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls")))
                (void) printf("f%s\n", rtlptr->val);
             break;

          case COMMENT:
             if (swa)
                (void) printf(acomment, rtlptr->val);
             else
                (void) printf("#%s\n", rtlptr->val);
             break;

          case RTLINE:
          case SIDEFFECT:
             if (swa) {
                if (rtlptr->val && *rtlptr->val) {
                   sem_ptr = str_ptr = i_ptr = 0;
                   linptr = rtlptr->val;
                   deadlist = rtlptr->deads;
                   curptr = rtlptr;
		   check_legal = TRUE;
                   if (yyparse()) {
                      (void) fprintf(stderr,
                                "vpo (dump_function_range): cannot assemble ");
                      show(rtlptr->val);
                   }
		   check_legal = FALSE;
                }
             }
             else {
                (void) printf("+%d\t\t", rtlptr->rnum);

                for (i = 0; i < MAXLINKS && rtlptr->all_lnks[i]; i++)
                   (void) printf("%d ", rtlptr->all_lnks[i]->rnum);
                (void) printf("\t");

                if (rtlptr->val)
                   show_rtl(stdout, rtlptr->val);
                (void) printf("\t");

                reget(rtlptr->deads, reg);
                for (a = reg; *a; a = skiploc(a) + 1)
                   show_rtl(stdout, a);

                if (debug && (debug & SHOW_COST || debug_opt("show_cost")))
                   (void) printf(" {%d}", rtlptr->cost);
                if (debug && rtlptr->se
                    && (debug & SHOW_SE || debug_opt("show_se"))) {
                   (void) printf(" {");
                   show_rtl(stdout, rtlptr->se);
                   (void) printf("}");
                }

                (void) printf("\n");
             }
             rtlprt(rtlptr, &rnum);
             break;

          default:
             (void) fprintf(stderr,
                            "vpo (dump_function_range): bad line, type %x\n",
                            rtlptr->type);
         }
      }
   }

   /*
    * In the second pass through the RTLs, dump only those items marked as
    * DELAYLINE.  These items will all go at the end of the output.
    */
   if (pass2) {
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & DELAYLINE) {
               if (swa)
                  (void) printf("%s\n", rtlptr->val);
               else
                  (void) printf("_%s\n", rtlptr->val);
            }
         }
      }
   }

   dassem = 0;

#ifdef VET
   if (fn && (swtd || swtm)) {
      char  line[MAXSTRING];

      sprintf(line, "end of %s\n", fn);
      printf(acomment, line);
   }
#endif
   (void) fflush(stdout);
}

void clear_dominators()
{
   struct bblock *cblk;
   for (cblk = top; cblk; cblk = cblk->down) {
      cblk->dom_front = NULL;
      cblk->idom = cblk->sdom = NULL;
   }
}

/* simplify_controlflow */
int simplify_controlflow()
{
   int   change2 = FALSE;
   /* simplify control flow more rigorously than we did before. */
#ifdef DISPOSE
   {
      if (nearly_exhausted_memory)
         return FALSE;
   }
#endif

#ifdef VET
   if (moreopts)
#endif
   {
      set_local_links(0);
      live_variable_analysis(0, 1, 0);
      remv_dead_variables(0, 1, TRUE);
      change2 |= remv_useless_jumps(r_u_j_count++);
      change2 |= remv_branch_chains(r_b_c_count++);
      change2 |= remove_useless_cond_branches(r_u_c_b_count++);
      change2 |= remv_unreachable_code(r_u_c_count++);
      change2 |= remv_useless_basic_blocks(r_u_b_count++);
      change2 |= reverse_jumps(r_j_count++);
      change2 |= minimize_jumps(m_j_count++);
      change2 |= merge_basic_blocks(m_b_b_count++);
      if (change2) {
         clear_loops();
         depth_first_search(d_f_s_count++);
         build_dominator_tree(b_d_t_count++);

         /*
          * Perform control flow analysis on the function to locate loops. Also,
          * perform loop-dependent control flow optimizations if the user has
          * requested that control flow optimizations be applied.
          */
         if (find_loops(1)) {
            if (swl) {
               (void) remv_forward_links(1);
               (void) remv_branch_chains(1);
               (void) remv_useless_basic_blocks(1);
               (void) remv_useless_jumps(1);
               (void) remv_unreachable_code(1);
               (void) reverse_jumps(1);
               (void) minimize_jumps(1);
               (void) (minimize_loop_jumps(1));

               (void) merge_basic_blocks(m_b_b_count++);
               clear_loops();
               depth_first_search(d_f_s_count++);
               build_dominator_tree(b_d_t_count++);
               (void) find_loops(2);
            }

            /*
             * Order the loop information structures (from outer to inner)
             * and determine the exit blocks for each loop if we have to use
             * such information.
             */
            if (swo || swm || (swr && hascs)) {
               order_loops();
               find_loop_exits();
            }
         }
#ifdef INTERACT
         estimate_execution_frequency(1);
#endif
         if (swr && hascs)
            hascs = count_caller_save();
      }
      live_variable_analysis(0, 1, 0);
   }
   return change2;
}



void rebuild_dom_front(int invocation)
{
   int   change = FALSE;
   if (!swl)
      return;
#ifdef VET
   if (!moreopts)
      return;
#endif
   clear_loops();
   clear_dominators();
   depth_first_search(d_f_s_count++);
   build_dominator_tree(b_d_t_count++);
   find_dominance_frontiers(f_d_f_count++);
   if (find_loops(1)) {
      if (swl) {
         (void) remv_forward_links(1);
         (void) remv_branch_chains(1);
         (void) remv_useless_basic_blocks(1);
         (void) remv_useless_jumps(1);
         (void) remv_unreachable_code(1);
         (void) reverse_jumps(1);
         (void) minimize_jumps(1);
         (void) (minimize_loop_jumps(1));
         (void) merge_basic_blocks(m_b_b_count++);
         clear_loops();
         clear_dominators();
         depth_first_search(d_f_s_count++);
         build_dominator_tree(b_d_t_count++);
         find_dominance_frontiers(f_d_f_count++);
         (void) find_loops(2);
      }
      /*
       * Order the loop information structures (from outer to inner loops)
       * and determine the exit blocks for each loop if we have to use such
       * information.
       */
      if (swm || (swr && hascs)) {
         order_loops();
      }
      if (swm || (swr && hascs) || swo)
         find_loop_exits();
   }
#ifdef INTERACT
   estimate_execution_frequency(1);
#endif
   if (swr && hascs)
      hascs = count_caller_save();
}

void sanity_check_links()
{
   struct bblock *cblk;
   struct list *rtl;
   int   i;
   fflush(stdout);
   fflush(stderr);
   for (cblk = top; cblk; cblk = cblk->down) {
      for (rtl = cblk->rtls; rtl; rtl = rtl->next) {
         for (i = 0; i < MAXLINKS && rtl->lnks[i]; i++)
            if (!cnts(rtl->lnks[i]))
               printf("\n\n\n\n\n\n\n\nBogus!\n\n\n\n\n");
         for (i = 0; i < MAXLINKS && rtl->blnks[i]; i++)
            if (!cnts(rtl->blnks[i]))
               printf("\n\n\n\nBogus!\n\n\n\n\n");
         for (i = 0; i < MAXLINKS && rtl->all_lnks[i]; i++)
            if (!cnts(rtl->all_lnks[i]))
               printf("\n\n\n\nBogus!\n\n\n\n\n");

      }

   }

   fflush(stdout);
   fflush(stderr);

}

void remove_null_rtls()
{
   struct bblock *cblk;
   struct list *rtl, *prtl;

#ifdef VET
	if(!moreopts)
		return;
#ifdef INTERACT
      	begin_phase(INST_SELECT_TRANS);
#else
   	begin_phase(INSTSELECT_PHASE);
#endif
	begin_trans(VET_OPT_TRANS);
#endif



   for (cblk = top; cblk; cblk = cblk->down) {
      for (rtl = cblk->rtls; rtl; rtl = prtl) {
         prtl = rtl->next;
         if (rtl->val == NULL && ((rtl->deads == 0) || rempty(rtl->deads))) {
            remv_links(rtl);
            remv_rtl(rtl);
         }
      }

   }

#ifdef VET
	end_trans();
#ifdef INTERACT
      	end_phase(INST_SELECT_TRANS);
#else
   	end_phase(INSTSELECT_PHASE);
#endif
#endif
}


/*
 * dump_loop - print out a human readable version of a loop (for debug purposes)
 */
int dump_loop(struct loopl *loop, int debug)
{

   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr;
   struct phi *pphi;
   struct defnode *pdef;
   int   rnum, i, pass2;
   char *a, reg[BIGSTRING];
   int   contains_pseudo = 0;
   struct blist *blocks;

   /*
    * Number the basic blocks for a debug display
    */
   if (debug) {
      for (cblk = top; cblk; cblk = cblk->next)
         cblk->dnum = 0;
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down)
         cblk->dnum = rnum++;
      for (cblk = top; cblk; cblk = cblk->next)
         if (!cblk->dnum)
            cblk->dnum = rnum++;
   }

   /*
    * Number all RTLs, so we can tell forward links from back links
    */
   if (!swa) {
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & RTLINE)
               rtlptr->rnum = rnum++;
         }
      }
   }

   dassem = 1;
   rnum = 1;
   pass2 = FALSE;

   /*
    * Go through all of the basic blocks starting with the entry block and
    * continuing along in the output order.
    */
   for (blocks = loop->blocks; blocks; blocks = blocks->next) {
      cblk = blocks->ptr;

      /*
       * If the user has requested debug output, show some of the information
       * that we have on this basic block.
       */
      if (debug) {

         i = FALSE;
         if (debug & SHOW_LABELS || debug_opt("show_labels")) {
            (void) printf("Number: %d", cblk->dnum);
            (void) printf(" (%s)  ",
                          (cblk->label) ? cblk->label : "no label");
            i = TRUE;
         }
         if (debug & SHOW_STATUS || debug_opt("show_status")) {
            (void) printf("Status: %x", cblk->status);
            if (cblk->status & FALLTHRU)
               if (cblk->status & JUMP)
                  (void) printf(" (FALLTHRU, JUMP)  ");
               else
                  (void) printf(" (FALLTHRU)  ");
            else if (cblk->status & JUMP)
               (void) printf(" (JUMP)  ");
            else
               (void) printf("  ");
            i = TRUE;
         }
         if (debug & SHOW_BNUM || debug_opt("show_bnum")) {
            (void) printf("Bnum: %d  ", cblk->bnum);
            i = TRUE;
         }

#ifdef MEASURE
         if (debug & SHOW_CLASS || debug_opt("show_class")) {
            (void) printf("Class: %d  ", cblk->equivnum);
            i = TRUE;
         }
#endif

         if (debug & SHOW_FREQ || debug_opt("show_freq")) {
            (void) printf("Freq: %d  ", cblk->freq);
            i = TRUE;
         }
         if (debug & SHOW_ESTIMATE || debug_opt("show_estimate")) {
            (void) printf("Estimate: %6.4f  ", cblk->estimate);
            i = TRUE;
         }
         if (cblk->loop && (debug & SHOW_LOOP || debug_opt("show_loop")))
            (void) printf("Loop head\n");
         else if (i)
            (void) printf("\n");

         i = FALSE;
         if (cblk->up && (debug & SHOW_UP || debug_opt("show_up"))) {
            (void) printf("Up: %d  ", cblk->up->dnum);
            i = FALSE;
         }
         if (debug & SHOW_SUCCS || debug_opt("show_succs")) {
            if (cblk->left) {
               (void) printf("Left: %d  ", cblk->left->dnum);
               i = TRUE;
            }
            if (cblk->right) {
               (void) printf("Right: %d  ", cblk->right->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DFS || debug_opt("show_dfs")) {
            if (cblk->prev_dfs) {
               (void) printf("Prev-dfs: %d  ", cblk->prev_dfs->dnum);
               i = TRUE;
            }
            if (cblk->next_dfs) {
               (void) printf("Next-dfs: %d  ", cblk->next_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PARENT || debug_opt("show_parent")) {
            if (cblk->parent_dfs) {
               (void) printf("Parent: %d  ", cblk->parent_dfs->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_DOM || debug_opt("show_dom")) {
            if (cblk->idom) {
               (void) printf("Idom: %d  ", cblk->idom->dnum);
               i = TRUE;
            }
            if (cblk->sdom) {
               (void) printf("Sdom: %d  ", cblk->sdom->dnum);
               i = TRUE;
            }
         }
         if (debug & SHOW_PREDS || debug_opt("show_preds")) {
            (void) printf("Preds: {");
            bptr = cblk->preds;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }
         else if (i)
            (void) printf("\n");

         if (debug & SHOW_FRONTIER || debug_opt("show_frontier")) {
            (void) printf("Dominance frontier: {");
            bptr = cblk->dom_front;
            while (bptr) {
               (void) printf("%d", bptr->ptr->dnum);
               if (bptr = bptr->next)
                  (void) printf(", ");
            }
            (void) printf("}\n");
         }

         if (debug & SHOW_USE || debug_opt("show_use")) {
            (void) printf("Use: ");
            reget(cblk->ulist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_DEF || debug_opt("show_def")) {
            (void) printf("Def: ");
            reget(cblk->dlist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_OUT || debug_opt("show_out")) {
            (void) printf("Out: ");
            reget(cblk->olist, reg);
            for (a = reg; *a; a = skiploc(a) + 1)
               show_rtl(stdout, a);
            (void) printf("\n");
         }

         if (debug & SHOW_PHI || debug_opt("show_phi")) {
            (void) printf("Phi: ");
            for (pphi = cblk->phi_funcs; pphi; pphi = pphi->next) {
               show_rtl(stdout, pphi->item->item);
               (void) printf("() ");
            }
            (void) printf("\n");
         }

         if (debug & SHOW_SETS || debug_opt("show_sets")) {
            (void) printf("Sets: ");
            for (pdef = cblk->sets_out; pdef; pdef = pdef->next) {
               show_rtl(stdout, pdef->item->item);
               (void) printf("[%d] ", pdef->set_rtl->rnum);
            }
            (void) printf("\n");
         }
      }

      /*
       * If this basic block has a label, determine if we need to show it. A
       * label is needed only if there is some item that uses it elsewhere in
       * this function.  This will be true only if the basic block has more
       * than one predecessor or if the block has a single predecessor but that
       * predecessor does not fall through into this basic block.
       */
      if (cblk->label && cblk != ret_block && cblk->preds
          && (cblk->preds->next || !(cblk->status & FALLTHRU))) {
         if (swa)
            (void) printf(labprt, cblk->label);
         else
            (void) printf("\t%s\n", cblk->label);
      }

      /*
       * Display the items in this basic block
       */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         switch (rtlptr->
                 type & ~(ARGLINE | SIDEFFECT | COMBLINE | FUNCNAME | CASELINE
                          | DELAYLINE)) {

          case TRASHLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("t");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case RESLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("r");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case SETLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("S");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ARGBLINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("A");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case USELINE:
             if (debug && rtlptr->val
                 && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("u");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case CSLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("C");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case PARMLINE:
             if (debug && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls"))) {
                (void) printf("P");
                show_rtl(stdout, rtlptr->val);
                (void) printf("\n");
             }
             break;

          case ASMLINE:
             if (rtlptr->type & DELAYLINE) {
                if (debug)
                   (void) printf("_%s\n", rtlptr->val);
                else
                   pass2 = TRUE;
             }
             else if (!(rtlptr->type & FUNCNAME)) {
                if (swa)
                   (void) printf("%s\n", rtlptr->val);
                else
                   (void) printf("-%s\n", rtlptr->val);
             }
             else if (debug
                      && (debug & SHOW_NONRTLS || debug_opt("show_nonrtls")))
                (void) printf("f%s\n", rtlptr->val);
             break;

          case COMMENT:
             if (swa) {
                if (!debug_opt("no_asm_comments"))
                   (void) printf(acomment, rtlptr->val);
             }
             else {
                if (!debug_opt("no_asm_comments"))
                   (void) printf("#%s\n", rtlptr->val);
             }
             break;

          case RTLINE:
          case SIDEFFECT:
             if (swa) {
                if (rtlptr->val && *rtlptr->val) {
                   char *a = rtlptr->val;
                   contains_pseudo = FALSE;
                   sem_ptr = str_ptr = i_ptr = 0;
                   linptr = rtlptr->val;
                   deadlist = rtlptr->deads;
                   curptr = rtlptr;

                   /* 
                    * when compiling with minimial optimizations (eg -AW)
                    * sometimes things dont' get reg-assigned.  we odn't
                    * emit these rtls because they're useless
                    * and might cause the parser to crash
                    * or generate bad machine language.
                    */
                   while (a = gtrg(a)) {
                      if (pseudoreg(unskiploc(a)))
                         contains_pseudo = TRUE;
                   }
                   if (!contains_pseudo) {
		     check_legal = TRUE;
                      if (yyparse()) {
                         (void) fprintf(stderr,
                                        "vpo (dump_function): cannot assemble ");
                         show(rtlptr->val);
                      }
		      check_legal = FALSE;
                   }
                }
             }
             else {
                rtlptr->rnum = rnum++;
                (void) printf("+%d\t\t", rtlptr->rnum);

                for (i = 0; i < MAXLINKS && rtlptr->all_lnks[i]; i++)
                   (void) printf("%d ", rtlptr->all_lnks[i]->rnum);
                (void) printf("\t");

                if (rtlptr->val)
                   show_rtl(stdout, rtlptr->val);
                (void) printf("\t");

                reget(rtlptr->deads, reg);
                for (a = reg; *a; a = skiplocOr2(a) + 1)
                   show_rtl(stdout, a);

                if (debug && (debug & SHOW_COST || debug_opt("show_cost")))
                   (void) printf(" {%d}", rtlptr->cost);
                if (debug && rtlptr->se
                    && (debug & SHOW_SE || debug_opt("show_se"))) {
                   (void) printf(" {");
                   show_rtl(stdout, rtlptr->se);
                   (void) printf("}");
                }

                (void) printf("\n");
             }
             rtlprt(rtlptr, &rnum);
             break;
          case METADATALINE:
             if (!swa && (debug & SHOW_NONRTLS))
                printf("m%s\n", rtlptr->val);
             break;

          default:
             (void) fprintf(stderr,
                            "vpo (dump_function): bad line, type %x\n",
                            rtlptr->type);
         }
      }
   }

   dassem = 0;
   (void) fflush(stdout);
}

#ifdef INTERACT

/* dump RTLs or assembly to the output file*/
void dump_rtl_asm(int dump_swa, FILE * fp, int is_gen_sim_flags)
{
   register struct list *rtlptr;
   register struct bblock *cblk;
   struct blist *bptr;
   struct phi *pphi;
   struct defnode *pdef;
   int   rnum, i, pass2, len;
   char *a, reg[BIGSTRING], inst_str[MAXSTRING];
   int   contains_pseudo = 0;

   /* Number all RTLs, so we can tell forward links from back links */
   if (!dump_swa) {
      rnum = 1;
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & RTLINE)
               rtlptr->rnum = rnum++;
         }
      }
   }

   dassem = 1;
   rnum = 1;
   pass2 = FALSE;

   /* Go through all of the basic blocks starting with the entry block and
    * continuing along in the output order */
   for (cblk = top; cblk; cblk = cblk->down) {
      if (cblk->label && cblk != ret_block && cblk->preds
          && (cblk->preds->next || !(cblk->status & FALLTHRU))) {
         if (dump_swa)
            (void) fprintf(fp, labprt, cblk->label);
         else
            (void) fprintf(fp, "\t%s\n", cblk->label);
      }

      /* Display the items in this basic block */
      for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
         if (!dump_swa)
            fprintf(fp, "%d ", rtlptr->rtl_id);

         switch (rtlptr->
                 type & ~(ARGLINE | SIDEFFECT | COMBLINE | FUNCNAME | CASELINE
                          | DELAYLINE)) {

          case TRASHLINE:
          case RESLINE:
          case SETLINE:
          case ARGBLINE:
          case USELINE:
          case CSLINE:
          case PARMLINE:
          case METADATALINE:
             break;

          case ASMLINE:
             if (rtlptr->type & DELAYLINE)
                pass2 = TRUE;
             else if (!(rtlptr->type & FUNCNAME)) {
	       if (dump_swa){
		 /*in case we are simulating the execution, then we intend to
		   get cycle counts for only the function which we are
		   optimizing. For this function we generate a flag in the
		   assembly so that the simulator can know for which
		   instructions to run the cycle-accurate simulator, and for
		   the rest we can run the fast functional simulator*/
		 if(is_gen_sim_flags){
		   insert_sim_flags(rtlptr->val);
		   add_simulator_ins(rtlptr, instfp, ASMLINE);
		 }
		 
		 (void) fprintf(fp, "%s\n", rtlptr->val);
    
		 /*if generating simulator flags, then add an unused no-op instruction at
		   the start of the current function, to indicate start of getting cycle
		   counts. This should be added after ".text" and fn name have been
		   written. We do this here, instead of in the function
		   add_simulator_ins so that the instruction is added after
		   the function name has been written, and not before it*/
		 if(is_gen_sim_flags){
		   len = strlen(fn);
		   if(strncmp(fn, rtlptr->val, len) == 0)
		     add_start_cycle_ins(instfp);
		 }
   	       }
	       else
		 (void) fprintf(fp, "-%s\n", rtlptr->val);
             }
             break;

          case COMMENT:
             if (dump_swa)
                (void) fprintf(fp, acomment, rtlptr->val);
             else
                (void) fprintf(fp, "#%s\n", rtlptr->val);
             break;

          case RTLINE:
          case SIDEFFECT:
             if (dump_swa) {
                if (rtlptr->val && *rtlptr->val) {
                   char *a = rtlptr->val;
                   contains_pseudo = FALSE;
                   sem_ptr = str_ptr = i_ptr = 0;
                   linptr = rtlptr->val;
                   deadlist = rtlptr->deads;
                   curptr = rtlptr;

                   /* 
                    * when compiling with minimial optimizations (eg -AW)
                    * sometimes things dont' get reg-assigned.  we odn't
                    * emit these rtls because they're useless
                    * and might cause the parser to crash
                    * or generate bad machine language.
                    */
                   while (a = gtrg(a)) {
                      if (pseudoreg(unskiploc(a)))
                         contains_pseudo = TRUE;
                   }
                   if (!contains_pseudo) {
		     check_legal = TRUE;
		     if (dump_yyparse(inst_str)) {
		       (void) fprintf(stderr,
				      "vpo (dump_function): cannot assemble ");
		       show(rtlptr->val);
		     }
		     else{
		       if(is_gen_sim_flags){
			 add_simulator_ins(rtlptr, fp, RTLINE);
			 insert_sim_flags(inst_str);
		       }
		       (void) fprintf(fp, "%s\n", inst_str);
		     }
		     check_legal = FALSE;
                   }
                }
             }
             else {
                rtlptr->rnum = rnum++;
#ifdef VET
                /* We don't want to print out the rnum info when vpo is called
                 * from VPOISO, so as to avoid confusing the diff of the
                 * correct and incorrect outputs.
                 */
                if (!debug_opt("no_rtl_line_nums"))
#endif
                {
                   (void) fprintf(fp, "+%d\t\t", rtlptr->rnum);

                   for (i = 0; i < MAXLINKS && rtlptr->lnks[i]; i++)
                      (void) fprintf(fp, "%d ", rtlptr->lnks[i]->rnum);
                   (void) fprintf(fp, "\t");
                }

                if (rtlptr->val)
                   show_rtl(fp, rtlptr->val);
                (void) fprintf(fp, "\t");

                reget(rtlptr->deads, reg);
                for (a = reg; *a; a = skiplocOr2(a) + 1)
                   show_rtl(fp, a);

                (void) fprintf(fp, "\n");
             }
             rtlprt(rtlptr, &rnum);
             break;

          default:
             (void) fprintf(stderr,
                            "vpo (dump_function): bad line, type %x\n",
                            rtlptr->type);
         }
      }
   }

   /*
    * In the second pass through the RTLs, dump only those items marked as
    * DELAYLINE.  These items will all go at the end of the output.
    */
   if (pass2) {
      for (cblk = top; cblk; cblk = cblk->down) {
         for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next) {
            if (rtlptr->type & DELAYLINE) {
               if (dump_swa)
                  (void) fprintf(fp, "%s\n", rtlptr->val);
               else
                  (void) fprintf(fp, "_%s\n", rtlptr->val);
            }
         }
      }
   }
   dassem = 0;
}


/*
 * dump_func_to_file - dumps function to a file
 */
void dump_func_to_file(char *filename)
{
   struct bblock *cblk;
   struct list *ptr;
   char  buf[BUFSIZ];
   FILE *fout;
   char *a;
   char  reg[MAXSTRING];

   (void) number_basic_blocks();
   number_rtls();

   /*clear all the preds and recalculate them to
    * avoid the order problem */
   clear_all_preds();
   recalculate_all_preds();
   calc_status();

   /* setup for output */
   fout = fopen(filename, "w");
   setbuf(fout, buf);
   fprintf(fout, "\n");

   /* go through every block */
   for (cblk = top; cblk; cblk = cblk->down) {

      /* show the block id and the label */
      fprintf(fout, "BBID:%d\n", cblk->block_id);
      if (cblk->label)
         fprintf(fout, "LABEL:%s:\n", cblk->label);

      /* show the successors and predecessors */
      if (cblk->left)
         fprintf(fout, "LEFT:%d\n", cblk->left->block_id);
      else
         fprintf(fout, "LEFT:0\n");
      if (cblk->right)
         fprintf(fout, "RIGHT:%d\n", cblk->right->block_id);
      else
         fprintf(fout, "RIGHT:0\n");
      m_show_preds(fout, cblk);

      /*show the status */
      m_show_status(fout, cblk);

      /*show the rtls in this basic block */
      for (ptr = cblk->rtls; ptr; ptr = ptr->next)
         if (cnts(ptr)) {

            /*show the number of this rtl */
            fprintf(fout, "%d\t", ptr->rtl_id);

            /*show the type of this rtl */
            fprintf(fout, "{%d}\t", (ptr->type));

            /*show the kind of this rtl */
            fprintf(fout, "[%d]\t", BASEKIND(ptr->kind));

            /*show the rtl value */
            show_rtl(fout, ptr->val);
            fprintf(fout, "\t");

            /*show side effect */
            if (ptr->se)
               show_rtl(fout, ptr->se);

            /*show the deads */
            m_rshow(fout, ptr->deads);
            fprintf(fout, "\n");
         }
	 else{
            /*show the number of this rtl */
            fprintf(fout, "%d\t", ptr->rtl_id);

            /*show the type of this rtl */
            fprintf(fout, "{%d}\t", (ptr->type));

            /*show the kind of this rtl */
            fprintf(fout, "[%d]\n", BASEKIND(ptr->kind));
	 }	   
   }
   fclose(fout);
}

/*
 * ShowPreds - print out the predecessor list to a file
 */
void m_show_preds(FILE * fout, struct bblock *cblk)
{
   struct blist *bptr;

   fprintf(fout, "Preds: {");
   bptr = cblk->preds;
   while (bptr) {
      fprintf(fout, "%d", /*bptr->ptr->dnum */ bptr->ptr->block_id);
      if (bptr = bptr->next)
         fprintf(fout, ", ");
   }
   fprintf(fout, "}\n");
}

/*
 * m_rshow - show the rlist to a file
 */
void m_rshow(FILE * fout, rlist vec)
{

   register char *a;
   char  reg[MAXSTRING];

   /*
    * This procedure is declared to make it easier to look at register vectors
    * while in dbx.   To print out the contents of a register vector, use "call
    * rshow(vector)".
    */
   reget(vec, reg);
   for (a = reg; *a; a += 3)
      show_rtl(fout, a);
}


/*
 * show_links - show all the links of rtlptr to fout
 */
void show_links(FILE * fout, struct list *rtlptr)
{
   int   i;
   fprintf(fout, "{");
   for (i = 0; i < MAXLINKS && rtlptr->lnks[i]; i++)
      fprintf(fout, "%d", rtlptr->lnks[i]->onum);
   fprintf(fout, "}\t");

}

/*
 * m_show_status - show the status of the cblk to fout
 */
void m_show_status(FILE * fout, struct bblock *cblk)
{
   unsigned short status = cblk->status & CLEAR;
   fprintf(fout, "Status: %x", status);
   if (status & FALLTHRU)
      if (status & JUMP)
         fprintf(fout, " (FALLTHRU, JUMP)   ");
      else
         fprintf(fout, " (FALLTHRU)   ");
   else if (status & JUMP)
      fprintf(fout, " (JUMP)   ");
   else
      fprintf(fout, "nothing   ");
   fprintf(fout, "\n");
}


/*
 * alloc_new_rtl - function defined to allocate new rtl space
 */
struct list *alloc_new_rtl()
{

   register struct list *rtl;

   rtl = (struct list *) SALLOCTYPE(sizeof(struct list), LISTTYPE);

#ifdef INTERACT
   rtl_id++;
   rtl->rtl_id = rtl_id;
#endif
   return rtl;
}

#endif  /* INTERACT */
